/** @file
  File name:    MmrcProjectDataGenerated.h
  Input File:   BXTM_SOC.xlsx

  THIS FILE IS AUTO-GENERATED BY THE MMRC TOOL. DO NOT CHANGE THIS CODE.

  If edits are needed in this file, they must be done via the MMRC tool.

  If there is additional project-specific data required by the MMRC, it
  can be placed in MmrcProjectData.h, which is used for non-tool-generated
  data

  This file contains data structures for a particular piece of silicon.
  These structures are fed to MmrcLibraries.c, which use them to initialize
  memory.

 @copyright
  INTEL CONFIDENTIAL
  Copyright 2005 - 2016 Intel Corporation.

  The source code contained or described herein and all documents related to the
  source code ("Material") are owned by Intel Corporation or its suppliers or
  licensors. Title to the Material remains with Intel Corporation or its suppliers
  and licensors. The Material may contain trade secrets and proprietary and
  confidential information of Intel Corporation and its suppliers and licensors,
  and is protected by worldwide copyright and trade secret laws and treaty
  provisions. No part of the Material may be used, copied, reproduced, modified,
  published, uploaded, posted, transmitted, distributed, or disclosed in any way
  without Intel's prior express written permission.

  No license under any patent, copyright, trade secret or other intellectual
  property right is granted to or conferred upon you by disclosure or delivery
  of the Materials, either expressly, by implication, inducement, estoppel or
  otherwise. Any license under such intellectual property rights must be
  express and approved by Intel in writing.

  Unless otherwise agreed by Intel in writing, you may not remove or alter
  this notice or any other notice embedded in Materials by Intel or
  Intel's suppliers or licensors in any way.

  This file contains an 'Intel Peripheral Driver' and is uniquely identified as
  "Intel Reference Module" and is licensed for Intel CPUs and chipsets under
  the terms of your license agreement with Intel or your vendor. This file may
  be modified by the user, subject to additional terms of the license agreement.

  @par Specification
**/
#ifndef _MMRCPROJECTDATAGENERATED_H_
#define _MMRCPROJECTDATAGENERATED_H_

#include "MmrcData.h"

extern char *CapsuleStrings[];
//
// Invalid value for a Blueprint define
//
#define INVALID_BLUEPRINT_DEFINE_VALUE                     0xDEADBEEF
//
// Blueprint project defines for BLUEPRINT_LPDDR3
//
#define ECT_MIN_CMD_BLUEPRINT_LPDDR3                       300 // Range for ECT in percentages of 2x clocks
#define ECT_MAX_CMD_BLUEPRINT_LPDDR3                       500 // Range for ECT in percentages of 2x clocks
#define ECT_STEP_CMD_BLUEPRINT_LPDDR3                      25 // Range for ECT in percentages of 2x clocks
#define ECT_MIN_CTL_BLUEPRINT_LPDDR3                       300 // 
#define ECT_MAX_CTL_BLUEPRINT_LPDDR3                       500 // 
#define ECT_STEP_CTL_BLUEPRINT_LPDDR3                      25 // 
//
// Blueprint project defines for BLUEPRINT_LPDDR4
//
#define ECT_MIN_CMD_BLUEPRINT_LPDDR4                       100 // Range for ECT in percentages of 2x clocks
#define ECT_MAX_CMD_BLUEPRINT_LPDDR4                       500 // Range for ECT in percentages of 2x clocks
#define ECT_STEP_CMD_BLUEPRINT_LPDDR4                      50 // Range for ECT in percentages of 2x clocks
#define ECT_MIN_CTL_BLUEPRINT_LPDDR4                       300 // 
#define ECT_MAX_CTL_BLUEPRINT_LPDDR4                       700 // 
#define ECT_STEP_CTL_BLUEPRINT_LPDDR4                      50 // 

#if MAX_BLUEPRINTS > 1
  extern UINT32 ECT_MIN_CMD_GENERATED[MAX_BLUEPRINTS];
  extern UINT32 ECT_MAX_CMD_GENERATED[MAX_BLUEPRINTS];
  extern UINT32 ECT_STEP_CMD_GENERATED[MAX_BLUEPRINTS];
  extern UINT32 ECT_MIN_CTL_GENERATED[MAX_BLUEPRINTS];
  extern UINT32 ECT_MAX_CTL_GENERATED[MAX_BLUEPRINTS];
  extern UINT32 ECT_STEP_CTL_GENERATED[MAX_BLUEPRINTS];
  #define ECT_MIN_CMD  ECT_MIN_CMD_GENERATED[MrcData->CurrentBlueprint]
  #define ECT_MAX_CMD  ECT_MAX_CMD_GENERATED[MrcData->CurrentBlueprint]
  #define ECT_STEP_CMD ECT_STEP_CMD_GENERATED[MrcData->CurrentBlueprint]
  #define ECT_MIN_CTL  ECT_MIN_CTL_GENERATED[MrcData->CurrentBlueprint]
  #define ECT_MAX_CTL  ECT_MAX_CTL_GENERATED[MrcData->CurrentBlueprint]
  #define ECT_STEP_CTL ECT_STEP_CTL_GENERATED[MrcData->CurrentBlueprint]
#else
  extern UINT32 ECT_MIN_CMD_GENERATED;
  extern UINT32 ECT_MAX_CMD_GENERATED;
  extern UINT32 ECT_STEP_CMD_GENERATED;
  extern UINT32 ECT_MIN_CTL_GENERATED;
  extern UINT32 ECT_MAX_CTL_GENERATED;
  extern UINT32 ECT_STEP_CTL_GENERATED;
  #define ECT_MIN_CMD  ECT_MIN_CMD_GENERATED
  #define ECT_MAX_CMD  ECT_MAX_CMD_GENERATED
  #define ECT_STEP_CMD ECT_STEP_CMD_GENERATED
  #define ECT_MIN_CTL  ECT_MIN_CTL_GENERATED
  #define ECT_MAX_CTL  ECT_MAX_CTL_GENERATED
  #define ECT_STEP_CTL ECT_STEP_CTL_GENERATED
#endif

#endif // _MMRCPROJECTDATAGENERATED_H_
