/** @file
  File name:    StringsGenerated.c
  Input File:   BXTM_SOC.xlsx

  THIS FILE IS AUTO-GENERATED BY THE MMRC TOOL. DO NOT CHANGE THIS CODE.

  If edits are needed in this file, they must be done via the MMRC tool.

  If there is additional project-specific data required by the MMRC, it
  can be placed in Strings.c, which is used for non-tool-generated
  data

  Includes various strings specific to a project.

 @copyright
  INTEL CONFIDENTIAL
  Copyright 2005 - 2016 Intel Corporation.

  The source code contained or described herein and all documents related to the
  source code ("Material") are owned by Intel Corporation or its suppliers or
  licensors. Title to the Material remains with Intel Corporation or its suppliers
  and licensors. The Material may contain trade secrets and proprietary and
  confidential information of Intel Corporation and its suppliers and licensors,
  and is protected by worldwide copyright and trade secret laws and treaty
  provisions. No part of the Material may be used, copied, reproduced, modified,
  published, uploaded, posted, transmitted, distributed, or disclosed in any way
  without Intel's prior express written permission.

  No license under any patent, copyright, trade secret or other intellectual
  property right is granted to or conferred upon you by disclosure or delivery
  of the Materials, either expressly, by implication, inducement, estoppel or
  otherwise. Any license under such intellectual property rights must be
  express and approved by Intel in writing.

  Unless otherwise agreed by Intel in writing, you may not remove or alter
  this notice or any other notice embedded in Materials by Intel or
  Intel's suppliers or licensors in any way.

  This file contains an 'Intel Peripheral Driver' and is uniquely identified as
  "Intel Reference Module" and is licensed for Intel CPUs and chipsets under
  the terms of your license agreement with Intel or your vendor. This file may
  be modified by the user, subject to additional terms of the license agreement.

  @par Specification
**/

#include "MmrcData.h"

#if CAPSULESTRINGS
char *OutputStrings[] = {
  "BLMODE", 
  NULL, 
};
#endif //CAPSULESTRINGS

#if DUMP_REGISTER_NAMES
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields0[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{30, 31, 0x0000000000000000, "RO", "DRAMDEVICE_PR", "Number of DRAM devices per rank:\r\n"
"Specifies how many DRAM devices are ganged together to form a single rank\r\n"
"00 - 1 DRAM device in each rank\r\n"
"01 - 2 DRAM devices in each rank\r\n"
"10 - 4 DRAM devices in each rank\r\n"
"11 - 8 DRAM devices in each rank"},
#else
{30, 31, 0x0000000000000000, "RO", "DRAMDEVICE_PR", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{28, 29, 0x0000000000000001, "RW", "ADDRDEC", "Specifies the address mapping to be used:[br] 00 - 1KB (A), 01 - 2KB (B), 10 - 4KB (C), 11 - Reserved"},
#else
{28, 29, 0x0000000000000001, "RW", "ADDRDEC", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{25, 27, 0x0000000000000000, "RW", "BLMODE", "000 - Fixed BL8,  [br]001 - Onthefly BL8,  [br]010 - Fixed BL16,  [br]011 - Onthefly BL16,  [br]100 - Fixed BL32,  [br]101 - Onthefly BL32,  [br]110-111 - Reserved"},
#else
{25, 27, 0x0000000000000000, "RW", "BLMODE", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{22, 24, 0x0000000000000000, "RW", "DRAMTYPE", "000 -  DDR3,  [br]001 - LPDDR3,  [br]010 -  LPDDR4,  [br]011 -  WIO2,  [br]100 -  DDR4,  [br]101-111 - Reserved [br]Note: The D-unit should only use this field if allowed by fuse"},
#else
{22, 24, 0x0000000000000000, "RW", "DRAMTYPE", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{21, 21, 0x0000000000000000, "RW", "ECCEN", "0 -  ECC is disabled,  1  - ECC is enabled. [br]This bit determines if the Dunit treats the PMI BE_ECC bits as ECC bits or Byte Enables. The Dunit should not allow this bit to be set if ECC is disabled by fuse. This should only be used in configurations that support ECC."},
#else
{21, 21, 0x0000000000000000, "RW", "ECCEN", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{19, 20, 0x0000000000000000, "RO", "CASWIZZLE", "CA Swizzle Type\r\n"
"00 - uniDIMM/SODIMM\r\n"
"01 - BGA\r\n"
"10 - BGA mirrored (LPDDR3 only)\r\n"
"11 - UDIMM (DDR3L only)"},
#else
{19, 20, 0x0000000000000000, "RO", "CASWIZZLE", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{16, 18, 0x0000000000000000, "RO", "RSVD20_16", "Reserved"},
#else
{16, 18, 0x0000000000000000, "RO", "RSVD20_16", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{15, 15, 0x0000000000000000, "RW", "BAHEN", "See Address Mapping section for full description.  [br]0 - Bank Address Hashing disabled,  [br]1 - Bank Address Hashing enabled."},
#else
{15, 15, 0x0000000000000000, "RW", "BAHEN", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{14, 14, 0x0000000000000000, "RW", "RSIEN", "See Address Mapping section for full description.  [br]0 - Rank Select Interleaving disabled, [br]1 - Rank Select Interleaving enabled."},
#else
{14, 14, 0x0000000000000000, "RW", "RSIEN", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{9, 13, 0x0000000000000000, "RO", "RSVD13_9", "Reserved"},
#else
{9, 13, 0x0000000000000000, "RO", "RSVD13_9", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{6, 8, 0x0000000000000000, "RW", "DDEN", "Density of the DRAM devices populated on Ranks 0 and 1. [br]000 - 4Gb,  [br]01 - 6Gb,  [br]010 - 8Gb,  [br]011 - 12Gb,  [br]100 - 16Gb,  [br]101-111 - Reserved [br]Note: For LPDDR4 this value is the die density."},
#else
{6, 8, 0x0000000000000000, "RW", "DDEN", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{4, 5, 0x0000000000000000, "RW", "DWID", "Data width of the DRAM devices populated on Ranks 0 and 1.  [br]00 - x8,  [br]01 - x16,  [br]10 - x32,  [br]11 - x64."},
#else
{4, 5, 0x0000000000000000, "RW", "DWID", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{3, 3, 0x0000000000000000, "RO", "RSVD3", "Reserved"},
#else
{3, 3, 0x0000000000000000, "RO", "RSVD3", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{2, 2, 0x0000000000000000, "RW", "DDMEN", "0 - PMI Dual Data Mode is disabled in Dunit, full cacheline read and writes go through a single Dunit. D-unit needs to issue 2 back to back CASes for DDR3/LPDDR3 [br]1 - PMI Dual Data Mode is enabled, only half cacheline read/writes go through a single Dunit, so Dunit only issues a single CAS for DDR3/LPDDR3 [br]Note: This field is reserved for BXT0/1"},
#else
{2, 2, 0x0000000000000000, "RW", "DDMEN", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{1, 1, 0x0000000000000000, "RW", "RKEN1", "Enable Rank 1:  Must be set to 1 to enable use of this rank."},
#else
{1, 1, 0x0000000000000000, "RW", "RKEN1", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 0, 0x0000000000000000, "RW", "RKEN0", "Enable Rank 0: Must be set to 1 to enable use of this rank.  Note: Setting this bit to 0 is not a functional mode."},
#else
{0, 0, 0x0000000000000000, "RW", "RKEN0", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo0[] = {{"D_CR_DRP0", "", 0x00000000, 16, 0x00000000FFFFFFFF, 0x0000000010000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields1[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{25, 31, 0x0000000000000010, "RW", "TCKCKEH", "Number of valid clock before CKE high (in DRAM Clocks) [br]LPDDR4: the value in this register covers both tCKCKEH and tCSCKEH [br]DDR3/LPDDR3/WIO2: the value covers tCKSRX which is defined as the number of valid DRAM clocks that have to toggle before the issuing of the Self Refresh Exit SRX. This value is also used if the clock frequency is changed or the clock is stopped or tristated during Power Down i.e. the number valid DRAM clocks that have to toggle before the issuing of the Power Down Exit PDX command. [br]tCKCKEH can be used to compensate for clock stabilization delays in the motherboard"},
#else
{25, 31, 0x0000000000000010, "RW", "TCKCKEH", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{23, 24, 0x0000000000000000, "RW", "TXSDLL", "D-unit waits max(tXSR+tZQCL/tZQCS, tXSDLL) before allowing traffic to DRAM.  (in 256 x DRAM Clocks) [br]LPDDR3/LPDDR4/WIO2: tXSDLL = 0, [br]DDR3L: tXSDLL = tDLLK = 512 Clocks = 2 x 256 DRAM Clocks [br]Note: tZQCL/TZQCS = 0 if no ZQ is performed on SR exit. [br]Reserved in BXT0/1"},
#else
{23, 24, 0x0000000000000000, "RW", "TXSDLL", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{14, 22, 0x0000000000000070, "RW", "TXSR", "Delay between Self Refresh Exit SRX to any DRAM Command not requiring DLL Lock (DDR3) [br]tXSR - Delay between Self Refresh Exit SRX to any DRAM Command (LPDDR/WIO2). [br](in DRAM Clocks)"},
#else
{14, 22, 0x0000000000000070, "RW", "TXSR", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{8, 13, 0x000000000000000B, "RW", "TRCD", "Specifies the delay between a DRAM Activate command and a DRAM Read or Write command to the same bank. (in DRAM Clocks) [br]Note: Derating adds 1.875ns to this timing"},
#else
{8, 13, 0x000000000000000B, "RW", "TRCD", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{6, 7, 0x0000000000000000, "RO", "RSVD7_6", "Reserved"},
#else
{6, 7, 0x0000000000000000, "RO", "RSVD7_6", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 5, 0x000000000000000B, "RW", "TRPPB", "Specifies the delay between a DRAM Precharge command and a DRAM Activate command to the same bank. (in DRAM Clocks) [br]Note: Derating adds 1.875ns to this timing."},
#else
{0, 5, 0x000000000000000B, "RW", "TRPPB", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo1[] = {{"D_CR_DTR0A", "", 0x00000008, 6, 0x00000000FFFFFFFF, 0x00000000201C0B0B}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields2[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{27, 31, 0x0000000000000006, "RW", "TXP", "Specifies the delay from the DRAM Power Down Exit PDX command to any valid command. (in DRAM Clocks)"},
#else
{27, 31, 0x0000000000000006, "RW", "TXP", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{26, 26, 0x0000000000000000, "RO", "RSVD26", "Reserved"},
#else
{26, 26, 0x0000000000000000, "RO", "RSVD26", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{14, 25, 0x0000000000000120, "RW", "TZQCL", "LPDDR3: tZQCL - Specifies the delay between the DRAM ZQ Calibration Long (ZQCL) command and any DRAM command during normal operation. [br]LPDDR4: tZQCAL - ZQ Calibration time. [br](in DRAM Clocks) [br]Note: This field defines the ZQ Calibration Long delay during normal operation. It is not the same as tZQinit which uses the same ZQCL command but the delay is longer. tZQinit applies only during poweron initialization of the DRAM devices and tZQoper applies during normal operation. BIOS executes the DRAM initialization sequence so it has to ensure tZQinit is met and not the Dunit"},
#else
{14, 25, 0x0000000000000120, "RW", "TZQCL", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{6, 13, 0x0000000000000048, "RW", "TZQCS", "ZQCS to any DRAM Command Delay:  Specifies the delay between the DRAM ZQ Calibration Short (ZQCS) command and any DRAM command. (in DRAM Clocks) [br]The DDR3 JEDEC standard defines tZQCS = Max(64nCK, 80ns) [br]The LPDDR3 JEDEC standards define tZQCS = Max(6nCK, 90ns) [br]LPDDR4 does not support ZQCS command"},
#else
{6, 13, 0x0000000000000048, "RW", "TZQCS", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 5, 0x0000000000000018, "RW", "TZQLAT", "Specifies the delay between the DRAM  ZQ Calibration Latch command and any DRAM command. (in DRAM Clocks) [br]The LPDDR4 JEDEC standard defines tZQLAT = 30ns [br]Not used in DDR3/LPDDR3/WIO2"},
#else
{0, 5, 0x0000000000000018, "RW", "TZQLAT", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo2[] = {{"D_CR_DTR1A", "", 0x0000000C, 5, 0x00000000FFFFFFFF, 0x0000000030481218}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields3[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{23, 31, 0x0000000000000118, "RW", "NRFCAB", "Specifies the delay between the REFab command to the next valid command. (in DRAM clocks)"},
#else
{23, 31, 0x0000000000000118, "RW", "NRFCAB", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{21, 22, 0x0000000000000000, "RO", "RSVD22_21", "Reserved"},
#else
{21, 22, 0x0000000000000000, "RO", "RSVD22_21", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{17, 20, 0x0000000000000004, "RW", "TCKE", "Specifies the minimum time from CKEL to CKEH. (in DRAM Clocks)"},
#else
{17, 20, 0x0000000000000004, "RW", "TCKE", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{16, 16, 0x0000000000000000, "RO", "RSVD16", "Reserved"},
#else
{16, 16, 0x0000000000000000, "RO", "RSVD16", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 15, 0x0000000000000C30, "RW", "NREFI", "Specifies the average time between refresh commands. JEDEC Base Refresh Interval time. (in DRAM Clocks) [br]Note: Dunit will ignore the 2 LSBs of this field"},
#else
{0, 15, 0x0000000000000C30, "RW", "NREFI", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo3[] = {{"D_CR_DTR2A", "", 0x00000010, 5, 0x00000000FFFFFFFF, 0x000000008C080C30}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields4[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{27, 31, 0x0000000000000006, "RW", "TRTP", "Specifies the minimum delay between the DRAM Read and Precharge commands to the same bank. (in DRAM Clocks) [br]LPDDR3 Equation: = BL/2 + tRTP - 4 [br]LPDDR4 Equation: = BL/2 + Max (8, tRTP) - 8 [br]WIO2 Equation: = BL/2 + tRTP - 2"},
#else
{27, 31, 0x0000000000000006, "RW", "TRTP", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{20, 26, 0x0000000000000000, "RW", "TCCD_INC", "Specifies the number of clocks to be added to turnaround times (for Stretch Mode). It increases delay between Read to Read or Read to Write commands. (in 4 x DRAM Clocks)"},
#else
{20, 26, 0x0000000000000000, "RW", "TCCD_INC", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{13, 19, 0x0000000000000017, "RW", "TWTP", "Specifies the minimum delay between the DRAM Write command and the Precharge command to the same bank. (in DRAM Clocks) [br]LPDDR3/LPDDR4/WIO2 Equation: tWTP = BL/2 + CWL + tWR + 1"},
#else
{13, 19, 0x0000000000000017, "RW", "TWTP", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{11, 12, 0x0000000000000001, "RW", "TCMD", "Specifies the number of DRAM clocks a command is held valid on the DRAM Address and Control buses. 1N is the DDR3 basic requirement.  2N is the extended mode for board signal integrity. [br]0h - Reserved, 1h - 1 DRAM Clock (1N), 2h - 2 DRAM Clocks (2N), 3h - Reserved [br]Note: tCMD must be set to 1N for LPDDR3/LPDDR4/WIO2. [br]Note: This field is reserved in BXT0/1"},
#else
{11, 12, 0x0000000000000001, "RW", "TCMD", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{6, 10, 0x0000000000000008, "RW", "TCWL", "The delay in DRAM clocks between the internal write command and the availability of the first word of DRAM input data. (in DRAM Clocks)"},
#else
{6, 10, 0x0000000000000008, "RW", "TCWL", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 5, 0x0000000000000028, "RW", "TWMWSB", "Specifies the minimum delay between DRAM Write command to Masked Write command to same bank. (in DRAM Clocks) [br]LPDDR4 Equation: tWMWSB = tCCDMW (BL16) or tCCDMW + 8 (BL32), [br]WIO2 Equation: tWMWSB = tCCDMW (BL4) or tCCDMW + 2 (BL8). [br]Note: Masked Write operation in LPDDR4 is always BL16 and in WIO2 is always BL4. [br]D-unit applies this timing for same rank as well as same bank, refer to Dunit HAS for more details"},
#else
{0, 5, 0x0000000000000028, "RW", "TWMWSB", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo4[] = {{"D_CR_DTR3A", "", 0x00000014, 6, 0x00000000FFFFFFFF, 0x000000003002EA28}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields5[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{24, 31, 0x0000000000000030, "RW", "TFAW", "A rolling timeframe in which a maximum of four Activate commands can be issued to the same rank. This is to limit the peak current draw from the DRAM devices. (in DRAM Clocks)"},
#else
{24, 31, 0x0000000000000030, "RW", "TFAW", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{18, 23, 0x0000000000000008, "RW", "TWRDR", "Specifies the delay from the start of a Write data burst of one rank to the start of a Read data burst of a different rank. (in DRAM Clocks) [br]LPDDR3 Equation: tWRDR = WL + tDQSSmax + BL/2 - (RL + tDQSCKmin - tRPRE) [br]LPDDR4 Equation: tWRDR = WL - RL + BL/2 + 4 - tDQSCKmin [br]Note: For LPDDR3/4 using ODT this latency may need to be increased by tODToffadj."},
#else
{18, 23, 0x0000000000000008, "RW", "TWRDR", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{12, 17, 0x0000000000000009, "RW", "TRWDR", "Specifies the delay from the start of a Read data burst of one rank to the Start of a Write data burst of a different rank. (in DRAM Clocks) [br]LPDDR3 Equation: tRWDR = RL + tDQSCKmax + BL/2 - (WL + tDQSSmin - tWPRE) [br]LPDDR4 Equation: tRWDR = RL + tDQSCKmax + BL/2 - (WL - 2)[br]Note: For LPDDR3/4 using ODT this latency may need to be adjusted by tODTon."},
#else
{12, 17, 0x0000000000000009, "RW", "TRWDR", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{6, 11, 0x0000000000000005, "RW", "TWWDR", "Specifies the delay from the start of a Write data burst of one rank to the start of a Write data burst of a different rank. (in DRAM Clocks) [br]LPDDR3 Equation: tWWDR = (WL + BL/2 + tDQSSmax + tWPRE) - (WL + tDQSSmin) [br]LPDDR4 Equation: tWWDR = BL/2 + 4 - tDQSSmin [br]Note: For LPDDR3/4 using ODT this latency may need to be increased by tODToffadj"},
#else
{6, 11, 0x0000000000000005, "RW", "TWWDR", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 5, 0x0000000000000009, "RW", "TRRDR", "Specifies the delay from the start of a Read data burst of one rank to the Start of a Read data burst of a different rank. (in DRAM Clocks) [br]LPDDR3/4 Equation: tRRDR = (RL + tDQSCKmax + BL/2) + tRPRE - (RL + tDQSCKmin)"},
#else
{0, 5, 0x0000000000000009, "RW", "TRRDR", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo5[] = {{"D_CR_DTR4A", "", 0x00000018, 5, 0x00000000FFFFFFFF, 0x0000000030209149}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields6[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{27, 31, 0x0000000000000006, "RW", "TRRD", "Specifies the minimum delay between two DRAM Activate commands to the same rank but different banks (tRC is the minimum delay between activations of the same bank). (in DRAM Clocks)  [br]Note: Derating adds 1.875ns to this timing."},
#else
{27, 31, 0x0000000000000006, "RW", "TRRD", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{26, 26, 0x0000000000000000, "RO", "RSVD26", "Reserved"},
#else
{26, 26, 0x0000000000000000, "RO", "RSVD26", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{23, 25, 0x0000000000000000, "RW", "TDERATE_INC", "Specifies the additional delay that is added to DRAM timing when indicated by MR4 status. (in DRAM clocks) [br]LPDDR3/LPDDR4/WIO2: Value is 1.875ns [br]Note: The value in this register is only added to these timing parameters: tRCD, tRAS, tRP and tRRD"},
#else
{23, 25, 0x0000000000000000, "RW", "TDERATE_INC", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{18, 22, 0x0000000000000010, "RW", "TWWSR", "Specifies the delay from a DRAM Write to another Write command of the same rank. [br]LPDDR3/LPDDR4/WIO2 Equation: tRRSR = tCCD"},
#else
{18, 22, 0x0000000000000010, "RW", "TWWSR", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{13, 17, 0x0000000000000010, "RW", "TRRSR", "Specifies the delay from a DRAM Read to another Read command of the same rank. [br]LPDDR3/LPDDR4/WIO2 Equation: tRRSR = tCCD"},
#else
{13, 17, 0x0000000000000010, "RW", "TRRSR", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{6, 12, 0x0000000000000003, "RW", "TWRSR", "Specifies the delay from a DRAM Read to Write command of the same rank. [br]LPDDR3/LPDDR4/WIO2 Equation: tWRSR  = WL + 1 + BL/2 + tWTR"},
#else
{6, 12, 0x0000000000000003, "RW", "TWRSR", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 5, 0x0000000000000002, "RW", "TRWSR", "Specifies the delay from a DRAM Read to a Write command of the same rank. [br]Equation: tRWSR = RL + tDQSCKmax + BL/2 - WL + tWPRE [br]Note:For LPDDR3/4 using ODT this latency may need to be increased by tODToffadj"},
#else
{0, 5, 0x0000000000000002, "RW", "TRWSR", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo6[] = {{"D_CR_DTR5A", "", 0x0000001C, 7, 0x00000000FFFFFFFF, 0x00000000304200C2}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields7[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{24, 31, 0x0000000000000020, "RW", "OREFDLY", "Rank idle period that defines an opportunity for refresh. (in DRAM clocks)"},
#else
{24, 31, 0x0000000000000020, "RW", "OREFDLY", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{23, 23, 0x0000000000000000, "RO", "RSVD3_2", "Reserved"},
#else
{23, 23, 0x0000000000000000, "RO", "RSVD3_2", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{19, 22, 0x0000000000000002, "RW", "TCKCKEL", "Specifies the amount of time that DRAM clocks need to toggle after CKE goes low. (in DRAM Clocks) [br]For WIO2/LPDDR3 this covers tCPDED [br]For LPDDR4 this covers both tCKCKEL and tCKELCMD [br]For DDR3 this is tCKSRE [br]Note: D-unit hardware enforces minimum of two SPID clocks after CKEL, any value in this register is the additional time."},
#else
{19, 22, 0x0000000000000002, "RW", "TCKCKEL", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{15, 18, 0x0000000000000000, "RW", "MNTDLY", "When a critical read request is pending in RPQ and a maintenance operation (MRR, ZQCal, Ref, etc.) needs to be performed, Dunit waits this amount of time before performing the maintenance operation to allow for some high priority requests to be issued (in 4x DRAM clocks)"},
#else
{15, 18, 0x0000000000000000, "RW", "MNTDLY", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{8, 14, 0x0000000000000014, "RW", "TPSTMRBLK", "Specifies the quiet time after issuing MRR/MRW command (in DRAM Clocks). [br]LPDDR3/4 Equation: tPSTMRBLK = RL + tDQSCK + BL/2 of MRR/MRW + 1 - WL - DTR5A.TRWSR, WIO2 Equation: tPSTMRBLK = RL + tDQSCK + BL/2 of MRR/MRW + 1"},
#else
{8, 14, 0x0000000000000014, "RW", "TPSTMRBLK", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{7, 7, 0x0000000000000000, "RO", "RSVD3_2", "Reserved"},
#else
{7, 7, 0x0000000000000000, "RO", "RSVD3_2", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 6, 0x0000000000000016, "RW", "TPREMRBLK", "Specifies the quiet time before issuing MRR/MRW command. (in DRAM clocks). [br] LPDDR3 Equation: tPREMRBLK = Max(RL + tDQSCK + BL/2 + tRPST, tXP + tMRRI), LPDDR4/WIO2 Equation: tPREMRBLK = tXP + tMRRI "},
#else
{0, 6, 0x0000000000000016, "RW", "TPREMRBLK", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo7[] = {{"D_CR_DTR6A", "", 0x00000020, 7, 0x00000000FFFFFFFF, 0x0000000020101416}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields8[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{26, 31, 0x0000000000000003, "RW", "TRPAB", "Specifies the delay between a DRAM Precharge All Bank command and a DRAM Activate command. (in DRAM Clocks) [br]Note: Derating adds 1.875ns to this timing  [br]For LPDDR, tRPpb = tRP, tRPab = tRP + 3ns.  [br]For DDR3 and WIO2 8ch tRPpb = tRPab = tRP."},
#else
{26, 31, 0x0000000000000003, "RW", "TRPAB", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{23, 25, 0x0000000000000002, "RW", "TPSTMRWBLK", "Mode Register Write to any command delay:\r\n"
"Specifies the quiet time after issuing MRW command (in 8 x DRAM clocks)\r\n"
"Note: This time covers for tMRD and tMRW"},
#else
{23, 25, 0x0000000000000002, "RW", "TPSTMRWBLK", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{16, 22, 0x0000000000000006, "RW", "TWRPDEN", "Specifies the minimum time between a write command to PowerDown command. (in DRAM Clocks) [br]Must be at least equal to tWR + tCCD + tWL + 2."},
#else
{16, 22, 0x0000000000000006, "RW", "TWRPDEN", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{9, 15, 0x0000000000000006, "RW", "TRDPDEN", "Specifies the minimum time between a read command to PowerDown command. (in DRAM Clocks) [br]Must be at least equal to tCL + tDQSCKmax + tCCD + tRPST"},
#else
{9, 15, 0x0000000000000006, "RW", "TRDPDEN", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{7, 8, 0x0000000000000000, "RO", "RSVD7", "Reserved"},
#else
{7, 8, 0x0000000000000000, "RO", "RSVD7", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 6, 0x0000000000000006, "RW", "TRAS", "Specifies the minimum delay between the DRAM Activate and Precharge commands to the same bank. (in DRAM Clocks) [br]Note: Derating adds 1.875ns to this timing"},
#else
{0, 6, 0x0000000000000006, "RW", "TRAS", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo8[] = {{"D_CR_DTR7A", "", 0x00000024, 6, 0x00000000FFFFFFFF, 0x000000000D060C06}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields9[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{26, 31, 0x0000000000000003, "RW", "TCKESR", "Specifies the minimum time that DRAM should remain in SR. (in DRAM Clocks)"},
#else
{26, 31, 0x0000000000000003, "RW", "TCKESR", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{25, 25, 0x0000000000000000, "RO", "RSVD25_23", "Reserved"},
#else
{25, 25, 0x0000000000000000, "RO", "RSVD25_23", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{17, 24, 0x000000000000000A, "RW", "LPMDTOCKEDLY", "Specifies the minimum time between the LP Mode exit to the CK stop/tristate deassertion and powerdown exit. (in DRAM Clocks) [br]Note: Must be equal t_idle_latency published in the DDRIO PHY HAS and less than 0xFC"},
#else
{17, 24, 0x000000000000000A, "RW", "LPMDTOCKEDLY", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{10, 16, 0x000000000000000A, "RW", "CKETOLPMDDLY", "Specifies the time between CK stop/tristate to the Low Power Mode entry. (in DRAM Clocks). This timing parameter is used to delay Low Power Mode entry. [br]Note: Must be at least equal to t_idle_length parameter published in the DDRIO PHY HAS and less than 0x7C"},
#else
{10, 16, 0x000000000000000A, "RW", "CKETOLPMDDLY", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{8, 9, 0x0000000000000000, "RO", "RSVD11_8", "Reserved"},
#else
{8, 9, 0x0000000000000000, "RO", "RSVD11_8", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 7, 0x0000000000000018, "RW", "PWDDLY", "This is a non-JEDEC timing parameter used to delay powerdown entry. (in DRAM Clocks) [br]Note: CKE goes low only on Phase 0 of SPID"},
#else
{0, 7, 0x0000000000000018, "RW", "PWDDLY", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo9[] = {{"D_CR_DTR8A", "", 0x00000028, 6, 0x00000000FFFFFFFF, 0x000000000C142818}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields10[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{30, 31, 0x0000000000000000, "RO", "RSVD31_30", "Reserved"},
#else
{30, 31, 0x0000000000000000, "RO", "RSVD31_30", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{29, 29, 0x0000000000000000, "RW", "R1RDODTCTL", "Specifies the behavior of ODT signals when a Read command is issued to Rank 1 [br]0 - Read ODT is disabled for Rank 1 [br] 1 - Assert ODT to for Rank 0 (non-targeted Rank) [br]Note: This register is reserved for LPDDR3 devices"},
#else
{29, 29, 0x0000000000000000, "RW", "R1RDODTCTL", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{28, 28, 0x0000000000000000, "RW", "R0RDODTCTL", "Specifies the behavior of ODT signals when a Read command is issued to Rank 0 [br]0 - Read ODT is disabled for Rank 0 [br] 1 - Assert ODT to for Rank 1 (non-targeted Rank) [br]Note: This register must be set to 0 for LPDDR3 devices"},
#else
{28, 28, 0x0000000000000000, "RW", "R0RDODTCTL", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{26, 27, 0x0000000000000000, "RW", "R1WRODTCTL", "Specifies the behavior of ODT signals when a Write command is issued to Rank 1 [br]00 - Write ODT is disabled [br]01 - Assert ODT to Rank 0 (non-targeted Rank) [br]10 - Assert ODT to Rank 1 (targeted Rank) [br]11 - Assert ODT to Rank 0 and Rank 1 [br]Note: 10 and 11 are reserved values for LPDDR3"},
#else
{26, 27, 0x0000000000000000, "RW", "R1WRODTCTL", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{24, 25, 0x0000000000000000, "RW", "R0WRODTCTL", "Specifies the behavior of ODT signals when a Write command is issued to Rank 0 [br]00 - Write ODT is disabled [br]01 - Assert ODT to Rank 0 (targeted Rank) [br]10 - Assert ODT to Rank 1 (non-targeted Rank) [br]11 - Assert ODT to Rank 0 and Rank 1 [br]Note: 10 and 11 are reserved values for LPDDR3"},
#else
{24, 25, 0x0000000000000000, "RW", "R0WRODTCTL", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{19, 23, 0x0000000000000000, "RO", "RSVD23_19", "Reserved"},
#else
{19, 23, 0x0000000000000000, "RO", "RSVD23_19", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{14, 18, 0x0000000000000000, "RW", "RDODTSTOP", "Specifies Read ODT assertion to ODT de-assert delay (in DRAM clocks) [br]DDR3 Equation: RDODTSTOP = 6 + DOCRx.WRODTSTOP - DOCRx.WRODTSTRT"},
#else
{14, 18, 0x0000000000000000, "RW", "RDODTSTOP", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{13, 13, 0x0000000000000000, "RO", "RSVD13_13", "Reserved"},
#else
{13, 13, 0x0000000000000000, "RO", "RSVD13_13", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{10, 12, 0x0000000000000000, "RW", "RDODTSTART", "Specifies Read ODT assertion delay after Read Command (in DRAM clocks) [br]DDR3 Equation: DDR3 Equation: RDODTSTART = CL - CWL + DTR1x.tCMD - DOCR.WRODTSTRT"},
#else
{10, 12, 0x0000000000000000, "RW", "RDODTSTART", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{5, 9, 0x0000000000000000, "RW", "WRODTSTOP", "Specifies number of clocks after ODT assertion that Dunit deasserts ODT signal (in DRAM clocks) [br]LPDDR3 Equation: WRODTSTOP = RU(tODTon(max)/tCK) + RU((tDQSSmax+tWPST)/tCK) + BL/2 - RD(tODToffmin/tCK) [br]DDR3 Equation: WRODTSTOP >= 6"},
#else
{5, 9, 0x0000000000000000, "RW", "WRODTSTOP", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{4, 4, 0x0000000000000000, "RW", "EARLYWRODT", "DDR3 spec requires ODT to be asserted high when the DRAM Write command is issued. EARLYWRODT can be set to enable asserting ODT one DRAM clock earlier than the Write Command (WR) for 2N."},
#else
{4, 4, 0x0000000000000000, "RW", "EARLYWRODT", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 3, 0x0000000000000000, "RW", "WRODTSTART", "Specifies number of clocks after Write command that Dunit asserts ODT signal (in DRAM clocks) [br]LPDDR3 Equation: WRODTSTART = WL - RU(tODTon(max)/tCK) [br]DDR3 Equation: WRODTSTART = 0"},
#else
{0, 3, 0x0000000000000000, "RW", "WRODTSTART", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo10[] = {{"D_CR_DOCRA", "", 0x0000002C, 12, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields11[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{29, 31, 0x0000000000000000, "RO", "RSVD31_29", "Reserved"},
#else
{29, 31, 0x0000000000000000, "RO", "RSVD31_29", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{24, 28, 0x0000000000000000, "RW", "SUSPMOP", "DDRIO PHY Power Mode Opcode: After the Dunit has placed the DRAM devices in Self Refresh mode as the result of a SUSPEND message, it sends this 5-bit value to the DDRIO PHY to tell it which power saving mode it should enter. [br]Changing this register value while in SUSPEND will have no effect. [br]Note: This opcode cannot be a PM state where it disables PHY PLLs i.e PM7 in LPDDR PHY"},
#else
{24, 28, 0x0000000000000000, "RW", "SUSPMOP", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{23, 23, 0x0000000000000000, "RO", "RSVD23", "Reserved"},
#else
{23, 23, 0x0000000000000000, "RO", "RSVD23", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{22, 22, 0x0000000000000000, "RW", "SRPMCLKW", "Specifies when it is safe to send PM message to the PHY. When enabled Dunit waits for SPID Clock to deassert before sending a PM message on SR entry. [br]0 - D-unit will not wait for SPID_clk to deassert before sending the PM message to PHY, 1 - D-unit will wait for SPID_clk to deassert before sending PM message to the PHY. [br]Note: The value must be 1 when DYNPMOP = 0x7"},
#else
{22, 22, 0x0000000000000000, "RW", "SRPMCLKW", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{17, 21, 0x0000000000000000, "RW", "DYNPMOP", "DDRIO PHY Power Mode Opcode:  After the D-unit has placed the DRAM devices in Self Refresh mode as the result of a Dynamic Self-Refresh, it sends this 5bit value to the DDRIO PHY to tell it which power saving mode it should enter. [br]Changing this register value while in self-refresh will only change the PM state for the next entry in DynSR."},
#else
{17, 21, 0x0000000000000000, "RW", "DYNPMOP", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{16, 16, 0x0000000000000000, "RW", "DYNSREN", "When set to 1 the D-unit will automatically control DRAM Self Refresh entry and exit based on interface state and requests in pending queues. When there is no pending request in the queues and PMI is idle then the D-unit will place the DRAM devices in Self Refresh mode. The DRAM devices will be brought out of Self-Refresh when idle conditions don't hold."},
#else
{16, 16, 0x0000000000000000, "RW", "DYNSREN", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 15, 0x0000000000000000, "RW", "SREDLY", "Specifies the minimum time the D-unit will wait before it enters Dynamic Self-Refresh mode when idle. (in 16x DRAM Clocks)"},
#else
{0, 15, 0x0000000000000000, "RW", "SREDLY", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo11[] = {{"D_CR_DPMC0", "", 0x00000030, 7, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields12[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{30, 31, 0x0000000000000000, "RO", "RSVD31_30", "Reserved"},
#else
{30, 31, 0x0000000000000000, "RO", "RSVD31_30", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{29, 29, 0x0000000000000000, "RW", "RPTCLKGTDIS", "Setting this bit to 0 allows majority of the repeaters between D-unit and PHY to clock gate when there is no activity in order to save power.[br]0 -  Enable Repeaters clock gating,  1 -  Disable Repeaters clock gating."},
#else
{29, 29, 0x0000000000000000, "RW", "RPTCLKGTDIS", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{28, 28, 0x0000000000000001, "RW", "SBEPCLKGTDIS", "Setting this bit to 0 enables the clock gating of IOSF-SB End Points in Dunit and CPGC when there is no IOSF-SB activity in order to save power. [br]0 -  Enable IOSF-SB EP clock gating,  1 -  Disable IOSF-SB clock gating. [br]Note: This is a de-feature bit and should be set to 0 for normal operation."},
#else
{28, 28, 0x0000000000000001, "RW", "SBEPCLKGTDIS", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{27, 27, 0x0000000000000000, "RW", "CLKGTDIS", "Setting this bit to 0 allows the majority of the D-unit clocks to be gated off when there is no activity in order to save power. When set to 1 D-unit clockgating is disabled.  0 -  Enable,  1 -  Disable. [br]Note: This is a de-feature bit and should be set to 0 for normal operation."},
#else
{27, 27, 0x0000000000000000, "RW", "CLKGTDIS", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{26, 26, 0x0000000000000000, "RW", "CSTRIST", "0 -  The DRAM CS pins associated with the enabled ranks are never tristated.  1 - DRAMs CS pins are tristated when DRAM clock is stopped or tristetd . [br]Note: CS is not tristated when clock stop tristate is disabled."},
#else
{26, 26, 0x0000000000000000, "RW", "CSTRIST", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{24, 25, 0x0000000000000000, "RW", "CMDTRIST", "Was CMDTRIST. This feature is controlled by PHY."},
#else
{24, 25, 0x0000000000000000, "RW", "CMDTRIST", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{16, 23, 0x0000000000000000, "RW", "PASR", "This is the Segment Mask used for the MRW to MR17 during SUSPENDP (Partial Array Self Refresh entry)."},
#else
{16, 23, 0x0000000000000000, "RW", "PASR", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{8, 15, 0x0000000000000000, "RW", "PCLSTO", "Specifies the time from the last access of a DRAM page until that page is scheduled to close by sending a Precharge command to DRAM. (in 16 x DRAM Clocks)"},
#else
{8, 15, 0x0000000000000000, "RW", "PCLSTO", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{7, 7, 0x0000000000000000, "RW", "PCLSTODIS", "When Disabled Dunit will not close the DRAM page when idle. 0 - Enable page close timer,  1 - Disable page close timer (Used during DRAM init and DDRIO training)."},
#else
{7, 7, 0x0000000000000000, "RW", "PCLSTODIS", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{5, 6, 0x0000000000000000, "RO", "RSVD6_5", "Reserved"},
#else
{5, 6, 0x0000000000000000, "RO", "RSVD6_5", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{3, 4, 0x0000000000000001, "RW", "ENCKSTP", "Enable/Disable CK Stop/Tristate During Power down.  [br]00 - Disable CK Stop/Tristate During Power down. 01 - Enable CK Stop During Power down. 10 - Enable CK Tristate During Power down. 11 - Reserved"},
#else
{3, 4, 0x0000000000000001, "RW", "ENCKSTP", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{1, 2, 0x0000000000000000, "RW", "LPMODEOP", "D-unit will send the value in this register after it has entered Powerdown Mode and has stopped/tristated the clock [br]00 - Disable LPMode"},
#else
{1, 2, 0x0000000000000000, "RW", "LPMODEOP", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 0, 0x0000000000000000, "RW", "DISPWRDN", "Setting this bit to 1 disables dynamic control of DRAM Power-Down entry and exit by keeping the CKE pins driven high. BIOS may set it to 1 during DRAM initialization and DDRIO training. This bit should be set to 0 for normal operation.  [br] 0 - The Dunit dynamically controls the CKE pins to place the DRAM devices in Power Down mode and bring them out of Power Down mode. 1 - The Dunit constantly drives the CKE pins high to keep the DRAM devices from entering Power Down mode when ranks are idle. [br]Note: This bit is overridden if CKEMODE = 1. [br]This bit does not control CKE behavior on SR entry/exit."},
#else
{0, 0, 0x0000000000000000, "RW", "DISPWRDN", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo12[] = {{"D_CR_DPMC1", "", 0x00000034, 13, 0x00000000FFFFFFFF, 0x0000000010000008}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields13[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{22, 31, 0x0000000000000000, "RO", "RSVD31_22", "Reserved"},
#else
{22, 31, 0x0000000000000000, "RO", "RSVD31_22", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{21, 21, 0x0000000000000000, "RW", "DISREFDBTCLR", "When set dunit will not clear refresh debt before Self Refresh SR Entry: [br]0 - Dunit sends all postponed REF commands to DRAM before it enters Self Refresh. 1 - Dunit enters SR without clearing the Refresh Debt (for Debug only)"},
#else
{21, 21, 0x0000000000000000, "RW", "DISREFDBTCLR", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{20, 20, 0x0000000000000000, "RW", "REFSKWDIS", "Disables Skewing of Refresh Counting between Ranks.  [br]Each rank has its own refresh counter. By default incrementing these refresh counters are skewed by 1/2 the tREFI period. Setting this bit to a 1 disables this feature and all refresh counters will increment at the same time per tREFI period. Skewing the tREFI counters can improve performance since traffic to all ranks does not have to be blocked to perform refresh. [br]0 - Incrementing the refresh counters are skewed by 1/2 tREFI period. 1 - All refresh counters will increment at the same time per tREFI period. [br]Reserved in BXT0"},
#else
{20, 20, 0x0000000000000000, "RW", "REFSKWDIS", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{18, 19, 0x0000000000000000, "RO", "RSVD19_18", "Reserved"},
#else
{18, 19, 0x0000000000000000, "RO", "RSVD19_18", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{16, 17, 0x0000000000000000, "RO", "RSVD17_16", "Reserved"},
#else
{16, 17, 0x0000000000000000, "RO", "RSVD17_16", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{15, 15, 0x0000000000000000, "RW", "EXTRAREFDBT", "When set to 1 D-unit adds one extra refresh debit (for a total of two) on Self-refresh exit."},
#else
{15, 15, 0x0000000000000000, "RW", "EXTRAREFDBT", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{12, 14, 0x0000000000000001, "RW", "MINREFRATE", "Ensures that refresh rate never drops below a certain limit regardless of TQ polling. [br]000 - Disable  tREFI counter, [br]001 - 0.25x refresh rate (i.e. 4x tREFI same as no limit), [br]010 - 0.5x refresh rate (i.e. 2x tREFI), [br]011 - 1x refresh rate (i.e. 1x tREFI), [br]100 - 2x refresh rate (i.e. 0.5x tREFI), [br]101 - 4x refresh rate (i.e. 0.25x tREFI), [br]110 - 4x refresh rate with derating forced on i.e. 0.25x tREFI, [br]111 - Reserved"},
#else
{12, 14, 0x0000000000000001, "RW", "MINREFRATE", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{8, 11, 0x0000000000000007, "RW", "REFWMPNC", "When the Refresh counter per rank is greater than this value the Dunit will send a REF command to the rank regardless of pending requests. [br]Note: REFWMPNC must be greater than or equal to REFWMHI and greater than 2, Max Value must be less than 8 to not violate 9xtREFI JEDEC requirement"},
#else
{8, 11, 0x0000000000000007, "RW", "REFWMPNC", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{4, 7, 0x0000000000000005, "RW", "REFWMHI", "When the Refresh counter per rank is greater than this value the Dunit will send a REF command to the rank if there is no critical priority requests in the pending queues [br]Note: value must be greater or equal to 1 and less than or equal to REFWMPNC"},
#else
{4, 7, 0x0000000000000005, "RW", "REFWMHI", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{1, 3, 0x0000000000000000, "RO", "RSVD3_1", "Reserved"},
#else
{1, 3, 0x0000000000000000, "RO", "RSVD3_1", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 0, 0x0000000000000000, "RW", "OREFDIS", "Disable opportunistic scheduling of refresh. [br]0 - Dunit will send a REF command only if there is no pending request to that rank, [br]1 - Dunit will not send any opportunistic refreshes. Refresh commands are only sent when the refresh counter is greater than REFWMHI [br]Note: When set DISREFDBTCLR must also be set to be able to enter SR"},
#else
{0, 0, 0x0000000000000000, "RW", "OREFDIS", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo13[] = {{"D_CR_DRFC", "", 0x00000038, 11, 0x00000000FFFFFFFF, 0x0000000000001750}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields14[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{27, 31, 0x0000000000000000, "RO", "RSVD31_27", "Reserved"},
#else
{27, 31, 0x0000000000000000, "RO", "RSVD31_27", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{21, 26, 0x0000000000000020, "RW", "WPQCOUNT", "Used to limit the number of available slots in Write Pending Queue/ Write Data Buffer. WPQCOUNT will only recognize changes when PMI ISM is not active."},
#else
{21, 26, 0x0000000000000020, "RW", "WPQCOUNT", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{16, 20, 0x0000000000000010, "RW", "RPQCOUNT", "Used to llimit the number of entries in Read Pending Queue. RPQCOUNT will only recognize changes when PMI ISM is not active."},
#else
{16, 20, 0x0000000000000010, "RW", "RPQCOUNT", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{10, 15, 0x0000000000000000, "RO", "RSVD15_10", "Reserved"},
#else
{10, 15, 0x0000000000000000, "RO", "RSVD15_10", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{8, 9, 0x0000000000000000, "RW", "INORDERMODE", "0h - In order mode disabled: Commands are sent out of order, [br]1h - Partial in order mode: Read and Write CAS commands are sent in the order they were recieved. ACT and PRE can go out of order, [br]2h - Full in order mode serialized test: All DRAM commands CAS ACT PRE associated with a PMI request are issued to DDR before any DRAM commands for a subsequent PMI request.  [br]3h - Reserved   [br]In order modes should be enabled during init/training/CPGC testing. Should never be changed while the Dunit queues are nonempty."},
#else
{8, 9, 0x0000000000000000, "RW", "INORDERMODE", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{7, 7, 0x0000000000000000, "RW", "BYPASSEN", "Idle Bypass Mode Enable: When enabled new page hit/empty read requests will bypass D-unit pipeline stages to save latency 0 - Disable Idle Bypass 1 - Enable Idle Bypass Note: Only applies to WIO2, this bit is reserved for other technologies"},
#else
{7, 7, 0x0000000000000000, "RW", "BYPASSEN", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{6, 6, 0x0000000000000000, "RO", "RSVD6", "Reserved"},
#else
{6, 6, 0x0000000000000000, "RO", "RSVD6", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{4, 5, 0x0000000000000000, "RW", "STRETCHMODE", "When stretch mode is enabled commands are initiated only on Phase 0 of SPIDClk. [br]00 - Stretch mode is disabled, 01 - Commands are initiated on Phase 0 of every SPID clocks, 10 - Commands are initiated on Phase 0 of even SPID clocks, 11 - Commands are initiated on Phase 0 of odd SPID clocks"},
#else
{4, 5, 0x0000000000000000, "RW", "STRETCHMODE", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 3, 0x0000000000000008, "RW", "TMWR_TA_DELTA", "The value in this register is subtracted from Masked Write to Read, Masked Write to Write and Masked Write to Masked Write turnaround times to account for half BL MWr commands in LPDDR4 and WIO2. [br]LPDDR4: = MWr tCCD = MWr BL/2 = 8 [br]WIO2: = MWr tCCD = MWr BL/2 = 2"},
#else
{0, 3, 0x0000000000000008, "RW", "TMWR_TA_DELTA", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo14[] = {{"D_CR_DSCH", "", 0x0000003C, 9, 0x00000000FFFFFFFF, 0x0000000004100008}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields15[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{23, 31, 0x0000000000000000, "RO", "RSVD31_23", "Reserved"},
#else
{23, 31, 0x0000000000000000, "RO", "RSVD31_23", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{21, 22, 0x0000000000000000, "RW", "SRXZQC", "00 - On DynSR exit ZQ timer determines the ZQ type. When the state is lost (i.e due to AutoPG/S0ix) ZQCL is always performed. [br]01 - Always perform ZQCL after self refresh exit, in LPDDR4, ZQ with traffic blocked [br]10 - Always perform ZQCS on SR exit. For LPDDR4, ZQ while traffic is allowed [br]11 - No ZQCL commands are sent. (it disables ZQCAL commands on SR exit)."},
#else
{21, 22, 0x0000000000000000, "RW", "SRXZQC", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{18, 20, 0x0000000000000000, "RO", "RSVD20_18", "Reserved"},
#else
{18, 20, 0x0000000000000000, "RO", "RSVD20_18", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{17, 17, 0x0000000000000000, "RW", "ZQCLMODE", "Specifies how ZQCal commands are sent to different ranks [br]0 - ZQCL commands are sent in parallel to all ranks after Self Refresh exit. [br]1 -  ZQCL commands are sent serially to each rank after Self Refresh exit."},
#else
{17, 17, 0x0000000000000000, "RW", "ZQCLMODE", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{16, 16, 0x0000000000000000, "RW", "ZQCDIS", "0 - Periodic ZQ Calibration is Enabled, [br]1 - Disable periodic ZQ Calibration"},
#else
{16, 16, 0x0000000000000000, "RW", "ZQCDIS", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{14, 15, 0x0000000000000000, "RO", "RSVD15_14", "Reserved"},
#else
{14, 15, 0x0000000000000000, "RO", "RSVD15_14", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 13, 0x0000000000001057, "RW", "ZQINT", "Specifies the time interval between two ZQCS (LPDDR3) or ZQ Start (LPDDR4) commands to a DRAM device. (in RTC 32.8KHz clocks)"},
#else
{0, 13, 0x0000000000001057, "RW", "ZQINT", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo15[] = {{"D_CR_DCAL", "", 0x00000040, 7, 0x00000000FFFFFFFF, 0x0000000000001057}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields16[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{19, 31, 0x0000000000000000, "RO", "RSVD31_19", "Reserved"},
#else
{19, 31, 0x0000000000000000, "RO", "RSVD31_19", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{18, 18, 0x0000000000000000, "RW", "CPGCLOCK", "Write a 1 to this bit to lock and clock gate the CPGC."},
#else
{18, 18, 0x0000000000000000, "RW", "CPGCLOCK", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{17, 17, 0x0000000000000000, "RO", "RSVD17", "Reserved"},
#else
{17, 17, 0x0000000000000000, "RO", "RSVD17", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{16, 16, 0x0000000000000000, "RW", "COLDWAKE", "This bit must be set and then cleared by BIOS during cold/warm reset. [br]Also when set before SUSPEND/WAKE commands D-unit will not send SR entry/exit commands to DRAM"},
#else
{16, 16, 0x0000000000000000, "RW", "COLDWAKE", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{13, 15, 0x0000000000000000, "RO", "RSVD15_13", "Reserved"},
#else
{13, 15, 0x0000000000000000, "RO", "RSVD15_13", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{12, 12, 0x0000000000000000, "RW", "ODTMODE", "0 - Dunit auto controls the ODT pins based on DRAM Write transactions. [br]1 - The value of ODTVAL directly controls the ODT pins. Note: Reserved for BXT0/1"},
#else
{12, 12, 0x0000000000000000, "RW", "ODTMODE", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{10, 11, 0x0000000000000000, "RO", "RSVD11_10", "Reserved"},
#else
{10, 11, 0x0000000000000000, "RO", "RSVD11_10", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{8, 9, 0x0000000000000000, "RW", "ODTVAL", "Each bit of ODTVAL directly controls an ODT pin when ODTMODE is set to 1.  Used only during init flow. Note: Reserved for BXT0/1"},
#else
{8, 9, 0x0000000000000000, "RW", "ODTVAL", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{5, 7, 0x0000000000000000, "RO", "RSVD7_5", "Reserved"},
#else
{5, 7, 0x0000000000000000, "RO", "RSVD7_5", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{4, 4, 0x0000000000000000, "RW", "CKEMODE", "0 - Dunit auto controls the CKE pins based on PowerDown and Self Refresh entry and exit.  [br]1 - The value of CKEVAL field directly controls the CKE pins."},
#else
{4, 4, 0x0000000000000000, "RW", "CKEMODE", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{2, 3, 0x0000000000000000, "RO", "RSVD3_2", "Reserved"},
#else
{2, 3, 0x0000000000000000, "RO", "RSVD3_2", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 1, 0x0000000000000000, "RW", "CKEVAL", "Each bit of CKEVAL directly controls a CKE pin when CKEMODE is set to 1.  [br]Used only during init flow."},
#else
{0, 1, 0x0000000000000000, "RW", "CKEVAL", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo16[] = {{"D_CR_DRMC", "", 0x00000044, 12, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields17[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{31, 31, 0x0000000000000000, "RW", "VNN_TIMER_EN", "0 - The Dunit VNN Scaling Timer is disabled, [br]1 - The Dunit VNN Scaling Timer is enabled"},
#else
{31, 31, 0x0000000000000000, "RW", "VNN_TIMER_EN", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{12, 30, 0x0000000000000000, "RO", "RSVD30_12", "Reserved"},
#else
{12, 30, 0x0000000000000000, "RO", "RSVD30_12", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 11, 0x0000000000000000, "RW", "VNN_TIMER_TIME", "The final timer value (in 16 x DRAM Clocks)"},
#else
{0, 11, 0x0000000000000000, "RW", "VNN_TIMER_TIME", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo17[] = {{"D_CR_VNNTIMER", "", 0x0000004C, 3, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields18[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{29, 31, 0x0000000000000003, "RW/V", "TQDATAR1", "If Rank 1 is disabled this value will remain zero. [br]This field contains the data of the last DRAM Mode Register Read to MR4 MRR issued. It is overwritten with each command."},
#else
{29, 31, 0x0000000000000003, "RW/V", "TQDATAR1", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{26, 28, 0x0000000000000003, "RW/V", "TQDATAR0", "This field contains the data of the last DRAM Mode Register Read to MR4 MRR issued. It is overwritten with each command."},
#else
{26, 28, 0x0000000000000003, "RW/V", "TQDATAR0", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{22, 25, 0x0000000000000000, "RO", "RSVD25_22", "Reserved"},
#else
{22, 25, 0x0000000000000000, "RO", "RSVD25_22", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{8, 21, 0x0000000000000000, "RW", "TQPOLLPER", "This sets the frequency by which the Dunit polls the DRAM mode register MR4 to determine required refresh rate. (in 4x tREFI units)"},
#else
{8, 21, 0x0000000000000000, "RW", "TQPOLLPER", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{5, 7, 0x0000000000000000, "RO", "RSVD7_5", "Reserved"},
#else
{5, 7, 0x0000000000000000, "RO", "RSVD7_5", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{4, 4, 0x0000000000000000, "RW", "SRTEN", "When set, before every Self refresh entry, D-unit writes a 1 to bit 7 of TQOFFSET.MR_VALUE when TQDATA for that rank indicates a value higher then 0x3, and writes a 0 to that bit otherwise. The new MR_VALUE is then written into MR2 of DDR3 for each enabled rank."},
#else
{4, 4, 0x0000000000000000, "RW", "SRTEN", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{3, 3, 0x0000000000000001, "RW", "ENDERATE", "When set to 1 the Dynamic Timing Derating is enabled. When the Dunit determines (via TQ polling) that the DRAM requires timing derating in addition to refresh interval adjustment the Dunit will automatically adjust the relevant timing parameters."},
#else
{3, 3, 0x0000000000000001, "RW", "ENDERATE", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{2, 2, 0x0000000000000000, "RW", "TQDATAPUSHEN", "When set to 1 Dunit pushes the data form the last MR4 read to a punit register"},
#else
{2, 2, 0x0000000000000000, "RW", "TQDATAPUSHEN", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{1, 1, 0x0000000000000000, "RW", "TQPOLLSREN", "This bit enables MR4 read on Self Refresh Exit. If disabled Dunit will not read MR4 value on Self-Refresh exit."},
#else
{1, 1, 0x0000000000000000, "RW", "TQPOLLSREN", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 0, 0x0000000000000000, "RW", "TQPOLLEN", "This bit enables periodic TQ Poll.  If disabled Dunit will not read MR4 value periodically. [br]Note: Will be enabled only if refreshes are enabled"},
#else
{0, 0, 0x0000000000000000, "RW", "TQPOLLEN", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo18[] = {{"D_CR_TQCTL", "", 0x00000050, 10, 0x00000000FFFFFFFF, 0x000000006C000008}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields19[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{26, 31, 0x0000000000000000, "RO", "RSVD31_26", "Reserved"},
#else
{26, 31, 0x0000000000000000, "RO", "RSVD31_26", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{16, 25, 0x0000000000000000, "RW", "MR_VALUE", "MR3 Shadow Register (WIO2 only ) [br]BIOS sets the value of this field at boot time based on the DRAM device configuration. Dunit merges the value in MR3_THERM_OFFSET with this field and writes the result into DRAM MR3 [br]MR2 Shadow Register (DDR3 Only): [br]BIOS writes the correct value of MR2 register in DDR3 into this field at boot time. D-unit modifes one bit and rewrites the MR2 into DDR3 before SR entry."},
#else
{16, 25, 0x0000000000000000, "RW", "MR_VALUE", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{11, 15, 0x0000000000000000, "RO", "RSVD15_11", "Reserved"},
#else
{11, 15, 0x0000000000000000, "RO", "RSVD15_11", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{8, 10, 0x0000000000000000, "RW", "MR4_ADDER", "Dunit adds the value of this field to TQDATA read from MR4 the resulting value is used to control refresh rate and AC timing derating."},
#else
{8, 10, 0x0000000000000000, "RW", "MR4_ADDER", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{3, 7, 0x0000000000000000, "RO", "RSVD7_3", "Reserved"},
#else
{3, 7, 0x0000000000000000, "RO", "RSVD7_3", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{2, 2, 0x0000000000000000, "RW/V", "MR3_OFFSET_UPDATE", "When set, dunit writes the merged value of MR3_VALUE and MR3_THERM_OFFSET into MR3 of DRAM. Dunit clears this bit once the value is written"},
#else
{2, 2, 0x0000000000000000, "RW/V", "MR3_OFFSET_UPDATE", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 1, 0x0000000000000000, "RW", "MR3_THERM_OFFSET", "(WIO2 only) Everytime MR3_OFFSET_UPDATE is set, Dunit merges the value in this field with MR3_VALUE and writes the result to MR3 in DRAM"},
#else
{0, 1, 0x0000000000000000, "RW", "MR3_THERM_OFFSET", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo19[] = {{"D_CR_TQOFFSET", "", 0x00000054, 7, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields20[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{31, 31, 0x0000000000000000, "RW/V", "IC", "Indicates that initialization of the Dunit has been completed. Memory accesses are permitted and maintenance operation begins. Until this bit is set to a 1 the memory controller will not accept DRAM requests from the Bunit/GSA/2LM (PMI ISMs will not leave idle).  [br]Note: Set this bit to 1 only when all other Dunit registers have been configured. Usually set at the last configuration step by BIOS on cold/warm reset. D-unit hardware sets this bit on SR exit"},
#else
{31, 31, 0x0000000000000000, "RW/V", "IC", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{30, 30, 0x0000000000000000, "RO/V", "DIOIC", "Status indication that the DDRIO PHY initialization is complete reflects the status spid_init_complete signal"},
#else
{30, 30, 0x0000000000000000, "RO/V", "DIOIC", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{29, 29, 0x0000000000000000, "RO", "RSVD29", "Reserved"},
#else
{29, 29, 0x0000000000000000, "RO", "RSVD29", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{28, 28, 0x0000000000000000, "RW", "PMICTL", "0 - Dunit PMI is connected to Bunit/GSA/2LM, 1 - Dunit PMI is connected to CPGC [br]Note: PMI must be idle and D-unit BGF_RUN = 0 before changing the value in this register"},
#else
{28, 28, 0x0000000000000000, "RW", "PMICTL", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{8, 27, 0x0000000000000000, "RO", "RSVD27_8", "Reserved"},
#else
{8, 27, 0x0000000000000000, "RO", "RSVD27_8", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{4, 7, 0x0000000000000000, "RO", "RSVD7_4", "Reserved"},
#else
{4, 7, 0x0000000000000000, "RO", "RSVD7_4", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{3, 3, 0x0000000000000000, "RW", "PSMIEN", "When enabled dunit will synchronize clock crossing signals  [br]0 - PSMI Mode is disabled, [br]1 - PSMI Mode is enabled [br]Note: change only allowed when D-unit is idle"},
#else
{3, 3, 0x0000000000000000, "RW", "PSMIEN", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{2, 2, 0x0000000000000000, "RW", "MNTRST", "Writing a 1 to this field resets all maintenance timers. Clears all states and also clears refresh debt queues. This bit needs to be cleared by software after at least 3 SPID clocks."},
#else
{2, 2, 0x0000000000000000, "RW", "MNTRST", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{1, 1, 0x0000000000000000, "RW", "MNTEN", "Setting this field to 1 enables all maintenance operations. When DCO.IC is set the maintenance operations are enabled irrespective of the value of this field"},
#else
{1, 1, 0x0000000000000000, "RW", "MNTEN", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 0, 0x0000000000000000, "RO", "RSVD0", "Reserved"},
#else
{0, 0, 0x0000000000000000, "RO", "RSVD0", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo20[] = {{"D_CR_DCO", "", 0x00000058, 10, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields21[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{9, 31, 0x0000000000000000, "RO", "RSVD31_9", "Reserved"},
#else
{9, 31, 0x0000000000000000, "RO", "RSVD31_9", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{8, 8, 0x0000000000000000, "RW", "CATRAINEN", "0 - Dunit is not in JEDEC CA Training Mode, 1 -  Dunit is in JEDEC CA Training Mode"},
#else
{8, 8, 0x0000000000000000, "RW", "CATRAINEN", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{7, 7, 0x0000000000000000, "RW", "DQCALEN", "0 - Dunit is not in DQ Calibration Mode, 1 -  Dunit is in DQ Calibration Mode"},
#else
{7, 7, 0x0000000000000000, "RW", "DQCALEN", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{6, 6, 0x0000000000000000, "RW", "BLKPHASEB", "The Dunit runs at half (LPDDR3/WIO2/DDR3) or quarter (LPDDR4) the frequency of the DRAM clock to save power. In order to issue back-to-back commands on every DRAM clock cycle, the Dunit has to schedule two commands per Dunit clock. Therefore, it processes requests through separate arbitration paths labeled as Phase_0, Phase_1, Phase_2 and Phase_3.  [br]In LPDDR3/WIO2/DDR3 case setting this bit to a 1 will disable Phase_1 and all memory requests will be processed through Phase_0 arbitration path. With only Phase_1 the DRAM devices will never see back-to-back commands. The best it will see is a command every other DRAM clock cycle. [br]In LPDDR4 case commands are two DRAM clocks and they are sent in two consecutive phases. Also, most of the commands are broken into two parts that have to be sent back-to-back. Therefore, setting this bit to 1 will disable initiating *new* commands on Phase_1, Phase_2 and Phase_3.[br]0 - No block, 1 - Block [br]Note: This bit does/must not impact the CPGCs ability to send requests to the SPID in Phase 1/2/3.  Dunit arbiter comprehends this bit to issue 1 Command per SPIDCLK when set versus 2 Commands per SPIDCLK when not set"},
#else
{6, 6, 0x0000000000000000, "RW", "BLKPHASEB", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{5, 5, 0x0000000000000000, "RW", "BLKWPQF", "Block Processing Write Requests until WPQ is Full. [br]When this bit is set to 1 the Dunit is blocked from processing any of the requests in the WPQ until it is full. The full level is based on the WPQCOUNT value. [br]0 - No block, 1 -  Block [br]Note: Once WPQ is full, it is unblocked until an entry is deallocated. So there could be more than one write scheduled during that window."},
#else
{5, 5, 0x0000000000000000, "RW", "BLKWPQF", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{4, 4, 0x0000000000000000, "RW", "BLKRPQF", "Block Processing Read Requests until RPQ is Full. [br]When this bit is set to 1 the Dunit is blocked from processing any of the requests in the RPQ until it is full. The full level is based on the RPQCOUNT value. [br]0 - No block,  1 -  Block"},
#else
{4, 4, 0x0000000000000000, "RW", "BLKRPQF", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{3, 3, 0x0000000000000000, "RW", "BLKPRE", "Block Precharge Commands to DRAM [br]0 - No Block, 1 - Block"},
#else
{3, 3, 0x0000000000000000, "RW", "BLKPRE", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{2, 2, 0x0000000000000000, "RW", "BLKACT", "Block Activate Commands to DRAM  [br]0 - No Block, 1 - Block"},
#else
{2, 2, 0x0000000000000000, "RW", "BLKACT", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{1, 1, 0x0000000000000000, "RW", "BLKWR", "Block Write Commands to DRAM  [br]0 - No Block, 1 - Block"},
#else
{1, 1, 0x0000000000000000, "RW", "BLKWR", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 0, 0x0000000000000000, "RW", "BLKRD", "Block Read Commands to DRAM  [br]0 - No Block, 1 - Block"},
#else
{0, 0, 0x0000000000000000, "RW", "BLKRD", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo21[] = {{"D_CR_DTRC", "", 0x0000005C, 10, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields22[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{9, 31, 0x0000000000000000, "RO", "RSVD31_9", "Reserved"},
#else
{9, 31, 0x0000000000000000, "RO", "RSVD31_9", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{8, 8, 0x0000000000000000, "RW", "SRXNRQDIS", "Disable Accepting Requests During Self Refresh Exit (prevent Dunit PMI ISM to leave idle) [br]0 - Dunit accepts and loads PMI requests into the queues during Self Refresh exit period while maintenance operation are in progress, [br]1 - Dunit does not accept PMI requests until Self Refresh exit and all maintenance operations have completed"},
#else
{8, 8, 0x0000000000000000, "RW", "SRXNRQDIS", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{7, 7, 0x0000000000000000, "RW", "MRRCP", "When set to 1 D-unit closes all pages by issuing a PREALL before sending the MRR command to DRAM"},
#else
{7, 7, 0x0000000000000000, "RW", "MRRCP", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{5, 6, 0x0000000000000000, "RO", "RSVD6_5", "Reserved"},
#else
{5, 6, 0x0000000000000000, "RO", "RSVD6_5", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{4, 4, 0x0000000000000000, "RW", "PGTBLSTATEN", "When set to 1 the D-unit ignores PHY periodic quite time update requests. [br]Note: Setting this bit does not prevent PHY from requesting selfrefresh exit or bus quiet time."},
#else
{4, 4, 0x0000000000000000, "RW", "PGTBLSTATEN", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{3, 3, 0x0000000000000000, "RW", "PHYQTDIS", "When set to 1 the D-unit ignores PHY periodic quite time update requests. [br]Note: Setting this bit does not prevent PHY from requesting selfrefresh exit or bus quiet time."},
#else
{3, 3, 0x0000000000000000, "RW", "PHYQTDIS", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{2, 2, 0x0000000000000000, "RW", "PMIDIS", "Page Table Status Update Enable \r\n"
"When set, Dunit will update the Page table status in DSTAT.PGTBLVLD. If not set, the status CR will not reflect the latest status of the page table."},
#else
{2, 2, 0x0000000000000000, "RW", "PMIDIS", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{1, 1, 0x0000000000000000, "RW", "CR_STAT_EN", "DSTAT CR update enable\r\n"
"When set, Dunit will update the status bits in D_CR_DSTAT. If not set, the status CR, D_CR_DSTAT will not reflect the latest status of the D-unit.\r\n"
"Note: This enable bit does not control Page Table Status field"},
#else
{1, 1, 0x0000000000000000, "RW", "CR_STAT_EN", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 0, 0x0000000000000000, "RO", "RSVD0", "Reserved"},
#else
{0, 0, 0x0000000000000000, "RO", "RSVD0", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo22[] = {{"D_CR_DCBR", "", 0x000000A0, 9, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields23[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{31, 31, 0x0000000000000000, "RW", "SCRM_EN", "When set to 1 data scrambling is enabled. When set to 0 data scrambling is disabled."},
#else
{31, 31, 0x0000000000000000, "RW", "SCRM_EN", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{30, 30, 0x0000000000000000, "RO", "RSVD30", "Reserved"},
#else
{30, 30, 0x0000000000000000, "RO", "RSVD30", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{28, 29, 0x0000000000000000, "RW", "CLOCKGATE", "This field controls how the scrambler output code is clock gated to reduce power.  [br]00 -  Clock gate disabled,  [br]01 - Clock Gate every 2 cycle,  [br]10 - Clock Gate every 3 cycle,  [br]11 - Clock Gate every 4 cycle"},
#else
{28, 29, 0x0000000000000000, "RW", "CLOCKGATE", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{16, 27, 0x0000000000000000, "RO", "RSVD27_16", "Reserved"},
#else
{16, 27, 0x0000000000000000, "RO", "RSVD27_16", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 15, 0x0000000000000000, "RW", "KEY", "Sets the key for the scrambler. The key should be a random value that is set following each cold boot."},
#else
{0, 15, 0x0000000000000000, "RW", "KEY", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo23[] = {{"D_CR_SCRAMCTRL", "", 0x000000A4, 5, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields24[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{16, 31, 0x0000000000000000, "RO/V", "PGTBLVLD", "This register indicates whether a page is open within a bank. Each bit reflects the page open status of a bank. 2 Ranks x 8 banks/rank = 16 status bits.  [br]PGTBLVLD[7:0] = Page open status for Rank 0 Bank[7:0], [br]PGTBLVLD[15:8] = Page open status for Rank 1 Bank[7:0], [br]0 - The associated bank has been opened, [br]1 - The associated bank is closed"},
#else
{16, 31, 0x0000000000000000, "RO/V", "PGTBLVLD", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{11, 15, 0x0000000000000000, "RO", "RSVD15_11", "Reserved"},
#else
{11, 15, 0x0000000000000000, "RO", "RSVD15_11", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{10, 10, 0x0000000000000000, "RO/V", "DISR", "The Dunit sets this bit to a 1 after it has placed the DRAM devices in Self Refresh mode.  [br]The Dunit clears this bit when it brings the DRAM devices out of Self Refresh mode and completes maintenance operations,  [br]0 -  DRAM not in SelfRefresh.  [br]1 -  DRAM in SelfRefresh  [br]Note: If DRAM is in SR because of Dynamic SR reading any Dunit register will bring DRAM out of SR"},
#else
{10, 10, 0x0000000000000000, "RO/V", "DISR", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{9, 9, 0x0000000000000000, "RO/V", "REFDBT1", "Rank 1 has a Refresh Debt."},
#else
{9, 9, 0x0000000000000000, "RO/V", "REFDBT1", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{8, 8, 0x0000000000000000, "RO/V", "REFDBT0", "Rank 0 has a Refresh Debt."},
#else
{8, 8, 0x0000000000000000, "RO/V", "REFDBT0", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{7, 7, 0x0000000000000000, "RO", "RSVD7", "Reserved"},
#else
{7, 7, 0x0000000000000000, "RO", "RSVD7", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{6, 6, 0x0000000000000000, "RO/V", "WPQEMPTY", "0 - Dunit WPQ is not empty (pending write requests in WPQ), 1 - Dunit WPQ is empty"},
#else
{6, 6, 0x0000000000000000, "RO/V", "WPQEMPTY", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{5, 5, 0x0000000000000000, "RO/V", "RPQEMPTY", "0 - Dunit RPQ is not empty (pending read requests in RPQ), 1 - Dunit RPQ is empty"},
#else
{5, 5, 0x0000000000000000, "RO/V", "RPQEMPTY", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 4, 0x0000000000000000, "RO", "RSVD4_0", "Reserved"},
#else
{0, 4, 0x0000000000000000, "RO", "RSVD4_0", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo24[] = {{"D_CR_DSTAT", "", 0x000000A8, 9, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields25[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{16, 31, 0x0000000000000000, "RO/V", "PGTBLVLD", "This register indicates whether a page is open within a bank. Each bit reflects the page open status of a bank. 2 Ranks x 8 banks/rank = 16 status bits.  [br]PGTBLVLD[7:0] = Page open status for Rank 0 Bank[7:0], [br]PGTBLVLD[15:8] = Page open status for Rank 1 Bank[7:0], [br]0 - The associated bank has been opened, [br]1 - The associated bank is closed"},
#else
{16, 31, 0x0000000000000000, "RO/V", "PGTBLVLD", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{11, 15, 0x0000000000000000, "RO", "RSVD15_11", "Reserved"},
#else
{11, 15, 0x0000000000000000, "RO", "RSVD15_11", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{10, 10, 0x0000000000000000, "RO/V", "DISR", "The Dunit sets this bit to a 1 after it has placed the DRAM devices in Self Refresh mode.  [br]The Dunit clears this bit when it brings the DRAM devices out of Self Refresh mode and completes maintenance operations,  [br]0 -  DRAM not in SelfRefresh.  [br]1 -  DRAM in SelfRefresh  [br]Note: If DRAM is in SR because of Dynamic SR reading any Dunit register will bring DRAM out of SR"},
#else
{10, 10, 0x0000000000000000, "RO/V", "DISR", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{9, 9, 0x0000000000000000, "RO/V", "REFDBT1", "Rank 1 has a Refresh Debt."},
#else
{9, 9, 0x0000000000000000, "RO/V", "REFDBT1", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{8, 8, 0x0000000000000000, "RO/V", "REFDBT0", "Rank 0 has a Refresh Debt."},
#else
{8, 8, 0x0000000000000000, "RO/V", "REFDBT0", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{7, 7, 0x0000000000000000, "RO", "RSVD7", "Reserved"},
#else
{7, 7, 0x0000000000000000, "RO", "RSVD7", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{6, 6, 0x0000000000000000, "RO/V", "WPQEMPTY", "0 - Dunit WPQ is not empty (pending write requests in WPQ), 1 - Dunit WPQ is empty"},
#else
{6, 6, 0x0000000000000000, "RO/V", "WPQEMPTY", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{5, 5, 0x0000000000000000, "RO/V", "RPQEMPTY", "0 - Dunit RPQ is not empty (pending read requests in RPQ), 1 - Dunit RPQ is empty"},
#else
{5, 5, 0x0000000000000000, "RO/V", "RPQEMPTY", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 4, 0x0000000000000000, "RO", "RSVD4_0", "Reserved"},
#else
{0, 4, 0x0000000000000000, "RO", "RSVD4_0", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo25[] = {{"D_CR_ERR_INJ", "", 0x000000AC, 9, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields26[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{2, 31, 0x0000000000000000, "RO", "RSVD31_2", "Reserved"},
#else
{2, 31, 0x0000000000000000, "RO", "RSVD31_2", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 1, 0x0000000000000000, "RW", "SEL", "If enabled the error injection is continuously armed for ERR_INJ.ADDR 32B write address matching until it is cleared. [br]00: No error injection. [br]01: Uncorrectable Error (UE) is armed for write address matching to inject UE by using the same poisoning scheme, i.e. inverting corresponding write ECC[6:0] on QW0 of the 32B data. [br]10: Correctable Error (CE) is armed for write address matching to inject CE by inverting corresponding write ECC[0] on QW0 of the 32B data. [br]11: Reserved."},
#else
{0, 1, 0x0000000000000000, "RW", "SEL", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo26[] = {{"D_CR_ERR_INJ_CTL", "", 0x000000B0, 2, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields27[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{16, 31, 0x0000000000000000, "RO/V", "PGTBLVLD", "This register indicates whether a page is open within a bank. Each bit reflects the page open status of a bank. 2 Ranks x 8 banks/rank = 16 status bits.  [br]PGTBLVLD[7:0] = Page open status for Rank 0 Bank[7:0], [br]PGTBLVLD[15:8] = Page open status for Rank 1 Bank[7:0], [br]0 - The associated bank has been opened, [br]1 - The associated bank is closed"},
#else
{16, 31, 0x0000000000000000, "RO/V", "PGTBLVLD", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{11, 15, 0x0000000000000000, "RO", "RSVD15_11", "Reserved"},
#else
{11, 15, 0x0000000000000000, "RO", "RSVD15_11", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{10, 10, 0x0000000000000000, "RO/V", "DISR", "The Dunit sets this bit to a 1 after it has placed the DRAM devices in Self Refresh mode.  [br]The Dunit clears this bit when it brings the DRAM devices out of Self Refresh mode and completes maintenance operations,  [br]0 -  DRAM not in SelfRefresh.  [br]1 -  DRAM in SelfRefresh  [br]Note: If DRAM is in SR because of Dynamic SR reading any Dunit register will bring DRAM out of SR"},
#else
{10, 10, 0x0000000000000000, "RO/V", "DISR", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{9, 9, 0x0000000000000000, "RO/V", "REFDBT1", "Rank 1 has a Refresh Debt."},
#else
{9, 9, 0x0000000000000000, "RO/V", "REFDBT1", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{8, 8, 0x0000000000000000, "RO/V", "REFDBT0", "Rank 0 has a Refresh Debt."},
#else
{8, 8, 0x0000000000000000, "RO/V", "REFDBT0", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{7, 7, 0x0000000000000000, "RO", "RSVD7", "Reserved"},
#else
{7, 7, 0x0000000000000000, "RO", "RSVD7", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{6, 6, 0x0000000000000000, "RO/V", "WPQEMPTY", "0 - Dunit WPQ is not empty (pending write requests in WPQ), 1 - Dunit WPQ is empty"},
#else
{6, 6, 0x0000000000000000, "RO/V", "WPQEMPTY", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{5, 5, 0x0000000000000000, "RO/V", "RPQEMPTY", "0 - Dunit RPQ is not empty (pending read requests in RPQ), 1 - Dunit RPQ is empty"},
#else
{5, 5, 0x0000000000000000, "RO/V", "RPQEMPTY", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 4, 0x0000000000000000, "RO", "RSVD4_0", "Reserved"},
#else
{0, 4, 0x0000000000000000, "RO", "RSVD4_0", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo27[] = {{"D_CR_ERR_ECC_LOG", "", 0x000000B4, 9, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields28[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{16, 31, 0x0000000000000000, "RO", "RSVD31_9", "Reserved"},
#else
{16, 31, 0x0000000000000000, "RO", "RSVD31_9", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 15, 0x0000000000000000, "RO/V", "FUSESTAT", "D-unit fuse bits are captured into this register and are available to be read.  [br][0] - fus_dun_ecc_dis,  [br][3:1] - fus_dun_max_supported_device_size[2:0], [br][5:4] - fus_dun_dram_type [1:0], [br][6:6] - wio2_channels, [br][15:7] - reserved"},
#else
{0, 15, 0x0000000000000000, "RO/V", "FUSESTAT", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo28[] = {{"D_CR_DFUSESTAT", "", 0x000000BC, 2, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields29[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{0, 31, 0x0000000000000000, "RW", "VAL", "General Purpose Scratchpad.  May be used for BIOS for data storage."},
#else
{0, 31, 0x0000000000000000, "RW", "VAL", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo29[] = {{"D_CR_SSKPD0", "", 0x000000C0, 1, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields30[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{0, 31, 0x0000000000000000, "RW", "VAL", "General Purpose Scratchpad.  May be used for BIOS for data storage."},
#else
{0, 31, 0x0000000000000000, "RW", "VAL", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo30[] = {{"D_CR_SSKPD1", "", 0x000000C4, 1, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields31[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{0, 31, 0x0000000000000000, "RW", "BONUS0", "Bonus Register 0  [br]This register is reserved for ECO"},
#else
{0, 31, 0x0000000000000000, "RW", "BONUS0", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo31[] = {{"D_CR_BONUS0", "", 0x000000C8, 1, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields32[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{0, 31, 0x0000000000000000, "RW", "BONUS1", "Bonus Register 1  [br]This register is reserved for ECO"},
#else
{0, 31, 0x0000000000000000, "RW", "BONUS1", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo32[] = {{"D_CR_BONUS1", "", 0x000000CC, 1, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields33[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{0, 31, 0x0000000000000000, "RO/V", "DQCALRDATLO", "Holds least significant 32 bits returned as a result of CA Training"},
#else
{0, 31, 0x0000000000000000, "RO/V", "DQCALRDATLO", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo33[] = {{"D_CR_DQCALRDATLO", "", 0x000000D0, 1, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields34[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{0, 31, 0x0000000000000000, "RO", "DQCALRDATHI", "Holds most significant 32 bits returned as a result of DQ Calibration/CA Training (Reserved in BXT0/1)"},
#else
{0, 31, 0x0000000000000000, "RO", "DQCALRDATHI", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo34[] = {{"D_CR_DQCALRDATHI", "", 0x000000D4, 1, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields35[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{16, 31, 0x0000000000000000, "RW", "CMDSPID_TO_SABY2_TSVS", "Provides custom TSVs for BGFs which write in the CMD SPID clock and read in SABY2 clock"},
#else
{16, 31, 0x0000000000000000, "RW", "CMDSPID_TO_SABY2_TSVS", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 15, 0x0000000000000000, "RW", "SABY2_TO_CMDSPID_TSVS", "Provides custom TSVs for BGFs which write in the SABY2 clock and read in CMD SPID clock"},
#else
{0, 15, 0x0000000000000000, "RW", "SABY2_TO_CMDSPID_TSVS", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo35[] = {{"D_CR_BGF_CUSTOM_TSV_CMD_PATTERN", "", 0x000000D8, 2, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields36[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{16, 31, 0x0000000000000000, "RW", "CMDSPID_TO_SABY2_TSVS", "Provides custom TSVs for BGFs which write in the CMD SPID clock and read in SABY2 clock"},
#else
{16, 31, 0x0000000000000000, "RW", "CMDSPID_TO_SABY2_TSVS", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 15, 0x0000000000000000, "RW", "SABY2_TO_CMDSPID_TSVS", "Provides custom TSVs for BGFs which write in SABY2 clock and read in CMD SPID clock"},
#else
{0, 15, 0x0000000000000000, "RW", "SABY2_TO_CMDSPID_TSVS", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo36[] = {{"D_CR_BGF_CUSTOM_TSV_CMD_INIT", "", 0x000000DC, 2, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields37[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{16, 31, 0x0000000000000000, "RW", "DATASPID_TO_SABY2_TSVS", "Provides custom TSVs for BGFs which write in the DATA SPID clock and read in SABY2 clock"},
#else
{16, 31, 0x0000000000000000, "RW", "DATASPID_TO_SABY2_TSVS", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 15, 0x0000000000000000, "RW", "SABY2_TO_DATASPID_TSVS", "Provides custom TSVs for BGFs which write in SABY2 clock and read in DATA SPID clock"},
#else
{0, 15, 0x0000000000000000, "RW", "SABY2_TO_DATASPID_TSVS", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo37[] = {{"D_CR_BGF_CUSTOM_TSV_DATA_PATTERN", "", 0x000000E0, 2, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields38[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{16, 31, 0x0000000000000000, "RW", "DATASPID_TO_SABY2_TSVS", "Provides custom TSVs for BGFs which write in the DATA SPID clock and read in SABY2 clock"},
#else
{16, 31, 0x0000000000000000, "RW", "DATASPID_TO_SABY2_TSVS", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 15, 0x0000000000000000, "RW", "SABY2_TO_DATASPID_TSVS", "Provides custom TSVs for BGFs which write in SABY2 clock and read in DATA SPID clock"},
#else
{0, 15, 0x0000000000000000, "RW", "SABY2_TO_DATASPID_TSVS", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo38[] = {{"D_CR_BGF_CUSTOM_TSV_DATA_INIT", "", 0x000000E4, 2, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields39[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{24, 31, 0x0000000000000003, "RW", "SPIDDATACLK_RATIO", "The ratio of clock  C (SPIDData):1"},
#else
{24, 31, 0x0000000000000003, "RW", "SPIDDATACLK_RATIO", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{16, 23, 0x0000000000000003, "RW", "SPIDCMDCLK_RATIO", "The ratio of clock  B (SPIDCmd):1"},
#else
{16, 23, 0x0000000000000003, "RW", "SPIDCMDCLK_RATIO", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{8, 15, 0x0000000000000001, "RW", "SACLKBY2_RATIO", "The ratio of clock  A (SAby2):1   Note: this field must be set to the same value as SPIDCMDCLK_RATIO when CPGC is active"},
#else
{8, 15, 0x0000000000000001, "RW", "SACLKBY2_RATIO", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{6, 7, 0x0000000000000000, "RW", "FUS_SEPERATION_SPIDSABY2", "Variable separation of the serial fifos to be passed into the se module."},
#else
{6, 7, 0x0000000000000000, "RW", "FUS_SEPERATION_SPIDSABY2", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{5, 5, 0x0000000000000000, "RW", "CG_DIS", "Disable BGF Clock Generator "},
#else
{5, 5, 0x0000000000000000, "RW", "CG_DIS", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{3, 4, 0x0000000000000000, "RW", "FUS_SEPERATION_SABY2SPID", "Variable separation of the serial fifos to be passed into the se module."},
#else
{3, 4, 0x0000000000000000, "RW", "FUS_SEPERATION_SABY2SPID", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{2, 2, 0x0000000000000000, "RW", "USE_LOCALSYNC", "Enable the  use of locally generated sync signals"},
#else
{2, 2, 0x0000000000000000, "RW", "USE_LOCALSYNC", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{1, 1, 0x0000000000000000, "RO", "RSVD_1", "Reserved"},
#else
{1, 1, 0x0000000000000000, "RO", "RSVD_1", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 0, 0x0000000000000000, "RW", "BGF_RUN", "Start BGFs"},
#else
{0, 0, 0x0000000000000000, "RW", "BGF_RUN", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo39[] = {{"D_CR_BGF_CTL", "", 0x00000120, 9, 0x00000000FFFFFFFF, 0x0000000003030100}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields40[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{27, 29, 0x0000000000000005, "RW", "RAW_WMM", "If a conflict read reaches this priority (or greater depending on access class occupancy), WMM will be triggered to unblock the corresponding write. Dunit will stay in WMM until corresponding write is issued. [br]Note: The value in this bit must not be higher than lowest terminal priority level of each access class"},
#else
{27, 29, 0x0000000000000005, "RW", "RAW_WMM", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{23, 25, 0x0000000000000006, "RW", "RIMPRIO", "If any read in the RPQ is at this programmable priority RIM is triggered"},
#else
{23, 25, 0x0000000000000006, "RW", "RIMPRIO", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{12, 17, 0x000000000000001E, "RW", "WIMTHRS", "When the number of entries in WPQ is greater than or equal to this value (higher than WMM Entry Watermark, less than WPQ size) it triggers Write Isoch Mode (WIM)"},
#else
{12, 17, 0x000000000000001E, "RW", "WIMTHRS", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{6, 11, 0x0000000000000014, "RW", "WMMEXIT", "When the number of entries in WPQ is less than this value the Dunit will switch back to Read Major Mode."},
#else
{6, 11, 0x0000000000000014, "RW", "WMMEXIT", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 5, 0x0000000000000018, "RW", "WMMENTRY", "When the number of entries in WPQ is greater than or equal to this value the Dunit will switch to Write Major Mode WMM [br]Note: the value must not be set to 0"},
#else
{0, 5, 0x0000000000000018, "RW", "WMMENTRY", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo40[] = {{"D_CR_MMC", "", 0x00000124, 5, 0x000000003FFFFFFF, 0x000000002B01E518}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields41[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{26, 31, 0x0000000000000000, "RO", "RSVD31_26", "Reserved"},
#else
{26, 31, 0x0000000000000000, "RO", "RSVD31_26", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{20, 25, 0x000000000000001F, "RW", "MAXWRB", "Maximum number of writes Dunit can send in WMM mode before returning to RMM.  (set B)"},
#else
{20, 25, 0x000000000000001F, "RW", "MAXWRB", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{14, 19, 0x0000000000000008, "RW", "MINRDB", "Minimum number of reads that has to be serviced before a switch to WMM is allowed (set B)"},
#else
{14, 19, 0x0000000000000008, "RW", "MINRDB", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{12, 13, 0x0000000000000000, "RO", "RSVD13_12", "Reserved"},
#else
{12, 13, 0x0000000000000000, "RO", "RSVD13_12", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{6, 11, 0x000000000000001F, "RW", "MAXWRA", "Maximum number of writes Dunit can send in WMM mode before returning to RMM.  (set A)"},
#else
{6, 11, 0x000000000000001F, "RW", "MAXWRA", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 5, 0x0000000000000008, "RW", "MINRDA", "Minimum number of reads that has to be serviced before a switch to WMM is allowed (set A)"},
#else
{0, 5, 0x0000000000000008, "RW", "MINRDA", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo41[] = {{"D_CR_MMRDWR_AB", "", 0x00000128, 6, 0x00000000FFFFFFFF, 0x0000000001F207C8}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields42[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{26, 31, 0x0000000000000000, "RO", "RSVD31_26", "Reserved"},
#else
{26, 31, 0x0000000000000000, "RO", "RSVD31_26", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{20, 25, 0x000000000000001F, "RW", "MAXWRD", "Maximum number of writes Dunit can send in WMM mode before returning to RMM.  (set D_"},
#else
{20, 25, 0x000000000000001F, "RW", "MAXWRD", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{14, 19, 0x0000000000000008, "RW", "MINRDD", "Minimum number of reads that has to be serviced before a switch to WMM is allowed. (set D)"},
#else
{14, 19, 0x0000000000000008, "RW", "MINRDD", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{12, 13, 0x0000000000000000, "RO", "RSVD13_12", "Reserved"},
#else
{12, 13, 0x0000000000000000, "RO", "RSVD13_12", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{6, 11, 0x000000000000001F, "RW", "MAXWRC", "Maximum number of writes Dunit can send in WMM mode before returning to RMM. (set C)"},
#else
{6, 11, 0x000000000000001F, "RW", "MAXWRC", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 5, 0x0000000000000008, "RW", "MINRDC", "Minimum number of reads that has to be serviced before a switch to WMM is allowed. (set C)"},
#else
{0, 5, 0x0000000000000008, "RW", "MINRDC", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo42[] = {{"D_CR_MMRDWR_CD", "", 0x0000012C, 6, 0x00000000FFFFFFFF, 0x0000000001F207C8}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields43[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{12, 14, 0x0000000000000001, "RW", "AC4IP", "Initial priority level of read requests coming with Access Class 4"},
#else
{12, 14, 0x0000000000000001, "RW", "AC4IP", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{9, 11, 0x0000000000000003, "RW", "AC3IP", "Initial priority level of read requests coming with Access Class 3"},
#else
{9, 11, 0x0000000000000003, "RW", "AC3IP", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{6, 8, 0x0000000000000007, "RW", "AC2IP", "Initial priority level of read requests coming with Access Class 2"},
#else
{6, 8, 0x0000000000000007, "RW", "AC2IP", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{3, 5, 0x0000000000000000, "RW", "AC1IP", "Initial priority level of read requests coming with Access Class 1"},
#else
{3, 5, 0x0000000000000000, "RW", "AC1IP", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 2, 0x0000000000000002, "RW", "AC0IP", "Initial priority level of read requests coming with Access Class 0"},
#else
{0, 2, 0x0000000000000002, "RW", "AC0IP", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo43[] = {{"D_CR_ACCIP", "", 0x00000130, 5, 0x0000000000007FFF, 0x00000000000017C2}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields44[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{30, 31, 0x0000000000000000, "RO", "RSVD31_30", "Reserved"},
#else
{30, 31, 0x0000000000000000, "RO", "RSVD31_30", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{25, 29, 0x0000000000000000, "RW", "P6RES", "Number of CASes that pass before a request in this priority promotes to the next priority level"},
#else
{25, 29, 0x0000000000000000, "RW", "P6RES", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{20, 24, 0x000000000000001F, "RW", "P5RES", "Number of CASes that pass before a request in this priority promotes to the next priority level"},
#else
{20, 24, 0x000000000000001F, "RW", "P5RES", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{15, 19, 0x000000000000000A, "RW", "P4RES", "Number of CASes that pass before a request in this priority promotes to the next priority level"},
#else
{15, 19, 0x000000000000000A, "RW", "P4RES", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{10, 14, 0x000000000000000A, "RW", "P3RES", "Number of CASes that pass before a request in this priority promotes to the next priority level"},
#else
{10, 14, 0x000000000000000A, "RW", "P3RES", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{5, 9, 0x000000000000000A, "RW", "P2RES", "Number of CASes that pass before a request in this priority promotes to the next priority level"},
#else
{5, 9, 0x000000000000000A, "RW", "P2RES", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 4, 0x0000000000000000, "RW", "P1RES", "Number of CASes that pass before a request in this priority promotes to the next priority level"},
#else
{0, 4, 0x0000000000000000, "RW", "P1RES", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo44[] = {{"D_CR_RD_PROM0", "", 0x00000134, 7, 0x00000000FFFFFFFF, 0x0000000001F52940}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields45[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{30, 31, 0x0000000000000000, "RO", "RSVD31_30", "Reserved"},
#else
{30, 31, 0x0000000000000000, "RO", "RSVD31_30", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{25, 29, 0x000000000000000A, "RW", "P6RES", "Number of CASes that pass before a request in this priority promotes to the next priority level"},
#else
{25, 29, 0x000000000000000A, "RW", "P6RES", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{20, 24, 0x0000000000000000, "RW", "P5RES", "Number of CASes that pass before a request in this priority promotes to the next priority level"},
#else
{20, 24, 0x0000000000000000, "RW", "P5RES", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{15, 19, 0x0000000000000000, "RW", "P4RES", "Number of CASes that pass before a request in this priority promotes to the next priority level"},
#else
{15, 19, 0x0000000000000000, "RW", "P4RES", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{10, 14, 0x0000000000000000, "RW", "P3RES", "Number of CASes that pass before a request in this priority promotes to the next priority level"},
#else
{10, 14, 0x0000000000000000, "RW", "P3RES", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{5, 9, 0x0000000000000000, "RW", "P2RES", "Number of CASes that pass before a request in this priority promotes to the next priority level"},
#else
{5, 9, 0x0000000000000000, "RW", "P2RES", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 4, 0x0000000000000000, "RW", "P1RES", "Number of CASes that pass before a request in this priority promotes to the next priority level"},
#else
{0, 4, 0x0000000000000000, "RW", "P1RES", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo45[] = {{"D_CR_RD_PROM1", "", 0x00000138, 7, 0x00000000FFFFFFFF, 0x0000000014000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields46[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{30, 31, 0x0000000000000000, "RO", "RSVD31_30", "Reserved"},
#else
{30, 31, 0x0000000000000000, "RO", "RSVD31_30", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{25, 29, 0x0000000000000000, "RW", "P6RES", "Number of CASes that pass before a request in this priority promotes to the next priority level"},
#else
{25, 29, 0x0000000000000000, "RW", "P6RES", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{20, 24, 0x0000000000000000, "RW", "P5RES", "Number of CASes that pass before a request in this priority promotes to the next priority level"},
#else
{20, 24, 0x0000000000000000, "RW", "P5RES", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{15, 19, 0x0000000000000000, "RW", "P4RES", "Number of CASes that pass before a request in this priority promotes to the next priority level"},
#else
{15, 19, 0x0000000000000000, "RW", "P4RES", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{10, 14, 0x0000000000000000, "RW", "P3RES", "Number of CASes that pass before a request in this priority promotes to the next priority level"},
#else
{10, 14, 0x0000000000000000, "RW", "P3RES", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{5, 9, 0x0000000000000000, "RW", "P2RES", "Number of CASes that pass before a request in this priority promotes to the next priority level"},
#else
{5, 9, 0x0000000000000000, "RW", "P2RES", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 4, 0x0000000000000000, "RW", "P1RES", "Number of CASes that pass before a request in this priority promotes to the next priority level"},
#else
{0, 4, 0x0000000000000000, "RW", "P1RES", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo46[] = {{"D_CR_RD_PROM2", "", 0x0000013C, 7, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields47[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{30, 31, 0x0000000000000000, "RO", "RSVD31_30", "Reserved"},
#else
{30, 31, 0x0000000000000000, "RO", "RSVD31_30", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{25, 29, 0x0000000000000000, "RW", "P6RES", "Number of CASes that pass before a request in this priority promotes to the next priority level"},
#else
{25, 29, 0x0000000000000000, "RW", "P6RES", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{20, 24, 0x000000000000001F, "RW", "P5RES", "Number of CASes that pass before a request in this priority promotes to the next priority level"},
#else
{20, 24, 0x000000000000001F, "RW", "P5RES", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{15, 19, 0x0000000000000005, "RW", "P4RES", "Number of CASes that pass before a request in this priority promotes to the next priority level"},
#else
{15, 19, 0x0000000000000005, "RW", "P4RES", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{10, 14, 0x0000000000000005, "RW", "P3RES", "Number of CASes that pass before a request in this priority promotes to the next priority level"},
#else
{10, 14, 0x0000000000000005, "RW", "P3RES", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{5, 9, 0x0000000000000000, "RW", "P2RES", "Number of CASes that pass before a request in this priority promotes to the next priority level"},
#else
{5, 9, 0x0000000000000000, "RW", "P2RES", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 4, 0x0000000000000000, "RW", "P1RES", "Number of CASes that pass before a request in this priority promotes to the next priority level"},
#else
{0, 4, 0x0000000000000000, "RW", "P1RES", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo47[] = {{"D_CR_RD_PROM3", "", 0x00000140, 7, 0x00000000FFFFFFFF, 0x0000000001F29400}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields48[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{30, 31, 0x0000000000000000, "RO", "RSVD31_30", "Reserved"},
#else
{30, 31, 0x0000000000000000, "RO", "RSVD31_30", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{25, 29, 0x0000000000000000, "RW", "P6RES", "Number of CASes that pass before a request in this priority promotes to the next priority level"},
#else
{25, 29, 0x0000000000000000, "RW", "P6RES", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{20, 24, 0x000000000000001F, "RW", "P5RES", "Number of CASes that pass before a request in this priority promotes to the next priority level"},
#else
{20, 24, 0x000000000000001F, "RW", "P5RES", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{15, 19, 0x000000000000000A, "RW", "P4RES", "Number of CASes that pass before a request in this priority promotes to the next priority level"},
#else
{15, 19, 0x000000000000000A, "RW", "P4RES", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{10, 14, 0x000000000000000A, "RW", "P3RES", "Number of CASes that pass before a request in this priority promotes to the next priority level"},
#else
{10, 14, 0x000000000000000A, "RW", "P3RES", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{5, 9, 0x000000000000000A, "RW", "P2RES", "Number of CASes that pass before a request in this priority promotes to the next priority level"},
#else
{5, 9, 0x000000000000000A, "RW", "P2RES", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 4, 0x000000000000000A, "RW", "P1RES", "Number of CASes that pass before a request in this priority promotes to the next priority level"},
#else
{0, 4, 0x000000000000000A, "RW", "P1RES", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo48[] = {{"D_CR_RD_PROM4", "", 0x00000144, 7, 0x00000000FFFFFFFF, 0x0000000001F5294A}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields49[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{11, 31, 0x0000000000000000, "RO", "RSVD31_11", "Reserved"},
#else
{11, 31, 0x0000000000000000, "RO", "RSVD31_11", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 10, 0x0000000000000006, "RW", "DEADLINE_THRS", "A requests with initial priority of 0 will exit priority 0 when its deadline is equal or less than this value plus current time  This field does not affect the priority of any requests in access classes with initial priority bigger than 0"},
#else
{0, 10, 0x0000000000000006, "RW", "DEADLINE_THRS", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo49[] = {{"D_CR_DL_THRS", "", 0x00000148, 2, 0x00000000FFFFFFFF, 0x0000000000000006}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields50[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{25, 31, 0x0000000000000000, "RO", "RSVD31_25", "Reserved"},
#else
{25, 31, 0x0000000000000000, "RO", "RSVD31_25", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{24, 24, 0x0000000000000000, "RW", "WMM_REG_R1", "Disable WMM Unsafe Write Page Hits block safe Write Page Misses same bank"},
#else
{24, 24, 0x0000000000000000, "RW", "WMM_REG_R1", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{20, 23, 0x0000000000000000, "RO", "RSVD23_20", "Reserved"},
#else
{20, 23, 0x0000000000000000, "RO", "RSVD23_20", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{19, 19, 0x0000000000000000, "RW", "WMM_PRIO_R4", "Disable WMM Unsafe Priority 1 Read Miss block Write Hit to same Bank. [br]Note: This rule does not block the bank that is being blocked by WMM_PRIO_R3. [br]Priority rules 1,3 and 4 should be enabled/disabled together."},
#else
{19, 19, 0x0000000000000000, "RW", "WMM_PRIO_R4", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{18, 18, 0x0000000000000000, "RW", "WMM_PRIO_R3", "Disable WMM Unsafe Priority 1 Write Hit block Write Miss to same Bank   [br]Note: This rule does not block the bank that is being blocked by WMM_PRIO_R1 [br]Priority rules 1,3 and 4 should be enabled/disabled together."},
#else
{18, 18, 0x0000000000000000, "RW", "WMM_PRIO_R3", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{17, 17, 0x0000000000000000, "RW", "WMM_PRIO_R2", "Disable WMM CAS Block Rule"},
#else
{17, 17, 0x0000000000000000, "RW", "WMM_PRIO_R2", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{16, 16, 0x0000000000000000, "RW", "WMM_PRIO_R1", "Disable WMM Unsafe Top Priority 1 Write Miss block Write Hit same bank. [br]Priority rules 1,3 and 4 should be enabled/disabled together."},
#else
{16, 16, 0x0000000000000000, "RW", "WMM_PRIO_R1", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{14, 15, 0x0000000000000000, "RO", "RSVD15_14", "Reserved"},
#else
{14, 15, 0x0000000000000000, "RO", "RSVD15_14", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{13, 13, 0x0000000000000000, "RW", "RMM_REG_R6", "Disable RMM Unsafe Write Page Hits block safe Write Page Misses same bank"},
#else
{13, 13, 0x0000000000000000, "RW", "RMM_REG_R6", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{12, 12, 0x0000000000000001, "RW", "RMM_REG_R5", "Disable RMM Unsafe Read Page Miss block all safe and unsafe Write Page Hit to the same bank. [br]Note: This field must not be set to 0 (enabled) if RMM_REG_R4 is also 0"},
#else
{12, 12, 0x0000000000000001, "RW", "RMM_REG_R5", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{11, 11, 0x0000000000000001, "RW", "RMM_REG_R4", "Disable RMM Unsafe Write Page Hit block safe Read Page Miss same bank. [br]Note: This field must not be set to 0 (enabled) if RMM_REG_R5 is also 0"},
#else
{11, 11, 0x0000000000000001, "RW", "RMM_REG_R4", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{10, 10, 0x0000000000000000, "RW", "RMM_REG_R3", "Disable RMM Unsafe Read Page Hit block safe Read and Write Page Miss same bank. [br]Note: This rule does not block the bank that is being blocked by RMM_PRIO_R3 and RMM_PRIO_R1"},
#else
{10, 10, 0x0000000000000000, "RW", "RMM_REG_R3", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{9, 9, 0x0000000000000000, "RW", "RMM_REG_R2", "Disable RMM Unsafe Read Page Empty block safe Write Page empty same rank"},
#else
{9, 9, 0x0000000000000000, "RW", "RMM_REG_R2", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{8, 8, 0x0000000000000000, "RW", "RMM_REG_R1", "Disable RMM Unsafe Read Page Hit block safe Write Page Hit same rank"},
#else
{8, 8, 0x0000000000000000, "RW", "RMM_REG_R1", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{4, 7, 0x0000000000000000, "RO", "RSVD7_4", "Reserved"},
#else
{4, 7, 0x0000000000000000, "RO", "RSVD7_4", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{3, 3, 0x0000000000000000, "RW", "RMM_PRIO_R4", "Disable RMM Unsafe Critical Read Miss block Read and Write Hit to same Bank. [br]Note: This rule does not block the bank that is being blocked by RMM_PRIO_R3. [br]Priority rules 1,3 and 4 should be enabled/disabled together."},
#else
{3, 3, 0x0000000000000000, "RW", "RMM_PRIO_R4", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{2, 2, 0x0000000000000000, "RW", "RMM_PRIO_R3", "Disable RMM Unsafe Critical Read Hit block Read and Write Miss to same Bank. [br]Note: This rule does not block the bank that is being blocked by RMM_PRIO_R1. [br]Priority rules 1,3 and 4 should be enabled/disabled together."},
#else
{2, 2, 0x0000000000000000, "RW", "RMM_PRIO_R3", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{1, 1, 0x0000000000000000, "RW", "RMM_PRIO_R2", "Disable RMM CAS Block Rule"},
#else
{1, 1, 0x0000000000000000, "RW", "RMM_PRIO_R2", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 0, 0x0000000000000000, "RW", "RMM_PRIO_R1", "Disable RMM Unsafe Top Critical Read Miss block Read and Write Hit same bank. [br]Note: Priority rules 1,3 and 4 should be enabled/disabled together."},
#else
{0, 0, 0x0000000000000000, "RW", "RMM_PRIO_R1", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo50[] = {{"D_CR_MM_BLK", "", 0x0000014C, 19, 0x00000000FFFFFFFF, 0x0000000000001800}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields51[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{8, 31, 0x0000000000000000, "RO", "RSVD31_8", "Reserved"},
#else
{8, 31, 0x0000000000000000, "RO", "RSVD31_8", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{3, 3, 0x0000000000000000, "RW/V", "SUSPENDP", "A SUSPENDP message will put the DRAM into Self-Refresh mode. The Dunit will complete servicing outstanding memory requests and flush all queued Refresh commands to DRAM before putting the DRAM in Self Refresh mode. Finally a PM message will be sent to the PHY. The bit is cleared by hardware after the PHY indicates the transition requested in the PM message has been completed.  Dunit will perform an MRW to MR17 with an opcode as defined by DPMC0.PASR before it places the DRAM into Self-Refresh. [br]Note: Reserved for BXT"},
#else
{3, 3, 0x0000000000000000, "RW/V", "SUSPENDP", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{2, 2, 0x0000000000000000, "RW/V", "SUSPEND", "A SUSPEND message will put the DRAM into Self-Refresh mode. The D-unit will complete servicing outstanding memory requests and flush all queued Refresh commands to DRAM before putting the DRAM in Self Refresh mode. Finally a PM message will be sent to the PHY. The bit is cleared by hardware only after the PHY indicates the transition requested in the PM message has been completed. Note: When COLDWAKE is set prior of setting this bit the DRAM will not be placed in SR"},
#else
{2, 2, 0x0000000000000000, "RW/V", "SUSPEND", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{1, 1, 0x0000000000000000, "RO", "RSVD1", "Reserved"},
#else
{1, 1, 0x0000000000000000, "RO", "RSVD1", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 0, 0x0000000000000000, "RW/V", "WAKE", "Take PHY out of PM states and wakes the DRAM out of Self Refresh mode. The bit is cleared by hardware only when the DRAM has exited out of Self Refresh mode and is accessible. Note: When COLDWAKE is set prior of setting this bit the D-unit will not send SR exit command and will not set the DCO.IC bit."},
#else
{0, 0, 0x0000000000000000, "RW/V", "WAKE", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo51[] = {{"D_CR_DRAM_SR_CMD", "", 0x00000154, 5, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields52[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{31, 31, 0x0000000000000000, "RW", "M2N", "2N Mode Command (Reserved in BXT0/1)"},
#else
{31, 31, 0x0000000000000000, "RW", "M2N", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{30, 30, 0x0000000000000000, "RW", "RANK", "Rank Select. [br]0 - Rank0, [br]1 - Rank1"},
#else
{30, 30, 0x0000000000000000, "RW", "RANK", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{29, 29, 0x0000000000000000, "RW", "MRRCMD", "This bit needs to be set if the command is a MRR"},
#else
{29, 29, 0x0000000000000000, "RW", "MRRCMD", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{28, 28, 0x0000000000000000, "RW", "BL", "This field sets the BL that D-unit drives on SPID interface. [br]For LPDDR3, WIO2 and DDR3: 0 - Burst Length is 4,  1 - Burst Length is 8. [br]For LPDDR4: 0 - Burst Length is 16, 1 - Burst Length is 32"},
#else
{28, 28, 0x0000000000000000, "RW", "BL", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{24, 27, 0x0000000000000000, "RO", "RSVD27_24", "Reserved"},
#else
{24, 27, 0x0000000000000000, "RO", "RSVD27_24", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 23, 0x0000000000000000, "RW", "DATA", "Command to be sent to DRAM. Not all DRAM commands are supported. [br]For LPDDR3: [br]DATA[9:0]=CA[9:0] Rising Edge, [br]DATA [19:10]=CA[9:0] Falling Edge, [br]DATA[23:20] not used. [br]For WIO2: [br]DATA[10:0]=CA[10:0] Rising Edge, [br]DATA[21:11]=CA[10:0] Falling Edge, [br]Data[23:22] not used. [br]For LPDDR4: [br]DATA[5:0]=CA[5:0] CMD1 Edge1, [br]DATA[11:6]=CA[5:0] CMD1 Edge2, [br]DATA[17:12]=CA[5:0] CMD2 Edge1, [br]DATA[23:18]=CA[5:0] CMD2 Edge2. [br]For DDR3: DATA[15:0] = A[15:0], [br]DATA[18:16] = BA[2:0], [br]DATA[19] = WE_N, [br]DATA[20] = CAS_N, [br]DATA[21] = RAS_N, [br]DATA[23:22] not used;"},
#else
{0, 23, 0x0000000000000000, "RW", "DATA", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo52[] = {{"D_CR_DRAM_CMD", "", 0x00000158, 6, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields53[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{8, 31, 0x0000000000000000, "RO", "RSVD31_8", "Reserved"},
#else
{8, 31, 0x0000000000000000, "RO", "RSVD31_8", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 7, 0x0000000000000000, "RO/V", "MRRDATA", "MRR Data: [br]This field contains the data of the last DRAM Mode Register Read MRR issued through DRAM_CMD register. It is overwritten with each MRR command."},
#else
{0, 7, 0x0000000000000000, "RO/V", "MRRDATA", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo53[] = {{"D_CR_DCMDDATA", "", 0x0000015C, 2, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields54[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{31, 31, 0x0000000000000000, "RW", "ENABLE_PRDR", "Enables pseudorandom data return feature in D-unit"},
#else
{31, 31, 0x0000000000000000, "RW", "ENABLE_PRDR", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{30, 30, 0x0000000000000000, "RW", "ENABLE_CHECKSUM", "Enables checksum calculation in D-unit"},
#else
{30, 30, 0x0000000000000000, "RW", "ENABLE_CHECKSUM", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{29, 29, 0x0000000000000000, "RW/V", "RESET", "Resets the checksum registers when written to 1. Bit automatically resets to 0"},
#else
{29, 29, 0x0000000000000000, "RW/V", "RESET", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{28, 28, 0x0000000000000000, "RW", "RDDATA_CREDIT_EN", "Read data credit counter enable. When set read data credit counter register is used for credit handling instead of initial credit handshaking."},
#else
{28, 28, 0x0000000000000000, "RW", "RDDATA_CREDIT_EN", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{24, 27, 0x0000000000000000, "RW", "RDDATA_CREDIT", "Read data credit counter value. This values is used as read return credit."},
#else
{24, 27, 0x0000000000000000, "RW", "RDDATA_CREDIT", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{16, 23, 0x0000000000000000, "RW/1C", "ADDR_CHECKSUM", "Contains the address checksum value for all addresses read and written from this D-unit. Write 1 to clear this field."},
#else
{16, 23, 0x0000000000000000, "RW/1C", "ADDR_CHECKSUM", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 15, 0x0000000000000000, "RW/1C", "DATA_CHECKSUM", "Contains the final checksum value for all data written to this D-unit. Write 1 to clear this field."},
#else
{0, 15, 0x0000000000000000, "RW/1C", "DATA_CHECKSUM", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo54[] = {{"D_CR_SBFT_CTL", "", 0x00000160, 7, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields55[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{0, 31, 0x00000000FFFFFFFF, "RW", "CLEAR_MASK", "Mask ANDed with pseudorandom data.  Resets to all 1s  setting bit n to 0 in this register will force every nth bit in the data to be set to 0"},
#else
{0, 31, 0x00000000FFFFFFFF, "RW", "CLEAR_MASK", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo55[] = {{"D_CR_SBFT_CMASK", "", 0x00000164, 1, 0x00000000FFFFFFFF, 0x00000000FFFFFFFF}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields56[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{0, 31, 0x0000000000000000, "RW", "SET_MASK", "Mask ORed with pseudorandom data.  Resets to all 0s  setting bit n to 1 in this register will force every nth bit in the data to be set to 1"},
#else
{0, 31, 0x0000000000000000, "RW", "SET_MASK", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo56[] = {{"D_CR_SBFT_SMASK", "", 0x00000168, 1, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields57[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{0, 31, 0x0000000000000000, "RW", "SEED", "Seed XORed with address bits to produce pseudorandom data.  Use this to statically produce different pseudorandom data streams for the same set of request addresses."},
#else
{0, 31, 0x0000000000000000, "RW", "SEED", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo57[] = {{"D_CR_SBFT_SEED", "", 0x0000016C, 1, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields58[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{20, 31, 0x0000000000000000, "RW", "RSVD31_20", "This sets the frequency by which the Dunit  initiates periodic retraining.(in 1x NREFI)"},
#else
{20, 31, 0x0000000000000000, "RW", "RSVD31_20", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{16, 19, 0x0000000000000000, "RO", "SABY2_CLK_TIMER", "Reserved"},
#else
{16, 19, 0x0000000000000000, "RO", "SABY2_CLK_TIMER", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{12, 15, 0x0000000000000000, "RW", "RSVD15_12", "After Dunit starts DQS oscillator, it must wait this amount of time before being able to read the value in MR18 and MR19. (in 16x DRAM clocks) [br]Value in this register must be at least equal to DRAM's MR23 value."},
#else
{12, 15, 0x0000000000000000, "RW", "RSVD15_12", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{8, 11, 0x0000000000000000, "RO", "SPID_CLK_TIMER", "Reserved"},
#else
{8, 11, 0x0000000000000000, "RO", "SPID_CLK_TIMER", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{4, 7, 0x0000000000000000, "RW", "RSVD_7_4", "This bit enables LPDDR4 DQS retraining on Self Refresh Exit. If disabled Dunit will not perform retraining on SR exit."},
#else
{4, 7, 0x0000000000000000, "RW", "RSVD_7_4", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 3, 0x0000000000000000, "RW", "SB_CLK_TIMER", "This bit enables periodic DQS Retraining  If disabled Dunit will not perform retraining periodically. [br]Note: Will be enabled only if DCO.IC is set and refreshes are enabled in DRFC.MINREFRATE"},
#else
{0, 3, 0x0000000000000000, "RW", "SB_CLK_TIMER", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo58[] = {{"D_CR_PGCB_CG_IDLE_TIMER", "", 0x0000017C, 6, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields59[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{16, 31, 0x0000000000000000, "RW", "DQS_RETRAIN_INT", "This sets the frequency by which the Dunit  initiates periodic retraining.(in 1x NREFI)"},
#else
{16, 31, 0x0000000000000000, "RW", "DQS_RETRAIN_INT", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{14, 15, 0x0000000000000000, "RO", "RSVD15_14", "Reserved"},
#else
{14, 15, 0x0000000000000000, "RO", "RSVD15_14", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{4, 13, 0x0000000000000000, "RW", "DQS_OSC_RT", "After Dunit starts DQS oscillator, it must wait this amount of time before being able to read the value in MR18 and MR19. (in 16x DRAM clocks) [br]Value in this register must be at least equal to DRAM's MR23 value."},
#else
{4, 13, 0x0000000000000000, "RW", "DQS_OSC_RT", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{2, 3, 0x0000000000000000, "RO", "RSVD3_2", "Reserved"},
#else
{2, 3, 0x0000000000000000, "RO", "RSVD3_2", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{1, 1, 0x0000000000000000, "RW", "DQS_RETRAIN_SRX_EN", "This bit enables LPDDR4 DQS retraining on Self Refresh Exit. If disabled Dunit will not perform retraining on SR exit."},
#else
{1, 1, 0x0000000000000000, "RW", "DQS_RETRAIN_SRX_EN", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 0, 0x0000000000000000, "RW", "DQS_RETRAIN_EN", "This bit enables periodic DQS Retraining  If disabled Dunit will not perform retraining periodically. [br]Note: Will be enabled only if DCO.IC is set and refreshes are enabled in DRFC.MINREFRATE"},
#else
{0, 0, 0x0000000000000000, "RW", "DQS_RETRAIN_EN", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo59[] = {{"D_CR_DQS_RETRAINING_CTL", "", 0x00000180, 6, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields60[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{15, 31, 0x0000000000000000, "RO", "RSVD31_15", "Reserved"},
#else
{15, 31, 0x0000000000000000, "RO", "RSVD31_15", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{12, 14, 0x0000000000000000, "RW", "MR4_BIT2_SEL", "Selects bit 2 of MR4 data"},
#else
{12, 14, 0x0000000000000000, "RW", "MR4_BIT2_SEL", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{11, 11, 0x0000000000000000, "RO", "RSVD11", "Reserved"},
#else
{11, 11, 0x0000000000000000, "RO", "RSVD11", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{8, 10, 0x0000000000000000, "RW", "MR4_BIT1_SEL", "Selects bit 1 of MR4 data"},
#else
{8, 10, 0x0000000000000000, "RW", "MR4_BIT1_SEL", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{7, 7, 0x0000000000000000, "RO", "RSVD7", "Reserved"},
#else
{7, 7, 0x0000000000000000, "RO", "RSVD7", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{4, 6, 0x0000000000000000, "RW", "MR4_BIT0_SEL", "Selects bit 0 of MR4 data"},
#else
{4, 6, 0x0000000000000000, "RW", "MR4_BIT0_SEL", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{2, 3, 0x0000000000000000, "RO", "RSVD3_2", "Reserved"},
#else
{2, 3, 0x0000000000000000, "RO", "RSVD3_2", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 1, 0x0000000000000000, "RW", "MR4_BYTE_SEL", "Selects byte position of the MR4 data"},
#else
{0, 1, 0x0000000000000000, "RW", "MR4_BYTE_SEL", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo60[] = {{"D_CR_MR4_DESWIZZLE", "", 0x00000184, 8, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields61[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{0, 31, 0x0000000000000000, "RW", "Data", "Complete register for DRAM commands"},
#else
{0, 31, 0x0000000000000000, "RW", "Data", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo61[] = {{"D_CR_DRAM_CMD_DATA", "", 0x00000134, 1, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields62[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{0, 31, 0x0000000000000000, "RW", "MRC_to_TAP", "Idle Bypass Mode Enable: When enabled new page hit/empty read requests will bypass D-unit pipeline stages to save latency 0 - Disable Idle Bypass 1 - Enable Idle Bypass Note: Only applies to WIO2, this bit is reserved for other technologies"},
#else
{0, 31, 0x0000000000000000, "RW", "MRC_to_TAP", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo62[] = {{"PUNIT_TAP", "", 0x000001F0, 1, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields63[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{0, 31, 0x0000000061010202, "RW", "Control_Policy_L", "Lower half of the SAI Control Policy Value [31:0]"},
#else
{0, 31, 0x0000000061010202, "RW", "Control_Policy_L", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo63[] = {{"CPGC2_ACCESS_CONTROL_POLICY_L", "", 0x00000000, 1, 0x00000000FFFFFFFF, 0x0000000061010202}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields64[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{0, 31, 0x0000000000000C00, "RW", "Control_Policy_H", "Upper half of the SAI Control Policy Value [63:32]"},
#else
{0, 31, 0x0000000000000C00, "RW", "Control_Policy_H", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo64[] = {{"CPGC2_ACCESS_CONTROL_POLICY_H", "", 0x00000004, 1, 0x00000000FFFFFFFF, 0x0000000000000C00}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields65[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{0, 31, 0x00000000FFFFFF3F, "RW", "Read_Policy_L", "Lower half of the SAI Read Policy Value [31:0]"},
#else
{0, 31, 0x00000000FFFFFF3F, "RW", "Read_Policy_L", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo65[] = {{"CPGC2_ACCESS_READ_POLICY_L", "", 0x00000008, 1, 0x00000000FFFFFFFF, 0x00000000FFFFFF3F}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields66[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{0, 31, 0x0000000001371FFF, "RW", "Read_Policy_H", "Upper half of the SAI Read Policy Value [63:32]"},
#else
{0, 31, 0x0000000001371FFF, "RW", "Read_Policy_H", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo66[] = {{"CPGC2_ACCESS_READ_POLICY_H", "", 0x0000000C, 1, 0x00000000FFFFFFFF, 0x0000000001371FFF}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields67[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{0, 31, 0x0000000061010202, "RW", "Write_Policy_L", "Lower half of the SAI Write Policy Value [31:0]"},
#else
{0, 31, 0x0000000061010202, "RW", "Write_Policy_L", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo67[] = {{"CPGC2_ACCESS_WRITE_POLICY_L", "", 0x00000010, 1, 0x00000000FFFFFFFF, 0x0000000061010202}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields68[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{0, 31, 0x0000000000000C00, "RW", "Write_Policy_H", "Upper half of the SAI Write Policy Value [63:32]"},
#else
{0, 31, 0x0000000000000C00, "RW", "Write_Policy_H", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo68[] = {{"CPGC2_ACCESS_WRITE_POLICY_H", "", 0x00000014, 1, 0x00000000FFFFFFFF, 0x0000000000000C00}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields69[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{0, 5, 0x0000000000000000, "RW", "Address_Decode_Rotate_Repeats", "Number of times the current Address_Instruction will repeat if Address_Decode_Enable is set. As N-1. (0=1 time)[br]\r\n"
"If  for the current Address_Instruction, Address_Decode_Enable is set, then at the start of that Address_Instruction initialize the XOR_Address_Pattern to a single 1 in the LSB of Column Address. Otherwise it is initialized to all zero's.[br]\r\n"
"For (Address_Decode_Rotate_Repeat_Current = 0; Current_ Address_Decode_Rotate_Repeat_Current <= Address_Decode_Rotate_Repeat;  Address_Decode_Rotate_Repeat_Current ++)[br]\r\n"
"Execute the entire Algorithm (Block Traversal, Algorithm_Instruction, Commands) with the following behavior:[br]\r\n"
"At the end of each complete Block Traversal, rotate the XOR Address Pattern 1 bit position from LSB to MSB (Column through Region_Bits_Column, Region_Bits_Row, Region_Num_Banks, and through Region_Num_Ranks).[br]\r\n"
"Region_Size.Num_Bank and Region_Size.Num_Rank numbers are converted to the equivalent number of adddress bits to cover their range (ceil(log2(Num+1))) and should be programmed to a power of 2 value (minus 1): 1,3,7, or 15.[br]\r\n"
"If only one Rank is being tested, then you should limit the amount in this register to the sum of the number of address bits without Rank bits."},
#else
{0, 5, 0x0000000000000000, "RW", "Address_Decode_Rotate_Repeats", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo69[] = {{"CPGC2_ADDRESS_CONTROL", "", 0x00000018, 1, 0x000000000000003F, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields70[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{7, 7, 0x0000000000000000, "RW", "Last", "Last Address_Instruction"},
#else
{7, 7, 0x0000000000000000, "RW", "Last", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{6, 6, 0x0000000000000000, "RW", "Address_Decode_Enable", "Enable rotating XOR of address bits. Used in concert with the Address_Decode_Enable field in the Command_Instruction list.[br]\r\n"
"This bit enables repeating of the current Address_Instruction for Address_Decode_Rotate_Repeats times."},
#else
{6, 6, 0x0000000000000000, "RW", "Address_Decode_Enable", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{3, 5, 0x0000000000000000, "RW", "Address_Direction", "[b]Address_Direction[/b][br]\r\n"
"There are 4 basic address directions and their inverse for a total of 8.[br]\r\n"
"We will denote this as a combination of a 1-bit field and a 2-bit field.[br]\r\n"
"[b](0)(00)  FastY -North[/b][br]\r\n"
" Increment Column and Carry Increment into Row.[br]\r\n"
"[b](1)(00) Inv(FastY) - South[/b][br]\r\n"
" Decrement Column and Carry Decrement into Row.[br]\r\n"
"[b](0)(01) Diagonal  North East[/b][br]\r\n"
" Increment Row and Column together and Carry Increment Column into Row.[br]\r\n"
"[b](1)(01) Inv(Diagonal)  South West[/b][br]\r\n"
" Decrement Row and Column together and Carry Decrement Column into Row.[br]\r\n"
"[b](0)(10) FastX  South East[/b][br]\r\n"
" Decrement Column and Increment Row and Carry Increment Column into Row.[br]\r\n"
"[b](1)(10) Inv(FastX) - North West[/b][br]\r\n"
" Increment Column and Decrement Row and Carry Decrement Column into Row.[br]\r\n"
"[b](0)(11) Diagonal2 - East[/b][br]\r\n"
"  Increment Row and Carry Increment into Column.[br]\r\n"
"[b](1)(11) Inv(Diagonal2)  West [/b][br]\r\n"
" Decrement Row and Carry Decrement into Column.[br]\r\n"
"\r\n"
"Note that the Bank and Rank Address direction follows the same as the Column (increment or Decrement).[br]\r\n"
"Note for diagonal directions, a Carry results in twice the normal increment/decrement of the Row field.[br]\r\n"
"Incrementing fields start at 0, and Decrementing fields start at 2^(field_block_size)-2^(field_increment)= top of block."},
#else
{3, 5, 0x0000000000000000, "RW", "Address_Direction", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 2, 0x0000000000000000, "RW", "Address_Order", "Controls the fastest changing address field, and how that carries into higher order fields.[br]\r\n"
"000 Rank, Bank, Row/Col[br]\r\n"
"001 Rank, Row/Col, Bank[br]\r\n"
"010 Bank, Rank, Row/Col[br]\r\n"
"011 Bank, Row/Col, Rank[br]\r\n"
"100 Row/Col, Rank, Bank[br]\r\n"
"101 Row/Col, Bank, Rank[br]\r\n"
"110 Row/Col  (Used for Offset) Rank and Bank are unchanged.[br]\r\n"
"111 Row-Col (Used for Stripe Offset) No Carry from any field to another[br]\r\n"
"Carry order between Row and Column is dependent on the Address_Direction field."},
#else
{0, 2, 0x0000000000000000, "RW", "Address_Order", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo70[] = {{"CPGC2_ADDRESS_INSTRUCTION_0_", "", 0x0000001C, 4, 0x00000000000000FF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields71[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{7, 7, 0x0000000000000000, "RW", "Last", "Last Address_Instruction"},
#else
{7, 7, 0x0000000000000000, "RW", "Last", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{6, 6, 0x0000000000000000, "RW", "Address_Decode_Enable", "Enable rotating XOR of address bits. Used in concert with the Address_Decode_Enable field in the Command_Instruction list.[br]\r\n"
"This bit enables repeating of the current Address_Instruction for Address_Decode_Rotate_Repeats times."},
#else
{6, 6, 0x0000000000000000, "RW", "Address_Decode_Enable", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{3, 5, 0x0000000000000000, "RW", "Address_Direction", "[b]Address_Direction[/b][br]\r\n"
"There are 4 basic address directions and their inverse for a total of 8.[br]\r\n"
"We will denote this as a combination of a 1-bit field and a 2-bit field.[br]\r\n"
"[b](0)(00)  FastY -North[/b][br]\r\n"
" Increment Column and Carry Increment into Row.[br]\r\n"
"[b](1)(00) Inv(FastY) - South[/b][br]\r\n"
" Decrement Column and Carry Decrement into Row.[br]\r\n"
"[b](0)(01) Diagonal  North East[/b][br]\r\n"
" Increment Row and Column together and Carry Increment Column into Row.[br]\r\n"
"[b](1)(01) Inv(Diagonal)  South West[/b][br]\r\n"
" Decrement Row and Column together and Carry Decrement Column into Row.[br]\r\n"
"[b](0)(10) FastX  South East[/b][br]\r\n"
" Decrement Column and Increment Row and Carry Increment Column into Row.[br]\r\n"
"[b](1)(10) Inv(FastX) - North West[/b][br]\r\n"
" Increment Column and Decrement Row and Carry Decrement Column into Row.[br]\r\n"
"[b](0)(11) Diagonal2 - East[/b][br]\r\n"
"  Increment Row and Carry Increment into Column.[br]\r\n"
"[b](1)(11) Inv(Diagonal2)  West [/b][br]\r\n"
" Decrement Row and Carry Decrement into Column.[br]\r\n"
"\r\n"
"Note that the Bank and Rank Address direction follows the same as the Column (increment or Decrement).[br]\r\n"
"Note for diagonal directions, a Carry results in twice the normal increment/decrement of the Row field.[br]\r\n"
"Incrementing fields start at 0, and Decrementing fields start at 2^(field_block_size)-2^(field_increment)= top of block."},
#else
{3, 5, 0x0000000000000000, "RW", "Address_Direction", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 2, 0x0000000000000000, "RW", "Address_Order", "Controls the fastest changing address field, and how that carries into higher order fields.[br]\r\n"
"000 Rank, Bank, Row/Col[br]\r\n"
"001 Rank, Row/Col, Bank[br]\r\n"
"010 Bank, Rank, Row/Col[br]\r\n"
"011 Bank, Row/Col, Rank[br]\r\n"
"100 Row/Col, Rank, Bank[br]\r\n"
"101 Row/Col, Bank, Rank[br]\r\n"
"110 Row/Col  (Used for Offset) Rank and Bank are unchanged.[br]\r\n"
"111 Row-Col (Used for Stripe Offset) No Carry from any field to another[br]\r\n"
"Carry order between Row and Column is dependent on the Address_Direction field."},
#else
{0, 2, 0x0000000000000000, "RW", "Address_Order", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo71[] = {{"CPGC2_ADDRESS_INSTRUCTION_1_", "", 0x0000001D, 4, 0x00000000000000FF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields72[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{7, 7, 0x0000000000000000, "RW", "Last", "Last Address_Instruction"},
#else
{7, 7, 0x0000000000000000, "RW", "Last", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{6, 6, 0x0000000000000000, "RW", "Address_Decode_Enable", "Enable rotating XOR of address bits. Used in concert with the Address_Decode_Enable field in the Command_Instruction list.[br]\r\n"
"This bit enables repeating of the current Address_Instruction for Address_Decode_Rotate_Repeats times."},
#else
{6, 6, 0x0000000000000000, "RW", "Address_Decode_Enable", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{3, 5, 0x0000000000000000, "RW", "Address_Direction", "[b]Address_Direction[/b][br]\r\n"
"There are 4 basic address directions and their inverse for a total of 8.[br]\r\n"
"We will denote this as a combination of a 1-bit field and a 2-bit field.[br]\r\n"
"[b](0)(00)  FastY -North[/b][br]\r\n"
" Increment Column and Carry Increment into Row.[br]\r\n"
"[b](1)(00) Inv(FastY) - South[/b][br]\r\n"
" Decrement Column and Carry Decrement into Row.[br]\r\n"
"[b](0)(01) Diagonal  North East[/b][br]\r\n"
" Increment Row and Column together and Carry Increment Column into Row.[br]\r\n"
"[b](1)(01) Inv(Diagonal)  South West[/b][br]\r\n"
" Decrement Row and Column together and Carry Decrement Column into Row.[br]\r\n"
"[b](0)(10) FastX  South East[/b][br]\r\n"
" Decrement Column and Increment Row and Carry Increment Column into Row.[br]\r\n"
"[b](1)(10) Inv(FastX) - North West[/b][br]\r\n"
" Increment Column and Decrement Row and Carry Decrement Column into Row.[br]\r\n"
"[b](0)(11) Diagonal2 - East[/b][br]\r\n"
"  Increment Row and Carry Increment into Column.[br]\r\n"
"[b](1)(11) Inv(Diagonal2)  West [/b][br]\r\n"
" Decrement Row and Carry Decrement into Column.[br]\r\n"
"\r\n"
"Note that the Bank and Rank Address direction follows the same as the Column (increment or Decrement).[br]\r\n"
"Note for diagonal directions, a Carry results in twice the normal increment/decrement of the Row field.[br]\r\n"
"Incrementing fields start at 0, and Decrementing fields start at 2^(field_block_size)-2^(field_increment)= top of block."},
#else
{3, 5, 0x0000000000000000, "RW", "Address_Direction", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 2, 0x0000000000000000, "RW", "Address_Order", "Controls the fastest changing address field, and how that carries into higher order fields.[br]\r\n"
"000 Rank, Bank, Row/Col[br]\r\n"
"001 Rank, Row/Col, Bank[br]\r\n"
"010 Bank, Rank, Row/Col[br]\r\n"
"011 Bank, Row/Col, Rank[br]\r\n"
"100 Row/Col, Rank, Bank[br]\r\n"
"101 Row/Col, Bank, Rank[br]\r\n"
"110 Row/Col  (Used for Offset) Rank and Bank are unchanged.[br]\r\n"
"111 Row-Col (Used for Stripe Offset) No Carry from any field to another[br]\r\n"
"Carry order between Row and Column is dependent on the Address_Direction field."},
#else
{0, 2, 0x0000000000000000, "RW", "Address_Order", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo72[] = {{"CPGC2_ADDRESS_INSTRUCTION_2_", "", 0x0000001E, 4, 0x00000000000000FF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields73[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{7, 7, 0x0000000000000000, "RW", "Last", "Last Address_Instruction"},
#else
{7, 7, 0x0000000000000000, "RW", "Last", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{6, 6, 0x0000000000000000, "RW", "Address_Decode_Enable", "Enable rotating XOR of address bits. Used in concert with the Address_Decode_Enable field in the Command_Instruction list.[br]\r\n"
"This bit enables repeating of the current Address_Instruction for Address_Decode_Rotate_Repeats times."},
#else
{6, 6, 0x0000000000000000, "RW", "Address_Decode_Enable", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{3, 5, 0x0000000000000000, "RW", "Address_Direction", "[b]Address_Direction[/b][br]\r\n"
"There are 4 basic address directions and their inverse for a total of 8.[br]\r\n"
"We will denote this as a combination of a 1-bit field and a 2-bit field.[br]\r\n"
"[b](0)(00)  FastY -North[/b][br]\r\n"
" Increment Column and Carry Increment into Row.[br]\r\n"
"[b](1)(00) Inv(FastY) - South[/b][br]\r\n"
" Decrement Column and Carry Decrement into Row.[br]\r\n"
"[b](0)(01) Diagonal  North East[/b][br]\r\n"
" Increment Row and Column together and Carry Increment Column into Row.[br]\r\n"
"[b](1)(01) Inv(Diagonal)  South West[/b][br]\r\n"
" Decrement Row and Column together and Carry Decrement Column into Row.[br]\r\n"
"[b](0)(10) FastX  South East[/b][br]\r\n"
" Decrement Column and Increment Row and Carry Increment Column into Row.[br]\r\n"
"[b](1)(10) Inv(FastX) - North West[/b][br]\r\n"
" Increment Column and Decrement Row and Carry Decrement Column into Row.[br]\r\n"
"[b](0)(11) Diagonal2 - East[/b][br]\r\n"
"  Increment Row and Carry Increment into Column.[br]\r\n"
"[b](1)(11) Inv(Diagonal2)  West [/b][br]\r\n"
" Decrement Row and Carry Decrement into Column.[br]\r\n"
"\r\n"
"Note that the Bank and Rank Address direction follows the same as the Column (increment or Decrement).[br]\r\n"
"Note for diagonal directions, a Carry results in twice the normal increment/decrement of the Row field.[br]\r\n"
"Incrementing fields start at 0, and Decrementing fields start at 2^(field_block_size)-2^(field_increment)= top of block."},
#else
{3, 5, 0x0000000000000000, "RW", "Address_Direction", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 2, 0x0000000000000000, "RW", "Address_Order", "Controls the fastest changing address field, and how that carries into higher order fields.[br]\r\n"
"000 Rank, Bank, Row/Col[br]\r\n"
"001 Rank, Row/Col, Bank[br]\r\n"
"010 Bank, Rank, Row/Col[br]\r\n"
"011 Bank, Row/Col, Rank[br]\r\n"
"100 Row/Col, Rank, Bank[br]\r\n"
"101 Row/Col, Bank, Rank[br]\r\n"
"110 Row/Col  (Used for Offset) Rank and Bank are unchanged.[br]\r\n"
"111 Row-Col (Used for Stripe Offset) No Carry from any field to another[br]\r\n"
"Carry order between Row and Column is dependent on the Address_Direction field."},
#else
{0, 2, 0x0000000000000000, "RW", "Address_Order", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo73[] = {{"CPGC2_ADDRESS_INSTRUCTION_3_", "", 0x0000001F, 4, 0x00000000000000FF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields74[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{7, 7, 0x0000000000000000, "RW", "Last", "Last Data_Instruction"},
#else
{7, 7, 0x0000000000000000, "RW", "Last", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{6, 6, 0x0000000000000000, "RW", "Invert_Data", "Globally Invert all data.  Combined with the Algorithm_Instruction Invert_Data field, and the Command_Instruction or Offset_Command_Instruction Invert_Data field to determine the final data polarity."},
#else
{6, 6, 0x0000000000000000, "RW", "Invert_Data", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{4, 5, 0x0000000000000000, "RW", "Data_Background", "00 - Solid[br]\r\n"
"01 - Column Stripes[br]\r\n"
"10 - Row Stripes[br]\r\n"
"11 - Checkerboard"},
#else
{4, 5, 0x0000000000000000, "RW", "Data_Background", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{3, 3, 0x0000000000000000, "RW", "Data_Select_Rotation_Enable", "Enable rotating lane pattern data. Used in concert with the Data_Select_Rotation_Enable field in the Data_Instruction list.[br]\r\n"
"This bit enables repeating of the current Data_Instruction for Data_Select_Rotation_Repeat times.[br]\r\n"
"Data generated using the advanced pattern generation will rotate by one data bit (LSB toward MSB) for each Data_Select_Rotation_Repeat.[br]\r\n"
"For the purpose of this shift, the order follows the Address_Instruction Address_Order and the Algorithm_Instruction[0] Address_Direction."},
#else
{3, 3, 0x0000000000000000, "RW", "Data_Select_Rotation_Enable", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo74[] = {{"CPGC2_DATA_INSTRUCTION_0_", "", 0x00000020, 4, 0x00000000000000FF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields75[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{7, 7, 0x0000000000000000, "RW", "Last", "Last Data_Instruction"},
#else
{7, 7, 0x0000000000000000, "RW", "Last", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{6, 6, 0x0000000000000000, "RW", "Invert_Data", "Globally Invert all data.  Combined with the Algorithm_Instruction Invert_Data field, and the Command_Instruction or Offset_Command_Instruction Invert_Data field to determine the final data polarity."},
#else
{6, 6, 0x0000000000000000, "RW", "Invert_Data", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{4, 5, 0x0000000000000000, "RW", "Data_Background", "00 - Solid[br]\r\n"
"01 - Column Stripes[br]\r\n"
"10 - Row Stripes[br]\r\n"
"11 - Checkerboard"},
#else
{4, 5, 0x0000000000000000, "RW", "Data_Background", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{3, 3, 0x0000000000000000, "RW", "Data_Select_Rotation_Enable", "Enable rotating lane pattern data. Used in concert with the Data_Select_Rotation_Enable field in the Data_Instruction list.[br]\r\n"
"This bit enables repeating of the current Data_Instruction for Data_Select_Rotation_Repeat times.[br]\r\n"
"Data generated using the advanced pattern generation will rotate by one data bit (LSB toward MSB) for each Data_Select_Rotation_Repeat.[br]\r\n"
"For the purpose of this shift, the order follows the Address_Instruction Address_Order and the Algorithm_Instruction[0] Address_Direction."},
#else
{3, 3, 0x0000000000000000, "RW", "Data_Select_Rotation_Enable", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo75[] = {{"CPGC2_DATA_INSTRUCTION_1_", "", 0x00000021, 4, 0x00000000000000FF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields76[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{7, 7, 0x0000000000000000, "RW", "Last", "Last Data_Instruction"},
#else
{7, 7, 0x0000000000000000, "RW", "Last", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{6, 6, 0x0000000000000000, "RW", "Invert_Data", "Globally Invert all data.  Combined with the Algorithm_Instruction Invert_Data field, and the Command_Instruction or Offset_Command_Instruction Invert_Data field to determine the final data polarity."},
#else
{6, 6, 0x0000000000000000, "RW", "Invert_Data", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{4, 5, 0x0000000000000000, "RW", "Data_Background", "00 - Solid[br]\r\n"
"01 - Column Stripes[br]\r\n"
"10 - Row Stripes[br]\r\n"
"11 - Checkerboard"},
#else
{4, 5, 0x0000000000000000, "RW", "Data_Background", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{3, 3, 0x0000000000000000, "RW", "Data_Select_Rotation_Enable", "Enable rotating lane pattern data. Used in concert with the Data_Select_Rotation_Enable field in the Data_Instruction list.[br]\r\n"
"This bit enables repeating of the current Data_Instruction for Data_Select_Rotation_Repeat times.[br]\r\n"
"Data generated using the advanced pattern generation will rotate by one data bit (LSB toward MSB) for each Data_Select_Rotation_Repeat.[br]\r\n"
"For the purpose of this shift, the order follows the Address_Instruction Address_Order and the Algorithm_Instruction[0] Address_Direction."},
#else
{3, 3, 0x0000000000000000, "RW", "Data_Select_Rotation_Enable", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo76[] = {{"CPGC2_DATA_INSTRUCTION_2_", "", 0x00000022, 4, 0x00000000000000FF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields77[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{7, 7, 0x0000000000000000, "RW", "Last", "Last Data_Instruction"},
#else
{7, 7, 0x0000000000000000, "RW", "Last", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{6, 6, 0x0000000000000000, "RW", "Invert_Data", "Globally Invert all data.  Combined with the Algorithm_Instruction Invert_Data field, and the Command_Instruction or Offset_Command_Instruction Invert_Data field to determine the final data polarity."},
#else
{6, 6, 0x0000000000000000, "RW", "Invert_Data", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{4, 5, 0x0000000000000000, "RW", "Data_Background", "00 - Solid[br]\r\n"
"01 - Column Stripes[br]\r\n"
"10 - Row Stripes[br]\r\n"
"11 - Checkerboard"},
#else
{4, 5, 0x0000000000000000, "RW", "Data_Background", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{3, 3, 0x0000000000000000, "RW", "Data_Select_Rotation_Enable", "Enable rotating lane pattern data. Used in concert with the Data_Select_Rotation_Enable field in the Data_Instruction list.[br]\r\n"
"This bit enables repeating of the current Data_Instruction for Data_Select_Rotation_Repeat times.[br]\r\n"
"Data generated using the advanced pattern generation will rotate by one data bit (LSB toward MSB) for each Data_Select_Rotation_Repeat.[br]\r\n"
"For the purpose of this shift, the order follows the Address_Instruction Address_Order and the Algorithm_Instruction[0] Address_Direction."},
#else
{3, 3, 0x0000000000000000, "RW", "Data_Select_Rotation_Enable", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo77[] = {{"CPGC2_DATA_INSTRUCTION_3_", "", 0x00000023, 4, 0x00000000000000FF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields78[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{0, 7, 0x0000000000000000, "RW", "Data_Select_Rotation_Repeats", "Number of times an enabled Data_Instruction will be repeated.  As N-1. (0=1 time)"},
#else
{0, 7, 0x0000000000000000, "RW", "Data_Select_Rotation_Repeats", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo78[] = {{"CPGC2_DATA_CONTROL", "", 0x00000024, 1, 0x00000000000000FF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields79[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{16, 23, 0x0000000000000000, "RO/V", "Data_Select_Rotation_Repeats_Current", "Current state of Data_Select_Rotation_Repeats loop (down count)"},
#else
{16, 23, 0x0000000000000000, "RO/V", "Data_Select_Rotation_Repeats_Current", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 5, 0x0000000000000000, "RO/V", "Address_Decode_Rotate_Repeats_Current", "Current state of Address_Decode_Rotate_Repeats loop. (down count)"},
#else
{0, 5, 0x0000000000000000, "RO/V", "Address_Decode_Rotate_Repeats_Current", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo79[] = {{"CPGC2_ADDRESS_DATA_STATUS", "", 0x00000028, 2, 0x0000000000FFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields80[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{7, 7, 0x0000000000000000, "RW", "Last", "Last Algorithm_Instruction. Execution continues at the first Algorithm_Instruction until the test is complete."},
#else
{7, 7, 0x0000000000000000, "RW", "Last", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{6, 6, 0x0000000000000000, "RW", "Invert_Data", "Invert all data for this Algorithm_Instruction.  Combined with the Data_Instruction Invert_Data field, and the Command_Instruction and Offset_Command_Instruction Invert_Data field to determine the final data polarity."},
#else
{6, 6, 0x0000000000000000, "RW", "Invert_Data", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{5, 5, 0x0000000000000000, "RW", "Inverse_Direction", "Invert the direction as set in the current Address_Instruction for the duration of this Algorithm_Instruction."},
#else
{5, 5, 0x0000000000000000, "RW", "Inverse_Direction", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 4, 0x0000000000000000, "RW", "Command_Start_Pointer", "Starting Command_Instruction for exection of this Algorithm_Instruction.  The Command_Inxtruction_Current cycles from Command_Start_Pointer, incrementing until a Command_Instruction contains the Last bit set, and then repeats for each Base_Address, Base_Repeats.[br]\r\n"
"Pointer to which one of the 24 command list to start with."},
#else
{0, 4, 0x0000000000000000, "RW", "Command_Start_Pointer", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo80[] = {{"CPGC2_ALGORITHM_INSTRUCTION_0_", "", 0x0000002C, 4, 0x00000000000000FF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields81[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{7, 7, 0x0000000000000000, "RW", "Last", "Last Algorithm_Instruction. Execution continues at the first Algorithm_Instruction until the test is complete."},
#else
{7, 7, 0x0000000000000000, "RW", "Last", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{6, 6, 0x0000000000000000, "RW", "Invert_Data", "Invert all data for this Algorithm_Instruction.  Combined with the Data_Instruction Invert_Data field, and the Command_Instruction and Offset_Command_Instruction Invert_Data field to determine the final data polarity."},
#else
{6, 6, 0x0000000000000000, "RW", "Invert_Data", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{5, 5, 0x0000000000000000, "RW", "Inverse_Direction", "Invert the direction as set in the current Address_Instruction for the duration of this Algorithm_Instruction."},
#else
{5, 5, 0x0000000000000000, "RW", "Inverse_Direction", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 4, 0x0000000000000000, "RW", "Command_Start_Pointer", "Starting Command_Instruction for exection of this Algorithm_Instruction.  The Command_Inxtruction_Current cycles from Command_Start_Pointer, incrementing until a Command_Instruction contains the Last bit set, and then repeats for each Base_Address, Base_Repeats.[br]\r\n"
"Pointer to which one of the 24 command list to start with."},
#else
{0, 4, 0x0000000000000000, "RW", "Command_Start_Pointer", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo81[] = {{"CPGC2_ALGORITHM_INSTRUCTION_1_", "", 0x0000002D, 4, 0x00000000000000FF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields82[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{7, 7, 0x0000000000000000, "RW", "Last", "Last Algorithm_Instruction. Execution continues at the first Algorithm_Instruction until the test is complete."},
#else
{7, 7, 0x0000000000000000, "RW", "Last", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{6, 6, 0x0000000000000000, "RW", "Invert_Data", "Invert all data for this Algorithm_Instruction.  Combined with the Data_Instruction Invert_Data field, and the Command_Instruction and Offset_Command_Instruction Invert_Data field to determine the final data polarity."},
#else
{6, 6, 0x0000000000000000, "RW", "Invert_Data", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{5, 5, 0x0000000000000000, "RW", "Inverse_Direction", "Invert the direction as set in the current Address_Instruction for the duration of this Algorithm_Instruction."},
#else
{5, 5, 0x0000000000000000, "RW", "Inverse_Direction", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 4, 0x0000000000000000, "RW", "Command_Start_Pointer", "Starting Command_Instruction for exection of this Algorithm_Instruction.  The Command_Inxtruction_Current cycles from Command_Start_Pointer, incrementing until a Command_Instruction contains the Last bit set, and then repeats for each Base_Address, Base_Repeats.[br]\r\n"
"Pointer to which one of the 24 command list to start with."},
#else
{0, 4, 0x0000000000000000, "RW", "Command_Start_Pointer", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo82[] = {{"CPGC2_ALGORITHM_INSTRUCTION_2_", "", 0x0000002E, 4, 0x00000000000000FF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields83[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{7, 7, 0x0000000000000000, "RW", "Last", "Last Algorithm_Instruction. Execution continues at the first Algorithm_Instruction until the test is complete."},
#else
{7, 7, 0x0000000000000000, "RW", "Last", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{6, 6, 0x0000000000000000, "RW", "Invert_Data", "Invert all data for this Algorithm_Instruction.  Combined with the Data_Instruction Invert_Data field, and the Command_Instruction and Offset_Command_Instruction Invert_Data field to determine the final data polarity."},
#else
{6, 6, 0x0000000000000000, "RW", "Invert_Data", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{5, 5, 0x0000000000000000, "RW", "Inverse_Direction", "Invert the direction as set in the current Address_Instruction for the duration of this Algorithm_Instruction."},
#else
{5, 5, 0x0000000000000000, "RW", "Inverse_Direction", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 4, 0x0000000000000000, "RW", "Command_Start_Pointer", "Starting Command_Instruction for exection of this Algorithm_Instruction.  The Command_Inxtruction_Current cycles from Command_Start_Pointer, incrementing until a Command_Instruction contains the Last bit set, and then repeats for each Base_Address, Base_Repeats.[br]\r\n"
"Pointer to which one of the 24 command list to start with."},
#else
{0, 4, 0x0000000000000000, "RW", "Command_Start_Pointer", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo83[] = {{"CPGC2_ALGORITHM_INSTRUCTION_3_", "", 0x0000002F, 4, 0x00000000000000FF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields84[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{7, 7, 0x0000000000000000, "RW", "Last", "Last Algorithm_Instruction. Execution continues at the first Algorithm_Instruction until the test is complete."},
#else
{7, 7, 0x0000000000000000, "RW", "Last", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{6, 6, 0x0000000000000000, "RW", "Invert_Data", "Invert all data for this Algorithm_Instruction.  Combined with the Data_Instruction Invert_Data field, and the Command_Instruction and Offset_Command_Instruction Invert_Data field to determine the final data polarity."},
#else
{6, 6, 0x0000000000000000, "RW", "Invert_Data", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{5, 5, 0x0000000000000000, "RW", "Inverse_Direction", "Invert the direction as set in the current Address_Instruction for the duration of this Algorithm_Instruction."},
#else
{5, 5, 0x0000000000000000, "RW", "Inverse_Direction", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 4, 0x0000000000000000, "RW", "Command_Start_Pointer", "Starting Command_Instruction for exection of this Algorithm_Instruction.  The Command_Inxtruction_Current cycles from Command_Start_Pointer, incrementing until a Command_Instruction contains the Last bit set, and then repeats for each Base_Address, Base_Repeats.[br]\r\n"
"Pointer to which one of the 24 command list to start with."},
#else
{0, 4, 0x0000000000000000, "RW", "Command_Start_Pointer", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo84[] = {{"CPGC2_ALGORITHM_INSTRUCTION_4_", "", 0x00000030, 4, 0x00000000000000FF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields85[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{7, 7, 0x0000000000000000, "RW", "Last", "Last Algorithm_Instruction. Execution continues at the first Algorithm_Instruction until the test is complete."},
#else
{7, 7, 0x0000000000000000, "RW", "Last", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{6, 6, 0x0000000000000000, "RW", "Invert_Data", "Invert all data for this Algorithm_Instruction.  Combined with the Data_Instruction Invert_Data field, and the Command_Instruction and Offset_Command_Instruction Invert_Data field to determine the final data polarity."},
#else
{6, 6, 0x0000000000000000, "RW", "Invert_Data", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{5, 5, 0x0000000000000000, "RW", "Inverse_Direction", "Invert the direction as set in the current Address_Instruction for the duration of this Algorithm_Instruction."},
#else
{5, 5, 0x0000000000000000, "RW", "Inverse_Direction", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 4, 0x0000000000000000, "RW", "Command_Start_Pointer", "Starting Command_Instruction for exection of this Algorithm_Instruction.  The Command_Inxtruction_Current cycles from Command_Start_Pointer, incrementing until a Command_Instruction contains the Last bit set, and then repeats for each Base_Address, Base_Repeats.[br]\r\n"
"Pointer to which one of the 24 command list to start with."},
#else
{0, 4, 0x0000000000000000, "RW", "Command_Start_Pointer", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo85[] = {{"CPGC2_ALGORITHM_INSTRUCTION_5_", "", 0x00000031, 4, 0x00000000000000FF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields86[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{7, 7, 0x0000000000000000, "RW", "Last", "Last Algorithm_Instruction. Execution continues at the first Algorithm_Instruction until the test is complete."},
#else
{7, 7, 0x0000000000000000, "RW", "Last", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{6, 6, 0x0000000000000000, "RW", "Invert_Data", "Invert all data for this Algorithm_Instruction.  Combined with the Data_Instruction Invert_Data field, and the Command_Instruction and Offset_Command_Instruction Invert_Data field to determine the final data polarity."},
#else
{6, 6, 0x0000000000000000, "RW", "Invert_Data", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{5, 5, 0x0000000000000000, "RW", "Inverse_Direction", "Invert the direction as set in the current Address_Instruction for the duration of this Algorithm_Instruction."},
#else
{5, 5, 0x0000000000000000, "RW", "Inverse_Direction", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 4, 0x0000000000000000, "RW", "Command_Start_Pointer", "Starting Command_Instruction for exection of this Algorithm_Instruction.  The Command_Inxtruction_Current cycles from Command_Start_Pointer, incrementing until a Command_Instruction contains the Last bit set, and then repeats for each Base_Address, Base_Repeats.[br]\r\n"
"Pointer to which one of the 24 command list to start with."},
#else
{0, 4, 0x0000000000000000, "RW", "Command_Start_Pointer", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo86[] = {{"CPGC2_ALGORITHM_INSTRUCTION_6_", "", 0x00000032, 4, 0x00000000000000FF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields87[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{7, 7, 0x0000000000000000, "RW", "Last", "Last Algorithm_Instruction. Execution continues at the first Algorithm_Instruction until the test is complete."},
#else
{7, 7, 0x0000000000000000, "RW", "Last", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{6, 6, 0x0000000000000000, "RW", "Invert_Data", "Invert all data for this Algorithm_Instruction.  Combined with the Data_Instruction Invert_Data field, and the Command_Instruction and Offset_Command_Instruction Invert_Data field to determine the final data polarity."},
#else
{6, 6, 0x0000000000000000, "RW", "Invert_Data", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{5, 5, 0x0000000000000000, "RW", "Inverse_Direction", "Invert the direction as set in the current Address_Instruction for the duration of this Algorithm_Instruction."},
#else
{5, 5, 0x0000000000000000, "RW", "Inverse_Direction", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 4, 0x0000000000000000, "RW", "Command_Start_Pointer", "Starting Command_Instruction for exection of this Algorithm_Instruction.  The Command_Inxtruction_Current cycles from Command_Start_Pointer, incrementing until a Command_Instruction contains the Last bit set, and then repeats for each Base_Address, Base_Repeats.[br]\r\n"
"Pointer to which one of the 24 command list to start with."},
#else
{0, 4, 0x0000000000000000, "RW", "Command_Start_Pointer", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo87[] = {{"CPGC2_ALGORITHM_INSTRUCTION_7_", "", 0x00000033, 4, 0x00000000000000FF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields88[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{5, 5, 0x0000000000000000, "RW", "Deselect_On", "If set, the CADB will be able to issue harassment patterns into the command and address bus."},
#else
{5, 5, 0x0000000000000000, "RW", "Deselect_On", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{4, 4, 0x0000000000000000, "RW", "Wait_Event_Start", "Wait_Event_Start causes the delay in beginning the current Algorithm_Instruction until the Event indicated by Select_Event has been acknowledged to have occurred.[br]\r\n"
"The Select_Event is acknowledged to be in progress.[br]\r\n"
"The latency between the event and the acknowledgement must be a known fixed value (preventing a hang situation).[br]\r\n"
"The Current_Repeat_Value is reset tzero.[br]\r\n"
""},
#else
{4, 4, 0x0000000000000000, "RW", "Wait_Event_Start", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{3, 3, 0x0000000000000000, "RW", "Wait_Count_Start", "Wait_Count_Start and Wait_Time are used to synchronize a specific time an Algorithm should start.[br]\r\n"
"Wait_Time is commonly used for Pause Refresh test where the read to a particular address needs to be a specific time away from when the write to an address occurs.[br]\r\n"
"If Wait_Count_Start = 0 then the start of the Algorithm_Instruction is not stalled.[br]\r\n"
"If Wait_Count_Start = 1 then the start of the Algorithm_Instruction is stalled until the Wait_Time_Current is equal to the Wait_Time.[br]\r\n"
"Wait_Time_Current represent the current count value from when it was last reset either by a Test starting or Wait_Count_Clear.[br]\r\n"
"Wait_Time_Current is a free running counter that accurately reflects the time from when it was last reset by using the following formula.[br]\r\n"
"Time elapsed = Wait_Timer_Current * (1/(frequency selected by Count_Value_Frequency).[br]\r\n"
"If Wait_Count_Clear = 1 then prior to starting the current Algorithm_Instruction, Wait_Time_Current is reset tzero.[br]\r\n"
"Wait_Time_Current is frozen if a Test encounters any stop condition.[br]\r\n"
"Wait_Time_Current is reset to zer0 when a test starts (Start_Test is asserted)[br]\r\n"
"Wait_Time_Current rolls over at the maximum value back tzero.[br]\r\n"
"Wait_Clock_Frequency(1:0) set the frequency that increment Current_Repeat_Value. The possible frequencies that can be selected are the following.[br]\r\n"
"Wait_Clock_Frequency = 00 = 1GHz (time = 1ns)[br]\r\n"
"Wait_Clock_Frequency = 01 = 1MHZ (time = 1us)[br]\r\n"
"Wait_Clock_Frequency = 10 = 1KHZ (time = 1ms)[br]\r\n"
"Wait_Clock_Frequence = 11 = DUNIT clock"},
#else
{3, 3, 0x0000000000000000, "RW", "Wait_Count_Start", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{2, 2, 0x0000000000000000, "RW", "Wait_Count_Clear", "Reset the Wait Timer at the start of this Algorithm Instruction"},
#else
{2, 2, 0x0000000000000000, "RW", "Wait_Count_Clear", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{1, 1, 0x0000000000000000, "RW", "Base_Range_Row", "Instead of using the Base_Repeats setting, use Base_Col_Repeats setting for the size of the block for this instruction as the size of the block. This may be used for a rapid short test hitting all banks to open pages etc, or to initialize a row worth of data."},
#else
{1, 1, 0x0000000000000000, "RW", "Base_Range_Row", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 0, 0x0000000000000000, "RW", "FastY_Init", "FastY_Init is used to allow a background write initialization type algorithm to use FastY with Columns as the LSB address field to ensure the fastest initialization possible.[br]\r\n"
"^(wD1) is a the most typical background Init function.[br]\r\n"
"MEMTEL uses the keyword INIT() to reference this feature.[br]\r\n"
"FastY_Init enables the current Algortihm_Instruction to override the current Address_Instruction[].Address_Direction and Address_Order.[br]\r\n"
"If set, then use the Address_Direction=000 (FastY) and Address_Order=000 (Rank, Bank, Row/Col), else use the settings defined in the current Address_Instruction."},
#else
{0, 0, 0x0000000000000000, "RW", "FastY_Init", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo88[] = {{"CPGC2_ALGORITHM_INSTRUCTION_CTRL_0_", "", 0x00000034, 6, 0x000000000000003F, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields89[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{5, 5, 0x0000000000000000, "RW", "Deselect_On", "If set, the CADB will be able to issue harassment patterns into the command and address bus."},
#else
{5, 5, 0x0000000000000000, "RW", "Deselect_On", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{4, 4, 0x0000000000000000, "RW", "Wait_Event_Start", "Wait_Event_Start causes the delay in beginning the current Algorithm_Instruction until the Event indicated by Select_Event has been acknowledged to have occurred.[br]\r\n"
"The Select_Event is acknowledged to be in progress.[br]\r\n"
"The latency between the event and the acknowledgement must be a known fixed value (preventing a hang situation).[br]\r\n"
"The Current_Repeat_Value is reset tzero.[br]\r\n"
""},
#else
{4, 4, 0x0000000000000000, "RW", "Wait_Event_Start", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{3, 3, 0x0000000000000000, "RW", "Wait_Count_Start", "Wait_Count_Start and Wait_Time are used to synchronize a specific time an Algorithm should start.[br]\r\n"
"Wait_Time is commonly used for Pause Refresh test where the read to a particular address needs to be a specific time away from when the write to an address occurs.[br]\r\n"
"If Wait_Count_Start = 0 then the start of the Algorithm_Instruction is not stalled.[br]\r\n"
"If Wait_Count_Start = 1 then the start of the Algorithm_Instruction is stalled until the Wait_Time_Current is equal to the Wait_Time.[br]\r\n"
"Wait_Time_Current represent the current count value from when it was last reset either by a Test starting or Wait_Count_Clear.[br]\r\n"
"Wait_Time_Current is a free running counter that accurately reflects the time from when it was last reset by using the following formula.[br]\r\n"
"Time elapsed = Wait_Timer_Current * (1/(frequency selected by Count_Value_Frequency).[br]\r\n"
"If Wait_Count_Clear = 1 then prior to starting the current Algorithm_Instruction, Wait_Time_Current is reset tzero.[br]\r\n"
"Wait_Time_Current is frozen if a Test encounters any stop condition.[br]\r\n"
"Wait_Time_Current is reset to zer0 when a test starts (Start_Test is asserted)[br]\r\n"
"Wait_Time_Current rolls over at the maximum value back tzero.[br]\r\n"
"Wait_Clock_Frequency(1:0) set the frequency that increment Current_Repeat_Value. The possible frequencies that can be selected are the following.[br]\r\n"
"Wait_Clock_Frequency = 00 = 1GHz (time = 1ns)[br]\r\n"
"Wait_Clock_Frequency = 01 = 1MHZ (time = 1us)[br]\r\n"
"Wait_Clock_Frequency = 10 = 1KHZ (time = 1ms)[br]\r\n"
"Wait_Clock_Frequence = 11 = DUNIT clock"},
#else
{3, 3, 0x0000000000000000, "RW", "Wait_Count_Start", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{2, 2, 0x0000000000000000, "RW", "Wait_Count_Clear", "Reset the Wait Timer at the start of this Algorithm Instruction"},
#else
{2, 2, 0x0000000000000000, "RW", "Wait_Count_Clear", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{1, 1, 0x0000000000000000, "RW", "Base_Range_Row", "Instead of using the Base_Repeats setting, use Base_Col_Repeats setting for the size of the block for this instruction as the size of the block. This may be used for a rapid short test hitting all banks to open pages etc, or to initialize a row worth of data."},
#else
{1, 1, 0x0000000000000000, "RW", "Base_Range_Row", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 0, 0x0000000000000000, "RW", "FastY_Init", "FastY_Init is used to allow a background write initialization type algorithm to use FastY with Columns as the LSB address field to ensure the fastest initialization possible.[br]\r\n"
"^(wD1) is a the most typical background Init function.[br]\r\n"
"MEMTEL uses the keyword INIT() to reference this feature.[br]\r\n"
"FastY_Init enables the current Algortihm_Instruction to override the current Address_Instruction[].Address_Direction and Address_Order.[br]\r\n"
"If set, then use the Address_Direction=000 (FastY) and Address_Order=000 (Rank, Bank, Row/Col), else use the settings defined in the current Address_Instruction."},
#else
{0, 0, 0x0000000000000000, "RW", "FastY_Init", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo89[] = {{"CPGC2_ALGORITHM_INSTRUCTION_CTRL_1_", "", 0x00000035, 6, 0x000000000000003F, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields90[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{5, 5, 0x0000000000000000, "RW", "Deselect_On", "If set, the CADB will be able to issue harassment patterns into the command and address bus."},
#else
{5, 5, 0x0000000000000000, "RW", "Deselect_On", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{4, 4, 0x0000000000000000, "RW", "Wait_Event_Start", "Wait_Event_Start causes the delay in beginning the current Algorithm_Instruction until the Event indicated by Select_Event has been acknowledged to have occurred.[br]\r\n"
"The Select_Event is acknowledged to be in progress.[br]\r\n"
"The latency between the event and the acknowledgement must be a known fixed value (preventing a hang situation).[br]\r\n"
"The Current_Repeat_Value is reset tzero.[br]\r\n"
""},
#else
{4, 4, 0x0000000000000000, "RW", "Wait_Event_Start", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{3, 3, 0x0000000000000000, "RW", "Wait_Count_Start", "Wait_Count_Start and Wait_Time are used to synchronize a specific time an Algorithm should start.[br]\r\n"
"Wait_Time is commonly used for Pause Refresh test where the read to a particular address needs to be a specific time away from when the write to an address occurs.[br]\r\n"
"If Wait_Count_Start = 0 then the start of the Algorithm_Instruction is not stalled.[br]\r\n"
"If Wait_Count_Start = 1 then the start of the Algorithm_Instruction is stalled until the Wait_Time_Current is equal to the Wait_Time.[br]\r\n"
"Wait_Time_Current represent the current count value from when it was last reset either by a Test starting or Wait_Count_Clear.[br]\r\n"
"Wait_Time_Current is a free running counter that accurately reflects the time from when it was last reset by using the following formula.[br]\r\n"
"Time elapsed = Wait_Timer_Current * (1/(frequency selected by Count_Value_Frequency).[br]\r\n"
"If Wait_Count_Clear = 1 then prior to starting the current Algorithm_Instruction, Wait_Time_Current is reset tzero.[br]\r\n"
"Wait_Time_Current is frozen if a Test encounters any stop condition.[br]\r\n"
"Wait_Time_Current is reset to zer0 when a test starts (Start_Test is asserted)[br]\r\n"
"Wait_Time_Current rolls over at the maximum value back tzero.[br]\r\n"
"Wait_Clock_Frequency(1:0) set the frequency that increment Current_Repeat_Value. The possible frequencies that can be selected are the following.[br]\r\n"
"Wait_Clock_Frequency = 00 = 1GHz (time = 1ns)[br]\r\n"
"Wait_Clock_Frequency = 01 = 1MHZ (time = 1us)[br]\r\n"
"Wait_Clock_Frequency = 10 = 1KHZ (time = 1ms)[br]\r\n"
"Wait_Clock_Frequence = 11 = DUNIT clock"},
#else
{3, 3, 0x0000000000000000, "RW", "Wait_Count_Start", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{2, 2, 0x0000000000000000, "RW", "Wait_Count_Clear", "Reset the Wait Timer at the start of this Algorithm Instruction"},
#else
{2, 2, 0x0000000000000000, "RW", "Wait_Count_Clear", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{1, 1, 0x0000000000000000, "RW", "Base_Range_Row", "Instead of using the Base_Repeats setting, use Base_Col_Repeats setting for the size of the block for this instruction as the size of the block. This may be used for a rapid short test hitting all banks to open pages etc, or to initialize a row worth of data."},
#else
{1, 1, 0x0000000000000000, "RW", "Base_Range_Row", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 0, 0x0000000000000000, "RW", "FastY_Init", "FastY_Init is used to allow a background write initialization type algorithm to use FastY with Columns as the LSB address field to ensure the fastest initialization possible.[br]\r\n"
"^(wD1) is a the most typical background Init function.[br]\r\n"
"MEMTEL uses the keyword INIT() to reference this feature.[br]\r\n"
"FastY_Init enables the current Algortihm_Instruction to override the current Address_Instruction[].Address_Direction and Address_Order.[br]\r\n"
"If set, then use the Address_Direction=000 (FastY) and Address_Order=000 (Rank, Bank, Row/Col), else use the settings defined in the current Address_Instruction."},
#else
{0, 0, 0x0000000000000000, "RW", "FastY_Init", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo90[] = {{"CPGC2_ALGORITHM_INSTRUCTION_CTRL_2_", "", 0x00000036, 6, 0x000000000000003F, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields91[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{5, 5, 0x0000000000000000, "RW", "Deselect_On", "If set, the CADB will be able to issue harassment patterns into the command and address bus."},
#else
{5, 5, 0x0000000000000000, "RW", "Deselect_On", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{4, 4, 0x0000000000000000, "RW", "Wait_Event_Start", "Wait_Event_Start causes the delay in beginning the current Algorithm_Instruction until the Event indicated by Select_Event has been acknowledged to have occurred.[br]\r\n"
"The Select_Event is acknowledged to be in progress.[br]\r\n"
"The latency between the event and the acknowledgement must be a known fixed value (preventing a hang situation).[br]\r\n"
"The Current_Repeat_Value is reset tzero.[br]\r\n"
""},
#else
{4, 4, 0x0000000000000000, "RW", "Wait_Event_Start", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{3, 3, 0x0000000000000000, "RW", "Wait_Count_Start", "Wait_Count_Start and Wait_Time are used to synchronize a specific time an Algorithm should start.[br]\r\n"
"Wait_Time is commonly used for Pause Refresh test where the read to a particular address needs to be a specific time away from when the write to an address occurs.[br]\r\n"
"If Wait_Count_Start = 0 then the start of the Algorithm_Instruction is not stalled.[br]\r\n"
"If Wait_Count_Start = 1 then the start of the Algorithm_Instruction is stalled until the Wait_Time_Current is equal to the Wait_Time.[br]\r\n"
"Wait_Time_Current represent the current count value from when it was last reset either by a Test starting or Wait_Count_Clear.[br]\r\n"
"Wait_Time_Current is a free running counter that accurately reflects the time from when it was last reset by using the following formula.[br]\r\n"
"Time elapsed = Wait_Timer_Current * (1/(frequency selected by Count_Value_Frequency).[br]\r\n"
"If Wait_Count_Clear = 1 then prior to starting the current Algorithm_Instruction, Wait_Time_Current is reset tzero.[br]\r\n"
"Wait_Time_Current is frozen if a Test encounters any stop condition.[br]\r\n"
"Wait_Time_Current is reset to zer0 when a test starts (Start_Test is asserted)[br]\r\n"
"Wait_Time_Current rolls over at the maximum value back tzero.[br]\r\n"
"Wait_Clock_Frequency(1:0) set the frequency that increment Current_Repeat_Value. The possible frequencies that can be selected are the following.[br]\r\n"
"Wait_Clock_Frequency = 00 = 1GHz (time = 1ns)[br]\r\n"
"Wait_Clock_Frequency = 01 = 1MHZ (time = 1us)[br]\r\n"
"Wait_Clock_Frequency = 10 = 1KHZ (time = 1ms)[br]\r\n"
"Wait_Clock_Frequence = 11 = DUNIT clock"},
#else
{3, 3, 0x0000000000000000, "RW", "Wait_Count_Start", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{2, 2, 0x0000000000000000, "RW", "Wait_Count_Clear", "Reset the Wait Timer at the start of this Algorithm Instruction"},
#else
{2, 2, 0x0000000000000000, "RW", "Wait_Count_Clear", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{1, 1, 0x0000000000000000, "RW", "Base_Range_Row", "Instead of using the Base_Repeats setting, use Base_Col_Repeats setting for the size of the block for this instruction as the size of the block. This may be used for a rapid short test hitting all banks to open pages etc, or to initialize a row worth of data."},
#else
{1, 1, 0x0000000000000000, "RW", "Base_Range_Row", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 0, 0x0000000000000000, "RW", "FastY_Init", "FastY_Init is used to allow a background write initialization type algorithm to use FastY with Columns as the LSB address field to ensure the fastest initialization possible.[br]\r\n"
"^(wD1) is a the most typical background Init function.[br]\r\n"
"MEMTEL uses the keyword INIT() to reference this feature.[br]\r\n"
"FastY_Init enables the current Algortihm_Instruction to override the current Address_Instruction[].Address_Direction and Address_Order.[br]\r\n"
"If set, then use the Address_Direction=000 (FastY) and Address_Order=000 (Rank, Bank, Row/Col), else use the settings defined in the current Address_Instruction."},
#else
{0, 0, 0x0000000000000000, "RW", "FastY_Init", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo91[] = {{"CPGC2_ALGORITHM_INSTRUCTION_CTRL_3_", "", 0x00000037, 6, 0x000000000000003F, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields92[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{5, 5, 0x0000000000000000, "RW", "Deselect_On", "If set, the CADB will be able to issue harassment patterns into the command and address bus."},
#else
{5, 5, 0x0000000000000000, "RW", "Deselect_On", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{4, 4, 0x0000000000000000, "RW", "Wait_Event_Start", "Wait_Event_Start causes the delay in beginning the current Algorithm_Instruction until the Event indicated by Select_Event has been acknowledged to have occurred.[br]\r\n"
"The Select_Event is acknowledged to be in progress.[br]\r\n"
"The latency between the event and the acknowledgement must be a known fixed value (preventing a hang situation).[br]\r\n"
"The Current_Repeat_Value is reset tzero.[br]\r\n"
""},
#else
{4, 4, 0x0000000000000000, "RW", "Wait_Event_Start", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{3, 3, 0x0000000000000000, "RW", "Wait_Count_Start", "Wait_Count_Start and Wait_Time are used to synchronize a specific time an Algorithm should start.[br]\r\n"
"Wait_Time is commonly used for Pause Refresh test where the read to a particular address needs to be a specific time away from when the write to an address occurs.[br]\r\n"
"If Wait_Count_Start = 0 then the start of the Algorithm_Instruction is not stalled.[br]\r\n"
"If Wait_Count_Start = 1 then the start of the Algorithm_Instruction is stalled until the Wait_Time_Current is equal to the Wait_Time.[br]\r\n"
"Wait_Time_Current represent the current count value from when it was last reset either by a Test starting or Wait_Count_Clear.[br]\r\n"
"Wait_Time_Current is a free running counter that accurately reflects the time from when it was last reset by using the following formula.[br]\r\n"
"Time elapsed = Wait_Timer_Current * (1/(frequency selected by Count_Value_Frequency).[br]\r\n"
"If Wait_Count_Clear = 1 then prior to starting the current Algorithm_Instruction, Wait_Time_Current is reset tzero.[br]\r\n"
"Wait_Time_Current is frozen if a Test encounters any stop condition.[br]\r\n"
"Wait_Time_Current is reset to zer0 when a test starts (Start_Test is asserted)[br]\r\n"
"Wait_Time_Current rolls over at the maximum value back tzero.[br]\r\n"
"Wait_Clock_Frequency(1:0) set the frequency that increment Current_Repeat_Value. The possible frequencies that can be selected are the following.[br]\r\n"
"Wait_Clock_Frequency = 00 = 1GHz (time = 1ns)[br]\r\n"
"Wait_Clock_Frequency = 01 = 1MHZ (time = 1us)[br]\r\n"
"Wait_Clock_Frequency = 10 = 1KHZ (time = 1ms)[br]\r\n"
"Wait_Clock_Frequence = 11 = DUNIT clock"},
#else
{3, 3, 0x0000000000000000, "RW", "Wait_Count_Start", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{2, 2, 0x0000000000000000, "RW", "Wait_Count_Clear", "Reset the Wait Timer at the start of this Algorithm Instruction"},
#else
{2, 2, 0x0000000000000000, "RW", "Wait_Count_Clear", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{1, 1, 0x0000000000000000, "RW", "Base_Range_Row", "Instead of using the Base_Repeats setting, use Base_Col_Repeats setting for the size of the block for this instruction as the size of the block. This may be used for a rapid short test hitting all banks to open pages etc, or to initialize a row worth of data."},
#else
{1, 1, 0x0000000000000000, "RW", "Base_Range_Row", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 0, 0x0000000000000000, "RW", "FastY_Init", "FastY_Init is used to allow a background write initialization type algorithm to use FastY with Columns as the LSB address field to ensure the fastest initialization possible.[br]\r\n"
"^(wD1) is a the most typical background Init function.[br]\r\n"
"MEMTEL uses the keyword INIT() to reference this feature.[br]\r\n"
"FastY_Init enables the current Algortihm_Instruction to override the current Address_Instruction[].Address_Direction and Address_Order.[br]\r\n"
"If set, then use the Address_Direction=000 (FastY) and Address_Order=000 (Rank, Bank, Row/Col), else use the settings defined in the current Address_Instruction."},
#else
{0, 0, 0x0000000000000000, "RW", "FastY_Init", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo92[] = {{"CPGC2_ALGORITHM_INSTRUCTION_CTRL_4_", "", 0x00000038, 6, 0x000000000000003F, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields93[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{5, 5, 0x0000000000000000, "RW", "Deselect_On", "If set, the CADB will be able to issue harassment patterns into the command and address bus."},
#else
{5, 5, 0x0000000000000000, "RW", "Deselect_On", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{4, 4, 0x0000000000000000, "RW", "Wait_Event_Start", "Wait_Event_Start causes the delay in beginning the current Algorithm_Instruction until the Event indicated by Select_Event has been acknowledged to have occurred.[br]\r\n"
"The Select_Event is acknowledged to be in progress.[br]\r\n"
"The latency between the event and the acknowledgement must be a known fixed value (preventing a hang situation).[br]\r\n"
"The Current_Repeat_Value is reset tzero.[br]\r\n"
""},
#else
{4, 4, 0x0000000000000000, "RW", "Wait_Event_Start", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{3, 3, 0x0000000000000000, "RW", "Wait_Count_Start", "Wait_Count_Start and Wait_Time are used to synchronize a specific time an Algorithm should start.[br]\r\n"
"Wait_Time is commonly used for Pause Refresh test where the read to a particular address needs to be a specific time away from when the write to an address occurs.[br]\r\n"
"If Wait_Count_Start = 0 then the start of the Algorithm_Instruction is not stalled.[br]\r\n"
"If Wait_Count_Start = 1 then the start of the Algorithm_Instruction is stalled until the Wait_Time_Current is equal to the Wait_Time.[br]\r\n"
"Wait_Time_Current represent the current count value from when it was last reset either by a Test starting or Wait_Count_Clear.[br]\r\n"
"Wait_Time_Current is a free running counter that accurately reflects the time from when it was last reset by using the following formula.[br]\r\n"
"Time elapsed = Wait_Timer_Current * (1/(frequency selected by Count_Value_Frequency).[br]\r\n"
"If Wait_Count_Clear = 1 then prior to starting the current Algorithm_Instruction, Wait_Time_Current is reset tzero.[br]\r\n"
"Wait_Time_Current is frozen if a Test encounters any stop condition.[br]\r\n"
"Wait_Time_Current is reset to zer0 when a test starts (Start_Test is asserted)[br]\r\n"
"Wait_Time_Current rolls over at the maximum value back tzero.[br]\r\n"
"Wait_Clock_Frequency(1:0) set the frequency that increment Current_Repeat_Value. The possible frequencies that can be selected are the following.[br]\r\n"
"Wait_Clock_Frequency = 00 = 1GHz (time = 1ns)[br]\r\n"
"Wait_Clock_Frequency = 01 = 1MHZ (time = 1us)[br]\r\n"
"Wait_Clock_Frequency = 10 = 1KHZ (time = 1ms)[br]\r\n"
"Wait_Clock_Frequence = 11 = DUNIT clock"},
#else
{3, 3, 0x0000000000000000, "RW", "Wait_Count_Start", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{2, 2, 0x0000000000000000, "RW", "Wait_Count_Clear", "Reset the Wait Timer at the start of this Algorithm Instruction"},
#else
{2, 2, 0x0000000000000000, "RW", "Wait_Count_Clear", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{1, 1, 0x0000000000000000, "RW", "Base_Range_Row", "Instead of using the Base_Repeats setting, use Base_Col_Repeats setting for the size of the block for this instruction as the size of the block. This may be used for a rapid short test hitting all banks to open pages etc, or to initialize a row worth of data."},
#else
{1, 1, 0x0000000000000000, "RW", "Base_Range_Row", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 0, 0x0000000000000000, "RW", "FastY_Init", "FastY_Init is used to allow a background write initialization type algorithm to use FastY with Columns as the LSB address field to ensure the fastest initialization possible.[br]\r\n"
"^(wD1) is a the most typical background Init function.[br]\r\n"
"MEMTEL uses the keyword INIT() to reference this feature.[br]\r\n"
"FastY_Init enables the current Algortihm_Instruction to override the current Address_Instruction[].Address_Direction and Address_Order.[br]\r\n"
"If set, then use the Address_Direction=000 (FastY) and Address_Order=000 (Rank, Bank, Row/Col), else use the settings defined in the current Address_Instruction."},
#else
{0, 0, 0x0000000000000000, "RW", "FastY_Init", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo93[] = {{"CPGC2_ALGORITHM_INSTRUCTION_CTRL_5_", "", 0x00000039, 6, 0x000000000000003F, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields94[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{5, 5, 0x0000000000000000, "RW", "Deselect_On", "If set, the CADB will be able to issue harassment patterns into the command and address bus."},
#else
{5, 5, 0x0000000000000000, "RW", "Deselect_On", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{4, 4, 0x0000000000000000, "RW", "Wait_Event_Start", "Wait_Event_Start causes the delay in beginning the current Algorithm_Instruction until the Event indicated by Select_Event has been acknowledged to have occurred.[br]\r\n"
"The Select_Event is acknowledged to be in progress.[br]\r\n"
"The latency between the event and the acknowledgement must be a known fixed value (preventing a hang situation).[br]\r\n"
"The Current_Repeat_Value is reset tzero.[br]\r\n"
""},
#else
{4, 4, 0x0000000000000000, "RW", "Wait_Event_Start", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{3, 3, 0x0000000000000000, "RW", "Wait_Count_Start", "Wait_Count_Start and Wait_Time are used to synchronize a specific time an Algorithm should start.[br]\r\n"
"Wait_Time is commonly used for Pause Refresh test where the read to a particular address needs to be a specific time away from when the write to an address occurs.[br]\r\n"
"If Wait_Count_Start = 0 then the start of the Algorithm_Instruction is not stalled.[br]\r\n"
"If Wait_Count_Start = 1 then the start of the Algorithm_Instruction is stalled until the Wait_Time_Current is equal to the Wait_Time.[br]\r\n"
"Wait_Time_Current represent the current count value from when it was last reset either by a Test starting or Wait_Count_Clear.[br]\r\n"
"Wait_Time_Current is a free running counter that accurately reflects the time from when it was last reset by using the following formula.[br]\r\n"
"Time elapsed = Wait_Timer_Current * (1/(frequency selected by Count_Value_Frequency).[br]\r\n"
"If Wait_Count_Clear = 1 then prior to starting the current Algorithm_Instruction, Wait_Time_Current is reset tzero.[br]\r\n"
"Wait_Time_Current is frozen if a Test encounters any stop condition.[br]\r\n"
"Wait_Time_Current is reset to zer0 when a test starts (Start_Test is asserted)[br]\r\n"
"Wait_Time_Current rolls over at the maximum value back tzero.[br]\r\n"
"Wait_Clock_Frequency(1:0) set the frequency that increment Current_Repeat_Value. The possible frequencies that can be selected are the following.[br]\r\n"
"Wait_Clock_Frequency = 00 = 1GHz (time = 1ns)[br]\r\n"
"Wait_Clock_Frequency = 01 = 1MHZ (time = 1us)[br]\r\n"
"Wait_Clock_Frequency = 10 = 1KHZ (time = 1ms)[br]\r\n"
"Wait_Clock_Frequence = 11 = DUNIT clock"},
#else
{3, 3, 0x0000000000000000, "RW", "Wait_Count_Start", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{2, 2, 0x0000000000000000, "RW", "Wait_Count_Clear", "Reset the Wait Timer at the start of this Algorithm Instruction"},
#else
{2, 2, 0x0000000000000000, "RW", "Wait_Count_Clear", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{1, 1, 0x0000000000000000, "RW", "Base_Range_Row", "Instead of using the Base_Repeats setting, use Base_Col_Repeats setting for the size of the block for this instruction as the size of the block. This may be used for a rapid short test hitting all banks to open pages etc, or to initialize a row worth of data."},
#else
{1, 1, 0x0000000000000000, "RW", "Base_Range_Row", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 0, 0x0000000000000000, "RW", "FastY_Init", "FastY_Init is used to allow a background write initialization type algorithm to use FastY with Columns as the LSB address field to ensure the fastest initialization possible.[br]\r\n"
"^(wD1) is a the most typical background Init function.[br]\r\n"
"MEMTEL uses the keyword INIT() to reference this feature.[br]\r\n"
"FastY_Init enables the current Algortihm_Instruction to override the current Address_Instruction[].Address_Direction and Address_Order.[br]\r\n"
"If set, then use the Address_Direction=000 (FastY) and Address_Order=000 (Rank, Bank, Row/Col), else use the settings defined in the current Address_Instruction."},
#else
{0, 0, 0x0000000000000000, "RW", "FastY_Init", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo94[] = {{"CPGC2_ALGORITHM_INSTRUCTION_CTRL_6_", "", 0x0000003A, 6, 0x000000000000003F, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields95[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{5, 5, 0x0000000000000000, "RW", "Deselect_On", "If set, the CADB will be able to issue harassment patterns into the command and address bus."},
#else
{5, 5, 0x0000000000000000, "RW", "Deselect_On", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{4, 4, 0x0000000000000000, "RW", "Wait_Event_Start", "Wait_Event_Start causes the delay in beginning the current Algorithm_Instruction until the Event indicated by Select_Event has been acknowledged to have occurred.[br]\r\n"
"The Select_Event is acknowledged to be in progress.[br]\r\n"
"The latency between the event and the acknowledgement must be a known fixed value (preventing a hang situation).[br]\r\n"
"The Current_Repeat_Value is reset tzero.[br]\r\n"
""},
#else
{4, 4, 0x0000000000000000, "RW", "Wait_Event_Start", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{3, 3, 0x0000000000000000, "RW", "Wait_Count_Start", "Wait_Count_Start and Wait_Time are used to synchronize a specific time an Algorithm should start.[br]\r\n"
"Wait_Time is commonly used for Pause Refresh test where the read to a particular address needs to be a specific time away from when the write to an address occurs.[br]\r\n"
"If Wait_Count_Start = 0 then the start of the Algorithm_Instruction is not stalled.[br]\r\n"
"If Wait_Count_Start = 1 then the start of the Algorithm_Instruction is stalled until the Wait_Time_Current is equal to the Wait_Time.[br]\r\n"
"Wait_Time_Current represent the current count value from when it was last reset either by a Test starting or Wait_Count_Clear.[br]\r\n"
"Wait_Time_Current is a free running counter that accurately reflects the time from when it was last reset by using the following formula.[br]\r\n"
"Time elapsed = Wait_Timer_Current * (1/(frequency selected by Count_Value_Frequency).[br]\r\n"
"If Wait_Count_Clear = 1 then prior to starting the current Algorithm_Instruction, Wait_Time_Current is reset tzero.[br]\r\n"
"Wait_Time_Current is frozen if a Test encounters any stop condition.[br]\r\n"
"Wait_Time_Current is reset to zer0 when a test starts (Start_Test is asserted)[br]\r\n"
"Wait_Time_Current rolls over at the maximum value back tzero.[br]\r\n"
"Wait_Clock_Frequency(1:0) set the frequency that increment Current_Repeat_Value. The possible frequencies that can be selected are the following.[br]\r\n"
"Wait_Clock_Frequency = 00 = 1GHz (time = 1ns)[br]\r\n"
"Wait_Clock_Frequency = 01 = 1MHZ (time = 1us)[br]\r\n"
"Wait_Clock_Frequency = 10 = 1KHZ (time = 1ms)[br]\r\n"
"Wait_Clock_Frequence = 11 = DUNIT clock"},
#else
{3, 3, 0x0000000000000000, "RW", "Wait_Count_Start", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{2, 2, 0x0000000000000000, "RW", "Wait_Count_Clear", "Reset the Wait Timer at the start of this Algorithm Instruction"},
#else
{2, 2, 0x0000000000000000, "RW", "Wait_Count_Clear", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{1, 1, 0x0000000000000000, "RW", "Base_Range_Row", "Instead of using the Base_Repeats setting, use Base_Col_Repeats setting for the size of the block for this instruction as the size of the block. This may be used for a rapid short test hitting all banks to open pages etc, or to initialize a row worth of data."},
#else
{1, 1, 0x0000000000000000, "RW", "Base_Range_Row", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 0, 0x0000000000000000, "RW", "FastY_Init", "FastY_Init is used to allow a background write initialization type algorithm to use FastY with Columns as the LSB address field to ensure the fastest initialization possible.[br]\r\n"
"^(wD1) is a the most typical background Init function.[br]\r\n"
"MEMTEL uses the keyword INIT() to reference this feature.[br]\r\n"
"FastY_Init enables the current Algortihm_Instruction to override the current Address_Instruction[].Address_Direction and Address_Order.[br]\r\n"
"If set, then use the Address_Direction=000 (FastY) and Address_Order=000 (Rank, Bank, Row/Col), else use the settings defined in the current Address_Instruction."},
#else
{0, 0, 0x0000000000000000, "RW", "FastY_Init", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo95[] = {{"CPGC2_ALGORITHM_INSTRUCTION_CTRL_7_", "", 0x0000003B, 6, 0x000000000000003F, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields96[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{0, 15, 0x0000000000000000, "RW/1C/V", "Wait_Timer_Current", "Current wait timer value. See Wait_Time description. (down count)"},
#else
{0, 15, 0x0000000000000000, "RW/1C/V", "Wait_Timer_Current", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo96[] = {{"CPGC2_ALGORITHM_WAIT_COUNT_CURRENT", "", 0x0000003C, 1, 0x000000000000FFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields97[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{30, 31, 0x0000000000000000, "RW", "Select_Event", "Select_Event is decoded in the following ways.[br]\r\n"
"Select_Event = 00 = Read/Write Pending CAS cue is empty[br]\r\n"
"Select_Event = 01 = CKE Power Down[br]\r\n"
"Select_Event = 10 = Refresh[br]\r\n"
"Select_Event = 11 = Self Refresh"},
#else
{30, 31, 0x0000000000000000, "RW", "Select_Event", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{24, 25, 0x0000000000000000, "RW", "Wait_Clock_Frequency", "00 - 1GHz[br]\r\n"
"01 - 1MHz[br]\r\n"
"10 - 1KHz[br]\r\n"
"11 - Native DUNIT clock"},
#else
{24, 25, 0x0000000000000000, "RW", "Wait_Clock_Frequency", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 15, 0x0000000000000000, "RW", "Wait_Time", "Number of clocks at Wait_Clock_Frequency to wait before starting current Algorithm_Instruction if Wait_Start = 1."},
#else
{0, 15, 0x0000000000000000, "RW", "Wait_Time", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo97[] = {{"CPGC2_ALGORITHM_WAIT_EVENT_CONTROL", "", 0x00000040, 3, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields98[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{0, 31, 0x0000000000000000, "RW", "Base_Repeats", "Base_Address_Loopcount - Typically the number of Base Addresses within the Block (Row*Col*Bank*Rank) As N-1 value."},
#else
{0, 31, 0x0000000000000000, "RW", "Base_Repeats", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo98[] = {{"CPGC2_BASE_REPEATS", "", 0x00000044, 1, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields99[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{0, 31, 0x0000000000000000, "RO/V", "Base_Repeats_Current", "Current_Base_Address_Loopcount (down count)"},
#else
{0, 31, 0x0000000000000000, "RO/V", "Base_Repeats_Current", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo99[] = {{"CPGC2_BASE_REPEATS_CURRENT", "", 0x00000048, 1, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields100[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{0, 31, 0x0000000000000000, "RW", "Base_Col_Repeats", "Modified Base_Address_Loopcount. Often used to initialze a Row or Column worth of data. [br] This is used when Base_Range_Row field of ALGORITHM_INSTRUCTION_CTL is activated."},
#else
{0, 31, 0x0000000000000000, "RW", "Base_Col_Repeats", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo100[] = {{"CPGC2_BASE_COL_REPEATS", "", 0x0000004C, 1, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields101[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{0, 31, 0x0000000000000000, "RW", "Block_Repeats", "Block_Loopcount - Typically the number of Blocks to be tested to traverse the entire Tested Region. (2^region_size/2^block_size -1) As N-1 value."},
#else
{0, 31, 0x0000000000000000, "RW", "Block_Repeats", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo101[] = {{"CPGC2_BLOCK_REPEATS", "", 0x00000050, 1, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields102[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{0, 31, 0x0000000000000000, "RO/V", "Block_Repeats_Current", "Current_Block_Loopcount (down count)"},
#else
{0, 31, 0x0000000000000000, "RO/V", "Block_Repeats_Current", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo102[] = {{"CPGC2_BLOCK_REPEATS_CURRENT", "", 0x00000054, 1, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields103[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{7, 7, 0x0000000000000000, "RW", "Last", "Last Command_Instruction.  Execution continues at the Command_Instruction pointed to by the Algorithm_Instruction's Command_Start_Pointer until the end of the Algorithm_Instruction."},
#else
{7, 7, 0x0000000000000000, "RW", "Last", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{6, 6, 0x0000000000000000, "RW", "Invert_Data", "Invert the data used for this command. This is combined with the Algorithm_Instruction and Data_Instruction Invert_Data bits for Base accesses. For Offset accesses, it is further combined with the Offset_Command Invert_Data bit."},
#else
{6, 6, 0x0000000000000000, "RW", "Invert_Data", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{5, 5, 0x0000000000000000, "RW", "Address_Decode_or_PRBS_En", "Enable rotating XOR of address bits or PRBS address generation. If the Address_Decode_Enable field in the Address_Instruction list is active, and [name] is also active, then for the access of this Command_Instruction, the address will be XOR with the XOR_Address_Pattern.[br]\r\n"
"If the Address_Decode_Enable field in the Address_Instruction list is inactive (0), and the Address_PRBS_Enable bit in the Address_PRBS_Control register is set, then the desired address bits will be replaced with the PRBS generated value.[br]\r\n"
"If the "},
#else
{5, 5, 0x0000000000000000, "RW", "Address_Decode_or_PRBS_En", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{4, 4, 0x0000000000000000, "RW", "Alternate_Data", "Use the alternate zero data source instead of the UniSequencers and Pattern_Select."},
#else
{4, 4, 0x0000000000000000, "RW", "Alternate_Data", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{3, 3, 0x0000000000000000, "RW", "Hammer", "This Base command will be repeated Hammer_Repeats times"},
#else
{3, 3, 0x0000000000000000, "RW", "Hammer", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{2, 2, 0x0000000000000000, "RW", "Offset", "If set, this is an Offset operation, and the selected Offset_Group will be executed in its place. In this case the Write, Hammer, and Alternate_Data fields are ignored."},
#else
{2, 2, 0x0000000000000000, "RW", "Offset", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{1, 1, 0x0000000000000000, "RW", "Offset_Group", "Selects which Offset_Group will be used if Offset field is set."},
#else
{1, 1, 0x0000000000000000, "RW", "Offset_Group", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 0, 0x0000000000000000, "RW", "Write", "A Base Write operation will be performed"},
#else
{0, 0, 0x0000000000000000, "RW", "Write", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo103[] = {{"CPGC2_COMMAND_INSTRUCTION_0_", "", 0x00000058, 8, 0x00000000000000FF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields104[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{7, 7, 0x0000000000000000, "RW", "Last", "Last Command_Instruction.  Execution continues at the Command_Instruction pointed to by the Algorithm_Instruction's Command_Start_Pointer until the end of the Algorithm_Instruction."},
#else
{7, 7, 0x0000000000000000, "RW", "Last", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{6, 6, 0x0000000000000000, "RW", "Invert_Data", "Invert the data used for this command. This is combined with the Algorithm_Instruction and Data_Instruction Invert_Data bits for Base accesses. For Offset accesses, it is further combined with the Offset_Command Invert_Data bit."},
#else
{6, 6, 0x0000000000000000, "RW", "Invert_Data", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{5, 5, 0x0000000000000000, "RW", "Address_Decode_or_PRBS_En", "Enable rotating XOR of address bits or PRBS address generation. If the Address_Decode_Enable field in the Address_Instruction list is active, and [name] is also active, then for the access of this Command_Instruction, the address will be XOR with the XOR_Address_Pattern.[br]\r\n"
"If the Address_Decode_Enable field in the Address_Instruction list is inactive (0), and the Address_PRBS_Enable bit in the Address_PRBS_Control register is set, then the desired address bits will be replaced with the PRBS generated value.[br]\r\n"
"If the "},
#else
{5, 5, 0x0000000000000000, "RW", "Address_Decode_or_PRBS_En", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{4, 4, 0x0000000000000000, "RW", "Alternate_Data", "Use the alternate zero data source instead of the UniSequencers and Pattern_Select."},
#else
{4, 4, 0x0000000000000000, "RW", "Alternate_Data", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{3, 3, 0x0000000000000000, "RW", "Hammer", "This Base command will be repeated Hammer_Repeats times"},
#else
{3, 3, 0x0000000000000000, "RW", "Hammer", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{2, 2, 0x0000000000000000, "RW", "Offset", "If set, this is an Offset operation, and the selected Offset_Group will be executed in its place. In this case the Write, Hammer, and Alternate_Data fields are ignored."},
#else
{2, 2, 0x0000000000000000, "RW", "Offset", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{1, 1, 0x0000000000000000, "RW", "Offset_Group", "Selects which Offset_Group will be used if Offset field is set."},
#else
{1, 1, 0x0000000000000000, "RW", "Offset_Group", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 0, 0x0000000000000000, "RW", "Write", "A Base Write operation will be performed"},
#else
{0, 0, 0x0000000000000000, "RW", "Write", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo104[] = {{"CPGC2_COMMAND_INSTRUCTION_1_", "", 0x00000059, 8, 0x00000000000000FF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields105[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{7, 7, 0x0000000000000000, "RW", "Last", "Last Command_Instruction.  Execution continues at the Command_Instruction pointed to by the Algorithm_Instruction's Command_Start_Pointer until the end of the Algorithm_Instruction."},
#else
{7, 7, 0x0000000000000000, "RW", "Last", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{6, 6, 0x0000000000000000, "RW", "Invert_Data", "Invert the data used for this command. This is combined with the Algorithm_Instruction and Data_Instruction Invert_Data bits for Base accesses. For Offset accesses, it is further combined with the Offset_Command Invert_Data bit."},
#else
{6, 6, 0x0000000000000000, "RW", "Invert_Data", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{5, 5, 0x0000000000000000, "RW", "Address_Decode_or_PRBS_En", "Enable rotating XOR of address bits or PRBS address generation. If the Address_Decode_Enable field in the Address_Instruction list is active, and [name] is also active, then for the access of this Command_Instruction, the address will be XOR with the XOR_Address_Pattern.[br]\r\n"
"If the Address_Decode_Enable field in the Address_Instruction list is inactive (0), and the Address_PRBS_Enable bit in the Address_PRBS_Control register is set, then the desired address bits will be replaced with the PRBS generated value.[br]\r\n"
"If the "},
#else
{5, 5, 0x0000000000000000, "RW", "Address_Decode_or_PRBS_En", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{4, 4, 0x0000000000000000, "RW", "Alternate_Data", "Use the alternate zero data source instead of the UniSequencers and Pattern_Select."},
#else
{4, 4, 0x0000000000000000, "RW", "Alternate_Data", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{3, 3, 0x0000000000000000, "RW", "Hammer", "This Base command will be repeated Hammer_Repeats times"},
#else
{3, 3, 0x0000000000000000, "RW", "Hammer", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{2, 2, 0x0000000000000000, "RW", "Offset", "If set, this is an Offset operation, and the selected Offset_Group will be executed in its place. In this case the Write, Hammer, and Alternate_Data fields are ignored."},
#else
{2, 2, 0x0000000000000000, "RW", "Offset", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{1, 1, 0x0000000000000000, "RW", "Offset_Group", "Selects which Offset_Group will be used if Offset field is set."},
#else
{1, 1, 0x0000000000000000, "RW", "Offset_Group", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 0, 0x0000000000000000, "RW", "Write", "A Base Write operation will be performed"},
#else
{0, 0, 0x0000000000000000, "RW", "Write", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo105[] = {{"CPGC2_COMMAND_INSTRUCTION_2_", "", 0x0000005A, 8, 0x00000000000000FF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields106[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{7, 7, 0x0000000000000000, "RW", "Last", "Last Command_Instruction.  Execution continues at the Command_Instruction pointed to by the Algorithm_Instruction's Command_Start_Pointer until the end of the Algorithm_Instruction."},
#else
{7, 7, 0x0000000000000000, "RW", "Last", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{6, 6, 0x0000000000000000, "RW", "Invert_Data", "Invert the data used for this command. This is combined with the Algorithm_Instruction and Data_Instruction Invert_Data bits for Base accesses. For Offset accesses, it is further combined with the Offset_Command Invert_Data bit."},
#else
{6, 6, 0x0000000000000000, "RW", "Invert_Data", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{5, 5, 0x0000000000000000, "RW", "Address_Decode_or_PRBS_En", "Enable rotating XOR of address bits or PRBS address generation. If the Address_Decode_Enable field in the Address_Instruction list is active, and [name] is also active, then for the access of this Command_Instruction, the address will be XOR with the XOR_Address_Pattern.[br]\r\n"
"If the Address_Decode_Enable field in the Address_Instruction list is inactive (0), and the Address_PRBS_Enable bit in the Address_PRBS_Control register is set, then the desired address bits will be replaced with the PRBS generated value.[br]\r\n"
"If the "},
#else
{5, 5, 0x0000000000000000, "RW", "Address_Decode_or_PRBS_En", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{4, 4, 0x0000000000000000, "RW", "Alternate_Data", "Use the alternate zero data source instead of the UniSequencers and Pattern_Select."},
#else
{4, 4, 0x0000000000000000, "RW", "Alternate_Data", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{3, 3, 0x0000000000000000, "RW", "Hammer", "This Base command will be repeated Hammer_Repeats times"},
#else
{3, 3, 0x0000000000000000, "RW", "Hammer", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{2, 2, 0x0000000000000000, "RW", "Offset", "If set, this is an Offset operation, and the selected Offset_Group will be executed in its place. In this case the Write, Hammer, and Alternate_Data fields are ignored."},
#else
{2, 2, 0x0000000000000000, "RW", "Offset", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{1, 1, 0x0000000000000000, "RW", "Offset_Group", "Selects which Offset_Group will be used if Offset field is set."},
#else
{1, 1, 0x0000000000000000, "RW", "Offset_Group", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 0, 0x0000000000000000, "RW", "Write", "A Base Write operation will be performed"},
#else
{0, 0, 0x0000000000000000, "RW", "Write", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo106[] = {{"CPGC2_COMMAND_INSTRUCTION_3_", "", 0x0000005B, 8, 0x00000000000000FF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields107[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{7, 7, 0x0000000000000000, "RW", "Last", "Last Command_Instruction.  Execution continues at the Command_Instruction pointed to by the Algorithm_Instruction's Command_Start_Pointer until the end of the Algorithm_Instruction."},
#else
{7, 7, 0x0000000000000000, "RW", "Last", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{6, 6, 0x0000000000000000, "RW", "Invert_Data", "Invert the data used for this command. This is combined with the Algorithm_Instruction and Data_Instruction Invert_Data bits for Base accesses. For Offset accesses, it is further combined with the Offset_Command Invert_Data bit."},
#else
{6, 6, 0x0000000000000000, "RW", "Invert_Data", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{5, 5, 0x0000000000000000, "RW", "Address_Decode_or_PRBS_En", "Enable rotating XOR of address bits or PRBS address generation. If the Address_Decode_Enable field in the Address_Instruction list is active, and [name] is also active, then for the access of this Command_Instruction, the address will be XOR with the XOR_Address_Pattern.[br]\r\n"
"If the Address_Decode_Enable field in the Address_Instruction list is inactive (0), and the Address_PRBS_Enable bit in the Address_PRBS_Control register is set, then the desired address bits will be replaced with the PRBS generated value.[br]\r\n"
"If the "},
#else
{5, 5, 0x0000000000000000, "RW", "Address_Decode_or_PRBS_En", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{4, 4, 0x0000000000000000, "RW", "Alternate_Data", "Use the alternate zero data source instead of the UniSequencers and Pattern_Select."},
#else
{4, 4, 0x0000000000000000, "RW", "Alternate_Data", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{3, 3, 0x0000000000000000, "RW", "Hammer", "This Base command will be repeated Hammer_Repeats times"},
#else
{3, 3, 0x0000000000000000, "RW", "Hammer", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{2, 2, 0x0000000000000000, "RW", "Offset", "If set, this is an Offset operation, and the selected Offset_Group will be executed in its place. In this case the Write, Hammer, and Alternate_Data fields are ignored."},
#else
{2, 2, 0x0000000000000000, "RW", "Offset", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{1, 1, 0x0000000000000000, "RW", "Offset_Group", "Selects which Offset_Group will be used if Offset field is set."},
#else
{1, 1, 0x0000000000000000, "RW", "Offset_Group", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 0, 0x0000000000000000, "RW", "Write", "A Base Write operation will be performed"},
#else
{0, 0, 0x0000000000000000, "RW", "Write", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo107[] = {{"CPGC2_COMMAND_INSTRUCTION_4_", "", 0x0000005C, 8, 0x00000000000000FF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields108[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{7, 7, 0x0000000000000000, "RW", "Last", "Last Command_Instruction.  Execution continues at the Command_Instruction pointed to by the Algorithm_Instruction's Command_Start_Pointer until the end of the Algorithm_Instruction."},
#else
{7, 7, 0x0000000000000000, "RW", "Last", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{6, 6, 0x0000000000000000, "RW", "Invert_Data", "Invert the data used for this command. This is combined with the Algorithm_Instruction and Data_Instruction Invert_Data bits for Base accesses. For Offset accesses, it is further combined with the Offset_Command Invert_Data bit."},
#else
{6, 6, 0x0000000000000000, "RW", "Invert_Data", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{5, 5, 0x0000000000000000, "RW", "Address_Decode_or_PRBS_En", "Enable rotating XOR of address bits or PRBS address generation. If the Address_Decode_Enable field in the Address_Instruction list is active, and [name] is also active, then for the access of this Command_Instruction, the address will be XOR with the XOR_Address_Pattern.[br]\r\n"
"If the Address_Decode_Enable field in the Address_Instruction list is inactive (0), and the Address_PRBS_Enable bit in the Address_PRBS_Control register is set, then the desired address bits will be replaced with the PRBS generated value.[br]\r\n"
"If the "},
#else
{5, 5, 0x0000000000000000, "RW", "Address_Decode_or_PRBS_En", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{4, 4, 0x0000000000000000, "RW", "Alternate_Data", "Use the alternate zero data source instead of the UniSequencers and Pattern_Select."},
#else
{4, 4, 0x0000000000000000, "RW", "Alternate_Data", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{3, 3, 0x0000000000000000, "RW", "Hammer", "This Base command will be repeated Hammer_Repeats times"},
#else
{3, 3, 0x0000000000000000, "RW", "Hammer", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{2, 2, 0x0000000000000000, "RW", "Offset", "If set, this is an Offset operation, and the selected Offset_Group will be executed in its place. In this case the Write, Hammer, and Alternate_Data fields are ignored."},
#else
{2, 2, 0x0000000000000000, "RW", "Offset", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{1, 1, 0x0000000000000000, "RW", "Offset_Group", "Selects which Offset_Group will be used if Offset field is set."},
#else
{1, 1, 0x0000000000000000, "RW", "Offset_Group", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 0, 0x0000000000000000, "RW", "Write", "A Base Write operation will be performed"},
#else
{0, 0, 0x0000000000000000, "RW", "Write", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo108[] = {{"CPGC2_COMMAND_INSTRUCTION_5_", "", 0x0000005D, 8, 0x00000000000000FF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields109[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{7, 7, 0x0000000000000000, "RW", "Last", "Last Command_Instruction.  Execution continues at the Command_Instruction pointed to by the Algorithm_Instruction's Command_Start_Pointer until the end of the Algorithm_Instruction."},
#else
{7, 7, 0x0000000000000000, "RW", "Last", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{6, 6, 0x0000000000000000, "RW", "Invert_Data", "Invert the data used for this command. This is combined with the Algorithm_Instruction and Data_Instruction Invert_Data bits for Base accesses. For Offset accesses, it is further combined with the Offset_Command Invert_Data bit."},
#else
{6, 6, 0x0000000000000000, "RW", "Invert_Data", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{5, 5, 0x0000000000000000, "RW", "Address_Decode_or_PRBS_En", "Enable rotating XOR of address bits or PRBS address generation. If the Address_Decode_Enable field in the Address_Instruction list is active, and [name] is also active, then for the access of this Command_Instruction, the address will be XOR with the XOR_Address_Pattern.[br]\r\n"
"If the Address_Decode_Enable field in the Address_Instruction list is inactive (0), and the Address_PRBS_Enable bit in the Address_PRBS_Control register is set, then the desired address bits will be replaced with the PRBS generated value.[br]\r\n"
"If the "},
#else
{5, 5, 0x0000000000000000, "RW", "Address_Decode_or_PRBS_En", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{4, 4, 0x0000000000000000, "RW", "Alternate_Data", "Use the alternate zero data source instead of the UniSequencers and Pattern_Select."},
#else
{4, 4, 0x0000000000000000, "RW", "Alternate_Data", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{3, 3, 0x0000000000000000, "RW", "Hammer", "This Base command will be repeated Hammer_Repeats times"},
#else
{3, 3, 0x0000000000000000, "RW", "Hammer", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{2, 2, 0x0000000000000000, "RW", "Offset", "If set, this is an Offset operation, and the selected Offset_Group will be executed in its place. In this case the Write, Hammer, and Alternate_Data fields are ignored."},
#else
{2, 2, 0x0000000000000000, "RW", "Offset", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{1, 1, 0x0000000000000000, "RW", "Offset_Group", "Selects which Offset_Group will be used if Offset field is set."},
#else
{1, 1, 0x0000000000000000, "RW", "Offset_Group", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 0, 0x0000000000000000, "RW", "Write", "A Base Write operation will be performed"},
#else
{0, 0, 0x0000000000000000, "RW", "Write", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo109[] = {{"CPGC2_COMMAND_INSTRUCTION_6_", "", 0x0000005E, 8, 0x00000000000000FF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields110[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{7, 7, 0x0000000000000000, "RW", "Last", "Last Command_Instruction.  Execution continues at the Command_Instruction pointed to by the Algorithm_Instruction's Command_Start_Pointer until the end of the Algorithm_Instruction."},
#else
{7, 7, 0x0000000000000000, "RW", "Last", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{6, 6, 0x0000000000000000, "RW", "Invert_Data", "Invert the data used for this command. This is combined with the Algorithm_Instruction and Data_Instruction Invert_Data bits for Base accesses. For Offset accesses, it is further combined with the Offset_Command Invert_Data bit."},
#else
{6, 6, 0x0000000000000000, "RW", "Invert_Data", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{5, 5, 0x0000000000000000, "RW", "Address_Decode_or_PRBS_En", "Enable rotating XOR of address bits or PRBS address generation. If the Address_Decode_Enable field in the Address_Instruction list is active, and [name] is also active, then for the access of this Command_Instruction, the address will be XOR with the XOR_Address_Pattern.[br]\r\n"
"If the Address_Decode_Enable field in the Address_Instruction list is inactive (0), and the Address_PRBS_Enable bit in the Address_PRBS_Control register is set, then the desired address bits will be replaced with the PRBS generated value.[br]\r\n"
"If the "},
#else
{5, 5, 0x0000000000000000, "RW", "Address_Decode_or_PRBS_En", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{4, 4, 0x0000000000000000, "RW", "Alternate_Data", "Use the alternate zero data source instead of the UniSequencers and Pattern_Select."},
#else
{4, 4, 0x0000000000000000, "RW", "Alternate_Data", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{3, 3, 0x0000000000000000, "RW", "Hammer", "This Base command will be repeated Hammer_Repeats times"},
#else
{3, 3, 0x0000000000000000, "RW", "Hammer", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{2, 2, 0x0000000000000000, "RW", "Offset", "If set, this is an Offset operation, and the selected Offset_Group will be executed in its place. In this case the Write, Hammer, and Alternate_Data fields are ignored."},
#else
{2, 2, 0x0000000000000000, "RW", "Offset", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{1, 1, 0x0000000000000000, "RW", "Offset_Group", "Selects which Offset_Group will be used if Offset field is set."},
#else
{1, 1, 0x0000000000000000, "RW", "Offset_Group", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 0, 0x0000000000000000, "RW", "Write", "A Base Write operation will be performed"},
#else
{0, 0, 0x0000000000000000, "RW", "Write", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo110[] = {{"CPGC2_COMMAND_INSTRUCTION_7_", "", 0x0000005F, 8, 0x00000000000000FF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields111[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{7, 7, 0x0000000000000000, "RW", "Last", "Last Command_Instruction.  Execution continues at the Command_Instruction pointed to by the Algorithm_Instruction's Command_Start_Pointer until the end of the Algorithm_Instruction."},
#else
{7, 7, 0x0000000000000000, "RW", "Last", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{6, 6, 0x0000000000000000, "RW", "Invert_Data", "Invert the data used for this command. This is combined with the Algorithm_Instruction and Data_Instruction Invert_Data bits for Base accesses. For Offset accesses, it is further combined with the Offset_Command Invert_Data bit."},
#else
{6, 6, 0x0000000000000000, "RW", "Invert_Data", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{5, 5, 0x0000000000000000, "RW", "Address_Decode_or_PRBS_En", "Enable rotating XOR of address bits or PRBS address generation. If the Address_Decode_Enable field in the Address_Instruction list is active, and [name] is also active, then for the access of this Command_Instruction, the address will be XOR with the XOR_Address_Pattern.[br]\r\n"
"If the Address_Decode_Enable field in the Address_Instruction list is inactive (0), and the Address_PRBS_Enable bit in the Address_PRBS_Control register is set, then the desired address bits will be replaced with the PRBS generated value.[br]\r\n"
"If the "},
#else
{5, 5, 0x0000000000000000, "RW", "Address_Decode_or_PRBS_En", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{4, 4, 0x0000000000000000, "RW", "Alternate_Data", "Use the alternate zero data source instead of the UniSequencers and Pattern_Select."},
#else
{4, 4, 0x0000000000000000, "RW", "Alternate_Data", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{3, 3, 0x0000000000000000, "RW", "Hammer", "This Base command will be repeated Hammer_Repeats times"},
#else
{3, 3, 0x0000000000000000, "RW", "Hammer", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{2, 2, 0x0000000000000000, "RW", "Offset", "If set, this is an Offset operation, and the selected Offset_Group will be executed in its place. In this case the Write, Hammer, and Alternate_Data fields are ignored."},
#else
{2, 2, 0x0000000000000000, "RW", "Offset", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{1, 1, 0x0000000000000000, "RW", "Offset_Group", "Selects which Offset_Group will be used if Offset field is set."},
#else
{1, 1, 0x0000000000000000, "RW", "Offset_Group", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 0, 0x0000000000000000, "RW", "Write", "A Base Write operation will be performed"},
#else
{0, 0, 0x0000000000000000, "RW", "Write", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo111[] = {{"CPGC2_COMMAND_INSTRUCTION_8_", "", 0x00000060, 8, 0x00000000000000FF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields112[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{7, 7, 0x0000000000000000, "RW", "Last", "Last Command_Instruction.  Execution continues at the Command_Instruction pointed to by the Algorithm_Instruction's Command_Start_Pointer until the end of the Algorithm_Instruction."},
#else
{7, 7, 0x0000000000000000, "RW", "Last", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{6, 6, 0x0000000000000000, "RW", "Invert_Data", "Invert the data used for this command. This is combined with the Algorithm_Instruction and Data_Instruction Invert_Data bits for Base accesses. For Offset accesses, it is further combined with the Offset_Command Invert_Data bit."},
#else
{6, 6, 0x0000000000000000, "RW", "Invert_Data", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{5, 5, 0x0000000000000000, "RW", "Address_Decode_or_PRBS_En", "Enable rotating XOR of address bits or PRBS address generation. If the Address_Decode_Enable field in the Address_Instruction list is active, and [name] is also active, then for the access of this Command_Instruction, the address will be XOR with the XOR_Address_Pattern.[br]\r\n"
"If the Address_Decode_Enable field in the Address_Instruction list is inactive (0), and the Address_PRBS_Enable bit in the Address_PRBS_Control register is set, then the desired address bits will be replaced with the PRBS generated value.[br]\r\n"
"If the "},
#else
{5, 5, 0x0000000000000000, "RW", "Address_Decode_or_PRBS_En", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{4, 4, 0x0000000000000000, "RW", "Alternate_Data", "Use the alternate zero data source instead of the UniSequencers and Pattern_Select."},
#else
{4, 4, 0x0000000000000000, "RW", "Alternate_Data", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{3, 3, 0x0000000000000000, "RW", "Hammer", "This Base command will be repeated Hammer_Repeats times"},
#else
{3, 3, 0x0000000000000000, "RW", "Hammer", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{2, 2, 0x0000000000000000, "RW", "Offset", "If set, this is an Offset operation, and the selected Offset_Group will be executed in its place. In this case the Write, Hammer, and Alternate_Data fields are ignored."},
#else
{2, 2, 0x0000000000000000, "RW", "Offset", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{1, 1, 0x0000000000000000, "RW", "Offset_Group", "Selects which Offset_Group will be used if Offset field is set."},
#else
{1, 1, 0x0000000000000000, "RW", "Offset_Group", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 0, 0x0000000000000000, "RW", "Write", "A Base Write operation will be performed"},
#else
{0, 0, 0x0000000000000000, "RW", "Write", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo112[] = {{"CPGC2_COMMAND_INSTRUCTION_9_", "", 0x00000061, 8, 0x00000000000000FF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields113[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{7, 7, 0x0000000000000000, "RW", "Last", "Last Command_Instruction.  Execution continues at the Command_Instruction pointed to by the Algorithm_Instruction's Command_Start_Pointer until the end of the Algorithm_Instruction."},
#else
{7, 7, 0x0000000000000000, "RW", "Last", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{6, 6, 0x0000000000000000, "RW", "Invert_Data", "Invert the data used for this command. This is combined with the Algorithm_Instruction and Data_Instruction Invert_Data bits for Base accesses. For Offset accesses, it is further combined with the Offset_Command Invert_Data bit."},
#else
{6, 6, 0x0000000000000000, "RW", "Invert_Data", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{5, 5, 0x0000000000000000, "RW", "Address_Decode_or_PRBS_En", "Enable rotating XOR of address bits or PRBS address generation. If the Address_Decode_Enable field in the Address_Instruction list is active, and [name] is also active, then for the access of this Command_Instruction, the address will be XOR with the XOR_Address_Pattern.[br]\r\n"
"If the Address_Decode_Enable field in the Address_Instruction list is inactive (0), and the Address_PRBS_Enable bit in the Address_PRBS_Control register is set, then the desired address bits will be replaced with the PRBS generated value.[br]\r\n"
"If the "},
#else
{5, 5, 0x0000000000000000, "RW", "Address_Decode_or_PRBS_En", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{4, 4, 0x0000000000000000, "RW", "Alternate_Data", "Use the alternate zero data source instead of the UniSequencers and Pattern_Select."},
#else
{4, 4, 0x0000000000000000, "RW", "Alternate_Data", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{3, 3, 0x0000000000000000, "RW", "Hammer", "This Base command will be repeated Hammer_Repeats times"},
#else
{3, 3, 0x0000000000000000, "RW", "Hammer", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{2, 2, 0x0000000000000000, "RW", "Offset", "If set, this is an Offset operation, and the selected Offset_Group will be executed in its place. In this case the Write, Hammer, and Alternate_Data fields are ignored."},
#else
{2, 2, 0x0000000000000000, "RW", "Offset", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{1, 1, 0x0000000000000000, "RW", "Offset_Group", "Selects which Offset_Group will be used if Offset field is set."},
#else
{1, 1, 0x0000000000000000, "RW", "Offset_Group", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 0, 0x0000000000000000, "RW", "Write", "A Base Write operation will be performed"},
#else
{0, 0, 0x0000000000000000, "RW", "Write", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo113[] = {{"CPGC2_COMMAND_INSTRUCTION_10_", "", 0x00000062, 8, 0x00000000000000FF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields114[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{7, 7, 0x0000000000000000, "RW", "Last", "Last Command_Instruction.  Execution continues at the Command_Instruction pointed to by the Algorithm_Instruction's Command_Start_Pointer until the end of the Algorithm_Instruction."},
#else
{7, 7, 0x0000000000000000, "RW", "Last", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{6, 6, 0x0000000000000000, "RW", "Invert_Data", "Invert the data used for this command. This is combined with the Algorithm_Instruction and Data_Instruction Invert_Data bits for Base accesses. For Offset accesses, it is further combined with the Offset_Command Invert_Data bit."},
#else
{6, 6, 0x0000000000000000, "RW", "Invert_Data", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{5, 5, 0x0000000000000000, "RW", "Address_Decode_or_PRBS_En", "Enable rotating XOR of address bits or PRBS address generation. If the Address_Decode_Enable field in the Address_Instruction list is active, and [name] is also active, then for the access of this Command_Instruction, the address will be XOR with the XOR_Address_Pattern.[br]\r\n"
"If the Address_Decode_Enable field in the Address_Instruction list is inactive (0), and the Address_PRBS_Enable bit in the Address_PRBS_Control register is set, then the desired address bits will be replaced with the PRBS generated value.[br]\r\n"
"If the "},
#else
{5, 5, 0x0000000000000000, "RW", "Address_Decode_or_PRBS_En", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{4, 4, 0x0000000000000000, "RW", "Alternate_Data", "Use the alternate zero data source instead of the UniSequencers and Pattern_Select."},
#else
{4, 4, 0x0000000000000000, "RW", "Alternate_Data", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{3, 3, 0x0000000000000000, "RW", "Hammer", "This Base command will be repeated Hammer_Repeats times"},
#else
{3, 3, 0x0000000000000000, "RW", "Hammer", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{2, 2, 0x0000000000000000, "RW", "Offset", "If set, this is an Offset operation, and the selected Offset_Group will be executed in its place. In this case the Write, Hammer, and Alternate_Data fields are ignored."},
#else
{2, 2, 0x0000000000000000, "RW", "Offset", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{1, 1, 0x0000000000000000, "RW", "Offset_Group", "Selects which Offset_Group will be used if Offset field is set."},
#else
{1, 1, 0x0000000000000000, "RW", "Offset_Group", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 0, 0x0000000000000000, "RW", "Write", "A Base Write operation will be performed"},
#else
{0, 0, 0x0000000000000000, "RW", "Write", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo114[] = {{"CPGC2_COMMAND_INSTRUCTION_11_", "", 0x00000063, 8, 0x00000000000000FF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields115[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{7, 7, 0x0000000000000000, "RW", "Last", "Last Command_Instruction.  Execution continues at the Command_Instruction pointed to by the Algorithm_Instruction's Command_Start_Pointer until the end of the Algorithm_Instruction."},
#else
{7, 7, 0x0000000000000000, "RW", "Last", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{6, 6, 0x0000000000000000, "RW", "Invert_Data", "Invert the data used for this command. This is combined with the Algorithm_Instruction and Data_Instruction Invert_Data bits for Base accesses. For Offset accesses, it is further combined with the Offset_Command Invert_Data bit."},
#else
{6, 6, 0x0000000000000000, "RW", "Invert_Data", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{5, 5, 0x0000000000000000, "RW", "Address_Decode_or_PRBS_En", "Enable rotating XOR of address bits or PRBS address generation. If the Address_Decode_Enable field in the Address_Instruction list is active, and [name] is also active, then for the access of this Command_Instruction, the address will be XOR with the XOR_Address_Pattern.[br]\r\n"
"If the Address_Decode_Enable field in the Address_Instruction list is inactive (0), and the Address_PRBS_Enable bit in the Address_PRBS_Control register is set, then the desired address bits will be replaced with the PRBS generated value.[br]\r\n"
"If the "},
#else
{5, 5, 0x0000000000000000, "RW", "Address_Decode_or_PRBS_En", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{4, 4, 0x0000000000000000, "RW", "Alternate_Data", "Use the alternate zero data source instead of the UniSequencers and Pattern_Select."},
#else
{4, 4, 0x0000000000000000, "RW", "Alternate_Data", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{3, 3, 0x0000000000000000, "RW", "Hammer", "This Base command will be repeated Hammer_Repeats times"},
#else
{3, 3, 0x0000000000000000, "RW", "Hammer", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{2, 2, 0x0000000000000000, "RW", "Offset", "If set, this is an Offset operation, and the selected Offset_Group will be executed in its place. In this case the Write, Hammer, and Alternate_Data fields are ignored."},
#else
{2, 2, 0x0000000000000000, "RW", "Offset", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{1, 1, 0x0000000000000000, "RW", "Offset_Group", "Selects which Offset_Group will be used if Offset field is set."},
#else
{1, 1, 0x0000000000000000, "RW", "Offset_Group", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 0, 0x0000000000000000, "RW", "Write", "A Base Write operation will be performed"},
#else
{0, 0, 0x0000000000000000, "RW", "Write", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo115[] = {{"CPGC2_COMMAND_INSTRUCTION_12_", "", 0x00000064, 8, 0x00000000000000FF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields116[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{7, 7, 0x0000000000000000, "RW", "Last", "Last Command_Instruction.  Execution continues at the Command_Instruction pointed to by the Algorithm_Instruction's Command_Start_Pointer until the end of the Algorithm_Instruction."},
#else
{7, 7, 0x0000000000000000, "RW", "Last", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{6, 6, 0x0000000000000000, "RW", "Invert_Data", "Invert the data used for this command. This is combined with the Algorithm_Instruction and Data_Instruction Invert_Data bits for Base accesses. For Offset accesses, it is further combined with the Offset_Command Invert_Data bit."},
#else
{6, 6, 0x0000000000000000, "RW", "Invert_Data", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{5, 5, 0x0000000000000000, "RW", "Address_Decode_or_PRBS_En", "Enable rotating XOR of address bits or PRBS address generation. If the Address_Decode_Enable field in the Address_Instruction list is active, and [name] is also active, then for the access of this Command_Instruction, the address will be XOR with the XOR_Address_Pattern.[br]\r\n"
"If the Address_Decode_Enable field in the Address_Instruction list is inactive (0), and the Address_PRBS_Enable bit in the Address_PRBS_Control register is set, then the desired address bits will be replaced with the PRBS generated value.[br]\r\n"
"If the "},
#else
{5, 5, 0x0000000000000000, "RW", "Address_Decode_or_PRBS_En", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{4, 4, 0x0000000000000000, "RW", "Alternate_Data", "Use the alternate zero data source instead of the UniSequencers and Pattern_Select."},
#else
{4, 4, 0x0000000000000000, "RW", "Alternate_Data", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{3, 3, 0x0000000000000000, "RW", "Hammer", "This Base command will be repeated Hammer_Repeats times"},
#else
{3, 3, 0x0000000000000000, "RW", "Hammer", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{2, 2, 0x0000000000000000, "RW", "Offset", "If set, this is an Offset operation, and the selected Offset_Group will be executed in its place. In this case the Write, Hammer, and Alternate_Data fields are ignored."},
#else
{2, 2, 0x0000000000000000, "RW", "Offset", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{1, 1, 0x0000000000000000, "RW", "Offset_Group", "Selects which Offset_Group will be used if Offset field is set."},
#else
{1, 1, 0x0000000000000000, "RW", "Offset_Group", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 0, 0x0000000000000000, "RW", "Write", "A Base Write operation will be performed"},
#else
{0, 0, 0x0000000000000000, "RW", "Write", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo116[] = {{"CPGC2_COMMAND_INSTRUCTION_13_", "", 0x00000065, 8, 0x00000000000000FF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields117[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{7, 7, 0x0000000000000000, "RW", "Last", "Last Command_Instruction.  Execution continues at the Command_Instruction pointed to by the Algorithm_Instruction's Command_Start_Pointer until the end of the Algorithm_Instruction."},
#else
{7, 7, 0x0000000000000000, "RW", "Last", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{6, 6, 0x0000000000000000, "RW", "Invert_Data", "Invert the data used for this command. This is combined with the Algorithm_Instruction and Data_Instruction Invert_Data bits for Base accesses. For Offset accesses, it is further combined with the Offset_Command Invert_Data bit."},
#else
{6, 6, 0x0000000000000000, "RW", "Invert_Data", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{5, 5, 0x0000000000000000, "RW", "Address_Decode_or_PRBS_En", "Enable rotating XOR of address bits or PRBS address generation. If the Address_Decode_Enable field in the Address_Instruction list is active, and [name] is also active, then for the access of this Command_Instruction, the address will be XOR with the XOR_Address_Pattern.[br]\r\n"
"If the Address_Decode_Enable field in the Address_Instruction list is inactive (0), and the Address_PRBS_Enable bit in the Address_PRBS_Control register is set, then the desired address bits will be replaced with the PRBS generated value.[br]\r\n"
"If the "},
#else
{5, 5, 0x0000000000000000, "RW", "Address_Decode_or_PRBS_En", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{4, 4, 0x0000000000000000, "RW", "Alternate_Data", "Use the alternate zero data source instead of the UniSequencers and Pattern_Select."},
#else
{4, 4, 0x0000000000000000, "RW", "Alternate_Data", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{3, 3, 0x0000000000000000, "RW", "Hammer", "This Base command will be repeated Hammer_Repeats times"},
#else
{3, 3, 0x0000000000000000, "RW", "Hammer", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{2, 2, 0x0000000000000000, "RW", "Offset", "If set, this is an Offset operation, and the selected Offset_Group will be executed in its place. In this case the Write, Hammer, and Alternate_Data fields are ignored."},
#else
{2, 2, 0x0000000000000000, "RW", "Offset", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{1, 1, 0x0000000000000000, "RW", "Offset_Group", "Selects which Offset_Group will be used if Offset field is set."},
#else
{1, 1, 0x0000000000000000, "RW", "Offset_Group", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 0, 0x0000000000000000, "RW", "Write", "A Base Write operation will be performed"},
#else
{0, 0, 0x0000000000000000, "RW", "Write", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo117[] = {{"CPGC2_COMMAND_INSTRUCTION_14_", "", 0x00000066, 8, 0x00000000000000FF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields118[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{7, 7, 0x0000000000000000, "RW", "Last", "Last Command_Instruction.  Execution continues at the Command_Instruction pointed to by the Algorithm_Instruction's Command_Start_Pointer until the end of the Algorithm_Instruction."},
#else
{7, 7, 0x0000000000000000, "RW", "Last", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{6, 6, 0x0000000000000000, "RW", "Invert_Data", "Invert the data used for this command. This is combined with the Algorithm_Instruction and Data_Instruction Invert_Data bits for Base accesses. For Offset accesses, it is further combined with the Offset_Command Invert_Data bit."},
#else
{6, 6, 0x0000000000000000, "RW", "Invert_Data", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{5, 5, 0x0000000000000000, "RW", "Address_Decode_or_PRBS_En", "Enable rotating XOR of address bits or PRBS address generation. If the Address_Decode_Enable field in the Address_Instruction list is active, and [name] is also active, then for the access of this Command_Instruction, the address will be XOR with the XOR_Address_Pattern.[br]\r\n"
"If the Address_Decode_Enable field in the Address_Instruction list is inactive (0), and the Address_PRBS_Enable bit in the Address_PRBS_Control register is set, then the desired address bits will be replaced with the PRBS generated value.[br]\r\n"
"If the "},
#else
{5, 5, 0x0000000000000000, "RW", "Address_Decode_or_PRBS_En", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{4, 4, 0x0000000000000000, "RW", "Alternate_Data", "Use the alternate zero data source instead of the UniSequencers and Pattern_Select."},
#else
{4, 4, 0x0000000000000000, "RW", "Alternate_Data", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{3, 3, 0x0000000000000000, "RW", "Hammer", "This Base command will be repeated Hammer_Repeats times"},
#else
{3, 3, 0x0000000000000000, "RW", "Hammer", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{2, 2, 0x0000000000000000, "RW", "Offset", "If set, this is an Offset operation, and the selected Offset_Group will be executed in its place. In this case the Write, Hammer, and Alternate_Data fields are ignored."},
#else
{2, 2, 0x0000000000000000, "RW", "Offset", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{1, 1, 0x0000000000000000, "RW", "Offset_Group", "Selects which Offset_Group will be used if Offset field is set."},
#else
{1, 1, 0x0000000000000000, "RW", "Offset_Group", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 0, 0x0000000000000000, "RW", "Write", "A Base Write operation will be performed"},
#else
{0, 0, 0x0000000000000000, "RW", "Write", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo118[] = {{"CPGC2_COMMAND_INSTRUCTION_15_", "", 0x00000067, 8, 0x00000000000000FF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields119[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{7, 7, 0x0000000000000000, "RW", "Last", "Last Command_Instruction.  Execution continues at the Command_Instruction pointed to by the Algorithm_Instruction's Command_Start_Pointer until the end of the Algorithm_Instruction."},
#else
{7, 7, 0x0000000000000000, "RW", "Last", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{6, 6, 0x0000000000000000, "RW", "Invert_Data", "Invert the data used for this command. This is combined with the Algorithm_Instruction and Data_Instruction Invert_Data bits for Base accesses. For Offset accesses, it is further combined with the Offset_Command Invert_Data bit."},
#else
{6, 6, 0x0000000000000000, "RW", "Invert_Data", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{5, 5, 0x0000000000000000, "RW", "Address_Decode_or_PRBS_En", "Enable rotating XOR of address bits or PRBS address generation. If the Address_Decode_Enable field in the Address_Instruction list is active, and [name] is also active, then for the access of this Command_Instruction, the address will be XOR with the XOR_Address_Pattern.[br]\r\n"
"If the Address_Decode_Enable field in the Address_Instruction list is inactive (0), and the Address_PRBS_Enable bit in the Address_PRBS_Control register is set, then the desired address bits will be replaced with the PRBS generated value.[br]\r\n"
"If the "},
#else
{5, 5, 0x0000000000000000, "RW", "Address_Decode_or_PRBS_En", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{4, 4, 0x0000000000000000, "RW", "Alternate_Data", "Use the alternate zero data source instead of the UniSequencers and Pattern_Select."},
#else
{4, 4, 0x0000000000000000, "RW", "Alternate_Data", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{3, 3, 0x0000000000000000, "RW", "Hammer", "This Base command will be repeated Hammer_Repeats times"},
#else
{3, 3, 0x0000000000000000, "RW", "Hammer", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{2, 2, 0x0000000000000000, "RW", "Offset", "If set, this is an Offset operation, and the selected Offset_Group will be executed in its place. In this case the Write, Hammer, and Alternate_Data fields are ignored."},
#else
{2, 2, 0x0000000000000000, "RW", "Offset", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{1, 1, 0x0000000000000000, "RW", "Offset_Group", "Selects which Offset_Group will be used if Offset field is set."},
#else
{1, 1, 0x0000000000000000, "RW", "Offset_Group", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 0, 0x0000000000000000, "RW", "Write", "A Base Write operation will be performed"},
#else
{0, 0, 0x0000000000000000, "RW", "Write", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo119[] = {{"CPGC2_COMMAND_INSTRUCTION_16_", "", 0x00000068, 8, 0x00000000000000FF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields120[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{7, 7, 0x0000000000000000, "RW", "Last", "Last Command_Instruction.  Execution continues at the Command_Instruction pointed to by the Algorithm_Instruction's Command_Start_Pointer until the end of the Algorithm_Instruction."},
#else
{7, 7, 0x0000000000000000, "RW", "Last", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{6, 6, 0x0000000000000000, "RW", "Invert_Data", "Invert the data used for this command. This is combined with the Algorithm_Instruction and Data_Instruction Invert_Data bits for Base accesses. For Offset accesses, it is further combined with the Offset_Command Invert_Data bit."},
#else
{6, 6, 0x0000000000000000, "RW", "Invert_Data", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{5, 5, 0x0000000000000000, "RW", "Address_Decode_or_PRBS_En", "Enable rotating XOR of address bits or PRBS address generation. If the Address_Decode_Enable field in the Address_Instruction list is active, and [name] is also active, then for the access of this Command_Instruction, the address will be XOR with the XOR_Address_Pattern.[br]\r\n"
"If the Address_Decode_Enable field in the Address_Instruction list is inactive (0), and the Address_PRBS_Enable bit in the Address_PRBS_Control register is set, then the desired address bits will be replaced with the PRBS generated value.[br]\r\n"
"If the "},
#else
{5, 5, 0x0000000000000000, "RW", "Address_Decode_or_PRBS_En", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{4, 4, 0x0000000000000000, "RW", "Alternate_Data", "Use the alternate zero data source instead of the UniSequencers and Pattern_Select."},
#else
{4, 4, 0x0000000000000000, "RW", "Alternate_Data", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{3, 3, 0x0000000000000000, "RW", "Hammer", "This Base command will be repeated Hammer_Repeats times"},
#else
{3, 3, 0x0000000000000000, "RW", "Hammer", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{2, 2, 0x0000000000000000, "RW", "Offset", "If set, this is an Offset operation, and the selected Offset_Group will be executed in its place. In this case the Write, Hammer, and Alternate_Data fields are ignored."},
#else
{2, 2, 0x0000000000000000, "RW", "Offset", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{1, 1, 0x0000000000000000, "RW", "Offset_Group", "Selects which Offset_Group will be used if Offset field is set."},
#else
{1, 1, 0x0000000000000000, "RW", "Offset_Group", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 0, 0x0000000000000000, "RW", "Write", "A Base Write operation will be performed"},
#else
{0, 0, 0x0000000000000000, "RW", "Write", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo120[] = {{"CPGC2_COMMAND_INSTRUCTION_17_", "", 0x00000069, 8, 0x00000000000000FF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields121[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{7, 7, 0x0000000000000000, "RW", "Last", "Last Command_Instruction.  Execution continues at the Command_Instruction pointed to by the Algorithm_Instruction's Command_Start_Pointer until the end of the Algorithm_Instruction."},
#else
{7, 7, 0x0000000000000000, "RW", "Last", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{6, 6, 0x0000000000000000, "RW", "Invert_Data", "Invert the data used for this command. This is combined with the Algorithm_Instruction and Data_Instruction Invert_Data bits for Base accesses. For Offset accesses, it is further combined with the Offset_Command Invert_Data bit."},
#else
{6, 6, 0x0000000000000000, "RW", "Invert_Data", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{5, 5, 0x0000000000000000, "RW", "Address_Decode_or_PRBS_En", "Enable rotating XOR of address bits or PRBS address generation. If the Address_Decode_Enable field in the Address_Instruction list is active, and [name] is also active, then for the access of this Command_Instruction, the address will be XOR with the XOR_Address_Pattern.[br]\r\n"
"If the Address_Decode_Enable field in the Address_Instruction list is inactive (0), and the Address_PRBS_Enable bit in the Address_PRBS_Control register is set, then the desired address bits will be replaced with the PRBS generated value.[br]\r\n"
"If the "},
#else
{5, 5, 0x0000000000000000, "RW", "Address_Decode_or_PRBS_En", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{4, 4, 0x0000000000000000, "RW", "Alternate_Data", "Use the alternate zero data source instead of the UniSequencers and Pattern_Select."},
#else
{4, 4, 0x0000000000000000, "RW", "Alternate_Data", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{3, 3, 0x0000000000000000, "RW", "Hammer", "This Base command will be repeated Hammer_Repeats times"},
#else
{3, 3, 0x0000000000000000, "RW", "Hammer", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{2, 2, 0x0000000000000000, "RW", "Offset", "If set, this is an Offset operation, and the selected Offset_Group will be executed in its place. In this case the Write, Hammer, and Alternate_Data fields are ignored."},
#else
{2, 2, 0x0000000000000000, "RW", "Offset", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{1, 1, 0x0000000000000000, "RW", "Offset_Group", "Selects which Offset_Group will be used if Offset field is set."},
#else
{1, 1, 0x0000000000000000, "RW", "Offset_Group", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 0, 0x0000000000000000, "RW", "Write", "A Base Write operation will be performed"},
#else
{0, 0, 0x0000000000000000, "RW", "Write", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo121[] = {{"CPGC2_COMMAND_INSTRUCTION_18_", "", 0x0000006A, 8, 0x00000000000000FF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields122[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{7, 7, 0x0000000000000000, "RW", "Last", "Last Command_Instruction.  Execution continues at the Command_Instruction pointed to by the Algorithm_Instruction's Command_Start_Pointer until the end of the Algorithm_Instruction."},
#else
{7, 7, 0x0000000000000000, "RW", "Last", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{6, 6, 0x0000000000000000, "RW", "Invert_Data", "Invert the data used for this command. This is combined with the Algorithm_Instruction and Data_Instruction Invert_Data bits for Base accesses. For Offset accesses, it is further combined with the Offset_Command Invert_Data bit."},
#else
{6, 6, 0x0000000000000000, "RW", "Invert_Data", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{5, 5, 0x0000000000000000, "RW", "Address_Decode_or_PRBS_En", "Enable rotating XOR of address bits or PRBS address generation. If the Address_Decode_Enable field in the Address_Instruction list is active, and [name] is also active, then for the access of this Command_Instruction, the address will be XOR with the XOR_Address_Pattern.[br]\r\n"
"If the Address_Decode_Enable field in the Address_Instruction list is inactive (0), and the Address_PRBS_Enable bit in the Address_PRBS_Control register is set, then the desired address bits will be replaced with the PRBS generated value.[br]\r\n"
"If the "},
#else
{5, 5, 0x0000000000000000, "RW", "Address_Decode_or_PRBS_En", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{4, 4, 0x0000000000000000, "RW", "Alternate_Data", "Use the alternate zero data source instead of the UniSequencers and Pattern_Select."},
#else
{4, 4, 0x0000000000000000, "RW", "Alternate_Data", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{3, 3, 0x0000000000000000, "RW", "Hammer", "This Base command will be repeated Hammer_Repeats times"},
#else
{3, 3, 0x0000000000000000, "RW", "Hammer", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{2, 2, 0x0000000000000000, "RW", "Offset", "If set, this is an Offset operation, and the selected Offset_Group will be executed in its place. In this case the Write, Hammer, and Alternate_Data fields are ignored."},
#else
{2, 2, 0x0000000000000000, "RW", "Offset", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{1, 1, 0x0000000000000000, "RW", "Offset_Group", "Selects which Offset_Group will be used if Offset field is set."},
#else
{1, 1, 0x0000000000000000, "RW", "Offset_Group", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 0, 0x0000000000000000, "RW", "Write", "A Base Write operation will be performed"},
#else
{0, 0, 0x0000000000000000, "RW", "Write", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo122[] = {{"CPGC2_COMMAND_INSTRUCTION_19_", "", 0x0000006B, 8, 0x00000000000000FF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields123[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{7, 7, 0x0000000000000000, "RW", "Last", "Last Command_Instruction.  Execution continues at the Command_Instruction pointed to by the Algorithm_Instruction's Command_Start_Pointer until the end of the Algorithm_Instruction."},
#else
{7, 7, 0x0000000000000000, "RW", "Last", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{6, 6, 0x0000000000000000, "RW", "Invert_Data", "Invert the data used for this command. This is combined with the Algorithm_Instruction and Data_Instruction Invert_Data bits for Base accesses. For Offset accesses, it is further combined with the Offset_Command Invert_Data bit."},
#else
{6, 6, 0x0000000000000000, "RW", "Invert_Data", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{5, 5, 0x0000000000000000, "RW", "Address_Decode_or_PRBS_En", "Enable rotating XOR of address bits or PRBS address generation. If the Address_Decode_Enable field in the Address_Instruction list is active, and [name] is also active, then for the access of this Command_Instruction, the address will be XOR with the XOR_Address_Pattern.[br]\r\n"
"If the Address_Decode_Enable field in the Address_Instruction list is inactive (0), and the Address_PRBS_Enable bit in the Address_PRBS_Control register is set, then the desired address bits will be replaced with the PRBS generated value.[br]\r\n"
"If the "},
#else
{5, 5, 0x0000000000000000, "RW", "Address_Decode_or_PRBS_En", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{4, 4, 0x0000000000000000, "RW", "Alternate_Data", "Use the alternate zero data source instead of the UniSequencers and Pattern_Select."},
#else
{4, 4, 0x0000000000000000, "RW", "Alternate_Data", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{3, 3, 0x0000000000000000, "RW", "Hammer", "This Base command will be repeated Hammer_Repeats times"},
#else
{3, 3, 0x0000000000000000, "RW", "Hammer", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{2, 2, 0x0000000000000000, "RW", "Offset", "If set, this is an Offset operation, and the selected Offset_Group will be executed in its place. In this case the Write, Hammer, and Alternate_Data fields are ignored."},
#else
{2, 2, 0x0000000000000000, "RW", "Offset", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{1, 1, 0x0000000000000000, "RW", "Offset_Group", "Selects which Offset_Group will be used if Offset field is set."},
#else
{1, 1, 0x0000000000000000, "RW", "Offset_Group", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 0, 0x0000000000000000, "RW", "Write", "A Base Write operation will be performed"},
#else
{0, 0, 0x0000000000000000, "RW", "Write", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo123[] = {{"CPGC2_COMMAND_INSTRUCTION_20_", "", 0x0000006C, 8, 0x00000000000000FF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields124[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{7, 7, 0x0000000000000000, "RW", "Last", "Last Command_Instruction.  Execution continues at the Command_Instruction pointed to by the Algorithm_Instruction's Command_Start_Pointer until the end of the Algorithm_Instruction."},
#else
{7, 7, 0x0000000000000000, "RW", "Last", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{6, 6, 0x0000000000000000, "RW", "Invert_Data", "Invert the data used for this command. This is combined with the Algorithm_Instruction and Data_Instruction Invert_Data bits for Base accesses. For Offset accesses, it is further combined with the Offset_Command Invert_Data bit."},
#else
{6, 6, 0x0000000000000000, "RW", "Invert_Data", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{5, 5, 0x0000000000000000, "RW", "Address_Decode_or_PRBS_En", "Enable rotating XOR of address bits or PRBS address generation. If the Address_Decode_Enable field in the Address_Instruction list is active, and [name] is also active, then for the access of this Command_Instruction, the address will be XOR with the XOR_Address_Pattern.[br]\r\n"
"If the Address_Decode_Enable field in the Address_Instruction list is inactive (0), and the Address_PRBS_Enable bit in the Address_PRBS_Control register is set, then the desired address bits will be replaced with the PRBS generated value.[br]\r\n"
"If the "},
#else
{5, 5, 0x0000000000000000, "RW", "Address_Decode_or_PRBS_En", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{4, 4, 0x0000000000000000, "RW", "Alternate_Data", "Use the alternate zero data source instead of the UniSequencers and Pattern_Select."},
#else
{4, 4, 0x0000000000000000, "RW", "Alternate_Data", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{3, 3, 0x0000000000000000, "RW", "Hammer", "This Base command will be repeated Hammer_Repeats times"},
#else
{3, 3, 0x0000000000000000, "RW", "Hammer", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{2, 2, 0x0000000000000000, "RW", "Offset", "If set, this is an Offset operation, and the selected Offset_Group will be executed in its place. In this case the Write, Hammer, and Alternate_Data fields are ignored."},
#else
{2, 2, 0x0000000000000000, "RW", "Offset", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{1, 1, 0x0000000000000000, "RW", "Offset_Group", "Selects which Offset_Group will be used if Offset field is set."},
#else
{1, 1, 0x0000000000000000, "RW", "Offset_Group", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 0, 0x0000000000000000, "RW", "Write", "A Base Write operation will be performed"},
#else
{0, 0, 0x0000000000000000, "RW", "Write", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo124[] = {{"CPGC2_COMMAND_INSTRUCTION_21_", "", 0x0000006D, 8, 0x00000000000000FF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields125[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{7, 7, 0x0000000000000000, "RW", "Last", "Last Command_Instruction.  Execution continues at the Command_Instruction pointed to by the Algorithm_Instruction's Command_Start_Pointer until the end of the Algorithm_Instruction."},
#else
{7, 7, 0x0000000000000000, "RW", "Last", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{6, 6, 0x0000000000000000, "RW", "Invert_Data", "Invert the data used for this command. This is combined with the Algorithm_Instruction and Data_Instruction Invert_Data bits for Base accesses. For Offset accesses, it is further combined with the Offset_Command Invert_Data bit."},
#else
{6, 6, 0x0000000000000000, "RW", "Invert_Data", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{5, 5, 0x0000000000000000, "RW", "Address_Decode_or_PRBS_En", "Enable rotating XOR of address bits or PRBS address generation. If the Address_Decode_Enable field in the Address_Instruction list is active, and [name] is also active, then for the access of this Command_Instruction, the address will be XOR with the XOR_Address_Pattern.[br]\r\n"
"If the Address_Decode_Enable field in the Address_Instruction list is inactive (0), and the Address_PRBS_Enable bit in the Address_PRBS_Control register is set, then the desired address bits will be replaced with the PRBS generated value.[br]\r\n"
"If the "},
#else
{5, 5, 0x0000000000000000, "RW", "Address_Decode_or_PRBS_En", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{4, 4, 0x0000000000000000, "RW", "Alternate_Data", "Use the alternate zero data source instead of the UniSequencers and Pattern_Select."},
#else
{4, 4, 0x0000000000000000, "RW", "Alternate_Data", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{3, 3, 0x0000000000000000, "RW", "Hammer", "This Base command will be repeated Hammer_Repeats times"},
#else
{3, 3, 0x0000000000000000, "RW", "Hammer", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{2, 2, 0x0000000000000000, "RW", "Offset", "If set, this is an Offset operation, and the selected Offset_Group will be executed in its place. In this case the Write, Hammer, and Alternate_Data fields are ignored."},
#else
{2, 2, 0x0000000000000000, "RW", "Offset", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{1, 1, 0x0000000000000000, "RW", "Offset_Group", "Selects which Offset_Group will be used if Offset field is set."},
#else
{1, 1, 0x0000000000000000, "RW", "Offset_Group", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 0, 0x0000000000000000, "RW", "Write", "A Base Write operation will be performed"},
#else
{0, 0, 0x0000000000000000, "RW", "Write", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo125[] = {{"CPGC2_COMMAND_INSTRUCTION_22_", "", 0x0000006E, 8, 0x00000000000000FF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields126[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{7, 7, 0x0000000000000000, "RW", "Last", "Last Command_Instruction.  Execution continues at the Command_Instruction pointed to by the Algorithm_Instruction's Command_Start_Pointer until the end of the Algorithm_Instruction."},
#else
{7, 7, 0x0000000000000000, "RW", "Last", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{6, 6, 0x0000000000000000, "RW", "Invert_Data", "Invert the data used for this command. This is combined with the Algorithm_Instruction and Data_Instruction Invert_Data bits for Base accesses. For Offset accesses, it is further combined with the Offset_Command Invert_Data bit."},
#else
{6, 6, 0x0000000000000000, "RW", "Invert_Data", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{5, 5, 0x0000000000000000, "RW", "Address_Decode_or_PRBS_En", "Enable rotating XOR of address bits or PRBS address generation. If the Address_Decode_Enable field in the Address_Instruction list is active, and [name] is also active, then for the access of this Command_Instruction, the address will be XOR with the XOR_Address_Pattern.[br]\r\n"
"If the Address_Decode_Enable field in the Address_Instruction list is inactive (0), and the Address_PRBS_Enable bit in the Address_PRBS_Control register is set, then the desired address bits will be replaced with the PRBS generated value.[br]\r\n"
"If the "},
#else
{5, 5, 0x0000000000000000, "RW", "Address_Decode_or_PRBS_En", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{4, 4, 0x0000000000000000, "RW", "Alternate_Data", "Use the alternate zero data source instead of the UniSequencers and Pattern_Select."},
#else
{4, 4, 0x0000000000000000, "RW", "Alternate_Data", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{3, 3, 0x0000000000000000, "RW", "Hammer", "This Base command will be repeated Hammer_Repeats times"},
#else
{3, 3, 0x0000000000000000, "RW", "Hammer", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{2, 2, 0x0000000000000000, "RW", "Offset", "If set, this is an Offset operation, and the selected Offset_Group will be executed in its place. In this case the Write, Hammer, and Alternate_Data fields are ignored."},
#else
{2, 2, 0x0000000000000000, "RW", "Offset", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{1, 1, 0x0000000000000000, "RW", "Offset_Group", "Selects which Offset_Group will be used if Offset field is set."},
#else
{1, 1, 0x0000000000000000, "RW", "Offset_Group", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 0, 0x0000000000000000, "RW", "Write", "A Base Write operation will be performed"},
#else
{0, 0, 0x0000000000000000, "RW", "Write", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo126[] = {{"CPGC2_COMMAND_INSTRUCTION_23_", "", 0x0000006F, 8, 0x00000000000000FF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields127[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{0, 31, 0x0000000000000000, "RW", "Hammer_Repeats", "Hammer_Repeats is the number of times any command is repeated at the same address when the Hammer control bit is set in the Command_Instruction (if not an offset command) or Offset_Command_Instruction"},
#else
{0, 31, 0x0000000000000000, "RW", "Hammer_Repeats", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo127[] = {{"CPGC2_HAMMER_REPEATS", "", 0x00000070, 1, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields128[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{0, 31, 0x0000000000000000, "RO/V", "Hammer_Repeats_Current", "Read only status register fo the current Hammer Loopcount (down count)"},
#else
{0, 31, 0x0000000000000000, "RO/V", "Hammer_Repeats_Current", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo128[] = {{"CPGC2_HAMMER_REPEATS_CURRENT", "", 0x00000074, 1, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields129[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{7, 7, 0x0000000000000000, "RW", "Last", "Last Offset_Address_Instruction. The offset instruction is complete after all Offset_Address, Offset_Repeats, and Offset_Commands have finished."},
#else
{7, 7, 0x0000000000000000, "RW", "Last", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{6, 6, 0x0000000000000000, "RW", "Stripe", "Normal Offsets use Address_Order=110[br]\r\n"
"This allows full traversal of the entire Block by and offset.[br]\r\n"
"If Stripe is active, then there is no carry between Row and Column. This will keep the offset address within the same Row, or the same Column or on the same diagonal."},
#else
{6, 6, 0x0000000000000000, "RW", "Stripe", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{3, 5, 0x0000000000000000, "RW", "Address_Direction", "[b]Address_Direction[/b][br]\r\n"
"There are 4 basic address directions and their inverse for a total of 8.[br]\r\n"
"We will denote this as a combination of a 1-bit field and a 2-bit field.[br]\r\n"
"[b](0)(00)  FastY -North[/b][br]\r\n"
" Increment Column and Carry Increment into Row.[br]\r\n"
"[b](1)(00) Inv(FastY) - South[/b][br]\r\n"
" Decrement Column and Carry Decrement into Row.[br]\r\n"
"[b](0)(01) Diagonal  North East[/b][br]\r\n"
" Increment Row and Column together and Carry Increment Column into Row.[br]\r\n"
"[b](1)(01) Inv(Diagonal)  South West[/b][br]\r\n"
" Decrement Row and Column together and Carry Decrement Column into Row.[br]\r\n"
"[b](0)(10) FastX  East[/b][br]\r\n"
" Increment Row and Carry Increment into Column.[br]\r\n"
"[b](1)(10) Inv(FastX) - West[/b][br]\r\n"
" Decrement Row and Carry Decrement into Column.[br]\r\n"
"[b](0)(11) Diagonal2 - South East[/b][br]\r\n"
" Decrement Column and Increment Row and Carry Increment Column into Row.[br]\r\n"
"[b](1)(11) Inv(Diagonal2)  North West [/b][br]\r\n"
" Increment Column and Decrement Row and Carry Decrement Column into Row.[br]\r\n"
"\r\n"
"Offset accesses begin one 'step' in the given direction from the current Base_Address."},
#else
{3, 5, 0x0000000000000000, "RW", "Address_Direction", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{2, 2, 0x0000000000000000, "RW", "Periodic_Data_Inv_En", "Enabled periodic data inversion - based on Address_Direction (OrderX field) -normally invert every 2^Block_Size_Bits_Row/Col, modified based on Periodic_Data_Inversion_Adjustment"},
#else
{2, 2, 0x0000000000000000, "RW", "Periodic_Data_Inv_En", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 1, 0x0000000000000000, "RW", "Periodic_Data_Inv_Adj", "Reduce or increase the inversion interval by -1,0,1 based on the value in this field.[br]00 - no adjust[br]01 - interval is increased by 1[br]11 - interval is decreased by 1[br]10 - reserved"},
#else
{0, 1, 0x0000000000000000, "RW", "Periodic_Data_Inv_Adj", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo129[] = {{"CPGC2_OFFSET_ADDRESS_INSTRUCTION_0_", "", 0x00000078, 5, 0x00000000000000FF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields130[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{7, 7, 0x0000000000000000, "RW", "Last", "Last Offset_Address_Instruction. The offset instruction is complete after all Offset_Address, Offset_Repeats, and Offset_Commands have finished."},
#else
{7, 7, 0x0000000000000000, "RW", "Last", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{6, 6, 0x0000000000000000, "RW", "Stripe", "Normal Offsets use Address_Order=110[br]\r\n"
"This allows full traversal of the entire Block by and offset.[br]\r\n"
"If Stripe is active, then there is no carry between Row and Column. This will keep the offset address within the same Row, or the same Column or on the same diagonal."},
#else
{6, 6, 0x0000000000000000, "RW", "Stripe", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{3, 5, 0x0000000000000000, "RW", "Address_Direction", "[b]Address_Direction[/b][br]\r\n"
"There are 4 basic address directions and their inverse for a total of 8.[br]\r\n"
"We will denote this as a combination of a 1-bit field and a 2-bit field.[br]\r\n"
"[b](0)(00)  FastY -North[/b][br]\r\n"
" Increment Column and Carry Increment into Row.[br]\r\n"
"[b](1)(00) Inv(FastY) - South[/b][br]\r\n"
" Decrement Column and Carry Decrement into Row.[br]\r\n"
"[b](0)(01) Diagonal  North East[/b][br]\r\n"
" Increment Row and Column together and Carry Increment Column into Row.[br]\r\n"
"[b](1)(01) Inv(Diagonal)  South West[/b][br]\r\n"
" Decrement Row and Column together and Carry Decrement Column into Row.[br]\r\n"
"[b](0)(10) FastX  East[/b][br]\r\n"
" Increment Row and Carry Increment into Column.[br]\r\n"
"[b](1)(10) Inv(FastX) - West[/b][br]\r\n"
" Decrement Row and Carry Decrement into Column.[br]\r\n"
"[b](0)(11) Diagonal2 - South East[/b][br]\r\n"
" Decrement Column and Increment Row and Carry Increment Column into Row.[br]\r\n"
"[b](1)(11) Inv(Diagonal2)  North West [/b][br]\r\n"
" Increment Column and Decrement Row and Carry Decrement Column into Row.[br]\r\n"
"\r\n"
"Offset accesses begin one 'step' in the given direction from the current Base_Address."},
#else
{3, 5, 0x0000000000000000, "RW", "Address_Direction", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{2, 2, 0x0000000000000000, "RW", "Periodic_Data_Inv_En", "Enabled periodic data inversion - based on Address_Direction (OrderX field) -normally invert every 2^Block_Size_Bits_Row/Col, modified based on Periodic_Data_Inversion_Adjustment"},
#else
{2, 2, 0x0000000000000000, "RW", "Periodic_Data_Inv_En", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 1, 0x0000000000000000, "RW", "Periodic_Data_Inv_Adj", "Reduce or increase the inversion interval by -1,0,1 based on the value in this field.[br]00 - no adjust[br]01 - interval is increased by 1[br]11 - interval is decreased by 1[br]10 - reserved"},
#else
{0, 1, 0x0000000000000000, "RW", "Periodic_Data_Inv_Adj", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo130[] = {{"CPGC2_OFFSET_ADDRESS_INSTRUCTION_1_", "", 0x00000079, 5, 0x00000000000000FF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields131[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{7, 7, 0x0000000000000000, "RW", "Last", "Last Offset_Address_Instruction. The offset instruction is complete after all Offset_Address, Offset_Repeats, and Offset_Commands have finished."},
#else
{7, 7, 0x0000000000000000, "RW", "Last", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{6, 6, 0x0000000000000000, "RW", "Stripe", "Normal Offsets use Address_Order=110[br]\r\n"
"This allows full traversal of the entire Block by and offset.[br]\r\n"
"If Stripe is active, then there is no carry between Row and Column. This will keep the offset address within the same Row, or the same Column or on the same diagonal."},
#else
{6, 6, 0x0000000000000000, "RW", "Stripe", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{3, 5, 0x0000000000000000, "RW", "Address_Direction", "[b]Address_Direction[/b][br]\r\n"
"There are 4 basic address directions and their inverse for a total of 8.[br]\r\n"
"We will denote this as a combination of a 1-bit field and a 2-bit field.[br]\r\n"
"[b](0)(00)  FastY -North[/b][br]\r\n"
" Increment Column and Carry Increment into Row.[br]\r\n"
"[b](1)(00) Inv(FastY) - South[/b][br]\r\n"
" Decrement Column and Carry Decrement into Row.[br]\r\n"
"[b](0)(01) Diagonal  North East[/b][br]\r\n"
" Increment Row and Column together and Carry Increment Column into Row.[br]\r\n"
"[b](1)(01) Inv(Diagonal)  South West[/b][br]\r\n"
" Decrement Row and Column together and Carry Decrement Column into Row.[br]\r\n"
"[b](0)(10) FastX  East[/b][br]\r\n"
" Increment Row and Carry Increment into Column.[br]\r\n"
"[b](1)(10) Inv(FastX) - West[/b][br]\r\n"
" Decrement Row and Carry Decrement into Column.[br]\r\n"
"[b](0)(11) Diagonal2 - South East[/b][br]\r\n"
" Decrement Column and Increment Row and Carry Increment Column into Row.[br]\r\n"
"[b](1)(11) Inv(Diagonal2)  North West [/b][br]\r\n"
" Increment Column and Decrement Row and Carry Decrement Column into Row.[br]\r\n"
"\r\n"
"Offset accesses begin one 'step' in the given direction from the current Base_Address."},
#else
{3, 5, 0x0000000000000000, "RW", "Address_Direction", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{2, 2, 0x0000000000000000, "RW", "Periodic_Data_Inv_En", "Enabled periodic data inversion - based on Address_Direction (OrderX field) -normally invert every 2^Block_Size_Bits_Row/Col, modified based on Periodic_Data_Inversion_Adjustment"},
#else
{2, 2, 0x0000000000000000, "RW", "Periodic_Data_Inv_En", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 1, 0x0000000000000000, "RW", "Periodic_Data_Inv_Adj", "Reduce or increase the inversion interval by -1,0,1 based on the value in this field.[br]00 - no adjust[br]01 - interval is increased by 1[br]11 - interval is decreased by 1[br]10 - reserved"},
#else
{0, 1, 0x0000000000000000, "RW", "Periodic_Data_Inv_Adj", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo131[] = {{"CPGC2_OFFSET_ADDRESS_INSTRUCTION_2_", "", 0x0000007A, 5, 0x00000000000000FF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields132[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{7, 7, 0x0000000000000000, "RW", "Last", "Last Offset_Address_Instruction. The offset instruction is complete after all Offset_Address, Offset_Repeats, and Offset_Commands have finished."},
#else
{7, 7, 0x0000000000000000, "RW", "Last", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{6, 6, 0x0000000000000000, "RW", "Stripe", "Normal Offsets use Address_Order=110[br]\r\n"
"This allows full traversal of the entire Block by and offset.[br]\r\n"
"If Stripe is active, then there is no carry between Row and Column. This will keep the offset address within the same Row, or the same Column or on the same diagonal."},
#else
{6, 6, 0x0000000000000000, "RW", "Stripe", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{3, 5, 0x0000000000000000, "RW", "Address_Direction", "[b]Address_Direction[/b][br]\r\n"
"There are 4 basic address directions and their inverse for a total of 8.[br]\r\n"
"We will denote this as a combination of a 1-bit field and a 2-bit field.[br]\r\n"
"[b](0)(00)  FastY -North[/b][br]\r\n"
" Increment Column and Carry Increment into Row.[br]\r\n"
"[b](1)(00) Inv(FastY) - South[/b][br]\r\n"
" Decrement Column and Carry Decrement into Row.[br]\r\n"
"[b](0)(01) Diagonal  North East[/b][br]\r\n"
" Increment Row and Column together and Carry Increment Column into Row.[br]\r\n"
"[b](1)(01) Inv(Diagonal)  South West[/b][br]\r\n"
" Decrement Row and Column together and Carry Decrement Column into Row.[br]\r\n"
"[b](0)(10) FastX  East[/b][br]\r\n"
" Increment Row and Carry Increment into Column.[br]\r\n"
"[b](1)(10) Inv(FastX) - West[/b][br]\r\n"
" Decrement Row and Carry Decrement into Column.[br]\r\n"
"[b](0)(11) Diagonal2 - South East[/b][br]\r\n"
" Decrement Column and Increment Row and Carry Increment Column into Row.[br]\r\n"
"[b](1)(11) Inv(Diagonal2)  North West [/b][br]\r\n"
" Increment Column and Decrement Row and Carry Decrement Column into Row.[br]\r\n"
"\r\n"
"Offset accesses begin one 'step' in the given direction from the current Base_Address."},
#else
{3, 5, 0x0000000000000000, "RW", "Address_Direction", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{2, 2, 0x0000000000000000, "RW", "Periodic_Data_Inv_En", "Enabled periodic data inversion - based on Address_Direction (OrderX field) -normally invert every 2^Block_Size_Bits_Row/Col, modified based on Periodic_Data_Inversion_Adjustment"},
#else
{2, 2, 0x0000000000000000, "RW", "Periodic_Data_Inv_En", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 1, 0x0000000000000000, "RW", "Periodic_Data_Inv_Adj", "Reduce or increase the inversion interval by -1,0,1 based on the value in this field.[br]00 - no adjust[br]01 - interval is increased by 1[br]11 - interval is decreased by 1[br]10 - reserved"},
#else
{0, 1, 0x0000000000000000, "RW", "Periodic_Data_Inv_Adj", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo132[] = {{"CPGC2_OFFSET_ADDRESS_INSTRUCTION_3_", "", 0x0000007B, 5, 0x00000000000000FF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields133[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{7, 7, 0x0000000000000000, "RW", "Last", "Last Offset_Address_Instruction. The offset instruction is complete after all Offset_Address, Offset_Repeats, and Offset_Commands have finished."},
#else
{7, 7, 0x0000000000000000, "RW", "Last", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{6, 6, 0x0000000000000000, "RW", "Stripe", "Normal Offsets use Address_Order=110[br]\r\n"
"This allows full traversal of the entire Block by and offset.[br]\r\n"
"If Stripe is active, then there is no carry between Row and Column. This will keep the offset address within the same Row, or the same Column or on the same diagonal."},
#else
{6, 6, 0x0000000000000000, "RW", "Stripe", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{3, 5, 0x0000000000000000, "RW", "Address_Direction", "[b]Address_Direction[/b][br]\r\n"
"There are 4 basic address directions and their inverse for a total of 8.[br]\r\n"
"We will denote this as a combination of a 1-bit field and a 2-bit field.[br]\r\n"
"[b](0)(00)  FastY -North[/b][br]\r\n"
" Increment Column and Carry Increment into Row.[br]\r\n"
"[b](1)(00) Inv(FastY) - South[/b][br]\r\n"
" Decrement Column and Carry Decrement into Row.[br]\r\n"
"[b](0)(01) Diagonal  North East[/b][br]\r\n"
" Increment Row and Column together and Carry Increment Column into Row.[br]\r\n"
"[b](1)(01) Inv(Diagonal)  South West[/b][br]\r\n"
" Decrement Row and Column together and Carry Decrement Column into Row.[br]\r\n"
"[b](0)(10) FastX  East[/b][br]\r\n"
" Increment Row and Carry Increment into Column.[br]\r\n"
"[b](1)(10) Inv(FastX) - West[/b][br]\r\n"
" Decrement Row and Carry Decrement into Column.[br]\r\n"
"[b](0)(11) Diagonal2 - South East[/b][br]\r\n"
" Decrement Column and Increment Row and Carry Increment Column into Row.[br]\r\n"
"[b](1)(11) Inv(Diagonal2)  North West [/b][br]\r\n"
" Increment Column and Decrement Row and Carry Decrement Column into Row.[br]\r\n"
"\r\n"
"Offset accesses begin one 'step' in the given direction from the current Base_Address."},
#else
{3, 5, 0x0000000000000000, "RW", "Address_Direction", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{2, 2, 0x0000000000000000, "RW", "Periodic_Data_Inv_En", "Enabled periodic data inversion - based on Address_Direction (OrderX field) -normally invert every 2^Block_Size_Bits_Row/Col, modified based on Periodic_Data_Inversion_Adjustment"},
#else
{2, 2, 0x0000000000000000, "RW", "Periodic_Data_Inv_En", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 1, 0x0000000000000000, "RW", "Periodic_Data_Inv_Adj", "Reduce or increase the inversion interval by -1,0,1 based on the value in this field.[br]00 - no adjust[br]01 - interval is increased by 1[br]11 - interval is decreased by 1[br]10 - reserved"},
#else
{0, 1, 0x0000000000000000, "RW", "Periodic_Data_Inv_Adj", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo133[] = {{"CPGC2_OFFSET_ADDRESS_INSTRUCTION_4_", "", 0x0000007C, 5, 0x00000000000000FF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields134[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{7, 7, 0x0000000000000000, "RW", "Last", "Last Offset_Address_Instruction. The offset instruction is complete after all Offset_Address, Offset_Repeats, and Offset_Commands have finished."},
#else
{7, 7, 0x0000000000000000, "RW", "Last", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{6, 6, 0x0000000000000000, "RW", "Stripe", "Normal Offsets use Address_Order=110[br]\r\n"
"This allows full traversal of the entire Block by and offset.[br]\r\n"
"If Stripe is active, then there is no carry between Row and Column. This will keep the offset address within the same Row, or the same Column or on the same diagonal."},
#else
{6, 6, 0x0000000000000000, "RW", "Stripe", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{3, 5, 0x0000000000000000, "RW", "Address_Direction", "[b]Address_Direction[/b][br]\r\n"
"There are 4 basic address directions and their inverse for a total of 8.[br]\r\n"
"We will denote this as a combination of a 1-bit field and a 2-bit field.[br]\r\n"
"[b](0)(00)  FastY -North[/b][br]\r\n"
" Increment Column and Carry Increment into Row.[br]\r\n"
"[b](1)(00) Inv(FastY) - South[/b][br]\r\n"
" Decrement Column and Carry Decrement into Row.[br]\r\n"
"[b](0)(01) Diagonal  North East[/b][br]\r\n"
" Increment Row and Column together and Carry Increment Column into Row.[br]\r\n"
"[b](1)(01) Inv(Diagonal)  South West[/b][br]\r\n"
" Decrement Row and Column together and Carry Decrement Column into Row.[br]\r\n"
"[b](0)(10) FastX  East[/b][br]\r\n"
" Increment Row and Carry Increment into Column.[br]\r\n"
"[b](1)(10) Inv(FastX) - West[/b][br]\r\n"
" Decrement Row and Carry Decrement into Column.[br]\r\n"
"[b](0)(11) Diagonal2 - South East[/b][br]\r\n"
" Decrement Column and Increment Row and Carry Increment Column into Row.[br]\r\n"
"[b](1)(11) Inv(Diagonal2)  North West [/b][br]\r\n"
" Increment Column and Decrement Row and Carry Decrement Column into Row.[br]\r\n"
"\r\n"
"Offset accesses begin one 'step' in the given direction from the current Base_Address."},
#else
{3, 5, 0x0000000000000000, "RW", "Address_Direction", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{2, 2, 0x0000000000000000, "RW", "Periodic_Data_Inv_En", "Enabled periodic data inversion - based on Address_Direction (OrderX field) -normally invert every 2^Block_Size_Bits_Row/Col, modified based on Periodic_Data_Inversion_Adjustment"},
#else
{2, 2, 0x0000000000000000, "RW", "Periodic_Data_Inv_En", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 1, 0x0000000000000000, "RW", "Periodic_Data_Inv_Adj", "Reduce or increase the inversion interval by -1,0,1 based on the value in this field.[br]00 - no adjust[br]01 - interval is increased by 1[br]11 - interval is decreased by 1[br]10 - reserved"},
#else
{0, 1, 0x0000000000000000, "RW", "Periodic_Data_Inv_Adj", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo134[] = {{"CPGC2_OFFSET_ADDRESS_INSTRUCTION_5_", "", 0x0000007D, 5, 0x00000000000000FF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields135[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{7, 7, 0x0000000000000000, "RW", "Last", "Last Offset_Address_Instruction. The offset instruction is complete after all Offset_Address, Offset_Repeats, and Offset_Commands have finished."},
#else
{7, 7, 0x0000000000000000, "RW", "Last", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{6, 6, 0x0000000000000000, "RW", "Stripe", "Normal Offsets use Address_Order=110[br]\r\n"
"This allows full traversal of the entire Block by and offset.[br]\r\n"
"If Stripe is active, then there is no carry between Row and Column. This will keep the offset address within the same Row, or the same Column or on the same diagonal."},
#else
{6, 6, 0x0000000000000000, "RW", "Stripe", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{3, 5, 0x0000000000000000, "RW", "Address_Direction", "[b]Address_Direction[/b][br]\r\n"
"There are 4 basic address directions and their inverse for a total of 8.[br]\r\n"
"We will denote this as a combination of a 1-bit field and a 2-bit field.[br]\r\n"
"[b](0)(00)  FastY -North[/b][br]\r\n"
" Increment Column and Carry Increment into Row.[br]\r\n"
"[b](1)(00) Inv(FastY) - South[/b][br]\r\n"
" Decrement Column and Carry Decrement into Row.[br]\r\n"
"[b](0)(01) Diagonal  North East[/b][br]\r\n"
" Increment Row and Column together and Carry Increment Column into Row.[br]\r\n"
"[b](1)(01) Inv(Diagonal)  South West[/b][br]\r\n"
" Decrement Row and Column together and Carry Decrement Column into Row.[br]\r\n"
"[b](0)(10) FastX  East[/b][br]\r\n"
" Increment Row and Carry Increment into Column.[br]\r\n"
"[b](1)(10) Inv(FastX) - West[/b][br]\r\n"
" Decrement Row and Carry Decrement into Column.[br]\r\n"
"[b](0)(11) Diagonal2 - South East[/b][br]\r\n"
" Decrement Column and Increment Row and Carry Increment Column into Row.[br]\r\n"
"[b](1)(11) Inv(Diagonal2)  North West [/b][br]\r\n"
" Increment Column and Decrement Row and Carry Decrement Column into Row.[br]\r\n"
"\r\n"
"Offset accesses begin one 'step' in the given direction from the current Base_Address."},
#else
{3, 5, 0x0000000000000000, "RW", "Address_Direction", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{2, 2, 0x0000000000000000, "RW", "Periodic_Data_Inv_En", "Enabled periodic data inversion - based on Address_Direction (OrderX field) -normally invert every 2^Block_Size_Bits_Row/Col, modified based on Periodic_Data_Inversion_Adjustment"},
#else
{2, 2, 0x0000000000000000, "RW", "Periodic_Data_Inv_En", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 1, 0x0000000000000000, "RW", "Periodic_Data_Inv_Adj", "Reduce or increase the inversion interval by -1,0,1 based on the value in this field.[br]00 - no adjust[br]01 - interval is increased by 1[br]11 - interval is decreased by 1[br]10 - reserved"},
#else
{0, 1, 0x0000000000000000, "RW", "Periodic_Data_Inv_Adj", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo135[] = {{"CPGC2_OFFSET_ADDRESS_INSTRUCTION_6_", "", 0x0000007E, 5, 0x00000000000000FF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields136[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{7, 7, 0x0000000000000000, "RW", "Last", "Last Offset_Address_Instruction. The offset instruction is complete after all Offset_Address, Offset_Repeats, and Offset_Commands have finished."},
#else
{7, 7, 0x0000000000000000, "RW", "Last", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{6, 6, 0x0000000000000000, "RW", "Stripe", "Normal Offsets use Address_Order=110[br]\r\n"
"This allows full traversal of the entire Block by and offset.[br]\r\n"
"If Stripe is active, then there is no carry between Row and Column. This will keep the offset address within the same Row, or the same Column or on the same diagonal."},
#else
{6, 6, 0x0000000000000000, "RW", "Stripe", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{3, 5, 0x0000000000000000, "RW", "Address_Direction", "[b]Address_Direction[/b][br]\r\n"
"There are 4 basic address directions and their inverse for a total of 8.[br]\r\n"
"We will denote this as a combination of a 1-bit field and a 2-bit field.[br]\r\n"
"[b](0)(00)  FastY -North[/b][br]\r\n"
" Increment Column and Carry Increment into Row.[br]\r\n"
"[b](1)(00) Inv(FastY) - South[/b][br]\r\n"
" Decrement Column and Carry Decrement into Row.[br]\r\n"
"[b](0)(01) Diagonal  North East[/b][br]\r\n"
" Increment Row and Column together and Carry Increment Column into Row.[br]\r\n"
"[b](1)(01) Inv(Diagonal)  South West[/b][br]\r\n"
" Decrement Row and Column together and Carry Decrement Column into Row.[br]\r\n"
"[b](0)(10) FastX  East[/b][br]\r\n"
" Increment Row and Carry Increment into Column.[br]\r\n"
"[b](1)(10) Inv(FastX) - West[/b][br]\r\n"
" Decrement Row and Carry Decrement into Column.[br]\r\n"
"[b](0)(11) Diagonal2 - South East[/b][br]\r\n"
" Decrement Column and Increment Row and Carry Increment Column into Row.[br]\r\n"
"[b](1)(11) Inv(Diagonal2)  North West [/b][br]\r\n"
" Increment Column and Decrement Row and Carry Decrement Column into Row.[br]\r\n"
"\r\n"
"Offset accesses begin one 'step' in the given direction from the current Base_Address."},
#else
{3, 5, 0x0000000000000000, "RW", "Address_Direction", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{2, 2, 0x0000000000000000, "RW", "Periodic_Data_Inv_En", "Enabled periodic data inversion - based on Address_Direction (OrderX field) -normally invert every 2^Block_Size_Bits_Row/Col, modified based on Periodic_Data_Inversion_Adjustment"},
#else
{2, 2, 0x0000000000000000, "RW", "Periodic_Data_Inv_En", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 1, 0x0000000000000000, "RW", "Periodic_Data_Inv_Adj", "Reduce or increase the inversion interval by -1,0,1 based on the value in this field.[br]00 - no adjust[br]01 - interval is increased by 1[br]11 - interval is decreased by 1[br]10 - reserved"},
#else
{0, 1, 0x0000000000000000, "RW", "Periodic_Data_Inv_Adj", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo136[] = {{"CPGC2_OFFSET_ADDRESS_INSTRUCTION_7_", "", 0x0000007F, 5, 0x00000000000000FF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields137[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{7, 7, 0x0000000000000000, "RW", "Last", "Last Offset_Address_Instruction. The offset instruction is complete after all Offset_Address, Offset_Repeats, and Offset_Commands have finished."},
#else
{7, 7, 0x0000000000000000, "RW", "Last", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{6, 6, 0x0000000000000000, "RW", "Stripe", "Normal Offsets use Address_Order=110[br]\r\n"
"This allows full traversal of the entire Block by and offset.[br]\r\n"
"If Stripe is active, then there is no carry between Row and Column. This will keep the offset address within the same Row, or the same Column or on the same diagonal."},
#else
{6, 6, 0x0000000000000000, "RW", "Stripe", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{3, 5, 0x0000000000000000, "RW", "Address_Direction", "[b]Address_Direction[/b][br]\r\n"
"There are 4 basic address directions and their inverse for a total of 8.[br]\r\n"
"We will denote this as a combination of a 1-bit field and a 2-bit field.[br]\r\n"
"[b](0)(00)  FastY -North[/b][br]\r\n"
" Increment Column and Carry Increment into Row.[br]\r\n"
"[b](1)(00) Inv(FastY) - South[/b][br]\r\n"
" Decrement Column and Carry Decrement into Row.[br]\r\n"
"[b](0)(01) Diagonal  North East[/b][br]\r\n"
" Increment Row and Column together and Carry Increment Column into Row.[br]\r\n"
"[b](1)(01) Inv(Diagonal)  South West[/b][br]\r\n"
" Decrement Row and Column together and Carry Decrement Column into Row.[br]\r\n"
"[b](0)(10) FastX  East[/b][br]\r\n"
" Increment Row and Carry Increment into Column.[br]\r\n"
"[b](1)(10) Inv(FastX) - West[/b][br]\r\n"
" Decrement Row and Carry Decrement into Column.[br]\r\n"
"[b](0)(11) Diagonal2 - South East[/b][br]\r\n"
" Decrement Column and Increment Row and Carry Increment Column into Row.[br]\r\n"
"[b](1)(11) Inv(Diagonal2)  North West [/b][br]\r\n"
" Increment Column and Decrement Row and Carry Decrement Column into Row.[br]\r\n"
"\r\n"
"Offset accesses begin one 'step' in the given direction from the current Base_Address."},
#else
{3, 5, 0x0000000000000000, "RW", "Address_Direction", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{2, 2, 0x0000000000000000, "RW", "Periodic_Data_Inv_En", "Enabled periodic data inversion - based on Address_Direction (OrderX field) -normally invert every 2^Block_Size_Bits_Row/Col, modified based on Periodic_Data_Inversion_Adjustment"},
#else
{2, 2, 0x0000000000000000, "RW", "Periodic_Data_Inv_En", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 1, 0x0000000000000000, "RW", "Periodic_Data_Inv_Adj", "Reduce or increase the inversion interval by -1,0,1 based on the value in this field.[br]00 - no adjust[br]01 - interval is increased by 1[br]11 - interval is decreased by 1[br]10 - reserved"},
#else
{0, 1, 0x0000000000000000, "RW", "Periodic_Data_Inv_Adj", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo137[] = {{"CPGC2_OFFSET_ADDRESS_INSTRUCTION_8_", "", 0x00000080, 5, 0x00000000000000FF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields138[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{7, 7, 0x0000000000000000, "RW", "Last", "Last Offset_Address_Instruction. The offset instruction is complete after all Offset_Address, Offset_Repeats, and Offset_Commands have finished."},
#else
{7, 7, 0x0000000000000000, "RW", "Last", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{6, 6, 0x0000000000000000, "RW", "Stripe", "Normal Offsets use Address_Order=110[br]\r\n"
"This allows full traversal of the entire Block by and offset.[br]\r\n"
"If Stripe is active, then there is no carry between Row and Column. This will keep the offset address within the same Row, or the same Column or on the same diagonal."},
#else
{6, 6, 0x0000000000000000, "RW", "Stripe", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{3, 5, 0x0000000000000000, "RW", "Address_Direction", "[b]Address_Direction[/b][br]\r\n"
"There are 4 basic address directions and their inverse for a total of 8.[br]\r\n"
"We will denote this as a combination of a 1-bit field and a 2-bit field.[br]\r\n"
"[b](0)(00)  FastY -North[/b][br]\r\n"
" Increment Column and Carry Increment into Row.[br]\r\n"
"[b](1)(00) Inv(FastY) - South[/b][br]\r\n"
" Decrement Column and Carry Decrement into Row.[br]\r\n"
"[b](0)(01) Diagonal  North East[/b][br]\r\n"
" Increment Row and Column together and Carry Increment Column into Row.[br]\r\n"
"[b](1)(01) Inv(Diagonal)  South West[/b][br]\r\n"
" Decrement Row and Column together and Carry Decrement Column into Row.[br]\r\n"
"[b](0)(10) FastX  East[/b][br]\r\n"
" Increment Row and Carry Increment into Column.[br]\r\n"
"[b](1)(10) Inv(FastX) - West[/b][br]\r\n"
" Decrement Row and Carry Decrement into Column.[br]\r\n"
"[b](0)(11) Diagonal2 - South East[/b][br]\r\n"
" Decrement Column and Increment Row and Carry Increment Column into Row.[br]\r\n"
"[b](1)(11) Inv(Diagonal2)  North West [/b][br]\r\n"
" Increment Column and Decrement Row and Carry Decrement Column into Row.[br]\r\n"
"\r\n"
"Offset accesses begin one 'step' in the given direction from the current Base_Address."},
#else
{3, 5, 0x0000000000000000, "RW", "Address_Direction", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{2, 2, 0x0000000000000000, "RW", "Periodic_Data_Inv_En", "Enabled periodic data inversion - based on Address_Direction (OrderX field) -normally invert every 2^Block_Size_Bits_Row/Col, modified based on Periodic_Data_Inversion_Adjustment"},
#else
{2, 2, 0x0000000000000000, "RW", "Periodic_Data_Inv_En", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 1, 0x0000000000000000, "RW", "Periodic_Data_Inv_Adj", "Reduce or increase the inversion interval by -1,0,1 based on the value in this field.[br]00 - no adjust[br]01 - interval is increased by 1[br]11 - interval is decreased by 1[br]10 - reserved"},
#else
{0, 1, 0x0000000000000000, "RW", "Periodic_Data_Inv_Adj", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo138[] = {{"CPGC2_OFFSET_ADDRESS_INSTRUCTION_9_", "", 0x00000081, 5, 0x00000000000000FF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields139[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{7, 7, 0x0000000000000000, "RW", "Last", "Last Offset_Address_Instruction. The offset instruction is complete after all Offset_Address, Offset_Repeats, and Offset_Commands have finished."},
#else
{7, 7, 0x0000000000000000, "RW", "Last", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{6, 6, 0x0000000000000000, "RW", "Stripe", "Normal Offsets use Address_Order=110[br]\r\n"
"This allows full traversal of the entire Block by and offset.[br]\r\n"
"If Stripe is active, then there is no carry between Row and Column. This will keep the offset address within the same Row, or the same Column or on the same diagonal."},
#else
{6, 6, 0x0000000000000000, "RW", "Stripe", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{3, 5, 0x0000000000000000, "RW", "Address_Direction", "[b]Address_Direction[/b][br]\r\n"
"There are 4 basic address directions and their inverse for a total of 8.[br]\r\n"
"We will denote this as a combination of a 1-bit field and a 2-bit field.[br]\r\n"
"[b](0)(00)  FastY -North[/b][br]\r\n"
" Increment Column and Carry Increment into Row.[br]\r\n"
"[b](1)(00) Inv(FastY) - South[/b][br]\r\n"
" Decrement Column and Carry Decrement into Row.[br]\r\n"
"[b](0)(01) Diagonal  North East[/b][br]\r\n"
" Increment Row and Column together and Carry Increment Column into Row.[br]\r\n"
"[b](1)(01) Inv(Diagonal)  South West[/b][br]\r\n"
" Decrement Row and Column together and Carry Decrement Column into Row.[br]\r\n"
"[b](0)(10) FastX  East[/b][br]\r\n"
" Increment Row and Carry Increment into Column.[br]\r\n"
"[b](1)(10) Inv(FastX) - West[/b][br]\r\n"
" Decrement Row and Carry Decrement into Column.[br]\r\n"
"[b](0)(11) Diagonal2 - South East[/b][br]\r\n"
" Decrement Column and Increment Row and Carry Increment Column into Row.[br]\r\n"
"[b](1)(11) Inv(Diagonal2)  North West [/b][br]\r\n"
" Increment Column and Decrement Row and Carry Decrement Column into Row.[br]\r\n"
"\r\n"
"Offset accesses begin one 'step' in the given direction from the current Base_Address."},
#else
{3, 5, 0x0000000000000000, "RW", "Address_Direction", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{2, 2, 0x0000000000000000, "RW", "Periodic_Data_Inv_En", "Enabled periodic data inversion - based on Address_Direction (OrderX field) -normally invert every 2^Block_Size_Bits_Row/Col, modified based on Periodic_Data_Inversion_Adjustment"},
#else
{2, 2, 0x0000000000000000, "RW", "Periodic_Data_Inv_En", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 1, 0x0000000000000000, "RW", "Periodic_Data_Inv_Adj", "Reduce or increase the inversion interval by -1,0,1 based on the value in this field.[br]00 - no adjust[br]01 - interval is increased by 1[br]11 - interval is decreased by 1[br]10 - reserved"},
#else
{0, 1, 0x0000000000000000, "RW", "Periodic_Data_Inv_Adj", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo139[] = {{"CPGC2_OFFSET_ADDRESS_INSTRUCTION_10_", "", 0x00000082, 5, 0x00000000000000FF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields140[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{7, 7, 0x0000000000000000, "RW", "Last", "Last Offset_Address_Instruction. The offset instruction is complete after all Offset_Address, Offset_Repeats, and Offset_Commands have finished."},
#else
{7, 7, 0x0000000000000000, "RW", "Last", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{6, 6, 0x0000000000000000, "RW", "Stripe", "Normal Offsets use Address_Order=110[br]\r\n"
"This allows full traversal of the entire Block by and offset.[br]\r\n"
"If Stripe is active, then there is no carry between Row and Column. This will keep the offset address within the same Row, or the same Column or on the same diagonal."},
#else
{6, 6, 0x0000000000000000, "RW", "Stripe", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{3, 5, 0x0000000000000000, "RW", "Address_Direction", "[b]Address_Direction[/b][br]\r\n"
"There are 4 basic address directions and their inverse for a total of 8.[br]\r\n"
"We will denote this as a combination of a 1-bit field and a 2-bit field.[br]\r\n"
"[b](0)(00)  FastY -North[/b][br]\r\n"
" Increment Column and Carry Increment into Row.[br]\r\n"
"[b](1)(00) Inv(FastY) - South[/b][br]\r\n"
" Decrement Column and Carry Decrement into Row.[br]\r\n"
"[b](0)(01) Diagonal  North East[/b][br]\r\n"
" Increment Row and Column together and Carry Increment Column into Row.[br]\r\n"
"[b](1)(01) Inv(Diagonal)  South West[/b][br]\r\n"
" Decrement Row and Column together and Carry Decrement Column into Row.[br]\r\n"
"[b](0)(10) FastX  East[/b][br]\r\n"
" Increment Row and Carry Increment into Column.[br]\r\n"
"[b](1)(10) Inv(FastX) - West[/b][br]\r\n"
" Decrement Row and Carry Decrement into Column.[br]\r\n"
"[b](0)(11) Diagonal2 - South East[/b][br]\r\n"
" Decrement Column and Increment Row and Carry Increment Column into Row.[br]\r\n"
"[b](1)(11) Inv(Diagonal2)  North West [/b][br]\r\n"
" Increment Column and Decrement Row and Carry Decrement Column into Row.[br]\r\n"
"\r\n"
"Offset accesses begin one 'step' in the given direction from the current Base_Address."},
#else
{3, 5, 0x0000000000000000, "RW", "Address_Direction", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{2, 2, 0x0000000000000000, "RW", "Periodic_Data_Inv_En", "Enabled periodic data inversion - based on Address_Direction (OrderX field) -normally invert every 2^Block_Size_Bits_Row/Col, modified based on Periodic_Data_Inversion_Adjustment"},
#else
{2, 2, 0x0000000000000000, "RW", "Periodic_Data_Inv_En", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 1, 0x0000000000000000, "RW", "Periodic_Data_Inv_Adj", "Reduce or increase the inversion interval by -1,0,1 based on the value in this field.[br]00 - no adjust[br]01 - interval is increased by 1[br]11 - interval is decreased by 1[br]10 - reserved"},
#else
{0, 1, 0x0000000000000000, "RW", "Periodic_Data_Inv_Adj", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo140[] = {{"CPGC2_OFFSET_ADDRESS_INSTRUCTION_11_", "", 0x00000083, 5, 0x00000000000000FF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields141[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{7, 7, 0x0000000000000000, "RW", "Last", "Last Offset_Address_Instruction. The offset instruction is complete after all Offset_Address, Offset_Repeats, and Offset_Commands have finished."},
#else
{7, 7, 0x0000000000000000, "RW", "Last", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{6, 6, 0x0000000000000000, "RW", "Stripe", "Normal Offsets use Address_Order=110[br]\r\n"
"This allows full traversal of the entire Block by and offset.[br]\r\n"
"If Stripe is active, then there is no carry between Row and Column. This will keep the offset address within the same Row, or the same Column or on the same diagonal."},
#else
{6, 6, 0x0000000000000000, "RW", "Stripe", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{3, 5, 0x0000000000000000, "RW", "Address_Direction", "[b]Address_Direction[/b][br]\r\n"
"There are 4 basic address directions and their inverse for a total of 8.[br]\r\n"
"We will denote this as a combination of a 1-bit field and a 2-bit field.[br]\r\n"
"[b](0)(00)  FastY -North[/b][br]\r\n"
" Increment Column and Carry Increment into Row.[br]\r\n"
"[b](1)(00) Inv(FastY) - South[/b][br]\r\n"
" Decrement Column and Carry Decrement into Row.[br]\r\n"
"[b](0)(01) Diagonal  North East[/b][br]\r\n"
" Increment Row and Column together and Carry Increment Column into Row.[br]\r\n"
"[b](1)(01) Inv(Diagonal)  South West[/b][br]\r\n"
" Decrement Row and Column together and Carry Decrement Column into Row.[br]\r\n"
"[b](0)(10) FastX  East[/b][br]\r\n"
" Increment Row and Carry Increment into Column.[br]\r\n"
"[b](1)(10) Inv(FastX) - West[/b][br]\r\n"
" Decrement Row and Carry Decrement into Column.[br]\r\n"
"[b](0)(11) Diagonal2 - South East[/b][br]\r\n"
" Decrement Column and Increment Row and Carry Increment Column into Row.[br]\r\n"
"[b](1)(11) Inv(Diagonal2)  North West [/b][br]\r\n"
" Increment Column and Decrement Row and Carry Decrement Column into Row.[br]\r\n"
"\r\n"
"Offset accesses begin one 'step' in the given direction from the current Base_Address."},
#else
{3, 5, 0x0000000000000000, "RW", "Address_Direction", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{2, 2, 0x0000000000000000, "RW", "Periodic_Data_Inv_En", "Enabled periodic data inversion - based on Address_Direction (OrderX field) -normally invert every 2^Block_Size_Bits_Row/Col, modified based on Periodic_Data_Inversion_Adjustment"},
#else
{2, 2, 0x0000000000000000, "RW", "Periodic_Data_Inv_En", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 1, 0x0000000000000000, "RW", "Periodic_Data_Inv_Adj", "Reduce or increase the inversion interval by -1,0,1 based on the value in this field.[br]00 - no adjust[br]01 - interval is increased by 1[br]11 - interval is decreased by 1[br]10 - reserved"},
#else
{0, 1, 0x0000000000000000, "RW", "Periodic_Data_Inv_Adj", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo141[] = {{"CPGC2_OFFSET_ADDRESS_INSTRUCTION_12_", "", 0x00000084, 5, 0x00000000000000FF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields142[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{7, 7, 0x0000000000000000, "RW", "Last", "Last Offset_Address_Instruction. The offset instruction is complete after all Offset_Address, Offset_Repeats, and Offset_Commands have finished."},
#else
{7, 7, 0x0000000000000000, "RW", "Last", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{6, 6, 0x0000000000000000, "RW", "Stripe", "Normal Offsets use Address_Order=110[br]\r\n"
"This allows full traversal of the entire Block by and offset.[br]\r\n"
"If Stripe is active, then there is no carry between Row and Column. This will keep the offset address within the same Row, or the same Column or on the same diagonal."},
#else
{6, 6, 0x0000000000000000, "RW", "Stripe", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{3, 5, 0x0000000000000000, "RW", "Address_Direction", "[b]Address_Direction[/b][br]\r\n"
"There are 4 basic address directions and their inverse for a total of 8.[br]\r\n"
"We will denote this as a combination of a 1-bit field and a 2-bit field.[br]\r\n"
"[b](0)(00)  FastY -North[/b][br]\r\n"
" Increment Column and Carry Increment into Row.[br]\r\n"
"[b](1)(00) Inv(FastY) - South[/b][br]\r\n"
" Decrement Column and Carry Decrement into Row.[br]\r\n"
"[b](0)(01) Diagonal  North East[/b][br]\r\n"
" Increment Row and Column together and Carry Increment Column into Row.[br]\r\n"
"[b](1)(01) Inv(Diagonal)  South West[/b][br]\r\n"
" Decrement Row and Column together and Carry Decrement Column into Row.[br]\r\n"
"[b](0)(10) FastX  East[/b][br]\r\n"
" Increment Row and Carry Increment into Column.[br]\r\n"
"[b](1)(10) Inv(FastX) - West[/b][br]\r\n"
" Decrement Row and Carry Decrement into Column.[br]\r\n"
"[b](0)(11) Diagonal2 - South East[/b][br]\r\n"
" Decrement Column and Increment Row and Carry Increment Column into Row.[br]\r\n"
"[b](1)(11) Inv(Diagonal2)  North West [/b][br]\r\n"
" Increment Column and Decrement Row and Carry Decrement Column into Row.[br]\r\n"
"\r\n"
"Offset accesses begin one 'step' in the given direction from the current Base_Address."},
#else
{3, 5, 0x0000000000000000, "RW", "Address_Direction", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{2, 2, 0x0000000000000000, "RW", "Periodic_Data_Inv_En", "Enabled periodic data inversion - based on Address_Direction (OrderX field) -normally invert every 2^Block_Size_Bits_Row/Col, modified based on Periodic_Data_Inversion_Adjustment"},
#else
{2, 2, 0x0000000000000000, "RW", "Periodic_Data_Inv_En", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 1, 0x0000000000000000, "RW", "Periodic_Data_Inv_Adj", "Reduce or increase the inversion interval by -1,0,1 based on the value in this field.[br]00 - no adjust[br]01 - interval is increased by 1[br]11 - interval is decreased by 1[br]10 - reserved"},
#else
{0, 1, 0x0000000000000000, "RW", "Periodic_Data_Inv_Adj", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo142[] = {{"CPGC2_OFFSET_ADDRESS_INSTRUCTION_13_", "", 0x00000085, 5, 0x00000000000000FF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields143[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{7, 7, 0x0000000000000000, "RW", "Last", "Last Offset_Address_Instruction. The offset instruction is complete after all Offset_Address, Offset_Repeats, and Offset_Commands have finished."},
#else
{7, 7, 0x0000000000000000, "RW", "Last", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{6, 6, 0x0000000000000000, "RW", "Stripe", "Normal Offsets use Address_Order=110[br]\r\n"
"This allows full traversal of the entire Block by and offset.[br]\r\n"
"If Stripe is active, then there is no carry between Row and Column. This will keep the offset address within the same Row, or the same Column or on the same diagonal."},
#else
{6, 6, 0x0000000000000000, "RW", "Stripe", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{3, 5, 0x0000000000000000, "RW", "Address_Direction", "[b]Address_Direction[/b][br]\r\n"
"There are 4 basic address directions and their inverse for a total of 8.[br]\r\n"
"We will denote this as a combination of a 1-bit field and a 2-bit field.[br]\r\n"
"[b](0)(00)  FastY -North[/b][br]\r\n"
" Increment Column and Carry Increment into Row.[br]\r\n"
"[b](1)(00) Inv(FastY) - South[/b][br]\r\n"
" Decrement Column and Carry Decrement into Row.[br]\r\n"
"[b](0)(01) Diagonal  North East[/b][br]\r\n"
" Increment Row and Column together and Carry Increment Column into Row.[br]\r\n"
"[b](1)(01) Inv(Diagonal)  South West[/b][br]\r\n"
" Decrement Row and Column together and Carry Decrement Column into Row.[br]\r\n"
"[b](0)(10) FastX  East[/b][br]\r\n"
" Increment Row and Carry Increment into Column.[br]\r\n"
"[b](1)(10) Inv(FastX) - West[/b][br]\r\n"
" Decrement Row and Carry Decrement into Column.[br]\r\n"
"[b](0)(11) Diagonal2 - South East[/b][br]\r\n"
" Decrement Column and Increment Row and Carry Increment Column into Row.[br]\r\n"
"[b](1)(11) Inv(Diagonal2)  North West [/b][br]\r\n"
" Increment Column and Decrement Row and Carry Decrement Column into Row.[br]\r\n"
"\r\n"
"Offset accesses begin one 'step' in the given direction from the current Base_Address."},
#else
{3, 5, 0x0000000000000000, "RW", "Address_Direction", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{2, 2, 0x0000000000000000, "RW", "Periodic_Data_Inv_En", "Enabled periodic data inversion - based on Address_Direction (OrderX field) -normally invert every 2^Block_Size_Bits_Row/Col, modified based on Periodic_Data_Inversion_Adjustment"},
#else
{2, 2, 0x0000000000000000, "RW", "Periodic_Data_Inv_En", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 1, 0x0000000000000000, "RW", "Periodic_Data_Inv_Adj", "Reduce or increase the inversion interval by -1,0,1 based on the value in this field.[br]00 - no adjust[br]01 - interval is increased by 1[br]11 - interval is decreased by 1[br]10 - reserved"},
#else
{0, 1, 0x0000000000000000, "RW", "Periodic_Data_Inv_Adj", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo143[] = {{"CPGC2_OFFSET_ADDRESS_INSTRUCTION_14_", "", 0x00000086, 5, 0x00000000000000FF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields144[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{7, 7, 0x0000000000000000, "RW", "Last", "Last Offset_Address_Instruction. The offset instruction is complete after all Offset_Address, Offset_Repeats, and Offset_Commands have finished."},
#else
{7, 7, 0x0000000000000000, "RW", "Last", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{6, 6, 0x0000000000000000, "RW", "Stripe", "Normal Offsets use Address_Order=110[br]\r\n"
"This allows full traversal of the entire Block by and offset.[br]\r\n"
"If Stripe is active, then there is no carry between Row and Column. This will keep the offset address within the same Row, or the same Column or on the same diagonal."},
#else
{6, 6, 0x0000000000000000, "RW", "Stripe", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{3, 5, 0x0000000000000000, "RW", "Address_Direction", "[b]Address_Direction[/b][br]\r\n"
"There are 4 basic address directions and their inverse for a total of 8.[br]\r\n"
"We will denote this as a combination of a 1-bit field and a 2-bit field.[br]\r\n"
"[b](0)(00)  FastY -North[/b][br]\r\n"
" Increment Column and Carry Increment into Row.[br]\r\n"
"[b](1)(00) Inv(FastY) - South[/b][br]\r\n"
" Decrement Column and Carry Decrement into Row.[br]\r\n"
"[b](0)(01) Diagonal  North East[/b][br]\r\n"
" Increment Row and Column together and Carry Increment Column into Row.[br]\r\n"
"[b](1)(01) Inv(Diagonal)  South West[/b][br]\r\n"
" Decrement Row and Column together and Carry Decrement Column into Row.[br]\r\n"
"[b](0)(10) FastX  East[/b][br]\r\n"
" Increment Row and Carry Increment into Column.[br]\r\n"
"[b](1)(10) Inv(FastX) - West[/b][br]\r\n"
" Decrement Row and Carry Decrement into Column.[br]\r\n"
"[b](0)(11) Diagonal2 - South East[/b][br]\r\n"
" Decrement Column and Increment Row and Carry Increment Column into Row.[br]\r\n"
"[b](1)(11) Inv(Diagonal2)  North West [/b][br]\r\n"
" Increment Column and Decrement Row and Carry Decrement Column into Row.[br]\r\n"
"\r\n"
"Offset accesses begin one 'step' in the given direction from the current Base_Address."},
#else
{3, 5, 0x0000000000000000, "RW", "Address_Direction", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{2, 2, 0x0000000000000000, "RW", "Periodic_Data_Inv_En", "Enabled periodic data inversion - based on Address_Direction (OrderX field) -normally invert every 2^Block_Size_Bits_Row/Col, modified based on Periodic_Data_Inversion_Adjustment"},
#else
{2, 2, 0x0000000000000000, "RW", "Periodic_Data_Inv_En", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 1, 0x0000000000000000, "RW", "Periodic_Data_Inv_Adj", "Reduce or increase the inversion interval by -1,0,1 based on the value in this field.[br]00 - no adjust[br]01 - interval is increased by 1[br]11 - interval is decreased by 1[br]10 - reserved"},
#else
{0, 1, 0x0000000000000000, "RW", "Periodic_Data_Inv_Adj", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo144[] = {{"CPGC2_OFFSET_ADDRESS_INSTRUCTION_15_", "", 0x00000087, 5, 0x00000000000000FF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields145[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{7, 7, 0x0000000000000000, "RW", "Last", "Last Offset_Command_Instruction. The offset instruction is complete after all Offset_Address, Offset_Repeats, and Offset_Commands have finished."},
#else
{7, 7, 0x0000000000000000, "RW", "Last", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{6, 6, 0x0000000000000000, "RW", "Invert_Data", "Invert all data for this Offset_Command_Instruction.  Combine the Data_Instruction Invert_Data field, the Algorithm_Instruction  Invert_Data field, Command_Instruction Invert_Data field and Offset_Command_Instruction Invert_Data field to determine the final data polarity."},
#else
{6, 6, 0x0000000000000000, "RW", "Invert_Data", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{4, 4, 0x0000000000000000, "RW", "Alternate_Data", "Use the alternate zero data source instead of the UniSequencers and Pattern_Select."},
#else
{4, 4, 0x0000000000000000, "RW", "Alternate_Data", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{3, 3, 0x0000000000000000, "RW", "Hammer", "This Offset command will be repeated Hammer_Repeats times"},
#else
{3, 3, 0x0000000000000000, "RW", "Hammer", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{2, 2, 0x0000000000000000, "RW", "Offset", "1=Normal Offset Command/Address, 0=Use Base Address and Offset_Command_Instruction Write bit"},
#else
{2, 2, 0x0000000000000000, "RW", "Offset", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 0, 0x0000000000000000, "RW", "Write", "A Write operation will be performed at the Offset (or Base if the Offset field = 0) Address."},
#else
{0, 0, 0x0000000000000000, "RW", "Write", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo145[] = {{"CPGC2_OFFSET_COMMAND_INSTRUCTION_0_", "", 0x00000088, 6, 0x00000000000000FF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields146[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{7, 7, 0x0000000000000000, "RW", "Last", "Last Offset_Command_Instruction. The offset instruction is complete after all Offset_Address, Offset_Repeats, and Offset_Commands have finished."},
#else
{7, 7, 0x0000000000000000, "RW", "Last", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{6, 6, 0x0000000000000000, "RW", "Invert_Data", "Invert all data for this Offset_Command_Instruction.  Combine the Data_Instruction Invert_Data field, the Algorithm_Instruction  Invert_Data field, Command_Instruction Invert_Data field and Offset_Command_Instruction Invert_Data field to determine the final data polarity."},
#else
{6, 6, 0x0000000000000000, "RW", "Invert_Data", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{4, 4, 0x0000000000000000, "RW", "Alternate_Data", "Use the alternate zero data source instead of the UniSequencers and Pattern_Select."},
#else
{4, 4, 0x0000000000000000, "RW", "Alternate_Data", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{3, 3, 0x0000000000000000, "RW", "Hammer", "This Offset command will be repeated Hammer_Repeats times"},
#else
{3, 3, 0x0000000000000000, "RW", "Hammer", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{2, 2, 0x0000000000000000, "RW", "Offset", "1=Normal Offset Command/Address, 0=Use Base Address and Offset_Command_Instruction Write bit"},
#else
{2, 2, 0x0000000000000000, "RW", "Offset", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 0, 0x0000000000000000, "RW", "Write", "A Write operation will be performed at the Offset (or Base if the Offset field = 0) Address."},
#else
{0, 0, 0x0000000000000000, "RW", "Write", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo146[] = {{"CPGC2_OFFSET_COMMAND_INSTRUCTION_1_", "", 0x00000089, 6, 0x00000000000000FF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields147[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{7, 7, 0x0000000000000000, "RW", "Last", "Last Offset_Command_Instruction. The offset instruction is complete after all Offset_Address, Offset_Repeats, and Offset_Commands have finished."},
#else
{7, 7, 0x0000000000000000, "RW", "Last", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{6, 6, 0x0000000000000000, "RW", "Invert_Data", "Invert all data for this Offset_Command_Instruction.  Combine the Data_Instruction Invert_Data field, the Algorithm_Instruction  Invert_Data field, Command_Instruction Invert_Data field and Offset_Command_Instruction Invert_Data field to determine the final data polarity."},
#else
{6, 6, 0x0000000000000000, "RW", "Invert_Data", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{4, 4, 0x0000000000000000, "RW", "Alternate_Data", "Use the alternate zero data source instead of the UniSequencers and Pattern_Select."},
#else
{4, 4, 0x0000000000000000, "RW", "Alternate_Data", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{3, 3, 0x0000000000000000, "RW", "Hammer", "This Offset command will be repeated Hammer_Repeats times"},
#else
{3, 3, 0x0000000000000000, "RW", "Hammer", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{2, 2, 0x0000000000000000, "RW", "Offset", "1=Normal Offset Command/Address, 0=Use Base Address and Offset_Command_Instruction Write bit"},
#else
{2, 2, 0x0000000000000000, "RW", "Offset", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 0, 0x0000000000000000, "RW", "Write", "A Write operation will be performed at the Offset (or Base if the Offset field = 0) Address."},
#else
{0, 0, 0x0000000000000000, "RW", "Write", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo147[] = {{"CPGC2_OFFSET_COMMAND_INSTRUCTION_2_", "", 0x0000008A, 6, 0x00000000000000FF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields148[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{7, 7, 0x0000000000000000, "RW", "Last", "Last Offset_Command_Instruction. The offset instruction is complete after all Offset_Address, Offset_Repeats, and Offset_Commands have finished."},
#else
{7, 7, 0x0000000000000000, "RW", "Last", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{6, 6, 0x0000000000000000, "RW", "Invert_Data", "Invert all data for this Offset_Command_Instruction.  Combine the Data_Instruction Invert_Data field, the Algorithm_Instruction  Invert_Data field, Command_Instruction Invert_Data field and Offset_Command_Instruction Invert_Data field to determine the final data polarity."},
#else
{6, 6, 0x0000000000000000, "RW", "Invert_Data", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{4, 4, 0x0000000000000000, "RW", "Alternate_Data", "Use the alternate zero data source instead of the UniSequencers and Pattern_Select."},
#else
{4, 4, 0x0000000000000000, "RW", "Alternate_Data", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{3, 3, 0x0000000000000000, "RW", "Hammer", "This Offset command will be repeated Hammer_Repeats times"},
#else
{3, 3, 0x0000000000000000, "RW", "Hammer", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{2, 2, 0x0000000000000000, "RW", "Offset", "1=Normal Offset Command/Address, 0=Use Base Address and Offset_Command_Instruction Write bit"},
#else
{2, 2, 0x0000000000000000, "RW", "Offset", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 0, 0x0000000000000000, "RW", "Write", "A Write operation will be performed at the Offset (or Base if the Offset field = 0) Address."},
#else
{0, 0, 0x0000000000000000, "RW", "Write", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo148[] = {{"CPGC2_OFFSET_COMMAND_INSTRUCTION_3_", "", 0x0000008B, 6, 0x00000000000000FF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields149[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{7, 7, 0x0000000000000000, "RW", "Last", "Last Offset_Command_Instruction. The offset instruction is complete after all Offset_Address, Offset_Repeats, and Offset_Commands have finished."},
#else
{7, 7, 0x0000000000000000, "RW", "Last", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{6, 6, 0x0000000000000000, "RW", "Invert_Data", "Invert all data for this Offset_Command_Instruction.  Combine the Data_Instruction Invert_Data field, the Algorithm_Instruction  Invert_Data field, Command_Instruction Invert_Data field and Offset_Command_Instruction Invert_Data field to determine the final data polarity."},
#else
{6, 6, 0x0000000000000000, "RW", "Invert_Data", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{4, 4, 0x0000000000000000, "RW", "Alternate_Data", "Use the alternate zero data source instead of the UniSequencers and Pattern_Select."},
#else
{4, 4, 0x0000000000000000, "RW", "Alternate_Data", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{3, 3, 0x0000000000000000, "RW", "Hammer", "This Offset command will be repeated Hammer_Repeats times"},
#else
{3, 3, 0x0000000000000000, "RW", "Hammer", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{2, 2, 0x0000000000000000, "RW", "Offset", "1=Normal Offset Command/Address, 0=Use Base Address and Offset_Command_Instruction Write bit"},
#else
{2, 2, 0x0000000000000000, "RW", "Offset", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 0, 0x0000000000000000, "RW", "Write", "A Write operation will be performed at the Offset (or Base if the Offset field = 0) Address."},
#else
{0, 0, 0x0000000000000000, "RW", "Write", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo149[] = {{"CPGC2_OFFSET_COMMAND_INSTRUCTION_4_", "", 0x0000008C, 6, 0x00000000000000FF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields150[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{7, 7, 0x0000000000000000, "RW", "Last", "Last Offset_Command_Instruction. The offset instruction is complete after all Offset_Address, Offset_Repeats, and Offset_Commands have finished."},
#else
{7, 7, 0x0000000000000000, "RW", "Last", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{6, 6, 0x0000000000000000, "RW", "Invert_Data", "Invert all data for this Offset_Command_Instruction.  Combine the Data_Instruction Invert_Data field, the Algorithm_Instruction  Invert_Data field, Command_Instruction Invert_Data field and Offset_Command_Instruction Invert_Data field to determine the final data polarity."},
#else
{6, 6, 0x0000000000000000, "RW", "Invert_Data", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{4, 4, 0x0000000000000000, "RW", "Alternate_Data", "Use the alternate zero data source instead of the UniSequencers and Pattern_Select."},
#else
{4, 4, 0x0000000000000000, "RW", "Alternate_Data", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{3, 3, 0x0000000000000000, "RW", "Hammer", "This Offset command will be repeated Hammer_Repeats times"},
#else
{3, 3, 0x0000000000000000, "RW", "Hammer", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{2, 2, 0x0000000000000000, "RW", "Offset", "1=Normal Offset Command/Address, 0=Use Base Address and Offset_Command_Instruction Write bit"},
#else
{2, 2, 0x0000000000000000, "RW", "Offset", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 0, 0x0000000000000000, "RW", "Write", "A Write operation will be performed at the Offset (or Base if the Offset field = 0) Address."},
#else
{0, 0, 0x0000000000000000, "RW", "Write", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo150[] = {{"CPGC2_OFFSET_COMMAND_INSTRUCTION_5_", "", 0x0000008D, 6, 0x00000000000000FF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields151[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{7, 7, 0x0000000000000000, "RW", "Last", "Last Offset_Command_Instruction. The offset instruction is complete after all Offset_Address, Offset_Repeats, and Offset_Commands have finished."},
#else
{7, 7, 0x0000000000000000, "RW", "Last", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{6, 6, 0x0000000000000000, "RW", "Invert_Data", "Invert all data for this Offset_Command_Instruction.  Combine the Data_Instruction Invert_Data field, the Algorithm_Instruction  Invert_Data field, Command_Instruction Invert_Data field and Offset_Command_Instruction Invert_Data field to determine the final data polarity."},
#else
{6, 6, 0x0000000000000000, "RW", "Invert_Data", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{4, 4, 0x0000000000000000, "RW", "Alternate_Data", "Use the alternate zero data source instead of the UniSequencers and Pattern_Select."},
#else
{4, 4, 0x0000000000000000, "RW", "Alternate_Data", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{3, 3, 0x0000000000000000, "RW", "Hammer", "This Offset command will be repeated Hammer_Repeats times"},
#else
{3, 3, 0x0000000000000000, "RW", "Hammer", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{2, 2, 0x0000000000000000, "RW", "Offset", "1=Normal Offset Command/Address, 0=Use Base Address and Offset_Command_Instruction Write bit"},
#else
{2, 2, 0x0000000000000000, "RW", "Offset", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 0, 0x0000000000000000, "RW", "Write", "A Write operation will be performed at the Offset (or Base if the Offset field = 0) Address."},
#else
{0, 0, 0x0000000000000000, "RW", "Write", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo151[] = {{"CPGC2_OFFSET_COMMAND_INSTRUCTION_6_", "", 0x0000008E, 6, 0x00000000000000FF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields152[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{7, 7, 0x0000000000000000, "RW", "Last", "Last Offset_Command_Instruction. The offset instruction is complete after all Offset_Address, Offset_Repeats, and Offset_Commands have finished."},
#else
{7, 7, 0x0000000000000000, "RW", "Last", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{6, 6, 0x0000000000000000, "RW", "Invert_Data", "Invert all data for this Offset_Command_Instruction.  Combine the Data_Instruction Invert_Data field, the Algorithm_Instruction  Invert_Data field, Command_Instruction Invert_Data field and Offset_Command_Instruction Invert_Data field to determine the final data polarity."},
#else
{6, 6, 0x0000000000000000, "RW", "Invert_Data", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{4, 4, 0x0000000000000000, "RW", "Alternate_Data", "Use the alternate zero data source instead of the UniSequencers and Pattern_Select."},
#else
{4, 4, 0x0000000000000000, "RW", "Alternate_Data", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{3, 3, 0x0000000000000000, "RW", "Hammer", "This Offset command will be repeated Hammer_Repeats times"},
#else
{3, 3, 0x0000000000000000, "RW", "Hammer", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{2, 2, 0x0000000000000000, "RW", "Offset", "1=Normal Offset Command/Address, 0=Use Base Address and Offset_Command_Instruction Write bit"},
#else
{2, 2, 0x0000000000000000, "RW", "Offset", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 0, 0x0000000000000000, "RW", "Write", "A Write operation will be performed at the Offset (or Base if the Offset field = 0) Address."},
#else
{0, 0, 0x0000000000000000, "RW", "Write", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo152[] = {{"CPGC2_OFFSET_COMMAND_INSTRUCTION_7_", "", 0x0000008F, 6, 0x00000000000000FF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields153[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{7, 7, 0x0000000000000000, "RW", "Last", "Last Offset_Command_Instruction. The offset instruction is complete after all Offset_Address, Offset_Repeats, and Offset_Commands have finished."},
#else
{7, 7, 0x0000000000000000, "RW", "Last", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{6, 6, 0x0000000000000000, "RW", "Invert_Data", "Invert all data for this Offset_Command_Instruction.  Combine the Data_Instruction Invert_Data field, the Algorithm_Instruction  Invert_Data field, Command_Instruction Invert_Data field and Offset_Command_Instruction Invert_Data field to determine the final data polarity."},
#else
{6, 6, 0x0000000000000000, "RW", "Invert_Data", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{4, 4, 0x0000000000000000, "RW", "Alternate_Data", "Use the alternate zero data source instead of the UniSequencers and Pattern_Select."},
#else
{4, 4, 0x0000000000000000, "RW", "Alternate_Data", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{3, 3, 0x0000000000000000, "RW", "Hammer", "This Offset command will be repeated Hammer_Repeats times"},
#else
{3, 3, 0x0000000000000000, "RW", "Hammer", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{2, 2, 0x0000000000000000, "RW", "Offset", "1=Normal Offset Command/Address, 0=Use Base Address and Offset_Command_Instruction Write bit"},
#else
{2, 2, 0x0000000000000000, "RW", "Offset", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 0, 0x0000000000000000, "RW", "Write", "A Write operation will be performed at the Offset (or Base if the Offset field = 0) Address."},
#else
{0, 0, 0x0000000000000000, "RW", "Write", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo153[] = {{"CPGC2_OFFSET_COMMAND_INSTRUCTION_8_", "", 0x00000090, 6, 0x00000000000000FF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields154[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{7, 7, 0x0000000000000000, "RW", "Last", "Last Offset_Command_Instruction. The offset instruction is complete after all Offset_Address, Offset_Repeats, and Offset_Commands have finished."},
#else
{7, 7, 0x0000000000000000, "RW", "Last", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{6, 6, 0x0000000000000000, "RW", "Invert_Data", "Invert all data for this Offset_Command_Instruction.  Combine the Data_Instruction Invert_Data field, the Algorithm_Instruction  Invert_Data field, Command_Instruction Invert_Data field and Offset_Command_Instruction Invert_Data field to determine the final data polarity."},
#else
{6, 6, 0x0000000000000000, "RW", "Invert_Data", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{4, 4, 0x0000000000000000, "RW", "Alternate_Data", "Use the alternate zero data source instead of the UniSequencers and Pattern_Select."},
#else
{4, 4, 0x0000000000000000, "RW", "Alternate_Data", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{3, 3, 0x0000000000000000, "RW", "Hammer", "This Offset command will be repeated Hammer_Repeats times"},
#else
{3, 3, 0x0000000000000000, "RW", "Hammer", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{2, 2, 0x0000000000000000, "RW", "Offset", "1=Normal Offset Command/Address, 0=Use Base Address and Offset_Command_Instruction Write bit"},
#else
{2, 2, 0x0000000000000000, "RW", "Offset", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 0, 0x0000000000000000, "RW", "Write", "A Write operation will be performed at the Offset (or Base if the Offset field = 0) Address."},
#else
{0, 0, 0x0000000000000000, "RW", "Write", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo154[] = {{"CPGC2_OFFSET_COMMAND_INSTRUCTION_9_", "", 0x00000091, 6, 0x00000000000000FF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields155[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{7, 7, 0x0000000000000000, "RW", "Last", "Last Offset_Command_Instruction. The offset instruction is complete after all Offset_Address, Offset_Repeats, and Offset_Commands have finished."},
#else
{7, 7, 0x0000000000000000, "RW", "Last", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{6, 6, 0x0000000000000000, "RW", "Invert_Data", "Invert all data for this Offset_Command_Instruction.  Combine the Data_Instruction Invert_Data field, the Algorithm_Instruction  Invert_Data field, Command_Instruction Invert_Data field and Offset_Command_Instruction Invert_Data field to determine the final data polarity."},
#else
{6, 6, 0x0000000000000000, "RW", "Invert_Data", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{4, 4, 0x0000000000000000, "RW", "Alternate_Data", "Use the alternate zero data source instead of the UniSequencers and Pattern_Select."},
#else
{4, 4, 0x0000000000000000, "RW", "Alternate_Data", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{3, 3, 0x0000000000000000, "RW", "Hammer", "This Offset command will be repeated Hammer_Repeats times"},
#else
{3, 3, 0x0000000000000000, "RW", "Hammer", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{2, 2, 0x0000000000000000, "RW", "Offset", "1=Normal Offset Command/Address, 0=Use Base Address and Offset_Command_Instruction Write bit"},
#else
{2, 2, 0x0000000000000000, "RW", "Offset", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 0, 0x0000000000000000, "RW", "Write", "A Write operation will be performed at the Offset (or Base if the Offset field = 0) Address."},
#else
{0, 0, 0x0000000000000000, "RW", "Write", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo155[] = {{"CPGC2_OFFSET_COMMAND_INSTRUCTION_10_", "", 0x00000092, 6, 0x00000000000000FF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields156[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{7, 7, 0x0000000000000000, "RW", "Last", "Last Offset_Command_Instruction. The offset instruction is complete after all Offset_Address, Offset_Repeats, and Offset_Commands have finished."},
#else
{7, 7, 0x0000000000000000, "RW", "Last", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{6, 6, 0x0000000000000000, "RW", "Invert_Data", "Invert all data for this Offset_Command_Instruction.  Combine the Data_Instruction Invert_Data field, the Algorithm_Instruction  Invert_Data field, Command_Instruction Invert_Data field and Offset_Command_Instruction Invert_Data field to determine the final data polarity."},
#else
{6, 6, 0x0000000000000000, "RW", "Invert_Data", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{4, 4, 0x0000000000000000, "RW", "Alternate_Data", "Use the alternate zero data source instead of the UniSequencers and Pattern_Select."},
#else
{4, 4, 0x0000000000000000, "RW", "Alternate_Data", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{3, 3, 0x0000000000000000, "RW", "Hammer", "This Offset command will be repeated Hammer_Repeats times"},
#else
{3, 3, 0x0000000000000000, "RW", "Hammer", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{2, 2, 0x0000000000000000, "RW", "Offset", "1=Normal Offset Command/Address, 0=Use Base Address and Offset_Command_Instruction Write bit"},
#else
{2, 2, 0x0000000000000000, "RW", "Offset", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 0, 0x0000000000000000, "RW", "Write", "A Write operation will be performed at the Offset (or Base if the Offset field = 0) Address."},
#else
{0, 0, 0x0000000000000000, "RW", "Write", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo156[] = {{"CPGC2_OFFSET_COMMAND_INSTRUCTION_11_", "", 0x00000093, 6, 0x00000000000000FF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields157[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{0, 31, 0x0000000000000000, "RW", "Offset_Repeats", "Set the loopcount for Offset (Distance from Base)"},
#else
{0, 31, 0x0000000000000000, "RW", "Offset_Repeats", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo157[] = {{"CPGC2_OFFSET_REPEATS_0_", "", 0x00000094, 1, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields158[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{0, 31, 0x0000000000000000, "RW", "Offset_Repeats", "Set the loopcount for Offset (Distance from Base)"},
#else
{0, 31, 0x0000000000000000, "RW", "Offset_Repeats", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo158[] = {{"CPGC2_OFFSET_REPEATS_1_", "", 0x00000098, 1, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields159[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{0, 31, 0x0000000000000000, "RO/V", "Offset_Repeats_Current", "Read only status register of the current Offset Loopcount (down count)"},
#else
{0, 31, 0x0000000000000000, "RO/V", "Offset_Repeats_Current", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo159[] = {{"CPGC2_OFFSET_REPEATS_CURRENT", "", 0x0000009C, 1, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields160[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{0, 17, 0x0000000000000000, "RW", "Low_Row", "Set the bottom Row for the physical memory being tested. This value is added to all Region Row Addresses computed."},
#else
{0, 17, 0x0000000000000000, "RW", "Low_Row", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo160[] = {{"CPGC2_REGION_LOW_ROW", "", 0x000000A0, 1, 0x000000000003FFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields161[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{0, 17, 0x0000000000000000, "RO/V", "Block_Low_Row_Current", "Current row within the testing region of memory Updated as the block traverses through the region."},
#else
{0, 17, 0x0000000000000000, "RO/V", "Block_Low_Row_Current", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo161[] = {{"CPGC2_REGION_LOW_ROW_CURRENT", "", 0x000000A4, 1, 0x000000000003FFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields162[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{16, 18, 0x0000000000000000, "RO/V", "Base_Rank_Current", "Current Base Address Rank within the block."},
#else
{16, 18, 0x0000000000000000, "RO/V", "Base_Rank_Current", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{2, 10, 0x0000000000000000, "RO/V", "Base_Col_Current", "Current Base Address Column within the block."},
#else
{2, 10, 0x0000000000000000, "RO/V", "Base_Col_Current", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo162[] = {{"CPGC2_BASE_ADDRESS_COL_RANK_CURRENT", "", 0x000000A8, 2, 0x000000000007FFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields163[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{24, 27, 0x0000000000000000, "RO/V", "Base_Bank_Current", "Current Base Address Bank within the block."},
#else
{24, 27, 0x0000000000000000, "RO/V", "Base_Bank_Current", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 17, 0x0000000000000000, "RO/V", "Base_Row_Current", "Current Base Address Row within the block."},
#else
{0, 17, 0x0000000000000000, "RO/V", "Base_Row_Current", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo163[] = {{"CPGC2_BASE_ADDRESS_ROW_BANK_CURRENT", "", 0x000000AC, 2, 0x000000000FFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields164[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{2, 10, 0x0000000000000000, "RO/V", "Offset_Col_Current", "Current Offset Address Column within the block.[br]\r\n"
"Only valid if the current Command_Instruction pointed to by Command_Instruction_Current is an Offset command."},
#else
{2, 10, 0x0000000000000000, "RO/V", "Offset_Col_Current", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo164[] = {{"CPGC2_OFFSET_ADDRESS_COL_CURRENT", "", 0x000000B0, 1, 0x00000000000007FF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields165[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{0, 17, 0x0000000000000000, "RO/V", "Offset_Row_Current", "Current Offset Address Row within the block.[br]\r\n"
"Only valid if the current Command_Instruction pointed to by Command_Instruction_Current is an Offset command."},
#else
{0, 17, 0x0000000000000000, "RO/V", "Offset_Row_Current", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo165[] = {{"CPGC2_OFFSET_ADDRESS_ROW_CURRENT", "", 0x000000B4, 1, 0x000000000003FFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields166[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{24, 28, 0x0000000000000000, "RW", "Region_Size_Bits_Row", "2^Region_Size_Bits_Row is the number of rows in the testing region. Must be >= to Block_Size_Bits_Row."},
#else
{24, 28, 0x0000000000000000, "RW", "Region_Size_Bits_Row", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{20, 23, 0x0000000000000000, "RW", "Region_Size_Bits_Col", "2^Region_Size_Bits_Col is the number of columns in the testing region. It is also used as the Block_Size_Bits_Col value to set the size of the block. Minimum value is 1 if Address_Decode_Enable =1. , so this normally needs to be set to the number of Column bits of the memory."},
#else
{20, 23, 0x0000000000000000, "RW", "Region_Size_Bits_Col", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{16, 19, 0x0000000000000000, "RW", "Block_Size_Num_Ranks", "Number of Ranks to test for a Block (as N-1 = top rank number)[br]\r\n"
"All Rank Addresses go through the Rank Address Lookup table."},
#else
{16, 19, 0x0000000000000000, "RW", "Block_Size_Num_Ranks", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{12, 15, 0x0000000000000000, "RW", "Block_Size_Num_Banks", "Number of Banks to test for a Block (as N-1 = top bank number)[br]\r\n"
"All Bank Address values go through the Bank Address Lookup table."},
#else
{12, 15, 0x0000000000000000, "RW", "Block_Size_Num_Banks", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{4, 8, 0x0000000000000000, "RW", "Block_Size_Bits_Row", "2^Block_Size_Bits_Row is the number of rows for a Block. If block traversal is used, then this must be at least 4 rows (=2). Minimum value is 1 if Address_Decode_Enable =1."},
#else
{4, 8, 0x0000000000000000, "RW", "Block_Size_Bits_Row", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 3, 0x0000000000000000, "RW", "Block_Size_Bits_Col", "Reserved for use as Block_Size_Bits_Col - Fixed as same as Region_Size_Bits_Col for BXT. There is no column traversal of a block in BXT"},
#else
{0, 3, 0x0000000000000000, "RW", "Block_Size_Bits_Col", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo166[] = {{"CPGC2_ADDRESS_SIZE", "", 0x000000B8, 6, 0x000000001FFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields167[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{26, 26, 0x0000000000000000, "RW", "Address_Inversion_Rate", "Address_Inversion_Rate determines if the enabled Address Fields toggle inversion on the Command Sequence Boundary (following a Command_Instruction with the Last bit set) or every Command_Instruction. [br]\r\n"
"   0  Invert enabled Address fields after executing the Command_Instruction with the Last bit set. [br][br]\r\n"
"1  Invert enabled Address fields following each Command_Instruction"},
#else
{26, 26, 0x0000000000000000, "RW", "Address_Inversion_Rate", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{22, 25, 0x0000000000000000, "RW", "Address_Inversion_Enable", "Address_Inversion_Enable enables particular Address Fields to be inverted.[br]\r\n"
"[25] Rank_Inversion_Enable, [24] Bank_Inversion_Enable, [23] Row_Inversion_Enable, [22] Col_Inversion_Enable"},
#else
{22, 25, 0x0000000000000000, "RW", "Address_Inversion_Enable", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{21, 21, 0x0000000000000000, "RW", "Address_Order0_Inc_Rate", "Address_Order0_Inc_Rate determines if the Address Order 0 Field is incremented on the Command Sequence Boundary (following a Command_Instruction with the Last bit set) or every Command_Instruction [br][br]\r\n"
"0  Increment Address after executing the Command_Instruction with the Last bit set. [br][br]\r\n"
"1  Increment Address following each Command_Instruction"},
#else
{21, 21, 0x0000000000000000, "RW", "Address_Order0_Inc_Rate", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{18, 20, 0x0000000000000000, "RO/V", "Reserved_Rank_Inc", "All Base Rank addresses are incremented (or decremented) by 2^Rank_Inc (unsigned value) - Fixed at 0 for BXT."},
#else
{18, 20, 0x0000000000000000, "RO/V", "Reserved_Rank_Inc", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{15, 17, 0x0000000000000000, "RO/V", "Reserved_Bank_Inc", "All Base Bank addresses are incremented (or decremented) by 2^Bank_Inc (unsigned value)  - Fixed at 0 for BXT."},
#else
{15, 17, 0x0000000000000000, "RO/V", "Reserved_Bank_Inc", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{11, 14, 0x0000000000000000, "RW", "Col_Inc", "All Base and Offset Column addresses are incremented (or decremented) by 2^Col_Inc (unsigned value)"},
#else
{11, 14, 0x0000000000000000, "RW", "Col_Inc", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{6, 9, 0x0000000000000000, "RW", "Row_Inc", "All Base and Offset Row addresses are incremented (or decremented) by 2^Row_Inc (unsigned value)"},
#else
{6, 9, 0x0000000000000000, "RW", "Row_Inc", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{5, 5, 0x0000000000000000, "RW", "Block_Move_Half_Block", "if Block_Move_One_Row =1 then[br]\r\n"
"the Block is moved by 1 row[br]\r\n"
"Else if Block_Move_Half_Bock = 1 then[br]\r\n"
"the Block is moved by 2^(Block_Size_Bits_Row)/2 Rows[br]\r\n"
"Else[br]\r\n"
"the Block is moved by = 2^(Row_Block_Size)"},
#else
{5, 5, 0x0000000000000000, "RW", "Block_Move_Half_Block", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{4, 4, 0x0000000000000000, "RW", "Block_Move_One_Row", "See Block_Move_Half_Block for description"},
#else
{4, 4, 0x0000000000000000, "RW", "Block_Move_One_Row", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo167[] = {{"CPGC2_BASE_ADDRESS_CONTROL", "", 0x000000BC, 9, 0x0000000007FFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields168[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{25, 25, 0x0000000000000000, "RW", "Address_PRBS_High_Row", "The higher order bits of the PRBS Address Generator (bits 3 through Address_PRBS_Size-1) will be on the same Row bits when the PRBS Address is selected."},
#else
{25, 25, 0x0000000000000000, "RW", "Address_PRBS_High_Row", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{24, 24, 0x0000000000000000, "RW", "Address_PRBS_High_Col", "The higher order bits of the PRBS Address Generator (bits 3 through Address_PRBS_Size-1) will be on the same Column bits when the PRBS Address is selected."},
#else
{24, 24, 0x0000000000000000, "RW", "Address_PRBS_High_Col", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{17, 17, 0x0000000000000000, "RW", "Address_PRBS_Mid_Row", "Bits [2:1] of the Row address will be bits [2:1] of the PRBS Address Generator  when the PRBS Address is selected."},
#else
{17, 17, 0x0000000000000000, "RW", "Address_PRBS_Mid_Row", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{16, 16, 0x0000000000000000, "RW", "Address_PRBS_Mid_Col", "Bits [2:1] of the Column address will be bits [2:1] of the PRBS Address Generator when the PRBS Address is selected."},
#else
{16, 16, 0x0000000000000000, "RW", "Address_PRBS_Mid_Col", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{9, 9, 0x0000000000000000, "RW", "Address_PRBS_Low_Row", "LSB of Row address will be the LSB of the PRBS Address Generator when the PRBS Address is selected."},
#else
{9, 9, 0x0000000000000000, "RW", "Address_PRBS_Low_Row", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{8, 8, 0x0000000000000000, "RW", "Address_PRBS_Low_Col", "LSB of Column address will be the LSB of the PRBS Address Generator when the PRBS Address is selected."},
#else
{8, 8, 0x0000000000000000, "RW", "Address_PRBS_Low_Col", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{7, 7, 0x0000000000000000, "RW", "Address_PRBS_Enable", "If Address_PRBS_Enable is active, and Address_Decode_Enable is not active in the current Address_Instruction, thenn each command is enabled to use the PRBS address if the Address_Decode_or_PRBS_En bit is set"},
#else
{7, 7, 0x0000000000000000, "RW", "Address_PRBS_Enable", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 3, 0x0000000000000004, "RW", "Address_PRBS_Size", "Size of PRBS for address generation if Address_PRBS_Enable is active. Valid values are 4 .. 15.  See text for PRBS Polynomials being used for each setting."},
#else
{0, 3, 0x0000000000000004, "RW", "Address_PRBS_Size", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo168[] = {{"CPGC2_ADDRESS_PRBS_CONTROL", "", 0x000000C0, 8, 0x0000000003FFFFFF, 0x0000000000000004}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields169[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{0, 14, 0x0000000000000000, "RW", "Address_PRBS_Seed", "Seed for Address PRBS generator"},
#else
{0, 14, 0x0000000000000000, "RW", "Address_PRBS_Seed", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo169[] = {{"CPGC2_ADDRESS_PRBS_SEED", "", 0x000000C4, 1, 0x0000000000007FFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields170[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{0, 14, 0x0000000000000000, "RW", "Address_PRBS_Current", "Current value of Address PRBS generator.  Address advances as Address_Order0_Inc_Rate.  The Seed is re-loaded at each Algorithm_Instruction boundary."},
#else
{0, 14, 0x0000000000000000, "RW", "Address_PRBS_Current", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo170[] = {{"CPGC2_ADDRESS_PRBS_CURRENT", "", 0x000000C8, 1, 0x0000000000007FFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields171[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{28, 29, 0x0000000000000000, "RO/V", "Address_Instruction_Current", "Current Address_Instruction pointer"},
#else
{28, 29, 0x0000000000000000, "RO/V", "Address_Instruction_Current", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{24, 25, 0x0000000000000000, "RO/V", "Data_Instruction_Current", "Current Data_Instruction pointer"},
#else
{24, 25, 0x0000000000000000, "RO/V", "Data_Instruction_Current", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{15, 17, 0x0000000000000000, "RO/V", "Algorithm_Instruction_Current", "Current Algorithm_Instruction pointer"},
#else
{15, 17, 0x0000000000000000, "RO/V", "Algorithm_Instruction_Current", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{8, 12, 0x0000000000000000, "RO/V", "Command_Instruction_Current", "Current Command_Instruction pointer"},
#else
{8, 12, 0x0000000000000000, "RO/V", "Command_Instruction_Current", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{6, 6, 0x0000000000000000, "RO/V", "Offset_Group_Instruction_Current", "Current Offset_Group as pointed to by the Current Command_Instruction (if an Offset instruction)"},
#else
{6, 6, 0x0000000000000000, "RO/V", "Offset_Group_Instruction_Current", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{3, 5, 0x0000000000000000, "RO/V", "Offset_Address_Instruction_Current", "Current Offset_Address_Instruction pointer"},
#else
{3, 5, 0x0000000000000000, "RO/V", "Offset_Address_Instruction_Current", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 2, 0x0000000000000000, "RO/V", "Offset_Command_Instruction_Current", "Current Offset_Command_Instruction pointer"},
#else
{0, 2, 0x0000000000000000, "RO/V", "Offset_Command_Instruction_Current", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo171[] = {{"CPGC2_CMD_FSM_CURRENT", "", 0x000000CC, 7, 0x000000003FFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields172[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{28, 31, 0x0000000000000000, "RW", "Increment_Value", "See Prescaler field for information on this field."},
#else
{28, 31, 0x0000000000000000, "RW", "Increment_Value", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{16, 25, 0x0000000000000000, "RW", "Clock_Freq", "When a setting of 1MHz or 1KHz is used in Wait_Clock_Frequency, This field provides a way to tell the hardware the native Memory Controller clock frequency, which is feed into the Prescaler automatically (with a 1 Increment_Value also automatically fed into the counter)."},
#else
{16, 25, 0x0000000000000000, "RW", "Clock_Freq", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 9, 0x0000000000000000, "RW", "Prescaler_for_Clock_Freq", "In order to make the 'standard' 1 GHz clock for the CPGC specified Wait_Clock_Frequency setting, we need to provide a pre-scaler, and Increment Value to modify the existing Wait_Timer_Current advancement. This field will divide the native Memory Controller clock by the provided value, with '1' being 'No Divide'. After that divide, the Wait_Timer_Current will advance by the 'Increment_Value' field. In this way, we are creating a clock ratio able to 'multiply' the native Memory Controller clock by 'Increment_Value/Prescaler'.  For small values of Wait_Time, the error will be substantial, and it may be better to modify the programming to the '11' Native Clock setting and manually compute the required Wait_Time for the desired delay."},
#else
{0, 9, 0x0000000000000000, "RW", "Prescaler_for_Clock_Freq", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo172[] = {{"CPGC2_WAIT_2_START_CONFIG", "", 0x000000D0, 3, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields173[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{13, 14, 0x0000000000000000, "RW", "Err1_grp_Sel", "Err Group 1 Select"},
#else
{13, 14, 0x0000000000000000, "RW", "Err1_grp_Sel", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{11, 12, 0x0000000000000000, "RW", "Err0_grp_Sel", "Err Group 0 Select"},
#else
{11, 12, 0x0000000000000000, "RW", "Err0_grp_Sel", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{9, 10, 0x0000000000000000, "RW", "Dpat1_grp_Sel", "Dpat Group 1 Select"},
#else
{9, 10, 0x0000000000000000, "RW", "Dpat1_grp_Sel", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{7, 8, 0x0000000000000000, "RW", "Dpat0_grp_Sel", "Dpat Group 0 Select"},
#else
{7, 8, 0x0000000000000000, "RW", "Dpat0_grp_Sel", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{5, 6, 0x0000000000000000, "RW", "Cmd1_grp_Sel", "Cmd Group 1 Select"},
#else
{5, 6, 0x0000000000000000, "RW", "Cmd1_grp_Sel", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{3, 4, 0x0000000000000000, "RW", "Cmd0_grp_Sel", "Cmd Group 0 Select"},
#else
{3, 4, 0x0000000000000000, "RW", "Cmd0_grp_Sel", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{2, 2, 0x0000000000000000, "RW", "Err1_or_Cmd1", "Err group 1 or Cmd group 1 select"},
#else
{2, 2, 0x0000000000000000, "RW", "Err1_or_Cmd1", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{1, 1, 0x0000000000000000, "RW", "Cmd0_or_Dpat1", "Cmd group 0  or Dpat group 1 select"},
#else
{1, 1, 0x0000000000000000, "RW", "Cmd0_or_Dpat1", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 0, 0x0000000000000000, "RW", "Dpat0_or_Err0", "Dpat group 0 or Err group 0 select"},
#else
{0, 0, 0x0000000000000000, "RW", "Dpat0_or_Err0", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo173[] = {{"CPGC2_VISA_MUX_SEL", "", 0x000000D4, 9, 0x0000000000007FFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields174[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{0, 0, 0x0000000000000000, "RW", "REQUEST_DATA_SIZE", "Size of requests CPGC is issuing, 64B and 32B transactions and is encoded as follows:[br][br]\r\n"
"                        0 - 32 Byte Transactions[br][br]\r\n"
"                        1 - 64 Byte Transactions"},
#else
{0, 0, 0x0000000000000000, "RW", "REQUEST_DATA_SIZE", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo174[] = {{"CPGC_SUBSEQ0_CTL_B", "", 0x000000D8, 1, 0x0000000000000001, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields175[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{24, 31, 0x0000000000000000, "RW", "START_TEST_DELAY", "Start_Test_Delay is the delay period (in byte clocks) to execute a test(i.e transition to Loopback.Pattern) after the link is in Loopback.Idle and Local_Start_Test is asserted.[br][br]\r\n"
"If Local_Start_Test is set upon the initial enttry to Loopback.Idle then a test (entry to Loopback.Pattern) will immediately start after Start_Test_Delay number of byte clocks is enforced.[br][br]\r\n"
"During Start_Test_test the Valid must not be asserted (i.e Loopback.PM) and no comparison of data will be taking place.[br][br]\r\n"
"Start_Test_Delay=0 is reserved and not allowed.[br][br]\r\n"
"Start_Test_Delay=1 will result in a 1byte clock delay.[br][br]\r\n"
"Start_Test_Delay=2 will result in a 2byte clock delay."},
#else
{24, 31, 0x0000000000000000, "RW", "START_TEST_DELAY", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{16, 20, 0x0000000000000000, "RW", "LOOPCOUNT", "2^(Loopcount) determines the length of a test.[br][br]\r\n"
"                One Loopcount consists of Pattern_Length followed by PM_Length.[br][br]\r\n"
"                Pattern_Length corresponds to the Loopback Master generating patterns and the Loopback.Slave and/or Loopback Master performing error checking occueeing (valid is assered).[br][br]\r\n"
"                PM_Length corresponds to the functional power savings mode (valid is not asserted).[br][br]\r\n"
"Loopcount=0 means the test is infinite.[br][br]\r\n"
"Loopcount=1 means the test will end after two loops.[br][br]\r\n"
"Loopcount=2 means the test will end after four loops.[br][br]\r\n"
"Loopcount=3 means the test will end after eight loops."},
#else
{16, 20, 0x0000000000000000, "RW", "LOOPCOUNT", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{8, 15, 0x0000000000000000, "RW", "PM_LENGTH", "PM_Length(i.e Loopback.PM) forms the second half of the loopcount sequence with Pattern_Length (i.e Loopback.Pattern)forming the first half.[br][br]\r\n"
"            PM_Length is used in conjection with Pattern_Length and Loopcount to go in and out of Power Savings Modes in an identical way to how the functional power saving mode behave. This includes post amble, pre-amble, etc.[br][br]\r\n"
"            PM_Length duration is defined in total # of byte clocks.[br][br]\r\n"
"            If PM_Length is set to 0 then no power saving modes will be entered.[br][br]\r\n"
"            If the end of the test has not been reached (Curren_Loopcount !=Loopcount) the loopcount is incremented and the sequence repeats (Pattern_Length followed by PM_Length).[br][br]\r\n"
"            If the end of the test has not been reached (Current_Loopcount=Loopcount) the link transitions back to Loopback.Idle following the PM state."},
#else
{8, 15, 0x0000000000000000, "RW", "PM_LENGTH", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 7, 0x0000000000000000, "RW", "PATTERN_LENGTH", "Pattern_Length (i.e Loopback.Pattern) forms the first half of the Loopcount sequence with PM_Length (i.e Loopback.PM) forming the second half.[br][br]\r\n"
"            Pattern_Length is the portion of Loopcount when patterns are generated(Loopback Master) and compared (Loopback Master and optionally the Loopback Slave).[br][br]\r\n"
"            Pattern_Length suration is defined in total # of byte clocks. A zero value is illegal.[br][br]\r\n"
"            The Sum of Pattern_Length and PM_Length (Duration of a Loopcount)must always be set to a value of two or more."},
#else
{0, 7, 0x0000000000000000, "RW", "PATTERN_LENGTH", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo175[] = {{"CPGC_LB_SEQ_CFG", "", 0x000000DC, 4, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields176[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{12, 13, 0x0000000000000000, "RW", "INITIALIZATION_MODE", "A change to Initialization_Mode occurs immediately.[br]\r\n"
"00 - OFF - REUT is clock gated.[br]\r\n"
"01 - LSM Mode  - Enter Loopback.Idle state through the appropriate Link Layer bits as a Loopback Master or Loopback Slave.[br]\r\n"
"10 - Force Master - Force entry to Loopback.Idle as a Loopback Master (Supported if Force_Loopback capability is set).[br]\r\n"
"11 - Force Slave - Force entry to Loopback.Idle as Loopback Slave (Supported if Force_Loopback capability is set).[br]\r\n"
"Note: A user must be careful to transition both sides of the Link to Loopback.Idle if switching Initialization_Mode from Force Master or Force Slave to LSM Mode or undefined behavior can be expected.[br]\r\n"
"Note: Initialization Mode should not be changed while Local_Start_Test is set, or while Test_In_Progress is set."},
#else
{12, 13, 0x0000000000000000, "RW", "INITIALIZATION_MODE", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{6, 6, 0x0000000000000000, "RW", "BIND_STOP_ON_ERROR", "Test will stop based on Global_Error (external input) and Local_Error will drive Global_Error."},
#else
{6, 6, 0x0000000000000000, "RW", "BIND_STOP_ON_ERROR", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{5, 5, 0x0000000000000000, "RW", "BIND_CLEAR_ERRORS", "Local_Clear_Errors will clear all other REUT instances that have this bit set."},
#else
{5, 5, 0x0000000000000000, "RW", "BIND_CLEAR_ERRORS", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{4, 4, 0x0000000000000000, "RW", "BIND_STOP_TEST", "Local_Stop_Test will stop all other REUT instances that have this bit set."},
#else
{4, 4, 0x0000000000000000, "RW", "BIND_STOP_TEST", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{3, 3, 0x0000000000000000, "RW", "BIND_START_TEST", "Local_Start_Test will start all other REUT instances that have this bit  set."},
#else
{3, 3, 0x0000000000000000, "RW", "BIND_START_TEST", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{2, 2, 0x0000000000000000, "RW/V", "LOCAL_CLEAR_ERRORS", "Setting Local_Clear_Errors  to 1 will immediately clear all local OPI REUT Error and OPI REUT SEQ STATUS registers (i.e. OPIO_REUT_ERR_* and OPIO_REUT_SEQ_*_*_STATUS registers).[br][br]\r\n"
"Local_Clear_Errors will immediately clear to 0 after clearing affected registers."},
#else
{2, 2, 0x0000000000000000, "RW/V", "LOCAL_CLEAR_ERRORS", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{1, 1, 0x0000000000000000, "RW/V", "LOCAL_STOP_TEST", "If  Local_Stop_Test is set to 1 and a Loopback test is in progress (i.e. Test_In_Progress=1) then a transition to Loopback.Idle will occur as soon as possible (i.e. Link enters Loopback.PM).[br][br]\r\n"
"Local_Stop_Test will immediately clear to 0 after stopping a Loopback test (i.e. Local_Stop_Test=0 while in Loopback.Idle)."},
#else
{1, 1, 0x0000000000000000, "RW/V", "LOCAL_STOP_TEST", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 0, 0x0000000000000000, "RW/V", "LOCAL_START_TEST", "If  Local_Start_Test is set a Sequence will immediately start, or wait until entry to Loopback state.  A complete Sequence is defined by the following behavior:[br][br]\r\n"
"1) An initial delay of Start_Test_Delay byte clocks must first occur in Loopback.PM (with Valid de-asserted) [br][br]\r\n"
"2) Transition to Loopback.Pattern (Valid asserted) for a duration of Pattern_Length Byte clocks during which data is generated and compared by the Loopback Master and optionally compared by the Loopback Slave.[br][br]\r\n"
"3) Increment Loopcounter[br][br]\r\n"
"4) Optionally Transition to Loopback.PM (with Valid deasserted), if so programmed, for a duration of PM_Length Byte clocks during which power modes are functionally enforced as what would happen normally based on the length of the PM_Length duration.[br][br]\r\n"
"5) If Current Loopcount !=2^Loopcount then go to step 2[br][br]\r\n"
"6) If Current Loopcount !=2^Loopcount then the Link returns to Loopback.Idle, Local_Start_Test is cleared for the Master. Local_Start_Test is not cleared on the Loopback.Slave."},
#else
{0, 0, 0x0000000000000000, "RW/V", "LOCAL_START_TEST", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo176[] = {{"CPGC_LB_SEQ_CTL", "", 0x000000E0, 8, 0x0000000000003FFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields177[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{0, 31, 0x0000000000000000, "RO/V", "CURRENT_LOOPCOUNT", "Current_Loopcount indicates how many times the full Sequence has been executed in the TX path. [br][br]\r\n"
"Current_Loopcount is cleared by Local_Clear_Errors"},
#else
{0, 31, 0x0000000000000000, "RO/V", "CURRENT_LOOPCOUNT", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo177[] = {{"CPGC_LB_SEQ_LOOPCOUNT_TX_STATUS", "", 0x000000E4, 1, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields178[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{0, 31, 0x0000000000000000, "RO/V", "CURRENT_LOOPCOUNT", "Current_Loopcount indicates how many times the full Sequence has been executed in the RX path.[br][br]\r\n"
"Current_Loopcount is cleared by Local_Clear_Errors"},
#else
{0, 31, 0x0000000000000000, "RO/V", "CURRENT_LOOPCOUNT", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo178[] = {{"CPGC_LB_SEQ_LOOPCOUNT_RX_STATUS", "", 0x000000E8, 1, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields179[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{0, 7, 0x0000000000000000, "RO/V", "CURRENT_PATTERN_LENGTH", " Current_Pattern_Length is used in conjuntion with Stop_On_Error_Control conditons to determine where the last failure occurred within Loopback.Pattern.[br][br]\r\n"
"Current_Pattern_Length indicates how many Bytes were left in Loopback.Pattern when the error occurred.[br][br]\r\n"
"Current_Pattern_Length is cleared by Local_Clear_Errors"},
#else
{0, 7, 0x0000000000000000, "RO/V", "CURRENT_PATTERN_LENGTH", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo179[] = {{"CPGC_LB_SEQ_PL_RX_STATUS", "", 0x000000EC, 1, 0x00000000000000FF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields180[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{31, 31, 0x0000000000000000, "RW", "PANIC_REFRESH_ONLY", "If Panick_Refresh_Only=1 then opportunistic and high priority auto refreshes will be disabled for all ranks and refreshes will only occur when the panic refresh watermark has been exceeded. If Panic_Refresh_Only=0 then refreshes will occur using the existing MC functional refresh logic.[br]\r\n"
"[br]\r\n"
"tREFI defines the average period between refreshes, and the rate that tREFI counter is incremented (in DCLK cycles, default is 4100). This field is a often a shadow register to an exisitng MC tREFI field. tREFI is located in another CR.  In Haswell this is located in the CR TC_RFTP.tREFI (15:0) in MCMNTS."},
#else
{31, 31, 0x0000000000000000, "RW", "PANIC_REFRESH_ONLY", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{8, 8, 0x0000000000000000, "RW", "REFZQ_EN_START_TEST_SYNC", "If RefZQ_En_Start_Test_Sync=1 this field will ensure all refresh/ZQ powerdown logic (counters, FSMs, etc.) is kept in the default reset state (no refresh/ZQ happening) while in Loopback.Marker during REUT Mode. Once the test starts and the transition to Loopback.Pattern occurs the refresh/ZQ logic will behave identical to normal functional MC mode based on the values programmed in the refresh/ZQ CRs. This allows deterministic and reproducible behavior across REUT tests with respect to refresh/ZQ since the logic is synchronized to the start of a REUT test.[br]\r\n"
"If RefZQ_En_Start_Test_Sync=0 the refresh/ZQ logic will not be synchronized to the start of a REUT test and will always behave identical to normal functional MC mode based on the values programmed in the refresh/ZQ CRs, whether in Loopback.Marker or Loopback.Pattern.[br]\r\n"
"[br]\r\n"
"NOTE: This bit should not be used in conjuction with Self Refresh.[br]\r\n"
""},
#else
{8, 8, 0x0000000000000000, "RW", "REFZQ_EN_START_TEST_SYNC", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 3, 0x0000000000000000, "RW", "REFRESH_RANK_MASK", "Refresh_Rank_Mask is a per rank field.[br]\r\n"
"[br]\r\n"
"The LSB relates to Rank0 and the MSB relates to the highest Rank.  If the per Rank bit of the Refresh_Rank_Mask is set to 1, then the REUT engine will disable executing any refresh to that rank while in REUT mode.[br]\r\n"
"[br]\r\n"
"If the per rank bit of the Refresh_Rank_Mask is set to 0 and then the REUT engine will enable executing a refresh (assuming the MC has refreshes enabled) to that Rank while in REUT mode based on the Panic_Refresh_Only value.[br]\r\n"
""},
#else
{0, 3, 0x0000000000000000, "RW", "REFRESH_RANK_MASK", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo180[] = {{"CPGC_MISC_REFRESH_CTL", "", 0x000000F0, 3, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields181[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{31, 31, 0x0000000000000000, "RW", "ALWAYS_DO_ZQ", "If Always_Do_ZQ is set to 1 a ZQ operation will always take place after a refresh occurs as long as the ZQ_Rank_Mask for that rank is set to 0.[br]\r\n"
"[br]\r\n"
"If Always_Do_ZQ is set to 0 a ZQ operation will take place at the normal programmed 128*ZQCS_period after a refresh occurs as long as the ZQ_Rank_Mask for that rank is set to 0.[br]\r\n"
""},
#else
{31, 31, 0x0000000000000000, "RW", "ALWAYS_DO_ZQ", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 1, 0x0000000000000000, "RW", "ZQ_RANK_MASK", "ZQ Mask is a per rank (Chip Select) field.  The LSB relates to Rank0 and the MSB relates to the highest Rank.[br]\r\n"
"[br]\r\n"
"If the per rank bit of the ZQ Mask is set to 1, then the REUT engine will disable executing ZQ operations to that Rank.   Note: that if the Refresh_Rank_Mask for the same rank is set to 1 then the ZQ Mask will have no effect and ZQ will disabled to that rank.[br]\r\n"
"[br]\r\n"
"If the per rank bit of the ZQ mask is set to 0 and refreshes are being issued to the corresponding Rank, ZQ will be issued at a rate equal to 128*ZQCS_period programmed inside the channel TC_ZQCAL CR, always occurring after refreshes occur.[br]\r\n"
"ZQCS_period is the time between ZQCS operations in tREFI*128 (2 to 255, default is 128.[br]\r\n"
"ZQCS_period is located in another CR.  In Haswell this is located in the CR TC_ZQCAL.[br]\r\n"
"ZQCS_period (7:0) in MCMNTS.[br]\r\n"
""},
#else
{0, 1, 0x0000000000000000, "RW", "ZQ_RANK_MASK", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo181[] = {{"CPGC_MISC_ZQ_CTL", "", 0x000000F4, 2, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields182[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{31, 31, 0x0000000000000000, "RW", "MPR_Train_DDR_On", "This bit is to be set during DDR training.  The MPR pattern (Hardcoded 0101 pattern) from the DRAM will be used to initially train the read timing.  This MPR pattern is accessed via the MR3 DRAM register and, per the JEDEC spec, the mode comes with two key limitations:[br]\r\n"
"[br]\r\n"
"   1. Before entering this mode, all pages must be precharges.[br]\r\n"
"[br]\r\n"
"   2. Once in this mode, the MC can only issue RD or RDA commands.[br]\r\n"
"[br]\r\n"
"   When this CR bit is set, the RAS# and WE# will always drive high.  This will morph any command from the scheduler into either READ or DESELECT.[br]\r\n"
"[br]\r\n"
"   The flow is as follows:[br]\r\n"
"[br]\r\n"
"   1. MRS Mode to write MR3[br]\r\n"
"[br]\r\n"
"   2. Set MPR_Train_DDR_On[br]\r\n"
"[br]\r\n"
"   3. Set REUT Mode[br]\r\n"
"[br]\r\n"
"   4. Wait for all pages to close (page table idle counter to expire)[br]\r\n"
"[br]\r\n"
"   5. Run REUT Test[br]\r\n"
"[br]\r\n"
"   6. Stop Test, clear MPR_Train_DDR_On bit, clear MR3 register[br]\r\n"
"[br]\r\n"
"   7. Continue with other REUT tests[br]\r\n"
"[br]\r\n"
"   Note that ZQ, CKE and Refresh should be disabled using the appropriate CR settings during MPR_Train_DDR_On.[br]\r\n"
""},
#else
{31, 31, 0x0000000000000000, "RW", "MPR_Train_DDR_On", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{16, 17, 0x0000000000000000, "RW", "ODT_ON", "ODT_on is a 4-bit field, one bit per rank (Chip Select).  The LSB relates to Rank0 and the MSB relates to the highest Rank.  When ODT_Override is set to 1 for a rank the value in ODT_On will be used as the ODT value for that rank.[br]\r\n"
""},
#else
{16, 17, 0x0000000000000000, "RW", "ODT_ON", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 1, 0x0000000000000000, "RW", "ODT_OVERRIDE", "ODT_Override is a per rank field.  The LSB relates to Rank0 and the MSB relates to the highest Rank. When ODT_Override is set to 1 for a rank, the ODT functional logic will be bypassed and the ODT_On value for that rank will be used. When ODT_Override is set to 0 for a rank, the ODT functional logic will drive the ODT value for that rank.[br]\r\n"
""},
#else
{0, 1, 0x0000000000000000, "RW", "ODT_OVERRIDE", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo182[] = {{"CPGC_MISC_ODT_CTL", "", 0x000000F8, 3, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields183[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{16, 17, 0x0000000000000000, "RW", "CKE_ON", "CKE_On is a 4-bit field, one bit per rank.  The LSB relates to Rank0 and the MSB relates to the highest Rank.  In REUT mode when the per rank bit is set CKE will be always on for that rank.[br]\r\n"
""},
#else
{16, 17, 0x0000000000000000, "RW", "CKE_ON", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{8, 8, 0x0000000000000000, "RW", "CKE_EN_START_TEST_SYNC", "When CKE_En_Start_Test_Sync is set to 1 this field will ensure all CKE powerdown logic (counters, FSMs, etc.) is kept in the default reset state (no CKE powerdowns happening) while in Loopback.Marker during REUT Mode. Once the test starts and the transition to Loopback.Pattern occurs the CKE powerdown logic will behave identical to normal functional MC mode based on the values programmed in the powerdown CR, PM_PDWN_config_0_0_0_MCHBAR. This allows deterministic and reproducible behavior across REUT tests with respect to CKE powerdown since the logic is synchronized to the start of a REUT test.[br]\r\n"
"[br]\r\n"
"When CKE_En_Start_Test_Sync is set to 0 the CKE powerdown logic will not be synchronized to the start of a REUT test and will always behave identical to normal functional MC mode based on the values programmed in the powerdown CR, PM_PDWN_config_0_0_0_MCHBAR, whether in Loopback.Marker or Loopback.Pattern.[br]\r\n"
"[br]\r\n"
"NOTE: This bit should not be used in conjuction with Self Refresh.[br]\r\n"
""},
#else
{8, 8, 0x0000000000000000, "RW", "CKE_EN_START_TEST_SYNC", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 1, 0x0000000000000000, "RW", "CKE_OVERRIDE", "CKE_Override is a a per rank field.  The LSB relates to Rank0 and the MSB relates to the highest Rank. When CKE_Override is set to 1 for a rank, the CKE functional logic will be bypassed and the CKE_On value for that rank will be used. When CKE_Override is set to 0 for a rank, the CKE functional logic will drive the CKE value for that rank.[br]\r\n"
""},
#else
{0, 1, 0x0000000000000000, "RW", "CKE_OVERRIDE", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo183[] = {{"CPGC_MISC_CKE_CTL", "", 0x000000FC, 3, 0x000000000003FFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields184[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{31, 31, 0x0000000000000000, "RW", "init_mrw_2n_cs", "When sending a MRW command via MRH and setting the Init_MRW bit, send the CS for two DCLK cycles (on the third and fourth cycles, rather than on just the third one.)[br]\r\n"
""},
#else
{31, 31, 0x0000000000000000, "RW", "init_mrw_2n_cs", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{12, 13, 0x0000000000000001, "RW", "ck_to_cke_delay", "When sending a MRW command via MRH and setting the Init_MRW bit, send the CS for two DCLK cycles (on the third and fourth cycles, rather than on just the third one.)[br]\r\n"
""},
#else
{12, 13, 0x0000000000000001, "RW", "ck_to_cke_delay", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{8, 11, 0x0000000000000000, "RW", "reset_delay", "Inserts an N Dclk delay ranging from 0 to 7 after the N to 1 Reset on Cmd is triggered.[br]\r\n"
""},
#else
{8, 11, 0x0000000000000000, "RW", "reset_delay", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{4, 7, 0x0000000000000000, "RW", "reset_on_command", "N:1 mode is set and utilized as designed in the functional MC logic where N is the number of cycles of allowed continuous CMD cycles before the MC logic will stall a sequence and insert a tri-state bubble.[br]\r\n"
"[br]\r\n"
"When Deselect traffic is driven by the CADB (combination of Subsequence_Deselect_Enable being set, CMD_Deselect_Enable enabling deselects, and a non zero value for Lane_Deselect_Enable) all Deselect cycles within the MC scheduler logic will be considered as consecutive Select cycles in the N:1 logic and thus a tri-state bubble will be inserted regularly as enforced by the N:1 logic.  Tristate effects both select and deselect cycles.[br]\r\n"
"[br]\r\n"
"The N:1 logic can also be triggered to insert a tri-state bubble and reset the N:1 logic after a programmable delay (Reset_N_to_1_Delay=0-7 Dclks) after a PRE/ACT/RD/WR CMD.  This allows one to synchronize the N:1 logic periodically to ensure the correct worst case pattern between victim and aggressor occurs.[br]\r\n"
"[br]\r\n"
"Reset N to 1 Logic on a WR (bit 4)[br]\r\n"
"Reset N to 1 Logic on a RD (bit 5)[br]\r\n"
"Reset N to 1 Logic on a ACT (bit 6)[br]\r\n"
"Reset N to 1 Logic on a PRE (bit 7)[br]\r\n"
""},
#else
{4, 7, 0x0000000000000000, "RW", "reset_on_command", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{1, 3, 0x0000000000000005, "RW", "cmd_rate_limit", "Cmd_Rate_Limit - The legal range is 2-7[br]\r\n"
""},
#else
{1, 3, 0x0000000000000005, "RW", "cmd_rate_limit", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 0, 0x0000000000000000, "RW", "enable_cmd_rate_limit", "Enable the Cmd_Rate_Limit.[br]\r\n"
""},
#else
{0, 0, 0x0000000000000000, "RW", "enable_cmd_rate_limit", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo184[] = {{"CPGC_MISC_CMD_RATE", "", 0x00000100, 6, 0x00000000FFFFFFFF, 0x000000000000100A}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields185[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{3, 3, 0x0000000000000000, "RW", "TRIGGER_OUT_ON_TEST_DONE", "Setting Trigger_Out_On_Test_Done enables external equipment to be synced deterministically to the exact moment when Trigger_Out_On_Channel_Test_Done_Status_1 is set.[br]\r\n"
"[br]\r\n"
"This capability enables external test equipment to be deterministically synched to when Channel 1 REUT test is completed.  This is required to allow synchronous REUT operation with external test hardware (HVM Tester, BERT, etc.).[br]\r\n"
"[br]\r\n"
"When Trigger_Out_On_Channel_Test_Done_Status_1 is set a deterministic externally viewable uBP trigger is generated each time REUT_GLOBAL_ERR.Channel_Test_Done_Status_1 is set to 1.[br]\r\n"
""},
#else
{3, 3, 0x0000000000000000, "RW", "TRIGGER_OUT_ON_TEST_DONE", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{2, 2, 0x0000000000000000, "RW", "TRIGGER_OUT_ON_ERROR", "Setting Trigger_Out_On_Error_0 enables external equipment to be synced deterministically to when any bit in Data_Error_Status or ECC_Error_Status on channel 0 is set.  Once any bit in Data_Error_Status or ECC_Error_Status on channel 0 is set no additional triggers will be generated.[br]\r\n"
"[br]\r\n"
"This capability enables external test equipment to be synched to an error event within REUT on channel 0.  This is required to allow synchronous REUT operation with external test hardware (HVM Tester, BERT, etc.).[br]\r\n"
"[br]\r\n"
"When Trigger_Out_On_Error_0 is set a deterministic uBP trigger is generated in relation to when REUT_CH_ERR_DATA_STATUS.Data_Error_Status or REUT_CH_ERR_ECC_CHUNK_RANK_BYTE_NTH_STATUS.ECC_Error_Status becomes non zero on channel 0.[br]\r\n"
"[br]\r\n"
""},
#else
{2, 2, 0x0000000000000000, "RW", "TRIGGER_OUT_ON_ERROR", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{1, 1, 0x0000000000000000, "RW", "TRIGGER_OUT_GLOBAL_START", "Setting Trigger_Out_Global_Start will generate a deterministic external uBP trigger that is based on Global_Start_Test being set.[br]\r\n"
"[br]\r\n"
"This capability enables a test to start in a synchronous fashion with respect to an external event.  This is required to allow synchronous REUT operation with external test hardware (HVM Tester, BERT, etc.).[br]\r\n"
"[br]\r\n"
"When Trigger_OUT_Global_Start is set a deterministic uBP trigger is generated each time REUT_GLOBAL_CTL.Global_Start_Test is set.[br]\r\n"
""},
#else
{1, 1, 0x0000000000000000, "RW", "TRIGGER_OUT_GLOBAL_START", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 0, 0x0000000000000000, "RW", "TRIGGER_IN_GLOBAL_START", "Setting Trigger_In_Global_Start enables a test to start based on a uBP trigger.  This capability enables a test to start in a synchronous fashion with respect to an external event.[br]\r\n"
"[br]\r\n"
"This is required to allow synchronous REUT operation with external test hardware (HVM Tester, BERT, etc.).[br]\r\n"
"When Trigger_In_Global_Start is set the uBP used to start a REUT test will set REUT_GLOBAL_CTL.Global_Start_Test on a deterministic boundary.[br]\r\n"
""},
#else
{0, 0, 0x0000000000000000, "RW", "TRIGGER_IN_GLOBAL_START", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo185[] = {{"CPGC_MISC_EXT_TRIGGER", "", 0x00000104, 4, 0x000000000000000F, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields186[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{9, 9, 0x0000000000000000, "RW/V", "CONTINUE_SINGLE_MODE", "When in Single_Command_Mode setting this bit will enable a new command to be issued. This bit immediately clears after being set."},
#else
{9, 9, 0x0000000000000000, "RW/V", "CONTINUE_SINGLE_MODE", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{8, 8, 0x0000000000000000, "RW", "SINGLE_CMD_MODE", "Enter Single Command mode were we will issue one command from CPGC and then pause command issuing. This may be resumed by setting Continue_Single_Mode, or normal continuous operation resumed by clearing this bit."},
#else
{8, 8, 0x0000000000000000, "RW", "SINGLE_CMD_MODE", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{2, 2, 0x0000000000000000, "RW/V", "CLEAR_ERRORS", "Setting this bit will immediately clear all error registers and error status."},
#else
{2, 2, 0x0000000000000000, "RW/V", "CLEAR_ERRORS", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{1, 1, 0x0000000000000000, "RW/V", "STOP_TEST", "Forces an exit from the tests running on this engine/channel.  This bit will always return '0' if read by software. Note that this will also cause a test stop for all engines with GLB_STOP_BIND set."},
#else
{1, 1, 0x0000000000000000, "RW/V", "STOP_TEST", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 0, 0x0000000000000000, "RW/V", "START_TEST", "Used to initiate a transition to active mode on this engine/channel (note that INIT_MODE has to be programmed first).  This bit will always return '0' if read by software. Note that this will also cause a test start for all engines with GLB_START_BIND set."},
#else
{0, 0, 0x0000000000000000, "RW/V", "START_TEST", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo186[] = {{"CPGC_SEQ_CTL", "", 0x00000108, 5, 0x00000000000003FF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields187[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{21, 21, 0x0000000000000001, "RW", "CPGC_CONTROL", "Used to indicate the OPIO(MCDRAM) or CPGC(DDR) mode.[br][br]\r\n"
"1 - CPGC Mode.[br][br]\r\n"
"0 - OPIO Mode."},
#else
{21, 21, 0x0000000000000001, "RW", "CPGC_CONTROL", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{12, 14, 0x0000000000000000, "RW", "INITIALIZATION_MODE", "000 - IDLE MODE[br]\r\n"
"001 - ACTIVE MODE[br]\r\n"
"010 - DIRECT MODE[br]\r\n"
"011 - ACTIVE MODE[br]\r\n"
"100 - MRS MODE[br]\r\n"
"101 - ERROR DUMP MODE (Reserved)[br]\r\n"
"110 - WDB FILL MODE (Reserved)[br]\r\n"
"111 - REWIND MODE (Reserved)"},
#else
{12, 14, 0x0000000000000000, "RW", "INITIALIZATION_MODE", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{11, 11, 0x0000000000000000, "RW", "GLOBAL_STOP_BIND", "Setting this bit will bind this channel engine to all other channel engines.  A test stop (both forced and due to a stop condition) for any channel engine with GLOBAL_STOP_BIND set will cause the same action to occur on all engines with GLOBAL_STOP_BIND set.  This feature is usually used when synchronization between multiple engines/channels necessitates a global control of all supported engines.[br] Note: this field is only available if multiple channels/engines are supported for the current implementation, otherwise it is reserved."},
#else
{11, 11, 0x0000000000000000, "RW", "GLOBAL_STOP_BIND", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{10, 10, 0x0000000000000000, "RW", "GLOBAL_START_BIND", "Setting this bit will bind this channel engine to all other channel engines. A test start for any channel with GLOBAL_START_BIND set will cause the same action to occur on all engines with GLOBAL_START_BIND set. This feature is usually used when synchronization between multiple engines/channels necessitates a global control of all supported engines.[br] Note: this field is only available if multiple channels/engines are supported for the current implementation, otherwise it is reserved."},
#else
{10, 10, 0x0000000000000000, "RW", "GLOBAL_START_BIND", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{9, 9, 0x0000000000000000, "RW", "GLOBAL_STOP_ON_ERR_BIND", "Setting this bit will bind this channel engine to all other channel engines. A test stop (due to an error condition) for any channel with GLOBAL_STOP_ON_ERR_BIND set will cause the same action to occur on all engines with GLOBAL_STOP_ON_ERR_BIND set. This feature is usually used when synchronization between multiple engines/channels necessitates a global control of all supported engines.[br] Note: this field is only available if multiple channels/engines are supported for the current implementation, otherwise it is reserved."},
#else
{9, 9, 0x0000000000000000, "RW", "GLOBAL_STOP_ON_ERR_BIND", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{8, 8, 0x0000000000000000, "RW", "GLOBAL_CLEAR_ERR_BIND", "Setting this bit will bind this channel engine to all other channel engines. Clearing all error registers and error status for any channel with GLOBAL_CLEAR_ERR_BIND set will cause the same action to occur on all engines with GLOBAL_CLEAR_ERR_BIND set. This feature is usually used when synchronization between multiple engines/channels necessitates a global control of all supported engines.[br] Note: this field is only available if multiple channels/engines are supported for the current implementation, otherwise it is reserved."},
#else
{8, 8, 0x0000000000000000, "RW", "GLOBAL_CLEAR_ERR_BIND", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{6, 6, 0x0000000000000000, "RW", "ENABLE_CONSTANT_WRITE_STROBE", "Setting this bit will cause the Tx write strobe to be driven out constantly while a test is in progress.[br] Note: This is most often used to help train the correct setting for per rank write levelling."},
#else
{6, 6, 0x0000000000000000, "RW", "ENABLE_CONSTANT_WRITE_STROBE", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo187[] = {{"CPGC_SEQ_CFG_A", "", 0x0000010C, 7, 0x00000000003FFFFF, 0x0000000000200000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields188[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{0, 9, 0x0000000000000000, "RW", "START_DELAY", "Number of clock cycles (in CPGC-S clock domain) the start of the test is delayed by after START_TEST has been asserted by the user. This is usually used to synchronize multiple SoC CPGC engines on multiple channels according to a defined phase relationship."},
#else
{0, 9, 0x0000000000000000, "RW", "START_DELAY", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo188[] = {{"CPGC_SEQ_CFG_B", "", 0x00000110, 1, 0x00000000000003FF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields189[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{31, 31, 0x0000000000000000, "RO/V", "TEST_DONE", "This bit will be set when the test is complete (or has been forced to exit due to a stop condition). But is cleared on a reset or when user starts another test."},
#else
{31, 31, 0x0000000000000000, "RO/V", "TEST_DONE", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{30, 30, 0x0000000000000000, "RO/V", "TEST_BUSY", "This bit will be set when once a test has started.  Bit is cleared on a reset or once test is done (or has been forced to exit due a stop condition)."},
#else
{30, 30, 0x0000000000000000, "RO/V", "TEST_BUSY", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{29, 29, 0x0000000000000000, "RO/V", "ALGO_DONE", "This bit will be set when all the algorithms are complete. It is cleared on a reset."},
#else
{29, 29, 0x0000000000000000, "RO/V", "ALGO_DONE", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{28, 28, 0x0000000000000000, "RO/V", "SINGLE_MODE_PAUSED", "This bit will be set when a command has been issued and we are paused due to Single_Command_Mode.  The test may be continued by either clearing Single_Command_Mode or by setting Continue_Single_Mode."},
#else
{28, 28, 0x0000000000000000, "RO/V", "SINGLE_MODE_PAUSED", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo189[] = {{"CPGC_SEQ_STATUS", "", 0x00000114, 4, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields190[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{5, 10, 0x0000000000000020, "RW/P", "WR_CREDIT_INIT", "This gives the default value for write credit counter at reset."},
#else
{5, 10, 0x0000000000000020, "RW/P", "WR_CREDIT_INIT", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 4, 0x0000000000000010, "RW/P", "RD_CREDIT_INIT", "This gives the default value for read credit counter at reset."},
#else
{0, 4, 0x0000000000000010, "RW/P", "RD_CREDIT_INIT", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo190[] = {{"CPGC2_CHICKEN_REG", "", 0x00000118, 2, 0x00000000000007FF, 0x0000000000000410}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields191[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{0, 31, 0x0000000000000000, "RO/V", "Content", "Flat register read access to Raster Repository.[br]\r\n"
"The format of this is 2 consecutive addresses contain a complete 64-bit data chunk error bit-map, or one Error_Summary entry."},
#else
{0, 31, 0x0000000000000000, "RO/V", "Content", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo191[] = {{"CPGC2_RASTER_REPO_CONTENT_0_", "", 0x0000011C, 1, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields192[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{0, 31, 0x0000000000000000, "RO/V", "Content", "Flat register read access to Raster Repository.[br]\r\n"
"The format of this is 2 consecutive addresses contain a complete 64-bit data chunk error bit-map, or one Error_Summary entry."},
#else
{0, 31, 0x0000000000000000, "RO/V", "Content", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo192[] = {{"CPGC2_RASTER_REPO_CONTENT_1_", "", 0x00000120, 1, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields193[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{0, 31, 0x0000000000000000, "RO/V", "Content", "Flat register read access to Raster Repository.[br]\r\n"
"The format of this is 2 consecutive addresses contain a complete 64-bit data chunk error bit-map, or one Error_Summary entry."},
#else
{0, 31, 0x0000000000000000, "RO/V", "Content", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo193[] = {{"CPGC2_RASTER_REPO_CONTENT_2_", "", 0x00000124, 1, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields194[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{0, 31, 0x0000000000000000, "RO/V", "Content", "Flat register read access to Raster Repository.[br]\r\n"
"The format of this is 2 consecutive addresses contain a complete 64-bit data chunk error bit-map, or one Error_Summary entry."},
#else
{0, 31, 0x0000000000000000, "RO/V", "Content", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo194[] = {{"CPGC2_RASTER_REPO_CONTENT_3_", "", 0x00000128, 1, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields195[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{0, 31, 0x0000000000000000, "RO/V", "Content", "Flat register read access to Raster Repository.[br]\r\n"
"The format of this is 2 consecutive addresses contain a complete 64-bit data chunk error bit-map, or one Error_Summary entry."},
#else
{0, 31, 0x0000000000000000, "RO/V", "Content", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo195[] = {{"CPGC2_RASTER_REPO_CONTENT_4_", "", 0x0000012C, 1, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields196[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{0, 31, 0x0000000000000000, "RO/V", "Content", "Flat register read access to Raster Repository.[br]\r\n"
"The format of this is 2 consecutive addresses contain a complete 64-bit data chunk error bit-map, or one Error_Summary entry."},
#else
{0, 31, 0x0000000000000000, "RO/V", "Content", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo196[] = {{"CPGC2_RASTER_REPO_CONTENT_5_", "", 0x00000130, 1, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields197[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{0, 31, 0x0000000000000000, "RO/V", "Content", "Flat register read access to Raster Repository.[br]\r\n"
"The format of this is 2 consecutive addresses contain a complete 64-bit data chunk error bit-map, or one Error_Summary entry."},
#else
{0, 31, 0x0000000000000000, "RO/V", "Content", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo197[] = {{"CPGC2_RASTER_REPO_CONTENT_6_", "", 0x00000134, 1, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields198[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{0, 31, 0x0000000000000000, "RO/V", "Content", "Flat register read access to Raster Repository.[br]\r\n"
"The format of this is 2 consecutive addresses contain a complete 64-bit data chunk error bit-map, or one Error_Summary entry."},
#else
{0, 31, 0x0000000000000000, "RO/V", "Content", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo198[] = {{"CPGC2_RASTER_REPO_CONTENT_7_", "", 0x00000138, 1, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields199[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{0, 31, 0x0000000000000000, "RO/V", "Content", "Flat register read access to Raster Repository.[br]\r\n"
"The format of this is 2 consecutive addresses contain a complete 64-bit data chunk error bit-map, or one Error_Summary entry."},
#else
{0, 31, 0x0000000000000000, "RO/V", "Content", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo199[] = {{"CPGC2_RASTER_REPO_CONTENT_8_", "", 0x0000013C, 1, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields200[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{0, 31, 0x0000000000000000, "RO/V", "Content", "Flat register read access to Raster Repository.[br]\r\n"
"The format of this is 2 consecutive addresses contain a complete 64-bit data chunk error bit-map, or one Error_Summary entry."},
#else
{0, 31, 0x0000000000000000, "RO/V", "Content", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo200[] = {{"CPGC2_RASTER_REPO_CONTENT_9_", "", 0x00000140, 1, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields201[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{0, 31, 0x0000000000000000, "RO/V", "Content", "Flat register read access to Raster Repository.[br]\r\n"
"The format of this is 2 consecutive addresses contain a complete 64-bit data chunk error bit-map, or one Error_Summary entry."},
#else
{0, 31, 0x0000000000000000, "RO/V", "Content", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo201[] = {{"CPGC2_RASTER_REPO_CONTENT_10_", "", 0x00000144, 1, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields202[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{0, 31, 0x0000000000000000, "RO/V", "Content", "Flat register read access to Raster Repository.[br]\r\n"
"The format of this is 2 consecutive addresses contain a complete 64-bit data chunk error bit-map, or one Error_Summary entry."},
#else
{0, 31, 0x0000000000000000, "RO/V", "Content", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo202[] = {{"CPGC2_RASTER_REPO_CONTENT_11_", "", 0x00000148, 1, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields203[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{0, 31, 0x0000000000000000, "RO/V", "Content", "Flat register read access to Raster Repository.[br]\r\n"
"The format of this is 2 consecutive addresses contain a complete 64-bit data chunk error bit-map, or one Error_Summary entry."},
#else
{0, 31, 0x0000000000000000, "RO/V", "Content", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo203[] = {{"CPGC2_RASTER_REPO_CONTENT_12_", "", 0x0000014C, 1, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields204[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{0, 31, 0x0000000000000000, "RO/V", "Content", "Flat register read access to Raster Repository.[br]\r\n"
"The format of this is 2 consecutive addresses contain a complete 64-bit data chunk error bit-map, or one Error_Summary entry."},
#else
{0, 31, 0x0000000000000000, "RO/V", "Content", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo204[] = {{"CPGC2_RASTER_REPO_CONTENT_13_", "", 0x00000150, 1, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields205[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{0, 31, 0x0000000000000000, "RO/V", "Content", "Flat register read access to Raster Repository.[br]\r\n"
"The format of this is 2 consecutive addresses contain a complete 64-bit data chunk error bit-map, or one Error_Summary entry."},
#else
{0, 31, 0x0000000000000000, "RO/V", "Content", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo205[] = {{"CPGC2_RASTER_REPO_CONTENT_14_", "", 0x00000154, 1, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields206[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{0, 31, 0x0000000000000000, "RO/V", "Content", "Flat register read access to Raster Repository.[br]\r\n"
"The format of this is 2 consecutive addresses contain a complete 64-bit data chunk error bit-map, or one Error_Summary entry."},
#else
{0, 31, 0x0000000000000000, "RO/V", "Content", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo206[] = {{"CPGC2_RASTER_REPO_CONTENT_15_", "", 0x00000158, 1, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields207[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{26, 27, 0x0000000000000000, "RO/V", "fail_count3", "Bank 0 Number of failing address."},
#else
{26, 27, 0x0000000000000000, "RO/V", "fail_count3", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{25, 25, 0x0000000000000000, "RO/V", "fail_any3", "0 - indications no failing address, 1 - indications 1 or more failing address"},
#else
{25, 25, 0x0000000000000000, "RO/V", "fail_any3", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{24, 24, 0x0000000000000000, "RO/V", "fail_excess3", "0  indicates no more than fail_max failing addresses, 1 - indicates more than fail_max failing addresses"},
#else
{24, 24, 0x0000000000000000, "RO/V", "fail_excess3", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{18, 19, 0x0000000000000000, "RO/V", "fail_count2", "Bank 0 Number of failing address."},
#else
{18, 19, 0x0000000000000000, "RO/V", "fail_count2", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{17, 17, 0x0000000000000000, "RO/V", "fail_any2", "0 - indications no failing address, 1 - indications 1 or more failing address"},
#else
{17, 17, 0x0000000000000000, "RO/V", "fail_any2", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{16, 16, 0x0000000000000000, "RO/V", "fail_excess2", "0  indicates no more than fail_max failing addresses, 1 - indicates more than fail_max failing addresses"},
#else
{16, 16, 0x0000000000000000, "RO/V", "fail_excess2", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{10, 11, 0x0000000000000000, "RO/V", "fail_count1", "Bank 0 Number of failing address."},
#else
{10, 11, 0x0000000000000000, "RO/V", "fail_count1", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{9, 9, 0x0000000000000000, "RO/V", "fail_any1", "0 - indications no failing address, 1 - indications 1 or more failing address"},
#else
{9, 9, 0x0000000000000000, "RO/V", "fail_any1", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{8, 8, 0x0000000000000000, "RO/V", "fail_excess1", "0  indicates no more than fail_max failing addresses, 1 - indicates more than fail_max failing addresses"},
#else
{8, 8, 0x0000000000000000, "RO/V", "fail_excess1", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{2, 3, 0x0000000000000000, "RO/V", "fail_count0", "Bank 0 Number of failing address."},
#else
{2, 3, 0x0000000000000000, "RO/V", "fail_count0", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{1, 1, 0x0000000000000000, "RO/V", "fail_any0", "0 - indications no failing address, 1 - indications 1 or more failing address"},
#else
{1, 1, 0x0000000000000000, "RO/V", "fail_any0", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 0, 0x0000000000000000, "RO/V", "fail_excess0", "0  indicates no more than fail_max failing addresses, 1 - indicates more than fail_max failing addresses"},
#else
{0, 0, 0x0000000000000000, "RO/V", "fail_excess0", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo207[] = {{"CPGC2_RASTER_REPO_CONTENT_ECC1", "", 0x0000015C, 12, 0x000000000FFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields208[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{26, 27, 0x0000000000000000, "RO/V", "fail_count3", "Bank 0 Number of failing address."},
#else
{26, 27, 0x0000000000000000, "RO/V", "fail_count3", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{25, 25, 0x0000000000000000, "RO/V", "fail_any3", "0 - indications no failing address, 1 - indications 1 or more failing address"},
#else
{25, 25, 0x0000000000000000, "RO/V", "fail_any3", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{24, 24, 0x0000000000000000, "RO/V", "fail_excess3", "0  indicates no more than fail_max failing addresses, 1 - indicates more than fail_max failing addresses"},
#else
{24, 24, 0x0000000000000000, "RO/V", "fail_excess3", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{18, 19, 0x0000000000000000, "RO/V", "fail_count2", "Bank 0 Number of failing address."},
#else
{18, 19, 0x0000000000000000, "RO/V", "fail_count2", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{17, 17, 0x0000000000000000, "RO/V", "fail_any2", "0 - indications no failing address, 1 - indications 1 or more failing address"},
#else
{17, 17, 0x0000000000000000, "RO/V", "fail_any2", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{16, 16, 0x0000000000000000, "RO/V", "fail_excess2", "0  indicates no more than fail_max failing addresses, 1 - indicates more than fail_max failing addresses"},
#else
{16, 16, 0x0000000000000000, "RO/V", "fail_excess2", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{10, 11, 0x0000000000000000, "RO/V", "fail_count1", "Bank 0 Number of failing address."},
#else
{10, 11, 0x0000000000000000, "RO/V", "fail_count1", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{9, 9, 0x0000000000000000, "RO/V", "fail_any1", "0 - indications no failing address, 1 - indications 1 or more failing address"},
#else
{9, 9, 0x0000000000000000, "RO/V", "fail_any1", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{8, 8, 0x0000000000000000, "RO/V", "fail_excess1", "0  indicates no more than fail_max failing addresses, 1 - indicates more than fail_max failing addresses"},
#else
{8, 8, 0x0000000000000000, "RO/V", "fail_excess1", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{2, 3, 0x0000000000000000, "RO/V", "fail_count0", "Bank 0 Number of failing address."},
#else
{2, 3, 0x0000000000000000, "RO/V", "fail_count0", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{1, 1, 0x0000000000000000, "RO/V", "fail_any0", "0 - indications no failing address, 1 - indications 1 or more failing address"},
#else
{1, 1, 0x0000000000000000, "RO/V", "fail_any0", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 0, 0x0000000000000000, "RO/V", "fail_excess0", "0  indicates no more than fail_max failing addresses, 1 - indicates more than fail_max failing addresses"},
#else
{0, 0, 0x0000000000000000, "RO/V", "fail_excess0", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo208[] = {{"CPGC2_RASTER_REPO_CONTENT_ECC2", "", 0x00000160, 12, 0x000000000FFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields209[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{0, 31, 0x0000000000000000, "RO/V", "Read_Command_Count_Current", "Current count of reads - freezes on stop_on_error conditions at the number of reads including the error that caused the stop."},
#else
{0, 31, 0x0000000000000000, "RO/V", "Read_Command_Count_Current", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo209[] = {{"CPGC2_READ_COMMAND_COUNT_CURRENT", "", 0x00000164, 1, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields210[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{0, 31, 0x0000000000000000, "RW", "Mask_First_N_Reads", "0=no masking, N= number of reads that will not result in any error indication for the raster repository."},
#else
{0, 31, 0x0000000000000000, "RW", "Mask_First_N_Reads", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo210[] = {{"CPGC2_MASK_ERRS_FIRST_N_READS", "", 0x00000168, 1, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields211[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{31, 31, 0x0000000000000000, "RW/V", "RasterRepoClear", "Reset the raster repo entries"},
#else
{31, 31, 0x0000000000000000, "RW/V", "RasterRepoClear", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{30, 30, 0x0000000000000000, "RW", "StopOnRaster", "If Raster Mode 1, test will stop after loading the bitmap into the raster, if Raster Mode 2, test will stop after loading 8 errors in the raster"},
#else
{30, 30, 0x0000000000000000, "RW", "StopOnRaster", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{16, 17, 0x0000000000000000, "RW", "RasterRepoMode", "00 Mode 1 BitMap Mode  [br][br]\r\n"
"01 Mode 2 Summary Mode [br]\r\n"
"10 mode 3 Filtered Failed Row Mode"},
#else
{16, 17, 0x0000000000000000, "RW", "RasterRepoMode", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{10, 11, 0x0000000000000000, "RW", "FailMax", "Maximum number of failing address before an additional failing address will set fail_excess for any bank.[br]\r\n"
"00  one failure, 01 - two failures, 10 - three failures, 11- four failures[br]\r\n"
"Maximum number of failing address before an additional failing address will set fail_excess for any bank.[br]\r\n"
"00  one failure, 01 - two failures, 10 - three failures, 11- four failures[br]\r\n"
""},
#else
{10, 11, 0x0000000000000000, "RW", "FailMax", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{9, 9, 0x0000000000000000, "RO/V", "FailAnyAll", "0 - indications no failing address, 1 - indications 1 or more failing address"},
#else
{9, 9, 0x0000000000000000, "RO/V", "FailAnyAll", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{8, 8, 0x0000000000000000, "RO/V", "FailExcessAll", "0 - indications less than max_fail failing addresses on all banks, 1 - indications "},
#else
{8, 8, 0x0000000000000000, "RO/V", "FailExcessAll", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{4, 6, 0x0000000000000000, "RO/V", "NumErrLogged", "Indicates the current number of errors loaded in the raster repo in Mode 2. Max value is 8"},
#else
{4, 6, 0x0000000000000000, "RO/V", "NumErrLogged", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{2, 2, 0x0000000000000000, "RO/V", "RasterRepoFull", "Indicates when the no. of errors logged exceed max value of 8"},
#else
{2, 2, 0x0000000000000000, "RO/V", "RasterRepoFull", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{1, 1, 0x0000000000000000, "RO/V", "SummaryValid", "Indicates when the summary information of the erroneous bitmap is loaded in the current summary buffer. This information consist of Algorithmic data, Physical Addr (Rank, Bank,Row,Col) and 8 2-bit error summary for every chunk"},
#else
{1, 1, 0x0000000000000000, "RO/V", "SummaryValid", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 0, 0x0000000000000000, "RO/V", "BitmapValid", "Indicates when Mode 1 erroneous bitmap data is loaded in the raster repo"},
#else
{0, 0, 0x0000000000000000, "RO/V", "BitmapValid", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo211[] = {{"CPGC2_RASTER_REPO_STATUS", "", 0x0000016C, 10, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields212[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{16, 31, 0x0000000000000000, "RO/V", "Algorithm_Summary", "Algorithm_Summary - currently formated as:[br]\r\n"
"[2:0] Offset_Command_Instruction_Current[br]\r\n"
"[5:3] Offset_Address_Instruction_Current[br]\r\n"
"[10:6] Command_Instruction_Current[br]\r\n"
"[13:11] Algorithm_Instruction_Current[br]\r\n"
"[15:14] Data_Instruction_Current"},
#else
{16, 31, 0x0000000000000000, "RO/V", "Algorithm_Summary", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 15, 0x0000000000000000, "RO/V", "Error_Summary", "Error_Summary - formatted as a pair of adjacent bits for each chunk, 00=no error in that chunk, 01=one error in that chunk, 10=two errors in that chunk, 11=three or more errors in that chunk."},
#else
{0, 15, 0x0000000000000000, "RO/V", "Error_Summary", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo212[] = {{"CPGC2_ERR_SUMMARY_A", "", 0x00000170, 2, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields213[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{2, 31, 0x0000000000000000, "RO/V", "Physical_Addres_Summary", "Error_Summary - Physical Address encoded as:[br]\r\n"
"[7:0] Column, [25:8] Row, [28:26] Bank, [29] Rank"},
#else
{2, 31, 0x0000000000000000, "RO/V", "Physical_Addres_Summary", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 1, 0x0000000000000000, "RO/V", "Algorithm_Summary", "Algorithm_Summary - currently formated as:[br]\r\n"
"[1:0] Address_Instruction_Current"},
#else
{0, 1, 0x0000000000000000, "RO/V", "Algorithm_Summary", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo213[] = {{"CPGC2_ERR_SUMMARY_B", "", 0x00000174, 2, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields214[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{0, 31, 0x0000000000000000, "RO/V", "DG_Reserved", "Reserved for expansion of Error_Summary (bits 7:0)"},
#else
{0, 31, 0x0000000000000000, "RO/V", "DG_Reserved", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo214[] = {{"CPGC2_ERR_SUMMARY_C", "", 0x00000178, 1, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields215[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{16, 18, 0x0000000000000000, "RW", "BUF_END_PNTR", "Pointer to last data pattern buffer entry before wrapping back to BUF_STRT_PTR if incrementing is enabled through being different from BUF_STRT_PTR.[br] Note: The actual size of this field depends on the # of lines supported for data generation. i.e If 1 or 2 lines are supported then it is a 1 bit field, if 8 lines are supported then 3 bits are available.Currently the RTL uses internal CPGC buffers so it has 4 lines and requires 2 bits"},
#else
{16, 18, 0x0000000000000000, "RW", "BUF_END_PNTR", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{8, 10, 0x0000000000000000, "RW", "BUF_STRT_PNTR", "Pointer to first buffer entry.  Also used as the only entry if BUF_INC_EN is not enabled.[br] Note: The actual size of this field depends on the # of lines supported for data generation (DATA_PAT_DEPTH_CAP). i.e If 1 or 2 lines are supported then it is a 1 bit field, if 16 lines are supported then the whole 4 bits are available.Currently the RTL uses internal CPGC buffers so it has 8 lines and requires 3 bits"},
#else
{8, 10, 0x0000000000000000, "RW", "BUF_STRT_PNTR", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{6, 6, 0x0000000000000000, "RW", "BUF_PNTR_INC_SCALE", "If set, the buffer pointer will be incremented at a linear rate given by BUF_PTR_INC_RATE, otherwise the buffer pointer will be incremented at an exponential rate given by BUF_PTR_INC_RATE.[br][br]\r\n"
"1=Buffer Pointer Increment Rate field is treated as a linear number.[br][br]\r\n"
"0=Buffer Pointer Increment Rate field is treated is an exponential number."},
#else
{6, 6, 0x0000000000000000, "RW", "BUF_PNTR_INC_SCALE", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 5, 0x0000000000000000, "RW", "BUF_PNTR_INC_RATE", "0: Each buffer entry will be used for 2^BUF_PTR_INC_RATE number of bursts (64Bytes) [br]\r\n"
"1:Each buffer entry will be used for BUF_PTR_INC_RATE + 1 number of 8-UI[br]\r\n"
"-- before incrementing the buffer pointer by 1.[br]\r\n"
" Note:  To disable Buffer Pointer increments, set BUF_END_PTR==BUF_STRT_PTR."},
#else
{0, 5, 0x0000000000000000, "RW", "BUF_PNTR_INC_RATE", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo215[] = {{"CPGC_DPAT_BUF_CTL", "", 0x0000017C, 4, 0x000000000007FFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields216[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{24, 28, 0x0000000000000000, "RW", "RELOAD_LFSR_SEED_RATE", "Reload_LFSR_Seed_Rate only exists if the LFSR_Save_Restore capability is set to 1.[br][br]\r\n"
"Reload_LFSR_Seed_Rate and Save_LFSR_Seed_Rate is most often used in conjunction with Lane_Rotate_Rate where the user desires to replay the same deterministic LFSR stress as the victim aggressor patterns shifts Lanes left.  When the victim aggressor pattern returns to the starting position the current LFSR stress is saved using Save_LFSR_Seed_Rate to allow the LFSR stress to advance for the new period.[br][br]\r\n"
"2^(Reload_LFSR_Seed_Rate-1) defines the periodic Loopcount interval that the current LFSR Seed UNISEQ#_RDSTAT.Uniseq_RdStat is reloaded from CPGC_UNISEQ#_RDSAVE.Pattern_Buffer[br][br]\r\n"
"When the Save_LFSR_Seed_Rate and Reload_LFSR_Seed_Rate is reached in the same Bit only the saving of the LFSR seed takes place.[br][br]\r\n"
"Examples:[br][br]\r\n"
"0=Disable - The current LFSR seed is never reloaded.[br][br]\r\n"
"1=The current LFSR seed  is reloaded every Loopcount.[br][br]\r\n"
"2=The current LFSR seed  is reloaded every other Loopcount.[br][br]\r\n"
"3=The current LFSR seed  is reloaded every fourth Loopcount."},
#else
{24, 28, 0x0000000000000000, "RW", "RELOAD_LFSR_SEED_RATE", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{16, 23, 0x0000000000000000, "RW", "SAVE_LFSR_SEED_RATE", "Save_LFSR_Seed_Rate only exists if the LFSR_Save_Restore capability is set to 1.[br][br]\r\n"
"See Reload_LFSR_Seed_Rate for use model.[br][br]\r\n"
"UNISEQ#_RDSAVE.Pattern_Buffer is initially loaded at the start of a test with UNISEQ#_RDSTAT.Uniseq_RdStat (the Seed). [br][br]\r\n"
"2^(Reload_LFSR_Seed_Rate-1) * (Save_LFSR_Seed_Rate) defines the periodic Loopcount interval that the current LFSR Seed is saved into UNISEQ#_RDSAVE.Pattern_Buffer[br][br]\r\n"
"When the Save_LFSR_Seed_Rate and Reload_LFSR_Seed_Rate is reached in the same Loopcount only the saving of the LFSR seed takes place.[br][br]\r\n"
"Examples:[br][br]\r\n"
"0=Disable - The current LFSR seed (UNISEQ#_RDSTAT.Uniseq_RdStat) is saved only at the start of test into UNISEQ#_RDSAVE.Pattern_Buffer[br][br]\r\n"
"1=Illegal (Would save every Reload and effectively disable both Save and Reload).[br][br]\r\n"
"2=The current LFSR seed is saved every other 2^(Reload_LFSR_Seed_Rate-1) Loopcounts.[br][br]\r\n"
"3=The current LFSR seed is saved every third Reload (and Reload does not happen)."},
#else
{16, 23, 0x0000000000000000, "RW", "SAVE_LFSR_SEED_RATE", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{15, 15, 0x0000000000000000, "RW", "ECC_DATA_SOURCE_SEL", "Indicates whether byte 0 (Dq0-Dq7) or byte 7 (dq56-dq63) is transmitted and compared for the ECC byte.[br][br]\r\n"
"0=byte group 0 will be transmitted and compared for the ECC byte.[br][br]\r\n"
"1=byte group 7 will be transmitted and compared for the ECC byte.[br][br]\r\n"
"Hardware directs if ECC is included within Generation and Checking."},
#else
{15, 15, 0x0000000000000000, "RW", "ECC_DATA_SOURCE_SEL", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{14, 14, 0x0000000000000000, "RW", "ECC_REPLACE_BYTE_CONTROL", "ECC_Replace_Byte_Control is used by the Read data path to mux the received ECC byte into the same byte group indicated by ECC_Data_Source_Sel.[br][br]\r\n"
"This is needed to capture ECC cacheline errors into the WDB when Enable_WDB_Error_Capture is set to 1."},
#else
{14, 14, 0x0000000000000000, "RW", "ECC_REPLACE_BYTE_CONTROL", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{13, 13, 0x0000000000000000, "RW", "ECC_DISABLE", "Setting this bit will internally disable all related ECC features in CPGC-S having the effect of generating all '0 in the ECC CPGC-S interface outputs, and of Binding to '0 all the ECC interface CPGC-S inputs. ECC masks and error comparisons will be disabled as well.[br] Note: If ECC is not supported at compile time, this bit will be reserved."},
#else
{13, 13, 0x0000000000000000, "RW", "ECC_DISABLE", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{6, 7, 0x0000000000000000, "RW", "UNISEQ2_MODE", "Defines the operational mode for unified sequence 2 as follows:[br][br]\r\n"
"00 - LMN Mode[br][br]\r\n"
"01 - Pattern Buffer Mode[br][br]\r\n"
"10 - LFSR Mode[br][br]\r\n"
"11 - Reserved for future use"},
#else
{6, 7, 0x0000000000000000, "RW", "UNISEQ2_MODE", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{3, 4, 0x0000000000000000, "RW", "UNISEQ1_MODE", "Defines the operational mode for unified sequence 1 as follows:[br][br]\r\n"
"00 - LMN Mode[br][br]\r\n"
"01 - Pattern Buffer Mode[br][br]\r\n"
"10 - LFSR Mode[br][br]\r\n"
"11 - Reserved for future use"},
#else
{3, 4, 0x0000000000000000, "RW", "UNISEQ1_MODE", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 1, 0x0000000000000000, "RW", "UNISEQ0_MODE", "Defines the operational mode for unified sequence 0 as follows:[br][br]\r\n"
"00 - LMN Mode[br][br]\r\n"
"01 - Pattern Buffer Mode[br][br]\r\n"
"10 - LFSR Mode[br][br]\r\n"
"11 - Reserved for future use"},
#else
{0, 1, 0x0000000000000000, "RW", "UNISEQ0_MODE", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo216[] = {{"CPGC_DPAT_CFG", "", 0x00000180, 8, 0x000000001FFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields217[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{24, 29, 0x0000000000000000, "RW", "LANE_ROTATE_RATE", "Lane_Rotate_Rate only exists if the Lane_Rotation_Support capability exists.[br][br]\r\n"
"2^(Lane_Rotate_Rate-1) indicates the periodic Loopcount rate when the EXTBUF_# registers are rotated up by one bit.[br][br]\r\n"
"Lane_Rotate_Rate=0 disables all rotation.[br][br]\r\n"
"Lane_Rotate_Rate=1 causes the EXTBUF_# registers to be rotated every one Loopcount.[br][br]\r\n"
"Lane_Rotate_Rate=2  causes the EXTBUF_# registers to be rotated every other Loopcount.[br][br]\r\n"
"Etc..[br][br]\r\n"
"When the EXTBUF_# registers are rotated Bit 0 shifts to Bit 1 all the way up to the Max-1 Bit and the Max bit shifts to Bit0."},
#else
{24, 29, 0x0000000000000000, "RW", "LANE_ROTATE_RATE", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{23, 23, 0x0000000000000000, "RW", "UNISEQ2_LFSR_STAGGER", "0=No Stagger, 1=Stagger.[br][br]\r\n"
"This bit must not be set unless Uniseq2_Mode is programmed to Select LFSR or the behavior is undefined."},
#else
{23, 23, 0x0000000000000000, "RW", "UNISEQ2_LFSR_STAGGER", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{18, 20, 0x0000000000000000, "RW", "UNISEQ2_LFSR_POLYNOMIAL_SIZE", "Possible Polynomial Sizes:[br][br]\r\n"
"0x0=Use 8 bit LFSR (x8 + x6 + x5 + x4)[br][br]\r\n"
"0x1=Use 15 bit LFSR (x15 + x14)[br][br]\r\n"
"0x2=Use 31 bit LFSR (x31 + x28)[br][br]\r\n"
"0x3=Use 23 bit LFSR (x23 + x18)[br][br]\r\n"
"0x4=Use 7 bit LFSR (x7 + x6)[br][br]\r\n"
"0x5=Use 16 bit LFSR (x16+x5+x4+x3)[br][br]\r\n"
"0x6=Use 23 bit LFSR (x23+x21+x18+x15+x7+x2)[br][br]\r\n"
"0x7=Use 32 bit LFSR (x32+x31+x30+x10)"},
#else
{18, 20, 0x0000000000000000, "RW", "UNISEQ2_LFSR_POLYNOMIAL_SIZE", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{15, 15, 0x0000000000000000, "RW", "UNISEQ1_LFSR_STAGGER", "0=No Stagger, 1=Stagger.[br][br]\r\n"
"This bit must not be set unless Uniseq1_Mode is programmed to Select LFSR or the behavior is undefined."},
#else
{15, 15, 0x0000000000000000, "RW", "UNISEQ1_LFSR_STAGGER", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{10, 12, 0x0000000000000000, "RW", "UNISEQ1_LFSR_POLYNOMIAL_SIZE", "Possible Polynomial Sizes:[br][br]\r\n"
"0x0=Use 8 bit LFSR (x8 + x6 + x5 + x4)[br][br]\r\n"
"0x1=Use 15 bit LFSR (x15 + x14)[br][br]\r\n"
"0x2=Use 31 bit LFSR (x31 + x28)[br][br]\r\n"
"0x3=Use 23 bit LFSR (x23 + x18)[br][br]\r\n"
"0x4=Use 7 bit LFSR (x7 + x6)[br][br]\r\n"
"0x5=Use 16 bit LFSR (x16+x5+x4+x3)[br][br]\r\n"
"0x6=Use 23 bit LFSR (x23+x21+x18+x15+x7+x2)[br][br]\r\n"
"0x7=Use 32 bit LFSR (x32+x31+x30+x10)"},
#else
{10, 12, 0x0000000000000000, "RW", "UNISEQ1_LFSR_POLYNOMIAL_SIZE", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{7, 7, 0x0000000000000000, "RW", "UNISEQ0_LFSR_STAGGER", "0=No Stagger, 1=Stagger.[br][br]\r\n"
"This bit must not be set unless Uniseq0_Mode is programmed to Select LFSR or the behavior is undefined."},
#else
{7, 7, 0x0000000000000000, "RW", "UNISEQ0_LFSR_STAGGER", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{2, 4, 0x0000000000000000, "RW", "UNISEQ0_LFSR_POLYNOMIAL_SIZE", "Possible Polynomial Sizes:[br][br]\r\n"
"0x0=Use 8 bit LFSR (x8 + x6 + x5 + x4)[br][br]\r\n"
"0x1=Use 15 bit LFSR (x15 + x14)[br][br]\r\n"
"0x2=Use 31 bit LFSR (x31 + x28)[br][br]\r\n"
"0x3=Use 23 bit LFSR (x23 + x18)[br][br]\r\n"
"0x4=Use 7 bit LFSR (x7 + x6)[br][br]\r\n"
"0x5=Use 16 bit LFSR (x16+x5+x4+x3)[br][br]\r\n"
"0x6=Use 23 bit LFSR (x23+x21+x18+x15+x7+x2)[br][br]\r\n"
"0x7=Use 32 bit LFSR (x32+x31+x30+x10)"},
#else
{2, 4, 0x0000000000000000, "RW", "UNISEQ0_LFSR_POLYNOMIAL_SIZE", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo217[] = {{"CPGC_DPAT_XTRA_LFSR_CFG", "", 0x00000184, 7, 0x000000003FFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields218[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{0, 31, 0x00000000AA55AA55, "RW", "PATTERN_BUFFER", "If UniSeq#_Mode is set to Pattern Buffer mode, then this field represents the initial content of the rotating pattern buffer for the unified sequencer. If UniSeq#_Mode is set to LFSR mode, then this field represents the 32-bit LFSR seed for the unified sequencer. Note: This is a shared register, it has a meaning according to the UniSeq# mode."},
#else
{0, 31, 0x00000000AA55AA55, "RW", "PATTERN_BUFFER", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo218[] = {{"CPGC_DPAT_UNISEQ_0_", "", 0x00000188, 1, 0x00000000FFFFFFFF, 0x00000000AA55AA55}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields219[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{0, 31, 0x00000000AA55AA55, "RW", "PATTERN_BUFFER", "If UniSeq#_Mode is set to Pattern Buffer mode, then this field represents the initial content of the rotating pattern buffer for the unified sequencer. If UniSeq#_Mode is set to LFSR mode, then this field represents the 32-bit LFSR seed for the unified sequencer. Note: This is a shared register, it has a meaning according to the UniSeq# mode."},
#else
{0, 31, 0x00000000AA55AA55, "RW", "PATTERN_BUFFER", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo219[] = {{"CPGC_DPAT_UNISEQ_1_", "", 0x0000018C, 1, 0x00000000FFFFFFFF, 0x00000000AA55AA55}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields220[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{0, 31, 0x00000000AA55AA55, "RW", "PATTERN_BUFFER", "If UniSeq#_Mode is set to Pattern Buffer mode, then this field represents the initial content of the rotating pattern buffer for the unified sequencer. If UniSeq#_Mode is set to LFSR mode, then this field represents the 32-bit LFSR seed for the unified sequencer. Note: This is a shared register, it has a meaning according to the UniSeq# mode."},
#else
{0, 31, 0x00000000AA55AA55, "RW", "PATTERN_BUFFER", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo220[] = {{"CPGC_DPAT_UNISEQ_2_", "", 0x00000190, 1, 0x00000000FFFFFFFF, 0x00000000AA55AA55}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields221[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{24, 31, 0x0000000000000001, "RW", "N_CNT", "N_Count only exists if  LMN_Support capability is set to 1.[br] After L_Count bits are driven at the beginning of a test then periodic pattern is continuously repeated depending on the value of Enable_Sweep_Frequency.[br] If Enable_Sweep_Frequency=0 then a steady state frequency is driven (see Enable_Sweep_Frequency for exact behavior).[br] If Enable_Sweep_Frequency=1 then a frequency sweep is continuously generated ranging from 2*(M) to 2*(N) driven (see Enable_Sweep_Frequency for exact behavior)"},
#else
{24, 31, 0x0000000000000001, "RW", "N_CNT", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{16, 23, 0x0000000000000001, "RW", "M_CNT", "M_Count only exists if  LMN_Support capability is set to 1.[br] After L_Count bits are driven at the beginning of a test then periodic pattern is continuously repeated depending on the value of Enable_Sweep_Frequency.[br] If Enable_Sweep_Frequency=0 then a steady state frequency is driven (see Enable_Sweep_Frequency for exact behavior).[br]If Enable_Sweep_Frequency=1 then a frequency sweep is continuously generated ranging from 2*(M) to 2*(N) driven (see Enable_Sweep_Frequency for exact behavior)"},
#else
{16, 23, 0x0000000000000001, "RW", "M_CNT", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{8, 15, 0x0000000000000001, "RW", "L_CNT", "If LMN_Support capability is set to 0 then:[br]A periodic square wave is generated that has the following behavior.[br][br]\r\n"
"1) Drive L_Polarity for L_Count Bits.[br][br]\r\n"
"2) Drive inverse of L_Polarity for L_Count Bits.[br][br]\r\n"
"3) Go to step 1.[br][br]\r\n"
"Else if LMN_Support is set to 1 then:[br][br]\r\n"
"After L_Count bits are driven at the beginning of a test then periodic pattern is continuously repeated depending on the value of Enable_Sweep_Frequency is set to 1.[br][br]\r\n"
"If Enable_Sweep_Frequency=0 then a steady state frequency is driven (see Enable_Sweep_Frequency for exact behavior)[br][br]\r\n"
"If Enable_Sweep_Frequency=1 then a frequency sweep is continuously generated ranging from 2*(M) to 2*(N) driven (see Enable_Sweep_Frequency for exact behavior)."},
#else
{8, 15, 0x0000000000000001, "RW", "L_CNT", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{4, 7, 0x0000000000000000, "RW", "L_COUNTER_HI", "Additional 4 bits to increase the size of LCount upto 12."},
#else
{4, 7, 0x0000000000000000, "RW", "L_COUNTER_HI", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{2, 2, 0x0000000000000000, "RW", "L_COUNT_EN", "Used in concatenation with FREQ_SWEEP_EN to enable 3 possible modes of LMN behavior."},
#else
{2, 2, 0x0000000000000000, "RW", "L_COUNT_EN", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{1, 1, 0x0000000000000000, "RW", "FREQ_SWEEP_EN", "Used in concatenation with L_COUNT_EN to enable 3 possible modes of LMN behavior:[br][br]\r\n"
"{L_COUNT_EN,FREQ_SWEEP_EN}[br][br]\r\n"
"{0,0} - Normal LMN[br][br]\r\n"
"{0,1} - Sweep clock pattern from 2*M period down to 2*N_Count period and repeat.[br][br]\r\n"
"{1,0} - L-Counter - drive clock pattern of 2*L period.[br][br]\r\n"
"{1,1} - Currently same as L-Counter mode - reserved for future use.[br][br]\r\n"
"If Normal LMN mode, then the following pattern is continuously repeated:[br][br]\r\n"
"  1) Drive L_Count bits with the  polarity set by L_Polarity[br][br]\r\n"
"  2) Drive M_Count bits with the  inverse of L_Polarity[br][br]\r\n"
"  3) Drive N_Count bits with the  value of L_Polarity[br][br]\r\n"
"  4) Go to step 2)[br][br]\r\n"
"If any L_Count, M_Count, or N_Count=0 then the  state will freeze at the polarity driven for that stage.[br][br][br]\r\n"
"If Sweep mode, then the following pattern is continuously repeated:[br][br]\r\n"
"  1) Drive L_Count bits with the  polarity set by L_Polarity[br][br]\r\n"
"  2) X_count=M_Count [br][br]\r\n"
"  3) Drive X_Count bits with the  inverse of L_Polarity[br][br]\r\n"
"  4) Drive X_Count bits with the  value of L_Polarity[br][br]\r\n"
"  5) Drive X_Count bits with the  inverse of L_Polarity[br][br]\r\n"
"  6) If X_Count==N_Count then go to step 9[br][br]\r\n"
"  7) X_Count=X_Count-1[br][br]\r\n"
"  8) Go to step 10[br][br]\r\n"
"  9) X_Count=M_Count[br][br]\r\n"
"10) Drive X_Count bits with the  value of L_Polarity[br][br]\r\n"
"11) Go to step 3[br][br]\r\n"
"[br]\r\n"
"If LCount mode, then the following pattern is continuously repeated:[br][br]\r\n"
"  1) Drive L_Polarity for L_Count Bits[br][br]\r\n"
"  2) Drive inverse of L_Polarity for L_Count Bits[br][br]\r\n"
"  3) Go to step 1 [br][br]\r\n"
"  [br][br]\r\n"
"if {0,1}, L_Count, M_Count, and N_Count must never be programmed to 0 and is considered undefined.[br][br]\r\n"
"if {1,0}, L_Count must never be programmed to 0 and is considered undefined.[br][br]\r\n"
"if {0,1}, M_Count and N_Count must be greater than or equal to 8 or behavior may be implementation specific.[br][br]\r\n"
"if {0,1}, N_Count must be programmed less than M_Count."},
#else
{1, 1, 0x0000000000000000, "RW", "FREQ_SWEEP_EN", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 0, 0x0000000000000000, "RW", "L_SEL", "The initial logic output of the sequencer is defined as follows:[br][br]\r\n"
"                        0 - Output Logic '0' for L_CNT UIs[br][br]\r\n"
"                        1 - Output Logic '1' for L_CNT UIs"},
#else
{0, 0, 0x0000000000000000, "RW", "L_SEL", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo221[] = {{"CPGC_DPAT_UNISEQ_LMN_0_", "", 0x00000194, 7, 0x00000000FFFFFFFF, 0x0000000001010100}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields222[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{24, 31, 0x0000000000000001, "RW", "N_CNT", "N_Count only exists if  LMN_Support capability is set to 1.[br] After L_Count bits are driven at the beginning of a test then periodic pattern is continuously repeated depending on the value of Enable_Sweep_Frequency.[br] If Enable_Sweep_Frequency=0 then a steady state frequency is driven (see Enable_Sweep_Frequency for exact behavior).[br] If Enable_Sweep_Frequency=1 then a frequency sweep is continuously generated ranging from 2*(M) to 2*(N) driven (see Enable_Sweep_Frequency for exact behavior)"},
#else
{24, 31, 0x0000000000000001, "RW", "N_CNT", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{16, 23, 0x0000000000000001, "RW", "M_CNT", "M_Count only exists if  LMN_Support capability is set to 1.[br] After L_Count bits are driven at the beginning of a test then periodic pattern is continuously repeated depending on the value of Enable_Sweep_Frequency.[br] If Enable_Sweep_Frequency=0 then a steady state frequency is driven (see Enable_Sweep_Frequency for exact behavior).[br]If Enable_Sweep_Frequency=1 then a frequency sweep is continuously generated ranging from 2*(M) to 2*(N) driven (see Enable_Sweep_Frequency for exact behavior)"},
#else
{16, 23, 0x0000000000000001, "RW", "M_CNT", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{8, 15, 0x0000000000000001, "RW", "L_CNT", "If LMN_Support capability is set to 0 then:[br]A periodic square wave is generated that has the following behavior.[br][br]\r\n"
"1) Drive L_Polarity for L_Count Bits.[br][br]\r\n"
"2) Drive inverse of L_Polarity for L_Count Bits.[br][br]\r\n"
"3) Go to step 1.[br][br]\r\n"
"Else if LMN_Support is set to 1 then:[br][br]\r\n"
"After L_Count bits are driven at the beginning of a test then periodic pattern is continuously repeated depending on the value of Enable_Sweep_Frequency is set to 1.[br][br]\r\n"
"If Enable_Sweep_Frequency=0 then a steady state frequency is driven (see Enable_Sweep_Frequency for exact behavior)[br][br]\r\n"
"If Enable_Sweep_Frequency=1 then a frequency sweep is continuously generated ranging from 2*(M) to 2*(N) driven (see Enable_Sweep_Frequency for exact behavior)."},
#else
{8, 15, 0x0000000000000001, "RW", "L_CNT", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{4, 7, 0x0000000000000000, "RW", "L_COUNTER_HI", "Additional 4 bits to increase the size of LCount upto 12."},
#else
{4, 7, 0x0000000000000000, "RW", "L_COUNTER_HI", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{2, 2, 0x0000000000000000, "RW", "L_COUNT_EN", "Used in concatenation with FREQ_SWEEP_EN to enable 3 possible modes of LMN behavior."},
#else
{2, 2, 0x0000000000000000, "RW", "L_COUNT_EN", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{1, 1, 0x0000000000000000, "RW", "FREQ_SWEEP_EN", "Used in concatenation with L_COUNT_EN to enable 3 possible modes of LMN behavior:[br][br]\r\n"
"{L_COUNT_EN,FREQ_SWEEP_EN}[br][br]\r\n"
"{0,0} - Normal LMN[br][br]\r\n"
"{0,1} - Sweep clock pattern from 2*M period down to 2*N_Count period and repeat.[br][br]\r\n"
"{1,0} - L-Counter - drive clock pattern of 2*L period.[br][br]\r\n"
"{1,1} - Currently same as L-Counter mode - reserved for future use.[br][br]\r\n"
"If Normal LMN mode, then the following pattern is continuously repeated:[br][br]\r\n"
"  1) Drive L_Count bits with the  polarity set by L_Polarity[br][br]\r\n"
"  2) Drive M_Count bits with the  inverse of L_Polarity[br][br]\r\n"
"  3) Drive N_Count bits with the  value of L_Polarity[br][br]\r\n"
"  4) Go to step 2)[br][br]\r\n"
"If any L_Count, M_Count, or N_Count=0 then the  state will freeze at the polarity driven for that stage.[br][br][br]\r\n"
"If Sweep mode, then the following pattern is continuously repeated:[br][br]\r\n"
"  1) Drive L_Count bits with the  polarity set by L_Polarity[br][br]\r\n"
"  2) X_count=M_Count [br][br]\r\n"
"  3) Drive X_Count bits with the  inverse of L_Polarity[br][br]\r\n"
"  4) Drive X_Count bits with the  value of L_Polarity[br][br]\r\n"
"  5) Drive X_Count bits with the  inverse of L_Polarity[br][br]\r\n"
"  6) If X_Count==N_Count then go to step 9[br][br]\r\n"
"  7) X_Count=X_Count-1[br][br]\r\n"
"  8) Go to step 10[br][br]\r\n"
"  9) X_Count=M_Count[br][br]\r\n"
"10) Drive X_Count bits with the  value of L_Polarity[br][br]\r\n"
"11) Go to step 3[br][br]\r\n"
"[br]\r\n"
"If LCount mode, then the following pattern is continuously repeated:[br][br]\r\n"
"  1) Drive L_Polarity for L_Count Bits[br][br]\r\n"
"  2) Drive inverse of L_Polarity for L_Count Bits[br][br]\r\n"
"  3) Go to step 1 [br][br]\r\n"
"  [br][br]\r\n"
"if {0,1}, L_Count, M_Count, and N_Count must never be programmed to 0 and is considered undefined.[br][br]\r\n"
"if {1,0}, L_Count must never be programmed to 0 and is considered undefined.[br][br]\r\n"
"if {0,1}, M_Count and N_Count must be greater than or equal to 8 or behavior may be implementation specific.[br][br]\r\n"
"if {0,1}, N_Count must be programmed less than M_Count."},
#else
{1, 1, 0x0000000000000000, "RW", "FREQ_SWEEP_EN", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 0, 0x0000000000000000, "RW", "L_SEL", "The initial logic output of the sequencer is defined as follows:[br][br]\r\n"
"                        0 - Output Logic '0' for L_CNT UIs[br][br]\r\n"
"                        1 - Output Logic '1' for L_CNT UIs"},
#else
{0, 0, 0x0000000000000000, "RW", "L_SEL", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo222[] = {{"CPGC_DPAT_UNISEQ_LMN_1_", "", 0x00000198, 7, 0x00000000FFFFFFFF, 0x0000000001010100}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields223[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{24, 31, 0x0000000000000001, "RW", "N_CNT", "N_Count only exists if  LMN_Support capability is set to 1.[br] After L_Count bits are driven at the beginning of a test then periodic pattern is continuously repeated depending on the value of Enable_Sweep_Frequency.[br] If Enable_Sweep_Frequency=0 then a steady state frequency is driven (see Enable_Sweep_Frequency for exact behavior).[br] If Enable_Sweep_Frequency=1 then a frequency sweep is continuously generated ranging from 2*(M) to 2*(N) driven (see Enable_Sweep_Frequency for exact behavior)"},
#else
{24, 31, 0x0000000000000001, "RW", "N_CNT", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{16, 23, 0x0000000000000001, "RW", "M_CNT", "M_Count only exists if  LMN_Support capability is set to 1.[br] After L_Count bits are driven at the beginning of a test then periodic pattern is continuously repeated depending on the value of Enable_Sweep_Frequency.[br] If Enable_Sweep_Frequency=0 then a steady state frequency is driven (see Enable_Sweep_Frequency for exact behavior).[br]If Enable_Sweep_Frequency=1 then a frequency sweep is continuously generated ranging from 2*(M) to 2*(N) driven (see Enable_Sweep_Frequency for exact behavior)"},
#else
{16, 23, 0x0000000000000001, "RW", "M_CNT", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{8, 15, 0x0000000000000001, "RW", "L_CNT", "If LMN_Support capability is set to 0 then:[br]A periodic square wave is generated that has the following behavior.[br][br]\r\n"
"1) Drive L_Polarity for L_Count Bits.[br][br]\r\n"
"2) Drive inverse of L_Polarity for L_Count Bits.[br][br]\r\n"
"3) Go to step 1.[br][br]\r\n"
"Else if LMN_Support is set to 1 then:[br][br]\r\n"
"After L_Count bits are driven at the beginning of a test then periodic pattern is continuously repeated depending on the value of Enable_Sweep_Frequency is set to 1.[br][br]\r\n"
"If Enable_Sweep_Frequency=0 then a steady state frequency is driven (see Enable_Sweep_Frequency for exact behavior)[br][br]\r\n"
"If Enable_Sweep_Frequency=1 then a frequency sweep is continuously generated ranging from 2*(M) to 2*(N) driven (see Enable_Sweep_Frequency for exact behavior)."},
#else
{8, 15, 0x0000000000000001, "RW", "L_CNT", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{4, 7, 0x0000000000000000, "RW", "L_COUNTER_HI", "Additional 4 bits to increase the size of LCount upto 12."},
#else
{4, 7, 0x0000000000000000, "RW", "L_COUNTER_HI", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{2, 2, 0x0000000000000000, "RW", "L_COUNT_EN", "Used in concatenation with FREQ_SWEEP_EN to enable 3 possible modes of LMN behavior."},
#else
{2, 2, 0x0000000000000000, "RW", "L_COUNT_EN", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{1, 1, 0x0000000000000000, "RW", "FREQ_SWEEP_EN", "Used in concatenation with L_COUNT_EN to enable 3 possible modes of LMN behavior:[br][br]\r\n"
"{L_COUNT_EN,FREQ_SWEEP_EN}[br][br]\r\n"
"{0,0} - Normal LMN[br][br]\r\n"
"{0,1} - Sweep clock pattern from 2*M period down to 2*N_Count period and repeat.[br][br]\r\n"
"{1,0} - L-Counter - drive clock pattern of 2*L period.[br][br]\r\n"
"{1,1} - Currently same as L-Counter mode - reserved for future use.[br][br]\r\n"
"If Normal LMN mode, then the following pattern is continuously repeated:[br][br]\r\n"
"  1) Drive L_Count bits with the  polarity set by L_Polarity[br][br]\r\n"
"  2) Drive M_Count bits with the  inverse of L_Polarity[br][br]\r\n"
"  3) Drive N_Count bits with the  value of L_Polarity[br][br]\r\n"
"  4) Go to step 2)[br][br]\r\n"
"If any L_Count, M_Count, or N_Count=0 then the  state will freeze at the polarity driven for that stage.[br][br][br]\r\n"
"If Sweep mode, then the following pattern is continuously repeated:[br][br]\r\n"
"  1) Drive L_Count bits with the  polarity set by L_Polarity[br][br]\r\n"
"  2) X_count=M_Count [br][br]\r\n"
"  3) Drive X_Count bits with the  inverse of L_Polarity[br][br]\r\n"
"  4) Drive X_Count bits with the  value of L_Polarity[br][br]\r\n"
"  5) Drive X_Count bits with the  inverse of L_Polarity[br][br]\r\n"
"  6) If X_Count==N_Count then go to step 9[br][br]\r\n"
"  7) X_Count=X_Count-1[br][br]\r\n"
"  8) Go to step 10[br][br]\r\n"
"  9) X_Count=M_Count[br][br]\r\n"
"10) Drive X_Count bits with the  value of L_Polarity[br][br]\r\n"
"11) Go to step 3[br][br]\r\n"
"[br]\r\n"
"If LCount mode, then the following pattern is continuously repeated:[br][br]\r\n"
"  1) Drive L_Polarity for L_Count Bits[br][br]\r\n"
"  2) Drive inverse of L_Polarity for L_Count Bits[br][br]\r\n"
"  3) Go to step 1 [br][br]\r\n"
"  [br][br]\r\n"
"if {0,1}, L_Count, M_Count, and N_Count must never be programmed to 0 and is considered undefined.[br][br]\r\n"
"if {1,0}, L_Count must never be programmed to 0 and is considered undefined.[br][br]\r\n"
"if {0,1}, M_Count and N_Count must be greater than or equal to 8 or behavior may be implementation specific.[br][br]\r\n"
"if {0,1}, N_Count must be programmed less than M_Count."},
#else
{1, 1, 0x0000000000000000, "RW", "FREQ_SWEEP_EN", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 0, 0x0000000000000000, "RW", "L_SEL", "The initial logic output of the sequencer is defined as follows:[br][br]\r\n"
"                        0 - Output Logic '0' for L_CNT UIs[br][br]\r\n"
"                        1 - Output Logic '1' for L_CNT UIs"},
#else
{0, 0, 0x0000000000000000, "RW", "L_SEL", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo223[] = {{"CPGC_DPAT_UNISEQ_LMN_2_", "", 0x0000019C, 7, 0x00000000FFFFFFFF, 0x0000000001010100}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields224[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{31, 31, 0x0000000000000000, "RW", "MASK_ROTATE_EN", "If set, the inversion/DC mask will rotate to the left at a rate defined by the MASK_ROTATE_RATE field."},
#else
{31, 31, 0x0000000000000000, "RW", "MASK_ROTATE_EN", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{30, 30, 0x0000000000000000, "RW", "DC_OR_INV", "Selects between using the inversion/DC mask for inversion or DC as follows:[br][br]\r\n"
"0 - Mask used for inversion.[br][br]\r\n"
"1 - Mask used for driving a DC signal of polarity DC_POL."},
#else
{30, 30, 0x0000000000000000, "RW", "DC_OR_INV", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{20, 20, 0x0000000000000000, "RW", "DC_POL", "Selects the polarity of the signal to be driven through the inversion/DC mask if DC_OR_INV is set to 1:[br][br]\r\n"
"0 - Drive a logic low (zero).[br][br]\r\n"
"1 - Drive a logic high (one)."},
#else
{20, 20, 0x0000000000000000, "RW", "DC_POL", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{16, 19, 0x0000000000000000, "RW", "MASK_ROTATE_RATE", "If inversion mask rotation is enabled through MASK_ROTATE_EN, the mask will rotate to the left every time 2^MASK_ROTATE_RATE bursts (64Bytes) have been have been issued."},
#else
{16, 19, 0x0000000000000000, "RW", "MASK_ROTATE_RATE", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 7, 0x0000000000000000, "RW", "ECC_INV_DC_MASK", "A value of  for any of the bits means the corresponding ECC lane(s) will be inverted or a DC value driven on it.  Note that this field is used to load bits [71:64] of the continuous shift register composed of this field along with DATA_INV_DC_MASK_HI and DATA_INV_DC_MASK_LO.   Note: this field is only available if ECC is supported for the current implementation, otherwise it is reserved."},
#else
{0, 7, 0x0000000000000000, "RW", "ECC_INV_DC_MASK", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo224[] = {{"CPGC_DPAT_INVDCCTL", "", 0x000001A0, 5, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields225[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{0, 31, 0x0000000000000000, "RW", "DATA_INV_DC_MASK_LO", "A value of '1' for any of the bits means the corresponding data lane(s) will be inverted or a DC value driven on it. Note that this field is used to load bits [31:0] of the continuous shift register composed of this field along with ECC_INV_DC_MASK and DATA_INV_DC_MASK_HI."},
#else
{0, 31, 0x0000000000000000, "RW", "DATA_INV_DC_MASK_LO", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo225[] = {{"CPGC_DPAT_INV_DC_MASK_LO", "", 0x000001A4, 1, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields226[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{0, 31, 0x0000000000000000, "RW", "DATA_INV_DC_MASK_HI", "A value of '1' for any of the bits means the corresponding data lane(s) will be inverted or a DC value driven on it. Note that this field is used to load bits [63:32] of the continuous shift register composed of this field along with ECC_INV_DC_MASK and DATA_INV_DC_MASK_LO."},
#else
{0, 31, 0x0000000000000000, "RW", "DATA_INV_DC_MASK_HI", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo226[] = {{"CPGC_DPAT_INV_DC_MASK_HI", "", 0x000001A8, 1, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields227[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{0, 31, 0x00000000FFFFFFFF, "RW", "DATA_MASK_LO", "A byte enable field with each bit corresponding to a data byte sent during a burst such that:[br]\r\n"
"0 - Mask the Corresponding Byte[br]\r\n"
"1 - No Mask to the Corresponding Byte[br]\r\n"
"The byte-to-bit mapping is given by Byte[n] -> bit[n].[br]\r\n"
"This register is for the first half cacheline of data.[br]\r\n"
"It is only used when ECC is not present or is disabled."},
#else
{0, 31, 0x00000000FFFFFFFF, "RW", "DATA_MASK_LO", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo227[] = {{"CPGC_DPAT_DRAMDM", "", 0x000001AC, 1, 0x00000000FFFFFFFF, 0x00000000FFFFFFFF}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields228[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{0, 31, 0x00000000FFFFFFFF, "RW", "DATA_MASK_HI", "A byte enable field with each bit corresponding to a data byte sent during a burst such that:[br]\r\n"
"0 - Mask the Corresponding Byte[br]\r\n"
"1 - No Mask to the Corresponding Byte[br]\r\n"
"The byte-to-bit mapping is given by Byte[n+32] -> bit[n].[br]\r\n"
"This register is for the Second half cacheline of data.[br]\r\n"
"It is only used when ECC is not present or is disabled."},
#else
{0, 31, 0x00000000FFFFFFFF, "RW", "DATA_MASK_HI", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo228[] = {{"CPGC_DPAT_XDRAMDM", "", 0x000001B0, 1, 0x00000000FFFFFFFF, 0x00000000FFFFFFFF}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields229[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{8, 11, 0x0000000000000000, "RO/V", "RD_BUF_PTR", "Pointer to current entry in the data pattern buffers used for generating the read data."},
#else
{8, 11, 0x0000000000000000, "RO/V", "RD_BUF_PTR", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 3, 0x0000000000000000, "RO/V", "WR_BUF_PTR", "Pointer to current entry in the data pattern buffers used for generating the write data."},
#else
{0, 3, 0x0000000000000000, "RO/V", "WR_BUF_PTR", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo229[] = {{"CPGC_DPAT_BUFSTAT", "", 0x000001B4, 2, 0x0000000000000FFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields230[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{1, 1, 0x0000000000000000, "RW", "READ_ADDRESS_AS_DATA", "When Read_Address_as_Data is set to '1' any address fields that the CADB is overriding during a Select cycle should be used for comparing the incoming data.  Otherwise, the functional path decoded address field should be used for comparing the incoming data.[br]\r\n"
"This override of the data will not respect any inversion, rotation or other data modification. It will only be active (override the normal output/reference) when Alternate_Data is active in either the Command_Instruction or the Offset_Command_Instruction as appropriate .[br]\r\n"
"The functional path decoded address field used for read comparison is repeated in chunk and should follow the Data Construction rules described below on what bytegroup relates to what decoded address:[br][br]\r\n"
"Chunk0 - Byte0 =Column(7:0)[br]\r\n"
"Chunk0 - Byte1 =Column(9:8) <- as many Column bits as supported[br]\r\n"
"Chunk0 - Byte2 =Row(0:7)[br]\r\n"
"Chunk0 - Byte3 =Row(15:8)[br]\r\n"
"Chunk0 - Byte4 =Row(17:16)<- as many Row bits as supported[br]\r\n"
"Chunk0 - Byte5 =Bank(3:0)  [Note: Bank Group may be part of this field] <- as many Bank bits as supported[br]\r\n"
"Chunk0 - Byte6 = Rank(1:0) <- as many Rank bits as supported (would be CS# if CADB output supported)[br]\r\n"
"Chunk0 - Byte7 =reserved (set to 0)[br]\r\n"
"\r\n"
"Note: Broxton will not support CADB Select cycle information being used for Address-as-data."},
#else
{1, 1, 0x0000000000000000, "RW", "READ_ADDRESS_AS_DATA", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 0, 0x0000000000000000, "RW", "WRITE_ADDRESS_AS_DATA", "When Write_Address_as_Data is set to '1' any address fields that the CADB is overriding during a Select cycle should be used for generating the write data.  Otherwise, the functional path decoded address field should be used for generating the write data.[br]\r\n"
"Data Construction rules follow the same as for READ_ADDRESS_AS_DATA.[br]\r\n"
"\r\n"
"This format is subject to change based on memory technology supported and other reasons and the main HAS documentation should be referenced if required. What is to be guaranteed is that every Cacheline of data will be unique to each address."},
#else
{0, 0, 0x0000000000000000, "RW", "WRITE_ADDRESS_AS_DATA", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo230[] = {{"CPGC_DPAT_ADDRESS_AS_DATA_CTRL", "", 0x000001B8, 2, 0x0000000000000003, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields231[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{0, 31, 0x0000000000000000, "RO/V", "UNISEQ_WRSTAT", "The current contents of the Pattern/LFSR buffer in write comparison domain."},
#else
{0, 31, 0x0000000000000000, "RO/V", "UNISEQ_WRSTAT", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo231[] = {{"CPGC_DPAT_UNISEQ_WRSTAT_0_", "", 0x000001BC, 1, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields232[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{0, 31, 0x0000000000000000, "RO/V", "UNISEQ_WRSTAT", "The current contents of the Pattern/LFSR buffer in write comparison domain."},
#else
{0, 31, 0x0000000000000000, "RO/V", "UNISEQ_WRSTAT", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo232[] = {{"CPGC_DPAT_UNISEQ_WRSTAT_1_", "", 0x000001C0, 1, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields233[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{0, 31, 0x0000000000000000, "RO/V", "UNISEQ_WRSTAT", "The current contents of the Pattern/LFSR buffer in write comparison domain."},
#else
{0, 31, 0x0000000000000000, "RO/V", "UNISEQ_WRSTAT", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo233[] = {{"CPGC_DPAT_UNISEQ_WRSTAT_2_", "", 0x000001C4, 1, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields234[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{0, 31, 0x00000000DEADBEEF, "RO/V", "UNISEQ_RDSTAT", "CPGC_REG_DPAT_UNISEQ_RDSTAT reflects the current and final status of the pattern buffer in the read domain.[br][br]\r\n"
"If PATBUF mode, then Pattern_Buffer is used as a fixed buffer that is output in serial fashion.   After all the bits in the Pattern_Buffer have been transmitted the  pattern will simply repeat itself continuously while a Loopback Test is in progress.[br][br]\r\n"
"If LFSR mode, then Pattern_Buffer is used as a seed to a fixed LFSR that is output in serial fashion.  Over time the LFSR pattern will repeat itself continuously while a Loopback Test is in progress. In LFSR Mode the contents of Pattern_Buffer will interact with the LFSR in the following ways:[br][br]\r\n"
"If LFSR_Save_Restore is set then CPGC_REG_DPAT_UNISEQ_WRSAVE.Pattern_Buffer will interact with CPGC_UNISEQ#_RDSTAT in the following ways:[br][br]\r\n"
"1) CPGC_UNISEQ#_RDSTAT will be periodically saved into CPGC_REG_DPAT_UNISEQ#_RDSAVE.Pattern_Buffer based on Save_LFSR_Seed_Rate (see Save_LFSR_Seed_Rate for more details).[br][br]\r\n"
"2) CPGC_UNISEQ#_RDSTAT will be periodically reloaded with CPGC_REG_DPAT_UNISEQ#_RDSAVE.Pattern_Buffer based on Reload_LFSR_Seed_Rate (see Reload_LFSR_Seed_Rate for more details)."},
#else
{0, 31, 0x00000000DEADBEEF, "RO/V", "UNISEQ_RDSTAT", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo234[] = {{"CPGC_DPAT_UNISEQ_RDSTAT_0_", "", 0x000001C8, 1, 0x00000000FFFFFFFF, 0x00000000DEADBEEF}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields235[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{0, 31, 0x00000000DEADBEEF, "RO/V", "UNISEQ_RDSTAT", "CPGC_REG_DPAT_UNISEQ_RDSTAT reflects the current and final status of the pattern buffer in the read domain.[br][br]\r\n"
"If PATBUF mode, then Pattern_Buffer is used as a fixed buffer that is output in serial fashion.   After all the bits in the Pattern_Buffer have been transmitted the  pattern will simply repeat itself continuously while a Loopback Test is in progress.[br][br]\r\n"
"If LFSR mode, then Pattern_Buffer is used as a seed to a fixed LFSR that is output in serial fashion.  Over time the LFSR pattern will repeat itself continuously while a Loopback Test is in progress. In LFSR Mode the contents of Pattern_Buffer will interact with the LFSR in the following ways:[br][br]\r\n"
"If LFSR_Save_Restore is set then CPGC_REG_DPAT_UNISEQ_WRSAVE.Pattern_Buffer will interact with CPGC_UNISEQ#_RDSTAT in the following ways:[br][br]\r\n"
"1) CPGC_UNISEQ#_RDSTAT will be periodically saved into CPGC_REG_DPAT_UNISEQ#_RDSAVE.Pattern_Buffer based on Save_LFSR_Seed_Rate (see Save_LFSR_Seed_Rate for more details).[br][br]\r\n"
"2) CPGC_UNISEQ#_RDSTAT will be periodically reloaded with CPGC_REG_DPAT_UNISEQ#_RDSAVE.Pattern_Buffer based on Reload_LFSR_Seed_Rate (see Reload_LFSR_Seed_Rate for more details)."},
#else
{0, 31, 0x00000000DEADBEEF, "RO/V", "UNISEQ_RDSTAT", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo235[] = {{"CPGC_DPAT_UNISEQ_RDSTAT_1_", "", 0x000001CC, 1, 0x00000000FFFFFFFF, 0x00000000DEADBEEF}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields236[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{0, 31, 0x00000000DEADBEEF, "RO/V", "UNISEQ_RDSTAT", "CPGC_REG_DPAT_UNISEQ_RDSTAT reflects the current and final status of the pattern buffer in the read domain.[br][br]\r\n"
"If PATBUF mode, then Pattern_Buffer is used as a fixed buffer that is output in serial fashion.   After all the bits in the Pattern_Buffer have been transmitted the  pattern will simply repeat itself continuously while a Loopback Test is in progress.[br][br]\r\n"
"If LFSR mode, then Pattern_Buffer is used as a seed to a fixed LFSR that is output in serial fashion.  Over time the LFSR pattern will repeat itself continuously while a Loopback Test is in progress. In LFSR Mode the contents of Pattern_Buffer will interact with the LFSR in the following ways:[br][br]\r\n"
"If LFSR_Save_Restore is set then CPGC_REG_DPAT_UNISEQ_WRSAVE.Pattern_Buffer will interact with CPGC_UNISEQ#_RDSTAT in the following ways:[br][br]\r\n"
"1) CPGC_UNISEQ#_RDSTAT will be periodically saved into CPGC_REG_DPAT_UNISEQ#_RDSAVE.Pattern_Buffer based on Save_LFSR_Seed_Rate (see Save_LFSR_Seed_Rate for more details).[br][br]\r\n"
"2) CPGC_UNISEQ#_RDSTAT will be periodically reloaded with CPGC_REG_DPAT_UNISEQ#_RDSAVE.Pattern_Buffer based on Reload_LFSR_Seed_Rate (see Reload_LFSR_Seed_Rate for more details)."},
#else
{0, 31, 0x00000000DEADBEEF, "RO/V", "UNISEQ_RDSTAT", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo236[] = {{"CPGC_DPAT_UNISEQ_RDSTAT_2_", "", 0x000001D0, 1, 0x00000000FFFFFFFF, 0x00000000DEADBEEF}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields237[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{0, 31, 0x0000000000000000, "RO/V", "LMN_WRSTAT", "The current contents of the LMN buffer in write comparison domain."},
#else
{0, 31, 0x0000000000000000, "RO/V", "LMN_WRSTAT", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo237[] = {{"CPGC_DPAT_LMN_WRSTAT_0_", "", 0x000001D4, 1, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields238[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{0, 31, 0x0000000000000000, "RO/V", "LMN_WRSTAT", "The current contents of the LMN buffer in write comparison domain."},
#else
{0, 31, 0x0000000000000000, "RO/V", "LMN_WRSTAT", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo238[] = {{"CPGC_DPAT_LMN_WRSTAT_1_", "", 0x000001D8, 1, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields239[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{0, 31, 0x0000000000000000, "RO/V", "LMN_WRSTAT", "The current contents of the LMN buffer in write comparison domain."},
#else
{0, 31, 0x0000000000000000, "RO/V", "LMN_WRSTAT", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo239[] = {{"CPGC_DPAT_LMN_WRSTAT_2_", "", 0x000001DC, 1, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields240[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{0, 31, 0x00000000DEADBEEF, "RO/V", "LMN_RDSTAT", "The current contents of the LMN buffer in read comparison domain."},
#else
{0, 31, 0x00000000DEADBEEF, "RO/V", "LMN_RDSTAT", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo240[] = {{"CPGC_DPAT_LMN_RDSTAT_0_", "", 0x000001E0, 1, 0x00000000FFFFFFFF, 0x00000000DEADBEEF}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields241[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{0, 31, 0x00000000DEADBEEF, "RO/V", "LMN_RDSTAT", "The current contents of the LMN buffer in read comparison domain."},
#else
{0, 31, 0x00000000DEADBEEF, "RO/V", "LMN_RDSTAT", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo241[] = {{"CPGC_DPAT_LMN_RDSTAT_1_", "", 0x000001E4, 1, 0x00000000FFFFFFFF, 0x00000000DEADBEEF}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields242[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{0, 31, 0x00000000DEADBEEF, "RO/V", "LMN_RDSTAT", "The current contents of the LMN buffer in read comparison domain."},
#else
{0, 31, 0x00000000DEADBEEF, "RO/V", "LMN_RDSTAT", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo242[] = {{"CPGC_DPAT_LMN_RDSTAT_2_", "", 0x000001E8, 1, 0x00000000FFFFFFFF, 0x00000000DEADBEEF}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields243[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{0, 31, 0x00000000DEADBEEF, "RO/V", "PATTERN_BUFFER", "The current contents of the Save register before the test stops in the write domain"},
#else
{0, 31, 0x00000000DEADBEEF, "RO/V", "PATTERN_BUFFER", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo243[] = {{"CPGC_DPAT_UNISEQ_WRSAVE_0_", "", 0x000001EC, 1, 0x00000000FFFFFFFF, 0x00000000DEADBEEF}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields244[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{0, 31, 0x00000000DEADBEEF, "RO/V", "PATTERN_BUFFER", "The current contents of the Save register before the test stops in the write domain"},
#else
{0, 31, 0x00000000DEADBEEF, "RO/V", "PATTERN_BUFFER", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo244[] = {{"CPGC_DPAT_UNISEQ_WRSAVE_1_", "", 0x000001F0, 1, 0x00000000FFFFFFFF, 0x00000000DEADBEEF}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields245[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{0, 31, 0x00000000DEADBEEF, "RO/V", "PATTERN_BUFFER", "The current contents of the Save register before the test stops in the write domain"},
#else
{0, 31, 0x00000000DEADBEEF, "RO/V", "PATTERN_BUFFER", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo245[] = {{"CPGC_DPAT_UNISEQ_WRSAVE_2_", "", 0x000001F4, 1, 0x00000000FFFFFFFF, 0x00000000DEADBEEF}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields246[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{0, 31, 0x0000000000000000, "RO/V", "PATTERN_BUFFER", "CPGC_REG_DPAT_UNISEQ#_RDSAVE.Pattern_Buffer will reflect either the initial or last saved value of CPGC_UNISEQ#_RDSTAT.[br][br]\r\n"
"If PATBUF mode, then Pattern_Buffer is used as a fixed buffer that is output in serial fashion.   After all the bits in the Pattern_Buffer have been transmitted the  pattern will simply repeat itself continuously while a Loopback Test is in progress.[br][br]\r\n"
"If LFSR mode, then Pattern_Buffer is used as a seed to a fixed LFSR that is output in serial fashion.  Over time the LFSR pattern will repeat itself continuously while a Loopback Test is in progress. In LFSR Mode the contents of Pattern_Buffer will interact with the LFSR in the following ways:[br][br]\r\n"
"If LFSR_Save_Restore is set then CPGC_REG_DPAT_UNISEQ_WRSAVE.Pattern_Buffer will interact with CPGC_UNISEQ#_RDSTAT in the following ways:[br][br]\r\n"
"1) CPGC_UNISEQ#_RDSTAT will be periodically saved into CPGC_REG_DPAT_UNISEQ#_RDSAVE.Pattern_Buffer based on Save_LFSR_Seed_Rate (see Save_LFSR_Seed_Rate for more details).[br][br]\r\n"
"2) CPGC_UNISEQ#_RDSTAT will be periodically reloaded with CPGC_REG_DPAT_UNISEQ#_RDSAVE.Pattern_Buffer based on Reload_LFSR_Seed_Rate (see Reload_LFSR_Seed_Rate for more details)."},
#else
{0, 31, 0x0000000000000000, "RO/V", "PATTERN_BUFFER", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo246[] = {{"CPGC_DPAT_UNISEQ_RDSAVE_0_", "", 0x000001F8, 1, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields247[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{0, 31, 0x0000000000000000, "RO/V", "PATTERN_BUFFER", "CPGC_REG_DPAT_UNISEQ#_RDSAVE.Pattern_Buffer will reflect either the initial or last saved value of CPGC_UNISEQ#_RDSTAT.[br][br]\r\n"
"If PATBUF mode, then Pattern_Buffer is used as a fixed buffer that is output in serial fashion.   After all the bits in the Pattern_Buffer have been transmitted the  pattern will simply repeat itself continuously while a Loopback Test is in progress.[br][br]\r\n"
"If LFSR mode, then Pattern_Buffer is used as a seed to a fixed LFSR that is output in serial fashion.  Over time the LFSR pattern will repeat itself continuously while a Loopback Test is in progress. In LFSR Mode the contents of Pattern_Buffer will interact with the LFSR in the following ways:[br][br]\r\n"
"If LFSR_Save_Restore is set then CPGC_REG_DPAT_UNISEQ_WRSAVE.Pattern_Buffer will interact with CPGC_UNISEQ#_RDSTAT in the following ways:[br][br]\r\n"
"1) CPGC_UNISEQ#_RDSTAT will be periodically saved into CPGC_REG_DPAT_UNISEQ#_RDSAVE.Pattern_Buffer based on Save_LFSR_Seed_Rate (see Save_LFSR_Seed_Rate for more details).[br][br]\r\n"
"2) CPGC_UNISEQ#_RDSTAT will be periodically reloaded with CPGC_REG_DPAT_UNISEQ#_RDSAVE.Pattern_Buffer based on Reload_LFSR_Seed_Rate (see Reload_LFSR_Seed_Rate for more details)."},
#else
{0, 31, 0x0000000000000000, "RO/V", "PATTERN_BUFFER", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo247[] = {{"CPGC_DPAT_UNISEQ_RDSAVE_1_", "", 0x000001FC, 1, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields248[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{0, 31, 0x0000000000000000, "RO/V", "PATTERN_BUFFER", "CPGC_REG_DPAT_UNISEQ#_RDSAVE.Pattern_Buffer will reflect either the initial or last saved value of CPGC_UNISEQ#_RDSTAT.[br][br]\r\n"
"If PATBUF mode, then Pattern_Buffer is used as a fixed buffer that is output in serial fashion.   After all the bits in the Pattern_Buffer have been transmitted the  pattern will simply repeat itself continuously while a Loopback Test is in progress.[br][br]\r\n"
"If LFSR mode, then Pattern_Buffer is used as a seed to a fixed LFSR that is output in serial fashion.  Over time the LFSR pattern will repeat itself continuously while a Loopback Test is in progress. In LFSR Mode the contents of Pattern_Buffer will interact with the LFSR in the following ways:[br][br]\r\n"
"If LFSR_Save_Restore is set then CPGC_REG_DPAT_UNISEQ_WRSAVE.Pattern_Buffer will interact with CPGC_UNISEQ#_RDSTAT in the following ways:[br][br]\r\n"
"1) CPGC_UNISEQ#_RDSTAT will be periodically saved into CPGC_REG_DPAT_UNISEQ#_RDSAVE.Pattern_Buffer based on Save_LFSR_Seed_Rate (see Save_LFSR_Seed_Rate for more details).[br][br]\r\n"
"2) CPGC_UNISEQ#_RDSTAT will be periodically reloaded with CPGC_REG_DPAT_UNISEQ#_RDSAVE.Pattern_Buffer based on Reload_LFSR_Seed_Rate (see Reload_LFSR_Seed_Rate for more details)."},
#else
{0, 31, 0x0000000000000000, "RO/V", "PATTERN_BUFFER", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo248[] = {{"CPGC_DPAT_UNISEQ_RDSAVE_2_", "", 0x00000200, 1, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields249[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{24, 31, 0x00000000000000AA, "RW", "DATA_LINE3", "Contents of Pattern Buffer 0 Data Line 3[br]\r\n"
"EXTBUF[0] corresponds to Lane 0 (32 UI of data maximum)[br]\r\n"
"EXTBUF[1] corresponds to Lane 1 (32 UI of data maximum)[br]\r\n"
".....[br]\r\n"
"EXTBUF[15] corresponds to Lane 15[br]\r\n"
"These 16 lanes are replicated across the number of active DQ lanes on the memory interface."},
#else
{24, 31, 0x00000000000000AA, "RW", "DATA_LINE3", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{16, 23, 0x00000000000000AA, "RW", "DATA_LINE2", "Contents of Pattern Buffer 0 Data Line 2.[br]\r\n"
"Line 2 refers to the 8-UI partial cache line as pointed to current status at CPGC_DPAT_BUFSTAT.[br]\r\n"
"This advancement is controlled by CPGC_DPAT_BUF_CTL."},
#else
{16, 23, 0x00000000000000AA, "RW", "DATA_LINE2", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{8, 15, 0x00000000000000AA, "RW", "DATA_LINE1", "Contents of Pattern Buffer 0 Data Line 1"},
#else
{8, 15, 0x00000000000000AA, "RW", "DATA_LINE1", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 7, 0x00000000000000AA, "RW", "DATA_LINE0", "Contents of Pattern Buffer 0 Data Line 0"},
#else
{0, 7, 0x00000000000000AA, "RW", "DATA_LINE0", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo249[] = {{"CPGC_DPAT_EXTBUF_0_", "", 0x00000204, 4, 0x00000000FFFFFFFF, 0x00000000AAAAAAAA}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields250[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{24, 31, 0x00000000000000AA, "RW", "DATA_LINE3", "Contents of Pattern Buffer 0 Data Line 3[br]\r\n"
"EXTBUF[0] corresponds to Lane 0 (32 UI of data maximum)[br]\r\n"
"EXTBUF[1] corresponds to Lane 1 (32 UI of data maximum)[br]\r\n"
".....[br]\r\n"
"EXTBUF[15] corresponds to Lane 15[br]\r\n"
"These 16 lanes are replicated across the number of active DQ lanes on the memory interface."},
#else
{24, 31, 0x00000000000000AA, "RW", "DATA_LINE3", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{16, 23, 0x00000000000000AA, "RW", "DATA_LINE2", "Contents of Pattern Buffer 0 Data Line 2.[br]\r\n"
"Line 2 refers to the 8-UI partial cache line as pointed to current status at CPGC_DPAT_BUFSTAT.[br]\r\n"
"This advancement is controlled by CPGC_DPAT_BUF_CTL."},
#else
{16, 23, 0x00000000000000AA, "RW", "DATA_LINE2", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{8, 15, 0x00000000000000AA, "RW", "DATA_LINE1", "Contents of Pattern Buffer 0 Data Line 1"},
#else
{8, 15, 0x00000000000000AA, "RW", "DATA_LINE1", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 7, 0x00000000000000AA, "RW", "DATA_LINE0", "Contents of Pattern Buffer 0 Data Line 0"},
#else
{0, 7, 0x00000000000000AA, "RW", "DATA_LINE0", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo250[] = {{"CPGC_DPAT_EXTBUF_1_", "", 0x00000208, 4, 0x00000000FFFFFFFF, 0x00000000AAAAAAAA}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields251[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{24, 31, 0x00000000000000AA, "RW", "DATA_LINE3", "Contents of Pattern Buffer 0 Data Line 3[br]\r\n"
"EXTBUF[0] corresponds to Lane 0 (32 UI of data maximum)[br]\r\n"
"EXTBUF[1] corresponds to Lane 1 (32 UI of data maximum)[br]\r\n"
".....[br]\r\n"
"EXTBUF[15] corresponds to Lane 15[br]\r\n"
"These 16 lanes are replicated across the number of active DQ lanes on the memory interface."},
#else
{24, 31, 0x00000000000000AA, "RW", "DATA_LINE3", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{16, 23, 0x00000000000000AA, "RW", "DATA_LINE2", "Contents of Pattern Buffer 0 Data Line 2.[br]\r\n"
"Line 2 refers to the 8-UI partial cache line as pointed to current status at CPGC_DPAT_BUFSTAT.[br]\r\n"
"This advancement is controlled by CPGC_DPAT_BUF_CTL."},
#else
{16, 23, 0x00000000000000AA, "RW", "DATA_LINE2", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{8, 15, 0x00000000000000AA, "RW", "DATA_LINE1", "Contents of Pattern Buffer 0 Data Line 1"},
#else
{8, 15, 0x00000000000000AA, "RW", "DATA_LINE1", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 7, 0x00000000000000AA, "RW", "DATA_LINE0", "Contents of Pattern Buffer 0 Data Line 0"},
#else
{0, 7, 0x00000000000000AA, "RW", "DATA_LINE0", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo251[] = {{"CPGC_DPAT_EXTBUF_2_", "", 0x0000020C, 4, 0x00000000FFFFFFFF, 0x00000000AAAAAAAA}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields252[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{24, 31, 0x00000000000000AA, "RW", "DATA_LINE3", "Contents of Pattern Buffer 0 Data Line 3[br]\r\n"
"EXTBUF[0] corresponds to Lane 0 (32 UI of data maximum)[br]\r\n"
"EXTBUF[1] corresponds to Lane 1 (32 UI of data maximum)[br]\r\n"
".....[br]\r\n"
"EXTBUF[15] corresponds to Lane 15[br]\r\n"
"These 16 lanes are replicated across the number of active DQ lanes on the memory interface."},
#else
{24, 31, 0x00000000000000AA, "RW", "DATA_LINE3", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{16, 23, 0x00000000000000AA, "RW", "DATA_LINE2", "Contents of Pattern Buffer 0 Data Line 2.[br]\r\n"
"Line 2 refers to the 8-UI partial cache line as pointed to current status at CPGC_DPAT_BUFSTAT.[br]\r\n"
"This advancement is controlled by CPGC_DPAT_BUF_CTL."},
#else
{16, 23, 0x00000000000000AA, "RW", "DATA_LINE2", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{8, 15, 0x00000000000000AA, "RW", "DATA_LINE1", "Contents of Pattern Buffer 0 Data Line 1"},
#else
{8, 15, 0x00000000000000AA, "RW", "DATA_LINE1", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 7, 0x00000000000000AA, "RW", "DATA_LINE0", "Contents of Pattern Buffer 0 Data Line 0"},
#else
{0, 7, 0x00000000000000AA, "RW", "DATA_LINE0", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo252[] = {{"CPGC_DPAT_EXTBUF_3_", "", 0x00000210, 4, 0x00000000FFFFFFFF, 0x00000000AAAAAAAA}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields253[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{24, 31, 0x00000000000000AA, "RW", "DATA_LINE3", "Contents of Pattern Buffer 0 Data Line 3[br]\r\n"
"EXTBUF[0] corresponds to Lane 0 (32 UI of data maximum)[br]\r\n"
"EXTBUF[1] corresponds to Lane 1 (32 UI of data maximum)[br]\r\n"
".....[br]\r\n"
"EXTBUF[15] corresponds to Lane 15[br]\r\n"
"These 16 lanes are replicated across the number of active DQ lanes on the memory interface."},
#else
{24, 31, 0x00000000000000AA, "RW", "DATA_LINE3", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{16, 23, 0x00000000000000AA, "RW", "DATA_LINE2", "Contents of Pattern Buffer 0 Data Line 2.[br]\r\n"
"Line 2 refers to the 8-UI partial cache line as pointed to current status at CPGC_DPAT_BUFSTAT.[br]\r\n"
"This advancement is controlled by CPGC_DPAT_BUF_CTL."},
#else
{16, 23, 0x00000000000000AA, "RW", "DATA_LINE2", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{8, 15, 0x00000000000000AA, "RW", "DATA_LINE1", "Contents of Pattern Buffer 0 Data Line 1"},
#else
{8, 15, 0x00000000000000AA, "RW", "DATA_LINE1", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 7, 0x00000000000000AA, "RW", "DATA_LINE0", "Contents of Pattern Buffer 0 Data Line 0"},
#else
{0, 7, 0x00000000000000AA, "RW", "DATA_LINE0", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo253[] = {{"CPGC_DPAT_EXTBUF_4_", "", 0x00000214, 4, 0x00000000FFFFFFFF, 0x00000000AAAAAAAA}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields254[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{24, 31, 0x00000000000000AA, "RW", "DATA_LINE3", "Contents of Pattern Buffer 0 Data Line 3[br]\r\n"
"EXTBUF[0] corresponds to Lane 0 (32 UI of data maximum)[br]\r\n"
"EXTBUF[1] corresponds to Lane 1 (32 UI of data maximum)[br]\r\n"
".....[br]\r\n"
"EXTBUF[15] corresponds to Lane 15[br]\r\n"
"These 16 lanes are replicated across the number of active DQ lanes on the memory interface."},
#else
{24, 31, 0x00000000000000AA, "RW", "DATA_LINE3", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{16, 23, 0x00000000000000AA, "RW", "DATA_LINE2", "Contents of Pattern Buffer 0 Data Line 2.[br]\r\n"
"Line 2 refers to the 8-UI partial cache line as pointed to current status at CPGC_DPAT_BUFSTAT.[br]\r\n"
"This advancement is controlled by CPGC_DPAT_BUF_CTL."},
#else
{16, 23, 0x00000000000000AA, "RW", "DATA_LINE2", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{8, 15, 0x00000000000000AA, "RW", "DATA_LINE1", "Contents of Pattern Buffer 0 Data Line 1"},
#else
{8, 15, 0x00000000000000AA, "RW", "DATA_LINE1", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 7, 0x00000000000000AA, "RW", "DATA_LINE0", "Contents of Pattern Buffer 0 Data Line 0"},
#else
{0, 7, 0x00000000000000AA, "RW", "DATA_LINE0", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo254[] = {{"CPGC_DPAT_EXTBUF_5_", "", 0x00000218, 4, 0x00000000FFFFFFFF, 0x00000000AAAAAAAA}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields255[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{24, 31, 0x00000000000000AA, "RW", "DATA_LINE3", "Contents of Pattern Buffer 0 Data Line 3[br]\r\n"
"EXTBUF[0] corresponds to Lane 0 (32 UI of data maximum)[br]\r\n"
"EXTBUF[1] corresponds to Lane 1 (32 UI of data maximum)[br]\r\n"
".....[br]\r\n"
"EXTBUF[15] corresponds to Lane 15[br]\r\n"
"These 16 lanes are replicated across the number of active DQ lanes on the memory interface."},
#else
{24, 31, 0x00000000000000AA, "RW", "DATA_LINE3", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{16, 23, 0x00000000000000AA, "RW", "DATA_LINE2", "Contents of Pattern Buffer 0 Data Line 2.[br]\r\n"
"Line 2 refers to the 8-UI partial cache line as pointed to current status at CPGC_DPAT_BUFSTAT.[br]\r\n"
"This advancement is controlled by CPGC_DPAT_BUF_CTL."},
#else
{16, 23, 0x00000000000000AA, "RW", "DATA_LINE2", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{8, 15, 0x00000000000000AA, "RW", "DATA_LINE1", "Contents of Pattern Buffer 0 Data Line 1"},
#else
{8, 15, 0x00000000000000AA, "RW", "DATA_LINE1", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 7, 0x00000000000000AA, "RW", "DATA_LINE0", "Contents of Pattern Buffer 0 Data Line 0"},
#else
{0, 7, 0x00000000000000AA, "RW", "DATA_LINE0", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo255[] = {{"CPGC_DPAT_EXTBUF_6_", "", 0x0000021C, 4, 0x00000000FFFFFFFF, 0x00000000AAAAAAAA}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields256[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{24, 31, 0x00000000000000AA, "RW", "DATA_LINE3", "Contents of Pattern Buffer 0 Data Line 3[br]\r\n"
"EXTBUF[0] corresponds to Lane 0 (32 UI of data maximum)[br]\r\n"
"EXTBUF[1] corresponds to Lane 1 (32 UI of data maximum)[br]\r\n"
".....[br]\r\n"
"EXTBUF[15] corresponds to Lane 15[br]\r\n"
"These 16 lanes are replicated across the number of active DQ lanes on the memory interface."},
#else
{24, 31, 0x00000000000000AA, "RW", "DATA_LINE3", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{16, 23, 0x00000000000000AA, "RW", "DATA_LINE2", "Contents of Pattern Buffer 0 Data Line 2.[br]\r\n"
"Line 2 refers to the 8-UI partial cache line as pointed to current status at CPGC_DPAT_BUFSTAT.[br]\r\n"
"This advancement is controlled by CPGC_DPAT_BUF_CTL."},
#else
{16, 23, 0x00000000000000AA, "RW", "DATA_LINE2", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{8, 15, 0x00000000000000AA, "RW", "DATA_LINE1", "Contents of Pattern Buffer 0 Data Line 1"},
#else
{8, 15, 0x00000000000000AA, "RW", "DATA_LINE1", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 7, 0x00000000000000AA, "RW", "DATA_LINE0", "Contents of Pattern Buffer 0 Data Line 0"},
#else
{0, 7, 0x00000000000000AA, "RW", "DATA_LINE0", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo256[] = {{"CPGC_DPAT_EXTBUF_7_", "", 0x00000220, 4, 0x00000000FFFFFFFF, 0x00000000AAAAAAAA}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields257[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{24, 31, 0x00000000000000AA, "RW", "DATA_LINE3", "Contents of Pattern Buffer 0 Data Line 3[br]\r\n"
"EXTBUF[0] corresponds to Lane 0 (32 UI of data maximum)[br]\r\n"
"EXTBUF[1] corresponds to Lane 1 (32 UI of data maximum)[br]\r\n"
".....[br]\r\n"
"EXTBUF[15] corresponds to Lane 15[br]\r\n"
"These 16 lanes are replicated across the number of active DQ lanes on the memory interface."},
#else
{24, 31, 0x00000000000000AA, "RW", "DATA_LINE3", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{16, 23, 0x00000000000000AA, "RW", "DATA_LINE2", "Contents of Pattern Buffer 0 Data Line 2.[br]\r\n"
"Line 2 refers to the 8-UI partial cache line as pointed to current status at CPGC_DPAT_BUFSTAT.[br]\r\n"
"This advancement is controlled by CPGC_DPAT_BUF_CTL."},
#else
{16, 23, 0x00000000000000AA, "RW", "DATA_LINE2", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{8, 15, 0x00000000000000AA, "RW", "DATA_LINE1", "Contents of Pattern Buffer 0 Data Line 1"},
#else
{8, 15, 0x00000000000000AA, "RW", "DATA_LINE1", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 7, 0x00000000000000AA, "RW", "DATA_LINE0", "Contents of Pattern Buffer 0 Data Line 0"},
#else
{0, 7, 0x00000000000000AA, "RW", "DATA_LINE0", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo257[] = {{"CPGC_DPAT_EXTBUF_8_", "", 0x00000224, 4, 0x00000000FFFFFFFF, 0x00000000AAAAAAAA}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields258[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{24, 31, 0x00000000000000AA, "RW", "DATA_LINE3", "Contents of Pattern Buffer 0 Data Line 3[br]\r\n"
"EXTBUF[0] corresponds to Lane 0 (32 UI of data maximum)[br]\r\n"
"EXTBUF[1] corresponds to Lane 1 (32 UI of data maximum)[br]\r\n"
".....[br]\r\n"
"EXTBUF[15] corresponds to Lane 15[br]\r\n"
"These 16 lanes are replicated across the number of active DQ lanes on the memory interface."},
#else
{24, 31, 0x00000000000000AA, "RW", "DATA_LINE3", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{16, 23, 0x00000000000000AA, "RW", "DATA_LINE2", "Contents of Pattern Buffer 0 Data Line 2.[br]\r\n"
"Line 2 refers to the 8-UI partial cache line as pointed to current status at CPGC_DPAT_BUFSTAT.[br]\r\n"
"This advancement is controlled by CPGC_DPAT_BUF_CTL."},
#else
{16, 23, 0x00000000000000AA, "RW", "DATA_LINE2", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{8, 15, 0x00000000000000AA, "RW", "DATA_LINE1", "Contents of Pattern Buffer 0 Data Line 1"},
#else
{8, 15, 0x00000000000000AA, "RW", "DATA_LINE1", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 7, 0x00000000000000AA, "RW", "DATA_LINE0", "Contents of Pattern Buffer 0 Data Line 0"},
#else
{0, 7, 0x00000000000000AA, "RW", "DATA_LINE0", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo258[] = {{"CPGC_DPAT_EXTBUF_9_", "", 0x00000228, 4, 0x00000000FFFFFFFF, 0x00000000AAAAAAAA}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields259[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{24, 31, 0x00000000000000AA, "RW", "DATA_LINE3", "Contents of Pattern Buffer 0 Data Line 3[br]\r\n"
"EXTBUF[0] corresponds to Lane 0 (32 UI of data maximum)[br]\r\n"
"EXTBUF[1] corresponds to Lane 1 (32 UI of data maximum)[br]\r\n"
".....[br]\r\n"
"EXTBUF[15] corresponds to Lane 15[br]\r\n"
"These 16 lanes are replicated across the number of active DQ lanes on the memory interface."},
#else
{24, 31, 0x00000000000000AA, "RW", "DATA_LINE3", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{16, 23, 0x00000000000000AA, "RW", "DATA_LINE2", "Contents of Pattern Buffer 0 Data Line 2.[br]\r\n"
"Line 2 refers to the 8-UI partial cache line as pointed to current status at CPGC_DPAT_BUFSTAT.[br]\r\n"
"This advancement is controlled by CPGC_DPAT_BUF_CTL."},
#else
{16, 23, 0x00000000000000AA, "RW", "DATA_LINE2", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{8, 15, 0x00000000000000AA, "RW", "DATA_LINE1", "Contents of Pattern Buffer 0 Data Line 1"},
#else
{8, 15, 0x00000000000000AA, "RW", "DATA_LINE1", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 7, 0x00000000000000AA, "RW", "DATA_LINE0", "Contents of Pattern Buffer 0 Data Line 0"},
#else
{0, 7, 0x00000000000000AA, "RW", "DATA_LINE0", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo259[] = {{"CPGC_DPAT_EXTBUF_10_", "", 0x0000022C, 4, 0x00000000FFFFFFFF, 0x00000000AAAAAAAA}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields260[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{24, 31, 0x00000000000000AA, "RW", "DATA_LINE3", "Contents of Pattern Buffer 0 Data Line 3[br]\r\n"
"EXTBUF[0] corresponds to Lane 0 (32 UI of data maximum)[br]\r\n"
"EXTBUF[1] corresponds to Lane 1 (32 UI of data maximum)[br]\r\n"
".....[br]\r\n"
"EXTBUF[15] corresponds to Lane 15[br]\r\n"
"These 16 lanes are replicated across the number of active DQ lanes on the memory interface."},
#else
{24, 31, 0x00000000000000AA, "RW", "DATA_LINE3", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{16, 23, 0x00000000000000AA, "RW", "DATA_LINE2", "Contents of Pattern Buffer 0 Data Line 2.[br]\r\n"
"Line 2 refers to the 8-UI partial cache line as pointed to current status at CPGC_DPAT_BUFSTAT.[br]\r\n"
"This advancement is controlled by CPGC_DPAT_BUF_CTL."},
#else
{16, 23, 0x00000000000000AA, "RW", "DATA_LINE2", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{8, 15, 0x00000000000000AA, "RW", "DATA_LINE1", "Contents of Pattern Buffer 0 Data Line 1"},
#else
{8, 15, 0x00000000000000AA, "RW", "DATA_LINE1", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 7, 0x00000000000000AA, "RW", "DATA_LINE0", "Contents of Pattern Buffer 0 Data Line 0"},
#else
{0, 7, 0x00000000000000AA, "RW", "DATA_LINE0", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo260[] = {{"CPGC_DPAT_EXTBUF_11_", "", 0x00000230, 4, 0x00000000FFFFFFFF, 0x00000000AAAAAAAA}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields261[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{24, 31, 0x00000000000000AA, "RW", "DATA_LINE3", "Contents of Pattern Buffer 0 Data Line 3[br]\r\n"
"EXTBUF[0] corresponds to Lane 0 (32 UI of data maximum)[br]\r\n"
"EXTBUF[1] corresponds to Lane 1 (32 UI of data maximum)[br]\r\n"
".....[br]\r\n"
"EXTBUF[15] corresponds to Lane 15[br]\r\n"
"These 16 lanes are replicated across the number of active DQ lanes on the memory interface."},
#else
{24, 31, 0x00000000000000AA, "RW", "DATA_LINE3", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{16, 23, 0x00000000000000AA, "RW", "DATA_LINE2", "Contents of Pattern Buffer 0 Data Line 2.[br]\r\n"
"Line 2 refers to the 8-UI partial cache line as pointed to current status at CPGC_DPAT_BUFSTAT.[br]\r\n"
"This advancement is controlled by CPGC_DPAT_BUF_CTL."},
#else
{16, 23, 0x00000000000000AA, "RW", "DATA_LINE2", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{8, 15, 0x00000000000000AA, "RW", "DATA_LINE1", "Contents of Pattern Buffer 0 Data Line 1"},
#else
{8, 15, 0x00000000000000AA, "RW", "DATA_LINE1", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 7, 0x00000000000000AA, "RW", "DATA_LINE0", "Contents of Pattern Buffer 0 Data Line 0"},
#else
{0, 7, 0x00000000000000AA, "RW", "DATA_LINE0", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo261[] = {{"CPGC_DPAT_EXTBUF_12_", "", 0x00000234, 4, 0x00000000FFFFFFFF, 0x00000000AAAAAAAA}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields262[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{24, 31, 0x00000000000000AA, "RW", "DATA_LINE3", "Contents of Pattern Buffer 0 Data Line 3[br]\r\n"
"EXTBUF[0] corresponds to Lane 0 (32 UI of data maximum)[br]\r\n"
"EXTBUF[1] corresponds to Lane 1 (32 UI of data maximum)[br]\r\n"
".....[br]\r\n"
"EXTBUF[15] corresponds to Lane 15[br]\r\n"
"These 16 lanes are replicated across the number of active DQ lanes on the memory interface."},
#else
{24, 31, 0x00000000000000AA, "RW", "DATA_LINE3", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{16, 23, 0x00000000000000AA, "RW", "DATA_LINE2", "Contents of Pattern Buffer 0 Data Line 2.[br]\r\n"
"Line 2 refers to the 8-UI partial cache line as pointed to current status at CPGC_DPAT_BUFSTAT.[br]\r\n"
"This advancement is controlled by CPGC_DPAT_BUF_CTL."},
#else
{16, 23, 0x00000000000000AA, "RW", "DATA_LINE2", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{8, 15, 0x00000000000000AA, "RW", "DATA_LINE1", "Contents of Pattern Buffer 0 Data Line 1"},
#else
{8, 15, 0x00000000000000AA, "RW", "DATA_LINE1", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 7, 0x00000000000000AA, "RW", "DATA_LINE0", "Contents of Pattern Buffer 0 Data Line 0"},
#else
{0, 7, 0x00000000000000AA, "RW", "DATA_LINE0", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo262[] = {{"CPGC_DPAT_EXTBUF_13_", "", 0x00000238, 4, 0x00000000FFFFFFFF, 0x00000000AAAAAAAA}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields263[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{24, 31, 0x00000000000000AA, "RW", "DATA_LINE3", "Contents of Pattern Buffer 0 Data Line 3[br]\r\n"
"EXTBUF[0] corresponds to Lane 0 (32 UI of data maximum)[br]\r\n"
"EXTBUF[1] corresponds to Lane 1 (32 UI of data maximum)[br]\r\n"
".....[br]\r\n"
"EXTBUF[15] corresponds to Lane 15[br]\r\n"
"These 16 lanes are replicated across the number of active DQ lanes on the memory interface."},
#else
{24, 31, 0x00000000000000AA, "RW", "DATA_LINE3", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{16, 23, 0x00000000000000AA, "RW", "DATA_LINE2", "Contents of Pattern Buffer 0 Data Line 2.[br]\r\n"
"Line 2 refers to the 8-UI partial cache line as pointed to current status at CPGC_DPAT_BUFSTAT.[br]\r\n"
"This advancement is controlled by CPGC_DPAT_BUF_CTL."},
#else
{16, 23, 0x00000000000000AA, "RW", "DATA_LINE2", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{8, 15, 0x00000000000000AA, "RW", "DATA_LINE1", "Contents of Pattern Buffer 0 Data Line 1"},
#else
{8, 15, 0x00000000000000AA, "RW", "DATA_LINE1", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 7, 0x00000000000000AA, "RW", "DATA_LINE0", "Contents of Pattern Buffer 0 Data Line 0"},
#else
{0, 7, 0x00000000000000AA, "RW", "DATA_LINE0", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo263[] = {{"CPGC_DPAT_EXTBUF_14_", "", 0x0000023C, 4, 0x00000000FFFFFFFF, 0x00000000AAAAAAAA}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields264[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{24, 31, 0x00000000000000AA, "RW", "DATA_LINE3", "Contents of Pattern Buffer 0 Data Line 3[br]\r\n"
"EXTBUF[0] corresponds to Lane 0 (32 UI of data maximum)[br]\r\n"
"EXTBUF[1] corresponds to Lane 1 (32 UI of data maximum)[br]\r\n"
".....[br]\r\n"
"EXTBUF[15] corresponds to Lane 15[br]\r\n"
"These 16 lanes are replicated across the number of active DQ lanes on the memory interface."},
#else
{24, 31, 0x00000000000000AA, "RW", "DATA_LINE3", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{16, 23, 0x00000000000000AA, "RW", "DATA_LINE2", "Contents of Pattern Buffer 0 Data Line 2.[br]\r\n"
"Line 2 refers to the 8-UI partial cache line as pointed to current status at CPGC_DPAT_BUFSTAT.[br]\r\n"
"This advancement is controlled by CPGC_DPAT_BUF_CTL."},
#else
{16, 23, 0x00000000000000AA, "RW", "DATA_LINE2", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{8, 15, 0x00000000000000AA, "RW", "DATA_LINE1", "Contents of Pattern Buffer 0 Data Line 1"},
#else
{8, 15, 0x00000000000000AA, "RW", "DATA_LINE1", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 7, 0x00000000000000AA, "RW", "DATA_LINE0", "Contents of Pattern Buffer 0 Data Line 0"},
#else
{0, 7, 0x00000000000000AA, "RW", "DATA_LINE0", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo264[] = {{"CPGC_DPAT_EXTBUF_15_", "", 0x00000240, 4, 0x00000000FFFFFFFF, 0x00000000AAAAAAAA}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields265[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{24, 31, 0x0000000000000000, "RW", "ERRCHK_MASK_CACHELINE", "Defines a periodic burst mask that repeats every 64Bytes of data as follows:[br][br]\r\n"
"Bit 0 - Burst 0 [br][br]\r\n"
"Bit 1 - Burst 1 [br][br]\r\n"
"...[br][br]\r\n"
"Bit 7 - Burst 7 [br][br]\r\n"
"Only bursts with a corresponding bit value of '0' will be checked for errors. A burst is defined as a burst length of 64 bytes of data.[br]\r\n"
"[b]CURRENTLY IMPLEMENTED AS AN ENABLE - to be changed soon to a mask[/b]"},
#else
{24, 31, 0x0000000000000000, "RW", "ERRCHK_MASK_CACHELINE", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{16, 23, 0x0000000000000000, "RW", "ERRCHK_MASK_CHUNK", "Defines which chunk within the burst of data (i.e. bit within a burst of 8-bits for each lane) to check for errors.[br]\r\n"
"Only chunks with a corresponding bit value of '0' will be checked for errors.[br]\r\n"
"[b]CURRENTLY IMPLEMENTED AS AN ENABLE - to be changed soon to a mask[/b] "},
#else
{16, 23, 0x0000000000000000, "RW", "ERRCHK_MASK_CHUNK", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{12, 13, 0x0000000000000000, "RW", "STOP_ON_ERROR_CTL", "Defines test stop conditions based on error checking as follows:[br][br]\r\n"
"00 - Never stop: Prevents any error from stopping the test.[br][br]\r\n"
"01 - Stop On Nth Error: Stop once ERR_CNTR has accumulated at least (STOP_ON_N + 1) errors.[br][br]\r\n"
"10 - Stop On All Byte Groups Error:  Stop if every byte group indicates that at least one of its lanes accumulated at least one error.[br]\r\n"
"That is, if all bits BYTEGRP_ERR_STAT, (and ECC_GRP_ERR_STAT if supported), are all set.[br][br]\r\n"
"11 - Stop On All Lanes Error:  Stop if every lane within every byte group has accumulated at least one error.[br]\r\n"
"That is, if all bits in LANE_ERR_STAT_LO, LANE_ERR_STAT_HI, (and LANE_ERR_STATECC if supported) are all set."},
#else
{12, 13, 0x0000000000000000, "RW", "STOP_ON_ERROR_CTL", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 5, 0x0000000000000000, "RW", "STOP_ON_N", "If STOP_ON_ERROR is set to Stop on Nth Error Mode, the test will stop after (STOP_ON_N + 1) or more errors have been accumulated in the ERR_CNTR"},
#else
{0, 5, 0x0000000000000000, "RW", "STOP_ON_N", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo265[] = {{"CPGC_ERR_CTL", "", 0x00000244, 4, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields266[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{0, 31, 0x0000000000000000, "RW", "DATA_ERRCHK_MASK_LO", "A mask used to disable error checking on data lanes [31:0].  Lanes selected through this mask will not be checked for errors. The lane-to-bit mapping for this mask is given by the following formula: Lane[n] -> bit[n].[br]\r\n"
"[b]REGISTER NAME WILL CHANGE SHORTLY - LNEN -> LNMSK[/b][br]\r\n"
"Functionality will change with special mapping when buswidth is < 64 (or 72) such that ChunkMask will move to this field starting at bit [...:32] extending the necessary number of bits for a full cache line of data. The mask in ERR_CTL will be unused for these busses/modes."},
#else
{0, 31, 0x0000000000000000, "RW", "DATA_ERRCHK_MASK_LO", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo266[] = {{"CPGC_ERR_LNEN_LO", "", 0x00000248, 1, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields267[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{0, 31, 0x0000000000000000, "RW", "DATA_ERRCHK_MASK_HI", "A mask used to disable error checking on data lanes [63:32].  Lanes selected through this mask will not be checked for errors. The lane-to-bit mapping for this mask is given by the following formula: Lane[n+32] -> bit[n].[br]\r\n"
"[b]REGISTER NAME WILL CHANGE SHORTLY - LNEN -> LNMSK[/b][br]\r\n"
"Functionality will change with special mapping when buswidth is < 64 (or 72) such that ChunkMask will move to this field starting at bit [...:32] extending the necessary number of bits for a full cache line of data. The mask in ERR_CTL will be unused for these busses/modes."},
#else
{0, 31, 0x0000000000000000, "RW", "DATA_ERRCHK_MASK_HI", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo267[] = {{"CPGC_ERR_LNEN_HI", "", 0x0000024C, 1, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields268[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{0, 7, 0x00000000000000FF, "RW", "ECC_ERRCHK_MASK", "Used as an error check enable mask for ECC lanes.  Lanes selected through the mask will not be checked for errors. The lane-to-bit mapping is 1-to-1 and hence bit 1 corresponds to ECC lane 0, bit 1 corresponds to ECC lane 1, and so on.[br] Note: This field is available only if ECC is supported. The default state is to disable ECC checking."},
#else
{0, 7, 0x00000000000000FF, "RW", "ECC_ERRCHK_MASK", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo268[] = {{"CPGC_ERR_XLNEN", "", 0x00000250, 1, 0x00000000000000FF, 0x00000000000000FF}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields269[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{0, 31, 0x0000000000000000, "RO/V", "LANE_ERR_STAT_LO", "Indicates if a mismatch was detected between the WR and the RD data on one of the lanes belonging to byte groups 0  3.  Hence lanes [32:0] map to bits [32:0] respectively.  The error status information is encoded as follows: [br][br]\r\n"
"0: No mismatches detected on corresponding lane.[br][br]\r\n"
"1: At least one mismatch detected on corresponding lane."},
#else
{0, 31, 0x0000000000000000, "RO/V", "LANE_ERR_STAT_LO", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo269[] = {{"CPGC_ERR_STAT03", "", 0x00000254, 1, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields270[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{0, 31, 0x0000000000000000, "RO/V", "LANE_ERR_STAT_HI", "Indicates if a mismatch was detected between the WR and the RD data on one of the lanes belonging to byte groups 4  7.  Hence lanes [63:32] map to bits [32:0] respectively.  The error status information is encoded as follows: [br][br]\r\n"
"0: No mismatches detected on corresponding lane.[br][br]\r\n"
"1: At least one mismatch detected on corresponding lane.[br]\r\n"
""},
#else
{0, 31, 0x0000000000000000, "RO/V", "LANE_ERR_STAT_HI", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo270[] = {{"CPGC_ERR_STAT47", "", 0x00000258, 1, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields271[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{16, 19, 0x0000000000000000, "RO/V", "RANK_ERR_STAT", "A one-hot field where each bit corresponds to a specific rank. If set, the corresponding rank has accumulated at least one error."},
#else
{16, 19, 0x0000000000000000, "RO/V", "RANK_ERR_STAT", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{8, 15, 0x0000000000000000, "RO/V", "CHUNK_ERR_STAT", "A flag field where each bit corresponds to a specific chunk (i.e. bit within a burst of 8-bits). If set, the corresponding chunk (UI) has accumulated at least one error."},
#else
{8, 15, 0x0000000000000000, "RO/V", "CHUNK_ERR_STAT", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 7, 0x0000000000000000, "RO/V", "ECC_LANE_ERR_STAT", "A fag field which indicates if a mismatch was detected between the WR and the RD data on one of the lanes belonging to the ECC byte group.  The error status information is encoded as follows:[br] 0: No mismatches detected on corresponding lane.[br] 1: At least one mismatch detected on corresponding lane.[br] Note: this field is only available if ECC is supported for the current implementation, otherwise it is reserved."},
#else
{0, 7, 0x0000000000000000, "RO/V", "ECC_LANE_ERR_STAT", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo271[] = {{"CPGC_ERR_ECC_CHNK_RANK_STAT", "", 0x0000025C, 3, 0x00000000000FFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields272[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{24, 29, 0x0000000000000000, "RO/V", "Nth_ERROR", "Nth_Error indicates the current Nth Error that has occurred.[br][br]\r\n"
"Nth_Error will roll over upon saturating to its maximum values.[br][br]\r\n"
"An Nth error is defined as 1 or more lane miscompares within a single comparison cycle (i.e. Chunk)."},
#else
{24, 29, 0x0000000000000000, "RO/V", "Nth_ERROR", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{20, 22, 0x0000000000000000, "RO/V", "RD_CHUNK_NUM_STAT", "RD_Chunk_Num_Status corresponds to the chunk number being read out of the WDB (EXTBUF )for a RdCAS operation while logging an error during Loopback.Pattern.[br][br]\r\n"
"RD_Chunk_Num_Status is needed in conjunction with the lower 3 column address bits of the cacheline experiencing the error in order to deterministically rewind the LFSR/PB/LMN counter after the test is stopped due to an error condition. This is due to the pipelined nature of the data path since a cacheline can be read out of the WDB (EXTBUF) at the same time an error is being detected against an earlier read.[br]\r\n"
"Using RD_Chunk_Num_Status and the lower 3 column address bits of the cacheline experiencing the error allows the user to determine the skid between the LFSR/PB/LMN counter and the error detection.[br]\r\n"
"RD_Chunk_Num_Status can be cleared by one of two ways.[br][br]\r\n"
"1. Local_Clear_Errors or (Global_Control and Global_Clear_Errors) to 1.[br][br]\r\n"
"2. Writing RD_Chunk_Num_Status=0x0. One may also choose to clear individual bits in RD_Chunk_Num_Status.[br]\r\n"
"Setting bits in RD_Chunk_Num_Status is undefined and should be avoided.[br][br]\r\n"
"Writing a 0 to bits in RD_Chunk_Num_Status can be cleared independently of Data_Error_Status, ECC_Error_Status, Rank_Error_Status, Chunk_Error_Status, and Byte_Group_Error_Status."},
#else
{20, 22, 0x0000000000000000, "RO/V", "RD_CHUNK_NUM_STAT", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{8, 8, 0x0000000000000000, "RW/1C/V", "ECCGRP_ERR_STAT", "A set bit implies that the ECC bytegroup has at least one lane that accumulated at least one error."},
#else
{8, 8, 0x0000000000000000, "RW/1C/V", "ECCGRP_ERR_STAT", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 7, 0x0000000000000000, "RW/1C/V", "BYTEGRP_ERR_STAT", "A flag field with each bit corresponding to a specific byte group.  Bit 0 corresponds to byte group 0, bit 1 corresponds to byte group 1, bit 2 corresponds to byte group 2, and so on.  A set bit implies that the corresponding byte group has at least one lane that accumulated at least one error."},
#else
{0, 7, 0x0000000000000000, "RW/1C/V", "BYTEGRP_ERR_STAT", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo272[] = {{"CPGC_ERR_BYTE_NTH_PAR_STAT", "", 0x00000260, 4, 0x000000003FFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields273[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{7, 8, 0x0000000000000000, "RW", "COUNTER_CONTROL", "Counter_Control determines what gets counted by CPGC_ERR_ERRCNTR_#.Counter_Status.[br][br]\r\n"
"00=Count Errors on all Lanes - The Error Counter will capture the OR of all errors across all unmasked Lanes in a Byte.  For example, if 1 lane or 72 lanes experience an error in a chunk then the CPGC_ERR_ERRCNTR_#.Counter_Status will be incremented by only 1.[br][br]\r\n"
"01=Count Errors on a particular Lane - The Error Counter will count the exact number of errors on the Lane indicated by CPGC_ERR_CNTRCTL.COUNTER_POINTER[br][br]\r\n"
"10=Count Errors on a particular Byte Group - The Error Counter will count the number of errors on the Byte group indicated by CPGC_ERR_CNTRCTL.COUNTER_POINTER. ECC is byte group 8 in x8 technology and ECC is byte group 8 and 17 in x4 technology.[br]\r\n"
"11=Count Errors on a particular Chunk - The Error Counter will count the number of errors on the a particular chunk in the cacheline indicated by CPGC_ERR_CNTRCTL.COUNTER_POINTER."},
#else
{7, 8, 0x0000000000000000, "RW", "COUNTER_CONTROL", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 6, 0x0000000000000000, "RW", "COUNTER_POINTER", "Lane_Control is used in conjunction with Counter_Control to indicate which Lane CPGC_ERR_ERRCNTR_#.Counter_Satus will count errors on."},
#else
{0, 6, 0x0000000000000000, "RW", "COUNTER_POINTER", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo273[] = {{"CPGC_ERR_CNTRCTL_0_", "", 0x00000264, 2, 0x00000000000001FF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields274[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{7, 8, 0x0000000000000000, "RW", "COUNTER_CONTROL", "Counter_Control determines what gets counted by CPGC_ERR_ERRCNTR_#.Counter_Status.[br][br]\r\n"
"00=Count Errors on all Lanes - The Error Counter will capture the OR of all errors across all unmasked Lanes in a Byte.  For example, if 1 lane or 72 lanes experience an error in a chunk then the CPGC_ERR_ERRCNTR_#.Counter_Status will be incremented by only 1.[br][br]\r\n"
"01=Count Errors on a particular Lane - The Error Counter will count the exact number of errors on the Lane indicated by CPGC_ERR_CNTRCTL.COUNTER_POINTER[br][br]\r\n"
"10=Count Errors on a particular Byte Group - The Error Counter will count the number of errors on the Byte group indicated by CPGC_ERR_CNTRCTL.COUNTER_POINTER. ECC is byte group 8 in x8 technology and ECC is byte group 8 and 17 in x4 technology.[br]\r\n"
"11=Count Errors on a particular Chunk - The Error Counter will count the number of errors on the a particular chunk in the cacheline indicated by CPGC_ERR_CNTRCTL.COUNTER_POINTER."},
#else
{7, 8, 0x0000000000000000, "RW", "COUNTER_CONTROL", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 6, 0x0000000000000000, "RW", "COUNTER_POINTER", "Lane_Control is used in conjunction with Counter_Control to indicate which Lane CPGC_ERR_ERRCNTR_#.Counter_Satus will count errors on."},
#else
{0, 6, 0x0000000000000000, "RW", "COUNTER_POINTER", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo274[] = {{"CPGC_ERR_CNTRCTL_1_", "", 0x00000268, 2, 0x00000000000001FF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields275[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{7, 8, 0x0000000000000000, "RW", "COUNTER_CONTROL", "Counter_Control determines what gets counted by CPGC_ERR_ERRCNTR_#.Counter_Status.[br][br]\r\n"
"00=Count Errors on all Lanes - The Error Counter will capture the OR of all errors across all unmasked Lanes in a Byte.  For example, if 1 lane or 72 lanes experience an error in a chunk then the CPGC_ERR_ERRCNTR_#.Counter_Status will be incremented by only 1.[br][br]\r\n"
"01=Count Errors on a particular Lane - The Error Counter will count the exact number of errors on the Lane indicated by CPGC_ERR_CNTRCTL.COUNTER_POINTER[br][br]\r\n"
"10=Count Errors on a particular Byte Group - The Error Counter will count the number of errors on the Byte group indicated by CPGC_ERR_CNTRCTL.COUNTER_POINTER. ECC is byte group 8 in x8 technology and ECC is byte group 8 and 17 in x4 technology.[br]\r\n"
"11=Count Errors on a particular Chunk - The Error Counter will count the number of errors on the a particular chunk in the cacheline indicated by CPGC_ERR_CNTRCTL.COUNTER_POINTER."},
#else
{7, 8, 0x0000000000000000, "RW", "COUNTER_CONTROL", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 6, 0x0000000000000000, "RW", "COUNTER_POINTER", "Lane_Control is used in conjunction with Counter_Control to indicate which Lane CPGC_ERR_ERRCNTR_#.Counter_Satus will count errors on."},
#else
{0, 6, 0x0000000000000000, "RW", "COUNTER_POINTER", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo275[] = {{"CPGC_ERR_CNTRCTL_2_", "", 0x0000026C, 2, 0x00000000000001FF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields276[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{7, 8, 0x0000000000000000, "RW", "COUNTER_CONTROL", "Counter_Control determines what gets counted by CPGC_ERR_ERRCNTR_#.Counter_Status.[br][br]\r\n"
"00=Count Errors on all Lanes - The Error Counter will capture the OR of all errors across all unmasked Lanes in a Byte.  For example, if 1 lane or 72 lanes experience an error in a chunk then the CPGC_ERR_ERRCNTR_#.Counter_Status will be incremented by only 1.[br][br]\r\n"
"01=Count Errors on a particular Lane - The Error Counter will count the exact number of errors on the Lane indicated by CPGC_ERR_CNTRCTL.COUNTER_POINTER[br][br]\r\n"
"10=Count Errors on a particular Byte Group - The Error Counter will count the number of errors on the Byte group indicated by CPGC_ERR_CNTRCTL.COUNTER_POINTER. ECC is byte group 8 in x8 technology and ECC is byte group 8 and 17 in x4 technology.[br]\r\n"
"11=Count Errors on a particular Chunk - The Error Counter will count the number of errors on the a particular chunk in the cacheline indicated by CPGC_ERR_CNTRCTL.COUNTER_POINTER."},
#else
{7, 8, 0x0000000000000000, "RW", "COUNTER_CONTROL", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 6, 0x0000000000000000, "RW", "COUNTER_POINTER", "Lane_Control is used in conjunction with Counter_Control to indicate which Lane CPGC_ERR_ERRCNTR_#.Counter_Satus will count errors on."},
#else
{0, 6, 0x0000000000000000, "RW", "COUNTER_POINTER", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo276[] = {{"CPGC_ERR_CNTRCTL_3_", "", 0x00000270, 2, 0x00000000000001FF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields277[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{7, 8, 0x0000000000000000, "RW", "COUNTER_CONTROL", "Counter_Control determines what gets counted by CPGC_ERR_ERRCNTR_#.Counter_Status.[br][br]\r\n"
"00=Count Errors on all Lanes - The Error Counter will capture the OR of all errors across all unmasked Lanes in a Byte.  For example, if 1 lane or 72 lanes experience an error in a chunk then the CPGC_ERR_ERRCNTR_#.Counter_Status will be incremented by only 1.[br][br]\r\n"
"01=Count Errors on a particular Lane - The Error Counter will count the exact number of errors on the Lane indicated by CPGC_ERR_CNTRCTL.COUNTER_POINTER[br][br]\r\n"
"10=Count Errors on a particular Byte Group - The Error Counter will count the number of errors on the Byte group indicated by CPGC_ERR_CNTRCTL.COUNTER_POINTER. ECC is byte group 8 in x8 technology and ECC is byte group 8 and 17 in x4 technology.[br]\r\n"
"11=Count Errors on a particular Chunk - The Error Counter will count the number of errors on the a particular chunk in the cacheline indicated by CPGC_ERR_CNTRCTL.COUNTER_POINTER."},
#else
{7, 8, 0x0000000000000000, "RW", "COUNTER_CONTROL", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 6, 0x0000000000000000, "RW", "COUNTER_POINTER", "Lane_Control is used in conjunction with Counter_Control to indicate which Lane CPGC_ERR_ERRCNTR_#.Counter_Satus will count errors on."},
#else
{0, 6, 0x0000000000000000, "RW", "COUNTER_POINTER", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo277[] = {{"CPGC_ERR_CNTRCTL_4_", "", 0x00000274, 2, 0x00000000000001FF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields278[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{7, 8, 0x0000000000000000, "RW", "COUNTER_CONTROL", "Counter_Control determines what gets counted by CPGC_ERR_ERRCNTR_#.Counter_Status.[br][br]\r\n"
"00=Count Errors on all Lanes - The Error Counter will capture the OR of all errors across all unmasked Lanes in a Byte.  For example, if 1 lane or 72 lanes experience an error in a chunk then the CPGC_ERR_ERRCNTR_#.Counter_Status will be incremented by only 1.[br][br]\r\n"
"01=Count Errors on a particular Lane - The Error Counter will count the exact number of errors on the Lane indicated by CPGC_ERR_CNTRCTL.COUNTER_POINTER[br][br]\r\n"
"10=Count Errors on a particular Byte Group - The Error Counter will count the number of errors on the Byte group indicated by CPGC_ERR_CNTRCTL.COUNTER_POINTER. ECC is byte group 8 in x8 technology and ECC is byte group 8 and 17 in x4 technology.[br]\r\n"
"11=Count Errors on a particular Chunk - The Error Counter will count the number of errors on the a particular chunk in the cacheline indicated by CPGC_ERR_CNTRCTL.COUNTER_POINTER."},
#else
{7, 8, 0x0000000000000000, "RW", "COUNTER_CONTROL", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 6, 0x0000000000000000, "RW", "COUNTER_POINTER", "Lane_Control is used in conjunction with Counter_Control to indicate which Lane CPGC_ERR_ERRCNTR_#.Counter_Satus will count errors on."},
#else
{0, 6, 0x0000000000000000, "RW", "COUNTER_POINTER", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo278[] = {{"CPGC_ERR_CNTRCTL_5_", "", 0x00000278, 2, 0x00000000000001FF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields279[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{7, 8, 0x0000000000000000, "RW", "COUNTER_CONTROL", "Counter_Control determines what gets counted by CPGC_ERR_ERRCNTR_#.Counter_Status.[br][br]\r\n"
"00=Count Errors on all Lanes - The Error Counter will capture the OR of all errors across all unmasked Lanes in a Byte.  For example, if 1 lane or 72 lanes experience an error in a chunk then the CPGC_ERR_ERRCNTR_#.Counter_Status will be incremented by only 1.[br][br]\r\n"
"01=Count Errors on a particular Lane - The Error Counter will count the exact number of errors on the Lane indicated by CPGC_ERR_CNTRCTL.COUNTER_POINTER[br][br]\r\n"
"10=Count Errors on a particular Byte Group - The Error Counter will count the number of errors on the Byte group indicated by CPGC_ERR_CNTRCTL.COUNTER_POINTER. ECC is byte group 8 in x8 technology and ECC is byte group 8 and 17 in x4 technology.[br]\r\n"
"11=Count Errors on a particular Chunk - The Error Counter will count the number of errors on the a particular chunk in the cacheline indicated by CPGC_ERR_CNTRCTL.COUNTER_POINTER."},
#else
{7, 8, 0x0000000000000000, "RW", "COUNTER_CONTROL", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 6, 0x0000000000000000, "RW", "COUNTER_POINTER", "Lane_Control is used in conjunction with Counter_Control to indicate which Lane CPGC_ERR_ERRCNTR_#.Counter_Satus will count errors on."},
#else
{0, 6, 0x0000000000000000, "RW", "COUNTER_POINTER", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo279[] = {{"CPGC_ERR_CNTRCTL_6_", "", 0x0000027C, 2, 0x00000000000001FF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields280[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{7, 8, 0x0000000000000000, "RW", "COUNTER_CONTROL", "Counter_Control determines what gets counted by CPGC_ERR_ERRCNTR_#.Counter_Status.[br][br]\r\n"
"00=Count Errors on all Lanes - The Error Counter will capture the OR of all errors across all unmasked Lanes in a Byte.  For example, if 1 lane or 72 lanes experience an error in a chunk then the CPGC_ERR_ERRCNTR_#.Counter_Status will be incremented by only 1.[br][br]\r\n"
"01=Count Errors on a particular Lane - The Error Counter will count the exact number of errors on the Lane indicated by CPGC_ERR_CNTRCTL.COUNTER_POINTER[br][br]\r\n"
"10=Count Errors on a particular Byte Group - The Error Counter will count the number of errors on the Byte group indicated by CPGC_ERR_CNTRCTL.COUNTER_POINTER. ECC is byte group 8 in x8 technology and ECC is byte group 8 and 17 in x4 technology.[br]\r\n"
"11=Count Errors on a particular Chunk - The Error Counter will count the number of errors on the a particular chunk in the cacheline indicated by CPGC_ERR_CNTRCTL.COUNTER_POINTER."},
#else
{7, 8, 0x0000000000000000, "RW", "COUNTER_CONTROL", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 6, 0x0000000000000000, "RW", "COUNTER_POINTER", "Lane_Control is used in conjunction with Counter_Control to indicate which Lane CPGC_ERR_ERRCNTR_#.Counter_Satus will count errors on."},
#else
{0, 6, 0x0000000000000000, "RW", "COUNTER_POINTER", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo280[] = {{"CPGC_ERR_CNTRCTL_7_", "", 0x00000280, 2, 0x00000000000001FF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields281[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{7, 8, 0x0000000000000000, "RW", "COUNTER_CONTROL", "Counter_Control determines what gets counted by CPGC_ERR_ERRCNTR_#.Counter_Status.[br][br]\r\n"
"00=Count Errors on all Lanes - The Error Counter will capture the OR of all errors across all unmasked Lanes in a Byte.  For example, if 1 lane or 72 lanes experience an error in a chunk then the CPGC_ERR_ERRCNTR_#.Counter_Status will be incremented by only 1.[br][br]\r\n"
"01=Count Errors on a particular Lane - The Error Counter will count the exact number of errors on the Lane indicated by CPGC_ERR_CNTRCTL.COUNTER_POINTER[br][br]\r\n"
"10=Count Errors on a particular Byte Group - The Error Counter will count the number of errors on the Byte group indicated by CPGC_ERR_CNTRCTL.COUNTER_POINTER. ECC is byte group 8 in x8 technology and ECC is byte group 8 and 17 in x4 technology.[br]\r\n"
"11=Count Errors on a particular Chunk - The Error Counter will count the number of errors on the a particular chunk in the cacheline indicated by CPGC_ERR_CNTRCTL.COUNTER_POINTER."},
#else
{7, 8, 0x0000000000000000, "RW", "COUNTER_CONTROL", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 6, 0x0000000000000000, "RW", "COUNTER_POINTER", "Lane_Control is used in conjunction with Counter_Control to indicate which Lane CPGC_ERR_ERRCNTR_#.Counter_Satus will count errors on."},
#else
{0, 6, 0x0000000000000000, "RW", "COUNTER_POINTER", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo281[] = {{"CPGC_ERR_CNTRCTL_8_", "", 0x00000284, 2, 0x00000000000001FF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields282[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{0, 22, 0x0000000000000000, "RO/V", "ERROR_COUNTER", "CPGC_ERR_ERRCNTR indicates the current error counter value which is configured by CPGC_ERR_CNTRCTL.Counter_Control.  The  Counter_Status will not  saturate and will wrap around, but any overflow of this counter will set the corresponding overflow status bit in CPGC_ERR_ERRCNTR_OVERFLOW_STATUS.ERROR_COUNTER_OVERFLOW.[br][br]\r\n"
"Counter_Status and Counter_Overflow can only be cleared by setting Local_Clear_Errors. "},
#else
{0, 22, 0x0000000000000000, "RO/V", "ERROR_COUNTER", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo282[] = {{"CPGC_ERR_CNTR_0_", "", 0x00000288, 1, 0x00000000007FFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields283[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{0, 22, 0x0000000000000000, "RO/V", "ERROR_COUNTER", "CPGC_ERR_ERRCNTR indicates the current error counter value which is configured by CPGC_ERR_CNTRCTL.Counter_Control.  The  Counter_Status will not  saturate and will wrap around, but any overflow of this counter will set the corresponding overflow status bit in CPGC_ERR_ERRCNTR_OVERFLOW_STATUS.ERROR_COUNTER_OVERFLOW.[br][br]\r\n"
"Counter_Status and Counter_Overflow can only be cleared by setting Local_Clear_Errors. "},
#else
{0, 22, 0x0000000000000000, "RO/V", "ERROR_COUNTER", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo283[] = {{"CPGC_ERR_CNTR_1_", "", 0x0000028C, 1, 0x00000000007FFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields284[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{0, 22, 0x0000000000000000, "RO/V", "ERROR_COUNTER", "CPGC_ERR_ERRCNTR indicates the current error counter value which is configured by CPGC_ERR_CNTRCTL.Counter_Control.  The  Counter_Status will not  saturate and will wrap around, but any overflow of this counter will set the corresponding overflow status bit in CPGC_ERR_ERRCNTR_OVERFLOW_STATUS.ERROR_COUNTER_OVERFLOW.[br][br]\r\n"
"Counter_Status and Counter_Overflow can only be cleared by setting Local_Clear_Errors. "},
#else
{0, 22, 0x0000000000000000, "RO/V", "ERROR_COUNTER", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo284[] = {{"CPGC_ERR_CNTR_2_", "", 0x00000290, 1, 0x00000000007FFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields285[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{0, 22, 0x0000000000000000, "RO/V", "ERROR_COUNTER", "CPGC_ERR_ERRCNTR indicates the current error counter value which is configured by CPGC_ERR_CNTRCTL.Counter_Control.  The  Counter_Status will not  saturate and will wrap around, but any overflow of this counter will set the corresponding overflow status bit in CPGC_ERR_ERRCNTR_OVERFLOW_STATUS.ERROR_COUNTER_OVERFLOW.[br][br]\r\n"
"Counter_Status and Counter_Overflow can only be cleared by setting Local_Clear_Errors. "},
#else
{0, 22, 0x0000000000000000, "RO/V", "ERROR_COUNTER", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo285[] = {{"CPGC_ERR_CNTR_3_", "", 0x00000294, 1, 0x00000000007FFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields286[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{0, 22, 0x0000000000000000, "RO/V", "ERROR_COUNTER", "CPGC_ERR_ERRCNTR indicates the current error counter value which is configured by CPGC_ERR_CNTRCTL.Counter_Control.  The  Counter_Status will not  saturate and will wrap around, but any overflow of this counter will set the corresponding overflow status bit in CPGC_ERR_ERRCNTR_OVERFLOW_STATUS.ERROR_COUNTER_OVERFLOW.[br][br]\r\n"
"Counter_Status and Counter_Overflow can only be cleared by setting Local_Clear_Errors. "},
#else
{0, 22, 0x0000000000000000, "RO/V", "ERROR_COUNTER", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo286[] = {{"CPGC_ERR_CNTR_4_", "", 0x00000298, 1, 0x00000000007FFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields287[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{0, 22, 0x0000000000000000, "RO/V", "ERROR_COUNTER", "CPGC_ERR_ERRCNTR indicates the current error counter value which is configured by CPGC_ERR_CNTRCTL.Counter_Control.  The  Counter_Status will not  saturate and will wrap around, but any overflow of this counter will set the corresponding overflow status bit in CPGC_ERR_ERRCNTR_OVERFLOW_STATUS.ERROR_COUNTER_OVERFLOW.[br][br]\r\n"
"Counter_Status and Counter_Overflow can only be cleared by setting Local_Clear_Errors. "},
#else
{0, 22, 0x0000000000000000, "RO/V", "ERROR_COUNTER", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo287[] = {{"CPGC_ERR_CNTR_5_", "", 0x0000029C, 1, 0x00000000007FFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields288[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{0, 22, 0x0000000000000000, "RO/V", "ERROR_COUNTER", "CPGC_ERR_ERRCNTR indicates the current error counter value which is configured by CPGC_ERR_CNTRCTL.Counter_Control.  The  Counter_Status will not  saturate and will wrap around, but any overflow of this counter will set the corresponding overflow status bit in CPGC_ERR_ERRCNTR_OVERFLOW_STATUS.ERROR_COUNTER_OVERFLOW.[br][br]\r\n"
"Counter_Status and Counter_Overflow can only be cleared by setting Local_Clear_Errors. "},
#else
{0, 22, 0x0000000000000000, "RO/V", "ERROR_COUNTER", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo288[] = {{"CPGC_ERR_CNTR_6_", "", 0x000002A0, 1, 0x00000000007FFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields289[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{0, 22, 0x0000000000000000, "RO/V", "ERROR_COUNTER", "CPGC_ERR_ERRCNTR indicates the current error counter value which is configured by CPGC_ERR_CNTRCTL.Counter_Control.  The  Counter_Status will not  saturate and will wrap around, but any overflow of this counter will set the corresponding overflow status bit in CPGC_ERR_ERRCNTR_OVERFLOW_STATUS.ERROR_COUNTER_OVERFLOW.[br][br]\r\n"
"Counter_Status and Counter_Overflow can only be cleared by setting Local_Clear_Errors. "},
#else
{0, 22, 0x0000000000000000, "RO/V", "ERROR_COUNTER", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo289[] = {{"CPGC_ERR_CNTR_7_", "", 0x000002A4, 1, 0x00000000007FFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields290[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{0, 22, 0x0000000000000000, "RO/V", "ERROR_COUNTER", "CPGC_ERR_ERRCNTR indicates the current error counter value which is configured by CPGC_ERR_CNTRCTL.Counter_Control.  The  Counter_Status will not  saturate and will wrap around, but any overflow of this counter will set the corresponding overflow status bit in CPGC_ERR_ERRCNTR_OVERFLOW_STATUS.ERROR_COUNTER_OVERFLOW.[br][br]\r\n"
"Counter_Status and Counter_Overflow can only be cleared by setting Local_Clear_Errors. "},
#else
{0, 22, 0x0000000000000000, "RO/V", "ERROR_COUNTER", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo290[] = {{"CPGC_ERR_CNTR_8_", "", 0x000002A8, 1, 0x00000000007FFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields291[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{0, 8, 0x0000000000000000, "RW/1C/V", "ERROR_COUNTER_OVERFLOW", "Counter_Overflow contains the overflow flag for CPGC_ERR_ERRCNTR.Error_Counter[br][br]\r\n"
"Bit 0 corresponds to ERROR_COUNTER_0[br][br]\r\n"
"Bit 1 corresponds to ERROR_COUNTER_1[br][br]\r\n"
"Bit 2 corresponds to ERROR_COUNTER_2[br][br]\r\n"
"..[br][br]\r\n"
"Bit 8 corresponds to ERROR_COUNTER_8[br][br]\r\n"
"Counter_Overflow_Status can be cleared by one of two ways.[br][br]\r\n"
"1. Local_Clear_Errors or (Global_Control and Global_Clear_Errors) to 1[br][br]\r\n"
"2. Writing Counter_Overflow_Status = 0x0.  One may also choose to clear individual bits in DCounter_Overflow_Status.  Setting bits in Counter_Overflow_Status from 0 to 1 is[br]\r\n"
"     undefined and should be avoided .[br][br]\r\n"
"Writing a 0 to bits in Counter_Overflow_Status can be cleared independently of Data_Error_Status, Byte_Group_Error_Status, Chunk_Error_Status, and ECC_Error_Status."},
#else
{0, 8, 0x0000000000000000, "RW/1C/V", "ERROR_COUNTER_OVERFLOW", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo291[] = {{"CPGC_ERR_CNTR_OV", "", 0x000002AC, 1, 0x00000000000001FF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields292[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{16, 16, 0x0000000000000000, "RW/1S", "CLR_DUN_RDBUF_PTR", "N/A"},
#else
{16, 16, 0x0000000000000000, "RW/1S", "CLR_DUN_RDBUF_PTR", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{15, 15, 0x0000000000000000, "RW/1S", "INC_CHUNK_COUNT", "N/A"},
#else
{15, 15, 0x0000000000000000, "RW/1S", "INC_CHUNK_COUNT", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{14, 14, 0x0000000000000000, "RW/1S", "ERRLOG_AUTO", "Asserting this bit will have the effect of CPGC automatically generating the needed Read transactions such as the current Read Pointer targets the last failing cachline. Instead of manually browsing, user can set this bit and logic will make sure that CURR_RD_PTR==ERROR_RD_PTR. This bit will always return '0' if read by software"},
#else
{14, 14, 0x0000000000000000, "RW/1S", "ERRLOG_AUTO", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{13, 13, 0x0000000000000000, "RW/1S", "ERRLOG_MOVE", "Asserting this bit will have the effect of incrementing by one the Current Read Pointer at the actual Read Data Buffer. User can manually browse through the Read Data Buffer and dump its contents. This bit will always return '0' if read by software."},
#else
{13, 13, 0x0000000000000000, "RW/1S", "ERRLOG_MOVE", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{12, 12, 0x0000000000000000, "RW", "ERRLOG_AUTO_CHNK_INC", "Signal that will allow auto-increment feature for each PMI 32bit data chunk read from the CPGC_ERRLOG_DATA register.[br] Note: If this bit is set, when doing the last PMI 32bit chunk data access via reading the CPGC_ERRLOG_DATA register, the CURR_RD_PTR will auto increment as well."},
#else
{12, 12, 0x0000000000000000, "RW", "ERRLOG_AUTO_CHNK_INC", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{5, 8, 0x0000000000000000, "RO/V", "ERROR_RD_PTR", "Provides the Read Pointer location that caused the error that triggered STOP_ON_ERROR. This will be used for knowing exactly which entry in the Read Data Buffer contains the faulty cacheline data.ValRTLSignal='dreut.configunit.CrErrLogCtl.AutoChunkInc'"},
#else
{5, 8, 0x0000000000000000, "RO/V", "ERROR_RD_PTR", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 3, 0x0000000000000000, "RO/V", "CURR_RD_PTR", "Provides the curren Read Pointer location indexed at the Read Data Buffer. This will be used for knowing how many Reads the user need to issue to return the pointer to the actual failing entry."},
#else
{0, 3, 0x0000000000000000, "RO/V", "CURR_RD_PTR", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo292[] = {{"CPGC_ERRLOG_CTL_STAT", "", 0x000002B0, 7, 0x000000000001FFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields293[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{0, 31, 0x0000000000000000, "RO/V", "ERRLOG_DATA", "32 bits of data corresponding to one of eight (or four for ANN) 32 bit PMI chunks available per Read Pointer location, If ERRLOG_AUTO_CHNK_INC is set, then each read to this register will read out a successive 32 bit PMI chunk of data."},
#else
{0, 31, 0x0000000000000000, "RO/V", "ERRLOG_DATA", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo293[] = {{"CPGC_ERRLOG_DATA", "", 0x000002B4, 1, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields294[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{1, 1, 0x0000000000000000, "RO/V", "TEST_IN_PROGRESS", "Used to indicate a loopback test is in progress"},
#else
{1, 1, 0x0000000000000000, "RO/V", "TEST_IN_PROGRESS", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 0, 0x0000000000000000, "RO/V", "ERROR_STATUS", "Bit set during the loopback test. Cleared when Local_Clear_Error is set."},
#else
{0, 0, 0x0000000000000000, "RO/V", "ERROR_STATUS", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo294[] = {{"CPGC_ERR_TEST_ERR_STAT", "", 0x000002B8, 2, 0x0000000000000003, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields295[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{28, 30, 0x0000000000000007, "RW", "L2P_RANK7_MAPPING", "Defines what physical Rank address (Memory Controller Rank Mapping) is mapped to this logical Rank address (Sequence Address Logic Domain)."},
#else
{28, 30, 0x0000000000000007, "RW", "L2P_RANK7_MAPPING", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{24, 26, 0x0000000000000006, "RW", "L2P_RANK6_MAPPING", "Defines what physical Rank address (Memory Controller Rank Mapping) is mapped to this logical Rank address (Sequence Address Logic Domain)."},
#else
{24, 26, 0x0000000000000006, "RW", "L2P_RANK6_MAPPING", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{20, 22, 0x0000000000000005, "RW", "L2P_RANK5_MAPPING", "Defines what physical Rank address (Memory Controller Rank Mapping) is mapped to this logical Rank address (Sequence Address Logic Domain)."},
#else
{20, 22, 0x0000000000000005, "RW", "L2P_RANK5_MAPPING", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{16, 18, 0x0000000000000004, "RW", "L2P_RANK4_MAPPING", "Defines what physical Rank address (Memory Controller Rank Mapping) is mapped to this logical Rank address (Sequence Address Logic Domain)."},
#else
{16, 18, 0x0000000000000004, "RW", "L2P_RANK4_MAPPING", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{12, 14, 0x0000000000000003, "RW", "L2P_RANK3_MAPPING", "Defines what physical Rank address (Memory Controller Rank Mapping) is mapped to this logical Rank address (Sequence Address Logic Domain)."},
#else
{12, 14, 0x0000000000000003, "RW", "L2P_RANK3_MAPPING", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{8, 10, 0x0000000000000002, "RW", "L2P_RANK2_MAPPING", "Defines what physical Rank address (Memory Controller Rank Mapping) is mapped to this logical Rank address (Sequence Address Logic Domain)."},
#else
{8, 10, 0x0000000000000002, "RW", "L2P_RANK2_MAPPING", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{4, 6, 0x0000000000000001, "RW", "L2P_RANK1_MAPPING", "Defines what physical Rank address (Memory Controller Rank Mapping) is mapped to this logical Rank address (Sequence Address Logic Domain)."},
#else
{4, 6, 0x0000000000000001, "RW", "L2P_RANK1_MAPPING", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 2, 0x0000000000000000, "RW", "L2P_RANK0_MAPPING", "Defines what physical Rank address (Memory Controller Rank Mapping) is mapped to this logical Rank address (Sequence Address Logic Domain)."},
#else
{0, 2, 0x0000000000000000, "RW", "L2P_RANK0_MAPPING", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo295[] = {{"CPGC_SEQ_RANK_L2P_MAPPING", "", 0x000002BC, 8, 0x000000007FFFFFFF, 0x0000000076543210}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields296[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{25, 29, 0x0000000000000005, "RW", "L2P_ROW5_SWIZZLE", "Defines how a particular Logical Row or Bank bit is remapped to a Physical Row address. The bits are essentially swizzled with each other. Bank Bits start at select value of 24. A value of 31 will select a constant '0' value."},
#else
{25, 29, 0x0000000000000005, "RW", "L2P_ROW5_SWIZZLE", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{20, 24, 0x0000000000000004, "RW", "L2P_ROW4_SWIZZLE", "Defines how a particular Logical Row or Bank bit is remapped to a Physical Row address. The bits are essentially swizzled with each other. Bank Bits start at select value of 24. A value of 31 will select a constant '0' value."},
#else
{20, 24, 0x0000000000000004, "RW", "L2P_ROW4_SWIZZLE", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{15, 19, 0x0000000000000003, "RW", "L2P_ROW3_SWIZZLE", "Defines how a particular Logical Row or Bank bit is remapped to a Physical Row address. The bits are essentially swizzled with each other. Bank Bits start at select value of 24. A value of 31 will select a constant '0' value."},
#else
{15, 19, 0x0000000000000003, "RW", "L2P_ROW3_SWIZZLE", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{10, 14, 0x0000000000000002, "RW", "L2P_ROW2_SWIZZLE", "Defines how a particular Logical Row or Bank bit is remapped to a Physical Row address. The bits are essentially swizzled with each other. Bank Bits start at select value of 24. A value of 31 will select a constant '0' value."},
#else
{10, 14, 0x0000000000000002, "RW", "L2P_ROW2_SWIZZLE", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{5, 9, 0x0000000000000001, "RW", "L2P_ROW1_SWIZZLE", "Defines how a particular Logical Row or Bank bit is remapped to a Physical Row address. The bits are essentially swizzled with each other. Bank Bits start at select value of 24. A value of 31 will select a constant '0' value."},
#else
{5, 9, 0x0000000000000001, "RW", "L2P_ROW1_SWIZZLE", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 4, 0x0000000000000000, "RW", "L2P_ROW0_SWIZZLE", "Defines how a particular Logical Row or Bank bit is remapped to a Physical Row address. The bits are essentially swizzled with each other. Bank Bits start at select value of 24. A value of 31 will select a constant '0' value."},
#else
{0, 4, 0x0000000000000000, "RW", "L2P_ROW0_SWIZZLE", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo296[] = {{"CPGC_SEQ_ROW_ADDR_SWIZZLE_A", "", 0x000002C0, 6, 0x000000003FFFFFFF, 0x000000000A418820}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields297[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{25, 29, 0x000000000000000B, "RW", "L2P_ROW11_SWIZZLE", "Defines how a particular Logical Row or Bank bit is remapped to a Physical Row address. The bits are essentially swizzled with each other. Bank Bits start at select value of 24. A value of 31 will select a constant '0' value."},
#else
{25, 29, 0x000000000000000B, "RW", "L2P_ROW11_SWIZZLE", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{20, 24, 0x000000000000000A, "RW", "L2P_ROW10_SWIZZLE", "Defines how a particular Logical Row or Bank bit is remapped to a Physical Row address. The bits are essentially swizzled with each other. Bank Bits start at select value of 24. A value of 31 will select a constant '0' value."},
#else
{20, 24, 0x000000000000000A, "RW", "L2P_ROW10_SWIZZLE", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{15, 19, 0x0000000000000009, "RW", "L2P_ROW9_SWIZZLE", "Defines how a particular Logical Row or Bank bit is remapped to a Physical Row address. The bits are essentially swizzled with each other. Bank Bits start at select value of 24. A value of 31 will select a constant '0' value."},
#else
{15, 19, 0x0000000000000009, "RW", "L2P_ROW9_SWIZZLE", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{10, 14, 0x0000000000000008, "RW", "L2P_ROW8_SWIZZLE", "Defines how a particular Logical Row or Bank bit is remapped to a Physical Row address. The bits are essentially swizzled with each other. Bank Bits start at select value of 24. A value of 31 will select a constant '0' value."},
#else
{10, 14, 0x0000000000000008, "RW", "L2P_ROW8_SWIZZLE", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{5, 9, 0x0000000000000007, "RW", "L2P_ROW7_SWIZZLE", "Defines how a particular Logical Row or Bank bit is remapped to a Physical Row address. The bits are essentially swizzled with each other. Bank Bits start at select value of 24. A value of 31 will select a constant '0' value."},
#else
{5, 9, 0x0000000000000007, "RW", "L2P_ROW7_SWIZZLE", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 4, 0x0000000000000006, "RW", "L2P_ROW6_SWIZZLE", "Defines how a particular Logical Row or Bank bit is remapped to a Physical Row address. The bits are essentially swizzled with each other. Bank Bits start at select value of 24. A value of 31 will select a constant '0' value."},
#else
{0, 4, 0x0000000000000006, "RW", "L2P_ROW6_SWIZZLE", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo297[] = {{"CPGC_SEQ_ROW_ADDR_SWIZZLE_B", "", 0x000002C4, 6, 0x000000003FFFFFFF, 0x0000000016A4A0E6}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields298[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{25, 29, 0x0000000000000011, "RW", "L2P_ROW17_SWIZZLE", "Defines how a particular Logical Row or Bank bit is remapped to a Physical Row address. The bits are essentially swizzled with each other. Bank Bits start at select value of 24. A value of 31 will select a constant '0' value."},
#else
{25, 29, 0x0000000000000011, "RW", "L2P_ROW17_SWIZZLE", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{20, 24, 0x0000000000000010, "RW", "L2P_ROW16_SWIZZLE", "Defines how a particular Logical Row or Bank bit is remapped to a Physical Row address. The bits are essentially swizzled with each other. Bank Bits start at select value of 24. A value of 31 will select a constant '0' value."},
#else
{20, 24, 0x0000000000000010, "RW", "L2P_ROW16_SWIZZLE", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{15, 19, 0x000000000000000F, "RW", "L2P_ROW15_SWIZZLE", "Defines how a particular Logical Row or Bank bit is remapped to a Physical Row address. The bits are essentially swizzled with each other. Bank Bits start at select value of 24. A value of 31 will select a constant '0' value."},
#else
{15, 19, 0x000000000000000F, "RW", "L2P_ROW15_SWIZZLE", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{10, 14, 0x000000000000000E, "RW", "L2P_ROW14_SWIZZLE", "Defines how a particular Logical Row or Bank bit is remapped to a Physical Row address. The bits are essentially swizzled with each other. Bank Bits start at select value of 24. A value of 31 will select a constant '0' value."},
#else
{10, 14, 0x000000000000000E, "RW", "L2P_ROW14_SWIZZLE", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{5, 9, 0x000000000000000D, "RW", "L2P_ROW13_SWIZZLE", "Defines how a particular Logical Row or Bank bit is remapped to a Physical Row address. The bits are essentially swizzled with each other. Bank Bits start at select value of 24. A value of 31 will select a constant '0' value."},
#else
{5, 9, 0x000000000000000D, "RW", "L2P_ROW13_SWIZZLE", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 4, 0x000000000000000C, "RW", "L2P_ROW12_SWIZZLE", "Defines how a particular Logical Row or Bank bit is remapped to a Physical Row address. The bits are essentially swizzled with each other. Bank Bits start at select value of 24. A value of 31 will select a constant '0' value."},
#else
{0, 4, 0x000000000000000C, "RW", "L2P_ROW12_SWIZZLE", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo298[] = {{"CPGC_SEQ_ROW_ADDR_SWIZZLE_C", "", 0x000002C8, 6, 0x000000003FFFFFFF, 0x000000002307B9AC}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields299[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{28, 31, 0x0000000000000007, "RW", "L2P_BANK7_MAPPING", "Defines what physical Bank address (Memory Controller Bank Mapping) is mapped to this logical Bank address (Sequence Address Logic Domain)."},
#else
{28, 31, 0x0000000000000007, "RW", "L2P_BANK7_MAPPING", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{24, 27, 0x0000000000000006, "RW", "L2P_BANK6_MAPPING", "Defines what physical Bank address (Memory Controller Bank Mapping) is mapped to this logical Bank address (Sequence Address Logic Domain)."},
#else
{24, 27, 0x0000000000000006, "RW", "L2P_BANK6_MAPPING", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{20, 23, 0x0000000000000005, "RW", "L2P_BANK5_MAPPING", "Defines what physical Bank address (Memory Controller Bank Mapping) is mapped to this logical Bank address (Sequence Address Logic Domain)."},
#else
{20, 23, 0x0000000000000005, "RW", "L2P_BANK5_MAPPING", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{16, 19, 0x0000000000000004, "RW", "L2P_BANK4_MAPPING", "Defines what physical Bank address (Memory Controller Bank Mapping) is mapped to this logical Bank address (Sequence Address Logic Domain)."},
#else
{16, 19, 0x0000000000000004, "RW", "L2P_BANK4_MAPPING", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{12, 15, 0x0000000000000003, "RW", "L2P_BANK3_MAPPING", "Defines what physical Bank address (Memory Controller Bank Mapping) is mapped to this logical Bank address (Sequence Address Logic Domain)."},
#else
{12, 15, 0x0000000000000003, "RW", "L2P_BANK3_MAPPING", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{8, 11, 0x0000000000000002, "RW", "L2P_BANK2_MAPPING", "Defines what physical Bank address (Memory Controller Bank Mapping) is mapped to this logical Bank address (Sequence Address Logic Domain)."},
#else
{8, 11, 0x0000000000000002, "RW", "L2P_BANK2_MAPPING", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{4, 7, 0x0000000000000001, "RW", "L2P_BANK1_MAPPING", "Defines what physical Bank address (Memory Controller Bank Mapping) is mapped to this logical Bank address (Sequence Address Logic Domain)."},
#else
{4, 7, 0x0000000000000001, "RW", "L2P_BANK1_MAPPING", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 3, 0x0000000000000000, "RW", "L2P_BANK0_MAPPING", "Defines what physical Bank address (Memory Controller Bank Mapping) is mapped to this logical Bank address (Sequence Address Logic Domain)."},
#else
{0, 3, 0x0000000000000000, "RW", "L2P_BANK0_MAPPING", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo299[] = {{"CPGC_SEQ_BANK_L2P_MAPPING_A", "", 0x000002CC, 8, 0x00000000FFFFFFFF, 0x0000000076543210}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields300[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{28, 31, 0x000000000000000F, "RW", "L2P_BANK15_MAPPING", "Defines what physical Bank address (Memory Controller Bank Mapping) is mapped to this logical Bank address (Sequence Address Logic Domain)."},
#else
{28, 31, 0x000000000000000F, "RW", "L2P_BANK15_MAPPING", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{24, 27, 0x000000000000000E, "RW", "L2P_BANK14_MAPPING", "Defines what physical Bank address (Memory Controller Bank Mapping) is mapped to this logical Bank address (Sequence Address Logic Domain)."},
#else
{24, 27, 0x000000000000000E, "RW", "L2P_BANK14_MAPPING", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{20, 23, 0x000000000000000D, "RW", "L2P_BANK13_MAPPING", "Defines what physical Bank address (Memory Controller Bank Mapping) is mapped to this logical Bank address (Sequence Address Logic Domain)."},
#else
{20, 23, 0x000000000000000D, "RW", "L2P_BANK13_MAPPING", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{16, 19, 0x000000000000000C, "RW", "L2P_BANK12_MAPPING", "Defines what physical Bank address (Memory Controller Bank Mapping) is mapped to this logical Bank address (Sequence Address Logic Domain)."},
#else
{16, 19, 0x000000000000000C, "RW", "L2P_BANK12_MAPPING", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{12, 15, 0x000000000000000B, "RW", "L2P_BANK11_MAPPING", "Defines what physical Bank address (Memory Controller Bank Mapping) is mapped to this logical Bank address (Sequence Address Logic Domain)."},
#else
{12, 15, 0x000000000000000B, "RW", "L2P_BANK11_MAPPING", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{8, 11, 0x000000000000000A, "RW", "L2P_BANK10_MAPPING", "Defines what physical Bank address (Memory Controller Bank Mapping) is mapped to this logical Bank address (Sequence Address Logic Domain)."},
#else
{8, 11, 0x000000000000000A, "RW", "L2P_BANK10_MAPPING", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{4, 7, 0x0000000000000009, "RW", "L2P_BANK9_MAPPING", "Defines what physical Bank address (Memory Controller Bank Mapping) is mapped to this logical Bank address (Sequence Address Logic Domain)."},
#else
{4, 7, 0x0000000000000009, "RW", "L2P_BANK9_MAPPING", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 3, 0x0000000000000008, "RW", "L2P_BANK8_MAPPING", "Defines what physical Bank address (Memory Controller Bank Mapping) is mapped to this logical Bank address (Sequence Address Logic Domain)."},
#else
{0, 3, 0x0000000000000008, "RW", "L2P_BANK8_MAPPING", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo300[] = {{"CPGC_SEQ_BANK_L2P_MAPPING_B", "", 0x000002D0, 8, 0x00000000FFFFFFFF, 0x00000000FEDCBA98}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields301[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{15, 19, 0x000000000000001F, "RW", "L2P_ROW3_XOR_SWIZZLE", "Row XOR source selection for lower order Row addresses. Select 31 if only using a direct mapping with no XOR."},
#else
{15, 19, 0x000000000000001F, "RW", "L2P_ROW3_XOR_SWIZZLE", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{10, 14, 0x000000000000001F, "RW", "L2P_ROW2_XOR_SWIZZLE", "Row XOR source selection for lower order Row addresses. Select 31 if only using a direct mapping with no XOR."},
#else
{10, 14, 0x000000000000001F, "RW", "L2P_ROW2_XOR_SWIZZLE", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{5, 9, 0x000000000000001F, "RW", "L2P_ROW1_XOR_SWIZZLE", "Row XOR source selection for lower order Row addresses. Select 31 if only using a direct mapping with no XOR."},
#else
{5, 9, 0x000000000000001F, "RW", "L2P_ROW1_XOR_SWIZZLE", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 4, 0x000000000000001F, "RW", "L2P_ROW0_XOR_SWIZZLE", "Row XOR source selection for lower order Row addresses. Select 31 if only using a direct mapping with no XOR. Bank Bits start at select value of 24. A value of 31 will select a constant '0' value."},
#else
{0, 4, 0x000000000000001F, "RW", "L2P_ROW0_XOR_SWIZZLE", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo301[] = {{"CPGC_SEQ_ROW_ADDR_SWIZZLE_X", "", 0x000002D4, 4, 0x00000000000FFFFF, 0x00000000000FFFFF}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields302[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{15, 19, 0x000000000000001B, "RW", "L2P_BANK3_SWIZZLE", "Defines how a particular Logical Row or Bank bit is remapped to a Physical Bank address. The bits are essentially swizzled with each other. Bank Bits start at select value of 24. A value of 31 will select a constant '0' value."},
#else
{15, 19, 0x000000000000001B, "RW", "L2P_BANK3_SWIZZLE", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{10, 14, 0x000000000000001A, "RW", "L2P_BANK2_SWIZZLE", "Defines how a particular Logical Row or Bank bit is remapped to a Physical Bank address. The bits are essentially swizzled with each other."},
#else
{10, 14, 0x000000000000001A, "RW", "L2P_BANK2_SWIZZLE", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{5, 9, 0x0000000000000019, "RW", "L2P_BANK1_SWIZZLE", "Defines how a particular Logical Row or Bank bit is remapped to a Physical Bank address. The bits are essentially swizzled with each other."},
#else
{5, 9, 0x0000000000000019, "RW", "L2P_BANK1_SWIZZLE", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 4, 0x0000000000000018, "RW", "L2P_BANK0_SWIZZLE", "Defines how a particular Logical Row or Bank bit is remapped to a Physical Bank address. The bits are essentially swizzled with each other."},
#else
{0, 4, 0x0000000000000018, "RW", "L2P_BANK0_SWIZZLE", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo302[] = {{"CPGC_SEQ_BANK_ADDR_SWIZZLE", "", 0x000002D8, 4, 0x00000000000FFFFF, 0x00000000000DEB38}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields303[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{28, 31, 0x0000000000000006, "RW", "L2P_COL6_SWIZZLE", "Defines how a particular Logical COL bit is remapped to a Physical COL address. The bits are essentially swizzled with each other."},
#else
{28, 31, 0x0000000000000006, "RW", "L2P_COL6_SWIZZLE", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{24, 27, 0x0000000000000005, "RW", "L2P_COL5_SWIZZLE", "Defines how a particular Logical COL bit is remapped to a Physical COL address. The bits are essentially swizzled with each other."},
#else
{24, 27, 0x0000000000000005, "RW", "L2P_COL5_SWIZZLE", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{20, 23, 0x0000000000000004, "RW", "L2P_COL4_SWIZZLE", "Defines how a particular Logical COL bit is remapped to a Physical COL address. The bits are essentially swizzled with each other."},
#else
{20, 23, 0x0000000000000004, "RW", "L2P_COL4_SWIZZLE", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{16, 19, 0x0000000000000003, "RW", "L2P_COL3_SWIZZLE", "Defines how a particular Logical COL bit is remapped to a Physical COL address. The bits are essentially swizzled with each other."},
#else
{16, 19, 0x0000000000000003, "RW", "L2P_COL3_SWIZZLE", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{12, 15, 0x0000000000000002, "RW", "L2P_COL2_SWIZZLE", "Defines how a particular Logical COL bit is remapped to a Physical COL address. The bits are essentially swizzled with each other."},
#else
{12, 15, 0x0000000000000002, "RW", "L2P_COL2_SWIZZLE", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{8, 11, 0x0000000000000001, "RW", "L2P_COL1_SWIZZLE", "Defines how a particular Logical COL bit is remapped to a Physical COL address. The bits are essentially swizzled with each other."},
#else
{8, 11, 0x0000000000000001, "RW", "L2P_COL1_SWIZZLE", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{4, 7, 0x0000000000000000, "RW", "L2P_COL0_SWIZZLE", "Defines how a particular Logical COL bit is remapped to a Physical COL address. The bits are essentially swizzled with each other."},
#else
{4, 7, 0x0000000000000000, "RW", "L2P_COL0_SWIZZLE", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo303[] = {{"CPGC_SEQ_COL_ADDR_SWIZZLE_A", "", 0x000002DC, 7, 0x00000000FFFFFFFF, 0x0000000065432100}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields304[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{4, 7, 0x0000000000000008, "RW", "L2P_COL8_SWIZZLE", "Defines how a particular Logical COL bit is remapped to a Physical COL address. The bits are essentially swizzled with each other."},
#else
{4, 7, 0x0000000000000008, "RW", "L2P_COL8_SWIZZLE", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 3, 0x0000000000000007, "RW", "L2P_COL7_SWIZZLE", "Defines how a particular Logical COL bit is remapped to a Physical COL address. The bits are essentially swizzled with each other."},
#else
{0, 3, 0x0000000000000007, "RW", "L2P_COL7_SWIZZLE", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo304[] = {{"CPGC_SEQ_COL_ADDR_SWIZZLE_B", "", 0x000002E0, 2, 0x00000000000000FF, 0x0000000000000087}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields305[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{24, 29, 0x0000000000000000, "RW", "PMI_ADDR_LOC_15", "N/A"},
#else
{24, 29, 0x0000000000000000, "RW", "PMI_ADDR_LOC_15", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{18, 23, 0x0000000000000000, "RW", "PMI_ADDR_LOC_14", "N/A"},
#else
{18, 23, 0x0000000000000000, "RW", "PMI_ADDR_LOC_14", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{12, 17, 0x0000000000000000, "RW", "PMI_ADDR_LOC_13", "N/A"},
#else
{12, 17, 0x0000000000000000, "RW", "PMI_ADDR_LOC_13", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{6, 11, 0x0000000000000000, "RW", "PMI_ADDR_LOC_12", "N/A"},
#else
{6, 11, 0x0000000000000000, "RW", "PMI_ADDR_LOC_12", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 5, 0x0000000000000000, "RW", "PMI_ADDR_LOC_11", "[5:4]=address field, [3:0]=address_bit"},
#else
{0, 5, 0x0000000000000000, "RW", "PMI_ADDR_LOC_11", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo305[] = {{"CPGC_PHY_TO_PMI_ADDR_MAP0", "", 0x000002E4, 5, 0x000000003FFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields306[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{24, 29, 0x0000000000000000, "RW", "PMI_ADDR_LOC_28", "N/A"},
#else
{24, 29, 0x0000000000000000, "RW", "PMI_ADDR_LOC_28", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{18, 23, 0x0000000000000000, "RW", "PMI_ADDR_LOC_27", "N/A"},
#else
{18, 23, 0x0000000000000000, "RW", "PMI_ADDR_LOC_27", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{12, 17, 0x0000000000000000, "RW", "PMI_ADDR_LOC_26", "N/A"},
#else
{12, 17, 0x0000000000000000, "RW", "PMI_ADDR_LOC_26", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{6, 11, 0x0000000000000000, "RW", "PMI_ADDR_LOC_25", "N/A"},
#else
{6, 11, 0x0000000000000000, "RW", "PMI_ADDR_LOC_25", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 5, 0x0000000000000000, "RW", "PMI_ADDR_LOC_24", "N/A"},
#else
{0, 5, 0x0000000000000000, "RW", "PMI_ADDR_LOC_24", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo306[] = {{"CPGC_PHY_TO_PMI_ADDR_MAP1", "", 0x000002E8, 5, 0x000000003FFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields307[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{24, 29, 0x0000000000000000, "RW", "PMI_ADDR_LOC_33", "N/A"},
#else
{24, 29, 0x0000000000000000, "RW", "PMI_ADDR_LOC_33", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{18, 23, 0x0000000000000000, "RW", "PMI_ADDR_LOC_32", "N/A"},
#else
{18, 23, 0x0000000000000000, "RW", "PMI_ADDR_LOC_32", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{12, 17, 0x0000000000000000, "RW", "PMI_ADDR_LOC_31", "N/A"},
#else
{12, 17, 0x0000000000000000, "RW", "PMI_ADDR_LOC_31", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{6, 11, 0x0000000000000000, "RW", "PMI_ADDR_LOC_30", "N/A"},
#else
{6, 11, 0x0000000000000000, "RW", "PMI_ADDR_LOC_30", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 5, 0x0000000000000000, "RW", "PMI_ADDR_LOC_29", "N/A"},
#else
{0, 5, 0x0000000000000000, "RW", "PMI_ADDR_LOC_29", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo307[] = {{"CPGC_PHY_TO_PMI_ADDR_MAP2", "", 0x000002EC, 5, 0x000000003FFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields308[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{5, 5, 0x0000000000000000, "RO/V", "DSLCT_TRIGGER", "If set, the CADB implementation supports means to trigger deselect packets after (or in between) certain user defined DDR/LPDDRcommands."},
#else
{5, 5, 0x0000000000000000, "RO/V", "DSLCT_TRIGGER", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{4, 4, 0x0000000000000000, "RO/V", "MRS_CMDS", "The CADB block supports linear walking of the Buffer with a fixed delay in between selecting new buffer entries."},
#else
{4, 4, 0x0000000000000000, "RO/V", "MRS_CMDS", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{3, 3, 0x0000000000000000, "RO/V", "UNISEQ_WIDTH_CAP", "The Unified Sequencer Width supported for command/address pattern generation is encoded as follows:[br][br]\r\n"
"0 - 16-bit[br][br]\r\n"
"1 - 32-bit."},
#else
{3, 3, 0x0000000000000000, "RO/V", "UNISEQ_WIDTH_CAP", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 1, 0x0000000000000000, "RO/V", "NUM_UNISEQ_CAP", "The number of unified sequencers supported for command/address pattern generation is encoded as follows:[br][br]\r\n"
"01 - 2 Unified Sequencers[br][br]\r\n"
"10 - 3 Unified Sequencers[br][br]\r\n"
"11 - 4 Unified Sequencers[br][br]\r\n"
"All other values are reserved for future use."},
#else
{0, 1, 0x0000000000000000, "RO/V", "NUM_UNISEQ_CAP", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo308[] = {{"CPGC_CADB_CAP", "", 0x000002F0, 4, 0x000000000000003F, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields309[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{31, 31, 0x0000000000000000, "RW", "CMD_DESELECT_STALL", "N/A"},
#else
{31, 31, 0x0000000000000000, "RW", "CMD_DESELECT_STALL", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{29, 29, 0x0000000000000000, "RW", "CMD_DESELECT_RESTART", "If set, the CADB pattern will reload each time the chosen CMD_DESELECT_START condition is met. Please refer to CMD_DESLECT_START field for more info"},
#else
{29, 29, 0x0000000000000000, "RW", "CMD_DESELECT_RESTART", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{24, 27, 0x0000000000000000, "RW", "RELOAD_STARTING_SEED", "Reload_Starting_Seed will reload the 16bit CADB unisequencer starting seeds for LFSR/PB engines used for Select and Deselect chunk choosing to current seeds synchronous with particular commands (PRE/ACT/RD/WR) that are indicated to cause the reload to happen.  The reload seed must be used as the CADB output in the same cycle as the command which causes the reload to happen.[br][br]\r\n"
"Setting Bit 24 - Reload the starting seed to current seed on WR.[br][br]\r\n"
"Setting Bit 25 - Reload the starting seed to current seed on RD.[br][br]\r\n"
"Setting Bit 26 - Reload the starting seed to current seed on ACT.[br][br]\r\n"
"Setting Bit 27 - Reload the starting seed to current seed on PR."},
#else
{24, 27, 0x0000000000000000, "RW", "RELOAD_STARTING_SEED", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{20, 23, 0x0000000000000000, "RW", "SAVE_CURRENT_SEED", "Save_Current_Seed when qualified with Subsequence_Deselect_Save_Enable from REUT engine indicates which command triggers saving the current LFSR/PB values for Select and Deselect logic to the starting seed copy.[br][br]\r\n"
"Setting Bit 20 - Save the current seed to starting seed on WR.[br][br]\r\n"
"Setting Bit 21 - Save the current seed to starting seed on RD.[br][br]\r\n"
"Setting Bit 22 - Save the current seed to starting seed on ACT.[br][br]\r\n"
"Setting Bit 23 - Save the current seed to starting seed on PR."},
#else
{20, 23, 0x0000000000000000, "RW", "SAVE_CURRENT_SEED", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{18, 19, 0x0000000000000000, "RW", "PRE_SELECT_ENABLE", "PRE_Select_Enable will drive the CADB during all ACT CMD Select cycles on selected pins that are enabled based on the description below.[br][br]\r\n"
"Setting Bit 18 - Drive CADB during a PRE for MA except AP bit.[br][br]\r\n"
"Setting Bit 19 - Drive CADB during a PRE for BA[br]\r\n"
""},
#else
{18, 19, 0x0000000000000000, "RW", "PRE_SELECT_ENABLE", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{16, 17, 0x0000000000000000, "RW", "ACT_SELECT_ENABLE", "ACT_Select_Enable will drive the CADB during all ACT CMD Select cycles on selected pins that are enabled based on the description below.[br][br]\r\n"
"Setting Bit 16 - Drive CADB during a ACT for MA.[br][br]\r\n"
"Setting Bit 17 - Drive CADB during a ACT for BA.[br]\r\n"
""},
#else
{16, 17, 0x0000000000000000, "RW", "ACT_SELECT_ENABLE", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{14, 15, 0x0000000000000000, "RW", "CAS_SELECT_ENABLE", "CAS_Select_Enable will drive the CADB during all CAS CMD Select cycles on selected pins that are enabled based on the description below.[br][br]\r\n"
"Setting Bit 14 - Drive CADB during a CAS for MA [11] and MA [9:0].[br][br]\r\n"
"Setting Bit 15 - Drive CADB during a CAS for BA.[br][br]\r\n"
""},
#else
{14, 15, 0x0000000000000000, "RW", "CAS_SELECT_ENABLE", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{10, 13, 0x0000000000000000, "RW", "LANE_DESELECT_EN", "Setting Bit 24 - Drive CADB on Deselects on MA.[br][br]\r\n"
"Setting Bit 25 - Drive CADB on Deselects on BA.[br][br]\r\n"
"Setting Bit 26 - Drive CADB on Deselects on CMD.[br][br]\r\n"
"Setting Bit 27 - Drive CADB on Deselects on CS.[br][br]\r\n"
"Note: If CS is set than and CADB entry that also has CS set to one, the logic overrides CMD signals w/NOP encoding, thus making CMD and CS mutually exclusive to ensure no DDR functional violations occur."},
#else
{10, 13, 0x0000000000000000, "RW", "LANE_DESELECT_EN", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{6, 9, 0x0000000000000000, "RW", "CMD_DESELECT_STOP", "Setting Bit 20 - Stop Driving Deselects on the following cycle after a WR CMD if Deselects where transmitting beforehand.[br][br]\r\n"
"Setting Bit 21 - Stop Driving Deselects on the following cycle after a RD CMD if Deselects where transmitting beforehand.[br][br]\r\n"
"Setting Bit 22 - Stop Driving Deselects on the following cycle after a ACT CMD if Deselects where transmitting beforehand.[br][br]\r\n"
"Setting Bit 23 - Stop Driving Deselects on the following cycle after a PRE CMD if Deselects where transmitting beforehand.[br][br]\r\n"
"Note: If Deselect was off before the command that is supposed to stop it, it will remain in the off state."},
#else
{6, 9, 0x0000000000000000, "RW", "CMD_DESELECT_STOP", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{2, 5, 0x0000000000000000, "RW", "CMD_DESELECT_START", "Setting Bit 16 - Start Driving Deselects on the following cycle after a WR CMD if CADB_Deselect_Enable is high.[br][br]\r\n"
"Setting Bit 17 - Start Driving Deselects on the following cycle after a RD CMD if CADB_Deselect_Enable is high.[br][br]\r\n"
"Setting Bit 18 - Start Driving Deselects on the following cycle after a ACT CMD if CADB_Deselect_Enable is high.[br][br]\r\n"
"Setting Bit 19 - Start Driving Deselects on the following cycle after a PRE CMD if CADB_Deselect_Enable is high.[br]"},
#else
{2, 5, 0x0000000000000000, "RW", "CMD_DESELECT_START", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 1, 0x0000000000000000, "RW", "CADB_MODE", "The operation mode of the command/address pattern generator is encoded as follows:[br][br]\r\n"
"00 - Sequencer and CAS command Driven: Same as Global Deselect though in this mode determinism is enforced as now CADB valid deselect patterns will depend on the values programmed on Lane_Deselect_Enable and CMD_Deselect_Enable thus allowing Deselect to synchronize with various CMD events and Subsequence control bits.[br][br]\r\n"
"01 - Global Deselect: Pattern stored in the command/address buffers will be driven on the bus during deselect cycles only whenever SoC CPGC is in ACTIVE or NORMAL modes.  SoC CPGC will drive out the pattern stored in the command/address buffers on all command and address signals (except CKE, and ODT). User can chose which ADDRESS/CMD lanes to be enabled in this mode. CS is special refert to it in LANE_DESELECT_EN .[br][br]\r\n"
"10 - Always On: Pattern stored in the command/address buffers will be driven on all command and address signals on every DCLK cycle only if SoC CPGC is in ACTIVE mode.  This is not a functional mode and should only be used for BDV purposes.[br][br]\r\n"
"11 - RESERVED:"},
#else
{0, 1, 0x0000000000000000, "RW", "CADB_MODE", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo309[] = {{"CPGC_CADB_CTL", "", 0x000002F4, 11, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields310[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{28, 29, 0x0000000000000000, "RW", "MRS_CS_MODE", "Only if it is set to 0 it will be deaserted at (1 or 2 cycles) number of cycles at the middle of Gap CS is selected per entry and per rank[br][br]\r\n"
"00 - No Override[br][br]\r\n"
"01 - No Override[br][br]\r\n"
"10 - One Cycle CS[br][br]\r\n"
"11 - Two Cycles CS"},
#else
{28, 29, 0x0000000000000000, "RW", "MRS_CS_MODE", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{24, 26, 0x0000000000000007, "RO/V", "MRS_CURR_PTR", "TODO"},
#else
{24, 26, 0x0000000000000007, "RO/V", "MRS_CURR_PTR", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{16, 18, 0x0000000000000007, "RW", "MRS_END_PTR", "Pointer to the last CADB entry to be used if on MRS mode[br] Note: This indexing mode of the CADB buffer is only available if in CPGC_SEQ_CFG_0.INITIALIZATION_MODE=MRS_MODE"},
#else
{16, 18, 0x0000000000000007, "RW", "MRS_END_PTR", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{8, 10, 0x0000000000000000, "RW", "MRS_START_PTR", "Pointer to the first CADB entry to be used if on MRS mode[br] Note: This indexing mode of the CADB buffer is only available if in CPGC_SEQ_CFG_0.INITIALIZATION_MODE=MRS_MODE"},
#else
{8, 10, 0x0000000000000000, "RW", "MRS_START_PTR", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{4, 4, 0x0000000000000000, "RW", "MRS_GAP_SCALE", "Linear or Exponential Scale for CADB_GAP value.[br]\r\n"
"[b]Note: This is not implemented in Reference RTL yet. [/b]]"},
#else
{4, 4, 0x0000000000000000, "RW", "MRS_GAP_SCALE", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 3, 0x0000000000000000, "RW", "MRS_GAP", "2^(MRS_GAP) clock cycles between changing to the next MRS CADB entry. Value Zero is prohibited[br] Note: This GAP is applicable to both, MRS mode or normal CADB pattern gen. When used for non MRS CADB pattern generation a value of Zero is allowed"},
#else
{0, 3, 0x0000000000000000, "RW", "MRS_GAP", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo310[] = {{"CPGC_CADB_MRSCFG", "", 0x000002F8, 6, 0x000000003FFFFFFF, 0x0000000007070000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields311[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{24, 25, 0x0000000000000001, "RW", "SEL_UNISEQ2_MODE", "Defines the operational mode for select unified sequence 2 as follows:[br][br]\r\n"
"00 - Reserved for future use[br][br]\r\n"
"01 - Pattern Buffer Mode[br][br]\r\n"
"10 - LFSR Mode[br][br]\r\n"
"11 - Reserved for future use"},
#else
{24, 25, 0x0000000000000001, "RW", "SEL_UNISEQ2_MODE", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{20, 21, 0x0000000000000001, "RW", "SEL_UNISEQ1_MODE", "Defines the operational mode for select unified sequence 1 as follows:[br][br]\r\n"
"00 - Reserved for future use[br][br]\r\n"
"01 - Pattern Buffer Mode[br][br]\r\n"
"10 - LFSR Mode[br][br]\r\n"
"11 - Reserved for future use"},
#else
{20, 21, 0x0000000000000001, "RW", "SEL_UNISEQ1_MODE", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{16, 17, 0x0000000000000001, "RW", "SEL_UNISEQ0_MODE", "Defines the operational mode for select unified sequence 0 as follows:[br][br]\r\n"
"00 - Reserved for future use[br][br]\r\n"
"01 - Pattern Buffer Mode[br][br]\r\n"
"10 - LFSR Mode[br][br]\r\n"
"11 - Reserved for future use"},
#else
{16, 17, 0x0000000000000001, "RW", "SEL_UNISEQ0_MODE", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{8, 9, 0x0000000000000001, "RW", "UNISEQ2_MODE", "Defines the operational mode for unified sequence 2 as follows:[br][br]\r\n"
"00 - LMN Mode[br][br]\r\n"
"01 - Pattern Buffer Mode[br][br]\r\n"
"10 - LFSR Mode[br][br]\r\n"
"11 - Reserved for future use"},
#else
{8, 9, 0x0000000000000001, "RW", "UNISEQ2_MODE", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{4, 5, 0x0000000000000001, "RW", "UNISEQ1_MODE", "Defines the operational mode for unified sequence 1 as follows:[br][br]\r\n"
"00 - LMN Mode[br][br]\r\n"
"01 - Pattern Buffer Mode[br][br]\r\n"
"10 - LFSR Mode[br][br]\r\n"
"11 - Reserved for future use"},
#else
{4, 5, 0x0000000000000001, "RW", "UNISEQ1_MODE", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 1, 0x0000000000000001, "RW", "UNISEQ0_MODE", "Defines the operational mode for unified sequence 0 as follows:[br][br]\r\n"
"00 - LMN Mode[br][br]\r\n"
"01 - Pattern Buffer Mode[br][br]\r\n"
"10 - LFSR Mode[br][br]\r\n"
"11 - Reserved for future use"},
#else
{0, 1, 0x0000000000000001, "RW", "UNISEQ0_MODE", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo311[] = {{"CPGC_CADB_CFG", "", 0x000002FC, 6, 0x0000000003FFFFFF, 0x0000000001110111}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields312[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{0, 15, 0x000000000000AA55, "RW", "CMD", "The initial content of the rotating pattern buffer for the unified sequencer."},
#else
{0, 15, 0x000000000000AA55, "RW", "CMD", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo312[] = {{"CPGC_CADB_UNISEQ0_PBUF", "", 0x00000300, 1, 0x000000000000FFFF, 0x000000000000AA55}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields313[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{0, 15, 0x000000000000AA55, "RW", "CMD", "The initial content of the rotating pattern buffer for the unified sequencer."},
#else
{0, 15, 0x000000000000AA55, "RW", "CMD", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo313[] = {{"CPGC_CADB_UNISEQ1_PBUF", "", 0x00000304, 1, 0x000000000000FFFF, 0x000000000000AA55}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields314[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{0, 15, 0x000000000000AA55, "RW", "CMD", "The initial content of the rotating pattern buffer for the unified sequencer."},
#else
{0, 15, 0x000000000000AA55, "RW", "CMD", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo314[] = {{"CPGC_CADB_UNISEQ2_PBUF", "", 0x00000308, 1, 0x000000000000FFFF, 0x000000000000AA55}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields315[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{24, 26, 0x0000000000000005, "RW", "M_CNT", "Number of UIs that the unisequencer will drive logic '1'."},
#else
{24, 26, 0x0000000000000005, "RW", "M_CNT", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{16, 18, 0x0000000000000002, "RW", "N_CNT", "Number of UIs that the unisequencer will drive logic '0'."},
#else
{16, 18, 0x0000000000000002, "RW", "N_CNT", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{8, 10, 0x0000000000000004, "RW", "L_CNT", "Number of UIs that the unisequencer will drive the logic value selected through L_SEL before entering the steady state periodic phase."},
#else
{8, 10, 0x0000000000000004, "RW", "L_CNT", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{4, 6, 0x0000000000000005, "RW", "CNT_SCALE", "Values for L_CNT, M_CNT, and N_CNT are scaled by a factor of 2^CNT_SCALE."},
#else
{4, 6, 0x0000000000000005, "RW", "CNT_SCALE", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{1, 1, 0x0000000000000000, "RW", "EN_SWEEP_FREQ", "0 - Disable Sweep Frequency. 1 - Enable Sweep Frequency. [br][br]\r\n"
"[b]Note: This is not implemented in Reference RTL yet. [/b]]"},
#else
{1, 1, 0x0000000000000000, "RW", "EN_SWEEP_FREQ", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 0, 0x0000000000000001, "RW", "L_SEL", "The initial logic output of the sequencer is defined as follows:[br][br]\r\n"
"                        0 - Output Logic '0' for L_CNT UIs[br][br]\r\n"
"                        1 - Output Logic '1' for L_CNT UIs"},
#else
{0, 0, 0x0000000000000001, "RW", "L_SEL", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo315[] = {{"CPGC_CADB_UNISEQ0_LMN", "", 0x0000030C, 6, 0x0000000007FFFFFF, 0x0000000005020451}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields316[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{24, 26, 0x0000000000000005, "RW", "M_CNT", "Number of UIs that the unisequencer will drive logic '1'."},
#else
{24, 26, 0x0000000000000005, "RW", "M_CNT", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{16, 18, 0x0000000000000002, "RW", "N_CNT", "Number of UIs that the unisequencer will drive logic '0'."},
#else
{16, 18, 0x0000000000000002, "RW", "N_CNT", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{8, 10, 0x0000000000000004, "RW", "L_CNT", "Number of UIs that the unisequencer will drive the logic value selected through L_SEL before entering the steady state periodic phase."},
#else
{8, 10, 0x0000000000000004, "RW", "L_CNT", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{4, 6, 0x0000000000000005, "RW", "CNT_SCALE", "Values for L_CNT, M_CNT, and N_CNT are scaled by a factor of 2^CNT_SCALE."},
#else
{4, 6, 0x0000000000000005, "RW", "CNT_SCALE", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{1, 1, 0x0000000000000000, "RW", "EN_SWEEP_FREQ", "0 - Disable Sweep Frequency. 1 - Enable Sweep Frequency. [br][br]\r\n"
"[b]Note: This is not implemented in Reference RTL yet. [/b]]"},
#else
{1, 1, 0x0000000000000000, "RW", "EN_SWEEP_FREQ", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 0, 0x0000000000000001, "RW", "L_SEL", "The initial logic output of the sequencer is defined as follows:[br][br]\r\n"
"                        0 - Output Logic '0' for L_CNT UIs[br][br]\r\n"
"                        1 - Output Logic '1' for L_CNT UIs"},
#else
{0, 0, 0x0000000000000001, "RW", "L_SEL", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo316[] = {{"CPGC_CADB_UNISEQ1_LMN", "", 0x00000310, 6, 0x0000000007FFFFFF, 0x0000000005020451}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields317[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{24, 26, 0x0000000000000005, "RW", "M_CNT", "Number of UIs that the unisequencer will drive logic '1'."},
#else
{24, 26, 0x0000000000000005, "RW", "M_CNT", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{16, 18, 0x0000000000000002, "RW", "N_CNT", "Number of UIs that the unisequencer will drive logic '0'."},
#else
{16, 18, 0x0000000000000002, "RW", "N_CNT", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{8, 10, 0x0000000000000004, "RW", "L_CNT", "Number of UIs that the unisequencer will drive the logic value selected through L_SEL before entering the steady state periodic phase."},
#else
{8, 10, 0x0000000000000004, "RW", "L_CNT", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{4, 6, 0x0000000000000005, "RW", "CNT_SCALE", "Values for L_CNT, M_CNT, and N_CNT are scaled by a factor of 2^CNT_SCALE."},
#else
{4, 6, 0x0000000000000005, "RW", "CNT_SCALE", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{1, 1, 0x0000000000000000, "RW", "EN_SWEEP_FREQ", "0 - Disable Sweep Frequency. 1 - Enable Sweep Frequency. [br][br]\r\n"
"[b]Note: This is not implemented in Reference RTL yet. [/b]]"},
#else
{1, 1, 0x0000000000000000, "RW", "EN_SWEEP_FREQ", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 0, 0x0000000000000001, "RW", "L_SEL", "The initial logic output of the sequencer is defined as follows:[br][br]\r\n"
"                        0 - Output Logic '0' for L_CNT UIs[br][br]\r\n"
"                        1 - Output Logic '1' for L_CNT UIs"},
#else
{0, 0, 0x0000000000000001, "RW", "L_SEL", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo317[] = {{"CPGC_CADB_UNISEQ2_LMN", "", 0x00000314, 6, 0x0000000007FFFFFF, 0x0000000005020451}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields318[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{0, 15, 0x000000000000AA55, "RW", "CMD", "The initial content of the rotating pattern buffer for the select unified sequencer."},
#else
{0, 15, 0x000000000000AA55, "RW", "CMD", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo318[] = {{"CPGC_CADB_SEL_UNISEQ0_PBUF", "", 0x00000318, 1, 0x000000000000FFFF, 0x000000000000AA55}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields319[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{0, 15, 0x000000000000AA55, "RW", "CMD", "The initial content of the rotating pattern buffer for the select unified sequencer."},
#else
{0, 15, 0x000000000000AA55, "RW", "CMD", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo319[] = {{"CPGC_CADB_SEL_UNISEQ1_PBUF", "", 0x0000031C, 1, 0x000000000000FFFF, 0x000000000000AA55}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields320[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{0, 15, 0x000000000000AA55, "RW", "CMD", "The initial content of the rotating pattern buffer for the select unified sequencer."},
#else
{0, 15, 0x000000000000AA55, "RW", "CMD", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo320[] = {{"CPGC_CADB_SEL_UNISEQ2_PBUF", "", 0x00000320, 1, 0x000000000000FFFF, 0x000000000000AA55}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields321[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{24, 27, 0x0000000000000000, "RW", "BANK_ADDR", "The DRAM bank address.[br] Note: Not used in LPDDR2/3"},
#else
{24, 27, 0x0000000000000000, "RW", "BANK_ADDR", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 19, 0x0000000000000000, "RW", "ROW_COL_ADDR", "The DRAM row/column address.[br][br]\r\n"
"LPDDR2/3 Maps the following:[br][br]\r\n"
"CA[9:0] rise=ROW_COL_ADDR[9:0][br][br]\r\n"
"CA[9:0] fall=ROW_COL_ADDR[19:10][br][br]\r\n"
"Note: Shared for DDR3 and LPDDR2/3. See ANN/CHV Dunit HAS for further information on the mapping."},
#else
{0, 19, 0x0000000000000000, "RW", "ROW_COL_ADDR", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo321[] = {{"CPGC_CADB_BUFA_0_", "", 0x00000324, 2, 0x000000000FFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields322[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{24, 27, 0x0000000000000000, "RW", "BANK_ADDR", "The DRAM bank address.[br] Note: Not used in LPDDR2/3"},
#else
{24, 27, 0x0000000000000000, "RW", "BANK_ADDR", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 19, 0x0000000000000000, "RW", "ROW_COL_ADDR", "The DRAM row/column address.[br][br]\r\n"
"LPDDR2/3 Maps the following:[br][br]\r\n"
"CA[9:0] rise=ROW_COL_ADDR[9:0][br][br]\r\n"
"CA[9:0] fall=ROW_COL_ADDR[19:10][br][br]\r\n"
"Note: Shared for DDR3 and LPDDR2/3. See ANN/CHV Dunit HAS for further information on the mapping."},
#else
{0, 19, 0x0000000000000000, "RW", "ROW_COL_ADDR", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo322[] = {{"CPGC_CADB_BUFA_1_", "", 0x00000328, 2, 0x000000000FFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields323[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{24, 27, 0x0000000000000000, "RW", "BANK_ADDR", "The DRAM bank address.[br] Note: Not used in LPDDR2/3"},
#else
{24, 27, 0x0000000000000000, "RW", "BANK_ADDR", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 19, 0x0000000000000000, "RW", "ROW_COL_ADDR", "The DRAM row/column address.[br][br]\r\n"
"LPDDR2/3 Maps the following:[br][br]\r\n"
"CA[9:0] rise=ROW_COL_ADDR[9:0][br][br]\r\n"
"CA[9:0] fall=ROW_COL_ADDR[19:10][br][br]\r\n"
"Note: Shared for DDR3 and LPDDR2/3. See ANN/CHV Dunit HAS for further information on the mapping."},
#else
{0, 19, 0x0000000000000000, "RW", "ROW_COL_ADDR", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo323[] = {{"CPGC_CADB_BUFA_2_", "", 0x0000032C, 2, 0x000000000FFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields324[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{24, 27, 0x0000000000000000, "RW", "BANK_ADDR", "The DRAM bank address.[br] Note: Not used in LPDDR2/3"},
#else
{24, 27, 0x0000000000000000, "RW", "BANK_ADDR", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 19, 0x0000000000000000, "RW", "ROW_COL_ADDR", "The DRAM row/column address.[br][br]\r\n"
"LPDDR2/3 Maps the following:[br][br]\r\n"
"CA[9:0] rise=ROW_COL_ADDR[9:0][br][br]\r\n"
"CA[9:0] fall=ROW_COL_ADDR[19:10][br][br]\r\n"
"Note: Shared for DDR3 and LPDDR2/3. See ANN/CHV Dunit HAS for further information on the mapping."},
#else
{0, 19, 0x0000000000000000, "RW", "ROW_COL_ADDR", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo324[] = {{"CPGC_CADB_BUFA_3_", "", 0x00000330, 2, 0x000000000FFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields325[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{24, 27, 0x0000000000000000, "RW", "BANK_ADDR", "The DRAM bank address.[br] Note: Not used in LPDDR2/3"},
#else
{24, 27, 0x0000000000000000, "RW", "BANK_ADDR", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 19, 0x0000000000000000, "RW", "ROW_COL_ADDR", "The DRAM row/column address.[br][br]\r\n"
"LPDDR2/3 Maps the following:[br][br]\r\n"
"CA[9:0] rise=ROW_COL_ADDR[9:0][br][br]\r\n"
"CA[9:0] fall=ROW_COL_ADDR[19:10][br][br]\r\n"
"Note: Shared for DDR3 and LPDDR2/3. See ANN/CHV Dunit HAS for further information on the mapping."},
#else
{0, 19, 0x0000000000000000, "RW", "ROW_COL_ADDR", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo325[] = {{"CPGC_CADB_BUFA_4_", "", 0x00000334, 2, 0x000000000FFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields326[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{24, 27, 0x0000000000000000, "RW", "BANK_ADDR", "The DRAM bank address.[br] Note: Not used in LPDDR2/3"},
#else
{24, 27, 0x0000000000000000, "RW", "BANK_ADDR", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 19, 0x0000000000000000, "RW", "ROW_COL_ADDR", "The DRAM row/column address.[br][br]\r\n"
"LPDDR2/3 Maps the following:[br][br]\r\n"
"CA[9:0] rise=ROW_COL_ADDR[9:0][br][br]\r\n"
"CA[9:0] fall=ROW_COL_ADDR[19:10][br][br]\r\n"
"Note: Shared for DDR3 and LPDDR2/3. See ANN/CHV Dunit HAS for further information on the mapping."},
#else
{0, 19, 0x0000000000000000, "RW", "ROW_COL_ADDR", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo326[] = {{"CPGC_CADB_BUFA_5_", "", 0x00000338, 2, 0x000000000FFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields327[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{24, 27, 0x0000000000000000, "RW", "BANK_ADDR", "The DRAM bank address.[br] Note: Not used in LPDDR2/3"},
#else
{24, 27, 0x0000000000000000, "RW", "BANK_ADDR", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 19, 0x0000000000000000, "RW", "ROW_COL_ADDR", "The DRAM row/column address.[br][br]\r\n"
"LPDDR2/3 Maps the following:[br][br]\r\n"
"CA[9:0] rise=ROW_COL_ADDR[9:0][br][br]\r\n"
"CA[9:0] fall=ROW_COL_ADDR[19:10][br][br]\r\n"
"Note: Shared for DDR3 and LPDDR2/3. See ANN/CHV Dunit HAS for further information on the mapping."},
#else
{0, 19, 0x0000000000000000, "RW", "ROW_COL_ADDR", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo327[] = {{"CPGC_CADB_BUFA_6_", "", 0x0000033C, 2, 0x000000000FFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields328[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{24, 27, 0x0000000000000000, "RW", "BANK_ADDR", "The DRAM bank address.[br] Note: Not used in LPDDR2/3"},
#else
{24, 27, 0x0000000000000000, "RW", "BANK_ADDR", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 19, 0x0000000000000000, "RW", "ROW_COL_ADDR", "The DRAM row/column address.[br][br]\r\n"
"LPDDR2/3 Maps the following:[br][br]\r\n"
"CA[9:0] rise=ROW_COL_ADDR[9:0][br][br]\r\n"
"CA[9:0] fall=ROW_COL_ADDR[19:10][br][br]\r\n"
"Note: Shared for DDR3 and LPDDR2/3. See ANN/CHV Dunit HAS for further information on the mapping."},
#else
{0, 19, 0x0000000000000000, "RW", "ROW_COL_ADDR", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo328[] = {{"CPGC_CADB_BUFA_7_", "", 0x00000340, 2, 0x000000000FFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields329[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{31, 31, 0x0000000000000000, "RW", "PAR", "Used to write the parity invert CADB data. [br][br]\r\n"
"When working with DDR4 if this bit is set and the CADB entry is selected, the parity value is inverted to reflect a C/A parity error.[br][br]\r\n"
"See CADB Read_Write_Pointer for programming details."},
#else
{31, 31, 0x0000000000000000, "RW", "PAR", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{30, 30, 0x0000000000000000, "RW", "Val", "Used to write the valid CADB data."},
#else
{30, 30, 0x0000000000000000, "RW", "Val", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{24, 27, 0x0000000000000000, "RW", "CKE", "The DRAM Clock Enable signals."},
#else
{24, 27, 0x0000000000000000, "RW", "CKE", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{16, 19, 0x0000000000000000, "RW", "ODT", "The DRAM On-Die Termination Signals.[br] Note: Not used in LPDDR2/3."},
#else
{16, 19, 0x0000000000000000, "RW", "ODT", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{8, 11, 0x0000000000000007, "RW", "CMD", "The DRAM command signals, [ACT#,RAS#,CAS#,WE#]. All Three signals are active low and hence default to '1's on reset.[br] Note: Not used in LPDDR2/3"},
#else
{8, 11, 0x0000000000000007, "RW", "CMD", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{2, 4, 0x0000000000000000, "RW", "CID", "The DRAM Chip ID."},
#else
{2, 4, 0x0000000000000000, "RW", "CID", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 1, 0x0000000000000003, "RW", "CS", "The DRAM Chip Select signals, [CS#]. These signals are active low and hence default is '1's on reset."},
#else
{0, 1, 0x0000000000000003, "RW", "CS", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo329[] = {{"CPGC_CADB_BUFB_0_", "", 0x00000344, 7, 0x00000000FFFFFFFF, 0x0000000000000703}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields330[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{31, 31, 0x0000000000000000, "RW", "PAR", "Used to write the parity invert CADB data. [br][br]\r\n"
"When working with DDR4 if this bit is set and the CADB entry is selected, the parity value is inverted to reflect a C/A parity error.[br][br]\r\n"
"See CADB Read_Write_Pointer for programming details."},
#else
{31, 31, 0x0000000000000000, "RW", "PAR", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{30, 30, 0x0000000000000000, "RW", "Val", "Used to write the valid CADB data."},
#else
{30, 30, 0x0000000000000000, "RW", "Val", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{24, 27, 0x0000000000000000, "RW", "CKE", "The DRAM Clock Enable signals."},
#else
{24, 27, 0x0000000000000000, "RW", "CKE", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{16, 19, 0x0000000000000000, "RW", "ODT", "The DRAM On-Die Termination Signals.[br] Note: Not used in LPDDR2/3."},
#else
{16, 19, 0x0000000000000000, "RW", "ODT", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{8, 11, 0x0000000000000007, "RW", "CMD", "The DRAM command signals, [ACT#,RAS#,CAS#,WE#]. All Three signals are active low and hence default to '1's on reset.[br] Note: Not used in LPDDR2/3"},
#else
{8, 11, 0x0000000000000007, "RW", "CMD", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{2, 4, 0x0000000000000000, "RW", "CID", "The DRAM Chip ID."},
#else
{2, 4, 0x0000000000000000, "RW", "CID", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 1, 0x0000000000000003, "RW", "CS", "The DRAM Chip Select signals, [CS#]. These signals are active low and hence default is '1's on reset."},
#else
{0, 1, 0x0000000000000003, "RW", "CS", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo330[] = {{"CPGC_CADB_BUFB_1_", "", 0x00000348, 7, 0x00000000FFFFFFFF, 0x0000000000000703}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields331[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{31, 31, 0x0000000000000000, "RW", "PAR", "Used to write the parity invert CADB data. [br][br]\r\n"
"When working with DDR4 if this bit is set and the CADB entry is selected, the parity value is inverted to reflect a C/A parity error.[br][br]\r\n"
"See CADB Read_Write_Pointer for programming details."},
#else
{31, 31, 0x0000000000000000, "RW", "PAR", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{30, 30, 0x0000000000000000, "RW", "Val", "Used to write the valid CADB data."},
#else
{30, 30, 0x0000000000000000, "RW", "Val", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{24, 27, 0x0000000000000000, "RW", "CKE", "The DRAM Clock Enable signals."},
#else
{24, 27, 0x0000000000000000, "RW", "CKE", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{16, 19, 0x0000000000000000, "RW", "ODT", "The DRAM On-Die Termination Signals.[br] Note: Not used in LPDDR2/3."},
#else
{16, 19, 0x0000000000000000, "RW", "ODT", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{8, 11, 0x0000000000000007, "RW", "CMD", "The DRAM command signals, [ACT#,RAS#,CAS#,WE#]. All Three signals are active low and hence default to '1's on reset.[br] Note: Not used in LPDDR2/3"},
#else
{8, 11, 0x0000000000000007, "RW", "CMD", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{2, 4, 0x0000000000000000, "RW", "CID", "The DRAM Chip ID."},
#else
{2, 4, 0x0000000000000000, "RW", "CID", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 1, 0x0000000000000003, "RW", "CS", "The DRAM Chip Select signals, [CS#]. These signals are active low and hence default is '1's on reset."},
#else
{0, 1, 0x0000000000000003, "RW", "CS", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo331[] = {{"CPGC_CADB_BUFB_2_", "", 0x0000034C, 7, 0x00000000FFFFFFFF, 0x0000000000000703}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields332[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{31, 31, 0x0000000000000000, "RW", "PAR", "Used to write the parity invert CADB data. [br][br]\r\n"
"When working with DDR4 if this bit is set and the CADB entry is selected, the parity value is inverted to reflect a C/A parity error.[br][br]\r\n"
"See CADB Read_Write_Pointer for programming details."},
#else
{31, 31, 0x0000000000000000, "RW", "PAR", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{30, 30, 0x0000000000000000, "RW", "Val", "Used to write the valid CADB data."},
#else
{30, 30, 0x0000000000000000, "RW", "Val", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{24, 27, 0x0000000000000000, "RW", "CKE", "The DRAM Clock Enable signals."},
#else
{24, 27, 0x0000000000000000, "RW", "CKE", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{16, 19, 0x0000000000000000, "RW", "ODT", "The DRAM On-Die Termination Signals.[br] Note: Not used in LPDDR2/3."},
#else
{16, 19, 0x0000000000000000, "RW", "ODT", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{8, 11, 0x0000000000000007, "RW", "CMD", "The DRAM command signals, [ACT#,RAS#,CAS#,WE#]. All Three signals are active low and hence default to '1's on reset.[br] Note: Not used in LPDDR2/3"},
#else
{8, 11, 0x0000000000000007, "RW", "CMD", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{2, 4, 0x0000000000000000, "RW", "CID", "The DRAM Chip ID."},
#else
{2, 4, 0x0000000000000000, "RW", "CID", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 1, 0x0000000000000003, "RW", "CS", "The DRAM Chip Select signals, [CS#]. These signals are active low and hence default is '1's on reset."},
#else
{0, 1, 0x0000000000000003, "RW", "CS", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo332[] = {{"CPGC_CADB_BUFB_3_", "", 0x00000350, 7, 0x00000000FFFFFFFF, 0x0000000000000703}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields333[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{31, 31, 0x0000000000000000, "RW", "PAR", "Used to write the parity invert CADB data. [br][br]\r\n"
"When working with DDR4 if this bit is set and the CADB entry is selected, the parity value is inverted to reflect a C/A parity error.[br][br]\r\n"
"See CADB Read_Write_Pointer for programming details."},
#else
{31, 31, 0x0000000000000000, "RW", "PAR", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{30, 30, 0x0000000000000000, "RW", "Val", "Used to write the valid CADB data."},
#else
{30, 30, 0x0000000000000000, "RW", "Val", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{24, 27, 0x0000000000000000, "RW", "CKE", "The DRAM Clock Enable signals."},
#else
{24, 27, 0x0000000000000000, "RW", "CKE", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{16, 19, 0x0000000000000000, "RW", "ODT", "The DRAM On-Die Termination Signals.[br] Note: Not used in LPDDR2/3."},
#else
{16, 19, 0x0000000000000000, "RW", "ODT", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{8, 11, 0x0000000000000007, "RW", "CMD", "The DRAM command signals, [ACT#,RAS#,CAS#,WE#]. All Three signals are active low and hence default to '1's on reset.[br] Note: Not used in LPDDR2/3"},
#else
{8, 11, 0x0000000000000007, "RW", "CMD", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{2, 4, 0x0000000000000000, "RW", "CID", "The DRAM Chip ID."},
#else
{2, 4, 0x0000000000000000, "RW", "CID", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 1, 0x0000000000000003, "RW", "CS", "The DRAM Chip Select signals, [CS#]. These signals are active low and hence default is '1's on reset."},
#else
{0, 1, 0x0000000000000003, "RW", "CS", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo333[] = {{"CPGC_CADB_BUFB_4_", "", 0x00000354, 7, 0x00000000FFFFFFFF, 0x0000000000000703}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields334[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{31, 31, 0x0000000000000000, "RW", "PAR", "Used to write the parity invert CADB data. [br][br]\r\n"
"When working with DDR4 if this bit is set and the CADB entry is selected, the parity value is inverted to reflect a C/A parity error.[br][br]\r\n"
"See CADB Read_Write_Pointer for programming details."},
#else
{31, 31, 0x0000000000000000, "RW", "PAR", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{30, 30, 0x0000000000000000, "RW", "Val", "Used to write the valid CADB data."},
#else
{30, 30, 0x0000000000000000, "RW", "Val", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{24, 27, 0x0000000000000000, "RW", "CKE", "The DRAM Clock Enable signals."},
#else
{24, 27, 0x0000000000000000, "RW", "CKE", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{16, 19, 0x0000000000000000, "RW", "ODT", "The DRAM On-Die Termination Signals.[br] Note: Not used in LPDDR2/3."},
#else
{16, 19, 0x0000000000000000, "RW", "ODT", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{8, 11, 0x0000000000000007, "RW", "CMD", "The DRAM command signals, [ACT#,RAS#,CAS#,WE#]. All Three signals are active low and hence default to '1's on reset.[br] Note: Not used in LPDDR2/3"},
#else
{8, 11, 0x0000000000000007, "RW", "CMD", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{2, 4, 0x0000000000000000, "RW", "CID", "The DRAM Chip ID."},
#else
{2, 4, 0x0000000000000000, "RW", "CID", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 1, 0x0000000000000003, "RW", "CS", "The DRAM Chip Select signals, [CS#]. These signals are active low and hence default is '1's on reset."},
#else
{0, 1, 0x0000000000000003, "RW", "CS", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo334[] = {{"CPGC_CADB_BUFB_5_", "", 0x00000358, 7, 0x00000000FFFFFFFF, 0x0000000000000703}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields335[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{31, 31, 0x0000000000000000, "RW", "PAR", "Used to write the parity invert CADB data. [br][br]\r\n"
"When working with DDR4 if this bit is set and the CADB entry is selected, the parity value is inverted to reflect a C/A parity error.[br][br]\r\n"
"See CADB Read_Write_Pointer for programming details."},
#else
{31, 31, 0x0000000000000000, "RW", "PAR", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{30, 30, 0x0000000000000000, "RW", "Val", "Used to write the valid CADB data."},
#else
{30, 30, 0x0000000000000000, "RW", "Val", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{24, 27, 0x0000000000000000, "RW", "CKE", "The DRAM Clock Enable signals."},
#else
{24, 27, 0x0000000000000000, "RW", "CKE", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{16, 19, 0x0000000000000000, "RW", "ODT", "The DRAM On-Die Termination Signals.[br] Note: Not used in LPDDR2/3."},
#else
{16, 19, 0x0000000000000000, "RW", "ODT", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{8, 11, 0x0000000000000007, "RW", "CMD", "The DRAM command signals, [ACT#,RAS#,CAS#,WE#]. All Three signals are active low and hence default to '1's on reset.[br] Note: Not used in LPDDR2/3"},
#else
{8, 11, 0x0000000000000007, "RW", "CMD", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{2, 4, 0x0000000000000000, "RW", "CID", "The DRAM Chip ID."},
#else
{2, 4, 0x0000000000000000, "RW", "CID", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 1, 0x0000000000000003, "RW", "CS", "The DRAM Chip Select signals, [CS#]. These signals are active low and hence default is '1's on reset."},
#else
{0, 1, 0x0000000000000003, "RW", "CS", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo335[] = {{"CPGC_CADB_BUFB_6_", "", 0x0000035C, 7, 0x00000000FFFFFFFF, 0x0000000000000703}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields336[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{31, 31, 0x0000000000000000, "RW", "PAR", "Used to write the parity invert CADB data. [br][br]\r\n"
"When working with DDR4 if this bit is set and the CADB entry is selected, the parity value is inverted to reflect a C/A parity error.[br][br]\r\n"
"See CADB Read_Write_Pointer for programming details."},
#else
{31, 31, 0x0000000000000000, "RW", "PAR", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{30, 30, 0x0000000000000000, "RW", "Val", "Used to write the valid CADB data."},
#else
{30, 30, 0x0000000000000000, "RW", "Val", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{24, 27, 0x0000000000000000, "RW", "CKE", "The DRAM Clock Enable signals."},
#else
{24, 27, 0x0000000000000000, "RW", "CKE", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{16, 19, 0x0000000000000000, "RW", "ODT", "The DRAM On-Die Termination Signals.[br] Note: Not used in LPDDR2/3."},
#else
{16, 19, 0x0000000000000000, "RW", "ODT", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{8, 11, 0x0000000000000007, "RW", "CMD", "The DRAM command signals, [ACT#,RAS#,CAS#,WE#]. All Three signals are active low and hence default to '1's on reset.[br] Note: Not used in LPDDR2/3"},
#else
{8, 11, 0x0000000000000007, "RW", "CMD", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{2, 4, 0x0000000000000000, "RW", "CID", "The DRAM Chip ID."},
#else
{2, 4, 0x0000000000000000, "RW", "CID", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 1, 0x0000000000000003, "RW", "CS", "The DRAM Chip Select signals, [CS#]. These signals are active low and hence default is '1's on reset."},
#else
{0, 1, 0x0000000000000003, "RW", "CS", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo336[] = {{"CPGC_CADB_BUFB_7_", "", 0x00000360, 7, 0x00000000FFFFFFFF, 0x0000000000000703}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields337[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{0, 15, 0x0000000000000000, "RO/V", "UNISEQ_STAT", "The current contents of the command/address pattern unified sequencer buffer.  In case a stop condition occurs, this register will contain the last value that was used to generate the command/address pattern.  Bit 0 represents the value used for the current chunk."},
#else
{0, 15, 0x0000000000000000, "RO/V", "UNISEQ_STAT", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo337[] = {{"CPGC_CADB_UNISEQ0STAT", "", 0x00000364, 1, 0x000000000000FFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields338[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{0, 15, 0x0000000000000000, "RO/V", "UNISEQ_STAT", "The current contents of the command/address pattern unified sequencer buffer.  In case a stop condition occurs, this register will contain the last value that was used to generate the command/address pattern.  Bit 0 represents the value used for the current chunk."},
#else
{0, 15, 0x0000000000000000, "RO/V", "UNISEQ_STAT", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo338[] = {{"CPGC_CADB_UNISEQ1STAT", "", 0x00000368, 1, 0x000000000000FFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields339[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{0, 15, 0x0000000000000000, "RO/V", "UNISEQ_STAT", "The current contents of the command/address pattern unified sequencer buffer.  In case a stop condition occurs, this register will contain the last value that was used to generate the command/address pattern.  Bit 0 represents the value used for the current chunk."},
#else
{0, 15, 0x0000000000000000, "RO/V", "UNISEQ_STAT", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo339[] = {{"CPGC_CADB_UNISEQ2STAT", "", 0x0000036C, 1, 0x000000000000FFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields340[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{0, 31, 0x0000000000000000, "RW", "Data", "Test register to create LPPHY boxtype."},
#else
{0, 31, 0x0000000000000000, "RW", "Data", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo340[] = {{"TEST", "", 0x00000000, 1, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields341[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{0, 31, 0x0000000000000000, "RW", "wake", "Simulation requirement to wake dunit chassis"},
#else
{0, 31, 0x0000000000000000, "RW", "wake", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo341[] = {{"wake_chasis", "", 0x00000110, 1, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields342[] = {
#ifdef MEM_SV_HOOKS
#if DUMP_REGISTER_DESCRIPTIONS
{30, 31, 0x0000000000000000, "RO", "reserved572", "Reserved bits"},
#else
{30, 31, 0x0000000000000000, "RO", "reserved572", NULL},
#endif
#else
#if DUMP_REGISTER_DESCRIPTIONS
{30, 31, 0x00000000, "RO", "Reserved", "Reserved"},
#else
{30, 31, 0x00000000, "RO", "Reserved",  NULL},
#endif
#endif // MEM_SV_HOOKS
#ifdef MEM_SV_HOOKS
#if DUMP_REGISTER_DESCRIPTIONS
{28, 29, 0x0000000000000000, "RO", "reserved573", "Reserved bits"},
#else
{28, 29, 0x0000000000000000, "RO", "reserved573", NULL},
#endif
#else
#if DUMP_REGISTER_DESCRIPTIONS
{28, 29, 0x00000000, "RO", "Reserved", "Reserved"},
#else
{28, 29, 0x00000000, "RO", "Reserved",  NULL},
#endif
#endif // MEM_SV_HOOKS
#ifdef MEM_SV_HOOKS
#if DUMP_REGISTER_DESCRIPTIONS
{24, 27, 0x0000000000000000, "RO", "reserved574", "Reserved bits"},
#else
{24, 27, 0x0000000000000000, "RO", "reserved574", NULL},
#endif
#else
#if DUMP_REGISTER_DESCRIPTIONS
{24, 27, 0x00000000, "RO", "Reserved", "Reserved"},
#else
{24, 27, 0x00000000, "RO", "Reserved",  NULL},
#endif
#endif // MEM_SV_HOOKS
#ifdef MEM_SV_HOOKS
#if DUMP_REGISTER_DESCRIPTIONS
{16, 23, 0x0000000000000000, "RO", "reserved575", "Reserved bits"},
#else
{16, 23, 0x0000000000000000, "RO", "reserved575", NULL},
#endif
#else
#if DUMP_REGISTER_DESCRIPTIONS
{16, 23, 0x00000000, "RO", "Reserved", "Reserved"},
#else
{16, 23, 0x00000000, "RO", "Reserved",  NULL},
#endif
#endif // MEM_SV_HOOKS
#ifdef MEM_SV_HOOKS
#if DUMP_REGISTER_DESCRIPTIONS
{14, 15, 0x0000000000000000, "RO", "reserved576", "Reserved bits"},
#else
{14, 15, 0x0000000000000000, "RO", "reserved576", NULL},
#endif
#else
#if DUMP_REGISTER_DESCRIPTIONS
{14, 15, 0x00000000, "RO", "Reserved", "Reserved"},
#else
{14, 15, 0x00000000, "RO", "Reserved",  NULL},
#endif
#endif // MEM_SV_HOOKS
#if DUMP_REGISTER_DESCRIPTIONS
{12, 13, 0x0000000000000000, "RW", "txdll_rk0siggrp03dbsel", "Deadband select for sig group 3 rank 0"},
#else
{12, 13, 0x0000000000000000, "RW", "txdll_rk0siggrp03dbsel", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{8, 11, 0x0000000000000000, "RW", "txdll_rk0siggrp03rdptroffset", "Read pointer offset for sig group 3 rank 0"},
#else
{8, 11, 0x0000000000000000, "RW", "txdll_rk0siggrp03rdptroffset", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 7, 0x0000000000000000, "RW", "txdll_rk0siggrp03picode", "PI code for sig group 3 rank 0"},
#else
{0, 7, 0x0000000000000000, "RW", "txdll_rk0siggrp03picode", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo342[] = {{"txdllsiggrp3ctla", "", 0x00000870, 8, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields343[] = {
#ifdef MEM_SV_HOOKS
#if DUMP_REGISTER_DESCRIPTIONS
{30, 31, 0x0000000000000000, "RO", "reserved562", "Reserved bits"},
#else
{30, 31, 0x0000000000000000, "RO", "reserved562", NULL},
#endif
#else
#if DUMP_REGISTER_DESCRIPTIONS
{30, 31, 0x00000000, "RO", "Reserved", "Reserved"},
#else
{30, 31, 0x00000000, "RO", "Reserved",  NULL},
#endif
#endif // MEM_SV_HOOKS
#ifdef MEM_SV_HOOKS
#if DUMP_REGISTER_DESCRIPTIONS
{28, 29, 0x0000000000000000, "RO", "reserved563", "Reserved bits"},
#else
{28, 29, 0x0000000000000000, "RO", "reserved563", NULL},
#endif
#else
#if DUMP_REGISTER_DESCRIPTIONS
{28, 29, 0x00000000, "RO", "Reserved", "Reserved"},
#else
{28, 29, 0x00000000, "RO", "Reserved",  NULL},
#endif
#endif // MEM_SV_HOOKS
#ifdef MEM_SV_HOOKS
#if DUMP_REGISTER_DESCRIPTIONS
{24, 27, 0x0000000000000000, "RO", "reserved564", "Reserved bits"},
#else
{24, 27, 0x0000000000000000, "RO", "reserved564", NULL},
#endif
#else
#if DUMP_REGISTER_DESCRIPTIONS
{24, 27, 0x00000000, "RO", "Reserved", "Reserved"},
#else
{24, 27, 0x00000000, "RO", "Reserved",  NULL},
#endif
#endif // MEM_SV_HOOKS
#ifdef MEM_SV_HOOKS
#if DUMP_REGISTER_DESCRIPTIONS
{16, 23, 0x0000000000000000, "RO", "reserved565", "Reserved bits"},
#else
{16, 23, 0x0000000000000000, "RO", "reserved565", NULL},
#endif
#else
#if DUMP_REGISTER_DESCRIPTIONS
{16, 23, 0x00000000, "RO", "Reserved", "Reserved"},
#else
{16, 23, 0x00000000, "RO", "Reserved",  NULL},
#endif
#endif // MEM_SV_HOOKS
#ifdef MEM_SV_HOOKS
#if DUMP_REGISTER_DESCRIPTIONS
{14, 15, 0x0000000000000000, "RO", "reserved566", "Reserved bits"},
#else
{14, 15, 0x0000000000000000, "RO", "reserved566", NULL},
#endif
#else
#if DUMP_REGISTER_DESCRIPTIONS
{14, 15, 0x00000000, "RO", "Reserved", "Reserved"},
#else
{14, 15, 0x00000000, "RO", "Reserved",  NULL},
#endif
#endif // MEM_SV_HOOKS
#if DUMP_REGISTER_DESCRIPTIONS
{12, 13, 0x0000000000000000, "RW", "txdll_rk0siggrp05dbsel", "Deadband select for sig group 5 rank 0"},
#else
{12, 13, 0x0000000000000000, "RW", "txdll_rk0siggrp05dbsel", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{8, 11, 0x0000000000000000, "RW", "txdll_rk0siggrp05rdptroffset", "Read pointer offset for sig group 5 rank 0"},
#else
{8, 11, 0x0000000000000000, "RW", "txdll_rk0siggrp05rdptroffset", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 7, 0x0000000000000000, "RW", "txdll_rk0siggrp05picode", "PI code for sig group 5 rank 0"},
#else
{0, 7, 0x0000000000000000, "RW", "txdll_rk0siggrp05picode", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo343[] = {{"txdllsiggrp5ctla", "", 0x00000868, 8, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields344[] = {
#ifdef MEM_SV_HOOKS
#if DUMP_REGISTER_DESCRIPTIONS
{30, 31, 0x0000000000000000, "RO", "reserved567", "Reserved bits"},
#else
{30, 31, 0x0000000000000000, "RO", "reserved567", NULL},
#endif
#else
#if DUMP_REGISTER_DESCRIPTIONS
{30, 31, 0x00000000, "RO", "Reserved", "Reserved"},
#else
{30, 31, 0x00000000, "RO", "Reserved",  NULL},
#endif
#endif // MEM_SV_HOOKS
#ifdef MEM_SV_HOOKS
#if DUMP_REGISTER_DESCRIPTIONS
{28, 29, 0x0000000000000000, "RO", "reserved568", "Reserved bits"},
#else
{28, 29, 0x0000000000000000, "RO", "reserved568", NULL},
#endif
#else
#if DUMP_REGISTER_DESCRIPTIONS
{28, 29, 0x00000000, "RO", "Reserved", "Reserved"},
#else
{28, 29, 0x00000000, "RO", "Reserved",  NULL},
#endif
#endif // MEM_SV_HOOKS
#ifdef MEM_SV_HOOKS
#if DUMP_REGISTER_DESCRIPTIONS
{24, 27, 0x0000000000000000, "RO", "reserved569", "Reserved bits"},
#else
{24, 27, 0x0000000000000000, "RO", "reserved569", NULL},
#endif
#else
#if DUMP_REGISTER_DESCRIPTIONS
{24, 27, 0x00000000, "RO", "Reserved", "Reserved"},
#else
{24, 27, 0x00000000, "RO", "Reserved",  NULL},
#endif
#endif // MEM_SV_HOOKS
#ifdef MEM_SV_HOOKS
#if DUMP_REGISTER_DESCRIPTIONS
{16, 23, 0x0000000000000000, "RO", "reserved570", "Reserved bits"},
#else
{16, 23, 0x0000000000000000, "RO", "reserved570", NULL},
#endif
#else
#if DUMP_REGISTER_DESCRIPTIONS
{16, 23, 0x00000000, "RO", "Reserved", "Reserved"},
#else
{16, 23, 0x00000000, "RO", "Reserved",  NULL},
#endif
#endif // MEM_SV_HOOKS
#ifdef MEM_SV_HOOKS
#if DUMP_REGISTER_DESCRIPTIONS
{14, 15, 0x0000000000000000, "RO", "reserved571", "Reserved bits"},
#else
{14, 15, 0x0000000000000000, "RO", "reserved571", NULL},
#endif
#else
#if DUMP_REGISTER_DESCRIPTIONS
{14, 15, 0x00000000, "RO", "Reserved", "Reserved"},
#else
{14, 15, 0x00000000, "RO", "Reserved",  NULL},
#endif
#endif // MEM_SV_HOOKS
#if DUMP_REGISTER_DESCRIPTIONS
{12, 13, 0x0000000000000000, "RW", "txdll_rk0siggrp04dbsel", "Deadband select for sig group 4 rank 0"},
#else
{12, 13, 0x0000000000000000, "RW", "txdll_rk0siggrp04dbsel", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{8, 11, 0x0000000000000000, "RW", "txdll_rk0siggrp04rdptroffset", "Read pointer offset for sig group 4 rank 0"},
#else
{8, 11, 0x0000000000000000, "RW", "txdll_rk0siggrp04rdptroffset", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 7, 0x0000000000000000, "RW", "txdll_rk0siggrp04picode", "PI code for sig group 4 rank 0"},
#else
{0, 7, 0x0000000000000000, "RW", "txdll_rk0siggrp04picode", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo344[] = {{"txdllsiggrp4ctla", "", 0x0000086C, 8, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields345[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{28, 31, 0x0000000000000000, "RW", "memtech", "Reserved bits"},
#else
{28, 31, 0x0000000000000000, "RW", "memtech", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{24, 27, 0x0000000000000000, "RW", "memfreq", "Memory frequency"},
#else
{24, 27, 0x0000000000000000, "RW", "memfreq", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{16, 23, 0x0000000000000000, "RW", "phyupd_dly", "Delay between the phy update request to ack [br]in terms of SPID clocks."},
#else
{16, 23, 0x0000000000000000, "RW", "phyupd_dly", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{15, 15, 0x0000000000000000, "RO", "reserved500", "Reserved bits"},
#else
{15, 15, 0x0000000000000000, "RO", "reserved500", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{13, 14, 0x0000000000000000, "RW", "stretchmode", "This is the stretch mode signal.[br]00- normal read[br]01- x4 stretch mode [br]10- x8 stretch mode[br]11- x16 stretch mode"},
#else
{13, 14, 0x0000000000000000, "RW", "stretchmode", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{12, 12, 0x0000000000000000, "RO", "reserved501", "Reserved bits"},
#else
{12, 12, 0x0000000000000000, "RO", "reserved501", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{11, 11, 0x0000000000000000, "RW", "slowpath", "Delay the wrcmd 1 spidclk before write into the fifo.[br]1: 1 spidclk delay[br]0: no delay[br]With clock gating enable, the write pointer is only valid @ the next spid clock edge of write command. -> delay 1 spidclk so we can capture it into the fifo.[br]Set to 1 if do clock gate. Else set it to 0."},
#else
{11, 11, 0x0000000000000000, "RW", "slowpath", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{10, 10, 0x0000000000000000, "RW", "txfifo_csn_ffloppreseten", "This is the txFIFO final flop preset enable[br]1 - iobufact_b assert will preset the final flop, otherwise resets the final flop"},
#else
{10, 10, 0x0000000000000000, "RW", "txfifo_csn_ffloppreseten", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{9, 9, 0x0000000000000000, "RW", "rdmcpsel", "Programmable MCP for Tx FIFO read pointer path."},
#else
{9, 9, 0x0000000000000000, "RW", "rdmcpsel", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{6, 8, 0x0000000000000000, "RO", "reserved502", "Reserved bits"},
#else
{6, 8, 0x0000000000000000, "RO", "reserved502", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{5, 5, 0x0000000000000000, "RW", "bl1632xbl48b", "This is the burstlength configuration register[br]1:BL16 and BL32[br]0:BL4 and BL8"},
#else
{5, 5, 0x0000000000000000, "RW", "bl1632xbl48b", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{3, 4, 0x0000000000000000, "RW", "spidclksel", "SPID clk sel [br]00: 0.5xmode[br]01: 0.25x mode[br]10: 0.1x mode[br]11: NA"},
#else
{3, 4, 0x0000000000000000, "RW", "spidclksel", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{2, 2, 0x0000000000000000, "RW", "lpddr34mode", "Single data rate v/s Double Data rate [br]0: Double data rate (LP3)[br]1: Single data rate (LP4)"},
#else
{2, 2, 0x0000000000000000, "RW", "lpddr34mode", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 1, 0x0000000000000000, "RO", "reserved503", "Reserved bits"},
#else
{0, 1, 0x0000000000000000, "RO", "reserved503", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo345[] = {{"digctl", "", 0x00000000, 14, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields346[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{28, 31, 0x0000000000000000, "RO", "reserved504", "Reserved bits"},
#else
{28, 31, 0x0000000000000000, "RO", "reserved504", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{24, 27, 0x0000000000000000, "RW", "compclkrdptrinit", "DLL comp init configuration."},
#else
{24, 27, 0x0000000000000000, "RW", "compclkrdptrinit", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{21, 23, 0x0000000000000000, "RW", "compclkrdptroffset", "DLL comp read pointer offset."},
#else
{21, 23, 0x0000000000000000, "RW", "compclkrdptroffset", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{17, 20, 0x0000000000000000, "RW", "ref1xrdptrinit", "This is the ref1x read pointer init configuration."},
#else
{17, 20, 0x0000000000000000, "RW", "ref1xrdptrinit", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{16, 16, 0x0000000000000000, "RW", "dqxccb", "Configure DQCCC as DQ or CCC[br]0: CCC[br]1: DQ"},
#else
{16, 16, 0x0000000000000000, "RW", "dqxccb", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{13, 15, 0x0000000000000000, "RW", "ref1xrdptroffset", "This is the ref1xread pointer offset configuration."},
#else
{13, 15, 0x0000000000000000, "RW", "ref1xrdptroffset", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{8, 12, 0x0000000000000000, "RW", "ref2xrdptrinit", "This is the ref2x read pointer init configuration."},
#else
{8, 12, 0x0000000000000000, "RW", "ref2xrdptrinit", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{4, 7, 0x0000000000000000, "RW", "cc_doublefifooffset", "This is the double FIFO offset configuration(in terms of 2xclock)."},
#else
{4, 7, 0x0000000000000000, "RW", "cc_doublefifooffset", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 3, 0x0000000000000000, "RW", "bl_doublefifooffset", "This is the double FIFO offset configuration(in terms of 2xclock)."},
#else
{0, 3, 0x0000000000000000, "RW", "bl_doublefifooffset", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo346[] = {{"fifoptrctl", "", 0x00000004, 9, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields347[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{28, 31, 0x0000000000000000, "RO", "reserved505", "Reserved bits"},
#else
{28, 31, 0x0000000000000000, "RO", "reserved505", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{25, 27, 0x0000000000000000, "RO", "reserved506", "Reserved bits"},
#else
{25, 27, 0x0000000000000000, "RO", "reserved506", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{24, 24, 0x0000000000000000, "RW", "ca_training", "CA training mode"},
#else
{24, 24, 0x0000000000000000, "RW", "ca_training", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{21, 23, 0x0000000000000000, "RO", "reserved507", "Reserved bits"},
#else
{21, 23, 0x0000000000000000, "RO", "reserved507", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{20, 20, 0x0000000000000000, "RW", "clktxdrven", "CK buffer enable[br]1: Enable buffer[br]0: Tristate buffer"},
#else
{20, 20, 0x0000000000000000, "RW", "clktxdrven", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{19, 19, 0x0000000000000000, "RW", "cketxdrven", "CKE buffer enable[br]1: Enable buffer[br]0: Tristate buffer"},
#else
{19, 19, 0x0000000000000000, "RW", "cketxdrven", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{18, 18, 0x0000000000000000, "RW", "cstxdrven", "CS buffer enable[br]1: Enable buffer[br]0: Tristate buffer"},
#else
{18, 18, 0x0000000000000000, "RW", "cstxdrven", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{8, 17, 0x0000000000000000, "RW", "cmdtxdrven", "CMD buffer enable[br]1: Enable buffer[br]0: Tristate buffer"},
#else
{8, 17, 0x0000000000000000, "RW", "cmdtxdrven", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{7, 7, 0x0000000000000000, "RO", "reserved508", "Reserved bits"},
#else
{7, 7, 0x0000000000000000, "RO", "reserved508", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{6, 6, 0x0000000000000000, "RO", "reserved509", "Reserved bits"},
#else
{6, 6, 0x0000000000000000, "RO", "reserved509", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{5, 5, 0x0000000000000000, "RO", "reserved510", "Reserved bits"},
#else
{5, 5, 0x0000000000000000, "RO", "reserved510", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{3, 4, 0x0000000000000000, "RO", "reserved511", "Reserved bits"},
#else
{3, 4, 0x0000000000000000, "RO", "reserved511", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{2, 2, 0x0000000000000000, "RW", "clknegxposb", "Start phase of CK"},
#else
{2, 2, 0x0000000000000000, "RW", "clknegxposb", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{1, 1, 0x0000000000000000, "RW", "cmdtristateovrval", "Command tristate override value"},
#else
{1, 1, 0x0000000000000000, "RW", "cmdtristateovrval", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 0, 0x0000000000000000, "RW", "cmdtristateovrsel", "Command tristate override select"},
#else
{0, 0, 0x0000000000000000, "RW", "cmdtristateovrsel", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo347[] = {{"cccctl", "", 0x00000008, 15, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields348[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{3, 31, 0x0000000000000000, "RO", "reserved512", "Reserved bits"},
#else
{3, 31, 0x0000000000000000, "RO", "reserved512", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{2, 2, 0x0000000000000000, "RW", "rstbtx_enbrst", "Tri-state control for LP4 reset buffer"},
#else
{2, 2, 0x0000000000000000, "RW", "rstbtx_enbrst", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{1, 1, 0x0000000000000000, "RW", "rstbtx_reset", "Reset for the LP4 reset buffer"},
#else
{1, 1, 0x0000000000000000, "RW", "rstbtx_reset", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 0, 0x0000000000000000, "RW", "rstbtx_set", "Set for the LP4 reset buffer"},
#else
{0, 0, 0x0000000000000000, "RW", "rstbtx_set", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo348[] = {{"lp4rstctl", "", 0x0000000C, 4, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields349[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{2, 31, 0x0000000000000000, "RO", "reserved513", "Reserved bits"},
#else
{2, 31, 0x0000000000000000, "RO", "reserved513", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{1, 1, 0x0000000000000000, "RW", "rxfiforst_b", "Rxfifo reset (active low)[br]1: deasserted[br]0 : asserted"},
#else
{1, 1, 0x0000000000000000, "RW", "rxfiforst_b", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 0, 0x0000000000000000, "RW", "spidrst_b", "Reset for functional logic in upartition (except compensation and power management logic)  [br]0: Reset assertion  [br]1: Reset de-assertion"},
#else
{0, 0, 0x0000000000000000, "RW", "spidrst_b", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo349[] = {{"digrstctl", "", 0x00000010, 3, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields350[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{1, 31, 0x0000000000000000, "RO", "reserved514", "Reserved bits"},
#else
{1, 31, 0x0000000000000000, "RO", "reserved514", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 0, 0x0000000000000000, "RW", "wrptren", "Config-controlled Write pointer enable. 0=config control disabled, 1=config control enabled. This bit qualifies the pm_wrptren, which eventually goes to DQPTRGEN Fub."},
#else
{0, 0, 0x0000000000000000, "RW", "wrptren", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo350[] = {{"fifoptren", "", 0x00000014, 2, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields351[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{2, 31, 0x0000000000000000, "RO", "reserved515", "Reserved bits"},
#else
{2, 31, 0x0000000000000000, "RO", "reserved515", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{1, 1, 0x0000000000000000, "RW", "lvl_cc_iobufactafe", "IO buffer activate - CCC Analog[br]Tristates DQ and DQS IO buffers [br]Disable Rx sections of IO buffers [br]0 : reset [br]1 : out of reset"},
#else
{1, 1, 0x0000000000000000, "RW", "lvl_cc_iobufactafe", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 0, 0x0000000000000000, "RW", "lvl_bl_iobufactafe", "IO buffer activate - DQ Analog[br]Tristates DQ and DQS IO buffers [br]Disable Rx sections of IO buffers [br]0 : reset [br]1 : out of reset"},
#else
{0, 0, 0x0000000000000000, "RW", "lvl_bl_iobufactafe", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo351[] = {{"iobufact_afe", "", 0x00000018, 3, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields352[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{2, 31, 0x0000000000000000, "RO", "reserved516", "Reserved bits"},
#else
{2, 31, 0x0000000000000000, "RO", "reserved516", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{1, 1, 0x0000000000000000, "RW", "cc_iobufactdig", "IO buffer activate - CCC Digital[br]Bytelane 1 SW reset for final TX flops in all upartitions."},
#else
{1, 1, 0x0000000000000000, "RW", "cc_iobufactdig", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 0, 0x0000000000000000, "RW", "bl_iobufactdig", "IO buffer activate - DQ Digital[br]Bytelane 1 SW reset for final TX flops in all upartitions."},
#else
{0, 0, 0x0000000000000000, "RW", "bl_iobufactdig", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo352[] = {{"iobufact_dig", "", 0x0000001C, 3, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields353[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{1, 31, 0x0000000000000000, "RO", "reserved517", "Reserved bits"},
#else
{1, 31, 0x0000000000000000, "RO", "reserved517", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 0, 0x0000000000000000, "RW", "spid_init_complete", "SPID init complete"},
#else
{0, 0, 0x0000000000000000, "RW", "spid_init_complete", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo353[] = {{"spidic", "", 0x00000020, 2, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields354[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{10, 31, 0x0000000000000000, "RO", "reserved518", "Reserved bits"},
#else
{10, 31, 0x0000000000000000, "RO", "reserved518", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{8, 9, 0x0000000000000000, "RO", "reserved519", "Reserved bits"},
#else
{8, 9, 0x0000000000000000, "RO", "reserved519", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{6, 7, 0x0000000000000000, "RW", "dqdrvenbph1", "Data mask drive enable"},
#else
{6, 7, 0x0000000000000000, "RW", "dqdrvenbph1", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{4, 5, 0x0000000000000000, "RW", "dqdrvenbpream1", "This is the two write preambles enable"},
#else
{4, 5, 0x0000000000000000, "RW", "dqdrvenbpream1", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{2, 3, 0x0000000000000000, "RW", "dqdrvenblastph", "Last phase - DQ Drive Enable"},
#else
{2, 3, 0x0000000000000000, "RW", "dqdrvenblastph", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 1, 0x0000000000000000, "RW", "dqdrvenbpream0", "This is the DQS configuration for first phase [br](2'b01-dqs_hi_lo,2'b00-dqs_lo_lo,2'b11-dqs_hi_hi)."},
#else
{0, 1, 0x0000000000000000, "RW", "dqdrvenbpream0", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo354[] = {{"wrdqctl", "", 0x00000024, 6, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields355[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{30, 31, 0x0000000000000000, "RW", "dqsdrvenbph1", "Phase 1 - DQS Drive enable"},
#else
{30, 31, 0x0000000000000000, "RW", "dqsdrvenbph1", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{28, 29, 0x0000000000000000, "RW", "dqsdrvenbpream1", "Preamble 1 - DQS drive enable"},
#else
{28, 29, 0x0000000000000000, "RW", "dqsdrvenbpream1", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{26, 27, 0x0000000000000000, "RW", "dqsdrvenblastph", "Last phase - DQS Drive enable"},
#else
{26, 27, 0x0000000000000000, "RW", "dqsdrvenblastph", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{24, 25, 0x0000000000000000, "RW", "dqsdrvenbpream0", "Preamble 0 - DQS Drive enable"},
#else
{24, 25, 0x0000000000000000, "RW", "dqsdrvenbpream0", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{21, 23, 0x0000000000000000, "RO", "reserved520", "Reserved bits"},
#else
{21, 23, 0x0000000000000000, "RO", "reserved520", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{20, 20, 0x0000000000000000, "RW", "dmdrven", "Data mask drive enable"},
#else
{20, 20, 0x0000000000000000, "RW", "dmdrven", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{19, 19, 0x0000000000000000, "RW", "wrpream0en", "This is the two write preambles enable"},
#else
{19, 19, 0x0000000000000000, "RW", "wrpream0en", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{18, 18, 0x0000000000000000, "RO", "reserved521", "TBD"},
#else
{18, 18, 0x0000000000000000, "RO", "reserved521", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{16, 17, 0x0000000000000003, "RW", "dqsdrvenbidle", "DQS Drive Enable - Idle"},
#else
{16, 17, 0x0000000000000003, "RW", "dqsdrvenbidle", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{14, 15, 0x0000000000000000, "RW", "dqsdataph1", "This is the DQS configuration for first phase [br](2'b01-dqs_hi_lo,2'b00-dqs_lo_lo,2'b11-dqs_hi_hi)."},
#else
{14, 15, 0x0000000000000000, "RW", "dqsdataph1", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{12, 13, 0x0000000000000000, "RW", "dqsdatapream1", "This is the DQS configuration during second preamble[br](2'b01-dqs_hi_lo,2'b00-dqs_lo_lo,2'b11-dqs_hi_hi)."},
#else
{12, 13, 0x0000000000000000, "RW", "dqsdatapream1", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{10, 11, 0x0000000000000000, "RW", "dqsdatalastph", "This is the DQS configuration for last phase [br](2'b01-dqs_hi_lo,2'b00-dqs_lo_lo,2'b11-dqs_hi_hi)."},
#else
{10, 11, 0x0000000000000000, "RW", "dqsdatalastph", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{8, 9, 0x0000000000000000, "RW", "dqsdatapream0", "This is the DQS configuration during first preamble[br](2'b01-dqs_hi_lo,2'b00-dqs_lo_lo,2'b11-dqs_hi_hi)."},
#else
{8, 9, 0x0000000000000000, "RW", "dqsdatapream0", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{6, 7, 0x0000000000000000, "RO", "reserved522", "Reserved bits"},
#else
{6, 7, 0x0000000000000000, "RO", "reserved522", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 5, 0x0000000000000000, "RW", "wrcmd2dqsstart", "Write command to DQS start delay"},
#else
{0, 5, 0x0000000000000000, "RW", "wrcmd2dqsstart", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo355[] = {{"wrdqsctl", "", 0x00000028, 15, 0x00000000FFFFFFFF, 0x0000000000030000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields356[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{24, 31, 0x0000000000000000, "RO", "reserved523", "Reserved bits"},
#else
{24, 31, 0x0000000000000000, "RO", "reserved523", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{16, 23, 0x0000000000000000, "RW", "rdcmd2rdvld_bonus", "Read command 2 read bonus bits."},
#else
{16, 23, 0x0000000000000000, "RW", "rdcmd2rdvld_bonus", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{15, 15, 0x0000000000000000, "RO", "reserved524", "Reserved bits"},
#else
{15, 15, 0x0000000000000000, "RO", "reserved524", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{12, 14, 0x0000000000000000, "RW", "rdcmd2rdvld_plus1sel", "Read command 2 read valid plus 1 sel."},
#else
{12, 14, 0x0000000000000000, "RW", "rdcmd2rdvld_plus1sel", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{11, 11, 0x0000000000000000, "RO", "reserved525", "Reserved bits"},
#else
{11, 11, 0x0000000000000000, "RO", "reserved525", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{8, 10, 0x0000000000000000, "RW", "earlyrdvld", "This is the early read valid configuration register [br]0: no early read valid geneartion[br]1/2/3/4: 1/2/3/4/spidclk early valid[br] >4: Illegal"},
#else
{8, 10, 0x0000000000000000, "RW", "earlyrdvld", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{6, 7, 0x0000000000000000, "RO", "reserved526", "Reserved bits"},
#else
{6, 7, 0x0000000000000000, "RO", "reserved526", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 5, 0x0000000000000000, "RW", "rdcmd2rdvld", "This is the read command to read valid register.[br]This is in terms of spidclk."},
#else
{0, 5, 0x0000000000000000, "RW", "rdcmd2rdvld", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo356[] = {{"rdvldctl", "", 0x0000002C, 8, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields357[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{11, 31, 0x0000000000000000, "RO", "reserved527", "This is the rank to rank override.(1 - no rank to rank switch enable)."},
#else
{11, 31, 0x0000000000000000, "RO", "reserved527", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{10, 10, 0x0000000000000000, "RW", "rk2rkmio2xclkpushout_iodrven", "pushing out the update of rank information 1 more 2xclk if set to 1."},
#else
{10, 10, 0x0000000000000000, "RW", "rk2rkmio2xclkpushout_iodrven", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{9, 9, 0x0000000000000000, "RW", "rk2rkmio2xclkpushout_txrden", "pushing out the update of rank information 1 more 2xclk if set to 1."},
#else
{9, 9, 0x0000000000000000, "RW", "rk2rkmio2xclkpushout_txrden", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{8, 8, 0x0000000000000000, "RW", "rk2rkmio2xclkpushout_txrcven", "pushing out the update of rank information 1 more 2xclk if set to 1."},
#else
{8, 8, 0x0000000000000000, "RW", "rk2rkmio2xclkpushout_txrcven", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{7, 7, 0x0000000000000000, "RW", "bl_rk2rken_txdqs_pi", "This is the rank to rank override.(1 - no rank to rank switch enable)."},
#else
{7, 7, 0x0000000000000000, "RW", "bl_rk2rken_txdqs_pi", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{6, 6, 0x0000000000000000, "RW", "bl_rk2rken_txdq_pi", "This is the rank to rank override.(1 - no rank to rank switch enable)."},
#else
{6, 6, 0x0000000000000000, "RW", "bl_rk2rken_txdq_pi", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{2, 5, 0x0000000000000000, "RO", "reserved528", "This is the rank to rank override.(1 - no rank to rank switch enable)."},
#else
{2, 5, 0x0000000000000000, "RO", "reserved528", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{1, 1, 0x0000000000000000, "RW", "bl_rk2rken_rxdq_pi", "This is the rank to rank override.(1 - no rank to rank switch enable)."},
#else
{1, 1, 0x0000000000000000, "RW", "bl_rk2rken_rxdq_pi", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 0, 0x0000000000000000, "RW", "bl_rk2rken_txrcven", "This is the rank to rank enable for the receive enable."},
#else
{0, 0, 0x0000000000000000, "RW", "bl_rk2rken_txrcven", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo357[] = {{"rk2rkctl1", "", 0x00000030, 9, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields358[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{28, 31, 0x0000000000000000, "RW", "rk2rkdrvenbcode_3rd", "This is the pattern for third 1x clock of rk2rk_rden[br](bit[0] - 1xhigh phase value, bit[1] - 1xlow phase value).[br]Applicable for both DQ and DQS drvenb."},
#else
{28, 31, 0x0000000000000000, "RW", "rk2rkdrvenbcode_3rd", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{24, 27, 0x0000000000000000, "RW", "rk2rkrdencode_3rd", "This is the pattern for third 1x clock of rk2rk_rden[br](bit[0] - 1xhigh phase value, bit[1] - 1xlow phase value)."},
#else
{24, 27, 0x0000000000000000, "RW", "rk2rkrdencode_3rd", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{23, 23, 0x0000000000000000, "RW", "rk2rkmio2xclkpushout_rxdq", "pushing out the update of rank information 1 more 2xclk if set to 1."},
#else
{23, 23, 0x0000000000000000, "RW", "rk2rkmio2xclkpushout_rxdq", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{22, 22, 0x0000000000000000, "RW", "rk2rkmio2xclkpushout_txdqs", "pushing out the update of rank information 1 more 2xclk if set to 1."},
#else
{22, 22, 0x0000000000000000, "RW", "rk2rkmio2xclkpushout_txdqs", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{21, 21, 0x0000000000000000, "RW", "rk2rkmio2xclkpushout_txdq", "pushing out the update of rank information 1 more 2xclk if set to 1."},
#else
{21, 21, 0x0000000000000000, "RW", "rk2rkmio2xclkpushout_txdq", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{15, 20, 0x0000000000000000, "RW", "wrcmd2rkchglatency", "This is the pattern for second 1x clock of rk2rk_iodrvenb[br](bit[0] - 1xhigh phase value, bit[1] - 1xlow phase value)."},
#else
{15, 20, 0x0000000000000000, "RW", "wrcmd2rkchglatency", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{14, 14, 0x0000000000000000, "RO", "reserved529", "Reserved bits"},
#else
{14, 14, 0x0000000000000000, "RO", "reserved529", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{8, 13, 0x0000000000000000, "RW", "rdcmd2rkchglatency", "This is the pattern for first 1x clock of rk2rk_iodrvenb[br](bit[0] - 1xhigh phase value, bit[1] - 1xlow phase value)."},
#else
{8, 13, 0x0000000000000000, "RW", "rdcmd2rkchglatency", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{6, 7, 0x0000000000000000, "RW", "rk2rkdrvenbcode_2nd", "This is the pattern for second 1x clock of rk2rk_rden[br](bit[0] - 1xhigh phase value, bit[1] - 1xlow phase value).[br]Applicable for both DQ and DQS drvenb."},
#else
{6, 7, 0x0000000000000000, "RW", "rk2rkdrvenbcode_2nd", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{4, 5, 0x0000000000000000, "RW", "rk2rkdrvenbcode_1st", "This is the pattern for first 1x clock of rk2rk_rden[br](bit[0] - 1xhigh phase value, bit[1] - 1xlow phase value).[br]Applicable for both DQ and DQS drvenb."},
#else
{4, 5, 0x0000000000000000, "RW", "rk2rkdrvenbcode_1st", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{2, 3, 0x0000000000000000, "RW", "rk2rkrdencode_2nd", "This is the pattern for second 1x clock of rk2rk_rden[br](bit[0] - 1xhigh phase value, bit[1] - 1xlow phase value)."},
#else
{2, 3, 0x0000000000000000, "RW", "rk2rkrdencode_2nd", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 1, 0x0000000000000000, "RW", "rk2rkrdencode_1st", "This is the pattern for first 1x clock of rk2rk_rden[br](bit[0] - 1xhigh phase value, bit[1] - 1xlow phase value)."},
#else
{0, 1, 0x0000000000000000, "RW", "rk2rkrdencode_1st", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo358[] = {{"rk2rkctl0", "", 0x00000034, 12, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields359[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{29, 31, 0x0000000000000000, "RW", "cc_rxodtsegovrval", "Receive ODT segment enable override value."},
#else
{29, 31, 0x0000000000000000, "RW", "cc_rxodtsegovrval", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{28, 28, 0x0000000000000000, "RW", "cc_rxodtsegovrsel", "Receive ODT segment enable override select.[br]0= Dynamic  control[br]1= Static  control"},
#else
{28, 28, 0x0000000000000000, "RW", "cc_rxodtsegovrsel", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{24, 27, 0x0000000000000000, "RW", "rk1_odtsegenrdptroffset", "Receive ODT segment enable read pointer offset."},
#else
{24, 27, 0x0000000000000000, "RW", "rk1_odtsegenrdptroffset", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{23, 23, 0x0000000000000000, "RO", "reserved530", "Reserved bits"},
#else
{23, 23, 0x0000000000000000, "RO", "reserved530", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{22, 22, 0x0000000000000000, "RW", "cc_rxodtsegtwohot", "This is the RXODTSEGEN one hot enable[br]0- rxodtsegen: 001->010->100[br]1-rxodtsegen: 011->110->101"},
#else
{22, 22, 0x0000000000000000, "RW", "cc_rxodtsegtwohot", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{16, 21, 0x0000000000000000, "RW", "cc_rxodtseglenbl4", "This is the receive ODT segment enable length configuration register.[br]It's in number of 1x clocks."},
#else
{16, 21, 0x0000000000000000, "RW", "cc_rxodtseglenbl4", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{14, 15, 0x0000000000000000, "RW", "cc_rxodtsegpst1", "This is the receive ODT segment enable configuration register - postamble 1 -  new(rise & fall). [br]00 - Rise & Fall - Low & Low[br]01 - Rise & Fall - High & Low[br]10 - Rise & Fall - Low & High[br]11 - Rise & Fall - High & High"},
#else
{14, 15, 0x0000000000000000, "RW", "cc_rxodtsegpst1", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{12, 13, 0x0000000000000000, "RW", "cc_rxodtsegpre1", "This is the receive ODT segment enable configuration register - preamble 1(rise & fall) [br]00 - Rise & Fall - Low & Low[br]01 - Rise & Fall - High & Low[br]10 - Rise & Fall - Low & High[br]11 - Rise & Fall - High & High"},
#else
{12, 13, 0x0000000000000000, "RW", "cc_rxodtsegpre1", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{10, 11, 0x0000000000000000, "RW", "cc_rxodtsegpst0", "This is the receive ODT segment enable configuration register - postamble 0 - new(rise & fall)[br]00 - Rise & Fall - Low & Low[br]01 - Rise & Fall - High & Low[br]10 - Rise & Fall - Low & High[br]11 - Rise & Fall - High & High"},
#else
{10, 11, 0x0000000000000000, "RW", "cc_rxodtsegpst0", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{8, 9, 0x0000000000000000, "RW", "cc_rxodtsegpre0", "This is the receive ODT segment enable configuration register - preamble 0(rise & fall) [br]00 - Rise & Fall - Low & Low[br]01 - Rise & Fall - High & Low[br]10 - Rise & Fall - Low & High[br]11 - Rise & Fall - High & High"},
#else
{8, 9, 0x0000000000000000, "RW", "cc_rxodtsegpre0", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{6, 7, 0x0000000000000000, "RO", "reserved531", "Reserved bits"},
#else
{6, 7, 0x0000000000000000, "RO", "reserved531", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 5, 0x0000000000000000, "RW", "cc_rdcmd2rxodtseg", "This is the receive ODT segment enable latency configuration register."},
#else
{0, 5, 0x0000000000000000, "RW", "cc_rdcmd2rxodtseg", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo359[] = {{"rxodtsegctl_cc", "", 0x00000038, 12, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields360[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{29, 31, 0x0000000000000000, "RW", "bl_rxodtsegovrval", "Receive ODT segment enable override value. [br]0: De-assert receive ODT enable [br]1: Assert receive ODT enable"},
#else
{29, 31, 0x0000000000000000, "RW", "bl_rxodtsegovrval", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{28, 28, 0x0000000000000000, "RW", "bl_rxodtsegovrsel", "Receive ODT segment enable override select.[br]0= Dynamic  receive ODT control[br]1= Static  receive ODT control"},
#else
{28, 28, 0x0000000000000000, "RW", "bl_rxodtsegovrsel", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{24, 27, 0x0000000000000000, "RW", "rk0_odtsegenrdptroffset", "Receive ODT segment enable read pointer offset."},
#else
{24, 27, 0x0000000000000000, "RW", "rk0_odtsegenrdptroffset", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{23, 23, 0x0000000000000000, "RO", "reserved532", "Reseved bits"},
#else
{23, 23, 0x0000000000000000, "RO", "reserved532", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{22, 22, 0x0000000000000000, "RW", "bl_rxodtsegtwohot", "This is the RXODTSEGEN one hot enable[br]0- rxodtsegen: 001->010->100[br]1-rxodtsegen: 011->110->101"},
#else
{22, 22, 0x0000000000000000, "RW", "bl_rxodtsegtwohot", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{16, 21, 0x0000000000000000, "RW", "bl_rxodtseglenbl4", "This is the receive ODT segment enable length configuration register.[br]It's in number of 1x clocks."},
#else
{16, 21, 0x0000000000000000, "RW", "bl_rxodtseglenbl4", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{14, 15, 0x0000000000000000, "RW", "bl_rxodtsegpst1", "This is the receive ODT segment enable configuration register - postamble 1 -  new(rise & fall). [br]00 - Rise & Fall - Low & Low[br]01 - Rise & Fall - High & Low[br]10 - Rise & Fall - Low & High[br]11 - Rise & Fall - High & High"},
#else
{14, 15, 0x0000000000000000, "RW", "bl_rxodtsegpst1", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{12, 13, 0x0000000000000000, "RW", "bl_rxodtsegpre1", "This is the receive ODT segment enable configuration register - preamble 1(rise & fall) [br]00 - Rise & Fall - Low & Low[br]01 - Rise & Fall - High & Low[br]10 - Rise & Fall - Low & High[br]11 - Rise & Fall - High & High"},
#else
{12, 13, 0x0000000000000000, "RW", "bl_rxodtsegpre1", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{10, 11, 0x0000000000000000, "RW", "bl_rxodtsegpst0", "This is the receive ODT segment enable configuration register - postamble 0 - new(rise & fall)[br]00 - Rise & Fall - Low & Low[br]01 - Rise & Fall - High & Low[br]10 - Rise & Fall - Low & High[br]11 - Rise & Fall - High & High"},
#else
{10, 11, 0x0000000000000000, "RW", "bl_rxodtsegpst0", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{8, 9, 0x0000000000000000, "RW", "bl_rxodtsegpre0", "This is the receive ODT segment enable configuration register - preamble 0(rise & fall) [br]00 - Rise & Fall - Low & Low[br]01 - Rise & Fall - High & Low[br]10 - Rise & Fall - Low & High[br]11 - Rise & Fall - High & High"},
#else
{8, 9, 0x0000000000000000, "RW", "bl_rxodtsegpre0", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{6, 7, 0x0000000000000000, "RO", "reserved533", "Reserved bits"},
#else
{6, 7, 0x0000000000000000, "RO", "reserved533", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 5, 0x0000000000000000, "RW", "bl_rdcmd2rxodtseg", "This is the receive ODT segment enable latency configuration register."},
#else
{0, 5, 0x0000000000000000, "RW", "bl_rdcmd2rxodtseg", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo360[] = {{"rxodtsegctl_dq", "", 0x0000003C, 12, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields361[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{28, 31, 0x0000000000000000, "RW", "rk1_odtenrdptroffset", "This is receive ODT enable read pointer offset."},
#else
{28, 31, 0x0000000000000000, "RW", "rk1_odtenrdptroffset", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{26, 27, 0x0000000000000000, "RO", "reserved534", "Reseved bits"},
#else
{26, 27, 0x0000000000000000, "RO", "reserved534", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{25, 25, 0x0000000000000000, "RW", "cc_rxodtenovrval", "Receive ODT enable override value. [br]0: De-assert receive enable [br]1: Assert receive enable"},
#else
{25, 25, 0x0000000000000000, "RW", "cc_rxodtenovrval", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{24, 24, 0x0000000000000000, "RW", "cc_rxodtenovrsel", "Receive ODT enable override select.[br]0= Dynamic RCVEN control[br]1= Static RCVEN control"},
#else
{24, 24, 0x0000000000000000, "RW", "cc_rxodtenovrsel", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{22, 23, 0x0000000000000000, "RO", "reserved535", "Reserved bits"},
#else
{22, 23, 0x0000000000000000, "RO", "reserved535", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{16, 21, 0x0000000000000000, "RW", "cc_rxodtenlenbl4", "This is the receive ODT enable length configuration register.[br]It's in number of 1x clocks."},
#else
{16, 21, 0x0000000000000000, "RW", "cc_rxodtenlenbl4", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{14, 15, 0x0000000000000000, "RW", "cc_rxodtenpst1", "This is the receive ODT enable configuration register - postamble 1 -  new(rise & fall). [br]00 - Rise & Fall - Low & Low[br]01 - Rise & Fall - High & Low[br]10 - Rise & Fall - Low & High[br]11 - Rise & Fall - High & High"},
#else
{14, 15, 0x0000000000000000, "RW", "cc_rxodtenpst1", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{12, 13, 0x0000000000000000, "RW", "cc_rxodtenpre1", "This is the receive ODT enable configuration register - preamble 1(rise & fall) [br]00 - Rise & Fall - Low & Low[br]01 - Rise & Fall - High & Low[br]10 - Rise & Fall - Low & High[br]11 - Rise & Fall - High & High"},
#else
{12, 13, 0x0000000000000000, "RW", "cc_rxodtenpre1", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{10, 11, 0x0000000000000000, "RW", "cc_rxodtenpst0", "This is the receive ODT enable configuration register - postamble 0 - new(rise & fall)[br]00 - Rise & Fall - Low & Low[br]01 - Rise & Fall - High & Low[br]10 - Rise & Fall - Low & High[br]11 - Rise & Fall - High & High"},
#else
{10, 11, 0x0000000000000000, "RW", "cc_rxodtenpst0", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{8, 9, 0x0000000000000000, "RW", "cc_rxodtenpre0", "This is the receive ODT enable configuration register - preamble 0(rise & fall) [br]00 - Rise & Fall - Low & Low[br]01 - Rise & Fall - High & Low[br]10 - Rise & Fall - Low & High[br]11 - Rise & Fall - High & High"},
#else
{8, 9, 0x0000000000000000, "RW", "cc_rxodtenpre0", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{6, 7, 0x0000000000000000, "RO", "reserved536", "Reserved bits"},
#else
{6, 7, 0x0000000000000000, "RO", "reserved536", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 5, 0x0000000000000000, "RW", "cc_rdcmd2rxodten", "This is the receive ODT enable latency configuration register."},
#else
{0, 5, 0x0000000000000000, "RW", "cc_rdcmd2rxodten", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo361[] = {{"rxodtctl_cc", "", 0x00000040, 12, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields362[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{28, 31, 0x0000000000000000, "RW", "rk0_odtenrdptroffset", "This is receive ODT enable read pointer offset."},
#else
{28, 31, 0x0000000000000000, "RW", "rk0_odtenrdptroffset", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{26, 27, 0x0000000000000000, "RO", "reserved537", "Reserved bits"},
#else
{26, 27, 0x0000000000000000, "RO", "reserved537", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{25, 25, 0x0000000000000000, "RW", "bl_rxodtenovrval", "Receive ODT enable override value. [br]0: De-assert receive enable [br]1: Assert receive enable"},
#else
{25, 25, 0x0000000000000000, "RW", "bl_rxodtenovrval", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{24, 24, 0x0000000000000000, "RW", "bl_rxodtenovrsel", "Receive ODT enable override select.[br]0= Dynamic RCVEN control[br]1= Static RCVEN control"},
#else
{24, 24, 0x0000000000000000, "RW", "bl_rxodtenovrsel", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{22, 23, 0x0000000000000000, "RO", "reserved538", "Reserved bits"},
#else
{22, 23, 0x0000000000000000, "RO", "reserved538", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{16, 21, 0x0000000000000000, "RW", "bl_rxodtenlenbl4", "This is the receive ODT enable length configuration register.[br]It's in number of 1x clocks."},
#else
{16, 21, 0x0000000000000000, "RW", "bl_rxodtenlenbl4", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{14, 15, 0x0000000000000000, "RW", "bl_rxodtenpst1", "This is the receive ODT enable configuration register - postamble 1 -  new(rise & fall). [br]00 - Rise & Fall - Low & Low[br]01 - Rise & Fall - High & Low[br]10 - Rise & Fall - Low & High[br]11 - Rise & Fall - High & High"},
#else
{14, 15, 0x0000000000000000, "RW", "bl_rxodtenpst1", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{12, 13, 0x0000000000000000, "RW", "bl_rxodtenpre1", "This is the receive ODT enable configuration register - preamble 1(rise & fall) [br]00 - Rise & Fall - Low & Low[br]01 - Rise & Fall - High & Low[br]10 - Rise & Fall - Low & High[br]11 - Rise & Fall - High & High"},
#else
{12, 13, 0x0000000000000000, "RW", "bl_rxodtenpre1", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{10, 11, 0x0000000000000000, "RW", "bl_rxodtenpst0", "This is the receive ODT enable configuration register - postamble 0 - new(rise & fall)[br]00 - Rise & Fall - Low & Low[br]01 - Rise & Fall - High & Low[br]10 - Rise & Fall - Low & High[br]11 - Rise & Fall - High & High"},
#else
{10, 11, 0x0000000000000000, "RW", "bl_rxodtenpst0", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{8, 9, 0x0000000000000000, "RW", "bl_rxodtenpre0", "This is the receive ODT enable configuration register - preamble 0(rise & fall) [br]00 - Rise & Fall - Low & Low[br]01 - Rise & Fall - High & Low[br]10 - Rise & Fall - Low & High[br]11 - Rise & Fall - High & High"},
#else
{8, 9, 0x0000000000000000, "RW", "bl_rxodtenpre0", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{6, 7, 0x0000000000000000, "RO", "reserved539", "Reserved bits"},
#else
{6, 7, 0x0000000000000000, "RO", "reserved539", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 5, 0x0000000000000000, "RW", "bl_rdcmd2rxodten", "This is the receive ODT enable latency configuration register."},
#else
{0, 5, 0x0000000000000000, "RW", "bl_rdcmd2rxodten", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo362[] = {{"rxodtctl_dq", "", 0x00000044, 12, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields363[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{31, 31, 0x0000000000000000, "RO", "drx_cc_rcvsmpl", "AFE status register - RCVSMPL - CC"},
#else
{31, 31, 0x0000000000000000, "RO", "drx_cc_rcvsmpl", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{28, 30, 0x0000000000000000, "RO", "reserved540", "Reserved bits"},
#else
{28, 30, 0x0000000000000000, "RO", "reserved540", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{27, 27, 0x0000000000000000, "RW", "drx_cc_dqscountrstb", "DQS counter reset"},
#else
{27, 27, 0x0000000000000000, "RW", "drx_cc_dqscountrstb", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{26, 26, 0x0000000000000000, "RW", "cc_rcvenmargin", "Receive enable margining data"},
#else
{26, 26, 0x0000000000000000, "RW", "cc_rcvenmargin", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{25, 25, 0x0000000000000000, "RW", "cc_rcvenovrval", "Receive enable override value. [br]0: De-assert receive enable [br]1: Assert receive enable"},
#else
{25, 25, 0x0000000000000000, "RW", "cc_rcvenovrval", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{24, 24, 0x0000000000000000, "RW", "cc_rcvenovrsel", "Receive enable override select.[br]0= Dynamic RCVEN control[br]1= Static RCVEN control"},
#else
{24, 24, 0x0000000000000000, "RW", "cc_rcvenovrsel", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{22, 23, 0x0000000000000000, "RO", "reserved541", "Reserved bits"},
#else
{22, 23, 0x0000000000000000, "RO", "reserved541", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{16, 21, 0x0000000000000000, "RW", "cc_rcvenlenbl4", "This is the receive enable length(number of 1x clock) configuration register."},
#else
{16, 21, 0x0000000000000000, "RW", "cc_rcvenlenbl4", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{14, 15, 0x0000000000000000, "RW", "cc_rcvenpst1", "This is the receive enable configuration register - postamble 1 -  new(rise & fall). [br]00 - Rise & Fall - Low & Low[br]01 - Rise & Fall - High & Low[br]10 - Rise & Fall - Low & High[br]11 - Rise & Fall - High & High"},
#else
{14, 15, 0x0000000000000000, "RW", "cc_rcvenpst1", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{12, 13, 0x0000000000000000, "RW", "cc_rcvenpre1", "This is the receive enable configuration register - preamble 1(rise & fall) [br]00 - Rise & Fall - Low & Low[br]01 - Rise & Fall - High & Low[br]10 - Rise & Fall - Low & High[br]11 - Rise & Fall - High & High"},
#else
{12, 13, 0x0000000000000000, "RW", "cc_rcvenpre1", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{10, 11, 0x0000000000000000, "RW", "cc_rcvenpst0", "This is the receive enable configuration register - postamble 0 - new(rise & fall)[br]00 - Rise & Fall - Low & Low[br]01 - Rise & Fall - High & Low[br]10 - Rise & Fall - Low & High[br]11 - Rise & Fall - High & High"},
#else
{10, 11, 0x0000000000000000, "RW", "cc_rcvenpst0", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{8, 9, 0x0000000000000000, "RW", "cc_rcvenpre0", "This is the receive enable configuration register - preamble 0(rise & fall) [br]00 - Rise & Fall - Low & Low[br]01 - Rise & Fall - High & Low[br]10 - Rise & Fall - Low & High[br]11 - Rise & Fall - High & High"},
#else
{8, 9, 0x0000000000000000, "RW", "cc_rcvenpre0", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{6, 7, 0x0000000000000000, "RO", "reserved542", "Reserved bits"},
#else
{6, 7, 0x0000000000000000, "RO", "reserved542", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 5, 0x0000000000000000, "RW", "cc_rdcmd2rcven", "This is the receive enable latency configuration register."},
#else
{0, 5, 0x0000000000000000, "RW", "cc_rdcmd2rcven", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo363[] = {{"rcvenctl_cc", "", 0x00000048, 14, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields364[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{31, 31, 0x0000000000000000, "RO", "drx_bl_rcvsmpl", "AFE status register - RCVSMPL - DQ"},
#else
{31, 31, 0x0000000000000000, "RO", "drx_bl_rcvsmpl", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{28, 30, 0x0000000000000000, "RO", "reserved543", "Reseved bits"},
#else
{28, 30, 0x0000000000000000, "RO", "reserved543", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{27, 27, 0x0000000000000000, "RW", "drx_bl_dqscountrstb", "DQS counter reset"},
#else
{27, 27, 0x0000000000000000, "RW", "drx_bl_dqscountrstb", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{26, 26, 0x0000000000000000, "RW", "bl_rcvenmargin", "Receive enable margining data"},
#else
{26, 26, 0x0000000000000000, "RW", "bl_rcvenmargin", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{25, 25, 0x0000000000000000, "RW", "bl_rcvenovrval", "Receive enable override value. [br]0: De-assert receive enable [br]1: Assert receive enable"},
#else
{25, 25, 0x0000000000000000, "RW", "bl_rcvenovrval", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{24, 24, 0x0000000000000000, "RW", "bl_rcvenovrsel", "Receive enable override select.[br]0= Dynamic RCVEN control[br]1= Static RCVEN control"},
#else
{24, 24, 0x0000000000000000, "RW", "bl_rcvenovrsel", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{22, 23, 0x0000000000000000, "RO", "reserved544", "Reserved bits"},
#else
{22, 23, 0x0000000000000000, "RO", "reserved544", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{16, 21, 0x0000000000000000, "RW", "bl_rcvenlenbl4", "This is the receive enable length(number of 1x clock) configuration register."},
#else
{16, 21, 0x0000000000000000, "RW", "bl_rcvenlenbl4", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{14, 15, 0x0000000000000000, "RW", "bl_rcvenpst1", "This is the receive enable configuration register - postamble 1 -  new(rise & fall). [br]00 - Rise & Fall - Low & Low[br]01 - Rise & Fall - High & Low[br]10 - Rise & Fall - Low & High[br]11 - Rise & Fall - High & High"},
#else
{14, 15, 0x0000000000000000, "RW", "bl_rcvenpst1", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{12, 13, 0x0000000000000000, "RW", "bl_rcvenpre1", "This is the receive enable configuration register - preamble 1(rise & fall) [br]00 - Rise & Fall - Low & Low[br]01 - Rise & Fall - High & Low[br]10 - Rise & Fall - Low & High[br]11 - Rise & Fall - High & High"},
#else
{12, 13, 0x0000000000000000, "RW", "bl_rcvenpre1", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{10, 11, 0x0000000000000000, "RW", "bl_rcvenpst0", "This is the receive enable configuration register - postamble 0 - new(rise & fall)[br]00 - Rise & Fall - Low & Low[br]01 - Rise & Fall - High & Low[br]10 - Rise & Fall - Low & High[br]11 - Rise & Fall - High & High"},
#else
{10, 11, 0x0000000000000000, "RW", "bl_rcvenpst0", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{8, 9, 0x0000000000000000, "RW", "bl_rcvenpre0", "This is the receive enable configuration register - preamble 0(rise & fall) [br]00 - Rise & Fall - Low & Low[br]01 - Rise & Fall - High & Low[br]10 - Rise & Fall - Low & High[br]11 - Rise & Fall - High & High"},
#else
{8, 9, 0x0000000000000000, "RW", "bl_rcvenpre0", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{6, 7, 0x0000000000000000, "RO", "reserved545", "Reserved bits"},
#else
{6, 7, 0x0000000000000000, "RO", "reserved545", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 5, 0x0000000000000000, "RW", "bl_rdcmd2rcven", "This is the receive enable latency configuration register.[br]RL - 1: maps to DRAM RL."},
#else
{0, 5, 0x0000000000000000, "RW", "bl_rdcmd2rcven", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo364[] = {{"rcvenctl_dq", "", 0x0000004C, 14, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields365[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{28, 31, 0x0000000000000000, "RW", "rk1_diffampenrdptroffset", "Differential amplifier read pointer offset control."},
#else
{28, 31, 0x0000000000000000, "RW", "rk1_diffampenrdptroffset", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{27, 27, 0x0000000000000000, "RW", "cc_dqsdiffampenovrval", "Override value for DQS Diffamp enable - DQ Lane"},
#else
{27, 27, 0x0000000000000000, "RW", "cc_dqsdiffampenovrval", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{26, 26, 0x0000000000000000, "RW", "cc_dqsdiffampenovrsel", "Override select for DQS Diffamp enable - DQ Lane"},
#else
{26, 26, 0x0000000000000000, "RW", "cc_dqsdiffampenovrsel", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{25, 25, 0x0000000000000000, "RW", "cc_dqdmdiffampenovrval", "Override value for DQ/DM Diffamp enable - DQ Lane"},
#else
{25, 25, 0x0000000000000000, "RW", "cc_dqdmdiffampenovrval", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{24, 24, 0x0000000000000000, "RW", "cc_dqdmdiffampenovrsel", "Override select for DQ/DM Diffamp enable - DQ Lane"},
#else
{24, 24, 0x0000000000000000, "RW", "cc_dqdmdiffampenovrsel", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{22, 23, 0x0000000000000000, "RW", "cc_diffampenpst1", "This is the diffamp enable configuration register - postamble 1 -  new(rise & fall). [br]00 - Rise & Fall - Low & Low[br]01 - Rise & Fall - High & Low[br]10 - Rise & Fall - Low & High[br]11 - Rise & Fall - High & High"},
#else
{22, 23, 0x0000000000000000, "RW", "cc_diffampenpst1", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{20, 21, 0x0000000000000000, "RW", "cc_diffampenpre1", "This is the diffamp enable configuration register - preamble 1(rise & fall) [br]00 - Rise & Fall - Low & Low[br]01 - Rise & Fall - High & Low[br]10 - Rise & Fall - Low & High[br]11 - Rise & Fall - High & High"},
#else
{20, 21, 0x0000000000000000, "RW", "cc_diffampenpre1", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{18, 19, 0x0000000000000000, "RW", "cc_diffampenpst0", "This is the diffamp enable configuration register - postamble 0 - new(rise & fall)[br]00 - Rise & Fall - Low & Low[br]01 - Rise & Fall - High & Low[br]10 - Rise & Fall - Low & High[br]11 - Rise & Fall - High & High"},
#else
{18, 19, 0x0000000000000000, "RW", "cc_diffampenpst0", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{16, 17, 0x0000000000000000, "RW", "cc_diffampenpre0", "This is the diffamp enable configuration register - preamble 0(rise & fall) [br]00 - Rise & Fall - Low & Low[br]01 - Rise & Fall - High & Low[br]10 - Rise & Fall - Low & High[br]11 - Rise & Fall - High & High"},
#else
{16, 17, 0x0000000000000000, "RW", "cc_diffampenpre0", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{14, 15, 0x0000000000000000, "RO", "reserved546", "Reserved bits"},
#else
{14, 15, 0x0000000000000000, "RO", "reserved546", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{8, 13, 0x0000000000000000, "RW", "cc_diffampenlenbl4", "This is the diffamp enable length(number of 1x clock) configuration register."},
#else
{8, 13, 0x0000000000000000, "RW", "cc_diffampenlenbl4", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{6, 7, 0x0000000000000000, "RO", "reserved547", "Reserved bits"},
#else
{6, 7, 0x0000000000000000, "RO", "reserved547", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 5, 0x0000000000000000, "RW", "cc_rdcmd2diffampen", "This is the Diffamp enable latency register."},
#else
{0, 5, 0x0000000000000000, "RW", "cc_rdcmd2diffampen", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo365[] = {{"diffampctl_cc", "", 0x00000050, 13, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields366[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{28, 31, 0x0000000000000000, "RW", "rk0_diffampenrdptroffset", "Differential amplifier read pointer offset control."},
#else
{28, 31, 0x0000000000000000, "RW", "rk0_diffampenrdptroffset", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{27, 27, 0x0000000000000000, "RW", "bl_dqsdiffampenovrval", "Override value for DQS Diffamp enable - DQ Lane"},
#else
{27, 27, 0x0000000000000000, "RW", "bl_dqsdiffampenovrval", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{26, 26, 0x0000000000000000, "RW", "bl_dqsdiffampenovrsel", "Override select for DQS Diffamp enable - DQ Lane"},
#else
{26, 26, 0x0000000000000000, "RW", "bl_dqsdiffampenovrsel", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{25, 25, 0x0000000000000000, "RW", "bl_dqdmdiffampenovrval", "Override value for DQ/DM Diffamp enable - DQ Lane"},
#else
{25, 25, 0x0000000000000000, "RW", "bl_dqdmdiffampenovrval", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{24, 24, 0x0000000000000000, "RW", "bl_dqdmdiffampenovrsel", "Override select for DQ/DM Diffamp enable - DQ Lane"},
#else
{24, 24, 0x0000000000000000, "RW", "bl_dqdmdiffampenovrsel", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{22, 23, 0x0000000000000000, "RW", "bl_diffampenpst1", "This is the diffamp enable configuration register - postamble 1 -  new(rise & fall). [br]00 - Rise & Fall - Low & Low[br]01 - Rise & Fall - High & Low[br]10 - Rise & Fall - Low & High[br]11 - Rise & Fall - High & High"},
#else
{22, 23, 0x0000000000000000, "RW", "bl_diffampenpst1", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{20, 21, 0x0000000000000000, "RW", "bl_diffampenpre1", "This is the diffamp enable configuration register - preamble 1(rise & fall) [br]00 - Rise & Fall - Low & Low[br]01 - Rise & Fall - High & Low[br]10 - Rise & Fall - Low & High[br]11 - Rise & Fall - High & High"},
#else
{20, 21, 0x0000000000000000, "RW", "bl_diffampenpre1", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{18, 19, 0x0000000000000000, "RW", "bl_diffampenpst0", "This is the diffamp enable configuration register - postamble 0 - new(rise & fall)[br]00 - Rise & Fall - Low & Low[br]01 - Rise & Fall - High & Low[br]10 - Rise & Fall - Low & High[br]11 - Rise & Fall - High & High"},
#else
{18, 19, 0x0000000000000000, "RW", "bl_diffampenpst0", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{16, 17, 0x0000000000000000, "RW", "bl_diffampenpre0", "This is the diffamp enable configuration register - preamble 0(rise & fall) [br]00 - Rise & Fall - Low & Low[br]01 - Rise & Fall - High & Low[br]10 - Rise & Fall - Low & High[br]11 - Rise & Fall - High & High"},
#else
{16, 17, 0x0000000000000000, "RW", "bl_diffampenpre0", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{14, 15, 0x0000000000000000, "RO", "reserved548", "Reserved bits"},
#else
{14, 15, 0x0000000000000000, "RO", "reserved548", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{8, 13, 0x0000000000000000, "RW", "bl_diffampenlenbl4", "This is the diffamp enable length(number of 1x clock) configuration register."},
#else
{8, 13, 0x0000000000000000, "RW", "bl_diffampenlenbl4", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{6, 7, 0x0000000000000000, "RO", "reserved549", "Reserved bits"},
#else
{6, 7, 0x0000000000000000, "RO", "reserved549", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 5, 0x0000000000000000, "RW", "bl_rdcmd2diffampen", "This is the Diffamp enable latency register."},
#else
{0, 5, 0x0000000000000000, "RW", "bl_rdcmd2diffampen", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo366[] = {{"diffampctl_dq", "", 0x00000054, 13, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields367[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{26, 31, 0x0000000000000000, "RO", "reserved550", "Reserved bits"},
#else
{26, 31, 0x0000000000000000, "RO", "reserved550", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{25, 25, 0x0000000000000000, "RW", "cc_wrlvl", "Write Levelization enable - CC Byte Lane"},
#else
{25, 25, 0x0000000000000000, "RW", "cc_wrlvl", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{24, 24, 0x0000000000000000, "RW", "bl_wrlvl", "Write Levelization enable - BL Byte Labe"},
#else
{24, 24, 0x0000000000000000, "RW", "bl_wrlvl", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{16, 23, 0x0000000000000000, "RO", "wrlvl_sample_b1", "DQTRAINSTS - WRLVL sampling from all DQ bit lanes of Bytelane 1"},
#else
{16, 23, 0x0000000000000000, "RO", "wrlvl_sample_b1", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{8, 15, 0x0000000000000000, "RO", "wrlvl_sample_b0", "DQTRAINSTS - WRLVL sampling from all DQ bit lanes of Bytelane 0"},
#else
{8, 15, 0x0000000000000000, "RO", "wrlvl_sample_b0", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{4, 7, 0x0000000000000000, "RO", "reserved551", "Reserved bits"},
#else
{4, 7, 0x0000000000000000, "RO", "reserved551", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{3, 3, 0x0000000000000000, "RO", "wrlvl_and_sample_b1", "DQTRAINSTS - WRLVL Byte1 sample AND combination"},
#else
{3, 3, 0x0000000000000000, "RO", "wrlvl_and_sample_b1", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{2, 2, 0x0000000000000000, "RO", "wrlvl_and_sample_b0", "DQTRAINSTS - WRLVL Byte0 sample AND combination"},
#else
{2, 2, 0x0000000000000000, "RO", "wrlvl_and_sample_b0", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{1, 1, 0x0000000000000000, "RO", "wrlvl_or_sample_b1", "DQTRAINSTS - WRLVL Byte1 sample OR combination"},
#else
{1, 1, 0x0000000000000000, "RO", "wrlvl_or_sample_b1", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 0, 0x0000000000000000, "RO", "wrlvl_or_sample_b0", "DQTRAINSTS - WRLVL Byte0 sample OR combination"},
#else
{0, 0, 0x0000000000000000, "RO", "wrlvl_or_sample_b0", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo367[] = {{"wrlvl", "", 0x00000058, 10, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields368[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{20, 31, 0x0000000000000000, "RO", "reserved552", "Reserved bits"},
#else
{20, 31, 0x0000000000000000, "RO", "reserved552", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{19, 19, 0x0000000000000000, "RW", "dynreadsiggrpen", "Enable Dynamic SIGGRP 2x clock control. 1= SIGGRPEN  controlled by the dynamic clock gating logic (DYNDLLFSM), 0= Statically-controlled SIGGRPEN"},
#else
{19, 19, 0x0000000000000000, "RW", "dynreadsiggrpen", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{18, 18, 0x0000000000000000, "RW", "dynreadref2xclken", "Enable Dynamic REF2XCLK control. 1= ref2xclken  controlled by the dynamic clock gating logic (DYNDLLFSM), 0= Statically-controlled REF2XCLKEN"},
#else
{18, 18, 0x0000000000000000, "RW", "dynreadref2xclken", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{17, 17, 0x0000000000000000, "RW", "dynreadref1xclken", "TBD"},
#else
{17, 17, 0x0000000000000000, "RW", "dynreadref1xclken", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{16, 16, 0x0000000000000000, "RW", "dynreadspidclken", "TBD"},
#else
{16, 16, 0x0000000000000000, "RW", "dynreadspidclken", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{15, 15, 0x0000000000000000, "RO", "reserved553", "Reserved bits"},
#else
{15, 15, 0x0000000000000000, "RO", "reserved553", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{12, 14, 0x0000000000000000, "RW", "read_stoprden", "This is the delay in terms of clocks the dven is disabled before clock gated."},
#else
{12, 14, 0x0000000000000000, "RW", "read_stoprden", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{11, 11, 0x0000000000000000, "RO", "reserved554", "Reserved bits"},
#else
{11, 11, 0x0000000000000000, "RO", "reserved554", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{8, 10, 0x0000000000000000, "RW", "read_startrden", "This is the delay in terms of clocks the drven is enabled, once wrcmd/rdcmd is received."},
#else
{8, 10, 0x0000000000000000, "RW", "read_startrden", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{6, 7, 0x0000000000000000, "RO", "reserved555", "Reserved bits"},
#else
{6, 7, 0x0000000000000000, "RO", "reserved555", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 5, 0x000000000000003F, "RW", "readclkgate_maxcntr", "Clock Gating register : IDLE timer counter max value for clock gating on tx/rx . Counter timeout based on last WRCMD/RDCMD received. 6 bits are good enough since it increments in spidclk."},
#else
{0, 5, 0x000000000000003F, "RW", "readclkgate_maxcntr", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo368[] = {{"clkgaterdctl", "", 0x0000005C, 11, 0x00000000FFFFFFFF, 0x000000000000003F}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields369[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{20, 31, 0x0000000000000000, "RO", "reserved556", "Reserved bits"},
#else
{20, 31, 0x0000000000000000, "RO", "reserved556", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{19, 19, 0x0000000000000000, "RW", "dynwritesiggrpen", "Enable Dynamic SIGGRP 2x clock control. 1= SIGGRPEN  controlled by the dynamic clock gating logic (DYNDLLFSM), 0= Statically-controlled SIGGRPEN"},
#else
{19, 19, 0x0000000000000000, "RW", "dynwritesiggrpen", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{18, 18, 0x0000000000000000, "RW", "dynwriteref2xclken", "Enable Dynamic REF2XCLK control. 1= ref2xclken  controlled by the dynamic clock gating logic (DYNDLLFSM), 0= Statically-controlled REF2XCLKEN"},
#else
{18, 18, 0x0000000000000000, "RW", "dynwriteref2xclken", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{17, 17, 0x0000000000000000, "RW", "dynwriteref1xclken", "TBD"},
#else
{17, 17, 0x0000000000000000, "RW", "dynwriteref1xclken", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{16, 16, 0x0000000000000000, "RW", "dynwritespidclken", "TBD"},
#else
{16, 16, 0x0000000000000000, "RW", "dynwritespidclken", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{15, 15, 0x0000000000000000, "RO", "reserved557", "Reserved bits"},
#else
{15, 15, 0x0000000000000000, "RO", "reserved557", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{12, 14, 0x0000000000000000, "RW", "write_stopdrv", "This is the delay in terms of clocks the dven is disabled before clock gated."},
#else
{12, 14, 0x0000000000000000, "RW", "write_stopdrv", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{11, 11, 0x0000000000000000, "RO", "reserved558", "Reserved bits"},
#else
{11, 11, 0x0000000000000000, "RO", "reserved558", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{8, 10, 0x0000000000000000, "RW", "write_startdrv", "This is the delay in terms of clocks the drven is enabled, once wrcmd/rdcmd is received."},
#else
{8, 10, 0x0000000000000000, "RW", "write_startdrv", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{6, 7, 0x0000000000000000, "RO", "reserved559", "Reserved bits"},
#else
{6, 7, 0x0000000000000000, "RO", "reserved559", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 5, 0x000000000000003F, "RW", "writeclkgate_maxcntr", "Clock Gating register : IDLE timer counter max value for clock gating on tx/rx . Counter timeout based on last WRCMD/RDCMD received. 6 bits are good enough since it increments in spidclk."},
#else
{0, 5, 0x000000000000003F, "RW", "writeclkgate_maxcntr", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo369[] = {{"clkgatewrctl", "", 0x00000060, 11, 0x00000000FFFFFFFF, 0x000000000000003F}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields370[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{20, 31, 0x0000000000000000, "RO", "reserved560", "Reserved bits"},
#else
{20, 31, 0x0000000000000000, "RO", "reserved560", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{19, 19, 0x0000000000000000, "RW", "dynsiggrpen", "Enable Dynamic SIGGRP 2x clock control. 1= SIGGRPEN  controlled by the dynamic clock gating logic (DYNDLLFSM), 0= Statically-controlled SIGGRPEN"},
#else
{19, 19, 0x0000000000000000, "RW", "dynsiggrpen", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{18, 18, 0x0000000000000000, "RW", "dynref2xclken", "Enable Dynamic REF2XCLK control. 1= ref2xclken  controlled by the dynamic clock gating logic (DYNDLLFSM), 0= Statically-controlled REF2XCLKEN"},
#else
{18, 18, 0x0000000000000000, "RW", "dynref2xclken", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{17, 17, 0x0000000000000000, "RW", "dynref1xclken", "TBD"},
#else
{17, 17, 0x0000000000000000, "RW", "dynref1xclken", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{16, 16, 0x0000000000000000, "RW", "dynspidclken", "TBD"},
#else
{16, 16, 0x0000000000000000, "RW", "dynspidclken", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{6, 15, 0x0000000000000000, "RO", "reserved561", "Reserved bits"},
#else
{6, 15, 0x0000000000000000, "RO", "reserved561", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 5, 0x000000000000003F, "RW", "clkgate_maxcntr", "Clock Gating register : IDLE timer counter max value for clock gating on tx/rx . Counter timeout based on last WRCMD/RDCMD received. 6 bits are good enough since it increments in spidclk."},
#else
{0, 5, 0x000000000000003F, "RW", "clkgate_maxcntr", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo370[] = {{"clkgatectl", "", 0x00000064, 7, 0x00000000FFFFFFFF, 0x000000000000003F}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields371[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{30, 31, 0x0000000000000000, "RO", "reserved562", "Reserved bits"},
#else
{30, 31, 0x0000000000000000, "RO", "reserved562", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{28, 29, 0x0000000000000000, "RO", "reserved563", "Reserved bits"},
#else
{28, 29, 0x0000000000000000, "RO", "reserved563", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{24, 27, 0x0000000000000000, "RO", "reserved564", "Reserved bits"},
#else
{24, 27, 0x0000000000000000, "RO", "reserved564", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{16, 23, 0x0000000000000000, "RO", "reserved565", "Reserved bits"},
#else
{16, 23, 0x0000000000000000, "RO", "reserved565", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{14, 15, 0x0000000000000000, "RO", "reserved566", "Reserved bits"},
#else
{14, 15, 0x0000000000000000, "RO", "reserved566", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{12, 13, 0x0000000000000000, "RW", "txdll_rk0siggrp05dbsel", "Deadband select for sig group 5 rank 0"},
#else
{12, 13, 0x0000000000000000, "RW", "txdll_rk0siggrp05dbsel", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{8, 11, 0x0000000000000000, "RW", "txdll_rk0siggrp05rdptroffset", "Read pointer offset for sig group 5 rank 0"},
#else
{8, 11, 0x0000000000000000, "RW", "txdll_rk0siggrp05rdptroffset", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 7, 0x0000000000000000, "RW", "txdll_rk0siggrp05picode", "PI code for sig group 5 rank 0"},
#else
{0, 7, 0x0000000000000000, "RW", "txdll_rk0siggrp05picode", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo371[] = {{"txdllsiggrp5ctl", "", 0x00000068, 8, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields372[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{30, 31, 0x0000000000000000, "RO", "reserved567", "Reserved bits"},
#else
{30, 31, 0x0000000000000000, "RO", "reserved567", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{28, 29, 0x0000000000000000, "RO", "reserved568", "Reserved bits"},
#else
{28, 29, 0x0000000000000000, "RO", "reserved568", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{24, 27, 0x0000000000000000, "RO", "reserved569", "Reserved bits"},
#else
{24, 27, 0x0000000000000000, "RO", "reserved569", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{16, 23, 0x0000000000000000, "RO", "reserved570", "Reserved bits"},
#else
{16, 23, 0x0000000000000000, "RO", "reserved570", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{14, 15, 0x0000000000000000, "RO", "reserved571", "Reserved bits"},
#else
{14, 15, 0x0000000000000000, "RO", "reserved571", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{12, 13, 0x0000000000000000, "RW", "txdll_rk0siggrp04dbsel", "Deadband select for sig group 4 rank 0"},
#else
{12, 13, 0x0000000000000000, "RW", "txdll_rk0siggrp04dbsel", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{8, 11, 0x0000000000000000, "RW", "txdll_rk0siggrp04rdptroffset", "Read pointer offset for sig group 4 rank 0"},
#else
{8, 11, 0x0000000000000000, "RW", "txdll_rk0siggrp04rdptroffset", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 7, 0x0000000000000000, "RW", "txdll_rk0siggrp04picode", "PI code for sig group 4 rank 0"},
#else
{0, 7, 0x0000000000000000, "RW", "txdll_rk0siggrp04picode", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo372[] = {{"txdllsiggrp4ctl", "", 0x0000006C, 8, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields373[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{30, 31, 0x0000000000000000, "RO", "reserved572", "Reserved bits"},
#else
{30, 31, 0x0000000000000000, "RO", "reserved572", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{28, 29, 0x0000000000000000, "RO", "reserved573", "Reserved bits"},
#else
{28, 29, 0x0000000000000000, "RO", "reserved573", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{24, 27, 0x0000000000000000, "RO", "reserved574", "Reserved bits"},
#else
{24, 27, 0x0000000000000000, "RO", "reserved574", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{16, 23, 0x0000000000000000, "RO", "reserved575", "Reserved bits"},
#else
{16, 23, 0x0000000000000000, "RO", "reserved575", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{14, 15, 0x0000000000000000, "RO", "reserved576", "Reserved bits"},
#else
{14, 15, 0x0000000000000000, "RO", "reserved576", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{12, 13, 0x0000000000000000, "RW", "txdll_rk0siggrp03dbsel", "Deadband select for sig group 3 rank 0"},
#else
{12, 13, 0x0000000000000000, "RW", "txdll_rk0siggrp03dbsel", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{8, 11, 0x0000000000000000, "RW", "txdll_rk0siggrp03rdptroffset", "Read pointer offset for sig group 3 rank 0"},
#else
{8, 11, 0x0000000000000000, "RW", "txdll_rk0siggrp03rdptroffset", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 7, 0x0000000000000000, "RW", "txdll_rk0siggrp03picode", "PI code for sig group 3 rank 0"},
#else
{0, 7, 0x0000000000000000, "RW", "txdll_rk0siggrp03picode", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo373[] = {{"txdllsiggrp3ctl", "", 0x00000070, 8, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields374[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{30, 31, 0x0000000000000000, "RO", "reserved577", "Reserved bits"},
#else
{30, 31, 0x0000000000000000, "RO", "reserved577", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{28, 29, 0x0000000000000000, "RW", "txdll_rk1siggrp02dbsel", "Deadband select for sig group 2 rank 1"},
#else
{28, 29, 0x0000000000000000, "RW", "txdll_rk1siggrp02dbsel", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{24, 27, 0x0000000000000000, "RW", "txdll_rk1siggrp02rdptroffset", "Read pointer offset for sig group 2 rank 1"},
#else
{24, 27, 0x0000000000000000, "RW", "txdll_rk1siggrp02rdptroffset", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{16, 23, 0x0000000000000000, "RW", "txdll_rk1siggrp02picode", "PI code for sig group 2 rank 1"},
#else
{16, 23, 0x0000000000000000, "RW", "txdll_rk1siggrp02picode", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{14, 15, 0x0000000000000000, "RO", "reserved578", "Reserved bits"},
#else
{14, 15, 0x0000000000000000, "RO", "reserved578", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{12, 13, 0x0000000000000000, "RW", "txdll_rk0siggrp02dbsel", "Deadband select for sig group 2 rank 0"},
#else
{12, 13, 0x0000000000000000, "RW", "txdll_rk0siggrp02dbsel", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{8, 11, 0x0000000000000000, "RW", "txdll_rk0siggrp02rdptroffset", "Read pointer offset for sig group 2 rank 0"},
#else
{8, 11, 0x0000000000000000, "RW", "txdll_rk0siggrp02rdptroffset", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 7, 0x0000000000000000, "RW", "txdll_rk0siggrp02picode", "PI code for sig group 2 rank 0"},
#else
{0, 7, 0x0000000000000000, "RW", "txdll_rk0siggrp02picode", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo374[] = {{"txdllsiggrp2ctl", "", 0x00000074, 8, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields375[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{30, 31, 0x0000000000000000, "RO", "reserved579", "Reserved bits"},
#else
{30, 31, 0x0000000000000000, "RO", "reserved579", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{28, 29, 0x0000000000000000, "RW", "txdll_rk1siggrp01dbsel", "Deadband select for sig group 1 rank 1"},
#else
{28, 29, 0x0000000000000000, "RW", "txdll_rk1siggrp01dbsel", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{24, 27, 0x0000000000000000, "RW", "txdll_rk1siggrp01rdptroffset", "Read pointer offset for sig group 1 rank 1"},
#else
{24, 27, 0x0000000000000000, "RW", "txdll_rk1siggrp01rdptroffset", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{16, 23, 0x0000000000000000, "RW", "txdll_rk1siggrp01picode", "PI code for sig group 1 rank 1"},
#else
{16, 23, 0x0000000000000000, "RW", "txdll_rk1siggrp01picode", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{14, 15, 0x0000000000000000, "RO", "reserved580", "Reserved bits"},
#else
{14, 15, 0x0000000000000000, "RO", "reserved580", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{12, 13, 0x0000000000000000, "RW", "txdll_rk0siggrp01dbsel", "Deadband select for sig group 1 rank 0"},
#else
{12, 13, 0x0000000000000000, "RW", "txdll_rk0siggrp01dbsel", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{8, 11, 0x0000000000000000, "RW", "txdll_rk0siggrp01rdptroffset", "Read pointer offset for sig group 1 rank 0"},
#else
{8, 11, 0x0000000000000000, "RW", "txdll_rk0siggrp01rdptroffset", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 7, 0x0000000000000000, "RW", "txdll_rk0siggrp01picode", "PI code for sig group 1 rank 0"},
#else
{0, 7, 0x0000000000000000, "RW", "txdll_rk0siggrp01picode", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo375[] = {{"txdllsiggrp1ctl", "", 0x00000078, 8, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields376[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{28, 31, 0x0000000000000000, "RO", "reserved581", "Reserved bits"},
#else
{28, 31, 0x0000000000000000, "RO", "reserved581", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{24, 27, 0x0000000000000000, "RW", "txdll_rk1siggrp00rdptroffset", "Read pointer offset for sig group 0 rank 1"},
#else
{24, 27, 0x0000000000000000, "RW", "txdll_rk1siggrp00rdptroffset", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{16, 23, 0x0000000000000000, "RW", "txdll_rk1siggrp00picode", "PI code for sig group 0 rank 1"},
#else
{16, 23, 0x0000000000000000, "RW", "txdll_rk1siggrp00picode", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{12, 15, 0x0000000000000000, "RO", "reserved582", "Reserved bits"},
#else
{12, 15, 0x0000000000000000, "RO", "reserved582", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{8, 11, 0x0000000000000000, "RW", "txdll_rk0siggrp00rdptroffset", "Read pointer offset for sig group 0 rank 0"},
#else
{8, 11, 0x0000000000000000, "RW", "txdll_rk0siggrp00rdptroffset", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 7, 0x0000000000000000, "RW", "txdll_rk0siggrp00picode", "PI code for sig group 0 rank 0"},
#else
{0, 7, 0x0000000000000000, "RW", "txdll_rk0siggrp00picode", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo376[] = {{"txdllsiggrp0ctl", "", 0x0000007C, 6, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields377[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{31, 31, 0x0000000000000000, "RO", "reserved583", "Reserved bits"},
#else
{31, 31, 0x0000000000000000, "RO", "reserved583", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{30, 30, 0x0000000000000000, "RW", "lvl_cc_weakpupstatic", "Weak Pull Up Control - CC Lane"},
#else
{30, 30, 0x0000000000000000, "RW", "lvl_cc_weakpupstatic", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{24, 29, 0x0000000000000000, "RW", "lvl_cc_weakpup", "Weak Pull Up Control - CC Lane"},
#else
{24, 29, 0x0000000000000000, "RW", "lvl_cc_weakpup", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{23, 23, 0x0000000000000000, "RO", "reserved584", "Reserved bits"},
#else
{23, 23, 0x0000000000000000, "RO", "reserved584", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{22, 22, 0x0000000000000000, "RW", "lvl_cc_weakpdnstatic", "Weak Pull Down Control - CC Lane"},
#else
{22, 22, 0x0000000000000000, "RW", "lvl_cc_weakpdnstatic", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{16, 21, 0x0000000000000000, "RW", "lvl_cc_weakpdn", "Weak Pull Down Control - CC Lane"},
#else
{16, 21, 0x0000000000000000, "RW", "lvl_cc_weakpdn", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{15, 15, 0x0000000000000000, "RO", "reserved585", "Reserved bits"},
#else
{15, 15, 0x0000000000000000, "RO", "reserved585", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{14, 14, 0x0000000000000000, "RW", "lvl_bl_weakpupstatic", "Weak Pull Up Control static bit for DQS - DQ Lane"},
#else
{14, 14, 0x0000000000000000, "RW", "lvl_bl_weakpupstatic", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{8, 13, 0x0000000000000000, "RW", "lvl_bl_weakpup", "Weak Pull Up Control code for DQS - DQ Lane"},
#else
{8, 13, 0x0000000000000000, "RW", "lvl_bl_weakpup", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{7, 7, 0x0000000000000000, "RO", "reserved586", "Reserved bits"},
#else
{7, 7, 0x0000000000000000, "RO", "reserved586", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{6, 6, 0x0000000000000000, "RW", "lvl_bl_weakpdnstatic", "Weak Pull Down Control static bit for DQS - DQ Lane"},
#else
{6, 6, 0x0000000000000000, "RW", "lvl_bl_weakpdnstatic", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 5, 0x0000000000000000, "RW", "lvl_bl_weakpdn", "Weak Pull Down Control code for DQS - DQ Lane"},
#else
{0, 5, 0x0000000000000000, "RW", "lvl_bl_weakpdn", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo377[] = {{"wkpuppdnctl", "", 0x00000080, 12, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields378[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{31, 31, 0x0000000000000000, "RO", "reserved587", "Reserved bits"},
#else
{31, 31, 0x0000000000000000, "RO", "reserved587", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{28, 30, 0x0000000000000007, "RW", "dtx_cc_drvsegen", "Segment enable for CC buffer. Used for per leg testing in HVM"},
#else
{28, 30, 0x0000000000000007, "RW", "dtx_cc_drvsegen", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{27, 27, 0x0000000000000000, "RO", "reserved588", "Reserved bits"},
#else
{27, 27, 0x0000000000000000, "RO", "reserved588", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{24, 26, 0x0000000000000007, "RW", "tx_cc_drvsegen", "Segment enable for CC buffer. Used for per leg testing in HVM"},
#else
{24, 26, 0x0000000000000007, "RW", "tx_cc_drvsegen", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{23, 23, 0x0000000000000000, "RO", "reserved589", "Reserved bits"},
#else
{23, 23, 0x0000000000000000, "RO", "reserved589", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{20, 22, 0x0000000000000007, "RW", "dtx_bl_drvsegen", "Segment enable for CC buffer. Used for per leg testing in HVM"},
#else
{20, 22, 0x0000000000000007, "RW", "dtx_bl_drvsegen", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{19, 19, 0x0000000000000000, "RO", "reserved590", "Reserved bits"},
#else
{19, 19, 0x0000000000000000, "RO", "reserved590", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{16, 18, 0x0000000000000007, "RW", "tx_bl_drvsegen", "Segment enable for CC buffer. Used for per leg testing in HVM"},
#else
{16, 18, 0x0000000000000007, "RW", "tx_bl_drvsegen", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{15, 15, 0x0000000000000000, "RO", "reserved591", "Reserved bits"},
#else
{15, 15, 0x0000000000000000, "RO", "reserved591", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{12, 14, 0x0000000000000001, "RW", "rxdll_cc_picapsel", "set cap tuning for pi"},
#else
{12, 14, 0x0000000000000001, "RW", "rxdll_cc_picapsel", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{11, 11, 0x0000000000000000, "RO", "reserved592", "Reserved bits"},
#else
{11, 11, 0x0000000000000000, "RO", "reserved592", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{8, 10, 0x0000000000000001, "RW", "rxdll_bl_picapsel", "set cap tuning for pi"},
#else
{8, 10, 0x0000000000000001, "RW", "rxdll_bl_picapsel", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{7, 7, 0x0000000000000000, "RO", "reserved593", "Reserved bits"},
#else
{7, 7, 0x0000000000000000, "RO", "reserved593", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{4, 6, 0x0000000000000001, "RW", "txdll_picapsel", "set cap tuning for pi"},
#else
{4, 6, 0x0000000000000001, "RW", "txdll_picapsel", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{3, 3, 0x0000000000000000, "RW", "dtx_cc_allfire", "Bypasses slewrate staggering"},
#else
{3, 3, 0x0000000000000000, "RW", "dtx_cc_allfire", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{2, 2, 0x0000000000000000, "RW", "dtx_bl_allfire", "Bypasses slewrate staggering"},
#else
{2, 2, 0x0000000000000000, "RW", "dtx_bl_allfire", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{1, 1, 0x0000000000000000, "RW", "tx_cc_allfire", "Bypasses slewrate staggering"},
#else
{1, 1, 0x0000000000000000, "RW", "tx_cc_allfire", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 0, 0x0000000000000000, "RW", "tx_bl_allfire", "Bypasses slewrate staggering"},
#else
{0, 0, 0x0000000000000000, "RW", "tx_bl_allfire", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo378[] = {{"afemisc1", "", 0x00000084, 18, 0x00000000FFFFFFFF, 0x0000000077771110}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields379[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{30, 31, 0x0000000000000000, "RW", "dtx_cc_drvenstretch", "Streches rising edge of drivenable to relax data to enable skew."},
#else
{30, 31, 0x0000000000000000, "RW", "dtx_cc_drvenstretch", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{28, 29, 0x0000000000000000, "RW", "dtx_bl_drvenstretch", "Streches rising edge of drivenable to relax data to enable skew."},
#else
{28, 29, 0x0000000000000000, "RW", "dtx_bl_drvenstretch", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{26, 27, 0x0000000000000000, "RW", "tx_cc_drvenstretch", "Streches rising edge of drivenable to relax data to enable skew."},
#else
{26, 27, 0x0000000000000000, "RW", "tx_cc_drvenstretch", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{24, 25, 0x0000000000000000, "RW", "tx_bl_drvenstretch", "Streches rising edge of drivenable to relax data to enable skew."},
#else
{24, 25, 0x0000000000000000, "RW", "tx_bl_drvenstretch", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{22, 23, 0x0000000000000001, "RW", "drx_cc_rxpwrmode", "00 = low power rx;[br]01 = high power rx (default)"},
#else
{22, 23, 0x0000000000000001, "RW", "drx_cc_rxpwrmode", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{20, 21, 0x0000000000000001, "RW", "rx_cc_rxpwrmode", "00 = low power rx;[br]01 = high power rx (default)"},
#else
{20, 21, 0x0000000000000001, "RW", "rx_cc_rxpwrmode", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{18, 19, 0x0000000000000001, "RW", "drx_bl_rxpwrmode", "00 = low power rx;[br]01 = high power rx (default)"},
#else
{18, 19, 0x0000000000000001, "RW", "drx_bl_rxpwrmode", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{16, 17, 0x0000000000000001, "RW", "rx_bl_rxpwrmode", "00 = low power rx;[br]01 = high power rx (default)"},
#else
{16, 17, 0x0000000000000001, "RW", "rx_bl_rxpwrmode", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{12, 15, 0x0000000000000000, "RO", "reserved594", "Reserved bits"},
#else
{12, 15, 0x0000000000000000, "RO", "reserved594", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{11, 11, 0x0000000000000001, "RW", "drx_cc_rxcommonmode", "changes the common mode of receiver from low common mode to vcc/2 based on lpddr3/ lpddr4."},
#else
{11, 11, 0x0000000000000001, "RW", "drx_cc_rxcommonmode", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{10, 10, 0x0000000000000001, "RW", "drx_bl_rxcommonmode", "changes the common mode of receiver from low common mode to vcc/2 based on lpddr3/ lpddr4."},
#else
{10, 10, 0x0000000000000001, "RW", "drx_bl_rxcommonmode", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{9, 9, 0x0000000000000001, "RW", "rx_cc_rxcommonmode", "changes the common mode of receiver from low common mode to vcc/2 based on lpddr3/ lpddr4."},
#else
{9, 9, 0x0000000000000001, "RW", "rx_cc_rxcommonmode", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{8, 8, 0x0000000000000001, "RW", "rx_bl_rxcommonmode", "changes the common mode of receiver from low common mode to vcc/2 based on lpddr3/ lpddr4."},
#else
{8, 8, 0x0000000000000001, "RW", "rx_bl_rxcommonmode", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{7, 7, 0x0000000000000001, "RW", "pdndrvstatic", "Static pull down code - DRV DQ"},
#else
{7, 7, 0x0000000000000001, "RW", "pdndrvstatic", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{6, 6, 0x0000000000000001, "RW", "pdndrvstaticdqs", "Static pull down code - DRV DQS/DQSB"},
#else
{6, 6, 0x0000000000000001, "RW", "pdndrvstaticdqs", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{5, 5, 0x0000000000000001, "RW", "pdnodtstatic", "Static pull down code - ODT DQ"},
#else
{5, 5, 0x0000000000000001, "RW", "pdnodtstatic", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{4, 4, 0x0000000000000001, "RW", "pdnodtstaticdqs", "Static pull down code - ODT DQS/DQSB"},
#else
{4, 4, 0x0000000000000001, "RW", "pdnodtstaticdqs", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{3, 3, 0x0000000000000001, "RW", "pupdrvstatic", "Static pull up code - DRV DQ"},
#else
{3, 3, 0x0000000000000001, "RW", "pupdrvstatic", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{2, 2, 0x0000000000000001, "RW", "pupdrvstaticdqs", "Static pull up code - DRV DQS/DQSB"},
#else
{2, 2, 0x0000000000000001, "RW", "pupdrvstaticdqs", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{1, 1, 0x0000000000000001, "RW", "pupodtstatic", "Static pull up code - ODT DQ"},
#else
{1, 1, 0x0000000000000001, "RW", "pupodtstatic", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 0, 0x0000000000000001, "RW", "pupodtstaticdqs", "Static pull up code - ODT DQS/DQSB"},
#else
{0, 0, 0x0000000000000001, "RW", "pupodtstaticdqs", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo379[] = {{"afemisc0", "", 0x00000088, 21, 0x00000000FFFFFFFF, 0x0000000000550FFF}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields380[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{8, 31, 0x0000000000000000, "RO", "reserved595", "Reserved bits"},
#else
{8, 31, 0x0000000000000000, "RO", "reserved595", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{4, 7, 0x0000000000000000, "RW", "lvl_cc_bonus", "Bonus bits - CC Lane"},
#else
{4, 7, 0x0000000000000000, "RW", "lvl_cc_bonus", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 3, 0x0000000000000000, "RW", "lvl_bl_bonus", "Bonus bits - DQ Lane"},
#else
{0, 3, 0x0000000000000000, "RW", "lvl_bl_bonus", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo380[] = {{"afebonus", "", 0x0000008C, 3, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields381[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{28, 31, 0x0000000000000000, "RW", "txdll_digobs1sel", "Digital observation select mux port 1"},
#else
{28, 31, 0x0000000000000000, "RW", "txdll_digobs1sel", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{24, 27, 0x0000000000000000, "RW", "txdll_digobs0sel", "Digital observation select mux port 0"},
#else
{24, 27, 0x0000000000000000, "RW", "txdll_digobs0sel", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{23, 23, 0x0000000000000000, "RW", "rxdll_cc_digobsen", "digital buf obs enable (1=enable;0=disable)"},
#else
{23, 23, 0x0000000000000000, "RW", "rxdll_cc_digobsen", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{22, 22, 0x0000000000000000, "RW", "rxdll_bl_digobsen", "digital buf obs enable (1=enable;0=disable)"},
#else
{22, 22, 0x0000000000000000, "RW", "rxdll_bl_digobsen", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{21, 21, 0x0000000000000000, "RW", "dtx_cc_digobsen", "digital buf obs enable (1=enable;0=disable)"},
#else
{21, 21, 0x0000000000000000, "RW", "dtx_cc_digobsen", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{20, 20, 0x0000000000000000, "RO", "reserved596", "Reserved bits"},
#else
{20, 20, 0x0000000000000000, "RO", "reserved596", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{19, 19, 0x0000000000000000, "RW", "txdll_digobsen", "digital buf obs enable (1=enable;0=disable)"},
#else
{19, 19, 0x0000000000000000, "RW", "txdll_digobsen", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{18, 18, 0x0000000000000000, "RW", "dtx_bl_digobsen", "digital buf obs enable (1=enable;0=disable)"},
#else
{18, 18, 0x0000000000000000, "RW", "dtx_bl_digobsen", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{16, 17, 0x0000000000000000, "RO", "reserved597", "Reserved bits"},
#else
{16, 17, 0x0000000000000000, "RO", "reserved597", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{12, 15, 0x0000000000000000, "RW", "rxdll_bl_digobs1sel", "Digital observation select mux port 1"},
#else
{12, 15, 0x0000000000000000, "RW", "rxdll_bl_digobs1sel", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{8, 11, 0x0000000000000000, "RW", "rxdll_bl_digobs0sel", "Digital observation select mux port 0"},
#else
{8, 11, 0x0000000000000000, "RW", "rxdll_bl_digobs0sel", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{4, 7, 0x0000000000000000, "RW", "rxdll_cc_digobs1sel", "Digital observation select mux port 1"},
#else
{4, 7, 0x0000000000000000, "RW", "rxdll_cc_digobs1sel", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 3, 0x0000000000000000, "RW", "rxdll_cc_digobs0sel", "Digital observation select mux port 0"},
#else
{0, 3, 0x0000000000000000, "RW", "rxdll_cc_digobs0sel", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo381[] = {{"digobsctl1", "", 0x00000090, 13, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields382[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{31, 31, 0x0000000000000000, "RO", "reserved598", "Reserved bits"},
#else
{31, 31, 0x0000000000000000, "RO", "reserved598", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{28, 30, 0x0000000000000000, "RW", "dtx_cc_digobs1sel", "Digital observation select mux port 1"},
#else
{28, 30, 0x0000000000000000, "RW", "dtx_cc_digobs1sel", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{27, 27, 0x0000000000000000, "RO", "reserved599", "Reserved bits"},
#else
{27, 27, 0x0000000000000000, "RO", "reserved599", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{24, 26, 0x0000000000000000, "RW", "dtx_cc_digobs0sel", "Digital observation select mux port 0"},
#else
{24, 26, 0x0000000000000000, "RW", "dtx_cc_digobs0sel", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{23, 23, 0x0000000000000000, "RO", "reserved600", "Reserved bits"},
#else
{23, 23, 0x0000000000000000, "RO", "reserved600", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{20, 22, 0x0000000000000000, "RW", "dtx_bl_digobs1sel", "Digital observation select mux port 1"},
#else
{20, 22, 0x0000000000000000, "RW", "dtx_bl_digobs1sel", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{19, 19, 0x0000000000000000, "RO", "reserved601", "Reserved bits"},
#else
{19, 19, 0x0000000000000000, "RO", "reserved601", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{16, 18, 0x0000000000000000, "RW", "dtx_bl_digobs0sel", "Digital observation select mux port 0"},
#else
{16, 18, 0x0000000000000000, "RW", "dtx_bl_digobs0sel", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{15, 15, 0x0000000000000000, "RO", "reserved602", "Reserved bits"},
#else
{15, 15, 0x0000000000000000, "RO", "reserved602", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{12, 14, 0x0000000000000000, "RW", "tx_cc_digobs1sel", "Digital observation select mux port 1"},
#else
{12, 14, 0x0000000000000000, "RW", "tx_cc_digobs1sel", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{11, 11, 0x0000000000000000, "RO", "reserved603", "Reserved bits"},
#else
{11, 11, 0x0000000000000000, "RO", "reserved603", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{8, 10, 0x0000000000000000, "RW", "tx_cc_digobs0sel", "Digital observation select mux port 0"},
#else
{8, 10, 0x0000000000000000, "RW", "tx_cc_digobs0sel", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{7, 7, 0x0000000000000000, "RO", "reserved604", "Reserved bits"},
#else
{7, 7, 0x0000000000000000, "RO", "reserved604", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{4, 6, 0x0000000000000000, "RW", "tx_bl_digobs1sel", "Digital observation select mux port 1"},
#else
{4, 6, 0x0000000000000000, "RW", "tx_bl_digobs1sel", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{3, 3, 0x0000000000000000, "RO", "reserved605", "Reserved bits"},
#else
{3, 3, 0x0000000000000000, "RO", "reserved605", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 2, 0x0000000000000000, "RW", "tx_bl_digobs0sel", "Digital observation select mux port 0"},
#else
{0, 2, 0x0000000000000000, "RW", "tx_bl_digobs0sel", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo382[] = {{"digobsctl0", "", 0x00000094, 16, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields383[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{29, 31, 0x0000000000000000, "RO", "reserved606", "Reserved bits"},
#else
{29, 31, 0x0000000000000000, "RO", "reserved606", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{24, 28, 0x0000000000000000, "RW", "rxdll_rxmuxsel", "enable strobe output from rx sdll.for each byte"},
#else
{24, 28, 0x0000000000000000, "RW", "rxdll_rxmuxsel", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{22, 23, 0x0000000000000000, "RO", "reserved607", "enable strobe output from rx sdll.for each byte"},
#else
{22, 23, 0x0000000000000000, "RO", "reserved607", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{21, 21, 0x0000000000000000, "RW", "txdll_dllfloprstb", "TxDLL flop reset"},
#else
{21, 21, 0x0000000000000000, "RW", "txdll_dllfloprstb", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{20, 20, 0x0000000000000000, "RW", "rxdll_dllfloprstb", "RxDLL flop reset"},
#else
{20, 20, 0x0000000000000000, "RW", "rxdll_dllfloprstb", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{19, 19, 0x0000000000000000, "RO", "reserved608", "enable strobe output from rx sdll.for each byte"},
#else
{19, 19, 0x0000000000000000, "RO", "reserved608", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{18, 18, 0x0000000000000000, "RW", "rxdll_bl_dqsouten", "enable strobe output from rx sdll.for each byte"},
#else
{18, 18, 0x0000000000000000, "RW", "rxdll_bl_dqsouten", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{17, 17, 0x0000000000000000, "RO", "reserved609", "enable data output from dq and dm pi's. for each byte"},
#else
{17, 17, 0x0000000000000000, "RO", "reserved609", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{16, 16, 0x0000000000000000, "RW", "rxdll_bl_rxdllen", "Rx DLL enable"},
#else
{16, 16, 0x0000000000000000, "RW", "rxdll_bl_rxdllen", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 15, 0x0000000000000000, "RO", "reserved610", "Reserved bits"},
#else
{0, 15, 0x0000000000000000, "RO", "reserved610", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo383[] = {{"rxdllctl_dqbldm", "", 0x00000098, 10, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields384[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{19, 31, 0x0000000000000000, "RO", "reserved611", "Reserved bits"},
#else
{19, 31, 0x0000000000000000, "RO", "reserved611", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{18, 18, 0x0000000000000000, "RW", "rxdll_cc_dqsouten", "enable strobe output from rx sdll.for each byte"},
#else
{18, 18, 0x0000000000000000, "RW", "rxdll_cc_dqsouten", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{17, 17, 0x0000000000000000, "RO", "reserved612", "enable data output from dq and dm pi's. for each byte"},
#else
{17, 17, 0x0000000000000000, "RO", "reserved612", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{16, 16, 0x0000000000000000, "RW", "rxdll_cc_rxdllen", "Rx DLL enable"},
#else
{16, 16, 0x0000000000000000, "RW", "rxdll_cc_rxdllen", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{1, 15, 0x0000000000000000, "RO", "reserved613", "Reserved bits"},
#else
{1, 15, 0x0000000000000000, "RO", "reserved613", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 0, 0x0000000000000000, "RW", "txdll_ref2xph0pien", "enable tx ref pi phase 0 enable"},
#else
{0, 0, 0x0000000000000000, "RW", "txdll_ref2xph0pien", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo384[] = {{"rxdllctl_ccbldm", "", 0x0000009C, 6, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields385[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{18, 31, 0x0000000000000000, "RO", "reserved614", "Reserved bits"},
#else
{18, 31, 0x0000000000000000, "RO", "reserved614", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{17, 17, 0x0000000000000000, "RO", "reserved615", "Reserved bits"},
#else
{17, 17, 0x0000000000000000, "RO", "reserved615", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{16, 16, 0x0000000000000000, "RW", "txdll_mdllen", "MDLL enable"},
#else
{16, 16, 0x0000000000000000, "RW", "txdll_mdllen", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{14, 15, 0x0000000000000000, "RO", "reserved616", "Reserved bits"},
#else
{14, 15, 0x0000000000000000, "RO", "reserved616", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{13, 13, 0x0000000000000000, "RW", "txdll_siggrp05pien", "PI enable for sig group 5 rank 0"},
#else
{13, 13, 0x0000000000000000, "RW", "txdll_siggrp05pien", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{12, 12, 0x0000000000000000, "RW", "txdll_siggrp04pien", "PI enable for sig group 4 rank 0"},
#else
{12, 12, 0x0000000000000000, "RW", "txdll_siggrp04pien", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{11, 11, 0x0000000000000000, "RW", "txdll_siggrp03pien", "PI enable for sig group 3 rank 0"},
#else
{11, 11, 0x0000000000000000, "RW", "txdll_siggrp03pien", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{10, 10, 0x0000000000000000, "RW", "txdll_siggrp02pien", "PI enable for sig group 2 rank 0"},
#else
{10, 10, 0x0000000000000000, "RW", "txdll_siggrp02pien", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{9, 9, 0x0000000000000000, "RW", "txdll_siggrp01pien", "PI enable for sig group 1 rank 0"},
#else
{9, 9, 0x0000000000000000, "RW", "txdll_siggrp01pien", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{8, 8, 0x0000000000000000, "RW", "txdll_siggrp00pien", "PI enable for sig group 0 rank 0"},
#else
{8, 8, 0x0000000000000000, "RW", "txdll_siggrp00pien", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{4, 7, 0x0000000000000000, "RO", "reserved617", "Reserved bits"},
#else
{4, 7, 0x0000000000000000, "RO", "reserved617", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{3, 3, 0x0000000000000000, "RW", "txdll_ref2xph270pien", "enable tx ref pi phase 270 enable"},
#else
{3, 3, 0x0000000000000000, "RW", "txdll_ref2xph270pien", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{2, 2, 0x0000000000000000, "RW", "txdll_ref2xph180pien", "enable tx ref pi phase 180 enable"},
#else
{2, 2, 0x0000000000000000, "RW", "txdll_ref2xph180pien", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{1, 1, 0x0000000000000000, "RW", "txdll_ref2xph90pien", "enable tx ref pi phase 90 enable"},
#else
{1, 1, 0x0000000000000000, "RW", "txdll_ref2xph90pien", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 0, 0x0000000000000000, "RO", "reserved618", "Reseved bits"},
#else
{0, 0, 0x0000000000000000, "RO", "reserved618", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo385[] = {{"txdllctl", "", 0x000000A0, 15, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields386[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{24, 31, 0x0000000000000000, "RO", "reserved619", "Reserved bits"},
#else
{24, 31, 0x0000000000000000, "RO", "reserved619", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{16, 23, 0x0000000000000000, "RW", "txdll_ref2xph270picode", "pi code for ref pi phase 270 output"},
#else
{16, 23, 0x0000000000000000, "RW", "txdll_ref2xph270picode", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{8, 15, 0x0000000000000000, "RW", "txdll_ref2xph180picode", "pi code for ref pi phase 180 output"},
#else
{8, 15, 0x0000000000000000, "RW", "txdll_ref2xph180picode", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 7, 0x0000000000000000, "RW", "txdll_ref2xph90picode", "pi code for ref pi phase 90 output"},
#else
{0, 7, 0x0000000000000000, "RW", "txdll_ref2xph90picode", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo386[] = {{"txdllref2xctl", "", 0x000000A4, 4, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields387[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{24, 31, 0x0000000000000000, "RW", "rxdll_bl_rk1dqshipicode", "pi code for rx rising dqs edge - DQ Lane"},
#else
{24, 31, 0x0000000000000000, "RW", "rxdll_bl_rk1dqshipicode", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{16, 23, 0x0000000000000000, "RW", "rxdll_bl_rk1dqslopicode", "pi code for rx falling dqs edge - DQ Lane"},
#else
{16, 23, 0x0000000000000000, "RW", "rxdll_bl_rk1dqslopicode", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{8, 15, 0x0000000000000000, "RO", "reserved620", "Reserved bits"},
#else
{8, 15, 0x0000000000000000, "RO", "reserved620", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 7, 0x0000000000000000, "RO", "reserved621", "Reserved bits"},
#else
{0, 7, 0x0000000000000000, "RO", "reserved621", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo387[] = {{"rxdlldqsrk1ctl", "", 0x000000A8, 4, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields388[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{24, 31, 0x0000000000000000, "RW", "rxdll_bl_rk0dqshipicode", "pi code for rx rising dqs edge - DQ Lane"},
#else
{24, 31, 0x0000000000000000, "RW", "rxdll_bl_rk0dqshipicode", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{16, 23, 0x0000000000000000, "RW", "rxdll_bl_rk0dqslopicode", "pi code for rx falling dqs edge - DQ Lane"},
#else
{16, 23, 0x0000000000000000, "RW", "rxdll_bl_rk0dqslopicode", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{8, 15, 0x0000000000000000, "RW", "rxdll_cc_rk0dqshipicode", "pi code for rx rising dqs edge  - CC Lane"},
#else
{8, 15, 0x0000000000000000, "RW", "rxdll_cc_rk0dqshipicode", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 7, 0x0000000000000000, "RW", "rxdll_cc_rk0dqslopicode", "pi code for rx falling dqs edge  - CC Lane"},
#else
{0, 7, 0x0000000000000000, "RW", "rxdll_cc_rk0dqslopicode", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo388[] = {{"rxdlldqsrk0ctl", "", 0x000000AC, 4, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields389[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{1, 31, 0x0000000000000000, "RO", "reserved622", "Reserved bits"},
#else
{1, 31, 0x0000000000000000, "RO", "reserved622", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 0, 0x0000000000000000, "RW", "txvref_cmn_vrefbufen", "enable signal for the tx vref unity gain buffer"},
#else
{0, 0, 0x0000000000000000, "RW", "txvref_cmn_vrefbufen", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo389[] = {{"vrefctl1", "", 0x000000B0, 2, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields390[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{24, 31, 0x0000000000000000, "RW", "vref_txlcompvrefctrl", "vref decode signal for the lcomp"},
#else
{24, 31, 0x0000000000000000, "RW", "vref_txlcompvrefctrl", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{22, 23, 0x0000000000000000, "RO", "reserved623", "Reserved bits"},
#else
{22, 23, 0x0000000000000000, "RO", "reserved623", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{21, 21, 0x0000000000000000, "RW", "lvl_bl_vrefiobufact", "vrefiobufact - DQ Lane"},
#else
{21, 21, 0x0000000000000000, "RW", "lvl_bl_vrefiobufact", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{20, 20, 0x0000000000000000, "RW", "lvl_cc_vrefiobufact", "vrefiobufact - CC Lane"},
#else
{20, 20, 0x0000000000000000, "RW", "lvl_cc_vrefiobufact", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{17, 19, 0x0000000000000000, "RO", "reserved624", "Reserved bits"},
#else
{17, 19, 0x0000000000000000, "RO", "reserved624", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{16, 16, 0x0000000000000000, "RW", "vref_vrefcmctrl", "common mode select to choose between lpddr3;lpddr4"},
#else
{16, 16, 0x0000000000000000, "RW", "vref_vrefcmctrl", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{8, 15, 0x0000000000000020, "RW", "vref_rxblvrefctrl", "vref decode signal for the b0 rx vref"},
#else
{8, 15, 0x0000000000000020, "RW", "vref_rxblvrefctrl", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 7, 0x0000000000000020, "RW", "vref_rxccvrefctrl", "vref decode signal for the cc0 rx vref"},
#else
{0, 7, 0x0000000000000020, "RW", "vref_rxccvrefctrl", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo390[] = {{"vrefctl0", "", 0x000000B4, 8, 0x00000000FFFFFFFF, 0x0000000000002020}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields391[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{4, 31, 0x0000000000000000, "RO", "reserved625", "Reserved bits"},
#else
{4, 31, 0x0000000000000000, "RO", "reserved625", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 3, 0x0000000000000000, "RW", "rxdll_bl_dq8rxpbdcode", "Rx Per bit De-skew code for dq0 valid codes"},
#else
{0, 3, 0x0000000000000000, "RW", "rxdll_bl_dq8rxpbdcode", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo391[] = {{"rxbl8pbdctl", "", 0x000000B8, 2, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields392[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{28, 31, 0x0000000000000000, "RW", "rxdll_bl_dq7rxpbdcode", "Rx Per bit De-skew code for dq0 valid codes"},
#else
{28, 31, 0x0000000000000000, "RW", "rxdll_bl_dq7rxpbdcode", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{24, 27, 0x0000000000000000, "RW", "rxdll_bl_dq6rxpbdcode", "Rx Per bit De-skew code for dq0 valid codes"},
#else
{24, 27, 0x0000000000000000, "RW", "rxdll_bl_dq6rxpbdcode", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{20, 23, 0x0000000000000000, "RW", "rxdll_bl_dq5rxpbdcode", "Rx Per bit De-skew code for dq0 valid codes"},
#else
{20, 23, 0x0000000000000000, "RW", "rxdll_bl_dq5rxpbdcode", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{16, 19, 0x0000000000000000, "RW", "rxdll_bl_dq4rxpbdcode", "Rx Per bit De-skew code for dq0 valid codes"},
#else
{16, 19, 0x0000000000000000, "RW", "rxdll_bl_dq4rxpbdcode", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{12, 15, 0x0000000000000000, "RW", "rxdll_bl_dq3rxpbdcode", "Rx Per bit De-skew code for dq0 valid codes"},
#else
{12, 15, 0x0000000000000000, "RW", "rxdll_bl_dq3rxpbdcode", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{8, 11, 0x0000000000000000, "RW", "rxdll_bl_dq2rxpbdcode", "Rx Per bit De-skew code for dq0 valid codes"},
#else
{8, 11, 0x0000000000000000, "RW", "rxdll_bl_dq2rxpbdcode", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{4, 7, 0x0000000000000000, "RW", "rxdll_bl_dq1rxpbdcode", "Rx Per bit De-skew code for dq0 valid codes"},
#else
{4, 7, 0x0000000000000000, "RW", "rxdll_bl_dq1rxpbdcode", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 3, 0x0000000000000000, "RW", "rxdll_bl_dq0rxpbdcode", "Rx Per bit De-skew code for dq0 valid codes"},
#else
{0, 3, 0x0000000000000000, "RW", "rxdll_bl_dq0rxpbdcode", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo392[] = {{"rxpbdblctl", "", 0x000000BC, 8, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields393[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{24, 31, 0x0000000000000000, "RO", "reserved626", "Reserved bits"},
#else
{24, 31, 0x0000000000000000, "RO", "reserved626", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{23, 23, 0x0000000000000000, "RW", "rxdll_cc_rxpbden", "Rx Per Bit De-skew enable (1=enable, 0=disable), 0 for cc always"},
#else
{23, 23, 0x0000000000000000, "RW", "rxdll_cc_rxpbden", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{22, 22, 0x0000000000000000, "RW", "rxdll_bl_rxpbden", "Rx Per Bit De-skew enable (1=enable, 0=disable)"},
#else
{22, 22, 0x0000000000000000, "RW", "rxdll_bl_rxpbden", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{4, 21, 0x0000000000000000, "RO", "reserved627", "Reserved bits"},
#else
{4, 21, 0x0000000000000000, "RO", "reserved627", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{3, 3, 0x0000000000000000, "RW", "tx_cc_pbdstaticlegen", "Per bit deskew enable - TX - CC"},
#else
{3, 3, 0x0000000000000000, "RW", "tx_cc_pbdstaticlegen", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{2, 2, 0x0000000000000000, "RW", "tx_bl_pbdstaticlegen", "Per bit deskew enable - TX - BL"},
#else
{2, 2, 0x0000000000000000, "RW", "tx_bl_pbdstaticlegen", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{1, 1, 0x0000000000000000, "RW", "dtx_cc_pbdstaticlegen", "Per bit deskew enable - DTX - CC"},
#else
{1, 1, 0x0000000000000000, "RW", "dtx_cc_pbdstaticlegen", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 0, 0x0000000000000000, "RW", "dtx_bl_pbdstaticlegen", "Per bit deskew enable - DTX - BL"},
#else
{0, 0, 0x0000000000000000, "RW", "dtx_bl_pbdstaticlegen", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo393[] = {{"txpbdctl1", "", 0x000000C0, 8, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields394[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{5, 31, 0x0000000000000000, "RO", "reserved628", "Reserved bits"},
#else
{5, 31, 0x0000000000000000, "RO", "reserved628", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 4, 0x0000000000000000, "RW", "tx_bldm_txpbdcode", "Tx Per Bit De-skew code for dq0 valid codes"},
#else
{0, 4, 0x0000000000000000, "RW", "tx_bldm_txpbdcode", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo394[] = {{"txpbdrk0ctl1", "", 0x000000C4, 2, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields395[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{21, 31, 0x0000000000000000, "RO", "reserved629", "Reserved bits"},
#else
{21, 31, 0x0000000000000000, "RO", "reserved629", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{16, 20, 0x0000000000000000, "RW", "dtx_bl_dqsbpbdcode", "Tx Per Bit De-skew code for dq0 valid codes"},
#else
{16, 20, 0x0000000000000000, "RW", "dtx_bl_dqsbpbdcode", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{8, 15, 0x0000000000000000, "RO", "reserved630", "Reserved bits"},
#else
{8, 15, 0x0000000000000000, "RO", "reserved630", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{5, 7, 0x0000000000000000, "RO", "reserved631", "Reserved bits"},
#else
{5, 7, 0x0000000000000000, "RO", "reserved631", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 4, 0x0000000000000000, "RW", "dtx_bl_dqspbdcode", "Tx Per Bit De-skew code for dq0 valid codes"},
#else
{0, 4, 0x0000000000000000, "RW", "dtx_bl_dqspbdcode", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo395[] = {{"txpbdrk0ctl0", "", 0x000000C8, 5, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields396[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{29, 31, 0x0000000000000000, "RO", "reserved632", "Reserved bits"},
#else
{29, 31, 0x0000000000000000, "RO", "reserved632", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{24, 28, 0x0000000000000000, "RW", "tx_bldq7_txpbdcode", "Tx Per Bit De-skew code for dq0 valid codes"},
#else
{24, 28, 0x0000000000000000, "RW", "tx_bldq7_txpbdcode", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{21, 23, 0x0000000000000000, "RO", "reserved633", "Reserved bits"},
#else
{21, 23, 0x0000000000000000, "RO", "reserved633", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{16, 20, 0x0000000000000000, "RW", "tx_bldq6_txpbdcode", "Tx Per Bit De-skew code for dq0 valid codes"},
#else
{16, 20, 0x0000000000000000, "RW", "tx_bldq6_txpbdcode", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{13, 15, 0x0000000000000000, "RO", "reserved634", "Reserved bits"},
#else
{13, 15, 0x0000000000000000, "RO", "reserved634", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{8, 12, 0x0000000000000000, "RW", "tx_bldq5_txpbdcode", "Tx Per Bit De-skew code for dq0 valid codes"},
#else
{8, 12, 0x0000000000000000, "RW", "tx_bldq5_txpbdcode", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{5, 7, 0x0000000000000000, "RO", "reserved635", "Reserved bits"},
#else
{5, 7, 0x0000000000000000, "RO", "reserved635", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 4, 0x0000000000000000, "RW", "tx_bldq4_txpbdcode", "Tx Per Bit De-skew code for dq0 valid codes"},
#else
{0, 4, 0x0000000000000000, "RW", "tx_bldq4_txpbdcode", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo396[] = {{"txpbdblctl1", "", 0x000000CC, 8, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields397[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{29, 31, 0x0000000000000000, "RO", "reserved636", "Reserved bits"},
#else
{29, 31, 0x0000000000000000, "RO", "reserved636", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{24, 28, 0x0000000000000000, "RW", "tx_bldq3_txpbdcode", "Tx Per Bit De-skew code for dq0 valid codes"},
#else
{24, 28, 0x0000000000000000, "RW", "tx_bldq3_txpbdcode", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{21, 23, 0x0000000000000000, "RO", "reserved637", "Reserved bits"},
#else
{21, 23, 0x0000000000000000, "RO", "reserved637", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{16, 20, 0x0000000000000000, "RW", "tx_bldq2_txpbdcode", "Tx Per Bit De-skew code for dq0 valid codes"},
#else
{16, 20, 0x0000000000000000, "RW", "tx_bldq2_txpbdcode", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{13, 15, 0x0000000000000000, "RO", "reserved638", "Reserved bits"},
#else
{13, 15, 0x0000000000000000, "RO", "reserved638", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{8, 12, 0x0000000000000000, "RW", "tx_bldq1_txpbdcode", "Tx Per Bit De-skew code for dq0 valid codes"},
#else
{8, 12, 0x0000000000000000, "RW", "tx_bldq1_txpbdcode", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{5, 7, 0x0000000000000000, "RO", "reserved639", "Reserved bits"},
#else
{5, 7, 0x0000000000000000, "RO", "reserved639", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 4, 0x0000000000000000, "RW", "tx_bldq0_txpbdcode", "Tx Per Bit De-skew code for dq0 valid codes"},
#else
{0, 4, 0x0000000000000000, "RW", "tx_bldq0_txpbdcode", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo397[] = {{"txpbdblctl0", "", 0x000000D0, 8, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields398[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{20, 31, 0x0000000000000000, "RO", "reserved640", "Reserved bits"},
#else
{20, 31, 0x0000000000000000, "RO", "reserved640", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{19, 19, 0x0000000000000001, "RW", "drx_cc_ampoffseten", "Offset cancellation enable for Rx (not used for cc)"},
#else
{19, 19, 0x0000000000000001, "RW", "drx_cc_ampoffseten", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{18, 18, 0x0000000000000000, "RW", "rx_cc_ampoffseten", "Offset cancellation enable for Rx (not used for cc)"},
#else
{18, 18, 0x0000000000000000, "RW", "rx_cc_ampoffseten", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{17, 17, 0x0000000000000001, "RW", "drx_bl_ampoffseten", "DQS Offset cancellation enable for Rx (1=enable, 0=disable)"},
#else
{17, 17, 0x0000000000000001, "RW", "drx_bl_ampoffseten", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{16, 16, 0x0000000000000000, "RW", "rx_bl_ampoffseten", "DQ Offset cancellation enable for Rx (1=enable, 0=disable)"},
#else
{16, 16, 0x0000000000000000, "RW", "rx_bl_ampoffseten", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{12, 15, 0x0000000000000000, "RW", "drx_ccck0_ampoffset", "tuning bits for offset cancellation (can be tied off for CC)"},
#else
{12, 15, 0x0000000000000000, "RW", "drx_ccck0_ampoffset", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{8, 11, 0x0000000000000000, "RW", "rx_cc_ampoffset", "tuning bits for offset cancellation (can be tied off for CC)"},
#else
{8, 11, 0x0000000000000000, "RW", "rx_cc_ampoffset", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{4, 7, 0x0000000000000000, "RW", "drx_bl_ampoffset", "Offset cancellation code (DQS buffers)[br]1100 -4[br]1011 -3[br]1010 -2[br]1001 -1[br]0000 0[br]0001 +1[br]0010 +2[br]0011 +3[br]0100 +4"},
#else
{4, 7, 0x0000000000000000, "RW", "drx_bl_ampoffset", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 3, 0x0000000000000000, "RW", "rx_bldm_ampoffset", "Offset cancellation code (DM/DQ buffers)[br]1100 -4[br]1011 -3[br]1010 -2[br]1001 -1[br]0000 0[br]0001 +1[br]0010 +2[br]0011 +3[br]0100 +4"},
#else
{0, 3, 0x0000000000000000, "RW", "rx_bldm_ampoffset", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo398[] = {{"offsetcnclctrl1", "", 0x000000D4, 9, 0x00000000FFFFFFFF, 0x00000000000A0000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields399[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{28, 31, 0x0000000000000000, "RW", "rx_bldq0_ampoffset", "Offset cancellation code (DM/DQ buffers)[br]1100 -4[br]1011 -3[br]1010 -2[br]1001 -1[br]0000 0[br]0001 +1[br]0010 +2[br]0011 +3[br]0100 +4"},
#else
{28, 31, 0x0000000000000000, "RW", "rx_bldq0_ampoffset", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{24, 27, 0x0000000000000000, "RW", "rx_bldq1_ampoffset", "Offset cancellation code (DM/DQ buffers)[br]1100 -4[br]1011 -3[br]1010 -2[br]1001 -1[br]0000 0[br]0001 +1[br]0010 +2[br]0011 +3[br]0100 +4"},
#else
{24, 27, 0x0000000000000000, "RW", "rx_bldq1_ampoffset", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{20, 23, 0x0000000000000000, "RW", "rx_bldq2_ampoffset", "Offset cancellation code (DM/DQ buffers)[br]1100 -4[br]1011 -3[br]1010 -2[br]1001 -1[br]0000 0[br]0001 +1[br]0010 +2[br]0011 +3[br]0100 +4"},
#else
{20, 23, 0x0000000000000000, "RW", "rx_bldq2_ampoffset", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{16, 19, 0x0000000000000000, "RW", "rx_bldq3_ampoffset", "Offset cancellation code (DM/DQ buffers)[br]1100 -4[br]1011 -3[br]1010 -2[br]1001 -1[br]0000 0[br]0001 +1[br]0010 +2[br]0011 +3[br]0100 +4"},
#else
{16, 19, 0x0000000000000000, "RW", "rx_bldq3_ampoffset", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{12, 15, 0x0000000000000000, "RW", "rx_bldq4_ampoffset", "Offset cancellation code (DM/DQ buffers)[br]1100 -4[br]1011 -3[br]1010 -2[br]1001 -1[br]0000 0[br]0001 +1[br]0010 +2[br]0011 +3[br]0100 +4"},
#else
{12, 15, 0x0000000000000000, "RW", "rx_bldq4_ampoffset", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{8, 11, 0x0000000000000000, "RW", "rx_bldq5_ampoffset", "Offset cancellation code (DM/DQ buffers)[br]1100 -4[br]1011 -3[br]1010 -2[br]1001 -1[br]0000 0[br]0001 +1[br]0010 +2[br]0011 +3[br]0100 +4"},
#else
{8, 11, 0x0000000000000000, "RW", "rx_bldq5_ampoffset", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{4, 7, 0x0000000000000000, "RW", "rx_bldq6_ampoffset", "Offset cancellation code (DM/DQ buffers)[br]1100 -4[br]1011 -3[br]1010 -2[br]1001 -1[br]0000 0[br]0001 +1[br]0010 +2[br]0011 +3[br]0100 +4"},
#else
{4, 7, 0x0000000000000000, "RW", "rx_bldq6_ampoffset", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 3, 0x0000000000000000, "RW", "rx_bldq7_ampoffset", "Offset cancellation code (DM/DQ buffers)[br]1100 -4[br]1011 -3[br]1010 -2[br]1001 -1[br]0000 0[br]0001 +1[br]0010 +2[br]0011 +3[br]0100 +4"},
#else
{0, 3, 0x0000000000000000, "RW", "rx_bldq7_ampoffset", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo399[] = {{"offsetcnclctrl0", "", 0x000000D8, 8, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields400[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{4, 31, 0x0000000000000000, "RO", "reserved641", "Reserved bits"},
#else
{4, 31, 0x0000000000000000, "RO", "reserved641", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{2, 3, 0x0000000000000000, "RW", "drx_bl_casbiasctrl", "DRX Bias Command Control - BL"},
#else
{2, 3, 0x0000000000000000, "RW", "drx_bl_casbiasctrl", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 1, 0x0000000000000000, "RW", "drx_bl_nbiasctrl", "DRX N Bias Control - BL"},
#else
{0, 1, 0x0000000000000000, "RW", "drx_bl_nbiasctrl", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo400[] = {{"ctlectl2", "", 0x000000DC, 3, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields401[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{31, 31, 0x0000000000000000, "RO", "reserved642", "Reserved bits"},
#else
{31, 31, 0x0000000000000000, "RO", "reserved642", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{30, 30, 0x0000000000000001, "RW", "drx_cc_biasen", "DRX Bias Enable - CC"},
#else
{30, 30, 0x0000000000000001, "RW", "drx_cc_biasen", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{28, 29, 0x0000000000000000, "RW", "drx_cc_casbiasctrl", "DRX Bias Command Control - CC"},
#else
{28, 29, 0x0000000000000000, "RW", "drx_cc_casbiasctrl", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{26, 27, 0x0000000000000000, "RW", "drx_cc_nbiasctrl", "DRX N Bias Control - CC"},
#else
{26, 27, 0x0000000000000000, "RW", "drx_cc_nbiasctrl", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{23, 25, 0x0000000000000000, "RW", "drx_cc_ctlebiasctrl", "DRX Bias Ctle Control - CC"},
#else
{23, 25, 0x0000000000000000, "RW", "drx_cc_ctlebiasctrl", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{22, 22, 0x0000000000000001, "RW", "rx_cc_ctleen", "Enable CTLE (not used for CC)"},
#else
{22, 22, 0x0000000000000001, "RW", "rx_cc_ctleen", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{20, 21, 0x0000000000000000, "RW", "rx_cc_ctlebiasctrl", "bias control for ctle amp[br]00 2k&          0.25xnom[br]01 1k&          0.4xnom[br]10 0.5k&     1xnom[br]11 0.25k&  1.7xnom"},
#else
{20, 21, 0x0000000000000000, "RW", "rx_cc_ctlebiasctrl", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{18, 19, 0x0000000000000000, "RW", "rx_cc_ctleres", "resistor tuning;00=0.5kohm;01=1kohm;10=1.5kohm;11=2kohm"},
#else
{18, 19, 0x0000000000000000, "RW", "rx_cc_ctleres", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{16, 17, 0x0000000000000001, "RW", "rx_cc_ctlecap", "cap tuning;00 = 0.5pf;01 = 1pf;10 = 1.5pf;11 = 2pf"},
#else
{16, 17, 0x0000000000000001, "RW", "rx_cc_ctlecap", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{15, 15, 0x0000000000000001, "RW", "drx_bl_ctleen", "Enable CTLE for DQS (1=enable, 0=disable)"},
#else
{15, 15, 0x0000000000000001, "RW", "drx_bl_ctleen", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{12, 14, 0x0000000000000000, "RW", "drx_bl_ctlebiasctrl", "bias control for ctle amp[br]00 2k&          0.25xnom[br]01 1k&          0.4xnom[br]10 0.5k&     1xnom[br]11 0.25k&  1.7xnom"},
#else
{12, 14, 0x0000000000000000, "RW", "drx_bl_ctlebiasctrl", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{10, 11, 0x0000000000000000, "RW", "drx_bl_ctleres", "resistor tuning;00=0.5kohm;01=1kohm;10=1.5kohm;11=2kohm"},
#else
{10, 11, 0x0000000000000000, "RW", "drx_bl_ctleres", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{8, 9, 0x0000000000000001, "RW", "drx_bl_ctlecap", "cap tuning;00 = 0.5pf;01 = 1pf;10 = 1.5pf;11 = 2pf"},
#else
{8, 9, 0x0000000000000001, "RW", "drx_bl_ctlecap", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{7, 7, 0x0000000000000001, "RW", "drx_bl_biasen", "DRX Bias Enable - BL"},
#else
{7, 7, 0x0000000000000001, "RW", "drx_bl_biasen", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{6, 6, 0x0000000000000001, "RW", "rx_bl_ctleen", "Enable CTLE for DQ (1=enable, 0=disable)"},
#else
{6, 6, 0x0000000000000001, "RW", "rx_bl_ctleen", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{4, 5, 0x0000000000000000, "RW", "rx_bl_ctlebiasctrl", "bias control for ctle amp[br]00 2k&          0.25xnom[br]01 1k&          0.4xnom[br]10 0.5k&     1xnom[br]11 0.25k&  1.7xnom"},
#else
{4, 5, 0x0000000000000000, "RW", "rx_bl_ctlebiasctrl", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{2, 3, 0x0000000000000000, "RW", "rx_bldm_ctleres", "resistor tuning;00=0.5kohm;01=1kohm;10=1.5kohm;11=2kohm"},
#else
{2, 3, 0x0000000000000000, "RW", "rx_bldm_ctleres", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 1, 0x0000000000000001, "RW", "rx_bldm_ctlecap", "cap tuning;00 = 0.1pf;01 = 0.2pf;10 = 0.3pf;11 = 0.4pf"},
#else
{0, 1, 0x0000000000000001, "RW", "rx_bldm_ctlecap", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo401[] = {{"ctlectl1", "", 0x000000E0, 18, 0x00000000FFFFFFFF, 0x00000000404181C1}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields402[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{30, 31, 0x0000000000000000, "RW", "rx_bldq0_ctleres", "resistor tuning;00=0.5kohm;01=1kohm;10=1.5kohm;11=2kohm"},
#else
{30, 31, 0x0000000000000000, "RW", "rx_bldq0_ctleres", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{28, 29, 0x0000000000000000, "RW", "rx_bldq1_ctleres", "resistor tuning;00=0.5kohm;01=1kohm;10=1.5kohm;11=2kohm"},
#else
{28, 29, 0x0000000000000000, "RW", "rx_bldq1_ctleres", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{26, 27, 0x0000000000000000, "RW", "rx_bldq2_ctleres", "resistor tuning;00=0.5kohm;01=1kohm;10=1.5kohm;11=2kohm"},
#else
{26, 27, 0x0000000000000000, "RW", "rx_bldq2_ctleres", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{24, 25, 0x0000000000000000, "RW", "rx_bldq3_ctleres", "resistor tuning;00=0.5kohm;01=1kohm;10=1.5kohm;11=2kohm"},
#else
{24, 25, 0x0000000000000000, "RW", "rx_bldq3_ctleres", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{22, 23, 0x0000000000000000, "RW", "rx_bldq4_ctleres", "resistor tuning;00=0.5kohm;01=1kohm;10=1.5kohm;11=2kohm"},
#else
{22, 23, 0x0000000000000000, "RW", "rx_bldq4_ctleres", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{20, 21, 0x0000000000000000, "RW", "rx_bldq5_ctleres", "resistor tuning;00=0.5kohm;01=1kohm;10=1.5kohm;11=2kohm"},
#else
{20, 21, 0x0000000000000000, "RW", "rx_bldq5_ctleres", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{18, 19, 0x0000000000000000, "RW", "rx_bldq6_ctleres", "resistor tuning;00=0.5kohm;01=1kohm;10=1.5kohm;11=2kohm"},
#else
{18, 19, 0x0000000000000000, "RW", "rx_bldq6_ctleres", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{16, 17, 0x0000000000000000, "RW", "rx_bldq7_ctleres", "resistor tuning;00=0.5kohm;01=1kohm;10=1.5kohm;11=2kohm"},
#else
{16, 17, 0x0000000000000000, "RW", "rx_bldq7_ctleres", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{14, 15, 0x0000000000000001, "RW", "rx_bldq0_ctlecap", "cap tuning;00 = 0.1pf;01 = 0.2pf;10 = 0.3pf;11 = 0.4pf"},
#else
{14, 15, 0x0000000000000001, "RW", "rx_bldq0_ctlecap", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{12, 13, 0x0000000000000001, "RW", "rx_bldq1_ctlecap", "cap tuning;00 = 0.1pf;01 = 0.2pf;10 = 0.3pf;11 = 0.4pf"},
#else
{12, 13, 0x0000000000000001, "RW", "rx_bldq1_ctlecap", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{10, 11, 0x0000000000000001, "RW", "rx_bldq2_ctlecap", "cap tuning;00 = 0.1pf;01 = 0.2pf;10 = 0.3pf;11 = 0.4pf"},
#else
{10, 11, 0x0000000000000001, "RW", "rx_bldq2_ctlecap", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{8, 9, 0x0000000000000001, "RW", "rx_bldq3_ctlecap", "cap tuning;00 = 0.1pf;01 = 0.2pf;10 = 0.3pf;11 = 0.4pf"},
#else
{8, 9, 0x0000000000000001, "RW", "rx_bldq3_ctlecap", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{6, 7, 0x0000000000000001, "RW", "rx_bldq4_ctlecap", "cap tuning;00 = 0.1pf;01 = 0.2pf;10 = 0.3pf;11 = 0.4pf"},
#else
{6, 7, 0x0000000000000001, "RW", "rx_bldq4_ctlecap", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{4, 5, 0x0000000000000001, "RW", "rx_bldq5_ctlecap", "cap tuning;00 = 0.1pf;01 = 0.2pf;10 = 0.3pf;11 = 0.4pf"},
#else
{4, 5, 0x0000000000000001, "RW", "rx_bldq5_ctlecap", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{2, 3, 0x0000000000000001, "RW", "rx_bldq6_ctlecap", "cap tuning;00 = 0.1pf;01 = 0.2pf;10 = 0.3pf;11 = 0.4pf"},
#else
{2, 3, 0x0000000000000001, "RW", "rx_bldq6_ctlecap", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 1, 0x0000000000000001, "RW", "rx_bldq7_ctlecap", "cap tuning;00 = 0.1pf;01 = 0.2pf;10 = 0.3pf;11 = 0.4pf"},
#else
{0, 1, 0x0000000000000001, "RW", "rx_bldq7_ctlecap", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo402[] = {{"ctlectl0", "", 0x000000E4, 16, 0x00000000FFFFFFFF, 0x0000000000005555}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields403[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{31, 31, 0x0000000000000000, "RW", "tx_bl_tcostaticlegen", "TX TCO enable - BL"},
#else
{31, 31, 0x0000000000000000, "RW", "tx_bl_tcostaticlegen", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{29, 30, 0x0000000000000000, "RO", "reserved643", "Reserved bits"},
#else
{29, 30, 0x0000000000000000, "RO", "reserved643", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{24, 28, 0x000000000000001F, "RW", "tx_bl_tcofall", "DQ TCO comp fall code - DQ Lane"},
#else
{24, 28, 0x000000000000001F, "RW", "tx_bl_tcofall", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{21, 23, 0x0000000000000000, "RO", "reserved644", "Reserved bits"},
#else
{21, 23, 0x0000000000000000, "RO", "reserved644", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{16, 20, 0x000000000000001F, "RW", "tx_bl_tcorise", "DQ TCO comp rise code - DQ Lane"},
#else
{16, 20, 0x000000000000001F, "RW", "tx_bl_tcorise", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{15, 15, 0x0000000000000000, "RW", "tx_cc_tcostaticlegen", "TX TCO enable - CC"},
#else
{15, 15, 0x0000000000000000, "RW", "tx_cc_tcostaticlegen", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{13, 14, 0x0000000000000000, "RO", "reserved645", "Reserved bits"},
#else
{13, 14, 0x0000000000000000, "RO", "reserved645", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{8, 12, 0x000000000000001F, "RW", "tx_cc_tcofall", "DQ TCO comp fall code - CC Lane"},
#else
{8, 12, 0x000000000000001F, "RW", "tx_cc_tcofall", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{5, 7, 0x0000000000000000, "RO", "reserved646", "Reserved bits"},
#else
{5, 7, 0x0000000000000000, "RO", "reserved646", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 4, 0x000000000000001F, "RW", "tx_cc_tcorise", "DQ TCO comp rise code - CC Lane"},
#else
{0, 4, 0x000000000000001F, "RW", "tx_cc_tcorise", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo403[] = {{"tcoctl_dqcc", "", 0x000000E8, 10, 0x00000000FFFFFFFF, 0x000000001F1F1F1F}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields404[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{30, 31, 0x0000000000000000, "RO", "reserved647", "Reserved bits"},
#else
{30, 31, 0x0000000000000000, "RO", "reserved647", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{29, 29, 0x0000000000000000, "RW", "dtx_bl_tcostaticlegen", "DTX TCO enable - BL"},
#else
{29, 29, 0x0000000000000000, "RW", "dtx_bl_tcostaticlegen", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{24, 28, 0x000000000000001F, "RW", "dtx_bl_tcofalldqsb", "DQSB TCO comp fall code - DQ Lane"},
#else
{24, 28, 0x000000000000001F, "RW", "dtx_bl_tcofalldqsb", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{21, 23, 0x0000000000000000, "RO", "reserved648", "Reserved bits"},
#else
{21, 23, 0x0000000000000000, "RO", "reserved648", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{16, 20, 0x000000000000001F, "RW", "dtx_bl_tcorisedqsb", "DQS TCO comp fall code - DQ Lane"},
#else
{16, 20, 0x000000000000001F, "RW", "dtx_bl_tcorisedqsb", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{13, 15, 0x0000000000000000, "RO", "reserved649", "Reserved bits"},
#else
{13, 15, 0x0000000000000000, "RO", "reserved649", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{8, 12, 0x000000000000001F, "RW", "dtx_bl_tcofalldqs", "DQSB TCO comp rise code - DQ Lane"},
#else
{8, 12, 0x000000000000001F, "RW", "dtx_bl_tcofalldqs", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{5, 7, 0x0000000000000000, "RO", "reserved650", "Reserved bits"},
#else
{5, 7, 0x0000000000000000, "RO", "reserved650", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 4, 0x000000000000001F, "RW", "dtx_bl_tcorisedqs", "DQS TCO comp rise code - DQ Lane"},
#else
{0, 4, 0x000000000000001F, "RW", "dtx_bl_tcorisedqs", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo404[] = {{"tcoctl_dq", "", 0x000000EC, 9, 0x00000000FFFFFFFF, 0x000000001F1F1F1F}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields405[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{30, 31, 0x0000000000000000, "RO", "reserved651", "Reserved bits"},
#else
{30, 31, 0x0000000000000000, "RO", "reserved651", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{29, 29, 0x0000000000000000, "RW", "dtx_cc_tcostaticlegen", "DTX TCO enable - CC"},
#else
{29, 29, 0x0000000000000000, "RW", "dtx_cc_tcostaticlegen", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{24, 28, 0x000000000000001F, "RW", "dtx_cc_tcofalldqsb", "DQSB TCO comp fall code - CC Lane"},
#else
{24, 28, 0x000000000000001F, "RW", "dtx_cc_tcofalldqsb", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{21, 23, 0x0000000000000000, "RO", "reserved652", "Reserved bits"},
#else
{21, 23, 0x0000000000000000, "RO", "reserved652", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{16, 20, 0x000000000000001F, "RW", "dtx_cc_tcorisedqsb", "DQSB TCO comp rise code - CC Lane"},
#else
{16, 20, 0x000000000000001F, "RW", "dtx_cc_tcorisedqsb", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{13, 15, 0x0000000000000000, "RO", "reserved653", "Reserved bits"},
#else
{13, 15, 0x0000000000000000, "RO", "reserved653", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{8, 12, 0x000000000000001F, "RW", "dtx_cc_tcofalldqs", "DQS TCO comp fall code - CC Lane"},
#else
{8, 12, 0x000000000000001F, "RW", "dtx_cc_tcofalldqs", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{5, 7, 0x0000000000000000, "RO", "reserved654", "Reserved bits"},
#else
{5, 7, 0x0000000000000000, "RO", "reserved654", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 4, 0x000000000000001F, "RW", "dtx_cc_tcorisedqs", "DQS TCO comp rise code - CC Lane"},
#else
{0, 4, 0x000000000000001F, "RW", "dtx_cc_tcorisedqs", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo405[] = {{"tcoctl_cc", "", 0x000000F0, 9, 0x00000000FFFFFFFF, 0x000000001F1F1F1F}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields406[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{20, 31, 0x0000000000000000, "RO", "reserved6555", "Reserved bits"},
#else
{20, 31, 0x0000000000000000, "RO", "reserved6555", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{16, 19, 0x0000000000000000, "RW", "txdll_rk0ckesiggrp06rdptroffset", ""},
#else
{16, 19, 0x0000000000000000, "RW", "txdll_rk0ckesiggrp06rdptroffset", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{12, 15, 0x0000000000000000, "RO", "reserved655", "Reserved bits"},
#else
{12, 15, 0x0000000000000000, "RO", "reserved655", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{10, 11, 0x0000000000000000, "RW", "txdll_rk1siggrp06dbsel", "Dead band select for sig grp 6 rank 1"},
#else
{10, 11, 0x0000000000000000, "RW", "txdll_rk1siggrp06dbsel", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{6, 9, 0x0000000000000000, "RW", "txdll_rk1siggrp06rdptroffset", "Read pointer offset for sig group 6 rank 1"},
#else
{6, 9, 0x0000000000000000, "RW", "txdll_rk1siggrp06rdptroffset", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{4, 5, 0x0000000000000000, "RW", "txdll_rk0siggrp06dbsel", "Dead band select for sig grp 6 rank 0"},
#else
{4, 5, 0x0000000000000000, "RW", "txdll_rk0siggrp06dbsel", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 3, 0x0000000000000000, "RW", "txdll_rk0siggrp06rdptroffset", "Read pointer offset for sig group 6 rank 0"},
#else
{0, 3, 0x0000000000000000, "RW", "txdll_rk0siggrp06rdptroffset", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo406[] = {{"txdllsiggrp6ctl", "", 0x000000F4, 7, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields407[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{28, 31, 0x0000000000000000, "RW", "reserved656", "Reserved bits"},
#else
{28, 31, 0x0000000000000000, "RW", "reserved656", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{24, 27, 0x0000000000000000, "RW", "rk1dqdrvsecondrdportref2xrdptroffset", "Read pointer offset for second port for LDO integration - DQDMDRV - RK1."},
#else
{24, 27, 0x0000000000000000, "RW", "rk1dqdrvsecondrdportref2xrdptroffset", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{20, 23, 0x0000000000000000, "RW", "rk0dqdrvsecondrdportref2xrdptroffset", "Read pointer offset for second port for LDO integration - DQDMDRV - RK0."},
#else
{20, 23, 0x0000000000000000, "RW", "rk0dqdrvsecondrdportref2xrdptroffset", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{16, 19, 0x0000000000000000, "RW", "rk1dqsecondrdportref2xrdptroffset", "Read pointer offset for second port for LDO integration - DQ - RK1."},
#else
{16, 19, 0x0000000000000000, "RW", "rk1dqsecondrdportref2xrdptroffset", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{12, 15, 0x0000000000000000, "RW", "rk0dqsecondrdportref2xrdptroffset", "Read pointer offset for second port for LDO integration - DQ - RK0."},
#else
{12, 15, 0x0000000000000000, "RW", "rk0dqsecondrdportref2xrdptroffset", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{8, 11, 0x0000000000000000, "RW", "rk1dqsdrvsecondrdportref2xrdptroffset", "Read pointer offset for second port for LDO integration - DQ - RK1."},
#else
{8, 11, 0x0000000000000000, "RW", "rk1dqsdrvsecondrdportref2xrdptroffset", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{4, 7, 0x0000000000000000, "RW", "rk0dqsdrvsecondrdportref2xrdptroffset", "Read pointer offset for second port for LDO integration - DQ - RK0."},
#else
{4, 7, 0x0000000000000000, "RW", "rk0dqsdrvsecondrdportref2xrdptroffset", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 3, 0x0000000000000000, "RW", "ckdrvsecondrdportref2xrdptroffset", "Read pointer offset for second port for LDO integration - DQ - RK1."},
#else
{0, 3, 0x0000000000000000, "RW", "ckdrvsecondrdportref2xrdptroffset", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo407[] = {{"ldoctl0", "", 0x000000F8, 8, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields408[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{8, 31, 0x0000000000000000, "RW", "reserved657", "Reserved bits"},
#else
{8, 31, 0x0000000000000000, "RW", "reserved657", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{4, 7, 0x0000000000000000, "RW", "cssecondrdportref2xrdptroffset", "Read pointer offset for second port for LDO integration - DQ - RK0."},
#else
{4, 7, 0x0000000000000000, "RW", "cssecondrdportref2xrdptroffset", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 3, 0x0000000000000000, "RW", "cmddrvsecondrdportref2xrdptroffset", "Read pointer offset for second port for LDO integration - DQ - RK1."},
#else
{0, 3, 0x0000000000000000, "RW", "cmddrvsecondrdportref2xrdptroffset", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo408[] = {{"ldoctl1", "", 0x000000FC, 3, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields409[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{24, 31, 0x0000000000000000, "RO", "reserved658", "Reserved bits"},
#else
{24, 31, 0x0000000000000000, "RO", "reserved658", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{21, 23, 0x0000000000000000, "RW", "data0sel", "Reserved bits"},
#else
{21, 23, 0x0000000000000000, "RW", "data0sel", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{18, 20, 0x0000000000000000, "RW", "data1sel", "Reserved bits"},
#else
{18, 20, 0x0000000000000000, "RW", "data1sel", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{15, 17, 0x0000000000000000, "RW", "data2sel", "Reserved bits"},
#else
{15, 17, 0x0000000000000000, "RW", "data2sel", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{12, 14, 0x0000000000000000, "RW", "data3sel", "Reserved bits"},
#else
{12, 14, 0x0000000000000000, "RW", "data3sel", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{9, 11, 0x0000000000000000, "RW", "data4sel", "Reserved bits"},
#else
{9, 11, 0x0000000000000000, "RW", "data4sel", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{6, 8, 0x0000000000000000, "RW", "data5sel", "Reserved bits"},
#else
{6, 8, 0x0000000000000000, "RW", "data5sel", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{3, 5, 0x0000000000000000, "RW", "data6sel", "Reserved bits"},
#else
{3, 5, 0x0000000000000000, "RW", "data6sel", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 2, 0x0000000000000000, "RW", "data7sel", "Reserved bits"},
#else
{0, 2, 0x0000000000000000, "RW", "data7sel", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo409[] = {{"ptdatamuxsel", "", 0x00000100, 9, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields410[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{31, 31, 0x0000000000000000, "RO", "reserved659", "Reserved bits"},
#else
{31, 31, 0x0000000000000000, "RO", "reserved659", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{28, 30, 0x0000000000000000, "RW", "lpmode_dasrtdqcmddrvenb_dly", "Low Power Mode Delays"},
#else
{28, 30, 0x0000000000000000, "RW", "lpmode_dasrtdqcmddrvenb_dly", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{27, 27, 0x0000000000000000, "RO", "reserved660", "Reserved bits"},
#else
{27, 27, 0x0000000000000000, "RO", "reserved660", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{24, 26, 0x0000000000000000, "RW", "lpmode_asrtdqcmdsigpien_dly", "Low Power Mode Delays"},
#else
{24, 26, 0x0000000000000000, "RW", "lpmode_asrtdqcmdsigpien_dly", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{23, 23, 0x0000000000000000, "RO", "reserved661", "Reserved bits"},
#else
{23, 23, 0x0000000000000000, "RO", "reserved661", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{20, 22, 0x0000000000000000, "RW", "lpmode_asrtdqcmddrvenb_dly", "Low Power Mode Delays"},
#else
{20, 22, 0x0000000000000000, "RW", "lpmode_asrtdqcmddrvenb_dly", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{19, 19, 0x0000000000000000, "RO", "reserved662", "Reserved bits"},
#else
{19, 19, 0x0000000000000000, "RO", "reserved662", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{16, 18, 0x0000000000000000, "RW", "lpmode_dasrtiobufact_dly", "Low Power Mode Delays"},
#else
{16, 18, 0x0000000000000000, "RW", "lpmode_dasrtiobufact_dly", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{15, 15, 0x0000000000000000, "RO", "reserved663", "Reserved bits"},
#else
{15, 15, 0x0000000000000000, "RO", "reserved663", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{12, 14, 0x0000000000000000, "RW", "lpmode_dasrtwrptren_dly", "Low Power Mode Delays"},
#else
{12, 14, 0x0000000000000000, "RW", "lpmode_dasrtwrptren_dly", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{11, 11, 0x0000000000000000, "RO", "reserved664", "Reserved bits"},
#else
{11, 11, 0x0000000000000000, "RO", "reserved664", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{8, 10, 0x0000000000000000, "RW", "lpmode_asrtref2xrstb_dly", "Low Power Mode Delays"},
#else
{8, 10, 0x0000000000000000, "RW", "lpmode_asrtref2xrstb_dly", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{7, 7, 0x0000000000000000, "RO", "reserved665", "Reserved bits"},
#else
{7, 7, 0x0000000000000000, "RO", "reserved665", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{4, 6, 0x0000000000000000, "RO", "reserved666", "Reserved bits"},
#else
{4, 6, 0x0000000000000000, "RO", "reserved666", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{3, 3, 0x0000000000000000, "RO", "reserved667", "Reserved bits"},
#else
{3, 3, 0x0000000000000000, "RO", "reserved667", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 2, 0x0000000000000000, "RW", "lpmode_dasrtref2xrstb_dly", "Low Power Mode Delays"},
#else
{0, 2, 0x0000000000000000, "RW", "lpmode_dasrtref2xrstb_dly", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo410[] = {{"lpmodectl0", "", 0x00000104, 16, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields411[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{31, 31, 0x0000000000000000, "RO", "reserved668", "Reserved bits"},
#else
{31, 31, 0x0000000000000000, "RO", "reserved668", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{28, 30, 0x0000000000000000, "RW", "lpmode_asrtwrptren_dly", "Reserved bits"},
#else
{28, 30, 0x0000000000000000, "RW", "lpmode_asrtwrptren_dly", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{27, 27, 0x0000000000000000, "RO", "reserved669", "Reserved bits"},
#else
{27, 27, 0x0000000000000000, "RO", "reserved669", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{24, 26, 0x0000000000000000, "RW", "lpmode_asrtiobufact_dly", "Reserved bits"},
#else
{24, 26, 0x0000000000000000, "RW", "lpmode_asrtiobufact_dly", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{23, 23, 0x0000000000000000, "RO", "reserved670", "Reserved bits"},
#else
{23, 23, 0x0000000000000000, "RO", "reserved670", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{22, 22, 0x0000000000000000, "RW", "lpmode_dqcmddrvenbovrd", "Reserved bits"},
#else
{22, 22, 0x0000000000000000, "RW", "lpmode_dqcmddrvenbovrd", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{21, 21, 0x0000000000000000, "RW", "lpmode_iobufactovrd", "Reserved bits"},
#else
{21, 21, 0x0000000000000000, "RW", "lpmode_iobufactovrd", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{20, 20, 0x0000000000000000, "RW", "lpmode_ref2xclkenovrd", "Reserved bits"},
#else
{20, 20, 0x0000000000000000, "RW", "lpmode_ref2xclkenovrd", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{19, 19, 0x0000000000000000, "RW", "siggrpen_lpmode1ovrd", "Reserved bits"},
#else
{19, 19, 0x0000000000000000, "RW", "siggrpen_lpmode1ovrd", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{18, 18, 0x0000000000000000, "RW", "siggrpen_lpmode2or3ovrd", "Reserved bits"},
#else
{18, 18, 0x0000000000000000, "RW", "siggrpen_lpmode2or3ovrd", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{17, 17, 0x0000000000000000, "RW", "lpmode_wrptrenovrd", "Reserved bits"},
#else
{17, 17, 0x0000000000000000, "RW", "lpmode_wrptrenovrd", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{16, 16, 0x0000000000000000, "RW", "lpmode_ref2xrstbovrd", "Reserved bits"},
#else
{16, 16, 0x0000000000000000, "RW", "lpmode_ref2xrstbovrd", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{8, 15, 0x0000000000000000, "RO", "reserved671", "Reserved bits"},
#else
{8, 15, 0x0000000000000000, "RO", "reserved671", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 7, 0x0000000000000000, "RW", "lpmode_asrtref2xsigpien_dly", "Low Power Mode Delays"},
#else
{0, 7, 0x0000000000000000, "RW", "lpmode_asrtref2xsigpien_dly", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo411[] = {{"lpmodectl1", "", 0x00000108, 14, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields412[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{24, 31, 0x0000000000000000, "RO", "reserved672", "Reserved bits"},
#else
{24, 31, 0x0000000000000000, "RO", "reserved672", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{18, 23, 0x0000000000000000, "RW", "rdcmd2rxdllupdt", "Read command to RXDLL update."},
#else
{18, 23, 0x0000000000000000, "RW", "rdcmd2rxdllupdt", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{12, 17, 0x0000000000000000, "RW", "rxdllupdtlen", "RXDLL update enable."},
#else
{12, 17, 0x0000000000000000, "RW", "rxdllupdtlen", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{6, 11, 0x0000000000000000, "RW", "rdcmd2rdactive", "Read command to active delay."},
#else
{6, 11, 0x0000000000000000, "RW", "rdcmd2rdactive", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 5, 0x0000000000000000, "RW", "rdactivelen", "Read active length."},
#else
{0, 5, 0x0000000000000000, "RW", "rdactivelen", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo412[] = {{"rxdllrdcmdctl0", "", 0x0000010C, 5, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields413[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{1, 31, 0x0000000000000000, "RO", "Reserved", "Reserved"},
#else
{1, 31, 0x0000000000000000, "RO", "Reserved", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 0, 0x0000000000000000, "RW", "dllcomprst_b", "Power-on or software reset0: reset state1: norma operationSet to 1 to enter normal operation."},
#else
{0, 0, 0x0000000000000000, "RW", "dllcomprst_b", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo413[] = {{"dllcomp_reset", "", 0x00000600, 2, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields414[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{1, 31, 0x0000000000000000, "RO", "Reserved", "Reserved"},
#else
{1, 31, 0x0000000000000000, "RO", "Reserved", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 0, 0x0000000000000000, "RW/1S/V", "txdll_init", "Activates initialization training sequence.0: initialization training sequence not active.1: initialization training sequence active.Self clearing after successful initialization training sequence."},
#else
{0, 0, 0x0000000000000000, "RW/1S/V", "txdll_init", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo414[] = {{"dllcomp_init", "", 0x00000604, 2, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields415[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{1, 31, 0x0000000000000000, "RO", "Reserved", "Reserved"},
#else
{1, 31, 0x0000000000000000, "RO", "Reserved", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 0, 0x0000000000000000, "RW", "lpddr_type", "LPDDR speed target. 0: LPDDR3, 1600 MHz. 1: LPDDR4, 3200 MHz."},
#else
{0, 0, 0x0000000000000000, "RW", "lpddr_type", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo415[] = {{"dllcomp_lpddrtype", "", 0x00000608, 2, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields416[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{1, 31, 0x0000000000000000, "RO", "Reserved", "Reserved"},
#else
{1, 31, 0x0000000000000000, "RO", "Reserved", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 0, 0x0000000000000001, "RW", "clkungate", "Internal Clock control. 0 = allow clock gating for low power; 1 = allow free running clock"},
#else
{0, 0, 0x0000000000000001, "RW", "clkungate", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo416[] = {{"dllcomp_clkungate", "", 0x0000060C, 2, 0x00000000FFFFFFFF, 0x0000000000000001}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields417[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{8, 31, 0x0000000000000000, "RO", "Reserved", "Reserved"},
#else
{8, 31, 0x0000000000000000, "RO", "Reserved", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{7, 7, 0x0000000000000000, "RO/V", "txdll_lock_error", "Set when initialization or fine periodic training failed the locking condition. Cleared on a read or writing a 0."},
#else
{7, 7, 0x0000000000000000, "RO/V", "txdll_lock_error", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{6, 6, 0x0000000000000000, "RO/V", "txdll_fine_error", "Set when fine code underflow or overflow occurs. Cleared on a read or writing a 0."},
#else
{6, 6, 0x0000000000000000, "RO/V", "txdll_fine_error", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{5, 5, 0x0000000000000000, "RO/V", "txdll_coarsep_error", "Set when coarse code underflow or overflow occurs. Cleared on a read or writing a 0."},
#else
{5, 5, 0x0000000000000000, "RO/V", "txdll_coarsep_error", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{4, 4, 0x0000000000000000, "RO/V", "txdll_error", "Set when Delay Cell count exceeds maximum value. Cleared on a read or writing a 0."},
#else
{4, 4, 0x0000000000000000, "RO/V", "txdll_error", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{2, 3, 0x0000000000000000, "RO", "Reserved0", "Reserved"},
#else
{2, 3, 0x0000000000000000, "RO", "Reserved0", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{1, 1, 0x0000000000000000, "RO/V", "txdll_lock_flag", "Set when initialization or fine periodic training passed the locking condition. Valid only when scr_lockseq_en is set to 1.Cleared on a read or writing a 0."},
#else
{1, 1, 0x0000000000000000, "RO/V", "txdll_lock_flag", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 0, 0x0000000000000000, "RO/V", "txdll_init_done", "Set when Initialization sequence is successful. Cleared on a read or writing a 0."},
#else
{0, 0, 0x0000000000000000, "RO/V", "txdll_init_done", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo417[] = {{"dllcomp_error_status", "", 0x00000610, 8, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields418[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{21, 31, 0x0000000000000000, "RO", "Reserved", "Reserved"},
#else
{21, 31, 0x0000000000000000, "RO", "Reserved", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{16, 20, 0x0000000000000007, "RO/V", "txdll_stat_fbmuxsel", "Delay Cell count value during normal operation"},
#else
{16, 20, 0x0000000000000007, "RO/V", "txdll_stat_fbmuxsel", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{12, 15, 0x000000000000000F, "RO/V", "txdll_stat_coarseicode", "Coarse code value at initialization training sequence completion."},
#else
{12, 15, 0x000000000000000F, "RO/V", "txdll_stat_coarseicode", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{8, 11, 0x000000000000000F, "RO/V", "txdll_stat_coarsecode", "Coarse code value during normal operation"},
#else
{8, 11, 0x000000000000000F, "RO/V", "txdll_stat_coarsecode", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 7, 0x000000000000007F, "RO/V", "txdll_stat_finecode", "Fine code value during normal operation"},
#else
{0, 7, 0x000000000000007F, "RO/V", "txdll_stat_finecode", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo418[] = {{"dllcomp_code_status", "", 0x00000614, 5, 0x00000000FFFFFFFF, 0x000000000007FF7F}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields419[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{31, 31, 0x0000000000000000, "RW", "lock_seq_en", "Enable lock sequence after initialization or fine periodic training sequence. 0: disable lock sequence. 1: enable lock sequence."},
#else
{31, 31, 0x0000000000000000, "RW", "lock_seq_en", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{30, 30, 0x0000000000000000, "RW", "lockerror_ignore", "Ignore lock error. Valid when scr_lockseq_en = 1. 0: Exit and wait for initialization training sequence. 1: ignore lock error and proceed to normal operation."},
#else
{30, 30, 0x0000000000000000, "RW", "lockerror_ignore", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{4, 29, 0x0000000000000000, "RO", "Reserved", "Reserved"},
#else
{4, 29, 0x0000000000000000, "RO", "Reserved", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 3, 0x0000000000000003, "RW", "lockcount_size", "Maximum samples to count for lock condition. The counter decrements until the value reaches 0 yielding scr_lockcount_size + 1 samples."},
#else
{0, 3, 0x0000000000000003, "RW", "lockcount_size", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo419[] = {{"dllcomp_lockctl", "", 0x00000618, 4, 0x00000000FFFFFFFF, 0x0000000000000003}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields420[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{31, 31, 0x0000000000000000, "RW", "muxcode_ovr_sel", "Override txdll_fbmuxsel[4:0] with scr_muxcode_ovr[4:0].0: disable override.1: enable override."},
#else
{31, 31, 0x0000000000000000, "RW", "muxcode_ovr_sel", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{21, 30, 0x0000000000000000, "RO", "Reserved", "Reserved"},
#else
{21, 30, 0x0000000000000000, "RO", "Reserved", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{16, 20, 0x000000000000000F, "RW", "muxcode_ovr", "Delay cell fbmuxsel override value."},
#else
{16, 20, 0x000000000000000F, "RW", "muxcode_ovr", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{13, 15, 0x0000000000000000, "RO", "Reserved0", "Reserved"},
#else
{13, 15, 0x0000000000000000, "RO", "Reserved0", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{8, 12, 0x000000000000001B, "RW", "muxcode_max", "Delay cell maximum count value. Used in overflow check"},
#else
{8, 12, 0x000000000000001B, "RW", "muxcode_max", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{5, 7, 0x0000000000000000, "RO", "Reserved1", "Reserved"},
#else
{5, 7, 0x0000000000000000, "RO", "Reserved1", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 4, 0x0000000000000009, "RW", "muxcode_min", "Delay cell minimum count value. Default start code."},
#else
{0, 4, 0x0000000000000009, "RW", "muxcode_min", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo420[] = {{"dllcomp_fbmuxsel", "", 0x0000061C, 7, 0x00000000FFFFFFFF, 0x00000000000F1B09}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields421[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{31, 31, 0x0000000000000000, "RW", "coarsecode_ovr_sel", "Override txdll_coarsecode[3:0] with scr_coarsecode_ovr[3:0]. 0: disable override, 1: enable override"},
#else
{31, 31, 0x0000000000000000, "RW", "coarsecode_ovr_sel", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{30, 30, 0x0000000000000000, "RW", "coarseicode_ovr_sel", "Override txdll_coarseicode[3:0] with scr_coarseicode_ovr[3:0]. 0: disable override, 1: enable override"},
#else
{30, 30, 0x0000000000000000, "RW", "coarseicode_ovr_sel", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{28, 29, 0x0000000000000000, "RO", "Reserved", "Reserved"},
#else
{28, 29, 0x0000000000000000, "RO", "Reserved", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{24, 27, 0x0000000000000002, "RW", "coarseicode_ovr", "Coarsei code override value."},
#else
{24, 27, 0x0000000000000002, "RW", "coarseicode_ovr", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{20, 23, 0x0000000000000000, "RO", "Reserved0", "Reserved"},
#else
{20, 23, 0x0000000000000000, "RO", "Reserved0", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{16, 19, 0x0000000000000002, "RW", "coarsecode_ovr", "Coarse code override value."},
#else
{16, 19, 0x0000000000000002, "RW", "coarsecode_ovr", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{12, 15, 0x0000000000000000, "RO", "Reserved1", "Reserved"},
#else
{12, 15, 0x0000000000000000, "RO", "Reserved1", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{8, 11, 0x000000000000000F, "RW", "coarsecode_max", "Coarse code maximum count value. Default start value. Used in overflow check"},
#else
{8, 11, 0x000000000000000F, "RW", "coarsecode_max", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{4, 7, 0x0000000000000000, "RO", "Reserved2", "Reserved"},
#else
{4, 7, 0x0000000000000000, "RO", "Reserved2", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 3, 0x0000000000000002, "RW", "coarsecode_min", "Coarse code minimum count value. Used in underflow check."},
#else
{0, 3, 0x0000000000000002, "RW", "coarsecode_min", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo421[] = {{"dllcomp_coarsecode", "", 0x00000620, 10, 0x00000000FFFFFFFF, 0x0000000002020F02}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields422[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{24, 31, 0x00000000000000CF, "RW", "finecodemax_limit", "Fine code limit - maximum value. Defines fine code drift allowed towards finecode maximum value before incrementing the coarse code for binary search training."},
#else
{24, 31, 0x00000000000000CF, "RW", "finecodemax_limit", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{16, 23, 0x0000000000000034, "RW", "finecodemin_limit", "Fine code limit - minimum value. Defines fine code drift allowed towards finecode minimum value before decrementing the coarse code for binary search training."},
#else
{16, 23, 0x0000000000000034, "RW", "finecodemin_limit", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{8, 15, 0x00000000000000FF, "RW", "finecode_max", "Fine code maximum value. Used in overflow check during fine continuous or fine periodic"},
#else
{8, 15, 0x00000000000000FF, "RW", "finecode_max", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 7, 0x0000000000000020, "RW", "finecode_min", "Underflow check during fine continuous or fine periodic training."},
#else
{0, 7, 0x0000000000000020, "RW", "finecode_min", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo422[] = {{"dllcomp_finecode", "", 0x00000624, 4, 0x00000000FFFFFFFF, 0x00000000CF34FF20}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields423[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{8, 31, 0x0000000000000000, "RO", "Reserved", "Reserved"},
#else
{8, 31, 0x0000000000000000, "RO", "Reserved", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 7, 0x00000000000000E8, "RW", "finecode_muxsel", "Two bit field selects one of 4 possible finecode values for each 8:1 mux input. Two bit field shared between -/+ index values (ex. -gf / +gf)"},
#else
{0, 7, 0x00000000000000E8, "RW", "finecode_muxsel", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo423[] = {{"dllcomp_finemuxsel", "", 0x00000628, 2, 0x00000000FFFFFFFF, 0x00000000000000E8}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields424[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{31, 31, 0x0000000000000000, "RW", "finec_mode", "Fine continuous training enable after initialization training. 0: Fine continuous training disable. 1: Fine continuous training enable (default). When both finec_mode and finep_mode are set to 1, dllcomp functionality is unpredictable."},
#else
{31, 31, 0x0000000000000000, "RW", "finec_mode", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{30, 30, 0x0000000000000000, "RW", "finep_mode", "Fine priodic training enable after initialization training. 0: Fine periodic disable (default). 1: Fine periodic enable. When both finec_mode and finep_mode are set to 1, dllcomp functionality is unpredictable."},
#else
{30, 30, 0x0000000000000000, "RW", "finep_mode", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{29, 29, 0x0000000000000000, "RW", "searchalgo_long", "Propriety search algorithm version to apply during lock, fine continuous and fine periodic training. 0: Apply short version. 1: Apply long version."},
#else
{29, 29, 0x0000000000000000, "RW", "searchalgo_long", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{8, 28, 0x0000000000000000, "RO", "Reserved", "Reserved"},
#else
{8, 28, 0x0000000000000000, "RO", "Reserved", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 7, 0x000000000000007F, "RW", "finecode_start", "Fine code start value to apply during binary search training"},
#else
{0, 7, 0x000000000000007F, "RW", "finecode_start", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo424[] = {{"dllcomp_finectl", "", 0x0000062C, 5, 0x00000000FFFFFFFF, 0x000000000000007F}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields425[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{31, 31, 0x0000000000000000, "RW", "finecode_ovr_sel", "Fine code override select. 0: Apply computed fine code (default). 1: Apply scr_finecode_ovr[7:0] ."},
#else
{31, 31, 0x0000000000000000, "RW", "finecode_ovr_sel", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{30, 30, 0x0000000000000000, "RW", "finecode_updateovr_ovr", "When scr_finecode_ovr_sel is active high, this bit drives txdll_dllupdateovr"},
#else
{30, 30, 0x0000000000000000, "RW", "finecode_updateovr_ovr", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{8, 29, 0x0000000000000000, "RO", "Reserved", "Reserved"},
#else
{8, 29, 0x0000000000000000, "RO", "Reserved", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 7, 0x0000000000000013, "RW", "finecode_ovr", "Fine code to override with when scr_finecode_ovr_sel = 1"},
#else
{0, 7, 0x0000000000000013, "RW", "finecode_ovr", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo425[] = {{"dllcomp_finecodeovr", "", 0x00000630, 4, 0x00000000FFFFFFFF, 0x0000000000000013}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields426[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{16, 31, 0x0000000000000000, "RO", "Reserved", "Reserved"},
#else
{16, 31, 0x0000000000000000, "RO", "Reserved", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 15, 0x0000000000003FFF, "RW", "finepwait_interval", "Fine periodic interval timer start value. Defines the interval between back to back fine periodic training sequences."},
#else
{0, 15, 0x0000000000003FFF, "RW", "finepwait_interval", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo426[] = {{"dllcomp_fptimer", "", 0x00000634, 2, 0x00000000FFFFFFFF, 0x0000000000003FFF}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields427[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{13, 31, 0x0000000000000000, "RO", "Reserved", "Reserved"},
#else
{13, 31, 0x0000000000000000, "RO", "Reserved", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{8, 12, 0x0000000000000006, "RW", "samplewait_max", "Wait interval between code update and sample ready. Applied during lock, fine continuous and fine"},
#else
{8, 12, 0x0000000000000006, "RW", "samplewait_max", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{5, 7, 0x0000000000000000, "RO", "Reserved0", "Reserved"},
#else
{5, 7, 0x0000000000000000, "RO", "Reserved0", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 4, 0x0000000000000002, "RW", "samplewait_min", "Wait interval between code update and sample ready. Applied during coarse initialization and fine"},
#else
{0, 4, 0x0000000000000002, "RW", "samplewait_min", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo427[] = {{"dllcomp_samplewait", "", 0x00000638, 4, 0x00000000FFFFFFFF, 0x0000000000000602}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields428[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{31, 31, 0x0000000000000000, "RW", "rxdll_coarsecode_ovr_sel", "Override rxdll_coarsecode[3:0] with scr_rxdll_coarsecode_ovr[3:0] . 0: disable override. 1: enable override."},
#else
{31, 31, 0x0000000000000000, "RW", "rxdll_coarsecode_ovr_sel", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{4, 30, 0x0000000000000000, "RO", "Reserved", "Reserved"},
#else
{4, 30, 0x0000000000000000, "RO", "Reserved", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 3, 0x0000000000000002, "RW", "rxdll_coarsecode_ovr", "Coarse code override value for rxdll_coarsecode[3:0]"},
#else
{0, 3, 0x0000000000000002, "RW", "rxdll_coarsecode_ovr", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo428[] = {{"dllcomp_rxcoarseovr", "", 0x0000063C, 3, 0x00000000FFFFFFFF, 0x0000000000000002}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields429[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{31, 31, 0x0000000000000000, "RW", "rxdll_finecode_ovr_sel", "Override rxdll_finecode[7:0] with scr_rxdll_finecode_ovr[7:0] . 0: disable override. 1: enable override."},
#else
{31, 31, 0x0000000000000000, "RW", "rxdll_finecode_ovr_sel", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{30, 30, 0x0000000000000000, "RW", "rxdll_finecode_updateovr_ovr", "When scr_rxdll_finecode_ovr_sel is active high, this bit drives rxdll_rxdqsdllupdateovr"},
#else
{30, 30, 0x0000000000000000, "RW", "rxdll_finecode_updateovr_ovr", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{8, 29, 0x0000000000000000, "RO", "Reserved", "Reserved"},
#else
{8, 29, 0x0000000000000000, "RO", "Reserved", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 7, 0x0000000000000013, "RW", "rxdll_finecode_ovr", "FIne code override value for rxdll_finecode[7:0]"},
#else
{0, 7, 0x0000000000000013, "RW", "rxdll_finecode_ovr", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo429[] = {{"dllcomp_rxfineovr", "", 0x00000640, 4, 0x00000000FFFFFFFF, 0x0000000000000013}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields430[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{17, 31, 0x0000000000000000, "RO", "reserved673", "Reserved"},
#else
{17, 31, 0x0000000000000000, "RO", "reserved673", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{16, 16, 0x0000000000000000, "RW", "dfxlowervisaulm0_bypass", "VISA Lower Level Bypass ULM0"},
#else
{16, 16, 0x0000000000000000, "RW", "dfxlowervisaulm0_bypass", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{8, 15, 0x0000000000000000, "RW", "dfxlowervisaulm0_clksel", "VISA Lower Level ULM0 CLK Select"},
#else
{8, 15, 0x0000000000000000, "RW", "dfxlowervisaulm0_clksel", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 7, 0x0000000000000000, "RW", "dfxlowervisaulm0_datasel", "VISA Lower Level ULM0 Lane (DATA) Select"},
#else
{0, 7, 0x0000000000000000, "RW", "dfxlowervisaulm0_datasel", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo430[] = {{"lower_dfxvisaulm0", "", 0x00000700, 4, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields431[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{17, 31, 0x0000000000000000, "RO", "reserved674", "Reserved"},
#else
{17, 31, 0x0000000000000000, "RO", "reserved674", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{16, 16, 0x0000000000000000, "RW", "dfxlowervisaulm1_bypass", "VISA Lower Level Bypass ULM1"},
#else
{16, 16, 0x0000000000000000, "RW", "dfxlowervisaulm1_bypass", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{8, 15, 0x0000000000000000, "RW", "dfxlowervisaulm1_clksel", "VISA Lower Level ULM1 CLK Select"},
#else
{8, 15, 0x0000000000000000, "RW", "dfxlowervisaulm1_clksel", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 7, 0x0000000000000000, "RW", "dfxlowervisaulm1_datasel", "VISA Lower Level ULM1 Lane (DATA) Select"},
#else
{0, 7, 0x0000000000000000, "RW", "dfxlowervisaulm1_datasel", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo431[] = {{"lower_dfxvisaulm1", "", 0x00000704, 4, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields432[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{7, 31, 0x0000000000000000, "RO", "reserved675", "Reserved"},
#else
{7, 31, 0x0000000000000000, "RO", "reserved675", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{4, 6, 0x0000000000000000, "RW", "dfxlowervisapattgen_msb", "VISA Lower Level ULM Pattern Generation"},
#else
{4, 6, 0x0000000000000000, "RW", "dfxlowervisapattgen_msb", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 3, 0x0000000000000000, "RW", "dfxlowervisapattgen_lsb", "VISA Lower Level ULM Pattern Generation"},
#else
{0, 3, 0x0000000000000000, "RW", "dfxlowervisapattgen_lsb", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo432[] = {{"lower_dfxvisapattgen", "", 0x00000708, 3, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields433[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{17, 31, 0x0000000000000000, "RO", "reserved676", "Reserved"},
#else
{17, 31, 0x0000000000000000, "RO", "reserved676", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{16, 16, 0x0000000000000000, "RW", "dfxtopvisaulm0_bypass", "VISA Top Level Bypass ULM0"},
#else
{16, 16, 0x0000000000000000, "RW", "dfxtopvisaulm0_bypass", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{8, 15, 0x0000000000000000, "RW", "dfxtopvisaulm0_clksel", "VISA Top Level ULM0 CLK Select"},
#else
{8, 15, 0x0000000000000000, "RW", "dfxtopvisaulm0_clksel", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 7, 0x0000000000000000, "RW", "dfxtopvisaulm0_datasel", "VISA Top Level ULM0 Lane (DATA) Select"},
#else
{0, 7, 0x0000000000000000, "RW", "dfxtopvisaulm0_datasel", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo433[] = {{"top_dfxvisaulm0", "", 0x0000070C, 4, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields434[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{17, 31, 0x0000000000000000, "RO", "reserved677", "Reserved"},
#else
{17, 31, 0x0000000000000000, "RO", "reserved677", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{16, 16, 0x0000000000000000, "RW", "dfxtopvisaulm1_bypass", "VISA Top Level Bypass ULM1"},
#else
{16, 16, 0x0000000000000000, "RW", "dfxtopvisaulm1_bypass", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{8, 15, 0x0000000000000000, "RW", "dfxtopvisaulm1_clksel", "VISA Top Level ULM1 CLK Select"},
#else
{8, 15, 0x0000000000000000, "RW", "dfxtopvisaulm1_clksel", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 7, 0x0000000000000000, "RW", "dfxtopvisaulm1_datasel", "VISA Top Level ULM1 Lane (DATA) Select"},
#else
{0, 7, 0x0000000000000000, "RW", "dfxtopvisaulm1_datasel", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo434[] = {{"top_dfxvisaulm1", "", 0x00000710, 4, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields435[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{7, 31, 0x0000000000000000, "RO", "reserved678", "Reserved"},
#else
{7, 31, 0x0000000000000000, "RO", "reserved678", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{4, 6, 0x0000000000000000, "RW", "dfxtopvisapattgen_msb", "VISA Top Level ULM Pattern Generation"},
#else
{4, 6, 0x0000000000000000, "RW", "dfxtopvisapattgen_msb", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 3, 0x0000000000000000, "RW", "dfxtopvisapattgen_lsb", "VISA Top Level ULM Pattern Generation"},
#else
{0, 3, 0x0000000000000000, "RW", "dfxtopvisapattgen_lsb", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo435[] = {{"top_dfxvisapattgen", "", 0x00000714, 3, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields436[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{22, 31, 0x0000000000000000, "RO", "reserved679", "Reserved bits"},
#else
{22, 31, 0x0000000000000000, "RO", "reserved679", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{21, 21, 0x0000000000000000, "RW", "bl_dfxmrgtxovren", "DQ Bytelane Tx FIFO Margin Mode config override enable for Tx data path and Latch enables via  DFXMRGTXFIFO[24:0]    1'b1  - Enable TxFIFO DFx overrides on Latch enables and TxData  1'b0 - Functional Mode of operation"},
#else
{21, 21, 0x0000000000000000, "RW", "bl_dfxmrgtxovren", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{20, 20, 0x0000000000000000, "RW", "bl_dfxmrgtxwren", "DQ Bytelane TxFIFO Margin Mode Latch enable override value used to make TxFIFO latches transparent allowing the loading of all TxFIFO Latches with data programmed in DFXMRGTXFIFO[23:0], if dfxmrgtxovren is asserted(1'b1)  1'b1 - All DQ/DM/DQS Tx FIFO Latches Transparent  0'b0 - All DQ/DM/DQS TxFIFO Latches CLosed"},
#else
{20, 20, 0x0000000000000000, "RW", "bl_dfxmrgtxwren", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{18, 19, 0x0000000000000000, "RW", "bl_dfxmrgtxdqsrise", "DQ Bytelane Tx FIFO Margin Mode DQS/B Rise Tx SubFIFO data load value. The value loaded will apply to all DQ Bytelane DQS/B Rise SubFIFOs. Recommended setting for HVM = 2'b00"},
#else
{18, 19, 0x0000000000000000, "RW", "bl_dfxmrgtxdqsrise", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{16, 17, 0x0000000000000000, "RW", "bl_dfxmrgtxdqsfall", "DQ Bytelane Tx FIFO Margin Mode DQS/B Fall Tx SubFIFO data load value. The value loaded will apply to all DQ Bytelane DQS/B Fall SubFIFOs. Recommended setting for HVM = 2'b00"},
#else
{16, 17, 0x0000000000000000, "RW", "bl_dfxmrgtxdqsfall", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{14, 15, 0x0000000000000000, "RW", "bl_dfxmrgtxdrise_ph0", "DQ Bytelane Tx FIFO Margin Mode DQ Phase0 Rise Tx SubFIFO load value. The value loaded will apply to all DQ BL Phase 0 Rise SubFIFOs  There isnt a valid or invalid value for this field, recommended setting for HVM = 2'b00"},
#else
{14, 15, 0x0000000000000000, "RW", "bl_dfxmrgtxdrise_ph0", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{12, 13, 0x0000000000000000, "RW", "bl_dfxmrgtxdrise_ph1", "DQ Bytelane Tx FIFO Margin Mode DQ Phase1 Rise Tx SubFIFO load value. The value loaded will apply to all DQ BL Phase 1 Rise SubFIFOs  There isnt a valid or invalid value for this field, recommended setting for HVM = 2'b00"},
#else
{12, 13, 0x0000000000000000, "RW", "bl_dfxmrgtxdrise_ph1", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{10, 11, 0x0000000000000000, "RW", "bl_dfxmrgtxdrise_ph2", "DQ Bytelane Tx FIFO Margin Mode DQ Phase0 Rise Tx SubFIFO load value. The value loaded will apply to all DQ BL Phase 2 Rise SubFIFOs  There isnt a valid or invalid value for this field, recommended setting for HVM = 2'b00"},
#else
{10, 11, 0x0000000000000000, "RW", "bl_dfxmrgtxdrise_ph2", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{8, 9, 0x0000000000000000, "RW", "bl_dfxmrgtxdrise_ph3", "DQ Bytelane Tx FIFO Margin Mode DQ Phase1 Rise Tx SubFIFO load value. The value loaded will apply to all DQ BL Phase 3 Rise SubFIFOs  There isnt a valid or invalid value for this field, recommended setting for HVM = 2'b00"},
#else
{8, 9, 0x0000000000000000, "RW", "bl_dfxmrgtxdrise_ph3", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{6, 7, 0x0000000000000000, "RW", "bl_dfxmrgtxdfall_ph0", "DQ Bytelane Tx FIFO Margin Mode DQ Phase0 Fall Tx SubFIFO load value. The value loaded will apply to all DQ BL Phase 0 Fall SubFIFOs  There isnt a valid or invalid value for this field, recommended setting for HVM = 2'b00"},
#else
{6, 7, 0x0000000000000000, "RW", "bl_dfxmrgtxdfall_ph0", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{4, 5, 0x0000000000000000, "RW", "bl_dfxmrgtxdfall_ph1", "DQ Bytelane Tx FIFO Margin Mode DQ Phase1 Fall Tx SubFIFO load value. The value loaded will apply to all DQ BL Phase 1 Fall SubFIFOs  There isnt a valid or invalid value for this field, recommended setting for HVM = 2'b00"},
#else
{4, 5, 0x0000000000000000, "RW", "bl_dfxmrgtxdfall_ph1", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{2, 3, 0x0000000000000000, "RW", "bl_dfxmrgtxdfall_ph2", "DQ Bytelane Tx FIFO Margin Mode DQ Phase2 Fall Tx SubFIFO load value. The value loaded will apply to all DQ BL Phase 2 Fall SubFIFOs  There isnt a valid or invalid value for this field, recommended setting for HVM = 2'b00"},
#else
{2, 3, 0x0000000000000000, "RW", "bl_dfxmrgtxdfall_ph2", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 1, 0x0000000000000000, "RW", "bl_dfxmrgtxdfall_ph3", "DQ Bytelane Tx FIFO Margin Mode DQ Phase3 Fall Tx SubFIFO load value. The value loaded will apply to all DQ BL Phase 3 Rise SubFIFOs  There isnt a valid or invalid value for this field, recommended setting for HVM = 2'b00"},
#else
{0, 1, 0x0000000000000000, "RW", "bl_dfxmrgtxdfall_ph3", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo436[] = {{"dfxmrg_bl", "", 0x00000718, 13, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields437[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{30, 31, 0x0000000000000000, "RO", "reserved680", "Reserved bits"},
#else
{30, 31, 0x0000000000000000, "RO", "reserved680", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{29, 29, 0x0000000000000000, "RW", "cc_dfxmrgtxovren", "DQCCC Bytelane Tx FIFO Margin Mode config override enable for Tx data path and Latch enables via  DFXMRGTXFIFO[24:0]    1'b1  - Enable TxFIFO DFx overrides on Latch enables and TxData  1'b0 - Functional Mode of operation"},
#else
{29, 29, 0x0000000000000000, "RW", "cc_dfxmrgtxovren", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{28, 28, 0x0000000000000000, "RW", "cc_dfxmrgtxwren", "DQCCC Bytelane TxFIFO Margin Mode Latch enable override value used to make TxFIFO latches transparent allowing the loading of all TxFIFO Latches with data programmed in DFXMRGTXFIFO[23:0], if dfxmrgtxovren is asserted(1'b1)  1'b1 - All DQCCC/DM/DQCCCS Tx FIFO Latches Transparent  0'b0 - All DQCCC/DM/DQCCCS TxFIFO Latches CLosed"},
#else
{28, 28, 0x0000000000000000, "RW", "cc_dfxmrgtxwren", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{26, 27, 0x0000000000000000, "RW", "cc_dfxmrgtxdqsrise", "DQCCC Bytelane Tx FIFO Margin Mode DQCCCS/B Rise Tx SubFIFO data load value. The value loaded will apply to all DQCCC Bytelane DQCCCS/B Rise SubFIFOs. Recommended setting for HVM = 2'b00"},
#else
{26, 27, 0x0000000000000000, "RW", "cc_dfxmrgtxdqsrise", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{24, 25, 0x0000000000000000, "RW", "cc_dfxmrgtxdqsfall", "DQCCC Bytelane Tx FIFO Margin Mode DQCCCS/B Fall Tx SubFIFO data load value. The value loaded will apply to all DQCCC Bytelane DQCCCS/B Fall SubFIFOs. Recommended setting for HVM = 2'b00"},
#else
{24, 25, 0x0000000000000000, "RW", "cc_dfxmrgtxdqsfall", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{22, 23, 0x0000000000000000, "RW", "cc_dfxmrgtxdrise_ph0", "DQCCC Bytelane Tx FIFO Margin Mode DQCCC Phase0 Rise Tx SubFIFO load value. The value loaded will apply to all DQCCC BL Phase 0 Rise SubFIFOs  There isnt a valid or invalid value for this field, recommended setting for HVM = 2'b00"},
#else
{22, 23, 0x0000000000000000, "RW", "cc_dfxmrgtxdrise_ph0", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{20, 21, 0x0000000000000000, "RW", "cc_dfxmrgtxdrise_ph1", "DQCCC Bytelane Tx FIFO Margin Mode DQCCC Phase1 Rise Tx SubFIFO load value. The value loaded will apply to all DQCCC BL Phase 1 Rise SubFIFOs  There isnt a valid or invalid value for this field, recommended setting for HVM = 2'b00"},
#else
{20, 21, 0x0000000000000000, "RW", "cc_dfxmrgtxdrise_ph1", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{18, 19, 0x0000000000000000, "RW", "cc_dfxmrgtxdrise_ph2", "DQCCC Bytelane Tx FIFO Margin Mode DQCCC Phase0 Rise Tx SubFIFO load value. The value loaded will apply to all DQCCC BL Phase 2 Rise SubFIFOs  There isnt a valid or invalid value for this field, recommended setting for HVM = 2'b00"},
#else
{18, 19, 0x0000000000000000, "RW", "cc_dfxmrgtxdrise_ph2", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{16, 17, 0x0000000000000000, "RW", "cc_dfxmrgtxdrise_ph3", "DQCCC Bytelane Tx FIFO Margin Mode DQCCC Phase1 Rise Tx SubFIFO load value. The value loaded will apply to all DQCCC BL Phase 3 Rise SubFIFOs  There isnt a valid or invalid value for this field, recommended setting for HVM = 2'b00"},
#else
{16, 17, 0x0000000000000000, "RW", "cc_dfxmrgtxdrise_ph3", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{14, 15, 0x0000000000000000, "RW", "cc_dfxmrgtxdfall_ph0", "DQCCC Bytelane Tx FIFO Margin Mode DQCCC Phase0 Fall Tx SubFIFO load value. The value loaded will apply to all DQCCC BL Phase 0 Fall SubFIFOs  There isnt a valid or invalid value for this field, recommended setting for HVM = 2'b00"},
#else
{14, 15, 0x0000000000000000, "RW", "cc_dfxmrgtxdfall_ph0", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{12, 13, 0x0000000000000000, "RW", "cc_dfxmrgtxdfall_ph1", "DQCCC Bytelane Tx FIFO Margin Mode DQCCC Phase1 Fall Tx SubFIFO load value. The value loaded will apply to all DQCCC BL Phase 1 Fall SubFIFOs  There isnt a valid or invalid value for this field, recommended setting for HVM = 2'b00"},
#else
{12, 13, 0x0000000000000000, "RW", "cc_dfxmrgtxdfall_ph1", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{10, 11, 0x0000000000000000, "RW", "cc_dfxmrgtxdfall_ph2", "DQCCC Bytelane Tx FIFO Margin Mode DQCCC Phase2 Fall Tx SubFIFO load value. The value loaded will apply to all DQCCC BL Phase 2 Fall SubFIFOs  There isnt a valid or invalid value for this field, recommended setting for HVM = 2'b00"},
#else
{10, 11, 0x0000000000000000, "RW", "cc_dfxmrgtxdfall_ph2", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{8, 9, 0x0000000000000000, "RW", "cc_dfxmrgtxdfall_ph3", "DQCCC Bytelane Tx FIFO Margin Mode DQCCC Phase3 Fall Tx SubFIFO load value. The value loaded will apply to all DQCCC BL Phase 3 Rise SubFIFOs  There isnt a valid or invalid value for this field, recommended setting for HVM = 2'b00"},
#else
{8, 9, 0x0000000000000000, "RW", "cc_dfxmrgtxdfall_ph3", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{6, 7, 0x0000000000000000, "RW", "cc_dfxmrgtxdsdr_ph0", "DQCCC Bytelane Tx FIFO Margin Mode DQCCC Phase0 SDR Tx SubFIFO load value. The value loaded will apply to all DQCCC BL Phase 0 SDR SubFIFOs  There isnt a valid or invalid value for this field, recommended setting for HVM = 2'b00"},
#else
{6, 7, 0x0000000000000000, "RW", "cc_dfxmrgtxdsdr_ph0", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{4, 5, 0x0000000000000000, "RW", "cc_dfxmrgtxdsdr_ph1", "DQCCC Bytelane Tx FIFO Margin Mode DQCCC Phase1 SDR Tx SubFIFO load value. The value loaded will apply to all DQCCC BL Phase 1 SDR SubFIFOs  There isnt a valid or invalid value for this field, recommended setting for HVM = 2'b00"},
#else
{4, 5, 0x0000000000000000, "RW", "cc_dfxmrgtxdsdr_ph1", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{2, 3, 0x0000000000000000, "RW", "cc_dfxmrgtxdsdr_ph2", "DQCCC Bytelane Tx FIFO Margin Mode DQCCC Phase2 SDR Tx SubFIFO load value. The value loaded will apply to all DQCCC BL Phase 2 SDR SubFIFOs  There isnt a valid or invalid value for this field, recommended setting for HVM = 2'b11"},
#else
{2, 3, 0x0000000000000000, "RW", "cc_dfxmrgtxdsdr_ph2", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 1, 0x0000000000000000, "RW", "cc_dfxmrgtxdsdr_ph3", "DQCCC Bytelane Tx FIFO Margin Mode DQCCC Phase3 SDR Tx SubFIFO load value. The value loaded will apply to all DQCCC BL Phase 3 Rise SubFIFOs  There isnt a valid or invalid value for this field, recommended setting for HVM = 2'b00"},
#else
{0, 1, 0x0000000000000000, "RW", "cc_dfxmrgtxdsdr_ph3", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo437[] = {{"dfxmrg_cc", "", 0x0000071C, 17, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields438[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{8, 31, 0x0000000000000000, "RO", "reserved681", "Reserved bits"},
#else
{8, 31, 0x0000000000000000, "RO", "reserved681", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 7, 0x0000000000000000, "RW", "bl_dfxmrgrx_cmpval", "DFx Margin Mode DQ Bytelane Rx Compare value; Used to compare Actual RxFIFO value vs Expected Rx FIFO value(TxFIFO Unloaded)"},
#else
{0, 7, 0x0000000000000000, "RW", "bl_dfxmrgrx_cmpval", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo438[] = {{"dfxmrg_blrx", "", 0x00000720, 2, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields439[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{25, 31, 0x0000000000000000, "RO", "reserved682", "Reserved bits"},
#else
{25, 31, 0x0000000000000000, "RO", "reserved682", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{16, 24, 0x0000000000000000, "RW", "cc_dfxmrgrx_sdrsel", "DFx Margin Mode SDR vs DDR Rx Compare Values"},
#else
{16, 24, 0x0000000000000000, "RW", "cc_dfxmrgrx_sdrsel", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{8, 15, 0x0000000000000000, "RW", "cc_dfxmrgrx_ddrcmpval", "DFx Margin Mode CCC Bytelane Rx Compare value for DDR pins; Used to compare Actual RxFIFO value vs Expected Rx FIFO value(TxFIFO Unloaded)"},
#else
{8, 15, 0x0000000000000000, "RW", "cc_dfxmrgrx_ddrcmpval", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 7, 0x0000000000000000, "RW", "cc_dfxmrgrx_sdrcmpval", "DFx Margin Mode CCC Bytelane Rx Compare value for SDR pins; Used to compare Actual RxFIFO value vs Expected Rx FIFO value(TxFIFO Unloaded)"},
#else
{0, 7, 0x0000000000000000, "RW", "cc_dfxmrgrx_sdrcmpval", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo439[] = {{"dfxmrg_ccrx", "", 0x00000724, 4, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields440[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{28, 31, 0x0000000000000000, "RW", "memtech", "Reserved bits"},
#else
{28, 31, 0x0000000000000000, "RW", "memtech", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{24, 27, 0x0000000000000000, "RW", "memfreq", "Memory frequency"},
#else
{24, 27, 0x0000000000000000, "RW", "memfreq", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{16, 23, 0x0000000000000000, "RW", "phyupd_dly", "Delay between the phy update request to ack [br]in terms of SPID clocks."},
#else
{16, 23, 0x0000000000000000, "RW", "phyupd_dly", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{15, 15, 0x0000000000000000, "RO", "reserved500", "Reserved bits"},
#else
{15, 15, 0x0000000000000000, "RO", "reserved500", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{13, 14, 0x0000000000000000, "RW", "stretchmode", "This is the stretch mode signal.[br]00- normal read[br]01- x4 stretch mode [br]10- x8 stretch mode[br]11- x16 stretch mode"},
#else
{13, 14, 0x0000000000000000, "RW", "stretchmode", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{12, 12, 0x0000000000000000, "RO", "reserved501", "Reserved bits"},
#else
{12, 12, 0x0000000000000000, "RO", "reserved501", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{11, 11, 0x0000000000000000, "RW", "slowpath", "Delay the wrcmd 1 spidclk before write into the fifo.[br]1: 1 spidclk delay[br]0: no delay[br]With clock gating enable, the write pointer is only valid @ the next spid clock edge of write command. -> delay 1 spidclk so we can capture it into the fifo.[br]Set to 1 if do clock gate. Else set it to 0."},
#else
{11, 11, 0x0000000000000000, "RW", "slowpath", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{10, 10, 0x0000000000000000, "RW", "txfifo_csn_ffloppreseten", "This is the txFIFO final flop preset enable[br]1 - iobufact_b assert will preset the final flop, otherwise resets the final flop"},
#else
{10, 10, 0x0000000000000000, "RW", "txfifo_csn_ffloppreseten", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{9, 9, 0x0000000000000000, "RW", "rdmcpsel", "Programmable MCP for Tx FIFO read pointer path."},
#else
{9, 9, 0x0000000000000000, "RW", "rdmcpsel", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{6, 8, 0x0000000000000000, "RO", "reserved502", "Reserved bits"},
#else
{6, 8, 0x0000000000000000, "RO", "reserved502", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{5, 5, 0x0000000000000000, "RW", "bl1632xbl48b", "This is the burstlength configuration register[br]1:BL16 and BL32[br]0:BL4 and BL8"},
#else
{5, 5, 0x0000000000000000, "RW", "bl1632xbl48b", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{3, 4, 0x0000000000000000, "RW", "spidclksel", "SPID clk sel [br]00: 0.5xmode[br]01: 0.25x mode[br]10: 0.1x mode[br]11: NA"},
#else
{3, 4, 0x0000000000000000, "RW", "spidclksel", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{2, 2, 0x0000000000000000, "RW", "lpddr34mode", "Single data rate v/s Double Data rate [br]0: Double data rate (LP3)[br]1: Single data rate (LP4)"},
#else
{2, 2, 0x0000000000000000, "RW", "lpddr34mode", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 1, 0x0000000000000000, "RO", "reserved503", "Reserved bits"},
#else
{0, 1, 0x0000000000000000, "RO", "reserved503", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo440[] = {{"digctl", "", 0x00000000, 14, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields441[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{28, 31, 0x0000000000000000, "RO", "reserved504", "Reserved bits"},
#else
{28, 31, 0x0000000000000000, "RO", "reserved504", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{24, 27, 0x0000000000000000, "RW", "compclkrdptrinit", "DLL comp init configuration."},
#else
{24, 27, 0x0000000000000000, "RW", "compclkrdptrinit", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{21, 23, 0x0000000000000000, "RW", "compclkrdptroffset", "DLL comp read pointer offset."},
#else
{21, 23, 0x0000000000000000, "RW", "compclkrdptroffset", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{17, 20, 0x0000000000000000, "RW", "ref1xrdptrinit", "This is the ref1x read pointer init configuration."},
#else
{17, 20, 0x0000000000000000, "RW", "ref1xrdptrinit", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{16, 16, 0x0000000000000000, "RW", "dqxccb", "Configure DQCCC as DQ or CCC[br]0: CCC[br]1: DQ"},
#else
{16, 16, 0x0000000000000000, "RW", "dqxccb", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{13, 15, 0x0000000000000000, "RW", "ref1xrdptroffset", "This is the ref1xread pointer offset configuration."},
#else
{13, 15, 0x0000000000000000, "RW", "ref1xrdptroffset", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{8, 12, 0x0000000000000000, "RW", "ref2xrdptrinit", "This is the ref2x read pointer init configuration."},
#else
{8, 12, 0x0000000000000000, "RW", "ref2xrdptrinit", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{4, 7, 0x0000000000000000, "RW", "cc_doublefifooffset", "This is the double FIFO offset configuration(in terms of 2xclock)."},
#else
{4, 7, 0x0000000000000000, "RW", "cc_doublefifooffset", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 3, 0x0000000000000000, "RW", "bl_doublefifooffset", "This is the double FIFO offset configuration(in terms of 2xclock)."},
#else
{0, 3, 0x0000000000000000, "RW", "bl_doublefifooffset", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo441[] = {{"fifoptrctl", "", 0x00000004, 9, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields442[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{28, 31, 0x0000000000000000, "RO", "reserved505", "Reserved bits"},
#else
{28, 31, 0x0000000000000000, "RO", "reserved505", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{25, 27, 0x0000000000000000, "RO", "reserved506", "Reserved bits"},
#else
{25, 27, 0x0000000000000000, "RO", "reserved506", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{24, 24, 0x0000000000000000, "RW", "ca_training", "CA training mode"},
#else
{24, 24, 0x0000000000000000, "RW", "ca_training", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{21, 23, 0x0000000000000000, "RO", "reserved507", "Reserved bits"},
#else
{21, 23, 0x0000000000000000, "RO", "reserved507", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{20, 20, 0x0000000000000000, "RW", "clktxdrven", "CK buffer enable[br]1: Enable buffer[br]0: Tristate buffer"},
#else
{20, 20, 0x0000000000000000, "RW", "clktxdrven", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{19, 19, 0x0000000000000000, "RW", "cketxdrven", "CKE buffer enable[br]1: Enable buffer[br]0: Tristate buffer"},
#else
{19, 19, 0x0000000000000000, "RW", "cketxdrven", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{18, 18, 0x0000000000000000, "RW", "cstxdrven", "CS buffer enable[br]1: Enable buffer[br]0: Tristate buffer"},
#else
{18, 18, 0x0000000000000000, "RW", "cstxdrven", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{8, 17, 0x0000000000000000, "RW", "cmdtxdrven", "CMD buffer enable[br]1: Enable buffer[br]0: Tristate buffer"},
#else
{8, 17, 0x0000000000000000, "RW", "cmdtxdrven", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{7, 7, 0x0000000000000000, "RO", "reserved508", "Reserved bits"},
#else
{7, 7, 0x0000000000000000, "RO", "reserved508", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{6, 6, 0x0000000000000000, "RO", "reserved509", "Reserved bits"},
#else
{6, 6, 0x0000000000000000, "RO", "reserved509", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{5, 5, 0x0000000000000000, "RO", "reserved510", "Reserved bits"},
#else
{5, 5, 0x0000000000000000, "RO", "reserved510", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{3, 4, 0x0000000000000000, "RO", "reserved511", "Reserved bits"},
#else
{3, 4, 0x0000000000000000, "RO", "reserved511", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{2, 2, 0x0000000000000000, "RW", "clknegxposb", "Start phase of CK"},
#else
{2, 2, 0x0000000000000000, "RW", "clknegxposb", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{1, 1, 0x0000000000000000, "RW", "cmdtristateovrval", "Command tristate override value"},
#else
{1, 1, 0x0000000000000000, "RW", "cmdtristateovrval", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 0, 0x0000000000000000, "RW", "cmdtristateovrsel", "Command tristate override select"},
#else
{0, 0, 0x0000000000000000, "RW", "cmdtristateovrsel", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo442[] = {{"cccctl", "", 0x00000008, 15, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields443[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{3, 31, 0x0000000000000000, "RO", "reserved512", "Reserved bits"},
#else
{3, 31, 0x0000000000000000, "RO", "reserved512", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{2, 2, 0x0000000000000000, "RW", "rstbtx_enbrst", "Tri-state control for LP4 reset buffer"},
#else
{2, 2, 0x0000000000000000, "RW", "rstbtx_enbrst", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{1, 1, 0x0000000000000000, "RW", "rstbtx_reset", "Reset for the LP4 reset buffer"},
#else
{1, 1, 0x0000000000000000, "RW", "rstbtx_reset", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 0, 0x0000000000000000, "RW", "rstbtx_set", "Set for the LP4 reset buffer"},
#else
{0, 0, 0x0000000000000000, "RW", "rstbtx_set", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo443[] = {{"lp4rstctl", "", 0x0000000C, 4, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields444[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{2, 31, 0x0000000000000000, "RO", "reserved513", "Reserved bits"},
#else
{2, 31, 0x0000000000000000, "RO", "reserved513", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{1, 1, 0x0000000000000000, "RW", "rxfiforst_b", "Rxfifo reset (active low)[br]1: deasserted[br]0 : asserted"},
#else
{1, 1, 0x0000000000000000, "RW", "rxfiforst_b", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 0, 0x0000000000000000, "RW", "spidrst_b", "Reset for functional logic in upartition (except compensation and power management logic)  [br]0: Reset assertion  [br]1: Reset de-assertion"},
#else
{0, 0, 0x0000000000000000, "RW", "spidrst_b", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo444[] = {{"digrstctl", "", 0x00000010, 3, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields445[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{1, 31, 0x0000000000000000, "RO", "reserved514", "Reserved bits"},
#else
{1, 31, 0x0000000000000000, "RO", "reserved514", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 0, 0x0000000000000000, "RW", "wrptren", "Config-controlled Write pointer enable. 0=config control disabled, 1=config control enabled. This bit qualifies the pm_wrptren, which eventually goes to DQPTRGEN Fub."},
#else
{0, 0, 0x0000000000000000, "RW", "wrptren", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo445[] = {{"fifoptren", "", 0x00000014, 2, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields446[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{2, 31, 0x0000000000000000, "RO", "reserved515", "Reserved bits"},
#else
{2, 31, 0x0000000000000000, "RO", "reserved515", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{1, 1, 0x0000000000000000, "RW", "lvl_cc_iobufactafe", "IO buffer activate - CCC Analog[br]Tristates DQ and DQS IO buffers [br]Disable Rx sections of IO buffers [br]0 : reset [br]1 : out of reset"},
#else
{1, 1, 0x0000000000000000, "RW", "lvl_cc_iobufactafe", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 0, 0x0000000000000000, "RW", "lvl_bl_iobufactafe", "IO buffer activate - DQ Analog[br]Tristates DQ and DQS IO buffers [br]Disable Rx sections of IO buffers [br]0 : reset [br]1 : out of reset"},
#else
{0, 0, 0x0000000000000000, "RW", "lvl_bl_iobufactafe", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo446[] = {{"iobufact_afe", "", 0x00000018, 3, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields447[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{2, 31, 0x0000000000000000, "RO", "reserved516", "Reserved bits"},
#else
{2, 31, 0x0000000000000000, "RO", "reserved516", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{1, 1, 0x0000000000000000, "RW", "cc_iobufactdig", "IO buffer activate - CCC Digital[br]Bytelane 1 SW reset for final TX flops in all upartitions."},
#else
{1, 1, 0x0000000000000000, "RW", "cc_iobufactdig", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 0, 0x0000000000000000, "RW", "bl_iobufactdig", "IO buffer activate - DQ Digital[br]Bytelane 1 SW reset for final TX flops in all upartitions."},
#else
{0, 0, 0x0000000000000000, "RW", "bl_iobufactdig", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo447[] = {{"iobufact_dig", "", 0x0000001C, 3, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields448[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{1, 31, 0x0000000000000000, "RO", "reserved517", "Reserved bits"},
#else
{1, 31, 0x0000000000000000, "RO", "reserved517", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 0, 0x0000000000000000, "RW", "spid_init_complete", "SPID init complete"},
#else
{0, 0, 0x0000000000000000, "RW", "spid_init_complete", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo448[] = {{"spidic", "", 0x00000020, 2, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields449[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{10, 31, 0x0000000000000000, "RO", "reserved518", "Reserved bits"},
#else
{10, 31, 0x0000000000000000, "RO", "reserved518", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{8, 9, 0x0000000000000000, "RO", "reserved519", "Reserved bits"},
#else
{8, 9, 0x0000000000000000, "RO", "reserved519", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{6, 7, 0x0000000000000000, "RW", "dqdrvenbph1", "Data mask drive enable"},
#else
{6, 7, 0x0000000000000000, "RW", "dqdrvenbph1", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{4, 5, 0x0000000000000000, "RW", "dqdrvenbpream1", "This is the two write preambles enable"},
#else
{4, 5, 0x0000000000000000, "RW", "dqdrvenbpream1", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{2, 3, 0x0000000000000000, "RW", "dqdrvenblastph", "Last phase - DQ Drive Enable"},
#else
{2, 3, 0x0000000000000000, "RW", "dqdrvenblastph", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 1, 0x0000000000000000, "RW", "dqdrvenbpream0", "This is the DQS configuration for first phase [br](2'b01-dqs_hi_lo,2'b00-dqs_lo_lo,2'b11-dqs_hi_hi)."},
#else
{0, 1, 0x0000000000000000, "RW", "dqdrvenbpream0", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo449[] = {{"wrdqctl", "", 0x00000024, 6, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields450[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{30, 31, 0x0000000000000000, "RW", "dqsdrvenbph1", "Phase 1 - DQS Drive enable"},
#else
{30, 31, 0x0000000000000000, "RW", "dqsdrvenbph1", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{28, 29, 0x0000000000000000, "RW", "dqsdrvenbpream1", "Preamble 1 - DQS drive enable"},
#else
{28, 29, 0x0000000000000000, "RW", "dqsdrvenbpream1", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{26, 27, 0x0000000000000000, "RW", "dqsdrvenblastph", "Last phase - DQS Drive enable"},
#else
{26, 27, 0x0000000000000000, "RW", "dqsdrvenblastph", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{24, 25, 0x0000000000000000, "RW", "dqsdrvenbpream0", "Preamble 0 - DQS Drive enable"},
#else
{24, 25, 0x0000000000000000, "RW", "dqsdrvenbpream0", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{21, 23, 0x0000000000000000, "RO", "reserved520", "Reserved bits"},
#else
{21, 23, 0x0000000000000000, "RO", "reserved520", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{20, 20, 0x0000000000000000, "RW", "dmdrven", "Data mask drive enable"},
#else
{20, 20, 0x0000000000000000, "RW", "dmdrven", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{19, 19, 0x0000000000000000, "RW", "wrpream0en", "This is the two write preambles enable"},
#else
{19, 19, 0x0000000000000000, "RW", "wrpream0en", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{18, 18, 0x0000000000000000, "RO", "reserved521", "TBD"},
#else
{18, 18, 0x0000000000000000, "RO", "reserved521", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{16, 17, 0x0000000000000003, "RW", "dqsdrvenbidle", "DQS Drive Enable - Idle"},
#else
{16, 17, 0x0000000000000003, "RW", "dqsdrvenbidle", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{14, 15, 0x0000000000000000, "RW", "dqsdataph1", "This is the DQS configuration for first phase [br](2'b01-dqs_hi_lo,2'b00-dqs_lo_lo,2'b11-dqs_hi_hi)."},
#else
{14, 15, 0x0000000000000000, "RW", "dqsdataph1", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{12, 13, 0x0000000000000000, "RW", "dqsdatapream1", "This is the DQS configuration during second preamble[br](2'b01-dqs_hi_lo,2'b00-dqs_lo_lo,2'b11-dqs_hi_hi)."},
#else
{12, 13, 0x0000000000000000, "RW", "dqsdatapream1", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{10, 11, 0x0000000000000000, "RW", "dqsdatalastph", "This is the DQS configuration for last phase [br](2'b01-dqs_hi_lo,2'b00-dqs_lo_lo,2'b11-dqs_hi_hi)."},
#else
{10, 11, 0x0000000000000000, "RW", "dqsdatalastph", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{8, 9, 0x0000000000000000, "RW", "dqsdatapream0", "This is the DQS configuration during first preamble[br](2'b01-dqs_hi_lo,2'b00-dqs_lo_lo,2'b11-dqs_hi_hi)."},
#else
{8, 9, 0x0000000000000000, "RW", "dqsdatapream0", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{6, 7, 0x0000000000000000, "RO", "reserved522", "Reserved bits"},
#else
{6, 7, 0x0000000000000000, "RO", "reserved522", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 5, 0x0000000000000000, "RW", "wrcmd2dqsstart", "Write command to DQS start delay"},
#else
{0, 5, 0x0000000000000000, "RW", "wrcmd2dqsstart", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo450[] = {{"wrdqsctl", "", 0x00000028, 15, 0x00000000FFFFFFFF, 0x0000000000030000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields451[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{24, 31, 0x0000000000000000, "RO", "reserved523", "Reserved bits"},
#else
{24, 31, 0x0000000000000000, "RO", "reserved523", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{16, 23, 0x0000000000000000, "RW", "rdcmd2rdvld_bonus", "Read command 2 read bonus bits."},
#else
{16, 23, 0x0000000000000000, "RW", "rdcmd2rdvld_bonus", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{15, 15, 0x0000000000000000, "RO", "reserved524", "Reserved bits"},
#else
{15, 15, 0x0000000000000000, "RO", "reserved524", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{12, 14, 0x0000000000000000, "RW", "rdcmd2rdvld_plus1sel", "Read command 2 read valid plus 1 sel."},
#else
{12, 14, 0x0000000000000000, "RW", "rdcmd2rdvld_plus1sel", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{11, 11, 0x0000000000000000, "RO", "reserved525", "Reserved bits"},
#else
{11, 11, 0x0000000000000000, "RO", "reserved525", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{8, 10, 0x0000000000000000, "RW", "earlyrdvld", "This is the early read valid configuration register [br]0: no early read valid geneartion[br]1/2/3/4: 1/2/3/4/spidclk early valid[br] >4: Illegal"},
#else
{8, 10, 0x0000000000000000, "RW", "earlyrdvld", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{6, 7, 0x0000000000000000, "RO", "reserved526", "Reserved bits"},
#else
{6, 7, 0x0000000000000000, "RO", "reserved526", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 5, 0x0000000000000000, "RW", "rdcmd2rdvld", "This is the read command to read valid register.[br]This is in terms of spidclk."},
#else
{0, 5, 0x0000000000000000, "RW", "rdcmd2rdvld", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo451[] = {{"rdvldctl", "", 0x0000002C, 8, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields452[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{11, 31, 0x0000000000000000, "RO", "reserved527", "This is the rank to rank override.(1 - no rank to rank switch enable)."},
#else
{11, 31, 0x0000000000000000, "RO", "reserved527", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{10, 10, 0x0000000000000000, "RW", "rk2rkmio2xclkpushout_iodrven", "pushing out the update of rank information 1 more 2xclk if set to 1."},
#else
{10, 10, 0x0000000000000000, "RW", "rk2rkmio2xclkpushout_iodrven", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{9, 9, 0x0000000000000000, "RW", "rk2rkmio2xclkpushout_txrden", "pushing out the update of rank information 1 more 2xclk if set to 1."},
#else
{9, 9, 0x0000000000000000, "RW", "rk2rkmio2xclkpushout_txrden", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{8, 8, 0x0000000000000000, "RW", "rk2rkmio2xclkpushout_txrcven", "pushing out the update of rank information 1 more 2xclk if set to 1."},
#else
{8, 8, 0x0000000000000000, "RW", "rk2rkmio2xclkpushout_txrcven", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{7, 7, 0x0000000000000000, "RW", "bl_rk2rken_txdqs_pi", "This is the rank to rank override.(1 - no rank to rank switch enable)."},
#else
{7, 7, 0x0000000000000000, "RW", "bl_rk2rken_txdqs_pi", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{6, 6, 0x0000000000000000, "RW", "bl_rk2rken_txdq_pi", "This is the rank to rank override.(1 - no rank to rank switch enable)."},
#else
{6, 6, 0x0000000000000000, "RW", "bl_rk2rken_txdq_pi", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{2, 5, 0x0000000000000000, "RO", "reserved528", "This is the rank to rank override.(1 - no rank to rank switch enable)."},
#else
{2, 5, 0x0000000000000000, "RO", "reserved528", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{1, 1, 0x0000000000000000, "RW", "bl_rk2rken_rxdq_pi", "This is the rank to rank override.(1 - no rank to rank switch enable)."},
#else
{1, 1, 0x0000000000000000, "RW", "bl_rk2rken_rxdq_pi", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 0, 0x0000000000000000, "RW", "bl_rk2rken_txrcven", "This is the rank to rank enable for the receive enable."},
#else
{0, 0, 0x0000000000000000, "RW", "bl_rk2rken_txrcven", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo452[] = {{"rk2rkctl1", "", 0x00000030, 9, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields453[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{28, 31, 0x0000000000000000, "RW", "rk2rkdrvenbcode_3rd", "This is the pattern for third 1x clock of rk2rk_rden[br](bit[0] - 1xhigh phase value, bit[1] - 1xlow phase value).[br]Applicable for both DQ and DQS drvenb."},
#else
{28, 31, 0x0000000000000000, "RW", "rk2rkdrvenbcode_3rd", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{24, 27, 0x0000000000000000, "RW", "rk2rkrdencode_3rd", "This is the pattern for third 1x clock of rk2rk_rden[br](bit[0] - 1xhigh phase value, bit[1] - 1xlow phase value)."},
#else
{24, 27, 0x0000000000000000, "RW", "rk2rkrdencode_3rd", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{23, 23, 0x0000000000000000, "RW", "rk2rkmio2xclkpushout_rxdq", "pushing out the update of rank information 1 more 2xclk if set to 1."},
#else
{23, 23, 0x0000000000000000, "RW", "rk2rkmio2xclkpushout_rxdq", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{22, 22, 0x0000000000000000, "RW", "rk2rkmio2xclkpushout_txdqs", "pushing out the update of rank information 1 more 2xclk if set to 1."},
#else
{22, 22, 0x0000000000000000, "RW", "rk2rkmio2xclkpushout_txdqs", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{21, 21, 0x0000000000000000, "RW", "rk2rkmio2xclkpushout_txdq", "pushing out the update of rank information 1 more 2xclk if set to 1."},
#else
{21, 21, 0x0000000000000000, "RW", "rk2rkmio2xclkpushout_txdq", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{15, 20, 0x0000000000000000, "RW", "wrcmd2rkchglatency", "This is the pattern for second 1x clock of rk2rk_iodrvenb[br](bit[0] - 1xhigh phase value, bit[1] - 1xlow phase value)."},
#else
{15, 20, 0x0000000000000000, "RW", "wrcmd2rkchglatency", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{14, 14, 0x0000000000000000, "RO", "reserved529", "Reserved bits"},
#else
{14, 14, 0x0000000000000000, "RO", "reserved529", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{8, 13, 0x0000000000000000, "RW", "rdcmd2rkchglatency", "This is the pattern for first 1x clock of rk2rk_iodrvenb[br](bit[0] - 1xhigh phase value, bit[1] - 1xlow phase value)."},
#else
{8, 13, 0x0000000000000000, "RW", "rdcmd2rkchglatency", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{6, 7, 0x0000000000000000, "RW", "rk2rkdrvenbcode_2nd", "This is the pattern for second 1x clock of rk2rk_rden[br](bit[0] - 1xhigh phase value, bit[1] - 1xlow phase value).[br]Applicable for both DQ and DQS drvenb."},
#else
{6, 7, 0x0000000000000000, "RW", "rk2rkdrvenbcode_2nd", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{4, 5, 0x0000000000000000, "RW", "rk2rkdrvenbcode_1st", "This is the pattern for first 1x clock of rk2rk_rden[br](bit[0] - 1xhigh phase value, bit[1] - 1xlow phase value).[br]Applicable for both DQ and DQS drvenb."},
#else
{4, 5, 0x0000000000000000, "RW", "rk2rkdrvenbcode_1st", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{2, 3, 0x0000000000000000, "RW", "rk2rkrdencode_2nd", "This is the pattern for second 1x clock of rk2rk_rden[br](bit[0] - 1xhigh phase value, bit[1] - 1xlow phase value)."},
#else
{2, 3, 0x0000000000000000, "RW", "rk2rkrdencode_2nd", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 1, 0x0000000000000000, "RW", "rk2rkrdencode_1st", "This is the pattern for first 1x clock of rk2rk_rden[br](bit[0] - 1xhigh phase value, bit[1] - 1xlow phase value)."},
#else
{0, 1, 0x0000000000000000, "RW", "rk2rkrdencode_1st", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo453[] = {{"rk2rkctl0", "", 0x00000034, 12, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields454[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{29, 31, 0x0000000000000000, "RW", "cc_rxodtsegovrval", "Receive ODT segment enable override value."},
#else
{29, 31, 0x0000000000000000, "RW", "cc_rxodtsegovrval", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{28, 28, 0x0000000000000000, "RW", "cc_rxodtsegovrsel", "Receive ODT segment enable override select.[br]0= Dynamic  control[br]1= Static  control"},
#else
{28, 28, 0x0000000000000000, "RW", "cc_rxodtsegovrsel", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{24, 27, 0x0000000000000000, "RW", "rk1_odtsegenrdptroffset", "Receive ODT segment enable read pointer offset."},
#else
{24, 27, 0x0000000000000000, "RW", "rk1_odtsegenrdptroffset", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{23, 23, 0x0000000000000000, "RO", "reserved530", "Reserved bits"},
#else
{23, 23, 0x0000000000000000, "RO", "reserved530", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{22, 22, 0x0000000000000000, "RW", "cc_rxodtsegtwohot", "This is the RXODTSEGEN one hot enable[br]0- rxodtsegen: 001->010->100[br]1-rxodtsegen: 011->110->101"},
#else
{22, 22, 0x0000000000000000, "RW", "cc_rxodtsegtwohot", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{16, 21, 0x0000000000000000, "RW", "cc_rxodtseglenbl4", "This is the receive ODT segment enable length configuration register.[br]It's in number of 1x clocks."},
#else
{16, 21, 0x0000000000000000, "RW", "cc_rxodtseglenbl4", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{14, 15, 0x0000000000000000, "RW", "cc_rxodtsegpst1", "This is the receive ODT segment enable configuration register - postamble 1 -  new(rise & fall). [br]00 - Rise & Fall - Low & Low[br]01 - Rise & Fall - High & Low[br]10 - Rise & Fall - Low & High[br]11 - Rise & Fall - High & High"},
#else
{14, 15, 0x0000000000000000, "RW", "cc_rxodtsegpst1", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{12, 13, 0x0000000000000000, "RW", "cc_rxodtsegpre1", "This is the receive ODT segment enable configuration register - preamble 1(rise & fall) [br]00 - Rise & Fall - Low & Low[br]01 - Rise & Fall - High & Low[br]10 - Rise & Fall - Low & High[br]11 - Rise & Fall - High & High"},
#else
{12, 13, 0x0000000000000000, "RW", "cc_rxodtsegpre1", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{10, 11, 0x0000000000000000, "RW", "cc_rxodtsegpst0", "This is the receive ODT segment enable configuration register - postamble 0 - new(rise & fall)[br]00 - Rise & Fall - Low & Low[br]01 - Rise & Fall - High & Low[br]10 - Rise & Fall - Low & High[br]11 - Rise & Fall - High & High"},
#else
{10, 11, 0x0000000000000000, "RW", "cc_rxodtsegpst0", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{8, 9, 0x0000000000000000, "RW", "cc_rxodtsegpre0", "This is the receive ODT segment enable configuration register - preamble 0(rise & fall) [br]00 - Rise & Fall - Low & Low[br]01 - Rise & Fall - High & Low[br]10 - Rise & Fall - Low & High[br]11 - Rise & Fall - High & High"},
#else
{8, 9, 0x0000000000000000, "RW", "cc_rxodtsegpre0", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{6, 7, 0x0000000000000000, "RO", "reserved531", "Reserved bits"},
#else
{6, 7, 0x0000000000000000, "RO", "reserved531", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 5, 0x0000000000000000, "RW", "cc_rdcmd2rxodtseg", "This is the receive ODT segment enable latency configuration register."},
#else
{0, 5, 0x0000000000000000, "RW", "cc_rdcmd2rxodtseg", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo454[] = {{"rxodtsegctl_cc", "", 0x00000038, 12, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields455[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{29, 31, 0x0000000000000000, "RW", "bl_rxodtsegovrval", "Receive ODT segment enable override value. [br]0: De-assert receive ODT enable [br]1: Assert receive ODT enable"},
#else
{29, 31, 0x0000000000000000, "RW", "bl_rxodtsegovrval", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{28, 28, 0x0000000000000000, "RW", "bl_rxodtsegovrsel", "Receive ODT segment enable override select.[br]0= Dynamic  receive ODT control[br]1= Static  receive ODT control"},
#else
{28, 28, 0x0000000000000000, "RW", "bl_rxodtsegovrsel", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{24, 27, 0x0000000000000000, "RW", "rk0_odtsegenrdptroffset", "Receive ODT segment enable read pointer offset."},
#else
{24, 27, 0x0000000000000000, "RW", "rk0_odtsegenrdptroffset", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{23, 23, 0x0000000000000000, "RO", "reserved532", "Reseved bits"},
#else
{23, 23, 0x0000000000000000, "RO", "reserved532", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{22, 22, 0x0000000000000000, "RW", "bl_rxodtsegtwohot", "This is the RXODTSEGEN one hot enable[br]0- rxodtsegen: 001->010->100[br]1-rxodtsegen: 011->110->101"},
#else
{22, 22, 0x0000000000000000, "RW", "bl_rxodtsegtwohot", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{16, 21, 0x0000000000000000, "RW", "bl_rxodtseglenbl4", "This is the receive ODT segment enable length configuration register.[br]It's in number of 1x clocks."},
#else
{16, 21, 0x0000000000000000, "RW", "bl_rxodtseglenbl4", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{14, 15, 0x0000000000000000, "RW", "bl_rxodtsegpst1", "This is the receive ODT segment enable configuration register - postamble 1 -  new(rise & fall). [br]00 - Rise & Fall - Low & Low[br]01 - Rise & Fall - High & Low[br]10 - Rise & Fall - Low & High[br]11 - Rise & Fall - High & High"},
#else
{14, 15, 0x0000000000000000, "RW", "bl_rxodtsegpst1", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{12, 13, 0x0000000000000000, "RW", "bl_rxodtsegpre1", "This is the receive ODT segment enable configuration register - preamble 1(rise & fall) [br]00 - Rise & Fall - Low & Low[br]01 - Rise & Fall - High & Low[br]10 - Rise & Fall - Low & High[br]11 - Rise & Fall - High & High"},
#else
{12, 13, 0x0000000000000000, "RW", "bl_rxodtsegpre1", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{10, 11, 0x0000000000000000, "RW", "bl_rxodtsegpst0", "This is the receive ODT segment enable configuration register - postamble 0 - new(rise & fall)[br]00 - Rise & Fall - Low & Low[br]01 - Rise & Fall - High & Low[br]10 - Rise & Fall - Low & High[br]11 - Rise & Fall - High & High"},
#else
{10, 11, 0x0000000000000000, "RW", "bl_rxodtsegpst0", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{8, 9, 0x0000000000000000, "RW", "bl_rxodtsegpre0", "This is the receive ODT segment enable configuration register - preamble 0(rise & fall) [br]00 - Rise & Fall - Low & Low[br]01 - Rise & Fall - High & Low[br]10 - Rise & Fall - Low & High[br]11 - Rise & Fall - High & High"},
#else
{8, 9, 0x0000000000000000, "RW", "bl_rxodtsegpre0", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{6, 7, 0x0000000000000000, "RO", "reserved533", "Reserved bits"},
#else
{6, 7, 0x0000000000000000, "RO", "reserved533", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 5, 0x0000000000000000, "RW", "bl_rdcmd2rxodtseg", "This is the receive ODT segment enable latency configuration register."},
#else
{0, 5, 0x0000000000000000, "RW", "bl_rdcmd2rxodtseg", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo455[] = {{"rxodtsegctl_dq", "", 0x0000003C, 12, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields456[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{28, 31, 0x0000000000000000, "RW", "rk1_odtenrdptroffset", "This is receive ODT enable read pointer offset."},
#else
{28, 31, 0x0000000000000000, "RW", "rk1_odtenrdptroffset", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{26, 27, 0x0000000000000000, "RO", "reserved534", "Reseved bits"},
#else
{26, 27, 0x0000000000000000, "RO", "reserved534", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{25, 25, 0x0000000000000000, "RW", "cc_rxodtenovrval", "Receive ODT enable override value. [br]0: De-assert receive enable [br]1: Assert receive enable"},
#else
{25, 25, 0x0000000000000000, "RW", "cc_rxodtenovrval", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{24, 24, 0x0000000000000000, "RW", "cc_rxodtenovrsel", "Receive ODT enable override select.[br]0= Dynamic RCVEN control[br]1= Static RCVEN control"},
#else
{24, 24, 0x0000000000000000, "RW", "cc_rxodtenovrsel", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{22, 23, 0x0000000000000000, "RO", "reserved535", "Reserved bits"},
#else
{22, 23, 0x0000000000000000, "RO", "reserved535", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{16, 21, 0x0000000000000000, "RW", "cc_rxodtenlenbl4", "This is the receive ODT enable length configuration register.[br]It's in number of 1x clocks."},
#else
{16, 21, 0x0000000000000000, "RW", "cc_rxodtenlenbl4", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{14, 15, 0x0000000000000000, "RW", "cc_rxodtenpst1", "This is the receive ODT enable configuration register - postamble 1 -  new(rise & fall). [br]00 - Rise & Fall - Low & Low[br]01 - Rise & Fall - High & Low[br]10 - Rise & Fall - Low & High[br]11 - Rise & Fall - High & High"},
#else
{14, 15, 0x0000000000000000, "RW", "cc_rxodtenpst1", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{12, 13, 0x0000000000000000, "RW", "cc_rxodtenpre1", "This is the receive ODT enable configuration register - preamble 1(rise & fall) [br]00 - Rise & Fall - Low & Low[br]01 - Rise & Fall - High & Low[br]10 - Rise & Fall - Low & High[br]11 - Rise & Fall - High & High"},
#else
{12, 13, 0x0000000000000000, "RW", "cc_rxodtenpre1", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{10, 11, 0x0000000000000000, "RW", "cc_rxodtenpst0", "This is the receive ODT enable configuration register - postamble 0 - new(rise & fall)[br]00 - Rise & Fall - Low & Low[br]01 - Rise & Fall - High & Low[br]10 - Rise & Fall - Low & High[br]11 - Rise & Fall - High & High"},
#else
{10, 11, 0x0000000000000000, "RW", "cc_rxodtenpst0", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{8, 9, 0x0000000000000000, "RW", "cc_rxodtenpre0", "This is the receive ODT enable configuration register - preamble 0(rise & fall) [br]00 - Rise & Fall - Low & Low[br]01 - Rise & Fall - High & Low[br]10 - Rise & Fall - Low & High[br]11 - Rise & Fall - High & High"},
#else
{8, 9, 0x0000000000000000, "RW", "cc_rxodtenpre0", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{6, 7, 0x0000000000000000, "RO", "reserved536", "Reserved bits"},
#else
{6, 7, 0x0000000000000000, "RO", "reserved536", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 5, 0x0000000000000000, "RW", "cc_rdcmd2rxodten", "This is the receive ODT enable latency configuration register."},
#else
{0, 5, 0x0000000000000000, "RW", "cc_rdcmd2rxodten", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo456[] = {{"rxodtctl_cc", "", 0x00000040, 12, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields457[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{28, 31, 0x0000000000000000, "RW", "rk0_odtenrdptroffset", "This is receive ODT enable read pointer offset."},
#else
{28, 31, 0x0000000000000000, "RW", "rk0_odtenrdptroffset", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{26, 27, 0x0000000000000000, "RO", "reserved537", "Reserved bits"},
#else
{26, 27, 0x0000000000000000, "RO", "reserved537", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{25, 25, 0x0000000000000000, "RW", "bl_rxodtenovrval", "Receive ODT enable override value. [br]0: De-assert receive enable [br]1: Assert receive enable"},
#else
{25, 25, 0x0000000000000000, "RW", "bl_rxodtenovrval", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{24, 24, 0x0000000000000000, "RW", "bl_rxodtenovrsel", "Receive ODT enable override select.[br]0= Dynamic RCVEN control[br]1= Static RCVEN control"},
#else
{24, 24, 0x0000000000000000, "RW", "bl_rxodtenovrsel", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{22, 23, 0x0000000000000000, "RO", "reserved538", "Reserved bits"},
#else
{22, 23, 0x0000000000000000, "RO", "reserved538", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{16, 21, 0x0000000000000000, "RW", "bl_rxodtenlenbl4", "This is the receive ODT enable length configuration register.[br]It's in number of 1x clocks."},
#else
{16, 21, 0x0000000000000000, "RW", "bl_rxodtenlenbl4", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{14, 15, 0x0000000000000000, "RW", "bl_rxodtenpst1", "This is the receive ODT enable configuration register - postamble 1 -  new(rise & fall). [br]00 - Rise & Fall - Low & Low[br]01 - Rise & Fall - High & Low[br]10 - Rise & Fall - Low & High[br]11 - Rise & Fall - High & High"},
#else
{14, 15, 0x0000000000000000, "RW", "bl_rxodtenpst1", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{12, 13, 0x0000000000000000, "RW", "bl_rxodtenpre1", "This is the receive ODT enable configuration register - preamble 1(rise & fall) [br]00 - Rise & Fall - Low & Low[br]01 - Rise & Fall - High & Low[br]10 - Rise & Fall - Low & High[br]11 - Rise & Fall - High & High"},
#else
{12, 13, 0x0000000000000000, "RW", "bl_rxodtenpre1", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{10, 11, 0x0000000000000000, "RW", "bl_rxodtenpst0", "This is the receive ODT enable configuration register - postamble 0 - new(rise & fall)[br]00 - Rise & Fall - Low & Low[br]01 - Rise & Fall - High & Low[br]10 - Rise & Fall - Low & High[br]11 - Rise & Fall - High & High"},
#else
{10, 11, 0x0000000000000000, "RW", "bl_rxodtenpst0", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{8, 9, 0x0000000000000000, "RW", "bl_rxodtenpre0", "This is the receive ODT enable configuration register - preamble 0(rise & fall) [br]00 - Rise & Fall - Low & Low[br]01 - Rise & Fall - High & Low[br]10 - Rise & Fall - Low & High[br]11 - Rise & Fall - High & High"},
#else
{8, 9, 0x0000000000000000, "RW", "bl_rxodtenpre0", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{6, 7, 0x0000000000000000, "RO", "reserved539", "Reserved bits"},
#else
{6, 7, 0x0000000000000000, "RO", "reserved539", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 5, 0x0000000000000000, "RW", "bl_rdcmd2rxodten", "This is the receive ODT enable latency configuration register."},
#else
{0, 5, 0x0000000000000000, "RW", "bl_rdcmd2rxodten", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo457[] = {{"rxodtctl_dq", "", 0x00000044, 12, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields458[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{31, 31, 0x0000000000000000, "RO", "drx_cc_rcvsmpl", "AFE status register - RCVSMPL - CC"},
#else
{31, 31, 0x0000000000000000, "RO", "drx_cc_rcvsmpl", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{28, 30, 0x0000000000000000, "RO", "reserved540", "Reserved bits"},
#else
{28, 30, 0x0000000000000000, "RO", "reserved540", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{27, 27, 0x0000000000000000, "RW", "drx_cc_dqscountrstb", "DQS counter reset"},
#else
{27, 27, 0x0000000000000000, "RW", "drx_cc_dqscountrstb", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{26, 26, 0x0000000000000000, "RW", "cc_rcvenmargin", "Receive enable margining data"},
#else
{26, 26, 0x0000000000000000, "RW", "cc_rcvenmargin", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{25, 25, 0x0000000000000000, "RW", "cc_rcvenovrval", "Receive enable override value. [br]0: De-assert receive enable [br]1: Assert receive enable"},
#else
{25, 25, 0x0000000000000000, "RW", "cc_rcvenovrval", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{24, 24, 0x0000000000000000, "RW", "cc_rcvenovrsel", "Receive enable override select.[br]0= Dynamic RCVEN control[br]1= Static RCVEN control"},
#else
{24, 24, 0x0000000000000000, "RW", "cc_rcvenovrsel", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{22, 23, 0x0000000000000000, "RO", "reserved541", "Reserved bits"},
#else
{22, 23, 0x0000000000000000, "RO", "reserved541", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{16, 21, 0x0000000000000000, "RW", "cc_rcvenlenbl4", "This is the receive enable length(number of 1x clock) configuration register."},
#else
{16, 21, 0x0000000000000000, "RW", "cc_rcvenlenbl4", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{14, 15, 0x0000000000000000, "RW", "cc_rcvenpst1", "This is the receive enable configuration register - postamble 1 -  new(rise & fall). [br]00 - Rise & Fall - Low & Low[br]01 - Rise & Fall - High & Low[br]10 - Rise & Fall - Low & High[br]11 - Rise & Fall - High & High"},
#else
{14, 15, 0x0000000000000000, "RW", "cc_rcvenpst1", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{12, 13, 0x0000000000000000, "RW", "cc_rcvenpre1", "This is the receive enable configuration register - preamble 1(rise & fall) [br]00 - Rise & Fall - Low & Low[br]01 - Rise & Fall - High & Low[br]10 - Rise & Fall - Low & High[br]11 - Rise & Fall - High & High"},
#else
{12, 13, 0x0000000000000000, "RW", "cc_rcvenpre1", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{10, 11, 0x0000000000000000, "RW", "cc_rcvenpst0", "This is the receive enable configuration register - postamble 0 - new(rise & fall)[br]00 - Rise & Fall - Low & Low[br]01 - Rise & Fall - High & Low[br]10 - Rise & Fall - Low & High[br]11 - Rise & Fall - High & High"},
#else
{10, 11, 0x0000000000000000, "RW", "cc_rcvenpst0", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{8, 9, 0x0000000000000000, "RW", "cc_rcvenpre0", "This is the receive enable configuration register - preamble 0(rise & fall) [br]00 - Rise & Fall - Low & Low[br]01 - Rise & Fall - High & Low[br]10 - Rise & Fall - Low & High[br]11 - Rise & Fall - High & High"},
#else
{8, 9, 0x0000000000000000, "RW", "cc_rcvenpre0", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{6, 7, 0x0000000000000000, "RO", "reserved542", "Reserved bits"},
#else
{6, 7, 0x0000000000000000, "RO", "reserved542", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 5, 0x0000000000000000, "RW", "cc_rdcmd2rcven", "This is the receive enable latency configuration register."},
#else
{0, 5, 0x0000000000000000, "RW", "cc_rdcmd2rcven", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo458[] = {{"rcvenctl_cc", "", 0x00000048, 14, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields459[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{31, 31, 0x0000000000000000, "RO", "drx_bl_rcvsmpl", "AFE status register - RCVSMPL - DQ"},
#else
{31, 31, 0x0000000000000000, "RO", "drx_bl_rcvsmpl", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{28, 30, 0x0000000000000000, "RO", "reserved543", "Reseved bits"},
#else
{28, 30, 0x0000000000000000, "RO", "reserved543", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{27, 27, 0x0000000000000000, "RW", "drx_bl_dqscountrstb", "DQS counter reset"},
#else
{27, 27, 0x0000000000000000, "RW", "drx_bl_dqscountrstb", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{26, 26, 0x0000000000000000, "RW", "bl_rcvenmargin", "Receive enable margining data"},
#else
{26, 26, 0x0000000000000000, "RW", "bl_rcvenmargin", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{25, 25, 0x0000000000000000, "RW", "bl_rcvenovrval", "Receive enable override value. [br]0: De-assert receive enable [br]1: Assert receive enable"},
#else
{25, 25, 0x0000000000000000, "RW", "bl_rcvenovrval", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{24, 24, 0x0000000000000000, "RW", "bl_rcvenovrsel", "Receive enable override select.[br]0= Dynamic RCVEN control[br]1= Static RCVEN control"},
#else
{24, 24, 0x0000000000000000, "RW", "bl_rcvenovrsel", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{22, 23, 0x0000000000000000, "RO", "reserved544", "Reserved bits"},
#else
{22, 23, 0x0000000000000000, "RO", "reserved544", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{16, 21, 0x0000000000000000, "RW", "bl_rcvenlenbl4", "This is the receive enable length(number of 1x clock) configuration register."},
#else
{16, 21, 0x0000000000000000, "RW", "bl_rcvenlenbl4", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{14, 15, 0x0000000000000000, "RW", "bl_rcvenpst1", "This is the receive enable configuration register - postamble 1 -  new(rise & fall). [br]00 - Rise & Fall - Low & Low[br]01 - Rise & Fall - High & Low[br]10 - Rise & Fall - Low & High[br]11 - Rise & Fall - High & High"},
#else
{14, 15, 0x0000000000000000, "RW", "bl_rcvenpst1", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{12, 13, 0x0000000000000000, "RW", "bl_rcvenpre1", "This is the receive enable configuration register - preamble 1(rise & fall) [br]00 - Rise & Fall - Low & Low[br]01 - Rise & Fall - High & Low[br]10 - Rise & Fall - Low & High[br]11 - Rise & Fall - High & High"},
#else
{12, 13, 0x0000000000000000, "RW", "bl_rcvenpre1", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{10, 11, 0x0000000000000000, "RW", "bl_rcvenpst0", "This is the receive enable configuration register - postamble 0 - new(rise & fall)[br]00 - Rise & Fall - Low & Low[br]01 - Rise & Fall - High & Low[br]10 - Rise & Fall - Low & High[br]11 - Rise & Fall - High & High"},
#else
{10, 11, 0x0000000000000000, "RW", "bl_rcvenpst0", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{8, 9, 0x0000000000000000, "RW", "bl_rcvenpre0", "This is the receive enable configuration register - preamble 0(rise & fall) [br]00 - Rise & Fall - Low & Low[br]01 - Rise & Fall - High & Low[br]10 - Rise & Fall - Low & High[br]11 - Rise & Fall - High & High"},
#else
{8, 9, 0x0000000000000000, "RW", "bl_rcvenpre0", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{6, 7, 0x0000000000000000, "RO", "reserved545", "Reserved bits"},
#else
{6, 7, 0x0000000000000000, "RO", "reserved545", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 5, 0x0000000000000000, "RW", "bl_rdcmd2rcven", "This is the receive enable latency configuration register.[br]RL - 1: maps to DRAM RL."},
#else
{0, 5, 0x0000000000000000, "RW", "bl_rdcmd2rcven", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo459[] = {{"rcvenctl_dq", "", 0x0000004C, 14, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields460[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{28, 31, 0x0000000000000000, "RW", "rk1_diffampenrdptroffset", "Differential amplifier read pointer offset control."},
#else
{28, 31, 0x0000000000000000, "RW", "rk1_diffampenrdptroffset", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{27, 27, 0x0000000000000000, "RW", "cc_dqsdiffampenovrval", "Override value for DQS Diffamp enable - DQ Lane"},
#else
{27, 27, 0x0000000000000000, "RW", "cc_dqsdiffampenovrval", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{26, 26, 0x0000000000000000, "RW", "cc_dqsdiffampenovrsel", "Override select for DQS Diffamp enable - DQ Lane"},
#else
{26, 26, 0x0000000000000000, "RW", "cc_dqsdiffampenovrsel", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{25, 25, 0x0000000000000000, "RW", "cc_dqdmdiffampenovrval", "Override value for DQ/DM Diffamp enable - DQ Lane"},
#else
{25, 25, 0x0000000000000000, "RW", "cc_dqdmdiffampenovrval", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{24, 24, 0x0000000000000000, "RW", "cc_dqdmdiffampenovrsel", "Override select for DQ/DM Diffamp enable - DQ Lane"},
#else
{24, 24, 0x0000000000000000, "RW", "cc_dqdmdiffampenovrsel", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{22, 23, 0x0000000000000000, "RW", "cc_diffampenpst1", "This is the diffamp enable configuration register - postamble 1 -  new(rise & fall). [br]00 - Rise & Fall - Low & Low[br]01 - Rise & Fall - High & Low[br]10 - Rise & Fall - Low & High[br]11 - Rise & Fall - High & High"},
#else
{22, 23, 0x0000000000000000, "RW", "cc_diffampenpst1", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{20, 21, 0x0000000000000000, "RW", "cc_diffampenpre1", "This is the diffamp enable configuration register - preamble 1(rise & fall) [br]00 - Rise & Fall - Low & Low[br]01 - Rise & Fall - High & Low[br]10 - Rise & Fall - Low & High[br]11 - Rise & Fall - High & High"},
#else
{20, 21, 0x0000000000000000, "RW", "cc_diffampenpre1", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{18, 19, 0x0000000000000000, "RW", "cc_diffampenpst0", "This is the diffamp enable configuration register - postamble 0 - new(rise & fall)[br]00 - Rise & Fall - Low & Low[br]01 - Rise & Fall - High & Low[br]10 - Rise & Fall - Low & High[br]11 - Rise & Fall - High & High"},
#else
{18, 19, 0x0000000000000000, "RW", "cc_diffampenpst0", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{16, 17, 0x0000000000000000, "RW", "cc_diffampenpre0", "This is the diffamp enable configuration register - preamble 0(rise & fall) [br]00 - Rise & Fall - Low & Low[br]01 - Rise & Fall - High & Low[br]10 - Rise & Fall - Low & High[br]11 - Rise & Fall - High & High"},
#else
{16, 17, 0x0000000000000000, "RW", "cc_diffampenpre0", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{14, 15, 0x0000000000000000, "RO", "reserved546", "Reserved bits"},
#else
{14, 15, 0x0000000000000000, "RO", "reserved546", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{8, 13, 0x0000000000000000, "RW", "cc_diffampenlenbl4", "This is the diffamp enable length(number of 1x clock) configuration register."},
#else
{8, 13, 0x0000000000000000, "RW", "cc_diffampenlenbl4", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{6, 7, 0x0000000000000000, "RO", "reserved547", "Reserved bits"},
#else
{6, 7, 0x0000000000000000, "RO", "reserved547", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 5, 0x0000000000000000, "RW", "cc_rdcmd2diffampen", "This is the Diffamp enable latency register."},
#else
{0, 5, 0x0000000000000000, "RW", "cc_rdcmd2diffampen", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo460[] = {{"diffampctl_cc", "", 0x00000050, 13, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields461[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{28, 31, 0x0000000000000000, "RW", "rk0_diffampenrdptroffset", "Differential amplifier read pointer offset control."},
#else
{28, 31, 0x0000000000000000, "RW", "rk0_diffampenrdptroffset", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{27, 27, 0x0000000000000000, "RW", "bl_dqsdiffampenovrval", "Override value for DQS Diffamp enable - DQ Lane"},
#else
{27, 27, 0x0000000000000000, "RW", "bl_dqsdiffampenovrval", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{26, 26, 0x0000000000000000, "RW", "bl_dqsdiffampenovrsel", "Override select for DQS Diffamp enable - DQ Lane"},
#else
{26, 26, 0x0000000000000000, "RW", "bl_dqsdiffampenovrsel", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{25, 25, 0x0000000000000000, "RW", "bl_dqdmdiffampenovrval", "Override value for DQ/DM Diffamp enable - DQ Lane"},
#else
{25, 25, 0x0000000000000000, "RW", "bl_dqdmdiffampenovrval", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{24, 24, 0x0000000000000000, "RW", "bl_dqdmdiffampenovrsel", "Override select for DQ/DM Diffamp enable - DQ Lane"},
#else
{24, 24, 0x0000000000000000, "RW", "bl_dqdmdiffampenovrsel", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{22, 23, 0x0000000000000000, "RW", "bl_diffampenpst1", "This is the diffamp enable configuration register - postamble 1 -  new(rise & fall). [br]00 - Rise & Fall - Low & Low[br]01 - Rise & Fall - High & Low[br]10 - Rise & Fall - Low & High[br]11 - Rise & Fall - High & High"},
#else
{22, 23, 0x0000000000000000, "RW", "bl_diffampenpst1", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{20, 21, 0x0000000000000000, "RW", "bl_diffampenpre1", "This is the diffamp enable configuration register - preamble 1(rise & fall) [br]00 - Rise & Fall - Low & Low[br]01 - Rise & Fall - High & Low[br]10 - Rise & Fall - Low & High[br]11 - Rise & Fall - High & High"},
#else
{20, 21, 0x0000000000000000, "RW", "bl_diffampenpre1", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{18, 19, 0x0000000000000000, "RW", "bl_diffampenpst0", "This is the diffamp enable configuration register - postamble 0 - new(rise & fall)[br]00 - Rise & Fall - Low & Low[br]01 - Rise & Fall - High & Low[br]10 - Rise & Fall - Low & High[br]11 - Rise & Fall - High & High"},
#else
{18, 19, 0x0000000000000000, "RW", "bl_diffampenpst0", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{16, 17, 0x0000000000000000, "RW", "bl_diffampenpre0", "This is the diffamp enable configuration register - preamble 0(rise & fall) [br]00 - Rise & Fall - Low & Low[br]01 - Rise & Fall - High & Low[br]10 - Rise & Fall - Low & High[br]11 - Rise & Fall - High & High"},
#else
{16, 17, 0x0000000000000000, "RW", "bl_diffampenpre0", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{14, 15, 0x0000000000000000, "RO", "reserved548", "Reserved bits"},
#else
{14, 15, 0x0000000000000000, "RO", "reserved548", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{8, 13, 0x0000000000000000, "RW", "bl_diffampenlenbl4", "This is the diffamp enable length(number of 1x clock) configuration register."},
#else
{8, 13, 0x0000000000000000, "RW", "bl_diffampenlenbl4", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{6, 7, 0x0000000000000000, "RO", "reserved549", "Reserved bits"},
#else
{6, 7, 0x0000000000000000, "RO", "reserved549", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 5, 0x0000000000000000, "RW", "bl_rdcmd2diffampen", "This is the Diffamp enable latency register."},
#else
{0, 5, 0x0000000000000000, "RW", "bl_rdcmd2diffampen", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo461[] = {{"diffampctl_dq", "", 0x00000054, 13, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields462[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{26, 31, 0x0000000000000000, "RO", "reserved550", "Reserved bits"},
#else
{26, 31, 0x0000000000000000, "RO", "reserved550", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{25, 25, 0x0000000000000000, "RW", "cc_wrlvl", "Write Levelization enable - CC Byte Lane"},
#else
{25, 25, 0x0000000000000000, "RW", "cc_wrlvl", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{24, 24, 0x0000000000000000, "RW", "bl_wrlvl", "Write Levelization enable - BL Byte Labe"},
#else
{24, 24, 0x0000000000000000, "RW", "bl_wrlvl", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{16, 23, 0x0000000000000000, "RO", "wrlvl_sample_b1", "DQTRAINSTS - WRLVL sampling from all DQ bit lanes of Bytelane 1"},
#else
{16, 23, 0x0000000000000000, "RO", "wrlvl_sample_b1", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{8, 15, 0x0000000000000000, "RO", "wrlvl_sample_b0", "DQTRAINSTS - WRLVL sampling from all DQ bit lanes of Bytelane 0"},
#else
{8, 15, 0x0000000000000000, "RO", "wrlvl_sample_b0", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{4, 7, 0x0000000000000000, "RO", "reserved551", "Reserved bits"},
#else
{4, 7, 0x0000000000000000, "RO", "reserved551", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{3, 3, 0x0000000000000000, "RO", "wrlvl_and_sample_b1", "DQTRAINSTS - WRLVL Byte1 sample AND combination"},
#else
{3, 3, 0x0000000000000000, "RO", "wrlvl_and_sample_b1", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{2, 2, 0x0000000000000000, "RO", "wrlvl_and_sample_b0", "DQTRAINSTS - WRLVL Byte0 sample AND combination"},
#else
{2, 2, 0x0000000000000000, "RO", "wrlvl_and_sample_b0", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{1, 1, 0x0000000000000000, "RO", "wrlvl_or_sample_b1", "DQTRAINSTS - WRLVL Byte1 sample OR combination"},
#else
{1, 1, 0x0000000000000000, "RO", "wrlvl_or_sample_b1", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 0, 0x0000000000000000, "RO", "wrlvl_or_sample_b0", "DQTRAINSTS - WRLVL Byte0 sample OR combination"},
#else
{0, 0, 0x0000000000000000, "RO", "wrlvl_or_sample_b0", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo462[] = {{"wrlvl", "", 0x00000058, 10, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields463[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{20, 31, 0x0000000000000000, "RO", "reserved552", "Reserved bits"},
#else
{20, 31, 0x0000000000000000, "RO", "reserved552", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{19, 19, 0x0000000000000000, "RW", "dynreadsiggrpen", "Enable Dynamic SIGGRP 2x clock control. 1= SIGGRPEN  controlled by the dynamic clock gating logic (DYNDLLFSM), 0= Statically-controlled SIGGRPEN"},
#else
{19, 19, 0x0000000000000000, "RW", "dynreadsiggrpen", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{18, 18, 0x0000000000000000, "RW", "dynreadref2xclken", "Enable Dynamic REF2XCLK control. 1= ref2xclken  controlled by the dynamic clock gating logic (DYNDLLFSM), 0= Statically-controlled REF2XCLKEN"},
#else
{18, 18, 0x0000000000000000, "RW", "dynreadref2xclken", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{17, 17, 0x0000000000000000, "RW", "dynreadref1xclken", "TBD"},
#else
{17, 17, 0x0000000000000000, "RW", "dynreadref1xclken", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{16, 16, 0x0000000000000000, "RW", "dynreadspidclken", "TBD"},
#else
{16, 16, 0x0000000000000000, "RW", "dynreadspidclken", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{15, 15, 0x0000000000000000, "RO", "reserved553", "Reserved bits"},
#else
{15, 15, 0x0000000000000000, "RO", "reserved553", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{12, 14, 0x0000000000000000, "RW", "read_stoprden", "This is the delay in terms of clocks the dven is disabled before clock gated."},
#else
{12, 14, 0x0000000000000000, "RW", "read_stoprden", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{11, 11, 0x0000000000000000, "RO", "reserved554", "Reserved bits"},
#else
{11, 11, 0x0000000000000000, "RO", "reserved554", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{8, 10, 0x0000000000000000, "RW", "read_startrden", "This is the delay in terms of clocks the drven is enabled, once wrcmd/rdcmd is received."},
#else
{8, 10, 0x0000000000000000, "RW", "read_startrden", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{6, 7, 0x0000000000000000, "RO", "reserved555", "Reserved bits"},
#else
{6, 7, 0x0000000000000000, "RO", "reserved555", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 5, 0x000000000000003F, "RW", "readclkgate_maxcntr", "Clock Gating register : IDLE timer counter max value for clock gating on tx/rx . Counter timeout based on last WRCMD/RDCMD received. 6 bits are good enough since it increments in spidclk."},
#else
{0, 5, 0x000000000000003F, "RW", "readclkgate_maxcntr", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo463[] = {{"clkgaterdctl", "", 0x0000005C, 11, 0x00000000FFFFFFFF, 0x000000000000003F}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields464[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{20, 31, 0x0000000000000000, "RO", "reserved556", "Reserved bits"},
#else
{20, 31, 0x0000000000000000, "RO", "reserved556", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{19, 19, 0x0000000000000000, "RW", "dynwritesiggrpen", "Enable Dynamic SIGGRP 2x clock control. 1= SIGGRPEN  controlled by the dynamic clock gating logic (DYNDLLFSM), 0= Statically-controlled SIGGRPEN"},
#else
{19, 19, 0x0000000000000000, "RW", "dynwritesiggrpen", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{18, 18, 0x0000000000000000, "RW", "dynwriteref2xclken", "Enable Dynamic REF2XCLK control. 1= ref2xclken  controlled by the dynamic clock gating logic (DYNDLLFSM), 0= Statically-controlled REF2XCLKEN"},
#else
{18, 18, 0x0000000000000000, "RW", "dynwriteref2xclken", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{17, 17, 0x0000000000000000, "RW", "dynwriteref1xclken", "TBD"},
#else
{17, 17, 0x0000000000000000, "RW", "dynwriteref1xclken", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{16, 16, 0x0000000000000000, "RW", "dynwritespidclken", "TBD"},
#else
{16, 16, 0x0000000000000000, "RW", "dynwritespidclken", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{15, 15, 0x0000000000000000, "RO", "reserved557", "Reserved bits"},
#else
{15, 15, 0x0000000000000000, "RO", "reserved557", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{12, 14, 0x0000000000000000, "RW", "write_stopdrv", "This is the delay in terms of clocks the dven is disabled before clock gated."},
#else
{12, 14, 0x0000000000000000, "RW", "write_stopdrv", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{11, 11, 0x0000000000000000, "RO", "reserved558", "Reserved bits"},
#else
{11, 11, 0x0000000000000000, "RO", "reserved558", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{8, 10, 0x0000000000000000, "RW", "write_startdrv", "This is the delay in terms of clocks the drven is enabled, once wrcmd/rdcmd is received."},
#else
{8, 10, 0x0000000000000000, "RW", "write_startdrv", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{6, 7, 0x0000000000000000, "RO", "reserved559", "Reserved bits"},
#else
{6, 7, 0x0000000000000000, "RO", "reserved559", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 5, 0x000000000000003F, "RW", "writeclkgate_maxcntr", "Clock Gating register : IDLE timer counter max value for clock gating on tx/rx . Counter timeout based on last WRCMD/RDCMD received. 6 bits are good enough since it increments in spidclk."},
#else
{0, 5, 0x000000000000003F, "RW", "writeclkgate_maxcntr", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo464[] = {{"clkgatewrctl", "", 0x00000060, 11, 0x00000000FFFFFFFF, 0x000000000000003F}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields465[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{20, 31, 0x0000000000000000, "RO", "reserved560", "Reserved bits"},
#else
{20, 31, 0x0000000000000000, "RO", "reserved560", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{19, 19, 0x0000000000000000, "RW", "dynsiggrpen", "Enable Dynamic SIGGRP 2x clock control. 1= SIGGRPEN  controlled by the dynamic clock gating logic (DYNDLLFSM), 0= Statically-controlled SIGGRPEN"},
#else
{19, 19, 0x0000000000000000, "RW", "dynsiggrpen", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{18, 18, 0x0000000000000000, "RW", "dynref2xclken", "Enable Dynamic REF2XCLK control. 1= ref2xclken  controlled by the dynamic clock gating logic (DYNDLLFSM), 0= Statically-controlled REF2XCLKEN"},
#else
{18, 18, 0x0000000000000000, "RW", "dynref2xclken", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{17, 17, 0x0000000000000000, "RW", "dynref1xclken", "TBD"},
#else
{17, 17, 0x0000000000000000, "RW", "dynref1xclken", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{16, 16, 0x0000000000000000, "RW", "dynspidclken", "TBD"},
#else
{16, 16, 0x0000000000000000, "RW", "dynspidclken", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{6, 15, 0x0000000000000000, "RO", "reserved561", "Reserved bits"},
#else
{6, 15, 0x0000000000000000, "RO", "reserved561", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 5, 0x000000000000003F, "RW", "clkgate_maxcntr", "Clock Gating register : IDLE timer counter max value for clock gating on tx/rx . Counter timeout based on last WRCMD/RDCMD received. 6 bits are good enough since it increments in spidclk."},
#else
{0, 5, 0x000000000000003F, "RW", "clkgate_maxcntr", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo465[] = {{"clkgatectl", "", 0x00000064, 7, 0x00000000FFFFFFFF, 0x000000000000003F}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields466[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{30, 31, 0x0000000000000000, "RO", "reserved562", "Reserved bits"},
#else
{30, 31, 0x0000000000000000, "RO", "reserved562", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{28, 29, 0x0000000000000000, "RO", "reserved563", "Reserved bits"},
#else
{28, 29, 0x0000000000000000, "RO", "reserved563", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{24, 27, 0x0000000000000000, "RO", "reserved564", "Reserved bits"},
#else
{24, 27, 0x0000000000000000, "RO", "reserved564", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{16, 23, 0x0000000000000000, "RO", "reserved565", "Reserved bits"},
#else
{16, 23, 0x0000000000000000, "RO", "reserved565", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{14, 15, 0x0000000000000000, "RO", "reserved566", "Reserved bits"},
#else
{14, 15, 0x0000000000000000, "RO", "reserved566", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{12, 13, 0x0000000000000000, "RW", "txdll_rk0siggrp05dbsel", "Deadband select for sig group 5 rank 0"},
#else
{12, 13, 0x0000000000000000, "RW", "txdll_rk0siggrp05dbsel", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{8, 11, 0x0000000000000000, "RW", "txdll_rk0siggrp05rdptroffset", "Read pointer offset for sig group 5 rank 0"},
#else
{8, 11, 0x0000000000000000, "RW", "txdll_rk0siggrp05rdptroffset", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 7, 0x0000000000000000, "RW", "txdll_rk0siggrp05picode", "PI code for sig group 5 rank 0"},
#else
{0, 7, 0x0000000000000000, "RW", "txdll_rk0siggrp05picode", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo466[] = {{"txdllsiggrp5ctl", "", 0x00000068, 8, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields467[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{30, 31, 0x0000000000000000, "RO", "reserved567", "Reserved bits"},
#else
{30, 31, 0x0000000000000000, "RO", "reserved567", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{28, 29, 0x0000000000000000, "RO", "reserved568", "Reserved bits"},
#else
{28, 29, 0x0000000000000000, "RO", "reserved568", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{24, 27, 0x0000000000000000, "RO", "reserved569", "Reserved bits"},
#else
{24, 27, 0x0000000000000000, "RO", "reserved569", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{16, 23, 0x0000000000000000, "RO", "reserved570", "Reserved bits"},
#else
{16, 23, 0x0000000000000000, "RO", "reserved570", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{14, 15, 0x0000000000000000, "RO", "reserved571", "Reserved bits"},
#else
{14, 15, 0x0000000000000000, "RO", "reserved571", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{12, 13, 0x0000000000000000, "RW", "txdll_rk0siggrp04dbsel", "Deadband select for sig group 4 rank 0"},
#else
{12, 13, 0x0000000000000000, "RW", "txdll_rk0siggrp04dbsel", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{8, 11, 0x0000000000000000, "RW", "txdll_rk0siggrp04rdptroffset", "Read pointer offset for sig group 4 rank 0"},
#else
{8, 11, 0x0000000000000000, "RW", "txdll_rk0siggrp04rdptroffset", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 7, 0x0000000000000000, "RW", "txdll_rk0siggrp04picode", "PI code for sig group 4 rank 0"},
#else
{0, 7, 0x0000000000000000, "RW", "txdll_rk0siggrp04picode", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo467[] = {{"txdllsiggrp4ctl", "", 0x0000006C, 8, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields468[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{30, 31, 0x0000000000000000, "RO", "reserved572", "Reserved bits"},
#else
{30, 31, 0x0000000000000000, "RO", "reserved572", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{28, 29, 0x0000000000000000, "RO", "reserved573", "Reserved bits"},
#else
{28, 29, 0x0000000000000000, "RO", "reserved573", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{24, 27, 0x0000000000000000, "RO", "reserved574", "Reserved bits"},
#else
{24, 27, 0x0000000000000000, "RO", "reserved574", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{16, 23, 0x0000000000000000, "RO", "reserved575", "Reserved bits"},
#else
{16, 23, 0x0000000000000000, "RO", "reserved575", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{14, 15, 0x0000000000000000, "RO", "reserved576", "Reserved bits"},
#else
{14, 15, 0x0000000000000000, "RO", "reserved576", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{12, 13, 0x0000000000000000, "RW", "txdll_rk0siggrp03dbsel", "Deadband select for sig group 3 rank 0"},
#else
{12, 13, 0x0000000000000000, "RW", "txdll_rk0siggrp03dbsel", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{8, 11, 0x0000000000000000, "RW", "txdll_rk0siggrp03rdptroffset", "Read pointer offset for sig group 3 rank 0"},
#else
{8, 11, 0x0000000000000000, "RW", "txdll_rk0siggrp03rdptroffset", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 7, 0x0000000000000000, "RW", "txdll_rk0siggrp03picode", "PI code for sig group 3 rank 0"},
#else
{0, 7, 0x0000000000000000, "RW", "txdll_rk0siggrp03picode", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo468[] = {{"txdllsiggrp3ctl", "", 0x00000070, 8, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields469[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{30, 31, 0x0000000000000000, "RO", "reserved577", "Reserved bits"},
#else
{30, 31, 0x0000000000000000, "RO", "reserved577", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{28, 29, 0x0000000000000000, "RW", "txdll_rk1siggrp02dbsel", "Deadband select for sig group 2 rank 1"},
#else
{28, 29, 0x0000000000000000, "RW", "txdll_rk1siggrp02dbsel", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{24, 27, 0x0000000000000000, "RW", "txdll_rk1siggrp02rdptroffset", "Read pointer offset for sig group 2 rank 1"},
#else
{24, 27, 0x0000000000000000, "RW", "txdll_rk1siggrp02rdptroffset", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{16, 23, 0x0000000000000000, "RW", "txdll_rk1siggrp02picode", "PI code for sig group 2 rank 1"},
#else
{16, 23, 0x0000000000000000, "RW", "txdll_rk1siggrp02picode", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{14, 15, 0x0000000000000000, "RO", "reserved578", "Reserved bits"},
#else
{14, 15, 0x0000000000000000, "RO", "reserved578", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{12, 13, 0x0000000000000000, "RW", "txdll_rk0siggrp02dbsel", "Deadband select for sig group 2 rank 0"},
#else
{12, 13, 0x0000000000000000, "RW", "txdll_rk0siggrp02dbsel", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{8, 11, 0x0000000000000000, "RW", "txdll_rk0siggrp02rdptroffset", "Read pointer offset for sig group 2 rank 0"},
#else
{8, 11, 0x0000000000000000, "RW", "txdll_rk0siggrp02rdptroffset", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 7, 0x0000000000000000, "RW", "txdll_rk0siggrp02picode", "PI code for sig group 2 rank 0"},
#else
{0, 7, 0x0000000000000000, "RW", "txdll_rk0siggrp02picode", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo469[] = {{"txdllsiggrp2ctl", "", 0x00000074, 8, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields470[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{30, 31, 0x0000000000000000, "RO", "reserved579", "Reserved bits"},
#else
{30, 31, 0x0000000000000000, "RO", "reserved579", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{28, 29, 0x0000000000000000, "RW", "txdll_rk1siggrp01dbsel", "Deadband select for sig group 1 rank 1"},
#else
{28, 29, 0x0000000000000000, "RW", "txdll_rk1siggrp01dbsel", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{24, 27, 0x0000000000000000, "RW", "txdll_rk1siggrp01rdptroffset", "Read pointer offset for sig group 1 rank 1"},
#else
{24, 27, 0x0000000000000000, "RW", "txdll_rk1siggrp01rdptroffset", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{16, 23, 0x0000000000000000, "RW", "txdll_rk1siggrp01picode", "PI code for sig group 1 rank 1"},
#else
{16, 23, 0x0000000000000000, "RW", "txdll_rk1siggrp01picode", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{14, 15, 0x0000000000000000, "RO", "reserved580", "Reserved bits"},
#else
{14, 15, 0x0000000000000000, "RO", "reserved580", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{12, 13, 0x0000000000000000, "RW", "txdll_rk0siggrp01dbsel", "Deadband select for sig group 1 rank 0"},
#else
{12, 13, 0x0000000000000000, "RW", "txdll_rk0siggrp01dbsel", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{8, 11, 0x0000000000000000, "RW", "txdll_rk0siggrp01rdptroffset", "Read pointer offset for sig group 1 rank 0"},
#else
{8, 11, 0x0000000000000000, "RW", "txdll_rk0siggrp01rdptroffset", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 7, 0x0000000000000000, "RW", "txdll_rk0siggrp01picode", "PI code for sig group 1 rank 0"},
#else
{0, 7, 0x0000000000000000, "RW", "txdll_rk0siggrp01picode", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo470[] = {{"txdllsiggrp1ctl", "", 0x00000078, 8, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields471[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{28, 31, 0x0000000000000000, "RO", "reserved581", "Reserved bits"},
#else
{28, 31, 0x0000000000000000, "RO", "reserved581", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{24, 27, 0x0000000000000000, "RW", "txdll_rk1siggrp00rdptroffset", "Read pointer offset for sig group 0 rank 1"},
#else
{24, 27, 0x0000000000000000, "RW", "txdll_rk1siggrp00rdptroffset", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{16, 23, 0x0000000000000000, "RW", "txdll_rk1siggrp00picode", "PI code for sig group 0 rank 1"},
#else
{16, 23, 0x0000000000000000, "RW", "txdll_rk1siggrp00picode", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{12, 15, 0x0000000000000000, "RO", "reserved582", "Reserved bits"},
#else
{12, 15, 0x0000000000000000, "RO", "reserved582", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{8, 11, 0x0000000000000000, "RW", "txdll_rk0siggrp00rdptroffset", "Read pointer offset for sig group 0 rank 0"},
#else
{8, 11, 0x0000000000000000, "RW", "txdll_rk0siggrp00rdptroffset", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 7, 0x0000000000000000, "RW", "txdll_rk0siggrp00picode", "PI code for sig group 0 rank 0"},
#else
{0, 7, 0x0000000000000000, "RW", "txdll_rk0siggrp00picode", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo471[] = {{"txdllsiggrp0ctl", "", 0x0000007C, 6, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields472[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{31, 31, 0x0000000000000000, "RO", "reserved583", "Reserved bits"},
#else
{31, 31, 0x0000000000000000, "RO", "reserved583", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{30, 30, 0x0000000000000000, "RW", "lvl_cc_weakpupstatic", "Weak Pull Up Control - CC Lane"},
#else
{30, 30, 0x0000000000000000, "RW", "lvl_cc_weakpupstatic", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{24, 29, 0x0000000000000000, "RW", "lvl_cc_weakpup", "Weak Pull Up Control - CC Lane"},
#else
{24, 29, 0x0000000000000000, "RW", "lvl_cc_weakpup", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{23, 23, 0x0000000000000000, "RO", "reserved584", "Reserved bits"},
#else
{23, 23, 0x0000000000000000, "RO", "reserved584", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{22, 22, 0x0000000000000000, "RW", "lvl_cc_weakpdnstatic", "Weak Pull Down Control - CC Lane"},
#else
{22, 22, 0x0000000000000000, "RW", "lvl_cc_weakpdnstatic", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{16, 21, 0x0000000000000000, "RW", "lvl_cc_weakpdn", "Weak Pull Down Control - CC Lane"},
#else
{16, 21, 0x0000000000000000, "RW", "lvl_cc_weakpdn", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{15, 15, 0x0000000000000000, "RO", "reserved585", "Reserved bits"},
#else
{15, 15, 0x0000000000000000, "RO", "reserved585", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{14, 14, 0x0000000000000000, "RW", "lvl_bl_weakpupstatic", "Weak Pull Up Control static bit for DQS - DQ Lane"},
#else
{14, 14, 0x0000000000000000, "RW", "lvl_bl_weakpupstatic", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{8, 13, 0x0000000000000000, "RW", "lvl_bl_weakpup", "Weak Pull Up Control code for DQS - DQ Lane"},
#else
{8, 13, 0x0000000000000000, "RW", "lvl_bl_weakpup", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{7, 7, 0x0000000000000000, "RO", "reserved586", "Reserved bits"},
#else
{7, 7, 0x0000000000000000, "RO", "reserved586", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{6, 6, 0x0000000000000000, "RW", "lvl_bl_weakpdnstatic", "Weak Pull Down Control static bit for DQS - DQ Lane"},
#else
{6, 6, 0x0000000000000000, "RW", "lvl_bl_weakpdnstatic", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 5, 0x0000000000000000, "RW", "lvl_bl_weakpdn", "Weak Pull Down Control code for DQS - DQ Lane"},
#else
{0, 5, 0x0000000000000000, "RW", "lvl_bl_weakpdn", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo472[] = {{"wkpuppdnctl", "", 0x00000080, 12, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields473[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{31, 31, 0x0000000000000000, "RO", "reserved587", "Reserved bits"},
#else
{31, 31, 0x0000000000000000, "RO", "reserved587", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{28, 30, 0x0000000000000007, "RW", "dtx_cc_drvsegen", "Segment enable for CC buffer. Used for per leg testing in HVM"},
#else
{28, 30, 0x0000000000000007, "RW", "dtx_cc_drvsegen", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{27, 27, 0x0000000000000000, "RO", "reserved588", "Reserved bits"},
#else
{27, 27, 0x0000000000000000, "RO", "reserved588", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{24, 26, 0x0000000000000007, "RW", "tx_cc_drvsegen", "Segment enable for CC buffer. Used for per leg testing in HVM"},
#else
{24, 26, 0x0000000000000007, "RW", "tx_cc_drvsegen", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{23, 23, 0x0000000000000000, "RO", "reserved589", "Reserved bits"},
#else
{23, 23, 0x0000000000000000, "RO", "reserved589", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{20, 22, 0x0000000000000007, "RW", "dtx_bl_drvsegen", "Segment enable for CC buffer. Used for per leg testing in HVM"},
#else
{20, 22, 0x0000000000000007, "RW", "dtx_bl_drvsegen", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{19, 19, 0x0000000000000000, "RO", "reserved590", "Reserved bits"},
#else
{19, 19, 0x0000000000000000, "RO", "reserved590", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{16, 18, 0x0000000000000007, "RW", "tx_bl_drvsegen", "Segment enable for CC buffer. Used for per leg testing in HVM"},
#else
{16, 18, 0x0000000000000007, "RW", "tx_bl_drvsegen", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{15, 15, 0x0000000000000000, "RO", "reserved591", "Reserved bits"},
#else
{15, 15, 0x0000000000000000, "RO", "reserved591", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{12, 14, 0x0000000000000001, "RW", "rxdll_cc_picapsel", "set cap tuning for pi"},
#else
{12, 14, 0x0000000000000001, "RW", "rxdll_cc_picapsel", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{11, 11, 0x0000000000000000, "RO", "reserved592", "Reserved bits"},
#else
{11, 11, 0x0000000000000000, "RO", "reserved592", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{8, 10, 0x0000000000000001, "RW", "rxdll_bl_picapsel", "set cap tuning for pi"},
#else
{8, 10, 0x0000000000000001, "RW", "rxdll_bl_picapsel", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{7, 7, 0x0000000000000000, "RO", "reserved593", "Reserved bits"},
#else
{7, 7, 0x0000000000000000, "RO", "reserved593", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{4, 6, 0x0000000000000001, "RW", "txdll_picapsel", "set cap tuning for pi"},
#else
{4, 6, 0x0000000000000001, "RW", "txdll_picapsel", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{3, 3, 0x0000000000000000, "RW", "dtx_cc_allfire", "Bypasses slewrate staggering"},
#else
{3, 3, 0x0000000000000000, "RW", "dtx_cc_allfire", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{2, 2, 0x0000000000000000, "RW", "dtx_bl_allfire", "Bypasses slewrate staggering"},
#else
{2, 2, 0x0000000000000000, "RW", "dtx_bl_allfire", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{1, 1, 0x0000000000000000, "RW", "tx_cc_allfire", "Bypasses slewrate staggering"},
#else
{1, 1, 0x0000000000000000, "RW", "tx_cc_allfire", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 0, 0x0000000000000000, "RW", "tx_bl_allfire", "Bypasses slewrate staggering"},
#else
{0, 0, 0x0000000000000000, "RW", "tx_bl_allfire", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo473[] = {{"afemisc1", "", 0x00000084, 18, 0x00000000FFFFFFFF, 0x0000000077771110}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields474[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{30, 31, 0x0000000000000000, "RW", "dtx_cc_drvenstretch", "Streches rising edge of drivenable to relax data to enable skew."},
#else
{30, 31, 0x0000000000000000, "RW", "dtx_cc_drvenstretch", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{28, 29, 0x0000000000000000, "RW", "dtx_bl_drvenstretch", "Streches rising edge of drivenable to relax data to enable skew."},
#else
{28, 29, 0x0000000000000000, "RW", "dtx_bl_drvenstretch", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{26, 27, 0x0000000000000000, "RW", "tx_cc_drvenstretch", "Streches rising edge of drivenable to relax data to enable skew."},
#else
{26, 27, 0x0000000000000000, "RW", "tx_cc_drvenstretch", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{24, 25, 0x0000000000000000, "RW", "tx_bl_drvenstretch", "Streches rising edge of drivenable to relax data to enable skew."},
#else
{24, 25, 0x0000000000000000, "RW", "tx_bl_drvenstretch", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{22, 23, 0x0000000000000001, "RW", "drx_cc_rxpwrmode", "00 = low power rx;[br]01 = high power rx (default)"},
#else
{22, 23, 0x0000000000000001, "RW", "drx_cc_rxpwrmode", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{20, 21, 0x0000000000000001, "RW", "rx_cc_rxpwrmode", "00 = low power rx;[br]01 = high power rx (default)"},
#else
{20, 21, 0x0000000000000001, "RW", "rx_cc_rxpwrmode", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{18, 19, 0x0000000000000001, "RW", "drx_bl_rxpwrmode", "00 = low power rx;[br]01 = high power rx (default)"},
#else
{18, 19, 0x0000000000000001, "RW", "drx_bl_rxpwrmode", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{16, 17, 0x0000000000000001, "RW", "rx_bl_rxpwrmode", "00 = low power rx;[br]01 = high power rx (default)"},
#else
{16, 17, 0x0000000000000001, "RW", "rx_bl_rxpwrmode", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{12, 15, 0x0000000000000000, "RO", "reserved594", "Reserved bits"},
#else
{12, 15, 0x0000000000000000, "RO", "reserved594", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{11, 11, 0x0000000000000001, "RW", "drx_cc_rxcommonmode", "changes the common mode of receiver from low common mode to vcc/2 based on lpddr3/ lpddr4."},
#else
{11, 11, 0x0000000000000001, "RW", "drx_cc_rxcommonmode", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{10, 10, 0x0000000000000001, "RW", "drx_bl_rxcommonmode", "changes the common mode of receiver from low common mode to vcc/2 based on lpddr3/ lpddr4."},
#else
{10, 10, 0x0000000000000001, "RW", "drx_bl_rxcommonmode", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{9, 9, 0x0000000000000001, "RW", "rx_cc_rxcommonmode", "changes the common mode of receiver from low common mode to vcc/2 based on lpddr3/ lpddr4."},
#else
{9, 9, 0x0000000000000001, "RW", "rx_cc_rxcommonmode", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{8, 8, 0x0000000000000001, "RW", "rx_bl_rxcommonmode", "changes the common mode of receiver from low common mode to vcc/2 based on lpddr3/ lpddr4."},
#else
{8, 8, 0x0000000000000001, "RW", "rx_bl_rxcommonmode", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{7, 7, 0x0000000000000001, "RW", "pdndrvstatic", "Static pull down code - DRV DQ"},
#else
{7, 7, 0x0000000000000001, "RW", "pdndrvstatic", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{6, 6, 0x0000000000000001, "RW", "pdndrvstaticdqs", "Static pull down code - DRV DQS/DQSB"},
#else
{6, 6, 0x0000000000000001, "RW", "pdndrvstaticdqs", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{5, 5, 0x0000000000000001, "RW", "pdnodtstatic", "Static pull down code - ODT DQ"},
#else
{5, 5, 0x0000000000000001, "RW", "pdnodtstatic", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{4, 4, 0x0000000000000001, "RW", "pdnodtstaticdqs", "Static pull down code - ODT DQS/DQSB"},
#else
{4, 4, 0x0000000000000001, "RW", "pdnodtstaticdqs", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{3, 3, 0x0000000000000001, "RW", "pupdrvstatic", "Static pull up code - DRV DQ"},
#else
{3, 3, 0x0000000000000001, "RW", "pupdrvstatic", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{2, 2, 0x0000000000000001, "RW", "pupdrvstaticdqs", "Static pull up code - DRV DQS/DQSB"},
#else
{2, 2, 0x0000000000000001, "RW", "pupdrvstaticdqs", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{1, 1, 0x0000000000000001, "RW", "pupodtstatic", "Static pull up code - ODT DQ"},
#else
{1, 1, 0x0000000000000001, "RW", "pupodtstatic", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 0, 0x0000000000000001, "RW", "pupodtstaticdqs", "Static pull up code - ODT DQS/DQSB"},
#else
{0, 0, 0x0000000000000001, "RW", "pupodtstaticdqs", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo474[] = {{"afemisc0", "", 0x00000088, 21, 0x00000000FFFFFFFF, 0x0000000000550FFF}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields475[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{8, 31, 0x0000000000000000, "RO", "reserved595", "Reserved bits"},
#else
{8, 31, 0x0000000000000000, "RO", "reserved595", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{4, 7, 0x0000000000000000, "RW", "lvl_cc_bonus", "Bonus bits - CC Lane"},
#else
{4, 7, 0x0000000000000000, "RW", "lvl_cc_bonus", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 3, 0x0000000000000000, "RW", "lvl_bl_bonus", "Bonus bits - DQ Lane"},
#else
{0, 3, 0x0000000000000000, "RW", "lvl_bl_bonus", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo475[] = {{"afebonus", "", 0x0000008C, 3, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields476[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{28, 31, 0x0000000000000000, "RW", "txdll_digobs1sel", "Digital observation select mux port 1"},
#else
{28, 31, 0x0000000000000000, "RW", "txdll_digobs1sel", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{24, 27, 0x0000000000000000, "RW", "txdll_digobs0sel", "Digital observation select mux port 0"},
#else
{24, 27, 0x0000000000000000, "RW", "txdll_digobs0sel", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{23, 23, 0x0000000000000000, "RW", "rxdll_cc_digobsen", "digital buf obs enable (1=enable;0=disable)"},
#else
{23, 23, 0x0000000000000000, "RW", "rxdll_cc_digobsen", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{22, 22, 0x0000000000000000, "RW", "rxdll_bl_digobsen", "digital buf obs enable (1=enable;0=disable)"},
#else
{22, 22, 0x0000000000000000, "RW", "rxdll_bl_digobsen", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{21, 21, 0x0000000000000000, "RW", "dtx_cc_digobsen", "digital buf obs enable (1=enable;0=disable)"},
#else
{21, 21, 0x0000000000000000, "RW", "dtx_cc_digobsen", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{20, 20, 0x0000000000000000, "RO", "reserved596", "Reserved bits"},
#else
{20, 20, 0x0000000000000000, "RO", "reserved596", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{19, 19, 0x0000000000000000, "RW", "txdll_digobsen", "digital buf obs enable (1=enable;0=disable)"},
#else
{19, 19, 0x0000000000000000, "RW", "txdll_digobsen", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{18, 18, 0x0000000000000000, "RW", "dtx_bl_digobsen", "digital buf obs enable (1=enable;0=disable)"},
#else
{18, 18, 0x0000000000000000, "RW", "dtx_bl_digobsen", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{16, 17, 0x0000000000000000, "RO", "reserved597", "Reserved bits"},
#else
{16, 17, 0x0000000000000000, "RO", "reserved597", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{12, 15, 0x0000000000000000, "RW", "rxdll_bl_digobs1sel", "Digital observation select mux port 1"},
#else
{12, 15, 0x0000000000000000, "RW", "rxdll_bl_digobs1sel", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{8, 11, 0x0000000000000000, "RW", "rxdll_bl_digobs0sel", "Digital observation select mux port 0"},
#else
{8, 11, 0x0000000000000000, "RW", "rxdll_bl_digobs0sel", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{4, 7, 0x0000000000000000, "RW", "rxdll_cc_digobs1sel", "Digital observation select mux port 1"},
#else
{4, 7, 0x0000000000000000, "RW", "rxdll_cc_digobs1sel", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 3, 0x0000000000000000, "RW", "rxdll_cc_digobs0sel", "Digital observation select mux port 0"},
#else
{0, 3, 0x0000000000000000, "RW", "rxdll_cc_digobs0sel", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo476[] = {{"digobsctl1", "", 0x00000090, 13, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields477[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{31, 31, 0x0000000000000000, "RO", "reserved598", "Reserved bits"},
#else
{31, 31, 0x0000000000000000, "RO", "reserved598", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{28, 30, 0x0000000000000000, "RW", "dtx_cc_digobs1sel", "Digital observation select mux port 1"},
#else
{28, 30, 0x0000000000000000, "RW", "dtx_cc_digobs1sel", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{27, 27, 0x0000000000000000, "RO", "reserved599", "Reserved bits"},
#else
{27, 27, 0x0000000000000000, "RO", "reserved599", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{24, 26, 0x0000000000000000, "RW", "dtx_cc_digobs0sel", "Digital observation select mux port 0"},
#else
{24, 26, 0x0000000000000000, "RW", "dtx_cc_digobs0sel", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{23, 23, 0x0000000000000000, "RO", "reserved600", "Reserved bits"},
#else
{23, 23, 0x0000000000000000, "RO", "reserved600", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{20, 22, 0x0000000000000000, "RW", "dtx_bl_digobs1sel", "Digital observation select mux port 1"},
#else
{20, 22, 0x0000000000000000, "RW", "dtx_bl_digobs1sel", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{19, 19, 0x0000000000000000, "RO", "reserved601", "Reserved bits"},
#else
{19, 19, 0x0000000000000000, "RO", "reserved601", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{16, 18, 0x0000000000000000, "RW", "dtx_bl_digobs0sel", "Digital observation select mux port 0"},
#else
{16, 18, 0x0000000000000000, "RW", "dtx_bl_digobs0sel", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{15, 15, 0x0000000000000000, "RO", "reserved602", "Reserved bits"},
#else
{15, 15, 0x0000000000000000, "RO", "reserved602", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{12, 14, 0x0000000000000000, "RW", "tx_cc_digobs1sel", "Digital observation select mux port 1"},
#else
{12, 14, 0x0000000000000000, "RW", "tx_cc_digobs1sel", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{11, 11, 0x0000000000000000, "RO", "reserved603", "Reserved bits"},
#else
{11, 11, 0x0000000000000000, "RO", "reserved603", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{8, 10, 0x0000000000000000, "RW", "tx_cc_digobs0sel", "Digital observation select mux port 0"},
#else
{8, 10, 0x0000000000000000, "RW", "tx_cc_digobs0sel", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{7, 7, 0x0000000000000000, "RO", "reserved604", "Reserved bits"},
#else
{7, 7, 0x0000000000000000, "RO", "reserved604", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{4, 6, 0x0000000000000000, "RW", "tx_bl_digobs1sel", "Digital observation select mux port 1"},
#else
{4, 6, 0x0000000000000000, "RW", "tx_bl_digobs1sel", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{3, 3, 0x0000000000000000, "RO", "reserved605", "Reserved bits"},
#else
{3, 3, 0x0000000000000000, "RO", "reserved605", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 2, 0x0000000000000000, "RW", "tx_bl_digobs0sel", "Digital observation select mux port 0"},
#else
{0, 2, 0x0000000000000000, "RW", "tx_bl_digobs0sel", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo477[] = {{"digobsctl0", "", 0x00000094, 16, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields478[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{29, 31, 0x0000000000000000, "RO", "reserved606", "Reserved bits"},
#else
{29, 31, 0x0000000000000000, "RO", "reserved606", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{24, 28, 0x0000000000000000, "RW", "rxdll_rxmuxsel", "enable strobe output from rx sdll.for each byte"},
#else
{24, 28, 0x0000000000000000, "RW", "rxdll_rxmuxsel", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{22, 23, 0x0000000000000000, "RO", "reserved607", "enable strobe output from rx sdll.for each byte"},
#else
{22, 23, 0x0000000000000000, "RO", "reserved607", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{21, 21, 0x0000000000000000, "RW", "txdll_dllfloprstb", "TxDLL flop reset"},
#else
{21, 21, 0x0000000000000000, "RW", "txdll_dllfloprstb", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{20, 20, 0x0000000000000000, "RW", "rxdll_dllfloprstb", "RxDLL flop reset"},
#else
{20, 20, 0x0000000000000000, "RW", "rxdll_dllfloprstb", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{19, 19, 0x0000000000000000, "RO", "reserved608", "enable strobe output from rx sdll.for each byte"},
#else
{19, 19, 0x0000000000000000, "RO", "reserved608", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{18, 18, 0x0000000000000000, "RW", "rxdll_bl_dqsouten", "enable strobe output from rx sdll.for each byte"},
#else
{18, 18, 0x0000000000000000, "RW", "rxdll_bl_dqsouten", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{17, 17, 0x0000000000000000, "RO", "reserved609", "enable data output from dq and dm pi's. for each byte"},
#else
{17, 17, 0x0000000000000000, "RO", "reserved609", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{16, 16, 0x0000000000000000, "RW", "rxdll_bl_rxdllen", "Rx DLL enable"},
#else
{16, 16, 0x0000000000000000, "RW", "rxdll_bl_rxdllen", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 15, 0x0000000000000000, "RO", "reserved610", "Reserved bits"},
#else
{0, 15, 0x0000000000000000, "RO", "reserved610", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo478[] = {{"rxdllctl_dqbldm", "", 0x00000098, 10, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields479[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{19, 31, 0x0000000000000000, "RO", "reserved611", "Reserved bits"},
#else
{19, 31, 0x0000000000000000, "RO", "reserved611", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{18, 18, 0x0000000000000000, "RW", "rxdll_cc_dqsouten", "enable strobe output from rx sdll.for each byte"},
#else
{18, 18, 0x0000000000000000, "RW", "rxdll_cc_dqsouten", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{17, 17, 0x0000000000000000, "RO", "reserved612", "enable data output from dq and dm pi's. for each byte"},
#else
{17, 17, 0x0000000000000000, "RO", "reserved612", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{16, 16, 0x0000000000000000, "RW", "rxdll_cc_rxdllen", "Rx DLL enable"},
#else
{16, 16, 0x0000000000000000, "RW", "rxdll_cc_rxdllen", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{1, 15, 0x0000000000000000, "RO", "reserved613", "Reserved bits"},
#else
{1, 15, 0x0000000000000000, "RO", "reserved613", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 0, 0x0000000000000000, "RW", "txdll_ref2xph0pien", "enable tx ref pi phase 0 enable"},
#else
{0, 0, 0x0000000000000000, "RW", "txdll_ref2xph0pien", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo479[] = {{"rxdllctl_ccbldm", "", 0x0000009C, 6, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields480[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{18, 31, 0x0000000000000000, "RO", "reserved614", "Reserved bits"},
#else
{18, 31, 0x0000000000000000, "RO", "reserved614", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{17, 17, 0x0000000000000000, "RO", "reserved615", "Reserved bits"},
#else
{17, 17, 0x0000000000000000, "RO", "reserved615", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{16, 16, 0x0000000000000000, "RW", "txdll_mdllen", "MDLL enable"},
#else
{16, 16, 0x0000000000000000, "RW", "txdll_mdllen", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{14, 15, 0x0000000000000000, "RO", "reserved616", "Reserved bits"},
#else
{14, 15, 0x0000000000000000, "RO", "reserved616", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{13, 13, 0x0000000000000000, "RW", "txdll_siggrp05pien", "PI enable for sig group 5 rank 0"},
#else
{13, 13, 0x0000000000000000, "RW", "txdll_siggrp05pien", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{12, 12, 0x0000000000000000, "RW", "txdll_siggrp04pien", "PI enable for sig group 4 rank 0"},
#else
{12, 12, 0x0000000000000000, "RW", "txdll_siggrp04pien", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{11, 11, 0x0000000000000000, "RW", "txdll_siggrp03pien", "PI enable for sig group 3 rank 0"},
#else
{11, 11, 0x0000000000000000, "RW", "txdll_siggrp03pien", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{10, 10, 0x0000000000000000, "RW", "txdll_siggrp02pien", "PI enable for sig group 2 rank 0"},
#else
{10, 10, 0x0000000000000000, "RW", "txdll_siggrp02pien", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{9, 9, 0x0000000000000000, "RW", "txdll_siggrp01pien", "PI enable for sig group 1 rank 0"},
#else
{9, 9, 0x0000000000000000, "RW", "txdll_siggrp01pien", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{8, 8, 0x0000000000000000, "RW", "txdll_siggrp00pien", "PI enable for sig group 0 rank 0"},
#else
{8, 8, 0x0000000000000000, "RW", "txdll_siggrp00pien", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{4, 7, 0x0000000000000000, "RO", "reserved617", "Reserved bits"},
#else
{4, 7, 0x0000000000000000, "RO", "reserved617", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{3, 3, 0x0000000000000000, "RW", "txdll_ref2xph270pien", "enable tx ref pi phase 270 enable"},
#else
{3, 3, 0x0000000000000000, "RW", "txdll_ref2xph270pien", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{2, 2, 0x0000000000000000, "RW", "txdll_ref2xph180pien", "enable tx ref pi phase 180 enable"},
#else
{2, 2, 0x0000000000000000, "RW", "txdll_ref2xph180pien", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{1, 1, 0x0000000000000000, "RW", "txdll_ref2xph90pien", "enable tx ref pi phase 90 enable"},
#else
{1, 1, 0x0000000000000000, "RW", "txdll_ref2xph90pien", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 0, 0x0000000000000000, "RO", "reserved618", "Reseved bits"},
#else
{0, 0, 0x0000000000000000, "RO", "reserved618", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo480[] = {{"txdllctl", "", 0x000000A0, 15, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields481[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{24, 31, 0x0000000000000000, "RO", "reserved619", "Reserved bits"},
#else
{24, 31, 0x0000000000000000, "RO", "reserved619", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{16, 23, 0x0000000000000000, "RW", "txdll_ref2xph270picode", "pi code for ref pi phase 270 output"},
#else
{16, 23, 0x0000000000000000, "RW", "txdll_ref2xph270picode", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{8, 15, 0x0000000000000000, "RW", "txdll_ref2xph180picode", "pi code for ref pi phase 180 output"},
#else
{8, 15, 0x0000000000000000, "RW", "txdll_ref2xph180picode", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 7, 0x0000000000000000, "RW", "txdll_ref2xph90picode", "pi code for ref pi phase 90 output"},
#else
{0, 7, 0x0000000000000000, "RW", "txdll_ref2xph90picode", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo481[] = {{"txdllref2xctl", "", 0x000000A4, 4, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields482[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{24, 31, 0x0000000000000000, "RW", "rxdll_bl_rk1dqshipicode", "pi code for rx rising dqs edge - DQ Lane"},
#else
{24, 31, 0x0000000000000000, "RW", "rxdll_bl_rk1dqshipicode", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{16, 23, 0x0000000000000000, "RW", "rxdll_bl_rk1dqslopicode", "pi code for rx falling dqs edge - DQ Lane"},
#else
{16, 23, 0x0000000000000000, "RW", "rxdll_bl_rk1dqslopicode", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{8, 15, 0x0000000000000000, "RO", "reserved620", "Reserved bits"},
#else
{8, 15, 0x0000000000000000, "RO", "reserved620", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 7, 0x0000000000000000, "RO", "reserved621", "Reserved bits"},
#else
{0, 7, 0x0000000000000000, "RO", "reserved621", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo482[] = {{"rxdlldqsrk1ctl", "", 0x000000A8, 4, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields483[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{24, 31, 0x0000000000000000, "RW", "rxdll_bl_rk0dqshipicode", "pi code for rx rising dqs edge - DQ Lane"},
#else
{24, 31, 0x0000000000000000, "RW", "rxdll_bl_rk0dqshipicode", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{16, 23, 0x0000000000000000, "RW", "rxdll_bl_rk0dqslopicode", "pi code for rx falling dqs edge - DQ Lane"},
#else
{16, 23, 0x0000000000000000, "RW", "rxdll_bl_rk0dqslopicode", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{8, 15, 0x0000000000000000, "RW", "rxdll_cc_rk0dqshipicode", "pi code for rx rising dqs edge  - CC Lane"},
#else
{8, 15, 0x0000000000000000, "RW", "rxdll_cc_rk0dqshipicode", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 7, 0x0000000000000000, "RW", "rxdll_cc_rk0dqslopicode", "pi code for rx falling dqs edge  - CC Lane"},
#else
{0, 7, 0x0000000000000000, "RW", "rxdll_cc_rk0dqslopicode", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo483[] = {{"rxdlldqsrk0ctl", "", 0x000000AC, 4, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields484[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{1, 31, 0x0000000000000000, "RO", "reserved622", "Reserved bits"},
#else
{1, 31, 0x0000000000000000, "RO", "reserved622", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 0, 0x0000000000000000, "RW", "txvref_cmn_vrefbufen", "enable signal for the tx vref unity gain buffer"},
#else
{0, 0, 0x0000000000000000, "RW", "txvref_cmn_vrefbufen", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo484[] = {{"vrefctl1", "", 0x000000B0, 2, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields485[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{24, 31, 0x0000000000000000, "RW", "vref_txlcompvrefctrl", "vref decode signal for the lcomp"},
#else
{24, 31, 0x0000000000000000, "RW", "vref_txlcompvrefctrl", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{22, 23, 0x0000000000000000, "RO", "reserved623", "Reserved bits"},
#else
{22, 23, 0x0000000000000000, "RO", "reserved623", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{21, 21, 0x0000000000000000, "RW", "lvl_bl_vrefiobufact", "vrefiobufact - DQ Lane"},
#else
{21, 21, 0x0000000000000000, "RW", "lvl_bl_vrefiobufact", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{20, 20, 0x0000000000000000, "RW", "lvl_cc_vrefiobufact", "vrefiobufact - CC Lane"},
#else
{20, 20, 0x0000000000000000, "RW", "lvl_cc_vrefiobufact", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{17, 19, 0x0000000000000000, "RO", "reserved624", "Reserved bits"},
#else
{17, 19, 0x0000000000000000, "RO", "reserved624", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{16, 16, 0x0000000000000000, "RW", "vref_vrefcmctrl", "common mode select to choose between lpddr3;lpddr4"},
#else
{16, 16, 0x0000000000000000, "RW", "vref_vrefcmctrl", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{8, 15, 0x0000000000000020, "RW", "vref_rxblvrefctrl", "vref decode signal for the b0 rx vref"},
#else
{8, 15, 0x0000000000000020, "RW", "vref_rxblvrefctrl", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 7, 0x0000000000000020, "RW", "vref_rxccvrefctrl", "vref decode signal for the cc0 rx vref"},
#else
{0, 7, 0x0000000000000020, "RW", "vref_rxccvrefctrl", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo485[] = {{"vrefctl0", "", 0x000000B4, 8, 0x00000000FFFFFFFF, 0x0000000000002020}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields486[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{4, 31, 0x0000000000000000, "RO", "reserved625", "Reserved bits"},
#else
{4, 31, 0x0000000000000000, "RO", "reserved625", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 3, 0x0000000000000000, "RW", "rxdll_bl_dq8rxpbdcode", "Rx Per bit De-skew code for dq0 valid codes"},
#else
{0, 3, 0x0000000000000000, "RW", "rxdll_bl_dq8rxpbdcode", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo486[] = {{"rxbl8pbdctl", "", 0x000000B8, 2, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields487[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{28, 31, 0x0000000000000000, "RW", "rxdll_bl_dq7rxpbdcode", "Rx Per bit De-skew code for dq0 valid codes"},
#else
{28, 31, 0x0000000000000000, "RW", "rxdll_bl_dq7rxpbdcode", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{24, 27, 0x0000000000000000, "RW", "rxdll_bl_dq6rxpbdcode", "Rx Per bit De-skew code for dq0 valid codes"},
#else
{24, 27, 0x0000000000000000, "RW", "rxdll_bl_dq6rxpbdcode", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{20, 23, 0x0000000000000000, "RW", "rxdll_bl_dq5rxpbdcode", "Rx Per bit De-skew code for dq0 valid codes"},
#else
{20, 23, 0x0000000000000000, "RW", "rxdll_bl_dq5rxpbdcode", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{16, 19, 0x0000000000000000, "RW", "rxdll_bl_dq4rxpbdcode", "Rx Per bit De-skew code for dq0 valid codes"},
#else
{16, 19, 0x0000000000000000, "RW", "rxdll_bl_dq4rxpbdcode", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{12, 15, 0x0000000000000000, "RW", "rxdll_bl_dq3rxpbdcode", "Rx Per bit De-skew code for dq0 valid codes"},
#else
{12, 15, 0x0000000000000000, "RW", "rxdll_bl_dq3rxpbdcode", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{8, 11, 0x0000000000000000, "RW", "rxdll_bl_dq2rxpbdcode", "Rx Per bit De-skew code for dq0 valid codes"},
#else
{8, 11, 0x0000000000000000, "RW", "rxdll_bl_dq2rxpbdcode", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{4, 7, 0x0000000000000000, "RW", "rxdll_bl_dq1rxpbdcode", "Rx Per bit De-skew code for dq0 valid codes"},
#else
{4, 7, 0x0000000000000000, "RW", "rxdll_bl_dq1rxpbdcode", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 3, 0x0000000000000000, "RW", "rxdll_bl_dq0rxpbdcode", "Rx Per bit De-skew code for dq0 valid codes"},
#else
{0, 3, 0x0000000000000000, "RW", "rxdll_bl_dq0rxpbdcode", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo487[] = {{"rxpbdblctl", "", 0x000000BC, 8, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields488[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{24, 31, 0x0000000000000000, "RO", "reserved626", "Reserved bits"},
#else
{24, 31, 0x0000000000000000, "RO", "reserved626", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{23, 23, 0x0000000000000000, "RW", "rxdll_cc_rxpbden", "Rx Per Bit De-skew enable (1=enable, 0=disable), 0 for cc always"},
#else
{23, 23, 0x0000000000000000, "RW", "rxdll_cc_rxpbden", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{22, 22, 0x0000000000000000, "RW", "rxdll_bl_rxpbden", "Rx Per Bit De-skew enable (1=enable, 0=disable)"},
#else
{22, 22, 0x0000000000000000, "RW", "rxdll_bl_rxpbden", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{4, 21, 0x0000000000000000, "RO", "reserved627", "Reserved bits"},
#else
{4, 21, 0x0000000000000000, "RO", "reserved627", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{3, 3, 0x0000000000000000, "RW", "tx_cc_pbdstaticlegen", "Per bit deskew enable - TX - CC"},
#else
{3, 3, 0x0000000000000000, "RW", "tx_cc_pbdstaticlegen", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{2, 2, 0x0000000000000000, "RW", "tx_bl_pbdstaticlegen", "Per bit deskew enable - TX - BL"},
#else
{2, 2, 0x0000000000000000, "RW", "tx_bl_pbdstaticlegen", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{1, 1, 0x0000000000000000, "RW", "dtx_cc_pbdstaticlegen", "Per bit deskew enable - DTX - CC"},
#else
{1, 1, 0x0000000000000000, "RW", "dtx_cc_pbdstaticlegen", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 0, 0x0000000000000000, "RW", "dtx_bl_pbdstaticlegen", "Per bit deskew enable - DTX - BL"},
#else
{0, 0, 0x0000000000000000, "RW", "dtx_bl_pbdstaticlegen", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo488[] = {{"txpbdctl1", "", 0x000000C0, 8, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields489[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{5, 31, 0x0000000000000000, "RO", "reserved628", "Reserved bits"},
#else
{5, 31, 0x0000000000000000, "RO", "reserved628", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 4, 0x0000000000000000, "RW", "tx_bldm_txpbdcode", "Tx Per Bit De-skew code for dq0 valid codes"},
#else
{0, 4, 0x0000000000000000, "RW", "tx_bldm_txpbdcode", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo489[] = {{"txpbdrk0ctl1", "", 0x000000C4, 2, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields490[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{21, 31, 0x0000000000000000, "RO", "reserved629", "Reserved bits"},
#else
{21, 31, 0x0000000000000000, "RO", "reserved629", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{16, 20, 0x0000000000000000, "RW", "dtx_bl_dqsbpbdcode", "Tx Per Bit De-skew code for dq0 valid codes"},
#else
{16, 20, 0x0000000000000000, "RW", "dtx_bl_dqsbpbdcode", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{8, 15, 0x0000000000000000, "RO", "reserved630", "Reserved bits"},
#else
{8, 15, 0x0000000000000000, "RO", "reserved630", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{5, 7, 0x0000000000000000, "RO", "reserved631", "Reserved bits"},
#else
{5, 7, 0x0000000000000000, "RO", "reserved631", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 4, 0x0000000000000000, "RW", "dtx_bl_dqspbdcode", "Tx Per Bit De-skew code for dq0 valid codes"},
#else
{0, 4, 0x0000000000000000, "RW", "dtx_bl_dqspbdcode", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo490[] = {{"txpbdrk0ctl0", "", 0x000000C8, 5, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields491[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{29, 31, 0x0000000000000000, "RO", "reserved632", "Reserved bits"},
#else
{29, 31, 0x0000000000000000, "RO", "reserved632", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{24, 28, 0x0000000000000000, "RW", "tx_bldq7_txpbdcode", "Tx Per Bit De-skew code for dq0 valid codes"},
#else
{24, 28, 0x0000000000000000, "RW", "tx_bldq7_txpbdcode", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{21, 23, 0x0000000000000000, "RO", "reserved633", "Reserved bits"},
#else
{21, 23, 0x0000000000000000, "RO", "reserved633", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{16, 20, 0x0000000000000000, "RW", "tx_bldq6_txpbdcode", "Tx Per Bit De-skew code for dq0 valid codes"},
#else
{16, 20, 0x0000000000000000, "RW", "tx_bldq6_txpbdcode", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{13, 15, 0x0000000000000000, "RO", "reserved634", "Reserved bits"},
#else
{13, 15, 0x0000000000000000, "RO", "reserved634", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{8, 12, 0x0000000000000000, "RW", "tx_bldq5_txpbdcode", "Tx Per Bit De-skew code for dq0 valid codes"},
#else
{8, 12, 0x0000000000000000, "RW", "tx_bldq5_txpbdcode", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{5, 7, 0x0000000000000000, "RO", "reserved635", "Reserved bits"},
#else
{5, 7, 0x0000000000000000, "RO", "reserved635", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 4, 0x0000000000000000, "RW", "tx_bldq4_txpbdcode", "Tx Per Bit De-skew code for dq0 valid codes"},
#else
{0, 4, 0x0000000000000000, "RW", "tx_bldq4_txpbdcode", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo491[] = {{"txpbdblctl1", "", 0x000000CC, 8, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields492[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{29, 31, 0x0000000000000000, "RO", "reserved636", "Reserved bits"},
#else
{29, 31, 0x0000000000000000, "RO", "reserved636", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{24, 28, 0x0000000000000000, "RW", "tx_bldq3_txpbdcode", "Tx Per Bit De-skew code for dq0 valid codes"},
#else
{24, 28, 0x0000000000000000, "RW", "tx_bldq3_txpbdcode", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{21, 23, 0x0000000000000000, "RO", "reserved637", "Reserved bits"},
#else
{21, 23, 0x0000000000000000, "RO", "reserved637", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{16, 20, 0x0000000000000000, "RW", "tx_bldq2_txpbdcode", "Tx Per Bit De-skew code for dq0 valid codes"},
#else
{16, 20, 0x0000000000000000, "RW", "tx_bldq2_txpbdcode", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{13, 15, 0x0000000000000000, "RO", "reserved638", "Reserved bits"},
#else
{13, 15, 0x0000000000000000, "RO", "reserved638", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{8, 12, 0x0000000000000000, "RW", "tx_bldq1_txpbdcode", "Tx Per Bit De-skew code for dq0 valid codes"},
#else
{8, 12, 0x0000000000000000, "RW", "tx_bldq1_txpbdcode", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{5, 7, 0x0000000000000000, "RO", "reserved639", "Reserved bits"},
#else
{5, 7, 0x0000000000000000, "RO", "reserved639", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 4, 0x0000000000000000, "RW", "tx_bldq0_txpbdcode", "Tx Per Bit De-skew code for dq0 valid codes"},
#else
{0, 4, 0x0000000000000000, "RW", "tx_bldq0_txpbdcode", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo492[] = {{"txpbdblctl0", "", 0x000000D0, 8, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields493[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{20, 31, 0x0000000000000000, "RO", "reserved640", "Reserved bits"},
#else
{20, 31, 0x0000000000000000, "RO", "reserved640", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{19, 19, 0x0000000000000001, "RW", "drx_cc_ampoffseten", "Offset cancellation enable for Rx (not used for cc)"},
#else
{19, 19, 0x0000000000000001, "RW", "drx_cc_ampoffseten", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{18, 18, 0x0000000000000000, "RW", "rx_cc_ampoffseten", "Offset cancellation enable for Rx (not used for cc)"},
#else
{18, 18, 0x0000000000000000, "RW", "rx_cc_ampoffseten", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{17, 17, 0x0000000000000001, "RW", "drx_bl_ampoffseten", "DQS Offset cancellation enable for Rx (1=enable, 0=disable)"},
#else
{17, 17, 0x0000000000000001, "RW", "drx_bl_ampoffseten", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{16, 16, 0x0000000000000000, "RW", "rx_bl_ampoffseten", "DQ Offset cancellation enable for Rx (1=enable, 0=disable)"},
#else
{16, 16, 0x0000000000000000, "RW", "rx_bl_ampoffseten", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{12, 15, 0x0000000000000000, "RW", "drx_ccck0_ampoffset", "tuning bits for offset cancellation (can be tied off for CC)"},
#else
{12, 15, 0x0000000000000000, "RW", "drx_ccck0_ampoffset", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{8, 11, 0x0000000000000000, "RW", "rx_cc_ampoffset", "tuning bits for offset cancellation (can be tied off for CC)"},
#else
{8, 11, 0x0000000000000000, "RW", "rx_cc_ampoffset", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{4, 7, 0x0000000000000000, "RW", "drx_bl_ampoffset", "Offset cancellation code (DQS buffers)[br]1100 -4[br]1011 -3[br]1010 -2[br]1001 -1[br]0000 0[br]0001 +1[br]0010 +2[br]0011 +3[br]0100 +4"},
#else
{4, 7, 0x0000000000000000, "RW", "drx_bl_ampoffset", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 3, 0x0000000000000000, "RW", "rx_bldm_ampoffset", "Offset cancellation code (DM/DQ buffers)[br]1100 -4[br]1011 -3[br]1010 -2[br]1001 -1[br]0000 0[br]0001 +1[br]0010 +2[br]0011 +3[br]0100 +4"},
#else
{0, 3, 0x0000000000000000, "RW", "rx_bldm_ampoffset", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo493[] = {{"offsetcnclctrl1", "", 0x000000D4, 9, 0x00000000FFFFFFFF, 0x00000000000A0000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields494[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{28, 31, 0x0000000000000000, "RW", "rx_bldq0_ampoffset", "Offset cancellation code (DM/DQ buffers)[br]1100 -4[br]1011 -3[br]1010 -2[br]1001 -1[br]0000 0[br]0001 +1[br]0010 +2[br]0011 +3[br]0100 +4"},
#else
{28, 31, 0x0000000000000000, "RW", "rx_bldq0_ampoffset", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{24, 27, 0x0000000000000000, "RW", "rx_bldq1_ampoffset", "Offset cancellation code (DM/DQ buffers)[br]1100 -4[br]1011 -3[br]1010 -2[br]1001 -1[br]0000 0[br]0001 +1[br]0010 +2[br]0011 +3[br]0100 +4"},
#else
{24, 27, 0x0000000000000000, "RW", "rx_bldq1_ampoffset", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{20, 23, 0x0000000000000000, "RW", "rx_bldq2_ampoffset", "Offset cancellation code (DM/DQ buffers)[br]1100 -4[br]1011 -3[br]1010 -2[br]1001 -1[br]0000 0[br]0001 +1[br]0010 +2[br]0011 +3[br]0100 +4"},
#else
{20, 23, 0x0000000000000000, "RW", "rx_bldq2_ampoffset", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{16, 19, 0x0000000000000000, "RW", "rx_bldq3_ampoffset", "Offset cancellation code (DM/DQ buffers)[br]1100 -4[br]1011 -3[br]1010 -2[br]1001 -1[br]0000 0[br]0001 +1[br]0010 +2[br]0011 +3[br]0100 +4"},
#else
{16, 19, 0x0000000000000000, "RW", "rx_bldq3_ampoffset", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{12, 15, 0x0000000000000000, "RW", "rx_bldq4_ampoffset", "Offset cancellation code (DM/DQ buffers)[br]1100 -4[br]1011 -3[br]1010 -2[br]1001 -1[br]0000 0[br]0001 +1[br]0010 +2[br]0011 +3[br]0100 +4"},
#else
{12, 15, 0x0000000000000000, "RW", "rx_bldq4_ampoffset", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{8, 11, 0x0000000000000000, "RW", "rx_bldq5_ampoffset", "Offset cancellation code (DM/DQ buffers)[br]1100 -4[br]1011 -3[br]1010 -2[br]1001 -1[br]0000 0[br]0001 +1[br]0010 +2[br]0011 +3[br]0100 +4"},
#else
{8, 11, 0x0000000000000000, "RW", "rx_bldq5_ampoffset", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{4, 7, 0x0000000000000000, "RW", "rx_bldq6_ampoffset", "Offset cancellation code (DM/DQ buffers)[br]1100 -4[br]1011 -3[br]1010 -2[br]1001 -1[br]0000 0[br]0001 +1[br]0010 +2[br]0011 +3[br]0100 +4"},
#else
{4, 7, 0x0000000000000000, "RW", "rx_bldq6_ampoffset", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 3, 0x0000000000000000, "RW", "rx_bldq7_ampoffset", "Offset cancellation code (DM/DQ buffers)[br]1100 -4[br]1011 -3[br]1010 -2[br]1001 -1[br]0000 0[br]0001 +1[br]0010 +2[br]0011 +3[br]0100 +4"},
#else
{0, 3, 0x0000000000000000, "RW", "rx_bldq7_ampoffset", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo494[] = {{"offsetcnclctrl0", "", 0x000000D8, 8, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields495[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{4, 31, 0x0000000000000000, "RO", "reserved641", "Reserved bits"},
#else
{4, 31, 0x0000000000000000, "RO", "reserved641", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{2, 3, 0x0000000000000000, "RW", "drx_bl_casbiasctrl", "DRX Bias Command Control - BL"},
#else
{2, 3, 0x0000000000000000, "RW", "drx_bl_casbiasctrl", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 1, 0x0000000000000000, "RW", "drx_bl_nbiasctrl", "DRX N Bias Control - BL"},
#else
{0, 1, 0x0000000000000000, "RW", "drx_bl_nbiasctrl", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo495[] = {{"ctlectl2", "", 0x000000DC, 3, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields496[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{31, 31, 0x0000000000000000, "RO", "reserved642", "Reserved bits"},
#else
{31, 31, 0x0000000000000000, "RO", "reserved642", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{30, 30, 0x0000000000000001, "RW", "drx_cc_biasen", "DRX Bias Enable - CC"},
#else
{30, 30, 0x0000000000000001, "RW", "drx_cc_biasen", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{28, 29, 0x0000000000000000, "RW", "drx_cc_casbiasctrl", "DRX Bias Command Control - CC"},
#else
{28, 29, 0x0000000000000000, "RW", "drx_cc_casbiasctrl", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{26, 27, 0x0000000000000000, "RW", "drx_cc_nbiasctrl", "DRX N Bias Control - CC"},
#else
{26, 27, 0x0000000000000000, "RW", "drx_cc_nbiasctrl", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{23, 25, 0x0000000000000000, "RW", "drx_cc_ctlebiasctrl", "DRX Bias Ctle Control - CC"},
#else
{23, 25, 0x0000000000000000, "RW", "drx_cc_ctlebiasctrl", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{22, 22, 0x0000000000000001, "RW", "rx_cc_ctleen", "Enable CTLE (not used for CC)"},
#else
{22, 22, 0x0000000000000001, "RW", "rx_cc_ctleen", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{20, 21, 0x0000000000000000, "RW", "rx_cc_ctlebiasctrl", "bias control for ctle amp[br]00 2k&          0.25xnom[br]01 1k&          0.4xnom[br]10 0.5k&     1xnom[br]11 0.25k&  1.7xnom"},
#else
{20, 21, 0x0000000000000000, "RW", "rx_cc_ctlebiasctrl", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{18, 19, 0x0000000000000000, "RW", "rx_cc_ctleres", "resistor tuning;00=0.5kohm;01=1kohm;10=1.5kohm;11=2kohm"},
#else
{18, 19, 0x0000000000000000, "RW", "rx_cc_ctleres", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{16, 17, 0x0000000000000001, "RW", "rx_cc_ctlecap", "cap tuning;00 = 0.5pf;01 = 1pf;10 = 1.5pf;11 = 2pf"},
#else
{16, 17, 0x0000000000000001, "RW", "rx_cc_ctlecap", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{15, 15, 0x0000000000000001, "RW", "drx_bl_ctleen", "Enable CTLE for DQS (1=enable, 0=disable)"},
#else
{15, 15, 0x0000000000000001, "RW", "drx_bl_ctleen", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{12, 14, 0x0000000000000000, "RW", "drx_bl_ctlebiasctrl", "bias control for ctle amp[br]00 2k&          0.25xnom[br]01 1k&          0.4xnom[br]10 0.5k&     1xnom[br]11 0.25k&  1.7xnom"},
#else
{12, 14, 0x0000000000000000, "RW", "drx_bl_ctlebiasctrl", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{10, 11, 0x0000000000000000, "RW", "drx_bl_ctleres", "resistor tuning;00=0.5kohm;01=1kohm;10=1.5kohm;11=2kohm"},
#else
{10, 11, 0x0000000000000000, "RW", "drx_bl_ctleres", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{8, 9, 0x0000000000000001, "RW", "drx_bl_ctlecap", "cap tuning;00 = 0.5pf;01 = 1pf;10 = 1.5pf;11 = 2pf"},
#else
{8, 9, 0x0000000000000001, "RW", "drx_bl_ctlecap", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{7, 7, 0x0000000000000001, "RW", "drx_bl_biasen", "DRX Bias Enable - BL"},
#else
{7, 7, 0x0000000000000001, "RW", "drx_bl_biasen", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{6, 6, 0x0000000000000001, "RW", "rx_bl_ctleen", "Enable CTLE for DQ (1=enable, 0=disable)"},
#else
{6, 6, 0x0000000000000001, "RW", "rx_bl_ctleen", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{4, 5, 0x0000000000000000, "RW", "rx_bl_ctlebiasctrl", "bias control for ctle amp[br]00 2k&          0.25xnom[br]01 1k&          0.4xnom[br]10 0.5k&     1xnom[br]11 0.25k&  1.7xnom"},
#else
{4, 5, 0x0000000000000000, "RW", "rx_bl_ctlebiasctrl", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{2, 3, 0x0000000000000000, "RW", "rx_bldm_ctleres", "resistor tuning;00=0.5kohm;01=1kohm;10=1.5kohm;11=2kohm"},
#else
{2, 3, 0x0000000000000000, "RW", "rx_bldm_ctleres", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 1, 0x0000000000000001, "RW", "rx_bldm_ctlecap", "cap tuning;00 = 0.1pf;01 = 0.2pf;10 = 0.3pf;11 = 0.4pf"},
#else
{0, 1, 0x0000000000000001, "RW", "rx_bldm_ctlecap", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo496[] = {{"ctlectl1", "", 0x000000E0, 18, 0x00000000FFFFFFFF, 0x00000000404181C1}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields497[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{30, 31, 0x0000000000000000, "RW", "rx_bldq0_ctleres", "resistor tuning;00=0.5kohm;01=1kohm;10=1.5kohm;11=2kohm"},
#else
{30, 31, 0x0000000000000000, "RW", "rx_bldq0_ctleres", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{28, 29, 0x0000000000000000, "RW", "rx_bldq1_ctleres", "resistor tuning;00=0.5kohm;01=1kohm;10=1.5kohm;11=2kohm"},
#else
{28, 29, 0x0000000000000000, "RW", "rx_bldq1_ctleres", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{26, 27, 0x0000000000000000, "RW", "rx_bldq2_ctleres", "resistor tuning;00=0.5kohm;01=1kohm;10=1.5kohm;11=2kohm"},
#else
{26, 27, 0x0000000000000000, "RW", "rx_bldq2_ctleres", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{24, 25, 0x0000000000000000, "RW", "rx_bldq3_ctleres", "resistor tuning;00=0.5kohm;01=1kohm;10=1.5kohm;11=2kohm"},
#else
{24, 25, 0x0000000000000000, "RW", "rx_bldq3_ctleres", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{22, 23, 0x0000000000000000, "RW", "rx_bldq4_ctleres", "resistor tuning;00=0.5kohm;01=1kohm;10=1.5kohm;11=2kohm"},
#else
{22, 23, 0x0000000000000000, "RW", "rx_bldq4_ctleres", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{20, 21, 0x0000000000000000, "RW", "rx_bldq5_ctleres", "resistor tuning;00=0.5kohm;01=1kohm;10=1.5kohm;11=2kohm"},
#else
{20, 21, 0x0000000000000000, "RW", "rx_bldq5_ctleres", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{18, 19, 0x0000000000000000, "RW", "rx_bldq6_ctleres", "resistor tuning;00=0.5kohm;01=1kohm;10=1.5kohm;11=2kohm"},
#else
{18, 19, 0x0000000000000000, "RW", "rx_bldq6_ctleres", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{16, 17, 0x0000000000000000, "RW", "rx_bldq7_ctleres", "resistor tuning;00=0.5kohm;01=1kohm;10=1.5kohm;11=2kohm"},
#else
{16, 17, 0x0000000000000000, "RW", "rx_bldq7_ctleres", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{14, 15, 0x0000000000000001, "RW", "rx_bldq0_ctlecap", "cap tuning;00 = 0.1pf;01 = 0.2pf;10 = 0.3pf;11 = 0.4pf"},
#else
{14, 15, 0x0000000000000001, "RW", "rx_bldq0_ctlecap", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{12, 13, 0x0000000000000001, "RW", "rx_bldq1_ctlecap", "cap tuning;00 = 0.1pf;01 = 0.2pf;10 = 0.3pf;11 = 0.4pf"},
#else
{12, 13, 0x0000000000000001, "RW", "rx_bldq1_ctlecap", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{10, 11, 0x0000000000000001, "RW", "rx_bldq2_ctlecap", "cap tuning;00 = 0.1pf;01 = 0.2pf;10 = 0.3pf;11 = 0.4pf"},
#else
{10, 11, 0x0000000000000001, "RW", "rx_bldq2_ctlecap", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{8, 9, 0x0000000000000001, "RW", "rx_bldq3_ctlecap", "cap tuning;00 = 0.1pf;01 = 0.2pf;10 = 0.3pf;11 = 0.4pf"},
#else
{8, 9, 0x0000000000000001, "RW", "rx_bldq3_ctlecap", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{6, 7, 0x0000000000000001, "RW", "rx_bldq4_ctlecap", "cap tuning;00 = 0.1pf;01 = 0.2pf;10 = 0.3pf;11 = 0.4pf"},
#else
{6, 7, 0x0000000000000001, "RW", "rx_bldq4_ctlecap", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{4, 5, 0x0000000000000001, "RW", "rx_bldq5_ctlecap", "cap tuning;00 = 0.1pf;01 = 0.2pf;10 = 0.3pf;11 = 0.4pf"},
#else
{4, 5, 0x0000000000000001, "RW", "rx_bldq5_ctlecap", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{2, 3, 0x0000000000000001, "RW", "rx_bldq6_ctlecap", "cap tuning;00 = 0.1pf;01 = 0.2pf;10 = 0.3pf;11 = 0.4pf"},
#else
{2, 3, 0x0000000000000001, "RW", "rx_bldq6_ctlecap", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 1, 0x0000000000000001, "RW", "rx_bldq7_ctlecap", "cap tuning;00 = 0.1pf;01 = 0.2pf;10 = 0.3pf;11 = 0.4pf"},
#else
{0, 1, 0x0000000000000001, "RW", "rx_bldq7_ctlecap", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo497[] = {{"ctlectl0", "", 0x000000E4, 16, 0x00000000FFFFFFFF, 0x0000000000005555}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields498[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{31, 31, 0x0000000000000000, "RW", "tx_bl_tcostaticlegen", "TX TCO enable - BL"},
#else
{31, 31, 0x0000000000000000, "RW", "tx_bl_tcostaticlegen", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{29, 30, 0x0000000000000000, "RO", "reserved643", "Reserved bits"},
#else
{29, 30, 0x0000000000000000, "RO", "reserved643", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{24, 28, 0x000000000000001F, "RW", "tx_bl_tcofall", "DQ TCO comp fall code - DQ Lane"},
#else
{24, 28, 0x000000000000001F, "RW", "tx_bl_tcofall", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{21, 23, 0x0000000000000000, "RO", "reserved644", "Reserved bits"},
#else
{21, 23, 0x0000000000000000, "RO", "reserved644", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{16, 20, 0x000000000000001F, "RW", "tx_bl_tcorise", "DQ TCO comp rise code - DQ Lane"},
#else
{16, 20, 0x000000000000001F, "RW", "tx_bl_tcorise", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{15, 15, 0x0000000000000000, "RW", "tx_cc_tcostaticlegen", "TX TCO enable - CC"},
#else
{15, 15, 0x0000000000000000, "RW", "tx_cc_tcostaticlegen", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{13, 14, 0x0000000000000000, "RO", "reserved645", "Reserved bits"},
#else
{13, 14, 0x0000000000000000, "RO", "reserved645", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{8, 12, 0x000000000000001F, "RW", "tx_cc_tcofall", "DQ TCO comp fall code - CC Lane"},
#else
{8, 12, 0x000000000000001F, "RW", "tx_cc_tcofall", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{5, 7, 0x0000000000000000, "RO", "reserved646", "Reserved bits"},
#else
{5, 7, 0x0000000000000000, "RO", "reserved646", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 4, 0x000000000000001F, "RW", "tx_cc_tcorise", "DQ TCO comp rise code - CC Lane"},
#else
{0, 4, 0x000000000000001F, "RW", "tx_cc_tcorise", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo498[] = {{"tcoctl_dqcc", "", 0x000000E8, 10, 0x00000000FFFFFFFF, 0x000000001F1F1F1F}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields499[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{30, 31, 0x0000000000000000, "RO", "reserved647", "Reserved bits"},
#else
{30, 31, 0x0000000000000000, "RO", "reserved647", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{29, 29, 0x0000000000000000, "RW", "dtx_bl_tcostaticlegen", "DTX TCO enable - BL"},
#else
{29, 29, 0x0000000000000000, "RW", "dtx_bl_tcostaticlegen", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{24, 28, 0x000000000000001F, "RW", "dtx_bl_tcofalldqsb", "DQSB TCO comp fall code - DQ Lane"},
#else
{24, 28, 0x000000000000001F, "RW", "dtx_bl_tcofalldqsb", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{21, 23, 0x0000000000000000, "RO", "reserved648", "Reserved bits"},
#else
{21, 23, 0x0000000000000000, "RO", "reserved648", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{16, 20, 0x000000000000001F, "RW", "dtx_bl_tcorisedqsb", "DQS TCO comp fall code - DQ Lane"},
#else
{16, 20, 0x000000000000001F, "RW", "dtx_bl_tcorisedqsb", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{13, 15, 0x0000000000000000, "RO", "reserved649", "Reserved bits"},
#else
{13, 15, 0x0000000000000000, "RO", "reserved649", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{8, 12, 0x000000000000001F, "RW", "dtx_bl_tcofalldqs", "DQSB TCO comp rise code - DQ Lane"},
#else
{8, 12, 0x000000000000001F, "RW", "dtx_bl_tcofalldqs", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{5, 7, 0x0000000000000000, "RO", "reserved650", "Reserved bits"},
#else
{5, 7, 0x0000000000000000, "RO", "reserved650", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 4, 0x000000000000001F, "RW", "dtx_bl_tcorisedqs", "DQS TCO comp rise code - DQ Lane"},
#else
{0, 4, 0x000000000000001F, "RW", "dtx_bl_tcorisedqs", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo499[] = {{"tcoctl_dq", "", 0x000000EC, 9, 0x00000000FFFFFFFF, 0x000000001F1F1F1F}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields500[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{30, 31, 0x0000000000000000, "RO", "reserved651", "Reserved bits"},
#else
{30, 31, 0x0000000000000000, "RO", "reserved651", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{29, 29, 0x0000000000000000, "RW", "dtx_cc_tcostaticlegen", "DTX TCO enable - CC"},
#else
{29, 29, 0x0000000000000000, "RW", "dtx_cc_tcostaticlegen", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{24, 28, 0x000000000000001F, "RW", "dtx_cc_tcofalldqsb", "DQSB TCO comp fall code - CC Lane"},
#else
{24, 28, 0x000000000000001F, "RW", "dtx_cc_tcofalldqsb", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{21, 23, 0x0000000000000000, "RO", "reserved652", "Reserved bits"},
#else
{21, 23, 0x0000000000000000, "RO", "reserved652", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{16, 20, 0x000000000000001F, "RW", "dtx_cc_tcorisedqsb", "DQSB TCO comp rise code - CC Lane"},
#else
{16, 20, 0x000000000000001F, "RW", "dtx_cc_tcorisedqsb", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{13, 15, 0x0000000000000000, "RO", "reserved653", "Reserved bits"},
#else
{13, 15, 0x0000000000000000, "RO", "reserved653", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{8, 12, 0x000000000000001F, "RW", "dtx_cc_tcofalldqs", "DQS TCO comp fall code - CC Lane"},
#else
{8, 12, 0x000000000000001F, "RW", "dtx_cc_tcofalldqs", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{5, 7, 0x0000000000000000, "RO", "reserved654", "Reserved bits"},
#else
{5, 7, 0x0000000000000000, "RO", "reserved654", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 4, 0x000000000000001F, "RW", "dtx_cc_tcorisedqs", "DQS TCO comp rise code - CC Lane"},
#else
{0, 4, 0x000000000000001F, "RW", "dtx_cc_tcorisedqs", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo500[] = {{"tcoctl_cc", "", 0x000000F0, 9, 0x00000000FFFFFFFF, 0x000000001F1F1F1F}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields501[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{12, 31, 0x0000000000000000, "RO", "reserved655", "Reserved bits"},
#else
{12, 31, 0x0000000000000000, "RO", "reserved655", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{10, 11, 0x0000000000000000, "RW", "txdll_rk1siggrp06dbsel", "Dead band select for sig grp 6 rank 1"},
#else
{10, 11, 0x0000000000000000, "RW", "txdll_rk1siggrp06dbsel", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{6, 9, 0x0000000000000000, "RW", "txdll_rk1siggrp06rdptroffset", "Read pointer offset for sig group 6 rank 1"},
#else
{6, 9, 0x0000000000000000, "RW", "txdll_rk1siggrp06rdptroffset", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{4, 5, 0x0000000000000000, "RW", "txdll_rk0siggrp06dbsel", "Dead band select for sig grp 6 rank 0"},
#else
{4, 5, 0x0000000000000000, "RW", "txdll_rk0siggrp06dbsel", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 3, 0x0000000000000000, "RW", "txdll_rk0siggrp06rdptroffset", "Read pointer offset for sig group 6 rank 0"},
#else
{0, 3, 0x0000000000000000, "RW", "txdll_rk0siggrp06rdptroffset", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo501[] = {{"txdllsiggrp6ctl", "", 0x000000F4, 5, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields502[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{28, 31, 0x0000000000000000, "RW", "reserved656", "Reserved bits"},
#else
{28, 31, 0x0000000000000000, "RW", "reserved656", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{24, 27, 0x0000000000000000, "RW", "rk1dqdrvsecondrdportref2xrdptroffset", "Read pointer offset for second port for LDO integration - DQDMDRV - RK1."},
#else
{24, 27, 0x0000000000000000, "RW", "rk1dqdrvsecondrdportref2xrdptroffset", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{20, 23, 0x0000000000000000, "RW", "rk0dqdrvsecondrdportref2xrdptroffset", "Read pointer offset for second port for LDO integration - DQDMDRV - RK0."},
#else
{20, 23, 0x0000000000000000, "RW", "rk0dqdrvsecondrdportref2xrdptroffset", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{16, 19, 0x0000000000000000, "RW", "rk1dqsecondrdportref2xrdptroffset", "Read pointer offset for second port for LDO integration - DQ - RK1."},
#else
{16, 19, 0x0000000000000000, "RW", "rk1dqsecondrdportref2xrdptroffset", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{12, 15, 0x0000000000000000, "RW", "rk0dqsecondrdportref2xrdptroffset", "Read pointer offset for second port for LDO integration - DQ - RK0."},
#else
{12, 15, 0x0000000000000000, "RW", "rk0dqsecondrdportref2xrdptroffset", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{8, 11, 0x0000000000000000, "RW", "rk1dqsdrvsecondrdportref2xrdptroffset", "Read pointer offset for second port for LDO integration - DQ - RK1."},
#else
{8, 11, 0x0000000000000000, "RW", "rk1dqsdrvsecondrdportref2xrdptroffset", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{4, 7, 0x0000000000000000, "RW", "rk0dqsdrvsecondrdportref2xrdptroffset", "Read pointer offset for second port for LDO integration - DQ - RK0."},
#else
{4, 7, 0x0000000000000000, "RW", "rk0dqsdrvsecondrdportref2xrdptroffset", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 3, 0x0000000000000000, "RW", "ckdrvsecondrdportref2xrdptroffset", "Read pointer offset for second port for LDO integration - DQ - RK1."},
#else
{0, 3, 0x0000000000000000, "RW", "ckdrvsecondrdportref2xrdptroffset", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo502[] = {{"ldoctl0", "", 0x000000F8, 8, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields503[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{8, 31, 0x0000000000000000, "RW", "reserved657", "Reserved bits"},
#else
{8, 31, 0x0000000000000000, "RW", "reserved657", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{4, 7, 0x0000000000000000, "RW", "cssecondrdportref2xrdptroffset", "Read pointer offset for second port for LDO integration - DQ - RK0."},
#else
{4, 7, 0x0000000000000000, "RW", "cssecondrdportref2xrdptroffset", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 3, 0x0000000000000000, "RW", "cmddrvsecondrdportref2xrdptroffset", "Read pointer offset for second port for LDO integration - DQ - RK1."},
#else
{0, 3, 0x0000000000000000, "RW", "cmddrvsecondrdportref2xrdptroffset", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo503[] = {{"ldoctl1", "", 0x000000FC, 3, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields504[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{24, 31, 0x0000000000000000, "RO", "reserved658", "Reserved bits"},
#else
{24, 31, 0x0000000000000000, "RO", "reserved658", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{21, 23, 0x0000000000000000, "RW", "data0sel", "Reserved bits"},
#else
{21, 23, 0x0000000000000000, "RW", "data0sel", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{18, 20, 0x0000000000000000, "RW", "data1sel", "Reserved bits"},
#else
{18, 20, 0x0000000000000000, "RW", "data1sel", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{15, 17, 0x0000000000000000, "RW", "data2sel", "Reserved bits"},
#else
{15, 17, 0x0000000000000000, "RW", "data2sel", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{12, 14, 0x0000000000000000, "RW", "data3sel", "Reserved bits"},
#else
{12, 14, 0x0000000000000000, "RW", "data3sel", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{9, 11, 0x0000000000000000, "RW", "data4sel", "Reserved bits"},
#else
{9, 11, 0x0000000000000000, "RW", "data4sel", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{6, 8, 0x0000000000000000, "RW", "data5sel", "Reserved bits"},
#else
{6, 8, 0x0000000000000000, "RW", "data5sel", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{3, 5, 0x0000000000000000, "RW", "data6sel", "Reserved bits"},
#else
{3, 5, 0x0000000000000000, "RW", "data6sel", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 2, 0x0000000000000000, "RW", "data7sel", "Reserved bits"},
#else
{0, 2, 0x0000000000000000, "RW", "data7sel", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo504[] = {{"ptdatamuxsel", "", 0x00000100, 9, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields505[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{31, 31, 0x0000000000000000, "RO", "reserved659", "Reserved bits"},
#else
{31, 31, 0x0000000000000000, "RO", "reserved659", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{28, 30, 0x0000000000000000, "RW", "lpmode_dasrtdqcmddrvenb_dly", "Low Power Mode Delays"},
#else
{28, 30, 0x0000000000000000, "RW", "lpmode_dasrtdqcmddrvenb_dly", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{27, 27, 0x0000000000000000, "RO", "reserved660", "Reserved bits"},
#else
{27, 27, 0x0000000000000000, "RO", "reserved660", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{24, 26, 0x0000000000000000, "RW", "lpmode_asrtdqcmdsigpien_dly", "Low Power Mode Delays"},
#else
{24, 26, 0x0000000000000000, "RW", "lpmode_asrtdqcmdsigpien_dly", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{23, 23, 0x0000000000000000, "RO", "reserved661", "Reserved bits"},
#else
{23, 23, 0x0000000000000000, "RO", "reserved661", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{20, 22, 0x0000000000000000, "RW", "lpmode_asrtdqcmddrvenb_dly", "Low Power Mode Delays"},
#else
{20, 22, 0x0000000000000000, "RW", "lpmode_asrtdqcmddrvenb_dly", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{19, 19, 0x0000000000000000, "RO", "reserved662", "Reserved bits"},
#else
{19, 19, 0x0000000000000000, "RO", "reserved662", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{16, 18, 0x0000000000000000, "RW", "lpmode_dasrtiobufact_dly", "Low Power Mode Delays"},
#else
{16, 18, 0x0000000000000000, "RW", "lpmode_dasrtiobufact_dly", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{15, 15, 0x0000000000000000, "RO", "reserved663", "Reserved bits"},
#else
{15, 15, 0x0000000000000000, "RO", "reserved663", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{12, 14, 0x0000000000000000, "RW", "lpmode_dasrtwrptren_dly", "Low Power Mode Delays"},
#else
{12, 14, 0x0000000000000000, "RW", "lpmode_dasrtwrptren_dly", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{11, 11, 0x0000000000000000, "RO", "reserved664", "Reserved bits"},
#else
{11, 11, 0x0000000000000000, "RO", "reserved664", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{8, 10, 0x0000000000000000, "RW", "lpmode_asrtref2xrstb_dly", "Low Power Mode Delays"},
#else
{8, 10, 0x0000000000000000, "RW", "lpmode_asrtref2xrstb_dly", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{7, 7, 0x0000000000000000, "RO", "reserved665", "Reserved bits"},
#else
{7, 7, 0x0000000000000000, "RO", "reserved665", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{4, 6, 0x0000000000000000, "RO", "reserved666", "Reserved bits"},
#else
{4, 6, 0x0000000000000000, "RO", "reserved666", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{3, 3, 0x0000000000000000, "RO", "reserved667", "Reserved bits"},
#else
{3, 3, 0x0000000000000000, "RO", "reserved667", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 2, 0x0000000000000000, "RW", "lpmode_dasrtref2xrstb_dly", "Low Power Mode Delays"},
#else
{0, 2, 0x0000000000000000, "RW", "lpmode_dasrtref2xrstb_dly", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo505[] = {{"lpmodectl0", "", 0x00000104, 16, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields506[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{31, 31, 0x0000000000000000, "RO", "reserved668", "Reserved bits"},
#else
{31, 31, 0x0000000000000000, "RO", "reserved668", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{28, 30, 0x0000000000000000, "RW", "lpmode_asrtwrptren_dly", "Reserved bits"},
#else
{28, 30, 0x0000000000000000, "RW", "lpmode_asrtwrptren_dly", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{27, 27, 0x0000000000000000, "RO", "reserved669", "Reserved bits"},
#else
{27, 27, 0x0000000000000000, "RO", "reserved669", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{24, 26, 0x0000000000000000, "RW", "lpmode_asrtiobufact_dly", "Reserved bits"},
#else
{24, 26, 0x0000000000000000, "RW", "lpmode_asrtiobufact_dly", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{23, 23, 0x0000000000000000, "RO", "reserved670", "Reserved bits"},
#else
{23, 23, 0x0000000000000000, "RO", "reserved670", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{22, 22, 0x0000000000000000, "RW", "lpmode_dqcmddrvenbovrd", "Reserved bits"},
#else
{22, 22, 0x0000000000000000, "RW", "lpmode_dqcmddrvenbovrd", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{21, 21, 0x0000000000000000, "RW", "lpmode_iobufactovrd", "Reserved bits"},
#else
{21, 21, 0x0000000000000000, "RW", "lpmode_iobufactovrd", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{20, 20, 0x0000000000000000, "RW", "lpmode_ref2xclkenovrd", "Reserved bits"},
#else
{20, 20, 0x0000000000000000, "RW", "lpmode_ref2xclkenovrd", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{19, 19, 0x0000000000000000, "RW", "siggrpen_lpmode1ovrd", "Reserved bits"},
#else
{19, 19, 0x0000000000000000, "RW", "siggrpen_lpmode1ovrd", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{18, 18, 0x0000000000000000, "RW", "siggrpen_lpmode2or3ovrd", "Reserved bits"},
#else
{18, 18, 0x0000000000000000, "RW", "siggrpen_lpmode2or3ovrd", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{17, 17, 0x0000000000000000, "RW", "lpmode_wrptrenovrd", "Reserved bits"},
#else
{17, 17, 0x0000000000000000, "RW", "lpmode_wrptrenovrd", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{16, 16, 0x0000000000000000, "RW", "lpmode_ref2xrstbovrd", "Reserved bits"},
#else
{16, 16, 0x0000000000000000, "RW", "lpmode_ref2xrstbovrd", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{8, 15, 0x0000000000000000, "RO", "reserved671", "Reserved bits"},
#else
{8, 15, 0x0000000000000000, "RO", "reserved671", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 7, 0x0000000000000000, "RW", "lpmode_asrtref2xsigpien_dly", "Low Power Mode Delays"},
#else
{0, 7, 0x0000000000000000, "RW", "lpmode_asrtref2xsigpien_dly", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo506[] = {{"lpmodectl1", "", 0x00000108, 14, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields507[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{24, 31, 0x0000000000000000, "RO", "reserved672", "Reserved bits"},
#else
{24, 31, 0x0000000000000000, "RO", "reserved672", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{18, 23, 0x0000000000000000, "RW", "rdcmd2rxdllupdt", "Read command to RXDLL update."},
#else
{18, 23, 0x0000000000000000, "RW", "rdcmd2rxdllupdt", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{12, 17, 0x0000000000000000, "RW", "rxdllupdtlen", "RXDLL update enable."},
#else
{12, 17, 0x0000000000000000, "RW", "rxdllupdtlen", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{6, 11, 0x0000000000000000, "RW", "rdcmd2rdactive", "Read command to active delay."},
#else
{6, 11, 0x0000000000000000, "RW", "rdcmd2rdactive", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 5, 0x0000000000000000, "RW", "rdactivelen", "Read active length."},
#else
{0, 5, 0x0000000000000000, "RW", "rdactivelen", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo507[] = {{"rxdllrdcmdctl0", "", 0x0000010C, 5, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields508[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{1, 31, 0x0000000000000000, "RO", "Reserved", "Reserved"},
#else
{1, 31, 0x0000000000000000, "RO", "Reserved", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 0, 0x0000000000000000, "RW", "dllcomprst_b", "Power-on or software reset0: reset state1: norma operationSet to 1 to enter normal operation."},
#else
{0, 0, 0x0000000000000000, "RW", "dllcomprst_b", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo508[] = {{"dllcomp_reset", "", 0x00000600, 2, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields509[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{1, 31, 0x0000000000000000, "RO", "Reserved", "Reserved"},
#else
{1, 31, 0x0000000000000000, "RO", "Reserved", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 0, 0x0000000000000000, "RW/1S/V", "txdll_init", "Activates initialization training sequence.0: initialization training sequence not active.1: initialization training sequence active.Self clearing after successful initialization training sequence."},
#else
{0, 0, 0x0000000000000000, "RW/1S/V", "txdll_init", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo509[] = {{"dllcomp_init", "", 0x00000604, 2, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields510[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{1, 31, 0x0000000000000000, "RO", "Reserved", "Reserved"},
#else
{1, 31, 0x0000000000000000, "RO", "Reserved", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 0, 0x0000000000000000, "RW", "lpddr_type", "LPDDR speed target. 0: LPDDR3, 1600 MHz. 1: LPDDR4, 3200 MHz."},
#else
{0, 0, 0x0000000000000000, "RW", "lpddr_type", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo510[] = {{"dllcomp_lpddrtype", "", 0x00000608, 2, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields511[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{1, 31, 0x0000000000000000, "RO", "Reserved", "Reserved"},
#else
{1, 31, 0x0000000000000000, "RO", "Reserved", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 0, 0x0000000000000001, "RW", "clkungate", "Internal Clock control. 0 = allow clock gating for low power; 1 = allow free running clock"},
#else
{0, 0, 0x0000000000000001, "RW", "clkungate", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo511[] = {{"dllcomp_clkungate", "", 0x0000060C, 2, 0x00000000FFFFFFFF, 0x0000000000000001}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields512[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{8, 31, 0x0000000000000000, "RO", "Reserved", "Reserved"},
#else
{8, 31, 0x0000000000000000, "RO", "Reserved", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{7, 7, 0x0000000000000000, "RO/V", "txdll_lock_error", "Set when initialization or fine periodic training failed the locking condition. Cleared on a read or writing a 0."},
#else
{7, 7, 0x0000000000000000, "RO/V", "txdll_lock_error", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{6, 6, 0x0000000000000000, "RO/V", "txdll_fine_error", "Set when fine code underflow or overflow occurs. Cleared on a read or writing a 0."},
#else
{6, 6, 0x0000000000000000, "RO/V", "txdll_fine_error", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{5, 5, 0x0000000000000000, "RO/V", "txdll_coarsep_error", "Set when coarse code underflow or overflow occurs. Cleared on a read or writing a 0."},
#else
{5, 5, 0x0000000000000000, "RO/V", "txdll_coarsep_error", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{4, 4, 0x0000000000000000, "RO/V", "txdll_error", "Set when Delay Cell count exceeds maximum value. Cleared on a read or writing a 0."},
#else
{4, 4, 0x0000000000000000, "RO/V", "txdll_error", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{2, 3, 0x0000000000000000, "RO", "Reserved0", "Reserved"},
#else
{2, 3, 0x0000000000000000, "RO", "Reserved0", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{1, 1, 0x0000000000000000, "RO/V", "txdll_lock_flag", "Set when initialization or fine periodic training passed the locking condition. Valid only when scr_lockseq_en is set to 1.Cleared on a read or writing a 0."},
#else
{1, 1, 0x0000000000000000, "RO/V", "txdll_lock_flag", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 0, 0x0000000000000000, "RO/V", "txdll_init_done", "Set when Initialization sequence is successful. Cleared on a read or writing a 0."},
#else
{0, 0, 0x0000000000000000, "RO/V", "txdll_init_done", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo512[] = {{"dllcomp_error_status", "", 0x00000610, 8, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields513[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{21, 31, 0x0000000000000000, "RO", "Reserved", "Reserved"},
#else
{21, 31, 0x0000000000000000, "RO", "Reserved", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{16, 20, 0x0000000000000007, "RO/V", "txdll_stat_fbmuxsel", "Delay Cell count value during normal operation"},
#else
{16, 20, 0x0000000000000007, "RO/V", "txdll_stat_fbmuxsel", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{12, 15, 0x000000000000000F, "RO/V", "txdll_stat_coarseicode", "Coarse code value at initialization training sequence completion."},
#else
{12, 15, 0x000000000000000F, "RO/V", "txdll_stat_coarseicode", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{8, 11, 0x000000000000000F, "RO/V", "txdll_stat_coarsecode", "Coarse code value during normal operation"},
#else
{8, 11, 0x000000000000000F, "RO/V", "txdll_stat_coarsecode", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 7, 0x000000000000007F, "RO/V", "txdll_stat_finecode", "Fine code value during normal operation"},
#else
{0, 7, 0x000000000000007F, "RO/V", "txdll_stat_finecode", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo513[] = {{"dllcomp_code_status", "", 0x00000614, 5, 0x00000000FFFFFFFF, 0x000000000007FF7F}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields514[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{31, 31, 0x0000000000000000, "RW", "lock_seq_en", "Enable lock sequence after initialization or fine periodic training sequence. 0: disable lock sequence. 1: enable lock sequence."},
#else
{31, 31, 0x0000000000000000, "RW", "lock_seq_en", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{30, 30, 0x0000000000000000, "RW", "lockerror_ignore", "Ignore lock error. Valid when scr_lockseq_en = 1. 0: Exit and wait for initialization training sequence. 1: ignore lock error and proceed to normal operation."},
#else
{30, 30, 0x0000000000000000, "RW", "lockerror_ignore", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{4, 29, 0x0000000000000000, "RO", "Reserved", "Reserved"},
#else
{4, 29, 0x0000000000000000, "RO", "Reserved", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 3, 0x0000000000000003, "RW", "lockcount_size", "Maximum samples to count for lock condition. The counter decrements until the value reaches 0 yielding scr_lockcount_size + 1 samples."},
#else
{0, 3, 0x0000000000000003, "RW", "lockcount_size", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo514[] = {{"dllcomp_lockctl", "", 0x00000618, 4, 0x00000000FFFFFFFF, 0x0000000000000003}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields515[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{31, 31, 0x0000000000000000, "RW", "muxcode_ovr_sel", "Override txdll_fbmuxsel[4:0] with scr_muxcode_ovr[4:0].0: disable override.1: enable override."},
#else
{31, 31, 0x0000000000000000, "RW", "muxcode_ovr_sel", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{21, 30, 0x0000000000000000, "RO", "Reserved", "Reserved"},
#else
{21, 30, 0x0000000000000000, "RO", "Reserved", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{16, 20, 0x000000000000000F, "RW", "muxcode_ovr", "Delay cell fbmuxsel override value."},
#else
{16, 20, 0x000000000000000F, "RW", "muxcode_ovr", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{13, 15, 0x0000000000000000, "RO", "Reserved0", "Reserved"},
#else
{13, 15, 0x0000000000000000, "RO", "Reserved0", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{8, 12, 0x000000000000001B, "RW", "muxcode_max", "Delay cell maximum count value. Used in overflow check"},
#else
{8, 12, 0x000000000000001B, "RW", "muxcode_max", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{5, 7, 0x0000000000000000, "RO", "Reserved1", "Reserved"},
#else
{5, 7, 0x0000000000000000, "RO", "Reserved1", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 4, 0x0000000000000009, "RW", "muxcode_min", "Delay cell minimum count value. Default start code."},
#else
{0, 4, 0x0000000000000009, "RW", "muxcode_min", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo515[] = {{"dllcomp_fbmuxsel", "", 0x0000061C, 7, 0x00000000FFFFFFFF, 0x00000000000F1B09}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields516[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{31, 31, 0x0000000000000000, "RW", "coarsecode_ovr_sel", "Override txdll_coarsecode[3:0] with scr_coarsecode_ovr[3:0]. 0: disable override, 1: enable override"},
#else
{31, 31, 0x0000000000000000, "RW", "coarsecode_ovr_sel", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{30, 30, 0x0000000000000000, "RW", "coarseicode_ovr_sel", "Override txdll_coarseicode[3:0] with scr_coarseicode_ovr[3:0]. 0: disable override, 1: enable override"},
#else
{30, 30, 0x0000000000000000, "RW", "coarseicode_ovr_sel", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{28, 29, 0x0000000000000000, "RO", "Reserved", "Reserved"},
#else
{28, 29, 0x0000000000000000, "RO", "Reserved", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{24, 27, 0x0000000000000002, "RW", "coarseicode_ovr", "Coarsei code override value."},
#else
{24, 27, 0x0000000000000002, "RW", "coarseicode_ovr", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{20, 23, 0x0000000000000000, "RO", "Reserved0", "Reserved"},
#else
{20, 23, 0x0000000000000000, "RO", "Reserved0", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{16, 19, 0x0000000000000002, "RW", "coarsecode_ovr", "Coarse code override value."},
#else
{16, 19, 0x0000000000000002, "RW", "coarsecode_ovr", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{12, 15, 0x0000000000000000, "RO", "Reserved1", "Reserved"},
#else
{12, 15, 0x0000000000000000, "RO", "Reserved1", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{8, 11, 0x000000000000000F, "RW", "coarsecode_max", "Coarse code maximum count value. Default start value. Used in overflow check"},
#else
{8, 11, 0x000000000000000F, "RW", "coarsecode_max", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{4, 7, 0x0000000000000000, "RO", "Reserved2", "Reserved"},
#else
{4, 7, 0x0000000000000000, "RO", "Reserved2", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 3, 0x0000000000000002, "RW", "coarsecode_min", "Coarse code minimum count value. Used in underflow check."},
#else
{0, 3, 0x0000000000000002, "RW", "coarsecode_min", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo516[] = {{"dllcomp_coarsecode", "", 0x00000620, 10, 0x00000000FFFFFFFF, 0x0000000002020F02}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields517[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{24, 31, 0x00000000000000CF, "RW", "finecodemax_limit", "Fine code limit - maximum value. Defines fine code drift allowed towards finecode maximum value before incrementing the coarse code for binary search training."},
#else
{24, 31, 0x00000000000000CF, "RW", "finecodemax_limit", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{16, 23, 0x0000000000000034, "RW", "finecodemin_limit", "Fine code limit - minimum value. Defines fine code drift allowed towards finecode minimum value before decrementing the coarse code for binary search training."},
#else
{16, 23, 0x0000000000000034, "RW", "finecodemin_limit", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{8, 15, 0x00000000000000FF, "RW", "finecode_max", "Fine code maximum value. Used in overflow check during fine continuous or fine periodic"},
#else
{8, 15, 0x00000000000000FF, "RW", "finecode_max", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 7, 0x0000000000000020, "RW", "finecode_min", "Underflow check during fine continuous or fine periodic training."},
#else
{0, 7, 0x0000000000000020, "RW", "finecode_min", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo517[] = {{"dllcomp_finecode", "", 0x00000624, 4, 0x00000000FFFFFFFF, 0x00000000CF34FF20}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields518[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{8, 31, 0x0000000000000000, "RO", "Reserved", "Reserved"},
#else
{8, 31, 0x0000000000000000, "RO", "Reserved", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 7, 0x00000000000000E8, "RW", "finecode_muxsel", "Two bit field selects one of 4 possible finecode values for each 8:1 mux input. Two bit field shared between -/+ index values (ex. -gf / +gf)"},
#else
{0, 7, 0x00000000000000E8, "RW", "finecode_muxsel", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo518[] = {{"dllcomp_finemuxsel", "", 0x00000628, 2, 0x00000000FFFFFFFF, 0x00000000000000E8}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields519[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{31, 31, 0x0000000000000000, "RW", "finec_mode", "Fine continuous training enable after initialization training. 0: Fine continuous training disable. 1: Fine continuous training enable (default). When both finec_mode and finep_mode are set to 1, dllcomp functionality is unpredictable."},
#else
{31, 31, 0x0000000000000000, "RW", "finec_mode", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{30, 30, 0x0000000000000000, "RW", "finep_mode", "Fine priodic training enable after initialization training. 0: Fine periodic disable (default). 1: Fine periodic enable. When both finec_mode and finep_mode are set to 1, dllcomp functionality is unpredictable."},
#else
{30, 30, 0x0000000000000000, "RW", "finep_mode", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{29, 29, 0x0000000000000000, "RW", "searchalgo_long", "Propriety search algorithm version to apply during lock, fine continuous and fine periodic training. 0: Apply short version. 1: Apply long version."},
#else
{29, 29, 0x0000000000000000, "RW", "searchalgo_long", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{8, 28, 0x0000000000000000, "RO", "Reserved", "Reserved"},
#else
{8, 28, 0x0000000000000000, "RO", "Reserved", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 7, 0x000000000000007F, "RW", "finecode_start", "Fine code start value to apply during binary search training"},
#else
{0, 7, 0x000000000000007F, "RW", "finecode_start", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo519[] = {{"dllcomp_finectl", "", 0x0000062C, 5, 0x00000000FFFFFFFF, 0x000000000000007F}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields520[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{31, 31, 0x0000000000000000, "RW", "finecode_ovr_sel", "Fine code override select. 0: Apply computed fine code (default). 1: Apply scr_finecode_ovr[7:0] ."},
#else
{31, 31, 0x0000000000000000, "RW", "finecode_ovr_sel", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{30, 30, 0x0000000000000000, "RW", "finecode_updateovr_ovr", "When scr_finecode_ovr_sel is active high, this bit drives txdll_dllupdateovr"},
#else
{30, 30, 0x0000000000000000, "RW", "finecode_updateovr_ovr", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{8, 29, 0x0000000000000000, "RO", "Reserved", "Reserved"},
#else
{8, 29, 0x0000000000000000, "RO", "Reserved", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 7, 0x0000000000000013, "RW", "finecode_ovr", "Fine code to override with when scr_finecode_ovr_sel = 1"},
#else
{0, 7, 0x0000000000000013, "RW", "finecode_ovr", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo520[] = {{"dllcomp_finecodeovr", "", 0x00000630, 4, 0x00000000FFFFFFFF, 0x0000000000000013}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields521[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{16, 31, 0x0000000000000000, "RO", "Reserved", "Reserved"},
#else
{16, 31, 0x0000000000000000, "RO", "Reserved", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 15, 0x0000000000003FFF, "RW", "finepwait_interval", "Fine periodic interval timer start value. Defines the interval between back to back fine periodic training sequences."},
#else
{0, 15, 0x0000000000003FFF, "RW", "finepwait_interval", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo521[] = {{"dllcomp_fptimer", "", 0x00000634, 2, 0x00000000FFFFFFFF, 0x0000000000003FFF}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields522[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{13, 31, 0x0000000000000000, "RO", "Reserved", "Reserved"},
#else
{13, 31, 0x0000000000000000, "RO", "Reserved", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{8, 12, 0x0000000000000006, "RW", "samplewait_max", "Wait interval between code update and sample ready. Applied during lock, fine continuous and fine"},
#else
{8, 12, 0x0000000000000006, "RW", "samplewait_max", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{5, 7, 0x0000000000000000, "RO", "Reserved0", "Reserved"},
#else
{5, 7, 0x0000000000000000, "RO", "Reserved0", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 4, 0x0000000000000002, "RW", "samplewait_min", "Wait interval between code update and sample ready. Applied during coarse initialization and fine"},
#else
{0, 4, 0x0000000000000002, "RW", "samplewait_min", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo522[] = {{"dllcomp_samplewait", "", 0x00000638, 4, 0x00000000FFFFFFFF, 0x0000000000000602}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields523[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{31, 31, 0x0000000000000000, "RW", "rxdll_coarsecode_ovr_sel", "Override rxdll_coarsecode[3:0] with scr_rxdll_coarsecode_ovr[3:0] . 0: disable override. 1: enable override."},
#else
{31, 31, 0x0000000000000000, "RW", "rxdll_coarsecode_ovr_sel", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{4, 30, 0x0000000000000000, "RO", "Reserved", "Reserved"},
#else
{4, 30, 0x0000000000000000, "RO", "Reserved", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 3, 0x0000000000000002, "RW", "rxdll_coarsecode_ovr", "Coarse code override value for rxdll_coarsecode[3:0]"},
#else
{0, 3, 0x0000000000000002, "RW", "rxdll_coarsecode_ovr", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo523[] = {{"dllcomp_rxcoarseovr", "", 0x0000063C, 3, 0x00000000FFFFFFFF, 0x0000000000000002}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields524[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{31, 31, 0x0000000000000000, "RW", "rxdll_finecode_ovr_sel", "Override rxdll_finecode[7:0] with scr_rxdll_finecode_ovr[7:0] . 0: disable override. 1: enable override."},
#else
{31, 31, 0x0000000000000000, "RW", "rxdll_finecode_ovr_sel", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{30, 30, 0x0000000000000000, "RW", "rxdll_finecode_updateovr_ovr", "When scr_rxdll_finecode_ovr_sel is active high, this bit drives rxdll_rxdqsdllupdateovr"},
#else
{30, 30, 0x0000000000000000, "RW", "rxdll_finecode_updateovr_ovr", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{8, 29, 0x0000000000000000, "RO", "Reserved", "Reserved"},
#else
{8, 29, 0x0000000000000000, "RO", "Reserved", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 7, 0x0000000000000013, "RW", "rxdll_finecode_ovr", "FIne code override value for rxdll_finecode[7:0]"},
#else
{0, 7, 0x0000000000000013, "RW", "rxdll_finecode_ovr", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo524[] = {{"dllcomp_rxfineovr", "", 0x00000640, 4, 0x00000000FFFFFFFF, 0x0000000000000013}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields525[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{17, 31, 0x0000000000000000, "RO", "reserved673", "Reserved"},
#else
{17, 31, 0x0000000000000000, "RO", "reserved673", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{16, 16, 0x0000000000000000, "RW", "dfxlowervisaulm0_bypass", "VISA Lower Level Bypass ULM0"},
#else
{16, 16, 0x0000000000000000, "RW", "dfxlowervisaulm0_bypass", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{8, 15, 0x0000000000000000, "RW", "dfxlowervisaulm0_clksel", "VISA Lower Level ULM0 CLK Select"},
#else
{8, 15, 0x0000000000000000, "RW", "dfxlowervisaulm0_clksel", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 7, 0x0000000000000000, "RW", "dfxlowervisaulm0_datasel", "VISA Lower Level ULM0 Lane (DATA) Select"},
#else
{0, 7, 0x0000000000000000, "RW", "dfxlowervisaulm0_datasel", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo525[] = {{"lower_dfxvisaulm0", "", 0x00000700, 4, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields526[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{17, 31, 0x0000000000000000, "RO", "reserved674", "Reserved"},
#else
{17, 31, 0x0000000000000000, "RO", "reserved674", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{16, 16, 0x0000000000000000, "RW", "dfxlowervisaulm1_bypass", "VISA Lower Level Bypass ULM1"},
#else
{16, 16, 0x0000000000000000, "RW", "dfxlowervisaulm1_bypass", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{8, 15, 0x0000000000000000, "RW", "dfxlowervisaulm1_clksel", "VISA Lower Level ULM1 CLK Select"},
#else
{8, 15, 0x0000000000000000, "RW", "dfxlowervisaulm1_clksel", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 7, 0x0000000000000000, "RW", "dfxlowervisaulm1_datasel", "VISA Lower Level ULM1 Lane (DATA) Select"},
#else
{0, 7, 0x0000000000000000, "RW", "dfxlowervisaulm1_datasel", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo526[] = {{"lower_dfxvisaulm1", "", 0x00000704, 4, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields527[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{7, 31, 0x0000000000000000, "RO", "reserved675", "Reserved"},
#else
{7, 31, 0x0000000000000000, "RO", "reserved675", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{4, 6, 0x0000000000000000, "RW", "dfxlowervisapattgen_msb", "VISA Lower Level ULM Pattern Generation"},
#else
{4, 6, 0x0000000000000000, "RW", "dfxlowervisapattgen_msb", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 3, 0x0000000000000000, "RW", "dfxlowervisapattgen_lsb", "VISA Lower Level ULM Pattern Generation"},
#else
{0, 3, 0x0000000000000000, "RW", "dfxlowervisapattgen_lsb", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo527[] = {{"lower_dfxvisapattgen", "", 0x00000708, 3, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields528[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{17, 31, 0x0000000000000000, "RO", "reserved676", "Reserved"},
#else
{17, 31, 0x0000000000000000, "RO", "reserved676", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{16, 16, 0x0000000000000000, "RW", "dfxtopvisaulm0_bypass", "VISA Top Level Bypass ULM0"},
#else
{16, 16, 0x0000000000000000, "RW", "dfxtopvisaulm0_bypass", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{8, 15, 0x0000000000000000, "RW", "dfxtopvisaulm0_clksel", "VISA Top Level ULM0 CLK Select"},
#else
{8, 15, 0x0000000000000000, "RW", "dfxtopvisaulm0_clksel", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 7, 0x0000000000000000, "RW", "dfxtopvisaulm0_datasel", "VISA Top Level ULM0 Lane (DATA) Select"},
#else
{0, 7, 0x0000000000000000, "RW", "dfxtopvisaulm0_datasel", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo528[] = {{"top_dfxvisaulm0", "", 0x0000070C, 4, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields529[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{17, 31, 0x0000000000000000, "RO", "reserved677", "Reserved"},
#else
{17, 31, 0x0000000000000000, "RO", "reserved677", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{16, 16, 0x0000000000000000, "RW", "dfxtopvisaulm1_bypass", "VISA Top Level Bypass ULM1"},
#else
{16, 16, 0x0000000000000000, "RW", "dfxtopvisaulm1_bypass", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{8, 15, 0x0000000000000000, "RW", "dfxtopvisaulm1_clksel", "VISA Top Level ULM1 CLK Select"},
#else
{8, 15, 0x0000000000000000, "RW", "dfxtopvisaulm1_clksel", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 7, 0x0000000000000000, "RW", "dfxtopvisaulm1_datasel", "VISA Top Level ULM1 Lane (DATA) Select"},
#else
{0, 7, 0x0000000000000000, "RW", "dfxtopvisaulm1_datasel", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo529[] = {{"top_dfxvisaulm1", "", 0x00000710, 4, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields530[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{7, 31, 0x0000000000000000, "RO", "reserved678", "Reserved"},
#else
{7, 31, 0x0000000000000000, "RO", "reserved678", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{4, 6, 0x0000000000000000, "RW", "dfxtopvisapattgen_msb", "VISA Top Level ULM Pattern Generation"},
#else
{4, 6, 0x0000000000000000, "RW", "dfxtopvisapattgen_msb", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 3, 0x0000000000000000, "RW", "dfxtopvisapattgen_lsb", "VISA Top Level ULM Pattern Generation"},
#else
{0, 3, 0x0000000000000000, "RW", "dfxtopvisapattgen_lsb", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo530[] = {{"top_dfxvisapattgen", "", 0x00000714, 3, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields531[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{22, 31, 0x0000000000000000, "RO", "reserved679", "Reserved bits"},
#else
{22, 31, 0x0000000000000000, "RO", "reserved679", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{21, 21, 0x0000000000000000, "RW", "bl_dfxmrgtxovren", "DQ Bytelane Tx FIFO Margin Mode config override enable for Tx data path and Latch enables via  DFXMRGTXFIFO[24:0]    1'b1  - Enable TxFIFO DFx overrides on Latch enables and TxData  1'b0 - Functional Mode of operation"},
#else
{21, 21, 0x0000000000000000, "RW", "bl_dfxmrgtxovren", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{20, 20, 0x0000000000000000, "RW", "bl_dfxmrgtxwren", "DQ Bytelane TxFIFO Margin Mode Latch enable override value used to make TxFIFO latches transparent allowing the loading of all TxFIFO Latches with data programmed in DFXMRGTXFIFO[23:0], if dfxmrgtxovren is asserted(1'b1)  1'b1 - All DQ/DM/DQS Tx FIFO Latches Transparent  0'b0 - All DQ/DM/DQS TxFIFO Latches CLosed"},
#else
{20, 20, 0x0000000000000000, "RW", "bl_dfxmrgtxwren", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{18, 19, 0x0000000000000000, "RW", "bl_dfxmrgtxdqsrise", "DQ Bytelane Tx FIFO Margin Mode DQS/B Rise Tx SubFIFO data load value. The value loaded will apply to all DQ Bytelane DQS/B Rise SubFIFOs. Recommended setting for HVM = 2'b00"},
#else
{18, 19, 0x0000000000000000, "RW", "bl_dfxmrgtxdqsrise", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{16, 17, 0x0000000000000000, "RW", "bl_dfxmrgtxdqsfall", "DQ Bytelane Tx FIFO Margin Mode DQS/B Fall Tx SubFIFO data load value. The value loaded will apply to all DQ Bytelane DQS/B Fall SubFIFOs. Recommended setting for HVM = 2'b00"},
#else
{16, 17, 0x0000000000000000, "RW", "bl_dfxmrgtxdqsfall", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{14, 15, 0x0000000000000000, "RW", "bl_dfxmrgtxdrise_ph0", "DQ Bytelane Tx FIFO Margin Mode DQ Phase0 Rise Tx SubFIFO load value. The value loaded will apply to all DQ BL Phase 0 Rise SubFIFOs  There isnt a valid or invalid value for this field, recommended setting for HVM = 2'b00"},
#else
{14, 15, 0x0000000000000000, "RW", "bl_dfxmrgtxdrise_ph0", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{12, 13, 0x0000000000000000, "RW", "bl_dfxmrgtxdrise_ph1", "DQ Bytelane Tx FIFO Margin Mode DQ Phase1 Rise Tx SubFIFO load value. The value loaded will apply to all DQ BL Phase 1 Rise SubFIFOs  There isnt a valid or invalid value for this field, recommended setting for HVM = 2'b00"},
#else
{12, 13, 0x0000000000000000, "RW", "bl_dfxmrgtxdrise_ph1", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{10, 11, 0x0000000000000000, "RW", "bl_dfxmrgtxdrise_ph2", "DQ Bytelane Tx FIFO Margin Mode DQ Phase0 Rise Tx SubFIFO load value. The value loaded will apply to all DQ BL Phase 2 Rise SubFIFOs  There isnt a valid or invalid value for this field, recommended setting for HVM = 2'b00"},
#else
{10, 11, 0x0000000000000000, "RW", "bl_dfxmrgtxdrise_ph2", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{8, 9, 0x0000000000000000, "RW", "bl_dfxmrgtxdrise_ph3", "DQ Bytelane Tx FIFO Margin Mode DQ Phase1 Rise Tx SubFIFO load value. The value loaded will apply to all DQ BL Phase 3 Rise SubFIFOs  There isnt a valid or invalid value for this field, recommended setting for HVM = 2'b00"},
#else
{8, 9, 0x0000000000000000, "RW", "bl_dfxmrgtxdrise_ph3", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{6, 7, 0x0000000000000000, "RW", "bl_dfxmrgtxdfall_ph0", "DQ Bytelane Tx FIFO Margin Mode DQ Phase0 Fall Tx SubFIFO load value. The value loaded will apply to all DQ BL Phase 0 Fall SubFIFOs  There isnt a valid or invalid value for this field, recommended setting for HVM = 2'b00"},
#else
{6, 7, 0x0000000000000000, "RW", "bl_dfxmrgtxdfall_ph0", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{4, 5, 0x0000000000000000, "RW", "bl_dfxmrgtxdfall_ph1", "DQ Bytelane Tx FIFO Margin Mode DQ Phase1 Fall Tx SubFIFO load value. The value loaded will apply to all DQ BL Phase 1 Fall SubFIFOs  There isnt a valid or invalid value for this field, recommended setting for HVM = 2'b00"},
#else
{4, 5, 0x0000000000000000, "RW", "bl_dfxmrgtxdfall_ph1", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{2, 3, 0x0000000000000000, "RW", "bl_dfxmrgtxdfall_ph2", "DQ Bytelane Tx FIFO Margin Mode DQ Phase2 Fall Tx SubFIFO load value. The value loaded will apply to all DQ BL Phase 2 Fall SubFIFOs  There isnt a valid or invalid value for this field, recommended setting for HVM = 2'b00"},
#else
{2, 3, 0x0000000000000000, "RW", "bl_dfxmrgtxdfall_ph2", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 1, 0x0000000000000000, "RW", "bl_dfxmrgtxdfall_ph3", "DQ Bytelane Tx FIFO Margin Mode DQ Phase3 Fall Tx SubFIFO load value. The value loaded will apply to all DQ BL Phase 3 Rise SubFIFOs  There isnt a valid or invalid value for this field, recommended setting for HVM = 2'b00"},
#else
{0, 1, 0x0000000000000000, "RW", "bl_dfxmrgtxdfall_ph3", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo531[] = {{"dfxmrg_bl", "", 0x00000718, 13, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields532[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{30, 31, 0x0000000000000000, "RO", "reserved680", "Reserved bits"},
#else
{30, 31, 0x0000000000000000, "RO", "reserved680", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{29, 29, 0x0000000000000000, "RW", "cc_dfxmrgtxovren", "DQCCC Bytelane Tx FIFO Margin Mode config override enable for Tx data path and Latch enables via  DFXMRGTXFIFO[24:0]    1'b1  - Enable TxFIFO DFx overrides on Latch enables and TxData  1'b0 - Functional Mode of operation"},
#else
{29, 29, 0x0000000000000000, "RW", "cc_dfxmrgtxovren", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{28, 28, 0x0000000000000000, "RW", "cc_dfxmrgtxwren", "DQCCC Bytelane TxFIFO Margin Mode Latch enable override value used to make TxFIFO latches transparent allowing the loading of all TxFIFO Latches with data programmed in DFXMRGTXFIFO[23:0], if dfxmrgtxovren is asserted(1'b1)  1'b1 - All DQCCC/DM/DQCCCS Tx FIFO Latches Transparent  0'b0 - All DQCCC/DM/DQCCCS TxFIFO Latches CLosed"},
#else
{28, 28, 0x0000000000000000, "RW", "cc_dfxmrgtxwren", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{26, 27, 0x0000000000000000, "RW", "cc_dfxmrgtxdqsrise", "DQCCC Bytelane Tx FIFO Margin Mode DQCCCS/B Rise Tx SubFIFO data load value. The value loaded will apply to all DQCCC Bytelane DQCCCS/B Rise SubFIFOs. Recommended setting for HVM = 2'b00"},
#else
{26, 27, 0x0000000000000000, "RW", "cc_dfxmrgtxdqsrise", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{24, 25, 0x0000000000000000, "RW", "cc_dfxmrgtxdqsfall", "DQCCC Bytelane Tx FIFO Margin Mode DQCCCS/B Fall Tx SubFIFO data load value. The value loaded will apply to all DQCCC Bytelane DQCCCS/B Fall SubFIFOs. Recommended setting for HVM = 2'b00"},
#else
{24, 25, 0x0000000000000000, "RW", "cc_dfxmrgtxdqsfall", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{22, 23, 0x0000000000000000, "RW", "cc_dfxmrgtxdrise_ph0", "DQCCC Bytelane Tx FIFO Margin Mode DQCCC Phase0 Rise Tx SubFIFO load value. The value loaded will apply to all DQCCC BL Phase 0 Rise SubFIFOs  There isnt a valid or invalid value for this field, recommended setting for HVM = 2'b00"},
#else
{22, 23, 0x0000000000000000, "RW", "cc_dfxmrgtxdrise_ph0", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{20, 21, 0x0000000000000000, "RW", "cc_dfxmrgtxdrise_ph1", "DQCCC Bytelane Tx FIFO Margin Mode DQCCC Phase1 Rise Tx SubFIFO load value. The value loaded will apply to all DQCCC BL Phase 1 Rise SubFIFOs  There isnt a valid or invalid value for this field, recommended setting for HVM = 2'b00"},
#else
{20, 21, 0x0000000000000000, "RW", "cc_dfxmrgtxdrise_ph1", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{18, 19, 0x0000000000000000, "RW", "cc_dfxmrgtxdrise_ph2", "DQCCC Bytelane Tx FIFO Margin Mode DQCCC Phase0 Rise Tx SubFIFO load value. The value loaded will apply to all DQCCC BL Phase 2 Rise SubFIFOs  There isnt a valid or invalid value for this field, recommended setting for HVM = 2'b00"},
#else
{18, 19, 0x0000000000000000, "RW", "cc_dfxmrgtxdrise_ph2", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{16, 17, 0x0000000000000000, "RW", "cc_dfxmrgtxdrise_ph3", "DQCCC Bytelane Tx FIFO Margin Mode DQCCC Phase1 Rise Tx SubFIFO load value. The value loaded will apply to all DQCCC BL Phase 3 Rise SubFIFOs  There isnt a valid or invalid value for this field, recommended setting for HVM = 2'b00"},
#else
{16, 17, 0x0000000000000000, "RW", "cc_dfxmrgtxdrise_ph3", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{14, 15, 0x0000000000000000, "RW", "cc_dfxmrgtxdfall_ph0", "DQCCC Bytelane Tx FIFO Margin Mode DQCCC Phase0 Fall Tx SubFIFO load value. The value loaded will apply to all DQCCC BL Phase 0 Fall SubFIFOs  There isnt a valid or invalid value for this field, recommended setting for HVM = 2'b00"},
#else
{14, 15, 0x0000000000000000, "RW", "cc_dfxmrgtxdfall_ph0", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{12, 13, 0x0000000000000000, "RW", "cc_dfxmrgtxdfall_ph1", "DQCCC Bytelane Tx FIFO Margin Mode DQCCC Phase1 Fall Tx SubFIFO load value. The value loaded will apply to all DQCCC BL Phase 1 Fall SubFIFOs  There isnt a valid or invalid value for this field, recommended setting for HVM = 2'b00"},
#else
{12, 13, 0x0000000000000000, "RW", "cc_dfxmrgtxdfall_ph1", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{10, 11, 0x0000000000000000, "RW", "cc_dfxmrgtxdfall_ph2", "DQCCC Bytelane Tx FIFO Margin Mode DQCCC Phase2 Fall Tx SubFIFO load value. The value loaded will apply to all DQCCC BL Phase 2 Fall SubFIFOs  There isnt a valid or invalid value for this field, recommended setting for HVM = 2'b00"},
#else
{10, 11, 0x0000000000000000, "RW", "cc_dfxmrgtxdfall_ph2", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{8, 9, 0x0000000000000000, "RW", "cc_dfxmrgtxdfall_ph3", "DQCCC Bytelane Tx FIFO Margin Mode DQCCC Phase3 Fall Tx SubFIFO load value. The value loaded will apply to all DQCCC BL Phase 3 Rise SubFIFOs  There isnt a valid or invalid value for this field, recommended setting for HVM = 2'b00"},
#else
{8, 9, 0x0000000000000000, "RW", "cc_dfxmrgtxdfall_ph3", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{6, 7, 0x0000000000000000, "RW", "cc_dfxmrgtxdsdr_ph0", "DQCCC Bytelane Tx FIFO Margin Mode DQCCC Phase0 SDR Tx SubFIFO load value. The value loaded will apply to all DQCCC BL Phase 0 SDR SubFIFOs  There isnt a valid or invalid value for this field, recommended setting for HVM = 2'b00"},
#else
{6, 7, 0x0000000000000000, "RW", "cc_dfxmrgtxdsdr_ph0", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{4, 5, 0x0000000000000000, "RW", "cc_dfxmrgtxdsdr_ph1", "DQCCC Bytelane Tx FIFO Margin Mode DQCCC Phase1 SDR Tx SubFIFO load value. The value loaded will apply to all DQCCC BL Phase 1 SDR SubFIFOs  There isnt a valid or invalid value for this field, recommended setting for HVM = 2'b00"},
#else
{4, 5, 0x0000000000000000, "RW", "cc_dfxmrgtxdsdr_ph1", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{2, 3, 0x0000000000000000, "RW", "cc_dfxmrgtxdsdr_ph2", "DQCCC Bytelane Tx FIFO Margin Mode DQCCC Phase2 SDR Tx SubFIFO load value. The value loaded will apply to all DQCCC BL Phase 2 SDR SubFIFOs  There isnt a valid or invalid value for this field, recommended setting for HVM = 2'b11"},
#else
{2, 3, 0x0000000000000000, "RW", "cc_dfxmrgtxdsdr_ph2", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 1, 0x0000000000000000, "RW", "cc_dfxmrgtxdsdr_ph3", "DQCCC Bytelane Tx FIFO Margin Mode DQCCC Phase3 SDR Tx SubFIFO load value. The value loaded will apply to all DQCCC BL Phase 3 Rise SubFIFOs  There isnt a valid or invalid value for this field, recommended setting for HVM = 2'b00"},
#else
{0, 1, 0x0000000000000000, "RW", "cc_dfxmrgtxdsdr_ph3", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo532[] = {{"dfxmrg_cc", "", 0x0000071C, 17, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields533[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{8, 31, 0x0000000000000000, "RO", "reserved681", "Reserved bits"},
#else
{8, 31, 0x0000000000000000, "RO", "reserved681", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 7, 0x0000000000000000, "RW", "bl_dfxmrgrx_cmpval", "DFx Margin Mode DQ Bytelane Rx Compare value; Used to compare Actual RxFIFO value vs Expected Rx FIFO value(TxFIFO Unloaded)"},
#else
{0, 7, 0x0000000000000000, "RW", "bl_dfxmrgrx_cmpval", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo533[] = {{"dfxmrg_blrx", "", 0x00000720, 2, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields534[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{25, 31, 0x0000000000000000, "RO", "reserved682", "Reserved bits"},
#else
{25, 31, 0x0000000000000000, "RO", "reserved682", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{16, 24, 0x0000000000000000, "RW", "cc_dfxmrgrx_sdrsel", "DFx Margin Mode SDR vs DDR Rx Compare Values"},
#else
{16, 24, 0x0000000000000000, "RW", "cc_dfxmrgrx_sdrsel", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{8, 15, 0x0000000000000000, "RW", "cc_dfxmrgrx_ddrcmpval", "DFx Margin Mode CCC Bytelane Rx Compare value for DDR pins; Used to compare Actual RxFIFO value vs Expected Rx FIFO value(TxFIFO Unloaded)"},
#else
{8, 15, 0x0000000000000000, "RW", "cc_dfxmrgrx_ddrcmpval", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 7, 0x0000000000000000, "RW", "cc_dfxmrgrx_sdrcmpval", "DFx Margin Mode CCC Bytelane Rx Compare value for SDR pins; Used to compare Actual RxFIFO value vs Expected Rx FIFO value(TxFIFO Unloaded)"},
#else
{0, 7, 0x0000000000000000, "RW", "cc_dfxmrgrx_sdrcmpval", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo534[] = {{"dfxmrg_ccrx", "", 0x00000724, 4, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields535[] = {
#ifdef MEM_SV_HOOKS
#if DUMP_REGISTER_DESCRIPTIONS
{30, 31, 0x0000000000000000, "RO", "reserved572", "Reserved bits"},
#else
{30, 31, 0x0000000000000000, "RO", "reserved572", NULL},
#endif
#else
#if DUMP_REGISTER_DESCRIPTIONS
{30, 31, 0x00000000, "RO", "Reserved", "Reserved"},
#else
{30, 31, 0x00000000, "RO", "Reserved",  NULL},
#endif
#endif // MEM_SV_HOOKS
#ifdef MEM_SV_HOOKS
#if DUMP_REGISTER_DESCRIPTIONS
{28, 29, 0x0000000000000000, "RO", "reserved573", "Reserved bits"},
#else
{28, 29, 0x0000000000000000, "RO", "reserved573", NULL},
#endif
#else
#if DUMP_REGISTER_DESCRIPTIONS
{28, 29, 0x00000000, "RO", "Reserved", "Reserved"},
#else
{28, 29, 0x00000000, "RO", "Reserved",  NULL},
#endif
#endif // MEM_SV_HOOKS
#ifdef MEM_SV_HOOKS
#if DUMP_REGISTER_DESCRIPTIONS
{24, 27, 0x0000000000000000, "RO", "reserved574", "Reserved bits"},
#else
{24, 27, 0x0000000000000000, "RO", "reserved574", NULL},
#endif
#else
#if DUMP_REGISTER_DESCRIPTIONS
{24, 27, 0x00000000, "RO", "Reserved", "Reserved"},
#else
{24, 27, 0x00000000, "RO", "Reserved",  NULL},
#endif
#endif // MEM_SV_HOOKS
#ifdef MEM_SV_HOOKS
#if DUMP_REGISTER_DESCRIPTIONS
{16, 23, 0x0000000000000000, "RO", "reserved575", "Reserved bits"},
#else
{16, 23, 0x0000000000000000, "RO", "reserved575", NULL},
#endif
#else
#if DUMP_REGISTER_DESCRIPTIONS
{16, 23, 0x00000000, "RO", "Reserved", "Reserved"},
#else
{16, 23, 0x00000000, "RO", "Reserved",  NULL},
#endif
#endif // MEM_SV_HOOKS
#ifdef MEM_SV_HOOKS
#if DUMP_REGISTER_DESCRIPTIONS
{14, 15, 0x0000000000000000, "RO", "reserved576", "Reserved bits"},
#else
{14, 15, 0x0000000000000000, "RO", "reserved576", NULL},
#endif
#else
#if DUMP_REGISTER_DESCRIPTIONS
{14, 15, 0x00000000, "RO", "Reserved", "Reserved"},
#else
{14, 15, 0x00000000, "RO", "Reserved",  NULL},
#endif
#endif // MEM_SV_HOOKS
#if DUMP_REGISTER_DESCRIPTIONS
{12, 13, 0x0000000000000000, "RW", "txdll_rk0siggrp03dbsel", "Deadband select for sig group 3 rank 0"},
#else
{12, 13, 0x0000000000000000, "RW", "txdll_rk0siggrp03dbsel", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{8, 11, 0x0000000000000000, "RW", "txdll_rk0siggrp03rdptroffset", "Read pointer offset for sig group 3 rank 0"},
#else
{8, 11, 0x0000000000000000, "RW", "txdll_rk0siggrp03rdptroffset", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 7, 0x0000000000000000, "RW", "txdll_rk0siggrp03picode", "PI code for sig group 3 rank 0"},
#else
{0, 7, 0x0000000000000000, "RW", "txdll_rk0siggrp03picode", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo535[] = {{"txdllsiggrp3ctla", "", 0x00000870, 8, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields536[] = {
#ifdef MEM_SV_HOOKS
#if DUMP_REGISTER_DESCRIPTIONS
{30, 31, 0x0000000000000000, "RO", "reserved562", "Reserved bits"},
#else
{30, 31, 0x0000000000000000, "RO", "reserved562", NULL},
#endif
#else
#if DUMP_REGISTER_DESCRIPTIONS
{30, 31, 0x00000000, "RO", "Reserved", "Reserved"},
#else
{30, 31, 0x00000000, "RO", "Reserved",  NULL},
#endif
#endif // MEM_SV_HOOKS
#ifdef MEM_SV_HOOKS
#if DUMP_REGISTER_DESCRIPTIONS
{28, 29, 0x0000000000000000, "RO", "reserved563", "Reserved bits"},
#else
{28, 29, 0x0000000000000000, "RO", "reserved563", NULL},
#endif
#else
#if DUMP_REGISTER_DESCRIPTIONS
{28, 29, 0x00000000, "RO", "Reserved", "Reserved"},
#else
{28, 29, 0x00000000, "RO", "Reserved",  NULL},
#endif
#endif // MEM_SV_HOOKS
#ifdef MEM_SV_HOOKS
#if DUMP_REGISTER_DESCRIPTIONS
{24, 27, 0x0000000000000000, "RO", "reserved564", "Reserved bits"},
#else
{24, 27, 0x0000000000000000, "RO", "reserved564", NULL},
#endif
#else
#if DUMP_REGISTER_DESCRIPTIONS
{24, 27, 0x00000000, "RO", "Reserved", "Reserved"},
#else
{24, 27, 0x00000000, "RO", "Reserved",  NULL},
#endif
#endif // MEM_SV_HOOKS
#ifdef MEM_SV_HOOKS
#if DUMP_REGISTER_DESCRIPTIONS
{16, 23, 0x0000000000000000, "RO", "reserved565", "Reserved bits"},
#else
{16, 23, 0x0000000000000000, "RO", "reserved565", NULL},
#endif
#else
#if DUMP_REGISTER_DESCRIPTIONS
{16, 23, 0x00000000, "RO", "Reserved", "Reserved"},
#else
{16, 23, 0x00000000, "RO", "Reserved",  NULL},
#endif
#endif // MEM_SV_HOOKS
#ifdef MEM_SV_HOOKS
#if DUMP_REGISTER_DESCRIPTIONS
{14, 15, 0x0000000000000000, "RO", "reserved566", "Reserved bits"},
#else
{14, 15, 0x0000000000000000, "RO", "reserved566", NULL},
#endif
#else
#if DUMP_REGISTER_DESCRIPTIONS
{14, 15, 0x00000000, "RO", "Reserved", "Reserved"},
#else
{14, 15, 0x00000000, "RO", "Reserved",  NULL},
#endif
#endif // MEM_SV_HOOKS
#if DUMP_REGISTER_DESCRIPTIONS
{12, 13, 0x0000000000000000, "RW", "txdll_rk0siggrp05dbsel", "Deadband select for sig group 5 rank 0"},
#else
{12, 13, 0x0000000000000000, "RW", "txdll_rk0siggrp05dbsel", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{8, 11, 0x0000000000000000, "RW", "txdll_rk0siggrp05rdptroffset", "Read pointer offset for sig group 5 rank 0"},
#else
{8, 11, 0x0000000000000000, "RW", "txdll_rk0siggrp05rdptroffset", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 7, 0x0000000000000000, "RW", "txdll_rk0siggrp05picode", "PI code for sig group 5 rank 0"},
#else
{0, 7, 0x0000000000000000, "RW", "txdll_rk0siggrp05picode", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo536[] = {{"txdllsiggrp5ctla", "", 0x00000868, 8, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields537[] = {
#ifdef MEM_SV_HOOKS
#if DUMP_REGISTER_DESCRIPTIONS
{30, 31, 0x0000000000000000, "RO", "reserved567", "Reserved bits"},
#else
{30, 31, 0x0000000000000000, "RO", "reserved567", NULL},
#endif
#else
#if DUMP_REGISTER_DESCRIPTIONS
{30, 31, 0x00000000, "RO", "Reserved", "Reserved"},
#else
{30, 31, 0x00000000, "RO", "Reserved",  NULL},
#endif
#endif // MEM_SV_HOOKS
#ifdef MEM_SV_HOOKS
#if DUMP_REGISTER_DESCRIPTIONS
{28, 29, 0x0000000000000000, "RO", "reserved568", "Reserved bits"},
#else
{28, 29, 0x0000000000000000, "RO", "reserved568", NULL},
#endif
#else
#if DUMP_REGISTER_DESCRIPTIONS
{28, 29, 0x00000000, "RO", "Reserved", "Reserved"},
#else
{28, 29, 0x00000000, "RO", "Reserved",  NULL},
#endif
#endif // MEM_SV_HOOKS
#ifdef MEM_SV_HOOKS
#if DUMP_REGISTER_DESCRIPTIONS
{24, 27, 0x0000000000000000, "RO", "reserved569", "Reserved bits"},
#else
{24, 27, 0x0000000000000000, "RO", "reserved569", NULL},
#endif
#else
#if DUMP_REGISTER_DESCRIPTIONS
{24, 27, 0x00000000, "RO", "Reserved", "Reserved"},
#else
{24, 27, 0x00000000, "RO", "Reserved",  NULL},
#endif
#endif // MEM_SV_HOOKS
#ifdef MEM_SV_HOOKS
#if DUMP_REGISTER_DESCRIPTIONS
{16, 23, 0x0000000000000000, "RO", "reserved570", "Reserved bits"},
#else
{16, 23, 0x0000000000000000, "RO", "reserved570", NULL},
#endif
#else
#if DUMP_REGISTER_DESCRIPTIONS
{16, 23, 0x00000000, "RO", "Reserved", "Reserved"},
#else
{16, 23, 0x00000000, "RO", "Reserved",  NULL},
#endif
#endif // MEM_SV_HOOKS
#ifdef MEM_SV_HOOKS
#if DUMP_REGISTER_DESCRIPTIONS
{14, 15, 0x0000000000000000, "RO", "reserved571", "Reserved bits"},
#else
{14, 15, 0x0000000000000000, "RO", "reserved571", NULL},
#endif
#else
#if DUMP_REGISTER_DESCRIPTIONS
{14, 15, 0x00000000, "RO", "Reserved", "Reserved"},
#else
{14, 15, 0x00000000, "RO", "Reserved",  NULL},
#endif
#endif // MEM_SV_HOOKS
#if DUMP_REGISTER_DESCRIPTIONS
{12, 13, 0x0000000000000000, "RW", "txdll_rk0siggrp04dbsel", "Deadband select for sig group 4 rank 0"},
#else
{12, 13, 0x0000000000000000, "RW", "txdll_rk0siggrp04dbsel", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{8, 11, 0x0000000000000000, "RW", "txdll_rk0siggrp04rdptroffset", "Read pointer offset for sig group 4 rank 0"},
#else
{8, 11, 0x0000000000000000, "RW", "txdll_rk0siggrp04rdptroffset", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 7, 0x0000000000000000, "RW", "txdll_rk0siggrp04picode", "PI code for sig group 4 rank 0"},
#else
{0, 7, 0x0000000000000000, "RW", "txdll_rk0siggrp04picode", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo537[] = {{"txdllsiggrp4ctla", "", 0x0000086C, 8, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields538[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{28, 31, 0x0000000000000000, "RW", "memtech", "Reserved bits"},
#else
{28, 31, 0x0000000000000000, "RW", "memtech", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{24, 27, 0x0000000000000000, "RW", "memfreq", "Memory frequency"},
#else
{24, 27, 0x0000000000000000, "RW", "memfreq", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{16, 23, 0x0000000000000000, "RW", "phyupd_dly", "Delay between the phy update request to ack [br]in terms of SPID clocks."},
#else
{16, 23, 0x0000000000000000, "RW", "phyupd_dly", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{15, 15, 0x0000000000000000, "RO", "reserved500", "Reserved bits"},
#else
{15, 15, 0x0000000000000000, "RO", "reserved500", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{13, 14, 0x0000000000000000, "RW", "stretchmode", "This is the stretch mode signal.[br]00- normal read[br]01- x4 stretch mode [br]10- x8 stretch mode[br]11- x16 stretch mode"},
#else
{13, 14, 0x0000000000000000, "RW", "stretchmode", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{12, 12, 0x0000000000000000, "RO", "reserved501", "Reserved bits"},
#else
{12, 12, 0x0000000000000000, "RO", "reserved501", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{11, 11, 0x0000000000000000, "RW", "slowpath", "Delay the wrcmd 1 spidclk before write into the fifo.[br]1: 1 spidclk delay[br]0: no delay[br]With clock gating enable, the write pointer is only valid @ the next spid clock edge of write command. -> delay 1 spidclk so we can capture it into the fifo.[br]Set to 1 if do clock gate. Else set it to 0."},
#else
{11, 11, 0x0000000000000000, "RW", "slowpath", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{10, 10, 0x0000000000000000, "RW", "txfifo_csn_ffloppreseten", "This is the txFIFO final flop preset enable[br]1 - iobufact_b assert will preset the final flop, otherwise resets the final flop"},
#else
{10, 10, 0x0000000000000000, "RW", "txfifo_csn_ffloppreseten", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{9, 9, 0x0000000000000000, "RW", "rdmcpsel", "Programmable MCP for Tx FIFO read pointer path."},
#else
{9, 9, 0x0000000000000000, "RW", "rdmcpsel", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{6, 8, 0x0000000000000000, "RO", "reserved502", "Reserved bits"},
#else
{6, 8, 0x0000000000000000, "RO", "reserved502", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{5, 5, 0x0000000000000000, "RW", "bl1632xbl48b", "This is the burstlength configuration register[br]1:BL16 and BL32[br]0:BL4 and BL8"},
#else
{5, 5, 0x0000000000000000, "RW", "bl1632xbl48b", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{3, 4, 0x0000000000000000, "RW", "spidclksel", "SPID clk sel [br]00: 0.5xmode[br]01: 0.25x mode[br]10: 0.1x mode[br]11: NA"},
#else
{3, 4, 0x0000000000000000, "RW", "spidclksel", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{2, 2, 0x0000000000000000, "RW", "lpddr34mode", "Single data rate v/s Double Data rate [br]0: Double data rate (LP3)[br]1: Single data rate (LP4)"},
#else
{2, 2, 0x0000000000000000, "RW", "lpddr34mode", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 1, 0x0000000000000000, "RO", "reserved503", "Reserved bits"},
#else
{0, 1, 0x0000000000000000, "RO", "reserved503", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo538[] = {{"digctl", "", 0x00000000, 14, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields539[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{28, 31, 0x0000000000000000, "RO", "reserved504", "Reserved bits"},
#else
{28, 31, 0x0000000000000000, "RO", "reserved504", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{24, 27, 0x0000000000000000, "RW", "compclkrdptrinit", "DLL comp init configuration."},
#else
{24, 27, 0x0000000000000000, "RW", "compclkrdptrinit", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{21, 23, 0x0000000000000000, "RW", "compclkrdptroffset", "DLL comp read pointer offset."},
#else
{21, 23, 0x0000000000000000, "RW", "compclkrdptroffset", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{17, 20, 0x0000000000000000, "RW", "ref1xrdptrinit", "This is the ref1x read pointer init configuration."},
#else
{17, 20, 0x0000000000000000, "RW", "ref1xrdptrinit", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{16, 16, 0x0000000000000000, "RW", "dqxccb", "Configure DQCCC as DQ or CCC[br]0: CCC[br]1: DQ"},
#else
{16, 16, 0x0000000000000000, "RW", "dqxccb", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{13, 15, 0x0000000000000000, "RW", "ref1xrdptroffset", "This is the ref1xread pointer offset configuration."},
#else
{13, 15, 0x0000000000000000, "RW", "ref1xrdptroffset", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{8, 12, 0x0000000000000000, "RW", "ref2xrdptrinit", "This is the ref2x read pointer init configuration."},
#else
{8, 12, 0x0000000000000000, "RW", "ref2xrdptrinit", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{4, 7, 0x0000000000000000, "RW", "cc_doublefifooffset", "This is the double FIFO offset configuration(in terms of 2xclock)."},
#else
{4, 7, 0x0000000000000000, "RW", "cc_doublefifooffset", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 3, 0x0000000000000000, "RW", "bl_doublefifooffset", "This is the double FIFO offset configuration(in terms of 2xclock)."},
#else
{0, 3, 0x0000000000000000, "RW", "bl_doublefifooffset", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo539[] = {{"fifoptrctl", "", 0x00000004, 9, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields540[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{28, 31, 0x0000000000000000, "RO", "reserved505", "Reserved bits"},
#else
{28, 31, 0x0000000000000000, "RO", "reserved505", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{25, 27, 0x0000000000000000, "RO", "reserved506", "Reserved bits"},
#else
{25, 27, 0x0000000000000000, "RO", "reserved506", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{24, 24, 0x0000000000000000, "RW", "ca_training", "CA training mode"},
#else
{24, 24, 0x0000000000000000, "RW", "ca_training", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{21, 23, 0x0000000000000000, "RO", "reserved507", "Reserved bits"},
#else
{21, 23, 0x0000000000000000, "RO", "reserved507", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{20, 20, 0x0000000000000000, "RW", "clktxdrven", "CK buffer enable[br]1: Enable buffer[br]0: Tristate buffer"},
#else
{20, 20, 0x0000000000000000, "RW", "clktxdrven", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{19, 19, 0x0000000000000000, "RW", "cketxdrven", "CKE buffer enable[br]1: Enable buffer[br]0: Tristate buffer"},
#else
{19, 19, 0x0000000000000000, "RW", "cketxdrven", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{18, 18, 0x0000000000000000, "RW", "cstxdrven", "CS buffer enable[br]1: Enable buffer[br]0: Tristate buffer"},
#else
{18, 18, 0x0000000000000000, "RW", "cstxdrven", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{8, 17, 0x0000000000000000, "RW", "cmdtxdrven", "CMD buffer enable[br]1: Enable buffer[br]0: Tristate buffer"},
#else
{8, 17, 0x0000000000000000, "RW", "cmdtxdrven", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{7, 7, 0x0000000000000000, "RO", "reserved508", "Reserved bits"},
#else
{7, 7, 0x0000000000000000, "RO", "reserved508", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{6, 6, 0x0000000000000000, "RO", "reserved509", "Reserved bits"},
#else
{6, 6, 0x0000000000000000, "RO", "reserved509", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{5, 5, 0x0000000000000000, "RO", "reserved510", "Reserved bits"},
#else
{5, 5, 0x0000000000000000, "RO", "reserved510", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{3, 4, 0x0000000000000000, "RO", "reserved511", "Reserved bits"},
#else
{3, 4, 0x0000000000000000, "RO", "reserved511", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{2, 2, 0x0000000000000000, "RW", "clknegxposb", "Start phase of CK"},
#else
{2, 2, 0x0000000000000000, "RW", "clknegxposb", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{1, 1, 0x0000000000000000, "RW", "cmdtristateovrval", "Command tristate override value"},
#else
{1, 1, 0x0000000000000000, "RW", "cmdtristateovrval", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 0, 0x0000000000000000, "RW", "cmdtristateovrsel", "Command tristate override select"},
#else
{0, 0, 0x0000000000000000, "RW", "cmdtristateovrsel", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo540[] = {{"cccctl", "", 0x00000008, 15, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields541[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{3, 31, 0x0000000000000000, "RO", "reserved512", "Reserved bits"},
#else
{3, 31, 0x0000000000000000, "RO", "reserved512", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{2, 2, 0x0000000000000000, "RW", "rstbtx_enbrst", "Tri-state control for LP4 reset buffer"},
#else
{2, 2, 0x0000000000000000, "RW", "rstbtx_enbrst", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{1, 1, 0x0000000000000000, "RW", "rstbtx_reset", "Reset for the LP4 reset buffer"},
#else
{1, 1, 0x0000000000000000, "RW", "rstbtx_reset", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 0, 0x0000000000000000, "RW", "rstbtx_set", "Set for the LP4 reset buffer"},
#else
{0, 0, 0x0000000000000000, "RW", "rstbtx_set", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo541[] = {{"lp4rstctl", "", 0x0000000C, 4, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields542[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{2, 31, 0x0000000000000000, "RO", "reserved513", "Reserved bits"},
#else
{2, 31, 0x0000000000000000, "RO", "reserved513", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{1, 1, 0x0000000000000000, "RW", "rxfiforst_b", "Rxfifo reset (active low)[br]1: deasserted[br]0 : asserted"},
#else
{1, 1, 0x0000000000000000, "RW", "rxfiforst_b", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 0, 0x0000000000000000, "RW", "spidrst_b", "Reset for functional logic in upartition (except compensation and power management logic)  [br]0: Reset assertion  [br]1: Reset de-assertion"},
#else
{0, 0, 0x0000000000000000, "RW", "spidrst_b", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo542[] = {{"digrstctl", "", 0x00000010, 3, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields543[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{1, 31, 0x0000000000000000, "RO", "reserved514", "Reserved bits"},
#else
{1, 31, 0x0000000000000000, "RO", "reserved514", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 0, 0x0000000000000000, "RW", "wrptren", "Config-controlled Write pointer enable. 0=config control disabled, 1=config control enabled. This bit qualifies the pm_wrptren, which eventually goes to DQPTRGEN Fub."},
#else
{0, 0, 0x0000000000000000, "RW", "wrptren", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo543[] = {{"fifoptren", "", 0x00000014, 2, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields544[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{2, 31, 0x0000000000000000, "RO", "reserved515", "Reserved bits"},
#else
{2, 31, 0x0000000000000000, "RO", "reserved515", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{1, 1, 0x0000000000000000, "RW", "lvl_cc_iobufactafe", "IO buffer activate - CCC Analog[br]Tristates DQ and DQS IO buffers [br]Disable Rx sections of IO buffers [br]0 : reset [br]1 : out of reset"},
#else
{1, 1, 0x0000000000000000, "RW", "lvl_cc_iobufactafe", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 0, 0x0000000000000000, "RW", "lvl_bl_iobufactafe", "IO buffer activate - DQ Analog[br]Tristates DQ and DQS IO buffers [br]Disable Rx sections of IO buffers [br]0 : reset [br]1 : out of reset"},
#else
{0, 0, 0x0000000000000000, "RW", "lvl_bl_iobufactafe", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo544[] = {{"iobufact_afe", "", 0x00000018, 3, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields545[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{2, 31, 0x0000000000000000, "RO", "reserved516", "Reserved bits"},
#else
{2, 31, 0x0000000000000000, "RO", "reserved516", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{1, 1, 0x0000000000000000, "RW", "cc_iobufactdig", "IO buffer activate - CCC Digital[br]Bytelane 1 SW reset for final TX flops in all upartitions."},
#else
{1, 1, 0x0000000000000000, "RW", "cc_iobufactdig", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 0, 0x0000000000000000, "RW", "bl_iobufactdig", "IO buffer activate - DQ Digital[br]Bytelane 1 SW reset for final TX flops in all upartitions."},
#else
{0, 0, 0x0000000000000000, "RW", "bl_iobufactdig", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo545[] = {{"iobufact_dig", "", 0x0000001C, 3, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields546[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{1, 31, 0x0000000000000000, "RO", "reserved517", "Reserved bits"},
#else
{1, 31, 0x0000000000000000, "RO", "reserved517", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 0, 0x0000000000000000, "RW", "spid_init_complete", "SPID init complete"},
#else
{0, 0, 0x0000000000000000, "RW", "spid_init_complete", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo546[] = {{"spidic", "", 0x00000020, 2, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields547[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{10, 31, 0x0000000000000000, "RO", "reserved518", "Reserved bits"},
#else
{10, 31, 0x0000000000000000, "RO", "reserved518", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{8, 9, 0x0000000000000000, "RO", "reserved519", "Reserved bits"},
#else
{8, 9, 0x0000000000000000, "RO", "reserved519", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{6, 7, 0x0000000000000000, "RW", "dqdrvenbph1", "Data mask drive enable"},
#else
{6, 7, 0x0000000000000000, "RW", "dqdrvenbph1", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{4, 5, 0x0000000000000000, "RW", "dqdrvenbpream1", "This is the two write preambles enable"},
#else
{4, 5, 0x0000000000000000, "RW", "dqdrvenbpream1", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{2, 3, 0x0000000000000000, "RW", "dqdrvenblastph", "Last phase - DQ Drive Enable"},
#else
{2, 3, 0x0000000000000000, "RW", "dqdrvenblastph", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 1, 0x0000000000000000, "RW", "dqdrvenbpream0", "This is the DQS configuration for first phase [br](2'b01-dqs_hi_lo,2'b00-dqs_lo_lo,2'b11-dqs_hi_hi)."},
#else
{0, 1, 0x0000000000000000, "RW", "dqdrvenbpream0", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo547[] = {{"wrdqctl", "", 0x00000024, 6, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields548[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{30, 31, 0x0000000000000000, "RW", "dqsdrvenbph1", "Phase 1 - DQS Drive enable"},
#else
{30, 31, 0x0000000000000000, "RW", "dqsdrvenbph1", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{28, 29, 0x0000000000000000, "RW", "dqsdrvenbpream1", "Preamble 1 - DQS drive enable"},
#else
{28, 29, 0x0000000000000000, "RW", "dqsdrvenbpream1", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{26, 27, 0x0000000000000000, "RW", "dqsdrvenblastph", "Last phase - DQS Drive enable"},
#else
{26, 27, 0x0000000000000000, "RW", "dqsdrvenblastph", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{24, 25, 0x0000000000000000, "RW", "dqsdrvenbpream0", "Preamble 0 - DQS Drive enable"},
#else
{24, 25, 0x0000000000000000, "RW", "dqsdrvenbpream0", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{21, 23, 0x0000000000000000, "RO", "reserved520", "Reserved bits"},
#else
{21, 23, 0x0000000000000000, "RO", "reserved520", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{20, 20, 0x0000000000000000, "RW", "dmdrven", "Data mask drive enable"},
#else
{20, 20, 0x0000000000000000, "RW", "dmdrven", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{19, 19, 0x0000000000000000, "RW", "wrpream0en", "This is the two write preambles enable"},
#else
{19, 19, 0x0000000000000000, "RW", "wrpream0en", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{18, 18, 0x0000000000000000, "RO", "reserved521", "TBD"},
#else
{18, 18, 0x0000000000000000, "RO", "reserved521", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{16, 17, 0x0000000000000003, "RW", "dqsdrvenbidle", "DQS Drive Enable - Idle"},
#else
{16, 17, 0x0000000000000003, "RW", "dqsdrvenbidle", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{14, 15, 0x0000000000000000, "RW", "dqsdataph1", "This is the DQS configuration for first phase [br](2'b01-dqs_hi_lo,2'b00-dqs_lo_lo,2'b11-dqs_hi_hi)."},
#else
{14, 15, 0x0000000000000000, "RW", "dqsdataph1", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{12, 13, 0x0000000000000000, "RW", "dqsdatapream1", "This is the DQS configuration during second preamble[br](2'b01-dqs_hi_lo,2'b00-dqs_lo_lo,2'b11-dqs_hi_hi)."},
#else
{12, 13, 0x0000000000000000, "RW", "dqsdatapream1", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{10, 11, 0x0000000000000000, "RW", "dqsdatalastph", "This is the DQS configuration for last phase [br](2'b01-dqs_hi_lo,2'b00-dqs_lo_lo,2'b11-dqs_hi_hi)."},
#else
{10, 11, 0x0000000000000000, "RW", "dqsdatalastph", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{8, 9, 0x0000000000000000, "RW", "dqsdatapream0", "This is the DQS configuration during first preamble[br](2'b01-dqs_hi_lo,2'b00-dqs_lo_lo,2'b11-dqs_hi_hi)."},
#else
{8, 9, 0x0000000000000000, "RW", "dqsdatapream0", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{6, 7, 0x0000000000000000, "RO", "reserved522", "Reserved bits"},
#else
{6, 7, 0x0000000000000000, "RO", "reserved522", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 5, 0x0000000000000000, "RW", "wrcmd2dqsstart", "Write command to DQS start delay"},
#else
{0, 5, 0x0000000000000000, "RW", "wrcmd2dqsstart", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo548[] = {{"wrdqsctl", "", 0x00000028, 15, 0x00000000FFFFFFFF, 0x0000000000030000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields549[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{24, 31, 0x0000000000000000, "RO", "reserved523", "Reserved bits"},
#else
{24, 31, 0x0000000000000000, "RO", "reserved523", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{16, 23, 0x0000000000000000, "RW", "rdcmd2rdvld_bonus", "Read command 2 read bonus bits."},
#else
{16, 23, 0x0000000000000000, "RW", "rdcmd2rdvld_bonus", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{15, 15, 0x0000000000000000, "RO", "reserved524", "Reserved bits"},
#else
{15, 15, 0x0000000000000000, "RO", "reserved524", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{12, 14, 0x0000000000000000, "RW", "rdcmd2rdvld_plus1sel", "Read command 2 read valid plus 1 sel."},
#else
{12, 14, 0x0000000000000000, "RW", "rdcmd2rdvld_plus1sel", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{11, 11, 0x0000000000000000, "RO", "reserved525", "Reserved bits"},
#else
{11, 11, 0x0000000000000000, "RO", "reserved525", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{8, 10, 0x0000000000000000, "RW", "earlyrdvld", "This is the early read valid configuration register [br]0: no early read valid geneartion[br]1/2/3/4: 1/2/3/4/spidclk early valid[br] >4: Illegal"},
#else
{8, 10, 0x0000000000000000, "RW", "earlyrdvld", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{6, 7, 0x0000000000000000, "RO", "reserved526", "Reserved bits"},
#else
{6, 7, 0x0000000000000000, "RO", "reserved526", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 5, 0x0000000000000000, "RW", "rdcmd2rdvld", "This is the read command to read valid register.[br]This is in terms of spidclk."},
#else
{0, 5, 0x0000000000000000, "RW", "rdcmd2rdvld", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo549[] = {{"rdvldctl", "", 0x0000002C, 8, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields550[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{11, 31, 0x0000000000000000, "RO", "reserved527", "This is the rank to rank override.(1 - no rank to rank switch enable)."},
#else
{11, 31, 0x0000000000000000, "RO", "reserved527", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{10, 10, 0x0000000000000000, "RW", "rk2rkmio2xclkpushout_iodrven", "pushing out the update of rank information 1 more 2xclk if set to 1."},
#else
{10, 10, 0x0000000000000000, "RW", "rk2rkmio2xclkpushout_iodrven", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{9, 9, 0x0000000000000000, "RW", "rk2rkmio2xclkpushout_txrden", "pushing out the update of rank information 1 more 2xclk if set to 1."},
#else
{9, 9, 0x0000000000000000, "RW", "rk2rkmio2xclkpushout_txrden", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{8, 8, 0x0000000000000000, "RW", "rk2rkmio2xclkpushout_txrcven", "pushing out the update of rank information 1 more 2xclk if set to 1."},
#else
{8, 8, 0x0000000000000000, "RW", "rk2rkmio2xclkpushout_txrcven", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{7, 7, 0x0000000000000000, "RW", "bl_rk2rken_txdqs_pi", "This is the rank to rank override.(1 - no rank to rank switch enable)."},
#else
{7, 7, 0x0000000000000000, "RW", "bl_rk2rken_txdqs_pi", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{6, 6, 0x0000000000000000, "RW", "bl_rk2rken_txdq_pi", "This is the rank to rank override.(1 - no rank to rank switch enable)."},
#else
{6, 6, 0x0000000000000000, "RW", "bl_rk2rken_txdq_pi", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{2, 5, 0x0000000000000000, "RO", "reserved528", "This is the rank to rank override.(1 - no rank to rank switch enable)."},
#else
{2, 5, 0x0000000000000000, "RO", "reserved528", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{1, 1, 0x0000000000000000, "RW", "bl_rk2rken_rxdq_pi", "This is the rank to rank override.(1 - no rank to rank switch enable)."},
#else
{1, 1, 0x0000000000000000, "RW", "bl_rk2rken_rxdq_pi", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 0, 0x0000000000000000, "RW", "bl_rk2rken_txrcven", "This is the rank to rank enable for the receive enable."},
#else
{0, 0, 0x0000000000000000, "RW", "bl_rk2rken_txrcven", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo550[] = {{"rk2rkctl1", "", 0x00000030, 9, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields551[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{28, 31, 0x0000000000000000, "RW", "rk2rkdrvenbcode_3rd", "This is the pattern for third 1x clock of rk2rk_rden[br](bit[0] - 1xhigh phase value, bit[1] - 1xlow phase value).[br]Applicable for both DQ and DQS drvenb."},
#else
{28, 31, 0x0000000000000000, "RW", "rk2rkdrvenbcode_3rd", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{24, 27, 0x0000000000000000, "RW", "rk2rkrdencode_3rd", "This is the pattern for third 1x clock of rk2rk_rden[br](bit[0] - 1xhigh phase value, bit[1] - 1xlow phase value)."},
#else
{24, 27, 0x0000000000000000, "RW", "rk2rkrdencode_3rd", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{23, 23, 0x0000000000000000, "RW", "rk2rkmio2xclkpushout_rxdq", "pushing out the update of rank information 1 more 2xclk if set to 1."},
#else
{23, 23, 0x0000000000000000, "RW", "rk2rkmio2xclkpushout_rxdq", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{22, 22, 0x0000000000000000, "RW", "rk2rkmio2xclkpushout_txdqs", "pushing out the update of rank information 1 more 2xclk if set to 1."},
#else
{22, 22, 0x0000000000000000, "RW", "rk2rkmio2xclkpushout_txdqs", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{21, 21, 0x0000000000000000, "RW", "rk2rkmio2xclkpushout_txdq", "pushing out the update of rank information 1 more 2xclk if set to 1."},
#else
{21, 21, 0x0000000000000000, "RW", "rk2rkmio2xclkpushout_txdq", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{15, 20, 0x0000000000000000, "RW", "wrcmd2rkchglatency", "This is the pattern for second 1x clock of rk2rk_iodrvenb[br](bit[0] - 1xhigh phase value, bit[1] - 1xlow phase value)."},
#else
{15, 20, 0x0000000000000000, "RW", "wrcmd2rkchglatency", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{14, 14, 0x0000000000000000, "RO", "reserved529", "Reserved bits"},
#else
{14, 14, 0x0000000000000000, "RO", "reserved529", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{8, 13, 0x0000000000000000, "RW", "rdcmd2rkchglatency", "This is the pattern for first 1x clock of rk2rk_iodrvenb[br](bit[0] - 1xhigh phase value, bit[1] - 1xlow phase value)."},
#else
{8, 13, 0x0000000000000000, "RW", "rdcmd2rkchglatency", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{6, 7, 0x0000000000000000, "RW", "rk2rkdrvenbcode_2nd", "This is the pattern for second 1x clock of rk2rk_rden[br](bit[0] - 1xhigh phase value, bit[1] - 1xlow phase value).[br]Applicable for both DQ and DQS drvenb."},
#else
{6, 7, 0x0000000000000000, "RW", "rk2rkdrvenbcode_2nd", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{4, 5, 0x0000000000000000, "RW", "rk2rkdrvenbcode_1st", "This is the pattern for first 1x clock of rk2rk_rden[br](bit[0] - 1xhigh phase value, bit[1] - 1xlow phase value).[br]Applicable for both DQ and DQS drvenb."},
#else
{4, 5, 0x0000000000000000, "RW", "rk2rkdrvenbcode_1st", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{2, 3, 0x0000000000000000, "RW", "rk2rkrdencode_2nd", "This is the pattern for second 1x clock of rk2rk_rden[br](bit[0] - 1xhigh phase value, bit[1] - 1xlow phase value)."},
#else
{2, 3, 0x0000000000000000, "RW", "rk2rkrdencode_2nd", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 1, 0x0000000000000000, "RW", "rk2rkrdencode_1st", "This is the pattern for first 1x clock of rk2rk_rden[br](bit[0] - 1xhigh phase value, bit[1] - 1xlow phase value)."},
#else
{0, 1, 0x0000000000000000, "RW", "rk2rkrdencode_1st", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo551[] = {{"rk2rkctl0", "", 0x00000034, 12, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields552[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{29, 31, 0x0000000000000000, "RW", "cc_rxodtsegovrval", "Receive ODT segment enable override value."},
#else
{29, 31, 0x0000000000000000, "RW", "cc_rxodtsegovrval", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{28, 28, 0x0000000000000000, "RW", "cc_rxodtsegovrsel", "Receive ODT segment enable override select.[br]0= Dynamic  control[br]1= Static  control"},
#else
{28, 28, 0x0000000000000000, "RW", "cc_rxodtsegovrsel", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{24, 27, 0x0000000000000000, "RW", "rk1_odtsegenrdptroffset", "Receive ODT segment enable read pointer offset."},
#else
{24, 27, 0x0000000000000000, "RW", "rk1_odtsegenrdptroffset", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{23, 23, 0x0000000000000000, "RO", "reserved530", "Reserved bits"},
#else
{23, 23, 0x0000000000000000, "RO", "reserved530", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{22, 22, 0x0000000000000000, "RW", "cc_rxodtsegtwohot", "This is the RXODTSEGEN one hot enable[br]0- rxodtsegen: 001->010->100[br]1-rxodtsegen: 011->110->101"},
#else
{22, 22, 0x0000000000000000, "RW", "cc_rxodtsegtwohot", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{16, 21, 0x0000000000000000, "RW", "cc_rxodtseglenbl4", "This is the receive ODT segment enable length configuration register.[br]It's in number of 1x clocks."},
#else
{16, 21, 0x0000000000000000, "RW", "cc_rxodtseglenbl4", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{14, 15, 0x0000000000000000, "RW", "cc_rxodtsegpst1", "This is the receive ODT segment enable configuration register - postamble 1 -  new(rise & fall). [br]00 - Rise & Fall - Low & Low[br]01 - Rise & Fall - High & Low[br]10 - Rise & Fall - Low & High[br]11 - Rise & Fall - High & High"},
#else
{14, 15, 0x0000000000000000, "RW", "cc_rxodtsegpst1", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{12, 13, 0x0000000000000000, "RW", "cc_rxodtsegpre1", "This is the receive ODT segment enable configuration register - preamble 1(rise & fall) [br]00 - Rise & Fall - Low & Low[br]01 - Rise & Fall - High & Low[br]10 - Rise & Fall - Low & High[br]11 - Rise & Fall - High & High"},
#else
{12, 13, 0x0000000000000000, "RW", "cc_rxodtsegpre1", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{10, 11, 0x0000000000000000, "RW", "cc_rxodtsegpst0", "This is the receive ODT segment enable configuration register - postamble 0 - new(rise & fall)[br]00 - Rise & Fall - Low & Low[br]01 - Rise & Fall - High & Low[br]10 - Rise & Fall - Low & High[br]11 - Rise & Fall - High & High"},
#else
{10, 11, 0x0000000000000000, "RW", "cc_rxodtsegpst0", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{8, 9, 0x0000000000000000, "RW", "cc_rxodtsegpre0", "This is the receive ODT segment enable configuration register - preamble 0(rise & fall) [br]00 - Rise & Fall - Low & Low[br]01 - Rise & Fall - High & Low[br]10 - Rise & Fall - Low & High[br]11 - Rise & Fall - High & High"},
#else
{8, 9, 0x0000000000000000, "RW", "cc_rxodtsegpre0", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{6, 7, 0x0000000000000000, "RO", "reserved531", "Reserved bits"},
#else
{6, 7, 0x0000000000000000, "RO", "reserved531", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 5, 0x0000000000000000, "RW", "cc_rdcmd2rxodtseg", "This is the receive ODT segment enable latency configuration register."},
#else
{0, 5, 0x0000000000000000, "RW", "cc_rdcmd2rxodtseg", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo552[] = {{"rxodtsegctl_cc", "", 0x00000038, 12, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields553[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{29, 31, 0x0000000000000000, "RW", "bl_rxodtsegovrval", "Receive ODT segment enable override value. [br]0: De-assert receive ODT enable [br]1: Assert receive ODT enable"},
#else
{29, 31, 0x0000000000000000, "RW", "bl_rxodtsegovrval", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{28, 28, 0x0000000000000000, "RW", "bl_rxodtsegovrsel", "Receive ODT segment enable override select.[br]0= Dynamic  receive ODT control[br]1= Static  receive ODT control"},
#else
{28, 28, 0x0000000000000000, "RW", "bl_rxodtsegovrsel", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{24, 27, 0x0000000000000000, "RW", "rk0_odtsegenrdptroffset", "Receive ODT segment enable read pointer offset."},
#else
{24, 27, 0x0000000000000000, "RW", "rk0_odtsegenrdptroffset", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{23, 23, 0x0000000000000000, "RO", "reserved532", "Reseved bits"},
#else
{23, 23, 0x0000000000000000, "RO", "reserved532", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{22, 22, 0x0000000000000000, "RW", "bl_rxodtsegtwohot", "This is the RXODTSEGEN one hot enable[br]0- rxodtsegen: 001->010->100[br]1-rxodtsegen: 011->110->101"},
#else
{22, 22, 0x0000000000000000, "RW", "bl_rxodtsegtwohot", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{16, 21, 0x0000000000000000, "RW", "bl_rxodtseglenbl4", "This is the receive ODT segment enable length configuration register.[br]It's in number of 1x clocks."},
#else
{16, 21, 0x0000000000000000, "RW", "bl_rxodtseglenbl4", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{14, 15, 0x0000000000000000, "RW", "bl_rxodtsegpst1", "This is the receive ODT segment enable configuration register - postamble 1 -  new(rise & fall). [br]00 - Rise & Fall - Low & Low[br]01 - Rise & Fall - High & Low[br]10 - Rise & Fall - Low & High[br]11 - Rise & Fall - High & High"},
#else
{14, 15, 0x0000000000000000, "RW", "bl_rxodtsegpst1", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{12, 13, 0x0000000000000000, "RW", "bl_rxodtsegpre1", "This is the receive ODT segment enable configuration register - preamble 1(rise & fall) [br]00 - Rise & Fall - Low & Low[br]01 - Rise & Fall - High & Low[br]10 - Rise & Fall - Low & High[br]11 - Rise & Fall - High & High"},
#else
{12, 13, 0x0000000000000000, "RW", "bl_rxodtsegpre1", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{10, 11, 0x0000000000000000, "RW", "bl_rxodtsegpst0", "This is the receive ODT segment enable configuration register - postamble 0 - new(rise & fall)[br]00 - Rise & Fall - Low & Low[br]01 - Rise & Fall - High & Low[br]10 - Rise & Fall - Low & High[br]11 - Rise & Fall - High & High"},
#else
{10, 11, 0x0000000000000000, "RW", "bl_rxodtsegpst0", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{8, 9, 0x0000000000000000, "RW", "bl_rxodtsegpre0", "This is the receive ODT segment enable configuration register - preamble 0(rise & fall) [br]00 - Rise & Fall - Low & Low[br]01 - Rise & Fall - High & Low[br]10 - Rise & Fall - Low & High[br]11 - Rise & Fall - High & High"},
#else
{8, 9, 0x0000000000000000, "RW", "bl_rxodtsegpre0", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{6, 7, 0x0000000000000000, "RO", "reserved533", "Reserved bits"},
#else
{6, 7, 0x0000000000000000, "RO", "reserved533", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 5, 0x0000000000000000, "RW", "bl_rdcmd2rxodtseg", "This is the receive ODT segment enable latency configuration register."},
#else
{0, 5, 0x0000000000000000, "RW", "bl_rdcmd2rxodtseg", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo553[] = {{"rxodtsegctl_dq", "", 0x0000003C, 12, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields554[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{28, 31, 0x0000000000000000, "RW", "rk1_odtenrdptroffset", "This is receive ODT enable read pointer offset."},
#else
{28, 31, 0x0000000000000000, "RW", "rk1_odtenrdptroffset", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{26, 27, 0x0000000000000000, "RO", "reserved534", "Reseved bits"},
#else
{26, 27, 0x0000000000000000, "RO", "reserved534", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{25, 25, 0x0000000000000000, "RW", "cc_rxodtenovrval", "Receive ODT enable override value. [br]0: De-assert receive enable [br]1: Assert receive enable"},
#else
{25, 25, 0x0000000000000000, "RW", "cc_rxodtenovrval", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{24, 24, 0x0000000000000000, "RW", "cc_rxodtenovrsel", "Receive ODT enable override select.[br]0= Dynamic RCVEN control[br]1= Static RCVEN control"},
#else
{24, 24, 0x0000000000000000, "RW", "cc_rxodtenovrsel", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{22, 23, 0x0000000000000000, "RO", "reserved535", "Reserved bits"},
#else
{22, 23, 0x0000000000000000, "RO", "reserved535", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{16, 21, 0x0000000000000000, "RW", "cc_rxodtenlenbl4", "This is the receive ODT enable length configuration register.[br]It's in number of 1x clocks."},
#else
{16, 21, 0x0000000000000000, "RW", "cc_rxodtenlenbl4", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{14, 15, 0x0000000000000000, "RW", "cc_rxodtenpst1", "This is the receive ODT enable configuration register - postamble 1 -  new(rise & fall). [br]00 - Rise & Fall - Low & Low[br]01 - Rise & Fall - High & Low[br]10 - Rise & Fall - Low & High[br]11 - Rise & Fall - High & High"},
#else
{14, 15, 0x0000000000000000, "RW", "cc_rxodtenpst1", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{12, 13, 0x0000000000000000, "RW", "cc_rxodtenpre1", "This is the receive ODT enable configuration register - preamble 1(rise & fall) [br]00 - Rise & Fall - Low & Low[br]01 - Rise & Fall - High & Low[br]10 - Rise & Fall - Low & High[br]11 - Rise & Fall - High & High"},
#else
{12, 13, 0x0000000000000000, "RW", "cc_rxodtenpre1", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{10, 11, 0x0000000000000000, "RW", "cc_rxodtenpst0", "This is the receive ODT enable configuration register - postamble 0 - new(rise & fall)[br]00 - Rise & Fall - Low & Low[br]01 - Rise & Fall - High & Low[br]10 - Rise & Fall - Low & High[br]11 - Rise & Fall - High & High"},
#else
{10, 11, 0x0000000000000000, "RW", "cc_rxodtenpst0", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{8, 9, 0x0000000000000000, "RW", "cc_rxodtenpre0", "This is the receive ODT enable configuration register - preamble 0(rise & fall) [br]00 - Rise & Fall - Low & Low[br]01 - Rise & Fall - High & Low[br]10 - Rise & Fall - Low & High[br]11 - Rise & Fall - High & High"},
#else
{8, 9, 0x0000000000000000, "RW", "cc_rxodtenpre0", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{6, 7, 0x0000000000000000, "RO", "reserved536", "Reserved bits"},
#else
{6, 7, 0x0000000000000000, "RO", "reserved536", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 5, 0x0000000000000000, "RW", "cc_rdcmd2rxodten", "This is the receive ODT enable latency configuration register."},
#else
{0, 5, 0x0000000000000000, "RW", "cc_rdcmd2rxodten", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo554[] = {{"rxodtctl_cc", "", 0x00000040, 12, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields555[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{28, 31, 0x0000000000000000, "RW", "rk0_odtenrdptroffset", "This is receive ODT enable read pointer offset."},
#else
{28, 31, 0x0000000000000000, "RW", "rk0_odtenrdptroffset", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{26, 27, 0x0000000000000000, "RO", "reserved537", "Reserved bits"},
#else
{26, 27, 0x0000000000000000, "RO", "reserved537", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{25, 25, 0x0000000000000000, "RW", "bl_rxodtenovrval", "Receive ODT enable override value. [br]0: De-assert receive enable [br]1: Assert receive enable"},
#else
{25, 25, 0x0000000000000000, "RW", "bl_rxodtenovrval", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{24, 24, 0x0000000000000000, "RW", "bl_rxodtenovrsel", "Receive ODT enable override select.[br]0= Dynamic RCVEN control[br]1= Static RCVEN control"},
#else
{24, 24, 0x0000000000000000, "RW", "bl_rxodtenovrsel", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{22, 23, 0x0000000000000000, "RO", "reserved538", "Reserved bits"},
#else
{22, 23, 0x0000000000000000, "RO", "reserved538", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{16, 21, 0x0000000000000000, "RW", "bl_rxodtenlenbl4", "This is the receive ODT enable length configuration register.[br]It's in number of 1x clocks."},
#else
{16, 21, 0x0000000000000000, "RW", "bl_rxodtenlenbl4", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{14, 15, 0x0000000000000000, "RW", "bl_rxodtenpst1", "This is the receive ODT enable configuration register - postamble 1 -  new(rise & fall). [br]00 - Rise & Fall - Low & Low[br]01 - Rise & Fall - High & Low[br]10 - Rise & Fall - Low & High[br]11 - Rise & Fall - High & High"},
#else
{14, 15, 0x0000000000000000, "RW", "bl_rxodtenpst1", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{12, 13, 0x0000000000000000, "RW", "bl_rxodtenpre1", "This is the receive ODT enable configuration register - preamble 1(rise & fall) [br]00 - Rise & Fall - Low & Low[br]01 - Rise & Fall - High & Low[br]10 - Rise & Fall - Low & High[br]11 - Rise & Fall - High & High"},
#else
{12, 13, 0x0000000000000000, "RW", "bl_rxodtenpre1", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{10, 11, 0x0000000000000000, "RW", "bl_rxodtenpst0", "This is the receive ODT enable configuration register - postamble 0 - new(rise & fall)[br]00 - Rise & Fall - Low & Low[br]01 - Rise & Fall - High & Low[br]10 - Rise & Fall - Low & High[br]11 - Rise & Fall - High & High"},
#else
{10, 11, 0x0000000000000000, "RW", "bl_rxodtenpst0", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{8, 9, 0x0000000000000000, "RW", "bl_rxodtenpre0", "This is the receive ODT enable configuration register - preamble 0(rise & fall) [br]00 - Rise & Fall - Low & Low[br]01 - Rise & Fall - High & Low[br]10 - Rise & Fall - Low & High[br]11 - Rise & Fall - High & High"},
#else
{8, 9, 0x0000000000000000, "RW", "bl_rxodtenpre0", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{6, 7, 0x0000000000000000, "RO", "reserved539", "Reserved bits"},
#else
{6, 7, 0x0000000000000000, "RO", "reserved539", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 5, 0x0000000000000000, "RW", "bl_rdcmd2rxodten", "This is the receive ODT enable latency configuration register."},
#else
{0, 5, 0x0000000000000000, "RW", "bl_rdcmd2rxodten", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo555[] = {{"rxodtctl_dq", "", 0x00000044, 12, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields556[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{31, 31, 0x0000000000000000, "RO", "drx_cc_rcvsmpl", "AFE status register - RCVSMPL - CC"},
#else
{31, 31, 0x0000000000000000, "RO", "drx_cc_rcvsmpl", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{28, 30, 0x0000000000000000, "RO", "reserved540", "Reserved bits"},
#else
{28, 30, 0x0000000000000000, "RO", "reserved540", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{27, 27, 0x0000000000000000, "RW", "drx_cc_dqscountrstb", "DQS counter reset"},
#else
{27, 27, 0x0000000000000000, "RW", "drx_cc_dqscountrstb", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{26, 26, 0x0000000000000000, "RW", "cc_rcvenmargin", "Receive enable margining data"},
#else
{26, 26, 0x0000000000000000, "RW", "cc_rcvenmargin", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{25, 25, 0x0000000000000000, "RW", "cc_rcvenovrval", "Receive enable override value. [br]0: De-assert receive enable [br]1: Assert receive enable"},
#else
{25, 25, 0x0000000000000000, "RW", "cc_rcvenovrval", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{24, 24, 0x0000000000000000, "RW", "cc_rcvenovrsel", "Receive enable override select.[br]0= Dynamic RCVEN control[br]1= Static RCVEN control"},
#else
{24, 24, 0x0000000000000000, "RW", "cc_rcvenovrsel", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{22, 23, 0x0000000000000000, "RO", "reserved541", "Reserved bits"},
#else
{22, 23, 0x0000000000000000, "RO", "reserved541", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{16, 21, 0x0000000000000000, "RW", "cc_rcvenlenbl4", "This is the receive enable length(number of 1x clock) configuration register."},
#else
{16, 21, 0x0000000000000000, "RW", "cc_rcvenlenbl4", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{14, 15, 0x0000000000000000, "RW", "cc_rcvenpst1", "This is the receive enable configuration register - postamble 1 -  new(rise & fall). [br]00 - Rise & Fall - Low & Low[br]01 - Rise & Fall - High & Low[br]10 - Rise & Fall - Low & High[br]11 - Rise & Fall - High & High"},
#else
{14, 15, 0x0000000000000000, "RW", "cc_rcvenpst1", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{12, 13, 0x0000000000000000, "RW", "cc_rcvenpre1", "This is the receive enable configuration register - preamble 1(rise & fall) [br]00 - Rise & Fall - Low & Low[br]01 - Rise & Fall - High & Low[br]10 - Rise & Fall - Low & High[br]11 - Rise & Fall - High & High"},
#else
{12, 13, 0x0000000000000000, "RW", "cc_rcvenpre1", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{10, 11, 0x0000000000000000, "RW", "cc_rcvenpst0", "This is the receive enable configuration register - postamble 0 - new(rise & fall)[br]00 - Rise & Fall - Low & Low[br]01 - Rise & Fall - High & Low[br]10 - Rise & Fall - Low & High[br]11 - Rise & Fall - High & High"},
#else
{10, 11, 0x0000000000000000, "RW", "cc_rcvenpst0", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{8, 9, 0x0000000000000000, "RW", "cc_rcvenpre0", "This is the receive enable configuration register - preamble 0(rise & fall) [br]00 - Rise & Fall - Low & Low[br]01 - Rise & Fall - High & Low[br]10 - Rise & Fall - Low & High[br]11 - Rise & Fall - High & High"},
#else
{8, 9, 0x0000000000000000, "RW", "cc_rcvenpre0", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{6, 7, 0x0000000000000000, "RO", "reserved542", "Reserved bits"},
#else
{6, 7, 0x0000000000000000, "RO", "reserved542", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 5, 0x0000000000000000, "RW", "cc_rdcmd2rcven", "This is the receive enable latency configuration register."},
#else
{0, 5, 0x0000000000000000, "RW", "cc_rdcmd2rcven", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo556[] = {{"rcvenctl_cc", "", 0x00000048, 14, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields557[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{31, 31, 0x0000000000000000, "RO", "drx_bl_rcvsmpl", "AFE status register - RCVSMPL - DQ"},
#else
{31, 31, 0x0000000000000000, "RO", "drx_bl_rcvsmpl", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{28, 30, 0x0000000000000000, "RO", "reserved543", "Reseved bits"},
#else
{28, 30, 0x0000000000000000, "RO", "reserved543", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{27, 27, 0x0000000000000000, "RW", "drx_bl_dqscountrstb", "DQS counter reset"},
#else
{27, 27, 0x0000000000000000, "RW", "drx_bl_dqscountrstb", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{26, 26, 0x0000000000000000, "RW", "bl_rcvenmargin", "Receive enable margining data"},
#else
{26, 26, 0x0000000000000000, "RW", "bl_rcvenmargin", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{25, 25, 0x0000000000000000, "RW", "bl_rcvenovrval", "Receive enable override value. [br]0: De-assert receive enable [br]1: Assert receive enable"},
#else
{25, 25, 0x0000000000000000, "RW", "bl_rcvenovrval", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{24, 24, 0x0000000000000000, "RW", "bl_rcvenovrsel", "Receive enable override select.[br]0= Dynamic RCVEN control[br]1= Static RCVEN control"},
#else
{24, 24, 0x0000000000000000, "RW", "bl_rcvenovrsel", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{22, 23, 0x0000000000000000, "RO", "reserved544", "Reserved bits"},
#else
{22, 23, 0x0000000000000000, "RO", "reserved544", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{16, 21, 0x0000000000000000, "RW", "bl_rcvenlenbl4", "This is the receive enable length(number of 1x clock) configuration register."},
#else
{16, 21, 0x0000000000000000, "RW", "bl_rcvenlenbl4", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{14, 15, 0x0000000000000000, "RW", "bl_rcvenpst1", "This is the receive enable configuration register - postamble 1 -  new(rise & fall). [br]00 - Rise & Fall - Low & Low[br]01 - Rise & Fall - High & Low[br]10 - Rise & Fall - Low & High[br]11 - Rise & Fall - High & High"},
#else
{14, 15, 0x0000000000000000, "RW", "bl_rcvenpst1", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{12, 13, 0x0000000000000000, "RW", "bl_rcvenpre1", "This is the receive enable configuration register - preamble 1(rise & fall) [br]00 - Rise & Fall - Low & Low[br]01 - Rise & Fall - High & Low[br]10 - Rise & Fall - Low & High[br]11 - Rise & Fall - High & High"},
#else
{12, 13, 0x0000000000000000, "RW", "bl_rcvenpre1", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{10, 11, 0x0000000000000000, "RW", "bl_rcvenpst0", "This is the receive enable configuration register - postamble 0 - new(rise & fall)[br]00 - Rise & Fall - Low & Low[br]01 - Rise & Fall - High & Low[br]10 - Rise & Fall - Low & High[br]11 - Rise & Fall - High & High"},
#else
{10, 11, 0x0000000000000000, "RW", "bl_rcvenpst0", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{8, 9, 0x0000000000000000, "RW", "bl_rcvenpre0", "This is the receive enable configuration register - preamble 0(rise & fall) [br]00 - Rise & Fall - Low & Low[br]01 - Rise & Fall - High & Low[br]10 - Rise & Fall - Low & High[br]11 - Rise & Fall - High & High"},
#else
{8, 9, 0x0000000000000000, "RW", "bl_rcvenpre0", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{6, 7, 0x0000000000000000, "RO", "reserved545", "Reserved bits"},
#else
{6, 7, 0x0000000000000000, "RO", "reserved545", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 5, 0x0000000000000000, "RW", "bl_rdcmd2rcven", "This is the receive enable latency configuration register.[br]RL - 1: maps to DRAM RL."},
#else
{0, 5, 0x0000000000000000, "RW", "bl_rdcmd2rcven", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo557[] = {{"rcvenctl_dq", "", 0x0000004C, 14, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields558[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{28, 31, 0x0000000000000000, "RW", "rk1_diffampenrdptroffset", "Differential amplifier read pointer offset control."},
#else
{28, 31, 0x0000000000000000, "RW", "rk1_diffampenrdptroffset", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{27, 27, 0x0000000000000000, "RW", "cc_dqsdiffampenovrval", "Override value for DQS Diffamp enable - DQ Lane"},
#else
{27, 27, 0x0000000000000000, "RW", "cc_dqsdiffampenovrval", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{26, 26, 0x0000000000000000, "RW", "cc_dqsdiffampenovrsel", "Override select for DQS Diffamp enable - DQ Lane"},
#else
{26, 26, 0x0000000000000000, "RW", "cc_dqsdiffampenovrsel", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{25, 25, 0x0000000000000000, "RW", "cc_dqdmdiffampenovrval", "Override value for DQ/DM Diffamp enable - DQ Lane"},
#else
{25, 25, 0x0000000000000000, "RW", "cc_dqdmdiffampenovrval", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{24, 24, 0x0000000000000000, "RW", "cc_dqdmdiffampenovrsel", "Override select for DQ/DM Diffamp enable - DQ Lane"},
#else
{24, 24, 0x0000000000000000, "RW", "cc_dqdmdiffampenovrsel", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{22, 23, 0x0000000000000000, "RW", "cc_diffampenpst1", "This is the diffamp enable configuration register - postamble 1 -  new(rise & fall). [br]00 - Rise & Fall - Low & Low[br]01 - Rise & Fall - High & Low[br]10 - Rise & Fall - Low & High[br]11 - Rise & Fall - High & High"},
#else
{22, 23, 0x0000000000000000, "RW", "cc_diffampenpst1", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{20, 21, 0x0000000000000000, "RW", "cc_diffampenpre1", "This is the diffamp enable configuration register - preamble 1(rise & fall) [br]00 - Rise & Fall - Low & Low[br]01 - Rise & Fall - High & Low[br]10 - Rise & Fall - Low & High[br]11 - Rise & Fall - High & High"},
#else
{20, 21, 0x0000000000000000, "RW", "cc_diffampenpre1", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{18, 19, 0x0000000000000000, "RW", "cc_diffampenpst0", "This is the diffamp enable configuration register - postamble 0 - new(rise & fall)[br]00 - Rise & Fall - Low & Low[br]01 - Rise & Fall - High & Low[br]10 - Rise & Fall - Low & High[br]11 - Rise & Fall - High & High"},
#else
{18, 19, 0x0000000000000000, "RW", "cc_diffampenpst0", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{16, 17, 0x0000000000000000, "RW", "cc_diffampenpre0", "This is the diffamp enable configuration register - preamble 0(rise & fall) [br]00 - Rise & Fall - Low & Low[br]01 - Rise & Fall - High & Low[br]10 - Rise & Fall - Low & High[br]11 - Rise & Fall - High & High"},
#else
{16, 17, 0x0000000000000000, "RW", "cc_diffampenpre0", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{14, 15, 0x0000000000000000, "RO", "reserved546", "Reserved bits"},
#else
{14, 15, 0x0000000000000000, "RO", "reserved546", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{8, 13, 0x0000000000000000, "RW", "cc_diffampenlenbl4", "This is the diffamp enable length(number of 1x clock) configuration register."},
#else
{8, 13, 0x0000000000000000, "RW", "cc_diffampenlenbl4", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{6, 7, 0x0000000000000000, "RO", "reserved547", "Reserved bits"},
#else
{6, 7, 0x0000000000000000, "RO", "reserved547", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 5, 0x0000000000000000, "RW", "cc_rdcmd2diffampen", "This is the Diffamp enable latency register."},
#else
{0, 5, 0x0000000000000000, "RW", "cc_rdcmd2diffampen", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo558[] = {{"diffampctl_cc", "", 0x00000050, 13, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields559[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{28, 31, 0x0000000000000000, "RW", "rk0_diffampenrdptroffset", "Differential amplifier read pointer offset control."},
#else
{28, 31, 0x0000000000000000, "RW", "rk0_diffampenrdptroffset", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{27, 27, 0x0000000000000000, "RW", "bl_dqsdiffampenovrval", "Override value for DQS Diffamp enable - DQ Lane"},
#else
{27, 27, 0x0000000000000000, "RW", "bl_dqsdiffampenovrval", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{26, 26, 0x0000000000000000, "RW", "bl_dqsdiffampenovrsel", "Override select for DQS Diffamp enable - DQ Lane"},
#else
{26, 26, 0x0000000000000000, "RW", "bl_dqsdiffampenovrsel", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{25, 25, 0x0000000000000000, "RW", "bl_dqdmdiffampenovrval", "Override value for DQ/DM Diffamp enable - DQ Lane"},
#else
{25, 25, 0x0000000000000000, "RW", "bl_dqdmdiffampenovrval", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{24, 24, 0x0000000000000000, "RW", "bl_dqdmdiffampenovrsel", "Override select for DQ/DM Diffamp enable - DQ Lane"},
#else
{24, 24, 0x0000000000000000, "RW", "bl_dqdmdiffampenovrsel", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{22, 23, 0x0000000000000000, "RW", "bl_diffampenpst1", "This is the diffamp enable configuration register - postamble 1 -  new(rise & fall). [br]00 - Rise & Fall - Low & Low[br]01 - Rise & Fall - High & Low[br]10 - Rise & Fall - Low & High[br]11 - Rise & Fall - High & High"},
#else
{22, 23, 0x0000000000000000, "RW", "bl_diffampenpst1", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{20, 21, 0x0000000000000000, "RW", "bl_diffampenpre1", "This is the diffamp enable configuration register - preamble 1(rise & fall) [br]00 - Rise & Fall - Low & Low[br]01 - Rise & Fall - High & Low[br]10 - Rise & Fall - Low & High[br]11 - Rise & Fall - High & High"},
#else
{20, 21, 0x0000000000000000, "RW", "bl_diffampenpre1", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{18, 19, 0x0000000000000000, "RW", "bl_diffampenpst0", "This is the diffamp enable configuration register - postamble 0 - new(rise & fall)[br]00 - Rise & Fall - Low & Low[br]01 - Rise & Fall - High & Low[br]10 - Rise & Fall - Low & High[br]11 - Rise & Fall - High & High"},
#else
{18, 19, 0x0000000000000000, "RW", "bl_diffampenpst0", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{16, 17, 0x0000000000000000, "RW", "bl_diffampenpre0", "This is the diffamp enable configuration register - preamble 0(rise & fall) [br]00 - Rise & Fall - Low & Low[br]01 - Rise & Fall - High & Low[br]10 - Rise & Fall - Low & High[br]11 - Rise & Fall - High & High"},
#else
{16, 17, 0x0000000000000000, "RW", "bl_diffampenpre0", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{14, 15, 0x0000000000000000, "RO", "reserved548", "Reserved bits"},
#else
{14, 15, 0x0000000000000000, "RO", "reserved548", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{8, 13, 0x0000000000000000, "RW", "bl_diffampenlenbl4", "This is the diffamp enable length(number of 1x clock) configuration register."},
#else
{8, 13, 0x0000000000000000, "RW", "bl_diffampenlenbl4", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{6, 7, 0x0000000000000000, "RO", "reserved549", "Reserved bits"},
#else
{6, 7, 0x0000000000000000, "RO", "reserved549", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 5, 0x0000000000000000, "RW", "bl_rdcmd2diffampen", "This is the Diffamp enable latency register."},
#else
{0, 5, 0x0000000000000000, "RW", "bl_rdcmd2diffampen", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo559[] = {{"diffampctl_dq", "", 0x00000054, 13, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields560[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{26, 31, 0x0000000000000000, "RO", "reserved550", "Reserved bits"},
#else
{26, 31, 0x0000000000000000, "RO", "reserved550", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{25, 25, 0x0000000000000000, "RW", "cc_wrlvl", "Write Levelization enable - CC Byte Lane"},
#else
{25, 25, 0x0000000000000000, "RW", "cc_wrlvl", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{24, 24, 0x0000000000000000, "RW", "bl_wrlvl", "Write Levelization enable - BL Byte Labe"},
#else
{24, 24, 0x0000000000000000, "RW", "bl_wrlvl", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{16, 23, 0x0000000000000000, "RO", "wrlvl_sample_b1", "DQTRAINSTS - WRLVL sampling from all DQ bit lanes of Bytelane 1"},
#else
{16, 23, 0x0000000000000000, "RO", "wrlvl_sample_b1", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{8, 15, 0x0000000000000000, "RO", "wrlvl_sample_b0", "DQTRAINSTS - WRLVL sampling from all DQ bit lanes of Bytelane 0"},
#else
{8, 15, 0x0000000000000000, "RO", "wrlvl_sample_b0", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{4, 7, 0x0000000000000000, "RO", "reserved551", "Reserved bits"},
#else
{4, 7, 0x0000000000000000, "RO", "reserved551", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{3, 3, 0x0000000000000000, "RO", "wrlvl_and_sample_b1", "DQTRAINSTS - WRLVL Byte1 sample AND combination"},
#else
{3, 3, 0x0000000000000000, "RO", "wrlvl_and_sample_b1", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{2, 2, 0x0000000000000000, "RO", "wrlvl_and_sample_b0", "DQTRAINSTS - WRLVL Byte0 sample AND combination"},
#else
{2, 2, 0x0000000000000000, "RO", "wrlvl_and_sample_b0", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{1, 1, 0x0000000000000000, "RO", "wrlvl_or_sample_b1", "DQTRAINSTS - WRLVL Byte1 sample OR combination"},
#else
{1, 1, 0x0000000000000000, "RO", "wrlvl_or_sample_b1", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 0, 0x0000000000000000, "RO", "wrlvl_or_sample_b0", "DQTRAINSTS - WRLVL Byte0 sample OR combination"},
#else
{0, 0, 0x0000000000000000, "RO", "wrlvl_or_sample_b0", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo560[] = {{"wrlvl", "", 0x00000058, 10, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields561[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{20, 31, 0x0000000000000000, "RO", "reserved552", "Reserved bits"},
#else
{20, 31, 0x0000000000000000, "RO", "reserved552", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{19, 19, 0x0000000000000000, "RW", "dynreadsiggrpen", "Enable Dynamic SIGGRP 2x clock control. 1= SIGGRPEN  controlled by the dynamic clock gating logic (DYNDLLFSM), 0= Statically-controlled SIGGRPEN"},
#else
{19, 19, 0x0000000000000000, "RW", "dynreadsiggrpen", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{18, 18, 0x0000000000000000, "RW", "dynreadref2xclken", "Enable Dynamic REF2XCLK control. 1= ref2xclken  controlled by the dynamic clock gating logic (DYNDLLFSM), 0= Statically-controlled REF2XCLKEN"},
#else
{18, 18, 0x0000000000000000, "RW", "dynreadref2xclken", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{17, 17, 0x0000000000000000, "RW", "dynreadref1xclken", "TBD"},
#else
{17, 17, 0x0000000000000000, "RW", "dynreadref1xclken", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{16, 16, 0x0000000000000000, "RW", "dynreadspidclken", "TBD"},
#else
{16, 16, 0x0000000000000000, "RW", "dynreadspidclken", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{15, 15, 0x0000000000000000, "RO", "reserved553", "Reserved bits"},
#else
{15, 15, 0x0000000000000000, "RO", "reserved553", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{12, 14, 0x0000000000000000, "RW", "read_stoprden", "This is the delay in terms of clocks the dven is disabled before clock gated."},
#else
{12, 14, 0x0000000000000000, "RW", "read_stoprden", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{11, 11, 0x0000000000000000, "RO", "reserved554", "Reserved bits"},
#else
{11, 11, 0x0000000000000000, "RO", "reserved554", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{8, 10, 0x0000000000000000, "RW", "read_startrden", "This is the delay in terms of clocks the drven is enabled, once wrcmd/rdcmd is received."},
#else
{8, 10, 0x0000000000000000, "RW", "read_startrden", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{6, 7, 0x0000000000000000, "RO", "reserved555", "Reserved bits"},
#else
{6, 7, 0x0000000000000000, "RO", "reserved555", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 5, 0x000000000000003F, "RW", "readclkgate_maxcntr", "Clock Gating register : IDLE timer counter max value for clock gating on tx/rx . Counter timeout based on last WRCMD/RDCMD received. 6 bits are good enough since it increments in spidclk."},
#else
{0, 5, 0x000000000000003F, "RW", "readclkgate_maxcntr", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo561[] = {{"clkgaterdctl", "", 0x0000005C, 11, 0x00000000FFFFFFFF, 0x000000000000003F}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields562[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{20, 31, 0x0000000000000000, "RO", "reserved556", "Reserved bits"},
#else
{20, 31, 0x0000000000000000, "RO", "reserved556", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{19, 19, 0x0000000000000000, "RW", "dynwritesiggrpen", "Enable Dynamic SIGGRP 2x clock control. 1= SIGGRPEN  controlled by the dynamic clock gating logic (DYNDLLFSM), 0= Statically-controlled SIGGRPEN"},
#else
{19, 19, 0x0000000000000000, "RW", "dynwritesiggrpen", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{18, 18, 0x0000000000000000, "RW", "dynwriteref2xclken", "Enable Dynamic REF2XCLK control. 1= ref2xclken  controlled by the dynamic clock gating logic (DYNDLLFSM), 0= Statically-controlled REF2XCLKEN"},
#else
{18, 18, 0x0000000000000000, "RW", "dynwriteref2xclken", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{17, 17, 0x0000000000000000, "RW", "dynwriteref1xclken", "TBD"},
#else
{17, 17, 0x0000000000000000, "RW", "dynwriteref1xclken", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{16, 16, 0x0000000000000000, "RW", "dynwritespidclken", "TBD"},
#else
{16, 16, 0x0000000000000000, "RW", "dynwritespidclken", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{15, 15, 0x0000000000000000, "RO", "reserved557", "Reserved bits"},
#else
{15, 15, 0x0000000000000000, "RO", "reserved557", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{12, 14, 0x0000000000000000, "RW", "write_stopdrv", "This is the delay in terms of clocks the dven is disabled before clock gated."},
#else
{12, 14, 0x0000000000000000, "RW", "write_stopdrv", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{11, 11, 0x0000000000000000, "RO", "reserved558", "Reserved bits"},
#else
{11, 11, 0x0000000000000000, "RO", "reserved558", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{8, 10, 0x0000000000000000, "RW", "write_startdrv", "This is the delay in terms of clocks the drven is enabled, once wrcmd/rdcmd is received."},
#else
{8, 10, 0x0000000000000000, "RW", "write_startdrv", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{6, 7, 0x0000000000000000, "RO", "reserved559", "Reserved bits"},
#else
{6, 7, 0x0000000000000000, "RO", "reserved559", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 5, 0x000000000000003F, "RW", "writeclkgate_maxcntr", "Clock Gating register : IDLE timer counter max value for clock gating on tx/rx . Counter timeout based on last WRCMD/RDCMD received. 6 bits are good enough since it increments in spidclk."},
#else
{0, 5, 0x000000000000003F, "RW", "writeclkgate_maxcntr", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo562[] = {{"clkgatewrctl", "", 0x00000060, 11, 0x00000000FFFFFFFF, 0x000000000000003F}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields563[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{20, 31, 0x0000000000000000, "RO", "reserved560", "Reserved bits"},
#else
{20, 31, 0x0000000000000000, "RO", "reserved560", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{19, 19, 0x0000000000000000, "RW", "dynsiggrpen", "Enable Dynamic SIGGRP 2x clock control. 1= SIGGRPEN  controlled by the dynamic clock gating logic (DYNDLLFSM), 0= Statically-controlled SIGGRPEN"},
#else
{19, 19, 0x0000000000000000, "RW", "dynsiggrpen", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{18, 18, 0x0000000000000000, "RW", "dynref2xclken", "Enable Dynamic REF2XCLK control. 1= ref2xclken  controlled by the dynamic clock gating logic (DYNDLLFSM), 0= Statically-controlled REF2XCLKEN"},
#else
{18, 18, 0x0000000000000000, "RW", "dynref2xclken", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{17, 17, 0x0000000000000000, "RW", "dynref1xclken", "TBD"},
#else
{17, 17, 0x0000000000000000, "RW", "dynref1xclken", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{16, 16, 0x0000000000000000, "RW", "dynspidclken", "TBD"},
#else
{16, 16, 0x0000000000000000, "RW", "dynspidclken", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{6, 15, 0x0000000000000000, "RO", "reserved561", "Reserved bits"},
#else
{6, 15, 0x0000000000000000, "RO", "reserved561", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 5, 0x000000000000003F, "RW", "clkgate_maxcntr", "Clock Gating register : IDLE timer counter max value for clock gating on tx/rx . Counter timeout based on last WRCMD/RDCMD received. 6 bits are good enough since it increments in spidclk."},
#else
{0, 5, 0x000000000000003F, "RW", "clkgate_maxcntr", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo563[] = {{"clkgatectl", "", 0x00000064, 7, 0x00000000FFFFFFFF, 0x000000000000003F}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields564[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{30, 31, 0x0000000000000000, "RO", "reserved562", "Reserved bits"},
#else
{30, 31, 0x0000000000000000, "RO", "reserved562", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{28, 29, 0x0000000000000000, "RO", "reserved563", "Reserved bits"},
#else
{28, 29, 0x0000000000000000, "RO", "reserved563", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{24, 27, 0x0000000000000000, "RO", "reserved564", "Reserved bits"},
#else
{24, 27, 0x0000000000000000, "RO", "reserved564", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{16, 23, 0x0000000000000000, "RO", "reserved565", "Reserved bits"},
#else
{16, 23, 0x0000000000000000, "RO", "reserved565", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{14, 15, 0x0000000000000000, "RO", "reserved566", "Reserved bits"},
#else
{14, 15, 0x0000000000000000, "RO", "reserved566", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{12, 13, 0x0000000000000000, "RW", "txdll_rk0siggrp05dbsel", "Deadband select for sig group 5 rank 0"},
#else
{12, 13, 0x0000000000000000, "RW", "txdll_rk0siggrp05dbsel", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{8, 11, 0x0000000000000000, "RW", "txdll_rk0siggrp05rdptroffset", "Read pointer offset for sig group 5 rank 0"},
#else
{8, 11, 0x0000000000000000, "RW", "txdll_rk0siggrp05rdptroffset", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 7, 0x0000000000000000, "RW", "txdll_rk0siggrp05picode", "PI code for sig group 5 rank 0"},
#else
{0, 7, 0x0000000000000000, "RW", "txdll_rk0siggrp05picode", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo564[] = {{"txdllsiggrp5ctl", "", 0x00000068, 8, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields565[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{30, 31, 0x0000000000000000, "RO", "reserved567", "Reserved bits"},
#else
{30, 31, 0x0000000000000000, "RO", "reserved567", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{28, 29, 0x0000000000000000, "RO", "reserved568", "Reserved bits"},
#else
{28, 29, 0x0000000000000000, "RO", "reserved568", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{24, 27, 0x0000000000000000, "RO", "reserved569", "Reserved bits"},
#else
{24, 27, 0x0000000000000000, "RO", "reserved569", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{16, 23, 0x0000000000000000, "RO", "reserved570", "Reserved bits"},
#else
{16, 23, 0x0000000000000000, "RO", "reserved570", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{14, 15, 0x0000000000000000, "RO", "reserved571", "Reserved bits"},
#else
{14, 15, 0x0000000000000000, "RO", "reserved571", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{12, 13, 0x0000000000000000, "RW", "txdll_rk0siggrp04dbsel", "Deadband select for sig group 4 rank 0"},
#else
{12, 13, 0x0000000000000000, "RW", "txdll_rk0siggrp04dbsel", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{8, 11, 0x0000000000000000, "RW", "txdll_rk0siggrp04rdptroffset", "Read pointer offset for sig group 4 rank 0"},
#else
{8, 11, 0x0000000000000000, "RW", "txdll_rk0siggrp04rdptroffset", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 7, 0x0000000000000000, "RW", "txdll_rk0siggrp04picode", "PI code for sig group 4 rank 0"},
#else
{0, 7, 0x0000000000000000, "RW", "txdll_rk0siggrp04picode", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo565[] = {{"txdllsiggrp4ctl", "", 0x0000006C, 8, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields566[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{30, 31, 0x0000000000000000, "RO", "reserved572", "Reserved bits"},
#else
{30, 31, 0x0000000000000000, "RO", "reserved572", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{28, 29, 0x0000000000000000, "RO", "reserved573", "Reserved bits"},
#else
{28, 29, 0x0000000000000000, "RO", "reserved573", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{24, 27, 0x0000000000000000, "RO", "reserved574", "Reserved bits"},
#else
{24, 27, 0x0000000000000000, "RO", "reserved574", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{16, 23, 0x0000000000000000, "RO", "reserved575", "Reserved bits"},
#else
{16, 23, 0x0000000000000000, "RO", "reserved575", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{14, 15, 0x0000000000000000, "RO", "reserved576", "Reserved bits"},
#else
{14, 15, 0x0000000000000000, "RO", "reserved576", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{12, 13, 0x0000000000000000, "RW", "txdll_rk0siggrp03dbsel", "Deadband select for sig group 3 rank 0"},
#else
{12, 13, 0x0000000000000000, "RW", "txdll_rk0siggrp03dbsel", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{8, 11, 0x0000000000000000, "RW", "txdll_rk0siggrp03rdptroffset", "Read pointer offset for sig group 3 rank 0"},
#else
{8, 11, 0x0000000000000000, "RW", "txdll_rk0siggrp03rdptroffset", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 7, 0x0000000000000000, "RW", "txdll_rk0siggrp03picode", "PI code for sig group 3 rank 0"},
#else
{0, 7, 0x0000000000000000, "RW", "txdll_rk0siggrp03picode", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo566[] = {{"txdllsiggrp3ctl", "", 0x00000070, 8, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields567[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{30, 31, 0x0000000000000000, "RO", "reserved577", "Reserved bits"},
#else
{30, 31, 0x0000000000000000, "RO", "reserved577", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{28, 29, 0x0000000000000000, "RW", "txdll_rk1siggrp02dbsel", "Deadband select for sig group 2 rank 1"},
#else
{28, 29, 0x0000000000000000, "RW", "txdll_rk1siggrp02dbsel", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{24, 27, 0x0000000000000000, "RW", "txdll_rk1siggrp02rdptroffset", "Read pointer offset for sig group 2 rank 1"},
#else
{24, 27, 0x0000000000000000, "RW", "txdll_rk1siggrp02rdptroffset", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{16, 23, 0x0000000000000000, "RW", "txdll_rk1siggrp02picode", "PI code for sig group 2 rank 1"},
#else
{16, 23, 0x0000000000000000, "RW", "txdll_rk1siggrp02picode", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{14, 15, 0x0000000000000000, "RO", "reserved578", "Reserved bits"},
#else
{14, 15, 0x0000000000000000, "RO", "reserved578", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{12, 13, 0x0000000000000000, "RW", "txdll_rk0siggrp02dbsel", "Deadband select for sig group 2 rank 0"},
#else
{12, 13, 0x0000000000000000, "RW", "txdll_rk0siggrp02dbsel", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{8, 11, 0x0000000000000000, "RW", "txdll_rk0siggrp02rdptroffset", "Read pointer offset for sig group 2 rank 0"},
#else
{8, 11, 0x0000000000000000, "RW", "txdll_rk0siggrp02rdptroffset", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 7, 0x0000000000000000, "RW", "txdll_rk0siggrp02picode", "PI code for sig group 2 rank 0"},
#else
{0, 7, 0x0000000000000000, "RW", "txdll_rk0siggrp02picode", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo567[] = {{"txdllsiggrp2ctl", "", 0x00000074, 8, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields568[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{30, 31, 0x0000000000000000, "RO", "reserved579", "Reserved bits"},
#else
{30, 31, 0x0000000000000000, "RO", "reserved579", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{28, 29, 0x0000000000000000, "RW", "txdll_rk1siggrp01dbsel", "Deadband select for sig group 1 rank 1"},
#else
{28, 29, 0x0000000000000000, "RW", "txdll_rk1siggrp01dbsel", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{24, 27, 0x0000000000000000, "RW", "txdll_rk1siggrp01rdptroffset", "Read pointer offset for sig group 1 rank 1"},
#else
{24, 27, 0x0000000000000000, "RW", "txdll_rk1siggrp01rdptroffset", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{16, 23, 0x0000000000000000, "RW", "txdll_rk1siggrp01picode", "PI code for sig group 1 rank 1"},
#else
{16, 23, 0x0000000000000000, "RW", "txdll_rk1siggrp01picode", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{14, 15, 0x0000000000000000, "RO", "reserved580", "Reserved bits"},
#else
{14, 15, 0x0000000000000000, "RO", "reserved580", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{12, 13, 0x0000000000000000, "RW", "txdll_rk0siggrp01dbsel", "Deadband select for sig group 1 rank 0"},
#else
{12, 13, 0x0000000000000000, "RW", "txdll_rk0siggrp01dbsel", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{8, 11, 0x0000000000000000, "RW", "txdll_rk0siggrp01rdptroffset", "Read pointer offset for sig group 1 rank 0"},
#else
{8, 11, 0x0000000000000000, "RW", "txdll_rk0siggrp01rdptroffset", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 7, 0x0000000000000000, "RW", "txdll_rk0siggrp01picode", "PI code for sig group 1 rank 0"},
#else
{0, 7, 0x0000000000000000, "RW", "txdll_rk0siggrp01picode", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo568[] = {{"txdllsiggrp1ctl", "", 0x00000078, 8, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields569[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{28, 31, 0x0000000000000000, "RO", "reserved581", "Reserved bits"},
#else
{28, 31, 0x0000000000000000, "RO", "reserved581", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{24, 27, 0x0000000000000000, "RW", "txdll_rk1siggrp00rdptroffset", "Read pointer offset for sig group 0 rank 1"},
#else
{24, 27, 0x0000000000000000, "RW", "txdll_rk1siggrp00rdptroffset", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{16, 23, 0x0000000000000000, "RW", "txdll_rk1siggrp00picode", "PI code for sig group 0 rank 1"},
#else
{16, 23, 0x0000000000000000, "RW", "txdll_rk1siggrp00picode", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{12, 15, 0x0000000000000000, "RO", "reserved582", "Reserved bits"},
#else
{12, 15, 0x0000000000000000, "RO", "reserved582", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{8, 11, 0x0000000000000000, "RW", "txdll_rk0siggrp00rdptroffset", "Read pointer offset for sig group 0 rank 0"},
#else
{8, 11, 0x0000000000000000, "RW", "txdll_rk0siggrp00rdptroffset", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 7, 0x0000000000000000, "RW", "txdll_rk0siggrp00picode", "PI code for sig group 0 rank 0"},
#else
{0, 7, 0x0000000000000000, "RW", "txdll_rk0siggrp00picode", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo569[] = {{"txdllsiggrp0ctl", "", 0x0000007C, 6, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields570[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{31, 31, 0x0000000000000000, "RO", "reserved583", "Reserved bits"},
#else
{31, 31, 0x0000000000000000, "RO", "reserved583", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{30, 30, 0x0000000000000000, "RW", "lvl_cc_weakpupstatic", "Weak Pull Up Control - CC Lane"},
#else
{30, 30, 0x0000000000000000, "RW", "lvl_cc_weakpupstatic", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{24, 29, 0x0000000000000000, "RW", "lvl_cc_weakpup", "Weak Pull Up Control - CC Lane"},
#else
{24, 29, 0x0000000000000000, "RW", "lvl_cc_weakpup", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{23, 23, 0x0000000000000000, "RO", "reserved584", "Reserved bits"},
#else
{23, 23, 0x0000000000000000, "RO", "reserved584", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{22, 22, 0x0000000000000000, "RW", "lvl_cc_weakpdnstatic", "Weak Pull Down Control - CC Lane"},
#else
{22, 22, 0x0000000000000000, "RW", "lvl_cc_weakpdnstatic", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{16, 21, 0x0000000000000000, "RW", "lvl_cc_weakpdn", "Weak Pull Down Control - CC Lane"},
#else
{16, 21, 0x0000000000000000, "RW", "lvl_cc_weakpdn", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{15, 15, 0x0000000000000000, "RO", "reserved585", "Reserved bits"},
#else
{15, 15, 0x0000000000000000, "RO", "reserved585", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{14, 14, 0x0000000000000000, "RW", "lvl_bl_weakpupstatic", "Weak Pull Up Control static bit for DQS - DQ Lane"},
#else
{14, 14, 0x0000000000000000, "RW", "lvl_bl_weakpupstatic", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{8, 13, 0x0000000000000000, "RW", "lvl_bl_weakpup", "Weak Pull Up Control code for DQS - DQ Lane"},
#else
{8, 13, 0x0000000000000000, "RW", "lvl_bl_weakpup", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{7, 7, 0x0000000000000000, "RO", "reserved586", "Reserved bits"},
#else
{7, 7, 0x0000000000000000, "RO", "reserved586", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{6, 6, 0x0000000000000000, "RW", "lvl_bl_weakpdnstatic", "Weak Pull Down Control static bit for DQS - DQ Lane"},
#else
{6, 6, 0x0000000000000000, "RW", "lvl_bl_weakpdnstatic", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 5, 0x0000000000000000, "RW", "lvl_bl_weakpdn", "Weak Pull Down Control code for DQS - DQ Lane"},
#else
{0, 5, 0x0000000000000000, "RW", "lvl_bl_weakpdn", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo570[] = {{"wkpuppdnctl", "", 0x00000080, 12, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields571[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{31, 31, 0x0000000000000000, "RO", "reserved587", "Reserved bits"},
#else
{31, 31, 0x0000000000000000, "RO", "reserved587", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{28, 30, 0x0000000000000007, "RW", "dtx_cc_drvsegen", "Segment enable for CC buffer. Used for per leg testing in HVM"},
#else
{28, 30, 0x0000000000000007, "RW", "dtx_cc_drvsegen", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{27, 27, 0x0000000000000000, "RO", "reserved588", "Reserved bits"},
#else
{27, 27, 0x0000000000000000, "RO", "reserved588", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{24, 26, 0x0000000000000007, "RW", "tx_cc_drvsegen", "Segment enable for CC buffer. Used for per leg testing in HVM"},
#else
{24, 26, 0x0000000000000007, "RW", "tx_cc_drvsegen", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{23, 23, 0x0000000000000000, "RO", "reserved589", "Reserved bits"},
#else
{23, 23, 0x0000000000000000, "RO", "reserved589", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{20, 22, 0x0000000000000007, "RW", "dtx_bl_drvsegen", "Segment enable for CC buffer. Used for per leg testing in HVM"},
#else
{20, 22, 0x0000000000000007, "RW", "dtx_bl_drvsegen", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{19, 19, 0x0000000000000000, "RO", "reserved590", "Reserved bits"},
#else
{19, 19, 0x0000000000000000, "RO", "reserved590", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{16, 18, 0x0000000000000007, "RW", "tx_bl_drvsegen", "Segment enable for CC buffer. Used for per leg testing in HVM"},
#else
{16, 18, 0x0000000000000007, "RW", "tx_bl_drvsegen", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{15, 15, 0x0000000000000000, "RO", "reserved591", "Reserved bits"},
#else
{15, 15, 0x0000000000000000, "RO", "reserved591", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{12, 14, 0x0000000000000001, "RW", "rxdll_cc_picapsel", "set cap tuning for pi"},
#else
{12, 14, 0x0000000000000001, "RW", "rxdll_cc_picapsel", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{11, 11, 0x0000000000000000, "RO", "reserved592", "Reserved bits"},
#else
{11, 11, 0x0000000000000000, "RO", "reserved592", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{8, 10, 0x0000000000000001, "RW", "rxdll_bl_picapsel", "set cap tuning for pi"},
#else
{8, 10, 0x0000000000000001, "RW", "rxdll_bl_picapsel", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{7, 7, 0x0000000000000000, "RO", "reserved593", "Reserved bits"},
#else
{7, 7, 0x0000000000000000, "RO", "reserved593", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{4, 6, 0x0000000000000001, "RW", "txdll_picapsel", "set cap tuning for pi"},
#else
{4, 6, 0x0000000000000001, "RW", "txdll_picapsel", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{3, 3, 0x0000000000000000, "RW", "dtx_cc_allfire", "Bypasses slewrate staggering"},
#else
{3, 3, 0x0000000000000000, "RW", "dtx_cc_allfire", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{2, 2, 0x0000000000000000, "RW", "dtx_bl_allfire", "Bypasses slewrate staggering"},
#else
{2, 2, 0x0000000000000000, "RW", "dtx_bl_allfire", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{1, 1, 0x0000000000000000, "RW", "tx_cc_allfire", "Bypasses slewrate staggering"},
#else
{1, 1, 0x0000000000000000, "RW", "tx_cc_allfire", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 0, 0x0000000000000000, "RW", "tx_bl_allfire", "Bypasses slewrate staggering"},
#else
{0, 0, 0x0000000000000000, "RW", "tx_bl_allfire", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo571[] = {{"afemisc1", "", 0x00000084, 18, 0x00000000FFFFFFFF, 0x0000000077771110}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields572[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{30, 31, 0x0000000000000000, "RW", "dtx_cc_drvenstretch", "Streches rising edge of drivenable to relax data to enable skew."},
#else
{30, 31, 0x0000000000000000, "RW", "dtx_cc_drvenstretch", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{28, 29, 0x0000000000000000, "RW", "dtx_bl_drvenstretch", "Streches rising edge of drivenable to relax data to enable skew."},
#else
{28, 29, 0x0000000000000000, "RW", "dtx_bl_drvenstretch", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{26, 27, 0x0000000000000000, "RW", "tx_cc_drvenstretch", "Streches rising edge of drivenable to relax data to enable skew."},
#else
{26, 27, 0x0000000000000000, "RW", "tx_cc_drvenstretch", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{24, 25, 0x0000000000000000, "RW", "tx_bl_drvenstretch", "Streches rising edge of drivenable to relax data to enable skew."},
#else
{24, 25, 0x0000000000000000, "RW", "tx_bl_drvenstretch", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{22, 23, 0x0000000000000001, "RW", "drx_cc_rxpwrmode", "00 = low power rx;[br]01 = high power rx (default)"},
#else
{22, 23, 0x0000000000000001, "RW", "drx_cc_rxpwrmode", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{20, 21, 0x0000000000000001, "RW", "rx_cc_rxpwrmode", "00 = low power rx;[br]01 = high power rx (default)"},
#else
{20, 21, 0x0000000000000001, "RW", "rx_cc_rxpwrmode", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{18, 19, 0x0000000000000001, "RW", "drx_bl_rxpwrmode", "00 = low power rx;[br]01 = high power rx (default)"},
#else
{18, 19, 0x0000000000000001, "RW", "drx_bl_rxpwrmode", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{16, 17, 0x0000000000000001, "RW", "rx_bl_rxpwrmode", "00 = low power rx;[br]01 = high power rx (default)"},
#else
{16, 17, 0x0000000000000001, "RW", "rx_bl_rxpwrmode", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{12, 15, 0x0000000000000000, "RO", "reserved594", "Reserved bits"},
#else
{12, 15, 0x0000000000000000, "RO", "reserved594", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{11, 11, 0x0000000000000001, "RW", "drx_cc_rxcommonmode", "changes the common mode of receiver from low common mode to vcc/2 based on lpddr3/ lpddr4."},
#else
{11, 11, 0x0000000000000001, "RW", "drx_cc_rxcommonmode", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{10, 10, 0x0000000000000001, "RW", "drx_bl_rxcommonmode", "changes the common mode of receiver from low common mode to vcc/2 based on lpddr3/ lpddr4."},
#else
{10, 10, 0x0000000000000001, "RW", "drx_bl_rxcommonmode", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{9, 9, 0x0000000000000001, "RW", "rx_cc_rxcommonmode", "changes the common mode of receiver from low common mode to vcc/2 based on lpddr3/ lpddr4."},
#else
{9, 9, 0x0000000000000001, "RW", "rx_cc_rxcommonmode", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{8, 8, 0x0000000000000001, "RW", "rx_bl_rxcommonmode", "changes the common mode of receiver from low common mode to vcc/2 based on lpddr3/ lpddr4."},
#else
{8, 8, 0x0000000000000001, "RW", "rx_bl_rxcommonmode", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{7, 7, 0x0000000000000001, "RW", "pdndrvstatic", "Static pull down code - DRV DQ"},
#else
{7, 7, 0x0000000000000001, "RW", "pdndrvstatic", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{6, 6, 0x0000000000000001, "RW", "pdndrvstaticdqs", "Static pull down code - DRV DQS/DQSB"},
#else
{6, 6, 0x0000000000000001, "RW", "pdndrvstaticdqs", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{5, 5, 0x0000000000000001, "RW", "pdnodtstatic", "Static pull down code - ODT DQ"},
#else
{5, 5, 0x0000000000000001, "RW", "pdnodtstatic", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{4, 4, 0x0000000000000001, "RW", "pdnodtstaticdqs", "Static pull down code - ODT DQS/DQSB"},
#else
{4, 4, 0x0000000000000001, "RW", "pdnodtstaticdqs", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{3, 3, 0x0000000000000001, "RW", "pupdrvstatic", "Static pull up code - DRV DQ"},
#else
{3, 3, 0x0000000000000001, "RW", "pupdrvstatic", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{2, 2, 0x0000000000000001, "RW", "pupdrvstaticdqs", "Static pull up code - DRV DQS/DQSB"},
#else
{2, 2, 0x0000000000000001, "RW", "pupdrvstaticdqs", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{1, 1, 0x0000000000000001, "RW", "pupodtstatic", "Static pull up code - ODT DQ"},
#else
{1, 1, 0x0000000000000001, "RW", "pupodtstatic", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 0, 0x0000000000000001, "RW", "pupodtstaticdqs", "Static pull up code - ODT DQS/DQSB"},
#else
{0, 0, 0x0000000000000001, "RW", "pupodtstaticdqs", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo572[] = {{"afemisc0", "", 0x00000088, 21, 0x00000000FFFFFFFF, 0x0000000000550FFF}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields573[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{8, 31, 0x0000000000000000, "RO", "reserved595", "Reserved bits"},
#else
{8, 31, 0x0000000000000000, "RO", "reserved595", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{4, 7, 0x0000000000000000, "RW", "lvl_cc_bonus", "Bonus bits - CC Lane"},
#else
{4, 7, 0x0000000000000000, "RW", "lvl_cc_bonus", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 3, 0x0000000000000000, "RW", "lvl_bl_bonus", "Bonus bits - DQ Lane"},
#else
{0, 3, 0x0000000000000000, "RW", "lvl_bl_bonus", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo573[] = {{"afebonus", "", 0x0000008C, 3, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields574[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{28, 31, 0x0000000000000000, "RW", "txdll_digobs1sel", "Digital observation select mux port 1"},
#else
{28, 31, 0x0000000000000000, "RW", "txdll_digobs1sel", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{24, 27, 0x0000000000000000, "RW", "txdll_digobs0sel", "Digital observation select mux port 0"},
#else
{24, 27, 0x0000000000000000, "RW", "txdll_digobs0sel", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{23, 23, 0x0000000000000000, "RW", "rxdll_cc_digobsen", "digital buf obs enable (1=enable;0=disable)"},
#else
{23, 23, 0x0000000000000000, "RW", "rxdll_cc_digobsen", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{22, 22, 0x0000000000000000, "RW", "rxdll_bl_digobsen", "digital buf obs enable (1=enable;0=disable)"},
#else
{22, 22, 0x0000000000000000, "RW", "rxdll_bl_digobsen", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{21, 21, 0x0000000000000000, "RW", "dtx_cc_digobsen", "digital buf obs enable (1=enable;0=disable)"},
#else
{21, 21, 0x0000000000000000, "RW", "dtx_cc_digobsen", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{20, 20, 0x0000000000000000, "RO", "reserved596", "Reserved bits"},
#else
{20, 20, 0x0000000000000000, "RO", "reserved596", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{19, 19, 0x0000000000000000, "RW", "txdll_digobsen", "digital buf obs enable (1=enable;0=disable)"},
#else
{19, 19, 0x0000000000000000, "RW", "txdll_digobsen", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{18, 18, 0x0000000000000000, "RW", "dtx_bl_digobsen", "digital buf obs enable (1=enable;0=disable)"},
#else
{18, 18, 0x0000000000000000, "RW", "dtx_bl_digobsen", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{16, 17, 0x0000000000000000, "RO", "reserved597", "Reserved bits"},
#else
{16, 17, 0x0000000000000000, "RO", "reserved597", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{12, 15, 0x0000000000000000, "RW", "rxdll_bl_digobs1sel", "Digital observation select mux port 1"},
#else
{12, 15, 0x0000000000000000, "RW", "rxdll_bl_digobs1sel", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{8, 11, 0x0000000000000000, "RW", "rxdll_bl_digobs0sel", "Digital observation select mux port 0"},
#else
{8, 11, 0x0000000000000000, "RW", "rxdll_bl_digobs0sel", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{4, 7, 0x0000000000000000, "RW", "rxdll_cc_digobs1sel", "Digital observation select mux port 1"},
#else
{4, 7, 0x0000000000000000, "RW", "rxdll_cc_digobs1sel", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 3, 0x0000000000000000, "RW", "rxdll_cc_digobs0sel", "Digital observation select mux port 0"},
#else
{0, 3, 0x0000000000000000, "RW", "rxdll_cc_digobs0sel", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo574[] = {{"digobsctl1", "", 0x00000090, 13, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields575[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{31, 31, 0x0000000000000000, "RO", "reserved598", "Reserved bits"},
#else
{31, 31, 0x0000000000000000, "RO", "reserved598", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{28, 30, 0x0000000000000000, "RW", "dtx_cc_digobs1sel", "Digital observation select mux port 1"},
#else
{28, 30, 0x0000000000000000, "RW", "dtx_cc_digobs1sel", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{27, 27, 0x0000000000000000, "RO", "reserved599", "Reserved bits"},
#else
{27, 27, 0x0000000000000000, "RO", "reserved599", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{24, 26, 0x0000000000000000, "RW", "dtx_cc_digobs0sel", "Digital observation select mux port 0"},
#else
{24, 26, 0x0000000000000000, "RW", "dtx_cc_digobs0sel", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{23, 23, 0x0000000000000000, "RO", "reserved600", "Reserved bits"},
#else
{23, 23, 0x0000000000000000, "RO", "reserved600", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{20, 22, 0x0000000000000000, "RW", "dtx_bl_digobs1sel", "Digital observation select mux port 1"},
#else
{20, 22, 0x0000000000000000, "RW", "dtx_bl_digobs1sel", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{19, 19, 0x0000000000000000, "RO", "reserved601", "Reserved bits"},
#else
{19, 19, 0x0000000000000000, "RO", "reserved601", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{16, 18, 0x0000000000000000, "RW", "dtx_bl_digobs0sel", "Digital observation select mux port 0"},
#else
{16, 18, 0x0000000000000000, "RW", "dtx_bl_digobs0sel", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{15, 15, 0x0000000000000000, "RO", "reserved602", "Reserved bits"},
#else
{15, 15, 0x0000000000000000, "RO", "reserved602", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{12, 14, 0x0000000000000000, "RW", "tx_cc_digobs1sel", "Digital observation select mux port 1"},
#else
{12, 14, 0x0000000000000000, "RW", "tx_cc_digobs1sel", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{11, 11, 0x0000000000000000, "RO", "reserved603", "Reserved bits"},
#else
{11, 11, 0x0000000000000000, "RO", "reserved603", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{8, 10, 0x0000000000000000, "RW", "tx_cc_digobs0sel", "Digital observation select mux port 0"},
#else
{8, 10, 0x0000000000000000, "RW", "tx_cc_digobs0sel", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{7, 7, 0x0000000000000000, "RO", "reserved604", "Reserved bits"},
#else
{7, 7, 0x0000000000000000, "RO", "reserved604", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{4, 6, 0x0000000000000000, "RW", "tx_bl_digobs1sel", "Digital observation select mux port 1"},
#else
{4, 6, 0x0000000000000000, "RW", "tx_bl_digobs1sel", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{3, 3, 0x0000000000000000, "RO", "reserved605", "Reserved bits"},
#else
{3, 3, 0x0000000000000000, "RO", "reserved605", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 2, 0x0000000000000000, "RW", "tx_bl_digobs0sel", "Digital observation select mux port 0"},
#else
{0, 2, 0x0000000000000000, "RW", "tx_bl_digobs0sel", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo575[] = {{"digobsctl0", "", 0x00000094, 16, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields576[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{29, 31, 0x0000000000000000, "RO", "reserved606", "Reserved bits"},
#else
{29, 31, 0x0000000000000000, "RO", "reserved606", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{24, 28, 0x0000000000000000, "RW", "rxdll_rxmuxsel", "enable strobe output from rx sdll.for each byte"},
#else
{24, 28, 0x0000000000000000, "RW", "rxdll_rxmuxsel", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{22, 23, 0x0000000000000000, "RO", "reserved607", "enable strobe output from rx sdll.for each byte"},
#else
{22, 23, 0x0000000000000000, "RO", "reserved607", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{21, 21, 0x0000000000000000, "RW", "txdll_dllfloprstb", "TxDLL flop reset"},
#else
{21, 21, 0x0000000000000000, "RW", "txdll_dllfloprstb", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{20, 20, 0x0000000000000000, "RW", "rxdll_dllfloprstb", "RxDLL flop reset"},
#else
{20, 20, 0x0000000000000000, "RW", "rxdll_dllfloprstb", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{19, 19, 0x0000000000000000, "RO", "reserved608", "enable strobe output from rx sdll.for each byte"},
#else
{19, 19, 0x0000000000000000, "RO", "reserved608", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{18, 18, 0x0000000000000000, "RW", "rxdll_bl_dqsouten", "enable strobe output from rx sdll.for each byte"},
#else
{18, 18, 0x0000000000000000, "RW", "rxdll_bl_dqsouten", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{17, 17, 0x0000000000000000, "RO", "reserved609", "enable data output from dq and dm pi's. for each byte"},
#else
{17, 17, 0x0000000000000000, "RO", "reserved609", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{16, 16, 0x0000000000000000, "RW", "rxdll_bl_rxdllen", "Rx DLL enable"},
#else
{16, 16, 0x0000000000000000, "RW", "rxdll_bl_rxdllen", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 15, 0x0000000000000000, "RO", "reserved610", "Reserved bits"},
#else
{0, 15, 0x0000000000000000, "RO", "reserved610", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo576[] = {{"rxdllctl_dqbldm", "", 0x00000098, 10, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields577[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{19, 31, 0x0000000000000000, "RO", "reserved611", "Reserved bits"},
#else
{19, 31, 0x0000000000000000, "RO", "reserved611", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{18, 18, 0x0000000000000000, "RW", "rxdll_cc_dqsouten", "enable strobe output from rx sdll.for each byte"},
#else
{18, 18, 0x0000000000000000, "RW", "rxdll_cc_dqsouten", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{17, 17, 0x0000000000000000, "RO", "reserved612", "enable data output from dq and dm pi's. for each byte"},
#else
{17, 17, 0x0000000000000000, "RO", "reserved612", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{16, 16, 0x0000000000000000, "RW", "rxdll_cc_rxdllen", "Rx DLL enable"},
#else
{16, 16, 0x0000000000000000, "RW", "rxdll_cc_rxdllen", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{1, 15, 0x0000000000000000, "RO", "reserved613", "Reserved bits"},
#else
{1, 15, 0x0000000000000000, "RO", "reserved613", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 0, 0x0000000000000000, "RW", "txdll_ref2xph0pien", "enable tx ref pi phase 0 enable"},
#else
{0, 0, 0x0000000000000000, "RW", "txdll_ref2xph0pien", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo577[] = {{"rxdllctl_ccbldm", "", 0x0000009C, 6, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields578[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{18, 31, 0x0000000000000000, "RO", "reserved614", "Reserved bits"},
#else
{18, 31, 0x0000000000000000, "RO", "reserved614", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{17, 17, 0x0000000000000000, "RO", "reserved615", "Reserved bits"},
#else
{17, 17, 0x0000000000000000, "RO", "reserved615", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{16, 16, 0x0000000000000000, "RW", "txdll_mdllen", "MDLL enable"},
#else
{16, 16, 0x0000000000000000, "RW", "txdll_mdllen", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{14, 15, 0x0000000000000000, "RO", "reserved616", "Reserved bits"},
#else
{14, 15, 0x0000000000000000, "RO", "reserved616", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{13, 13, 0x0000000000000000, "RW", "txdll_siggrp05pien", "PI enable for sig group 5 rank 0"},
#else
{13, 13, 0x0000000000000000, "RW", "txdll_siggrp05pien", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{12, 12, 0x0000000000000000, "RW", "txdll_siggrp04pien", "PI enable for sig group 4 rank 0"},
#else
{12, 12, 0x0000000000000000, "RW", "txdll_siggrp04pien", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{11, 11, 0x0000000000000000, "RW", "txdll_siggrp03pien", "PI enable for sig group 3 rank 0"},
#else
{11, 11, 0x0000000000000000, "RW", "txdll_siggrp03pien", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{10, 10, 0x0000000000000000, "RW", "txdll_siggrp02pien", "PI enable for sig group 2 rank 0"},
#else
{10, 10, 0x0000000000000000, "RW", "txdll_siggrp02pien", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{9, 9, 0x0000000000000000, "RW", "txdll_siggrp01pien", "PI enable for sig group 1 rank 0"},
#else
{9, 9, 0x0000000000000000, "RW", "txdll_siggrp01pien", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{8, 8, 0x0000000000000000, "RW", "txdll_siggrp00pien", "PI enable for sig group 0 rank 0"},
#else
{8, 8, 0x0000000000000000, "RW", "txdll_siggrp00pien", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{4, 7, 0x0000000000000000, "RO", "reserved617", "Reserved bits"},
#else
{4, 7, 0x0000000000000000, "RO", "reserved617", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{3, 3, 0x0000000000000000, "RW", "txdll_ref2xph270pien", "enable tx ref pi phase 270 enable"},
#else
{3, 3, 0x0000000000000000, "RW", "txdll_ref2xph270pien", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{2, 2, 0x0000000000000000, "RW", "txdll_ref2xph180pien", "enable tx ref pi phase 180 enable"},
#else
{2, 2, 0x0000000000000000, "RW", "txdll_ref2xph180pien", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{1, 1, 0x0000000000000000, "RW", "txdll_ref2xph90pien", "enable tx ref pi phase 90 enable"},
#else
{1, 1, 0x0000000000000000, "RW", "txdll_ref2xph90pien", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 0, 0x0000000000000000, "RO", "reserved618", "Reseved bits"},
#else
{0, 0, 0x0000000000000000, "RO", "reserved618", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo578[] = {{"txdllctl", "", 0x000000A0, 15, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields579[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{24, 31, 0x0000000000000000, "RO", "reserved619", "Reserved bits"},
#else
{24, 31, 0x0000000000000000, "RO", "reserved619", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{16, 23, 0x0000000000000000, "RW", "txdll_ref2xph270picode", "pi code for ref pi phase 270 output"},
#else
{16, 23, 0x0000000000000000, "RW", "txdll_ref2xph270picode", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{8, 15, 0x0000000000000000, "RW", "txdll_ref2xph180picode", "pi code for ref pi phase 180 output"},
#else
{8, 15, 0x0000000000000000, "RW", "txdll_ref2xph180picode", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 7, 0x0000000000000000, "RW", "txdll_ref2xph90picode", "pi code for ref pi phase 90 output"},
#else
{0, 7, 0x0000000000000000, "RW", "txdll_ref2xph90picode", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo579[] = {{"txdllref2xctl", "", 0x000000A4, 4, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields580[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{24, 31, 0x0000000000000000, "RW", "rxdll_bl_rk1dqshipicode", "pi code for rx rising dqs edge - DQ Lane"},
#else
{24, 31, 0x0000000000000000, "RW", "rxdll_bl_rk1dqshipicode", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{16, 23, 0x0000000000000000, "RW", "rxdll_bl_rk1dqslopicode", "pi code for rx falling dqs edge - DQ Lane"},
#else
{16, 23, 0x0000000000000000, "RW", "rxdll_bl_rk1dqslopicode", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{8, 15, 0x0000000000000000, "RO", "reserved620", "Reserved bits"},
#else
{8, 15, 0x0000000000000000, "RO", "reserved620", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 7, 0x0000000000000000, "RO", "reserved621", "Reserved bits"},
#else
{0, 7, 0x0000000000000000, "RO", "reserved621", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo580[] = {{"rxdlldqsrk1ctl", "", 0x000000A8, 4, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields581[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{24, 31, 0x0000000000000000, "RW", "rxdll_bl_rk0dqshipicode", "pi code for rx rising dqs edge - DQ Lane"},
#else
{24, 31, 0x0000000000000000, "RW", "rxdll_bl_rk0dqshipicode", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{16, 23, 0x0000000000000000, "RW", "rxdll_bl_rk0dqslopicode", "pi code for rx falling dqs edge - DQ Lane"},
#else
{16, 23, 0x0000000000000000, "RW", "rxdll_bl_rk0dqslopicode", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{8, 15, 0x0000000000000000, "RW", "rxdll_cc_rk0dqshipicode", "pi code for rx rising dqs edge  - CC Lane"},
#else
{8, 15, 0x0000000000000000, "RW", "rxdll_cc_rk0dqshipicode", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 7, 0x0000000000000000, "RW", "rxdll_cc_rk0dqslopicode", "pi code for rx falling dqs edge  - CC Lane"},
#else
{0, 7, 0x0000000000000000, "RW", "rxdll_cc_rk0dqslopicode", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo581[] = {{"rxdlldqsrk0ctl", "", 0x000000AC, 4, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields582[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{1, 31, 0x0000000000000000, "RO", "reserved622", "Reserved bits"},
#else
{1, 31, 0x0000000000000000, "RO", "reserved622", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 0, 0x0000000000000001, "RW", "txvref_cmn_vrefbufen", "enable signal for the tx vref unity gain buffer"},
#else
{0, 0, 0x0000000000000001, "RW", "txvref_cmn_vrefbufen", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo582[] = {{"vrefctl1", "", 0x000000B0, 2, 0x00000000FFFFFFFF, 0x0000000000000001}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields583[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{24, 31, 0x0000000000000000, "RW", "vref_txlcompvrefctrl", "vref decode signal for the lcomp"},
#else
{24, 31, 0x0000000000000000, "RW", "vref_txlcompvrefctrl", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{22, 23, 0x0000000000000000, "RO", "reserved623", "Reserved bits"},
#else
{22, 23, 0x0000000000000000, "RO", "reserved623", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{21, 21, 0x0000000000000000, "RW", "lvl_bl_vrefiobufact", "vrefiobufact - DQ Lane"},
#else
{21, 21, 0x0000000000000000, "RW", "lvl_bl_vrefiobufact", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{20, 20, 0x0000000000000000, "RW", "lvl_cc_vrefiobufact", "vrefiobufact - CC Lane"},
#else
{20, 20, 0x0000000000000000, "RW", "lvl_cc_vrefiobufact", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{17, 19, 0x0000000000000000, "RO", "reserved624", "Reserved bits"},
#else
{17, 19, 0x0000000000000000, "RO", "reserved624", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{16, 16, 0x0000000000000000, "RW", "vref_vrefcmctrl", "common mode select to choose between lpddr3;lpddr4"},
#else
{16, 16, 0x0000000000000000, "RW", "vref_vrefcmctrl", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{8, 15, 0x0000000000000020, "RW", "vref_rxblvrefctrl", "vref decode signal for the b0 rx vref"},
#else
{8, 15, 0x0000000000000020, "RW", "vref_rxblvrefctrl", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 7, 0x0000000000000020, "RW", "vref_rxccvrefctrl", "vref decode signal for the cc0 rx vref"},
#else
{0, 7, 0x0000000000000020, "RW", "vref_rxccvrefctrl", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo583[] = {{"vrefctl0", "", 0x000000B4, 8, 0x00000000FFFFFFFF, 0x0000000000002020}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields584[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{4, 31, 0x0000000000000000, "RO", "reserved625", "Reserved bits"},
#else
{4, 31, 0x0000000000000000, "RO", "reserved625", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 3, 0x0000000000000000, "RW", "rxdll_bl_dq8rxpbdcode", "Rx Per bit De-skew code for dq0 valid codes"},
#else
{0, 3, 0x0000000000000000, "RW", "rxdll_bl_dq8rxpbdcode", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo584[] = {{"rxbl8pbdctl", "", 0x000000B8, 2, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields585[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{28, 31, 0x0000000000000000, "RW", "rxdll_bl_dq7rxpbdcode", "Rx Per bit De-skew code for dq0 valid codes"},
#else
{28, 31, 0x0000000000000000, "RW", "rxdll_bl_dq7rxpbdcode", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{24, 27, 0x0000000000000000, "RW", "rxdll_bl_dq6rxpbdcode", "Rx Per bit De-skew code for dq0 valid codes"},
#else
{24, 27, 0x0000000000000000, "RW", "rxdll_bl_dq6rxpbdcode", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{20, 23, 0x0000000000000000, "RW", "rxdll_bl_dq5rxpbdcode", "Rx Per bit De-skew code for dq0 valid codes"},
#else
{20, 23, 0x0000000000000000, "RW", "rxdll_bl_dq5rxpbdcode", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{16, 19, 0x0000000000000000, "RW", "rxdll_bl_dq4rxpbdcode", "Rx Per bit De-skew code for dq0 valid codes"},
#else
{16, 19, 0x0000000000000000, "RW", "rxdll_bl_dq4rxpbdcode", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{12, 15, 0x0000000000000000, "RW", "rxdll_bl_dq3rxpbdcode", "Rx Per bit De-skew code for dq0 valid codes"},
#else
{12, 15, 0x0000000000000000, "RW", "rxdll_bl_dq3rxpbdcode", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{8, 11, 0x0000000000000000, "RW", "rxdll_bl_dq2rxpbdcode", "Rx Per bit De-skew code for dq0 valid codes"},
#else
{8, 11, 0x0000000000000000, "RW", "rxdll_bl_dq2rxpbdcode", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{4, 7, 0x0000000000000000, "RW", "rxdll_bl_dq1rxpbdcode", "Rx Per bit De-skew code for dq0 valid codes"},
#else
{4, 7, 0x0000000000000000, "RW", "rxdll_bl_dq1rxpbdcode", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 3, 0x0000000000000000, "RW", "rxdll_bl_dq0rxpbdcode", "Rx Per bit De-skew code for dq0 valid codes"},
#else
{0, 3, 0x0000000000000000, "RW", "rxdll_bl_dq0rxpbdcode", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo585[] = {{"rxpbdblctl", "", 0x000000BC, 8, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields586[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{24, 31, 0x0000000000000000, "RO", "reserved626", "Reserved bits"},
#else
{24, 31, 0x0000000000000000, "RO", "reserved626", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{23, 23, 0x0000000000000000, "RW", "rxdll_cc_rxpbden", "Rx Per Bit De-skew enable (1=enable, 0=disable), 0 for cc always"},
#else
{23, 23, 0x0000000000000000, "RW", "rxdll_cc_rxpbden", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{22, 22, 0x0000000000000000, "RW", "rxdll_bl_rxpbden", "Rx Per Bit De-skew enable (1=enable, 0=disable)"},
#else
{22, 22, 0x0000000000000000, "RW", "rxdll_bl_rxpbden", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{4, 21, 0x0000000000000000, "RO", "reserved627", "Reserved bits"},
#else
{4, 21, 0x0000000000000000, "RO", "reserved627", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{3, 3, 0x0000000000000000, "RW", "tx_cc_pbdstaticlegen", "Per bit deskew enable - TX - CC"},
#else
{3, 3, 0x0000000000000000, "RW", "tx_cc_pbdstaticlegen", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{2, 2, 0x0000000000000000, "RW", "tx_bl_pbdstaticlegen", "Per bit deskew enable - TX - BL"},
#else
{2, 2, 0x0000000000000000, "RW", "tx_bl_pbdstaticlegen", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{1, 1, 0x0000000000000000, "RW", "dtx_cc_pbdstaticlegen", "Per bit deskew enable - DTX - CC"},
#else
{1, 1, 0x0000000000000000, "RW", "dtx_cc_pbdstaticlegen", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 0, 0x0000000000000000, "RW", "dtx_bl_pbdstaticlegen", "Per bit deskew enable - DTX - BL"},
#else
{0, 0, 0x0000000000000000, "RW", "dtx_bl_pbdstaticlegen", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo586[] = {{"txpbdctl1", "", 0x000000C0, 8, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields587[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{5, 31, 0x0000000000000000, "RO", "reserved628", "Reserved bits"},
#else
{5, 31, 0x0000000000000000, "RO", "reserved628", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 4, 0x0000000000000000, "RW", "tx_bldm_txpbdcode", "Tx Per Bit De-skew code for dq0 valid codes"},
#else
{0, 4, 0x0000000000000000, "RW", "tx_bldm_txpbdcode", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo587[] = {{"txpbdrk0ctl1", "", 0x000000C4, 2, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields588[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{21, 31, 0x0000000000000000, "RO", "reserved629", "Reserved bits"},
#else
{21, 31, 0x0000000000000000, "RO", "reserved629", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{16, 20, 0x0000000000000000, "RW", "dtx_bl_dqsbpbdcode", "Tx Per Bit De-skew code for dq0 valid codes"},
#else
{16, 20, 0x0000000000000000, "RW", "dtx_bl_dqsbpbdcode", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{8, 15, 0x0000000000000000, "RO", "reserved630", "Reserved bits"},
#else
{8, 15, 0x0000000000000000, "RO", "reserved630", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{5, 7, 0x0000000000000000, "RO", "reserved631", "Reserved bits"},
#else
{5, 7, 0x0000000000000000, "RO", "reserved631", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 4, 0x0000000000000000, "RW", "dtx_bl_dqspbdcode", "Tx Per Bit De-skew code for dq0 valid codes"},
#else
{0, 4, 0x0000000000000000, "RW", "dtx_bl_dqspbdcode", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo588[] = {{"txpbdrk0ctl0", "", 0x000000C8, 5, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields589[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{29, 31, 0x0000000000000000, "RO", "reserved632", "Reserved bits"},
#else
{29, 31, 0x0000000000000000, "RO", "reserved632", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{24, 28, 0x0000000000000000, "RW", "tx_bldq7_txpbdcode", "Tx Per Bit De-skew code for dq0 valid codes"},
#else
{24, 28, 0x0000000000000000, "RW", "tx_bldq7_txpbdcode", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{21, 23, 0x0000000000000000, "RO", "reserved633", "Reserved bits"},
#else
{21, 23, 0x0000000000000000, "RO", "reserved633", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{16, 20, 0x0000000000000000, "RW", "tx_bldq6_txpbdcode", "Tx Per Bit De-skew code for dq0 valid codes"},
#else
{16, 20, 0x0000000000000000, "RW", "tx_bldq6_txpbdcode", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{13, 15, 0x0000000000000000, "RO", "reserved634", "Reserved bits"},
#else
{13, 15, 0x0000000000000000, "RO", "reserved634", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{8, 12, 0x0000000000000000, "RW", "tx_bldq5_txpbdcode", "Tx Per Bit De-skew code for dq0 valid codes"},
#else
{8, 12, 0x0000000000000000, "RW", "tx_bldq5_txpbdcode", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{5, 7, 0x0000000000000000, "RO", "reserved635", "Reserved bits"},
#else
{5, 7, 0x0000000000000000, "RO", "reserved635", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 4, 0x0000000000000000, "RW", "tx_bldq4_txpbdcode", "Tx Per Bit De-skew code for dq0 valid codes"},
#else
{0, 4, 0x0000000000000000, "RW", "tx_bldq4_txpbdcode", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo589[] = {{"txpbdblctl1", "", 0x000000CC, 8, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields590[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{29, 31, 0x0000000000000000, "RO", "reserved636", "Reserved bits"},
#else
{29, 31, 0x0000000000000000, "RO", "reserved636", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{24, 28, 0x0000000000000000, "RW", "tx_bldq3_txpbdcode", "Tx Per Bit De-skew code for dq0 valid codes"},
#else
{24, 28, 0x0000000000000000, "RW", "tx_bldq3_txpbdcode", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{21, 23, 0x0000000000000000, "RO", "reserved637", "Reserved bits"},
#else
{21, 23, 0x0000000000000000, "RO", "reserved637", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{16, 20, 0x0000000000000000, "RW", "tx_bldq2_txpbdcode", "Tx Per Bit De-skew code for dq0 valid codes"},
#else
{16, 20, 0x0000000000000000, "RW", "tx_bldq2_txpbdcode", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{13, 15, 0x0000000000000000, "RO", "reserved638", "Reserved bits"},
#else
{13, 15, 0x0000000000000000, "RO", "reserved638", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{8, 12, 0x0000000000000000, "RW", "tx_bldq1_txpbdcode", "Tx Per Bit De-skew code for dq0 valid codes"},
#else
{8, 12, 0x0000000000000000, "RW", "tx_bldq1_txpbdcode", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{5, 7, 0x0000000000000000, "RO", "reserved639", "Reserved bits"},
#else
{5, 7, 0x0000000000000000, "RO", "reserved639", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 4, 0x0000000000000000, "RW", "tx_bldq0_txpbdcode", "Tx Per Bit De-skew code for dq0 valid codes"},
#else
{0, 4, 0x0000000000000000, "RW", "tx_bldq0_txpbdcode", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo590[] = {{"txpbdblctl0", "", 0x000000D0, 8, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields591[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{20, 31, 0x0000000000000000, "RO", "reserved640", "Reserved bits"},
#else
{20, 31, 0x0000000000000000, "RO", "reserved640", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{19, 19, 0x0000000000000001, "RW", "drx_cc_ampoffseten", "Offset cancellation enable for Rx (not used for cc)"},
#else
{19, 19, 0x0000000000000001, "RW", "drx_cc_ampoffseten", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{18, 18, 0x0000000000000000, "RW", "rx_cc_ampoffseten", "Offset cancellation enable for Rx (not used for cc)"},
#else
{18, 18, 0x0000000000000000, "RW", "rx_cc_ampoffseten", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{17, 17, 0x0000000000000001, "RW", "drx_bl_ampoffseten", "DQS Offset cancellation enable for Rx (1=enable, 0=disable)"},
#else
{17, 17, 0x0000000000000001, "RW", "drx_bl_ampoffseten", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{16, 16, 0x0000000000000000, "RW", "rx_bl_ampoffseten", "DQ Offset cancellation enable for Rx (1=enable, 0=disable)"},
#else
{16, 16, 0x0000000000000000, "RW", "rx_bl_ampoffseten", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{12, 15, 0x0000000000000000, "RW", "drx_ccck0_ampoffset", "tuning bits for offset cancellation (can be tied off for CC)"},
#else
{12, 15, 0x0000000000000000, "RW", "drx_ccck0_ampoffset", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{8, 11, 0x0000000000000000, "RW", "rx_cc_ampoffset", "tuning bits for offset cancellation (can be tied off for CC)"},
#else
{8, 11, 0x0000000000000000, "RW", "rx_cc_ampoffset", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{4, 7, 0x0000000000000000, "RW", "drx_bl_ampoffset", "Offset cancellation code (DQS buffers)[br]1100 -4[br]1011 -3[br]1010 -2[br]1001 -1[br]0000 0[br]0001 +1[br]0010 +2[br]0011 +3[br]0100 +4"},
#else
{4, 7, 0x0000000000000000, "RW", "drx_bl_ampoffset", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 3, 0x0000000000000000, "RW", "rx_bldm_ampoffset", "Offset cancellation code (DM/DQ buffers)[br]1100 -4[br]1011 -3[br]1010 -2[br]1001 -1[br]0000 0[br]0001 +1[br]0010 +2[br]0011 +3[br]0100 +4"},
#else
{0, 3, 0x0000000000000000, "RW", "rx_bldm_ampoffset", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo591[] = {{"offsetcnclctrl1", "", 0x000000D4, 9, 0x00000000FFFFFFFF, 0x00000000000A0000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields592[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{28, 31, 0x0000000000000000, "RW", "rx_bldq0_ampoffset", "Offset cancellation code (DM/DQ buffers)[br]1100 -4[br]1011 -3[br]1010 -2[br]1001 -1[br]0000 0[br]0001 +1[br]0010 +2[br]0011 +3[br]0100 +4"},
#else
{28, 31, 0x0000000000000000, "RW", "rx_bldq0_ampoffset", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{24, 27, 0x0000000000000000, "RW", "rx_bldq1_ampoffset", "Offset cancellation code (DM/DQ buffers)[br]1100 -4[br]1011 -3[br]1010 -2[br]1001 -1[br]0000 0[br]0001 +1[br]0010 +2[br]0011 +3[br]0100 +4"},
#else
{24, 27, 0x0000000000000000, "RW", "rx_bldq1_ampoffset", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{20, 23, 0x0000000000000000, "RW", "rx_bldq2_ampoffset", "Offset cancellation code (DM/DQ buffers)[br]1100 -4[br]1011 -3[br]1010 -2[br]1001 -1[br]0000 0[br]0001 +1[br]0010 +2[br]0011 +3[br]0100 +4"},
#else
{20, 23, 0x0000000000000000, "RW", "rx_bldq2_ampoffset", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{16, 19, 0x0000000000000000, "RW", "rx_bldq3_ampoffset", "Offset cancellation code (DM/DQ buffers)[br]1100 -4[br]1011 -3[br]1010 -2[br]1001 -1[br]0000 0[br]0001 +1[br]0010 +2[br]0011 +3[br]0100 +4"},
#else
{16, 19, 0x0000000000000000, "RW", "rx_bldq3_ampoffset", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{12, 15, 0x0000000000000000, "RW", "rx_bldq4_ampoffset", "Offset cancellation code (DM/DQ buffers)[br]1100 -4[br]1011 -3[br]1010 -2[br]1001 -1[br]0000 0[br]0001 +1[br]0010 +2[br]0011 +3[br]0100 +4"},
#else
{12, 15, 0x0000000000000000, "RW", "rx_bldq4_ampoffset", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{8, 11, 0x0000000000000000, "RW", "rx_bldq5_ampoffset", "Offset cancellation code (DM/DQ buffers)[br]1100 -4[br]1011 -3[br]1010 -2[br]1001 -1[br]0000 0[br]0001 +1[br]0010 +2[br]0011 +3[br]0100 +4"},
#else
{8, 11, 0x0000000000000000, "RW", "rx_bldq5_ampoffset", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{4, 7, 0x0000000000000000, "RW", "rx_bldq6_ampoffset", "Offset cancellation code (DM/DQ buffers)[br]1100 -4[br]1011 -3[br]1010 -2[br]1001 -1[br]0000 0[br]0001 +1[br]0010 +2[br]0011 +3[br]0100 +4"},
#else
{4, 7, 0x0000000000000000, "RW", "rx_bldq6_ampoffset", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 3, 0x0000000000000000, "RW", "rx_bldq7_ampoffset", "Offset cancellation code (DM/DQ buffers)[br]1100 -4[br]1011 -3[br]1010 -2[br]1001 -1[br]0000 0[br]0001 +1[br]0010 +2[br]0011 +3[br]0100 +4"},
#else
{0, 3, 0x0000000000000000, "RW", "rx_bldq7_ampoffset", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo592[] = {{"offsetcnclctrl0", "", 0x000000D8, 8, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields593[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{4, 31, 0x0000000000000000, "RO", "reserved641", "Reserved bits"},
#else
{4, 31, 0x0000000000000000, "RO", "reserved641", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{2, 3, 0x0000000000000000, "RW", "drx_bl_casbiasctrl", "DRX Bias Command Control - BL"},
#else
{2, 3, 0x0000000000000000, "RW", "drx_bl_casbiasctrl", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 1, 0x0000000000000000, "RW", "drx_bl_nbiasctrl", "DRX N Bias Control - BL"},
#else
{0, 1, 0x0000000000000000, "RW", "drx_bl_nbiasctrl", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo593[] = {{"ctlectl2", "", 0x000000DC, 3, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields594[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{31, 31, 0x0000000000000000, "RO", "reserved642", "Reserved bits"},
#else
{31, 31, 0x0000000000000000, "RO", "reserved642", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{30, 30, 0x0000000000000001, "RW", "drx_cc_biasen", "DRX Bias Enable - CC"},
#else
{30, 30, 0x0000000000000001, "RW", "drx_cc_biasen", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{28, 29, 0x0000000000000000, "RW", "drx_cc_casbiasctrl", "DRX Bias Command Control - CC"},
#else
{28, 29, 0x0000000000000000, "RW", "drx_cc_casbiasctrl", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{26, 27, 0x0000000000000000, "RW", "drx_cc_nbiasctrl", "DRX N Bias Control - CC"},
#else
{26, 27, 0x0000000000000000, "RW", "drx_cc_nbiasctrl", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{23, 25, 0x0000000000000000, "RW", "drx_cc_ctlebiasctrl", "DRX Bias Ctle Control - CC"},
#else
{23, 25, 0x0000000000000000, "RW", "drx_cc_ctlebiasctrl", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{22, 22, 0x0000000000000001, "RW", "rx_cc_ctleen", "Enable CTLE (not used for CC)"},
#else
{22, 22, 0x0000000000000001, "RW", "rx_cc_ctleen", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{20, 21, 0x0000000000000000, "RW", "rx_cc_ctlebiasctrl", "bias control for ctle amp[br]00 2k&          0.25xnom[br]01 1k&          0.4xnom[br]10 0.5k&     1xnom[br]11 0.25k&  1.7xnom"},
#else
{20, 21, 0x0000000000000000, "RW", "rx_cc_ctlebiasctrl", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{18, 19, 0x0000000000000000, "RW", "rx_cc_ctleres", "resistor tuning;00=0.5kohm;01=1kohm;10=1.5kohm;11=2kohm"},
#else
{18, 19, 0x0000000000000000, "RW", "rx_cc_ctleres", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{16, 17, 0x0000000000000001, "RW", "rx_cc_ctlecap", "cap tuning;00 = 0.5pf;01 = 1pf;10 = 1.5pf;11 = 2pf"},
#else
{16, 17, 0x0000000000000001, "RW", "rx_cc_ctlecap", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{15, 15, 0x0000000000000001, "RW", "drx_bl_ctleen", "Enable CTLE for DQS (1=enable, 0=disable)"},
#else
{15, 15, 0x0000000000000001, "RW", "drx_bl_ctleen", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{12, 14, 0x0000000000000000, "RW", "drx_bl_ctlebiasctrl", "bias control for ctle amp[br]00 2k&          0.25xnom[br]01 1k&          0.4xnom[br]10 0.5k&     1xnom[br]11 0.25k&  1.7xnom"},
#else
{12, 14, 0x0000000000000000, "RW", "drx_bl_ctlebiasctrl", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{10, 11, 0x0000000000000000, "RW", "drx_bl_ctleres", "resistor tuning;00=0.5kohm;01=1kohm;10=1.5kohm;11=2kohm"},
#else
{10, 11, 0x0000000000000000, "RW", "drx_bl_ctleres", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{8, 9, 0x0000000000000001, "RW", "drx_bl_ctlecap", "cap tuning;00 = 0.5pf;01 = 1pf;10 = 1.5pf;11 = 2pf"},
#else
{8, 9, 0x0000000000000001, "RW", "drx_bl_ctlecap", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{7, 7, 0x0000000000000001, "RW", "drx_bl_biasen", "DRX Bias Enable - BL"},
#else
{7, 7, 0x0000000000000001, "RW", "drx_bl_biasen", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{6, 6, 0x0000000000000001, "RW", "rx_bl_ctleen", "Enable CTLE for DQ (1=enable, 0=disable)"},
#else
{6, 6, 0x0000000000000001, "RW", "rx_bl_ctleen", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{4, 5, 0x0000000000000000, "RW", "rx_bl_ctlebiasctrl", "bias control for ctle amp[br]00 2k&          0.25xnom[br]01 1k&          0.4xnom[br]10 0.5k&     1xnom[br]11 0.25k&  1.7xnom"},
#else
{4, 5, 0x0000000000000000, "RW", "rx_bl_ctlebiasctrl", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{2, 3, 0x0000000000000000, "RW", "rx_bldm_ctleres", "resistor tuning;00=0.5kohm;01=1kohm;10=1.5kohm;11=2kohm"},
#else
{2, 3, 0x0000000000000000, "RW", "rx_bldm_ctleres", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 1, 0x0000000000000001, "RW", "rx_bldm_ctlecap", "cap tuning;00 = 0.1pf;01 = 0.2pf;10 = 0.3pf;11 = 0.4pf"},
#else
{0, 1, 0x0000000000000001, "RW", "rx_bldm_ctlecap", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo594[] = {{"ctlectl1", "", 0x000000E0, 18, 0x00000000FFFFFFFF, 0x00000000404181C1}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields595[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{30, 31, 0x0000000000000000, "RW", "rx_bldq0_ctleres", "resistor tuning;00=0.5kohm;01=1kohm;10=1.5kohm;11=2kohm"},
#else
{30, 31, 0x0000000000000000, "RW", "rx_bldq0_ctleres", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{28, 29, 0x0000000000000000, "RW", "rx_bldq1_ctleres", "resistor tuning;00=0.5kohm;01=1kohm;10=1.5kohm;11=2kohm"},
#else
{28, 29, 0x0000000000000000, "RW", "rx_bldq1_ctleres", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{26, 27, 0x0000000000000000, "RW", "rx_bldq2_ctleres", "resistor tuning;00=0.5kohm;01=1kohm;10=1.5kohm;11=2kohm"},
#else
{26, 27, 0x0000000000000000, "RW", "rx_bldq2_ctleres", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{24, 25, 0x0000000000000000, "RW", "rx_bldq3_ctleres", "resistor tuning;00=0.5kohm;01=1kohm;10=1.5kohm;11=2kohm"},
#else
{24, 25, 0x0000000000000000, "RW", "rx_bldq3_ctleres", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{22, 23, 0x0000000000000000, "RW", "rx_bldq4_ctleres", "resistor tuning;00=0.5kohm;01=1kohm;10=1.5kohm;11=2kohm"},
#else
{22, 23, 0x0000000000000000, "RW", "rx_bldq4_ctleres", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{20, 21, 0x0000000000000000, "RW", "rx_bldq5_ctleres", "resistor tuning;00=0.5kohm;01=1kohm;10=1.5kohm;11=2kohm"},
#else
{20, 21, 0x0000000000000000, "RW", "rx_bldq5_ctleres", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{18, 19, 0x0000000000000000, "RW", "rx_bldq6_ctleres", "resistor tuning;00=0.5kohm;01=1kohm;10=1.5kohm;11=2kohm"},
#else
{18, 19, 0x0000000000000000, "RW", "rx_bldq6_ctleres", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{16, 17, 0x0000000000000000, "RW", "rx_bldq7_ctleres", "resistor tuning;00=0.5kohm;01=1kohm;10=1.5kohm;11=2kohm"},
#else
{16, 17, 0x0000000000000000, "RW", "rx_bldq7_ctleres", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{14, 15, 0x0000000000000001, "RW", "rx_bldq0_ctlecap", "cap tuning;00 = 0.1pf;01 = 0.2pf;10 = 0.3pf;11 = 0.4pf"},
#else
{14, 15, 0x0000000000000001, "RW", "rx_bldq0_ctlecap", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{12, 13, 0x0000000000000001, "RW", "rx_bldq1_ctlecap", "cap tuning;00 = 0.1pf;01 = 0.2pf;10 = 0.3pf;11 = 0.4pf"},
#else
{12, 13, 0x0000000000000001, "RW", "rx_bldq1_ctlecap", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{10, 11, 0x0000000000000001, "RW", "rx_bldq2_ctlecap", "cap tuning;00 = 0.1pf;01 = 0.2pf;10 = 0.3pf;11 = 0.4pf"},
#else
{10, 11, 0x0000000000000001, "RW", "rx_bldq2_ctlecap", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{8, 9, 0x0000000000000001, "RW", "rx_bldq3_ctlecap", "cap tuning;00 = 0.1pf;01 = 0.2pf;10 = 0.3pf;11 = 0.4pf"},
#else
{8, 9, 0x0000000000000001, "RW", "rx_bldq3_ctlecap", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{6, 7, 0x0000000000000001, "RW", "rx_bldq4_ctlecap", "cap tuning;00 = 0.1pf;01 = 0.2pf;10 = 0.3pf;11 = 0.4pf"},
#else
{6, 7, 0x0000000000000001, "RW", "rx_bldq4_ctlecap", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{4, 5, 0x0000000000000001, "RW", "rx_bldq5_ctlecap", "cap tuning;00 = 0.1pf;01 = 0.2pf;10 = 0.3pf;11 = 0.4pf"},
#else
{4, 5, 0x0000000000000001, "RW", "rx_bldq5_ctlecap", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{2, 3, 0x0000000000000001, "RW", "rx_bldq6_ctlecap", "cap tuning;00 = 0.1pf;01 = 0.2pf;10 = 0.3pf;11 = 0.4pf"},
#else
{2, 3, 0x0000000000000001, "RW", "rx_bldq6_ctlecap", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 1, 0x0000000000000001, "RW", "rx_bldq7_ctlecap", "cap tuning;00 = 0.1pf;01 = 0.2pf;10 = 0.3pf;11 = 0.4pf"},
#else
{0, 1, 0x0000000000000001, "RW", "rx_bldq7_ctlecap", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo595[] = {{"ctlectl0", "", 0x000000E4, 16, 0x00000000FFFFFFFF, 0x0000000000005555}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields596[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{31, 31, 0x0000000000000000, "RW", "tx_bl_tcostaticlegen", "TX TCO enable - BL"},
#else
{31, 31, 0x0000000000000000, "RW", "tx_bl_tcostaticlegen", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{29, 30, 0x0000000000000000, "RO", "reserved643", "Reserved bits"},
#else
{29, 30, 0x0000000000000000, "RO", "reserved643", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{24, 28, 0x000000000000001F, "RW", "tx_bl_tcofall", "DQ TCO comp fall code - DQ Lane"},
#else
{24, 28, 0x000000000000001F, "RW", "tx_bl_tcofall", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{21, 23, 0x0000000000000000, "RO", "reserved644", "Reserved bits"},
#else
{21, 23, 0x0000000000000000, "RO", "reserved644", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{16, 20, 0x000000000000001F, "RW", "tx_bl_tcorise", "DQ TCO comp rise code - DQ Lane"},
#else
{16, 20, 0x000000000000001F, "RW", "tx_bl_tcorise", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{15, 15, 0x0000000000000000, "RW", "tx_cc_tcostaticlegen", "TX TCO enable - CC"},
#else
{15, 15, 0x0000000000000000, "RW", "tx_cc_tcostaticlegen", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{13, 14, 0x0000000000000000, "RO", "reserved645", "Reserved bits"},
#else
{13, 14, 0x0000000000000000, "RO", "reserved645", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{8, 12, 0x000000000000001F, "RW", "tx_cc_tcofall", "DQ TCO comp fall code - CC Lane"},
#else
{8, 12, 0x000000000000001F, "RW", "tx_cc_tcofall", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{5, 7, 0x0000000000000000, "RO", "reserved646", "Reserved bits"},
#else
{5, 7, 0x0000000000000000, "RO", "reserved646", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 4, 0x000000000000001F, "RW", "tx_cc_tcorise", "DQ TCO comp rise code - CC Lane"},
#else
{0, 4, 0x000000000000001F, "RW", "tx_cc_tcorise", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo596[] = {{"tcoctl_dqcc", "", 0x000000E8, 10, 0x00000000FFFFFFFF, 0x000000001F1F1F1F}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields597[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{30, 31, 0x0000000000000000, "RO", "reserved647", "Reserved bits"},
#else
{30, 31, 0x0000000000000000, "RO", "reserved647", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{29, 29, 0x0000000000000000, "RW", "dtx_bl_tcostaticlegen", "DTX TCO enable - BL"},
#else
{29, 29, 0x0000000000000000, "RW", "dtx_bl_tcostaticlegen", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{24, 28, 0x000000000000001F, "RW", "dtx_bl_tcofalldqsb", "DQSB TCO comp fall code - DQ Lane"},
#else
{24, 28, 0x000000000000001F, "RW", "dtx_bl_tcofalldqsb", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{21, 23, 0x0000000000000000, "RO", "reserved648", "Reserved bits"},
#else
{21, 23, 0x0000000000000000, "RO", "reserved648", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{16, 20, 0x000000000000001F, "RW", "dtx_bl_tcorisedqsb", "DQS TCO comp fall code - DQ Lane"},
#else
{16, 20, 0x000000000000001F, "RW", "dtx_bl_tcorisedqsb", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{13, 15, 0x0000000000000000, "RO", "reserved649", "Reserved bits"},
#else
{13, 15, 0x0000000000000000, "RO", "reserved649", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{8, 12, 0x000000000000001F, "RW", "dtx_bl_tcofalldqs", "DQSB TCO comp rise code - DQ Lane"},
#else
{8, 12, 0x000000000000001F, "RW", "dtx_bl_tcofalldqs", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{5, 7, 0x0000000000000000, "RO", "reserved650", "Reserved bits"},
#else
{5, 7, 0x0000000000000000, "RO", "reserved650", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 4, 0x000000000000001F, "RW", "dtx_bl_tcorisedqs", "DQS TCO comp rise code - DQ Lane"},
#else
{0, 4, 0x000000000000001F, "RW", "dtx_bl_tcorisedqs", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo597[] = {{"tcoctl_dq", "", 0x000000EC, 9, 0x00000000FFFFFFFF, 0x000000001F1F1F1F}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields598[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{30, 31, 0x0000000000000000, "RO", "reserved651", "Reserved bits"},
#else
{30, 31, 0x0000000000000000, "RO", "reserved651", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{29, 29, 0x0000000000000000, "RW", "dtx_cc_tcostaticlegen", "DTX TCO enable - CC"},
#else
{29, 29, 0x0000000000000000, "RW", "dtx_cc_tcostaticlegen", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{24, 28, 0x000000000000001F, "RW", "dtx_cc_tcofalldqsb", "DQSB TCO comp fall code - CC Lane"},
#else
{24, 28, 0x000000000000001F, "RW", "dtx_cc_tcofalldqsb", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{21, 23, 0x0000000000000000, "RO", "reserved652", "Reserved bits"},
#else
{21, 23, 0x0000000000000000, "RO", "reserved652", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{16, 20, 0x000000000000001F, "RW", "dtx_cc_tcorisedqsb", "DQSB TCO comp rise code - CC Lane"},
#else
{16, 20, 0x000000000000001F, "RW", "dtx_cc_tcorisedqsb", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{13, 15, 0x0000000000000000, "RO", "reserved653", "Reserved bits"},
#else
{13, 15, 0x0000000000000000, "RO", "reserved653", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{8, 12, 0x000000000000001F, "RW", "dtx_cc_tcofalldqs", "DQS TCO comp fall code - CC Lane"},
#else
{8, 12, 0x000000000000001F, "RW", "dtx_cc_tcofalldqs", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{5, 7, 0x0000000000000000, "RO", "reserved654", "Reserved bits"},
#else
{5, 7, 0x0000000000000000, "RO", "reserved654", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 4, 0x000000000000001F, "RW", "dtx_cc_tcorisedqs", "DQS TCO comp rise code - CC Lane"},
#else
{0, 4, 0x000000000000001F, "RW", "dtx_cc_tcorisedqs", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo598[] = {{"tcoctl_cc", "", 0x000000F0, 9, 0x00000000FFFFFFFF, 0x000000001F1F1F1F}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields599[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{12, 31, 0x0000000000000000, "RO", "reserved655", "Reserved bits"},
#else
{12, 31, 0x0000000000000000, "RO", "reserved655", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{10, 11, 0x0000000000000000, "RW", "txdll_rk1siggrp06dbsel", "Dead band select for sig grp 6 rank 1"},
#else
{10, 11, 0x0000000000000000, "RW", "txdll_rk1siggrp06dbsel", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{6, 9, 0x0000000000000000, "RW", "txdll_rk1siggrp06rdptroffset", "Read pointer offset for sig group 6 rank 1"},
#else
{6, 9, 0x0000000000000000, "RW", "txdll_rk1siggrp06rdptroffset", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{4, 5, 0x0000000000000000, "RW", "txdll_rk0siggrp06dbsel", "Dead band select for sig grp 6 rank 0"},
#else
{4, 5, 0x0000000000000000, "RW", "txdll_rk0siggrp06dbsel", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 3, 0x0000000000000000, "RW", "txdll_rk0siggrp06rdptroffset", "Read pointer offset for sig group 6 rank 0"},
#else
{0, 3, 0x0000000000000000, "RW", "txdll_rk0siggrp06rdptroffset", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo599[] = {{"txdllsiggrp6ctl", "", 0x000000F4, 5, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields600[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{28, 31, 0x0000000000000000, "RW", "reserved656", "Reserved bits"},
#else
{28, 31, 0x0000000000000000, "RW", "reserved656", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{24, 27, 0x0000000000000000, "RW", "rk1dqdrvsecondrdportref2xrdptroffset", "Read pointer offset for second port for LDO integration - DQDMDRV - RK1."},
#else
{24, 27, 0x0000000000000000, "RW", "rk1dqdrvsecondrdportref2xrdptroffset", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{20, 23, 0x0000000000000000, "RW", "rk0dqdrvsecondrdportref2xrdptroffset", "Read pointer offset for second port for LDO integration - DQDMDRV - RK0."},
#else
{20, 23, 0x0000000000000000, "RW", "rk0dqdrvsecondrdportref2xrdptroffset", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{16, 19, 0x0000000000000000, "RW", "rk1dqsecondrdportref2xrdptroffset", "Read pointer offset for second port for LDO integration - DQ - RK1."},
#else
{16, 19, 0x0000000000000000, "RW", "rk1dqsecondrdportref2xrdptroffset", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{12, 15, 0x0000000000000000, "RW", "rk0dqsecondrdportref2xrdptroffset", "Read pointer offset for second port for LDO integration - DQ - RK0."},
#else
{12, 15, 0x0000000000000000, "RW", "rk0dqsecondrdportref2xrdptroffset", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{8, 11, 0x0000000000000000, "RW", "rk1dqsdrvsecondrdportref2xrdptroffset", "Read pointer offset for second port for LDO integration - DQ - RK1."},
#else
{8, 11, 0x0000000000000000, "RW", "rk1dqsdrvsecondrdportref2xrdptroffset", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{4, 7, 0x0000000000000000, "RW", "rk0dqsdrvsecondrdportref2xrdptroffset", "Read pointer offset for second port for LDO integration - DQ - RK0."},
#else
{4, 7, 0x0000000000000000, "RW", "rk0dqsdrvsecondrdportref2xrdptroffset", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 3, 0x0000000000000000, "RW", "ckdrvsecondrdportref2xrdptroffset", "Read pointer offset for second port for LDO integration - DQ - RK1."},
#else
{0, 3, 0x0000000000000000, "RW", "ckdrvsecondrdportref2xrdptroffset", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo600[] = {{"ldoctl0", "", 0x000000F8, 8, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields601[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{8, 31, 0x0000000000000000, "RW", "reserved657", "Reserved bits"},
#else
{8, 31, 0x0000000000000000, "RW", "reserved657", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{4, 7, 0x0000000000000000, "RW", "cssecondrdportref2xrdptroffset", "Read pointer offset for second port for LDO integration - DQ - RK0."},
#else
{4, 7, 0x0000000000000000, "RW", "cssecondrdportref2xrdptroffset", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 3, 0x0000000000000000, "RW", "cmddrvsecondrdportref2xrdptroffset", "Read pointer offset for second port for LDO integration - DQ - RK1."},
#else
{0, 3, 0x0000000000000000, "RW", "cmddrvsecondrdportref2xrdptroffset", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo601[] = {{"ldoctl1", "", 0x000000FC, 3, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields602[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{24, 31, 0x0000000000000000, "RO", "reserved658", "Reserved bits"},
#else
{24, 31, 0x0000000000000000, "RO", "reserved658", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{21, 23, 0x0000000000000000, "RW", "data0sel", "Reserved bits"},
#else
{21, 23, 0x0000000000000000, "RW", "data0sel", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{18, 20, 0x0000000000000000, "RW", "data1sel", "Reserved bits"},
#else
{18, 20, 0x0000000000000000, "RW", "data1sel", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{15, 17, 0x0000000000000000, "RW", "data2sel", "Reserved bits"},
#else
{15, 17, 0x0000000000000000, "RW", "data2sel", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{12, 14, 0x0000000000000000, "RW", "data3sel", "Reserved bits"},
#else
{12, 14, 0x0000000000000000, "RW", "data3sel", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{9, 11, 0x0000000000000000, "RW", "data4sel", "Reserved bits"},
#else
{9, 11, 0x0000000000000000, "RW", "data4sel", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{6, 8, 0x0000000000000000, "RW", "data5sel", "Reserved bits"},
#else
{6, 8, 0x0000000000000000, "RW", "data5sel", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{3, 5, 0x0000000000000000, "RW", "data6sel", "Reserved bits"},
#else
{3, 5, 0x0000000000000000, "RW", "data6sel", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 2, 0x0000000000000000, "RW", "data7sel", "Reserved bits"},
#else
{0, 2, 0x0000000000000000, "RW", "data7sel", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo602[] = {{"ptdatamuxsel", "", 0x00000100, 9, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields603[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{31, 31, 0x0000000000000000, "RO", "reserved659", "Reserved bits"},
#else
{31, 31, 0x0000000000000000, "RO", "reserved659", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{28, 30, 0x0000000000000000, "RW", "lpmode_dasrtdqcmddrvenb_dly", "Low Power Mode Delays"},
#else
{28, 30, 0x0000000000000000, "RW", "lpmode_dasrtdqcmddrvenb_dly", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{27, 27, 0x0000000000000000, "RO", "reserved660", "Reserved bits"},
#else
{27, 27, 0x0000000000000000, "RO", "reserved660", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{24, 26, 0x0000000000000000, "RW", "lpmode_asrtdqcmdsigpien_dly", "Low Power Mode Delays"},
#else
{24, 26, 0x0000000000000000, "RW", "lpmode_asrtdqcmdsigpien_dly", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{23, 23, 0x0000000000000000, "RO", "reserved661", "Reserved bits"},
#else
{23, 23, 0x0000000000000000, "RO", "reserved661", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{20, 22, 0x0000000000000000, "RW", "lpmode_asrtdqcmddrvenb_dly", "Low Power Mode Delays"},
#else
{20, 22, 0x0000000000000000, "RW", "lpmode_asrtdqcmddrvenb_dly", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{19, 19, 0x0000000000000000, "RO", "reserved662", "Reserved bits"},
#else
{19, 19, 0x0000000000000000, "RO", "reserved662", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{16, 18, 0x0000000000000000, "RW", "lpmode_dasrtiobufact_dly", "Low Power Mode Delays"},
#else
{16, 18, 0x0000000000000000, "RW", "lpmode_dasrtiobufact_dly", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{15, 15, 0x0000000000000000, "RO", "reserved663", "Reserved bits"},
#else
{15, 15, 0x0000000000000000, "RO", "reserved663", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{12, 14, 0x0000000000000000, "RW", "lpmode_dasrtwrptren_dly", "Low Power Mode Delays"},
#else
{12, 14, 0x0000000000000000, "RW", "lpmode_dasrtwrptren_dly", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{11, 11, 0x0000000000000000, "RO", "reserved664", "Reserved bits"},
#else
{11, 11, 0x0000000000000000, "RO", "reserved664", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{8, 10, 0x0000000000000000, "RW", "lpmode_asrtref2xrstb_dly", "Low Power Mode Delays"},
#else
{8, 10, 0x0000000000000000, "RW", "lpmode_asrtref2xrstb_dly", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{7, 7, 0x0000000000000000, "RO", "reserved665", "Reserved bits"},
#else
{7, 7, 0x0000000000000000, "RO", "reserved665", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{4, 6, 0x0000000000000000, "RO", "reserved666", "Reserved bits"},
#else
{4, 6, 0x0000000000000000, "RO", "reserved666", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{3, 3, 0x0000000000000000, "RO", "reserved667", "Reserved bits"},
#else
{3, 3, 0x0000000000000000, "RO", "reserved667", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 2, 0x0000000000000000, "RW", "lpmode_dasrtref2xrstb_dly", "Low Power Mode Delays"},
#else
{0, 2, 0x0000000000000000, "RW", "lpmode_dasrtref2xrstb_dly", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo603[] = {{"lpmodectl0", "", 0x00000104, 16, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields604[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{31, 31, 0x0000000000000000, "RO", "reserved668", "Reserved bits"},
#else
{31, 31, 0x0000000000000000, "RO", "reserved668", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{28, 30, 0x0000000000000000, "RW", "lpmode_asrtwrptren_dly", "Reserved bits"},
#else
{28, 30, 0x0000000000000000, "RW", "lpmode_asrtwrptren_dly", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{27, 27, 0x0000000000000000, "RO", "reserved669", "Reserved bits"},
#else
{27, 27, 0x0000000000000000, "RO", "reserved669", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{24, 26, 0x0000000000000000, "RW", "lpmode_asrtiobufact_dly", "Reserved bits"},
#else
{24, 26, 0x0000000000000000, "RW", "lpmode_asrtiobufact_dly", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{23, 23, 0x0000000000000000, "RO", "reserved670", "Reserved bits"},
#else
{23, 23, 0x0000000000000000, "RO", "reserved670", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{22, 22, 0x0000000000000000, "RW", "lpmode_dqcmddrvenbovrd", "Reserved bits"},
#else
{22, 22, 0x0000000000000000, "RW", "lpmode_dqcmddrvenbovrd", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{21, 21, 0x0000000000000000, "RW", "lpmode_iobufactovrd", "Reserved bits"},
#else
{21, 21, 0x0000000000000000, "RW", "lpmode_iobufactovrd", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{20, 20, 0x0000000000000000, "RW", "lpmode_ref2xclkenovrd", "Reserved bits"},
#else
{20, 20, 0x0000000000000000, "RW", "lpmode_ref2xclkenovrd", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{19, 19, 0x0000000000000000, "RW", "siggrpen_lpmode1ovrd", "Reserved bits"},
#else
{19, 19, 0x0000000000000000, "RW", "siggrpen_lpmode1ovrd", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{18, 18, 0x0000000000000000, "RW", "siggrpen_lpmode2or3ovrd", "Reserved bits"},
#else
{18, 18, 0x0000000000000000, "RW", "siggrpen_lpmode2or3ovrd", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{17, 17, 0x0000000000000000, "RW", "lpmode_wrptrenovrd", "Reserved bits"},
#else
{17, 17, 0x0000000000000000, "RW", "lpmode_wrptrenovrd", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{16, 16, 0x0000000000000000, "RW", "lpmode_ref2xrstbovrd", "Reserved bits"},
#else
{16, 16, 0x0000000000000000, "RW", "lpmode_ref2xrstbovrd", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{8, 15, 0x0000000000000000, "RO", "reserved671", "Reserved bits"},
#else
{8, 15, 0x0000000000000000, "RO", "reserved671", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 7, 0x0000000000000000, "RW", "lpmode_asrtref2xsigpien_dly", "Low Power Mode Delays"},
#else
{0, 7, 0x0000000000000000, "RW", "lpmode_asrtref2xsigpien_dly", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo604[] = {{"lpmodectl1", "", 0x00000108, 14, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields605[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{24, 31, 0x0000000000000000, "RO", "reserved672", "Reserved bits"},
#else
{24, 31, 0x0000000000000000, "RO", "reserved672", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{18, 23, 0x0000000000000000, "RW", "rdcmd2rxdllupdt", "Read command to RXDLL update."},
#else
{18, 23, 0x0000000000000000, "RW", "rdcmd2rxdllupdt", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{12, 17, 0x0000000000000000, "RW", "rxdllupdtlen", "RXDLL update enable."},
#else
{12, 17, 0x0000000000000000, "RW", "rxdllupdtlen", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{6, 11, 0x0000000000000000, "RW", "rdcmd2rdactive", "Read command to active delay."},
#else
{6, 11, 0x0000000000000000, "RW", "rdcmd2rdactive", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 5, 0x0000000000000000, "RW", "rdactivelen", "Read active length."},
#else
{0, 5, 0x0000000000000000, "RW", "rdactivelen", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo605[] = {{"rxdllrdcmdctl0", "", 0x0000010C, 5, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields606[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{1, 31, 0x0000000000000000, "RO", "Reserved", "Reserved"},
#else
{1, 31, 0x0000000000000000, "RO", "Reserved", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 0, 0x0000000000000000, "RW", "dllcomprst_b", "Power-on or software reset0: reset state1: norma operationSet to 1 to enter normal operation."},
#else
{0, 0, 0x0000000000000000, "RW", "dllcomprst_b", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo606[] = {{"dllcomp_reset", "", 0x00000600, 2, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields607[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{1, 31, 0x0000000000000000, "RO", "Reserved", "Reserved"},
#else
{1, 31, 0x0000000000000000, "RO", "Reserved", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 0, 0x0000000000000000, "RW/1S/V", "txdll_init", "Activates initialization training sequence.0: initialization training sequence not active.1: initialization training sequence active.Self clearing after successful initialization training sequence."},
#else
{0, 0, 0x0000000000000000, "RW/1S/V", "txdll_init", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo607[] = {{"dllcomp_init", "", 0x00000604, 2, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields608[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{1, 31, 0x0000000000000000, "RO", "Reserved", "Reserved"},
#else
{1, 31, 0x0000000000000000, "RO", "Reserved", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 0, 0x0000000000000000, "RW", "lpddr_type", "LPDDR speed target. 0: LPDDR3, 1600 MHz. 1: LPDDR4, 3200 MHz."},
#else
{0, 0, 0x0000000000000000, "RW", "lpddr_type", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo608[] = {{"dllcomp_lpddrtype", "", 0x00000608, 2, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields609[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{1, 31, 0x0000000000000000, "RO", "Reserved", "Reserved"},
#else
{1, 31, 0x0000000000000000, "RO", "Reserved", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 0, 0x0000000000000001, "RW", "clkungate", "Internal Clock control. 0 = allow clock gating for low power; 1 = allow free running clock"},
#else
{0, 0, 0x0000000000000001, "RW", "clkungate", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo609[] = {{"dllcomp_clkungate", "", 0x0000060C, 2, 0x00000000FFFFFFFF, 0x0000000000000001}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields610[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{8, 31, 0x0000000000000000, "RO", "Reserved", "Reserved"},
#else
{8, 31, 0x0000000000000000, "RO", "Reserved", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{7, 7, 0x0000000000000000, "RO/V", "txdll_lock_error", "Set when initialization or fine periodic training failed the locking condition. Cleared on a read or writing a 0."},
#else
{7, 7, 0x0000000000000000, "RO/V", "txdll_lock_error", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{6, 6, 0x0000000000000000, "RO/V", "txdll_fine_error", "Set when fine code underflow or overflow occurs. Cleared on a read or writing a 0."},
#else
{6, 6, 0x0000000000000000, "RO/V", "txdll_fine_error", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{5, 5, 0x0000000000000000, "RO/V", "txdll_coarsep_error", "Set when coarse code underflow or overflow occurs. Cleared on a read or writing a 0."},
#else
{5, 5, 0x0000000000000000, "RO/V", "txdll_coarsep_error", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{4, 4, 0x0000000000000000, "RO/V", "txdll_error", "Set when Delay Cell count exceeds maximum value. Cleared on a read or writing a 0."},
#else
{4, 4, 0x0000000000000000, "RO/V", "txdll_error", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{2, 3, 0x0000000000000000, "RO", "Reserved0", "Reserved"},
#else
{2, 3, 0x0000000000000000, "RO", "Reserved0", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{1, 1, 0x0000000000000000, "RO/V", "txdll_lock_flag", "Set when initialization or fine periodic training passed the locking condition. Valid only when scr_lockseq_en is set to 1.Cleared on a read or writing a 0."},
#else
{1, 1, 0x0000000000000000, "RO/V", "txdll_lock_flag", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 0, 0x0000000000000000, "RO/V", "txdll_init_done", "Set when Initialization sequence is successful. Cleared on a read or writing a 0."},
#else
{0, 0, 0x0000000000000000, "RO/V", "txdll_init_done", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo610[] = {{"dllcomp_error_status", "", 0x00000610, 8, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields611[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{21, 31, 0x0000000000000000, "RO", "Reserved", "Reserved"},
#else
{21, 31, 0x0000000000000000, "RO", "Reserved", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{16, 20, 0x0000000000000007, "RO/V", "txdll_stat_fbmuxsel", "Delay Cell count value during normal operation"},
#else
{16, 20, 0x0000000000000007, "RO/V", "txdll_stat_fbmuxsel", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{12, 15, 0x000000000000000F, "RO/V", "txdll_stat_coarseicode", "Coarse code value at initialization training sequence completion."},
#else
{12, 15, 0x000000000000000F, "RO/V", "txdll_stat_coarseicode", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{8, 11, 0x000000000000000F, "RO/V", "txdll_stat_coarsecode", "Coarse code value during normal operation"},
#else
{8, 11, 0x000000000000000F, "RO/V", "txdll_stat_coarsecode", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 7, 0x000000000000007F, "RO/V", "txdll_stat_finecode", "Fine code value during normal operation"},
#else
{0, 7, 0x000000000000007F, "RO/V", "txdll_stat_finecode", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo611[] = {{"dllcomp_code_status", "", 0x00000614, 5, 0x00000000FFFFFFFF, 0x000000000007FF7F}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields612[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{31, 31, 0x0000000000000000, "RW", "lock_seq_en", "Enable lock sequence after initialization or fine periodic training sequence. 0: disable lock sequence. 1: enable lock sequence."},
#else
{31, 31, 0x0000000000000000, "RW", "lock_seq_en", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{30, 30, 0x0000000000000000, "RW", "lockerror_ignore", "Ignore lock error. Valid when scr_lockseq_en = 1. 0: Exit and wait for initialization training sequence. 1: ignore lock error and proceed to normal operation."},
#else
{30, 30, 0x0000000000000000, "RW", "lockerror_ignore", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{4, 29, 0x0000000000000000, "RO", "Reserved", "Reserved"},
#else
{4, 29, 0x0000000000000000, "RO", "Reserved", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 3, 0x0000000000000003, "RW", "lockcount_size", "Maximum samples to count for lock condition. The counter decrements until the value reaches 0 yielding scr_lockcount_size + 1 samples."},
#else
{0, 3, 0x0000000000000003, "RW", "lockcount_size", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo612[] = {{"dllcomp_lockctl", "", 0x00000618, 4, 0x00000000FFFFFFFF, 0x0000000000000003}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields613[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{31, 31, 0x0000000000000000, "RW", "muxcode_ovr_sel", "Override txdll_fbmuxsel[4:0] with scr_muxcode_ovr[4:0].0: disable override.1: enable override."},
#else
{31, 31, 0x0000000000000000, "RW", "muxcode_ovr_sel", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{21, 30, 0x0000000000000000, "RO", "Reserved", "Reserved"},
#else
{21, 30, 0x0000000000000000, "RO", "Reserved", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{16, 20, 0x000000000000000F, "RW", "muxcode_ovr", "Delay cell fbmuxsel override value."},
#else
{16, 20, 0x000000000000000F, "RW", "muxcode_ovr", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{13, 15, 0x0000000000000000, "RO", "Reserved0", "Reserved"},
#else
{13, 15, 0x0000000000000000, "RO", "Reserved0", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{8, 12, 0x000000000000001B, "RW", "muxcode_max", "Delay cell maximum count value. Used in overflow check"},
#else
{8, 12, 0x000000000000001B, "RW", "muxcode_max", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{5, 7, 0x0000000000000000, "RO", "Reserved1", "Reserved"},
#else
{5, 7, 0x0000000000000000, "RO", "Reserved1", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 4, 0x0000000000000009, "RW", "muxcode_min", "Delay cell minimum count value. Default start code."},
#else
{0, 4, 0x0000000000000009, "RW", "muxcode_min", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo613[] = {{"dllcomp_fbmuxsel", "", 0x0000061C, 7, 0x00000000FFFFFFFF, 0x00000000000F1B09}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields614[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{31, 31, 0x0000000000000000, "RW", "coarsecode_ovr_sel", "Override txdll_coarsecode[3:0] with scr_coarsecode_ovr[3:0]. 0: disable override, 1: enable override"},
#else
{31, 31, 0x0000000000000000, "RW", "coarsecode_ovr_sel", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{30, 30, 0x0000000000000000, "RW", "coarseicode_ovr_sel", "Override txdll_coarseicode[3:0] with scr_coarseicode_ovr[3:0]. 0: disable override, 1: enable override"},
#else
{30, 30, 0x0000000000000000, "RW", "coarseicode_ovr_sel", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{28, 29, 0x0000000000000000, "RO", "Reserved", "Reserved"},
#else
{28, 29, 0x0000000000000000, "RO", "Reserved", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{24, 27, 0x0000000000000002, "RW", "coarseicode_ovr", "Coarsei code override value."},
#else
{24, 27, 0x0000000000000002, "RW", "coarseicode_ovr", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{20, 23, 0x0000000000000000, "RO", "Reserved0", "Reserved"},
#else
{20, 23, 0x0000000000000000, "RO", "Reserved0", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{16, 19, 0x0000000000000002, "RW", "coarsecode_ovr", "Coarse code override value."},
#else
{16, 19, 0x0000000000000002, "RW", "coarsecode_ovr", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{12, 15, 0x0000000000000000, "RO", "Reserved1", "Reserved"},
#else
{12, 15, 0x0000000000000000, "RO", "Reserved1", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{8, 11, 0x000000000000000F, "RW", "coarsecode_max", "Coarse code maximum count value. Default start value. Used in overflow check"},
#else
{8, 11, 0x000000000000000F, "RW", "coarsecode_max", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{4, 7, 0x0000000000000000, "RO", "Reserved2", "Reserved"},
#else
{4, 7, 0x0000000000000000, "RO", "Reserved2", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 3, 0x0000000000000002, "RW", "coarsecode_min", "Coarse code minimum count value. Used in underflow check."},
#else
{0, 3, 0x0000000000000002, "RW", "coarsecode_min", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo614[] = {{"dllcomp_coarsecode", "", 0x00000620, 10, 0x00000000FFFFFFFF, 0x0000000002020F02}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields615[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{24, 31, 0x00000000000000CF, "RW", "finecodemax_limit", "Fine code limit - maximum value. Defines fine code drift allowed towards finecode maximum value before incrementing the coarse code for binary search training."},
#else
{24, 31, 0x00000000000000CF, "RW", "finecodemax_limit", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{16, 23, 0x0000000000000034, "RW", "finecodemin_limit", "Fine code limit - minimum value. Defines fine code drift allowed towards finecode minimum value before decrementing the coarse code for binary search training."},
#else
{16, 23, 0x0000000000000034, "RW", "finecodemin_limit", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{8, 15, 0x00000000000000FF, "RW", "finecode_max", "Fine code maximum value. Used in overflow check during fine continuous or fine periodic"},
#else
{8, 15, 0x00000000000000FF, "RW", "finecode_max", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 7, 0x0000000000000020, "RW", "finecode_min", "Underflow check during fine continuous or fine periodic training."},
#else
{0, 7, 0x0000000000000020, "RW", "finecode_min", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo615[] = {{"dllcomp_finecode", "", 0x00000624, 4, 0x00000000FFFFFFFF, 0x00000000CF34FF20}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields616[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{8, 31, 0x0000000000000000, "RO", "Reserved", "Reserved"},
#else
{8, 31, 0x0000000000000000, "RO", "Reserved", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 7, 0x00000000000000E8, "RW", "finecode_muxsel", "Two bit field selects one of 4 possible finecode values for each 8:1 mux input. Two bit field shared between -/+ index values (ex. -gf / +gf)"},
#else
{0, 7, 0x00000000000000E8, "RW", "finecode_muxsel", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo616[] = {{"dllcomp_finemuxsel", "", 0x00000628, 2, 0x00000000FFFFFFFF, 0x00000000000000E8}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields617[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{31, 31, 0x0000000000000000, "RW", "finec_mode", "Fine continuous training enable after initialization training. 0: Fine continuous training disable. 1: Fine continuous training enable (default). When both finec_mode and finep_mode are set to 1, dllcomp functionality is unpredictable."},
#else
{31, 31, 0x0000000000000000, "RW", "finec_mode", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{30, 30, 0x0000000000000000, "RW", "finep_mode", "Fine priodic training enable after initialization training. 0: Fine periodic disable (default). 1: Fine periodic enable. When both finec_mode and finep_mode are set to 1, dllcomp functionality is unpredictable."},
#else
{30, 30, 0x0000000000000000, "RW", "finep_mode", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{29, 29, 0x0000000000000000, "RW", "searchalgo_long", "Propriety search algorithm version to apply during lock, fine continuous and fine periodic training. 0: Apply short version. 1: Apply long version."},
#else
{29, 29, 0x0000000000000000, "RW", "searchalgo_long", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{8, 28, 0x0000000000000000, "RO", "Reserved", "Reserved"},
#else
{8, 28, 0x0000000000000000, "RO", "Reserved", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 7, 0x000000000000007F, "RW", "finecode_start", "Fine code start value to apply during binary search training"},
#else
{0, 7, 0x000000000000007F, "RW", "finecode_start", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo617[] = {{"dllcomp_finectl", "", 0x0000062C, 5, 0x00000000FFFFFFFF, 0x000000000000007F}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields618[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{31, 31, 0x0000000000000000, "RW", "finecode_ovr_sel", "Fine code override select. 0: Apply computed fine code (default). 1: Apply scr_finecode_ovr[7:0] ."},
#else
{31, 31, 0x0000000000000000, "RW", "finecode_ovr_sel", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{30, 30, 0x0000000000000000, "RW", "finecode_updateovr_ovr", "When scr_finecode_ovr_sel is active high, this bit drives txdll_dllupdateovr"},
#else
{30, 30, 0x0000000000000000, "RW", "finecode_updateovr_ovr", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{8, 29, 0x0000000000000000, "RO", "Reserved", "Reserved"},
#else
{8, 29, 0x0000000000000000, "RO", "Reserved", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 7, 0x0000000000000013, "RW", "finecode_ovr", "Fine code to override with when scr_finecode_ovr_sel = 1"},
#else
{0, 7, 0x0000000000000013, "RW", "finecode_ovr", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo618[] = {{"dllcomp_finecodeovr", "", 0x00000630, 4, 0x00000000FFFFFFFF, 0x0000000000000013}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields619[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{16, 31, 0x0000000000000000, "RO", "Reserved", "Reserved"},
#else
{16, 31, 0x0000000000000000, "RO", "Reserved", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 15, 0x0000000000003FFF, "RW", "finepwait_interval", "Fine periodic interval timer start value. Defines the interval between back to back fine periodic training sequences."},
#else
{0, 15, 0x0000000000003FFF, "RW", "finepwait_interval", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo619[] = {{"dllcomp_fptimer", "", 0x00000634, 2, 0x00000000FFFFFFFF, 0x0000000000003FFF}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields620[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{13, 31, 0x0000000000000000, "RO", "Reserved", "Reserved"},
#else
{13, 31, 0x0000000000000000, "RO", "Reserved", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{8, 12, 0x0000000000000006, "RW", "samplewait_max", "Wait interval between code update and sample ready. Applied during lock, fine continuous and fine"},
#else
{8, 12, 0x0000000000000006, "RW", "samplewait_max", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{5, 7, 0x0000000000000000, "RO", "Reserved0", "Reserved"},
#else
{5, 7, 0x0000000000000000, "RO", "Reserved0", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 4, 0x0000000000000002, "RW", "samplewait_min", "Wait interval between code update and sample ready. Applied during coarse initialization and fine"},
#else
{0, 4, 0x0000000000000002, "RW", "samplewait_min", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo620[] = {{"dllcomp_samplewait", "", 0x00000638, 4, 0x00000000FFFFFFFF, 0x0000000000000602}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields621[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{31, 31, 0x0000000000000000, "RW", "rxdll_coarsecode_ovr_sel", "Override rxdll_coarsecode[3:0] with scr_rxdll_coarsecode_ovr[3:0] . 0: disable override. 1: enable override."},
#else
{31, 31, 0x0000000000000000, "RW", "rxdll_coarsecode_ovr_sel", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{4, 30, 0x0000000000000000, "RO", "Reserved", "Reserved"},
#else
{4, 30, 0x0000000000000000, "RO", "Reserved", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 3, 0x0000000000000002, "RW", "rxdll_coarsecode_ovr", "Coarse code override value for rxdll_coarsecode[3:0]"},
#else
{0, 3, 0x0000000000000002, "RW", "rxdll_coarsecode_ovr", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo621[] = {{"dllcomp_rxcoarseovr", "", 0x0000063C, 3, 0x00000000FFFFFFFF, 0x0000000000000002}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields622[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{31, 31, 0x0000000000000000, "RW", "rxdll_finecode_ovr_sel", "Override rxdll_finecode[7:0] with scr_rxdll_finecode_ovr[7:0] . 0: disable override. 1: enable override."},
#else
{31, 31, 0x0000000000000000, "RW", "rxdll_finecode_ovr_sel", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{30, 30, 0x0000000000000000, "RW", "rxdll_finecode_updateovr_ovr", "When scr_rxdll_finecode_ovr_sel is active high, this bit drives rxdll_rxdqsdllupdateovr"},
#else
{30, 30, 0x0000000000000000, "RW", "rxdll_finecode_updateovr_ovr", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{8, 29, 0x0000000000000000, "RO", "Reserved", "Reserved"},
#else
{8, 29, 0x0000000000000000, "RO", "Reserved", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 7, 0x0000000000000013, "RW", "rxdll_finecode_ovr", "FIne code override value for rxdll_finecode[7:0]"},
#else
{0, 7, 0x0000000000000013, "RW", "rxdll_finecode_ovr", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo622[] = {{"dllcomp_rxfineovr", "", 0x00000640, 4, 0x00000000FFFFFFFF, 0x0000000000000013}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields623[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{17, 31, 0x0000000000000000, "RO", "reserved673", "Reserved"},
#else
{17, 31, 0x0000000000000000, "RO", "reserved673", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{16, 16, 0x0000000000000000, "RW", "dfxlowervisaulm0_bypass", "VISA Lower Level Bypass ULM0"},
#else
{16, 16, 0x0000000000000000, "RW", "dfxlowervisaulm0_bypass", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{8, 15, 0x0000000000000000, "RW", "dfxlowervisaulm0_clksel", "VISA Lower Level ULM0 CLK Select"},
#else
{8, 15, 0x0000000000000000, "RW", "dfxlowervisaulm0_clksel", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 7, 0x0000000000000000, "RW", "dfxlowervisaulm0_datasel", "VISA Lower Level ULM0 Lane (DATA) Select"},
#else
{0, 7, 0x0000000000000000, "RW", "dfxlowervisaulm0_datasel", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo623[] = {{"lower_dfxvisaulm0", "", 0x00000700, 4, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields624[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{17, 31, 0x0000000000000000, "RO", "reserved674", "Reserved"},
#else
{17, 31, 0x0000000000000000, "RO", "reserved674", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{16, 16, 0x0000000000000000, "RW", "dfxlowervisaulm1_bypass", "VISA Lower Level Bypass ULM1"},
#else
{16, 16, 0x0000000000000000, "RW", "dfxlowervisaulm1_bypass", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{8, 15, 0x0000000000000000, "RW", "dfxlowervisaulm1_clksel", "VISA Lower Level ULM1 CLK Select"},
#else
{8, 15, 0x0000000000000000, "RW", "dfxlowervisaulm1_clksel", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 7, 0x0000000000000000, "RW", "dfxlowervisaulm1_datasel", "VISA Lower Level ULM1 Lane (DATA) Select"},
#else
{0, 7, 0x0000000000000000, "RW", "dfxlowervisaulm1_datasel", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo624[] = {{"lower_dfxvisaulm1", "", 0x00000704, 4, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields625[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{7, 31, 0x0000000000000000, "RO", "reserved675", "Reserved"},
#else
{7, 31, 0x0000000000000000, "RO", "reserved675", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{4, 6, 0x0000000000000000, "RW", "dfxlowervisapattgen_msb", "VISA Lower Level ULM Pattern Generation"},
#else
{4, 6, 0x0000000000000000, "RW", "dfxlowervisapattgen_msb", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 3, 0x0000000000000000, "RW", "dfxlowervisapattgen_lsb", "VISA Lower Level ULM Pattern Generation"},
#else
{0, 3, 0x0000000000000000, "RW", "dfxlowervisapattgen_lsb", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo625[] = {{"lower_dfxvisapattgen", "", 0x00000708, 3, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields626[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{17, 31, 0x0000000000000000, "RO", "reserved676", "Reserved"},
#else
{17, 31, 0x0000000000000000, "RO", "reserved676", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{16, 16, 0x0000000000000000, "RW", "dfxtopvisaulm0_bypass", "VISA Top Level Bypass ULM0"},
#else
{16, 16, 0x0000000000000000, "RW", "dfxtopvisaulm0_bypass", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{8, 15, 0x0000000000000000, "RW", "dfxtopvisaulm0_clksel", "VISA Top Level ULM0 CLK Select"},
#else
{8, 15, 0x0000000000000000, "RW", "dfxtopvisaulm0_clksel", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 7, 0x0000000000000000, "RW", "dfxtopvisaulm0_datasel", "VISA Top Level ULM0 Lane (DATA) Select"},
#else
{0, 7, 0x0000000000000000, "RW", "dfxtopvisaulm0_datasel", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo626[] = {{"top_dfxvisaulm0", "", 0x0000070C, 4, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields627[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{17, 31, 0x0000000000000000, "RO", "reserved677", "Reserved"},
#else
{17, 31, 0x0000000000000000, "RO", "reserved677", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{16, 16, 0x0000000000000000, "RW", "dfxtopvisaulm1_bypass", "VISA Top Level Bypass ULM1"},
#else
{16, 16, 0x0000000000000000, "RW", "dfxtopvisaulm1_bypass", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{8, 15, 0x0000000000000000, "RW", "dfxtopvisaulm1_clksel", "VISA Top Level ULM1 CLK Select"},
#else
{8, 15, 0x0000000000000000, "RW", "dfxtopvisaulm1_clksel", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 7, 0x0000000000000000, "RW", "dfxtopvisaulm1_datasel", "VISA Top Level ULM1 Lane (DATA) Select"},
#else
{0, 7, 0x0000000000000000, "RW", "dfxtopvisaulm1_datasel", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo627[] = {{"top_dfxvisaulm1", "", 0x00000710, 4, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields628[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{7, 31, 0x0000000000000000, "RO", "reserved678", "Reserved"},
#else
{7, 31, 0x0000000000000000, "RO", "reserved678", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{4, 6, 0x0000000000000000, "RW", "dfxtopvisapattgen_msb", "VISA Top Level ULM Pattern Generation"},
#else
{4, 6, 0x0000000000000000, "RW", "dfxtopvisapattgen_msb", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 3, 0x0000000000000000, "RW", "dfxtopvisapattgen_lsb", "VISA Top Level ULM Pattern Generation"},
#else
{0, 3, 0x0000000000000000, "RW", "dfxtopvisapattgen_lsb", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo628[] = {{"top_dfxvisapattgen", "", 0x00000714, 3, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields629[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{22, 31, 0x0000000000000000, "RO", "reserved679", "Reserved bits"},
#else
{22, 31, 0x0000000000000000, "RO", "reserved679", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{21, 21, 0x0000000000000000, "RW", "bl_dfxmrgtxovren", "DQ Bytelane Tx FIFO Margin Mode config override enable for Tx data path and Latch enables via  DFXMRGTXFIFO[24:0]    1'b1  - Enable TxFIFO DFx overrides on Latch enables and TxData  1'b0 - Functional Mode of operation"},
#else
{21, 21, 0x0000000000000000, "RW", "bl_dfxmrgtxovren", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{20, 20, 0x0000000000000000, "RW", "bl_dfxmrgtxwren", "DQ Bytelane TxFIFO Margin Mode Latch enable override value used to make TxFIFO latches transparent allowing the loading of all TxFIFO Latches with data programmed in DFXMRGTXFIFO[23:0], if dfxmrgtxovren is asserted(1'b1)  1'b1 - All DQ/DM/DQS Tx FIFO Latches Transparent  0'b0 - All DQ/DM/DQS TxFIFO Latches CLosed"},
#else
{20, 20, 0x0000000000000000, "RW", "bl_dfxmrgtxwren", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{18, 19, 0x0000000000000000, "RW", "bl_dfxmrgtxdqsrise", "DQ Bytelane Tx FIFO Margin Mode DQS/B Rise Tx SubFIFO data load value. The value loaded will apply to all DQ Bytelane DQS/B Rise SubFIFOs. Recommended setting for HVM = 2'b00"},
#else
{18, 19, 0x0000000000000000, "RW", "bl_dfxmrgtxdqsrise", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{16, 17, 0x0000000000000000, "RW", "bl_dfxmrgtxdqsfall", "DQ Bytelane Tx FIFO Margin Mode DQS/B Fall Tx SubFIFO data load value. The value loaded will apply to all DQ Bytelane DQS/B Fall SubFIFOs. Recommended setting for HVM = 2'b00"},
#else
{16, 17, 0x0000000000000000, "RW", "bl_dfxmrgtxdqsfall", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{14, 15, 0x0000000000000000, "RW", "bl_dfxmrgtxdrise_ph0", "DQ Bytelane Tx FIFO Margin Mode DQ Phase0 Rise Tx SubFIFO load value. The value loaded will apply to all DQ BL Phase 0 Rise SubFIFOs  There isnt a valid or invalid value for this field, recommended setting for HVM = 2'b00"},
#else
{14, 15, 0x0000000000000000, "RW", "bl_dfxmrgtxdrise_ph0", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{12, 13, 0x0000000000000000, "RW", "bl_dfxmrgtxdrise_ph1", "DQ Bytelane Tx FIFO Margin Mode DQ Phase1 Rise Tx SubFIFO load value. The value loaded will apply to all DQ BL Phase 1 Rise SubFIFOs  There isnt a valid or invalid value for this field, recommended setting for HVM = 2'b00"},
#else
{12, 13, 0x0000000000000000, "RW", "bl_dfxmrgtxdrise_ph1", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{10, 11, 0x0000000000000000, "RW", "bl_dfxmrgtxdrise_ph2", "DQ Bytelane Tx FIFO Margin Mode DQ Phase0 Rise Tx SubFIFO load value. The value loaded will apply to all DQ BL Phase 2 Rise SubFIFOs  There isnt a valid or invalid value for this field, recommended setting for HVM = 2'b00"},
#else
{10, 11, 0x0000000000000000, "RW", "bl_dfxmrgtxdrise_ph2", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{8, 9, 0x0000000000000000, "RW", "bl_dfxmrgtxdrise_ph3", "DQ Bytelane Tx FIFO Margin Mode DQ Phase1 Rise Tx SubFIFO load value. The value loaded will apply to all DQ BL Phase 3 Rise SubFIFOs  There isnt a valid or invalid value for this field, recommended setting for HVM = 2'b00"},
#else
{8, 9, 0x0000000000000000, "RW", "bl_dfxmrgtxdrise_ph3", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{6, 7, 0x0000000000000000, "RW", "bl_dfxmrgtxdfall_ph0", "DQ Bytelane Tx FIFO Margin Mode DQ Phase0 Fall Tx SubFIFO load value. The value loaded will apply to all DQ BL Phase 0 Fall SubFIFOs  There isnt a valid or invalid value for this field, recommended setting for HVM = 2'b00"},
#else
{6, 7, 0x0000000000000000, "RW", "bl_dfxmrgtxdfall_ph0", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{4, 5, 0x0000000000000000, "RW", "bl_dfxmrgtxdfall_ph1", "DQ Bytelane Tx FIFO Margin Mode DQ Phase1 Fall Tx SubFIFO load value. The value loaded will apply to all DQ BL Phase 1 Fall SubFIFOs  There isnt a valid or invalid value for this field, recommended setting for HVM = 2'b00"},
#else
{4, 5, 0x0000000000000000, "RW", "bl_dfxmrgtxdfall_ph1", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{2, 3, 0x0000000000000000, "RW", "bl_dfxmrgtxdfall_ph2", "DQ Bytelane Tx FIFO Margin Mode DQ Phase2 Fall Tx SubFIFO load value. The value loaded will apply to all DQ BL Phase 2 Fall SubFIFOs  There isnt a valid or invalid value for this field, recommended setting for HVM = 2'b00"},
#else
{2, 3, 0x0000000000000000, "RW", "bl_dfxmrgtxdfall_ph2", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 1, 0x0000000000000000, "RW", "bl_dfxmrgtxdfall_ph3", "DQ Bytelane Tx FIFO Margin Mode DQ Phase3 Fall Tx SubFIFO load value. The value loaded will apply to all DQ BL Phase 3 Rise SubFIFOs  There isnt a valid or invalid value for this field, recommended setting for HVM = 2'b00"},
#else
{0, 1, 0x0000000000000000, "RW", "bl_dfxmrgtxdfall_ph3", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo629[] = {{"dfxmrg_bl", "", 0x00000718, 13, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields630[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{30, 31, 0x0000000000000000, "RO", "reserved680", "Reserved bits"},
#else
{30, 31, 0x0000000000000000, "RO", "reserved680", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{29, 29, 0x0000000000000000, "RW", "cc_dfxmrgtxovren", "DQCCC Bytelane Tx FIFO Margin Mode config override enable for Tx data path and Latch enables via  DFXMRGTXFIFO[24:0]    1'b1  - Enable TxFIFO DFx overrides on Latch enables and TxData  1'b0 - Functional Mode of operation"},
#else
{29, 29, 0x0000000000000000, "RW", "cc_dfxmrgtxovren", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{28, 28, 0x0000000000000000, "RW", "cc_dfxmrgtxwren", "DQCCC Bytelane TxFIFO Margin Mode Latch enable override value used to make TxFIFO latches transparent allowing the loading of all TxFIFO Latches with data programmed in DFXMRGTXFIFO[23:0], if dfxmrgtxovren is asserted(1'b1)  1'b1 - All DQCCC/DM/DQCCCS Tx FIFO Latches Transparent  0'b0 - All DQCCC/DM/DQCCCS TxFIFO Latches CLosed"},
#else
{28, 28, 0x0000000000000000, "RW", "cc_dfxmrgtxwren", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{26, 27, 0x0000000000000000, "RW", "cc_dfxmrgtxdqsrise", "DQCCC Bytelane Tx FIFO Margin Mode DQCCCS/B Rise Tx SubFIFO data load value. The value loaded will apply to all DQCCC Bytelane DQCCCS/B Rise SubFIFOs. Recommended setting for HVM = 2'b00"},
#else
{26, 27, 0x0000000000000000, "RW", "cc_dfxmrgtxdqsrise", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{24, 25, 0x0000000000000000, "RW", "cc_dfxmrgtxdqsfall", "DQCCC Bytelane Tx FIFO Margin Mode DQCCCS/B Fall Tx SubFIFO data load value. The value loaded will apply to all DQCCC Bytelane DQCCCS/B Fall SubFIFOs. Recommended setting for HVM = 2'b00"},
#else
{24, 25, 0x0000000000000000, "RW", "cc_dfxmrgtxdqsfall", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{22, 23, 0x0000000000000000, "RW", "cc_dfxmrgtxdrise_ph0", "DQCCC Bytelane Tx FIFO Margin Mode DQCCC Phase0 Rise Tx SubFIFO load value. The value loaded will apply to all DQCCC BL Phase 0 Rise SubFIFOs  There isnt a valid or invalid value for this field, recommended setting for HVM = 2'b00"},
#else
{22, 23, 0x0000000000000000, "RW", "cc_dfxmrgtxdrise_ph0", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{20, 21, 0x0000000000000000, "RW", "cc_dfxmrgtxdrise_ph1", "DQCCC Bytelane Tx FIFO Margin Mode DQCCC Phase1 Rise Tx SubFIFO load value. The value loaded will apply to all DQCCC BL Phase 1 Rise SubFIFOs  There isnt a valid or invalid value for this field, recommended setting for HVM = 2'b00"},
#else
{20, 21, 0x0000000000000000, "RW", "cc_dfxmrgtxdrise_ph1", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{18, 19, 0x0000000000000000, "RW", "cc_dfxmrgtxdrise_ph2", "DQCCC Bytelane Tx FIFO Margin Mode DQCCC Phase0 Rise Tx SubFIFO load value. The value loaded will apply to all DQCCC BL Phase 2 Rise SubFIFOs  There isnt a valid or invalid value for this field, recommended setting for HVM = 2'b00"},
#else
{18, 19, 0x0000000000000000, "RW", "cc_dfxmrgtxdrise_ph2", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{16, 17, 0x0000000000000000, "RW", "cc_dfxmrgtxdrise_ph3", "DQCCC Bytelane Tx FIFO Margin Mode DQCCC Phase1 Rise Tx SubFIFO load value. The value loaded will apply to all DQCCC BL Phase 3 Rise SubFIFOs  There isnt a valid or invalid value for this field, recommended setting for HVM = 2'b00"},
#else
{16, 17, 0x0000000000000000, "RW", "cc_dfxmrgtxdrise_ph3", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{14, 15, 0x0000000000000000, "RW", "cc_dfxmrgtxdfall_ph0", "DQCCC Bytelane Tx FIFO Margin Mode DQCCC Phase0 Fall Tx SubFIFO load value. The value loaded will apply to all DQCCC BL Phase 0 Fall SubFIFOs  There isnt a valid or invalid value for this field, recommended setting for HVM = 2'b00"},
#else
{14, 15, 0x0000000000000000, "RW", "cc_dfxmrgtxdfall_ph0", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{12, 13, 0x0000000000000000, "RW", "cc_dfxmrgtxdfall_ph1", "DQCCC Bytelane Tx FIFO Margin Mode DQCCC Phase1 Fall Tx SubFIFO load value. The value loaded will apply to all DQCCC BL Phase 1 Fall SubFIFOs  There isnt a valid or invalid value for this field, recommended setting for HVM = 2'b00"},
#else
{12, 13, 0x0000000000000000, "RW", "cc_dfxmrgtxdfall_ph1", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{10, 11, 0x0000000000000000, "RW", "cc_dfxmrgtxdfall_ph2", "DQCCC Bytelane Tx FIFO Margin Mode DQCCC Phase2 Fall Tx SubFIFO load value. The value loaded will apply to all DQCCC BL Phase 2 Fall SubFIFOs  There isnt a valid or invalid value for this field, recommended setting for HVM = 2'b00"},
#else
{10, 11, 0x0000000000000000, "RW", "cc_dfxmrgtxdfall_ph2", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{8, 9, 0x0000000000000000, "RW", "cc_dfxmrgtxdfall_ph3", "DQCCC Bytelane Tx FIFO Margin Mode DQCCC Phase3 Fall Tx SubFIFO load value. The value loaded will apply to all DQCCC BL Phase 3 Rise SubFIFOs  There isnt a valid or invalid value for this field, recommended setting for HVM = 2'b00"},
#else
{8, 9, 0x0000000000000000, "RW", "cc_dfxmrgtxdfall_ph3", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{6, 7, 0x0000000000000000, "RW", "cc_dfxmrgtxdsdr_ph0", "DQCCC Bytelane Tx FIFO Margin Mode DQCCC Phase0 SDR Tx SubFIFO load value. The value loaded will apply to all DQCCC BL Phase 0 SDR SubFIFOs  There isnt a valid or invalid value for this field, recommended setting for HVM = 2'b00"},
#else
{6, 7, 0x0000000000000000, "RW", "cc_dfxmrgtxdsdr_ph0", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{4, 5, 0x0000000000000000, "RW", "cc_dfxmrgtxdsdr_ph1", "DQCCC Bytelane Tx FIFO Margin Mode DQCCC Phase1 SDR Tx SubFIFO load value. The value loaded will apply to all DQCCC BL Phase 1 SDR SubFIFOs  There isnt a valid or invalid value for this field, recommended setting for HVM = 2'b00"},
#else
{4, 5, 0x0000000000000000, "RW", "cc_dfxmrgtxdsdr_ph1", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{2, 3, 0x0000000000000000, "RW", "cc_dfxmrgtxdsdr_ph2", "DQCCC Bytelane Tx FIFO Margin Mode DQCCC Phase2 SDR Tx SubFIFO load value. The value loaded will apply to all DQCCC BL Phase 2 SDR SubFIFOs  There isnt a valid or invalid value for this field, recommended setting for HVM = 2'b11"},
#else
{2, 3, 0x0000000000000000, "RW", "cc_dfxmrgtxdsdr_ph2", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 1, 0x0000000000000000, "RW", "cc_dfxmrgtxdsdr_ph3", "DQCCC Bytelane Tx FIFO Margin Mode DQCCC Phase3 SDR Tx SubFIFO load value. The value loaded will apply to all DQCCC BL Phase 3 Rise SubFIFOs  There isnt a valid or invalid value for this field, recommended setting for HVM = 2'b00"},
#else
{0, 1, 0x0000000000000000, "RW", "cc_dfxmrgtxdsdr_ph3", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo630[] = {{"dfxmrg_cc", "", 0x0000071C, 17, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields631[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{8, 31, 0x0000000000000000, "RO", "reserved681", "Reserved bits"},
#else
{8, 31, 0x0000000000000000, "RO", "reserved681", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 7, 0x0000000000000000, "RW", "bl_dfxmrgrx_cmpval", "DFx Margin Mode DQ Bytelane Rx Compare value; Used to compare Actual RxFIFO value vs Expected Rx FIFO value(TxFIFO Unloaded)"},
#else
{0, 7, 0x0000000000000000, "RW", "bl_dfxmrgrx_cmpval", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo631[] = {{"dfxmrg_blrx", "", 0x00000720, 2, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields632[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{25, 31, 0x0000000000000000, "RO", "reserved682", "Reserved bits"},
#else
{25, 31, 0x0000000000000000, "RO", "reserved682", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{16, 24, 0x0000000000000000, "RW", "cc_dfxmrgrx_sdrsel", "DFx Margin Mode SDR vs DDR Rx Compare Values"},
#else
{16, 24, 0x0000000000000000, "RW", "cc_dfxmrgrx_sdrsel", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{8, 15, 0x0000000000000000, "RW", "cc_dfxmrgrx_ddrcmpval", "DFx Margin Mode CCC Bytelane Rx Compare value for DDR pins; Used to compare Actual RxFIFO value vs Expected Rx FIFO value(TxFIFO Unloaded)"},
#else
{8, 15, 0x0000000000000000, "RW", "cc_dfxmrgrx_ddrcmpval", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 7, 0x0000000000000000, "RW", "cc_dfxmrgrx_sdrcmpval", "DFx Margin Mode CCC Bytelane Rx Compare value for SDR pins; Used to compare Actual RxFIFO value vs Expected Rx FIFO value(TxFIFO Unloaded)"},
#else
{0, 7, 0x0000000000000000, "RW", "cc_dfxmrgrx_sdrcmpval", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo632[] = {{"dfxmrg_ccrx", "", 0x00000724, 4, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields633[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{30, 31, 0x0000000000000000, "RO", "Reserved", "Reserved"},
#else
{30, 31, 0x0000000000000000, "RO", "Reserved", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{24, 29, 0x0000000000000000, "RW", "ptrdtype2rdvld", "LP4 Periodic Training Control 1"},
#else
{24, 29, 0x0000000000000000, "RW", "ptrdtype2rdvld", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{17, 23, 0x0000000000000000, "RW", "rk1initialindex", "LP4 Periodic Training Control 1"},
#else
{17, 23, 0x0000000000000000, "RW", "rk1initialindex", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{10, 16, 0x0000000000000000, "RW", "rk0initialindex", "LP4 Periodic Training Control 1"},
#else
{10, 16, 0x0000000000000000, "RW", "rk0initialindex", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{6, 9, 0x0000000000000000, "RW", "ptloadcode_dly", "LP4 Periodic Training Control 1"},
#else
{6, 9, 0x0000000000000000, "RW", "ptloadcode_dly", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{3, 5, 0x0000000000000000, "RW", "ptrdtype2rdvld_plus1sel", "LP4 Periodic Training Control 1"},
#else
{3, 5, 0x0000000000000000, "RW", "ptrdtype2rdvld_plus1sel", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{2, 2, 0x0000000000000000, "RW", "numpi_perindex", "LP4 Periodic Training Control 1"},
#else
{2, 2, 0x0000000000000000, "RW", "numpi_perindex", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{1, 1, 0x0000000000000000, "RW", "bytelane1datasel", "LP4 Periodic Training Control 1"},
#else
{1, 1, 0x0000000000000000, "RW", "bytelane1datasel", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 0, 0x0000000000000000, "RW", "pten", "LP4 Periodic Training Control 1"},
#else
{0, 0, 0x0000000000000000, "RW", "pten", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo633[] = {{"ptctl0", "", 0x00000000, 9, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields634[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{16, 31, 0x0000000000000000, "RO", "Reserved", "LP4 Periodic Training Control 1"},
#else
{16, 31, 0x0000000000000000, "RO", "Reserved", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{9, 15, 0x0000000000000000, "RO/V", "rk1currentindex", "LP4 Periodic Training Control 1"},
#else
{9, 15, 0x0000000000000000, "RO/V", "rk1currentindex", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{8, 8, 0x0000000000000000, "RO", "Reserved0", "LP4 Periodic Training Control 1"},
#else
{8, 8, 0x0000000000000000, "RO", "Reserved0", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{1, 7, 0x0000000000000000, "RO/V", "rk0currentindex", "LP4 Periodic Training Control 1"},
#else
{1, 7, 0x0000000000000000, "RO/V", "rk0currentindex", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 0, 0x0000000000000000, "RO", "Reserved1", "LP4 Periodic Training Control 1"},
#else
{0, 0, 0x0000000000000000, "RO", "Reserved1", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo634[] = {{"ptctl1", "", 0x00000004, 5, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields635[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{16, 31, 0x0000000000000000, "RW", "rocount1", "LP4 PT Ring Oscillator Count Pair 12"},
#else
{16, 31, 0x0000000000000000, "RW", "rocount1", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 15, 0x0000000000000000, "RW", "rocount2", "LP4 PT Ring Oscillator Count Pair 12"},
#else
{0, 15, 0x0000000000000000, "RW", "rocount2", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo635[] = {{"ptrocnt12", "", 0x00000008, 2, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields636[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{16, 31, 0x0000000000000000, "RW", "rocount3", "LP4 PT Ring Oscillator Count Pair 34"},
#else
{16, 31, 0x0000000000000000, "RW", "rocount3", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 15, 0x0000000000000000, "RW", "rocount4", "LP4 PT Ring Oscillator Count Pair 34"},
#else
{0, 15, 0x0000000000000000, "RW", "rocount4", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo636[] = {{"ptrocnt34", "", 0x0000000C, 2, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields637[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{16, 31, 0x0000000000000000, "RW", "rocount5", "LP4 PT Ring Oscillator Count Pair 56"},
#else
{16, 31, 0x0000000000000000, "RW", "rocount5", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 15, 0x0000000000000000, "RW", "rocount6", "LP4 PT Ring Oscillator Count Pair 56"},
#else
{0, 15, 0x0000000000000000, "RW", "rocount6", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo637[] = {{"ptrocnt56", "", 0x00000010, 2, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields638[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{16, 31, 0x0000000000000000, "RW", "rocount7", "LP4 PT Ring Oscillator Count Pair 78"},
#else
{16, 31, 0x0000000000000000, "RW", "rocount7", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 15, 0x0000000000000000, "RW", "rocount8", "LP4 PT Ring Oscillator Count Pair 78"},
#else
{0, 15, 0x0000000000000000, "RW", "rocount8", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo638[] = {{"ptrocnt78", "", 0x00000014, 2, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields639[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{16, 31, 0x0000000000000000, "RW", "rocount9", "LP4 PT Ring Oscillator Count Pair 910"},
#else
{16, 31, 0x0000000000000000, "RW", "rocount9", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 15, 0x0000000000000000, "RW", "rocount10", "LP4 PT Ring Oscillator Count Pair 910"},
#else
{0, 15, 0x0000000000000000, "RW", "rocount10", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo639[] = {{"ptrocnt910", "", 0x00000018, 2, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields640[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{16, 31, 0x0000000000000000, "RW", "rocount11", "LP4 PT Ring Oscillator Count Pair 1112"},
#else
{16, 31, 0x0000000000000000, "RW", "rocount11", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 15, 0x0000000000000000, "RW", "rocount12", "LP4 PT Ring Oscillator Count Pair 1112"},
#else
{0, 15, 0x0000000000000000, "RW", "rocount12", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo640[] = {{"ptrocnt1112", "", 0x0000001C, 2, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields641[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{16, 31, 0x0000000000000000, "RW", "rocount13", "LP4 PT Ring Oscillator Count Pair 1314"},
#else
{16, 31, 0x0000000000000000, "RW", "rocount13", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 15, 0x0000000000000000, "RW", "rocount14", "LP4 PT Ring Oscillator Count Pair 1314"},
#else
{0, 15, 0x0000000000000000, "RW", "rocount14", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo641[] = {{"ptrocnt1314", "", 0x00000020, 2, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields642[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{16, 31, 0x0000000000000000, "RW", "rocount15", "LP4 PT Ring Oscillator Count Pair 1516"},
#else
{16, 31, 0x0000000000000000, "RW", "rocount15", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 15, 0x0000000000000000, "RW", "rocount16", "LP4 PT Ring Oscillator Count Pair 1516"},
#else
{0, 15, 0x0000000000000000, "RW", "rocount16", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo642[] = {{"ptrocnt1516", "", 0x00000024, 2, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields643[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{16, 31, 0x0000000000000000, "RW", "rocount17", "LP4 PT Ring Oscillator Count Pair 1718"},
#else
{16, 31, 0x0000000000000000, "RW", "rocount17", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 15, 0x0000000000000000, "RW", "rocount18", "LP4 PT Ring Oscillator Count Pair 1718"},
#else
{0, 15, 0x0000000000000000, "RW", "rocount18", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo643[] = {{"ptrocnt1718", "", 0x00000028, 2, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields644[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{16, 31, 0x0000000000000000, "RW", "rocount19", "LP4 PT Ring Oscillator Count Pair 1920"},
#else
{16, 31, 0x0000000000000000, "RW", "rocount19", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 15, 0x0000000000000000, "RW", "rocount20", "LP4 PT Ring Oscillator Count Pair 1920"},
#else
{0, 15, 0x0000000000000000, "RW", "rocount20", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo644[] = {{"ptrocnt1920", "", 0x0000002C, 2, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields645[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{16, 31, 0x0000000000000000, "RW", "rocount21", "LP4 PT Ring Oscillator Count Pair 2122"},
#else
{16, 31, 0x0000000000000000, "RW", "rocount21", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 15, 0x0000000000000000, "RW", "rocount22", "LP4 PT Ring Oscillator Count Pair 2122"},
#else
{0, 15, 0x0000000000000000, "RW", "rocount22", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo645[] = {{"ptrocnt2122", "", 0x00000030, 2, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields646[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{16, 31, 0x0000000000000000, "RW", "rocount23", "LP4 PT Ring Oscillator Count Pair 2324"},
#else
{16, 31, 0x0000000000000000, "RW", "rocount23", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 15, 0x0000000000000000, "RW", "rocount24", "LP4 PT Ring Oscillator Count Pair 2324"},
#else
{0, 15, 0x0000000000000000, "RW", "rocount24", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo646[] = {{"ptrocnt2324", "", 0x00000034, 2, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields647[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{16, 31, 0x0000000000000000, "RW", "rocount25", "LP4 PT Ring Oscillator Count Pair 2526"},
#else
{16, 31, 0x0000000000000000, "RW", "rocount25", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 15, 0x0000000000000000, "RW", "rocount26", "LP4 PT Ring Oscillator Count Pair 2526"},
#else
{0, 15, 0x0000000000000000, "RW", "rocount26", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo647[] = {{"ptrocnt2526", "", 0x00000038, 2, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields648[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{16, 31, 0x0000000000000000, "RW", "rocount27", "LP4 PT Ring Oscillator Count Pair 2728"},
#else
{16, 31, 0x0000000000000000, "RW", "rocount27", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 15, 0x0000000000000000, "RW", "rocount28", "LP4 PT Ring Oscillator Count Pair 2728"},
#else
{0, 15, 0x0000000000000000, "RW", "rocount28", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo648[] = {{"ptrocnt2728", "", 0x0000003C, 2, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields649[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{16, 31, 0x0000000000000000, "RW", "rocount29", "LP4 PT Ring Oscillator Count Pair 2930"},
#else
{16, 31, 0x0000000000000000, "RW", "rocount29", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 15, 0x0000000000000000, "RW", "rocount30", "LP4 PT Ring Oscillator Count Pair 2930"},
#else
{0, 15, 0x0000000000000000, "RW", "rocount30", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo649[] = {{"ptrocnt2930", "", 0x00000040, 2, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields650[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{16, 31, 0x0000000000000000, "RW", "rocount31", "LP4 PT Ring Oscillator Count Pair 3132"},
#else
{16, 31, 0x0000000000000000, "RW", "rocount31", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 15, 0x0000000000000000, "RW", "rocount32", "LP4 PT Ring Oscillator Count Pair 3132"},
#else
{0, 15, 0x0000000000000000, "RW", "rocount32", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo650[] = {{"ptrocnt3132", "", 0x00000044, 2, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields651[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{16, 31, 0x0000000000000000, "RW", "rocount33", "LP4 PT Ring Oscillator Count Pair 3334"},
#else
{16, 31, 0x0000000000000000, "RW", "rocount33", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 15, 0x0000000000000000, "RW", "rocount34", "LP4 PT Ring Oscillator Count Pair 3334"},
#else
{0, 15, 0x0000000000000000, "RW", "rocount34", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo651[] = {{"ptrocnt3334", "", 0x00000048, 2, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields652[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{16, 31, 0x0000000000000000, "RW", "rocount35", "LP4 PT Ring Oscillator Count Pair 3536"},
#else
{16, 31, 0x0000000000000000, "RW", "rocount35", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 15, 0x0000000000000000, "RW", "rocount36", "LP4 PT Ring Oscillator Count Pair 3536"},
#else
{0, 15, 0x0000000000000000, "RW", "rocount36", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo652[] = {{"ptrocnt3536", "", 0x0000004C, 2, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields653[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{16, 31, 0x0000000000000000, "RW", "rocount37", "LP4 PT Ring Oscillator Count Pair 3738"},
#else
{16, 31, 0x0000000000000000, "RW", "rocount37", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 15, 0x0000000000000000, "RW", "rocount38", "LP4 PT Ring Oscillator Count Pair 3738"},
#else
{0, 15, 0x0000000000000000, "RW", "rocount38", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo653[] = {{"ptrocnt3738", "", 0x00000050, 2, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields654[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{16, 31, 0x0000000000000000, "RW", "rocount39", "LP4 PT Ring Oscillator Count Pair 3940"},
#else
{16, 31, 0x0000000000000000, "RW", "rocount39", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 15, 0x0000000000000000, "RW", "rocount40", "LP4 PT Ring Oscillator Count Pair 3940"},
#else
{0, 15, 0x0000000000000000, "RW", "rocount40", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo654[] = {{"ptrocnt3940", "", 0x00000054, 2, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields655[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{16, 31, 0x0000000000000000, "RW", "rocount41", "LP4 PT Ring Oscillator Count Pair 4142"},
#else
{16, 31, 0x0000000000000000, "RW", "rocount41", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 15, 0x0000000000000000, "RW", "rocount42", "LP4 PT Ring Oscillator Count Pair 4142"},
#else
{0, 15, 0x0000000000000000, "RW", "rocount42", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo655[] = {{"ptrocnt4142", "", 0x00000058, 2, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields656[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{16, 31, 0x0000000000000000, "RW", "rocount43", "LP4 PT Ring Oscillator Count Pair 4344"},
#else
{16, 31, 0x0000000000000000, "RW", "rocount43", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 15, 0x0000000000000000, "RW", "rocount44", "LP4 PT Ring Oscillator Count Pair 4344"},
#else
{0, 15, 0x0000000000000000, "RW", "rocount44", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo656[] = {{"ptrocnt4344", "", 0x0000005C, 2, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields657[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{16, 31, 0x0000000000000000, "RW", "rocount45", "LP4 PT Ring Oscillator Count Pair 4546"},
#else
{16, 31, 0x0000000000000000, "RW", "rocount45", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 15, 0x0000000000000000, "RW", "rocount46", "LP4 PT Ring Oscillator Count Pair 4546"},
#else
{0, 15, 0x0000000000000000, "RW", "rocount46", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo657[] = {{"ptrocnt4546", "", 0x00000060, 2, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields658[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{16, 31, 0x0000000000000000, "RW", "rocount47", "LP4 PT Ring Oscillator Count Pair 4748"},
#else
{16, 31, 0x0000000000000000, "RW", "rocount47", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 15, 0x0000000000000000, "RW", "rocount48", "LP4 PT Ring Oscillator Count Pair 4748"},
#else
{0, 15, 0x0000000000000000, "RW", "rocount48", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo658[] = {{"ptrocnt4748", "", 0x00000064, 2, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields659[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{16, 31, 0x0000000000000000, "RW", "rocount49", "LP4 PT Ring Oscillator Count Pair 4950"},
#else
{16, 31, 0x0000000000000000, "RW", "rocount49", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 15, 0x0000000000000000, "RW", "rocount50", "LP4 PT Ring Oscillator Count Pair 4950"},
#else
{0, 15, 0x0000000000000000, "RW", "rocount50", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo659[] = {{"ptrocnt4950", "", 0x00000068, 2, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields660[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{16, 31, 0x0000000000000000, "RW", "rocount51", "LP4 PT Ring Oscillator Count Pair 5152"},
#else
{16, 31, 0x0000000000000000, "RW", "rocount51", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 15, 0x0000000000000000, "RW", "rocount52", "LP4 PT Ring Oscillator Count Pair 5152"},
#else
{0, 15, 0x0000000000000000, "RW", "rocount52", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo660[] = {{"ptrocnt5152", "", 0x0000006C, 2, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields661[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{16, 31, 0x0000000000000000, "RW", "rocount53", "LP4 PT Ring Oscillator Count Pair 5354"},
#else
{16, 31, 0x0000000000000000, "RW", "rocount53", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 15, 0x0000000000000000, "RW", "rocount54", "LP4 PT Ring Oscillator Count Pair 5354"},
#else
{0, 15, 0x0000000000000000, "RW", "rocount54", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo661[] = {{"ptrocnt5354", "", 0x00000070, 2, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields662[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{16, 31, 0x0000000000000000, "RW", "rocount55", "LP4 PT Ring Oscillator Count Pair 5556"},
#else
{16, 31, 0x0000000000000000, "RW", "rocount55", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 15, 0x0000000000000000, "RW", "rocount56", "LP4 PT Ring Oscillator Count Pair 5556"},
#else
{0, 15, 0x0000000000000000, "RW", "rocount56", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo662[] = {{"ptrocnt5556", "", 0x00000074, 2, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields663[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{16, 31, 0x0000000000000000, "RW", "rocount57", "LP4 PT Ring Oscillator Count Pair 5758"},
#else
{16, 31, 0x0000000000000000, "RW", "rocount57", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 15, 0x0000000000000000, "RW", "rocount58", "LP4 PT Ring Oscillator Count Pair 5758"},
#else
{0, 15, 0x0000000000000000, "RW", "rocount58", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo663[] = {{"ptrocnt5758", "", 0x00000078, 2, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields664[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{16, 31, 0x0000000000000000, "RW", "rocount59", "LP4 PT Ring Oscillator Count Pair 5960"},
#else
{16, 31, 0x0000000000000000, "RW", "rocount59", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 15, 0x0000000000000000, "RW", "rocount60", "LP4 PT Ring Oscillator Count Pair 5960"},
#else
{0, 15, 0x0000000000000000, "RW", "rocount60", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo664[] = {{"ptrocnt5960", "", 0x0000007C, 2, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields665[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{16, 31, 0x0000000000000000, "RW", "rocount61", "LP4 PT Ring Oscillator Count Pair 6162"},
#else
{16, 31, 0x0000000000000000, "RW", "rocount61", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 15, 0x0000000000000000, "RW", "rocount62", "LP4 PT Ring Oscillator Count Pair 6162"},
#else
{0, 15, 0x0000000000000000, "RW", "rocount62", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo665[] = {{"ptrocnt6162", "", 0x00000080, 2, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields666[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{16, 31, 0x0000000000000000, "RW", "rocount63", "LP4 PT Ring Oscillator Count Pair 6364"},
#else
{16, 31, 0x0000000000000000, "RW", "rocount63", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 15, 0x0000000000000000, "RW", "rocount64", "LP4 PT Ring Oscillator Count Pair 6364"},
#else
{0, 15, 0x0000000000000000, "RW", "rocount64", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo666[] = {{"ptrocnt6364", "", 0x00000084, 2, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields667[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{16, 31, 0x0000000000000000, "RW", "rocount65", "LP4 PT Ring Oscillator Count Pair 6566"},
#else
{16, 31, 0x0000000000000000, "RW", "rocount65", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 15, 0x0000000000000000, "RW", "rocount66", "LP4 PT Ring Oscillator Count Pair 6566"},
#else
{0, 15, 0x0000000000000000, "RW", "rocount66", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo667[] = {{"ptrocnt6566", "", 0x00000088, 2, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields668[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{16, 31, 0x0000000000000000, "RW", "rocount67", "LP4 PT Ring Oscillator Count Pair 6768"},
#else
{16, 31, 0x0000000000000000, "RW", "rocount67", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 15, 0x0000000000000000, "RW", "rocount68", "LP4 PT Ring Oscillator Count Pair 6768"},
#else
{0, 15, 0x0000000000000000, "RW", "rocount68", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo668[] = {{"ptrocnt6768", "", 0x0000008C, 2, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields669[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{16, 31, 0x0000000000000000, "RW", "rocount69", "LP4 PT Ring Oscillator Count Pair 6970"},
#else
{16, 31, 0x0000000000000000, "RW", "rocount69", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 15, 0x0000000000000000, "RW", "rocount70", "LP4 PT Ring Oscillator Count Pair 6970"},
#else
{0, 15, 0x0000000000000000, "RW", "rocount70", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo669[] = {{"ptrocnt6970", "", 0x00000090, 2, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields670[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{24, 31, 0x0000000000000000, "RW", "maxpi_per2xclk", "LP4 PT Dead Band Region MAXPI"},
#else
{24, 31, 0x0000000000000000, "RW", "maxpi_per2xclk", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{16, 23, 0x0000000000000000, "RW", "dbregion1_marker", "LP4 PT Dead Band Region Region 1 Marker"},
#else
{16, 23, 0x0000000000000000, "RW", "dbregion1_marker", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{8, 15, 0x0000000000000000, "RW", "dbregion2_marker", "LP4 PT Dead Band Region Region 2 Marker"},
#else
{8, 15, 0x0000000000000000, "RW", "dbregion2_marker", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 7, 0x0000000000000000, "RW", "dbregion3_marker", "LP4 PT Dead Band Region Region 3 Marker"},
#else
{0, 7, 0x0000000000000000, "RW", "dbregion3_marker", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo670[] = {{"dbregionctl1", "", 0x00000094, 4, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields671[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{24, 31, 0x0000000000000000, "RW", "dbregion4_marker", "LP4 PT Dead Band Region Region 4 Marker"},
#else
{24, 31, 0x0000000000000000, "RW", "dbregion4_marker", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{16, 23, 0x0000000000000000, "RW", "dbregion5_marker", "LP4 PT Dead Band Region Region 5 Marker"},
#else
{16, 23, 0x0000000000000000, "RW", "dbregion5_marker", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{8, 15, 0x0000000000000000, "RW", "dbregion6_marker", "LP4 PT Dead Band Region Region 6 Marker"},
#else
{8, 15, 0x0000000000000000, "RW", "dbregion6_marker", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 7, 0x0000000000000000, "RW", "dbregion7_marker", "LP4 PT Dead Band Region Region 7 Marker"},
#else
{0, 7, 0x0000000000000000, "RW", "dbregion7_marker", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo671[] = {{"dbregionctl2", "", 0x00000098, 4, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields672[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{30, 31, 0x0000000000000000, "RW", "rk0dbregion0_dyndqdbsel", "LP4 PT Dead Band Rk0 DB Control"},
#else
{30, 31, 0x0000000000000000, "RW", "rk0dbregion0_dyndqdbsel", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{28, 29, 0x0000000000000000, "RW", "rk0dbregion1_dyndqdbsel", "LP4 PT Dead Band Rk0 DB Control"},
#else
{28, 29, 0x0000000000000000, "RW", "rk0dbregion1_dyndqdbsel", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{26, 27, 0x0000000000000000, "RW", "rk0dbregion2_dyndqdbsel", "LP4 PT Dead Band Rk0 DB Control"},
#else
{26, 27, 0x0000000000000000, "RW", "rk0dbregion2_dyndqdbsel", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{24, 25, 0x0000000000000000, "RW", "rk0dbregion3_dyndqdbsel", "LP4 PT Dead Band Rk0 DB Control"},
#else
{24, 25, 0x0000000000000000, "RW", "rk0dbregion3_dyndqdbsel", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{22, 23, 0x0000000000000000, "RW", "rk0dbregion4_dyndqdbsel", "LP4 PT Dead Band Rk0 DB Control"},
#else
{22, 23, 0x0000000000000000, "RW", "rk0dbregion4_dyndqdbsel", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{20, 21, 0x0000000000000000, "RW", "rk0dbregion5_dyndqdbsel", "LP4 PT Dead Band Rk0 DB Control"},
#else
{20, 21, 0x0000000000000000, "RW", "rk0dbregion5_dyndqdbsel", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{18, 19, 0x0000000000000000, "RW", "rk0dbregion6_dyndqdbsel", "LP4 PT Dead Band Rk0 DB Control"},
#else
{18, 19, 0x0000000000000000, "RW", "rk0dbregion6_dyndqdbsel", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{16, 17, 0x0000000000000000, "RW", "rk0dbregion7_dyndqdbsel", "LP4 PT Dead Band Rk0 DB Control"},
#else
{16, 17, 0x0000000000000000, "RW", "rk0dbregion7_dyndqdbsel", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{14, 15, 0x0000000000000000, "RW", "rk0dbregion0_dyndqdboffset", "LP4 PT Dead Band Rk0 DB Offset Control"},
#else
{14, 15, 0x0000000000000000, "RW", "rk0dbregion0_dyndqdboffset", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{12, 13, 0x0000000000000000, "RW", "rk0dbregion1_dyndqdboffset", "LP4 PT Dead Band Rk0 DB Offset Control"},
#else
{12, 13, 0x0000000000000000, "RW", "rk0dbregion1_dyndqdboffset", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{10, 11, 0x0000000000000000, "RW", "rk0dbregion2_dyndqdboffset", "LP4 PT Dead Band Rk0 DB Offset Control"},
#else
{10, 11, 0x0000000000000000, "RW", "rk0dbregion2_dyndqdboffset", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{8, 9, 0x0000000000000000, "RW", "rk0dbregion3_dyndqdboffset", "LP4 PT Dead Band Rk0 DB Offset Control"},
#else
{8, 9, 0x0000000000000000, "RW", "rk0dbregion3_dyndqdboffset", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{6, 7, 0x0000000000000000, "RW", "rk0dbregion4_dyndqdboffset", "LP4 PT Dead Band Rk0 DB Offset Control"},
#else
{6, 7, 0x0000000000000000, "RW", "rk0dbregion4_dyndqdboffset", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{4, 5, 0x0000000000000000, "RW", "rk0dbregion5_dyndqdboffset", "LP4 PT Dead Band Rk0 DB Offset Control"},
#else
{4, 5, 0x0000000000000000, "RW", "rk0dbregion5_dyndqdboffset", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{2, 3, 0x0000000000000000, "RW", "rk0dbregion6_dyndqdboffset", "LP4 PT Dead Band Rk0 DB Offset Control"},
#else
{2, 3, 0x0000000000000000, "RW", "rk0dbregion6_dyndqdboffset", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 1, 0x0000000000000000, "RW", "rk0dbregion7_dyndqdboffset", "LP4 PT Dead Band Rk0 DB Offset Control"},
#else
{0, 1, 0x0000000000000000, "RW", "rk0dbregion7_dyndqdboffset", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo672[] = {{"dbregionctl3", "", 0x0000009C, 16, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields673[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{31, 31, 0x0000000000000000, "RO", "Reserved", "Reserved bits"},
#else
{31, 31, 0x0000000000000000, "RO", "Reserved", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{24, 30, 0x0000000000000000, "RW", "lrcomp_pdgrp0_pu_override", "grp0 pull up override code"},
#else
{24, 30, 0x0000000000000000, "RW", "lrcomp_pdgrp0_pu_override", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{23, 23, 0x0000000000000000, "RO", "Reserved0", "Reserved bits"},
#else
{23, 23, 0x0000000000000000, "RO", "Reserved0", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{16, 22, 0x0000000000000000, "RW", "lrcomp_pdgrp0_pd_override", "grp0 pull down override code"},
#else
{16, 22, 0x0000000000000000, "RW", "lrcomp_pdgrp0_pd_override", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{15, 15, 0x0000000000000000, "RO", "Reserved1", "Reserved bits"},
#else
{15, 15, 0x0000000000000000, "RO", "Reserved1", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{8, 14, 0x0000000000000000, "RW", "lrcomp_pdgrp1_pu_override", "grp1 pull up override code"},
#else
{8, 14, 0x0000000000000000, "RW", "lrcomp_pdgrp1_pu_override", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{7, 7, 0x0000000000000000, "RO", "Reserved2", "Reserved bits"},
#else
{7, 7, 0x0000000000000000, "RO", "Reserved2", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 6, 0x0000000000000000, "RW", "lrcomp_pdgrp1_pd_override", "grp1 pull down override code"},
#else
{0, 6, 0x0000000000000000, "RW", "lrcomp_pdgrp1_pd_override", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo673[] = {{"dpic_lrcomp_ovr1", "", 0x000000A0, 8, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields674[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{31, 31, 0x0000000000000000, "RO", "Reserved", "Reserved bits"},
#else
{31, 31, 0x0000000000000000, "RO", "Reserved", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{24, 30, 0x0000000000000000, "RW", "lrcomp_pdgrp2_pu_override", "grp2 pull up override code"},
#else
{24, 30, 0x0000000000000000, "RW", "lrcomp_pdgrp2_pu_override", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{23, 23, 0x0000000000000000, "RO", "Reserved0", "Reserved bits"},
#else
{23, 23, 0x0000000000000000, "RO", "Reserved0", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{16, 22, 0x0000000000000000, "RW", "lrcomp_pdgrp2_pd_override", "grp2 pull down override code"},
#else
{16, 22, 0x0000000000000000, "RW", "lrcomp_pdgrp2_pd_override", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{15, 15, 0x0000000000000000, "RO", "Reserved1", "Reserved bits"},
#else
{15, 15, 0x0000000000000000, "RO", "Reserved1", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{8, 14, 0x0000000000000000, "RW", "lrcomp_pdgrp3_pu_override", "grp3 pull up override code"},
#else
{8, 14, 0x0000000000000000, "RW", "lrcomp_pdgrp3_pu_override", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{7, 7, 0x0000000000000000, "RO", "Reserved2", "Reserved bits"},
#else
{7, 7, 0x0000000000000000, "RO", "Reserved2", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 6, 0x0000000000000000, "RW", "lrcomp_pdgrp3_pd_override", "grp3 pull down override code"},
#else
{0, 6, 0x0000000000000000, "RW", "lrcomp_pdgrp3_pd_override", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo674[] = {{"dpic_lrcomp_ovr2", "", 0x000000A4, 8, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields675[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{31, 31, 0x0000000000000000, "RO", "Reserved", "Reserved bits"},
#else
{31, 31, 0x0000000000000000, "RO", "Reserved", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{24, 30, 0x0000000000000000, "RW", "lrcomp_pdgrp4_pu_override", "grp4 pull up override code"},
#else
{24, 30, 0x0000000000000000, "RW", "lrcomp_pdgrp4_pu_override", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{23, 23, 0x0000000000000000, "RO", "Reserved0", "Reserved bits"},
#else
{23, 23, 0x0000000000000000, "RO", "Reserved0", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{16, 22, 0x0000000000000000, "RW", "lrcomp_pdgrp4_pd_override", "grp4 pull down override code"},
#else
{16, 22, 0x0000000000000000, "RW", "lrcomp_pdgrp4_pd_override", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{15, 15, 0x0000000000000000, "RO", "Reserved1", "Reserved bits"},
#else
{15, 15, 0x0000000000000000, "RO", "Reserved1", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{8, 14, 0x0000000000000000, "RW", "lrcomp_pdgrp5_pu_override", "grp5 pull up override code"},
#else
{8, 14, 0x0000000000000000, "RW", "lrcomp_pdgrp5_pu_override", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{7, 7, 0x0000000000000000, "RO", "Reserved2", "Reserved bits"},
#else
{7, 7, 0x0000000000000000, "RO", "Reserved2", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 6, 0x0000000000000000, "RW", "lrcomp_pdgrp5_pd_override", "grp5 pull down override code"},
#else
{0, 6, 0x0000000000000000, "RW", "lrcomp_pdgrp5_pd_override", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo675[] = {{"dpic_lrcomp_ovr3", "", 0x000000A8, 8, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields676[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{14, 31, 0x0000000000000000, "RO", "Reserved", "Reserved bits"},
#else
{14, 31, 0x0000000000000000, "RO", "Reserved", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{8, 13, 0x0000000000000000, "RW", "lrcomppd_grp_override_en", "Pull down override enable"},
#else
{8, 13, 0x0000000000000000, "RW", "lrcomppd_grp_override_en", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{6, 7, 0x0000000000000000, "RO", "Reserved0", "Reserved bits"},
#else
{6, 7, 0x0000000000000000, "RO", "Reserved0", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 5, 0x0000000000000000, "RW", "lrcomppu_grp_override_en", "Pull up override enable"},
#else
{0, 5, 0x0000000000000000, "RW", "lrcomppu_grp_override_en", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo676[] = {{"dpic_lrcomp_pupdovr", "", 0x000000AC, 4, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields677[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{24, 31, 0x0000000000000000, "RO/V", "lrcomp_pu_code_grp0", "Pull up codes for group 0"},
#else
{24, 31, 0x0000000000000000, "RO/V", "lrcomp_pu_code_grp0", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{16, 23, 0x0000000000000000, "RO/V", "lrcomp_pd_code_grp0", "Pull down codes for group 0"},
#else
{16, 23, 0x0000000000000000, "RO/V", "lrcomp_pd_code_grp0", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{8, 15, 0x0000000000000007, "RO/V", "lrcomp_pu_code_grp1", "Pull up codes for group 1"},
#else
{8, 15, 0x0000000000000007, "RO/V", "lrcomp_pu_code_grp1", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 7, 0x0000000000000008, "RO/V", "lrcomp_pd_code_grp1", "Pull down codes for group 1"},
#else
{0, 7, 0x0000000000000008, "RO/V", "lrcomp_pd_code_grp1", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo677[] = {{"dpic_lrcomp_codes_0", "", 0x000000B0, 4, 0x00000000FFFFFFFF, 0x0000000000000708}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields678[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{24, 31, 0x0000000000000000, "RO/V", "lrcomp_pu_code_grp2", "Pull up codes for group 2"},
#else
{24, 31, 0x0000000000000000, "RO/V", "lrcomp_pu_code_grp2", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{16, 23, 0x0000000000000000, "RO/V", "lrcomp_pd_code_grp2", "Pull down codes for group 2"},
#else
{16, 23, 0x0000000000000000, "RO/V", "lrcomp_pd_code_grp2", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{8, 15, 0x0000000000000007, "RO/V", "lrcomp_pu_code_grp3", "Pull up codes for group 3"},
#else
{8, 15, 0x0000000000000007, "RO/V", "lrcomp_pu_code_grp3", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 7, 0x0000000000000008, "RO/V", "lrcomp_pd_code_grp3", "Pull down codes for group 3"},
#else
{0, 7, 0x0000000000000008, "RO/V", "lrcomp_pd_code_grp3", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo678[] = {{"dpic_lrcomp_codes_1", "", 0x000000B4, 4, 0x00000000FFFFFFFF, 0x0000000000000708}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields679[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{24, 31, 0x0000000000000000, "RO/V", "lrcomp_pu_code_grp4", "Pull up codes for group 4"},
#else
{24, 31, 0x0000000000000000, "RO/V", "lrcomp_pu_code_grp4", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{16, 23, 0x0000000000000000, "RO/V", "lrcomp_pd_code_grp4", "Pull down codes for group 4"},
#else
{16, 23, 0x0000000000000000, "RO/V", "lrcomp_pd_code_grp4", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{8, 15, 0x0000000000000007, "RO/V", "lrcomp_pu_code_grp5", "Pull up codes for group 5"},
#else
{8, 15, 0x0000000000000007, "RO/V", "lrcomp_pu_code_grp5", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 7, 0x0000000000000008, "RO/V", "lrcomp_pd_code_grp5", "Pull down codes for group 5"},
#else
{0, 7, 0x0000000000000008, "RO/V", "lrcomp_pd_code_grp5", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo679[] = {{"dpic_lrcomp_codes_2", "", 0x000000B8, 4, 0x00000000FFFFFFFF, 0x0000000000000708}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields680[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{31, 31, 0x0000000000000000, "RO", "Reserved", "Reserved bits"},
#else
{31, 31, 0x0000000000000000, "RO", "Reserved", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{26, 30, 0x0000000000000001, "RW", "rcomp_numave", "Number of times to repeat and average the Rcomp compensation"},
#else
{26, 30, 0x0000000000000001, "RW", "rcomp_numave", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{19, 25, 0x0000000000000020, "RW", "rcomp_initval", "Initial value for Rcomp binary search"},
#else
{19, 25, 0x0000000000000020, "RW", "rcomp_initval", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{12, 18, 0x0000000000000010, "RW", "rcomp_initstep", "Initial step value for Rcomp binary search"},
#else
{12, 18, 0x0000000000000010, "RW", "rcomp_initstep", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{8, 11, 0x000000000000000A, "RW", "rcomp_numsteps", "Number of binary search steps"},
#else
{8, 11, 0x000000000000000A, "RW", "rcomp_numsteps", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 7, 0x000000000000000E, "RW", "rcomp_enable_delay", "Delay after enabling Rcomp before starting measurement timer"},
#else
{0, 7, 0x000000000000000E, "RW", "rcomp_enable_delay", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo680[] = {{"dpic_grcomp_cfg1", "", 0x000000BC, 6, 0x00000000FFFFFFFF, 0x0000000005010A0E}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields681[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{28, 31, 0x0000000000000000, "RO", "Reserved", "Reserved bits"},
#else
{28, 31, 0x0000000000000000, "RO", "Reserved", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{20, 27, 0x000000000000000E, "RW", "rcomp_sampdel1", "Rcomp sample time 1"},
#else
{20, 27, 0x000000000000000E, "RW", "rcomp_sampdel1", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{12, 19, 0x000000000000000E, "RW", "rcomp_sampdel2", "Rcomp sample time 2"},
#else
{12, 19, 0x000000000000000E, "RW", "rcomp_sampdel2", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{4, 11, 0x000000000000000E, "RW", "rcomp_sampdel3", "Rcomp sample time 3"},
#else
{4, 11, 0x000000000000000E, "RW", "rcomp_sampdel3", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{2, 3, 0x0000000000000000, "RO", "Reserved0", "Reserved bits"},
#else
{2, 3, 0x0000000000000000, "RO", "Reserved0", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 1, 0x0000000000000001, "RW", "comp_msgbus_clk_div", "indicates the division ratio of the comp clock w.r.t spid clk"},
#else
{0, 1, 0x0000000000000001, "RW", "comp_msgbus_clk_div", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo681[] = {{"dpic_grcomp_cfg2", "", 0x000000C0, 6, 0x00000000FFFFFFFF, 0x0000000000E0E0E1}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields682[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{12, 31, 0x0000000000000000, "RO", "Reserved", "Reserved bits"},
#else
{12, 31, 0x0000000000000000, "RO", "Reserved", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{8, 11, 0x000000000000000F, "RW", "gcomp_ch_en", "Tells which channels are enabled. '1' channel enabled '0' channel disabled. This must be equal to the corresponding bits in the LCOMP"},
#else
{8, 11, 0x000000000000000F, "RW", "gcomp_ch_en", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 7, 0x000000000000003F, "RW", "rcomp_max_code_val", "Rcomp max value of code. The live code wont go beyond this. If the comp sm gives a value greater than this, it will be capped to this value."},
#else
{0, 7, 0x000000000000003F, "RW", "rcomp_max_code_val", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo682[] = {{"dpic_grcomp_cfg3", "", 0x000000C4, 3, 0x00000000FFFFFFFF, 0x0000000000000F3F}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields683[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{24, 31, 0x0000000000000018, "RW", "comp_vref_grp0", "vrefctrl voltage"},
#else
{24, 31, 0x0000000000000018, "RW", "comp_vref_grp0", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{16, 23, 0x0000000000000018, "RW", "comp_vref_grp1", "vrefctrl voltage"},
#else
{16, 23, 0x0000000000000018, "RW", "comp_vref_grp1", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{8, 15, 0x0000000000000018, "RW", "comp_vref_grp2", "vrefctrl voltage"},
#else
{8, 15, 0x0000000000000018, "RW", "comp_vref_grp2", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 7, 0x0000000000000018, "RW", "comp_vref_grp3", "vrefctrl voltage"},
#else
{0, 7, 0x0000000000000018, "RW", "comp_vref_grp3", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo683[] = {{"dpic_grcomp_vref_0", "", 0x000000C8, 4, 0x00000000FFFFFFFF, 0x0000000018181818}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields684[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{16, 31, 0x0000000000000000, "RO", "Reserved", "Reserved bits"},
#else
{16, 31, 0x0000000000000000, "RO", "Reserved", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{8, 15, 0x0000000000000018, "RW", "comp_vref_grp4", "vrefctrl voltage"},
#else
{8, 15, 0x0000000000000018, "RW", "comp_vref_grp4", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 7, 0x0000000000000018, "RW", "comp_vref_grp5", "vrefctrl voltage"},
#else
{0, 7, 0x0000000000000018, "RW", "comp_vref_grp5", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo684[] = {{"dpic_grcomp_vref_1", "", 0x000000CC, 3, 0x00000000FFFFFFFF, 0x0000000000001818}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields685[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{31, 31, 0x0000000000000000, "RO", "Reserved", "Reserved bits"},
#else
{31, 31, 0x0000000000000000, "RO", "Reserved", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{23, 30, 0x0000000000000000, "RW", "comp_rcomp_pu_code_copy_bits", "tells the rcomp to copy the adjecent code instead of evaluating it"},
#else
{23, 30, 0x0000000000000000, "RW", "comp_rcomp_pu_code_copy_bits", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{16, 22, 0x0000000000000001, "RW", "delta_timer_expire_cnt", "Number of clock cycles, for the design to wait before taking action on bus_quiet_time_gnt. This must be set the same as LCOMP bqt_settle_width"},
#else
{16, 22, 0x0000000000000001, "RW", "delta_timer_expire_cnt", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{1, 15, 0x0000000000000960, "RW", "comp_rcomp_mstrcompctl_timer_exp_cnt", "This count estimates the number of cycles it would take for all LCOMP from the start of LCOMP evaluation to the finish of LCOMP evaluation."},
#else
{1, 15, 0x0000000000000960, "RW", "comp_rcomp_mstrcompctl_timer_exp_cnt", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 0, 0x0000000000000000, "RW", "comprst_b", "async active low reset for gcomp"},
#else
{0, 0, 0x0000000000000000, "RW", "comprst_b", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo685[] = {{"dpic_grcomp_rstctl", "", 0x000000D0, 5, 0x00000000FFFFFFFF, 0x00000000000112C0}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields686[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{1, 31, 0x0000000000000000, "RO", "Reserved", "Reserved bits"},
#else
{1, 31, 0x0000000000000000, "RO", "Reserved", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 0, 0x0000000000000000, "RW", "rcomp_clkgate_en", "Clock gating contorl for rcomp."},
#else
{0, 0, 0x0000000000000000, "RW", "rcomp_clkgate_en", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo686[] = {{"dpic_grcomp_clkgate", "", 0x000000D4, 2, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields687[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{1, 31, 0x0000000000000000, "RO", "Reserved", "Reserved bits"},
#else
{1, 31, 0x0000000000000000, "RO", "Reserved", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 0, 0x0000000000000000, "RW/1S/V", "rcomp_init_comp", "bit to start the initial rcomp"},
#else
{0, 0, 0x0000000000000000, "RW/1S/V", "rcomp_init_comp", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo687[] = {{"dpic_grcomp_init", "", 0x000000D8, 2, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields688[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{31, 31, 0x0000000000000000, "RO", "Reserved", "Reserved bits"},
#else
{31, 31, 0x0000000000000000, "RO", "Reserved", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{26, 30, 0x0000000000000001, "RW", "lrcomp_numave", "Number of times to repeat and average the Rcomp compensation"},
#else
{26, 30, 0x0000000000000001, "RW", "lrcomp_numave", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{19, 25, 0x0000000000000020, "RW", "lrcomp_initval", "Initial value for Rcomp binary search"},
#else
{19, 25, 0x0000000000000020, "RW", "lrcomp_initval", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{12, 18, 0x0000000000000010, "RW", "lrcomp_initstep", "Initial step value for Rcomp binary search"},
#else
{12, 18, 0x0000000000000010, "RW", "lrcomp_initstep", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{8, 11, 0x000000000000000A, "RW", "lrcomp_numsteps", "Number of binary search steps"},
#else
{8, 11, 0x000000000000000A, "RW", "lrcomp_numsteps", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 7, 0x000000000000000E, "RW", "lrcomp_enable_delay", "Delay after enabling Rcomp before starting measurement timer"},
#else
{0, 7, 0x000000000000000E, "RW", "lrcomp_enable_delay", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo688[] = {{"dpic_lrcomp_cfg1", "", 0x000000DC, 6, 0x00000000FFFFFFFF, 0x0000000005010A0E}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields689[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{27, 31, 0x0000000000000000, "RO", "Reserved", "Reserved bits"},
#else
{27, 31, 0x0000000000000000, "RO", "Reserved", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{19, 26, 0x000000000000000E, "RW", "lrcomp_sampdel1", "Rcomp sample time 1"},
#else
{19, 26, 0x000000000000000E, "RW", "lrcomp_sampdel1", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{11, 18, 0x000000000000000E, "RW", "lrcomp_sampdel2", "Rcomp sample time 2"},
#else
{11, 18, 0x000000000000000E, "RW", "lrcomp_sampdel2", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{3, 10, 0x000000000000000E, "RW", "lrcomp_sampdel3", "Rcomp sample time 3"},
#else
{3, 10, 0x000000000000000E, "RW", "lrcomp_sampdel3", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{2, 2, 0x0000000000000000, "RW", "lcomp_sel_membus_frm_gcomp", "set it to '1' to select the membus form gcomp, '0' to select it from previous module."},
#else
{2, 2, 0x0000000000000000, "RW", "lcomp_sel_membus_frm_gcomp", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 1, 0x0000000000000001, "RW", "lrcomp_msgbus_clk_div", "indicates the division ratio of the comp clock w.r.t spid clk"},
#else
{0, 1, 0x0000000000000001, "RW", "lrcomp_msgbus_clk_div", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo689[] = {{"dpic_lrcomp_cfg2", "", 0x000000E0, 6, 0x00000000FFFFFFFF, 0x0000000000707071}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields690[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{12, 31, 0x0000000000000000, "RO", "Reserved", "Reserved bits"},
#else
{12, 31, 0x0000000000000000, "RO", "Reserved", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{8, 11, 0x000000000000000F, "RW", "lcomp_ch_en", "Tells which channels are enabled. '1' channel enabled '0' channel disabled. This must be equal to the corresponding bits in the GCOMP"},
#else
{8, 11, 0x000000000000000F, "RW", "lcomp_ch_en", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 7, 0x000000000000003F, "RW", "lrcomp_max_code_val", "Rcomp max value of code. The live code wont go beyond this. If the comp sm gives a value greater than this, it will be capped to this value."},
#else
{0, 7, 0x000000000000003F, "RW", "lrcomp_max_code_val", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo690[] = {{"dpic_lrcomp_cfg3", "", 0x000000E4, 3, 0x00000000FFFFFFFF, 0x0000000000000F3F}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields691[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{22, 31, 0x0000000000000000, "RO", "Reserved", "Reserved bits"},
#else
{22, 31, 0x0000000000000000, "RO", "Reserved", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{15, 21, 0x0000000000000001, "RW", "lrcomp_pd_live_override", "override for pull down live rcomp code going to AFE"},
#else
{15, 21, 0x0000000000000001, "RW", "lrcomp_pd_live_override", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{14, 14, 0x0000000000000000, "RW", "lrcomp_pd_live_override_en", "override enable for override for pull down live rcomp code going to AFE"},
#else
{14, 14, 0x0000000000000000, "RW", "lrcomp_pd_live_override_en", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{8, 13, 0x0000000000000000, "RO", "Reserved0", "Reserved bits"},
#else
{8, 13, 0x0000000000000000, "RO", "Reserved0", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{1, 7, 0x0000000000000000, "RW", "lrcomp_pd_puref_override", "Override for pull up driver rcomp"},
#else
{1, 7, 0x0000000000000000, "RW", "lrcomp_pd_puref_override", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 0, 0x0000000000000000, "RW", "lrcomp_pd_puref_override_en", "Override enable for pull up driver rcomp"},
#else
{0, 0, 0x0000000000000000, "RW", "lrcomp_pd_puref_override_en", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo691[] = {{"dpic_lrcomp_ovr0", "", 0x000000E8, 6, 0x00000000FFFFFFFF, 0x0000000000008000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields692[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{27, 31, 0x0000000000000000, "RO", "Reserved", "Reserved bits"},
#else
{27, 31, 0x0000000000000000, "RO", "Reserved", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{25, 26, 0x0000000000000001, "RW", "sel_bqt_for_lcomp", "selects the bus_quiet_time_gnt signal for lcomp buffer."},
#else
{25, 26, 0x0000000000000001, "RW", "sel_bqt_for_lcomp", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{24, 24, 0x0000000000000001, "RW", "lrcomp_pd_staticlive", "static live signal for PD comp buffer."},
#else
{24, 24, 0x0000000000000001, "RW", "lrcomp_pd_staticlive", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{23, 23, 0x0000000000000001, "RW", "lrcomp_pu_static", "static leg signal for PD comp buffer."},
#else
{23, 23, 0x0000000000000001, "RW", "lrcomp_pu_static", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{22, 22, 0x0000000000000000, "RO", "Reserved0", "Reserved bits"},
#else
{22, 22, 0x0000000000000000, "RO", "Reserved0", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{16, 21, 0x0000000000000000, "RW", "lrcomp_general_timer", "Not used in design."},
#else
{16, 21, 0x0000000000000000, "RW", "lrcomp_general_timer", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{12, 15, 0x0000000000000000, "RW", "lrcomp_stg2_width", "no of cycles needed for stage 2 update."},
#else
{12, 15, 0x0000000000000000, "RW", "lrcomp_stg2_width", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{8, 11, 0x0000000000000008, "RW", "lrcomp_update_len", "no of cycles needed for code update."},
#else
{8, 11, 0x0000000000000008, "RW", "lrcomp_update_len", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{7, 7, 0x0000000000000000, "RW", "lrcomp_update", "config control for updating rcomp codes."},
#else
{7, 7, 0x0000000000000000, "RW", "lrcomp_update", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{6, 6, 0x0000000000000000, "RW", "lrcomp_updtbyen", "enable for config concifg control for updating rcomp codes."},
#else
{6, 6, 0x0000000000000000, "RW", "lrcomp_updtbyen", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 5, 0x0000000000000000, "RW", "lrcomp_grp_update_disable", "config contorl for disabling rcomp code per group."},
#else
{0, 5, 0x0000000000000000, "RW", "lrcomp_grp_update_disable", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo692[] = {{"dpic_lrcomp_ctl0", "", 0x000000EC, 11, 0x00000000FFFFFFFF, 0x0000000003800800}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields693[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{17, 31, 0x0000000000000000, "RO", "Reserved", "Reserved bits"},
#else
{17, 31, 0x0000000000000000, "RO", "Reserved", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{12, 16, 0x0000000000000000, "RW", "lcomp_pdcode_copy_bits", "tells the rcomp to copy the adjecent code instead of evaluating it"},
#else
{12, 16, 0x0000000000000000, "RW", "lcomp_pdcode_copy_bits", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{6, 11, 0x000000000000003F, "RW", "lrcomp_pdcode_valid_bits", "tells the rcomp which groups are valid."},
#else
{6, 11, 0x000000000000003F, "RW", "lrcomp_pdcode_valid_bits", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 5, 0x000000000000003F, "RW", "lrcomp_en_indirect_update", "enable indirect update, when '1', it enables indirect update for respective group, when '0', it disables indirect update for that group."},
#else
{0, 5, 0x000000000000003F, "RW", "lrcomp_en_indirect_update", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo693[] = {{"dpic_lrcomp_ctl1", "", 0x000000F0, 4, 0x00000000FFFFFFFF, 0x0000000000000FFF}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields694[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{1, 31, 0x0000000000000000, "RO", "Reserved", "Reserved bits"},
#else
{1, 31, 0x0000000000000000, "RO", "Reserved", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 0, 0x0000000000000000, "RW", "lcomprst_b", "active low reset for lcomp."},
#else
{0, 0, 0x0000000000000000, "RW", "lcomprst_b", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo694[] = {{"dpic_lrcomp_rstctl", "", 0x000000F4, 2, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields695[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{2, 31, 0x0000000000000000, "RO", "Reserved", "Reserved bits"},
#else
{2, 31, 0x0000000000000000, "RO", "Reserved", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{1, 1, 0x0000000000000000, "RW", "lrcomp_clkgate_en", "Clock gating control for rcomp."},
#else
{1, 1, 0x0000000000000000, "RW", "lrcomp_clkgate_en", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 0, 0x0000000000000000, "RW", "ltxdlycomp_clkgate_en", "Clock gating control for txdlycomp"},
#else
{0, 0, 0x0000000000000000, "RW", "ltxdlycomp_clkgate_en", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo695[] = {{"dpic_txdlycomp_clkgate", "", 0x000000F8, 3, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields696[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{1, 31, 0x0000000000000000, "RO", "Reserved", "Reserved bits"},
#else
{1, 31, 0x0000000000000000, "RO", "Reserved", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 0, 0x0000000000000000, "RW/1S/V", "ltxdlycomp_init_comp", "enable initial txdlycomp"},
#else
{0, 0, 0x0000000000000000, "RW/1S/V", "ltxdlycomp_init_comp", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo696[] = {{"dpic_txdlycomp_init", "", 0x000000FC, 2, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields697[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{17, 31, 0x0000000000000000, "RO", "Reserved", "Reserved bits"},
#else
{17, 31, 0x0000000000000000, "RO", "Reserved", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{9, 16, 0x0000000000000000, "RW", "ltxdlycomp_live_override", "TX Delay comp live code override value"},
#else
{9, 16, 0x0000000000000000, "RW", "ltxdlycomp_live_override", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{8, 8, 0x0000000000000000, "RW", "ltxdlycomp_live_override_en", "Enable for TX Delay ocmp live code override value."},
#else
{8, 8, 0x0000000000000000, "RW", "ltxdlycomp_live_override_en", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{4, 7, 0x0000000000000007, "RW", "ltxdlycomp_coarse_max", "TX Delay comp MAX value of coarse code."},
#else
{4, 7, 0x0000000000000007, "RW", "ltxdlycomp_coarse_max", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 3, 0x0000000000000004, "RW", "ltxdlycomp_fine_max", "TX Delay comp MAX value of fine code."},
#else
{0, 3, 0x0000000000000004, "RW", "ltxdlycomp_fine_max", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo697[] = {{"dpic_txdlycompovr", "", 0x00000100, 5, 0x00000000FFFFFFFF, 0x0000000000000074}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields698[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{5, 31, 0x0000000000000000, "RO", "Reserved", "Reserved bits"},
#else
{5, 31, 0x0000000000000000, "RO", "Reserved", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{1, 4, 0x0000000000000000, "RO/V", "lcomp_cmn_obonus", "read back value from AFE"},
#else
{1, 4, 0x0000000000000000, "RO/V", "lcomp_cmn_obonus", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 0, 0x0000000000000000, "RO/V", "ltxdlycomp_limit_hit_error_set", "read back value of txdlycomp limit error set flag"},
#else
{0, 0, 0x0000000000000000, "RO/V", "ltxdlycomp_limit_hit_error_set", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo698[] = {{"dpic_lcomp_readback", "", 0x00000104, 3, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields699[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{19, 31, 0x0000000000000000, "RO", "Reserved", "Reserved bits"},
#else
{19, 31, 0x0000000000000000, "RO", "Reserved", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{12, 18, 0x0000000000000001, "RW", "lrcomp_bqt_settle_width", "the number of cycles after lcomp receives the bus_quiet_time_gnt signal, and before it takes any action. This allows the phy to finish off any running read/write cycles"},
#else
{12, 18, 0x0000000000000001, "RW", "lrcomp_bqt_settle_width", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{8, 11, 0x0000000000000001, "RW", "lrcomp_setup_width", "For future designs, where there might be a need to generate a stage3 enable for AFE. It needs to be '1' otherwise."},
#else
{8, 11, 0x0000000000000001, "RW", "lrcomp_setup_width", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{4, 7, 0x0000000000000001, "RW", "lrcomp_hold_width", "For future designs, where there might be a need to generate a stage3 enable for AFE. It needs to be '1' otherwise."},
#else
{4, 7, 0x0000000000000001, "RW", "lrcomp_hold_width", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 3, 0x0000000000000001, "RW", "lrcomp_enable_width", "For future designs, where there might be a need to generate a stage3 enable for AFE. It needs to be '1' otherwise."},
#else
{0, 3, 0x0000000000000001, "RW", "lrcomp_enable_width", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo699[] = {{"dpic_lrcomp_ctl2", "", 0x00000108, 5, 0x00000000FFFFFFFF, 0x0000000000001111}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields700[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{1, 31, 0x0000000000000000, "RO", "Reserved", "bit to start the initial rcomp"},
#else
{1, 31, 0x0000000000000000, "RO", "Reserved", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 0, 0x0000000000000000, "RW", "comp_periodic_enable", "bit to enable the periodic rcomp. It also enables the periodic txdlycomp"},
#else
{0, 0, 0x0000000000000000, "RW", "comp_periodic_enable", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo700[] = {{"dpic_grcomp_periodiccomp", "", 0x0000010C, 2, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields701[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{30, 31, 0x0000000000000000, "RO", "Reserved", "Reserved bits"},
#else
{30, 31, 0x0000000000000000, "RO", "Reserved", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{29, 29, 0x0000000000000000, "RW", "ltxdlycomp_update", "config update contorl for txdlyocmp code"},
#else
{29, 29, 0x0000000000000000, "RW", "ltxdlycomp_update", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{28, 28, 0x0000000000000000, "RW", "ltxdlycomp_updtbyen", "enable for config update contorl for txdlycomp code."},
#else
{28, 28, 0x0000000000000000, "RW", "ltxdlycomp_updtbyen", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{23, 27, 0x0000000000000006, "RW", "ltxdlycomp_grp0_tapsel", "select the delay tap node in AFE for group0"},
#else
{23, 27, 0x0000000000000006, "RW", "ltxdlycomp_grp0_tapsel", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{22, 22, 0x0000000000000000, "RW", "ltxdlycomp_grp0_update_disable", "bits to disable for group0 code update."},
#else
{22, 22, 0x0000000000000000, "RW", "ltxdlycomp_grp0_update_disable", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{21, 21, 0x0000000000000000, "RW", "ltxdlycomp_grp0_override_en", "bits for override control of grp0 code"},
#else
{21, 21, 0x0000000000000000, "RW", "ltxdlycomp_grp0_override_en", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{13, 20, 0x0000000000000000, "RW", "ltxdlycomp_grp0_coarse_override", "config value for grp0 coarse code."},
#else
{13, 20, 0x0000000000000000, "RW", "ltxdlycomp_grp0_coarse_override", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{5, 12, 0x0000000000000000, "RW", "ltxdlycomp_grp0_fine_override", "config value for grp0 fine code."},
#else
{5, 12, 0x0000000000000000, "RW", "ltxdlycomp_grp0_fine_override", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{4, 4, 0x0000000000000000, "RW", "ltxdlycomp_limit_hit_error", "When set, it indicates Tx Delay Comp has hit coarse or fine max limit."},
#else
{4, 4, 0x0000000000000000, "RW", "ltxdlycomp_limit_hit_error", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{3, 3, 0x0000000000000000, "RO", "Reserved0", "Reserved bits"},
#else
{3, 3, 0x0000000000000000, "RO", "Reserved0", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{2, 2, 0x0000000000000000, "RW", "ltxdlycomp_continuous_en", "continuous enable mode for txdlycomp"},
#else
{2, 2, 0x0000000000000000, "RW", "ltxdlycomp_continuous_en", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{1, 1, 0x0000000000000000, "RW", "ltxdlycomp_1group", "When set, Tx Delay Comp evaluation is restricted to only one group"},
#else
{1, 1, 0x0000000000000000, "RW", "ltxdlycomp_1group", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 0, 0x0000000000000000, "RO", "Reserved1", "Reserved bits"},
#else
{0, 0, 0x0000000000000000, "RO", "Reserved1", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo701[] = {{"dpic_txdlycomp_0", "", 0x00000110, 13, 0x00000000FFFFFFFF, 0x0000000003000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields702[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{23, 31, 0x0000000000000000, "RO", "Reserved", "Reserved bits"},
#else
{23, 31, 0x0000000000000000, "RO", "Reserved", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{18, 22, 0x0000000000000006, "RW", "ltxdlycomp_grp1_tapsel", "select the delay tap node in AFE for group1"},
#else
{18, 22, 0x0000000000000006, "RW", "ltxdlycomp_grp1_tapsel", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{17, 17, 0x0000000000000000, "RW", "ltxdlycomp_grp1_update_disable", "bits to disable for group1 code update."},
#else
{17, 17, 0x0000000000000000, "RW", "ltxdlycomp_grp1_update_disable", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{16, 16, 0x0000000000000000, "RW", "ltxdlycomp_grp1_override_en", "bits for override control of grp1 code"},
#else
{16, 16, 0x0000000000000000, "RW", "ltxdlycomp_grp1_override_en", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{8, 15, 0x0000000000000000, "RW", "ltxdlycomp_grp1_coarse_override", "config value for grp1 coarse code."},
#else
{8, 15, 0x0000000000000000, "RW", "ltxdlycomp_grp1_coarse_override", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 7, 0x0000000000000000, "RW", "ltxdlycomp_grp1_fine_override", "config value for grp1 fine code."},
#else
{0, 7, 0x0000000000000000, "RW", "ltxdlycomp_grp1_fine_override", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo702[] = {{"dpic_txdlycomp_1", "", 0x00000114, 6, 0x00000000FFFFFFFF, 0x0000000000180000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields703[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{23, 31, 0x0000000000000000, "RO", "Reserved", "Reserved bits"},
#else
{23, 31, 0x0000000000000000, "RO", "Reserved", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{18, 22, 0x0000000000000006, "RW", "ltxdlycomp_grp2_tapsel", "select the delay tap node in AFE for group2"},
#else
{18, 22, 0x0000000000000006, "RW", "ltxdlycomp_grp2_tapsel", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{17, 17, 0x0000000000000000, "RW", "ltxdlycomp_grp2_update_disable", "bits to disable for group2 code update."},
#else
{17, 17, 0x0000000000000000, "RW", "ltxdlycomp_grp2_update_disable", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{16, 16, 0x0000000000000000, "RW", "ltxdlycomp_grp2_override_en", "bits for override control of grp2 code"},
#else
{16, 16, 0x0000000000000000, "RW", "ltxdlycomp_grp2_override_en", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{8, 15, 0x0000000000000000, "RW", "ltxdlycomp_grp2_coarse_override", "config value for grp2 coarse code."},
#else
{8, 15, 0x0000000000000000, "RW", "ltxdlycomp_grp2_coarse_override", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 7, 0x0000000000000000, "RW", "ltxdlycomp_grp2_fine_override", "config value for grp2 fine code."},
#else
{0, 7, 0x0000000000000000, "RW", "ltxdlycomp_grp2_fine_override", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo703[] = {{"dpic_txdlycomp_2", "", 0x00000118, 6, 0x00000000FFFFFFFF, 0x0000000000180000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields704[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{23, 31, 0x0000000000000000, "RO", "Reserved", "Reserved bits"},
#else
{23, 31, 0x0000000000000000, "RO", "Reserved", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{18, 22, 0x0000000000000006, "RW", "ltxdlycomp_grp3_tapsel", "select the delay tap node in AFE for group3"},
#else
{18, 22, 0x0000000000000006, "RW", "ltxdlycomp_grp3_tapsel", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{17, 17, 0x0000000000000000, "RW", "ltxdlycomp_grp3_update_disable", "bits to disable for group3 code update."},
#else
{17, 17, 0x0000000000000000, "RW", "ltxdlycomp_grp3_update_disable", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{16, 16, 0x0000000000000000, "RW", "ltxdlycomp_grp3_override_en", "bits for override control of grp3 code"},
#else
{16, 16, 0x0000000000000000, "RW", "ltxdlycomp_grp3_override_en", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{8, 15, 0x0000000000000000, "RW", "ltxdlycomp_grp3_coarse_override", "config value for grp3 coarse code."},
#else
{8, 15, 0x0000000000000000, "RW", "ltxdlycomp_grp3_coarse_override", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 7, 0x0000000000000000, "RW", "ltxdlycomp_grp3_fine_override", "config value for grp3 fine code."},
#else
{0, 7, 0x0000000000000000, "RW", "ltxdlycomp_grp3_fine_override", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo704[] = {{"dpic_txdlycomp_3", "", 0x0000011C, 6, 0x00000000FFFFFFFF, 0x0000000000180000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields705[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{24, 31, 0x0000000000000000, "RO/V", "ltxdlycomp_coarse_code_grp0", "reserved"},
#else
{24, 31, 0x0000000000000000, "RO/V", "ltxdlycomp_coarse_code_grp0", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{16, 23, 0x0000000000000000, "RO/V", "ltxdlycomp_fine_code_grp0", "reserved"},
#else
{16, 23, 0x0000000000000000, "RO/V", "ltxdlycomp_fine_code_grp0", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{8, 15, 0x0000000000000007, "RO/V", "ltxdlycomp_coarse_code_grp1", "reserved"},
#else
{8, 15, 0x0000000000000007, "RO/V", "ltxdlycomp_coarse_code_grp1", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 7, 0x0000000000000008, "RO/V", "ltxdlycomp_fine_code_grp1", "reserved"},
#else
{0, 7, 0x0000000000000008, "RO/V", "ltxdlycomp_fine_code_grp1", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo705[] = {{"dpic_ltxdlycomp_codes_0", "", 0x00000120, 4, 0x00000000FFFFFFFF, 0x0000000000000708}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields706[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{24, 31, 0x0000000000000000, "RO/V", "ltxdlycomp_coarse_code_grp2", "reserved"},
#else
{24, 31, 0x0000000000000000, "RO/V", "ltxdlycomp_coarse_code_grp2", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{16, 23, 0x0000000000000000, "RO/V", "ltxdlycomp_fine_code_grp2", "reserved"},
#else
{16, 23, 0x0000000000000000, "RO/V", "ltxdlycomp_fine_code_grp2", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{8, 15, 0x0000000000000007, "RO/V", "ltxdlycomp_coarse_code_grp3", "reserved"},
#else
{8, 15, 0x0000000000000007, "RO/V", "ltxdlycomp_coarse_code_grp3", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 7, 0x0000000000000008, "RO/V", "ltxdlycomp_fine_code_grp3", "reserved"},
#else
{0, 7, 0x0000000000000008, "RO/V", "ltxdlycomp_fine_code_grp3", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo706[] = {{"dpic_ltxdlycomp_codes_1", "", 0x00000124, 4, 0x00000000FFFFFFFF, 0x0000000000000708}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields707[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{24, 31, 0x0000000000000000, "RW/V", "i_fbdivratio", "generic 8bit feedback divider ratio. N=i_fbdivratio"},
#else
{24, 31, 0x0000000000000000, "RW/V", "i_fbdivratio", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{16, 23, 0x0000000000000064, "RW", "int_fbdiv", "This register will be used to set the ADPLL internal FB divider value when using long loop (external) division. At this mode the value in i_fbdivratio[7:0] should reflect the true total division ratio (including the long loop division) for the ADPLL calibration process"},
#else
{16, 23, 0x0000000000000064, "RW", "int_fbdiv", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{12, 15, 0x0000000000000000, "RW/V", "i_ndiv", "Currently reserved bits. pre divider control.  M=i_ndiv (only 1 to 7 are valid)"},
#else
{12, 15, 0x0000000000000000, "RW/V", "i_ndiv", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo707[] = {{"PLLDIVRATIOS_0", "", 0x00000000, 3, 0x00000000FFFFFFFF, 0x0000000000640000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields708[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{31, 31, 0x0000000000000000, "RO/V", "o_errorflag", "General Error flag."},
#else
{31, 31, 0x0000000000000000, "RO/V", "o_errorflag", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{30, 30, 0x0000000000000000, "RO/V", "o_plllock", "PLL Lock indicator signal. "},
#else
{30, 30, 0x0000000000000000, "RO/V", "o_plllock", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{29, 29, 0x0000000000000000, "RO/V", "o_refclk_req_h", "ADPLL's Refclk request bit. "},
#else
{29, 29, 0x0000000000000000, "RO/V", "o_refclk_req_h", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{28, 28, 0x0000000000000000, "RO/V", "o_locktimer", "Lock time expected Indication bit."},
#else
{28, 28, 0x0000000000000000, "RO/V", "o_locktimer", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{18, 27, 0x0000000000000000, "RO/V", "dcoclk_edge_cnt", "DCO edge's counter"},
#else
{18, 27, 0x0000000000000000, "RO/V", "dcoclk_edge_cnt", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{8, 17, 0x0000000000000000, "RO/V", "locktime_final", "Locktime counter per refclk cycles, stops at overflow / lock."},
#else
{8, 17, 0x0000000000000000, "RO/V", "locktime_final", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo708[] = {{"PLLSEQUENCE_0", "", 0x00000004, 6, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields709[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{31, 31, 0x0000000000000000, "RW/V", "i_force_tdccalib", "force tdc calibration in normal locking"},
#else
{31, 31, 0x0000000000000000, "RW/V", "i_force_tdccalib", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{30, 30, 0x0000000000000000, "RW/V", "i_force_pwrgateoff", "force power gating off in all modes"},
#else
{30, 30, 0x0000000000000000, "RW/V", "i_force_pwrgateoff", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{29, 29, 0x0000000000000000, "RW/V", "i_force_clkgateoff", "force clock gating off in all modes"},
#else
{29, 29, 0x0000000000000000, "RW/V", "i_force_clkgateoff", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{28, 28, 0x0000000000000000, "RW", "force_boot", "EV: forces boot locking instead of normal locking"},
#else
{28, 28, 0x0000000000000000, "RW", "force_boot", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{27, 27, 0x0000000000000000, "RW", "force_dcoen", "EV: forces dco enable even if PLL is off. Need this for example in openloop mode"},
#else
{27, 27, 0x0000000000000000, "RW", "force_dcoen", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{26, 26, 0x0000000000000000, "RW", "force_digcoreen", "EV: forces digital core reset off (unless pwrgood=0)"},
#else
{26, 26, 0x0000000000000000, "RW", "force_digcoreen", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{24, 25, 0x0000000000000000, "RW/V", "i_lockwdet_win", "phase error threshold at which  PLL is unlocked (HH max pe allowed)"},
#else
{24, 25, 0x0000000000000000, "RW/V", "i_lockwdet_win", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{23, 23, 0x0000000000000000, "RW/V", "i_lockdet_cnt", "lock counter 32 (L) or 64 (H) cycles"},
#else
{23, 23, 0x0000000000000000, "RW/V", "i_lockdet_cnt", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{21, 22, 0x0000000000000000, "RW/V", "i_fine_limit", "defines distance of fine code from edges that would trigger SFR trimming. Distance defined by 2^(fine_limit+5)"},
#else
{21, 22, 0x0000000000000000, "RW/V", "i_fine_limit", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{19, 20, 0x0000000000000000, "RW/V", "i_refclkdly_sel", "control delay of refclk_dly clock that is used by DCO latches"},
#else
{19, 20, 0x0000000000000000, "RW/V", "i_refclkdly_sel", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{18, 18, 0x0000000000000000, "RW", "refclk2fnlch_sel", "Selects refproc's delayed clock / inverted version of refclk2dig for DCO latches n DS."},
#else
{18, 18, 0x0000000000000000, "RW", "refclk2fnlch_sel", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{13, 17, 0x0000000000000000, "RW/V", "i_int_coeff", "Ki filter coefficient, 2^n. Two's complement"},
#else
{13, 17, 0x0000000000000000, "RW/V", "i_int_coeff", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{9, 12, 0x0000000000000000, "RW/V", "i_prop_coeff", "Kp filter coefficient, 2^n. Two's complement"},
#else
{9, 12, 0x0000000000000000, "RW/V", "i_prop_coeff", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo709[] = {{"CONFIG_0", "", 0x00000008, 13, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields710[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{31, 31, 0x0000000000000000, "RW/V", "i_fbclk_extsel", "external feedback clock select (allowing use of external feedback divider). In this case, user must set fbdivratio to the feedback ratio he uses"},
#else
{31, 31, 0x0000000000000000, "RW/V", "i_fbclk_extsel", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{30, 30, 0x0000000000000000, "RW/V", "i_dcoclk_extsel", "long loop clock select through dcoclk_ext clock"},
#else
{30, 30, 0x0000000000000000, "RW/V", "i_dcoclk_extsel", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{27, 29, 0x0000000000000004, "RW", "clkgdly_cnt", "Delay for clock gating (0 menas no delay)."},
#else
{27, 29, 0x0000000000000004, "RW", "clkgdly_cnt", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{26, 26, 0x0000000000000000, "RW", "config_1_bonus", "Disables auto-clockgating."},
#else
{26, 26, 0x0000000000000000, "RW", "config_1_bonus", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{25, 25, 0x0000000000000000, "RW/V", "i_dcodither_en", "enable sigma delta"},
#else
{25, 25, 0x0000000000000000, "RW/V", "i_dcodither_en", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{23, 24, 0x0000000000000000, "RW/V", "i_dcodither_clk_sel", "select sigma delta over sampling clock"},
#else
{23, 24, 0x0000000000000000, "RW/V", "i_dcodither_clk_sel", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{22, 22, 0x0000000000000000, "RW", "dcodither_ovrd", "bypass sigma delta dithering bit with external bit"},
#else
{22, 22, 0x0000000000000000, "RW", "dcodither_ovrd", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{21, 21, 0x0000000000000000, "RW", "dcodither_val", "sigma delta dithering external bit"},
#else
{21, 21, 0x0000000000000000, "RW", "dcodither_val", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{17, 20, 0x0000000000000000, "RW", "pemod_frq", "EV: pe modulation frequency"},
#else
{17, 20, 0x0000000000000000, "RW", "pemod_frq", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{11, 16, 0x0000000000000000, "RW", "pemod_amp", "EV: pe modulation amplitude. Two's complement"},
#else
{11, 16, 0x0000000000000000, "RW", "pemod_amp", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo710[] = {{"CONFIG_1", "", 0x0000000C, 10, 0x00000000FFFFFFFF, 0x0000000020000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields711[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{16, 31, 0x0000000000000000, "RW", "digconfig", "Digital's internal spare config."},
#else
{16, 31, 0x0000000000000000, "RW", "digconfig", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 15, 0x0000000000000000, "RW/V", "i_pllconfig", "Bonus Cells"},
#else
{0, 15, 0x0000000000000000, "RW/V", "i_pllconfig", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo711[] = {{"CONFIG_2", "", 0x00000010, 2, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields712[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{24, 31, 0x0000000000000000, "RW/V", "i_sfrcalib_fmincnt", "set to round(1.1GHz/Fref)-1 for proper SFR calibration"},
#else
{24, 31, 0x0000000000000000, "RW/V", "i_sfrcalib_fmincnt", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{16, 23, 0x0000000000000000, "RW/V", "i_sfrcalib_fmaxcnt", "set to round(3.43GHz/Fref)-1 for proper SFR calibration"},
#else
{16, 23, 0x0000000000000000, "RW/V", "i_sfrcalib_fmaxcnt", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{8, 15, 0x0000000000000000, "RW/V", "i_tdccalib_osccnt", "set to round(1.47GHz/Frefclk)-1 for proper TDC calibration"},
#else
{8, 15, 0x0000000000000000, "RW/V", "i_tdccalib_osccnt", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{1, 7, 0x0000000000000000, "RW/V", "i_locktimercnt_th", "Set this bus to the number of refclk cycles after which the o_locktimer is asserted,"},
#else
{1, 7, 0x0000000000000000, "RW/V", "i_locktimercnt_th", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo712[] = {{"CONFIG_3", "", 0x00000014, 4, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields713[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{23, 31, 0x00000000000001FF, "RO/V", "fine_min", "DCO's fine code min sampled value."},
#else
{23, 31, 0x00000000000001FF, "RO/V", "fine_min", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{18, 22, 0x000000000000000F, "RO/V", "pe_min", "Phase error min sampled value."},
#else
{18, 22, 0x000000000000000F, "RO/V", "pe_min", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{9, 17, 0x0000000000000000, "RO/V", "fine_max", "DCO's fine code max sampled value."},
#else
{9, 17, 0x0000000000000000, "RO/V", "fine_max", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{4, 8, 0x0000000000000010, "RO/V", "pe_max", "Phase error max sampled value."},
#else
{4, 8, 0x0000000000000010, "RO/V", "pe_max", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 3, 0x0000000000000000, "RW", "spare_filter", "Spare registers for Filter"},
#else
{0, 3, 0x0000000000000000, "RW", "spare_filter", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo713[] = {{"FILTER_OBS", "", 0x00000018, 5, 0x00000000FFFFFFFF, 0x00000000FFBC0100}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields714[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{16, 31, 0x0000000000000000, "RO/V", "odfx_avisa_dbgbus", "Visa lane's 1 n 0"},
#else
{16, 31, 0x0000000000000000, "RO/V", "odfx_avisa_dbgbus", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo714[] = {{"VISA_OUT", "", 0x0000001C, 1, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields715[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{28, 31, 0x0000000000000008, "RW", "tdctrim_val", "TDC trim override value"},
#else
{28, 31, 0x0000000000000008, "RW", "tdctrim_val", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{27, 27, 0x0000000000000000, "RW", "tdctrim_ovrd", "TDC trim override select"},
#else
{27, 27, 0x0000000000000000, "RW", "tdctrim_ovrd", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{18, 26, 0x0000000000000100, "RW", "dcofine_val", "EV: DCO fine override value"},
#else
{18, 26, 0x0000000000000100, "RW", "dcofine_val", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{17, 17, 0x0000000000000000, "RW", "dcofine_ovrd", "EV: DCO fine override select"},
#else
{17, 17, 0x0000000000000000, "RW", "dcofine_ovrd", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{10, 16, 0x000000000000003F, "RW", "dcocoarse_val", "EV: DCO coarse override value"},
#else
{10, 16, 0x000000000000003F, "RW", "dcocoarse_val", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{9, 9, 0x0000000000000000, "RW", "dcocoarse_ovrd", "EV: bypass coarse calibration code with coarse_val"},
#else
{9, 9, 0x0000000000000000, "RW", "dcocoarse_ovrd", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{5, 8, 0x0000000000000000, "RW/V", "i_sfr_spare", "Spare bit for the SFR"},
#else
{5, 8, 0x0000000000000000, "RW/V", "i_sfr_spare", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{4, 4, 0x0000000000000000, "RW", "fine_minmax_selcnt", "EV:\r\n"
"1' - use fine min max loggin window counter from (cfg_lockdet_cnt), \r\n"
"'0'- select narrow lock counter value (cfg_strict_lockwin)"},
#else
{4, 4, 0x0000000000000000, "RW", "fine_minmax_selcnt", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{3, 3, 0x0000000000000000, "RW", "fine_minmax_timer", "EV:\r\n"
"1' - disable minmax sampling by counter. \r\n"
"'0'- disbale by falling minmaxen bit"},
#else
{3, 3, 0x0000000000000000, "RW", "fine_minmax_timer", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo715[] = {{"DFT_0", "", 0x00000020, 9, 0x00000000FFFFFFFF, 0x000000008400FC00}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields716[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{31, 31, 0x0000000000000000, "RW", "dcolat_byp", "Makes DCO latches transparent. Allows open loop checks without refclk."},
#else
{31, 31, 0x0000000000000000, "RW", "dcolat_byp", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{30, 30, 0x0000000000000000, "RW", "tdcbbpd_en", "Enable bbpd in the sign bit of the TDC instead of FFPD"},
#else
{30, 30, 0x0000000000000000, "RW", "tdcbbpd_en", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{28, 29, 0x0000000000000003, "RW", "o_dcsense_chopsel", "div_farm clock chooper: '00' = refclk. '01', '11' = vss, '10' = vcc"},
#else
{28, 29, 0x0000000000000003, "RW", "o_dcsense_chopsel", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{27, 27, 0x0000000000000000, "RW", "force_cloopen", "EV: forces PLL into close loop mode and final filter coefficient"},
#else
{27, 27, 0x0000000000000000, "RW", "force_cloopen", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{26, 26, 0x0000000000000000, "RW", "force_tdcosc", "EV: configures TDC chain as ring oscillator"},
#else
{26, 26, 0x0000000000000000, "RW", "force_tdcosc", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{25, 25, 0x0000000000000000, "RW/V", "i_force_fbdivrstoff", "force feedback divider reset off in all modes"},
#else
{25, 25, 0x0000000000000000, "RW/V", "i_force_fbdivrstoff", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{24, 24, 0x0000000000000000, "RW", "dcocalib_cnthalf", "dco calibration (and tdc calibration?) counter counts half of default count for faster calibration"},
#else
{24, 24, 0x0000000000000000, "RW", "dcocalib_cnthalf", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{23, 23, 0x0000000000000000, "RW", "narrow_lockwin", "Strict Lock window config. '0' = -1<pe_tdc<0 for 8 cycles. '1' = -2<pe_tdc<1 for 16 cycles."},
#else
{23, 23, 0x0000000000000000, "RW", "narrow_lockwin", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{22, 22, 0x0000000000000000, "RW", "fine_pe_minmaxen", "when '1', min/max values of fine code are monitored (anyway, not when lock=0)"},
#else
{22, 22, 0x0000000000000000, "RW", "fine_pe_minmaxen", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{21, 21, 0x0000000000000000, "RW", "fine_pe_minmaxrst", "resets the fine minmax value"},
#else
{21, 21, 0x0000000000000000, "RW", "fine_pe_minmaxrst", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{20, 20, 0x0000000000000000, "RW", "p2p_fine_pe_select", "when '1', min/max values of TDC output code are monitored (anyway, not when lock=0)"},
#else
{20, 20, 0x0000000000000000, "RW", "p2p_fine_pe_select", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{19, 19, 0x0000000000000000, "RW", "dft_1_bonus", "resets the pe_minmax value"},
#else
{19, 19, 0x0000000000000000, "RW", "dft_1_bonus", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{18, 18, 0x0000000000000000, "RW", "fine_sweepen", "EV: sweep fine code (triangle sweep)"},
#else
{18, 18, 0x0000000000000000, "RW", "fine_sweepen", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{17, 17, 0x0000000000000000, "RW", "coarsesweep_en", "Coarse sweep bit."},
#else
{17, 17, 0x0000000000000000, "RW", "coarsesweep_en", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{16, 16, 0x0000000000000000, "RW", "tdcsweep_en", "TDC sweep bit."},
#else
{16, 16, 0x0000000000000000, "RW", "tdcsweep_en", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{14, 15, 0x0000000000000000, "RW/V", "i_kpscale", "Kp scaling during startup for faster lock (2^n)"},
#else
{14, 15, 0x0000000000000000, "RW/V", "i_kpscale", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{12, 13, 0x0000000000000000, "RW/V", "i_kiscale", "Ki scaling during startup for faster lock (2^n)"},
#else
{12, 13, 0x0000000000000000, "RW/V", "i_kiscale", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{10, 11, 0x0000000000000000, "RW/V", "i_kpkiscale_cnt", "controls number of refclk cycles at startup at which Kp and Ki are scaled up for faster lock (kpscale, kiscale)"},
#else
{10, 11, 0x0000000000000000, "RW/V", "i_kpkiscale_cnt", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{1, 9, 0x0000000000000000, "RO/V", "fine_pe_minmax_p2p", "EV: fine min - fine max values peak to peak"},
#else
{1, 9, 0x0000000000000000, "RO/V", "fine_pe_minmax_p2p", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 0, 0x0000000000000000, "RW", "lock_boost_en", "if asserted: FSM stays in gain boost, without time limit, till PLL is locked."},
#else
{0, 0, 0x0000000000000000, "RW", "lock_boost_en", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo716[] = {{"DFT_1", "", 0x00000024, 20, 0x00000000FFFFFFFF, 0x0000000030000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields717[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{28, 31, 0x0000000000000000, "RO/V", "o_digtop_obs", "Digital Obs out."},
#else
{28, 31, 0x0000000000000000, "RO/V", "o_digtop_obs", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{27, 27, 0x0000000000000000, "RO/V", "tdc_scan_err", "TDC scan test error flag."},
#else
{27, 27, 0x0000000000000000, "RO/V", "tdc_scan_err", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{26, 26, 0x0000000000000000, "RO/V", "narrow_lock", "Narrow lock window test failed"},
#else
{26, 26, 0x0000000000000000, "RO/V", "narrow_lock", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{25, 25, 0x0000000000000000, "RO/V", "lock_fail", "PLL went out of lock."},
#else
{25, 25, 0x0000000000000000, "RO/V", "lock_fail", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{24, 24, 0x0000000000000000, "RO/V", "sequence_fail", "Calib procedure fail flag."},
#else
{24, 24, 0x0000000000000000, "RO/V", "sequence_fail", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{23, 23, 0x0000000000000000, "RO/V", "fn_ovrfl_pos", "Fine Positive code overflow."},
#else
{23, 23, 0x0000000000000000, "RO/V", "fn_ovrfl_pos", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{22, 22, 0x0000000000000000, "RO/V", "fn_ovrfl_neg", "Fine Negative code overflow."},
#else
{22, 22, 0x0000000000000000, "RO/V", "fn_ovrfl_neg", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{21, 21, 0x0000000000000000, "RO/V", "p1_ovrflw_pos", "Filter's Integrator Positive code overflow."},
#else
{21, 21, 0x0000000000000000, "RO/V", "p1_ovrflw_pos", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{20, 20, 0x0000000000000000, "RO/V", "p1_ovrflw_neg", "Filter's Integrator Negative code overflow."},
#else
{20, 20, 0x0000000000000000, "RO/V", "p1_ovrflw_neg", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{19, 19, 0x0000000000000000, "RO/V", "sfrcalib_ovrfl", "SFR calib overflow."},
#else
{19, 19, 0x0000000000000000, "RO/V", "sfrcalib_ovrfl", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{18, 18, 0x0000000000000000, "RO/V", "sfrtrim_ovrfl", "SFR trim overflow."},
#else
{18, 18, 0x0000000000000000, "RO/V", "sfrtrim_ovrfl", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{14, 17, 0x0000000000000008, "RW", "obs_sel3", "obs(3) muxing control bits.\r\n"
"Same control settings apply as noted in obs_sel0[3:0]"},
#else
{14, 17, 0x0000000000000008, "RW", "obs_sel3", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{10, 13, 0x000000000000000B, "RW", "obs_sel2", "obs(2) muxing control bits.\r\n"
"Same control settings apply as noted in obs_sel0[3:0]"},
#else
{10, 13, 0x000000000000000B, "RW", "obs_sel2", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{6, 9, 0x0000000000000000, "RW", "obs_sel1", "obs(1)muxing control bits.\r\n"
"Same control settings apply as noted in obs_sel0[3:0]"},
#else
{6, 9, 0x0000000000000000, "RW", "obs_sel1", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{2, 5, 0x0000000000000003, "RW", "obs_sel0", "obs(0) muxing control bits.\r\n"
"--------------------------------------------\r\n"
"|    i_obs_sel[0] |      o_obs[0]     |\r\n"
"---------------------------------------------\r\n"
"|        0xxx          | digtop_obs[0] |\r\n"
"--------------------------------------------\r\n"
"|        1000          |      dcoclk          |\r\n"
"--------------------------------------------\r\n"
"|        1001          |    dcoclk_div2  |\r\n"
"--------------------------------------------\r\n"
"|        1010          |   dcoclk_div4   |\r\n"
"--------------------------------------------\r\n"
"|        1011          |          fbclk         |\r\n"
"--------------------------------------------\r\n"
"|        1100          |          refclk       |\r\n"
"--------------------------------------------\r\n"
"|        1101          |          fbclk16    |\r\n"
"--------------------------------------------\r\n"
"|        1110          |         refclk16   |\r\n"
"--------------------------------------------\r\n"
"|        1111          |      dither_bit   |\r\n"
"--------------------------------------------"},
#else
{2, 5, 0x0000000000000003, "RW", "obs_sel0", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{1, 1, 0x0000000000000000, "RW", "narrow_lock_late", "Narrow lock time indicator signals, this signal asserts in case the narrow lock asserts after o_locktimer assertion"},
#else
{1, 1, 0x0000000000000000, "RW", "narrow_lock_late", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo717[] = {{"DFT_2", "", 0x00000028, 16, 0x00000000FFFFFFFF, 0x0000000000022C0C}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields718[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{24, 31, 0x0000000000000000, "RW", "sfr_monsel", "Select for SFR analog monitor"},
#else
{24, 31, 0x0000000000000000, "RW", "sfr_monsel", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{20, 23, 0x0000000000000008, "RW", "sfrcalib_val", "sfr calibration initial value. Also used as override value when calib_ovrd is 1"},
#else
{20, 23, 0x0000000000000008, "RW", "sfrcalib_val", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{16, 19, 0x0000000000000008, "RW", "sfrtrim_val", "EV: sfr trim override value"},
#else
{16, 19, 0x0000000000000008, "RW", "sfrtrim_val", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{15, 15, 0x0000000000000000, "RW", "sfrcalib_ovrd", "EV: sfr calibration is bypassed with sfrcalib_val"},
#else
{15, 15, 0x0000000000000000, "RW", "sfrcalib_ovrd", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{14, 14, 0x0000000000000000, "RW", "sfrtrim_ovrd", "EV: sfr trim override select"},
#else
{14, 14, 0x0000000000000000, "RW", "sfrtrim_ovrd", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{13, 13, 0x0000000000000000, "RW", "sfren_ovrd", "EV: SFR enable override (bypass the power up sequence)"},
#else
{13, 13, 0x0000000000000000, "RW", "sfren_ovrd", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{12, 12, 0x0000000000000000, "RW", "sfren_val", "EV: SFR enable value"},
#else
{12, 12, 0x0000000000000000, "RW", "sfren_val", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{11, 11, 0x0000000000000000, "RW", "sfr_bypass", "EV: SFR bypass control"},
#else
{11, 11, 0x0000000000000000, "RW", "sfr_bypass", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{10, 10, 0x0000000000000000, "RW", "sfrtimer_cnt2x", "EV: multiplies SFR counters by 2x"},
#else
{10, 10, 0x0000000000000000, "RW", "sfrtimer_cnt2x", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{8, 9, 0x0000000000000000, "RW/V", "i_sfrsupplymode", "SFR supply indicator. \r\n"
"00 - Not allowed\r\n"
"01 - 1.2V\r\n"
"10 - 1.25V\r\n"
"11 - 1.35V"},
#else
{8, 9, 0x0000000000000000, "RW/V", "i_sfrsupplymode", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{4, 7, 0x0000000000000000, "RW/V", "i_sfrtimer_coef", "set this bus to round((Frefclk / 20MHz) - 1) to allow ADPLL generate an absolute timer for SFR trimming, SFR calibration, SFR on and DCO settle"},
#else
{4, 7, 0x0000000000000000, "RW/V", "i_sfrtimer_coef", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{3, 3, 0x0000000000000000, "RW", "sfrlpfres_ovrd_sel", "enable the override of the lpf resistor bypass control using  sfrlpfres_ovrd_val"},
#else
{3, 3, 0x0000000000000000, "RW", "sfrlpfres_ovrd_sel", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{2, 2, 0x0000000000000000, "RW", "sfrlpfres_ovrd_val", "disable the lpf resistor bypass"},
#else
{2, 2, 0x0000000000000000, "RW", "sfrlpfres_ovrd_val", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{1, 1, 0x0000000000000000, "RW", "digmode_en", "enable digmod during sfr_disable"},
#else
{1, 1, 0x0000000000000000, "RW", "digmode_en", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo718[] = {{"SFRCONFIG_0", "", 0x0000002C, 14, 0x00000000FFFFFFFF, 0x0000000000880000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields719[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{31, 31, 0x0000000000000000, "RW", "bisten", "Triggers bist block."},
#else
{31, 31, 0x0000000000000000, "RW", "bisten", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{23, 30, 0x0000000000000000, "RW", "fbdivratio_bistmax", "Top bist sweep division value."},
#else
{23, 30, 0x0000000000000000, "RW", "fbdivratio_bistmax", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{15, 22, 0x0000000000000000, "RW", "fbdivratio_bistmin", "Bottom bist sweep division value."},
#else
{15, 22, 0x0000000000000000, "RW", "fbdivratio_bistmin", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{14, 14, 0x0000000000000001, "RW", "crs_precision", "Triggers another cycle of DCO calibration, and selects a more accurate coarse code."},
#else
{14, 14, 0x0000000000000001, "RW", "crs_precision", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{13, 13, 0x0000000000000001, "RO/V", "fbdiv_shmoo_bist_flag", "HVM: This bit indicates if the fbdiv shmoo BIST passes. Its value is valid only in case 'bist_done' = 1'b1. 1'b0: test faild 1'b1: test passed"},
#else
{13, 13, 0x0000000000000001, "RO/V", "fbdiv_shmoo_bist_flag", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{12, 12, 0x0000000000000000, "RO/V", "bist_done", "Indicates if bist test finished."},
#else
{12, 12, 0x0000000000000000, "RO/V", "bist_done", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo719[] = {{"DFT_BIST", "", 0x00000030, 6, 0x00000000FFFFFFFF, 0x0000000000006000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields720[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{28, 31, 0x0000000000000008, "RO/V", "o_sfr_calib_out", "SFR fast trim code."},
#else
{28, 31, 0x0000000000000008, "RO/V", "o_sfr_calib_out", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{24, 27, 0x0000000000000008, "RO/V", "o_sfr_trim_out", "SFR slow trim code."},
#else
{24, 27, 0x0000000000000008, "RO/V", "o_sfr_trim_out", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{20, 23, 0x0000000000000007, "RO/V", "o_tdc_trim_out", "TDC trim code."},
#else
{20, 23, 0x0000000000000007, "RO/V", "o_tdc_trim_out", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{13, 19, 0x0000000000000000, "RO/V", "o_dco_coarse_out", "DCO coarse code."},
#else
{13, 19, 0x0000000000000000, "RO/V", "o_dco_coarse_out", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo720[] = {{"CALIB_MNTR", "", 0x00000034, 4, 0x00000000FFFFFFFF, 0x0000000088700000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields721[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{30, 31, 0x0000000000000000, "RW", "bgach", "Indicates what type of channel this is and what mapping of input DQ pattern to coefficient should be used"},
#else
{30, 31, 0x0000000000000000, "RW", "bgach", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{27, 29, 0x0000000000000002, "RW", "coeffscale", "Scale LSB of all coefficient by this number"},
#else
{27, 29, 0x0000000000000002, "RW", "coeffscale", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{24, 26, 0x0000000000000000, "RW/V", "coeff6", "Feedforward coefficient for number of PMOS legs to enable for one lane pattern 6"},
#else
{24, 26, 0x0000000000000000, "RW/V", "coeff6", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{20, 23, 0x0000000000000000, "RW/V", "coeff5", "Feedforward coefficient for number of PMOS legs to enable for one lane pattern 5"},
#else
{20, 23, 0x0000000000000000, "RW/V", "coeff5", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{16, 19, 0x0000000000000000, "RW/V", "coeff4", "Feedforward coefficient for number of PMOS legs to enable for one lane pattern 4"},
#else
{16, 19, 0x0000000000000000, "RW/V", "coeff4", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{12, 15, 0x0000000000000000, "RW/V", "coeff3", "Feedforward coefficient for number of PMOS legs to enable for one lane pattern 3"},
#else
{12, 15, 0x0000000000000000, "RW/V", "coeff3", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{8, 11, 0x0000000000000000, "RW/V", "coeff2", "Feedforward coefficient for number of PMOS legs to enable for one lane pattern 2"},
#else
{8, 11, 0x0000000000000000, "RW/V", "coeff2", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{4, 7, 0x0000000000000000, "RW/V", "coeff1", "Feedforward coefficient for number of PMOS legs to enable for one lane pattern 1"},
#else
{4, 7, 0x0000000000000000, "RW/V", "coeff1", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 3, 0x0000000000000000, "RW/V", "coeff0", "Feedforward coefficient for number of PMOS legs to enable for one lane pattern 0"},
#else
{0, 3, 0x0000000000000000, "RW/V", "coeff0", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo721[] = {{"txffdq0_dvfs", "", 0x00000000, 9, 0x00000000FFFFFFFF, 0x0000000010000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields722[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{30, 31, 0x0000000000000000, "RW", "bgach", "Indicates what type of channel this is and what mapping of input DQ pattern to coefficient should be used"},
#else
{30, 31, 0x0000000000000000, "RW", "bgach", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{27, 29, 0x0000000000000002, "RW", "coeffscale", "Scale LSB of all coefficient by this number"},
#else
{27, 29, 0x0000000000000002, "RW", "coeffscale", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{24, 26, 0x0000000000000000, "RW/V", "coeff6", "Feedforward coefficient for number of PMOS legs to enable for one lane pattern 6"},
#else
{24, 26, 0x0000000000000000, "RW/V", "coeff6", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{20, 23, 0x0000000000000000, "RW/V", "coeff5", "Feedforward coefficient for number of PMOS legs to enable for one lane pattern 5"},
#else
{20, 23, 0x0000000000000000, "RW/V", "coeff5", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{16, 19, 0x0000000000000000, "RW/V", "coeff4", "Feedforward coefficient for number of PMOS legs to enable for one lane pattern 4"},
#else
{16, 19, 0x0000000000000000, "RW/V", "coeff4", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{12, 15, 0x0000000000000000, "RW/V", "coeff3", "Feedforward coefficient for number of PMOS legs to enable for one lane pattern 3"},
#else
{12, 15, 0x0000000000000000, "RW/V", "coeff3", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{8, 11, 0x0000000000000000, "RW/V", "coeff2", "Feedforward coefficient for number of PMOS legs to enable for one lane pattern 2"},
#else
{8, 11, 0x0000000000000000, "RW/V", "coeff2", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{4, 7, 0x0000000000000000, "RW/V", "coeff1", "Feedforward coefficient for number of PMOS legs to enable for one lane pattern 1"},
#else
{4, 7, 0x0000000000000000, "RW/V", "coeff1", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 3, 0x0000000000000000, "RW/V", "coeff0", "Feedforward coefficient for number of PMOS legs to enable for one lane pattern 0"},
#else
{0, 3, 0x0000000000000000, "RW/V", "coeff0", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo722[] = {{"txffdq1_dvfs", "", 0x00000004, 9, 0x00000000FFFFFFFF, 0x0000000010000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields723[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{30, 31, 0x0000000000000000, "RW", "bgach", "Indicates what type of channel this is and what mapping of input CA pattern to coefficient should be used"},
#else
{30, 31, 0x0000000000000000, "RW", "bgach", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{27, 29, 0x0000000000000002, "RW", "coeffscale", "Scale LSB of all coefficient by this number"},
#else
{27, 29, 0x0000000000000002, "RW", "coeffscale", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{24, 26, 0x0000000000000000, "RW/V", "coeff6", "Feedforward coefficient for number of PMOS legs to enable for one lane pattern 6"},
#else
{24, 26, 0x0000000000000000, "RW/V", "coeff6", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{20, 23, 0x0000000000000000, "RW/V", "coeff5", "Feedforward coefficient for number of PMOS legs to enable for one lane pattern 5"},
#else
{20, 23, 0x0000000000000000, "RW/V", "coeff5", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{16, 19, 0x0000000000000000, "RW/V", "coeff4", "Feedforward coefficient for number of PMOS legs to enable for one lane pattern 4"},
#else
{16, 19, 0x0000000000000000, "RW/V", "coeff4", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{12, 15, 0x0000000000000000, "RW/V", "coeff3", "Feedforward coefficient for number of PMOS legs to enable for one lane pattern 3"},
#else
{12, 15, 0x0000000000000000, "RW/V", "coeff3", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{8, 11, 0x0000000000000000, "RW/V", "coeff2", "Feedforward coefficient for number of PMOS legs to enable for one lane pattern 2"},
#else
{8, 11, 0x0000000000000000, "RW/V", "coeff2", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{4, 7, 0x0000000000000000, "RW/V", "coeff1", "Feedforward coefficient for number of PMOS legs to enable for one lane pattern 1"},
#else
{4, 7, 0x0000000000000000, "RW/V", "coeff1", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 3, 0x0000000000000000, "RW/V", "coeff0", "Feedforward coefficient for number of PMOS legs to enable for one lane pattern 0"},
#else
{0, 3, 0x0000000000000000, "RW/V", "coeff0", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo723[] = {{"txffca0_dvfs", "", 0x00000008, 9, 0x00000000FFFFFFFF, 0x0000000010000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields724[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{30, 31, 0x0000000000000000, "RW", "bgach", "Indicates what type of channel this is and what mapping of input CA pattern to coefficient should be used"},
#else
{30, 31, 0x0000000000000000, "RW", "bgach", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{27, 29, 0x0000000000000002, "RW", "coeffscale", "Scale LSB of all coefficient by this number"},
#else
{27, 29, 0x0000000000000002, "RW", "coeffscale", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{24, 26, 0x0000000000000000, "RW/V", "coeff6", "Feedforward coefficient for number of PMOS legs to enable for one lane pattern 6"},
#else
{24, 26, 0x0000000000000000, "RW/V", "coeff6", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{20, 23, 0x0000000000000000, "RW/V", "coeff5", "Feedforward coefficient for number of PMOS legs to enable for one lane pattern 5"},
#else
{20, 23, 0x0000000000000000, "RW/V", "coeff5", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{16, 19, 0x0000000000000000, "RW/V", "coeff4", "Feedforward coefficient for number of PMOS legs to enable for one lane pattern 4"},
#else
{16, 19, 0x0000000000000000, "RW/V", "coeff4", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{12, 15, 0x0000000000000000, "RW/V", "coeff3", "Feedforward coefficient for number of PMOS legs to enable for one lane pattern 3"},
#else
{12, 15, 0x0000000000000000, "RW/V", "coeff3", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{8, 11, 0x0000000000000000, "RW/V", "coeff2", "Feedforward coefficient for number of PMOS legs to enable for one lane pattern 2"},
#else
{8, 11, 0x0000000000000000, "RW/V", "coeff2", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{4, 7, 0x0000000000000000, "RW/V", "coeff1", "Feedforward coefficient for number of PMOS legs to enable for one lane pattern 1"},
#else
{4, 7, 0x0000000000000000, "RW/V", "coeff1", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 3, 0x0000000000000000, "RW/V", "coeff0", "Feedforward coefficient for number of PMOS legs to enable for one lane pattern 0"},
#else
{0, 3, 0x0000000000000000, "RW/V", "coeff0", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo724[] = {{"txffca1_dvfs", "", 0x0000000C, 9, 0x00000000FFFFFFFF, 0x0000000010000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields725[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{30, 31, 0x0000000000000000, "RW", "dqrdrdpointersep", "Read DQ data from FIFO for feedforward path N cycles before reading DQ for transmitter"},
#else
{30, 31, 0x0000000000000000, "RW", "dqrdrdpointersep", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{24, 29, 0x0000000000000000, "RW/V", "tcodeclkstop", "Number of PMOS legs to enable in feedback regulator for CKE low, clock stop operation"},
#else
{24, 29, 0x0000000000000000, "RW/V", "tcodeclkstop", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{18, 23, 0x0000000000000000, "RW/V", "tcodeidle", "Number of PMOS legs to enable in feedback regulator for CKE high, idle operation"},
#else
{18, 23, 0x0000000000000000, "RW/V", "tcodeidle", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{12, 17, 0x0000000000000000, "RW/V", "tcodeca", "Number of PMOS legs to enable in feedback regulator for CKE high, driving CA bits"},
#else
{12, 17, 0x0000000000000000, "RW/V", "tcodeca", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{6, 11, 0x0000000000000000, "RW/V", "tcodedq", "Number of PMOS legs to enable in feedback regulator for CKE high, driving DQ bits"},
#else
{6, 11, 0x0000000000000000, "RW/V", "tcodedq", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 5, 0x0000000000000000, "RW/V", "tcodecadq", "Number of PMOS legs to enable in feedback regulator for CKE high, driving CA & DQ bits"},
#else
{0, 5, 0x0000000000000000, "RW/V", "tcodecadq", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo725[] = {{"txtcode0_dvfs", "", 0x00000010, 6, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields726[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{30, 31, 0x0000000000000000, "RW", "dqrdrdpointersep", "Read DQ data from FIFO for feedforward path N cycles before reading DQ for transmitter"},
#else
{30, 31, 0x0000000000000000, "RW", "dqrdrdpointersep", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{24, 29, 0x0000000000000000, "RW/V", "tcodeclkstop", "Number of PMOS legs to enable in feedback regulator for CKE low, clock stop operation"},
#else
{24, 29, 0x0000000000000000, "RW/V", "tcodeclkstop", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{18, 23, 0x0000000000000000, "RW/V", "tcodeidle", "Number of PMOS legs to enable in feedback regulator for CKE high, idle operation"},
#else
{18, 23, 0x0000000000000000, "RW/V", "tcodeidle", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{12, 17, 0x0000000000000000, "RW/V", "tcodeca", "Number of PMOS legs to enable in feedback regulator for CKE high, driving CA bits"},
#else
{12, 17, 0x0000000000000000, "RW/V", "tcodeca", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{6, 11, 0x0000000000000000, "RW/V", "tcodedq", "Number of PMOS legs to enable in feedback regulator for CKE high, driving DQ bits"},
#else
{6, 11, 0x0000000000000000, "RW/V", "tcodedq", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 5, 0x0000000000000000, "RW/V", "tcodecadq", "Number of PMOS legs to enable in feedback regulator for CKE high, driving CA & DQ bits"},
#else
{0, 5, 0x0000000000000000, "RW/V", "tcodecadq", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo726[] = {{"txtcode1_dvfs", "", 0x00000014, 6, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields727[] = {
#ifdef MEM_SV_HOOKS
#if DUMP_REGISTER_DESCRIPTIONS
{25, 31, 0x0000000000000000, "RO", "Reserved", "Reserved bits"},
#else
{25, 31, 0x0000000000000000, "RO", "Reserved", NULL},
#endif
#else
#if DUMP_REGISTER_DESCRIPTIONS
{25, 31, 0x00000000, "RO", "Reserved", "Reserved"},
#else
{25, 31, 0x00000000, "RO", "Reserved",  NULL},
#endif
#endif // MEM_SV_HOOKS
#if DUMP_REGISTER_DESCRIPTIONS
{24, 24, 0x0000000000000000, "RW/V", "enoffsetcorrection", "Trigger sensor offset correction. When set to 1'b1, offset compensation will start. Self reset when compensation is done."},
#else
{24, 24, 0x0000000000000000, "RW/V", "enoffsetcorrection", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{18, 23, 0x0000000000000000, "RW/V", "saoffset3", "Strong Arm Latch 3 offset. 2s compliment signed offset with step size of Vddq/384"},
#else
{18, 23, 0x0000000000000000, "RW/V", "saoffset3", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{12, 17, 0x0000000000000000, "RW/V", "saoffset2", "Strong Arm Latch 3 offset. 2s compliment signed offset with step size of Vddq/384"},
#else
{12, 17, 0x0000000000000000, "RW/V", "saoffset2", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{6, 11, 0x0000000000000000, "RW/V", "saoffset1", "Strong Arm Latch 3 offset. 2s compliment signed offset with step size of Vddq/384"},
#else
{6, 11, 0x0000000000000000, "RW/V", "saoffset1", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 5, 0x0000000000000000, "RW/V", "saoffset0", "Strong Arm Latch 3 offset. 2s compliment signed offset with step size of Vddq/384"},
#else
{0, 5, 0x0000000000000000, "RW/V", "saoffset0", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo727[] = {{"txsaoffset", "", 0x00000018, 6, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields728[] = {
#ifdef MEM_SV_HOOKS
#if DUMP_REGISTER_DESCRIPTIONS
{23, 31, 0x0000000000000000, "RO", "Reserved", "Reserved bits"},
#else
{23, 31, 0x0000000000000000, "RO", "Reserved", NULL},
#endif
#else
#if DUMP_REGISTER_DESCRIPTIONS
{23, 31, 0x00000000, "RO", "Reserved", "Reserved"},
#else
{23, 31, 0x00000000, "RO", "Reserved",  NULL},
#endif
#endif // MEM_SV_HOOKS
#if DUMP_REGISTER_DESCRIPTIONS
{19, 22, 0x0000000000000000, "RW", "enfeedforwardtrain", "Drive Tcode value from feedback regulator to TxRegFF for {0: Training Off, 1: CACoEff0, & 7: CACoEff6, 8: DQCoEff0, & 14: DQCoEff6, 15: Rsvd}.[br]Writing this to a non-zero value will atuotmatically reset Tcode, Code and the associated Tcode CR to the middle value (one time reset pulse on WrEn).[br]While this register is non-zero, IOSF will NOT be able to write TxRegFF registers."},
#else
{19, 22, 0x0000000000000000, "RW", "enfeedforwardtrain", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{18, 18, 0x0000000000000001, "RW", "bypassregulator", "Turn off the regulator and turn on all PMOS legs to achieve the lowest possible resistance"},
#else
{18, 18, 0x0000000000000001, "RW", "bypassregulator", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{13, 17, 0x000000000000000A, "RW", "targetv", "Target VccFAR voltage value of Vref = (TargetV+64)/96"},
#else
{13, 17, 0x000000000000000A, "RW", "targetv", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{10, 12, 0x0000000000000003, "RW", "fastbw", "Must have a net number of (FastBW+1) samples in the same direction before updating Code"},
#else
{10, 12, 0x0000000000000003, "RW", "fastbw", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{7, 9, 0x0000000000000003, "RW", "slowbw", "Must have a net number of 4*(SlowBW+1) samples in the same direction before updating Tcode"},
#else
{7, 9, 0x0000000000000003, "RW", "slowbw", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{4, 6, 0x0000000000000004, "RW", "maxripple", "Limit |Code-Tcode| to be <= (MaxRipple+1)"},
#else
{4, 6, 0x0000000000000004, "RW", "maxripple", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{3, 3, 0x0000000000000000, "RW", "enregulator", "Master enable for the feedback/feedforward/panic regulator. If this bit is 0, all parts of the regulator turn off.[br]If BypassRegulator is 1, the value of EnRegulator is don't care and the feedback/feedforward/panic regulator is off.[br]If BypassRegulator and EnRegulator is 0, all PMOS legs turn off and VccFAR is HiZ (Reset Default)."},
#else
{3, 3, 0x0000000000000000, "RW", "enregulator", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{2, 2, 0x0000000000000001, "RW", "enfeedbackdrv", "Enable feedback regulator driver (Disable during feedforward training)"},
#else
{2, 2, 0x0000000000000001, "RW", "enfeedbackdrv", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 1, 0x0000000000000000, "RW", "enmode", "Enables fully independent tracking modes (default) or consolidates modes (1-3). Modes based on setting = {0: (0,1,2,3,4) 1: (0,1,2-4) 2: (0,1-4) 3: (0-4)}.[br]Ex: A value of 0 enables tracking 5 independent Tcode values in the feedback regulator.[br]Ex: A value of 3 enables tracking a single shared TCode value in the feedback regulator."},
#else
{0, 1, 0x0000000000000000, "RW", "enmode", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo728[] = {{"txfb", "", 0x0000001C, 10, 0x00000000FFFFFFFF, 0x0000000000054DC4}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields729[] = {
#ifdef MEM_SV_HOOKS
#if DUMP_REGISTER_DESCRIPTIONS
{28, 31, 0x0000000000000000, "RO", "Reserved", "Reserved bits"},
#else
{28, 31, 0x0000000000000000, "RO", "Reserved", NULL},
#endif
#else
#if DUMP_REGISTER_DESCRIPTIONS
{28, 31, 0x00000000, "RO", "Reserved", "Reserved"},
#else
{28, 31, 0x00000000, "RO", "Reserved",  NULL},
#endif
#endif // MEM_SV_HOOKS
#if DUMP_REGISTER_DESCRIPTIONS
{27, 27, 0x0000000000000000, "RW", "forcepanicon", "Force panic to be on"},
#else
{27, 27, 0x0000000000000000, "RW", "forcepanicon", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{26, 26, 0x0000000000000000, "RW", "enpanicdowncomp", "Enable panic down compensation"},
#else
{26, 26, 0x0000000000000000, "RW", "enpanicdowncomp", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{24, 25, 0x0000000000000000, "RW", "viewana", "Select analog signal to observe"},
#else
{24, 25, 0x0000000000000000, "RW", "viewana", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{20, 23, 0x0000000000000000, "RW", "viewdigch1", "Select digital signal to observe on Ch1 view pins"},
#else
{20, 23, 0x0000000000000000, "RW", "viewdigch1", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{16, 19, 0x0000000000000000, "RW", "viewdigch0", "Select digital signal to observe on Ch0 view pins"},
#else
{16, 19, 0x0000000000000000, "RW", "viewdigch0", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{15, 15, 0x0000000000000001, "RW", "pdcbit", "Chicken bit that disables all clock & power gating in LDO"},
#else
{15, 15, 0x0000000000000001, "RW", "pdcbit", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{14, 14, 0x0000000000000000, "RW", "enpdidle", "During CKE power down, Target amp wakes for 4 dclks, active for 8 dclks (i.e. allow Code/Tcode updates) and sleeps for 24 dclks.[br]During sleep/wake, set Code equal to drive TcodeIdle."},
#else
{14, 14, 0x0000000000000000, "RW", "enpdidle", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{13, 13, 0x0000000000000000, "RW", "enpdclkstop", "During CKE power down, Target amp wakes for 4 dclks, active for 8 dclks (i.e. allow Code/Tcode updates) and sleeps for 63 dclks.[br]During sleep/wake, set Code equal to drive TcodeClkStop."},
#else
{13, 13, 0x0000000000000000, "RW", "enpdclkstop", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{12, 12, 0x0000000000000001, "RW", "enpanicsr", "Enable Panic on SR exit until the regulator has been in each mode for a certain period of time"},
#else
{12, 12, 0x0000000000000001, "RW", "enpanicsr", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{10, 11, 0x0000000000000001, "RW", "enpanicclk", "Enable Panic for 8 dclk after ClkStop exit. MSB/LSB bit used for High/Low DVFS point"},
#else
{10, 11, 0x0000000000000001, "RW", "enpanicclk", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{8, 9, 0x0000000000000001, "RW", "enpanicca", "Enable Panic during CA traffic, extending for 2 dclks after CA turns off. MSB/LSB bit used for High/Low DVFS point"},
#else
{8, 9, 0x0000000000000001, "RW", "enpanicca", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{6, 7, 0x0000000000000001, "RW", "enpanicdq", "Enable Panic during DQ traffic, extending for 2 dclks after DQ turns off. MSB/LSB bit used for High/Low DVFS point"},
#else
{6, 7, 0x0000000000000001, "RW", "enpanicdq", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{3, 5, 0x0000000000000000, "RW", "panicvhi", "PanicHi voltage level is 3*PanicHi*Vccdq/384. Value of 0 disables PanicHi sensor and PanicLo driver"},
#else
{3, 5, 0x0000000000000000, "RW", "panicvhi", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 2, 0x0000000000000000, "RW", "panicvlo", "PanicHi voltage level is -3*PanicHi*Vccdq/384. Value of 0 disables PanicLo sensor and PanicLo driver"},
#else
{0, 2, 0x0000000000000000, "RW", "panicvlo", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo729[] = {{"txpanic", "", 0x00000020, 15, 0x00000000FFFFFFFF, 0x0000000000009540}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields730[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{26, 31, 0x0000000000000000, "RW/V", "paniccompn_b", "NMOS Panic Driver Compensation code for DVFS Frequency B.[br]Overloaded such that this stores PanicDnCount during IOLB on the DVFS value that is NOT being used."},
#else
{26, 31, 0x0000000000000000, "RW/V", "paniccompn_b", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{20, 25, 0x0000000000000000, "RW/V", "paniccompp_b", "PMOS Panic Driver Compensation code for DVFS Frequency B.[br]Overloaded such that this stores PanicDnCount during IOLB on the DVFS value that is NOT being used."},
#else
{20, 25, 0x0000000000000000, "RW/V", "paniccompp_b", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{14, 19, 0x0000000000000000, "RW/V", "paniccompn_a", "NMOS Panic Driver Compensation code for DVFS Frequency A.[br]Overloaded such that this stores PanicDnCount during IOLB on the DVFS value that is NOT being used."},
#else
{14, 19, 0x0000000000000000, "RW/V", "paniccompn_a", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{8, 13, 0x0000000000000000, "RW/V", "paniccompp_a", "PMOS Panic Driver Compensation code for DVFS Frequency A.[br]Overloaded such that this stores PanicDnCount during IOLB on the DVFS value that is NOT being used."},
#else
{8, 13, 0x0000000000000000, "RW/V", "paniccompp_a", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{4, 7, 0x0000000000000000, "RW", "paniccompnmult_b", "Multiplier of NMOS compensation code for DVFS Frequency B "},
#else
{4, 7, 0x0000000000000000, "RW", "paniccompnmult_b", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 3, 0x0000000000000000, "RW", "paniccompnmult_a", "Multiplier of NMOS compensation code for DVFS Frequency A"},
#else
{0, 3, 0x0000000000000000, "RW", "paniccompnmult_a", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo730[] = {{"txpaniccomp", "", 0x00000024, 6, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields731[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{10, 31, 0x0000000000000000, "RO", "Reserved", "Reserved"},
#else
{10, 31, 0x0000000000000000, "RO", "Reserved", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{9, 9, 0x0000000000000000, "RW", "cgctrl_clkgaten", "Clock gate enable. When set to 1, enables the ISM to leave ACTIVE and gates the side_clk if in the IDLE state. When set to 0, the ISM never leaves ACTIVE once it gets to that state and the clock is never gated. Recommended value = 1."},
#else
{9, 9, 0x0000000000000000, "RW", "cgctrl_clkgaten", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{8, 8, 0x0000000000000000, "RW", "cgctrl_clkgatedef", "Clock gate defeature. When set to 1, disables side_clk gating within the endpoint when ISM is IDLE. Set to 0 for normal operation. Recommended value = 0"},
#else
{8, 8, 0x0000000000000000, "RW", "cgctrl_clkgatedef", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 7, 0x0000000000000010, "RW", "cgctrl_idlecnt", "Idle count limit for ISM which is determines when the block should transition to IDLE_REQ. Recommended value = 8'd16.[br]A value of zero breaks the design resulting in an unresponsive endpoint."},
#else
{0, 7, 0x0000000000000010, "RW", "cgctrl_idlecnt", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo731[] = {{"dpic_cri_cfg", "", 0x00000000, 4, 0x00000000FFFFFFFF, 0x0000000000000010}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields732[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{29, 31, 0x0000000000000000, "RO", "Reserved", "Reserved bits"},
#else
{29, 31, 0x0000000000000000, "RO", "Reserved", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{28, 28, 0x0000000000000000, "RW", "fbdivrst_b", "Feedback clock reset addition (used during power switch operation)"},
#else
{28, 28, 0x0000000000000000, "RW", "fbdivrst_b", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{26, 27, 0x0000000000000000, "RO", "Reserved0", "Reserved bits"},
#else
{26, 27, 0x0000000000000000, "RO", "Reserved0", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{24, 25, 0x0000000000000000, "RW", "pll_cmn_fbmuxsel", "mplldivs feedback multiplexer select (muxa). not part of adpll."},
#else
{24, 25, 0x0000000000000000, "RW", "pll_cmn_fbmuxsel", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{5, 23, 0x0000000000000000, "RO", "Reserved1", "Reserved bits"},
#else
{5, 23, 0x0000000000000000, "RO", "Reserved1", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 4, 0x0000000000000002, "RW", "pll_cmn_refdivsel", "mplldivs reference divider ratio select (diva). not part of adpll."},
#else
{0, 4, 0x0000000000000002, "RW", "pll_cmn_refdivsel", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo732[] = {{"plldivctl", "", 0x00000004, 6, 0x00000000FFFFFFFF, 0x0000000000000002}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields733[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{25, 31, 0x0000000000000000, "RO", "Reserved", "Reserved"},
#else
{25, 31, 0x0000000000000000, "RO", "Reserved", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{20, 24, 0x0000000000000000, "RW", "pll_cmn_fbclktrim", "Coarse delay value for the min DLL delay matching logic in PLL.[br]This should match the initial coarse delay value generated from initial DLL Compensation."},
#else
{20, 24, 0x0000000000000000, "RW", "pll_cmn_fbclktrim", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{17, 19, 0x0000000000000000, "RO", "Reserved0", "Reserved"},
#else
{17, 19, 0x0000000000000000, "RO", "Reserved0", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{16, 16, 0x0000000000000000, "RW", "pll_cmn_2xclken", "2x clock tree drive output enable"},
#else
{16, 16, 0x0000000000000000, "RW", "pll_cmn_2xclken", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{14, 15, 0x0000000000000000, "RO", "Reserved1", "Reserved"},
#else
{14, 15, 0x0000000000000000, "RO", "Reserved1", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{12, 13, 0x0000000000000001, "RW", "pll_cmn_2xclkmuxsel", "mplldivs 2xclk multiplexer select (muxc). not part of adpll."},
#else
{12, 13, 0x0000000000000001, "RW", "pll_cmn_2xclkmuxsel", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{9, 11, 0x0000000000000000, "RO", "Reserved2", "Reserved"},
#else
{9, 11, 0x0000000000000000, "RO", "Reserved2", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{8, 8, 0x0000000000000000, "RW", "pll_cmn_mplldivsrstb", "mplldivs divider reset bar"},
#else
{8, 8, 0x0000000000000000, "RW", "pll_cmn_mplldivsrstb", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{4, 7, 0x0000000000000000, "RO", "Reserved3", "Reserved"},
#else
{4, 7, 0x0000000000000000, "RO", "Reserved3", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{3, 3, 0x0000000000000000, "RW", "pll_cmn_dcocal", "forces dco calibration when exiting deep sleep mode. required if changing feedback divider ratio or refclk frequency"},
#else
{3, 3, 0x0000000000000000, "RW", "pll_cmn_dcocal", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{2, 2, 0x0000000000000000, "RW", "pll_cmn_sfren", "forces sfr on even when pll is disabled (active standby mode)"},
#else
{2, 2, 0x0000000000000000, "RW", "pll_cmn_sfren", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{1, 1, 0x0000000000000000, "RO/V", "pll_cmn_plllock", "pll lock signal (hardware based)"},
#else
{1, 1, 0x0000000000000000, "RO/V", "pll_cmn_plllock", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 0, 0x0000000000000000, "RW", "pll_cmn_pllen", "pll enable signal"},
#else
{0, 0, 0x0000000000000000, "RW", "pll_cmn_pllen", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo733[] = {{"pllctl", "", 0x00000008, 13, 0x00000000FFFFFFFF, 0x0000000000001000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields734[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{16, 31, 0x0000000000000000, "RO", "Reserved", "Reserved"},
#else
{16, 31, 0x0000000000000000, "RO", "Reserved", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{8, 15, 0x0000000000000003, "RW", "cripg_clkgaten_stgdly", "Delay for staggered power gate enable. Determines the number of cycles interval between each power gate enable bit being asserted. Cripgctrl FSM is in PWRGATE state. Value of 0 not supported."},
#else
{8, 15, 0x0000000000000003, "RW", "cripg_clkgaten_stgdly", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{7, 7, 0x0000000000000000, "RO", "Reserved0", "Reserved"},
#else
{7, 7, 0x0000000000000000, "RO", "Reserved0", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{4, 6, 0x0000000000000001, "RW", "cripg_enable_stgdly", "Delay for staggered power gate enable. Determines the number of cycles interval between each power gate enable bit being asserted. Cripgctrl FSM is in PWRGATE state. A value of zero breaks the design resulting in an unresponsive powergating control."},
#else
{4, 6, 0x0000000000000001, "RW", "cripg_enable_stgdly", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{3, 3, 0x0000000000000000, "RO", "Reserved1", "Reserved"},
#else
{3, 3, 0x0000000000000000, "RO", "Reserved1", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 2, 0x0000000000000001, "RW", "cripg_disable_stgdly", "Delay for staggered power gate disable. Determines the number of cycles interval between each power gate enable bit being de-asserted. Cripgctrl FSM is in PWRUNGATE state. A value of zero breaks the design resulting in an unresponsive powergating control."},
#else
{0, 2, 0x0000000000000001, "RW", "cripg_disable_stgdly", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo734[] = {{"cripg_delay1", "", 0x0000000C, 6, 0x00000000FFFFFFFF, 0x0000000000000311}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields735[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{26, 31, 0x0000000000000000, "RO", "Reserved", "Reserved"},
#else
{26, 31, 0x0000000000000000, "RO", "Reserved", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{24, 25, 0x0000000000000002, "RW", "cripg_isol_en_dly", "No. of cycles after isolation cells are enabled/disabled before FSM moves on from ISOLEN/ISOLDIS. A value of zero breaks the design resulting in an unresponsive powergating control."},
#else
{24, 25, 0x0000000000000002, "RW", "cripg_isol_en_dly", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{23, 23, 0x0000000000000000, "RO", "Reserved0", "Reserved"},
#else
{23, 23, 0x0000000000000000, "RO", "Reserved0", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{20, 22, 0x0000000000000002, "RW", "cripg_rst_asrt_dly", "No. of cycles after staggered reset assertion/de-assertion before FSM moves on from RSTASRT/RSTDSRT. A value of zero breaks the design resulting in an unresponsive powergating control."},
#else
{20, 22, 0x0000000000000002, "RW", "cripg_rst_asrt_dly", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{19, 19, 0x0000000000000000, "RO", "Reserved1", "Reserved"},
#else
{19, 19, 0x0000000000000000, "RO", "Reserved1", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{16, 18, 0x0000000000000003, "RW", "cripg_ism_lock_dly", "No. of cycles after agent ism idle lock/unlock before FSM moves on from ISMLOCK/ISMUNLOCK. A value of zero breaks the design resulting in an unresponsive powergating control."},
#else
{16, 18, 0x0000000000000003, "RW", "cripg_ism_lock_dly", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{8, 15, 0x0000000000000003, "RW", "cripg_clkreq_dsrt_dly", "On wakeup, this indicates the no. of cycles that FSM stays in PWRUGCLKACK after receiving clkack. A value of zero breaks the design resulting in an unresponsive powergating control."},
#else
{8, 15, 0x0000000000000003, "RW", "cripg_clkreq_dsrt_dly", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 7, 0x0000000000000014, "RW", "cripg_ism_idle_dly", "When both fabric and agent ISMs are idle. This delay indicates the no. of cycle the FSMs need to be idle after receiving clkack before entering power gating flow. A value of zero breaks the design resulting in an unresponsive powergating control."},
#else
{0, 7, 0x0000000000000014, "RW", "cripg_ism_idle_dly", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo735[] = {{"cripg_delay0", "", 0x00000010, 8, 0x00000000FFFFFFFF, 0x0000000002230314}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields736[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{16, 31, 0x0000000000000000, "RO", "Reserved", "Reserved"},
#else
{16, 31, 0x0000000000000000, "RO", "Reserved", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{15, 15, 0x0000000000000000, "RW", "cripg_clkgaten_ovr", "Config control for side clock req. This config value is used to override o_side_clkreq. When this config bit is set to '1', o_side_clkreq is set to '1' except when in CLKREQDSRT state of the CRIPG FSM"},
#else
{15, 15, 0x0000000000000000, "RW", "cripg_clkgaten_ovr", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{14, 14, 0x0000000000000000, "RW", "cripg_side_clkreq_ovr", "Config control for side clock req. This config value is used to override o_side_clkreq. When this config bit is set to '1', o_side_clkreq is set to '1' except when in CLKREQDSRT state of the CRIPG FSM"},
#else
{14, 14, 0x0000000000000000, "RW", "cripg_side_clkreq_ovr", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{13, 13, 0x0000000000000000, "RW", "cripg_isolen", "Config control for isolation enable. This config value is used for isol_en when config override in cripg_isolen_ovr is set to '1'. This value is ignored if cripg_isolen_ovr is set to '0'."},
#else
{13, 13, 0x0000000000000000, "RW", "cripg_isolen", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{12, 12, 0x0000000000000000, "RW", "cripg_isolen_ovr", "Config override for isolation enable. This config value is used for isol_en when config override in cripg_isolen_ovr is set to '1'. This value is ignored if cripg_isolen_ovr is set to '0'."},
#else
{12, 12, 0x0000000000000000, "RW", "cripg_isolen_ovr", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{8, 11, 0x0000000000000000, "RO", "Reserved0", "Reserved"},
#else
{8, 11, 0x0000000000000000, "RO", "Reserved0", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{4, 7, 0x0000000000000000, "RW", "cripgen_staggered", "Config control for staggered power gate enable. This config value is used for the cripgen_staggered[3:0] when config override in cripgen_staggered_ovr is set to '1'. This value is ignored if cripgen_staggered_ovr is set to '0'."},
#else
{4, 7, 0x0000000000000000, "RW", "cripgen_staggered", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{1, 3, 0x0000000000000000, "RO", "Reserved1", "Reserved"},
#else
{1, 3, 0x0000000000000000, "RO", "Reserved1", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 0, 0x0000000000000000, "RW", "cripgen_staggered_ovr", "Config override for staggered power gate enable. When set to '1' cripgen_staggered[3:0] is equal to the value set in cripgen_staggered register field. When set to '0', cripgen_staggered[3:0] is equal to the logic defined value."},
#else
{0, 0, 0x0000000000000000, "RW", "cripgen_staggered_ovr", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo736[] = {{"cripgctl", "", 0x00000014, 9, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields737[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{1, 31, 0x0000000000000000, "RO", "Reserved", "Reserved"},
#else
{1, 31, 0x0000000000000000, "RO", "Reserved", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 0, 0x0000000000000000, "RW", "cripgen", "CRI Power Gating Enable. When set to '1' - CRI Power gating logic is enabled. When set to '0' - CRI Power gating logic is disabled."},
#else
{0, 0, 0x0000000000000000, "RW", "cripgen", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo737[] = {{"cripgen_ctl", "", 0x00000018, 2, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields738[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{10, 31, 0x0000000000000000, "RO", "Reserved", "Reserved"},
#else
{10, 31, 0x0000000000000000, "RO", "Reserved", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{8, 9, 0x0000000000000000, "RW", "func_mon_cmn_anaobssel", "Analog Observation Control"},
#else
{8, 9, 0x0000000000000000, "RW", "func_mon_cmn_anaobssel", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{4, 7, 0x0000000000000000, "RW", "func_mon_cmn_digobs1sel", "Digital Observation Control 1"},
#else
{4, 7, 0x0000000000000000, "RW", "func_mon_cmn_digobs1sel", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 3, 0x0000000000000000, "RW", "func_mon_cmn_digobs0sel", "Digital Observation Control 0"},
#else
{0, 3, 0x0000000000000000, "RW", "func_mon_cmn_digobs0sel", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo738[] = {{"obsctl0", "", 0x0000001C, 4, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields739[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{25, 31, 0x0000000000000000, "RO", "Reserved", "Reserved"},
#else
{25, 31, 0x0000000000000000, "RO", "Reserved", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{24, 24, 0x0000000000000000, "RO/V", "pll_cmn_errorflag", "PLL Error Flag"},
#else
{24, 24, 0x0000000000000000, "RO/V", "pll_cmn_errorflag", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{21, 23, 0x0000000000000000, "RO", "Reserved0", "Reserved"},
#else
{21, 23, 0x0000000000000000, "RO", "Reserved0", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{20, 20, 0x0000000000000000, "RW", "pll_cmn_anaobsen", "PLL Analog Observation Enable"},
#else
{20, 20, 0x0000000000000000, "RW", "pll_cmn_anaobsen", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{17, 19, 0x0000000000000000, "RO", "Reserved1", "Reserved"},
#else
{17, 19, 0x0000000000000000, "RO", "Reserved1", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{16, 16, 0x0000000000000000, "RW", "pll_cmn_digobsen", "PLL Digital Observation Enable"},
#else
{16, 16, 0x0000000000000000, "RW", "pll_cmn_digobsen", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{14, 15, 0x0000000000000000, "RO", "Reserved2", "Reserved"},
#else
{14, 15, 0x0000000000000000, "RO", "Reserved2", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{12, 13, 0x0000000000000000, "RW", "pll_cmn_anaobs1sel", "PLL Analog Observation Control 1"},
#else
{12, 13, 0x0000000000000000, "RW", "pll_cmn_anaobs1sel", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{10, 11, 0x0000000000000000, "RO", "Reserved3", "Reserved"},
#else
{10, 11, 0x0000000000000000, "RO", "Reserved3", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{8, 9, 0x0000000000000000, "RW", "pll_cmn_anaobs0sel", "PLL Analog Observation Control 0"},
#else
{8, 9, 0x0000000000000000, "RW", "pll_cmn_anaobs0sel", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{4, 7, 0x0000000000000000, "RW", "pll_cmn_digobs1sel", "PLL Digital Observation Control 1"},
#else
{4, 7, 0x0000000000000000, "RW", "pll_cmn_digobs1sel", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 3, 0x0000000000000000, "RW", "pll_cmn_digobs0sel", "PLL Digital Observation Control 0"},
#else
{0, 3, 0x0000000000000000, "RW", "pll_cmn_digobs0sel", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo739[] = {{"obsctl1", "", 0x00000020, 12, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields740[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{21, 31, 0x0000000000000000, "RO", "Reserved", "Reserved"},
#else
{21, 31, 0x0000000000000000, "RO", "Reserved", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{20, 20, 0x0000000000000001, "RW", "clken_on_gsp", "Clock enable / disable on global sync point boundary."},
#else
{20, 20, 0x0000000000000001, "RW", "clken_on_gsp", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{16, 19, 0x0000000000000000, "RW", "clken2clkack_dly", "Delay from clock enable to clock ack"},
#else
{16, 19, 0x0000000000000000, "RW", "clken2clkack_dly", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{12, 15, 0x0000000000000000, "RW", "clkreqdasrt2clkoff_dly", "Delay from CLKREQDSRT to clock off"},
#else
{12, 15, 0x0000000000000000, "RW", "clkreqdasrt2clkoff_dly", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{8, 11, 0x0000000000000000, "RW", "early_spidclkusync", "Early usync setting (with respect to global usync boundary)[br]2 : 2 clocks prior to global sync boundary[br]3 : 3 clocks prior to global sync boundary[br]and so on."},
#else
{8, 11, 0x0000000000000000, "RW", "early_spidclkusync", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{6, 7, 0x0000000000000000, "RO", "Reserved0", "Reserved"},
#else
{6, 7, 0x0000000000000000, "RO", "Reserved0", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 5, 0x0000000000000000, "RW", "usynccounter", "Counter value"},
#else
{0, 5, 0x0000000000000000, "RW", "usynccounter", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo740[] = {{"spidclkctl0", "", 0x00000024, 7, 0x00000000FFFFFFFF, 0x0000000000100000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields741[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{17, 31, 0x0000000000000000, "RO", "Reserved", "Reseved"},
#else
{17, 31, 0x0000000000000000, "RO", "Reserved", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{16, 16, 0x0000000000000000, "RW", "lpddr34mode", "LPDDR 3 / 4 Mode Indiication"},
#else
{16, 16, 0x0000000000000000, "RW", "lpddr34mode", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{14, 15, 0x0000000000000000, "RO", "Reserved0", "Reseved"},
#else
{14, 15, 0x0000000000000000, "RO", "Reserved0", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{13, 13, 0x0000000000000000, "RO/V", "ldomaindig_cmn_ldovccfarpwrgood", "When set, vccfar has converged to the target voltage and is ready to use."},
#else
{13, 13, 0x0000000000000000, "RO/V", "ldomaindig_cmn_ldovccfarpwrgood", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{12, 12, 0x0000000000000000, "RW", "ldomaindig_cmn_iolbtest", "LDO IOLB Test Enable"},
#else
{12, 12, 0x0000000000000000, "RW", "ldomaindig_cmn_iolbtest", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{8, 11, 0x0000000000000001, "RW", "ldomaindig_cmn_clockratio", "LDO Clock Ratio"},
#else
{8, 11, 0x0000000000000001, "RW", "ldomaindig_cmn_clockratio", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{7, 7, 0x0000000000000000, "RW", "ldomaindig_cmn_startldooffsetcomp", "LDO offset comp"},
#else
{7, 7, 0x0000000000000000, "RW", "ldomaindig_cmn_startldooffsetcomp", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{6, 6, 0x0000000000000001, "RW", "ldomaindig_cmn_dvfsfreqselect", "LDO Self Refresh Exit"},
#else
{6, 6, 0x0000000000000001, "RW", "ldomaindig_cmn_dvfsfreqselect", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{5, 5, 0x0000000000000000, "RW", "ldomaindig_cmn_selfrefreshexit", "LDO Self Refresh Exit"},
#else
{5, 5, 0x0000000000000000, "RW", "ldomaindig_cmn_selfrefreshexit", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{4, 4, 0x0000000000000000, "RW", "ldoffdig_cc_ldoiobufact", "LDO IO Bufact - CC"},
#else
{4, 4, 0x0000000000000000, "RW", "ldoffdig_cc_ldoiobufact", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{3, 3, 0x0000000000000000, "RW", "ldoffdig_bl_ldoiobufact", "LDO IO Bufact - BL"},
#else
{3, 3, 0x0000000000000000, "RW", "ldoffdig_bl_ldoiobufact", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{2, 2, 0x0000000000000001, "RW", "ldoffdig_cc_ldoffclkenable", "LDO FF Clock Enable - CC"},
#else
{2, 2, 0x0000000000000001, "RW", "ldoffdig_cc_ldoffclkenable", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{1, 1, 0x0000000000000001, "RW", "ldoffdig_bl_ldoffclkenable", "LDO FF Clock Enable - BL"},
#else
{1, 1, 0x0000000000000001, "RW", "ldoffdig_bl_ldoffclkenable", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 0, 0x0000000000000000, "RW", "pll_cmn_ldoclken", "LDO Clock Enable"},
#else
{0, 0, 0x0000000000000000, "RW", "pll_cmn_ldoclken", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo741[] = {{"ldoctl1", "", 0x00000028, 14, 0x00000000FFFFFFFF, 0x0000000000000146}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields742[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{1, 31, 0x0000000000000000, "RO", "Reserved", "Reserved"},
#else
{1, 31, 0x0000000000000000, "RO", "Reserved", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 0, 0x0000000000000000, "RW", "ldomaindig_cmn_ldoon", "LDO On"},
#else
{0, 0, 0x0000000000000000, "RW", "ldomaindig_cmn_ldoon", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo742[] = {{"ldoonctl", "", 0x0000002C, 2, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields743[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{1, 31, 0x0000000000000000, "RO", "Reserved", "Reserved"},
#else
{1, 31, 0x0000000000000000, "RO", "Reserved", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 0, 0x0000000000000000, "RW", "ldomaindig_cmn_ldodigrstb", "LDO Reset"},
#else
{0, 0, 0x0000000000000000, "RW", "ldomaindig_cmn_ldodigrstb", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo743[] = {{"ldorstctl", "", 0x00000030, 2, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields744[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{1, 31, 0x0000000000000000, "RO", "Reserved", "Reseved"},
#else
{1, 31, 0x0000000000000000, "RO", "Reserved", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 0, 0x0000000000000000, "RW", "lvug_isolen", "Isolation enable for LVUG to VNNUG crossing"},
#else
{0, 0, 0x0000000000000000, "RW", "lvug_isolen", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo744[] = {{"lvugsupplyctl0", "", 0x00000034, 2, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields745[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{1, 31, 0x0000000000000000, "RO", "Reserved", "Reserved"},
#else
{1, 31, 0x0000000000000000, "RO", "Reserved", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 0, 0x0000000000000000, "RW", "pm_pmrst_b", "PM module reset from config register"},
#else
{0, 0, 0x0000000000000000, "RW", "pm_pmrst_b", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo745[] = {{"dpic_pm_rstb", "", 0x00000100, 2, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields746[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{3, 31, 0x0000000000000000, "RO", "Reserved", "Reserved"},
#else
{3, 31, 0x0000000000000000, "RO", "Reserved", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{2, 2, 0x0000000000000000, "RW", "pm_vccapwronstaggered_ovr", "PWR VCCA On Staggered Override"},
#else
{2, 2, 0x0000000000000000, "RW", "pm_vccapwronstaggered_ovr", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{1, 1, 0x0000000000000000, "RW", "pm_vnnapwronstaggered_ovr", "PWR VNNA On Staggered Override"},
#else
{1, 1, 0x0000000000000000, "RW", "pm_vnnapwronstaggered_ovr", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 0, 0x0000000000000000, "RW", "pm_isolen_ovr", "Isolation Override"},
#else
{0, 0, 0x0000000000000000, "RW", "pm_isolen_ovr", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo746[] = {{"dpic_pm_pgovr", "", 0x00000104, 4, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields747[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{30, 31, 0x0000000000000000, "RO", "Reserved", "Reserved"},
#else
{30, 31, 0x0000000000000000, "RO", "Reserved", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{29, 29, 0x0000000000000000, "RW", "pm_dllcomp_clkgate_ovr", "dll comp clak gate overiride"},
#else
{29, 29, 0x0000000000000000, "RW", "pm_dllcomp_clkgate_ovr", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{28, 28, 0x0000000000000000, "RW", "pm_ref2xph0_ovr", "ref2x phase 0 override"},
#else
{28, 28, 0x0000000000000000, "RW", "pm_ref2xph0_ovr", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{27, 27, 0x0000000000000000, "RW", "pm_ref2xrstb_ovr", "ref2xrstb override"},
#else
{27, 27, 0x0000000000000000, "RW", "pm_ref2xrstb_ovr", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{26, 26, 0x0000000000000000, "RW", "vcca_sel", "Select VCCA mode of operation"},
#else
{26, 26, 0x0000000000000000, "RW", "vcca_sel", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{25, 25, 0x0000000000000000, "RW", "pswitch_cmn_vccapwron", "Power mux (ungated): Enable VCCA"},
#else
{25, 25, 0x0000000000000000, "RW", "pswitch_cmn_vccapwron", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{24, 24, 0x0000000000000001, "RW", "pswitch_cmn_vnnpwron", "Power mux (ungated): Enable VNN"},
#else
{24, 24, 0x0000000000000001, "RW", "pswitch_cmn_vnnpwron", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{16, 23, 0x0000000000000000, "RW", "pm_vccapwronstaggered", "PWR VCCA On Staggered value"},
#else
{16, 23, 0x0000000000000000, "RW", "pm_vccapwronstaggered", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{8, 15, 0x00000000000000FF, "RW", "pm_vnnapwronstaggered", "PWR VNNA On Staggered value"},
#else
{8, 15, 0x00000000000000FF, "RW", "pm_vnnapwronstaggered", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{7, 7, 0x0000000000000000, "RO", "Reserved0", "Reserved"},
#else
{7, 7, 0x0000000000000000, "RO", "Reserved0", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{6, 6, 0x0000000000000000, "RW", "pm_clkgateen_ovr", "Clock Gate Override"},
#else
{6, 6, 0x0000000000000000, "RW", "pm_clkgateen_ovr", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{5, 5, 0x0000000000000000, "RW", "pm_isolen", "Isolation Enable Value"},
#else
{5, 5, 0x0000000000000000, "RW", "pm_isolen", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{4, 4, 0x0000000000000000, "RW", "pm_diffampenable_ovr", "DIFFAMP Enable Overide"},
#else
{4, 4, 0x0000000000000000, "RW", "pm_diffampenable_ovr", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{3, 3, 0x0000000000000000, "RW", "pm_iobufact_ovr", "IOBUFACT Override"},
#else
{3, 3, 0x0000000000000000, "RW", "pm_iobufact_ovr", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{2, 2, 0x0000000000000000, "RW", "pm_ckdll_sdllen_ovr", "SDLL Enable Override"},
#else
{2, 2, 0x0000000000000000, "RW", "pm_ckdll_sdllen_ovr", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{1, 1, 0x0000000000000000, "RW", "pm_adpllen_ovr", "ADPLL Enable Override"},
#else
{1, 1, 0x0000000000000000, "RW", "pm_adpllen_ovr", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 0, 0x0000000000000000, "RW", "pm_adpll_sfron_ovr", "SFR On Override"},
#else
{0, 0, 0x0000000000000000, "RW", "pm_adpll_sfron_ovr", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo747[] = {{"dpic_pm_config0", "", 0x00000108, 17, 0x00000000FFFFFFFF, 0x000000000100FF00}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields748[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{20, 31, 0x0000000000000000, "RO", "Reserved", "Reserved"},
#else
{20, 31, 0x0000000000000000, "RO", "Reserved", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{19, 19, 0x0000000000000000, "RW/1S/V", "pm_hvm_req", "HVM Request"},
#else
{19, 19, 0x0000000000000000, "RW/1S/V", "pm_hvm_req", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{15, 18, 0x0000000000000004, "RW", "pm_hvm_delay", "Delay between power off and power on in hvm mode"},
#else
{15, 18, 0x0000000000000004, "RW", "pm_hvm_delay", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{14, 14, 0x0000000000000000, "RW", "pm_stagger_bits_sel", "0 for 2 bit stagger ata time sel and 1 for 1 bit stagger at a time"},
#else
{14, 14, 0x0000000000000000, "RW", "pm_stagger_bits_sel", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{13, 13, 0x0000000000000000, "RW", "pm_ldopg_pwron_ovr", "LDO Power On Override"},
#else
{13, 13, 0x0000000000000000, "RW", "pm_ldopg_pwron_ovr", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{12, 12, 0x0000000000000000, "RW", "pm_spidclkenovrride", "SPID Clock Override"},
#else
{12, 12, 0x0000000000000000, "RW", "pm_spidclkenovrride", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{11, 11, 0x0000000000000000, "RW", "pm_adpllouten_ovr", "ADPLL-Out Output Enable Override"},
#else
{11, 11, 0x0000000000000000, "RW", "pm_adpllouten_ovr", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{10, 10, 0x0000000000000000, "RW", "pm_vrefiobufact_ovr", "VREF IO BUFACT Overide"},
#else
{10, 10, 0x0000000000000000, "RW", "pm_vrefiobufact_ovr", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{9, 9, 0x0000000000000000, "RW", "pm_vrefen_ovr", "VREFEN  Overide value"},
#else
{9, 9, 0x0000000000000000, "RW", "pm_vrefen_ovr", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{8, 8, 0x0000000000000000, "RW", "pm_dqrxfiforstb_ovr", "DQRX FIFO Reset Override"},
#else
{8, 8, 0x0000000000000000, "RW", "pm_dqrxfiforstb_ovr", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{7, 7, 0x0000000000000000, "RW", "pm_pien_ovr", "PI Enable Override"},
#else
{7, 7, 0x0000000000000000, "RW", "pm_pien_ovr", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{6, 6, 0x0000000000000000, "RW", "pm_wrptren_ovr", "Write Pointer Enable Override"},
#else
{6, 6, 0x0000000000000000, "RW", "pm_wrptren_ovr", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{5, 5, 0x0000000000000000, "RW", "pm_clkdll_floprstb_ovr", "Clock DLL Flop Reset Override"},
#else
{5, 5, 0x0000000000000000, "RW", "pm_clkdll_floprstb_ovr", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{4, 4, 0x0000000000000000, "RW", "pm_clkdll_floprstb", "Clock DLL Flop Reset Value"},
#else
{4, 4, 0x0000000000000000, "RW", "pm_clkdll_floprstb", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{3, 3, 0x0000000000000000, "RW", "pm_pg2xrst_b_ovr", "2x Reset Override"},
#else
{3, 3, 0x0000000000000000, "RW", "pm_pg2xrst_b_ovr", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{2, 2, 0x0000000000000000, "RW", "pm_pg2xrst_b", "2x Reset Value"},
#else
{2, 2, 0x0000000000000000, "RW", "pm_pg2xrst_b", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{1, 1, 0x0000000000000000, "RO/V", "pm_adpll_lock", "PM adpll lock"},
#else
{1, 1, 0x0000000000000000, "RO/V", "pm_adpll_lock", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 0, 0x0000000000000000, "RW", "pm_comp_en_ovr", "COMP Enable Overide"},
#else
{0, 0, 0x0000000000000000, "RW", "pm_comp_en_ovr", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo748[] = {{"dpic_pm_config1", "", 0x0000010C, 18, 0x00000000FFFFFFFF, 0x0000000000020000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields749[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{1, 31, 0x0000000000000000, "RO", "Reserved", "Reserved"},
#else
{1, 31, 0x0000000000000000, "RO", "Reserved", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 0, 0x0000000000000001, "RW", "pmclk_clkreq", "clk request"},
#else
{0, 0, 0x0000000000000001, "RW", "pmclk_clkreq", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo749[] = {{"dpic_pm_clkreq", "", 0x00000110, 2, 0x00000000FFFFFFFF, 0x0000000000000001}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields750[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{28, 31, 0x0000000000000000, "RO", "Reserved", "Reserved"},
#else
{28, 31, 0x0000000000000000, "RO", "Reserved", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{24, 27, 0x0000000000000000, "RW", "pm_acktime", "Wait timer for the message interface to provide delay before ack/nack is aaserted or deaaserted"},
#else
{24, 27, 0x0000000000000000, "RW", "pm_acktime", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{16, 23, 0x0000000000000001, "RW", "pm_iobufact_dly", "Delay to assert/de-assert IO BUFFER ACTIVATE"},
#else
{16, 23, 0x0000000000000001, "RW", "pm_iobufact_dly", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{12, 15, 0x0000000000000000, "RW", "pm_dllcompcg_enable_dly", "dllcomp clock enable  gate delay"},
#else
{12, 15, 0x0000000000000000, "RW", "pm_dllcompcg_enable_dly", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{8, 11, 0x0000000000000000, "RW", "pm_ref2xph0_enable_dly", "ref2x phase 0 enable delay"},
#else
{8, 11, 0x0000000000000000, "RW", "pm_ref2xph0_enable_dly", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{4, 7, 0x0000000000000000, "RW", "pm_dllcompcg_disable_dly", "dllcomp clock disable  gate delay"},
#else
{4, 7, 0x0000000000000000, "RW", "pm_dllcompcg_disable_dly", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 3, 0x0000000000000000, "RW", "pm_ref2xph0_disable_dly", "ref2x phase 0 disble delay"},
#else
{0, 3, 0x0000000000000000, "RW", "pm_ref2xph0_disable_dly", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo750[] = {{"dpic_pm_delay0", "", 0x00000114, 7, 0x00000000FFFFFFFF, 0x0000000000010000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields751[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{24, 31, 0x0000000000000002, "RW", "pm_wrptr_enable_dly", "Delay to turn on the PI's associated with the wrptr in each module"},
#else
{24, 31, 0x0000000000000002, "RW", "pm_wrptr_enable_dly", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{16, 23, 0x0000000000000004, "RW", "pm_sdll_enable_dly", "Delay to turn on the PI's associated with the DLLs in each module"},
#else
{16, 23, 0x0000000000000004, "RW", "pm_sdll_enable_dly", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 15, 0x0000000000000190, "RW", "pm_comp_enable_dly", "Comp enable delay in PM clocks"},
#else
{0, 15, 0x0000000000000190, "RW", "pm_comp_enable_dly", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo751[] = {{"dpic_pm_delay1", "", 0x00000118, 3, 0x00000000FFFFFFFF, 0x0000000002040190}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields752[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{16, 31, 0x00000000000000C8, "RW", "pm_adpll_sfron_dly", "Delay after which the pmseq state machine moves from adpll_sfron state to adpll_on_hs state"},
#else
{16, 31, 0x00000000000000C8, "RW", "pm_adpll_sfron_dly", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{8, 15, 0x0000000000000002, "RW", "pm_wrptr_disable_dly", "Delay to turn off the PI's associated with the wrptr in each module"},
#else
{8, 15, 0x0000000000000002, "RW", "pm_wrptr_disable_dly", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 7, 0x0000000000000002, "RW", "pm_sdll_disable_dly", "Delay to turn off the PI's associated with the DLLs in each module"},
#else
{0, 7, 0x0000000000000002, "RW", "pm_sdll_disable_dly", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo752[] = {{"dpic_pm_delay2", "", 0x0000011C, 3, 0x00000000FFFFFFFF, 0x0000000000C80202}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields753[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{16, 31, 0x0000000000000000, "RW", "pm_comp_disable_dly", "Comp disable delay in PM clocks"},
#else
{16, 31, 0x0000000000000000, "RW", "pm_comp_disable_dly", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 15, 0x0000000000000000, "RW", "pm_adpll_sfroff_dly", "Delay after which the pmseq state machine moves from dis_comp state to adpll_off_hs state"},
#else
{0, 15, 0x0000000000000000, "RW", "pm_adpll_sfroff_dly", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo753[] = {{"dpic_pm_delay3", "", 0x00000120, 2, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields754[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{28, 31, 0x0000000000000000, "RO", "Reserved", "Reserved"},
#else
{28, 31, 0x0000000000000000, "RO", "Reserved", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{20, 27, 0x000000000000000A, "RW", "pm_pg_disable_stgdly", "Delay between each power un-gating stagger FSM state transition"},
#else
{20, 27, 0x000000000000000A, "RW", "pm_pg_disable_stgdly", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{12, 19, 0x000000000000000A, "RW", "pm_pg_enable_stgdly", "Delay between each power gating stagger FSM state transition"},
#else
{12, 19, 0x000000000000000A, "RW", "pm_pg_enable_stgdly", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{8, 11, 0x0000000000000002, "RW", "pm_isol2pgdly", "Delay for the isolate and un-isolate"},
#else
{8, 11, 0x0000000000000002, "RW", "pm_isol2pgdly", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{4, 7, 0x0000000000000000, "RO", "Reserved0", "Reserved"},
#else
{4, 7, 0x0000000000000000, "RO", "Reserved0", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 3, 0x0000000000000004, "RW", "pm_clkgate_wait_timer", "Delay for the clock gate or clock ungate"},
#else
{0, 3, 0x0000000000000004, "RW", "pm_clkgate_wait_timer", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo754[] = {{"dpic_pm_delay4", "", 0x00000124, 6, 0x00000000FFFFFFFF, 0x0000000000A0A204}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields755[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{24, 31, 0x0000000000000004, "RW", "pm_pg2xrstb_enable_dly", "Delay to deassert pg2xrstb"},
#else
{24, 31, 0x0000000000000004, "RW", "pm_pg2xrstb_enable_dly", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{16, 23, 0x0000000000000004, "RW", "pm_pg2xrstb_disable_dly", "Delay to assert pg2xrst_b"},
#else
{16, 23, 0x0000000000000004, "RW", "pm_pg2xrstb_disable_dly", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{8, 15, 0x0000000000000004, "RW", "pm_pgphyrstb_enable_dly", "Delay to deassert pgphyrst_b"},
#else
{8, 15, 0x0000000000000004, "RW", "pm_pgphyrstb_enable_dly", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 7, 0x0000000000000004, "RW", "pm_pgphyrstb_disable_dly", "Delay to assert pgphyrst_d"},
#else
{0, 7, 0x0000000000000004, "RW", "pm_pgphyrstb_disable_dly", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo755[] = {{"dpic_pm_delay5", "", 0x00000128, 4, 0x00000000FFFFFFFF, 0x0000000004040404}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields756[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{30, 31, 0x0000000000000000, "RO", "Reserved", "Reserved"},
#else
{30, 31, 0x0000000000000000, "RO", "Reserved", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{24, 29, 0x0000000000000000, "RO", "Reserved0", "Reserved"},
#else
{24, 29, 0x0000000000000000, "RO", "Reserved0", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{12, 23, 0x0000000000000004, "RW", "pm_vrefiobufact_enable_dly", "Delay after vrefiobufact set to 1"},
#else
{12, 23, 0x0000000000000004, "RW", "pm_vrefiobufact_enable_dly", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 11, 0x0000000000000004, "RW", "pm_vrefiobufact_disable_dly", "Delay after vrefiobufact set to 0"},
#else
{0, 11, 0x0000000000000004, "RW", "pm_vrefiobufact_disable_dly", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo756[] = {{"dpic_pm_delay6", "", 0x0000012C, 4, 0x00000000FFFFFFFF, 0x0000000000004004}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields757[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{30, 31, 0x0000000000000000, "RO", "Reserved", "Reserved"},
#else
{30, 31, 0x0000000000000000, "RO", "Reserved", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{24, 29, 0x0000000000000000, "RO", "Reserved0", "Reserved"},
#else
{24, 29, 0x0000000000000000, "RO", "Reserved0", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{12, 23, 0x0000000000000004, "RW", "pm_vrefen_enable_dly", "Delay after vrefen set to 1"},
#else
{12, 23, 0x0000000000000004, "RW", "pm_vrefen_enable_dly", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 11, 0x0000000000000004, "RW", "pm_vrefen_disable_dly", "Delay after vrefen set to 0"},
#else
{0, 11, 0x0000000000000004, "RW", "pm_vrefen_disable_dly", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo757[] = {{"dpic_pm_delay7", "", 0x00000130, 4, 0x00000000FFFFFFFF, 0x0000000000004004}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields758[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{25, 31, 0x0000000000000000, "RO", "reserved500", "Reserved"},
#else
{25, 31, 0x0000000000000000, "RO", "reserved500", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{22, 24, 0x0000000000000002, "RW", "pm_ref2xrstb_enable_dly", "enable ref2xrstb"},
#else
{22, 24, 0x0000000000000002, "RW", "pm_ref2xrstb_enable_dly", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{19, 21, 0x0000000000000002, "RW", "pm_ref2xrstb_disable_dly", "disable ref2xrstb"},
#else
{19, 21, 0x0000000000000002, "RW", "pm_ref2xrstb_disable_dly", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{11, 18, 0x0000000000000000, "RW", "pm_disable_ldopg_dly", "Enable LDO Power gate delay"},
#else
{11, 18, 0x0000000000000000, "RW", "pm_disable_ldopg_dly", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{8, 10, 0x0000000000000000, "RW", "pm_disable_isol_dly", "Enable LDO isol dleay"},
#else
{8, 10, 0x0000000000000000, "RW", "pm_disable_isol_dly", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{4, 7, 0x0000000000000000, "RW", "pm_disable_ldovref_dly", "Enable LDO vref delay"},
#else
{4, 7, 0x0000000000000000, "RW", "pm_disable_ldovref_dly", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 3, 0x0000000000000000, "RW", "pm_pien_dly", "Enable PI delay"},
#else
{0, 3, 0x0000000000000000, "RW", "pm_pien_dly", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo758[] = {{"dpic_pm_delay8", "", 0x00000134, 7, 0x00000000FFFFFFFF, 0x0000000000900000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields759[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{24, 31, 0x0000000000000000, "RO", "reserved501", "Reserved"},
#else
{24, 31, 0x0000000000000000, "RO", "reserved501", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{23, 23, 0x0000000000000000, "RW", "pm_ldoselfrefreshexit", "LDO Self Refresh Exit Override"},
#else
{23, 23, 0x0000000000000000, "RW", "pm_ldoselfrefreshexit", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{19, 22, 0x0000000000000000, "RW", "pm_enable_ldopg_dly", "Disable LDO Power gate delay"},
#else
{19, 22, 0x0000000000000000, "RW", "pm_enable_ldopg_dly", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{16, 18, 0x0000000000000000, "RW", "pm_enable_isol_dly", "Disable LDO isol dleay"},
#else
{16, 18, 0x0000000000000000, "RW", "pm_enable_isol_dly", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 15, 0x0000000000000000, "RW", "pm_enable_ldovref_dly", "Disable LDO vref delay"},
#else
{0, 15, 0x0000000000000000, "RW", "pm_enable_ldovref_dly", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo759[] = {{"dpic_pm_delay9", "", 0x00000138, 5, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields760[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{1, 31, 0x0000000000000000, "RO", "Reserved", "Reserved"},
#else
{1, 31, 0x0000000000000000, "RO", "Reserved", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 0, 0x0000000000000000, "RW", "pm_clkgateen", "Clock Gate Enable"},
#else
{0, 0, 0x0000000000000000, "RW", "pm_clkgateen", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo760[] = {{"dpic_pm_clkgate", "", 0x0000013C, 2, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields761[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{27, 31, 0x0000000000000004, "RW", "hvm_pmmsg", "HVM PM Message"},
#else
{27, 31, 0x0000000000000004, "RW", "hvm_pmmsg", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{16, 26, 0x0000000000000000, "RO", "Reserved", "Reserved"},
#else
{16, 26, 0x0000000000000000, "RO", "Reserved", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{11, 15, 0x0000000000000000, "RO/V", "pm_cfg_status", "State of Power Management logic. [4]: busy. [3:0] : PM state"},
#else
{11, 15, 0x0000000000000000, "RO/V", "pm_cfg_status", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{8, 10, 0x0000000000000000, "RO", "Reserved0", "Reserved"},
#else
{8, 10, 0x0000000000000000, "RO", "Reserved0", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{7, 7, 0x0000000000000000, "RO/V", "pmclk_ack", "PM clock ack"},
#else
{7, 7, 0x0000000000000000, "RO/V", "pmclk_ack", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{6, 6, 0x0000000000000000, "RO/V", "pm_sw_ack", "PM software acknowledge"},
#else
{6, 6, 0x0000000000000000, "RO/V", "pm_sw_ack", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{5, 5, 0x0000000000000000, "RW/1S/V", "pm_sw_req", "Config based Power Management Message Request"},
#else
{5, 5, 0x0000000000000000, "RW/1S/V", "pm_sw_req", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 4, 0x0000000000000000, "RW", "pm_sw_msg", "Config based Power Management Message"},
#else
{0, 4, 0x0000000000000000, "RW", "pm_sw_msg", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo761[] = {{"dpic_pmswmsg", "", 0x00000140, 8, 0x00000000FFFFFFFF, 0x0000000020000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields762[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{30, 31, 0x0000000000000000, "RO", "Reserved", "Reserved bits"},
#else
{30, 31, 0x0000000000000000, "RO", "Reserved", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{24, 29, 0x0000000000000000, "RW", "comp_rcomp_pu_live_override", "override for pull up live rcomp code going to AFE"},
#else
{24, 29, 0x0000000000000000, "RW", "comp_rcomp_pu_live_override", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{23, 23, 0x0000000000000000, "RW", "comp_rcomp_pu_live_override_en", "override enable for override for pull up live rcomp code going to AFE"},
#else
{23, 23, 0x0000000000000000, "RW", "comp_rcomp_pu_live_override_en", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{21, 22, 0x0000000000000000, "RW", "gcomp_cmn_digobs0_sel", "Select for digital observation mux 0 (grcomp)"},
#else
{21, 22, 0x0000000000000000, "RW", "gcomp_cmn_digobs0_sel", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{19, 20, 0x0000000000000000, "RW", "gcomp_cmn_digobs1_sel", "Select for digital observation mux 1 (grcomp)"},
#else
{19, 20, 0x0000000000000000, "RW", "gcomp_cmn_digobs1_sel", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{18, 18, 0x0000000000000000, "RW", "gcomp_cmn_obsen", "digital observation enable (grcomp)"},
#else
{18, 18, 0x0000000000000000, "RW", "gcomp_cmn_obsen", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{10, 17, 0x0000000000000000, "RO", "Reserved0", "Reserved bits"},
#else
{10, 17, 0x0000000000000000, "RO", "Reserved0", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 9, 0x0000000000000000, "RO", "Reserved1", "Reserved bits"},
#else
{0, 9, 0x0000000000000000, "RO", "Reserved1", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo762[] = {{"dpic_grcomp_ovr", "", 0x00000300, 8, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields763[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{27, 31, 0x0000000000000000, "RO", "Reserved", "Reserved bits"},
#else
{27, 31, 0x0000000000000000, "RO", "Reserved", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{21, 26, 0x0000000000000000, "RW", "rcomp_general_timer", "Not used in design."},
#else
{21, 26, 0x0000000000000000, "RW", "rcomp_general_timer", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{1, 20, 0x0000000000007D00, "RW", "rcomp_wakeup_period", "this tells a timer to start the periodic comp cycle when this number of cycles are completed. Usually this is programmed to 'h7d00 for a 4us delay between two periodic comp cycles."},
#else
{1, 20, 0x0000000000007D00, "RW", "rcomp_wakeup_period", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 0, 0x0000000000000000, "RW", "rcomp_pu_staticlive", "static leg signal for the AFE"},
#else
{0, 0, 0x0000000000000000, "RW", "rcomp_pu_staticlive", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo763[] = {{"dpic_grcomp_ctl", "", 0x00000304, 4, 0x00000000FFFFFFFF, 0x000000000000FA00}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields764[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{25, 31, 0x0000000000000000, "RO", "Reserved", "Reserved bits"},
#else
{25, 31, 0x0000000000000000, "RO", "Reserved", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{9, 24, 0x0000000000000000, "RW", "lrcomp_spare", "Bonus configs"},
#else
{9, 24, 0x0000000000000000, "RW", "lrcomp_spare", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{7, 8, 0x0000000000000000, "RW", "lrcomp_cmn_digobs0sel", "Select for digital observation mux 0 (lrcomp)"},
#else
{7, 8, 0x0000000000000000, "RW", "lrcomp_cmn_digobs0sel", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{5, 6, 0x0000000000000000, "RW", "lrcomp_cmn_digobs1sel", "Select for digital observation mux 1 (lrcomp)"},
#else
{5, 6, 0x0000000000000000, "RW", "lrcomp_cmn_digobs1sel", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{4, 4, 0x0000000000000000, "RW", "lrcomp_cmn_obsen", "digital observation enable  (lrcomp)"},
#else
{4, 4, 0x0000000000000000, "RW", "lrcomp_cmn_obsen", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 3, 0x0000000000000000, "RW", "lrcomp_cmn_ibonus", "Bonus configs"},
#else
{0, 3, 0x0000000000000000, "RW", "lrcomp_cmn_ibonus", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo764[] = {{"dpic_lrcomp_debug", "", 0x00000500, 6, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields765[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{17, 31, 0x0000000000000000, "RO", "Reserved", "Reserved"},
#else
{17, 31, 0x0000000000000000, "RO", "Reserved", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{16, 16, 0x0000000000000000, "RW", "dfxlowervisaulm0_bypass", "VISA Lower Level Bypass ULM0"},
#else
{16, 16, 0x0000000000000000, "RW", "dfxlowervisaulm0_bypass", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{8, 15, 0x0000000000000000, "RW", "dfxlowervisaulm0_clksel", "VISA Lower Level ULM0 CLK Select"},
#else
{8, 15, 0x0000000000000000, "RW", "dfxlowervisaulm0_clksel", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 7, 0x0000000000000000, "RW", "dfxlowervisaulm0_datasel", "VISA Lower Level ULM0 Lane (DATA) Select"},
#else
{0, 7, 0x0000000000000000, "RW", "dfxlowervisaulm0_datasel", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo765[] = {{"lower_dfxvisaulm0", "", 0x00000700, 4, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields766[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{17, 31, 0x0000000000000000, "RO", "Reserved", "Reserved"},
#else
{17, 31, 0x0000000000000000, "RO", "Reserved", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{16, 16, 0x0000000000000000, "RW", "dfxlowervisaulm1_bypass", "VISA Lower Level Bypass ULM1"},
#else
{16, 16, 0x0000000000000000, "RW", "dfxlowervisaulm1_bypass", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{8, 15, 0x0000000000000000, "RW", "dfxlowervisaulm1_clksel", "VISA Lower Level ULM1 CLK Select"},
#else
{8, 15, 0x0000000000000000, "RW", "dfxlowervisaulm1_clksel", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 7, 0x0000000000000000, "RW", "dfxlowervisaulm1_datasel", "VISA Lower Level ULM1 Lane (DATA) Select"},
#else
{0, 7, 0x0000000000000000, "RW", "dfxlowervisaulm1_datasel", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo766[] = {{"lower_dfxvisaulm1", "", 0x00000704, 4, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields767[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{7, 31, 0x0000000000000000, "RO", "Reserved", "Reserved"},
#else
{7, 31, 0x0000000000000000, "RO", "Reserved", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{4, 6, 0x0000000000000000, "RW", "dfxlowervisapattgen_msb", "VISA Lower Level ULM Pattern Generation"},
#else
{4, 6, 0x0000000000000000, "RW", "dfxlowervisapattgen_msb", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 3, 0x0000000000000000, "RW", "dfxlowervisapattgen_lsb", "VISA Lower Level ULM Pattern Generation"},
#else
{0, 3, 0x0000000000000000, "RW", "dfxlowervisapattgen_lsb", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo767[] = {{"lower_dfxvisapattgen", "", 0x00000708, 3, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields768[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{17, 31, 0x0000000000000000, "RO", "Reserved", "Reserved"},
#else
{17, 31, 0x0000000000000000, "RO", "Reserved", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{16, 16, 0x0000000000000000, "RW", "dfxtopvisaulm0_bypass", "VISA Top Level Bypass ULM0"},
#else
{16, 16, 0x0000000000000000, "RW", "dfxtopvisaulm0_bypass", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{8, 15, 0x0000000000000000, "RW", "dfxtopvisaulm0_clksel", "VISA Top Level ULM0 CLK Select"},
#else
{8, 15, 0x0000000000000000, "RW", "dfxtopvisaulm0_clksel", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 7, 0x0000000000000000, "RW", "dfxtopvisaulm0_datasel", "VISA Top Level ULM0 Lane (DATA) Select"},
#else
{0, 7, 0x0000000000000000, "RW", "dfxtopvisaulm0_datasel", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo768[] = {{"top_dfxvisaulm0", "", 0x0000070C, 4, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields769[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{17, 31, 0x0000000000000000, "RO", "Reserved", "Reserved"},
#else
{17, 31, 0x0000000000000000, "RO", "Reserved", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{16, 16, 0x0000000000000000, "RW", "dfxtopvisaulm1_bypass", "VISA Top Level Bypass ULM1"},
#else
{16, 16, 0x0000000000000000, "RW", "dfxtopvisaulm1_bypass", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{8, 15, 0x0000000000000000, "RW", "dfxtopvisaulm1_clksel", "VISA Top Level ULM1 CLK Select"},
#else
{8, 15, 0x0000000000000000, "RW", "dfxtopvisaulm1_clksel", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 7, 0x0000000000000000, "RW", "dfxtopvisaulm1_datasel", "VISA Top Level ULM1 Lane (DATA) Select"},
#else
{0, 7, 0x0000000000000000, "RW", "dfxtopvisaulm1_datasel", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo769[] = {{"top_dfxvisaulm1", "", 0x00000710, 4, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields770[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{7, 31, 0x0000000000000000, "RO", "Reserved", "Reserved"},
#else
{7, 31, 0x0000000000000000, "RO", "Reserved", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{4, 6, 0x0000000000000000, "RW", "dfxtopvisapattgen_msb", "VISA Top Level ULM Pattern Generation"},
#else
{4, 6, 0x0000000000000000, "RW", "dfxtopvisapattgen_msb", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 3, 0x0000000000000000, "RW", "dfxtopvisapattgen_lsb", "VISA Top Level ULM Pattern Generation"},
#else
{0, 3, 0x0000000000000000, "RW", "dfxtopvisapattgen_lsb", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo770[] = {{"top_dfxvisapattgen", "", 0x00000714, 3, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields771[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{0, 31, 0x0000000000000000, "RW", "Data", "Test register to create WIO2PHY boxtype."},
#else
{0, 31, 0x0000000000000000, "RW", "Data", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo771[] = {{"TEST", "", 0x00000000, 1, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields772[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{23, 31, 0x0000000000000000, "RO", "RESERVED_0", "Reserved"},
#else
{23, 31, 0x0000000000000000, "RO", "RESERVED_0", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{2, 22, 0x0000000000000000, "RW/V", "REGGTO", "This field selects any one of the DWORD registers within the MMIO register space of Device 2 if the target is MMIO Registers.  This field selects a GTT offset if the target is the GTT."},
#else
{2, 22, 0x0000000000000000, "RW/V", "REGGTO", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 1, 0x0000000000000000, "RW/V", "TARG", "00: MMIO Registers  01: GTT  1X: Reserved"},
#else
{0, 1, 0x0000000000000000, "RW/V", "TARG", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo772[] = {{"B_CR_INDEX_0_2_0_IOBAR", "", 0x00000000, 3, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields773[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{5, 7, 0x0000000000000000, "RO", "RESERVED_0", "Reserved"},
#else
{5, 7, 0x0000000000000000, "RO", "RESERVED_0", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{4, 4, 0x0000000000000000, "RW/V", "VGAGR10", "Page mode enable  0: VGA mode  1: Page mode"},
#else
{4, 4, 0x0000000000000000, "RW/V", "VGAGR10", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{2, 3, 0x0000000000000000, "RW/V", "VGAGR6", "select for VGA memory space  00: 0xA_0000-0xB_FFFF  01: 0xA_0000-0xA_FFFF  10: 0xB_0000-0xB_7FFF  11: 0xB_0000-0xB_FFFF"},
#else
{2, 3, 0x0000000000000000, "RW/V", "VGAGR6", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{1, 1, 0x0000000000000000, "RW/V", "VGAMSR1", "Controls memory access not IO  0: VGA memory access is disabled  1: VGA memory access is enabled"},
#else
{1, 1, 0x0000000000000000, "RW/V", "VGAMSR1", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 0, 0x0000000000000000, "RW/V", "VGAMSR0", "Selects the IO space  0: 3Bx mode mono  1: 3Dx mode color"},
#else
{0, 0, 0x0000000000000000, "RW/V", "VGAMSR0", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo773[] = {{"B_CR_VGADEC_0_2_0_VGABAR", "", 0x00000000, 5, 0x00000000000000FF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields774[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{11, 15, 0x0000000000000000, "RO", "RESERVED_0", "Reserved"},
#else
{11, 15, 0x0000000000000000, "RO", "RESERVED_0", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{10, 10, 0x0000000000000000, "RW/V", "INTDIS", "This bit disables the device from asserting INTx.  0: Enable the assertion of this devices INTx signal.  1: Disable the assertion of this devices INTx signal. DO_INTx messages will not be sent to DMI.  INTERNAL INTEL ONLY:GSA Implementation: When 1 blocks sending of Line interrupts. The interrupt status is not blocked from being reflected in the INTSTS bit."},
#else
{10, 10, 0x0000000000000000, "RW/V", "INTDIS", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{9, 9, 0x0000000000000000, "RO", "FB2B", "Not Implemented. Hardwired to 0."},
#else
{9, 9, 0x0000000000000000, "RO", "FB2B", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{8, 8, 0x0000000000000000, "RO", "SEN", "Not Implemented. Hardwired to 0."},
#else
{8, 8, 0x0000000000000000, "RO", "SEN", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{7, 7, 0x0000000000000000, "RO", "WCC", "Not Implemented. Hardwired to 0."},
#else
{7, 7, 0x0000000000000000, "RO", "WCC", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{6, 6, 0x0000000000000000, "RO", "PER", "Not Implemented. Hardwired to 0. Since the IGD belongs to the category of devices that does not corrupt programs or data in system memory or hard drives the IGD ignores any parity error that it detects and continues with normal operation."},
#else
{6, 6, 0x0000000000000000, "RO", "PER", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{5, 5, 0x0000000000000000, "RO", "VPS", "This bit is hardwired to 0 to disable snooping."},
#else
{5, 5, 0x0000000000000000, "RO", "VPS", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{4, 4, 0x0000000000000000, "RO", "MWIE", "Hardwired to 0. The IGD does not support memory write and invalidate commands."},
#else
{4, 4, 0x0000000000000000, "RO", "MWIE", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{3, 3, 0x0000000000000000, "RO", "SCE", "This bit is hardwired to 0. The IGD ignores Special cycles."},
#else
{3, 3, 0x0000000000000000, "RO", "SCE", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{2, 2, 0x0000000000000000, "RW/V", "BME", "0: Disable IGD bus mastering.  1: Enable the IGD to function as a PCI compliant master.  INTERNAL INTEL ONLY:GSA Implementation: When 0 blocks the sending of MSI interrupts. When 1 permits the sending of above. Note: See description INTDIS MSE and INTSTS bits."},
#else
{2, 2, 0x0000000000000000, "RW/V", "BME", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{1, 1, 0x0000000000000000, "RW/V", "MAE", "This bit controls the IGDs response to memory space accesses.  0: Disable.  1: Enable.    Device 2 Function Level Reset must reset this bit."},
#else
{1, 1, 0x0000000000000000, "RW/V", "MAE", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 0, 0x0000000000000000, "RW/V", "IOAE", "This bit controls the IGDs response to I/O space accesses.  0: Disable.  1: Enable.    Device 2 Function Level Reset must reset this bit."},
#else
{0, 0, 0x0000000000000000, "RW/V", "IOAE", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo774[] = {{"B_CR_PCICMD_0_2_0_PCI", "", 0x00000004, 12, 0x000000000000FFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields775[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{2, 15, 0x0000000000000000, "RO", "RESERVED_0", "Reserved"},
#else
{2, 15, 0x0000000000000000, "RO", "RESERVED_0", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{1, 1, 0x0000000000000000, "RW/V", "MAE", "This bit controls the IGDs response to memory space accesses.  0: Disable.  1: Enable."},
#else
{1, 1, 0x0000000000000000, "RW/V", "MAE", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 0, 0x0000000000000000, "RW/V", "IOAE", "This bit controls the IGDs response to I/O space accesses.  0: Disable.  1: Enable."},
#else
{0, 0, 0x0000000000000000, "RW/V", "IOAE", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo775[] = {{"B_CR_PCICMD_0_3_0_PCI", "", 0x00000004, 3, 0x000000000000FFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields776[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{24, 31, 0x0000000000000000, "RW/V", "MBA", "GTTMMADR[38:24] is {GTTMMADR_HI[6:0],GTTMMADR_LO[31:24]}.  Set by the OS these bits correspond to address signals [38:24]. 16MB combined for MMIO and Global GTT table aperture. 2MB for MMIO. 6MB reserved and 8 MB for GTT."},
#else
{24, 31, 0x0000000000000000, "RW/V", "MBA", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{4, 23, 0x0000000000000000, "RO", "ADM", "Hardwired to 0s to indicate at least 16MB address range."},
#else
{4, 23, 0x0000000000000000, "RO", "ADM", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{3, 3, 0x0000000000000000, "RO", "PREFMEM", "Hardwired to 0 to prevent prefetching."},
#else
{3, 3, 0x0000000000000000, "RO", "PREFMEM", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{1, 2, 0x0000000000000002, "RO", "MEMTYP", "00 : To indicate 32 bit base address  01: Reserved  10 : To indicate 64 bit base address  11: Reserved"},
#else
{1, 2, 0x0000000000000002, "RO", "MEMTYP", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 0, 0x0000000000000000, "RO", "MIOS", "Hardwired to 0 to indicate memory space."},
#else
{0, 0, 0x0000000000000000, "RO", "MIOS", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo776[] = {{"B_CR_GTTMMADR_LO_0_2_0_PCI", "", 0x00000010, 5, 0x00000000FFFFFFFF, 0x0000000000000004}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields777[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{24, 31, 0x0000000000000000, "RW/V", "MBA", "ISPMMADR[38:24] is {ISPMMADR_HI[6:0],ISPMMADR_LO[31:24]}.  Set by the OS these bits correspond to address signals [38:24]. 16MB is the size of the ISPMMADR."},
#else
{24, 31, 0x0000000000000000, "RW/V", "MBA", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{4, 23, 0x0000000000000000, "RO", "ADM", "Hardwired to 0s to indicate at least 16MB address range."},
#else
{4, 23, 0x0000000000000000, "RO", "ADM", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{3, 3, 0x0000000000000000, "RO", "PREFMEM", "Hardwired to 0 to prevent prefetching."},
#else
{3, 3, 0x0000000000000000, "RO", "PREFMEM", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{1, 2, 0x0000000000000002, "RO", "MEMTYP", "00 : To indicate 32 bit base address  01: Reserved  10 : To indicate 64 bit base address  11: Reserved"},
#else
{1, 2, 0x0000000000000002, "RO", "MEMTYP", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 0, 0x0000000000000000, "RO", "MIOS", "Hardwired to 0 to indicate memory space."},
#else
{0, 0, 0x0000000000000000, "RO", "MIOS", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo777[] = {{"B_CR_ISPMMADR_LO_0_3_0_PCI", "", 0x00000010, 5, 0x00000000FFFFFFFF, 0x0000000000000004}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields778[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{7, 31, 0x0000000000000000, "RO", "RESERVED_0", "Reserved.  Must be set to 0 since addressing above 512GB is not supported."},
#else
{7, 31, 0x0000000000000000, "RO", "RESERVED_0", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 6, 0x0000000000000000, "RW/V", "MBA", "Set by the OS these bits correspond to address signals [38:24]. 16MB combined for MMIO and Global GTT table aperture. 2MB for MMIO, 6MB reserved and 8 MB for GTT."},
#else
{0, 6, 0x0000000000000000, "RW/V", "MBA", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo778[] = {{"B_CR_GTTMMADR_HI_0_2_0_PCI", "", 0x00000014, 2, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields779[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{7, 31, 0x0000000000000000, "RO", "RESERVED_0", "Reserved.  Must be set to 0 since addressing above 512GB is not supported."},
#else
{7, 31, 0x0000000000000000, "RO", "RESERVED_0", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 6, 0x0000000000000000, "RW/V", "MBA", "Upper bits of ISPMMADR[38:24]"},
#else
{0, 6, 0x0000000000000000, "RW/V", "MBA", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo779[] = {{"B_CR_ISPMMADR_HI_0_3_0_PCI", "", 0x00000014, 2, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields780[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{31, 31, 0x0000000000000000, "RW/V", "ADMSK4096", "This Bit is either part of the Memory Base Address R/W or part of the Address Mask RO depending on the value of MSAC[4:0]."},
#else
{31, 31, 0x0000000000000000, "RW/V", "ADMSK4096", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{30, 30, 0x0000000000000000, "RW/V", "ADMSK2048", "This Bit is either part of the Memory Base Address R/W or part of the Address Mask RO depending on the value of MSAC[4:0]."},
#else
{30, 30, 0x0000000000000000, "RW/V", "ADMSK2048", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{29, 29, 0x0000000000000000, "RW/V", "ADMSK1024", "This Bit is either part of the Memory Base Address R/W or part of the Address Mask RO depending on the value of MSAC[4:0]."},
#else
{29, 29, 0x0000000000000000, "RW/V", "ADMSK1024", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{28, 28, 0x0000000000000000, "RW/V", "ADMSK512", "This Bit is either part of the Memory Base Address R/W or part of the Address Mask RO depending on the value of MSAC[4:0]."},
#else
{28, 28, 0x0000000000000000, "RW/V", "ADMSK512", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{27, 27, 0x0000000000000000, "RW/V", "ADMSK256", "This Bit is either part of the Memory Base Address R/W or part of the Address Mask RO depending on the value of MSAC[4:0]."},
#else
{27, 27, 0x0000000000000000, "RW/V", "ADMSK256", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{4, 26, 0x0000000000000000, "RO", "ADM", "Hardwired to 0s to indicate at least 128MB address range."},
#else
{4, 26, 0x0000000000000000, "RO", "ADM", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{3, 3, 0x0000000000000000, "RO", "PREFMEM", "Hardwired to 0 to prevent prefetching."},
#else
{3, 3, 0x0000000000000000, "RO", "PREFMEM", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{1, 2, 0x0000000000000002, "RO", "MEMTYP", "00 : To indicate 32 bit base address  01: Reserved  10 : To indicate 64 bit base address  11: Reserved"},
#else
{1, 2, 0x0000000000000002, "RO", "MEMTYP", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 0, 0x0000000000000000, "RO", "MIOS", "Hardwired to 0 to indicate memory space."},
#else
{0, 0, 0x0000000000000000, "RO", "MIOS", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo780[] = {{"B_CR_GMADR_LO_0_2_0_PCI", "", 0x00000018, 9, 0x00000000FFFFFFFF, 0x0000000000000004}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields781[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{7, 31, 0x0000000000000000, "RO", "RESERVED_0", "Reserved.  Must be set to 0 since addressing above 512GB is not supported."},
#else
{7, 31, 0x0000000000000000, "RO", "RESERVED_0", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 6, 0x0000000000000000, "RW/V", "MBA", "Memory Base Address MBA: Set by the OS these bits correspond to address signals [38:32]."},
#else
{0, 6, 0x0000000000000000, "RW/V", "MBA", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo781[] = {{"B_CR_GMADR_HI_0_2_0_PCI", "", 0x0000001C, 2, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields782[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{16, 31, 0x0000000000000000, "RO", "RESERVED_1", "Reserved"},
#else
{16, 31, 0x0000000000000000, "RO", "RESERVED_1", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{6, 15, 0x0000000000000000, "RW/V", "IOBASE", "These bits correspond to address signals [15:6]. If there is a match then address hits the IOBAR.  Device 2 FLR must reset this field."},
#else
{6, 15, 0x0000000000000000, "RW/V", "IOBASE", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{3, 5, 0x0000000000000000, "RO", "RESERVED_0", "Reserved"},
#else
{3, 5, 0x0000000000000000, "RO", "RESERVED_0", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{1, 2, 0x0000000000000000, "RO", "MEMTYPE", "Hardwired to 0s to indicate 32bit address."},
#else
{1, 2, 0x0000000000000000, "RO", "MEMTYPE", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 0, 0x0000000000000001, "RO", "MIOS", "Hardwired to 1 to indicate IO space."},
#else
{0, 0, 0x0000000000000001, "RO", "MIOS", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo782[] = {{"B_CR_IOBAR_0_2_0_PCI", "", 0x00000020, 5, 0x00000000FFFFFFFF, 0x0000000000000001}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields783[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{15, 31, 0x000000000001FBFF, "RW", "BASE_ADDR", "Defines the base address of the MCHBAR.  MCHBAR[38:15] is {MCHBAR_HI[6:0],MCHBAR_LO[31:15]}. If incoming Request Address[38:15] matches MCHBAR[38:15] then request hits an address in the MCHBAR range."},
#else
{15, 31, 0x000000000001FBFF, "RW", "BASE_ADDR", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{4, 14, 0x0000000000000000, "RO", "BASE_ADDR_NOT_IMPLEMENTED", "Hardwired to 0 to indicate size of BAR 32kB"},
#else
{4, 14, 0x0000000000000000, "RO", "BASE_ADDR_NOT_IMPLEMENTED", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{1, 3, 0x0000000000000000, "RO", "RESERVED_0", "Prefetchable space"},
#else
{1, 3, 0x0000000000000000, "RO", "RESERVED_0", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 0, 0x0000000000000001, "RW", "MCHBAREN", "0: MCHBAR is disabled and does not claim any memory  1: MCHBAR memory mapped accesses are claimed and decoded appropriately."},
#else
{0, 0, 0x0000000000000001, "RW", "MCHBAREN", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo783[] = {{"B_CR_MCHBAR_LO_0_0_0_PCI", "", 0x00000048, 4, 0x00000000FFFFFFFF, 0x00000000FDFF8001}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields784[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{7, 31, 0x0000000000000000, "RO", "RESERVED_0", "Reserved"},
#else
{7, 31, 0x0000000000000000, "RO", "RESERVED_0", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 6, 0x0000000000000000, "RW", "BASE_ADDR", "Defines the base address of the MCHBAR.  If incoming Request Address[38:15] matches MCHBAR[38:15] then request hits an address in the MCHBAR range."},
#else
{0, 6, 0x0000000000000000, "RW", "BASE_ADDR", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo784[] = {{"B_CR_MCHBAR_HI_0_0_0_PCI", "", 0x0000004C, 2, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields785[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{8, 15, 0x0000000000000000, "RW", "GMS", "This field is used to select the amount of Main Memory that is preallocated to support the Internal Graphics device in VGA nonlinear and Native linear modes. The BIOS ensures that memory is preallocated only when Internal graphics is enabled.  This register is also Intel TXT lockable.  Hardware does not clear or set any of these bits automatically based on IGD being disabled/enabled.  BIOS Requirement: BIOS must not set this field to 0h if IVD bit 1 of this register is 0.  0x00:0MB  0x01:32MB  0x02:64MB  0x03:96MB  0x04:128MB  0x05:160MB  0x06:192MB  0x07:224MB  0x08:256MB  0x09:288MB  0x0A:320MB  0x0B:352MB  0x0C:384MB  0x0D:416MB  0x0E:448MB  0x0F:480MB  0x10:512MB  0x20:...1024MB...  0x30:...1536MB...  0x3F:...2016MB  0x40-0xFF:Illegal value"},
#else
{8, 15, 0x0000000000000000, "RW", "GMS", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{6, 7, 0x0000000000000000, "RW", "GGMS", "This field is used to select the amount of Main Memory that is preallocated to support the Internal Graphics Translation Table. The BIOS ensures that memory is preallocated only when Internal graphics is enabled.  GSM is assumed to be a contiguous physical DRAM space with DSM and BIOS needs to allocate a contiguous memory chunk. Hardware will derive the base of GSM from DSM only using the GSM size programmed in the register.  Hardware functionality in case of programming this value to Reserved is not guaranteed.  0x0:No Preallocated Memory  0x1:2MB of Preallocated Memory  0x2:4MB of Preallocated Memory  0x3:8MB of Preallocated Memory"},
#else
{6, 7, 0x0000000000000000, "RW", "GGMS", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{3, 5, 0x0000000000000000, "RO", "RESERVED_0", "Reserved"},
#else
{3, 5, 0x0000000000000000, "RO", "RESERVED_0", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{2, 2, 0x0000000000000000, "RW", "VAMEN", "Enables the use of the iGFX enbines for Versatile Acceleration.  1: iGFX engines are in Versatile Acceleration Mode. Device 2 Class Code is 048000h.  0: iGFX engines are in iGFX Mode. Device 2 Class Code is 030000h."},
#else
{2, 2, 0x0000000000000000, "RW", "VAMEN", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{1, 1, 0x0000000000000000, "RW/L", "IVD", "0: Enable. Device 2 IGD claims VGA memory and IO cycles the SubClass Code within Device 2 Class Code register is 00.  1: Disable. Device 2 IGD does not claim VGA cycles Mem and IO and the Sub Class Code field within Device 2 function 0 Class Code register is 80.  BIOS Requirement: BIOS must not set this bit to 0 if the GMS field bits 7:3 of this register preallocates no memory.  This bit MUST be set to 1 if Device 2 is disabled either via a fuse or fuse override B_CR_CAPID0_A[IGD]  1 or via a register DEVEN[3]  0.  This register is locked by Intel TXT lock.  0:Enable  1:Disable"},
#else
{1, 1, 0x0000000000000000, "RW/L", "IVD", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 0, 0x0000000000000000, "RW", "GGCLCK", "Reserved.  Unused by the Bunit."},
#else
{0, 0, 0x0000000000000000, "RW", "GGCLCK", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo785[] = {{"B_CR_GGC_0_0_0_PCI", "", 0x00000050, 6, 0x000000000000FFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields786[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{6, 31, 0x0000000000000000, "RO", "RESERVED_1", "Reserved"},
#else
{6, 31, 0x0000000000000000, "RO", "RESERVED_1", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{5, 5, 0x0000000000000001, "RW", "D3F0EN", "0:      Bus 0 Device 3 Function 0 is disabled and hidden;  1:      Bus 0 Device 3 Function 0 is enabled and visible  This bit will be set to 0b and remain 0b if Device 3 capability is disabled."},
#else
{5, 5, 0x0000000000000001, "RW", "D3F0EN", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{4, 4, 0x0000000000000001, "RW", "D2F0EN", "0:      Bus 0 Device 2 Function 0 is disabled and hidden;  1:      Bus 0 Device 2 Function 0 is enabled and visible  This bit will be set to 0b and remain 0b if Device 2 capability is disabled."},
#else
{4, 4, 0x0000000000000001, "RW", "D2F0EN", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{2, 3, 0x0000000000000000, "RO", "RESERVED_0", "Reserved"},
#else
{2, 3, 0x0000000000000000, "RO", "RESERVED_0", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{1, 1, 0x0000000000000001, "RW", "D0F1EN", "0:      Bus 0 Device 0 Function 1 is disabled and hidden  1:      Bus 0 Device 0 Function 1 is enabled and visible  This bit will be set to 0b and remain 0b if Device 0/0/1 capability is disabled."},
#else
{1, 1, 0x0000000000000001, "RW", "D0F1EN", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 0, 0x0000000000000001, "RO", "D0F0EN", "Bus 0 Device 0 Function 0 may not be disabled and is therefore hardwired to 1."},
#else
{0, 0, 0x0000000000000001, "RO", "D0F0EN", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo786[] = {{"B_CR_DEVEN_0_0_0_PCI", "", 0x00000054, 6, 0x00000000FFFFFFFF, 0x0000000000000033}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields787[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{1, 7, 0x0000000000000000, "RO", "RESERVED_0", "Reserved"},
#else
{1, 7, 0x0000000000000000, "RO", "RESERVED_0", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 0, 0x0000000000000000, "RW/V", "IOBARDIS", "IOBAR Disable. IOBARDIS:  System BIOS can choose to disable and hide the IOBAR for systems that do not require legacy IOBAR access to Gfx MMIO registers  0: IOBAR is enabled and exposed at offset 0x20 in Device 2 Configuration space. Default  1: IOBAR is disabled and not visible in PCI Configuration Space. Behaves as if hardwired to zeros."},
#else
{0, 0, 0x0000000000000000, "RW/V", "IOBARDIS", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo787[] = {{"B_CR_DEV2CTL_0_2_0_PCI", "", 0x00000058, 2, 0x00000000000000FF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields788[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{28, 31, 0x0000000000000000, "RW", "PCIEXBAR", "PCIEXBAR: PCIEXBAR[38:28] is {PCIEXBAR_HI[6:0],PCIEXBAR_LO[31:28]}. Describes bits [38:28] of the base address of the contiguous 256MB region for PCI Express Enhanced Configuration region.   If bits [38:28] of the request address matches the PCIEXBAR[38:28] then the request targets the PCI Express Enhanced Configuration Space region.  A posted memory operation from an IDI agent will be treated as a nonposted operation by the Tunit and Aunit."},
#else
{28, 31, 0x0000000000000000, "RW", "PCIEXBAR", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{27, 27, 0x0000000000000000, "RO", "ADMSK128", "Reserved.  Unused by SoC since PCIEXBAR is a fixed 256MB region in SoCs."},
#else
{27, 27, 0x0000000000000000, "RO", "ADMSK128", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{26, 26, 0x0000000000000000, "RO", "ADMSK64", "Reserved.  Unused by SoC since PCIEXBAR is a fixed 256MB region in SoCs."},
#else
{26, 26, 0x0000000000000000, "RO", "ADMSK64", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{3, 25, 0x0000000000000000, "RO", "RESERVED_1", "Reserved"},
#else
{3, 25, 0x0000000000000000, "RO", "RESERVED_1", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{1, 2, 0x0000000000000000, "RO", "LENGTH", "Length of the region.  Reserved and set to 0 indicating a fixed 256 MB region."},
#else
{1, 2, 0x0000000000000000, "RO", "LENGTH", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 0, 0x0000000000000000, "RW", "PCIEXBAREN", "PCIEXBAREN:  0:  PCIEXBAR range is disabled.  Address may target DRAM or MMIO depending on other address decode rules.  1: PCIEXBAR range is enabled.  Incoming request address must be compared with PCIEXBAR to determine whether the request targets PCI Express Enhanced Configuration region."},
#else
{0, 0, 0x0000000000000000, "RW", "PCIEXBAREN", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo788[] = {{"B_CR_PCIEXBAR_LO_0_0_0_PCI", "", 0x00000060, 6, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields789[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{5, 7, 0x0000000000000000, "RO", "RESERVED_0", "Reserved"},
#else
{5, 7, 0x0000000000000000, "RO", "RESERVED_0", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{4, 4, 0x0000000000000000, "RW/V", "APSZ4", "This field is used in conjuction with other APSZ fields to determine the size of Aperture GMADR and affects certain bits of GMADR register. The description below is for all APSZ fields [4:0]  00000: 128MB  GMADR.B[26:4] is hardwired to 0.  00001:  256MB  GMADR.B[27]=0, RO.  00010:  illegal hardware will treat this as 00011.  00011:  512MB  GMADR.B[28:27]=0, RO.  00100-00110:  illegal hardware will treat this as 00111.  00111:  1024MB  GMADR.B[29:27]=0,RO.  01000-01110:  illegal hardware will treat this as 01111.  01111:  2048MB  GMADR.B[30:27]=0,RO.  10000-11110:  illegal hardware will treat this as 11111.  11111:  4096MB  GMADR.B[31:27]=0,RO"},
#else
{4, 4, 0x0000000000000000, "RW/V", "APSZ4", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{3, 3, 0x0000000000000000, "RW/V", "APSZ3", "This field is used in conjuction with other APSZ fields to determine the size of Aperture GMADR and affects certain bits of GMADR register. The description below is for all APSZ fields [4:0]  00000: 128MB  GMADR.B[26:4] is hardwired to 0.  00001:  256MB  GMADR.B[27]=0, RO.  00010:  illegal hardware will treat this as 00011.  00011:  512MB  GMADR.B[28:27]=0, RO.  00100-00110:  illegal hardware will treat this as 00111.  00111:  1024MB  GMADR.B[29:27]=0,RO.  01000-01110:  illegal hardware will treat this as 01111.  01111:  2048MB  GMADR.B[30:27]=0,RO.  10000-11110:  illegal hardware will treat this as 11111.  11111:  4096MB  GMADR.B[31:27]=0,RO"},
#else
{3, 3, 0x0000000000000000, "RW/V", "APSZ3", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{2, 2, 0x0000000000000000, "RW/V", "APSZ2", "This field is used in conjuction with other APSZ fields to determine the size of Aperture GMADR and affects certain bits of GMADR register. The description below is for all APSZ fields [4:0]  00000: 128MB  GMADR.B[26:4] is hardwired to 0.  00001:  256MB  GMADR.B[27]=0, RO.  00010:  illegal hardware will treat this as 00011.  00011:  512MB  GMADR.B[28:27]=0, RO.  00100-00110:  illegal hardware will treat this as 00111.  00111:  1024MB  GMADR.B[29:27]=0,RO.  01000-01110:  illegal hardware will treat this as 01111.  01111:  2048MB  GMADR.B[30:27]=0,RO.  10000-11110:  illegal hardware will treat this as 11111.  11111:  4096MB  GMADR.B[31:27]=0,RO"},
#else
{2, 2, 0x0000000000000000, "RW/V", "APSZ2", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{1, 1, 0x0000000000000000, "RW/V", "APSZ1", "This field is used in conjuction with other APSZ fields to determine the size of Aperture GMADR and affects certain bits of GMADR register. The description below is for all APSZ fields [4:0]  00000: 128MB  GMADR.B[26:4] is hardwired to 0.  00001:  256MB  GMADR.B[27]=0, RO.  00010:  illegal hardware will treat this as 00011.  00011:  512MB  GMADR.B[28:27]=0, RO.  00100-00110:  illegal hardware will treat this as 00111.  00111:  1024MB  GMADR.B[29:27]=0,RO.  01000-01110:  illegal hardware will treat this as 01111.  01111:  2048MB  GMADR.B[30:27]=0,RO.  10000-11110:  illegal hardware will treat this as 11111.  11111:  4096MB  GMADR.B[31:27]=0,RO"},
#else
{1, 1, 0x0000000000000000, "RW/V", "APSZ1", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 0, 0x0000000000000001, "RW/V", "APSZ0", "This field is used in conjuction with other APSZ fields to determine the size of Aperture GMADR and affects certain bits of GMADR register. The description below is for all APSZ fields [4:0]  00000: 128MB  GMADR.B[26:4] is hardwired to 0.  00001:  256MB  GMADR.B[27]=0, RO.  00010:  illegal hardware will treat this as 00011.  00011:  512MB  GMADR.B[28:27]=0, RO.  00100-00110:  illegal hardware will treat this as 00111.  00111:  1024MB  GMADR.B[29:27]=0,RO.  01000-01110:  illegal hardware will treat this as 01111.  01111:  2048MB  GMADR.B[30:27]=0,RO.  10000-11110:  illegal hardware will treat this as 11111.  11111:  4096MB  GMADR.B[31:27]=0,RO"},
#else
{0, 0, 0x0000000000000001, "RW/V", "APSZ0", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo789[] = {{"B_CR_MSAC_0_2_0_PCI", "", 0x00000062, 6, 0x00000000000000FF, 0x0000000000000001}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields790[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{7, 31, 0x0000000000000000, "RO", "RESERVED_0", "Reserved"},
#else
{7, 31, 0x0000000000000000, "RO", "RESERVED_0", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 6, 0x0000000000000000, "RW", "PCIEXBAR", "PCIEXBAR: PCIEXBAR[38:28] is {PCIEXBAR_HI[6:0],PCIEXBAR_LO[31:28]}. Describes bits [38:28] of the base address of the contiguous 256MB region for PCI Express Enhanced Configuration region.   If bits [38:28] of the request address matches the PCIEXBAR[38:28] then the request targets the PCI Express Enhanced Configuration Space region.  A posted memory operation from an IDI agent will be treated as a nonposted operation by the Tunit and Aunit."},
#else
{0, 6, 0x0000000000000000, "RW", "PCIEXBAR", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo790[] = {{"B_CR_PCIEXBAR_HI_0_0_0_PCI", "", 0x00000064, 2, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields791[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{31, 31, 0x0000000000000000, "RW/V", "EPM", "This field controls DMA accesses to the protected lowmemory and protected highmemory regions.  0: Protected memory regions are disabled.  1: Protected memory regions are enabled. Access control is implemented.  IA accesses are always allowed access.  NonIA accesses are allowed if request SAI matches the SAI of the Default VTd Engine.  Requests blocked due to protected memory region violation are not recorded or reported as remapping faults. Hardware reports the status of the protected memory enable/disable operation through the PRS field in this register. Hardware implementations supporting DMA draining must drain any inflight translated DMA requests queued within the RootComplex before indicating the protected memory region as enabled through the PRS field."},
#else
{31, 31, 0x0000000000000000, "RW/V", "EPM", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{1, 30, 0x0000000000000000, "RO", "RESERVED_0", "Reserved"},
#else
{1, 30, 0x0000000000000000, "RO", "RESERVED_0", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 0, 0x0000000000000000, "RO", "PRS", "Unused by the Bunit.  This field indicates the status of protected memory regions:  0: Protected memory regions disabled.  1: Protected memory regions enabled."},
#else
{0, 0, 0x0000000000000000, "RO", "PRS", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo791[] = {{"B_CR_PMEN_REG_0_0_0_DEFVTDBAR", "", 0x00000064, 3, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields792[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{20, 31, 0x0000000000000000, "RW/V", "PLMB", "This register specifies the base of protected lowmemory region in system memory."},
#else
{20, 31, 0x0000000000000000, "RW/V", "PLMB", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 19, 0x0000000000000000, "RO", "RESERVED_0", "Reserved"},
#else
{0, 19, 0x0000000000000000, "RO", "RESERVED_0", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo792[] = {{"B_CR_PLMBASE_REG_0_0_0_DEFVTDBAR", "", 0x00000068, 2, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields793[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{20, 31, 0x0000000000000000, "RW/V", "PLML", "This register specifies the last host physical address of the DMAprotected lowmemory region in system memory."},
#else
{20, 31, 0x0000000000000000, "RW/V", "PLML", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 19, 0x0000000000000000, "RO", "RESERVED_0", "Reserved"},
#else
{0, 19, 0x0000000000000000, "RO", "RESERVED_0", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo793[] = {{"B_CR_PLMLIMIT_REG_0_0_0_DEFVTDBAR", "", 0x0000006C, 2, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields794[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{39, 63, 0x0000000000000000, "RO", "RESERVED_1", "Reserved"},
#else
{39, 63, 0x0000000000000000, "RO", "RESERVED_1", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{20, 38, 0x0000000000000000, "RW/V", "PHMB", "This register specifies the base of protected high memory region in system memory.  Hardware ignores and does not implement bits 63:HAW where HAW is the host address width."},
#else
{20, 38, 0x0000000000000000, "RW/V", "PHMB", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 19, 0x0000000000000000, "RO", "RESERVED_0", "Reserved"},
#else
{0, 19, 0x0000000000000000, "RO", "RESERVED_0", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo794[] = {{"B_CR_PHMBASE_REG_0_0_0_DEFVTDBAR", "", 0x00000070, 3, 0xFFFFFFFFFFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields795[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{15, 15, 0x0000000000000000, "RW/V", "INITIATE_FLR", "Initiate Function Level Reset:  A write of 1b initiates Function Level Reset to the Function. The value read by software from this bit is always 0b.  Bunit uses only this bit for Dev2 FLR.  Rest of the bits in this register are ignored by the Bunit."},
#else
{15, 15, 0x0000000000000000, "RW/V", "INITIATE_FLR", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{12, 14, 0x0000000000000000, "RO", "MAX_READ_REQUEST_SIZE", "Max Read Request Size:  Functions that do not generate Read Requests larger than 128 bytes and Functions that do not generate Read Requests on their own behalf are permitted to implement this field as Read Only RO with a value of 000b."},
#else
{12, 14, 0x0000000000000000, "RO", "MAX_READ_REQUEST_SIZE", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{11, 11, 0x0000000000000000, "RO", "ENABLE_NO_SNOOP", "Enable No Snoop  This bit is permitted to be hardwired to 0b if a Function would never Set the No Snoop attribute in transactions it initiates. The graphics device never generates a PCI Express TLP."},
#else
{11, 11, 0x0000000000000000, "RO", "ENABLE_NO_SNOOP", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{10, 10, 0x0000000000000000, "RO", "AUX_PM_ENABLE", "Aux Power PM Enable  Functions that do not implement this capability hardwire this bit to 0b."},
#else
{10, 10, 0x0000000000000000, "RO", "AUX_PM_ENABLE", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{9, 9, 0x0000000000000000, "RO", "PHANTOM_FUNCTIONS_ENABLE", "Phantom Functions Enable  Functions that do not implement this capability hardwire this bit to 0b."},
#else
{9, 9, 0x0000000000000000, "RO", "PHANTOM_FUNCTIONS_ENABLE", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{8, 8, 0x0000000000000000, "RO", "EXTENDED_TAG_ENABLE", "Extended Tag Field Enable:  Functions that do not implement this capability hardwire this bit to 0b."},
#else
{8, 8, 0x0000000000000000, "RO", "EXTENDED_TAG_ENABLE", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{5, 7, 0x0000000000000000, "RO", "MAX_PAYLOAD_SIZE", "Max Payload Size:  Functions that support only the 128byte max payload size are permitted to hardwire this field to 000b."},
#else
{5, 7, 0x0000000000000000, "RO", "MAX_PAYLOAD_SIZE", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{4, 4, 0x0000000000000000, "RO", "RO_ENABLE", "Enable Relaxed Ordering:  A Function is permitted to hardwire this bit to 0b if it never sets the Relaxed Ordering attribute in transactions it initiates as a Requester. The graphics device never generates a PCI Express TLP."},
#else
{4, 4, 0x0000000000000000, "RO", "RO_ENABLE", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{3, 3, 0x0000000000000000, "RO", "UR_ENABLE", "Unsupported Request Response Enable:  A Root Complex Integrated Endpoint that is not associated with a Root Complex Event Collector is permitted to hardwire this bit to 0b."},
#else
{3, 3, 0x0000000000000000, "RO", "UR_ENABLE", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{2, 2, 0x0000000000000000, "RO", "FATAL_ERR_ENABLE", "Fatal Error Enable:  A Root Complex Integrated Endpoint that is not associated with a Root Complex Event Collector is permitted to hardwire this bit to 0b."},
#else
{2, 2, 0x0000000000000000, "RO", "FATAL_ERR_ENABLE", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{1, 1, 0x0000000000000000, "RO", "NONFATAL_ERR_ENABLE", "NonFatal Error Enable:  A Root Complex Integrated Endpoint that is not associated with a Root Complex Event Collector is permitted to hardwire this bit to 0b."},
#else
{1, 1, 0x0000000000000000, "RO", "NONFATAL_ERR_ENABLE", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 0, 0x0000000000000000, "RO", "CORRECTABLE_ERR_ENABLE", "Correctable Error Enable:  A Root Complex Integrated Endpoint that is not associated with a Root Complex Event Collector is permitted to hardwire this bit to 0b."},
#else
{0, 0, 0x0000000000000000, "RO", "CORRECTABLE_ERR_ENABLE", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo795[] = {{"B_CR_DEVICECTL_0_2_0_PCI", "", 0x00000078, 12, 0x000000000000FFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields796[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{15, 15, 0x0000000000000000, "RW/V", "INITIATE_FLR", "Initiate Function Level Reset:  A write of 1b initiates Function Level Reset to the Function. The value read by software from this bit is always 0b.  Bunit uses only this bit for Dev3 FLR.  Rest of the bits in this register are ignored by the Bunit."},
#else
{15, 15, 0x0000000000000000, "RW/V", "INITIATE_FLR", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{12, 14, 0x0000000000000000, "RO", "MAX_READ_REQUEST_SIZE", "Max Read Request Size:  Functions that do not generate Read Requests larger than 128 bytes and Functions that do not generate Read Requests on their own behalf are permitted to implement this field as Read Only RO with a value of 000b."},
#else
{12, 14, 0x0000000000000000, "RO", "MAX_READ_REQUEST_SIZE", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{11, 11, 0x0000000000000000, "RO", "ENABLE_NO_SNOOP", "Enable No Snoop  This bit is permitted to be hardwired to 0b if a Function would never Set the No Snoop attribute in transactions it initiates. The graphics device never generates a PCI Express TLP."},
#else
{11, 11, 0x0000000000000000, "RO", "ENABLE_NO_SNOOP", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{10, 10, 0x0000000000000000, "RO", "AUX_PM_ENABLE", "Aux Power PM Enable  Functions that do not implement this capability hardwire this bit to 0b."},
#else
{10, 10, 0x0000000000000000, "RO", "AUX_PM_ENABLE", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{9, 9, 0x0000000000000000, "RO", "PHANTOM_FUNCTIONS_ENABLE", "Phantom Functions Enable  Functions that do not implement this capability hardwire this bit to 0b."},
#else
{9, 9, 0x0000000000000000, "RO", "PHANTOM_FUNCTIONS_ENABLE", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{8, 8, 0x0000000000000000, "RO", "EXTENDED_TAG_ENABLE", "Extended Tag Field Enable:  Functions that do not implement this capability hardwire this bit to 0b."},
#else
{8, 8, 0x0000000000000000, "RO", "EXTENDED_TAG_ENABLE", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{5, 7, 0x0000000000000000, "RO", "MAX_PAYLOAD_SIZE", "Max Payload Size:  Functions that support only the 128byte max payload size are permitted to hardwire this field to 000b."},
#else
{5, 7, 0x0000000000000000, "RO", "MAX_PAYLOAD_SIZE", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{4, 4, 0x0000000000000000, "RO", "RO_ENABLE", "Enable Relaxed Ordering:  A Function is permitted to hardwire this bit to 0b if it never sets the Relaxed Ordering attribute in transactions it initiates as a Requester. The graphics device never generates a PCI Express TLP."},
#else
{4, 4, 0x0000000000000000, "RO", "RO_ENABLE", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{3, 3, 0x0000000000000000, "RO", "UR_ENABLE", "Unsupported Request Response Enable:  A Root Complex Integrated Endpoint that is not associated with a Root Complex Event Collector is permitted to hardwire this bit to 0b."},
#else
{3, 3, 0x0000000000000000, "RO", "UR_ENABLE", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{2, 2, 0x0000000000000000, "RO", "FATAL_ERR_ENABLE", "Fatal Error Enable:  A Root Complex Integrated Endpoint that is not associated with a Root Complex Event Collector is permitted to hardwire this bit to 0b."},
#else
{2, 2, 0x0000000000000000, "RO", "FATAL_ERR_ENABLE", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{1, 1, 0x0000000000000000, "RO", "NONFATAL_ERR_ENABLE", "NonFatal Error Enable:  A Root Complex Integrated Endpoint that is not associated with a Root Complex Event Collector is permitted to hardwire this bit to 0b."},
#else
{1, 1, 0x0000000000000000, "RO", "NONFATAL_ERR_ENABLE", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 0, 0x0000000000000000, "RO", "CORRECTABLE_ERR_ENABLE", "Correctable Error Enable:  A Root Complex Integrated Endpoint that is not associated with a Root Complex Event Collector is permitted to hardwire this bit to 0b."},
#else
{0, 0, 0x0000000000000000, "RO", "CORRECTABLE_ERR_ENABLE", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo796[] = {{"B_CR_DEVICECTL_0_3_0_PCI", "", 0x00000078, 12, 0x000000000000FFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields797[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{39, 63, 0x0000000000000000, "RO", "RESERVED_1", "Reserved"},
#else
{39, 63, 0x0000000000000000, "RO", "RESERVED_1", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{20, 38, 0x0000000000000000, "RW/V", "PHML", "This register specifies the last host physical address of the DMA protected highmemory region in system memory.  Hardware ignores and does not implement bits 63:HAW where HAW is the host address width."},
#else
{20, 38, 0x0000000000000000, "RW/V", "PHML", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 19, 0x0000000000000000, "RO", "RESERVED_0", "Reserved"},
#else
{0, 19, 0x0000000000000000, "RO", "RESERVED_0", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo797[] = {{"B_CR_PHMLIMIT_REG_0_0_0_DEFVTDBAR", "", 0x00000078, 3, 0xFFFFFFFFFFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields798[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{20, 31, 0x0000000000000000, "RW", "TOUUD", "TOUUD[38:20] is {TOUUD_HI[6:0],TOUUD_LO[31:20]}.  Upper usable DRAM address range ends at the preceding byte.  Upper MMIO Range starts at this address and extends up to the maximum system addressable memory range.  Bits 38:20 are compared with bits 38:20 of the incoming request address to determine whether the request targets the upper usable DRAM range or upper MMIO range.  If Request Address[38:20]>=TOUUD[38:20] and any bit in Request Address[38:32] is set request is determined to target the upper MMIO range."},
#else
{20, 31, 0x0000000000000000, "RW", "TOUUD", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{1, 19, 0x0000000000000000, "RO", "RESERVED_1", "Reserved"},
#else
{1, 19, 0x0000000000000000, "RO", "RESERVED_1", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 0, 0x0000000000000000, "RW", "LOCK", "Reserved.  Lock is unused by Bunit.  Register overwrites are protected via SAI access control policy registers."},
#else
{0, 0, 0x0000000000000000, "RW", "LOCK", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo798[] = {{"B_CR_TOUUD_LO_0_0_0_PCI", "", 0x000000A8, 3, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields799[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{7, 31, 0x0000000000000000, "RO", "RESERVED_0", "Reserved"},
#else
{7, 31, 0x0000000000000000, "RO", "RESERVED_0", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 6, 0x0000000000000001, "RW", "TOUUD", "TOUUD[38:20] is {TOUUD_HI[6:0],TOUUD_LO[31:20]}.  Upper usable DRAM address range ends at the preceding byte.  Upper MMIO Range starts at this address and extends up to the maximum system addressable memory range.  Bits 38:20 are compared with bits 38:20 of the incoming request address to determine whether the request targets the upper usable DRAM range or upper MMIO range.  If Request Address[38:20]>=TOUUD[38:20] and any bit in Request Address[38:32] is set request is determined to target the upper MMIO range."},
#else
{0, 6, 0x0000000000000001, "RW", "TOUUD", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo799[] = {{"B_CR_TOUUD_HI_0_0_0_PCI", "", 0x000000AC, 2, 0x00000000FFFFFFFF, 0x0000000000000001}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields800[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{20, 31, 0x0000000000000000, "RW", "BGSM", "This register contains the base address of the Graphics Stolen Memory.  The limit for the Graphics Stolen Memory is TOLUD-1.  Incoming Request Address[31:20] is compared against BGSM[31:20] and TOLUD[31:20] to determine if the address falls in the range.  The comparison check is as follows:  BGSM[31:20]<=Address[31:20] && Address[31:20]<TOLUD[31:20] and Address[38:32]==0.  Request SAI is then checked against the allowed SAIs to determine if access is allowed"},
#else
{20, 31, 0x0000000000000000, "RW", "BGSM", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{1, 19, 0x0000000000000000, "RO", "RESERVED_0", "Reserved"},
#else
{1, 19, 0x0000000000000000, "RO", "RESERVED_0", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 0, 0x0000000000000000, "RW", "LOCK", "Reserved.  Lock is unused by Bunit.  Register overwrites are protected via SAI access control policy registers."},
#else
{0, 0, 0x0000000000000000, "RW", "LOCK", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo800[] = {{"B_CR_BGSM_0_0_0_PCI", "", 0x000000B4, 3, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields801[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{20, 31, 0x0000000000000001, "RW", "TSEGMB", "Base address of TSEG DRAM memory.  BIOS determines the base of TSEG memory which must be at or below Graphics Base of GTT Stolen Memory BGSM.  SMM range starts at this base and ends at BGSM1.  Incoming Request Address [31:20] will be compared with TSEGMB[31:20] and BGSM[31:20] to determine if the request targets the SMM range.  The comparison check is as follows: Address[31:20]>=TSEGMB[31:20] && Address[31:20]<BGSM[31:20] and  Address[38:32]==0.  If the check passes the request targets the SMM range.  If the protection for the range is enabled then the request SAI is compared against allowed SAIs specified by BSMRRAC and BSMRWAC registers to determine if access is allowed."},
#else
{20, 31, 0x0000000000000001, "RW", "TSEGMB", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{1, 19, 0x0000000000000000, "RO", "RESERVED_0", "Reserved"},
#else
{1, 19, 0x0000000000000000, "RO", "RESERVED_0", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 0, 0x0000000000000000, "RW", "LOCK", "Reserved.  Lock is unused by Bunit.  Register overwrites are protected via SAI access control policy registers."},
#else
{0, 0, 0x0000000000000000, "RW", "LOCK", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo801[] = {{"B_CR_TSEGMB_0_0_0_PCI", "", 0x000000B8, 3, 0x00000000FFFFFFFF, 0x0000000000100000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields802[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{20, 31, 0x0000000000000400, "RW", "TOLUD", "Defines the top of lower usable DRAM which ends at the preceding byte.  Lower MMIO Address range starts at this address and continues up to the 4GB Address 0xFFFF_FFFF.  Bits 31:20 are compared with incoming request Address[31:20] to determine whether the request targets lower usable DRAM range or the lower MMIO range.  If Request Address[31:20]>=TOLUD[31:20] and Request Address[38:32]==0 then the Request Address falls in the Lower MMIO Address range."},
#else
{20, 31, 0x0000000000000400, "RW", "TOLUD", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{1, 19, 0x0000000000000000, "RO", "RESERVED_0", "Reserved"},
#else
{1, 19, 0x0000000000000000, "RO", "RESERVED_0", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 0, 0x0000000000000000, "RW", "LOCK", "Reserved.  Lock is unused by Bunit.  Register overwrites are protected via SAI access control policy registers."},
#else
{0, 0, 0x0000000000000000, "RW", "LOCK", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo802[] = {{"B_CR_TOLUD_0_0_0_PCI", "", 0x000000BC, 3, 0x00000000FFFFFFFF, 0x0000000040000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields803[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{15, 15, 0x0000000000000000, "RO", "PMESTS", "This bit is 0 to indicate that IGD does not support PME generation from D3 cold."},
#else
{15, 15, 0x0000000000000000, "RO", "PMESTS", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{13, 14, 0x0000000000000000, "RO", "DSCALE", "The IGD does not support data register. This bit always returns 00 when read write operations have no effect."},
#else
{13, 14, 0x0000000000000000, "RO", "DSCALE", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{9, 12, 0x0000000000000000, "RO", "DSEL", "The IGD does not support data register. This bit always returns 0h when read write operations have no effect."},
#else
{9, 12, 0x0000000000000000, "RO", "DSEL", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{8, 8, 0x0000000000000000, "RO", "PMEEN", "This bit is 0 to indicate that PME assertion from D3 cold is disabled."},
#else
{8, 8, 0x0000000000000000, "RO", "PMEEN", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{2, 7, 0x0000000000000000, "RO", "RESERVED_1", "Reserved"},
#else
{2, 7, 0x0000000000000000, "RO", "RESERVED_1", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 1, 0x0000000000000000, "RW/V", "PWRSTAT", "This field indicates the current power state of the IGD and can be used to set the IGD into a new power state. If software attempts to write an unsupported state to this field write operation must complete normally on the bus but the data is discarded and no state change occurs. On a transition from D3 to D0 the graphics controller is optionally reset to initial values.   Bits[1:0] Power state  00: D0 Default  01: D1 Not Supported  10: D2 Not Supported  11: D3"},
#else
{0, 1, 0x0000000000000000, "RW/V", "PWRSTAT", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo803[] = {{"B_CR_PMCS_0_2_0_PCI", "", 0x000000D4, 6, 0x000000000000FFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields804[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{2, 15, 0x0000000000000000, "RO", "RESERVED_1", "Reserved"},
#else
{2, 15, 0x0000000000000000, "RO", "RESERVED_1", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 1, 0x0000000000000000, "RW/V", "PWRSTAT", "This field indicates the current power state of the Iunit and can be used to set the Iunit into a new power state. If software attempts to write an unsupported state to this field write operation must complete normally on the bus but the data is discarded and no state change occurs. On a transition from D3 to D0 the Iunit is optionally reset to initial values.   Bits[1:0] Power state  00: D0 Default  01: D1 Not Supported  10: D2 Not Supported  11: D3"},
#else
{0, 1, 0x0000000000000000, "RW/V", "PWRSTAT", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo804[] = {{"B_CR_PMCS_0_3_0_PCI", "", 0x000000D4, 2, 0x000000000000FFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields805[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{24, 31, 0x0000000000000000, "RW", "SPARE31_24", "Reserved for future capabilities."},
#else
{24, 31, 0x0000000000000000, "RW", "SPARE31_24", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{23, 23, 0x0000000000000000, "RW", "VTDD", "0: Enable VTd  1: Disable VTd"},
#else
{23, 23, 0x0000000000000000, "RW", "VTDD", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{22, 22, 0x0000000000000000, "RW", "FUSE_SPARE22", "Fuse backed spare."},
#else
{22, 22, 0x0000000000000000, "RW", "FUSE_SPARE22", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{21, 21, 0x0000000000000000, "RW", "FUSE_SPARE21", "Fuse backed spare."},
#else
{21, 21, 0x0000000000000000, "RW", "FUSE_SPARE21", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{20, 20, 0x0000000000000000, "RW", "FUSE_SPARE20", "Fuse backed spare."},
#else
{20, 20, 0x0000000000000000, "RW", "FUSE_SPARE20", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{19, 19, 0x0000000000000000, "RW", "FUSE_SPARE19", "Fuse backed spare."},
#else
{19, 19, 0x0000000000000000, "RW", "FUSE_SPARE19", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{18, 18, 0x0000000000000000, "RW", "FUSE_SPARE18", "Fuse backed spare."},
#else
{18, 18, 0x0000000000000000, "RW", "FUSE_SPARE18", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{17, 17, 0x0000000000000000, "RW", "FUSE_SPARE17", "Fuse backed spare."},
#else
{17, 17, 0x0000000000000000, "RW", "FUSE_SPARE17", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{16, 16, 0x0000000000000000, "RW", "FUSE_SPARE16", "Fuse backed spare."},
#else
{16, 16, 0x0000000000000000, "RW", "FUSE_SPARE16", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{15, 15, 0x0000000000000000, "RW", "CDD", "0: DPTF Camarillo associated memory spaces are accessible.  1: DPTF Camarillo associated memory and IO spaces are disabled.  DEVEN_0_0_0_PCI field for DPTF can not be set."},
#else
{15, 15, 0x0000000000000000, "RW", "CDD", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{14, 14, 0x0000000000000000, "RW", "FUSE_SPARE14", "Fuse backed spare."},
#else
{14, 14, 0x0000000000000000, "RW", "FUSE_SPARE14", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{13, 13, 0x0000000000000000, "RW", "FUSE_SPARE13", "Fuse backed spare."},
#else
{13, 13, 0x0000000000000000, "RW", "FUSE_SPARE13", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{12, 12, 0x0000000000000000, "RW", "FUSE_SPARE12", "Fuse backed spare."},
#else
{12, 12, 0x0000000000000000, "RW", "FUSE_SPARE12", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{11, 11, 0x0000000000000000, "RW", "IGD", "0: There is a graphics engine within this CPU. Internal Graphics Device Device 2 is enabled and all of its memory and I/O spaces are accessable. Configuration cycles to Device 2 will be completed within the CPU. All nonSMM memory and IO accesses to VGA will be handled based on Memory and IO enables of Device 2 and IO registers within Device 2 and VGA Enable of the PCI to PCI bridge control register in Devices 1 and 6 If PCI Express GFX attach is supported. A selected amount of Graphics Memory space is preallocated from the main memory based on Graphics Mode Select GMS in the GGC Register. Graphics Memory is preallocated above TSEG Memory.  1: There is no graphics engine within this CPU. Internal Graphics Device Device 2 and all of its memory and I/O functions are disabled. Configuration cycle targeted to Device 2 will be passed on to DMI. In addition all clocks to internal graphics logic are turned off. All nonSMM memory and IO accesses to VGA will be handled based on VGA Enable of the PCI to PCI bridge control register in Devices 1 and 6. DEVEN [4:3] Device 0 offset 54h have no meaning. Device 2 Functions 0 and 1 are disabled and hidden."},
#else
{11, 11, 0x0000000000000000, "RW", "IGD", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{10, 10, 0x0000000000000000, "RO", "DIDOE", "Controls if there is an override of Dev2 GFX device ID. This functionality is not needed on BXT because Dev2 supports receiving the SetIDValue message for changing device ID. Hardwired to 1b0.   0b Disable ability to override DID  For production  1b Enable ability to override DID  For debug and samples only"},
#else
{10, 10, 0x0000000000000000, "RO", "DIDOE", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{8, 9, 0x0000000000000000, "RO", "CDID", "Controls the value of Dev2 GFX device ID. This functionality is not needed on BXT because Dev2 supports receiving the SetIDValue message for changing device ID. Hardwared to 2b00.  Identifier assigned to the core/primary PCI device.The corresponding two bit capability ID  programming is:  00: Desktop  01: Mobile  10: Server  11: Marketing Spare"},
#else
{8, 9, 0x0000000000000000, "RO", "CDID", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 7, 0x0000000000000000, "RW", "SPARE7_0", "Reserved for future capabilities"},
#else
{0, 7, 0x0000000000000000, "RW", "SPARE7_0", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo805[] = {{"B_CR_CAPID0_A_0_0_0_PCI", "", 0x000000E4, 17, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields806[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{31, 31, 0x0000000000000000, "RW", "IMGU_DIS", "0: Imaging Unit associated memory spaces are accessible.  1: Imaging Unit associated memory and IO spaces are disabled.  DEVEN_0_0_0_PCI field for Iunit can not be set."},
#else
{31, 31, 0x0000000000000000, "RW", "IMGU_DIS", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{30, 30, 0x0000000000000000, "RW", "FUSE_SPARE30", "Fuse backed spare."},
#else
{30, 30, 0x0000000000000000, "RW", "FUSE_SPARE30", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{29, 29, 0x0000000000000000, "RW", "FUSE_SPARE29", "Fuse backed spares potentially to be used for PKGTYP encoding."},
#else
{29, 29, 0x0000000000000000, "RW", "FUSE_SPARE29", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{28, 28, 0x0000000000000000, "RW", "FUSE_SPARE28", "Fuse backed spares potentially to be used for PKGTYP encoding."},
#else
{28, 28, 0x0000000000000000, "RW", "FUSE_SPARE28", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{27, 27, 0x0000000000000000, "RW", "FUSE_SPARE27", "Fuse backed spares potentially to be used for PKGTYP encoding."},
#else
{27, 27, 0x0000000000000000, "RW", "FUSE_SPARE27", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{26, 26, 0x0000000000000000, "RW", "FUSE_SPARE26", "Fuse backed spares potentially to be used for PKGTYP encoding."},
#else
{26, 26, 0x0000000000000000, "RW", "FUSE_SPARE26", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{25, 25, 0x0000000000000000, "RW", "FUSE_SPARE25", "Fuse backed spares potentially to be used for PKGTYP encoding."},
#else
{25, 25, 0x0000000000000000, "RW", "FUSE_SPARE25", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{24, 24, 0x0000000000000000, "RW", "SVMDIS", "0: Enable SVM mode  1: Disable SVM mode"},
#else
{24, 24, 0x0000000000000000, "RW", "SVMDIS", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 23, 0x0000000000000000, "RW", "SPARE23_0", "Reserved for future capabilities."},
#else
{0, 23, 0x0000000000000000, "RW", "SPARE23_0", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo806[] = {{"B_CR_CAPID0_B_0_0_0_PCI", "", 0x000000E8, 9, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields807[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{1, 7, 0x0000000000000000, "RO", "RESERVED_0", "Reserved"},
#else
{1, 7, 0x0000000000000000, "RO", "RESERVED_0", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 0, 0x0000000000000000, "RO/V", "SECURE_BOOT_ALLOWED", "0:  Secure boot is disabled.  1: Secure boot is enabled."},
#else
{0, 0, 0x0000000000000000, "RO/V", "SECURE_BOOT_ALLOWED", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo807[] = {{"B_CR_SECURE_BOOT_ALLOWED", "", 0x00001000, 2, 0x00000000000000FF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields808[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{63, 63, 0x0000000000000000, "RW", "PSMI_MODE", "When set, indicates that PSMI mode is enabled"},
#else
{63, 63, 0x0000000000000000, "RW", "PSMI_MODE", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{62, 62, 0x0000000000000000, "RW", "COPY_DIRECTION", "0: upon de-assertion of PSMI_Wipe signal, Bunit will copy the 46-bit HH Timer to the shadow register.  This mode is used during PSMI trace Collect mode on silicon. 1: upon de-assertion of PSMI_Wipe signal, Bunit will copy the shadow register value to the 46-bit Hammock Harbor Timer.  This mode is used during PSMI trace Replay mode on emulation."},
#else
{62, 62, 0x0000000000000000, "RW", "COPY_DIRECTION", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{46, 61, 0x0000000000000000, "RO", "RESERVED_0", "Reserved"},
#else
{46, 61, 0x0000000000000000, "RO", "RESERVED_0", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 45, 0x0000000000000000, "RW/V", "MOT_HH_TIMER_SHADOW", "Shadow copy of the MOT Hammock Harbor Timer counter."},
#else
{0, 45, 0x0000000000000000, "RW/V", "MOT_HH_TIMER_SHADOW", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo808[] = {{"B_CR_MOT_HH_TIMER_SHADOW", "", 0x00004B00, 4, 0xFFFFFFFFFFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields809[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{6, 31, 0x0000000000000000, "RO", "RESERVED_2", "Reserved"},
#else
{6, 31, 0x0000000000000000, "RO", "RESERVED_2", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{5, 5, 0x0000000000000000, "RW", "HAE", "Hardware Autonomous Enable"},
#else
{5, 5, 0x0000000000000000, "RW", "HAE", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{4, 4, 0x0000000000000000, "RO", "RESERVED_1", "Reserved"},
#else
{4, 4, 0x0000000000000000, "RO", "RESERVED_1", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{3, 3, 0x0000000000000001, "RW", "SE", "Sleep Enable"},
#else
{3, 3, 0x0000000000000001, "RW", "SE", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{1, 2, 0x0000000000000000, "RO", "RESERVED_0", "Reserved"},
#else
{1, 2, 0x0000000000000000, "RO", "RESERVED_0", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 0, 0x0000000000000001, "RW", "PMCRE", "PMC Request Enable"},
#else
{0, 0, 0x0000000000000001, "RW", "PMCRE", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo809[] = {{"B_CR_PGCB_PWRGATE_PCE", "", 0x00004B10, 6, 0x00000000FFFFFFFF, 0x0000000000000009}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields810[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{4, 31, 0x0000000000000000, "RO", "RESERVED_0", "Reserved"},
#else
{4, 31, 0x0000000000000000, "RO", "RESERVED_0", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 3, 0x0000000000000002, "RW", "cfg_pwrgate_holdoff", "Power gating hold-off time. This is the min time from when all internal Idle conditions have been observed to when PGCB starts the power gating sequence. The actual time is 2^value."},
#else
{0, 3, 0x0000000000000002, "RW", "cfg_pwrgate_holdoff", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo810[] = {{"B_CR_PGCB_PG_IDLE_TIMER", "", 0x00004B14, 2, 0x00000000FFFFFFFF, 0x0000000000000002}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields811[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{25, 31, 0x0000000000000000, "RO", "RESERVED_2", "Reserved"},
#else
{25, 31, 0x0000000000000000, "RO", "RESERVED_2", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{24, 24, 0x0000000000000000, "RW", "cfg_pgcb_clkgate_disabled", "PGCB clock gating disable. Controls whether the PGCB's own clock can be gated.  Set to disable PGCB clock gating.  Clear to enable PGCB clock gating."},
#else
{24, 24, 0x0000000000000000, "RW", "cfg_pgcb_clkgate_disabled", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{19, 23, 0x0000000000000000, "RO", "RESERVED_1", "Reserved"},
#else
{19, 23, 0x0000000000000000, "RO", "RESERVED_1", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{16, 18, 0x0000000000000000, "RW", "cfg_clkreq_ctl_disabled", "Trunk clock gating disable. 1 bit per domain: bit 16 = sideband clk, bit 17 = sa2xclk, bit 18 = sa1xclk.  Set to disable trunk clock gating.  Clear to enable trunk clock gating."},
#else
{16, 18, 0x0000000000000000, "RW", "cfg_clkreq_ctl_disabled", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{3, 15, 0x0000000000000000, "RO", "RESERVED_0", "Reserved"},
#else
{3, 15, 0x0000000000000000, "RO", "RESERVED_0", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 2, 0x0000000000000000, "RW", "cfg_clkgate_disabled", "Clock gating disable. 1 bit per domain. Bit 0: sideband clk, Bit 1: sa2xclk, Bit 2: sa1xclk.  Set to disable clock gating.  Clear to enable clock gating."},
#else
{0, 2, 0x0000000000000000, "RW", "cfg_clkgate_disabled", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo811[] = {{"B_CR_PGCB_CLKGATE_DIS", "", 0x00004B18, 6, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields812[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{12, 31, 0x0000000000000000, "RO", "RESERVED_0", "Reserved"},
#else
{12, 31, 0x0000000000000000, "RO", "RESERVED_0", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{8, 11, 0x0000000000000004, "RW", "sa1xclk_cfg_clkgate_holdoff", "sa1xclk clock gating hold-off time.  This is the minimum time from sa1x clock request deassertion to when the clock can be gated.  The actual time is 2^value."},
#else
{8, 11, 0x0000000000000004, "RW", "sa1xclk_cfg_clkgate_holdoff", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{4, 7, 0x0000000000000004, "RW", "sa2xclk_cfg_clkgate_holdoff", "sa2xclk clock gating hold-off time.  This is the minimum time from sa2x clock request deassertion to when the clock can be gated.  The actual time is 2^value."},
#else
{4, 7, 0x0000000000000004, "RW", "sa2xclk_cfg_clkgate_holdoff", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 3, 0x0000000000000004, "RW", "sbclk_cfg_clkgate_holdoff", "sideband clock gating hold-off time.  This is the minimum time from sideband clock request deassertion to when the clock can be gated.  The actual time is 2^value."},
#else
{0, 3, 0x0000000000000004, "RW", "sbclk_cfg_clkgate_holdoff", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo812[] = {{"B_CR_PGCB_CG_IDLE_TIMER", "", 0x00004B1C, 4, 0x00000000FFFFFFFF, 0x0000000000000444}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields813[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{11, 63, 0x0000000000000000, "RO", "RESERVED_0", "Reserved"},
#else
{11, 63, 0x0000000000000000, "RO", "RESERVED_0", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{10, 10, 0x0000000000000000, "RW", "MC_RD_DATA_COR", "NonIDI access to MMIO"},
#else
{10, 10, 0x0000000000000000, "RW", "MC_RD_DATA_COR", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{9, 9, 0x0000000000000000, "RW", "MC_RD_DATA_UNC", "NonIDI access to MMIO"},
#else
{9, 9, 0x0000000000000000, "RW", "MC_RD_DATA_UNC", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{8, 8, 0x0000000000000000, "RW", "BRAM_RD_PAR", "BRAM Read parity error userver only feature"},
#else
{8, 8, 0x0000000000000000, "RW", "BRAM_RD_PAR", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{7, 7, 0x0000000000000000, "RW", "BRAM_WR_PAR", "BRAM Write parity error userver only feature"},
#else
{7, 7, 0x0000000000000000, "RW", "BRAM_WR_PAR", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{6, 6, 0x0000000000000000, "RW", "XUCODE_ERR", "XUCode Software initiated error.  FIXME: Meant for private, Intel only use."},
#else
{6, 6, 0x0000000000000000, "RW", "XUCODE_ERR", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{5, 5, 0x0000000000000000, "RW", "IA_HIT_GSM", "IA hit to graphics stolen memory"},
#else
{5, 5, 0x0000000000000000, "RW", "IA_HIT_GSM", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{4, 4, 0x0000000000000000, "RW", "MMIO_CLFLUSH", "ClFlush to MMIO"},
#else
{4, 4, 0x0000000000000000, "RW", "MMIO_CLFLUSH", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{3, 3, 0x0000000000000000, "RW", "MMIO_WBMTOIE", "WBMTo access to MMIO"},
#else
{3, 3, 0x0000000000000000, "RW", "MMIO_WBMTOIE", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{2, 2, 0x0000000000000000, "RW", "MMIO_HITM", "MMIO Access HITM"},
#else
{2, 2, 0x0000000000000000, "RW", "MMIO_HITM", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{1, 1, 0x0000000000000000, "RW", "PII_2_MMIO", "NonIDI access to MMIO"},
#else
{1, 1, 0x0000000000000000, "RW", "PII_2_MMIO", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 0, 0x0000000000000000, "RW", "UNS_IDI_OP", "Unsupported IDI Opcode"},
#else
{0, 0, 0x0000000000000000, "RW", "UNS_IDI_OP", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo813[] = {{"B_CR_MCI_CTL", "", 0x00004B20, 12, 0xFFFFFFFFFFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields814[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{63, 63, 0x0000000000000000, "RW/V", "MCI_STATUS_VALID", "MCI_Status Valid VAL: When set indicates the information in the rest of this register is valid.  Software is responsible for clearing the VAL flag."},
#else
{63, 63, 0x0000000000000000, "RW/V", "MCI_STATUS_VALID", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{62, 62, 0x0000000000000000, "RW/V", "ERR_OVERFLOW", "Error Overflow OVER: Indicates a second error was received while the MCI_Status Valid bit as set. The Bunit supports the Machine Check Overwrite rules for a Machine Check Overflow. For the purpose of Bunit error reporting corrected errors or SERRORs sent from the Dunit will be overwritten by any new errors received. The first uncorrected error received will not be overwritten by any new errors received."},
#else
{62, 62, 0x0000000000000000, "RW/V", "ERR_OVERFLOW", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{61, 61, 0x0000000000000000, "RW/V", "UNCORRECTED_ERR", "Uncorrected Error UC: Indicates that an uncorrected error was received by the Bunit. The source of the uncorrected error can be any of those as indicated in the MCI_CTL register.  For BXT when an error is logged both UC and PCC are set to 1.  In DNV corretable errors do no set UC and PCC."},
#else
{61, 61, 0x0000000000000000, "RW/V", "UNCORRECTED_ERR", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{60, 60, 0x0000000000000000, "RW/V", "ERR_ENABLED", "Error Reporting Enabled EN: Error reporting has been enabled by the MCI_CTL register"},
#else
{60, 60, 0x0000000000000000, "RW/V", "ERR_ENABLED", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{59, 59, 0x0000000000000000, "RW/V", "MCI_STATUS_MISCV", "MCI_MISC register Valid MISCV: This field will be 0 except for XuCode writter errors which set this field to 1."},
#else
{59, 59, 0x0000000000000000, "RW/V", "MCI_STATUS_MISCV", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{58, 58, 0x0000000000000000, "RW/V", "MCI_STATUS_ADDRV", "MCI_ADDR register Valid ADDRV: When set indicated the value stored in the MCI_ADDR register is valid."},
#else
{58, 58, 0x0000000000000000, "RW/V", "MCI_STATUS_ADDRV", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{57, 57, 0x0000000000000000, "RW/V", "PROCESSOR_CONTEXT_CORRUPTED", "Processor Context Corrupted PCC: When set indicates the state of the processor might have been corrupted. When clear indicates the error did not affect the processor state.   In BXT this field is set whenever an error is logged.  For Denverton UC and PCC are not set for correctable errors from the Dunit but uncorrectable errors will set both UC and PCC."},
#else
{57, 57, 0x0000000000000000, "RW/V", "PROCESSOR_CONTEXT_CORRUPTED", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{53, 56, 0x0000000000000000, "RO", "RESERVED_0", "Reserved. These bits correspond to S AR and Corrected Error Status indicator.  They are all readonly and always return 0s"},
#else
{53, 56, 0x0000000000000000, "RO", "RESERVED_0", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{52, 52, 0x0000000000000000, "RW/V", "CORRECTED_ERR_COUNT_OVERFLOW", "Corrected Error Count Overflow CERRCNTOVER: Sets if the corrected error count is saturated to 3FFh and another corrected error occurs."},
#else
{52, 52, 0x0000000000000000, "RW/V", "CORRECTED_ERR_COUNT_OVERFLOW", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{38, 51, 0x0000000000000000, "RW/V", "CORRECTED_ERR_COUNT", "Corrected Error Count CERRCNT: The number of corrected errors that have been received from the Dunit."},
#else
{38, 51, 0x0000000000000000, "RW/V", "CORRECTED_ERR_COUNT", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{37, 37, 0x0000000000000000, "RW/V", "BRAM_ERR", "BRAM Error: Parity Error on BRAM"},
#else
{37, 37, 0x0000000000000000, "RW/V", "BRAM_ERR", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{32, 36, 0x0000000000000000, "RW/V", "AGENT_ID", "Agent ID: Agent ID of request that had an ECC or BRAM error"},
#else
{32, 36, 0x0000000000000000, "RW/V", "AGENT_ID", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{16, 31, 0x0000000000000000, "RW/V", "MODEL_SPECIFIC_ERR_CODE", "Model Specific Error Code"},
#else
{16, 31, 0x0000000000000000, "RW/V", "MODEL_SPECIFIC_ERR_CODE", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 15, 0x0000000000000000, "RW/V", "MCA_ERR_CODE", "MCA Error Code"},
#else
{0, 15, 0x0000000000000000, "RW/V", "MCA_ERR_CODE", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo814[] = {{"B_CR_MCI_STATUS", "", 0x00004B28, 14, 0xFFFFFFFFFFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields815[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{40, 63, 0x0000000000000000, "RO", "RESERVED_0", "Reserved"},
#else
{40, 63, 0x0000000000000000, "RO", "RESERVED_0", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 39, 0x0000000000000000, "RW/V", "MCA_ADDRESS", "Address MCI_ADDR: When ADDRV is set in the MCI_STATUS register the memory or system address is stored in this register."},
#else
{0, 39, 0x0000000000000000, "RW/V", "MCA_ADDRESS", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo815[] = {{"B_CR_MCI_ADDR", "", 0x00004B30, 2, 0xFFFFFFFFFFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields816[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{0, 63, 0x0000000000000000, "RW/V", "MISC", "Misc info"},
#else
{0, 63, 0x0000000000000000, "RW/V", "MISC", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo816[] = {{"B_CR_MCI_MISC", "", 0x00004B38, 1, 0xFFFFFFFFFFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields817[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{31, 63, 0x0000000000000000, "RO", "RESERVED_1", "Reserved"},
#else
{31, 63, 0x0000000000000000, "RO", "RESERVED_1", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{30, 30, 0x0000000000000000, "RW", "CORRECTED_ERROR_INTERRUPT_ENABLE", "This bit is set by software to enable the generation of corrected error interrupts."},
#else
{30, 30, 0x0000000000000000, "RW", "CORRECTED_ERROR_INTERRUPT_ENABLE", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{15, 29, 0x0000000000000000, "RO", "RESERVED_0", "Reserved"},
#else
{15, 29, 0x0000000000000000, "RO", "RESERVED_0", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 14, 0x0000000000000000, "RW", "CORRECTED_ERROR_COUNT_THRESHOLD", "Corrected Error Count Threshold CECTHRSH: Specifies the value to use for the corrected error threshold."},
#else
{0, 14, 0x0000000000000000, "RW", "CORRECTED_ERROR_COUNT_THRESHOLD", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo817[] = {{"B_CR_MCI_CTL2", "", 0x00004B40, 4, 0xFFFFFFFFFFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields818[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{1, 31, 0x0000000000000000, "RO", "RESERVED_0", "Reserved"},
#else
{1, 31, 0x0000000000000000, "RO", "RESERVED_0", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 0, 0x0000000000000001, "RW", "MC_SIGNAL_MODE", "When set to 1  Bunit will not allow any transaction with uncorrectable error or subsequent memory transaction to propagate through to DRAM FIXME:  actually prevents only live data from returning to CPU and signal MC event to CPU if enabled in IA32_MC5_CTL. This will essentially hang CPU and CPU will end up with IERR shutdown.  Issue: When set to zero Bunit will allow transaction with an uncorrectable error to propagate and signal MC event to CPU if enabled in IA32_MC5_CTL.  If enabled MC event will be taken by CPU cores at the end of instruction boundary after it detected by ROB."},
#else
{0, 0, 0x0000000000000001, "RW", "MC_SIGNAL_MODE", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo818[] = {{"B_CR_BMCMODE_LOW", "", 0x00004B48, 2, 0x00000000FFFFFFFF, 0x0000000000000001}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields819[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{0, 31, 0x0000000000000000, "RO", "RESERVED_0", "Reserved"},
#else
{0, 31, 0x0000000000000000, "RO", "RESERVED_0", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo819[] = {{"B_CR_BMCMODE_HIGH", "", 0x00004B4C, 1, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields820[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{0, 63, 0x0000040061010202, "RW", "MEM_RANGE_CTRL_POL", "Bit vector used to determine which agents are allowed write access to the BIOSWR_RAC BIOSWR_WAC and BIOSWR_CP registers based on the value from the agents 6bit SAI field."},
#else
{0, 63, 0x0000040061010202, "RW", "MEM_RANGE_CTRL_POL", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo820[] = {{"B_CR_BIOSWR_CP", "", 0x00004B50, 1, 0xFFFFFFFFFFFFFFFF, 0x0000040061010202}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields821[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{0, 63, 0x00000C00630D0217, "RW", "MEM_RANGE_POL", "Bit vector used to determine which agents are allowed read access based on the agents 6bit encoded SAI value."},
#else
{0, 63, 0x00000C00630D0217, "RW", "MEM_RANGE_POL", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo821[] = {{"B_CR_BIOSWR_RAC", "", 0x00004B58, 1, 0xFFFFFFFFFFFFFFFF, 0x00000C00630D0217}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields822[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{0, 63, 0x00000C00610C0212, "RW", "MEM_RANGE_POL", "Bit vector used to determine which agents are allowed write access based on the agents 6bit encoded SAI value."},
#else
{0, 63, 0x00000C00610C0212, "RW", "MEM_RANGE_POL", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo822[] = {{"B_CR_BIOSWR_WAC", "", 0x00004B60, 1, 0xFFFFFFFFFFFFFFFF, 0x00000C00610C0212}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields823[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{0, 63, 0x00000C0061010202, "RW", "SMM_CTRL_POL", "Bunit SMM Control Policy: Bit vector used to determine which agents are allowed access to the BSMRRAC BSMRWAC and BSMRCP registers based on the value from the agents 6bit SAI field."},
#else
{0, 63, 0x00000C0061010202, "RW", "SMM_CTRL_POL", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo823[] = {{"B_CR_BSMRCP", "", 0x00004B68, 1, 0xFFFFFFFFFFFFFFFF, 0x00000C0061010202}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields824[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{63, 63, 0x0000000000000000, "RW", "SMM_SAI_POL_63", "Bunit SMM Read Access Policy: Bit vector used to determine which agents are allowed read access to the Bunit SMM Range from TSEGMB to BGSM1 based on the agents 6bit encoded SAI value."},
#else
{63, 63, 0x0000000000000000, "RW", "SMM_SAI_POL_63", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{62, 62, 0x0000000000000000, "RO", "SMM_SAI_POL_62", "Bunit SMM Read Access Policy: Bit vector used to determine which agents are allowed read access to the Bunit SMM Range from TSEGMB to BGSM1 based on the agents 6bit encoded SAI value."},
#else
{62, 62, 0x0000000000000000, "RO", "SMM_SAI_POL_62", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{61, 61, 0x0000000000000000, "RO", "SMM_SAI_POL_61", "Bunit SMM Read Access Policy: Bit vector used to determine which agents are allowed read access to the Bunit SMM Range from TSEGMB to BGSM1 based on the agents 6bit encoded SAI value."},
#else
{61, 61, 0x0000000000000000, "RO", "SMM_SAI_POL_61", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{60, 60, 0x0000000000000000, "RO", "SMM_SAI_POL_60", "Bunit SMM Read Access Policy: Bit vector used to determine which agents are allowed read access to the Bunit SMM Range from TSEGMB to BGSM1 based on the agents 6bit encoded SAI value."},
#else
{60, 60, 0x0000000000000000, "RO", "SMM_SAI_POL_60", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{59, 59, 0x0000000000000000, "RO", "SMM_SAI_POL_59", "Bunit SMM Read Access Policy: Bit vector used to determine which agents are allowed read access to the Bunit SMM Range from TSEGMB to BGSM1 based on the agents 6bit encoded SAI value."},
#else
{59, 59, 0x0000000000000000, "RO", "SMM_SAI_POL_59", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{58, 58, 0x0000000000000000, "RO", "SMM_SAI_POL_58", "Bunit SMM Read Access Policy: Bit vector used to determine which agents are allowed read access to the Bunit SMM Range from TSEGMB to BGSM1 based on the agents 6bit encoded SAI value."},
#else
{58, 58, 0x0000000000000000, "RO", "SMM_SAI_POL_58", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{57, 57, 0x0000000000000000, "RO", "SMM_SAI_POL_57", "Bunit SMM Read Access Policy: Bit vector used to determine which agents are allowed read access to the Bunit SMM Range from TSEGMB to BGSM1 based on the agents 6bit encoded SAI value."},
#else
{57, 57, 0x0000000000000000, "RO", "SMM_SAI_POL_57", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{56, 56, 0x0000000000000000, "RW", "SMM_SAI_POL_56", "Bunit SMM Read Access Policy: Bit vector used to determine which agents are allowed read access to the Bunit SMM Range from TSEGMB to BGSM1 based on the agents 6bit encoded SAI value."},
#else
{56, 56, 0x0000000000000000, "RW", "SMM_SAI_POL_56", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{55, 55, 0x0000000000000000, "RW", "SMM_SAI_POL_55", "Bunit SMM Read Access Policy: Bit vector used to determine which agents are allowed read access to the Bunit SMM Range from TSEGMB to BGSM1 based on the agents 6bit encoded SAI value."},
#else
{55, 55, 0x0000000000000000, "RW", "SMM_SAI_POL_55", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{54, 54, 0x0000000000000000, "RW", "SMM_SAI_POL_54", "Bunit SMM Read Access Policy: Bit vector used to determine which agents are allowed read access to the Bunit SMM Range from TSEGMB to BGSM1 based on the agents 6bit encoded SAI value."},
#else
{54, 54, 0x0000000000000000, "RW", "SMM_SAI_POL_54", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{53, 53, 0x0000000000000000, "RO", "SMM_SAI_POL_53", "Bunit SMM Read Access Policy: Bit vector used to determine which agents are allowed read access to the Bunit SMM Range from TSEGMB to BGSM1 based on the agents 6bit encoded SAI value."},
#else
{53, 53, 0x0000000000000000, "RO", "SMM_SAI_POL_53", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{52, 52, 0x0000000000000000, "RO", "SMM_SAI_POL_52", "Bunit SMM Read Access Policy: Bit vector used to determine which agents are allowed read access to the Bunit SMM Range from TSEGMB to BGSM1 based on the agents 6bit encoded SAI value."},
#else
{52, 52, 0x0000000000000000, "RO", "SMM_SAI_POL_52", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{51, 51, 0x0000000000000000, "RO", "SMM_SAI_POL_51", "Bunit SMM Read Access Policy: Bit vector used to determine which agents are allowed read access to the Bunit SMM Range from TSEGMB to BGSM1 based on the agents 6bit encoded SAI value."},
#else
{51, 51, 0x0000000000000000, "RO", "SMM_SAI_POL_51", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{50, 50, 0x0000000000000000, "RW", "SMM_SAI_POL_50", "Bunit SMM Read Access Policy: Bit vector used to determine which agents are allowed read access to the Bunit SMM Range from TSEGMB to BGSM1 based on the agents 6bit encoded SAI value."},
#else
{50, 50, 0x0000000000000000, "RW", "SMM_SAI_POL_50", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{49, 49, 0x0000000000000000, "RW", "SMM_SAI_POL_49", "Bunit SMM Read Access Policy: Bit vector used to determine which agents are allowed read access to the Bunit SMM Range from TSEGMB to BGSM1 based on the agents 6bit encoded SAI value."},
#else
{49, 49, 0x0000000000000000, "RW", "SMM_SAI_POL_49", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{48, 48, 0x0000000000000000, "RW", "SMM_SAI_POL_48", "Bunit SMM Read Access Policy: Bit vector used to determine which agents are allowed read access to the Bunit SMM Range from TSEGMB to BGSM1 based on the agents 6bit encoded SAI value."},
#else
{48, 48, 0x0000000000000000, "RW", "SMM_SAI_POL_48", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{47, 47, 0x0000000000000000, "RO", "SMM_SAI_POL_47", "Bunit SMM Read Access Policy: Bit vector used to determine which agents are allowed read access to the Bunit SMM Range from TSEGMB to BGSM1 based on the agents 6bit encoded SAI value."},
#else
{47, 47, 0x0000000000000000, "RO", "SMM_SAI_POL_47", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{46, 46, 0x0000000000000000, "RO", "SMM_SAI_POL_46", "Bunit SMM Read Access Policy: Bit vector used to determine which agents are allowed read access to the Bunit SMM Range from TSEGMB to BGSM1 based on the agents 6bit encoded SAI value."},
#else
{46, 46, 0x0000000000000000, "RO", "SMM_SAI_POL_46", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{45, 45, 0x0000000000000000, "RO", "SMM_SAI_POL_45", "Bunit SMM Read Access Policy: Bit vector used to determine which agents are allowed read access to the Bunit SMM Range from TSEGMB to BGSM1 based on the agents 6bit encoded SAI value."},
#else
{45, 45, 0x0000000000000000, "RO", "SMM_SAI_POL_45", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{44, 44, 0x0000000000000000, "RW", "SMM_SAI_POL_44", "Bunit SMM Read Access Policy: Bit vector used to determine which agents are allowed read access to the Bunit SMM Range from TSEGMB to BGSM1 based on the agents 6bit encoded SAI value."},
#else
{44, 44, 0x0000000000000000, "RW", "SMM_SAI_POL_44", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{43, 43, 0x0000000000000000, "RW", "SMM_SAI_POL_43", "Bunit SMM Read Access Policy: Bit vector used to determine which agents are allowed read access to the Bunit SMM Range from TSEGMB to BGSM1 based on the agents 6bit encoded SAI value."},
#else
{43, 43, 0x0000000000000000, "RW", "SMM_SAI_POL_43", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{42, 42, 0x0000000000000000, "RW", "SMM_SAI_POL_42", "Bunit SMM Read Access Policy: Bit vector used to determine which agents are allowed read access to the Bunit SMM Range from TSEGMB to BGSM1 based on the agents 6bit encoded SAI value."},
#else
{42, 42, 0x0000000000000000, "RW", "SMM_SAI_POL_42", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{41, 41, 0x0000000000000000, "RW", "SMM_SAI_POL_41", "Bunit SMM Read Access Policy: Bit vector used to determine which agents are allowed read access to the Bunit SMM Range from TSEGMB to BGSM1 based on the agents 6bit encoded SAI value."},
#else
{41, 41, 0x0000000000000000, "RW", "SMM_SAI_POL_41", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{40, 40, 0x0000000000000000, "RW", "SMM_SAI_POL_40", "Bunit SMM Read Access Policy: Bit vector used to determine which agents are allowed read access to the Bunit SMM Range from TSEGMB to BGSM1 based on the agents 6bit encoded SAI value."},
#else
{40, 40, 0x0000000000000000, "RW", "SMM_SAI_POL_40", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{39, 39, 0x0000000000000000, "RO", "SMM_SAI_POL_39", "Bunit SMM Read Access Policy: Bit vector used to determine which agents are allowed read access to the Bunit SMM Range from TSEGMB to BGSM1 based on the agents 6bit encoded SAI value."},
#else
{39, 39, 0x0000000000000000, "RO", "SMM_SAI_POL_39", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{38, 38, 0x0000000000000000, "RW", "SMM_SAI_POL_38", "Bunit SMM Read Access Policy: Bit vector used to determine which agents are allowed read access to the Bunit SMM Range from TSEGMB to BGSM1 based on the agents 6bit encoded SAI value."},
#else
{38, 38, 0x0000000000000000, "RW", "SMM_SAI_POL_38", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{37, 37, 0x0000000000000000, "RO", "SMM_SAI_POL_37", "Bunit SMM Read Access Policy: Bit vector used to determine which agents are allowed read access to the Bunit SMM Range from TSEGMB to BGSM1 based on the agents 6bit encoded SAI value."},
#else
{37, 37, 0x0000000000000000, "RO", "SMM_SAI_POL_37", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{36, 36, 0x0000000000000000, "RW", "SMM_SAI_POL_36", "Bunit SMM Read Access Policy: Bit vector used to determine which agents are allowed read access to the Bunit SMM Range from TSEGMB to BGSM1 based on the agents 6bit encoded SAI value."},
#else
{36, 36, 0x0000000000000000, "RW", "SMM_SAI_POL_36", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{35, 35, 0x0000000000000000, "RO", "SMM_SAI_POL_35", "Bunit SMM Read Access Policy: Bit vector used to determine which agents are allowed read access to the Bunit SMM Range from TSEGMB to BGSM1 based on the agents 6bit encoded SAI value."},
#else
{35, 35, 0x0000000000000000, "RO", "SMM_SAI_POL_35", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{34, 34, 0x0000000000000000, "RW", "SMM_SAI_POL_34", "Bunit SMM Read Access Policy: Bit vector used to determine which agents are allowed read access to the Bunit SMM Range from TSEGMB to BGSM1 based on the agents 6bit encoded SAI value."},
#else
{34, 34, 0x0000000000000000, "RW", "SMM_SAI_POL_34", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{33, 33, 0x0000000000000000, "RW", "SMM_SAI_POL_33", "Bunit SMM Read Access Policy: Bit vector used to determine which agents are allowed read access to the Bunit SMM Range from TSEGMB to BGSM1 based on the agents 6bit encoded SAI value."},
#else
{33, 33, 0x0000000000000000, "RW", "SMM_SAI_POL_33", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{32, 32, 0x0000000000000000, "RW", "SMM_SAI_POL_32", "Bunit SMM Read Access Policy: Bit vector used to determine which agents are allowed read access to the Bunit SMM Range from TSEGMB to BGSM1 based on the agents 6bit encoded SAI value."},
#else
{32, 32, 0x0000000000000000, "RW", "SMM_SAI_POL_32", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{31, 31, 0x0000000000000000, "RO", "SMM_SAI_POL_31", "Bunit SMM Read Access Policy: Bit vector used to determine which agents are allowed read access to the Bunit SMM Range from TSEGMB to BGSM1 based on the agents 6bit encoded SAI value."},
#else
{31, 31, 0x0000000000000000, "RO", "SMM_SAI_POL_31", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{30, 30, 0x0000000000000000, "RW", "SMM_SAI_POL_30", "Bunit SMM Read Access Policy: Bit vector used to determine which agents are allowed read access to the Bunit SMM Range from TSEGMB to BGSM1 based on the agents 6bit encoded SAI value."},
#else
{30, 30, 0x0000000000000000, "RW", "SMM_SAI_POL_30", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{29, 29, 0x0000000000000000, "RW", "SMM_SAI_POL_29", "Bunit SMM Read Access Policy: Bit vector used to determine which agents are allowed read access to the Bunit SMM Range from TSEGMB to BGSM1 based on the agents 6bit encoded SAI value."},
#else
{29, 29, 0x0000000000000000, "RW", "SMM_SAI_POL_29", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{28, 28, 0x0000000000000000, "RW", "SMM_SAI_POL_28", "Bunit SMM Read Access Policy: Bit vector used to determine which agents are allowed read access to the Bunit SMM Range from TSEGMB to BGSM1 based on the agents 6bit encoded SAI value."},
#else
{28, 28, 0x0000000000000000, "RW", "SMM_SAI_POL_28", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{27, 27, 0x0000000000000000, "RW", "SMM_SAI_POL_27", "Bunit SMM Read Access Policy: Bit vector used to determine which agents are allowed read access to the Bunit SMM Range from TSEGMB to BGSM1 based on the agents 6bit encoded SAI value."},
#else
{27, 27, 0x0000000000000000, "RW", "SMM_SAI_POL_27", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{26, 26, 0x0000000000000000, "RW", "SMM_SAI_POL_26", "Bunit SMM Read Access Policy: Bit vector used to determine which agents are allowed read access to the Bunit SMM Range from TSEGMB to BGSM1 based on the agents 6bit encoded SAI value."},
#else
{26, 26, 0x0000000000000000, "RW", "SMM_SAI_POL_26", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{25, 25, 0x0000000000000000, "RW", "SMM_SAI_POL_25", "Bunit SMM Read Access Policy: Bit vector used to determine which agents are allowed read access to the Bunit SMM Range from TSEGMB to BGSM1 based on the agents 6bit encoded SAI value."},
#else
{25, 25, 0x0000000000000000, "RW", "SMM_SAI_POL_25", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{24, 24, 0x0000000000000000, "RW", "SMM_SAI_POL_24", "Bunit SMM Read Access Policy: Bit vector used to determine which agents are allowed read access to the Bunit SMM Range from TSEGMB to BGSM1 based on the agents 6bit encoded SAI value."},
#else
{24, 24, 0x0000000000000000, "RW", "SMM_SAI_POL_24", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{23, 23, 0x0000000000000000, "RO", "SMM_SAI_POL_23", "Bunit SMM Read Access Policy: Bit vector used to determine which agents are allowed read access to the Bunit SMM Range from TSEGMB to BGSM1 based on the agents 6bit encoded SAI value."},
#else
{23, 23, 0x0000000000000000, "RO", "SMM_SAI_POL_23", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{22, 22, 0x0000000000000000, "RO", "SMM_SAI_POL_22", "Bunit SMM Read Access Policy: Bit vector used to determine which agents are allowed read access to the Bunit SMM Range from TSEGMB to BGSM1 based on the agents 6bit encoded SAI value."},
#else
{22, 22, 0x0000000000000000, "RO", "SMM_SAI_POL_22", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{21, 21, 0x0000000000000000, "RW", "SMM_SAI_POL_21", "Bunit SMM Read Access Policy: Bit vector used to determine which agents are allowed read access to the Bunit SMM Range from TSEGMB to BGSM1 based on the agents 6bit encoded SAI value."},
#else
{21, 21, 0x0000000000000000, "RW", "SMM_SAI_POL_21", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{20, 20, 0x0000000000000000, "RO", "SMM_SAI_POL_20", "Bunit SMM Read Access Policy: Bit vector used to determine which agents are allowed read access to the Bunit SMM Range from TSEGMB to BGSM1 based on the agents 6bit encoded SAI value."},
#else
{20, 20, 0x0000000000000000, "RO", "SMM_SAI_POL_20", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{19, 19, 0x0000000000000000, "RO", "SMM_SAI_POL_19", "Bunit SMM Read Access Policy: Bit vector used to determine which agents are allowed read access to the Bunit SMM Range from TSEGMB to BGSM1 based on the agents 6bit encoded SAI value."},
#else
{19, 19, 0x0000000000000000, "RO", "SMM_SAI_POL_19", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{18, 18, 0x0000000000000000, "RO", "SMM_SAI_POL_18", "Bunit SMM Read Access Policy: Bit vector used to determine which agents are allowed read access to the Bunit SMM Range from TSEGMB to BGSM1 based on the agents 6bit encoded SAI value."},
#else
{18, 18, 0x0000000000000000, "RO", "SMM_SAI_POL_18", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{17, 17, 0x0000000000000000, "RW", "SMM_SAI_POL_17", "Bunit SMM Read Access Policy: Bit vector used to determine which agents are allowed read access to the Bunit SMM Range from TSEGMB to BGSM1 based on the agents 6bit encoded SAI value."},
#else
{17, 17, 0x0000000000000000, "RW", "SMM_SAI_POL_17", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{16, 16, 0x0000000000000001, "RW", "SMM_SAI_POL_16", "Bunit SMM Read Access Policy: Bit vector used to determine which agents are allowed read access to the Bunit SMM Range from TSEGMB to BGSM1 based on the agents 6bit encoded SAI value."},
#else
{16, 16, 0x0000000000000001, "RW", "SMM_SAI_POL_16", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{15, 15, 0x0000000000000000, "RO", "SMM_SAI_POL_15", "Bunit SMM Read Access Policy: Bit vector used to determine which agents are allowed read access to the Bunit SMM Range from TSEGMB to BGSM1 based on the agents 6bit encoded SAI value."},
#else
{15, 15, 0x0000000000000000, "RO", "SMM_SAI_POL_15", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{14, 14, 0x0000000000000000, "RO", "SMM_SAI_POL_14", "Bunit SMM Read Access Policy: Bit vector used to determine which agents are allowed read access to the Bunit SMM Range from TSEGMB to BGSM1 based on the agents 6bit encoded SAI value."},
#else
{14, 14, 0x0000000000000000, "RO", "SMM_SAI_POL_14", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{13, 13, 0x0000000000000000, "RW", "SMM_SAI_POL_13", "Bunit SMM Read Access Policy: Bit vector used to determine which agents are allowed read access to the Bunit SMM Range from TSEGMB to BGSM1 based on the agents 6bit encoded SAI value."},
#else
{13, 13, 0x0000000000000000, "RW", "SMM_SAI_POL_13", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{12, 12, 0x0000000000000000, "RW", "SMM_SAI_POL_12", "Bunit SMM Read Access Policy: Bit vector used to determine which agents are allowed read access to the Bunit SMM Range from TSEGMB to BGSM1 based on the agents 6bit encoded SAI value."},
#else
{12, 12, 0x0000000000000000, "RW", "SMM_SAI_POL_12", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{11, 11, 0x0000000000000000, "RO", "SMM_SAI_POL_11", "Bunit SMM Read Access Policy: Bit vector used to determine which agents are allowed read access to the Bunit SMM Range from TSEGMB to BGSM1 based on the agents 6bit encoded SAI value."},
#else
{11, 11, 0x0000000000000000, "RO", "SMM_SAI_POL_11", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{10, 10, 0x0000000000000000, "RO", "SMM_SAI_POL_10", "Bunit SMM Read Access Policy: Bit vector used to determine which agents are allowed read access to the Bunit SMM Range from TSEGMB to BGSM1 based on the agents 6bit encoded SAI value."},
#else
{10, 10, 0x0000000000000000, "RO", "SMM_SAI_POL_10", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{9, 9, 0x0000000000000000, "RO", "SMM_SAI_POL_9", "Bunit SMM Read Access Policy: Bit vector used to determine which agents are allowed read access to the Bunit SMM Range from TSEGMB to BGSM1 based on the agents 6bit encoded SAI value."},
#else
{9, 9, 0x0000000000000000, "RO", "SMM_SAI_POL_9", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{8, 8, 0x0000000000000000, "RW", "SMM_SAI_POL_8", "Bunit SMM Read Access Policy: Bit vector used to determine which agents are allowed read access to the Bunit SMM Range from TSEGMB to BGSM1 based on the agents 6bit encoded SAI value."},
#else
{8, 8, 0x0000000000000000, "RW", "SMM_SAI_POL_8", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{7, 7, 0x0000000000000000, "RO", "SMM_SAI_POL_7", "Bunit SMM Read Access Policy: Bit vector used to determine which agents are allowed read access to the Bunit SMM Range from TSEGMB to BGSM1 based on the agents 6bit encoded SAI value."},
#else
{7, 7, 0x0000000000000000, "RO", "SMM_SAI_POL_7", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{6, 6, 0x0000000000000000, "RO", "SMM_SAI_POL_6", "Bunit SMM Read Access Policy: Bit vector used to determine which agents are allowed read access to the Bunit SMM Range from TSEGMB to BGSM1 based on the agents 6bit encoded SAI value."},
#else
{6, 6, 0x0000000000000000, "RO", "SMM_SAI_POL_6", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{5, 5, 0x0000000000000000, "RW", "SMM_SAI_POL_5", "Bunit SMM Read Access Policy: Bit vector used to determine which agents are allowed read access to the Bunit SMM Range from TSEGMB to BGSM1 based on the agents 6bit encoded SAI value."},
#else
{5, 5, 0x0000000000000000, "RW", "SMM_SAI_POL_5", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{4, 4, 0x0000000000000001, "RW", "SMM_SAI_POL_4", "Bunit SMM Read Access Policy: Bit vector used to determine which agents are allowed read access to the Bunit SMM Range from TSEGMB to BGSM1 based on the agents 6bit encoded SAI value."},
#else
{4, 4, 0x0000000000000001, "RW", "SMM_SAI_POL_4", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{3, 3, 0x0000000000000000, "RW", "SMM_SAI_POL_3", "Bunit SMM Read Access Policy: Bit vector used to determine which agents are allowed read access to the Bunit SMM Range from TSEGMB to BGSM1 based on the agents 6bit encoded SAI value."},
#else
{3, 3, 0x0000000000000000, "RW", "SMM_SAI_POL_3", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{2, 2, 0x0000000000000001, "RW", "SMM_SAI_POL_2", "Bunit SMM Read Access Policy: Bit vector used to determine which agents are allowed read access to the Bunit SMM Range from TSEGMB to BGSM1 based on the agents 6bit encoded SAI value."},
#else
{2, 2, 0x0000000000000001, "RW", "SMM_SAI_POL_2", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{1, 1, 0x0000000000000001, "RW", "SMM_SAI_POL_1", "Bunit SMM Read Access Policy: Bit vector used to determine which agents are allowed read access to the Bunit SMM Range from TSEGMB to BGSM1 based on the agents 6bit encoded SAI value."},
#else
{1, 1, 0x0000000000000001, "RW", "SMM_SAI_POL_1", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 0, 0x0000000000000001, "RW", "SMM_SAI_POL_0", "Bunit SMM Read Access Policy: Bit vector used to determine which agents are allowed read access to the Bunit SMM Range from TSEGMB to BGSM1 based on the agents 6bit encoded SAI value."},
#else
{0, 0, 0x0000000000000001, "RW", "SMM_SAI_POL_0", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo824[] = {{"B_CR_BSMRRAC", "", 0x00004B70, 64, 0xFFFFFFFFFFFFFFFF, 0x0000000000010017}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields825[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{63, 63, 0x0000000000000000, "RW", "SMM_SAI_POL_63", "Bunit SMM Write Access Policy: Bit vector used to determine which agents are allowed write access to the Bunit SMM Range from TSEGMB to BGSM1 based on the agents 6bit encoded SAI value."},
#else
{63, 63, 0x0000000000000000, "RW", "SMM_SAI_POL_63", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{62, 62, 0x0000000000000000, "RO", "SMM_SAI_POL_62", "Bunit SMM Write Access Policy: Bit vector used to determine which agents are allowed write access to the Bunit SMM Range from TSEGMB to BGSM1 based on the agents 6bit encoded SAI value."},
#else
{62, 62, 0x0000000000000000, "RO", "SMM_SAI_POL_62", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{61, 61, 0x0000000000000000, "RO", "SMM_SAI_POL_61", "Bunit SMM Write Access Policy: Bit vector used to determine which agents are allowed write access to the Bunit SMM Range from TSEGMB to BGSM1 based on the agents 6bit encoded SAI value."},
#else
{61, 61, 0x0000000000000000, "RO", "SMM_SAI_POL_61", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{60, 60, 0x0000000000000000, "RO", "SMM_SAI_POL_60", "Bunit SMM Write Access Policy: Bit vector used to determine which agents are allowed write access to the Bunit SMM Range from TSEGMB to BGSM1 based on the agents 6bit encoded SAI value."},
#else
{60, 60, 0x0000000000000000, "RO", "SMM_SAI_POL_60", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{59, 59, 0x0000000000000000, "RO", "SMM_SAI_POL_59", "Bunit SMM Write Access Policy: Bit vector used to determine which agents are allowed write access to the Bunit SMM Range from TSEGMB to BGSM1 based on the agents 6bit encoded SAI value."},
#else
{59, 59, 0x0000000000000000, "RO", "SMM_SAI_POL_59", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{58, 58, 0x0000000000000000, "RO", "SMM_SAI_POL_58", "Bunit SMM Write Access Policy: Bit vector used to determine which agents are allowed write access to the Bunit SMM Range from TSEGMB to BGSM1 based on the agents 6bit encoded SAI value."},
#else
{58, 58, 0x0000000000000000, "RO", "SMM_SAI_POL_58", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{57, 57, 0x0000000000000000, "RO", "SMM_SAI_POL_57", "Bunit SMM Write Access Policy: Bit vector used to determine which agents are allowed write access to the Bunit SMM Range from TSEGMB to BGSM1 based on the agents 6bit encoded SAI value."},
#else
{57, 57, 0x0000000000000000, "RO", "SMM_SAI_POL_57", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{56, 56, 0x0000000000000000, "RW", "SMM_SAI_POL_56", "Bunit SMM Write Access Policy: Bit vector used to determine which agents are allowed write access to the Bunit SMM Range from TSEGMB to BGSM1 based on the agents 6bit encoded SAI value."},
#else
{56, 56, 0x0000000000000000, "RW", "SMM_SAI_POL_56", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{55, 55, 0x0000000000000000, "RW", "SMM_SAI_POL_55", "Bunit SMM Write Access Policy: Bit vector used to determine which agents are allowed write access to the Bunit SMM Range from TSEGMB to BGSM1 based on the agents 6bit encoded SAI value."},
#else
{55, 55, 0x0000000000000000, "RW", "SMM_SAI_POL_55", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{54, 54, 0x0000000000000000, "RW", "SMM_SAI_POL_54", "Bunit SMM Write Access Policy: Bit vector used to determine which agents are allowed write access to the Bunit SMM Range from TSEGMB to BGSM1 based on the agents 6bit encoded SAI value."},
#else
{54, 54, 0x0000000000000000, "RW", "SMM_SAI_POL_54", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{53, 53, 0x0000000000000000, "RO", "SMM_SAI_POL_53", "Bunit SMM Write Access Policy: Bit vector used to determine which agents are allowed write access to the Bunit SMM Range from TSEGMB to BGSM1 based on the agents 6bit encoded SAI value."},
#else
{53, 53, 0x0000000000000000, "RO", "SMM_SAI_POL_53", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{52, 52, 0x0000000000000000, "RO", "SMM_SAI_POL_52", "Bunit SMM Write Access Policy: Bit vector used to determine which agents are allowed write access to the Bunit SMM Range from TSEGMB to BGSM1 based on the agents 6bit encoded SAI value."},
#else
{52, 52, 0x0000000000000000, "RO", "SMM_SAI_POL_52", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{51, 51, 0x0000000000000000, "RO", "SMM_SAI_POL_51", "Bunit SMM Write Access Policy: Bit vector used to determine which agents are allowed write access to the Bunit SMM Range from TSEGMB to BGSM1 based on the agents 6bit encoded SAI value."},
#else
{51, 51, 0x0000000000000000, "RO", "SMM_SAI_POL_51", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{50, 50, 0x0000000000000000, "RW", "SMM_SAI_POL_50", "Bunit SMM Write Access Policy: Bit vector used to determine which agents are allowed write access to the Bunit SMM Range from TSEGMB to BGSM1 based on the agents 6bit encoded SAI value."},
#else
{50, 50, 0x0000000000000000, "RW", "SMM_SAI_POL_50", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{49, 49, 0x0000000000000000, "RW", "SMM_SAI_POL_49", "Bunit SMM Write Access Policy: Bit vector used to determine which agents are allowed write access to the Bunit SMM Range from TSEGMB to BGSM1 based on the agents 6bit encoded SAI value."},
#else
{49, 49, 0x0000000000000000, "RW", "SMM_SAI_POL_49", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{48, 48, 0x0000000000000000, "RW", "SMM_SAI_POL_48", "Bunit SMM Write Access Policy: Bit vector used to determine which agents are allowed write access to the Bunit SMM Range from TSEGMB to BGSM1 based on the agents 6bit encoded SAI value."},
#else
{48, 48, 0x0000000000000000, "RW", "SMM_SAI_POL_48", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{47, 47, 0x0000000000000000, "RO", "SMM_SAI_POL_47", "Bunit SMM Write Access Policy: Bit vector used to determine which agents are allowed write access to the Bunit SMM Range from TSEGMB to BGSM1 based on the agents 6bit encoded SAI value."},
#else
{47, 47, 0x0000000000000000, "RO", "SMM_SAI_POL_47", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{46, 46, 0x0000000000000000, "RO", "SMM_SAI_POL_46", "Bunit SMM Write Access Policy: Bit vector used to determine which agents are allowed write access to the Bunit SMM Range from TSEGMB to BGSM1 based on the agents 6bit encoded SAI value."},
#else
{46, 46, 0x0000000000000000, "RO", "SMM_SAI_POL_46", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{45, 45, 0x0000000000000000, "RO", "SMM_SAI_POL_45", "Bunit SMM Write Access Policy: Bit vector used to determine which agents are allowed write access to the Bunit SMM Range from TSEGMB to BGSM1 based on the agents 6bit encoded SAI value."},
#else
{45, 45, 0x0000000000000000, "RO", "SMM_SAI_POL_45", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{44, 44, 0x0000000000000000, "RW", "SMM_SAI_POL_44", "Bunit SMM Write Access Policy: Bit vector used to determine which agents are allowed write access to the Bunit SMM Range from TSEGMB to BGSM1 based on the agents 6bit encoded SAI value."},
#else
{44, 44, 0x0000000000000000, "RW", "SMM_SAI_POL_44", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{43, 43, 0x0000000000000000, "RW", "SMM_SAI_POL_43", "Bunit SMM Write Access Policy: Bit vector used to determine which agents are allowed write access to the Bunit SMM Range from TSEGMB to BGSM1 based on the agents 6bit encoded SAI value."},
#else
{43, 43, 0x0000000000000000, "RW", "SMM_SAI_POL_43", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{42, 42, 0x0000000000000000, "RW", "SMM_SAI_POL_42", "Bunit SMM Write Access Policy: Bit vector used to determine which agents are allowed write access to the Bunit SMM Range from TSEGMB to BGSM1 based on the agents 6bit encoded SAI value."},
#else
{42, 42, 0x0000000000000000, "RW", "SMM_SAI_POL_42", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{41, 41, 0x0000000000000000, "RW", "SMM_SAI_POL_41", "Bunit SMM Write Access Policy: Bit vector used to determine which agents are allowed write access to the Bunit SMM Range from TSEGMB to BGSM1 based on the agents 6bit encoded SAI value."},
#else
{41, 41, 0x0000000000000000, "RW", "SMM_SAI_POL_41", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{40, 40, 0x0000000000000000, "RW", "SMM_SAI_POL_40", "Bunit SMM Write Access Policy: Bit vector used to determine which agents are allowed write access to the Bunit SMM Range from TSEGMB to BGSM1 based on the agents 6bit encoded SAI value."},
#else
{40, 40, 0x0000000000000000, "RW", "SMM_SAI_POL_40", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{39, 39, 0x0000000000000000, "RO", "SMM_SAI_POL_39", "Bunit SMM Write Access Policy: Bit vector used to determine which agents are allowed write access to the Bunit SMM Range from TSEGMB to BGSM1 based on the agents 6bit encoded SAI value."},
#else
{39, 39, 0x0000000000000000, "RO", "SMM_SAI_POL_39", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{38, 38, 0x0000000000000000, "RW", "SMM_SAI_POL_38", "Bunit SMM Write Access Policy: Bit vector used to determine which agents are allowed write access to the Bunit SMM Range from TSEGMB to BGSM1 based on the agents 6bit encoded SAI value."},
#else
{38, 38, 0x0000000000000000, "RW", "SMM_SAI_POL_38", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{37, 37, 0x0000000000000000, "RO", "SMM_SAI_POL_37", "Bunit SMM Write Access Policy: Bit vector used to determine which agents are allowed write access to the Bunit SMM Range from TSEGMB to BGSM1 based on the agents 6bit encoded SAI value."},
#else
{37, 37, 0x0000000000000000, "RO", "SMM_SAI_POL_37", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{36, 36, 0x0000000000000000, "RW", "SMM_SAI_POL_36", "Bunit SMM Write Access Policy: Bit vector used to determine which agents are allowed write access to the Bunit SMM Range from TSEGMB to BGSM1 based on the agents 6bit encoded SAI value."},
#else
{36, 36, 0x0000000000000000, "RW", "SMM_SAI_POL_36", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{35, 35, 0x0000000000000000, "RO", "SMM_SAI_POL_35", "Bunit SMM Write Access Policy: Bit vector used to determine which agents are allowed write access to the Bunit SMM Range from TSEGMB to BGSM1 based on the agents 6bit encoded SAI value."},
#else
{35, 35, 0x0000000000000000, "RO", "SMM_SAI_POL_35", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{34, 34, 0x0000000000000000, "RW", "SMM_SAI_POL_34", "Bunit SMM Write Access Policy: Bit vector used to determine which agents are allowed write access to the Bunit SMM Range from TSEGMB to BGSM1 based on the agents 6bit encoded SAI value."},
#else
{34, 34, 0x0000000000000000, "RW", "SMM_SAI_POL_34", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{33, 33, 0x0000000000000000, "RW", "SMM_SAI_POL_33", "Bunit SMM Write Access Policy: Bit vector used to determine which agents are allowed write access to the Bunit SMM Range from TSEGMB to BGSM1 based on the agents 6bit encoded SAI value."},
#else
{33, 33, 0x0000000000000000, "RW", "SMM_SAI_POL_33", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{32, 32, 0x0000000000000000, "RW", "SMM_SAI_POL_32", "Bunit SMM Write Access Policy: Bit vector used to determine which agents are allowed write access to the Bunit SMM Range from TSEGMB to BGSM1 based on the agents 6bit encoded SAI value."},
#else
{32, 32, 0x0000000000000000, "RW", "SMM_SAI_POL_32", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{31, 31, 0x0000000000000000, "RO", "SMM_SAI_POL_31", "Bunit SMM Write Access Policy: Bit vector used to determine which agents are allowed write access to the Bunit SMM Range from TSEGMB to BGSM1 based on the agents 6bit encoded SAI value."},
#else
{31, 31, 0x0000000000000000, "RO", "SMM_SAI_POL_31", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{30, 30, 0x0000000000000000, "RW", "SMM_SAI_POL_30", "Bunit SMM Write Access Policy: Bit vector used to determine which agents are allowed write access to the Bunit SMM Range from TSEGMB to BGSM1 based on the agents 6bit encoded SAI value."},
#else
{30, 30, 0x0000000000000000, "RW", "SMM_SAI_POL_30", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{29, 29, 0x0000000000000000, "RW", "SMM_SAI_POL_29", "Bunit SMM Write Access Policy: Bit vector used to determine which agents are allowed write access to the Bunit SMM Range from TSEGMB to BGSM1 based on the agents 6bit encoded SAI value."},
#else
{29, 29, 0x0000000000000000, "RW", "SMM_SAI_POL_29", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{28, 28, 0x0000000000000000, "RW", "SMM_SAI_POL_28", "Bunit SMM Write Access Policy: Bit vector used to determine which agents are allowed write access to the Bunit SMM Range from TSEGMB to BGSM1 based on the agents 6bit encoded SAI value."},
#else
{28, 28, 0x0000000000000000, "RW", "SMM_SAI_POL_28", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{27, 27, 0x0000000000000000, "RW", "SMM_SAI_POL_27", "Bunit SMM Write Access Policy: Bit vector used to determine which agents are allowed write access to the Bunit SMM Range from TSEGMB to BGSM1 based on the agents 6bit encoded SAI value."},
#else
{27, 27, 0x0000000000000000, "RW", "SMM_SAI_POL_27", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{26, 26, 0x0000000000000000, "RW", "SMM_SAI_POL_26", "Bunit SMM Write Access Policy: Bit vector used to determine which agents are allowed write access to the Bunit SMM Range from TSEGMB to BGSM1 based on the agents 6bit encoded SAI value."},
#else
{26, 26, 0x0000000000000000, "RW", "SMM_SAI_POL_26", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{25, 25, 0x0000000000000000, "RW", "SMM_SAI_POL_25", "Bunit SMM Write Access Policy: Bit vector used to determine which agents are allowed write access to the Bunit SMM Range from TSEGMB to BGSM1 based on the agents 6bit encoded SAI value."},
#else
{25, 25, 0x0000000000000000, "RW", "SMM_SAI_POL_25", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{24, 24, 0x0000000000000000, "RW", "SMM_SAI_POL_24", "Bunit SMM Write Access Policy: Bit vector used to determine which agents are allowed write access to the Bunit SMM Range from TSEGMB to BGSM1 based on the agents 6bit encoded SAI value."},
#else
{24, 24, 0x0000000000000000, "RW", "SMM_SAI_POL_24", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{23, 23, 0x0000000000000000, "RO", "SMM_SAI_POL_23", "Bunit SMM Write Access Policy: Bit vector used to determine which agents are allowed write access to the Bunit SMM Range from TSEGMB to BGSM1 based on the agents 6bit encoded SAI value."},
#else
{23, 23, 0x0000000000000000, "RO", "SMM_SAI_POL_23", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{22, 22, 0x0000000000000000, "RO", "SMM_SAI_POL_22", "Bunit SMM Write Access Policy: Bit vector used to determine which agents are allowed write access to the Bunit SMM Range from TSEGMB to BGSM1 based on the agents 6bit encoded SAI value."},
#else
{22, 22, 0x0000000000000000, "RO", "SMM_SAI_POL_22", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{21, 21, 0x0000000000000000, "RW", "SMM_SAI_POL_21", "Bunit SMM Write Access Policy: Bit vector used to determine which agents are allowed write access to the Bunit SMM Range from TSEGMB to BGSM1 based on the agents 6bit encoded SAI value."},
#else
{21, 21, 0x0000000000000000, "RW", "SMM_SAI_POL_21", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{20, 20, 0x0000000000000000, "RO", "SMM_SAI_POL_20", "Bunit SMM Write Access Policy: Bit vector used to determine which agents are allowed write access to the Bunit SMM Range from TSEGMB to BGSM1 based on the agents 6bit encoded SAI value."},
#else
{20, 20, 0x0000000000000000, "RO", "SMM_SAI_POL_20", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{19, 19, 0x0000000000000000, "RO", "SMM_SAI_POL_19", "Bunit SMM Write Access Policy: Bit vector used to determine which agents are allowed write access to the Bunit SMM Range from TSEGMB to BGSM1 based on the agents 6bit encoded SAI value."},
#else
{19, 19, 0x0000000000000000, "RO", "SMM_SAI_POL_19", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{18, 18, 0x0000000000000000, "RO", "SMM_SAI_POL_18", "Bunit SMM Write Access Policy: Bit vector used to determine which agents are allowed write access to the Bunit SMM Range from TSEGMB to BGSM1 based on the agents 6bit encoded SAI value."},
#else
{18, 18, 0x0000000000000000, "RO", "SMM_SAI_POL_18", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{17, 17, 0x0000000000000000, "RW", "SMM_SAI_POL_17", "Bunit SMM Write Access Policy: Bit vector used to determine which agents are allowed write access to the Bunit SMM Range from TSEGMB to BGSM1 based on the agents 6bit encoded SAI value."},
#else
{17, 17, 0x0000000000000000, "RW", "SMM_SAI_POL_17", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{16, 16, 0x0000000000000001, "RW", "SMM_SAI_POL_16", "Bunit SMM Write Access Policy: Bit vector used to determine which agents are allowed write access to the Bunit SMM Range from TSEGMB to BGSM1 based on the agents 6bit encoded SAI value."},
#else
{16, 16, 0x0000000000000001, "RW", "SMM_SAI_POL_16", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{15, 15, 0x0000000000000000, "RO", "SMM_SAI_POL_15", "Bunit SMM Write Access Policy: Bit vector used to determine which agents are allowed write access to the Bunit SMM Range from TSEGMB to BGSM1 based on the agents 6bit encoded SAI value."},
#else
{15, 15, 0x0000000000000000, "RO", "SMM_SAI_POL_15", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{14, 14, 0x0000000000000000, "RO", "SMM_SAI_POL_14", "Bunit SMM Write Access Policy: Bit vector used to determine which agents are allowed write access to the Bunit SMM Range from TSEGMB to BGSM1 based on the agents 6bit encoded SAI value."},
#else
{14, 14, 0x0000000000000000, "RO", "SMM_SAI_POL_14", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{13, 13, 0x0000000000000000, "RW", "SMM_SAI_POL_13", "Bunit SMM Write Access Policy: Bit vector used to determine which agents are allowed write access to the Bunit SMM Range from TSEGMB to BGSM1 based on the agents 6bit encoded SAI value."},
#else
{13, 13, 0x0000000000000000, "RW", "SMM_SAI_POL_13", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{12, 12, 0x0000000000000000, "RW", "SMM_SAI_POL_12", "Bunit SMM Write Access Policy: Bit vector used to determine which agents are allowed write access to the Bunit SMM Range from TSEGMB to BGSM1 based on the agents 6bit encoded SAI value."},
#else
{12, 12, 0x0000000000000000, "RW", "SMM_SAI_POL_12", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{11, 11, 0x0000000000000000, "RO", "SMM_SAI_POL_11", "Bunit SMM Write Access Policy: Bit vector used to determine which agents are allowed write access to the Bunit SMM Range from TSEGMB to BGSM1 based on the agents 6bit encoded SAI value."},
#else
{11, 11, 0x0000000000000000, "RO", "SMM_SAI_POL_11", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{10, 10, 0x0000000000000000, "RO", "SMM_SAI_POL_10", "Bunit SMM Write Access Policy: Bit vector used to determine which agents are allowed write access to the Bunit SMM Range from TSEGMB to BGSM1 based on the agents 6bit encoded SAI value."},
#else
{10, 10, 0x0000000000000000, "RO", "SMM_SAI_POL_10", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{9, 9, 0x0000000000000000, "RO", "SMM_SAI_POL_9", "Bunit SMM Write Access Policy: Bit vector used to determine which agents are allowed write access to the Bunit SMM Range from TSEGMB to BGSM1 based on the agents 6bit encoded SAI value."},
#else
{9, 9, 0x0000000000000000, "RO", "SMM_SAI_POL_9", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{8, 8, 0x0000000000000000, "RW", "SMM_SAI_POL_8", "Bunit SMM Write Access Policy: Bit vector used to determine which agents are allowed write access to the Bunit SMM Range from TSEGMB to BGSM1 based on the agents 6bit encoded SAI value."},
#else
{8, 8, 0x0000000000000000, "RW", "SMM_SAI_POL_8", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{7, 7, 0x0000000000000000, "RO", "SMM_SAI_POL_7", "Bunit SMM Write Access Policy: Bit vector used to determine which agents are allowed write access to the Bunit SMM Range from TSEGMB to BGSM1 based on the agents 6bit encoded SAI value."},
#else
{7, 7, 0x0000000000000000, "RO", "SMM_SAI_POL_7", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{6, 6, 0x0000000000000000, "RO", "SMM_SAI_POL_6", "Bunit SMM Write Access Policy: Bit vector used to determine which agents are allowed write access to the Bunit SMM Range from TSEGMB to BGSM1 based on the agents 6bit encoded SAI value."},
#else
{6, 6, 0x0000000000000000, "RO", "SMM_SAI_POL_6", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{5, 5, 0x0000000000000000, "RW", "SMM_SAI_POL_5", "Bunit SMM Write Access Policy: Bit vector used to determine which agents are allowed write access to the Bunit SMM Range from TSEGMB to BGSM1 based on the agents 6bit encoded SAI value."},
#else
{5, 5, 0x0000000000000000, "RW", "SMM_SAI_POL_5", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{4, 4, 0x0000000000000001, "RW", "SMM_SAI_POL_4", "Bunit SMM Write Access Policy: Bit vector used to determine which agents are allowed write access to the Bunit SMM Range from TSEGMB to BGSM1 based on the agents 6bit encoded SAI value."},
#else
{4, 4, 0x0000000000000001, "RW", "SMM_SAI_POL_4", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{3, 3, 0x0000000000000000, "RW", "SMM_SAI_POL_3", "Bunit SMM Write Access Policy: Bit vector used to determine which agents are allowed write access to the Bunit SMM Range from TSEGMB to BGSM1 based on the agents 6bit encoded SAI value."},
#else
{3, 3, 0x0000000000000000, "RW", "SMM_SAI_POL_3", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{2, 2, 0x0000000000000001, "RW", "SMM_SAI_POL_2", "Bunit SMM Write Access Policy: Bit vector used to determine which agents are allowed write access to the Bunit SMM Range from TSEGMB to BGSM1 based on the agents 6bit encoded SAI value."},
#else
{2, 2, 0x0000000000000001, "RW", "SMM_SAI_POL_2", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{1, 1, 0x0000000000000001, "RW", "SMM_SAI_POL_1", "Bunit SMM Write Access Policy: Bit vector used to determine which agents are allowed write access to the Bunit SMM Range from TSEGMB to BGSM1 based on the agents 6bit encoded SAI value."},
#else
{1, 1, 0x0000000000000001, "RW", "SMM_SAI_POL_1", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 0, 0x0000000000000001, "RW", "SMM_SAI_POL_0", "Bunit SMM Write Access Policy: Bit vector used to determine which agents are allowed write access to the Bunit SMM Range from TSEGMB to BGSM1 based on the agents 6bit encoded SAI value."},
#else
{0, 0, 0x0000000000000001, "RW", "SMM_SAI_POL_0", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo825[] = {{"B_CR_BSMRWAC", "", 0x00004B78, 64, 0xFFFFFFFFFFFFFFFF, 0x0000000000010017}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields826[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{0, 63, 0x00000C0061010202, "RW", "DEFVTDPMR_CTRL_POL", "Bunit Def VTd PMR Control Policy: Bit vector used to determine which agents are allowed access to the BDEFVTDPMR_RAC BDEFVTDPMR_WAC and BDEFVTDPMR_CP registers based on the value from the agents 6bit SAI field."},
#else
{0, 63, 0x00000C0061010202, "RW", "DEFVTDPMR_CTRL_POL", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo826[] = {{"B_CR_BDEFVTDPMR_CP", "", 0x00004B80, 1, 0xFFFFFFFFFFFFFFFF, 0x00000C0061010202}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields827[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{63, 63, 0x0000000000000000, "RW", "DEFVTDPMR_SAI_POL_63", "Bunit Def VTd PMR Read Access Policy: Bit vector used to determine which agents are allowed read access to the Default VTd PMR Low and High memory ranges based on the agents 6bit encoded SAI value."},
#else
{63, 63, 0x0000000000000000, "RW", "DEFVTDPMR_SAI_POL_63", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{62, 62, 0x0000000000000000, "RO", "DEFVTDPMR_SAI_POL_62", "Bunit Def VTd PMR Read Access Policy: Bit vector used to determine which agents are allowed read access to the Default VTd PMR Low and High memory ranges based on the agents 6bit encoded SAI value."},
#else
{62, 62, 0x0000000000000000, "RO", "DEFVTDPMR_SAI_POL_62", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{61, 61, 0x0000000000000000, "RO", "DEFVTDPMR_SAI_POL_61", "Bunit Def VTd PMR Read Access Policy: Bit vector used to determine which agents are allowed read access to the Default VTd PMR Low and High memory ranges based on the agents 6bit encoded SAI value."},
#else
{61, 61, 0x0000000000000000, "RO", "DEFVTDPMR_SAI_POL_61", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{60, 60, 0x0000000000000000, "RO", "DEFVTDPMR_SAI_POL_60", "Bunit Def VTd PMR Read Access Policy: Bit vector used to determine which agents are allowed read access to the Default VTd PMR Low and High memory ranges based on the agents 6bit encoded SAI value."},
#else
{60, 60, 0x0000000000000000, "RO", "DEFVTDPMR_SAI_POL_60", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{59, 59, 0x0000000000000000, "RO", "DEFVTDPMR_SAI_POL_59", "Bunit Def VTd PMR Read Access Policy: Bit vector used to determine which agents are allowed read access to the Default VTd PMR Low and High memory ranges based on the agents 6bit encoded SAI value."},
#else
{59, 59, 0x0000000000000000, "RO", "DEFVTDPMR_SAI_POL_59", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{58, 58, 0x0000000000000000, "RO", "DEFVTDPMR_SAI_POL_58", "Bunit Def VTd PMR Read Access Policy: Bit vector used to determine which agents are allowed read access to the Default VTd PMR Low and High memory ranges based on the agents 6bit encoded SAI value."},
#else
{58, 58, 0x0000000000000000, "RO", "DEFVTDPMR_SAI_POL_58", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{57, 57, 0x0000000000000000, "RO", "DEFVTDPMR_SAI_POL_57", "Bunit Def VTd PMR Read Access Policy: Bit vector used to determine which agents are allowed read access to the Default VTd PMR Low and High memory ranges based on the agents 6bit encoded SAI value."},
#else
{57, 57, 0x0000000000000000, "RO", "DEFVTDPMR_SAI_POL_57", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{56, 56, 0x0000000000000000, "RW", "DEFVTDPMR_SAI_POL_56", "Bunit Def VTd PMR Read Access Policy: Bit vector used to determine which agents are allowed read access to the Default VTd PMR Low and High memory ranges based on the agents 6bit encoded SAI value."},
#else
{56, 56, 0x0000000000000000, "RW", "DEFVTDPMR_SAI_POL_56", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{55, 55, 0x0000000000000000, "RW", "DEFVTDPMR_SAI_POL_55", "Bunit Def VTd PMR Read Access Policy: Bit vector used to determine which agents are allowed read access to the Default VTd PMR Low and High memory ranges based on the agents 6bit encoded SAI value."},
#else
{55, 55, 0x0000000000000000, "RW", "DEFVTDPMR_SAI_POL_55", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{54, 54, 0x0000000000000000, "RW", "DEFVTDPMR_SAI_POL_54", "Bunit Def VTd PMR Read Access Policy: Bit vector used to determine which agents are allowed read access to the Default VTd PMR Low and High memory ranges based on the agents 6bit encoded SAI value."},
#else
{54, 54, 0x0000000000000000, "RW", "DEFVTDPMR_SAI_POL_54", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{53, 53, 0x0000000000000000, "RO", "DEFVTDPMR_SAI_POL_53", "Bunit Def VTd PMR Read Access Policy: Bit vector used to determine which agents are allowed read access to the Default VTd PMR Low and High memory ranges based on the agents 6bit encoded SAI value."},
#else
{53, 53, 0x0000000000000000, "RO", "DEFVTDPMR_SAI_POL_53", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{52, 52, 0x0000000000000000, "RO", "DEFVTDPMR_SAI_POL_52", "Bunit Def VTd PMR Read Access Policy: Bit vector used to determine which agents are allowed read access to the Default VTd PMR Low and High memory ranges based on the agents 6bit encoded SAI value."},
#else
{52, 52, 0x0000000000000000, "RO", "DEFVTDPMR_SAI_POL_52", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{51, 51, 0x0000000000000000, "RO", "DEFVTDPMR_SAI_POL_51", "Bunit Def VTd PMR Read Access Policy: Bit vector used to determine which agents are allowed read access to the Default VTd PMR Low and High memory ranges based on the agents 6bit encoded SAI value."},
#else
{51, 51, 0x0000000000000000, "RO", "DEFVTDPMR_SAI_POL_51", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{50, 50, 0x0000000000000000, "RW", "DEFVTDPMR_SAI_POL_50", "Bunit Def VTd PMR Read Access Policy: Bit vector used to determine which agents are allowed read access to the Default VTd PMR Low and High memory ranges based on the agents 6bit encoded SAI value."},
#else
{50, 50, 0x0000000000000000, "RW", "DEFVTDPMR_SAI_POL_50", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{49, 49, 0x0000000000000000, "RW", "DEFVTDPMR_SAI_POL_49", "Bunit Def VTd PMR Read Access Policy: Bit vector used to determine which agents are allowed read access to the Default VTd PMR Low and High memory ranges based on the agents 6bit encoded SAI value."},
#else
{49, 49, 0x0000000000000000, "RW", "DEFVTDPMR_SAI_POL_49", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{48, 48, 0x0000000000000001, "RW", "DEFVTDPMR_SAI_POL_48", "Bunit Def VTd PMR Read Access Policy: Bit vector used to determine which agents are allowed read access to the Default VTd PMR Low and High memory ranges based on the agents 6bit encoded SAI value."},
#else
{48, 48, 0x0000000000000001, "RW", "DEFVTDPMR_SAI_POL_48", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{47, 47, 0x0000000000000000, "RO", "DEFVTDPMR_SAI_POL_47", "Bunit Def VTd PMR Read Access Policy: Bit vector used to determine which agents are allowed read access to the Default VTd PMR Low and High memory ranges based on the agents 6bit encoded SAI value."},
#else
{47, 47, 0x0000000000000000, "RO", "DEFVTDPMR_SAI_POL_47", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{46, 46, 0x0000000000000000, "RO", "DEFVTDPMR_SAI_POL_46", "Bunit Def VTd PMR Read Access Policy: Bit vector used to determine which agents are allowed read access to the Default VTd PMR Low and High memory ranges based on the agents 6bit encoded SAI value."},
#else
{46, 46, 0x0000000000000000, "RO", "DEFVTDPMR_SAI_POL_46", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{45, 45, 0x0000000000000000, "RO", "DEFVTDPMR_SAI_POL_45", "Bunit Def VTd PMR Read Access Policy: Bit vector used to determine which agents are allowed read access to the Default VTd PMR Low and High memory ranges based on the agents 6bit encoded SAI value."},
#else
{45, 45, 0x0000000000000000, "RO", "DEFVTDPMR_SAI_POL_45", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{44, 44, 0x0000000000000001, "RW", "DEFVTDPMR_SAI_POL_44", "Bunit Def VTd PMR Read Access Policy: Bit vector used to determine which agents are allowed read access to the Default VTd PMR Low and High memory ranges based on the agents 6bit encoded SAI value."},
#else
{44, 44, 0x0000000000000001, "RW", "DEFVTDPMR_SAI_POL_44", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{43, 43, 0x0000000000000000, "RW", "DEFVTDPMR_SAI_POL_43", "Bunit Def VTd PMR Read Access Policy: Bit vector used to determine which agents are allowed read access to the Default VTd PMR Low and High memory ranges based on the agents 6bit encoded SAI value."},
#else
{43, 43, 0x0000000000000000, "RW", "DEFVTDPMR_SAI_POL_43", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{42, 42, 0x0000000000000000, "RW", "DEFVTDPMR_SAI_POL_42", "Bunit Def VTd PMR Read Access Policy: Bit vector used to determine which agents are allowed read access to the Default VTd PMR Low and High memory ranges based on the agents 6bit encoded SAI value."},
#else
{42, 42, 0x0000000000000000, "RW", "DEFVTDPMR_SAI_POL_42", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{41, 41, 0x0000000000000000, "RW", "DEFVTDPMR_SAI_POL_41", "Bunit Def VTd PMR Read Access Policy: Bit vector used to determine which agents are allowed read access to the Default VTd PMR Low and High memory ranges based on the agents 6bit encoded SAI value."},
#else
{41, 41, 0x0000000000000000, "RW", "DEFVTDPMR_SAI_POL_41", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{40, 40, 0x0000000000000000, "RW", "DEFVTDPMR_SAI_POL_40", "Bunit Def VTd PMR Read Access Policy: Bit vector used to determine which agents are allowed read access to the Default VTd PMR Low and High memory ranges based on the agents 6bit encoded SAI value."},
#else
{40, 40, 0x0000000000000000, "RW", "DEFVTDPMR_SAI_POL_40", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{39, 39, 0x0000000000000000, "RO", "DEFVTDPMR_SAI_POL_39", "Bunit Def VTd PMR Read Access Policy: Bit vector used to determine which agents are allowed read access to the Default VTd PMR Low and High memory ranges based on the agents 6bit encoded SAI value."},
#else
{39, 39, 0x0000000000000000, "RO", "DEFVTDPMR_SAI_POL_39", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{38, 38, 0x0000000000000000, "RW", "DEFVTDPMR_SAI_POL_38", "Bunit Def VTd PMR Read Access Policy: Bit vector used to determine which agents are allowed read access to the Default VTd PMR Low and High memory ranges based on the agents 6bit encoded SAI value."},
#else
{38, 38, 0x0000000000000000, "RW", "DEFVTDPMR_SAI_POL_38", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{37, 37, 0x0000000000000000, "RO", "DEFVTDPMR_SAI_POL_37", "Bunit Def VTd PMR Read Access Policy: Bit vector used to determine which agents are allowed read access to the Default VTd PMR Low and High memory ranges based on the agents 6bit encoded SAI value."},
#else
{37, 37, 0x0000000000000000, "RO", "DEFVTDPMR_SAI_POL_37", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{36, 36, 0x0000000000000000, "RW", "DEFVTDPMR_SAI_POL_36", "Bunit Def VTd PMR Read Access Policy: Bit vector used to determine which agents are allowed read access to the Default VTd PMR Low and High memory ranges based on the agents 6bit encoded SAI value."},
#else
{36, 36, 0x0000000000000000, "RW", "DEFVTDPMR_SAI_POL_36", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{35, 35, 0x0000000000000000, "RO", "DEFVTDPMR_SAI_POL_35", "Bunit Def VTd PMR Read Access Policy: Bit vector used to determine which agents are allowed read access to the Default VTd PMR Low and High memory ranges based on the agents 6bit encoded SAI value."},
#else
{35, 35, 0x0000000000000000, "RO", "DEFVTDPMR_SAI_POL_35", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{34, 34, 0x0000000000000000, "RW", "DEFVTDPMR_SAI_POL_34", "Bunit Def VTd PMR Read Access Policy: Bit vector used to determine which agents are allowed read access to the Default VTd PMR Low and High memory ranges based on the agents 6bit encoded SAI value."},
#else
{34, 34, 0x0000000000000000, "RW", "DEFVTDPMR_SAI_POL_34", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{33, 33, 0x0000000000000000, "RW", "DEFVTDPMR_SAI_POL_33", "Bunit Def VTd PMR Read Access Policy: Bit vector used to determine which agents are allowed read access to the Default VTd PMR Low and High memory ranges based on the agents 6bit encoded SAI value."},
#else
{33, 33, 0x0000000000000000, "RW", "DEFVTDPMR_SAI_POL_33", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{32, 32, 0x0000000000000000, "RW", "DEFVTDPMR_SAI_POL_32", "Bunit Def VTd PMR Read Access Policy: Bit vector used to determine which agents are allowed read access to the Default VTd PMR Low and High memory ranges based on the agents 6bit encoded SAI value."},
#else
{32, 32, 0x0000000000000000, "RW", "DEFVTDPMR_SAI_POL_32", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{31, 31, 0x0000000000000000, "RO", "DEFVTDPMR_SAI_POL_31", "Bunit Def VTd PMR Read Access Policy: Bit vector used to determine which agents are allowed read access to the Default VTd PMR Low and High memory ranges based on the agents 6bit encoded SAI value."},
#else
{31, 31, 0x0000000000000000, "RO", "DEFVTDPMR_SAI_POL_31", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{30, 30, 0x0000000000000000, "RW", "DEFVTDPMR_SAI_POL_30", "Bunit Def VTd PMR Read Access Policy: Bit vector used to determine which agents are allowed read access to the Default VTd PMR Low and High memory ranges based on the agents 6bit encoded SAI value."},
#else
{30, 30, 0x0000000000000000, "RW", "DEFVTDPMR_SAI_POL_30", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{29, 29, 0x0000000000000000, "RW", "DEFVTDPMR_SAI_POL_29", "Bunit Def VTd PMR Read Access Policy: Bit vector used to determine which agents are allowed read access to the Default VTd PMR Low and High memory ranges based on the agents 6bit encoded SAI value."},
#else
{29, 29, 0x0000000000000000, "RW", "DEFVTDPMR_SAI_POL_29", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{28, 28, 0x0000000000000000, "RW", "DEFVTDPMR_SAI_POL_28", "Bunit Def VTd PMR Read Access Policy: Bit vector used to determine which agents are allowed read access to the Default VTd PMR Low and High memory ranges based on the agents 6bit encoded SAI value."},
#else
{28, 28, 0x0000000000000000, "RW", "DEFVTDPMR_SAI_POL_28", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{27, 27, 0x0000000000000000, "RW", "DEFVTDPMR_SAI_POL_27", "Bunit Def VTd PMR Read Access Policy: Bit vector used to determine which agents are allowed read access to the Default VTd PMR Low and High memory ranges based on the agents 6bit encoded SAI value."},
#else
{27, 27, 0x0000000000000000, "RW", "DEFVTDPMR_SAI_POL_27", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{26, 26, 0x0000000000000000, "RW", "DEFVTDPMR_SAI_POL_26", "Bunit Def VTd PMR Read Access Policy: Bit vector used to determine which agents are allowed read access to the Default VTd PMR Low and High memory ranges based on the agents 6bit encoded SAI value."},
#else
{26, 26, 0x0000000000000000, "RW", "DEFVTDPMR_SAI_POL_26", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{25, 25, 0x0000000000000000, "RW", "DEFVTDPMR_SAI_POL_25", "Bunit Def VTd PMR Read Access Policy: Bit vector used to determine which agents are allowed read access to the Default VTd PMR Low and High memory ranges based on the agents 6bit encoded SAI value."},
#else
{25, 25, 0x0000000000000000, "RW", "DEFVTDPMR_SAI_POL_25", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{24, 24, 0x0000000000000000, "RW", "DEFVTDPMR_SAI_POL_24", "Bunit Def VTd PMR Read Access Policy: Bit vector used to determine which agents are allowed read access to the Default VTd PMR Low and High memory ranges based on the agents 6bit encoded SAI value."},
#else
{24, 24, 0x0000000000000000, "RW", "DEFVTDPMR_SAI_POL_24", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{23, 23, 0x0000000000000000, "RO", "DEFVTDPMR_SAI_POL_23", "Bunit Def VTd PMR Read Access Policy: Bit vector used to determine which agents are allowed read access to the Default VTd PMR Low and High memory ranges based on the agents 6bit encoded SAI value."},
#else
{23, 23, 0x0000000000000000, "RO", "DEFVTDPMR_SAI_POL_23", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{22, 22, 0x0000000000000000, "RO", "DEFVTDPMR_SAI_POL_22", "Bunit Def VTd PMR Read Access Policy: Bit vector used to determine which agents are allowed read access to the Default VTd PMR Low and High memory ranges based on the agents 6bit encoded SAI value."},
#else
{22, 22, 0x0000000000000000, "RO", "DEFVTDPMR_SAI_POL_22", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{21, 21, 0x0000000000000000, "RW", "DEFVTDPMR_SAI_POL_21", "Bunit Def VTd PMR Read Access Policy: Bit vector used to determine which agents are allowed read access to the Default VTd PMR Low and High memory ranges based on the agents 6bit encoded SAI value."},
#else
{21, 21, 0x0000000000000000, "RW", "DEFVTDPMR_SAI_POL_21", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{20, 20, 0x0000000000000000, "RO", "DEFVTDPMR_SAI_POL_20", "Bunit Def VTd PMR Read Access Policy: Bit vector used to determine which agents are allowed read access to the Default VTd PMR Low and High memory ranges based on the agents 6bit encoded SAI value."},
#else
{20, 20, 0x0000000000000000, "RO", "DEFVTDPMR_SAI_POL_20", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{19, 19, 0x0000000000000000, "RO", "DEFVTDPMR_SAI_POL_19", "Bunit Def VTd PMR Read Access Policy: Bit vector used to determine which agents are allowed read access to the Default VTd PMR Low and High memory ranges based on the agents 6bit encoded SAI value."},
#else
{19, 19, 0x0000000000000000, "RO", "DEFVTDPMR_SAI_POL_19", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{18, 18, 0x0000000000000000, "RO", "DEFVTDPMR_SAI_POL_18", "Bunit Def VTd PMR Read Access Policy: Bit vector used to determine which agents are allowed read access to the Default VTd PMR Low and High memory ranges based on the agents 6bit encoded SAI value."},
#else
{18, 18, 0x0000000000000000, "RO", "DEFVTDPMR_SAI_POL_18", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{17, 17, 0x0000000000000000, "RW", "DEFVTDPMR_SAI_POL_17", "Bunit Def VTd PMR Read Access Policy: Bit vector used to determine which agents are allowed read access to the Default VTd PMR Low and High memory ranges based on the agents 6bit encoded SAI value."},
#else
{17, 17, 0x0000000000000000, "RW", "DEFVTDPMR_SAI_POL_17", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{16, 16, 0x0000000000000001, "RW", "DEFVTDPMR_SAI_POL_16", "Bunit Def VTd PMR Read Access Policy: Bit vector used to determine which agents are allowed read access to the Default VTd PMR Low and High memory ranges based on the agents 6bit encoded SAI value."},
#else
{16, 16, 0x0000000000000001, "RW", "DEFVTDPMR_SAI_POL_16", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{15, 15, 0x0000000000000000, "RO", "DEFVTDPMR_SAI_POL_15", "Bunit Def VTd PMR Read Access Policy: Bit vector used to determine which agents are allowed read access to the Default VTd PMR Low and High memory ranges based on the agents 6bit encoded SAI value."},
#else
{15, 15, 0x0000000000000000, "RO", "DEFVTDPMR_SAI_POL_15", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{14, 14, 0x0000000000000000, "RO", "DEFVTDPMR_SAI_POL_14", "Bunit Def VTd PMR Read Access Policy: Bit vector used to determine which agents are allowed read access to the Default VTd PMR Low and High memory ranges based on the agents 6bit encoded SAI value."},
#else
{14, 14, 0x0000000000000000, "RO", "DEFVTDPMR_SAI_POL_14", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{13, 13, 0x0000000000000000, "RW", "DEFVTDPMR_SAI_POL_13", "Bunit Def VTd PMR Read Access Policy: Bit vector used to determine which agents are allowed read access to the Default VTd PMR Low and High memory ranges based on the agents 6bit encoded SAI value."},
#else
{13, 13, 0x0000000000000000, "RW", "DEFVTDPMR_SAI_POL_13", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{12, 12, 0x0000000000000001, "RW", "DEFVTDPMR_SAI_POL_12", "Bunit Def VTd PMR Read Access Policy: Bit vector used to determine which agents are allowed read access to the Default VTd PMR Low and High memory ranges based on the agents 6bit encoded SAI value."},
#else
{12, 12, 0x0000000000000001, "RW", "DEFVTDPMR_SAI_POL_12", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{11, 11, 0x0000000000000000, "RO", "DEFVTDPMR_SAI_POL_11", "Bunit Def VTd PMR Read Access Policy: Bit vector used to determine which agents are allowed read access to the Default VTd PMR Low and High memory ranges based on the agents 6bit encoded SAI value."},
#else
{11, 11, 0x0000000000000000, "RO", "DEFVTDPMR_SAI_POL_11", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{10, 10, 0x0000000000000000, "RO", "DEFVTDPMR_SAI_POL_10", "Bunit Def VTd PMR Read Access Policy: Bit vector used to determine which agents are allowed read access to the Default VTd PMR Low and High memory ranges based on the agents 6bit encoded SAI value."},
#else
{10, 10, 0x0000000000000000, "RO", "DEFVTDPMR_SAI_POL_10", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{9, 9, 0x0000000000000000, "RO", "DEFVTDPMR_SAI_POL_9", "Bunit Def VTd PMR Read Access Policy: Bit vector used to determine which agents are allowed read access to the Default VTd PMR Low and High memory ranges based on the agents 6bit encoded SAI value."},
#else
{9, 9, 0x0000000000000000, "RO", "DEFVTDPMR_SAI_POL_9", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{8, 8, 0x0000000000000001, "RW", "DEFVTDPMR_SAI_POL_8", "Bunit Def VTd PMR Read Access Policy: Bit vector used to determine which agents are allowed read access to the Default VTd PMR Low and High memory ranges based on the agents 6bit encoded SAI value."},
#else
{8, 8, 0x0000000000000001, "RW", "DEFVTDPMR_SAI_POL_8", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{7, 7, 0x0000000000000000, "RO", "DEFVTDPMR_SAI_POL_7", "Bunit Def VTd PMR Read Access Policy: Bit vector used to determine which agents are allowed read access to the Default VTd PMR Low and High memory ranges based on the agents 6bit encoded SAI value."},
#else
{7, 7, 0x0000000000000000, "RO", "DEFVTDPMR_SAI_POL_7", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{6, 6, 0x0000000000000000, "RO", "DEFVTDPMR_SAI_POL_6", "Bunit Def VTd PMR Read Access Policy: Bit vector used to determine which agents are allowed read access to the Default VTd PMR Low and High memory ranges based on the agents 6bit encoded SAI value."},
#else
{6, 6, 0x0000000000000000, "RO", "DEFVTDPMR_SAI_POL_6", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{5, 5, 0x0000000000000000, "RW", "DEFVTDPMR_SAI_POL_5", "Bunit Def VTd PMR Read Access Policy: Bit vector used to determine which agents are allowed read access to the Default VTd PMR Low and High memory ranges based on the agents 6bit encoded SAI value."},
#else
{5, 5, 0x0000000000000000, "RW", "DEFVTDPMR_SAI_POL_5", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{4, 4, 0x0000000000000001, "RW", "DEFVTDPMR_SAI_POL_4", "Bunit Def VTd PMR Read Access Policy: Bit vector used to determine which agents are allowed read access to the Default VTd PMR Low and High memory ranges based on the agents 6bit encoded SAI value."},
#else
{4, 4, 0x0000000000000001, "RW", "DEFVTDPMR_SAI_POL_4", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{3, 3, 0x0000000000000000, "RW", "DEFVTDPMR_SAI_POL_3", "Bunit Def VTd PMR Read Access Policy: Bit vector used to determine which agents are allowed read access to the Default VTd PMR Low and High memory ranges based on the agents 6bit encoded SAI value."},
#else
{3, 3, 0x0000000000000000, "RW", "DEFVTDPMR_SAI_POL_3", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{2, 2, 0x0000000000000001, "RW", "DEFVTDPMR_SAI_POL_2", "Bunit Def VTd PMR Read Access Policy: Bit vector used to determine which agents are allowed read access to the Default VTd PMR Low and High memory ranges based on the agents 6bit encoded SAI value."},
#else
{2, 2, 0x0000000000000001, "RW", "DEFVTDPMR_SAI_POL_2", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{1, 1, 0x0000000000000001, "RW", "DEFVTDPMR_SAI_POL_1", "Bunit Def VTd PMR Read Access Policy: Bit vector used to determine which agents are allowed read access to the Default VTd PMR Low and High memory ranges based on the agents 6bit encoded SAI value."},
#else
{1, 1, 0x0000000000000001, "RW", "DEFVTDPMR_SAI_POL_1", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 0, 0x0000000000000001, "RW", "DEFVTDPMR_SAI_POL_0", "Bunit Def VTd PMR Read Access Policy: Bit vector used to determine which agents are allowed read access to the Default VTd PMR Low and High memory ranges based on the agents 6bit encoded SAI value."},
#else
{0, 0, 0x0000000000000001, "RW", "DEFVTDPMR_SAI_POL_0", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo827[] = {{"B_CR_BDEFVTDPMR_RAC", "", 0x00004B88, 64, 0xFFFFFFFFFFFFFFFF, 0x0001100000011117}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields828[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{63, 63, 0x0000000000000000, "RW", "DEFVTDPMR_SAI_POL_63", "Bunit Def VTd PMR Write Access Policy: Bit vector used to determine which agents are allowed write access to the Default VTd PMR Low and High memory ranges based on the agents 6bit encoded SAI value."},
#else
{63, 63, 0x0000000000000000, "RW", "DEFVTDPMR_SAI_POL_63", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{62, 62, 0x0000000000000000, "RO", "DEFVTDPMR_SAI_POL_62", "Bunit Def VTd PMR Write Access Policy: Bit vector used to determine which agents are allowed write access to the Default VTd PMR Low and High memory ranges based on the agents 6bit encoded SAI value."},
#else
{62, 62, 0x0000000000000000, "RO", "DEFVTDPMR_SAI_POL_62", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{61, 61, 0x0000000000000000, "RO", "DEFVTDPMR_SAI_POL_61", "Bunit Def VTd PMR Write Access Policy: Bit vector used to determine which agents are allowed write access to the Default VTd PMR Low and High memory ranges based on the agents 6bit encoded SAI value."},
#else
{61, 61, 0x0000000000000000, "RO", "DEFVTDPMR_SAI_POL_61", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{60, 60, 0x0000000000000000, "RO", "DEFVTDPMR_SAI_POL_60", "Bunit Def VTd PMR Write Access Policy: Bit vector used to determine which agents are allowed write access to the Default VTd PMR Low and High memory ranges based on the agents 6bit encoded SAI value."},
#else
{60, 60, 0x0000000000000000, "RO", "DEFVTDPMR_SAI_POL_60", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{59, 59, 0x0000000000000000, "RO", "DEFVTDPMR_SAI_POL_59", "Bunit Def VTd PMR Write Access Policy: Bit vector used to determine which agents are allowed write access to the Default VTd PMR Low and High memory ranges based on the agents 6bit encoded SAI value."},
#else
{59, 59, 0x0000000000000000, "RO", "DEFVTDPMR_SAI_POL_59", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{58, 58, 0x0000000000000000, "RO", "DEFVTDPMR_SAI_POL_58", "Bunit Def VTd PMR Write Access Policy: Bit vector used to determine which agents are allowed write access to the Default VTd PMR Low and High memory ranges based on the agents 6bit encoded SAI value."},
#else
{58, 58, 0x0000000000000000, "RO", "DEFVTDPMR_SAI_POL_58", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{57, 57, 0x0000000000000000, "RO", "DEFVTDPMR_SAI_POL_57", "Bunit Def VTd PMR Write Access Policy: Bit vector used to determine which agents are allowed write access to the Default VTd PMR Low and High memory ranges based on the agents 6bit encoded SAI value."},
#else
{57, 57, 0x0000000000000000, "RO", "DEFVTDPMR_SAI_POL_57", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{56, 56, 0x0000000000000000, "RW", "DEFVTDPMR_SAI_POL_56", "Bunit Def VTd PMR Write Access Policy: Bit vector used to determine which agents are allowed write access to the Default VTd PMR Low and High memory ranges based on the agents 6bit encoded SAI value."},
#else
{56, 56, 0x0000000000000000, "RW", "DEFVTDPMR_SAI_POL_56", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{55, 55, 0x0000000000000000, "RW", "DEFVTDPMR_SAI_POL_55", "Bunit Def VTd PMR Write Access Policy: Bit vector used to determine which agents are allowed write access to the Default VTd PMR Low and High memory ranges based on the agents 6bit encoded SAI value."},
#else
{55, 55, 0x0000000000000000, "RW", "DEFVTDPMR_SAI_POL_55", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{54, 54, 0x0000000000000000, "RW", "DEFVTDPMR_SAI_POL_54", "Bunit Def VTd PMR Write Access Policy: Bit vector used to determine which agents are allowed write access to the Default VTd PMR Low and High memory ranges based on the agents 6bit encoded SAI value."},
#else
{54, 54, 0x0000000000000000, "RW", "DEFVTDPMR_SAI_POL_54", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{53, 53, 0x0000000000000000, "RO", "DEFVTDPMR_SAI_POL_53", "Bunit Def VTd PMR Write Access Policy: Bit vector used to determine which agents are allowed write access to the Default VTd PMR Low and High memory ranges based on the agents 6bit encoded SAI value."},
#else
{53, 53, 0x0000000000000000, "RO", "DEFVTDPMR_SAI_POL_53", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{52, 52, 0x0000000000000000, "RO", "DEFVTDPMR_SAI_POL_52", "Bunit Def VTd PMR Write Access Policy: Bit vector used to determine which agents are allowed write access to the Default VTd PMR Low and High memory ranges based on the agents 6bit encoded SAI value."},
#else
{52, 52, 0x0000000000000000, "RO", "DEFVTDPMR_SAI_POL_52", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{51, 51, 0x0000000000000000, "RO", "DEFVTDPMR_SAI_POL_51", "Bunit Def VTd PMR Write Access Policy: Bit vector used to determine which agents are allowed write access to the Default VTd PMR Low and High memory ranges based on the agents 6bit encoded SAI value."},
#else
{51, 51, 0x0000000000000000, "RO", "DEFVTDPMR_SAI_POL_51", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{50, 50, 0x0000000000000000, "RW", "DEFVTDPMR_SAI_POL_50", "Bunit Def VTd PMR Write Access Policy: Bit vector used to determine which agents are allowed write access to the Default VTd PMR Low and High memory ranges based on the agents 6bit encoded SAI value."},
#else
{50, 50, 0x0000000000000000, "RW", "DEFVTDPMR_SAI_POL_50", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{49, 49, 0x0000000000000000, "RW", "DEFVTDPMR_SAI_POL_49", "Bunit Def VTd PMR Write Access Policy: Bit vector used to determine which agents are allowed write access to the Default VTd PMR Low and High memory ranges based on the agents 6bit encoded SAI value."},
#else
{49, 49, 0x0000000000000000, "RW", "DEFVTDPMR_SAI_POL_49", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{48, 48, 0x0000000000000001, "RW", "DEFVTDPMR_SAI_POL_48", "Bunit Def VTd PMR Write Access Policy: Bit vector used to determine which agents are allowed write access to the Default VTd PMR Low and High memory ranges based on the agents 6bit encoded SAI value."},
#else
{48, 48, 0x0000000000000001, "RW", "DEFVTDPMR_SAI_POL_48", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{47, 47, 0x0000000000000000, "RO", "DEFVTDPMR_SAI_POL_47", "Bunit Def VTd PMR Write Access Policy: Bit vector used to determine which agents are allowed write access to the Default VTd PMR Low and High memory ranges based on the agents 6bit encoded SAI value."},
#else
{47, 47, 0x0000000000000000, "RO", "DEFVTDPMR_SAI_POL_47", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{46, 46, 0x0000000000000000, "RO", "DEFVTDPMR_SAI_POL_46", "Bunit Def VTd PMR Write Access Policy: Bit vector used to determine which agents are allowed write access to the Default VTd PMR Low and High memory ranges based on the agents 6bit encoded SAI value."},
#else
{46, 46, 0x0000000000000000, "RO", "DEFVTDPMR_SAI_POL_46", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{45, 45, 0x0000000000000000, "RO", "DEFVTDPMR_SAI_POL_45", "Bunit Def VTd PMR Write Access Policy: Bit vector used to determine which agents are allowed write access to the Default VTd PMR Low and High memory ranges based on the agents 6bit encoded SAI value."},
#else
{45, 45, 0x0000000000000000, "RO", "DEFVTDPMR_SAI_POL_45", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{44, 44, 0x0000000000000001, "RW", "DEFVTDPMR_SAI_POL_44", "Bunit Def VTd PMR Write Access Policy: Bit vector used to determine which agents are allowed write access to the Default VTd PMR Low and High memory ranges based on the agents 6bit encoded SAI value."},
#else
{44, 44, 0x0000000000000001, "RW", "DEFVTDPMR_SAI_POL_44", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{43, 43, 0x0000000000000000, "RW", "DEFVTDPMR_SAI_POL_43", "Bunit Def VTd PMR Write Access Policy: Bit vector used to determine which agents are allowed write access to the Default VTd PMR Low and High memory ranges based on the agents 6bit encoded SAI value."},
#else
{43, 43, 0x0000000000000000, "RW", "DEFVTDPMR_SAI_POL_43", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{42, 42, 0x0000000000000000, "RW", "DEFVTDPMR_SAI_POL_42", "Bunit Def VTd PMR Write Access Policy: Bit vector used to determine which agents are allowed write access to the Default VTd PMR Low and High memory ranges based on the agents 6bit encoded SAI value."},
#else
{42, 42, 0x0000000000000000, "RW", "DEFVTDPMR_SAI_POL_42", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{41, 41, 0x0000000000000000, "RW", "DEFVTDPMR_SAI_POL_41", "Bunit Def VTd PMR Write Access Policy: Bit vector used to determine which agents are allowed write access to the Default VTd PMR Low and High memory ranges based on the agents 6bit encoded SAI value."},
#else
{41, 41, 0x0000000000000000, "RW", "DEFVTDPMR_SAI_POL_41", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{40, 40, 0x0000000000000000, "RW", "DEFVTDPMR_SAI_POL_40", "Bunit Def VTd PMR Write Access Policy: Bit vector used to determine which agents are allowed write access to the Default VTd PMR Low and High memory ranges based on the agents 6bit encoded SAI value."},
#else
{40, 40, 0x0000000000000000, "RW", "DEFVTDPMR_SAI_POL_40", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{39, 39, 0x0000000000000000, "RO", "DEFVTDPMR_SAI_POL_39", "Bunit Def VTd PMR Write Access Policy: Bit vector used to determine which agents are allowed write access to the Default VTd PMR Low and High memory ranges based on the agents 6bit encoded SAI value."},
#else
{39, 39, 0x0000000000000000, "RO", "DEFVTDPMR_SAI_POL_39", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{38, 38, 0x0000000000000000, "RW", "DEFVTDPMR_SAI_POL_38", "Bunit Def VTd PMR Write Access Policy: Bit vector used to determine which agents are allowed write access to the Default VTd PMR Low and High memory ranges based on the agents 6bit encoded SAI value."},
#else
{38, 38, 0x0000000000000000, "RW", "DEFVTDPMR_SAI_POL_38", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{37, 37, 0x0000000000000000, "RO", "DEFVTDPMR_SAI_POL_37", "Bunit Def VTd PMR Write Access Policy: Bit vector used to determine which agents are allowed write access to the Default VTd PMR Low and High memory ranges based on the agents 6bit encoded SAI value."},
#else
{37, 37, 0x0000000000000000, "RO", "DEFVTDPMR_SAI_POL_37", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{36, 36, 0x0000000000000000, "RW", "DEFVTDPMR_SAI_POL_36", "Bunit Def VTd PMR Write Access Policy: Bit vector used to determine which agents are allowed write access to the Default VTd PMR Low and High memory ranges based on the agents 6bit encoded SAI value."},
#else
{36, 36, 0x0000000000000000, "RW", "DEFVTDPMR_SAI_POL_36", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{35, 35, 0x0000000000000000, "RO", "DEFVTDPMR_SAI_POL_35", "Bunit Def VTd PMR Write Access Policy: Bit vector used to determine which agents are allowed write access to the Default VTd PMR Low and High memory ranges based on the agents 6bit encoded SAI value."},
#else
{35, 35, 0x0000000000000000, "RO", "DEFVTDPMR_SAI_POL_35", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{34, 34, 0x0000000000000000, "RW", "DEFVTDPMR_SAI_POL_34", "Bunit Def VTd PMR Write Access Policy: Bit vector used to determine which agents are allowed write access to the Default VTd PMR Low and High memory ranges based on the agents 6bit encoded SAI value."},
#else
{34, 34, 0x0000000000000000, "RW", "DEFVTDPMR_SAI_POL_34", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{33, 33, 0x0000000000000000, "RW", "DEFVTDPMR_SAI_POL_33", "Bunit Def VTd PMR Write Access Policy: Bit vector used to determine which agents are allowed write access to the Default VTd PMR Low and High memory ranges based on the agents 6bit encoded SAI value."},
#else
{33, 33, 0x0000000000000000, "RW", "DEFVTDPMR_SAI_POL_33", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{32, 32, 0x0000000000000000, "RW", "DEFVTDPMR_SAI_POL_32", "Bunit Def VTd PMR Write Access Policy: Bit vector used to determine which agents are allowed write access to the Default VTd PMR Low and High memory ranges based on the agents 6bit encoded SAI value."},
#else
{32, 32, 0x0000000000000000, "RW", "DEFVTDPMR_SAI_POL_32", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{31, 31, 0x0000000000000000, "RO", "DEFVTDPMR_SAI_POL_31", "Bunit Def VTd PMR Write Access Policy: Bit vector used to determine which agents are allowed write access to the Default VTd PMR Low and High memory ranges based on the agents 6bit encoded SAI value."},
#else
{31, 31, 0x0000000000000000, "RO", "DEFVTDPMR_SAI_POL_31", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{30, 30, 0x0000000000000000, "RW", "DEFVTDPMR_SAI_POL_30", "Bunit Def VTd PMR Write Access Policy: Bit vector used to determine which agents are allowed write access to the Default VTd PMR Low and High memory ranges based on the agents 6bit encoded SAI value."},
#else
{30, 30, 0x0000000000000000, "RW", "DEFVTDPMR_SAI_POL_30", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{29, 29, 0x0000000000000000, "RW", "DEFVTDPMR_SAI_POL_29", "Bunit Def VTd PMR Write Access Policy: Bit vector used to determine which agents are allowed write access to the Default VTd PMR Low and High memory ranges based on the agents 6bit encoded SAI value."},
#else
{29, 29, 0x0000000000000000, "RW", "DEFVTDPMR_SAI_POL_29", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{28, 28, 0x0000000000000000, "RW", "DEFVTDPMR_SAI_POL_28", "Bunit Def VTd PMR Write Access Policy: Bit vector used to determine which agents are allowed write access to the Default VTd PMR Low and High memory ranges based on the agents 6bit encoded SAI value."},
#else
{28, 28, 0x0000000000000000, "RW", "DEFVTDPMR_SAI_POL_28", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{27, 27, 0x0000000000000000, "RW", "DEFVTDPMR_SAI_POL_27", "Bunit Def VTd PMR Write Access Policy: Bit vector used to determine which agents are allowed write access to the Default VTd PMR Low and High memory ranges based on the agents 6bit encoded SAI value."},
#else
{27, 27, 0x0000000000000000, "RW", "DEFVTDPMR_SAI_POL_27", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{26, 26, 0x0000000000000000, "RW", "DEFVTDPMR_SAI_POL_26", "Bunit Def VTd PMR Write Access Policy: Bit vector used to determine which agents are allowed write access to the Default VTd PMR Low and High memory ranges based on the agents 6bit encoded SAI value."},
#else
{26, 26, 0x0000000000000000, "RW", "DEFVTDPMR_SAI_POL_26", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{25, 25, 0x0000000000000000, "RW", "DEFVTDPMR_SAI_POL_25", "Bunit Def VTd PMR Write Access Policy: Bit vector used to determine which agents are allowed write access to the Default VTd PMR Low and High memory ranges based on the agents 6bit encoded SAI value."},
#else
{25, 25, 0x0000000000000000, "RW", "DEFVTDPMR_SAI_POL_25", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{24, 24, 0x0000000000000000, "RW", "DEFVTDPMR_SAI_POL_24", "Bunit Def VTd PMR Write Access Policy: Bit vector used to determine which agents are allowed write access to the Default VTd PMR Low and High memory ranges based on the agents 6bit encoded SAI value."},
#else
{24, 24, 0x0000000000000000, "RW", "DEFVTDPMR_SAI_POL_24", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{23, 23, 0x0000000000000000, "RO", "DEFVTDPMR_SAI_POL_23", "Bunit Def VTd PMR Write Access Policy: Bit vector used to determine which agents are allowed write access to the Default VTd PMR Low and High memory ranges based on the agents 6bit encoded SAI value."},
#else
{23, 23, 0x0000000000000000, "RO", "DEFVTDPMR_SAI_POL_23", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{22, 22, 0x0000000000000000, "RO", "DEFVTDPMR_SAI_POL_22", "Bunit Def VTd PMR Write Access Policy: Bit vector used to determine which agents are allowed write access to the Default VTd PMR Low and High memory ranges based on the agents 6bit encoded SAI value."},
#else
{22, 22, 0x0000000000000000, "RO", "DEFVTDPMR_SAI_POL_22", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{21, 21, 0x0000000000000000, "RW", "DEFVTDPMR_SAI_POL_21", "Bunit Def VTd PMR Write Access Policy: Bit vector used to determine which agents are allowed write access to the Default VTd PMR Low and High memory ranges based on the agents 6bit encoded SAI value."},
#else
{21, 21, 0x0000000000000000, "RW", "DEFVTDPMR_SAI_POL_21", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{20, 20, 0x0000000000000000, "RO", "DEFVTDPMR_SAI_POL_20", "Bunit Def VTd PMR Write Access Policy: Bit vector used to determine which agents are allowed write access to the Default VTd PMR Low and High memory ranges based on the agents 6bit encoded SAI value."},
#else
{20, 20, 0x0000000000000000, "RO", "DEFVTDPMR_SAI_POL_20", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{19, 19, 0x0000000000000000, "RO", "DEFVTDPMR_SAI_POL_19", "Bunit Def VTd PMR Write Access Policy: Bit vector used to determine which agents are allowed write access to the Default VTd PMR Low and High memory ranges based on the agents 6bit encoded SAI value."},
#else
{19, 19, 0x0000000000000000, "RO", "DEFVTDPMR_SAI_POL_19", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{18, 18, 0x0000000000000000, "RO", "DEFVTDPMR_SAI_POL_18", "Bunit Def VTd PMR Write Access Policy: Bit vector used to determine which agents are allowed write access to the Default VTd PMR Low and High memory ranges based on the agents 6bit encoded SAI value."},
#else
{18, 18, 0x0000000000000000, "RO", "DEFVTDPMR_SAI_POL_18", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{17, 17, 0x0000000000000000, "RW", "DEFVTDPMR_SAI_POL_17", "Bunit Def VTd PMR Write Access Policy: Bit vector used to determine which agents are allowed write access to the Default VTd PMR Low and High memory ranges based on the agents 6bit encoded SAI value."},
#else
{17, 17, 0x0000000000000000, "RW", "DEFVTDPMR_SAI_POL_17", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{16, 16, 0x0000000000000001, "RW", "DEFVTDPMR_SAI_POL_16", "Bunit Def VTd PMR Write Access Policy: Bit vector used to determine which agents are allowed write access to the Default VTd PMR Low and High memory ranges based on the agents 6bit encoded SAI value."},
#else
{16, 16, 0x0000000000000001, "RW", "DEFVTDPMR_SAI_POL_16", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{15, 15, 0x0000000000000000, "RO", "DEFVTDPMR_SAI_POL_15", "Bunit Def VTd PMR Write Access Policy: Bit vector used to determine which agents are allowed write access to the Default VTd PMR Low and High memory ranges based on the agents 6bit encoded SAI value."},
#else
{15, 15, 0x0000000000000000, "RO", "DEFVTDPMR_SAI_POL_15", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{14, 14, 0x0000000000000000, "RO", "DEFVTDPMR_SAI_POL_14", "Bunit Def VTd PMR Write Access Policy: Bit vector used to determine which agents are allowed write access to the Default VTd PMR Low and High memory ranges based on the agents 6bit encoded SAI value."},
#else
{14, 14, 0x0000000000000000, "RO", "DEFVTDPMR_SAI_POL_14", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{13, 13, 0x0000000000000000, "RW", "DEFVTDPMR_SAI_POL_13", "Bunit Def VTd PMR Write Access Policy: Bit vector used to determine which agents are allowed write access to the Default VTd PMR Low and High memory ranges based on the agents 6bit encoded SAI value."},
#else
{13, 13, 0x0000000000000000, "RW", "DEFVTDPMR_SAI_POL_13", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{12, 12, 0x0000000000000001, "RW", "DEFVTDPMR_SAI_POL_12", "Bunit Def VTd PMR Write Access Policy: Bit vector used to determine which agents are allowed write access to the Default VTd PMR Low and High memory ranges based on the agents 6bit encoded SAI value."},
#else
{12, 12, 0x0000000000000001, "RW", "DEFVTDPMR_SAI_POL_12", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{11, 11, 0x0000000000000000, "RO", "DEFVTDPMR_SAI_POL_11", "Bunit Def VTd PMR Write Access Policy: Bit vector used to determine which agents are allowed write access to the Default VTd PMR Low and High memory ranges based on the agents 6bit encoded SAI value."},
#else
{11, 11, 0x0000000000000000, "RO", "DEFVTDPMR_SAI_POL_11", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{10, 10, 0x0000000000000000, "RO", "DEFVTDPMR_SAI_POL_10", "Bunit Def VTd PMR Write Access Policy: Bit vector used to determine which agents are allowed write access to the Default VTd PMR Low and High memory ranges based on the agents 6bit encoded SAI value."},
#else
{10, 10, 0x0000000000000000, "RO", "DEFVTDPMR_SAI_POL_10", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{9, 9, 0x0000000000000000, "RO", "DEFVTDPMR_SAI_POL_9", "Bunit Def VTd PMR Write Access Policy: Bit vector used to determine which agents are allowed write access to the Default VTd PMR Low and High memory ranges based on the agents 6bit encoded SAI value."},
#else
{9, 9, 0x0000000000000000, "RO", "DEFVTDPMR_SAI_POL_9", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{8, 8, 0x0000000000000001, "RW", "DEFVTDPMR_SAI_POL_8", "Bunit Def VTd PMR Write Access Policy: Bit vector used to determine which agents are allowed write access to the Default VTd PMR Low and High memory ranges based on the agents 6bit encoded SAI value."},
#else
{8, 8, 0x0000000000000001, "RW", "DEFVTDPMR_SAI_POL_8", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{7, 7, 0x0000000000000000, "RO", "DEFVTDPMR_SAI_POL_7", "Bunit Def VTd PMR Write Access Policy: Bit vector used to determine which agents are allowed write access to the Default VTd PMR Low and High memory ranges based on the agents 6bit encoded SAI value."},
#else
{7, 7, 0x0000000000000000, "RO", "DEFVTDPMR_SAI_POL_7", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{6, 6, 0x0000000000000000, "RO", "DEFVTDPMR_SAI_POL_6", "Bunit Def VTd PMR Write Access Policy: Bit vector used to determine which agents are allowed write access to the Default VTd PMR Low and High memory ranges based on the agents 6bit encoded SAI value."},
#else
{6, 6, 0x0000000000000000, "RO", "DEFVTDPMR_SAI_POL_6", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{5, 5, 0x0000000000000000, "RW", "DEFVTDPMR_SAI_POL_5", "Bunit Def VTd PMR Write Access Policy: Bit vector used to determine which agents are allowed write access to the Default VTd PMR Low and High memory ranges based on the agents 6bit encoded SAI value."},
#else
{5, 5, 0x0000000000000000, "RW", "DEFVTDPMR_SAI_POL_5", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{4, 4, 0x0000000000000001, "RW", "DEFVTDPMR_SAI_POL_4", "Bunit Def VTd PMR Write Access Policy: Bit vector used to determine which agents are allowed write access to the Default VTd PMR Low and High memory ranges based on the agents 6bit encoded SAI value."},
#else
{4, 4, 0x0000000000000001, "RW", "DEFVTDPMR_SAI_POL_4", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{3, 3, 0x0000000000000000, "RW", "DEFVTDPMR_SAI_POL_3", "Bunit Def VTd PMR Write Access Policy: Bit vector used to determine which agents are allowed write access to the Default VTd PMR Low and High memory ranges based on the agents 6bit encoded SAI value."},
#else
{3, 3, 0x0000000000000000, "RW", "DEFVTDPMR_SAI_POL_3", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{2, 2, 0x0000000000000001, "RW", "DEFVTDPMR_SAI_POL_2", "Bunit Def VTd PMR Write Access Policy: Bit vector used to determine which agents are allowed write access to the Default VTd PMR Low and High memory ranges based on the agents 6bit encoded SAI value."},
#else
{2, 2, 0x0000000000000001, "RW", "DEFVTDPMR_SAI_POL_2", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{1, 1, 0x0000000000000001, "RW", "DEFVTDPMR_SAI_POL_1", "Bunit Def VTd PMR Write Access Policy: Bit vector used to determine which agents are allowed write access to the Default VTd PMR Low and High memory ranges based on the agents 6bit encoded SAI value."},
#else
{1, 1, 0x0000000000000001, "RW", "DEFVTDPMR_SAI_POL_1", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 0, 0x0000000000000001, "RW", "DEFVTDPMR_SAI_POL_0", "Bunit Def VTd PMR Write Access Policy: Bit vector used to determine which agents are allowed write access to the Default VTd PMR Low and High memory ranges based on the agents 6bit encoded SAI value."},
#else
{0, 0, 0x0000000000000001, "RW", "DEFVTDPMR_SAI_POL_0", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo828[] = {{"B_CR_BDEFVTDPMR_WAC", "", 0x00004B90, 64, 0xFFFFFFFFFFFFFFFF, 0x0001100000011117}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields829[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{0, 63, 0x0000040061010202, "RW", "MEM_RANGE_CTRL_POL", "Bit vector used to determine which agents are allowed write access to the IA_GT_UNTRUSTED_RAC IA_GT_UNTRUSTED_WAC and IA_GT_UNTRUSTED_CP registers based on the value from the agents 6bit SAI field."},
#else
{0, 63, 0x0000040061010202, "RW", "MEM_RANGE_CTRL_POL", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo829[] = {{"B_CR_IA_GT_UNTRUSTED_CP", "", 0x00004B98, 1, 0xFFFFFFFFFFFFFFFF, 0x0000040061010202}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields830[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{0, 63, 0x00011C0063010317, "RW", "MEM_RANGE_POL", "Bit vector used to determine which agents are allowed read access based on the agents 6bit encoded SAI value."},
#else
{0, 63, 0x00011C0063010317, "RW", "MEM_RANGE_POL", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo830[] = {{"B_CR_IA_GT_UNTRUSTED_RAC", "", 0x00004BA0, 1, 0xFFFFFFFFFFFFFFFF, 0x00011C0063010317}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields831[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{0, 63, 0x00011C0061000317, "RW", "MEM_RANGE_POL", "Bit vector used to determine which agents are allowed write access based on the agents 6bit encoded SAI value."},
#else
{0, 63, 0x00011C0061000317, "RW", "MEM_RANGE_POL", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo831[] = {{"B_CR_IA_GT_UNTRUSTED_WAC", "", 0x00004BA8, 1, 0xFFFFFFFFFFFFFFFF, 0x00011C0061000317}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields832[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{0, 63, 0x0000040021000202, "RW", "IA_CTRL_POL", "Bunit IA Core Control Policy: Bit vector used to determine which agents are allowed access to the P_U_CODERDWR_RAC P_U_CODERDWR_WAC and P_U_CODERDWR_CP registers based on the value from the agents 6bit SAI field."},
#else
{0, 63, 0x0000040021000202, "RW", "IA_CTRL_POL", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo832[] = {{"B_CR_P_U_CODERDWR_CP", "", 0x00004C00, 1, 0xFFFFFFFFFFFFFFFF, 0x0000040021000202}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields833[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{0, 63, 0x0000040021010202, "RW", "IA_SAI_POL", "Bunit IA Core SAI Read Access Policy: Bit vector used to determine which agents are allowed read access to the Bunit IA Core Configuration registers based on the agents 6bit encoded SAI value."},
#else
{0, 63, 0x0000040021010202, "RW", "IA_SAI_POL", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo833[] = {{"B_CR_P_U_CODERDWR_RAC", "", 0x00004C08, 1, 0xFFFFFFFFFFFFFFFF, 0x0000040021010202}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields834[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{0, 63, 0x0000040021000202, "RW", "IA_SAI_POL", "Bunit IA Core SAI Write Access Policy: Bit vector used to determine which agents are allowed write access to the Bunit IA Core Configuration registers based on the agents 6bit encoded SAI value."},
#else
{0, 63, 0x0000040021000202, "RW", "IA_SAI_POL", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo834[] = {{"B_CR_P_U_CODERDWR_WAC", "", 0x00004C10, 1, 0xFFFFFFFFFFFFFFFF, 0x0000040021000202}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields835[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{3, 31, 0x0000000000000000, "RO", "RESERVED_0", "Reserved"},
#else
{3, 31, 0x0000000000000000, "RO", "RESERVED_0", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{2, 2, 0x0000000000000001, "RW", "BOOT_MODE", "Boot Bios : When set Core is in Boot mode."},
#else
{2, 2, 0x0000000000000001, "RW", "BOOT_MODE", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{1, 1, 0x0000000000000000, "RW", "ACM_NPP_MODE", "ACM/NPP Mode: When set Core is in Authenticated Code Module / NonPersistent Patch mode."},
#else
{1, 1, 0x0000000000000000, "RW", "ACM_NPP_MODE", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 0, 0x0000000000000000, "RW", "SMM_MODE", "SMM  Mode : When set Core is in SMM mode."},
#else
{0, 0, 0x0000000000000000, "RW", "SMM_MODE", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo835[] = {{"B_CR_LPMODE", "", 0x00004C18, 4, 0x00000000FFFFFFFF, 0x0000000000000004}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields836[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{31, 31, 0x0000000000000000, "RO", "RESERVED_0", "Reserved"},
#else
{31, 31, 0x0000000000000000, "RO", "RESERVED_0", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{30, 30, 0x0000000000000001, "RO/V", "IDI_SHUTDOWN", "When set, all IDI interfaces are in SHUTDOWN state."},
#else
{30, 30, 0x0000000000000001, "RO/V", "IDI_SHUTDOWN", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{29, 29, 0x0000000000000001, "RO/V", "PII_AGENT_IDLE", "When set, PII agent ISM (in A unit) is in Idle state."},
#else
{29, 29, 0x0000000000000001, "RO/V", "PII_AGENT_IDLE", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{28, 28, 0x0000000000000001, "RO/V", "PII_FABRIC_IDLE", "When set, PII fabric ISM (in B unit) is in Idle state."},
#else
{28, 28, 0x0000000000000001, "RO/V", "PII_FABRIC_IDLE", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{27, 27, 0x0000000000000001, "RO/V", "IOSF_IDLE", "When set, A unit's IOSF interface is idle."},
#else
{27, 27, 0x0000000000000001, "RO/V", "IOSF_IDLE", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{26, 26, 0x0000000000000001, "RO/V", "PMI_AGENT_IDLE_S0", "When set, all PMI agent ISM's for slice 0 (in B unit) are in Idle state."},
#else
{26, 26, 0x0000000000000001, "RO/V", "PMI_AGENT_IDLE_S0", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{25, 25, 0x0000000000000001, "RO/V", "PMI_FABRIC_IDLE_S0", "When set, all PMI fabric ISM's for slice 0 (in D units) are in Idle state."},
#else
{25, 25, 0x0000000000000001, "RO/V", "PMI_FABRIC_IDLE_S0", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{24, 24, 0x0000000000000001, "RO/V", "PMI_AGENT_IDLE_S1", "When set, all PMI agent ISM's for slice 1 (in B unit) are in Idle state."},
#else
{24, 24, 0x0000000000000001, "RO/V", "PMI_AGENT_IDLE_S1", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{23, 23, 0x0000000000000001, "RO/V", "PMI_FABRIC_IDLE_S1", "When set, all PMI fabric ISM's for slice 1 (in D units) are in Idle state."},
#else
{23, 23, 0x0000000000000001, "RO/V", "PMI_FABRIC_IDLE_S1", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{22, 22, 0x0000000000000001, "RO/V", "IDI_CQ_EMPTY_S0", "When set, IDI conflict queue in slice 0 is empty."},
#else
{22, 22, 0x0000000000000001, "RO/V", "IDI_CQ_EMPTY_S0", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{21, 21, 0x0000000000000001, "RO/V", "IDI_CQ_EMPTY_S1", "When set, IDI conflict queue in slice 1 is empty."},
#else
{21, 21, 0x0000000000000001, "RO/V", "IDI_CQ_EMPTY_S1", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{20, 20, 0x0000000000000001, "RO/V", "PII_CQ_EMPTY", "When set, PII conflict queues are empty."},
#else
{20, 20, 0x0000000000000001, "RO/V", "PII_CQ_EMPTY", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{19, 19, 0x0000000000000001, "RO/V", "LOCKQ_EMPTY", "When set, Lock queue is empty."},
#else
{19, 19, 0x0000000000000001, "RO/V", "LOCKQ_EMPTY", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{18, 18, 0x0000000000000001, "RO/V", "REFCNTS_ZERO_S0", "When set, all B unit scoreboard refcnts in slice 0 are zero."},
#else
{18, 18, 0x0000000000000001, "RO/V", "REFCNTS_ZERO_S0", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{17, 17, 0x0000000000000001, "RO/V", "REFCNTS_ZERO_S1", "When set, all B unit scoreboard refcnts in slice 1 are zero."},
#else
{17, 17, 0x0000000000000001, "RO/V", "REFCNTS_ZERO_S1", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{16, 16, 0x0000000000000001, "RO/V", "NO_PEND_RD_REQ_S0", "When set, B unit scoreboard in slice 0 has no pending read requests."},
#else
{16, 16, 0x0000000000000001, "RO/V", "NO_PEND_RD_REQ_S0", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{15, 15, 0x0000000000000001, "RO/V", "NO_PEND_RD_REQ_S1", "When set, B unit scoreboard in slice 1 has no pending read requests."},
#else
{15, 15, 0x0000000000000001, "RO/V", "NO_PEND_RD_REQ_S1", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{14, 14, 0x0000000000000001, "RO/V", "NO_DIRTY_ENTRIES_S0", "When set, B unit scoreboard in slice 0 has no dirty entries."},
#else
{14, 14, 0x0000000000000001, "RO/V", "NO_DIRTY_ENTRIES_S0", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{13, 13, 0x0000000000000001, "RO/V", "NO_DIRTY_ENTRIES_S1", "When set, B unit scoreboard in slice 1 has no dirty entries."},
#else
{13, 13, 0x0000000000000001, "RO/V", "NO_DIRTY_ENTRIES_S1", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{12, 12, 0x0000000000000001, "RO/V", "MOT_IDLE_S0", "When set, B unit MOT in slice 0 is idle."},
#else
{12, 12, 0x0000000000000001, "RO/V", "MOT_IDLE_S0", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{11, 11, 0x0000000000000001, "RO/V", "MOT_IDLE_S1", "When set, B unit MOT in slice 1 is idle."},
#else
{11, 11, 0x0000000000000001, "RO/V", "MOT_IDLE_S1", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{10, 10, 0x0000000000000001, "RO/V", "OOAQ_EMPTY_S0", "When set, T unit OOAQ in slice 0 is empty."},
#else
{10, 10, 0x0000000000000001, "RO/V", "OOAQ_EMPTY_S0", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{9, 9, 0x0000000000000001, "RO/V", "OOAQ_EMPTY_S1", "When set, T unit OOAQ in slice 1 is empty."},
#else
{9, 9, 0x0000000000000001, "RO/V", "OOAQ_EMPTY_S1", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{8, 8, 0x0000000000000001, "RO/V", "PICLET_IDLE", "When set, T unit PICLET is idle."},
#else
{8, 8, 0x0000000000000001, "RO/V", "PICLET_IDLE", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{7, 7, 0x0000000000000001, "RO/V", "VLW_IDLE", "When set, T unit VLW is idle."},
#else
{7, 7, 0x0000000000000001, "RO/V", "VLW_IDLE", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{6, 6, 0x0000000000000001, "RO/V", "NO_OUTB_SB_MSG", "When set, T unit has no outbound SB message pending."},
#else
{6, 6, 0x0000000000000001, "RO/V", "NO_OUTB_SB_MSG", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{5, 5, 0x0000000000000001, "RO/V", "B_SB_AGENT_IDLE", "When set, B unit SB agent ISM is in Idle state."},
#else
{5, 5, 0x0000000000000001, "RO/V", "B_SB_AGENT_IDLE", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{4, 4, 0x0000000000000001, "RO/V", "B_SB_FABRIC_IDLE", "When set, B unit SB fabric ISM is in Idle state."},
#else
{4, 4, 0x0000000000000001, "RO/V", "B_SB_FABRIC_IDLE", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{3, 3, 0x0000000000000001, "RO/V", "T_SB_AGENT_IDLE", "When set, T unit SB agent ISM is in Idle state."},
#else
{3, 3, 0x0000000000000001, "RO/V", "T_SB_AGENT_IDLE", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{2, 2, 0x0000000000000001, "RO/V", "T_SB_FABRIC_IDLE", "When set, T unit SB fabric ISM is in Idle state."},
#else
{2, 2, 0x0000000000000001, "RO/V", "T_SB_FABRIC_IDLE", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{1, 1, 0x0000000000000001, "RO/V", "B_SB_NO_CLKREQ", "When set, B unit SB endpoint is not requesting SB clock."},
#else
{1, 1, 0x0000000000000001, "RO/V", "B_SB_NO_CLKREQ", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 0, 0x0000000000000001, "RO/V", "T_SB_NO_CLKREQ", "When set, T unit SB endpoint is not requesting SB clock."},
#else
{0, 0, 0x0000000000000001, "RO/V", "T_SB_NO_CLKREQ", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo836[] = {{"B_CR_BT_IDLE_STATUS", "", 0x00004C1C, 32, 0x00000000FFFFFFFF, 0x000000007FFFFFFF}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields837[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{0, 63, 0x0000040061010212, "RW", "MEM_RANGE_CTRL_POL", "Bit vector used to determine which agents are allowed write access to the BIOSWR_EXPOSE_RAC BIOSWR_EXPOSE_WAC and BIOSWR_EXPOSE_CP registers based on the value from the agents 6bit SAI field."},
#else
{0, 63, 0x0000040061010212, "RW", "MEM_RANGE_CTRL_POL", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo837[] = {{"B_CR_BIOSWR_EXPOSE_CP", "", 0x00004C20, 1, 0xFFFFFFFFFFFFFFFF, 0x0000040061010212}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields838[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{0, 63, 0x00000C0063010217, "RW", "MEM_RANGE_POL", "Bit vector used to determine which agents are allowed read access based on the agents 6bit encoded SAI value."},
#else
{0, 63, 0x00000C0063010217, "RW", "MEM_RANGE_POL", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo838[] = {{"B_CR_BIOSWR_EXPOSE_RAC", "", 0x00004C28, 1, 0xFFFFFFFFFFFFFFFF, 0x00000C0063010217}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields839[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{0, 63, 0x00000C0061000212, "RW", "MEM_RANGE_POL", "Bit vector used to determine which agents are allowed write access based on the agents 6bit encoded SAI value."},
#else
{0, 63, 0x00000C0061000212, "RW", "MEM_RANGE_POL", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo839[] = {{"B_CR_BIOSWR_EXPOSE_WAC", "", 0x00004C30, 1, 0xFFFFFFFFFFFFFFFF, 0x00000C0061000212}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields840[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{16, 31, 0x0000000000000000, "RO", "RESERVED_0", "Reserved"},
#else
{16, 31, 0x0000000000000000, "RO", "RESERVED_0", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{12, 15, 0x0000000000000000, "RW", "MOT", "Access Class for MOT requests"},
#else
{12, 15, 0x0000000000000000, "RW", "MOT", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{8, 11, 0x0000000000000004, "RW", "GFX_AC", "Access Class for GFX Requests"},
#else
{8, 11, 0x0000000000000004, "RW", "GFX_AC", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{4, 7, 0x0000000000000000, "RW", "IA_PREFETCH_AC", "Access Class for IA Prefetch Requests.  Not supported by BXT/DNV"},
#else
{4, 7, 0x0000000000000000, "RW", "IA_PREFETCH_AC", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 3, 0x0000000000000000, "RW", "IA_DEMAND_AC", "Access Class for IA Demand Requests"},
#else
{0, 3, 0x0000000000000000, "RW", "IA_DEMAND_AC", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo840[] = {{"B_CR_SCH_AC_MAPPING0", "", 0x00004C38, 5, 0x00000000FFFFFFFF, 0x0000000000000400}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields841[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{28, 31, 0x0000000000000000, "RW", "CHANNEL7_AC", "Access Class for Channel 7 BXT VCbr"},
#else
{28, 31, 0x0000000000000000, "RW", "CHANNEL7_AC", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{24, 27, 0x0000000000000002, "RW", "CHANNEL6_AC", "Access Class for Channel 6 BXT VC2c"},
#else
{24, 27, 0x0000000000000002, "RW", "CHANNEL6_AC", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{20, 23, 0x0000000000000002, "RW", "CHANNEL5_AC", "Access Class for Channel 5 BXT VC2b"},
#else
{20, 23, 0x0000000000000002, "RW", "CHANNEL5_AC", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{16, 19, 0x0000000000000002, "RW", "CHANNEL4_AC", "Access Class for Channel 4 BXT VC2a"},
#else
{16, 19, 0x0000000000000002, "RW", "CHANNEL4_AC", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{12, 15, 0x0000000000000001, "RW", "CHANNEL3_AC", "Access Class for Channel 3 BXT VC1b"},
#else
{12, 15, 0x0000000000000001, "RW", "CHANNEL3_AC", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{8, 11, 0x0000000000000001, "RW", "CHANNEL2_AC", "Access Class for Channel 2 BXT VC1a"},
#else
{8, 11, 0x0000000000000001, "RW", "CHANNEL2_AC", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{4, 7, 0x0000000000000000, "RW", "CHANNEL1_AC", "Access Class for Channel 1 BXT VC0b"},
#else
{4, 7, 0x0000000000000000, "RW", "CHANNEL1_AC", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 3, 0x0000000000000000, "RW", "CHANNEL0_AC", "Access Class for Channel 0 BXT VC0a"},
#else
{0, 3, 0x0000000000000000, "RW", "CHANNEL0_AC", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo841[] = {{"B_CR_SCH_AC_MAPPING1", "", 0x00004C3C, 8, 0x00000000FFFFFFFF, 0x0000000002221100}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields842[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{28, 31, 0x0000000000000000, "RO", "CHANNEL15_AC", "Access Class for Channel 15 BXT Reserved"},
#else
{28, 31, 0x0000000000000000, "RO", "CHANNEL15_AC", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{24, 27, 0x0000000000000000, "RO", "CHANNEL14_AC", "Access Class for Channel 14 BXT Reserved"},
#else
{24, 27, 0x0000000000000000, "RO", "CHANNEL14_AC", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{20, 23, 0x0000000000000000, "RO", "CHANNEL13_AC", "Access Class for Channel 13 BXT Reserved"},
#else
{20, 23, 0x0000000000000000, "RO", "CHANNEL13_AC", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{16, 19, 0x0000000000000000, "RO", "CHANNEL12_AC", "Access Class for Channel 12 BXT Reserved"},
#else
{16, 19, 0x0000000000000000, "RO", "CHANNEL12_AC", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{12, 15, 0x0000000000000000, "RO", "CHANNEL11_AC", "Access Class for Channel 11 BXT Reserved"},
#else
{12, 15, 0x0000000000000000, "RO", "CHANNEL11_AC", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{8, 11, 0x0000000000000001, "RW", "CHANNEL10_AC", "Access Class for Channel 10 BXT VCiommu1b"},
#else
{8, 11, 0x0000000000000001, "RW", "CHANNEL10_AC", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{4, 7, 0x0000000000000000, "RW", "CHANNEL9_AC", "Access Class for Channel 9 BXT VCiommu0b"},
#else
{4, 7, 0x0000000000000000, "RW", "CHANNEL9_AC", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 3, 0x0000000000000000, "RW", "CHANNEL8_AC", "Access Class for Channel 8 BXT VCiommu0a"},
#else
{0, 3, 0x0000000000000000, "RW", "CHANNEL8_AC", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo842[] = {{"B_CR_SCH_AC_MAPPING2", "", 0x00004C40, 8, 0x00000000FFFFFFFF, 0x0000000000000100}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields843[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{24, 31, 0x0000000000000000, "RW", "ENTER_PMI_IDLE_DEADLINE_THRSH", "Enter PMI Idle Deadline Threshold:  Formerly ENTER_SELF_REFRESH_THRSH.  Required request latency to allow PMI to enter IDLE state.  Value programmed has a 240ns resolution.  If the Bunit receives ISOC requests that have a required latency less than this value the Bunit will keep the memory out of Self Refresh.  NOTE:  PND2 will not need this and hence the default of 0x0"},
#else
{24, 31, 0x0000000000000000, "RW", "ENTER_PMI_IDLE_DEADLINE_THRSH", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{20, 23, 0x0000000000000008, "RW", "SCHEDULER_LATENCY", "Scheduler Latency:  Request latency below which an ISOC request is considered as a HiPriority Request. Value programmed has 240ns resolution. Default is approximately 2usec."},
#else
{20, 23, 0x0000000000000008, "RW", "SCHEDULER_LATENCY", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{19, 19, 0x0000000000000000, "RW", "ABORT_PII_REQUESTS", "Used by the Punit for reset flow.  When set to 1, Bunit will abort all PII transactions, i.e no PMI transactions will be launched for the PII transactions.  Reads will be completed with all 1's data and Abort bit set on the PII completion.  Writes will be dropped.  This bit has no effect on transactions admitted to the Bunit prior to when the bit was set and they will be handled normally.   When the bit is clear, all PII transactions will be handled normally."},
#else
{19, 19, 0x0000000000000000, "RW", "ABORT_PII_REQUESTS", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{12, 18, 0x0000000000000000, "RW", "EXIT_PMI_IDLE_LATENCY", "Exit PMI Idle Latency:  Required latency to Exit Self Refresh in 240ns increments. Default is 0usec which will cause any isoc request regardless of its deadline indication to cause PMI to exit idle state.  Note that best effort requests will always cause PMI to exit idle state.  NOTE:  PND2 will always wake up PMI on any request regardless of the request deadline hence the default value of 0."},
#else
{12, 18, 0x0000000000000000, "RW", "EXIT_PMI_IDLE_LATENCY", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{11, 11, 0x0000000000000000, "RW", "SLICE_EXIT_MODE", "0: Bunit causes all PMI channels in both slices to exit IDLE state if a transaction targeting any slice is stalled in the BunitFE Badmit arbiter.  1: Bunit causes all PMI channels in only the targeted slcie to exit IDLE state when a transaction is stalled in the BunitFE Badmit arbiter."},
#else
{11, 11, 0x0000000000000000, "RW", "SLICE_EXIT_MODE", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{10, 10, 0x0000000000000001, "RW", "CH_EXIT_MODE", "0: Request in Bunit scheduler scoreboard targeting any PMI channel within the slice will cause all PMI channels to exit IDLE state.  1: A PMI channel will exit IDLE state only when a request targeting that PMI channel is available to be scheduled in the Bunit scheduler scoreboard."},
#else
{10, 10, 0x0000000000000001, "RW", "CH_EXIT_MODE", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{8, 9, 0x0000000000000000, "RO", "RESERVED_0", "Reserved"},
#else
{8, 9, 0x0000000000000000, "RO", "RESERVED_0", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{1, 7, 0x0000000000000001, "RW", "ENTER_PMI_IDLE_DLY", "Enter PMI Idle Delay: Formerly called ENTER_SELF_REFRESH_DLY.  Duration the Bunit waits before asking PMI interfaces to go idle. Each unit of time is 240ns."},
#else
{1, 7, 0x0000000000000001, "RW", "ENTER_PMI_IDLE_DLY", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 0, 0x0000000000000001, "RW", "ENABLE_PMI_IDLE", "Enable PMI to move to an idle state:  When set Bunit will cause a PMI interface to move to an idle state depending on various idle indicators.  When cleared Bunit will always keep all PMI interfaces active."},
#else
{0, 0, 0x0000000000000001, "RW", "ENABLE_PMI_IDLE", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo843[] = {{"B_CR_BISOC", "", 0x00004C44, 9, 0x00000000FFFFFFFF, 0x0000000000800403}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields844[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{30, 31, 0x0000000000000000, "RW", "COS_CAT_AGENT15", "COS Category for Agent15"},
#else
{30, 31, 0x0000000000000000, "RW", "COS_CAT_AGENT15", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{28, 29, 0x0000000000000000, "RW", "COS_CAT_AGENT14", "COS Category for Agent14"},
#else
{28, 29, 0x0000000000000000, "RW", "COS_CAT_AGENT14", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{26, 27, 0x0000000000000001, "RW", "COS_CAT_AGENT13", "COS Category for Agent13"},
#else
{26, 27, 0x0000000000000001, "RW", "COS_CAT_AGENT13", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{24, 25, 0x0000000000000000, "RW", "COS_CAT_AGENT12", "COS Category for Agent12"},
#else
{24, 25, 0x0000000000000000, "RW", "COS_CAT_AGENT12", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{22, 23, 0x0000000000000000, "RW", "COS_CAT_AGENT11", "COS Category for Agent11"},
#else
{22, 23, 0x0000000000000000, "RW", "COS_CAT_AGENT11", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{20, 21, 0x0000000000000000, "RW", "COS_CAT_AGENT10", "COS Category for Agent10"},
#else
{20, 21, 0x0000000000000000, "RW", "COS_CAT_AGENT10", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{18, 19, 0x0000000000000001, "RW", "COS_CAT_AGENT9", "COS Category for Agent9"},
#else
{18, 19, 0x0000000000000001, "RW", "COS_CAT_AGENT9", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{16, 17, 0x0000000000000001, "RW", "COS_CAT_AGENT8", "COS Category for Agent8"},
#else
{16, 17, 0x0000000000000001, "RW", "COS_CAT_AGENT8", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{14, 15, 0x0000000000000001, "RW", "COS_CAT_AGENT7", "COS Category for Agent7"},
#else
{14, 15, 0x0000000000000001, "RW", "COS_CAT_AGENT7", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{12, 13, 0x0000000000000001, "RW", "COS_CAT_AGENT6", "COS Category for Agent6"},
#else
{12, 13, 0x0000000000000001, "RW", "COS_CAT_AGENT6", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{10, 11, 0x0000000000000001, "RW", "COS_CAT_AGENT5", "COS Category for Agent5"},
#else
{10, 11, 0x0000000000000001, "RW", "COS_CAT_AGENT5", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{8, 9, 0x0000000000000000, "RW", "COS_CAT_AGENT4", "COS Category for Agent4"},
#else
{8, 9, 0x0000000000000000, "RW", "COS_CAT_AGENT4", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{6, 7, 0x0000000000000000, "RW", "COS_CAT_AGENT3", "COS Category for Agent3"},
#else
{6, 7, 0x0000000000000000, "RW", "COS_CAT_AGENT3", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{4, 5, 0x0000000000000000, "RW", "COS_CAT_AGENT2", "COS Category for Agent2"},
#else
{4, 5, 0x0000000000000000, "RW", "COS_CAT_AGENT2", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{2, 3, 0x0000000000000000, "RW", "COS_CAT_AGENT1", "COS Category for Agent1"},
#else
{2, 3, 0x0000000000000000, "RW", "COS_CAT_AGENT1", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 1, 0x0000000000000000, "RW", "COS_CAT_AGENT0", "COS Category for Agent0"},
#else
{0, 1, 0x0000000000000000, "RW", "COS_CAT_AGENT0", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo844[] = {{"B_CR_BCOSCAT", "", 0x00004C4C, 16, 0x00000000FFFFFFFF, 0x0000000004055400}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields845[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{31, 31, 0x0000000000000000, "RW", "DPT_MODE", "DPT Enable:  When set enables dynamic prefetch throttling of IDI requests."},
#else
{31, 31, 0x0000000000000000, "RW", "DPT_MODE", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{14, 30, 0x0000000000000000, "RO", "RESERVED_0", "Reserved"},
#else
{14, 30, 0x0000000000000000, "RO", "RESERVED_0", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{8, 13, 0x0000000000000010, "RW", "DPT_HI_THRESH", "Upper threshold for DPT throttling."},
#else
{8, 13, 0x0000000000000010, "RW", "DPT_HI_THRESH", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{6, 7, 0x0000000000000000, "RO", "RESERVED_1", "Reserved"},
#else
{6, 7, 0x0000000000000000, "RO", "RESERVED_1", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 5, 0x0000000000000008, "RW", "DPT_LO_THRESH", "Lower threshold for DPT throttling."},
#else
{0, 5, 0x0000000000000008, "RW", "DPT_LO_THRESH", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo845[] = {{"B_CR_BDPT", "", 0x00004C50, 5, 0x00000000FFFFFFFF, 0x0000000000001008}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields846[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{63, 63, 0x0000000000000000, "RW", "LOCK", "When set, microcode will disallow writes to the this register via the WRMSR path.  Intended usage is for BIOS to set the LOCK when it updates the CR and Ucode to check the LOCK bit to decide whether the WRMSR to this CR must be allowed.  Bunit implements only storage for this bit.  No hardware exists to implement hardware locking."},
#else
{63, 63, 0x0000000000000000, "RW", "LOCK", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{52, 62, 0x0000000000000000, "RO", "RESERVED_3", "Reserved"},
#else
{52, 62, 0x0000000000000000, "RO", "RESERVED_3", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{38, 51, 0x0000000000000000, "RW", "CH_HASH_MASK", "When both PMI channels in a slice are enabled this field specifies the Channel Hash Mask to be applied on Addr[19:6] postremap DRAM address of the request to compute which PMI channel a request must be routed to.  Relevant only when HVM mode is disabled and only for requests that do not fall under the MOT region.  Bunit will override the programmed value to include the Channel Selector bit.  Additionally, Bunit will remove the Slice Selector bit.  See INTERLEAVE_MODE field.  Note that HVM mode and MOT regions have special hash requirements and hence they do not use the CH_HASH_MASK."},
#else
{38, 51, 0x0000000000000000, "RW", "CH_HASH_MASK", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{33, 37, 0x0000000000000000, "RO", "RESERVED_2", "Reserved"},
#else
{33, 37, 0x0000000000000000, "RO", "RESERVED_2", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{32, 32, 0x0000000000000000, "RW", "CH_1_DISABLED", "Bunit is divided into two slices, and each slice has two PMI channels to the internal memory subsystem, for a total of four channels. With this bit asserted, channel 1 in both slices is disabled, and thus no memory addresses are mapped to the slice's ch 1. All requests are sent to the slice's channel 0. "},
#else
{32, 32, 0x0000000000000000, "RW", "CH_1_DISABLED", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{31, 31, 0x0000000000000000, "RW", "SPARE", "Spare bit: TBD."},
#else
{31, 31, 0x0000000000000000, "RW", "SPARE", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{20, 30, 0x0000000000000000, "RO", "RESERVED_1", "Reserved"},
#else
{20, 30, 0x0000000000000000, "RO", "RESERVED_1", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{6, 19, 0x0000000000000000, "RW", "SLICE_HASH_MASK", "When both slices are enabled this field specifies the Slice Hash Mask to be applied on Addr[19:6] physical address of the request to compute which slice a request must be routed to.  Relevant only when HVM mode is disabled and only for physical addresses that do not fall under the Asymmetric Memory Region and the MOT region.  Bunit will override the programmed value to include the Slice Selector bit.  Additionally, Bunit will remove the Channel Selector bit. See INTERLEAVE_MODE field.  Note that HVM mode non-address IDI requests asymmetric memory region and MOT regions have special hash requirements and hence they do not use the SLICE_HASH_MASK."},
#else
{6, 19, 0x0000000000000000, "RW", "SLICE_HASH_MASK", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{4, 5, 0x0000000000000000, "RO", "RESERVED_0", "Reserved"},
#else
{4, 5, 0x0000000000000000, "RO", "RESERVED_0", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{2, 3, 0x0000000000000000, "RW", "INTERLEAVE_MODE", "Default interleave mode that specifies how the Slice Selector and Channel Selector bits are to be determined.  Relevant only when HVM mode is disabled and only for system memory addresses that do not fall under the MOT region or the Asymmetric memory region in the System Address Map.  Legal encodings are 0x0 0x1 and 0x2.  An encoding of 0x3 is treated as if it was 0x2.   When both slices and all four PMI channels are enabled   0x0: Default Slice Selector is Addr[10] and Default Channel Selector is Addr[11]  0x1: Default Slice Selector is Addr[11] and Default Channel Selector is Addr[12]  0x2: Default Slice Selector is Addr[12] and Default Channel Selector is Addr[13]  When both slices are enabled but only one channel in each slice enabled:   0x0: Default Slice Selector is Addr[10]  0x1: Default Slice Selector is Addr[11]  0x2: Default Slice Selector is Addr[12]  When only SLICE0 is enabled and both channels on that slice are enabled:   0x0: Default Channel Selector is Addr[10]  0x1: Default Channel Selector is Addr[11]  0x2: Default Channel Selector is Addr[12]  When SLICE0 and only one channel in that slice is enabled this field is not relevant.  Bunit overrides the setting of the SLICE_HASH_MASK to always include the Slice Selector bit.  Similarly Bunit overrides the setting of the CH_HASH_MASK to always include the Channel Selector bit."},
#else
{2, 3, 0x0000000000000000, "RW", "INTERLEAVE_MODE", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{1, 1, 0x0000000000000000, "RW", "HVM_MODE", "0: HVM mode is disabled.  1: HVM mode is enabled.   When HVM mode is enabled Slice Hash and Channel Hash is done as follows:  Both slices and all four PMI channels enabled:  Slice Hash is Request Physical Addr[29] Channel Hash is PostRemap Addr[30]  Both slices enabled but only one PMI channel in each slice enabled:  Slice Hash is Request Physical Addr[29]  Only one SLICE0 enabled but both PMI channels in SLICE0 enabled:  Channel Hash is PostRemap Addr[29]  When HVM_MODE is enabled TOLUD must be set at 2GB."},
#else
{1, 1, 0x0000000000000000, "RW", "HVM_MODE", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 0, 0x0000000000000000, "RW", "SLICE_1_DISABLED", "Slice 1 is disabled no memory address mapped to Slice 1.  All request sent to Slice 0"},
#else
{0, 0, 0x0000000000000000, "RW", "SLICE_1_DISABLED", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo846[] = {{"B_CR_SLICE_CHANNEL_HASH", "", 0x00004C58, 12, 0xFFFFFFFFFFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields847[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{24, 31, 0x0000000000000000, "RW", "BEST_EFFORT_MAX_LATENCY", "Best Effort Max Latency: This field specifies the max latency for scheduling Best Effort Traffic. The value is added to the global timer value when a read request is granted at Badmit. After the delay specified the page scheduling is ignored for the requests and the request will be scheduled in order. Agent weights still affect the final scheduling latency after the specified delay time has expired.  NOTE:  No longer relevant since page aware scheduling has been removed."},
#else
{24, 31, 0x0000000000000000, "RW", "BEST_EFFORT_MAX_LATENCY", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 23, 0x0000000000000000, "RO", "RESERVED_1", "Reserved"},
#else
{0, 23, 0x0000000000000000, "RO", "RESERVED_1", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo847[] = {{"B_CR_BSCHCTRL0", "", 0x00004C60, 2, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields848[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{31, 31, 0x0000000000000000, "RW/V", "ENABLE_INTR", "Enable Interrupt on Protected Memory Region Violation: When set the BUnit will send an interrupt request on IOSF SB to the PUnit. Bunit will send IOSF-SB message only on the first violation"},
#else
{31, 31, 0x0000000000000000, "RW/V", "ENABLE_INTR", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{30, 30, 0x0000000000000000, "RW/V", "ENABLE_LOG", "Enable Logging on Protected Memory Region Violation: When set  the BUnit will latch violation information into this register.  This bit is cleared upon first violation and must be reset by software in order to log again.  Memory protection is maintained even while the interrupt/capture mechanism is disabled."},
#else
{30, 30, 0x0000000000000000, "RW/V", "ENABLE_LOG", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{28, 29, 0x0000000000000000, "RO", "RESERVED_1", "Reserved"},
#else
{28, 29, 0x0000000000000000, "RO", "RESERVED_1", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{27, 27, 0x0000000000000000, "RW/V", "PII_ABORT", "PII request address had Abort bit set and hence was aborted."},
#else
{27, 27, 0x0000000000000000, "RW/V", "PII_ABORT", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{26, 26, 0x0000000000000000, "RW/V", "UNS_PFI_LEN", "Unsupported PII A2B request length.  This field is deprecated which implies RTL functionality for correct setting of this status field may not be validated.  Future derivatives will remove this status field altogether.  Aunit is an internal IP and as such it must be validated to emit correct request lengths.  Unsupported lengths should be coded as assertions."},
#else
{26, 26, 0x0000000000000000, "RW/V", "UNS_PFI_LEN", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{25, 25, 0x0000000000000000, "RW/V", "UNS_IDI_LEN", "Unsupported IDI length.  This field is deprecated which implies RTL functionality for correct setting of this status field may not be validated.  Future derivatives will remove this status field altogether.  RTL must code assertions to check for correct IDI lengths."},
#else
{25, 25, 0x0000000000000000, "RW/V", "UNS_IDI_LEN", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{24, 24, 0x0000000000000000, "RW/V", "ECAM_OPC_VIO", "ECAM opcode is not PRD or WIL."},
#else
{24, 24, 0x0000000000000000, "RW/V", "ECAM_OPC_VIO", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{23, 23, 0x0000000000000000, "RW/V", "WB_NON_DRAM_VIO", "IDI WB is not to DRAM space.   This field is deprecated which implies RTL functionality for correct setting of this status field may not be validated.  Future derivatives will remove this status field altogether.  WbMto targeting WB space is logged as a machine check error."},
#else
{23, 23, 0x0000000000000000, "RW/V", "WB_NON_DRAM_VIO", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{22, 22, 0x0000000000000000, "RO", "RESERVED_0", "Reserved"},
#else
{22, 22, 0x0000000000000000, "RO", "RESERVED_0", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{16, 21, 0x0000000000000000, "RW/V", "PMR_VIO", "Protected Memory Range Violation :  This 6bit value indicates which region was last violated when the interrupt is enabled.  Encoding is as follows:   0x0: Reserved  0x1: Graphics Stolen Memory violation  0x2: SMM region violation  0x3: PRMRR region violation  0x4: Reserved  0x5: VTd PMR Low region violation  0x6: VTd PMR High region violation  0x7: MOT region violation  0x10-0x23:  Generic IMR region violation.  0x10 is for IMR0 violation and 0x23 is for IMR19 violation."},
#else
{16, 21, 0x0000000000000000, "RW/V", "PMR_VIO", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{15, 15, 0x0000000000000000, "RW/V", "MEM_AXS_2APIC", "Memory Access to APIC region from a nonIDI agent"},
#else
{15, 15, 0x0000000000000000, "RW/V", "MEM_AXS_2APIC", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{14, 14, 0x0000000000000000, "RW/V", "PII_2_MMIO", "MMIO Access from a nonIDI agent.   This field is deprecated which implies RTL functionality for correct setting of this status field may not be validated.  Future derivatives will remove this status field altogether.  This is logged as machine check error."},
#else
{14, 14, 0x0000000000000000, "RW/V", "PII_2_MMIO", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{13, 13, 0x0000000000000000, "RW/V", "UNS_PFI_OPC", "Unsupported PII A2B Request Opcode.   This field is deprecated which implies RTL functionality for correct setting of this status field may not be validated.  Future derivatives will remove this status field altogether.  Aunit is an internal IP and as such it must be validated to emit correct request opcodes.  Unsupported opcodes should be coded as assertions"},
#else
{13, 13, 0x0000000000000000, "RW/V", "UNS_PFI_OPC", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{12, 12, 0x0000000000000000, "RW/V", "UNS_IDI_OPC", "Unsupported IDI Request Opcode.   This field is deprecated which implies RTL functionality for correct setting of this status field may not be validated.  Future derivatives will remove this status field altogether.  Unsupported IDI length is logged a machine check error."},
#else
{12, 12, 0x0000000000000000, "RW/V", "UNS_IDI_OPC", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{8, 11, 0x0000000000000000, "RW/V", "VIOLATING_AGENT_ID", "Protected Asset Access Violation Agent ID:  This 4bit value indicates which agent caused the last access violation if the interrupt is enabled. The Agent ID values are assigned starting with the Goldmont IDI Attach Points GT IDI Attach and followed by Aunit.  For 2GLM configuration AgentID 0 is GLM0 AgentID 1 is GLM1 AgentID 2 is GT and AgentID 3 is Aunit."},
#else
{8, 11, 0x0000000000000000, "RW/V", "VIOLATING_AGENT_ID", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 7, 0x0000000000000000, "RW/V", "VIOLATING_AGENT_CHIID", "Protect Asset Access Violation Channel ID:  This value indicates the Channel ID VC of the request that caused the last access violation if the interrupt is enabled. If access violation was from an IDI attach point this field latches the LPID."},
#else
{0, 7, 0x0000000000000000, "RW/V", "VIOLATING_AGENT_CHIID", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo848[] = {{"B_CR_BPMRVCTL", "", 0x00004C68, 16, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields849[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{18, 31, 0x0000000000000000, "RO", "RESERVED_0", "Reserved"},
#else
{18, 31, 0x0000000000000000, "RO", "RESERVED_0", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{17, 17, 0x0000000000000000, "RW", "SAI_VIO_LOG_ENABLE", "Toggles logging of SAI violations in the status registers "},
#else
{17, 17, 0x0000000000000000, "RW", "SAI_VIO_LOG_ENABLE", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{16, 16, 0x0000000000000000, "RW", "SAI_VIO_MSG_ENABLE", "Toggles sending of SAI violation messages on sideband"},
#else
{16, 16, 0x0000000000000000, "RW", "SAI_VIO_MSG_ENABLE", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{8, 15, 0x0000000000000000, "RW/V", "VIO_SAI", "SAI bits that triggered the violation"},
#else
{8, 15, 0x0000000000000000, "RW/V", "VIO_SAI", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{2, 7, 0x0000000000000000, "RO", "RESERVED_1", "Reserved"},
#else
{2, 7, 0x0000000000000000, "RO", "RESERVED_1", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{1, 1, 0x0000000000000000, "RW/V", "VIO_MORE_THAN_1", "More than one SAI violation detected"},
#else
{1, 1, 0x0000000000000000, "RW/V", "VIO_MORE_THAN_1", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 0, 0x0000000000000000, "RW/V", "VIO_MORE_THAN_0", "First SAI violation detected"},
#else
{0, 0, 0x0000000000000000, "RW/V", "VIO_MORE_THAN_0", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo849[] = {{"B_CR_B_SECURITY_STAT0", "", 0x00004C6C, 7, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields850[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{16, 31, 0x0000000000000000, "RW/V", "VIO_ADDR", "Address that triggered the violation"},
#else
{16, 31, 0x0000000000000000, "RW/V", "VIO_ADDR", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{8, 15, 0x0000000000000000, "RW/V", "VIO_SRC_PORT", "Port that sent the violation"},
#else
{8, 15, 0x0000000000000000, "RW/V", "VIO_SRC_PORT", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 7, 0x0000000000000000, "RW/V", "VIO_OPC", "Opcode that triggered the violation"},
#else
{0, 7, 0x0000000000000000, "RW/V", "VIO_OPC", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo850[] = {{"B_CR_B_SECURITY_STAT1", "", 0x00004C70, 3, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields851[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{31, 31, 0x0000000000000000, "RW", "SEND_ALL_ACCESS_MEM", "Send All Accesses to Memory:  When set  all accesses will be sent to memory  regardless of address."},
#else
{31, 31, 0x0000000000000000, "RW", "SEND_ALL_ACCESS_MEM", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{30, 30, 0x0000000000000000, "RW", "XSBFT_MODE", "XSBFT Mode: Enable XSBFT mode. When set  the Bunit does not wait for a read completion from Dunit to determine read data availability."},
#else
{30, 30, 0x0000000000000000, "RW", "XSBFT_MODE", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{29, 29, 0x0000000000000000, "RW", "DISABLE_BADMIT_URGENT_ISOC", "This bit is not used by the HW; it counts as a spare bit. There is an A-unit CR bit that approximates this behavior. Was: Disable Badmit Urgent ISOC Requests: Disables the ISOC high priority path in Badmit. When set all ISOC agent requests are treated as Normal priority."},
#else
{29, 29, 0x0000000000000000, "RW", "DISABLE_BADMIT_URGENT_ISOC", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{28, 28, 0x0000000000000000, "RW", "INVERT_PARITY_ERR", "Intended for Post Silicon testing of parity logic."},
#else
{28, 28, 0x0000000000000000, "RW", "INVERT_PARITY_ERR", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{25, 27, 0x0000000000000000, "RW", "LOCK_KEEPOUT_TIMER", "Counter value that specifies how long the Bunit will keep out a second lock transaction after the first one has completed.Based on the usync clk frequency (16.67 MHz) 0:0.96us(16 usyncs) 1:1.92us(32 usyncs) 2:2.88us(48 usyncs) 3:3.84us(64 usyncs) 7:7.6us(128 usyncs)"},
#else
{25, 27, 0x0000000000000000, "RW", "LOCK_KEEPOUT_TIMER", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{24, 24, 0x0000000000000001, "RW", "LOCK_KEEPOUT_ENABLE", "0: Disables lock keepout timer. 1: Enables lock keepout timer which would prevent Bunit from processing successive lock transactions back to back."},
#else
{24, 24, 0x0000000000000001, "RW", "LOCK_KEEPOUT_ENABLE", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{21, 23, 0x0000000000000000, "RO", "RESERVED_0", "Reserved"},
#else
{21, 23, 0x0000000000000000, "RO", "RESERVED_0", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{16, 20, 0x0000000000000001, "RW", "TOTAL_DOWNSTREAM_NP_LIMIT", "This will limit the number of downstream non-posted transaction that can be admitted into each Slice.  Be careful with programming the value of this register, set to high and you can cause deadlocks."},
#else
{16, 20, 0x0000000000000001, "RW", "TOTAL_DOWNSTREAM_NP_LIMIT", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{8, 15, 0x000000000000000C, "RW", "POSTED_QUEUE_THRESHOLD", "Chicken bits to change posted queue threshold.  Programming to a value greater than 12 in BXT can cause deadlocks."},
#else
{8, 15, 0x000000000000000C, "RW", "POSTED_QUEUE_THRESHOLD", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 7, 0x0000000000000000, "RW", "CASUAL_WATER_MARK", "Casual Water Mark CasualWaterMark :  The casual watermark is used to trigger the BUnits casual flush mechanism.  When the number of dirty entries is below the casual watermark  no entries will be flushed even if the PMI interfaces are idle."},
#else
{0, 7, 0x0000000000000000, "RW", "CASUAL_WATER_MARK", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo851[] = {{"B_CR_BDEBUG0", "", 0x00004C78, 10, 0x00000000FFFFFFFF, 0x0000000001010C00}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields852[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{16, 31, 0x00000000000000FF, "RW", "AGENT_WEIGHT_ENABLE", "Agent Weight Enable: When set these bits enable the use of Agent weights by the Bunit scheduler regardless of the COS Category configuration set for Agents 015. Normally the Agent weights are only used when the COS Category for an Agent is configured for Best Effort. When the Agent Weight Enable bit is set for an agent the COS category is still used as priority for the agent but the agent is also limited by the weights specified for the agent in the BARBCTRL and BSCHWTx registers."},
#else
{16, 31, 0x00000000000000FF, "RW", "AGENT_WEIGHT_ENABLE", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{12, 15, 0x0000000000000000, "RO", "RESERVED_0", "Reserved"},
#else
{12, 15, 0x0000000000000000, "RO", "RESERVED_0", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{11, 11, 0x0000000000000001, "RW", "PII2_CREDIT_ACC", "PII2 ConflictQ s will accumulate credits in a counter and will not send the credits to the AUnit immediately if the corresponding ConflictQ is not empty. Only when the ConflictQ is empty will credits be sent to the AUnit. This is to avoid new requests from continuously recycling through the ConflictQ."},
#else
{11, 11, 0x0000000000000001, "RW", "PII2_CREDIT_ACC", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{10, 10, 0x0000000000000000, "RW", "ENABLE_DB_BYPASS", "This bit enables the bypass path of the DB. When set data received from the dunit may be sent directly to the requesting agent using the Live Read Data Return path. When this bit is clear the Live Read Data Return path is delayed 1 clock cycle.  FIXME:  Can we find another home for this register"},
#else
{10, 10, 0x0000000000000000, "RW", "ENABLE_DB_BYPASS", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{9, 9, 0x0000000000000000, "RW", "READ_DATA_BYPASS_ENABLE", "These bits enable the bypass of the Read Data pipestage for those agents for which the pipestage has been provisioned. When set  the Read Data will be returned 1 clock cycle earlier. There is 1 bit per Bunit requester  with lower bits corresponding to IDI agents followed by Aunit. The bit may only be set for those agents that have the pipestage provisioned.  FIXME:  Can we find another home for this register"},
#else
{9, 9, 0x0000000000000000, "RW", "READ_DATA_BYPASS_ENABLE", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{3, 8, 0x0000000000000027, "RW", "TOTAL_IDI_LIMIT", "Maximum number of entries in each slice that IDI requests are allowed to allocate in the Bunit scoreboard/BRAM and the Tunit tracker.  Same CR is used as the limit value for both Bunit scoreboard/BRAM and the Tunit tracker.  Once either limit - scoreboard/BRAM or tracker is reached, no IDI request will be accepted by the Badmit arbiter.  Limit is global across all IDI agents and not enforced per IDI agent.  In other words any IDI agent individually and together with other IDI agents are allowed to use only up to TOTAL_IDI_LIMIT entries in each slice.  NOTE:  In BXT, programming a value lower than 34 can lead to deadlocks."},
#else
{3, 8, 0x0000000000000027, "RW", "TOTAL_IDI_LIMIT", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{2, 2, 0x0000000000000000, "RW", "ENABLE_SINGLE_ENTRY_IDI_CQ", "When set, B-unit will allow at most one request per IDI agent to be queued up in each of the IDI Conflict Queues.  Enabling this mode will severly throttle performance even in the absence of address conflicts."},
#else
{2, 2, 0x0000000000000000, "RW", "ENABLE_SINGLE_ENTRY_IDI_CQ", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{1, 1, 0x0000000000000000, "RW", "ENABLE_SINGLE_PII_REQUEST_OUTSTANDING", "When set, B-unit will not grant a second PII transaction until the first transaction has retired from the B-unit.  If this CR is set to 1 when PII transactions are still pending, Bunit may not limit the outstanding PII transactions to 1."},
#else
{1, 1, 0x0000000000000000, "RW", "ENABLE_SINGLE_PII_REQUEST_OUTSTANDING", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 0, 0x0000000000000000, "RW", "ENABLE_DRAM_READ", "Enable DRAM Read for Partial Write:  The BUnit has byteenable capability so it doesnt require a DRAM read when there is a partial write.  This bit forces it to perform the read anyway."},
#else
{0, 0, 0x0000000000000000, "RW", "ENABLE_DRAM_READ", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo852[] = {{"B_CR_BDEBUG1", "", 0x00004C7C, 9, 0x00000000FFFFFFFF, 0x0000000000FF0938}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields853[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{31, 31, 0x0000000000000000, "RW", "THROTTLE_ENABLE", "Memory Throttling Enable: 0: Bunit scheduler will not throttle any transaction.  1: Bunit scheduler will implement throttling and limit the number of transactions sent during a throttling window"},
#else
{31, 31, 0x0000000000000000, "RW", "THROTTLE_ENABLE", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{24, 30, 0x0000000000000000, "RO", "RESERVED_0", "Reserved"},
#else
{24, 30, 0x0000000000000000, "RO", "RESERVED_0", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{16, 23, 0x0000000000000000, "RW", "THROTTLE_INTERVAL", "Specifies the duration of the throttling interval as a multiple of 60ns N60ns.  Example:  When programmed to 0x4 the throttling interval is 240ns."},
#else
{16, 23, 0x0000000000000000, "RW", "THROTTLE_INTERVAL", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 15, 0x0000000000000000, "RW", "THROTTLE_COUNT", "Total number of read and write requests allowed to be sent during any throttle interval across all PMI channels in each slice.  Slice0 is allowed to send up to THROTTLE_COUNT requests.  Similarly Slice1 is allowed to send up to THROTTLE_COUNT requests."},
#else
{0, 15, 0x0000000000000000, "RW", "THROTTLE_COUNT", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo853[] = {{"B_CR_BTHCTRL", "", 0x00004C80, 4, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields854[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{0, 31, 0x0000000000000000, "RO/V", "THROTTLE_CYCLE_COUNT", "Counts the number of cycles the Bunit has an available request to send but the request is throttled.  Counter is not saturating and will roll over to zero.  It is upto the consumer of the counter to handle roll over cases."},
#else
{0, 31, 0x0000000000000000, "RO/V", "THROTTLE_CYCLE_COUNT", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo854[] = {{"B_CR_BTH_CYCLE_COUNT_SLICE0", "", 0x00004C84, 1, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields855[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{0, 31, 0x0000000000000000, "RO/V", "THROTTLE_CYCLE_COUNT", "Counts the number of cycles the Bunit has an available request to send but the request is throttled.  Counter is not saturating and will roll over to zero.  It is upto the consumer of the counter to handle roll over cases."},
#else
{0, 31, 0x0000000000000000, "RO/V", "THROTTLE_CYCLE_COUNT", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo855[] = {{"B_CR_BTH_CYCLE_COUNT_SLICE1", "", 0x00004C88, 1, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields856[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{0, 63, 0x0000040061010202, "RW", "MEM_RANGE_CTRL_POL", "Bit vector used to determine which agents are allowed write access to the IA_UNTRUSTED_RAC IA_UNTRUSTED_WAC and IA_UNTRUSTED_CP registers based on the value from the agents 6bit SAI field."},
#else
{0, 63, 0x0000040061010202, "RW", "MEM_RANGE_CTRL_POL", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo856[] = {{"B_CR_IA_UNTRUSTED_CP", "", 0x00004C90, 1, 0xFFFFFFFFFFFFFFFF, 0x0000040061010202}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields857[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{0, 63, 0x00000C0063010217, "RW", "MEM_RANGE_POL", "Bit vector used to determine which agents are allowed read access based on the agents 6bit encoded SAI value."},
#else
{0, 63, 0x00000C0063010217, "RW", "MEM_RANGE_POL", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo857[] = {{"B_CR_IA_UNTRUSTED_RAC", "", 0x00004C98, 1, 0xFFFFFFFFFFFFFFFF, 0x00000C0063010217}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields858[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{0, 63, 0x00000C0061000217, "RW", "MEM_RANGE_POL", "Bit vector used to determine which agents are allowed write access based on the agents 6bit encoded SAI value."},
#else
{0, 63, 0x00000C0061000217, "RW", "MEM_RANGE_POL", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo858[] = {{"B_CR_IA_UNTRUSTED_WAC", "", 0x00004CA0, 1, 0xFFFFFFFFFFFFFFFF, 0x00000C0061000217}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields859[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{31, 31, 0x0000000000000000, "WO", "C2URPL_U2CRSP_CLR", "Write 1 to reset MISRRPLSIG register to 0xFFFF_FFFF"},
#else
{31, 31, 0x0000000000000000, "WO", "C2URPL_U2CRSP_CLR", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{30, 30, 0x0000000000000000, "WO", "C2U_DATA_CLR", "Write 1 to reset MISRC2UDATSIG register to 0xFFFF_FFFF"},
#else
{30, 30, 0x0000000000000000, "WO", "C2U_DATA_CLR", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{29, 29, 0x0000000000000000, "WO", "U2C_DATA_CLR", "Write 1 to reset MISRU2CDATSIG register to 0xFFFF_FFFF"},
#else
{29, 29, 0x0000000000000000, "WO", "U2C_DATA_CLR", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{28, 28, 0x0000000000000000, "WO", "C2U_REQ_CLR", "Write 1 to reset MISRC2UREQSIG register to 0xFFFF_FFFF"},
#else
{28, 28, 0x0000000000000000, "WO", "C2U_REQ_CLR", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{27, 27, 0x0000000000000000, "WO", "U2C_REQ_CLR", "Write 1 to reset MISRU2CREQSIG register to 0xFFFF_FFFF"},
#else
{27, 27, 0x0000000000000000, "WO", "U2C_REQ_CLR", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{26, 26, 0x0000000000000000, "RO", "RESERVED_0", "Reserved"},
#else
{26, 26, 0x0000000000000000, "RO", "RESERVED_0", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{25, 25, 0x0000000000000000, "RW", "MISR_FAB1_EN", "When set, enables FAB1 to IDI MISRs"},
#else
{25, 25, 0x0000000000000000, "RW", "MISR_FAB1_EN", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{24, 24, 0x0000000000000000, "RW", "MISR_EN", "When set, enables normal IDI MISRs"},
#else
{24, 24, 0x0000000000000000, "RW", "MISR_EN", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{20, 23, 0x0000000000000000, "RW", "C2U_RPL_IDI_SEL", "IDI select for C2U reply MISR observation."},
#else
{20, 23, 0x0000000000000000, "RW", "C2U_RPL_IDI_SEL", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{16, 19, 0x0000000000000000, "RW", "U2C_RSP_IDI_SEL", "IDI select for U2C response MISR observation."},
#else
{16, 19, 0x0000000000000000, "RW", "U2C_RSP_IDI_SEL", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{12, 15, 0x0000000000000000, "RW", "C2U_DATA_IDI_SEL", "IDI select for C2U data MISR observation."},
#else
{12, 15, 0x0000000000000000, "RW", "C2U_DATA_IDI_SEL", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{8, 11, 0x0000000000000000, "RW", "U2C_DATA_IDI_SEL", "IDI select for U2C data MISR observation."},
#else
{8, 11, 0x0000000000000000, "RW", "U2C_DATA_IDI_SEL", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{4, 7, 0x0000000000000000, "RW", "C2U_REQ_IDI_SEL", "IDI select for C2U request MISR observation."},
#else
{4, 7, 0x0000000000000000, "RW", "C2U_REQ_IDI_SEL", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 3, 0x0000000000000000, "RW", "U2C_REQ_IDI_SEL", "IDI select for U2C request MISR observation."},
#else
{0, 3, 0x0000000000000000, "RW", "U2C_REQ_IDI_SEL", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo859[] = {{"B_CR_MISRCTL", "", 0x00004CB4, 14, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields860[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{0, 31, 0x00000000FFFFFFFF, "RO/V", "U2C_REQ_SIG", "MISR signature for U2C request."},
#else
{0, 31, 0x00000000FFFFFFFF, "RO/V", "U2C_REQ_SIG", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo860[] = {{"B_CR_MISRS2CREQSIG", "", 0x00004CB8, 1, 0x00000000FFFFFFFF, 0x00000000FFFFFFFF}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields861[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{0, 31, 0x00000000FFFFFFFF, "RO/V", "C2U_REQ_SIG", "MISR signature for C2U request. Read only."},
#else
{0, 31, 0x00000000FFFFFFFF, "RO/V", "C2U_REQ_SIG", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo861[] = {{"B_CR_MISRC2SREQSIG", "", 0x00004CBC, 1, 0x00000000FFFFFFFF, 0x00000000FFFFFFFF}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields862[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{0, 31, 0x00000000FFFFFFFF, "RO/V", "U2C_DATA_SIG", "MISR signature for U2C data."},
#else
{0, 31, 0x00000000FFFFFFFF, "RO/V", "U2C_DATA_SIG", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo862[] = {{"B_CR_MISRS2CDATASIG", "", 0x00004CC0, 1, 0x00000000FFFFFFFF, 0x00000000FFFFFFFF}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields863[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{0, 31, 0x00000000FFFFFFFF, "RO/V", "C2U_DATA_SIG", "MISR signature for C2U data."},
#else
{0, 31, 0x00000000FFFFFFFF, "RO/V", "C2U_DATA_SIG", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo863[] = {{"B_CR_MISRC2SDATASIG", "", 0x00004CC4, 1, 0x00000000FFFFFFFF, 0x00000000FFFFFFFF}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields864[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{0, 31, 0x00000000FFFFFFFF, "RO/V", "U2CRSP_C2URPL_SIG", "MISR signature for U2C response and C2U reply."},
#else
{0, 31, 0x00000000FFFFFFFF, "RO/V", "U2CRSP_C2URPL_SIG", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo864[] = {{"B_CR_MISRRPLSIG", "", 0x00004CC8, 1, 0x00000000FFFFFFFF, 0x00000000FFFFFFFF}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields865[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{16, 31, 0x0000000000000000, "RW", "DISABLE_REQUEST_COMBINING", "For A2B requests this field specifies which VCs are eligible for request combining.  DISABLE_REQUEST_COMBINING[16] specifies eligibility for channel 0 VC0a DISABLE_REQUEST_COMBINING[17] specifies eligibility for channel 1 VC0b and so on.  When the bit is set for a VC the VC is disabled for reqeust combining.  Any VC is eligible for request combining only if either of the following holds: a VC can accept only inorder read completions and T_WRITE_ORDERING specifies that the VC must receive inorder writepulls or b a VC provides the guarantee that it will never send snooped requests."},
#else
{16, 31, 0x0000000000000000, "RW", "DISABLE_REQUEST_COMBINING", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{15, 15, 0x0000000000000000, "RW", "HH_DISABLE_SYNC", "Disable Hammock Harbor Sync protocol and enable clock counting NOTE: This does not prevent badmit blocking for not having a valid sync'd time"},
#else
{15, 15, 0x0000000000000000, "RW", "HH_DISABLE_SYNC", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{14, 14, 0x0000000000000000, "RW", "DISABLE_BADMIT_STALL_FOR_MOT_HH_TIME", "When clear and MOT is enabled, Bunit admit arbiter will wait for valid Hammock Harbor Time before granting any transaction.  When clear or when MOT is disabled, Bunit admit arbiter will grant transactions without waiting for Hammock Harbor time to be valid."},
#else
{14, 14, 0x0000000000000000, "RW", "DISABLE_BADMIT_STALL_FOR_MOT_HH_TIME", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{13, 13, 0x0000000000000000, "RW", "DISABLE_OWNED", "Disable Owned: When set the Bunit will not used the Owned status for a tag entry."},
#else
{13, 13, 0x0000000000000000, "RW", "DISABLE_OWNED", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{12, 12, 0x0000000000000000, "RW", "INORDER_READ_ENABLE", "InOrder Read Enable: When set enables the BUnit to schedule read commands in the order they were enqueued into the Bunit."},
#else
{12, 12, 0x0000000000000000, "RW", "INORDER_READ_ENABLE", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{11, 11, 0x0000000000000000, "RW", "INORDER_FLUSH_ENABLE", "InOrder Flush Enable: When set enables the BUnit to flush entries from its write buffer in the order they were enqueued into the Bunit."},
#else
{11, 11, 0x0000000000000000, "RW", "INORDER_FLUSH_ENABLE", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{10, 10, 0x0000000000000000, "RW", "ALL_DOWNSTREAM_CHID", "When ALL_DOWNSTREAM_CHID_OVERRIDE bit is set to 1 Bunit will map all downstream MMIO and IO transactions to only one channel specified by this ALL_DOWNSTREAM_CHID bit ignoring the results of the system address decode logic.   In SoCs where there is only one downstream channel e.g. DNV specifying chid 1  will have undefined behavior.  It is the responsibility of BIOS or other system software to ensure that downstream chid is not overridden to refer to a nonexistent channel.  NOTE:  In BXT usage of this override to send transactions to agents below PSF1 on VC0a will lead to unexpected machine behavior including hangs."},
#else
{10, 10, 0x0000000000000000, "RW", "ALL_DOWNSTREAM_CHID", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{9, 9, 0x0000000000000000, "RW", "ALL_DOWNSTREAM_CHID_OVERRIDE", "When set Bunit will map all downstream transactions to the channel specified by ALL_DOWNSTREAM_CHID ignoring the results of the Bunit system address decode logic."},
#else
{9, 9, 0x0000000000000000, "RW", "ALL_DOWNSTREAM_CHID_OVERRIDE", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{8, 8, 0x0000000000000000, "RW", "ENABLE_IO_SPACE_MATCH", "0: Disable IO space matching.  Nonaddress requests will not cause conflicts with themselves and with other requests.  1:  Enable IO space matching.  Nonaddress requests can cause conflicts with themselves and with other requests."},
#else
{8, 8, 0x0000000000000000, "RW", "ENABLE_IO_SPACE_MATCH", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{7, 7, 0x0000000000000001, "RW", "FORCE_MOT_FLUSH_FOR_IDLE", "When set to 1,  Bunit behavior will be such that MOT will be forced to flush its pending buffers when all other idle conditions are met for atleast one PMI channel.  When clear, Bunit will not pro-actively flush the MOT buffer and will wait on MOT buffer to naturally go empty (for e.g. after a periodic internal MOT flush event) before any PMI channel is brought to an idle state."},
#else
{7, 7, 0x0000000000000001, "RW", "FORCE_MOT_FLUSH_FOR_IDLE", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{6, 6, 0x0000000000000001, "RW", "FORCE_MOT_FLUSH_FOR_READ_SCHED", "When set to 1,  MOT will be forced to flush its pending buffers when the oldest read request in the Bunit scheduler is unable to be scheduled waiting on MOT to release its lock on the targeted BTag entry.  When clear, MOT will not be forced to flush when the scheduling of oldest read request to PMI is stalled due to MOT."},
#else
{6, 6, 0x0000000000000001, "RW", "FORCE_MOT_FLUSH_FOR_READ_SCHED", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{5, 5, 0x0000000000000001, "RW", "FORCE_MOT_FLUSH_FOR_X2B_WRITE", "When set to 1,  MOT will be forced to flush its pending buffers when any IDI or PII write data interface is head-of-line blocked at the X2B arbiter waiting on MOT to release its lock on the targeted BTag entry.  When clear, MOT will not be forced to flush upon write data interface stalls due to MOT."},
#else
{5, 5, 0x0000000000000001, "RW", "FORCE_MOT_FLUSH_FOR_X2B_WRITE", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{4, 4, 0x0000000000000001, "RW", "ENABLE_RW_MATCH_OVER_FULL_LINE", "0:  Read/Write access type checks for request combining are done separately for each of the two 32B chunks in a cache line.  1:  Read/Write access type checks for request combining are done over the full line.  In other words when this bit is set, Bunit will not admit a read request if a write request to any chunk of the same line is still not retired.  Similarly, Bunit will not admit a write request, if a read request to any chunk of the same line is till pending."},
#else
{4, 4, 0x0000000000000001, "RW", "ENABLE_RW_MATCH_OVER_FULL_LINE", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{3, 3, 0x0000000000000000, "RW", "SINGLE_CHUNK_ACCESS", "Single Chunk Access: When set the Bunit will only allow 1 access to each 32B chunk of the Tag entry at a time.  Note when DISABLE_REQUEST_COMBINING is set for a VC the Bunit will only allow one request to the entire Tag entry at a time."},
#else
{3, 3, 0x0000000000000000, "RW", "SINGLE_CHUNK_ACCESS", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{2, 2, 0x0000000000000000, "RW", "BECLK_GATE_EN", "BEClkGateEnable: Enables clock gating for the byte enable storage  when the MasterClkGateEnable bit is set. Should be set in normal operation."},
#else
{2, 2, 0x0000000000000000, "RW", "BECLK_GATE_EN", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{1, 1, 0x0000000000000000, "RW", "MASTERCLK_GATE_EN", "MasterClkGateEnable: Master enable signal for BUnit clock gating"},
#else
{1, 1, 0x0000000000000000, "RW", "MASTERCLK_GATE_EN", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 0, 0x0000000000000000, "RW", "REQUESTCLK_GATE_EN", "RequestClkGateEnable: Enable signal for requestspecific BUnit clock gating.  Meaningful only when MasterClkGateEnable signal is asserted."},
#else
{0, 0, 0x0000000000000000, "RW", "REQUESTCLK_GATE_EN", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo865[] = {{"B_CR_BCTRL", "", 0x00004CD4, 17, 0x00000000FFFFFFFF, 0x00000000000000F0}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields866[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{39, 63, 0x0000000000000000, "RO", "RESERVED_1", "Reserved"},
#else
{39, 63, 0x0000000000000000, "RO", "RESERVED_1", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{12, 38, 0x0000000000000000, "RW", "RANGE_BASE", "This field corresponds to bits 38:12 of the base address memory range which is allocated to PRMRR memory.  PRMRR region size must be a strict poweroftwo at least 4KB and naturally aligned to the size.  These bits are compared with the result of the RANGE_MASK[38:12] applied to bits 38:12 of the incoming address to determine if an access falls within the PRMRR defined region."},
#else
{12, 38, 0x0000000000000000, "RW", "RANGE_BASE", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 11, 0x0000000000000000, "RO", "RESERVED_2", "Reserved"},
#else
{0, 11, 0x0000000000000000, "RO", "RESERVED_2", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo866[] = {{"B_CR_PRMRR_BASE", "", 0x00004CD8, 3, 0xFFFFFFFFFFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields867[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{39, 63, 0x0000000000000000, "RO", "RESERVED_1", "Reserved"},
#else
{39, 63, 0x0000000000000000, "RO", "RESERVED_1", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{12, 38, 0x0000000000000000, "RW", "RANGE_MASK", "This field indicates which address bits must match PRMRR base in order to qualify as an PRMRR access.  These bits are ANDed with bits 38:12 of the incoming address to determine if the combined result matches the RANGE_BASE[38:12] value.  A match indicates the the incoming address falls within the PRMRR region."},
#else
{12, 38, 0x0000000000000000, "RW", "RANGE_MASK", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{11, 11, 0x0000000000000000, "RW", "RANGE_EN", "Indicates whether the PRMRR range is enabled and valid.  1: Enabled and Valid.  Access control is enforced.  0: Not enabled.  Access control is not enforced."},
#else
{11, 11, 0x0000000000000000, "RW", "RANGE_EN", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{10, 10, 0x0000000000000000, "RW", "LOCK", "Reserved. Lock bit is unused by Bunit.  Bunit uses policy registers to lock down register."},
#else
{10, 10, 0x0000000000000000, "RW", "LOCK", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{9, 9, 0x0000000000000001, "RW", "IWB_EN", "1: Enables IWB data from caching agents for requests targeting PRMRR to be returned to requestor.  0: Disables IWB data from caching agents for requests targeting PRMRR to be returned to requestor.  NOTE: PRMRR does not have separate IA_IWB_EN and GT_IWB_EN bits.  Since GT self-protects accesses to PRMRR, IWB_EN can be set to 1."},
#else
{9, 9, 0x0000000000000001, "RW", "IWB_EN", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{8, 8, 0x0000000000000000, "RW", "TR_EN", "1: Allows tracing of transactions to the PRMRR region by tracing agents.  0: Disallows tracing of transactions to the PRMRR region by tracing agents."},
#else
{8, 8, 0x0000000000000000, "RW", "TR_EN", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 7, 0x0000000000000000, "RO", "RESERVED_2", "Reserved"},
#else
{0, 7, 0x0000000000000000, "RO", "RESERVED_2", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo867[] = {{"B_CR_PRMRR_MASK", "", 0x00004CE0, 7, 0xFFFFFFFFFFFFFFFF, 0x0000000000000200}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields868[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{0, 63, 0x0000040061010202, "RW", "PRMRR_CTRL_POL", "Bunit PRMRR Control Policy: Bit vector used to determine which agents are allowed access to the BPRMRRRAC, BPRMRRWAC and BPRMRRCP registers based on the value from the agents 6bit SAI field."},
#else
{0, 63, 0x0000040061010202, "RW", "PRMRR_CTRL_POL", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo868[] = {{"B_CR_BPRMRRCP", "", 0x00004CE8, 1, 0xFFFFFFFFFFFFFFFF, 0x0000040061010202}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields869[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{63, 63, 0x0000000000000000, "RW", "PRMRR_SAI_POL_63", "Bunit PRMRR SAI Read Access Policy: Bit vector used to determine which agents are allowed read access to the PRMRR region based on the agents 6bit encoded SAI value."},
#else
{63, 63, 0x0000000000000000, "RW", "PRMRR_SAI_POL_63", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{62, 62, 0x0000000000000000, "RO", "PRMRR_SAI_POL_62", "Bunit PRMRR SAI Read Access Policy: Bit vector used to determine which agents are allowed read access to the PRMRR region based on the agents 6bit encoded SAI value."},
#else
{62, 62, 0x0000000000000000, "RO", "PRMRR_SAI_POL_62", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{61, 61, 0x0000000000000000, "RO", "PRMRR_SAI_POL_61", "Bunit PRMRR SAI Read Access Policy: Bit vector used to determine which agents are allowed read access to the PRMRR region based on the agents 6bit encoded SAI value."},
#else
{61, 61, 0x0000000000000000, "RO", "PRMRR_SAI_POL_61", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{60, 60, 0x0000000000000000, "RO", "PRMRR_SAI_POL_60", "Bunit PRMRR SAI Read Access Policy: Bit vector used to determine which agents are allowed read access to the PRMRR region based on the agents 6bit encoded SAI value."},
#else
{60, 60, 0x0000000000000000, "RO", "PRMRR_SAI_POL_60", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{59, 59, 0x0000000000000000, "RO", "PRMRR_SAI_POL_59", "Bunit PRMRR SAI Read Access Policy: Bit vector used to determine which agents are allowed read access to the PRMRR region based on the agents 6bit encoded SAI value."},
#else
{59, 59, 0x0000000000000000, "RO", "PRMRR_SAI_POL_59", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{58, 58, 0x0000000000000000, "RO", "PRMRR_SAI_POL_58", "Bunit PRMRR SAI Read Access Policy: Bit vector used to determine which agents are allowed read access to the PRMRR region based on the agents 6bit encoded SAI value."},
#else
{58, 58, 0x0000000000000000, "RO", "PRMRR_SAI_POL_58", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{57, 57, 0x0000000000000000, "RO", "PRMRR_SAI_POL_57", "Bunit PRMRR SAI Read Access Policy: Bit vector used to determine which agents are allowed read access to the PRMRR region based on the agents 6bit encoded SAI value."},
#else
{57, 57, 0x0000000000000000, "RO", "PRMRR_SAI_POL_57", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{56, 56, 0x0000000000000000, "RW", "PRMRR_SAI_POL_56", "Bunit PRMRR SAI Read Access Policy: Bit vector used to determine which agents are allowed read access to the PRMRR region based on the agents 6bit encoded SAI value."},
#else
{56, 56, 0x0000000000000000, "RW", "PRMRR_SAI_POL_56", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{55, 55, 0x0000000000000000, "RW", "PRMRR_SAI_POL_55", "Bunit PRMRR SAI Read Access Policy: Bit vector used to determine which agents are allowed read access to the PRMRR region based on the agents 6bit encoded SAI value."},
#else
{55, 55, 0x0000000000000000, "RW", "PRMRR_SAI_POL_55", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{54, 54, 0x0000000000000000, "RW", "PRMRR_SAI_POL_54", "Bunit PRMRR SAI Read Access Policy: Bit vector used to determine which agents are allowed read access to the PRMRR region based on the agents 6bit encoded SAI value."},
#else
{54, 54, 0x0000000000000000, "RW", "PRMRR_SAI_POL_54", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{53, 53, 0x0000000000000000, "RO", "PRMRR_SAI_POL_53", "Bunit PRMRR SAI Read Access Policy: Bit vector used to determine which agents are allowed read access to the PRMRR region based on the agents 6bit encoded SAI value."},
#else
{53, 53, 0x0000000000000000, "RO", "PRMRR_SAI_POL_53", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{52, 52, 0x0000000000000000, "RO", "PRMRR_SAI_POL_52", "Bunit PRMRR SAI Read Access Policy: Bit vector used to determine which agents are allowed read access to the PRMRR region based on the agents 6bit encoded SAI value."},
#else
{52, 52, 0x0000000000000000, "RO", "PRMRR_SAI_POL_52", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{51, 51, 0x0000000000000000, "RO", "PRMRR_SAI_POL_51", "Bunit PRMRR SAI Read Access Policy: Bit vector used to determine which agents are allowed read access to the PRMRR region based on the agents 6bit encoded SAI value."},
#else
{51, 51, 0x0000000000000000, "RO", "PRMRR_SAI_POL_51", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{50, 50, 0x0000000000000000, "RW", "PRMRR_SAI_POL_50", "Bunit PRMRR SAI Read Access Policy: Bit vector used to determine which agents are allowed read access to the PRMRR region based on the agents 6bit encoded SAI value."},
#else
{50, 50, 0x0000000000000000, "RW", "PRMRR_SAI_POL_50", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{49, 49, 0x0000000000000000, "RW", "PRMRR_SAI_POL_49", "Bunit PRMRR SAI Read Access Policy: Bit vector used to determine which agents are allowed read access to the PRMRR region based on the agents 6bit encoded SAI value."},
#else
{49, 49, 0x0000000000000000, "RW", "PRMRR_SAI_POL_49", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{48, 48, 0x0000000000000000, "RW", "PRMRR_SAI_POL_48", "Bunit PRMRR SAI Read Access Policy: Bit vector used to determine which agents are allowed read access to the PRMRR region based on the agents 6bit encoded SAI value."},
#else
{48, 48, 0x0000000000000000, "RW", "PRMRR_SAI_POL_48", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{47, 47, 0x0000000000000000, "RO", "PRMRR_SAI_POL_47", "Bunit PRMRR SAI Read Access Policy: Bit vector used to determine which agents are allowed read access to the PRMRR region based on the agents 6bit encoded SAI value."},
#else
{47, 47, 0x0000000000000000, "RO", "PRMRR_SAI_POL_47", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{46, 46, 0x0000000000000000, "RO", "PRMRR_SAI_POL_46", "Bunit PRMRR SAI Read Access Policy: Bit vector used to determine which agents are allowed read access to the PRMRR region based on the agents 6bit encoded SAI value."},
#else
{46, 46, 0x0000000000000000, "RO", "PRMRR_SAI_POL_46", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{45, 45, 0x0000000000000000, "RO", "PRMRR_SAI_POL_45", "Bunit PRMRR SAI Read Access Policy: Bit vector used to determine which agents are allowed read access to the PRMRR region based on the agents 6bit encoded SAI value."},
#else
{45, 45, 0x0000000000000000, "RO", "PRMRR_SAI_POL_45", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{44, 44, 0x0000000000000000, "RW", "PRMRR_SAI_POL_44", "Bunit PRMRR SAI Read Access Policy: Bit vector used to determine which agents are allowed read access to the PRMRR region based on the agents 6bit encoded SAI value."},
#else
{44, 44, 0x0000000000000000, "RW", "PRMRR_SAI_POL_44", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{43, 43, 0x0000000000000000, "RW", "PRMRR_SAI_POL_43", "Bunit PRMRR SAI Read Access Policy: Bit vector used to determine which agents are allowed read access to the PRMRR region based on the agents 6bit encoded SAI value."},
#else
{43, 43, 0x0000000000000000, "RW", "PRMRR_SAI_POL_43", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{42, 42, 0x0000000000000000, "RW", "PRMRR_SAI_POL_42", "Bunit PRMRR SAI Read Access Policy: Bit vector used to determine which agents are allowed read access to the PRMRR region based on the agents 6bit encoded SAI value."},
#else
{42, 42, 0x0000000000000000, "RW", "PRMRR_SAI_POL_42", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{41, 41, 0x0000000000000000, "RW", "PRMRR_SAI_POL_41", "Bunit PRMRR SAI Read Access Policy: Bit vector used to determine which agents are allowed read access to the PRMRR region based on the agents 6bit encoded SAI value."},
#else
{41, 41, 0x0000000000000000, "RW", "PRMRR_SAI_POL_41", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{40, 40, 0x0000000000000000, "RW", "PRMRR_SAI_POL_40", "Bunit PRMRR SAI Read Access Policy: Bit vector used to determine which agents are allowed read access to the PRMRR region based on the agents 6bit encoded SAI value."},
#else
{40, 40, 0x0000000000000000, "RW", "PRMRR_SAI_POL_40", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{39, 39, 0x0000000000000000, "RO", "PRMRR_SAI_POL_39", "Bunit PRMRR SAI Read Access Policy: Bit vector used to determine which agents are allowed read access to the PRMRR region based on the agents 6bit encoded SAI value."},
#else
{39, 39, 0x0000000000000000, "RO", "PRMRR_SAI_POL_39", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{38, 38, 0x0000000000000000, "RW", "PRMRR_SAI_POL_38", "Bunit PRMRR SAI Read Access Policy: Bit vector used to determine which agents are allowed read access to the PRMRR region based on the agents 6bit encoded SAI value."},
#else
{38, 38, 0x0000000000000000, "RW", "PRMRR_SAI_POL_38", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{37, 37, 0x0000000000000000, "RO", "PRMRR_SAI_POL_37", "Bunit PRMRR SAI Read Access Policy: Bit vector used to determine which agents are allowed read access to the PRMRR region based on the agents 6bit encoded SAI value."},
#else
{37, 37, 0x0000000000000000, "RO", "PRMRR_SAI_POL_37", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{36, 36, 0x0000000000000000, "RW", "PRMRR_SAI_POL_36", "Bunit PRMRR SAI Read Access Policy: Bit vector used to determine which agents are allowed read access to the PRMRR region based on the agents 6bit encoded SAI value."},
#else
{36, 36, 0x0000000000000000, "RW", "PRMRR_SAI_POL_36", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{35, 35, 0x0000000000000000, "RO", "PRMRR_SAI_POL_35", "Bunit PRMRR SAI Read Access Policy: Bit vector used to determine which agents are allowed read access to the PRMRR region based on the agents 6bit encoded SAI value."},
#else
{35, 35, 0x0000000000000000, "RO", "PRMRR_SAI_POL_35", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{34, 34, 0x0000000000000000, "RW", "PRMRR_SAI_POL_34", "Bunit PRMRR SAI Read Access Policy: Bit vector used to determine which agents are allowed read access to the PRMRR region based on the agents 6bit encoded SAI value."},
#else
{34, 34, 0x0000000000000000, "RW", "PRMRR_SAI_POL_34", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{33, 33, 0x0000000000000000, "RW", "PRMRR_SAI_POL_33", "Bunit PRMRR SAI Read Access Policy: Bit vector used to determine which agents are allowed read access to the PRMRR region based on the agents 6bit encoded SAI value."},
#else
{33, 33, 0x0000000000000000, "RW", "PRMRR_SAI_POL_33", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{32, 32, 0x0000000000000000, "RW", "PRMRR_SAI_POL_32", "Bunit PRMRR SAI Read Access Policy: Bit vector used to determine which agents are allowed read access to the PRMRR region based on the agents 6bit encoded SAI value."},
#else
{32, 32, 0x0000000000000000, "RW", "PRMRR_SAI_POL_32", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{31, 31, 0x0000000000000000, "RO", "PRMRR_SAI_POL_31", "Bunit PRMRR SAI Read Access Policy: Bit vector used to determine which agents are allowed read access to the PRMRR region based on the agents 6bit encoded SAI value."},
#else
{31, 31, 0x0000000000000000, "RO", "PRMRR_SAI_POL_31", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{30, 30, 0x0000000000000000, "RW", "PRMRR_SAI_POL_30", "Bunit PRMRR SAI Read Access Policy: Bit vector used to determine which agents are allowed read access to the PRMRR region based on the agents 6bit encoded SAI value."},
#else
{30, 30, 0x0000000000000000, "RW", "PRMRR_SAI_POL_30", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{29, 29, 0x0000000000000000, "RW", "PRMRR_SAI_POL_29", "Bunit PRMRR SAI Read Access Policy: Bit vector used to determine which agents are allowed read access to the PRMRR region based on the agents 6bit encoded SAI value."},
#else
{29, 29, 0x0000000000000000, "RW", "PRMRR_SAI_POL_29", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{28, 28, 0x0000000000000000, "RW", "PRMRR_SAI_POL_28", "Bunit PRMRR SAI Read Access Policy: Bit vector used to determine which agents are allowed read access to the PRMRR region based on the agents 6bit encoded SAI value."},
#else
{28, 28, 0x0000000000000000, "RW", "PRMRR_SAI_POL_28", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{27, 27, 0x0000000000000000, "RW", "PRMRR_SAI_POL_27", "Bunit PRMRR SAI Read Access Policy: Bit vector used to determine which agents are allowed read access to the PRMRR region based on the agents 6bit encoded SAI value."},
#else
{27, 27, 0x0000000000000000, "RW", "PRMRR_SAI_POL_27", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{26, 26, 0x0000000000000000, "RW", "PRMRR_SAI_POL_26", "Bunit PRMRR SAI Read Access Policy: Bit vector used to determine which agents are allowed read access to the PRMRR region based on the agents 6bit encoded SAI value."},
#else
{26, 26, 0x0000000000000000, "RW", "PRMRR_SAI_POL_26", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{25, 25, 0x0000000000000000, "RW", "PRMRR_SAI_POL_25", "Bunit PRMRR SAI Read Access Policy: Bit vector used to determine which agents are allowed read access to the PRMRR region based on the agents 6bit encoded SAI value."},
#else
{25, 25, 0x0000000000000000, "RW", "PRMRR_SAI_POL_25", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{24, 24, 0x0000000000000000, "RW", "PRMRR_SAI_POL_24", "Bunit PRMRR SAI Read Access Policy: Bit vector used to determine which agents are allowed read access to the PRMRR region based on the agents 6bit encoded SAI value."},
#else
{24, 24, 0x0000000000000000, "RW", "PRMRR_SAI_POL_24", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{23, 23, 0x0000000000000000, "RO", "PRMRR_SAI_POL_23", "Bunit PRMRR SAI Read Access Policy: Bit vector used to determine which agents are allowed read access to the PRMRR region based on the agents 6bit encoded SAI value."},
#else
{23, 23, 0x0000000000000000, "RO", "PRMRR_SAI_POL_23", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{22, 22, 0x0000000000000000, "RO", "PRMRR_SAI_POL_22", "Bunit PRMRR SAI Read Access Policy: Bit vector used to determine which agents are allowed read access to the PRMRR region based on the agents 6bit encoded SAI value."},
#else
{22, 22, 0x0000000000000000, "RO", "PRMRR_SAI_POL_22", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{21, 21, 0x0000000000000000, "RW", "PRMRR_SAI_POL_21", "Bunit PRMRR SAI Read Access Policy: Bit vector used to determine which agents are allowed read access to the PRMRR region based on the agents 6bit encoded SAI value."},
#else
{21, 21, 0x0000000000000000, "RW", "PRMRR_SAI_POL_21", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{20, 20, 0x0000000000000000, "RO", "PRMRR_SAI_POL_20", "Bunit PRMRR SAI Read Access Policy: Bit vector used to determine which agents are allowed read access to the PRMRR region based on the agents 6bit encoded SAI value."},
#else
{20, 20, 0x0000000000000000, "RO", "PRMRR_SAI_POL_20", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{19, 19, 0x0000000000000000, "RO", "PRMRR_SAI_POL_19", "Bunit PRMRR SAI Read Access Policy: Bit vector used to determine which agents are allowed read access to the PRMRR region based on the agents 6bit encoded SAI value."},
#else
{19, 19, 0x0000000000000000, "RO", "PRMRR_SAI_POL_19", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{18, 18, 0x0000000000000000, "RO", "PRMRR_SAI_POL_18", "Bunit PRMRR SAI Read Access Policy: Bit vector used to determine which agents are allowed read access to the PRMRR region based on the agents 6bit encoded SAI value."},
#else
{18, 18, 0x0000000000000000, "RO", "PRMRR_SAI_POL_18", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{17, 17, 0x0000000000000000, "RW", "PRMRR_SAI_POL_17", "Bunit PRMRR SAI Read Access Policy: Bit vector used to determine which agents are allowed read access to the PRMRR region based on the agents 6bit encoded SAI value."},
#else
{17, 17, 0x0000000000000000, "RW", "PRMRR_SAI_POL_17", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{16, 16, 0x0000000000000001, "RW", "PRMRR_SAI_POL_16", "Bunit PRMRR SAI Read Access Policy: Bit vector used to determine which agents are allowed read access to the PRMRR region based on the agents 6bit encoded SAI value."},
#else
{16, 16, 0x0000000000000001, "RW", "PRMRR_SAI_POL_16", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{15, 15, 0x0000000000000000, "RO", "PRMRR_SAI_POL_15", "Bunit PRMRR SAI Read Access Policy: Bit vector used to determine which agents are allowed read access to the PRMRR region based on the agents 6bit encoded SAI value."},
#else
{15, 15, 0x0000000000000000, "RO", "PRMRR_SAI_POL_15", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{14, 14, 0x0000000000000000, "RO", "PRMRR_SAI_POL_14", "Bunit PRMRR SAI Read Access Policy: Bit vector used to determine which agents are allowed read access to the PRMRR region based on the agents 6bit encoded SAI value."},
#else
{14, 14, 0x0000000000000000, "RO", "PRMRR_SAI_POL_14", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{13, 13, 0x0000000000000000, "RW", "PRMRR_SAI_POL_13", "Bunit PRMRR SAI Read Access Policy: Bit vector used to determine which agents are allowed read access to the PRMRR region based on the agents 6bit encoded SAI value."},
#else
{13, 13, 0x0000000000000000, "RW", "PRMRR_SAI_POL_13", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{12, 12, 0x0000000000000000, "RW", "PRMRR_SAI_POL_12", "Bunit PRMRR SAI Read Access Policy: Bit vector used to determine which agents are allowed read access to the PRMRR region based on the agents 6bit encoded SAI value."},
#else
{12, 12, 0x0000000000000000, "RW", "PRMRR_SAI_POL_12", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{11, 11, 0x0000000000000000, "RO", "PRMRR_SAI_POL_11", "Bunit PRMRR SAI Read Access Policy: Bit vector used to determine which agents are allowed read access to the PRMRR region based on the agents 6bit encoded SAI value."},
#else
{11, 11, 0x0000000000000000, "RO", "PRMRR_SAI_POL_11", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{10, 10, 0x0000000000000000, "RO", "PRMRR_SAI_POL_10", "Bunit PRMRR SAI Read Access Policy: Bit vector used to determine which agents are allowed read access to the PRMRR region based on the agents 6bit encoded SAI value."},
#else
{10, 10, 0x0000000000000000, "RO", "PRMRR_SAI_POL_10", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{9, 9, 0x0000000000000000, "RO", "PRMRR_SAI_POL_9", "Bunit PRMRR SAI Read Access Policy: Bit vector used to determine which agents are allowed read access to the PRMRR region based on the agents 6bit encoded SAI value."},
#else
{9, 9, 0x0000000000000000, "RO", "PRMRR_SAI_POL_9", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{8, 8, 0x0000000000000000, "RW", "PRMRR_SAI_POL_8", "Bunit PRMRR SAI Read Access Policy: Bit vector used to determine which agents are allowed read access to the PRMRR region based on the agents 6bit encoded SAI value."},
#else
{8, 8, 0x0000000000000000, "RW", "PRMRR_SAI_POL_8", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{7, 7, 0x0000000000000000, "RO", "PRMRR_SAI_POL_7", "Bunit PRMRR SAI Read Access Policy: Bit vector used to determine which agents are allowed read access to the PRMRR region based on the agents 6bit encoded SAI value."},
#else
{7, 7, 0x0000000000000000, "RO", "PRMRR_SAI_POL_7", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{6, 6, 0x0000000000000000, "RO", "PRMRR_SAI_POL_6", "Bunit PRMRR SAI Read Access Policy: Bit vector used to determine which agents are allowed read access to the PRMRR region based on the agents 6bit encoded SAI value."},
#else
{6, 6, 0x0000000000000000, "RO", "PRMRR_SAI_POL_6", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{5, 5, 0x0000000000000000, "RW", "PRMRR_SAI_POL_5", "Bunit PRMRR SAI Read Access Policy: Bit vector used to determine which agents are allowed read access to the PRMRR region based on the agents 6bit encoded SAI value."},
#else
{5, 5, 0x0000000000000000, "RW", "PRMRR_SAI_POL_5", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{4, 4, 0x0000000000000001, "RW", "PRMRR_SAI_POL_4", "Bunit PRMRR SAI Read Access Policy: Bit vector used to determine which agents are allowed read access to the PRMRR region based on the agents 6bit encoded SAI value."},
#else
{4, 4, 0x0000000000000001, "RW", "PRMRR_SAI_POL_4", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{3, 3, 0x0000000000000000, "RW", "PRMRR_SAI_POL_3", "Bunit PRMRR SAI Read Access Policy: Bit vector used to determine which agents are allowed read access to the PRMRR region based on the agents 6bit encoded SAI value."},
#else
{3, 3, 0x0000000000000000, "RW", "PRMRR_SAI_POL_3", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{2, 2, 0x0000000000000001, "RW", "PRMRR_SAI_POL_2", "Bunit PRMRR SAI Read Access Policy: Bit vector used to determine which agents are allowed read access to the PRMRR region based on the agents 6bit encoded SAI value."},
#else
{2, 2, 0x0000000000000001, "RW", "PRMRR_SAI_POL_2", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{1, 1, 0x0000000000000001, "RW", "PRMRR_SAI_POL_1", "Bunit PRMRR SAI Read Access Policy: Bit vector used to determine which agents are allowed read access to the PRMRR region based on the agents 6bit encoded SAI value."},
#else
{1, 1, 0x0000000000000001, "RW", "PRMRR_SAI_POL_1", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 0, 0x0000000000000001, "RW", "PRMRR_SAI_POL_0", "Bunit PRMRR SAI Read Access Policy: Bit vector used to determine which agents are allowed read access to the PRMRR region based on the agents 6bit encoded SAI value."},
#else
{0, 0, 0x0000000000000001, "RW", "PRMRR_SAI_POL_0", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo869[] = {{"B_CR_BPRMRRRAC", "", 0x00004CF0, 64, 0xFFFFFFFFFFFFFFFF, 0x0000000000010017}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields870[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{63, 63, 0x0000000000000000, "RW", "PRMRR_SAI_POL_63", "Bunit PRMRR Write Access Policy: Bit vector used to determine which agents are allowed write access to the Bunit PRMRR region based on the agents 6bit encoded SAI value."},
#else
{63, 63, 0x0000000000000000, "RW", "PRMRR_SAI_POL_63", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{62, 62, 0x0000000000000000, "RO", "PRMRR_SAI_POL_62", "Bunit PRMRR Write Access Policy: Bit vector used to determine which agents are allowed write access to the Bunit PRMRR region based on the agents 6bit encoded SAI value."},
#else
{62, 62, 0x0000000000000000, "RO", "PRMRR_SAI_POL_62", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{61, 61, 0x0000000000000000, "RO", "PRMRR_SAI_POL_61", "Bunit PRMRR Write Access Policy: Bit vector used to determine which agents are allowed write access to the Bunit PRMRR region based on the agents 6bit encoded SAI value."},
#else
{61, 61, 0x0000000000000000, "RO", "PRMRR_SAI_POL_61", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{60, 60, 0x0000000000000000, "RO", "PRMRR_SAI_POL_60", "Bunit PRMRR Write Access Policy: Bit vector used to determine which agents are allowed write access to the Bunit PRMRR region based on the agents 6bit encoded SAI value."},
#else
{60, 60, 0x0000000000000000, "RO", "PRMRR_SAI_POL_60", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{59, 59, 0x0000000000000000, "RO", "PRMRR_SAI_POL_59", "Bunit PRMRR Write Access Policy: Bit vector used to determine which agents are allowed write access to the Bunit PRMRR region based on the agents 6bit encoded SAI value."},
#else
{59, 59, 0x0000000000000000, "RO", "PRMRR_SAI_POL_59", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{58, 58, 0x0000000000000000, "RO", "PRMRR_SAI_POL_58", "Bunit PRMRR Write Access Policy: Bit vector used to determine which agents are allowed write access to the Bunit PRMRR region based on the agents 6bit encoded SAI value."},
#else
{58, 58, 0x0000000000000000, "RO", "PRMRR_SAI_POL_58", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{57, 57, 0x0000000000000000, "RO", "PRMRR_SAI_POL_57", "Bunit PRMRR Write Access Policy: Bit vector used to determine which agents are allowed write access to the Bunit PRMRR region based on the agents 6bit encoded SAI value."},
#else
{57, 57, 0x0000000000000000, "RO", "PRMRR_SAI_POL_57", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{56, 56, 0x0000000000000000, "RW", "PRMRR_SAI_POL_56", "Bunit PRMRR Write Access Policy: Bit vector used to determine which agents are allowed write access to the Bunit PRMRR region based on the agents 6bit encoded SAI value."},
#else
{56, 56, 0x0000000000000000, "RW", "PRMRR_SAI_POL_56", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{55, 55, 0x0000000000000000, "RW", "PRMRR_SAI_POL_55", "Bunit PRMRR Write Access Policy: Bit vector used to determine which agents are allowed write access to the Bunit PRMRR region based on the agents 6bit encoded SAI value."},
#else
{55, 55, 0x0000000000000000, "RW", "PRMRR_SAI_POL_55", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{54, 54, 0x0000000000000000, "RW", "PRMRR_SAI_POL_54", "Bunit PRMRR Write Access Policy: Bit vector used to determine which agents are allowed write access to the Bunit PRMRR region based on the agents 6bit encoded SAI value."},
#else
{54, 54, 0x0000000000000000, "RW", "PRMRR_SAI_POL_54", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{53, 53, 0x0000000000000000, "RO", "PRMRR_SAI_POL_53", "Bunit PRMRR Write Access Policy: Bit vector used to determine which agents are allowed write access to the Bunit PRMRR region based on the agents 6bit encoded SAI value."},
#else
{53, 53, 0x0000000000000000, "RO", "PRMRR_SAI_POL_53", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{52, 52, 0x0000000000000000, "RO", "PRMRR_SAI_POL_52", "Bunit PRMRR Write Access Policy: Bit vector used to determine which agents are allowed write access to the Bunit PRMRR region based on the agents 6bit encoded SAI value."},
#else
{52, 52, 0x0000000000000000, "RO", "PRMRR_SAI_POL_52", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{51, 51, 0x0000000000000000, "RO", "PRMRR_SAI_POL_51", "Bunit PRMRR Write Access Policy: Bit vector used to determine which agents are allowed write access to the Bunit PRMRR region based on the agents 6bit encoded SAI value."},
#else
{51, 51, 0x0000000000000000, "RO", "PRMRR_SAI_POL_51", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{50, 50, 0x0000000000000000, "RW", "PRMRR_SAI_POL_50", "Bunit PRMRR Write Access Policy: Bit vector used to determine which agents are allowed write access to the Bunit PRMRR region based on the agents 6bit encoded SAI value."},
#else
{50, 50, 0x0000000000000000, "RW", "PRMRR_SAI_POL_50", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{49, 49, 0x0000000000000000, "RW", "PRMRR_SAI_POL_49", "Bunit PRMRR Write Access Policy: Bit vector used to determine which agents are allowed write access to the Bunit PRMRR region based on the agents 6bit encoded SAI value."},
#else
{49, 49, 0x0000000000000000, "RW", "PRMRR_SAI_POL_49", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{48, 48, 0x0000000000000000, "RW", "PRMRR_SAI_POL_48", "Bunit PRMRR Write Access Policy: Bit vector used to determine which agents are allowed write access to the Bunit PRMRR region based on the agents 6bit encoded SAI value."},
#else
{48, 48, 0x0000000000000000, "RW", "PRMRR_SAI_POL_48", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{47, 47, 0x0000000000000000, "RO", "PRMRR_SAI_POL_47", "Bunit PRMRR Write Access Policy: Bit vector used to determine which agents are allowed write access to the Bunit PRMRR region based on the agents 6bit encoded SAI value."},
#else
{47, 47, 0x0000000000000000, "RO", "PRMRR_SAI_POL_47", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{46, 46, 0x0000000000000000, "RO", "PRMRR_SAI_POL_46", "Bunit PRMRR Write Access Policy: Bit vector used to determine which agents are allowed write access to the Bunit PRMRR region based on the agents 6bit encoded SAI value."},
#else
{46, 46, 0x0000000000000000, "RO", "PRMRR_SAI_POL_46", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{45, 45, 0x0000000000000000, "RO", "PRMRR_SAI_POL_45", "Bunit PRMRR Write Access Policy: Bit vector used to determine which agents are allowed write access to the Bunit PRMRR region based on the agents 6bit encoded SAI value."},
#else
{45, 45, 0x0000000000000000, "RO", "PRMRR_SAI_POL_45", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{44, 44, 0x0000000000000000, "RW", "PRMRR_SAI_POL_44", "Bunit PRMRR Write Access Policy: Bit vector used to determine which agents are allowed write access to the Bunit PRMRR region based on the agents 6bit encoded SAI value."},
#else
{44, 44, 0x0000000000000000, "RW", "PRMRR_SAI_POL_44", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{43, 43, 0x0000000000000000, "RW", "PRMRR_SAI_POL_43", "Bunit PRMRR Write Access Policy: Bit vector used to determine which agents are allowed write access to the Bunit PRMRR region based on the agents 6bit encoded SAI value."},
#else
{43, 43, 0x0000000000000000, "RW", "PRMRR_SAI_POL_43", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{42, 42, 0x0000000000000000, "RW", "PRMRR_SAI_POL_42", "Bunit PRMRR Write Access Policy: Bit vector used to determine which agents are allowed write access to the Bunit PRMRR region based on the agents 6bit encoded SAI value."},
#else
{42, 42, 0x0000000000000000, "RW", "PRMRR_SAI_POL_42", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{41, 41, 0x0000000000000000, "RW", "PRMRR_SAI_POL_41", "Bunit PRMRR Write Access Policy: Bit vector used to determine which agents are allowed write access to the Bunit PRMRR region based on the agents 6bit encoded SAI value."},
#else
{41, 41, 0x0000000000000000, "RW", "PRMRR_SAI_POL_41", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{40, 40, 0x0000000000000000, "RW", "PRMRR_SAI_POL_40", "Bunit PRMRR Write Access Policy: Bit vector used to determine which agents are allowed write access to the Bunit PRMRR region based on the agents 6bit encoded SAI value."},
#else
{40, 40, 0x0000000000000000, "RW", "PRMRR_SAI_POL_40", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{39, 39, 0x0000000000000000, "RO", "PRMRR_SAI_POL_39", "Bunit PRMRR Write Access Policy: Bit vector used to determine which agents are allowed write access to the Bunit PRMRR region based on the agents 6bit encoded SAI value."},
#else
{39, 39, 0x0000000000000000, "RO", "PRMRR_SAI_POL_39", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{38, 38, 0x0000000000000000, "RW", "PRMRR_SAI_POL_38", "Bunit PRMRR Write Access Policy: Bit vector used to determine which agents are allowed write access to the Bunit PRMRR region based on the agents 6bit encoded SAI value."},
#else
{38, 38, 0x0000000000000000, "RW", "PRMRR_SAI_POL_38", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{37, 37, 0x0000000000000000, "RO", "PRMRR_SAI_POL_37", "Bunit PRMRR Write Access Policy: Bit vector used to determine which agents are allowed write access to the Bunit PRMRR region based on the agents 6bit encoded SAI value."},
#else
{37, 37, 0x0000000000000000, "RO", "PRMRR_SAI_POL_37", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{36, 36, 0x0000000000000000, "RW", "PRMRR_SAI_POL_36", "Bunit PRMRR Write Access Policy: Bit vector used to determine which agents are allowed write access to the Bunit PRMRR region based on the agents 6bit encoded SAI value."},
#else
{36, 36, 0x0000000000000000, "RW", "PRMRR_SAI_POL_36", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{35, 35, 0x0000000000000000, "RO", "PRMRR_SAI_POL_35", "Bunit PRMRR Write Access Policy: Bit vector used to determine which agents are allowed write access to the Bunit PRMRR region based on the agents 6bit encoded SAI value."},
#else
{35, 35, 0x0000000000000000, "RO", "PRMRR_SAI_POL_35", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{34, 34, 0x0000000000000000, "RW", "PRMRR_SAI_POL_34", "Bunit PRMRR Write Access Policy: Bit vector used to determine which agents are allowed write access to the Bunit PRMRR region based on the agents 6bit encoded SAI value."},
#else
{34, 34, 0x0000000000000000, "RW", "PRMRR_SAI_POL_34", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{33, 33, 0x0000000000000000, "RW", "PRMRR_SAI_POL_33", "Bunit PRMRR Write Access Policy: Bit vector used to determine which agents are allowed write access to the Bunit PRMRR region based on the agents 6bit encoded SAI value."},
#else
{33, 33, 0x0000000000000000, "RW", "PRMRR_SAI_POL_33", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{32, 32, 0x0000000000000000, "RW", "PRMRR_SAI_POL_32", "Bunit PRMRR Write Access Policy: Bit vector used to determine which agents are allowed write access to the Bunit PRMRR region based on the agents 6bit encoded SAI value."},
#else
{32, 32, 0x0000000000000000, "RW", "PRMRR_SAI_POL_32", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{31, 31, 0x0000000000000000, "RO", "PRMRR_SAI_POL_31", "Bunit PRMRR Write Access Policy: Bit vector used to determine which agents are allowed write access to the Bunit PRMRR region based on the agents 6bit encoded SAI value."},
#else
{31, 31, 0x0000000000000000, "RO", "PRMRR_SAI_POL_31", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{30, 30, 0x0000000000000000, "RW", "PRMRR_SAI_POL_30", "Bunit PRMRR Write Access Policy: Bit vector used to determine which agents are allowed write access to the Bunit PRMRR region based on the agents 6bit encoded SAI value."},
#else
{30, 30, 0x0000000000000000, "RW", "PRMRR_SAI_POL_30", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{29, 29, 0x0000000000000000, "RW", "PRMRR_SAI_POL_29", "Bunit PRMRR Write Access Policy: Bit vector used to determine which agents are allowed write access to the Bunit PRMRR region based on the agents 6bit encoded SAI value."},
#else
{29, 29, 0x0000000000000000, "RW", "PRMRR_SAI_POL_29", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{28, 28, 0x0000000000000000, "RW", "PRMRR_SAI_POL_28", "Bunit PRMRR Write Access Policy: Bit vector used to determine which agents are allowed write access to the Bunit PRMRR region based on the agents 6bit encoded SAI value."},
#else
{28, 28, 0x0000000000000000, "RW", "PRMRR_SAI_POL_28", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{27, 27, 0x0000000000000000, "RW", "PRMRR_SAI_POL_27", "Bunit PRMRR Write Access Policy: Bit vector used to determine which agents are allowed write access to the Bunit PRMRR region based on the agents 6bit encoded SAI value."},
#else
{27, 27, 0x0000000000000000, "RW", "PRMRR_SAI_POL_27", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{26, 26, 0x0000000000000000, "RW", "PRMRR_SAI_POL_26", "Bunit PRMRR Write Access Policy: Bit vector used to determine which agents are allowed write access to the Bunit PRMRR region based on the agents 6bit encoded SAI value."},
#else
{26, 26, 0x0000000000000000, "RW", "PRMRR_SAI_POL_26", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{25, 25, 0x0000000000000000, "RW", "PRMRR_SAI_POL_25", "Bunit PRMRR Write Access Policy: Bit vector used to determine which agents are allowed write access to the Bunit PRMRR region based on the agents 6bit encoded SAI value."},
#else
{25, 25, 0x0000000000000000, "RW", "PRMRR_SAI_POL_25", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{24, 24, 0x0000000000000000, "RW", "PRMRR_SAI_POL_24", "Bunit PRMRR Write Access Policy: Bit vector used to determine which agents are allowed write access to the Bunit PRMRR region based on the agents 6bit encoded SAI value."},
#else
{24, 24, 0x0000000000000000, "RW", "PRMRR_SAI_POL_24", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{23, 23, 0x0000000000000000, "RO", "PRMRR_SAI_POL_23", "Bunit PRMRR Write Access Policy: Bit vector used to determine which agents are allowed write access to the Bunit PRMRR region based on the agents 6bit encoded SAI value."},
#else
{23, 23, 0x0000000000000000, "RO", "PRMRR_SAI_POL_23", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{22, 22, 0x0000000000000000, "RO", "PRMRR_SAI_POL_22", "Bunit PRMRR Write Access Policy: Bit vector used to determine which agents are allowed write access to the Bunit PRMRR region based on the agents 6bit encoded SAI value."},
#else
{22, 22, 0x0000000000000000, "RO", "PRMRR_SAI_POL_22", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{21, 21, 0x0000000000000000, "RW", "PRMRR_SAI_POL_21", "Bunit PRMRR Write Access Policy: Bit vector used to determine which agents are allowed write access to the Bunit PRMRR region based on the agents 6bit encoded SAI value."},
#else
{21, 21, 0x0000000000000000, "RW", "PRMRR_SAI_POL_21", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{20, 20, 0x0000000000000000, "RO", "PRMRR_SAI_POL_20", "Bunit PRMRR Write Access Policy: Bit vector used to determine which agents are allowed write access to the Bunit PRMRR region based on the agents 6bit encoded SAI value."},
#else
{20, 20, 0x0000000000000000, "RO", "PRMRR_SAI_POL_20", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{19, 19, 0x0000000000000000, "RO", "PRMRR_SAI_POL_19", "Bunit PRMRR Write Access Policy: Bit vector used to determine which agents are allowed write access to the Bunit PRMRR region based on the agents 6bit encoded SAI value."},
#else
{19, 19, 0x0000000000000000, "RO", "PRMRR_SAI_POL_19", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{18, 18, 0x0000000000000000, "RO", "PRMRR_SAI_POL_18", "Bunit PRMRR Write Access Policy: Bit vector used to determine which agents are allowed write access to the Bunit PRMRR region based on the agents 6bit encoded SAI value."},
#else
{18, 18, 0x0000000000000000, "RO", "PRMRR_SAI_POL_18", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{17, 17, 0x0000000000000000, "RW", "PRMRR_SAI_POL_17", "Bunit PRMRR Write Access Policy: Bit vector used to determine which agents are allowed write access to the Bunit PRMRR region based on the agents 6bit encoded SAI value."},
#else
{17, 17, 0x0000000000000000, "RW", "PRMRR_SAI_POL_17", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{16, 16, 0x0000000000000001, "RW", "PRMRR_SAI_POL_16", "Bunit PRMRR Write Access Policy: Bit vector used to determine which agents are allowed write access to the Bunit PRMRR region based on the agents 6bit encoded SAI value."},
#else
{16, 16, 0x0000000000000001, "RW", "PRMRR_SAI_POL_16", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{15, 15, 0x0000000000000000, "RO", "PRMRR_SAI_POL_15", "Bunit PRMRR Write Access Policy: Bit vector used to determine which agents are allowed write access to the Bunit PRMRR region based on the agents 6bit encoded SAI value."},
#else
{15, 15, 0x0000000000000000, "RO", "PRMRR_SAI_POL_15", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{14, 14, 0x0000000000000000, "RO", "PRMRR_SAI_POL_14", "Bunit PRMRR Write Access Policy: Bit vector used to determine which agents are allowed write access to the Bunit PRMRR region based on the agents 6bit encoded SAI value."},
#else
{14, 14, 0x0000000000000000, "RO", "PRMRR_SAI_POL_14", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{13, 13, 0x0000000000000000, "RW", "PRMRR_SAI_POL_13", "Bunit PRMRR Write Access Policy: Bit vector used to determine which agents are allowed write access to the Bunit PRMRR region based on the agents 6bit encoded SAI value."},
#else
{13, 13, 0x0000000000000000, "RW", "PRMRR_SAI_POL_13", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{12, 12, 0x0000000000000000, "RW", "PRMRR_SAI_POL_12", "Bunit PRMRR Write Access Policy: Bit vector used to determine which agents are allowed write access to the Bunit PRMRR region based on the agents 6bit encoded SAI value."},
#else
{12, 12, 0x0000000000000000, "RW", "PRMRR_SAI_POL_12", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{11, 11, 0x0000000000000000, "RO", "PRMRR_SAI_POL_11", "Bunit PRMRR Write Access Policy: Bit vector used to determine which agents are allowed write access to the Bunit PRMRR region based on the agents 6bit encoded SAI value."},
#else
{11, 11, 0x0000000000000000, "RO", "PRMRR_SAI_POL_11", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{10, 10, 0x0000000000000000, "RO", "PRMRR_SAI_POL_10", "Bunit PRMRR Write Access Policy: Bit vector used to determine which agents are allowed write access to the Bunit PRMRR region based on the agents 6bit encoded SAI value."},
#else
{10, 10, 0x0000000000000000, "RO", "PRMRR_SAI_POL_10", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{9, 9, 0x0000000000000000, "RO", "PRMRR_SAI_POL_9", "Bunit PRMRR Write Access Policy: Bit vector used to determine which agents are allowed write access to the Bunit PRMRR region based on the agents 6bit encoded SAI value."},
#else
{9, 9, 0x0000000000000000, "RO", "PRMRR_SAI_POL_9", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{8, 8, 0x0000000000000000, "RW", "PRMRR_SAI_POL_8", "Bunit PRMRR Write Access Policy: Bit vector used to determine which agents are allowed write access to the Bunit PRMRR region based on the agents 6bit encoded SAI value."},
#else
{8, 8, 0x0000000000000000, "RW", "PRMRR_SAI_POL_8", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{7, 7, 0x0000000000000000, "RO", "PRMRR_SAI_POL_7", "Bunit PRMRR Write Access Policy: Bit vector used to determine which agents are allowed write access to the Bunit PRMRR region based on the agents 6bit encoded SAI value."},
#else
{7, 7, 0x0000000000000000, "RO", "PRMRR_SAI_POL_7", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{6, 6, 0x0000000000000000, "RO", "PRMRR_SAI_POL_6", "Bunit PRMRR Write Access Policy: Bit vector used to determine which agents are allowed write access to the Bunit PRMRR region based on the agents 6bit encoded SAI value."},
#else
{6, 6, 0x0000000000000000, "RO", "PRMRR_SAI_POL_6", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{5, 5, 0x0000000000000000, "RW", "PRMRR_SAI_POL_5", "Bunit PRMRR Write Access Policy: Bit vector used to determine which agents are allowed write access to the Bunit PRMRR region based on the agents 6bit encoded SAI value."},
#else
{5, 5, 0x0000000000000000, "RW", "PRMRR_SAI_POL_5", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{4, 4, 0x0000000000000001, "RW", "PRMRR_SAI_POL_4", "Bunit PRMRR Write Access Policy: Bit vector used to determine which agents are allowed write access to the Bunit PRMRR region based on the agents 6bit encoded SAI value."},
#else
{4, 4, 0x0000000000000001, "RW", "PRMRR_SAI_POL_4", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{3, 3, 0x0000000000000000, "RW", "PRMRR_SAI_POL_3", "Bunit PRMRR Write Access Policy: Bit vector used to determine which agents are allowed write access to the Bunit PRMRR region based on the agents 6bit encoded SAI value."},
#else
{3, 3, 0x0000000000000000, "RW", "PRMRR_SAI_POL_3", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{2, 2, 0x0000000000000001, "RW", "PRMRR_SAI_POL_2", "Bunit PRMRR Write Access Policy: Bit vector used to determine which agents are allowed write access to the Bunit PRMRR region based on the agents 6bit encoded SAI value."},
#else
{2, 2, 0x0000000000000001, "RW", "PRMRR_SAI_POL_2", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{1, 1, 0x0000000000000001, "RW", "PRMRR_SAI_POL_1", "Bunit PRMRR Write Access Policy: Bit vector used to determine which agents are allowed write access to the Bunit PRMRR region based on the agents 6bit encoded SAI value."},
#else
{1, 1, 0x0000000000000001, "RW", "PRMRR_SAI_POL_1", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 0, 0x0000000000000001, "RW", "PRMRR_SAI_POL_0", "Bunit PRMRR Write Access Policy: Bit vector used to determine which agents are allowed write access to the Bunit PRMRR region based on the agents 6bit encoded SAI value."},
#else
{0, 0, 0x0000000000000001, "RW", "PRMRR_SAI_POL_0", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo870[] = {{"B_CR_BPRMRRWAC", "", 0x00004CF8, 64, 0xFFFFFFFFFFFFFFFF, 0x0000000000010017}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields871[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{4, 31, 0x0000000000000000, "RO", "RESERVED_0", "Reserved"},
#else
{4, 31, 0x0000000000000000, "RO", "RESERVED_0", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{3, 3, 0x0000000000000000, "RW", "SEND_BOOT_VECTOR_TO_DRAM", "When set accesses to BIOS1, BIOS2, BIOS3 and BIOS4 ranges will be sent to memory regardless of the Host IO Boundary setting in TOLUD."},
#else
{3, 3, 0x0000000000000000, "RW", "SEND_BOOT_VECTOR_TO_DRAM", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{2, 2, 0x0000000000000001, "RW", "ABSEGINDRAM", "ABSeginDRAM Legacy Video Area: When this bit is set  reads and writes targeting A or Bsegments are routed to DRAM.  Asegment corresponds to the memory range 0xA_0000 to 0xA_FFFF.  Bsegment corresponds to the memory ranges 0xB_0000 to 0xB_7FFF and 0xB_8000 to 0xB_FFFF."},
#else
{2, 2, 0x0000000000000001, "RW", "ABSEGINDRAM", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{1, 1, 0x0000000000000001, "RW", "READ_FSEG_FROM_DRAM", "Read FSeg from DRAM FSegmentReadFromDRAM: When this bit is set  reads targeting Fsegment are routed to DRAM.  Fsegment corresponds to the memory range 0xF_0000 to 0xF_FFFF."},
#else
{1, 1, 0x0000000000000001, "RW", "READ_FSEG_FROM_DRAM", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 0, 0x0000000000000001, "RW", "READ_ESEG_FROM_DRAM", "Read ESeg from DRAM ESegmentReadFromDRAM: When this bit is set  reads targeting Esegment are routed to DRAM.  Fsegment corresponds to the memory range 0xE_0000 to 0xE_FFFF."},
#else
{0, 0, 0x0000000000000001, "RW", "READ_ESEG_FROM_DRAM", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo871[] = {{"B_CR_BMISC_0_0_0_MCHBAR", "", 0x00006800, 5, 0x00000000FFFFFFFF, 0x0000000000000007}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields872[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{0, 63, 0x0000000000000000, "RO", "SEC_SAI_POL", "Bunit Security Control Policy: Bit vector used to determine which agents are allowed access to the BIARAC BIAWAC and BIACP registers based on the value from the agents 6bit SAI field."},
#else
{0, 63, 0x0000000000000000, "RO", "SEC_SAI_POL", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo872[] = {{"B_CR_SECURITY_CP_0_0_0_MCHBAR", "", 0x00006808, 1, 0xFFFFFFFFFFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields873[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{0, 63, 0x00000C0061010202, "RO", "SEC_SAI_POL", "Bunit Security SAI Read Access Policy: Bit vector used to determine which agents are allowed read access to the Bunit Security Group Configuration registers based on the agents 6bit encoded SAI value."},
#else
{0, 63, 0x00000C0061010202, "RO", "SEC_SAI_POL", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo873[] = {{"B_CR_SECURITY_RAC_0_0_0_MCHBAR", "", 0x00006810, 1, 0xFFFFFFFFFFFFFFFF, 0x00000C0061010202}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields874[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{0, 63, 0x00000C0061010202, "RO", "SEC_SAI_POL", "Bunit Security SAI Write Access Policy: Bit vector used to determine which agents are allowed write access to the Bunit Security Group Configuration registers based on the agents 6bit encoded SAI value."},
#else
{0, 63, 0x00000C0061010202, "RO", "SEC_SAI_POL", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo874[] = {{"B_CR_SECURITY_WAC_0_0_0_MCHBAR", "", 0x00006818, 1, 0xFFFFFFFFFFFFFFFF, 0x00000C0061010202}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields875[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{0, 31, 0x0000000000000000, "RO/V", "MEM_ACCESS_COUNT", "Counts the number of PMI transactions that the Bunit has sent to any PMI channel.  Counts both reads and writes.  Counter is not saturating and will roll over to zero.  It is upto the consumer of the counter to handle roll over cases."},
#else
{0, 31, 0x0000000000000000, "RO/V", "MEM_ACCESS_COUNT", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo875[] = {{"B_CR_MEM_ACCESS_COUNT_SLICE0", "", 0x00006868, 1, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields876[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{0, 31, 0x0000000000000000, "RO/V", "MEM_ACCESS_COUNT", "Counts the number of PMI transactions that the Bunit has sent to any PMI channel.  Counts both reads and writes.  Counter is not saturating and will roll over to zero.  It is upto the consumer of the counter to handle roll over cases."},
#else
{0, 31, 0x0000000000000000, "RO/V", "MEM_ACCESS_COUNT", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo876[] = {{"B_CR_MEM_ACCESS_COUNT_SLICE1", "", 0x0000686C, 1, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields877[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{31, 31, 0x0000000000000000, "RW", "IMR_EN", "IMR Enable: Enables access checking for the IMR region."},
#else
{31, 31, 0x0000000000000000, "RW", "IMR_EN", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{30, 30, 0x0000000000000000, "RW", "TR_EN", "Asset Classification AC[0]: Trace Enable: Enables snooping of transactions to the IMR region by tracing agents."},
#else
{30, 30, 0x0000000000000000, "RW", "TR_EN", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{29, 29, 0x0000000000000000, "RO", "RESERVED_1", "Reserved"},
#else
{29, 29, 0x0000000000000000, "RO", "RESERVED_1", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 28, 0x0000000000000000, "RW", "IMR0_BASE", "Base 0 IMR0BASE:  Specifies bits 38:10 of the start address of IMR0 region.  IMR region size must be a strict poweroftwo at least 1KB and naturally aligned to the size.  These bits are compared with the result of the IMR0MASK[28:0] applied to bits 38:10 of the incoming address to determine if an access falls within the IMR0 defined region."},
#else
{0, 28, 0x0000000000000000, "RW", "IMR0_BASE", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo877[] = {{"B_CR_BIMR0BASE_0_0_0_MCHBAR", "", 0x00006870, 4, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields878[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{31, 31, 0x0000000000000000, "RW", "GT_IWB_EN", "Asset Classification AC[2]: GT Implicit WB Enable: Enables implicit writebacks to protected region from GT caching agent. When set to 1 enables implicit writeback data HITM data from GT to be returned to the requester.  When set to 0 inhibits HITM data from GT from being returned to the requester.  HITM data from IA cores may be returned to the requester depending on the setting of the IA_IWB_EN bit."},
#else
{31, 31, 0x0000000000000000, "RW", "GT_IWB_EN", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{30, 30, 0x0000000000000000, "RW", "IA_IWB_EN", "Asset Classification AC[1]: IA Implicit WB Enable: Enables implicit writebacks to protected region from IA caching agent.  When set to 1 enables implicit writeback data HITM data from IA cores to be returned to the requester.  When set to 0 inhibits HITM data from IA cores from being returned to the requester.  HITM data from GT may be returned to the requester depending on the setting of the GT_IWB_EN bit."},
#else
{30, 30, 0x0000000000000000, "RW", "IA_IWB_EN", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{29, 29, 0x0000000000000000, "RO", "RESERVED_0", "Reserved"},
#else
{29, 29, 0x0000000000000000, "RO", "RESERVED_0", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 28, 0x0000000000000000, "RW", "IMR0_MASK", "Mask 0 IMR0MASK:  These bits are ANDed with bits 38:10 of the incoming address to determine if the combined result matches the IMR0BASE[28:0] value.  A match indicates the the incoming address falls within the IMR0 region."},
#else
{0, 28, 0x0000000000000000, "RW", "IMR0_MASK", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo878[] = {{"B_CR_BIMR0MASK_0_0_0_MCHBAR", "", 0x00006874, 4, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields879[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{0, 63, 0x00000C0061010202, "RW", "IMR0_CTRL_POL", "Bunit IMR0 Control Policy: Bit vector used to determine which agents are allowed access to the BIMR0RAC, BIMR0WAC, BIMR0CP registers based on the value from the agents 6bit SAI field."},
#else
{0, 63, 0x00000C0061010202, "RW", "IMR0_CTRL_POL", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo879[] = {{"B_CR_BIMR0CP_0_0_0_MCHBAR", "", 0x00006878, 1, 0xFFFFFFFFFFFFFFFF, 0x00000C0061010202}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields880[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{63, 63, 0x0000000000000000, "RW", "IMR0_READ_POL_63", "Bunit IMR0 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR0 region based on the agents 6bit encoded SAI value."},
#else
{63, 63, 0x0000000000000000, "RW", "IMR0_READ_POL_63", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{62, 62, 0x0000000000000000, "RO", "IMR0_READ_POL_62", "Bunit IMR0 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR0 region based on the agents 6bit encoded SAI value."},
#else
{62, 62, 0x0000000000000000, "RO", "IMR0_READ_POL_62", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{61, 61, 0x0000000000000000, "RO", "IMR0_READ_POL_61", "Bunit IMR0 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR0 region based on the agents 6bit encoded SAI value."},
#else
{61, 61, 0x0000000000000000, "RO", "IMR0_READ_POL_61", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{60, 60, 0x0000000000000000, "RO", "IMR0_READ_POL_60", "Bunit IMR0 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR0 region based on the agents 6bit encoded SAI value."},
#else
{60, 60, 0x0000000000000000, "RO", "IMR0_READ_POL_60", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{59, 59, 0x0000000000000000, "RO", "IMR0_READ_POL_59", "Bunit IMR0 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR0 region based on the agents 6bit encoded SAI value."},
#else
{59, 59, 0x0000000000000000, "RO", "IMR0_READ_POL_59", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{58, 58, 0x0000000000000000, "RO", "IMR0_READ_POL_58", "Bunit IMR0 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR0 region based on the agents 6bit encoded SAI value."},
#else
{58, 58, 0x0000000000000000, "RO", "IMR0_READ_POL_58", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{57, 57, 0x0000000000000000, "RO", "IMR0_READ_POL_57", "Bunit IMR0 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR0 region based on the agents 6bit encoded SAI value."},
#else
{57, 57, 0x0000000000000000, "RO", "IMR0_READ_POL_57", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{56, 56, 0x0000000000000000, "RW", "IMR0_READ_POL_56", "Bunit IMR0 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR0 region based on the agents 6bit encoded SAI value."},
#else
{56, 56, 0x0000000000000000, "RW", "IMR0_READ_POL_56", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{55, 55, 0x0000000000000000, "RW", "IMR0_READ_POL_55", "Bunit IMR0 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR0 region based on the agents 6bit encoded SAI value."},
#else
{55, 55, 0x0000000000000000, "RW", "IMR0_READ_POL_55", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{54, 54, 0x0000000000000000, "RW", "IMR0_READ_POL_54", "Bunit IMR0 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR0 region based on the agents 6bit encoded SAI value."},
#else
{54, 54, 0x0000000000000000, "RW", "IMR0_READ_POL_54", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{53, 53, 0x0000000000000000, "RO", "IMR0_READ_POL_53", "Bunit IMR0 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR0 region based on the agents 6bit encoded SAI value."},
#else
{53, 53, 0x0000000000000000, "RO", "IMR0_READ_POL_53", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{52, 52, 0x0000000000000000, "RO", "IMR0_READ_POL_52", "Bunit IMR0 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR0 region based on the agents 6bit encoded SAI value."},
#else
{52, 52, 0x0000000000000000, "RO", "IMR0_READ_POL_52", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{51, 51, 0x0000000000000000, "RO", "IMR0_READ_POL_51", "Bunit IMR0 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR0 region based on the agents 6bit encoded SAI value."},
#else
{51, 51, 0x0000000000000000, "RO", "IMR0_READ_POL_51", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{50, 50, 0x0000000000000000, "RW", "IMR0_READ_POL_50", "Bunit IMR0 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR0 region based on the agents 6bit encoded SAI value."},
#else
{50, 50, 0x0000000000000000, "RW", "IMR0_READ_POL_50", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{49, 49, 0x0000000000000000, "RW", "IMR0_READ_POL_49", "Bunit IMR0 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR0 region based on the agents 6bit encoded SAI value."},
#else
{49, 49, 0x0000000000000000, "RW", "IMR0_READ_POL_49", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{48, 48, 0x0000000000000000, "RW", "IMR0_READ_POL_48", "Bunit IMR0 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR0 region based on the agents 6bit encoded SAI value."},
#else
{48, 48, 0x0000000000000000, "RW", "IMR0_READ_POL_48", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{47, 47, 0x0000000000000000, "RO", "IMR0_READ_POL_47", "Bunit IMR0 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR0 region based on the agents 6bit encoded SAI value."},
#else
{47, 47, 0x0000000000000000, "RO", "IMR0_READ_POL_47", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{46, 46, 0x0000000000000000, "RO", "IMR0_READ_POL_46", "Bunit IMR0 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR0 region based on the agents 6bit encoded SAI value."},
#else
{46, 46, 0x0000000000000000, "RO", "IMR0_READ_POL_46", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{45, 45, 0x0000000000000000, "RO", "IMR0_READ_POL_45", "Bunit IMR0 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR0 region based on the agents 6bit encoded SAI value."},
#else
{45, 45, 0x0000000000000000, "RO", "IMR0_READ_POL_45", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{44, 44, 0x0000000000000000, "RW", "IMR0_READ_POL_44", "Bunit IMR0 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR0 region based on the agents 6bit encoded SAI value."},
#else
{44, 44, 0x0000000000000000, "RW", "IMR0_READ_POL_44", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{43, 43, 0x0000000000000000, "RW", "IMR0_READ_POL_43", "Bunit IMR0 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR0 region based on the agents 6bit encoded SAI value."},
#else
{43, 43, 0x0000000000000000, "RW", "IMR0_READ_POL_43", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{42, 42, 0x0000000000000000, "RW", "IMR0_READ_POL_42", "Bunit IMR0 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR0 region based on the agents 6bit encoded SAI value."},
#else
{42, 42, 0x0000000000000000, "RW", "IMR0_READ_POL_42", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{41, 41, 0x0000000000000000, "RW", "IMR0_READ_POL_41", "Bunit IMR0 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR0 region based on the agents 6bit encoded SAI value."},
#else
{41, 41, 0x0000000000000000, "RW", "IMR0_READ_POL_41", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{40, 40, 0x0000000000000000, "RW", "IMR0_READ_POL_40", "Bunit IMR0 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR0 region based on the agents 6bit encoded SAI value."},
#else
{40, 40, 0x0000000000000000, "RW", "IMR0_READ_POL_40", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{39, 39, 0x0000000000000000, "RO", "IMR0_READ_POL_39", "Bunit IMR0 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR0 region based on the agents 6bit encoded SAI value."},
#else
{39, 39, 0x0000000000000000, "RO", "IMR0_READ_POL_39", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{38, 38, 0x0000000000000000, "RW", "IMR0_READ_POL_38", "Bunit IMR0 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR0 region based on the agents 6bit encoded SAI value."},
#else
{38, 38, 0x0000000000000000, "RW", "IMR0_READ_POL_38", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{37, 37, 0x0000000000000000, "RO", "IMR0_READ_POL_37", "Bunit IMR0 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR0 region based on the agents 6bit encoded SAI value."},
#else
{37, 37, 0x0000000000000000, "RO", "IMR0_READ_POL_37", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{36, 36, 0x0000000000000000, "RW", "IMR0_READ_POL_36", "Bunit IMR0 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR0 region based on the agents 6bit encoded SAI value."},
#else
{36, 36, 0x0000000000000000, "RW", "IMR0_READ_POL_36", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{35, 35, 0x0000000000000000, "RO", "IMR0_READ_POL_35", "Bunit IMR0 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR0 region based on the agents 6bit encoded SAI value."},
#else
{35, 35, 0x0000000000000000, "RO", "IMR0_READ_POL_35", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{34, 34, 0x0000000000000000, "RW", "IMR0_READ_POL_34", "Bunit IMR0 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR0 region based on the agents 6bit encoded SAI value."},
#else
{34, 34, 0x0000000000000000, "RW", "IMR0_READ_POL_34", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{33, 33, 0x0000000000000000, "RW", "IMR0_READ_POL_33", "Bunit IMR0 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR0 region based on the agents 6bit encoded SAI value."},
#else
{33, 33, 0x0000000000000000, "RW", "IMR0_READ_POL_33", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{32, 32, 0x0000000000000000, "RW", "IMR0_READ_POL_32", "Bunit IMR0 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR0 region based on the agents 6bit encoded SAI value."},
#else
{32, 32, 0x0000000000000000, "RW", "IMR0_READ_POL_32", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{31, 31, 0x0000000000000000, "RO", "IMR0_READ_POL_31", "Bunit IMR0 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR0 region based on the agents 6bit encoded SAI value."},
#else
{31, 31, 0x0000000000000000, "RO", "IMR0_READ_POL_31", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{30, 30, 0x0000000000000000, "RW", "IMR0_READ_POL_30", "Bunit IMR0 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR0 region based on the agents 6bit encoded SAI value."},
#else
{30, 30, 0x0000000000000000, "RW", "IMR0_READ_POL_30", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{29, 29, 0x0000000000000000, "RW", "IMR0_READ_POL_29", "Bunit IMR0 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR0 region based on the agents 6bit encoded SAI value."},
#else
{29, 29, 0x0000000000000000, "RW", "IMR0_READ_POL_29", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{28, 28, 0x0000000000000000, "RW", "IMR0_READ_POL_28", "Bunit IMR0 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR0 region based on the agents 6bit encoded SAI value."},
#else
{28, 28, 0x0000000000000000, "RW", "IMR0_READ_POL_28", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{27, 27, 0x0000000000000000, "RW", "IMR0_READ_POL_27", "Bunit IMR0 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR0 region based on the agents 6bit encoded SAI value."},
#else
{27, 27, 0x0000000000000000, "RW", "IMR0_READ_POL_27", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{26, 26, 0x0000000000000000, "RW", "IMR0_READ_POL_26", "Bunit IMR0 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR0 region based on the agents 6bit encoded SAI value."},
#else
{26, 26, 0x0000000000000000, "RW", "IMR0_READ_POL_26", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{25, 25, 0x0000000000000000, "RW", "IMR0_READ_POL_25", "Bunit IMR0 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR0 region based on the agents 6bit encoded SAI value."},
#else
{25, 25, 0x0000000000000000, "RW", "IMR0_READ_POL_25", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{24, 24, 0x0000000000000000, "RW", "IMR0_READ_POL_24", "Bunit IMR0 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR0 region based on the agents 6bit encoded SAI value."},
#else
{24, 24, 0x0000000000000000, "RW", "IMR0_READ_POL_24", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{23, 23, 0x0000000000000000, "RO", "IMR0_READ_POL_23", "Bunit IMR0 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR0 region based on the agents 6bit encoded SAI value."},
#else
{23, 23, 0x0000000000000000, "RO", "IMR0_READ_POL_23", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{22, 22, 0x0000000000000000, "RO", "IMR0_READ_POL_22", "Bunit IMR0 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR0 region based on the agents 6bit encoded SAI value."},
#else
{22, 22, 0x0000000000000000, "RO", "IMR0_READ_POL_22", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{21, 21, 0x0000000000000000, "RW", "IMR0_READ_POL_21", "Bunit IMR0 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR0 region based on the agents 6bit encoded SAI value."},
#else
{21, 21, 0x0000000000000000, "RW", "IMR0_READ_POL_21", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{20, 20, 0x0000000000000000, "RO", "IMR0_READ_POL_20", "Bunit IMR0 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR0 region based on the agents 6bit encoded SAI value."},
#else
{20, 20, 0x0000000000000000, "RO", "IMR0_READ_POL_20", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{19, 19, 0x0000000000000000, "RO", "IMR0_READ_POL_19", "Bunit IMR0 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR0 region based on the agents 6bit encoded SAI value."},
#else
{19, 19, 0x0000000000000000, "RO", "IMR0_READ_POL_19", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{18, 18, 0x0000000000000000, "RO", "IMR0_READ_POL_18", "Bunit IMR0 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR0 region based on the agents 6bit encoded SAI value."},
#else
{18, 18, 0x0000000000000000, "RO", "IMR0_READ_POL_18", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{17, 17, 0x0000000000000000, "RW", "IMR0_READ_POL_17", "Bunit IMR0 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR0 region based on the agents 6bit encoded SAI value."},
#else
{17, 17, 0x0000000000000000, "RW", "IMR0_READ_POL_17", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{16, 16, 0x0000000000000000, "RW", "IMR0_READ_POL_16", "Bunit IMR0 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR0 region based on the agents 6bit encoded SAI value."},
#else
{16, 16, 0x0000000000000000, "RW", "IMR0_READ_POL_16", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{15, 15, 0x0000000000000000, "RO", "IMR0_READ_POL_15", "Bunit IMR0 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR0 region based on the agents 6bit encoded SAI value."},
#else
{15, 15, 0x0000000000000000, "RO", "IMR0_READ_POL_15", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{14, 14, 0x0000000000000000, "RO", "IMR0_READ_POL_14", "Bunit IMR0 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR0 region based on the agents 6bit encoded SAI value."},
#else
{14, 14, 0x0000000000000000, "RO", "IMR0_READ_POL_14", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{13, 13, 0x0000000000000000, "RW", "IMR0_READ_POL_13", "Bunit IMR0 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR0 region based on the agents 6bit encoded SAI value."},
#else
{13, 13, 0x0000000000000000, "RW", "IMR0_READ_POL_13", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{12, 12, 0x0000000000000000, "RW", "IMR0_READ_POL_12", "Bunit IMR0 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR0 region based on the agents 6bit encoded SAI value."},
#else
{12, 12, 0x0000000000000000, "RW", "IMR0_READ_POL_12", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{11, 11, 0x0000000000000000, "RO", "IMR0_READ_POL_11", "Bunit IMR0 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR0 region based on the agents 6bit encoded SAI value."},
#else
{11, 11, 0x0000000000000000, "RO", "IMR0_READ_POL_11", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{10, 10, 0x0000000000000000, "RO", "IMR0_READ_POL_10", "Bunit IMR0 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR0 region based on the agents 6bit encoded SAI value."},
#else
{10, 10, 0x0000000000000000, "RO", "IMR0_READ_POL_10", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{9, 9, 0x0000000000000000, "RO", "IMR0_READ_POL_9", "Bunit IMR0 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR0 region based on the agents 6bit encoded SAI value."},
#else
{9, 9, 0x0000000000000000, "RO", "IMR0_READ_POL_9", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{8, 8, 0x0000000000000000, "RW", "IMR0_READ_POL_8", "Bunit IMR0 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR0 region based on the agents 6bit encoded SAI value."},
#else
{8, 8, 0x0000000000000000, "RW", "IMR0_READ_POL_8", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{7, 7, 0x0000000000000000, "RO", "IMR0_READ_POL_7", "Bunit IMR0 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR0 region based on the agents 6bit encoded SAI value."},
#else
{7, 7, 0x0000000000000000, "RO", "IMR0_READ_POL_7", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{6, 6, 0x0000000000000000, "RO", "IMR0_READ_POL_6", "Bunit IMR0 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR0 region based on the agents 6bit encoded SAI value."},
#else
{6, 6, 0x0000000000000000, "RO", "IMR0_READ_POL_6", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{5, 5, 0x0000000000000000, "RW", "IMR0_READ_POL_5", "Bunit IMR0 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR0 region based on the agents 6bit encoded SAI value."},
#else
{5, 5, 0x0000000000000000, "RW", "IMR0_READ_POL_5", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{4, 4, 0x0000000000000000, "RW", "IMR0_READ_POL_4", "Bunit IMR0 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR0 region based on the agents 6bit encoded SAI value."},
#else
{4, 4, 0x0000000000000000, "RW", "IMR0_READ_POL_4", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{3, 3, 0x0000000000000000, "RW", "IMR0_READ_POL_3", "Bunit IMR0 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR0 region based on the agents 6bit encoded SAI value."},
#else
{3, 3, 0x0000000000000000, "RW", "IMR0_READ_POL_3", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{2, 2, 0x0000000000000000, "RW", "IMR0_READ_POL_2", "Bunit IMR0 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR0 region based on the agents 6bit encoded SAI value."},
#else
{2, 2, 0x0000000000000000, "RW", "IMR0_READ_POL_2", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{1, 1, 0x0000000000000000, "RW", "IMR0_READ_POL_1", "Bunit IMR0 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR0 region based on the agents 6bit encoded SAI value."},
#else
{1, 1, 0x0000000000000000, "RW", "IMR0_READ_POL_1", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 0, 0x0000000000000000, "RW", "IMR0_READ_POL_0", "Bunit IMR0 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR0 region based on the agents 6bit encoded SAI value."},
#else
{0, 0, 0x0000000000000000, "RW", "IMR0_READ_POL_0", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo880[] = {{"B_CR_BIMR0RAC_0_0_0_MCHBAR", "", 0x00006880, 64, 0xFFFFFFFFFFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields881[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{63, 63, 0x0000000000000000, "RW", "IMR0_WRITE_POL_63", "Bunit IMR0 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR0 region based on the agents 6bit encoded SAI value."},
#else
{63, 63, 0x0000000000000000, "RW", "IMR0_WRITE_POL_63", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{62, 62, 0x0000000000000000, "RO", "IMR0_WRITE_POL_62", "Bunit IMR0 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR0 region based on the agents 6bit encoded SAI value."},
#else
{62, 62, 0x0000000000000000, "RO", "IMR0_WRITE_POL_62", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{61, 61, 0x0000000000000000, "RO", "IMR0_WRITE_POL_61", "Bunit IMR0 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR0 region based on the agents 6bit encoded SAI value."},
#else
{61, 61, 0x0000000000000000, "RO", "IMR0_WRITE_POL_61", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{60, 60, 0x0000000000000000, "RO", "IMR0_WRITE_POL_60", "Bunit IMR0 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR0 region based on the agents 6bit encoded SAI value."},
#else
{60, 60, 0x0000000000000000, "RO", "IMR0_WRITE_POL_60", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{59, 59, 0x0000000000000000, "RO", "IMR0_WRITE_POL_59", "Bunit IMR0 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR0 region based on the agents 6bit encoded SAI value."},
#else
{59, 59, 0x0000000000000000, "RO", "IMR0_WRITE_POL_59", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{58, 58, 0x0000000000000000, "RO", "IMR0_WRITE_POL_58", "Bunit IMR0 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR0 region based on the agents 6bit encoded SAI value."},
#else
{58, 58, 0x0000000000000000, "RO", "IMR0_WRITE_POL_58", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{57, 57, 0x0000000000000000, "RO", "IMR0_WRITE_POL_57", "Bunit IMR0 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR0 region based on the agents 6bit encoded SAI value."},
#else
{57, 57, 0x0000000000000000, "RO", "IMR0_WRITE_POL_57", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{56, 56, 0x0000000000000000, "RW", "IMR0_WRITE_POL_56", "Bunit IMR0 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR0 region based on the agents 6bit encoded SAI value."},
#else
{56, 56, 0x0000000000000000, "RW", "IMR0_WRITE_POL_56", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{55, 55, 0x0000000000000000, "RW", "IMR0_WRITE_POL_55", "Bunit IMR0 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR0 region based on the agents 6bit encoded SAI value."},
#else
{55, 55, 0x0000000000000000, "RW", "IMR0_WRITE_POL_55", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{54, 54, 0x0000000000000000, "RW", "IMR0_WRITE_POL_54", "Bunit IMR0 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR0 region based on the agents 6bit encoded SAI value."},
#else
{54, 54, 0x0000000000000000, "RW", "IMR0_WRITE_POL_54", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{53, 53, 0x0000000000000000, "RO", "IMR0_WRITE_POL_53", "Bunit IMR0 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR0 region based on the agents 6bit encoded SAI value."},
#else
{53, 53, 0x0000000000000000, "RO", "IMR0_WRITE_POL_53", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{52, 52, 0x0000000000000000, "RO", "IMR0_WRITE_POL_52", "Bunit IMR0 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR0 region based on the agents 6bit encoded SAI value."},
#else
{52, 52, 0x0000000000000000, "RO", "IMR0_WRITE_POL_52", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{51, 51, 0x0000000000000000, "RO", "IMR0_WRITE_POL_51", "Bunit IMR0 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR0 region based on the agents 6bit encoded SAI value."},
#else
{51, 51, 0x0000000000000000, "RO", "IMR0_WRITE_POL_51", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{50, 50, 0x0000000000000000, "RW", "IMR0_WRITE_POL_50", "Bunit IMR0 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR0 region based on the agents 6bit encoded SAI value."},
#else
{50, 50, 0x0000000000000000, "RW", "IMR0_WRITE_POL_50", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{49, 49, 0x0000000000000000, "RW", "IMR0_WRITE_POL_49", "Bunit IMR0 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR0 region based on the agents 6bit encoded SAI value."},
#else
{49, 49, 0x0000000000000000, "RW", "IMR0_WRITE_POL_49", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{48, 48, 0x0000000000000000, "RW", "IMR0_WRITE_POL_48", "Bunit IMR0 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR0 region based on the agents 6bit encoded SAI value."},
#else
{48, 48, 0x0000000000000000, "RW", "IMR0_WRITE_POL_48", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{47, 47, 0x0000000000000000, "RO", "IMR0_WRITE_POL_47", "Bunit IMR0 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR0 region based on the agents 6bit encoded SAI value."},
#else
{47, 47, 0x0000000000000000, "RO", "IMR0_WRITE_POL_47", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{46, 46, 0x0000000000000000, "RO", "IMR0_WRITE_POL_46", "Bunit IMR0 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR0 region based on the agents 6bit encoded SAI value."},
#else
{46, 46, 0x0000000000000000, "RO", "IMR0_WRITE_POL_46", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{45, 45, 0x0000000000000000, "RO", "IMR0_WRITE_POL_45", "Bunit IMR0 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR0 region based on the agents 6bit encoded SAI value."},
#else
{45, 45, 0x0000000000000000, "RO", "IMR0_WRITE_POL_45", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{44, 44, 0x0000000000000000, "RW", "IMR0_WRITE_POL_44", "Bunit IMR0 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR0 region based on the agents 6bit encoded SAI value."},
#else
{44, 44, 0x0000000000000000, "RW", "IMR0_WRITE_POL_44", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{43, 43, 0x0000000000000000, "RW", "IMR0_WRITE_POL_43", "Bunit IMR0 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR0 region based on the agents 6bit encoded SAI value."},
#else
{43, 43, 0x0000000000000000, "RW", "IMR0_WRITE_POL_43", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{42, 42, 0x0000000000000000, "RW", "IMR0_WRITE_POL_42", "Bunit IMR0 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR0 region based on the agents 6bit encoded SAI value."},
#else
{42, 42, 0x0000000000000000, "RW", "IMR0_WRITE_POL_42", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{41, 41, 0x0000000000000000, "RW", "IMR0_WRITE_POL_41", "Bunit IMR0 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR0 region based on the agents 6bit encoded SAI value."},
#else
{41, 41, 0x0000000000000000, "RW", "IMR0_WRITE_POL_41", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{40, 40, 0x0000000000000000, "RW", "IMR0_WRITE_POL_40", "Bunit IMR0 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR0 region based on the agents 6bit encoded SAI value."},
#else
{40, 40, 0x0000000000000000, "RW", "IMR0_WRITE_POL_40", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{39, 39, 0x0000000000000000, "RO", "IMR0_WRITE_POL_39", "Bunit IMR0 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR0 region based on the agents 6bit encoded SAI value."},
#else
{39, 39, 0x0000000000000000, "RO", "IMR0_WRITE_POL_39", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{38, 38, 0x0000000000000000, "RW", "IMR0_WRITE_POL_38", "Bunit IMR0 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR0 region based on the agents 6bit encoded SAI value."},
#else
{38, 38, 0x0000000000000000, "RW", "IMR0_WRITE_POL_38", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{37, 37, 0x0000000000000000, "RO", "IMR0_WRITE_POL_37", "Bunit IMR0 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR0 region based on the agents 6bit encoded SAI value."},
#else
{37, 37, 0x0000000000000000, "RO", "IMR0_WRITE_POL_37", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{36, 36, 0x0000000000000000, "RW", "IMR0_WRITE_POL_36", "Bunit IMR0 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR0 region based on the agents 6bit encoded SAI value."},
#else
{36, 36, 0x0000000000000000, "RW", "IMR0_WRITE_POL_36", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{35, 35, 0x0000000000000000, "RO", "IMR0_WRITE_POL_35", "Bunit IMR0 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR0 region based on the agents 6bit encoded SAI value."},
#else
{35, 35, 0x0000000000000000, "RO", "IMR0_WRITE_POL_35", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{34, 34, 0x0000000000000000, "RW", "IMR0_WRITE_POL_34", "Bunit IMR0 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR0 region based on the agents 6bit encoded SAI value."},
#else
{34, 34, 0x0000000000000000, "RW", "IMR0_WRITE_POL_34", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{33, 33, 0x0000000000000000, "RW", "IMR0_WRITE_POL_33", "Bunit IMR0 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR0 region based on the agents 6bit encoded SAI value."},
#else
{33, 33, 0x0000000000000000, "RW", "IMR0_WRITE_POL_33", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{32, 32, 0x0000000000000000, "RW", "IMR0_WRITE_POL_32", "Bunit IMR0 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR0 region based on the agents 6bit encoded SAI value."},
#else
{32, 32, 0x0000000000000000, "RW", "IMR0_WRITE_POL_32", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{31, 31, 0x0000000000000000, "RO", "IMR0_WRITE_POL_31", "Bunit IMR0 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR0 region based on the agents 6bit encoded SAI value."},
#else
{31, 31, 0x0000000000000000, "RO", "IMR0_WRITE_POL_31", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{30, 30, 0x0000000000000000, "RW", "IMR0_WRITE_POL_30", "Bunit IMR0 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR0 region based on the agents 6bit encoded SAI value."},
#else
{30, 30, 0x0000000000000000, "RW", "IMR0_WRITE_POL_30", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{29, 29, 0x0000000000000000, "RW", "IMR0_WRITE_POL_29", "Bunit IMR0 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR0 region based on the agents 6bit encoded SAI value."},
#else
{29, 29, 0x0000000000000000, "RW", "IMR0_WRITE_POL_29", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{28, 28, 0x0000000000000000, "RW", "IMR0_WRITE_POL_28", "Bunit IMR0 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR0 region based on the agents 6bit encoded SAI value."},
#else
{28, 28, 0x0000000000000000, "RW", "IMR0_WRITE_POL_28", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{27, 27, 0x0000000000000000, "RW", "IMR0_WRITE_POL_27", "Bunit IMR0 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR0 region based on the agents 6bit encoded SAI value."},
#else
{27, 27, 0x0000000000000000, "RW", "IMR0_WRITE_POL_27", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{26, 26, 0x0000000000000000, "RW", "IMR0_WRITE_POL_26", "Bunit IMR0 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR0 region based on the agents 6bit encoded SAI value."},
#else
{26, 26, 0x0000000000000000, "RW", "IMR0_WRITE_POL_26", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{25, 25, 0x0000000000000000, "RW", "IMR0_WRITE_POL_25", "Bunit IMR0 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR0 region based on the agents 6bit encoded SAI value."},
#else
{25, 25, 0x0000000000000000, "RW", "IMR0_WRITE_POL_25", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{24, 24, 0x0000000000000000, "RW", "IMR0_WRITE_POL_24", "Bunit IMR0 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR0 region based on the agents 6bit encoded SAI value."},
#else
{24, 24, 0x0000000000000000, "RW", "IMR0_WRITE_POL_24", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{23, 23, 0x0000000000000000, "RO", "IMR0_WRITE_POL_23", "Bunit IMR0 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR0 region based on the agents 6bit encoded SAI value."},
#else
{23, 23, 0x0000000000000000, "RO", "IMR0_WRITE_POL_23", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{22, 22, 0x0000000000000000, "RO", "IMR0_WRITE_POL_22", "Bunit IMR0 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR0 region based on the agents 6bit encoded SAI value."},
#else
{22, 22, 0x0000000000000000, "RO", "IMR0_WRITE_POL_22", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{21, 21, 0x0000000000000000, "RW", "IMR0_WRITE_POL_21", "Bunit IMR0 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR0 region based on the agents 6bit encoded SAI value."},
#else
{21, 21, 0x0000000000000000, "RW", "IMR0_WRITE_POL_21", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{20, 20, 0x0000000000000000, "RO", "IMR0_WRITE_POL_20", "Bunit IMR0 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR0 region based on the agents 6bit encoded SAI value."},
#else
{20, 20, 0x0000000000000000, "RO", "IMR0_WRITE_POL_20", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{19, 19, 0x0000000000000000, "RO", "IMR0_WRITE_POL_19", "Bunit IMR0 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR0 region based on the agents 6bit encoded SAI value."},
#else
{19, 19, 0x0000000000000000, "RO", "IMR0_WRITE_POL_19", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{18, 18, 0x0000000000000000, "RO", "IMR0_WRITE_POL_18", "Bunit IMR0 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR0 region based on the agents 6bit encoded SAI value."},
#else
{18, 18, 0x0000000000000000, "RO", "IMR0_WRITE_POL_18", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{17, 17, 0x0000000000000000, "RW", "IMR0_WRITE_POL_17", "Bunit IMR0 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR0 region based on the agents 6bit encoded SAI value."},
#else
{17, 17, 0x0000000000000000, "RW", "IMR0_WRITE_POL_17", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{16, 16, 0x0000000000000000, "RW", "IMR0_WRITE_POL_16", "Bunit IMR0 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR0 region based on the agents 6bit encoded SAI value."},
#else
{16, 16, 0x0000000000000000, "RW", "IMR0_WRITE_POL_16", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{15, 15, 0x0000000000000000, "RO", "IMR0_WRITE_POL_15", "Bunit IMR0 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR0 region based on the agents 6bit encoded SAI value."},
#else
{15, 15, 0x0000000000000000, "RO", "IMR0_WRITE_POL_15", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{14, 14, 0x0000000000000000, "RO", "IMR0_WRITE_POL_14", "Bunit IMR0 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR0 region based on the agents 6bit encoded SAI value."},
#else
{14, 14, 0x0000000000000000, "RO", "IMR0_WRITE_POL_14", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{13, 13, 0x0000000000000000, "RW", "IMR0_WRITE_POL_13", "Bunit IMR0 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR0 region based on the agents 6bit encoded SAI value."},
#else
{13, 13, 0x0000000000000000, "RW", "IMR0_WRITE_POL_13", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{12, 12, 0x0000000000000000, "RW", "IMR0_WRITE_POL_12", "Bunit IMR0 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR0 region based on the agents 6bit encoded SAI value."},
#else
{12, 12, 0x0000000000000000, "RW", "IMR0_WRITE_POL_12", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{11, 11, 0x0000000000000000, "RO", "IMR0_WRITE_POL_11", "Bunit IMR0 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR0 region based on the agents 6bit encoded SAI value."},
#else
{11, 11, 0x0000000000000000, "RO", "IMR0_WRITE_POL_11", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{10, 10, 0x0000000000000000, "RO", "IMR0_WRITE_POL_10", "Bunit IMR0 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR0 region based on the agents 6bit encoded SAI value."},
#else
{10, 10, 0x0000000000000000, "RO", "IMR0_WRITE_POL_10", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{9, 9, 0x0000000000000000, "RO", "IMR0_WRITE_POL_9", "Bunit IMR0 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR0 region based on the agents 6bit encoded SAI value."},
#else
{9, 9, 0x0000000000000000, "RO", "IMR0_WRITE_POL_9", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{8, 8, 0x0000000000000000, "RW", "IMR0_WRITE_POL_8", "Bunit IMR0 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR0 region based on the agents 6bit encoded SAI value."},
#else
{8, 8, 0x0000000000000000, "RW", "IMR0_WRITE_POL_8", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{7, 7, 0x0000000000000000, "RO", "IMR0_WRITE_POL_7", "Bunit IMR0 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR0 region based on the agents 6bit encoded SAI value."},
#else
{7, 7, 0x0000000000000000, "RO", "IMR0_WRITE_POL_7", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{6, 6, 0x0000000000000000, "RO", "IMR0_WRITE_POL_6", "Bunit IMR0 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR0 region based on the agents 6bit encoded SAI value."},
#else
{6, 6, 0x0000000000000000, "RO", "IMR0_WRITE_POL_6", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{5, 5, 0x0000000000000000, "RW", "IMR0_WRITE_POL_5", "Bunit IMR0 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR0 region based on the agents 6bit encoded SAI value."},
#else
{5, 5, 0x0000000000000000, "RW", "IMR0_WRITE_POL_5", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{4, 4, 0x0000000000000000, "RW", "IMR0_WRITE_POL_4", "Bunit IMR0 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR0 region based on the agents 6bit encoded SAI value."},
#else
{4, 4, 0x0000000000000000, "RW", "IMR0_WRITE_POL_4", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{3, 3, 0x0000000000000000, "RW", "IMR0_WRITE_POL_3", "Bunit IMR0 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR0 region based on the agents 6bit encoded SAI value."},
#else
{3, 3, 0x0000000000000000, "RW", "IMR0_WRITE_POL_3", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{2, 2, 0x0000000000000000, "RW", "IMR0_WRITE_POL_2", "Bunit IMR0 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR0 region based on the agents 6bit encoded SAI value."},
#else
{2, 2, 0x0000000000000000, "RW", "IMR0_WRITE_POL_2", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{1, 1, 0x0000000000000000, "RW", "IMR0_WRITE_POL_1", "Bunit IMR0 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR0 region based on the agents 6bit encoded SAI value."},
#else
{1, 1, 0x0000000000000000, "RW", "IMR0_WRITE_POL_1", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 0, 0x0000000000000000, "RW", "IMR0_WRITE_POL_0", "Bunit IMR0 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR0 region based on the agents 6bit encoded SAI value."},
#else
{0, 0, 0x0000000000000000, "RW", "IMR0_WRITE_POL_0", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo881[] = {{"B_CR_BIMR0WAC_0_0_0_MCHBAR", "", 0x00006888, 64, 0xFFFFFFFFFFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields882[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{31, 31, 0x0000000000000000, "RW", "IMR_EN", "IMR Enable: Enables access checking for the IMR region."},
#else
{31, 31, 0x0000000000000000, "RW", "IMR_EN", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{30, 30, 0x0000000000000000, "RW", "TR_EN", "Asset Classification AC[0]: Trace Enable: Enables snooping of transactions to the IMR region by tracing agents."},
#else
{30, 30, 0x0000000000000000, "RW", "TR_EN", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{29, 29, 0x0000000000000000, "RO", "RESERVED_1", "Reserved"},
#else
{29, 29, 0x0000000000000000, "RO", "RESERVED_1", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 28, 0x0000000000000000, "RW", "IMR1_BASE", "Base 1 IMR1BASE:  Specifies bits 38:10 of the start address of IMR1 region.  IMR region size must be a strict poweroftwo at least 1KB and naturally aligned to the size.  These bits are compared with the result of the IMR1MASK[28:0] applied to bits 38:10 of the incoming address to determine if an access falls within the IMR1 defined region."},
#else
{0, 28, 0x0000000000000000, "RW", "IMR1_BASE", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo882[] = {{"B_CR_BIMR1BASE_0_0_0_MCHBAR", "", 0x00006890, 4, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields883[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{31, 31, 0x0000000000000000, "RW", "GT_IWB_EN", "Asset Classification AC[2]: GT Implicit WB Enable: Enables implicit writebacks to protected region from GT caching agent. When set to 1 enables implicit writeback data HITM data from GT to be returned to the requester.  When set to 0 inhibits HITM data from GT from being returned to the requester.  HITM data from IA cores may be returned to the requester depending on the setting of the IA_IWB_EN bit."},
#else
{31, 31, 0x0000000000000000, "RW", "GT_IWB_EN", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{30, 30, 0x0000000000000000, "RW", "IA_IWB_EN", "Asset Classification AC[1]: IA Implicit WB Enable: Enables implicit writebacks to protected region from IA caching agent.  When set to 1 enables implicit writeback data HITM data from IA cores to be returned to the requester.  When set to 0 inhibits HITM data from IA cores from being returned to the requester.  HITM data from GT may be returned to the requester depending on the setting of the GT_IWB_EN bit."},
#else
{30, 30, 0x0000000000000000, "RW", "IA_IWB_EN", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{29, 29, 0x0000000000000000, "RO", "RESERVED_0", "Reserved"},
#else
{29, 29, 0x0000000000000000, "RO", "RESERVED_0", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 28, 0x0000000000000000, "RW", "IMR1_MASK", "Mask 1 IMR1MASK:  These bits are ANDed with bits 38:10 of the incoming address to determine if the combined result matches the IMR1BASE[28:0] value.  A match indicates the the incoming address falls within the IMR1 region."},
#else
{0, 28, 0x0000000000000000, "RW", "IMR1_MASK", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo883[] = {{"B_CR_BIMR1MASK_0_0_0_MCHBAR", "", 0x00006894, 4, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields884[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{0, 63, 0x00000C0061010202, "RW", "IMR1_CTRL_POL", "Bunit IMR1 Control Policy: Bit vector used to determine which agents are allowed access to the BIMR1RAC, BIMR1WAC, BIMR1CP registers based on the value from the agents 6bit SAI field."},
#else
{0, 63, 0x00000C0061010202, "RW", "IMR1_CTRL_POL", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo884[] = {{"B_CR_BIMR1CP_0_0_0_MCHBAR", "", 0x00006898, 1, 0xFFFFFFFFFFFFFFFF, 0x00000C0061010202}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields885[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{63, 63, 0x0000000000000000, "RW", "IMR1_READ_POL_63", "Bunit IMR1 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR1 region based on the agents 6bit encoded SAI value."},
#else
{63, 63, 0x0000000000000000, "RW", "IMR1_READ_POL_63", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{62, 62, 0x0000000000000000, "RO", "IMR1_READ_POL_62", "Bunit IMR1 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR1 region based on the agents 6bit encoded SAI value."},
#else
{62, 62, 0x0000000000000000, "RO", "IMR1_READ_POL_62", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{61, 61, 0x0000000000000000, "RO", "IMR1_READ_POL_61", "Bunit IMR1 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR1 region based on the agents 6bit encoded SAI value."},
#else
{61, 61, 0x0000000000000000, "RO", "IMR1_READ_POL_61", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{60, 60, 0x0000000000000000, "RO", "IMR1_READ_POL_60", "Bunit IMR1 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR1 region based on the agents 6bit encoded SAI value."},
#else
{60, 60, 0x0000000000000000, "RO", "IMR1_READ_POL_60", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{59, 59, 0x0000000000000000, "RO", "IMR1_READ_POL_59", "Bunit IMR1 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR1 region based on the agents 6bit encoded SAI value."},
#else
{59, 59, 0x0000000000000000, "RO", "IMR1_READ_POL_59", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{58, 58, 0x0000000000000000, "RO", "IMR1_READ_POL_58", "Bunit IMR1 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR1 region based on the agents 6bit encoded SAI value."},
#else
{58, 58, 0x0000000000000000, "RO", "IMR1_READ_POL_58", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{57, 57, 0x0000000000000000, "RO", "IMR1_READ_POL_57", "Bunit IMR1 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR1 region based on the agents 6bit encoded SAI value."},
#else
{57, 57, 0x0000000000000000, "RO", "IMR1_READ_POL_57", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{56, 56, 0x0000000000000000, "RW", "IMR1_READ_POL_56", "Bunit IMR1 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR1 region based on the agents 6bit encoded SAI value."},
#else
{56, 56, 0x0000000000000000, "RW", "IMR1_READ_POL_56", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{55, 55, 0x0000000000000000, "RW", "IMR1_READ_POL_55", "Bunit IMR1 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR1 region based on the agents 6bit encoded SAI value."},
#else
{55, 55, 0x0000000000000000, "RW", "IMR1_READ_POL_55", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{54, 54, 0x0000000000000000, "RW", "IMR1_READ_POL_54", "Bunit IMR1 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR1 region based on the agents 6bit encoded SAI value."},
#else
{54, 54, 0x0000000000000000, "RW", "IMR1_READ_POL_54", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{53, 53, 0x0000000000000000, "RO", "IMR1_READ_POL_53", "Bunit IMR1 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR1 region based on the agents 6bit encoded SAI value."},
#else
{53, 53, 0x0000000000000000, "RO", "IMR1_READ_POL_53", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{52, 52, 0x0000000000000000, "RO", "IMR1_READ_POL_52", "Bunit IMR1 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR1 region based on the agents 6bit encoded SAI value."},
#else
{52, 52, 0x0000000000000000, "RO", "IMR1_READ_POL_52", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{51, 51, 0x0000000000000000, "RO", "IMR1_READ_POL_51", "Bunit IMR1 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR1 region based on the agents 6bit encoded SAI value."},
#else
{51, 51, 0x0000000000000000, "RO", "IMR1_READ_POL_51", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{50, 50, 0x0000000000000000, "RW", "IMR1_READ_POL_50", "Bunit IMR1 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR1 region based on the agents 6bit encoded SAI value."},
#else
{50, 50, 0x0000000000000000, "RW", "IMR1_READ_POL_50", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{49, 49, 0x0000000000000000, "RW", "IMR1_READ_POL_49", "Bunit IMR1 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR1 region based on the agents 6bit encoded SAI value."},
#else
{49, 49, 0x0000000000000000, "RW", "IMR1_READ_POL_49", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{48, 48, 0x0000000000000000, "RW", "IMR1_READ_POL_48", "Bunit IMR1 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR1 region based on the agents 6bit encoded SAI value."},
#else
{48, 48, 0x0000000000000000, "RW", "IMR1_READ_POL_48", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{47, 47, 0x0000000000000000, "RO", "IMR1_READ_POL_47", "Bunit IMR1 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR1 region based on the agents 6bit encoded SAI value."},
#else
{47, 47, 0x0000000000000000, "RO", "IMR1_READ_POL_47", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{46, 46, 0x0000000000000000, "RO", "IMR1_READ_POL_46", "Bunit IMR1 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR1 region based on the agents 6bit encoded SAI value."},
#else
{46, 46, 0x0000000000000000, "RO", "IMR1_READ_POL_46", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{45, 45, 0x0000000000000000, "RO", "IMR1_READ_POL_45", "Bunit IMR1 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR1 region based on the agents 6bit encoded SAI value."},
#else
{45, 45, 0x0000000000000000, "RO", "IMR1_READ_POL_45", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{44, 44, 0x0000000000000000, "RW", "IMR1_READ_POL_44", "Bunit IMR1 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR1 region based on the agents 6bit encoded SAI value."},
#else
{44, 44, 0x0000000000000000, "RW", "IMR1_READ_POL_44", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{43, 43, 0x0000000000000000, "RW", "IMR1_READ_POL_43", "Bunit IMR1 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR1 region based on the agents 6bit encoded SAI value."},
#else
{43, 43, 0x0000000000000000, "RW", "IMR1_READ_POL_43", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{42, 42, 0x0000000000000000, "RW", "IMR1_READ_POL_42", "Bunit IMR1 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR1 region based on the agents 6bit encoded SAI value."},
#else
{42, 42, 0x0000000000000000, "RW", "IMR1_READ_POL_42", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{41, 41, 0x0000000000000000, "RW", "IMR1_READ_POL_41", "Bunit IMR1 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR1 region based on the agents 6bit encoded SAI value."},
#else
{41, 41, 0x0000000000000000, "RW", "IMR1_READ_POL_41", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{40, 40, 0x0000000000000000, "RW", "IMR1_READ_POL_40", "Bunit IMR1 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR1 region based on the agents 6bit encoded SAI value."},
#else
{40, 40, 0x0000000000000000, "RW", "IMR1_READ_POL_40", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{39, 39, 0x0000000000000000, "RO", "IMR1_READ_POL_39", "Bunit IMR1 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR1 region based on the agents 6bit encoded SAI value."},
#else
{39, 39, 0x0000000000000000, "RO", "IMR1_READ_POL_39", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{38, 38, 0x0000000000000000, "RW", "IMR1_READ_POL_38", "Bunit IMR1 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR1 region based on the agents 6bit encoded SAI value."},
#else
{38, 38, 0x0000000000000000, "RW", "IMR1_READ_POL_38", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{37, 37, 0x0000000000000000, "RO", "IMR1_READ_POL_37", "Bunit IMR1 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR1 region based on the agents 6bit encoded SAI value."},
#else
{37, 37, 0x0000000000000000, "RO", "IMR1_READ_POL_37", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{36, 36, 0x0000000000000000, "RW", "IMR1_READ_POL_36", "Bunit IMR1 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR1 region based on the agents 6bit encoded SAI value."},
#else
{36, 36, 0x0000000000000000, "RW", "IMR1_READ_POL_36", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{35, 35, 0x0000000000000000, "RO", "IMR1_READ_POL_35", "Bunit IMR1 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR1 region based on the agents 6bit encoded SAI value."},
#else
{35, 35, 0x0000000000000000, "RO", "IMR1_READ_POL_35", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{34, 34, 0x0000000000000000, "RW", "IMR1_READ_POL_34", "Bunit IMR1 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR1 region based on the agents 6bit encoded SAI value."},
#else
{34, 34, 0x0000000000000000, "RW", "IMR1_READ_POL_34", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{33, 33, 0x0000000000000000, "RW", "IMR1_READ_POL_33", "Bunit IMR1 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR1 region based on the agents 6bit encoded SAI value."},
#else
{33, 33, 0x0000000000000000, "RW", "IMR1_READ_POL_33", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{32, 32, 0x0000000000000000, "RW", "IMR1_READ_POL_32", "Bunit IMR1 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR1 region based on the agents 6bit encoded SAI value."},
#else
{32, 32, 0x0000000000000000, "RW", "IMR1_READ_POL_32", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{31, 31, 0x0000000000000000, "RO", "IMR1_READ_POL_31", "Bunit IMR1 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR1 region based on the agents 6bit encoded SAI value."},
#else
{31, 31, 0x0000000000000000, "RO", "IMR1_READ_POL_31", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{30, 30, 0x0000000000000000, "RW", "IMR1_READ_POL_30", "Bunit IMR1 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR1 region based on the agents 6bit encoded SAI value."},
#else
{30, 30, 0x0000000000000000, "RW", "IMR1_READ_POL_30", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{29, 29, 0x0000000000000000, "RW", "IMR1_READ_POL_29", "Bunit IMR1 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR1 region based on the agents 6bit encoded SAI value."},
#else
{29, 29, 0x0000000000000000, "RW", "IMR1_READ_POL_29", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{28, 28, 0x0000000000000000, "RW", "IMR1_READ_POL_28", "Bunit IMR1 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR1 region based on the agents 6bit encoded SAI value."},
#else
{28, 28, 0x0000000000000000, "RW", "IMR1_READ_POL_28", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{27, 27, 0x0000000000000000, "RW", "IMR1_READ_POL_27", "Bunit IMR1 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR1 region based on the agents 6bit encoded SAI value."},
#else
{27, 27, 0x0000000000000000, "RW", "IMR1_READ_POL_27", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{26, 26, 0x0000000000000000, "RW", "IMR1_READ_POL_26", "Bunit IMR1 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR1 region based on the agents 6bit encoded SAI value."},
#else
{26, 26, 0x0000000000000000, "RW", "IMR1_READ_POL_26", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{25, 25, 0x0000000000000000, "RW", "IMR1_READ_POL_25", "Bunit IMR1 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR1 region based on the agents 6bit encoded SAI value."},
#else
{25, 25, 0x0000000000000000, "RW", "IMR1_READ_POL_25", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{24, 24, 0x0000000000000000, "RW", "IMR1_READ_POL_24", "Bunit IMR1 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR1 region based on the agents 6bit encoded SAI value."},
#else
{24, 24, 0x0000000000000000, "RW", "IMR1_READ_POL_24", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{23, 23, 0x0000000000000000, "RO", "IMR1_READ_POL_23", "Bunit IMR1 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR1 region based on the agents 6bit encoded SAI value."},
#else
{23, 23, 0x0000000000000000, "RO", "IMR1_READ_POL_23", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{22, 22, 0x0000000000000000, "RO", "IMR1_READ_POL_22", "Bunit IMR1 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR1 region based on the agents 6bit encoded SAI value."},
#else
{22, 22, 0x0000000000000000, "RO", "IMR1_READ_POL_22", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{21, 21, 0x0000000000000000, "RW", "IMR1_READ_POL_21", "Bunit IMR1 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR1 region based on the agents 6bit encoded SAI value."},
#else
{21, 21, 0x0000000000000000, "RW", "IMR1_READ_POL_21", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{20, 20, 0x0000000000000000, "RO", "IMR1_READ_POL_20", "Bunit IMR1 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR1 region based on the agents 6bit encoded SAI value."},
#else
{20, 20, 0x0000000000000000, "RO", "IMR1_READ_POL_20", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{19, 19, 0x0000000000000000, "RO", "IMR1_READ_POL_19", "Bunit IMR1 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR1 region based on the agents 6bit encoded SAI value."},
#else
{19, 19, 0x0000000000000000, "RO", "IMR1_READ_POL_19", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{18, 18, 0x0000000000000000, "RO", "IMR1_READ_POL_18", "Bunit IMR1 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR1 region based on the agents 6bit encoded SAI value."},
#else
{18, 18, 0x0000000000000000, "RO", "IMR1_READ_POL_18", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{17, 17, 0x0000000000000000, "RW", "IMR1_READ_POL_17", "Bunit IMR1 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR1 region based on the agents 6bit encoded SAI value."},
#else
{17, 17, 0x0000000000000000, "RW", "IMR1_READ_POL_17", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{16, 16, 0x0000000000000000, "RW", "IMR1_READ_POL_16", "Bunit IMR1 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR1 region based on the agents 6bit encoded SAI value."},
#else
{16, 16, 0x0000000000000000, "RW", "IMR1_READ_POL_16", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{15, 15, 0x0000000000000000, "RO", "IMR1_READ_POL_15", "Bunit IMR1 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR1 region based on the agents 6bit encoded SAI value."},
#else
{15, 15, 0x0000000000000000, "RO", "IMR1_READ_POL_15", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{14, 14, 0x0000000000000000, "RO", "IMR1_READ_POL_14", "Bunit IMR1 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR1 region based on the agents 6bit encoded SAI value."},
#else
{14, 14, 0x0000000000000000, "RO", "IMR1_READ_POL_14", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{13, 13, 0x0000000000000000, "RW", "IMR1_READ_POL_13", "Bunit IMR1 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR1 region based on the agents 6bit encoded SAI value."},
#else
{13, 13, 0x0000000000000000, "RW", "IMR1_READ_POL_13", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{12, 12, 0x0000000000000000, "RW", "IMR1_READ_POL_12", "Bunit IMR1 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR1 region based on the agents 6bit encoded SAI value."},
#else
{12, 12, 0x0000000000000000, "RW", "IMR1_READ_POL_12", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{11, 11, 0x0000000000000000, "RO", "IMR1_READ_POL_11", "Bunit IMR1 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR1 region based on the agents 6bit encoded SAI value."},
#else
{11, 11, 0x0000000000000000, "RO", "IMR1_READ_POL_11", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{10, 10, 0x0000000000000000, "RO", "IMR1_READ_POL_10", "Bunit IMR1 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR1 region based on the agents 6bit encoded SAI value."},
#else
{10, 10, 0x0000000000000000, "RO", "IMR1_READ_POL_10", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{9, 9, 0x0000000000000000, "RO", "IMR1_READ_POL_9", "Bunit IMR1 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR1 region based on the agents 6bit encoded SAI value."},
#else
{9, 9, 0x0000000000000000, "RO", "IMR1_READ_POL_9", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{8, 8, 0x0000000000000000, "RW", "IMR1_READ_POL_8", "Bunit IMR1 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR1 region based on the agents 6bit encoded SAI value."},
#else
{8, 8, 0x0000000000000000, "RW", "IMR1_READ_POL_8", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{7, 7, 0x0000000000000000, "RO", "IMR1_READ_POL_7", "Bunit IMR1 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR1 region based on the agents 6bit encoded SAI value."},
#else
{7, 7, 0x0000000000000000, "RO", "IMR1_READ_POL_7", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{6, 6, 0x0000000000000000, "RO", "IMR1_READ_POL_6", "Bunit IMR1 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR1 region based on the agents 6bit encoded SAI value."},
#else
{6, 6, 0x0000000000000000, "RO", "IMR1_READ_POL_6", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{5, 5, 0x0000000000000000, "RW", "IMR1_READ_POL_5", "Bunit IMR1 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR1 region based on the agents 6bit encoded SAI value."},
#else
{5, 5, 0x0000000000000000, "RW", "IMR1_READ_POL_5", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{4, 4, 0x0000000000000000, "RW", "IMR1_READ_POL_4", "Bunit IMR1 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR1 region based on the agents 6bit encoded SAI value."},
#else
{4, 4, 0x0000000000000000, "RW", "IMR1_READ_POL_4", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{3, 3, 0x0000000000000000, "RW", "IMR1_READ_POL_3", "Bunit IMR1 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR1 region based on the agents 6bit encoded SAI value."},
#else
{3, 3, 0x0000000000000000, "RW", "IMR1_READ_POL_3", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{2, 2, 0x0000000000000000, "RW", "IMR1_READ_POL_2", "Bunit IMR1 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR1 region based on the agents 6bit encoded SAI value."},
#else
{2, 2, 0x0000000000000000, "RW", "IMR1_READ_POL_2", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{1, 1, 0x0000000000000000, "RW", "IMR1_READ_POL_1", "Bunit IMR1 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR1 region based on the agents 6bit encoded SAI value."},
#else
{1, 1, 0x0000000000000000, "RW", "IMR1_READ_POL_1", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 0, 0x0000000000000000, "RW", "IMR1_READ_POL_0", "Bunit IMR1 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR1 region based on the agents 6bit encoded SAI value."},
#else
{0, 0, 0x0000000000000000, "RW", "IMR1_READ_POL_0", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo885[] = {{"B_CR_BIMR1RAC_0_0_0_MCHBAR", "", 0x000068A0, 64, 0xFFFFFFFFFFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields886[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{63, 63, 0x0000000000000000, "RW", "IMR1_WRITE_POL_63", "Bunit IMR1 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR1 region based on the agents 6bit encoded SAI value."},
#else
{63, 63, 0x0000000000000000, "RW", "IMR1_WRITE_POL_63", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{62, 62, 0x0000000000000000, "RO", "IMR1_WRITE_POL_62", "Bunit IMR1 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR1 region based on the agents 6bit encoded SAI value."},
#else
{62, 62, 0x0000000000000000, "RO", "IMR1_WRITE_POL_62", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{61, 61, 0x0000000000000000, "RO", "IMR1_WRITE_POL_61", "Bunit IMR1 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR1 region based on the agents 6bit encoded SAI value."},
#else
{61, 61, 0x0000000000000000, "RO", "IMR1_WRITE_POL_61", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{60, 60, 0x0000000000000000, "RO", "IMR1_WRITE_POL_60", "Bunit IMR1 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR1 region based on the agents 6bit encoded SAI value."},
#else
{60, 60, 0x0000000000000000, "RO", "IMR1_WRITE_POL_60", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{59, 59, 0x0000000000000000, "RO", "IMR1_WRITE_POL_59", "Bunit IMR1 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR1 region based on the agents 6bit encoded SAI value."},
#else
{59, 59, 0x0000000000000000, "RO", "IMR1_WRITE_POL_59", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{58, 58, 0x0000000000000000, "RO", "IMR1_WRITE_POL_58", "Bunit IMR1 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR1 region based on the agents 6bit encoded SAI value."},
#else
{58, 58, 0x0000000000000000, "RO", "IMR1_WRITE_POL_58", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{57, 57, 0x0000000000000000, "RO", "IMR1_WRITE_POL_57", "Bunit IMR1 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR1 region based on the agents 6bit encoded SAI value."},
#else
{57, 57, 0x0000000000000000, "RO", "IMR1_WRITE_POL_57", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{56, 56, 0x0000000000000000, "RW", "IMR1_WRITE_POL_56", "Bunit IMR1 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR1 region based on the agents 6bit encoded SAI value."},
#else
{56, 56, 0x0000000000000000, "RW", "IMR1_WRITE_POL_56", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{55, 55, 0x0000000000000000, "RW", "IMR1_WRITE_POL_55", "Bunit IMR1 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR1 region based on the agents 6bit encoded SAI value."},
#else
{55, 55, 0x0000000000000000, "RW", "IMR1_WRITE_POL_55", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{54, 54, 0x0000000000000000, "RW", "IMR1_WRITE_POL_54", "Bunit IMR1 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR1 region based on the agents 6bit encoded SAI value."},
#else
{54, 54, 0x0000000000000000, "RW", "IMR1_WRITE_POL_54", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{53, 53, 0x0000000000000000, "RO", "IMR1_WRITE_POL_53", "Bunit IMR1 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR1 region based on the agents 6bit encoded SAI value."},
#else
{53, 53, 0x0000000000000000, "RO", "IMR1_WRITE_POL_53", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{52, 52, 0x0000000000000000, "RO", "IMR1_WRITE_POL_52", "Bunit IMR1 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR1 region based on the agents 6bit encoded SAI value."},
#else
{52, 52, 0x0000000000000000, "RO", "IMR1_WRITE_POL_52", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{51, 51, 0x0000000000000000, "RO", "IMR1_WRITE_POL_51", "Bunit IMR1 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR1 region based on the agents 6bit encoded SAI value."},
#else
{51, 51, 0x0000000000000000, "RO", "IMR1_WRITE_POL_51", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{50, 50, 0x0000000000000000, "RW", "IMR1_WRITE_POL_50", "Bunit IMR1 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR1 region based on the agents 6bit encoded SAI value."},
#else
{50, 50, 0x0000000000000000, "RW", "IMR1_WRITE_POL_50", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{49, 49, 0x0000000000000000, "RW", "IMR1_WRITE_POL_49", "Bunit IMR1 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR1 region based on the agents 6bit encoded SAI value."},
#else
{49, 49, 0x0000000000000000, "RW", "IMR1_WRITE_POL_49", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{48, 48, 0x0000000000000000, "RW", "IMR1_WRITE_POL_48", "Bunit IMR1 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR1 region based on the agents 6bit encoded SAI value."},
#else
{48, 48, 0x0000000000000000, "RW", "IMR1_WRITE_POL_48", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{47, 47, 0x0000000000000000, "RO", "IMR1_WRITE_POL_47", "Bunit IMR1 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR1 region based on the agents 6bit encoded SAI value."},
#else
{47, 47, 0x0000000000000000, "RO", "IMR1_WRITE_POL_47", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{46, 46, 0x0000000000000000, "RO", "IMR1_WRITE_POL_46", "Bunit IMR1 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR1 region based on the agents 6bit encoded SAI value."},
#else
{46, 46, 0x0000000000000000, "RO", "IMR1_WRITE_POL_46", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{45, 45, 0x0000000000000000, "RO", "IMR1_WRITE_POL_45", "Bunit IMR1 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR1 region based on the agents 6bit encoded SAI value."},
#else
{45, 45, 0x0000000000000000, "RO", "IMR1_WRITE_POL_45", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{44, 44, 0x0000000000000000, "RW", "IMR1_WRITE_POL_44", "Bunit IMR1 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR1 region based on the agents 6bit encoded SAI value."},
#else
{44, 44, 0x0000000000000000, "RW", "IMR1_WRITE_POL_44", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{43, 43, 0x0000000000000000, "RW", "IMR1_WRITE_POL_43", "Bunit IMR1 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR1 region based on the agents 6bit encoded SAI value."},
#else
{43, 43, 0x0000000000000000, "RW", "IMR1_WRITE_POL_43", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{42, 42, 0x0000000000000000, "RW", "IMR1_WRITE_POL_42", "Bunit IMR1 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR1 region based on the agents 6bit encoded SAI value."},
#else
{42, 42, 0x0000000000000000, "RW", "IMR1_WRITE_POL_42", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{41, 41, 0x0000000000000000, "RW", "IMR1_WRITE_POL_41", "Bunit IMR1 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR1 region based on the agents 6bit encoded SAI value."},
#else
{41, 41, 0x0000000000000000, "RW", "IMR1_WRITE_POL_41", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{40, 40, 0x0000000000000000, "RW", "IMR1_WRITE_POL_40", "Bunit IMR1 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR1 region based on the agents 6bit encoded SAI value."},
#else
{40, 40, 0x0000000000000000, "RW", "IMR1_WRITE_POL_40", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{39, 39, 0x0000000000000000, "RO", "IMR1_WRITE_POL_39", "Bunit IMR1 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR1 region based on the agents 6bit encoded SAI value."},
#else
{39, 39, 0x0000000000000000, "RO", "IMR1_WRITE_POL_39", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{38, 38, 0x0000000000000000, "RW", "IMR1_WRITE_POL_38", "Bunit IMR1 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR1 region based on the agents 6bit encoded SAI value."},
#else
{38, 38, 0x0000000000000000, "RW", "IMR1_WRITE_POL_38", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{37, 37, 0x0000000000000000, "RO", "IMR1_WRITE_POL_37", "Bunit IMR1 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR1 region based on the agents 6bit encoded SAI value."},
#else
{37, 37, 0x0000000000000000, "RO", "IMR1_WRITE_POL_37", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{36, 36, 0x0000000000000000, "RW", "IMR1_WRITE_POL_36", "Bunit IMR1 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR1 region based on the agents 6bit encoded SAI value."},
#else
{36, 36, 0x0000000000000000, "RW", "IMR1_WRITE_POL_36", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{35, 35, 0x0000000000000000, "RO", "IMR1_WRITE_POL_35", "Bunit IMR1 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR1 region based on the agents 6bit encoded SAI value."},
#else
{35, 35, 0x0000000000000000, "RO", "IMR1_WRITE_POL_35", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{34, 34, 0x0000000000000000, "RW", "IMR1_WRITE_POL_34", "Bunit IMR1 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR1 region based on the agents 6bit encoded SAI value."},
#else
{34, 34, 0x0000000000000000, "RW", "IMR1_WRITE_POL_34", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{33, 33, 0x0000000000000000, "RW", "IMR1_WRITE_POL_33", "Bunit IMR1 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR1 region based on the agents 6bit encoded SAI value."},
#else
{33, 33, 0x0000000000000000, "RW", "IMR1_WRITE_POL_33", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{32, 32, 0x0000000000000000, "RW", "IMR1_WRITE_POL_32", "Bunit IMR1 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR1 region based on the agents 6bit encoded SAI value."},
#else
{32, 32, 0x0000000000000000, "RW", "IMR1_WRITE_POL_32", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{31, 31, 0x0000000000000000, "RO", "IMR1_WRITE_POL_31", "Bunit IMR1 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR1 region based on the agents 6bit encoded SAI value."},
#else
{31, 31, 0x0000000000000000, "RO", "IMR1_WRITE_POL_31", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{30, 30, 0x0000000000000000, "RW", "IMR1_WRITE_POL_30", "Bunit IMR1 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR1 region based on the agents 6bit encoded SAI value."},
#else
{30, 30, 0x0000000000000000, "RW", "IMR1_WRITE_POL_30", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{29, 29, 0x0000000000000000, "RW", "IMR1_WRITE_POL_29", "Bunit IMR1 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR1 region based on the agents 6bit encoded SAI value."},
#else
{29, 29, 0x0000000000000000, "RW", "IMR1_WRITE_POL_29", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{28, 28, 0x0000000000000000, "RW", "IMR1_WRITE_POL_28", "Bunit IMR1 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR1 region based on the agents 6bit encoded SAI value."},
#else
{28, 28, 0x0000000000000000, "RW", "IMR1_WRITE_POL_28", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{27, 27, 0x0000000000000000, "RW", "IMR1_WRITE_POL_27", "Bunit IMR1 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR1 region based on the agents 6bit encoded SAI value."},
#else
{27, 27, 0x0000000000000000, "RW", "IMR1_WRITE_POL_27", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{26, 26, 0x0000000000000000, "RW", "IMR1_WRITE_POL_26", "Bunit IMR1 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR1 region based on the agents 6bit encoded SAI value."},
#else
{26, 26, 0x0000000000000000, "RW", "IMR1_WRITE_POL_26", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{25, 25, 0x0000000000000000, "RW", "IMR1_WRITE_POL_25", "Bunit IMR1 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR1 region based on the agents 6bit encoded SAI value."},
#else
{25, 25, 0x0000000000000000, "RW", "IMR1_WRITE_POL_25", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{24, 24, 0x0000000000000000, "RW", "IMR1_WRITE_POL_24", "Bunit IMR1 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR1 region based on the agents 6bit encoded SAI value."},
#else
{24, 24, 0x0000000000000000, "RW", "IMR1_WRITE_POL_24", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{23, 23, 0x0000000000000000, "RO", "IMR1_WRITE_POL_23", "Bunit IMR1 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR1 region based on the agents 6bit encoded SAI value."},
#else
{23, 23, 0x0000000000000000, "RO", "IMR1_WRITE_POL_23", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{22, 22, 0x0000000000000000, "RO", "IMR1_WRITE_POL_22", "Bunit IMR1 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR1 region based on the agents 6bit encoded SAI value."},
#else
{22, 22, 0x0000000000000000, "RO", "IMR1_WRITE_POL_22", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{21, 21, 0x0000000000000000, "RW", "IMR1_WRITE_POL_21", "Bunit IMR1 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR1 region based on the agents 6bit encoded SAI value."},
#else
{21, 21, 0x0000000000000000, "RW", "IMR1_WRITE_POL_21", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{20, 20, 0x0000000000000000, "RO", "IMR1_WRITE_POL_20", "Bunit IMR1 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR1 region based on the agents 6bit encoded SAI value."},
#else
{20, 20, 0x0000000000000000, "RO", "IMR1_WRITE_POL_20", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{19, 19, 0x0000000000000000, "RO", "IMR1_WRITE_POL_19", "Bunit IMR1 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR1 region based on the agents 6bit encoded SAI value."},
#else
{19, 19, 0x0000000000000000, "RO", "IMR1_WRITE_POL_19", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{18, 18, 0x0000000000000000, "RO", "IMR1_WRITE_POL_18", "Bunit IMR1 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR1 region based on the agents 6bit encoded SAI value."},
#else
{18, 18, 0x0000000000000000, "RO", "IMR1_WRITE_POL_18", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{17, 17, 0x0000000000000000, "RW", "IMR1_WRITE_POL_17", "Bunit IMR1 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR1 region based on the agents 6bit encoded SAI value."},
#else
{17, 17, 0x0000000000000000, "RW", "IMR1_WRITE_POL_17", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{16, 16, 0x0000000000000000, "RW", "IMR1_WRITE_POL_16", "Bunit IMR1 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR1 region based on the agents 6bit encoded SAI value."},
#else
{16, 16, 0x0000000000000000, "RW", "IMR1_WRITE_POL_16", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{15, 15, 0x0000000000000000, "RO", "IMR1_WRITE_POL_15", "Bunit IMR1 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR1 region based on the agents 6bit encoded SAI value."},
#else
{15, 15, 0x0000000000000000, "RO", "IMR1_WRITE_POL_15", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{14, 14, 0x0000000000000000, "RO", "IMR1_WRITE_POL_14", "Bunit IMR1 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR1 region based on the agents 6bit encoded SAI value."},
#else
{14, 14, 0x0000000000000000, "RO", "IMR1_WRITE_POL_14", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{13, 13, 0x0000000000000000, "RW", "IMR1_WRITE_POL_13", "Bunit IMR1 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR1 region based on the agents 6bit encoded SAI value."},
#else
{13, 13, 0x0000000000000000, "RW", "IMR1_WRITE_POL_13", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{12, 12, 0x0000000000000000, "RW", "IMR1_WRITE_POL_12", "Bunit IMR1 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR1 region based on the agents 6bit encoded SAI value."},
#else
{12, 12, 0x0000000000000000, "RW", "IMR1_WRITE_POL_12", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{11, 11, 0x0000000000000000, "RO", "IMR1_WRITE_POL_11", "Bunit IMR1 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR1 region based on the agents 6bit encoded SAI value."},
#else
{11, 11, 0x0000000000000000, "RO", "IMR1_WRITE_POL_11", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{10, 10, 0x0000000000000000, "RO", "IMR1_WRITE_POL_10", "Bunit IMR1 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR1 region based on the agents 6bit encoded SAI value."},
#else
{10, 10, 0x0000000000000000, "RO", "IMR1_WRITE_POL_10", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{9, 9, 0x0000000000000000, "RO", "IMR1_WRITE_POL_9", "Bunit IMR1 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR1 region based on the agents 6bit encoded SAI value."},
#else
{9, 9, 0x0000000000000000, "RO", "IMR1_WRITE_POL_9", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{8, 8, 0x0000000000000000, "RW", "IMR1_WRITE_POL_8", "Bunit IMR1 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR1 region based on the agents 6bit encoded SAI value."},
#else
{8, 8, 0x0000000000000000, "RW", "IMR1_WRITE_POL_8", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{7, 7, 0x0000000000000000, "RO", "IMR1_WRITE_POL_7", "Bunit IMR1 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR1 region based on the agents 6bit encoded SAI value."},
#else
{7, 7, 0x0000000000000000, "RO", "IMR1_WRITE_POL_7", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{6, 6, 0x0000000000000000, "RO", "IMR1_WRITE_POL_6", "Bunit IMR1 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR1 region based on the agents 6bit encoded SAI value."},
#else
{6, 6, 0x0000000000000000, "RO", "IMR1_WRITE_POL_6", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{5, 5, 0x0000000000000000, "RW", "IMR1_WRITE_POL_5", "Bunit IMR1 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR1 region based on the agents 6bit encoded SAI value."},
#else
{5, 5, 0x0000000000000000, "RW", "IMR1_WRITE_POL_5", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{4, 4, 0x0000000000000000, "RW", "IMR1_WRITE_POL_4", "Bunit IMR1 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR1 region based on the agents 6bit encoded SAI value."},
#else
{4, 4, 0x0000000000000000, "RW", "IMR1_WRITE_POL_4", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{3, 3, 0x0000000000000000, "RW", "IMR1_WRITE_POL_3", "Bunit IMR1 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR1 region based on the agents 6bit encoded SAI value."},
#else
{3, 3, 0x0000000000000000, "RW", "IMR1_WRITE_POL_3", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{2, 2, 0x0000000000000000, "RW", "IMR1_WRITE_POL_2", "Bunit IMR1 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR1 region based on the agents 6bit encoded SAI value."},
#else
{2, 2, 0x0000000000000000, "RW", "IMR1_WRITE_POL_2", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{1, 1, 0x0000000000000000, "RW", "IMR1_WRITE_POL_1", "Bunit IMR1 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR1 region based on the agents 6bit encoded SAI value."},
#else
{1, 1, 0x0000000000000000, "RW", "IMR1_WRITE_POL_1", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 0, 0x0000000000000000, "RW", "IMR1_WRITE_POL_0", "Bunit IMR1 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR1 region based on the agents 6bit encoded SAI value."},
#else
{0, 0, 0x0000000000000000, "RW", "IMR1_WRITE_POL_0", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo886[] = {{"B_CR_BIMR1WAC_0_0_0_MCHBAR", "", 0x000068A8, 64, 0xFFFFFFFFFFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields887[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{31, 31, 0x0000000000000000, "RW", "IMR_EN", "IMR Enable: Enables access checking for the IMR region."},
#else
{31, 31, 0x0000000000000000, "RW", "IMR_EN", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{30, 30, 0x0000000000000000, "RW", "TR_EN", "Asset Classification AC[0]: Trace Enable: Enables snooping of transactions to the IMR region by tracing agents."},
#else
{30, 30, 0x0000000000000000, "RW", "TR_EN", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{29, 29, 0x0000000000000000, "RO", "RESERVED_1", "Reserved"},
#else
{29, 29, 0x0000000000000000, "RO", "RESERVED_1", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 28, 0x0000000000000000, "RW", "IMR2_BASE", "Base 0 IMR2BASE:  Specifies bits 38:10 of the start address of IMR2 region.  IMR region size must be a strict poweroftwo at least 1KB and naturally aligned to the size.  These bits are compared with the result of the IMR2MASK[28:0] applied to bits 38:10 of the incoming address to determine if an access falls within the IMR2 defined region."},
#else
{0, 28, 0x0000000000000000, "RW", "IMR2_BASE", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo887[] = {{"B_CR_BIMR2BASE_0_0_0_MCHBAR", "", 0x000068B0, 4, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields888[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{31, 31, 0x0000000000000000, "RW", "GT_IWB_EN", "Asset Classification AC[2]: GT Implicit WB Enable: Enables implicit writebacks to protected region from GT caching agent. When set to 1 enables implicit writeback data HITM data from GT to be returned to the requester.  When set to 0 inhibits HITM data from GT from being returned to the requester.  HITM data from IA cores may be returned to the requester depending on the setting of the IA_IWB_EN bit."},
#else
{31, 31, 0x0000000000000000, "RW", "GT_IWB_EN", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{30, 30, 0x0000000000000000, "RW", "IA_IWB_EN", "Asset Classification AC[1]: IA Implicit WB Enable: Enables implicit writebacks to protected region from IA caching agent.  When set to 1 enables implicit writeback data HITM data from IA cores to be returned to the requester.  When set to 0 inhibits HITM data from IA cores from being returned to the requester.  HITM data from GT may be returned to the requester depending on the setting of the GT_IWB_EN bit."},
#else
{30, 30, 0x0000000000000000, "RW", "IA_IWB_EN", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{29, 29, 0x0000000000000000, "RO", "RESERVED_0", "Reserved"},
#else
{29, 29, 0x0000000000000000, "RO", "RESERVED_0", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 28, 0x0000000000000000, "RW", "IMR2_MASK", "Mask 0 IMR2MASK:  These bits are ANDed with bits 38:10 of the incoming address to determine if the combined result matches the IMR2BASE[28:0] value.  A match indicates the the incoming address falls within the IMR2 region."},
#else
{0, 28, 0x0000000000000000, "RW", "IMR2_MASK", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo888[] = {{"B_CR_BIMR2MASK_0_0_0_MCHBAR", "", 0x000068B4, 4, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields889[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{0, 63, 0x00000C0061010202, "RW", "IMR2_CTRL_POL", "Bunit IMR2 Control Policy: Bit vector used to determine which agents are allowed access to the BIMR2RAC, BIMR2WAC, BIMR2CP registers based on the value from the agents 6bit SAI field."},
#else
{0, 63, 0x00000C0061010202, "RW", "IMR2_CTRL_POL", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo889[] = {{"B_CR_BIMR2CP_0_0_0_MCHBAR", "", 0x000068B8, 1, 0xFFFFFFFFFFFFFFFF, 0x00000C0061010202}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields890[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{63, 63, 0x0000000000000000, "RW", "IMR2_READ_POL_63", "Bunit IMR2 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR2 region based on the agents 6bit encoded SAI value."},
#else
{63, 63, 0x0000000000000000, "RW", "IMR2_READ_POL_63", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{62, 62, 0x0000000000000000, "RO", "IMR2_READ_POL_62", "Bunit IMR2 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR2 region based on the agents 6bit encoded SAI value."},
#else
{62, 62, 0x0000000000000000, "RO", "IMR2_READ_POL_62", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{61, 61, 0x0000000000000000, "RO", "IMR2_READ_POL_61", "Bunit IMR2 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR2 region based on the agents 6bit encoded SAI value."},
#else
{61, 61, 0x0000000000000000, "RO", "IMR2_READ_POL_61", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{60, 60, 0x0000000000000000, "RO", "IMR2_READ_POL_60", "Bunit IMR2 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR2 region based on the agents 6bit encoded SAI value."},
#else
{60, 60, 0x0000000000000000, "RO", "IMR2_READ_POL_60", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{59, 59, 0x0000000000000000, "RO", "IMR2_READ_POL_59", "Bunit IMR2 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR2 region based on the agents 6bit encoded SAI value."},
#else
{59, 59, 0x0000000000000000, "RO", "IMR2_READ_POL_59", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{58, 58, 0x0000000000000000, "RO", "IMR2_READ_POL_58", "Bunit IMR2 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR2 region based on the agents 6bit encoded SAI value."},
#else
{58, 58, 0x0000000000000000, "RO", "IMR2_READ_POL_58", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{57, 57, 0x0000000000000000, "RO", "IMR2_READ_POL_57", "Bunit IMR2 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR2 region based on the agents 6bit encoded SAI value."},
#else
{57, 57, 0x0000000000000000, "RO", "IMR2_READ_POL_57", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{56, 56, 0x0000000000000000, "RW", "IMR2_READ_POL_56", "Bunit IMR2 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR2 region based on the agents 6bit encoded SAI value."},
#else
{56, 56, 0x0000000000000000, "RW", "IMR2_READ_POL_56", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{55, 55, 0x0000000000000000, "RW", "IMR2_READ_POL_55", "Bunit IMR2 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR2 region based on the agents 6bit encoded SAI value."},
#else
{55, 55, 0x0000000000000000, "RW", "IMR2_READ_POL_55", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{54, 54, 0x0000000000000000, "RW", "IMR2_READ_POL_54", "Bunit IMR2 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR2 region based on the agents 6bit encoded SAI value."},
#else
{54, 54, 0x0000000000000000, "RW", "IMR2_READ_POL_54", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{53, 53, 0x0000000000000000, "RO", "IMR2_READ_POL_53", "Bunit IMR2 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR2 region based on the agents 6bit encoded SAI value."},
#else
{53, 53, 0x0000000000000000, "RO", "IMR2_READ_POL_53", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{52, 52, 0x0000000000000000, "RO", "IMR2_READ_POL_52", "Bunit IMR2 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR2 region based on the agents 6bit encoded SAI value."},
#else
{52, 52, 0x0000000000000000, "RO", "IMR2_READ_POL_52", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{51, 51, 0x0000000000000000, "RO", "IMR2_READ_POL_51", "Bunit IMR2 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR2 region based on the agents 6bit encoded SAI value."},
#else
{51, 51, 0x0000000000000000, "RO", "IMR2_READ_POL_51", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{50, 50, 0x0000000000000000, "RW", "IMR2_READ_POL_50", "Bunit IMR2 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR2 region based on the agents 6bit encoded SAI value."},
#else
{50, 50, 0x0000000000000000, "RW", "IMR2_READ_POL_50", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{49, 49, 0x0000000000000000, "RW", "IMR2_READ_POL_49", "Bunit IMR2 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR2 region based on the agents 6bit encoded SAI value."},
#else
{49, 49, 0x0000000000000000, "RW", "IMR2_READ_POL_49", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{48, 48, 0x0000000000000000, "RW", "IMR2_READ_POL_48", "Bunit IMR2 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR2 region based on the agents 6bit encoded SAI value."},
#else
{48, 48, 0x0000000000000000, "RW", "IMR2_READ_POL_48", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{47, 47, 0x0000000000000000, "RO", "IMR2_READ_POL_47", "Bunit IMR2 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR2 region based on the agents 6bit encoded SAI value."},
#else
{47, 47, 0x0000000000000000, "RO", "IMR2_READ_POL_47", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{46, 46, 0x0000000000000000, "RO", "IMR2_READ_POL_46", "Bunit IMR2 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR2 region based on the agents 6bit encoded SAI value."},
#else
{46, 46, 0x0000000000000000, "RO", "IMR2_READ_POL_46", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{45, 45, 0x0000000000000000, "RO", "IMR2_READ_POL_45", "Bunit IMR2 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR2 region based on the agents 6bit encoded SAI value."},
#else
{45, 45, 0x0000000000000000, "RO", "IMR2_READ_POL_45", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{44, 44, 0x0000000000000000, "RW", "IMR2_READ_POL_44", "Bunit IMR2 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR2 region based on the agents 6bit encoded SAI value."},
#else
{44, 44, 0x0000000000000000, "RW", "IMR2_READ_POL_44", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{43, 43, 0x0000000000000000, "RW", "IMR2_READ_POL_43", "Bunit IMR2 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR2 region based on the agents 6bit encoded SAI value."},
#else
{43, 43, 0x0000000000000000, "RW", "IMR2_READ_POL_43", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{42, 42, 0x0000000000000000, "RW", "IMR2_READ_POL_42", "Bunit IMR2 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR2 region based on the agents 6bit encoded SAI value."},
#else
{42, 42, 0x0000000000000000, "RW", "IMR2_READ_POL_42", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{41, 41, 0x0000000000000000, "RW", "IMR2_READ_POL_41", "Bunit IMR2 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR2 region based on the agents 6bit encoded SAI value."},
#else
{41, 41, 0x0000000000000000, "RW", "IMR2_READ_POL_41", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{40, 40, 0x0000000000000000, "RW", "IMR2_READ_POL_40", "Bunit IMR2 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR2 region based on the agents 6bit encoded SAI value."},
#else
{40, 40, 0x0000000000000000, "RW", "IMR2_READ_POL_40", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{39, 39, 0x0000000000000000, "RO", "IMR2_READ_POL_39", "Bunit IMR2 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR2 region based on the agents 6bit encoded SAI value."},
#else
{39, 39, 0x0000000000000000, "RO", "IMR2_READ_POL_39", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{38, 38, 0x0000000000000000, "RW", "IMR2_READ_POL_38", "Bunit IMR2 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR2 region based on the agents 6bit encoded SAI value."},
#else
{38, 38, 0x0000000000000000, "RW", "IMR2_READ_POL_38", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{37, 37, 0x0000000000000000, "RO", "IMR2_READ_POL_37", "Bunit IMR2 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR2 region based on the agents 6bit encoded SAI value."},
#else
{37, 37, 0x0000000000000000, "RO", "IMR2_READ_POL_37", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{36, 36, 0x0000000000000000, "RW", "IMR2_READ_POL_36", "Bunit IMR2 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR2 region based on the agents 6bit encoded SAI value."},
#else
{36, 36, 0x0000000000000000, "RW", "IMR2_READ_POL_36", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{35, 35, 0x0000000000000000, "RO", "IMR2_READ_POL_35", "Bunit IMR2 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR2 region based on the agents 6bit encoded SAI value."},
#else
{35, 35, 0x0000000000000000, "RO", "IMR2_READ_POL_35", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{34, 34, 0x0000000000000000, "RW", "IMR2_READ_POL_34", "Bunit IMR2 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR2 region based on the agents 6bit encoded SAI value."},
#else
{34, 34, 0x0000000000000000, "RW", "IMR2_READ_POL_34", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{33, 33, 0x0000000000000000, "RW", "IMR2_READ_POL_33", "Bunit IMR2 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR2 region based on the agents 6bit encoded SAI value."},
#else
{33, 33, 0x0000000000000000, "RW", "IMR2_READ_POL_33", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{32, 32, 0x0000000000000000, "RW", "IMR2_READ_POL_32", "Bunit IMR2 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR2 region based on the agents 6bit encoded SAI value."},
#else
{32, 32, 0x0000000000000000, "RW", "IMR2_READ_POL_32", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{31, 31, 0x0000000000000000, "RO", "IMR2_READ_POL_31", "Bunit IMR2 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR2 region based on the agents 6bit encoded SAI value."},
#else
{31, 31, 0x0000000000000000, "RO", "IMR2_READ_POL_31", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{30, 30, 0x0000000000000000, "RW", "IMR2_READ_POL_30", "Bunit IMR2 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR2 region based on the agents 6bit encoded SAI value."},
#else
{30, 30, 0x0000000000000000, "RW", "IMR2_READ_POL_30", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{29, 29, 0x0000000000000000, "RW", "IMR2_READ_POL_29", "Bunit IMR2 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR2 region based on the agents 6bit encoded SAI value."},
#else
{29, 29, 0x0000000000000000, "RW", "IMR2_READ_POL_29", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{28, 28, 0x0000000000000000, "RW", "IMR2_READ_POL_28", "Bunit IMR2 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR2 region based on the agents 6bit encoded SAI value."},
#else
{28, 28, 0x0000000000000000, "RW", "IMR2_READ_POL_28", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{27, 27, 0x0000000000000000, "RW", "IMR2_READ_POL_27", "Bunit IMR2 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR2 region based on the agents 6bit encoded SAI value."},
#else
{27, 27, 0x0000000000000000, "RW", "IMR2_READ_POL_27", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{26, 26, 0x0000000000000000, "RW", "IMR2_READ_POL_26", "Bunit IMR2 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR2 region based on the agents 6bit encoded SAI value."},
#else
{26, 26, 0x0000000000000000, "RW", "IMR2_READ_POL_26", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{25, 25, 0x0000000000000000, "RW", "IMR2_READ_POL_25", "Bunit IMR2 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR2 region based on the agents 6bit encoded SAI value."},
#else
{25, 25, 0x0000000000000000, "RW", "IMR2_READ_POL_25", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{24, 24, 0x0000000000000000, "RW", "IMR2_READ_POL_24", "Bunit IMR2 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR2 region based on the agents 6bit encoded SAI value."},
#else
{24, 24, 0x0000000000000000, "RW", "IMR2_READ_POL_24", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{23, 23, 0x0000000000000000, "RO", "IMR2_READ_POL_23", "Bunit IMR2 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR2 region based on the agents 6bit encoded SAI value."},
#else
{23, 23, 0x0000000000000000, "RO", "IMR2_READ_POL_23", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{22, 22, 0x0000000000000000, "RO", "IMR2_READ_POL_22", "Bunit IMR2 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR2 region based on the agents 6bit encoded SAI value."},
#else
{22, 22, 0x0000000000000000, "RO", "IMR2_READ_POL_22", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{21, 21, 0x0000000000000000, "RW", "IMR2_READ_POL_21", "Bunit IMR2 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR2 region based on the agents 6bit encoded SAI value."},
#else
{21, 21, 0x0000000000000000, "RW", "IMR2_READ_POL_21", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{20, 20, 0x0000000000000000, "RO", "IMR2_READ_POL_20", "Bunit IMR2 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR2 region based on the agents 6bit encoded SAI value."},
#else
{20, 20, 0x0000000000000000, "RO", "IMR2_READ_POL_20", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{19, 19, 0x0000000000000000, "RO", "IMR2_READ_POL_19", "Bunit IMR2 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR2 region based on the agents 6bit encoded SAI value."},
#else
{19, 19, 0x0000000000000000, "RO", "IMR2_READ_POL_19", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{18, 18, 0x0000000000000000, "RO", "IMR2_READ_POL_18", "Bunit IMR2 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR2 region based on the agents 6bit encoded SAI value."},
#else
{18, 18, 0x0000000000000000, "RO", "IMR2_READ_POL_18", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{17, 17, 0x0000000000000000, "RW", "IMR2_READ_POL_17", "Bunit IMR2 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR2 region based on the agents 6bit encoded SAI value."},
#else
{17, 17, 0x0000000000000000, "RW", "IMR2_READ_POL_17", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{16, 16, 0x0000000000000000, "RW", "IMR2_READ_POL_16", "Bunit IMR2 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR2 region based on the agents 6bit encoded SAI value."},
#else
{16, 16, 0x0000000000000000, "RW", "IMR2_READ_POL_16", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{15, 15, 0x0000000000000000, "RO", "IMR2_READ_POL_15", "Bunit IMR2 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR2 region based on the agents 6bit encoded SAI value."},
#else
{15, 15, 0x0000000000000000, "RO", "IMR2_READ_POL_15", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{14, 14, 0x0000000000000000, "RO", "IMR2_READ_POL_14", "Bunit IMR2 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR2 region based on the agents 6bit encoded SAI value."},
#else
{14, 14, 0x0000000000000000, "RO", "IMR2_READ_POL_14", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{13, 13, 0x0000000000000000, "RW", "IMR2_READ_POL_13", "Bunit IMR2 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR2 region based on the agents 6bit encoded SAI value."},
#else
{13, 13, 0x0000000000000000, "RW", "IMR2_READ_POL_13", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{12, 12, 0x0000000000000000, "RW", "IMR2_READ_POL_12", "Bunit IMR2 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR2 region based on the agents 6bit encoded SAI value."},
#else
{12, 12, 0x0000000000000000, "RW", "IMR2_READ_POL_12", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{11, 11, 0x0000000000000000, "RO", "IMR2_READ_POL_11", "Bunit IMR2 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR2 region based on the agents 6bit encoded SAI value."},
#else
{11, 11, 0x0000000000000000, "RO", "IMR2_READ_POL_11", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{10, 10, 0x0000000000000000, "RO", "IMR2_READ_POL_10", "Bunit IMR2 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR2 region based on the agents 6bit encoded SAI value."},
#else
{10, 10, 0x0000000000000000, "RO", "IMR2_READ_POL_10", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{9, 9, 0x0000000000000000, "RO", "IMR2_READ_POL_9", "Bunit IMR2 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR2 region based on the agents 6bit encoded SAI value."},
#else
{9, 9, 0x0000000000000000, "RO", "IMR2_READ_POL_9", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{8, 8, 0x0000000000000000, "RW", "IMR2_READ_POL_8", "Bunit IMR2 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR2 region based on the agents 6bit encoded SAI value."},
#else
{8, 8, 0x0000000000000000, "RW", "IMR2_READ_POL_8", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{7, 7, 0x0000000000000000, "RO", "IMR2_READ_POL_7", "Bunit IMR2 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR2 region based on the agents 6bit encoded SAI value."},
#else
{7, 7, 0x0000000000000000, "RO", "IMR2_READ_POL_7", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{6, 6, 0x0000000000000000, "RO", "IMR2_READ_POL_6", "Bunit IMR2 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR2 region based on the agents 6bit encoded SAI value."},
#else
{6, 6, 0x0000000000000000, "RO", "IMR2_READ_POL_6", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{5, 5, 0x0000000000000000, "RW", "IMR2_READ_POL_5", "Bunit IMR2 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR2 region based on the agents 6bit encoded SAI value."},
#else
{5, 5, 0x0000000000000000, "RW", "IMR2_READ_POL_5", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{4, 4, 0x0000000000000000, "RW", "IMR2_READ_POL_4", "Bunit IMR2 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR2 region based on the agents 6bit encoded SAI value."},
#else
{4, 4, 0x0000000000000000, "RW", "IMR2_READ_POL_4", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{3, 3, 0x0000000000000000, "RW", "IMR2_READ_POL_3", "Bunit IMR2 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR2 region based on the agents 6bit encoded SAI value."},
#else
{3, 3, 0x0000000000000000, "RW", "IMR2_READ_POL_3", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{2, 2, 0x0000000000000000, "RW", "IMR2_READ_POL_2", "Bunit IMR2 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR2 region based on the agents 6bit encoded SAI value."},
#else
{2, 2, 0x0000000000000000, "RW", "IMR2_READ_POL_2", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{1, 1, 0x0000000000000000, "RW", "IMR2_READ_POL_1", "Bunit IMR2 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR2 region based on the agents 6bit encoded SAI value."},
#else
{1, 1, 0x0000000000000000, "RW", "IMR2_READ_POL_1", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 0, 0x0000000000000000, "RW", "IMR2_READ_POL_0", "Bunit IMR2 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR2 region based on the agents 6bit encoded SAI value."},
#else
{0, 0, 0x0000000000000000, "RW", "IMR2_READ_POL_0", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo890[] = {{"B_CR_BIMR2RAC_0_0_0_MCHBAR", "", 0x000068C0, 64, 0xFFFFFFFFFFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields891[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{63, 63, 0x0000000000000000, "RW", "IMR2_WRITE_POL_63", "Bunit IMR2 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR2 region based on the agents 6bit encoded SAI value."},
#else
{63, 63, 0x0000000000000000, "RW", "IMR2_WRITE_POL_63", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{62, 62, 0x0000000000000000, "RO", "IMR2_WRITE_POL_62", "Bunit IMR2 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR2 region based on the agents 6bit encoded SAI value."},
#else
{62, 62, 0x0000000000000000, "RO", "IMR2_WRITE_POL_62", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{61, 61, 0x0000000000000000, "RO", "IMR2_WRITE_POL_61", "Bunit IMR2 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR2 region based on the agents 6bit encoded SAI value."},
#else
{61, 61, 0x0000000000000000, "RO", "IMR2_WRITE_POL_61", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{60, 60, 0x0000000000000000, "RO", "IMR2_WRITE_POL_60", "Bunit IMR2 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR2 region based on the agents 6bit encoded SAI value."},
#else
{60, 60, 0x0000000000000000, "RO", "IMR2_WRITE_POL_60", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{59, 59, 0x0000000000000000, "RO", "IMR2_WRITE_POL_59", "Bunit IMR2 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR2 region based on the agents 6bit encoded SAI value."},
#else
{59, 59, 0x0000000000000000, "RO", "IMR2_WRITE_POL_59", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{58, 58, 0x0000000000000000, "RO", "IMR2_WRITE_POL_58", "Bunit IMR2 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR2 region based on the agents 6bit encoded SAI value."},
#else
{58, 58, 0x0000000000000000, "RO", "IMR2_WRITE_POL_58", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{57, 57, 0x0000000000000000, "RO", "IMR2_WRITE_POL_57", "Bunit IMR2 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR2 region based on the agents 6bit encoded SAI value."},
#else
{57, 57, 0x0000000000000000, "RO", "IMR2_WRITE_POL_57", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{56, 56, 0x0000000000000000, "RW", "IMR2_WRITE_POL_56", "Bunit IMR2 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR2 region based on the agents 6bit encoded SAI value."},
#else
{56, 56, 0x0000000000000000, "RW", "IMR2_WRITE_POL_56", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{55, 55, 0x0000000000000000, "RW", "IMR2_WRITE_POL_55", "Bunit IMR2 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR2 region based on the agents 6bit encoded SAI value."},
#else
{55, 55, 0x0000000000000000, "RW", "IMR2_WRITE_POL_55", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{54, 54, 0x0000000000000000, "RW", "IMR2_WRITE_POL_54", "Bunit IMR2 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR2 region based on the agents 6bit encoded SAI value."},
#else
{54, 54, 0x0000000000000000, "RW", "IMR2_WRITE_POL_54", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{53, 53, 0x0000000000000000, "RO", "IMR2_WRITE_POL_53", "Bunit IMR2 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR2 region based on the agents 6bit encoded SAI value."},
#else
{53, 53, 0x0000000000000000, "RO", "IMR2_WRITE_POL_53", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{52, 52, 0x0000000000000000, "RO", "IMR2_WRITE_POL_52", "Bunit IMR2 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR2 region based on the agents 6bit encoded SAI value."},
#else
{52, 52, 0x0000000000000000, "RO", "IMR2_WRITE_POL_52", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{51, 51, 0x0000000000000000, "RO", "IMR2_WRITE_POL_51", "Bunit IMR2 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR2 region based on the agents 6bit encoded SAI value."},
#else
{51, 51, 0x0000000000000000, "RO", "IMR2_WRITE_POL_51", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{50, 50, 0x0000000000000000, "RW", "IMR2_WRITE_POL_50", "Bunit IMR2 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR2 region based on the agents 6bit encoded SAI value."},
#else
{50, 50, 0x0000000000000000, "RW", "IMR2_WRITE_POL_50", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{49, 49, 0x0000000000000000, "RW", "IMR2_WRITE_POL_49", "Bunit IMR2 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR2 region based on the agents 6bit encoded SAI value."},
#else
{49, 49, 0x0000000000000000, "RW", "IMR2_WRITE_POL_49", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{48, 48, 0x0000000000000000, "RW", "IMR2_WRITE_POL_48", "Bunit IMR2 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR2 region based on the agents 6bit encoded SAI value."},
#else
{48, 48, 0x0000000000000000, "RW", "IMR2_WRITE_POL_48", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{47, 47, 0x0000000000000000, "RO", "IMR2_WRITE_POL_47", "Bunit IMR2 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR2 region based on the agents 6bit encoded SAI value."},
#else
{47, 47, 0x0000000000000000, "RO", "IMR2_WRITE_POL_47", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{46, 46, 0x0000000000000000, "RO", "IMR2_WRITE_POL_46", "Bunit IMR2 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR2 region based on the agents 6bit encoded SAI value."},
#else
{46, 46, 0x0000000000000000, "RO", "IMR2_WRITE_POL_46", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{45, 45, 0x0000000000000000, "RO", "IMR2_WRITE_POL_45", "Bunit IMR2 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR2 region based on the agents 6bit encoded SAI value."},
#else
{45, 45, 0x0000000000000000, "RO", "IMR2_WRITE_POL_45", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{44, 44, 0x0000000000000000, "RW", "IMR2_WRITE_POL_44", "Bunit IMR2 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR2 region based on the agents 6bit encoded SAI value."},
#else
{44, 44, 0x0000000000000000, "RW", "IMR2_WRITE_POL_44", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{43, 43, 0x0000000000000000, "RW", "IMR2_WRITE_POL_43", "Bunit IMR2 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR2 region based on the agents 6bit encoded SAI value."},
#else
{43, 43, 0x0000000000000000, "RW", "IMR2_WRITE_POL_43", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{42, 42, 0x0000000000000000, "RW", "IMR2_WRITE_POL_42", "Bunit IMR2 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR2 region based on the agents 6bit encoded SAI value."},
#else
{42, 42, 0x0000000000000000, "RW", "IMR2_WRITE_POL_42", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{41, 41, 0x0000000000000000, "RW", "IMR2_WRITE_POL_41", "Bunit IMR2 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR2 region based on the agents 6bit encoded SAI value."},
#else
{41, 41, 0x0000000000000000, "RW", "IMR2_WRITE_POL_41", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{40, 40, 0x0000000000000000, "RW", "IMR2_WRITE_POL_40", "Bunit IMR2 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR2 region based on the agents 6bit encoded SAI value."},
#else
{40, 40, 0x0000000000000000, "RW", "IMR2_WRITE_POL_40", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{39, 39, 0x0000000000000000, "RO", "IMR2_WRITE_POL_39", "Bunit IMR2 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR2 region based on the agents 6bit encoded SAI value."},
#else
{39, 39, 0x0000000000000000, "RO", "IMR2_WRITE_POL_39", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{38, 38, 0x0000000000000000, "RW", "IMR2_WRITE_POL_38", "Bunit IMR2 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR2 region based on the agents 6bit encoded SAI value."},
#else
{38, 38, 0x0000000000000000, "RW", "IMR2_WRITE_POL_38", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{37, 37, 0x0000000000000000, "RO", "IMR2_WRITE_POL_37", "Bunit IMR2 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR2 region based on the agents 6bit encoded SAI value."},
#else
{37, 37, 0x0000000000000000, "RO", "IMR2_WRITE_POL_37", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{36, 36, 0x0000000000000000, "RW", "IMR2_WRITE_POL_36", "Bunit IMR2 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR2 region based on the agents 6bit encoded SAI value."},
#else
{36, 36, 0x0000000000000000, "RW", "IMR2_WRITE_POL_36", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{35, 35, 0x0000000000000000, "RO", "IMR2_WRITE_POL_35", "Bunit IMR2 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR2 region based on the agents 6bit encoded SAI value."},
#else
{35, 35, 0x0000000000000000, "RO", "IMR2_WRITE_POL_35", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{34, 34, 0x0000000000000000, "RW", "IMR2_WRITE_POL_34", "Bunit IMR2 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR2 region based on the agents 6bit encoded SAI value."},
#else
{34, 34, 0x0000000000000000, "RW", "IMR2_WRITE_POL_34", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{33, 33, 0x0000000000000000, "RW", "IMR2_WRITE_POL_33", "Bunit IMR2 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR2 region based on the agents 6bit encoded SAI value."},
#else
{33, 33, 0x0000000000000000, "RW", "IMR2_WRITE_POL_33", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{32, 32, 0x0000000000000000, "RW", "IMR2_WRITE_POL_32", "Bunit IMR2 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR2 region based on the agents 6bit encoded SAI value."},
#else
{32, 32, 0x0000000000000000, "RW", "IMR2_WRITE_POL_32", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{31, 31, 0x0000000000000000, "RO", "IMR2_WRITE_POL_31", "Bunit IMR2 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR2 region based on the agents 6bit encoded SAI value."},
#else
{31, 31, 0x0000000000000000, "RO", "IMR2_WRITE_POL_31", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{30, 30, 0x0000000000000000, "RW", "IMR2_WRITE_POL_30", "Bunit IMR2 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR2 region based on the agents 6bit encoded SAI value."},
#else
{30, 30, 0x0000000000000000, "RW", "IMR2_WRITE_POL_30", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{29, 29, 0x0000000000000000, "RW", "IMR2_WRITE_POL_29", "Bunit IMR2 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR2 region based on the agents 6bit encoded SAI value."},
#else
{29, 29, 0x0000000000000000, "RW", "IMR2_WRITE_POL_29", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{28, 28, 0x0000000000000000, "RW", "IMR2_WRITE_POL_28", "Bunit IMR2 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR2 region based on the agents 6bit encoded SAI value."},
#else
{28, 28, 0x0000000000000000, "RW", "IMR2_WRITE_POL_28", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{27, 27, 0x0000000000000000, "RW", "IMR2_WRITE_POL_27", "Bunit IMR2 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR2 region based on the agents 6bit encoded SAI value."},
#else
{27, 27, 0x0000000000000000, "RW", "IMR2_WRITE_POL_27", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{26, 26, 0x0000000000000000, "RW", "IMR2_WRITE_POL_26", "Bunit IMR2 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR2 region based on the agents 6bit encoded SAI value."},
#else
{26, 26, 0x0000000000000000, "RW", "IMR2_WRITE_POL_26", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{25, 25, 0x0000000000000000, "RW", "IMR2_WRITE_POL_25", "Bunit IMR2 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR2 region based on the agents 6bit encoded SAI value."},
#else
{25, 25, 0x0000000000000000, "RW", "IMR2_WRITE_POL_25", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{24, 24, 0x0000000000000000, "RW", "IMR2_WRITE_POL_24", "Bunit IMR2 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR2 region based on the agents 6bit encoded SAI value."},
#else
{24, 24, 0x0000000000000000, "RW", "IMR2_WRITE_POL_24", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{23, 23, 0x0000000000000000, "RO", "IMR2_WRITE_POL_23", "Bunit IMR2 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR2 region based on the agents 6bit encoded SAI value."},
#else
{23, 23, 0x0000000000000000, "RO", "IMR2_WRITE_POL_23", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{22, 22, 0x0000000000000000, "RO", "IMR2_WRITE_POL_22", "Bunit IMR2 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR2 region based on the agents 6bit encoded SAI value."},
#else
{22, 22, 0x0000000000000000, "RO", "IMR2_WRITE_POL_22", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{21, 21, 0x0000000000000000, "RW", "IMR2_WRITE_POL_21", "Bunit IMR2 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR2 region based on the agents 6bit encoded SAI value."},
#else
{21, 21, 0x0000000000000000, "RW", "IMR2_WRITE_POL_21", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{20, 20, 0x0000000000000000, "RO", "IMR2_WRITE_POL_20", "Bunit IMR2 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR2 region based on the agents 6bit encoded SAI value."},
#else
{20, 20, 0x0000000000000000, "RO", "IMR2_WRITE_POL_20", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{19, 19, 0x0000000000000000, "RO", "IMR2_WRITE_POL_19", "Bunit IMR2 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR2 region based on the agents 6bit encoded SAI value."},
#else
{19, 19, 0x0000000000000000, "RO", "IMR2_WRITE_POL_19", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{18, 18, 0x0000000000000000, "RO", "IMR2_WRITE_POL_18", "Bunit IMR2 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR2 region based on the agents 6bit encoded SAI value."},
#else
{18, 18, 0x0000000000000000, "RO", "IMR2_WRITE_POL_18", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{17, 17, 0x0000000000000000, "RW", "IMR2_WRITE_POL_17", "Bunit IMR2 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR2 region based on the agents 6bit encoded SAI value."},
#else
{17, 17, 0x0000000000000000, "RW", "IMR2_WRITE_POL_17", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{16, 16, 0x0000000000000000, "RW", "IMR2_WRITE_POL_16", "Bunit IMR2 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR2 region based on the agents 6bit encoded SAI value."},
#else
{16, 16, 0x0000000000000000, "RW", "IMR2_WRITE_POL_16", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{15, 15, 0x0000000000000000, "RO", "IMR2_WRITE_POL_15", "Bunit IMR2 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR2 region based on the agents 6bit encoded SAI value."},
#else
{15, 15, 0x0000000000000000, "RO", "IMR2_WRITE_POL_15", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{14, 14, 0x0000000000000000, "RO", "IMR2_WRITE_POL_14", "Bunit IMR2 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR2 region based on the agents 6bit encoded SAI value."},
#else
{14, 14, 0x0000000000000000, "RO", "IMR2_WRITE_POL_14", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{13, 13, 0x0000000000000000, "RW", "IMR2_WRITE_POL_13", "Bunit IMR2 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR2 region based on the agents 6bit encoded SAI value."},
#else
{13, 13, 0x0000000000000000, "RW", "IMR2_WRITE_POL_13", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{12, 12, 0x0000000000000000, "RW", "IMR2_WRITE_POL_12", "Bunit IMR2 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR2 region based on the agents 6bit encoded SAI value."},
#else
{12, 12, 0x0000000000000000, "RW", "IMR2_WRITE_POL_12", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{11, 11, 0x0000000000000000, "RO", "IMR2_WRITE_POL_11", "Bunit IMR2 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR2 region based on the agents 6bit encoded SAI value."},
#else
{11, 11, 0x0000000000000000, "RO", "IMR2_WRITE_POL_11", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{10, 10, 0x0000000000000000, "RO", "IMR2_WRITE_POL_10", "Bunit IMR2 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR2 region based on the agents 6bit encoded SAI value."},
#else
{10, 10, 0x0000000000000000, "RO", "IMR2_WRITE_POL_10", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{9, 9, 0x0000000000000000, "RO", "IMR2_WRITE_POL_9", "Bunit IMR2 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR2 region based on the agents 6bit encoded SAI value."},
#else
{9, 9, 0x0000000000000000, "RO", "IMR2_WRITE_POL_9", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{8, 8, 0x0000000000000000, "RW", "IMR2_WRITE_POL_8", "Bunit IMR2 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR2 region based on the agents 6bit encoded SAI value."},
#else
{8, 8, 0x0000000000000000, "RW", "IMR2_WRITE_POL_8", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{7, 7, 0x0000000000000000, "RO", "IMR2_WRITE_POL_7", "Bunit IMR2 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR2 region based on the agents 6bit encoded SAI value."},
#else
{7, 7, 0x0000000000000000, "RO", "IMR2_WRITE_POL_7", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{6, 6, 0x0000000000000000, "RO", "IMR2_WRITE_POL_6", "Bunit IMR2 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR2 region based on the agents 6bit encoded SAI value."},
#else
{6, 6, 0x0000000000000000, "RO", "IMR2_WRITE_POL_6", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{5, 5, 0x0000000000000000, "RW", "IMR2_WRITE_POL_5", "Bunit IMR2 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR2 region based on the agents 6bit encoded SAI value."},
#else
{5, 5, 0x0000000000000000, "RW", "IMR2_WRITE_POL_5", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{4, 4, 0x0000000000000000, "RW", "IMR2_WRITE_POL_4", "Bunit IMR2 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR2 region based on the agents 6bit encoded SAI value."},
#else
{4, 4, 0x0000000000000000, "RW", "IMR2_WRITE_POL_4", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{3, 3, 0x0000000000000000, "RW", "IMR2_WRITE_POL_3", "Bunit IMR2 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR2 region based on the agents 6bit encoded SAI value."},
#else
{3, 3, 0x0000000000000000, "RW", "IMR2_WRITE_POL_3", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{2, 2, 0x0000000000000000, "RW", "IMR2_WRITE_POL_2", "Bunit IMR2 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR2 region based on the agents 6bit encoded SAI value."},
#else
{2, 2, 0x0000000000000000, "RW", "IMR2_WRITE_POL_2", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{1, 1, 0x0000000000000000, "RW", "IMR2_WRITE_POL_1", "Bunit IMR2 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR2 region based on the agents 6bit encoded SAI value."},
#else
{1, 1, 0x0000000000000000, "RW", "IMR2_WRITE_POL_1", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 0, 0x0000000000000000, "RW", "IMR2_WRITE_POL_0", "Bunit IMR2 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR2 region based on the agents 6bit encoded SAI value."},
#else
{0, 0, 0x0000000000000000, "RW", "IMR2_WRITE_POL_0", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo891[] = {{"B_CR_BIMR2WAC_0_0_0_MCHBAR", "", 0x000068C8, 64, 0xFFFFFFFFFFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields892[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{31, 31, 0x0000000000000000, "RW", "IMR_EN", "IMR Enable: Enables access checking for the IMR region."},
#else
{31, 31, 0x0000000000000000, "RW", "IMR_EN", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{30, 30, 0x0000000000000000, "RW", "TR_EN", "Asset Classification AC[0]: Trace Enable: Enables snooping of transactions to the IMR region by tracing agents."},
#else
{30, 30, 0x0000000000000000, "RW", "TR_EN", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{29, 29, 0x0000000000000000, "RO", "RESERVED_1", "Reserved"},
#else
{29, 29, 0x0000000000000000, "RO", "RESERVED_1", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 28, 0x0000000000000000, "RW", "IMR3_BASE", "Base 0 IMR3BASE:  Specifies bits 38:10 of the start address of IMR3 region.  IMR region size must be a strict poweroftwo at least 1KB and naturally aligned to the size.  These bits are compared with the result of the IMR3MASK[28:0] applied to bits 38:10 of the incoming address to determine if an access falls within the IMR3 defined region."},
#else
{0, 28, 0x0000000000000000, "RW", "IMR3_BASE", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo892[] = {{"B_CR_BIMR3BASE_0_0_0_MCHBAR", "", 0x000068D0, 4, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields893[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{31, 31, 0x0000000000000000, "RW", "GT_IWB_EN", "Asset Classification AC[2]: GT Implicit WB Enable: Enables implicit writebacks to protected region from GT caching agent. When set to 1 enables implicit writeback data HITM data from GT to be returned to the requester.  When set to 0 inhibits HITM data from GT from being returned to the requester.  HITM data from IA cores may be returned to the requester depending on the setting of the IA_IWB_EN bit."},
#else
{31, 31, 0x0000000000000000, "RW", "GT_IWB_EN", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{30, 30, 0x0000000000000000, "RW", "IA_IWB_EN", "Asset Classification AC[1]: IA Implicit WB Enable: Enables implicit writebacks to protected region from IA caching agent.  When set to 1 enables implicit writeback data HITM data from IA cores to be returned to the requester.  When set to 0 inhibits HITM data from IA cores from being returned to the requester.  HITM data from GT may be returned to the requester depending on the setting of the GT_IWB_EN bit."},
#else
{30, 30, 0x0000000000000000, "RW", "IA_IWB_EN", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{29, 29, 0x0000000000000000, "RO", "RESERVED_0", "Reserved"},
#else
{29, 29, 0x0000000000000000, "RO", "RESERVED_0", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 28, 0x0000000000000000, "RW", "IMR3_MASK", "Mask 0 IMR3MASK:  These bits are ANDed with bits 38:10 of the incoming address to determine if the combined result matches the IMR3BASE[28:0] value.  A match indicates the the incoming address falls within the IMR3 region."},
#else
{0, 28, 0x0000000000000000, "RW", "IMR3_MASK", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo893[] = {{"B_CR_BIMR3MASK_0_0_0_MCHBAR", "", 0x000068D4, 4, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields894[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{0, 63, 0x00000C0061010202, "RW", "IMR3_CTRL_POL", "Bunit IMR3 Control Policy: Bit vector used to determine which agents are allowed access to the BIMR3RAC, BIMR3WAC, BIMR3CP registers based on the value from the agents 6bit SAI field."},
#else
{0, 63, 0x00000C0061010202, "RW", "IMR3_CTRL_POL", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo894[] = {{"B_CR_BIMR3CP_0_0_0_MCHBAR", "", 0x000068D8, 1, 0xFFFFFFFFFFFFFFFF, 0x00000C0061010202}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields895[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{63, 63, 0x0000000000000000, "RW", "IMR3_READ_POL_63", "Bunit IMR3 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR3 region based on the agents 6bit encoded SAI value."},
#else
{63, 63, 0x0000000000000000, "RW", "IMR3_READ_POL_63", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{62, 62, 0x0000000000000000, "RO", "IMR3_READ_POL_62", "Bunit IMR3 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR3 region based on the agents 6bit encoded SAI value."},
#else
{62, 62, 0x0000000000000000, "RO", "IMR3_READ_POL_62", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{61, 61, 0x0000000000000000, "RO", "IMR3_READ_POL_61", "Bunit IMR3 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR3 region based on the agents 6bit encoded SAI value."},
#else
{61, 61, 0x0000000000000000, "RO", "IMR3_READ_POL_61", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{60, 60, 0x0000000000000000, "RO", "IMR3_READ_POL_60", "Bunit IMR3 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR3 region based on the agents 6bit encoded SAI value."},
#else
{60, 60, 0x0000000000000000, "RO", "IMR3_READ_POL_60", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{59, 59, 0x0000000000000000, "RO", "IMR3_READ_POL_59", "Bunit IMR3 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR3 region based on the agents 6bit encoded SAI value."},
#else
{59, 59, 0x0000000000000000, "RO", "IMR3_READ_POL_59", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{58, 58, 0x0000000000000000, "RO", "IMR3_READ_POL_58", "Bunit IMR3 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR3 region based on the agents 6bit encoded SAI value."},
#else
{58, 58, 0x0000000000000000, "RO", "IMR3_READ_POL_58", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{57, 57, 0x0000000000000000, "RO", "IMR3_READ_POL_57", "Bunit IMR3 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR3 region based on the agents 6bit encoded SAI value."},
#else
{57, 57, 0x0000000000000000, "RO", "IMR3_READ_POL_57", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{56, 56, 0x0000000000000000, "RW", "IMR3_READ_POL_56", "Bunit IMR3 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR3 region based on the agents 6bit encoded SAI value."},
#else
{56, 56, 0x0000000000000000, "RW", "IMR3_READ_POL_56", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{55, 55, 0x0000000000000000, "RW", "IMR3_READ_POL_55", "Bunit IMR3 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR3 region based on the agents 6bit encoded SAI value."},
#else
{55, 55, 0x0000000000000000, "RW", "IMR3_READ_POL_55", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{54, 54, 0x0000000000000000, "RW", "IMR3_READ_POL_54", "Bunit IMR3 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR3 region based on the agents 6bit encoded SAI value."},
#else
{54, 54, 0x0000000000000000, "RW", "IMR3_READ_POL_54", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{53, 53, 0x0000000000000000, "RO", "IMR3_READ_POL_53", "Bunit IMR3 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR3 region based on the agents 6bit encoded SAI value."},
#else
{53, 53, 0x0000000000000000, "RO", "IMR3_READ_POL_53", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{52, 52, 0x0000000000000000, "RO", "IMR3_READ_POL_52", "Bunit IMR3 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR3 region based on the agents 6bit encoded SAI value."},
#else
{52, 52, 0x0000000000000000, "RO", "IMR3_READ_POL_52", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{51, 51, 0x0000000000000000, "RO", "IMR3_READ_POL_51", "Bunit IMR3 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR3 region based on the agents 6bit encoded SAI value."},
#else
{51, 51, 0x0000000000000000, "RO", "IMR3_READ_POL_51", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{50, 50, 0x0000000000000000, "RW", "IMR3_READ_POL_50", "Bunit IMR3 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR3 region based on the agents 6bit encoded SAI value."},
#else
{50, 50, 0x0000000000000000, "RW", "IMR3_READ_POL_50", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{49, 49, 0x0000000000000000, "RW", "IMR3_READ_POL_49", "Bunit IMR3 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR3 region based on the agents 6bit encoded SAI value."},
#else
{49, 49, 0x0000000000000000, "RW", "IMR3_READ_POL_49", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{48, 48, 0x0000000000000000, "RW", "IMR3_READ_POL_48", "Bunit IMR3 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR3 region based on the agents 6bit encoded SAI value."},
#else
{48, 48, 0x0000000000000000, "RW", "IMR3_READ_POL_48", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{47, 47, 0x0000000000000000, "RO", "IMR3_READ_POL_47", "Bunit IMR3 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR3 region based on the agents 6bit encoded SAI value."},
#else
{47, 47, 0x0000000000000000, "RO", "IMR3_READ_POL_47", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{46, 46, 0x0000000000000000, "RO", "IMR3_READ_POL_46", "Bunit IMR3 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR3 region based on the agents 6bit encoded SAI value."},
#else
{46, 46, 0x0000000000000000, "RO", "IMR3_READ_POL_46", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{45, 45, 0x0000000000000000, "RO", "IMR3_READ_POL_45", "Bunit IMR3 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR3 region based on the agents 6bit encoded SAI value."},
#else
{45, 45, 0x0000000000000000, "RO", "IMR3_READ_POL_45", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{44, 44, 0x0000000000000000, "RW", "IMR3_READ_POL_44", "Bunit IMR3 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR3 region based on the agents 6bit encoded SAI value."},
#else
{44, 44, 0x0000000000000000, "RW", "IMR3_READ_POL_44", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{43, 43, 0x0000000000000000, "RW", "IMR3_READ_POL_43", "Bunit IMR3 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR3 region based on the agents 6bit encoded SAI value."},
#else
{43, 43, 0x0000000000000000, "RW", "IMR3_READ_POL_43", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{42, 42, 0x0000000000000000, "RW", "IMR3_READ_POL_42", "Bunit IMR3 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR3 region based on the agents 6bit encoded SAI value."},
#else
{42, 42, 0x0000000000000000, "RW", "IMR3_READ_POL_42", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{41, 41, 0x0000000000000000, "RW", "IMR3_READ_POL_41", "Bunit IMR3 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR3 region based on the agents 6bit encoded SAI value."},
#else
{41, 41, 0x0000000000000000, "RW", "IMR3_READ_POL_41", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{40, 40, 0x0000000000000000, "RW", "IMR3_READ_POL_40", "Bunit IMR3 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR3 region based on the agents 6bit encoded SAI value."},
#else
{40, 40, 0x0000000000000000, "RW", "IMR3_READ_POL_40", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{39, 39, 0x0000000000000000, "RO", "IMR3_READ_POL_39", "Bunit IMR3 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR3 region based on the agents 6bit encoded SAI value."},
#else
{39, 39, 0x0000000000000000, "RO", "IMR3_READ_POL_39", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{38, 38, 0x0000000000000000, "RW", "IMR3_READ_POL_38", "Bunit IMR3 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR3 region based on the agents 6bit encoded SAI value."},
#else
{38, 38, 0x0000000000000000, "RW", "IMR3_READ_POL_38", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{37, 37, 0x0000000000000000, "RO", "IMR3_READ_POL_37", "Bunit IMR3 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR3 region based on the agents 6bit encoded SAI value."},
#else
{37, 37, 0x0000000000000000, "RO", "IMR3_READ_POL_37", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{36, 36, 0x0000000000000000, "RW", "IMR3_READ_POL_36", "Bunit IMR3 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR3 region based on the agents 6bit encoded SAI value."},
#else
{36, 36, 0x0000000000000000, "RW", "IMR3_READ_POL_36", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{35, 35, 0x0000000000000000, "RO", "IMR3_READ_POL_35", "Bunit IMR3 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR3 region based on the agents 6bit encoded SAI value."},
#else
{35, 35, 0x0000000000000000, "RO", "IMR3_READ_POL_35", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{34, 34, 0x0000000000000000, "RW", "IMR3_READ_POL_34", "Bunit IMR3 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR3 region based on the agents 6bit encoded SAI value."},
#else
{34, 34, 0x0000000000000000, "RW", "IMR3_READ_POL_34", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{33, 33, 0x0000000000000000, "RW", "IMR3_READ_POL_33", "Bunit IMR3 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR3 region based on the agents 6bit encoded SAI value."},
#else
{33, 33, 0x0000000000000000, "RW", "IMR3_READ_POL_33", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{32, 32, 0x0000000000000000, "RW", "IMR3_READ_POL_32", "Bunit IMR3 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR3 region based on the agents 6bit encoded SAI value."},
#else
{32, 32, 0x0000000000000000, "RW", "IMR3_READ_POL_32", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{31, 31, 0x0000000000000000, "RO", "IMR3_READ_POL_31", "Bunit IMR3 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR3 region based on the agents 6bit encoded SAI value."},
#else
{31, 31, 0x0000000000000000, "RO", "IMR3_READ_POL_31", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{30, 30, 0x0000000000000000, "RW", "IMR3_READ_POL_30", "Bunit IMR3 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR3 region based on the agents 6bit encoded SAI value."},
#else
{30, 30, 0x0000000000000000, "RW", "IMR3_READ_POL_30", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{29, 29, 0x0000000000000000, "RW", "IMR3_READ_POL_29", "Bunit IMR3 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR3 region based on the agents 6bit encoded SAI value."},
#else
{29, 29, 0x0000000000000000, "RW", "IMR3_READ_POL_29", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{28, 28, 0x0000000000000000, "RW", "IMR3_READ_POL_28", "Bunit IMR3 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR3 region based on the agents 6bit encoded SAI value."},
#else
{28, 28, 0x0000000000000000, "RW", "IMR3_READ_POL_28", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{27, 27, 0x0000000000000000, "RW", "IMR3_READ_POL_27", "Bunit IMR3 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR3 region based on the agents 6bit encoded SAI value."},
#else
{27, 27, 0x0000000000000000, "RW", "IMR3_READ_POL_27", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{26, 26, 0x0000000000000000, "RW", "IMR3_READ_POL_26", "Bunit IMR3 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR3 region based on the agents 6bit encoded SAI value."},
#else
{26, 26, 0x0000000000000000, "RW", "IMR3_READ_POL_26", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{25, 25, 0x0000000000000000, "RW", "IMR3_READ_POL_25", "Bunit IMR3 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR3 region based on the agents 6bit encoded SAI value."},
#else
{25, 25, 0x0000000000000000, "RW", "IMR3_READ_POL_25", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{24, 24, 0x0000000000000000, "RW", "IMR3_READ_POL_24", "Bunit IMR3 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR3 region based on the agents 6bit encoded SAI value."},
#else
{24, 24, 0x0000000000000000, "RW", "IMR3_READ_POL_24", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{23, 23, 0x0000000000000000, "RO", "IMR3_READ_POL_23", "Bunit IMR3 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR3 region based on the agents 6bit encoded SAI value."},
#else
{23, 23, 0x0000000000000000, "RO", "IMR3_READ_POL_23", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{22, 22, 0x0000000000000000, "RO", "IMR3_READ_POL_22", "Bunit IMR3 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR3 region based on the agents 6bit encoded SAI value."},
#else
{22, 22, 0x0000000000000000, "RO", "IMR3_READ_POL_22", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{21, 21, 0x0000000000000000, "RW", "IMR3_READ_POL_21", "Bunit IMR3 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR3 region based on the agents 6bit encoded SAI value."},
#else
{21, 21, 0x0000000000000000, "RW", "IMR3_READ_POL_21", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{20, 20, 0x0000000000000000, "RO", "IMR3_READ_POL_20", "Bunit IMR3 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR3 region based on the agents 6bit encoded SAI value."},
#else
{20, 20, 0x0000000000000000, "RO", "IMR3_READ_POL_20", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{19, 19, 0x0000000000000000, "RO", "IMR3_READ_POL_19", "Bunit IMR3 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR3 region based on the agents 6bit encoded SAI value."},
#else
{19, 19, 0x0000000000000000, "RO", "IMR3_READ_POL_19", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{18, 18, 0x0000000000000000, "RO", "IMR3_READ_POL_18", "Bunit IMR3 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR3 region based on the agents 6bit encoded SAI value."},
#else
{18, 18, 0x0000000000000000, "RO", "IMR3_READ_POL_18", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{17, 17, 0x0000000000000000, "RW", "IMR3_READ_POL_17", "Bunit IMR3 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR3 region based on the agents 6bit encoded SAI value."},
#else
{17, 17, 0x0000000000000000, "RW", "IMR3_READ_POL_17", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{16, 16, 0x0000000000000000, "RW", "IMR3_READ_POL_16", "Bunit IMR3 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR3 region based on the agents 6bit encoded SAI value."},
#else
{16, 16, 0x0000000000000000, "RW", "IMR3_READ_POL_16", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{15, 15, 0x0000000000000000, "RO", "IMR3_READ_POL_15", "Bunit IMR3 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR3 region based on the agents 6bit encoded SAI value."},
#else
{15, 15, 0x0000000000000000, "RO", "IMR3_READ_POL_15", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{14, 14, 0x0000000000000000, "RO", "IMR3_READ_POL_14", "Bunit IMR3 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR3 region based on the agents 6bit encoded SAI value."},
#else
{14, 14, 0x0000000000000000, "RO", "IMR3_READ_POL_14", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{13, 13, 0x0000000000000000, "RW", "IMR3_READ_POL_13", "Bunit IMR3 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR3 region based on the agents 6bit encoded SAI value."},
#else
{13, 13, 0x0000000000000000, "RW", "IMR3_READ_POL_13", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{12, 12, 0x0000000000000000, "RW", "IMR3_READ_POL_12", "Bunit IMR3 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR3 region based on the agents 6bit encoded SAI value."},
#else
{12, 12, 0x0000000000000000, "RW", "IMR3_READ_POL_12", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{11, 11, 0x0000000000000000, "RO", "IMR3_READ_POL_11", "Bunit IMR3 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR3 region based on the agents 6bit encoded SAI value."},
#else
{11, 11, 0x0000000000000000, "RO", "IMR3_READ_POL_11", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{10, 10, 0x0000000000000000, "RO", "IMR3_READ_POL_10", "Bunit IMR3 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR3 region based on the agents 6bit encoded SAI value."},
#else
{10, 10, 0x0000000000000000, "RO", "IMR3_READ_POL_10", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{9, 9, 0x0000000000000000, "RO", "IMR3_READ_POL_9", "Bunit IMR3 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR3 region based on the agents 6bit encoded SAI value."},
#else
{9, 9, 0x0000000000000000, "RO", "IMR3_READ_POL_9", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{8, 8, 0x0000000000000000, "RW", "IMR3_READ_POL_8", "Bunit IMR3 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR3 region based on the agents 6bit encoded SAI value."},
#else
{8, 8, 0x0000000000000000, "RW", "IMR3_READ_POL_8", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{7, 7, 0x0000000000000000, "RO", "IMR3_READ_POL_7", "Bunit IMR3 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR3 region based on the agents 6bit encoded SAI value."},
#else
{7, 7, 0x0000000000000000, "RO", "IMR3_READ_POL_7", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{6, 6, 0x0000000000000000, "RO", "IMR3_READ_POL_6", "Bunit IMR3 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR3 region based on the agents 6bit encoded SAI value."},
#else
{6, 6, 0x0000000000000000, "RO", "IMR3_READ_POL_6", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{5, 5, 0x0000000000000000, "RW", "IMR3_READ_POL_5", "Bunit IMR3 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR3 region based on the agents 6bit encoded SAI value."},
#else
{5, 5, 0x0000000000000000, "RW", "IMR3_READ_POL_5", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{4, 4, 0x0000000000000000, "RW", "IMR3_READ_POL_4", "Bunit IMR3 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR3 region based on the agents 6bit encoded SAI value."},
#else
{4, 4, 0x0000000000000000, "RW", "IMR3_READ_POL_4", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{3, 3, 0x0000000000000000, "RW", "IMR3_READ_POL_3", "Bunit IMR3 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR3 region based on the agents 6bit encoded SAI value."},
#else
{3, 3, 0x0000000000000000, "RW", "IMR3_READ_POL_3", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{2, 2, 0x0000000000000000, "RW", "IMR3_READ_POL_2", "Bunit IMR3 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR3 region based on the agents 6bit encoded SAI value."},
#else
{2, 2, 0x0000000000000000, "RW", "IMR3_READ_POL_2", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{1, 1, 0x0000000000000000, "RW", "IMR3_READ_POL_1", "Bunit IMR3 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR3 region based on the agents 6bit encoded SAI value."},
#else
{1, 1, 0x0000000000000000, "RW", "IMR3_READ_POL_1", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 0, 0x0000000000000000, "RW", "IMR3_READ_POL_0", "Bunit IMR3 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR3 region based on the agents 6bit encoded SAI value."},
#else
{0, 0, 0x0000000000000000, "RW", "IMR3_READ_POL_0", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo895[] = {{"B_CR_BIMR3RAC_0_0_0_MCHBAR", "", 0x000068E0, 64, 0xFFFFFFFFFFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields896[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{63, 63, 0x0000000000000000, "RW", "IMR3_WRITE_POL_63", "Bunit IMR3 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR3 region based on the agents 6bit encoded SAI value."},
#else
{63, 63, 0x0000000000000000, "RW", "IMR3_WRITE_POL_63", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{62, 62, 0x0000000000000000, "RO", "IMR3_WRITE_POL_62", "Bunit IMR3 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR3 region based on the agents 6bit encoded SAI value."},
#else
{62, 62, 0x0000000000000000, "RO", "IMR3_WRITE_POL_62", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{61, 61, 0x0000000000000000, "RO", "IMR3_WRITE_POL_61", "Bunit IMR3 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR3 region based on the agents 6bit encoded SAI value."},
#else
{61, 61, 0x0000000000000000, "RO", "IMR3_WRITE_POL_61", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{60, 60, 0x0000000000000000, "RO", "IMR3_WRITE_POL_60", "Bunit IMR3 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR3 region based on the agents 6bit encoded SAI value."},
#else
{60, 60, 0x0000000000000000, "RO", "IMR3_WRITE_POL_60", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{59, 59, 0x0000000000000000, "RO", "IMR3_WRITE_POL_59", "Bunit IMR3 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR3 region based on the agents 6bit encoded SAI value."},
#else
{59, 59, 0x0000000000000000, "RO", "IMR3_WRITE_POL_59", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{58, 58, 0x0000000000000000, "RO", "IMR3_WRITE_POL_58", "Bunit IMR3 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR3 region based on the agents 6bit encoded SAI value."},
#else
{58, 58, 0x0000000000000000, "RO", "IMR3_WRITE_POL_58", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{57, 57, 0x0000000000000000, "RO", "IMR3_WRITE_POL_57", "Bunit IMR3 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR3 region based on the agents 6bit encoded SAI value."},
#else
{57, 57, 0x0000000000000000, "RO", "IMR3_WRITE_POL_57", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{56, 56, 0x0000000000000000, "RW", "IMR3_WRITE_POL_56", "Bunit IMR3 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR3 region based on the agents 6bit encoded SAI value."},
#else
{56, 56, 0x0000000000000000, "RW", "IMR3_WRITE_POL_56", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{55, 55, 0x0000000000000000, "RW", "IMR3_WRITE_POL_55", "Bunit IMR3 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR3 region based on the agents 6bit encoded SAI value."},
#else
{55, 55, 0x0000000000000000, "RW", "IMR3_WRITE_POL_55", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{54, 54, 0x0000000000000000, "RW", "IMR3_WRITE_POL_54", "Bunit IMR3 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR3 region based on the agents 6bit encoded SAI value."},
#else
{54, 54, 0x0000000000000000, "RW", "IMR3_WRITE_POL_54", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{53, 53, 0x0000000000000000, "RO", "IMR3_WRITE_POL_53", "Bunit IMR3 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR3 region based on the agents 6bit encoded SAI value."},
#else
{53, 53, 0x0000000000000000, "RO", "IMR3_WRITE_POL_53", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{52, 52, 0x0000000000000000, "RO", "IMR3_WRITE_POL_52", "Bunit IMR3 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR3 region based on the agents 6bit encoded SAI value."},
#else
{52, 52, 0x0000000000000000, "RO", "IMR3_WRITE_POL_52", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{51, 51, 0x0000000000000000, "RO", "IMR3_WRITE_POL_51", "Bunit IMR3 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR3 region based on the agents 6bit encoded SAI value."},
#else
{51, 51, 0x0000000000000000, "RO", "IMR3_WRITE_POL_51", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{50, 50, 0x0000000000000000, "RW", "IMR3_WRITE_POL_50", "Bunit IMR3 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR3 region based on the agents 6bit encoded SAI value."},
#else
{50, 50, 0x0000000000000000, "RW", "IMR3_WRITE_POL_50", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{49, 49, 0x0000000000000000, "RW", "IMR3_WRITE_POL_49", "Bunit IMR3 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR3 region based on the agents 6bit encoded SAI value."},
#else
{49, 49, 0x0000000000000000, "RW", "IMR3_WRITE_POL_49", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{48, 48, 0x0000000000000000, "RW", "IMR3_WRITE_POL_48", "Bunit IMR3 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR3 region based on the agents 6bit encoded SAI value."},
#else
{48, 48, 0x0000000000000000, "RW", "IMR3_WRITE_POL_48", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{47, 47, 0x0000000000000000, "RO", "IMR3_WRITE_POL_47", "Bunit IMR3 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR3 region based on the agents 6bit encoded SAI value."},
#else
{47, 47, 0x0000000000000000, "RO", "IMR3_WRITE_POL_47", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{46, 46, 0x0000000000000000, "RO", "IMR3_WRITE_POL_46", "Bunit IMR3 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR3 region based on the agents 6bit encoded SAI value."},
#else
{46, 46, 0x0000000000000000, "RO", "IMR3_WRITE_POL_46", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{45, 45, 0x0000000000000000, "RO", "IMR3_WRITE_POL_45", "Bunit IMR3 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR3 region based on the agents 6bit encoded SAI value."},
#else
{45, 45, 0x0000000000000000, "RO", "IMR3_WRITE_POL_45", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{44, 44, 0x0000000000000000, "RW", "IMR3_WRITE_POL_44", "Bunit IMR3 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR3 region based on the agents 6bit encoded SAI value."},
#else
{44, 44, 0x0000000000000000, "RW", "IMR3_WRITE_POL_44", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{43, 43, 0x0000000000000000, "RW", "IMR3_WRITE_POL_43", "Bunit IMR3 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR3 region based on the agents 6bit encoded SAI value."},
#else
{43, 43, 0x0000000000000000, "RW", "IMR3_WRITE_POL_43", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{42, 42, 0x0000000000000000, "RW", "IMR3_WRITE_POL_42", "Bunit IMR3 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR3 region based on the agents 6bit encoded SAI value."},
#else
{42, 42, 0x0000000000000000, "RW", "IMR3_WRITE_POL_42", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{41, 41, 0x0000000000000000, "RW", "IMR3_WRITE_POL_41", "Bunit IMR3 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR3 region based on the agents 6bit encoded SAI value."},
#else
{41, 41, 0x0000000000000000, "RW", "IMR3_WRITE_POL_41", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{40, 40, 0x0000000000000000, "RW", "IMR3_WRITE_POL_40", "Bunit IMR3 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR3 region based on the agents 6bit encoded SAI value."},
#else
{40, 40, 0x0000000000000000, "RW", "IMR3_WRITE_POL_40", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{39, 39, 0x0000000000000000, "RO", "IMR3_WRITE_POL_39", "Bunit IMR3 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR3 region based on the agents 6bit encoded SAI value."},
#else
{39, 39, 0x0000000000000000, "RO", "IMR3_WRITE_POL_39", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{38, 38, 0x0000000000000000, "RW", "IMR3_WRITE_POL_38", "Bunit IMR3 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR3 region based on the agents 6bit encoded SAI value."},
#else
{38, 38, 0x0000000000000000, "RW", "IMR3_WRITE_POL_38", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{37, 37, 0x0000000000000000, "RO", "IMR3_WRITE_POL_37", "Bunit IMR3 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR3 region based on the agents 6bit encoded SAI value."},
#else
{37, 37, 0x0000000000000000, "RO", "IMR3_WRITE_POL_37", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{36, 36, 0x0000000000000000, "RW", "IMR3_WRITE_POL_36", "Bunit IMR3 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR3 region based on the agents 6bit encoded SAI value."},
#else
{36, 36, 0x0000000000000000, "RW", "IMR3_WRITE_POL_36", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{35, 35, 0x0000000000000000, "RO", "IMR3_WRITE_POL_35", "Bunit IMR3 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR3 region based on the agents 6bit encoded SAI value."},
#else
{35, 35, 0x0000000000000000, "RO", "IMR3_WRITE_POL_35", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{34, 34, 0x0000000000000000, "RW", "IMR3_WRITE_POL_34", "Bunit IMR3 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR3 region based on the agents 6bit encoded SAI value."},
#else
{34, 34, 0x0000000000000000, "RW", "IMR3_WRITE_POL_34", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{33, 33, 0x0000000000000000, "RW", "IMR3_WRITE_POL_33", "Bunit IMR3 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR3 region based on the agents 6bit encoded SAI value."},
#else
{33, 33, 0x0000000000000000, "RW", "IMR3_WRITE_POL_33", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{32, 32, 0x0000000000000000, "RW", "IMR3_WRITE_POL_32", "Bunit IMR3 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR3 region based on the agents 6bit encoded SAI value."},
#else
{32, 32, 0x0000000000000000, "RW", "IMR3_WRITE_POL_32", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{31, 31, 0x0000000000000000, "RO", "IMR3_WRITE_POL_31", "Bunit IMR3 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR3 region based on the agents 6bit encoded SAI value."},
#else
{31, 31, 0x0000000000000000, "RO", "IMR3_WRITE_POL_31", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{30, 30, 0x0000000000000000, "RW", "IMR3_WRITE_POL_30", "Bunit IMR3 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR3 region based on the agents 6bit encoded SAI value."},
#else
{30, 30, 0x0000000000000000, "RW", "IMR3_WRITE_POL_30", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{29, 29, 0x0000000000000000, "RW", "IMR3_WRITE_POL_29", "Bunit IMR3 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR3 region based on the agents 6bit encoded SAI value."},
#else
{29, 29, 0x0000000000000000, "RW", "IMR3_WRITE_POL_29", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{28, 28, 0x0000000000000000, "RW", "IMR3_WRITE_POL_28", "Bunit IMR3 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR3 region based on the agents 6bit encoded SAI value."},
#else
{28, 28, 0x0000000000000000, "RW", "IMR3_WRITE_POL_28", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{27, 27, 0x0000000000000000, "RW", "IMR3_WRITE_POL_27", "Bunit IMR3 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR3 region based on the agents 6bit encoded SAI value."},
#else
{27, 27, 0x0000000000000000, "RW", "IMR3_WRITE_POL_27", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{26, 26, 0x0000000000000000, "RW", "IMR3_WRITE_POL_26", "Bunit IMR3 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR3 region based on the agents 6bit encoded SAI value."},
#else
{26, 26, 0x0000000000000000, "RW", "IMR3_WRITE_POL_26", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{25, 25, 0x0000000000000000, "RW", "IMR3_WRITE_POL_25", "Bunit IMR3 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR3 region based on the agents 6bit encoded SAI value."},
#else
{25, 25, 0x0000000000000000, "RW", "IMR3_WRITE_POL_25", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{24, 24, 0x0000000000000000, "RW", "IMR3_WRITE_POL_24", "Bunit IMR3 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR3 region based on the agents 6bit encoded SAI value."},
#else
{24, 24, 0x0000000000000000, "RW", "IMR3_WRITE_POL_24", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{23, 23, 0x0000000000000000, "RO", "IMR3_WRITE_POL_23", "Bunit IMR3 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR3 region based on the agents 6bit encoded SAI value."},
#else
{23, 23, 0x0000000000000000, "RO", "IMR3_WRITE_POL_23", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{22, 22, 0x0000000000000000, "RO", "IMR3_WRITE_POL_22", "Bunit IMR3 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR3 region based on the agents 6bit encoded SAI value."},
#else
{22, 22, 0x0000000000000000, "RO", "IMR3_WRITE_POL_22", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{21, 21, 0x0000000000000000, "RW", "IMR3_WRITE_POL_21", "Bunit IMR3 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR3 region based on the agents 6bit encoded SAI value."},
#else
{21, 21, 0x0000000000000000, "RW", "IMR3_WRITE_POL_21", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{20, 20, 0x0000000000000000, "RO", "IMR3_WRITE_POL_20", "Bunit IMR3 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR3 region based on the agents 6bit encoded SAI value."},
#else
{20, 20, 0x0000000000000000, "RO", "IMR3_WRITE_POL_20", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{19, 19, 0x0000000000000000, "RO", "IMR3_WRITE_POL_19", "Bunit IMR3 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR3 region based on the agents 6bit encoded SAI value."},
#else
{19, 19, 0x0000000000000000, "RO", "IMR3_WRITE_POL_19", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{18, 18, 0x0000000000000000, "RO", "IMR3_WRITE_POL_18", "Bunit IMR3 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR3 region based on the agents 6bit encoded SAI value."},
#else
{18, 18, 0x0000000000000000, "RO", "IMR3_WRITE_POL_18", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{17, 17, 0x0000000000000000, "RW", "IMR3_WRITE_POL_17", "Bunit IMR3 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR3 region based on the agents 6bit encoded SAI value."},
#else
{17, 17, 0x0000000000000000, "RW", "IMR3_WRITE_POL_17", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{16, 16, 0x0000000000000000, "RW", "IMR3_WRITE_POL_16", "Bunit IMR3 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR3 region based on the agents 6bit encoded SAI value."},
#else
{16, 16, 0x0000000000000000, "RW", "IMR3_WRITE_POL_16", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{15, 15, 0x0000000000000000, "RO", "IMR3_WRITE_POL_15", "Bunit IMR3 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR3 region based on the agents 6bit encoded SAI value."},
#else
{15, 15, 0x0000000000000000, "RO", "IMR3_WRITE_POL_15", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{14, 14, 0x0000000000000000, "RO", "IMR3_WRITE_POL_14", "Bunit IMR3 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR3 region based on the agents 6bit encoded SAI value."},
#else
{14, 14, 0x0000000000000000, "RO", "IMR3_WRITE_POL_14", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{13, 13, 0x0000000000000000, "RW", "IMR3_WRITE_POL_13", "Bunit IMR3 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR3 region based on the agents 6bit encoded SAI value."},
#else
{13, 13, 0x0000000000000000, "RW", "IMR3_WRITE_POL_13", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{12, 12, 0x0000000000000000, "RW", "IMR3_WRITE_POL_12", "Bunit IMR3 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR3 region based on the agents 6bit encoded SAI value."},
#else
{12, 12, 0x0000000000000000, "RW", "IMR3_WRITE_POL_12", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{11, 11, 0x0000000000000000, "RO", "IMR3_WRITE_POL_11", "Bunit IMR3 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR3 region based on the agents 6bit encoded SAI value."},
#else
{11, 11, 0x0000000000000000, "RO", "IMR3_WRITE_POL_11", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{10, 10, 0x0000000000000000, "RO", "IMR3_WRITE_POL_10", "Bunit IMR3 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR3 region based on the agents 6bit encoded SAI value."},
#else
{10, 10, 0x0000000000000000, "RO", "IMR3_WRITE_POL_10", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{9, 9, 0x0000000000000000, "RO", "IMR3_WRITE_POL_9", "Bunit IMR3 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR3 region based on the agents 6bit encoded SAI value."},
#else
{9, 9, 0x0000000000000000, "RO", "IMR3_WRITE_POL_9", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{8, 8, 0x0000000000000000, "RW", "IMR3_WRITE_POL_8", "Bunit IMR3 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR3 region based on the agents 6bit encoded SAI value."},
#else
{8, 8, 0x0000000000000000, "RW", "IMR3_WRITE_POL_8", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{7, 7, 0x0000000000000000, "RO", "IMR3_WRITE_POL_7", "Bunit IMR3 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR3 region based on the agents 6bit encoded SAI value."},
#else
{7, 7, 0x0000000000000000, "RO", "IMR3_WRITE_POL_7", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{6, 6, 0x0000000000000000, "RO", "IMR3_WRITE_POL_6", "Bunit IMR3 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR3 region based on the agents 6bit encoded SAI value."},
#else
{6, 6, 0x0000000000000000, "RO", "IMR3_WRITE_POL_6", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{5, 5, 0x0000000000000000, "RW", "IMR3_WRITE_POL_5", "Bunit IMR3 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR3 region based on the agents 6bit encoded SAI value."},
#else
{5, 5, 0x0000000000000000, "RW", "IMR3_WRITE_POL_5", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{4, 4, 0x0000000000000000, "RW", "IMR3_WRITE_POL_4", "Bunit IMR3 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR3 region based on the agents 6bit encoded SAI value."},
#else
{4, 4, 0x0000000000000000, "RW", "IMR3_WRITE_POL_4", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{3, 3, 0x0000000000000000, "RW", "IMR3_WRITE_POL_3", "Bunit IMR3 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR3 region based on the agents 6bit encoded SAI value."},
#else
{3, 3, 0x0000000000000000, "RW", "IMR3_WRITE_POL_3", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{2, 2, 0x0000000000000000, "RW", "IMR3_WRITE_POL_2", "Bunit IMR3 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR3 region based on the agents 6bit encoded SAI value."},
#else
{2, 2, 0x0000000000000000, "RW", "IMR3_WRITE_POL_2", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{1, 1, 0x0000000000000000, "RW", "IMR3_WRITE_POL_1", "Bunit IMR3 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR3 region based on the agents 6bit encoded SAI value."},
#else
{1, 1, 0x0000000000000000, "RW", "IMR3_WRITE_POL_1", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 0, 0x0000000000000000, "RW", "IMR3_WRITE_POL_0", "Bunit IMR3 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR3 region based on the agents 6bit encoded SAI value."},
#else
{0, 0, 0x0000000000000000, "RW", "IMR3_WRITE_POL_0", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo896[] = {{"B_CR_BIMR3WAC_0_0_0_MCHBAR", "", 0x000068E8, 64, 0xFFFFFFFFFFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields897[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{31, 31, 0x0000000000000000, "RW", "IMR_EN", "IMR Enable: Enables access checking for the IMR region."},
#else
{31, 31, 0x0000000000000000, "RW", "IMR_EN", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{30, 30, 0x0000000000000000, "RW", "TR_EN", "Asset Classification AC[0]: Trace Enable: Enables snooping of transactions to the IMR region by tracing agents."},
#else
{30, 30, 0x0000000000000000, "RW", "TR_EN", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{29, 29, 0x0000000000000000, "RO", "RESERVED_1", "Reserved"},
#else
{29, 29, 0x0000000000000000, "RO", "RESERVED_1", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 28, 0x0000000000000000, "RW", "IMR4_BASE", "Base 0 IMR4BASE:  Specifies bits 38:10 of the start address of IMR4 region.  IMR region size must be a strict poweroftwo at least 1KB and naturally aligned to the size.  These bits are compared with the result of the IMR4MASK[28:0] applied to bits 38:10 of the incoming address to determine if an access falls within the IMR4 defined region."},
#else
{0, 28, 0x0000000000000000, "RW", "IMR4_BASE", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo897[] = {{"B_CR_BIMR4BASE_0_0_0_MCHBAR", "", 0x000068F0, 4, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields898[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{31, 31, 0x0000000000000000, "RW", "GT_IWB_EN", "Asset Classification AC[2]: GT Implicit WB Enable: Enables implicit writebacks to protected region from GT caching agent. When set to 1 enables implicit writeback data HITM data from GT to be returned to the requester.  When set to 0 inhibits HITM data from GT from being returned to the requester.  HITM data from IA cores may be returned to the requester depending on the setting of the IA_IWB_EN bit."},
#else
{31, 31, 0x0000000000000000, "RW", "GT_IWB_EN", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{30, 30, 0x0000000000000000, "RW", "IA_IWB_EN", "Asset Classification AC[1]: IA Implicit WB Enable: Enables implicit writebacks to protected region from IA caching agent.  When set to 1 enables implicit writeback data HITM data from IA cores to be returned to the requester.  When set to 0 inhibits HITM data from IA cores from being returned to the requester.  HITM data from GT may be returned to the requester depending on the setting of the GT_IWB_EN bit."},
#else
{30, 30, 0x0000000000000000, "RW", "IA_IWB_EN", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{29, 29, 0x0000000000000000, "RO", "RESERVED_0", "Reserved"},
#else
{29, 29, 0x0000000000000000, "RO", "RESERVED_0", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 28, 0x0000000000000000, "RW", "IMR4_MASK", "Mask 0 IMR4MASK:  These bits are ANDed with bits 38:10 of the incoming address to determine if the combined result matches the IMR4BASE[28:0] value.  A match indicates the the incoming address falls within the IMR4 region."},
#else
{0, 28, 0x0000000000000000, "RW", "IMR4_MASK", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo898[] = {{"B_CR_BIMR4MASK_0_0_0_MCHBAR", "", 0x000068F4, 4, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields899[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{0, 63, 0x00000C0061010202, "RW", "IMR4_CTRL_POL", "Bunit IMR4 Control Policy: Bit vector used to determine which agents are allowed access to the BIMR4RAC, BIMR4WAC, BIMR4CP registers based on the value from the agents 6bit SAI field."},
#else
{0, 63, 0x00000C0061010202, "RW", "IMR4_CTRL_POL", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo899[] = {{"B_CR_BIMR4CP_0_0_0_MCHBAR", "", 0x000068F8, 1, 0xFFFFFFFFFFFFFFFF, 0x00000C0061010202}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields900[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{63, 63, 0x0000000000000000, "RW", "IMR4_READ_POL_63", "Bunit IMR4 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR4 region based on the agents 6bit encoded SAI value."},
#else
{63, 63, 0x0000000000000000, "RW", "IMR4_READ_POL_63", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{62, 62, 0x0000000000000000, "RO", "IMR4_READ_POL_62", "Bunit IMR4 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR4 region based on the agents 6bit encoded SAI value."},
#else
{62, 62, 0x0000000000000000, "RO", "IMR4_READ_POL_62", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{61, 61, 0x0000000000000000, "RO", "IMR4_READ_POL_61", "Bunit IMR4 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR4 region based on the agents 6bit encoded SAI value."},
#else
{61, 61, 0x0000000000000000, "RO", "IMR4_READ_POL_61", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{60, 60, 0x0000000000000000, "RO", "IMR4_READ_POL_60", "Bunit IMR4 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR4 region based on the agents 6bit encoded SAI value."},
#else
{60, 60, 0x0000000000000000, "RO", "IMR4_READ_POL_60", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{59, 59, 0x0000000000000000, "RO", "IMR4_READ_POL_59", "Bunit IMR4 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR4 region based on the agents 6bit encoded SAI value."},
#else
{59, 59, 0x0000000000000000, "RO", "IMR4_READ_POL_59", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{58, 58, 0x0000000000000000, "RO", "IMR4_READ_POL_58", "Bunit IMR4 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR4 region based on the agents 6bit encoded SAI value."},
#else
{58, 58, 0x0000000000000000, "RO", "IMR4_READ_POL_58", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{57, 57, 0x0000000000000000, "RO", "IMR4_READ_POL_57", "Bunit IMR4 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR4 region based on the agents 6bit encoded SAI value."},
#else
{57, 57, 0x0000000000000000, "RO", "IMR4_READ_POL_57", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{56, 56, 0x0000000000000000, "RW", "IMR4_READ_POL_56", "Bunit IMR4 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR4 region based on the agents 6bit encoded SAI value."},
#else
{56, 56, 0x0000000000000000, "RW", "IMR4_READ_POL_56", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{55, 55, 0x0000000000000000, "RW", "IMR4_READ_POL_55", "Bunit IMR4 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR4 region based on the agents 6bit encoded SAI value."},
#else
{55, 55, 0x0000000000000000, "RW", "IMR4_READ_POL_55", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{54, 54, 0x0000000000000000, "RW", "IMR4_READ_POL_54", "Bunit IMR4 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR4 region based on the agents 6bit encoded SAI value."},
#else
{54, 54, 0x0000000000000000, "RW", "IMR4_READ_POL_54", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{53, 53, 0x0000000000000000, "RO", "IMR4_READ_POL_53", "Bunit IMR4 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR4 region based on the agents 6bit encoded SAI value."},
#else
{53, 53, 0x0000000000000000, "RO", "IMR4_READ_POL_53", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{52, 52, 0x0000000000000000, "RO", "IMR4_READ_POL_52", "Bunit IMR4 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR4 region based on the agents 6bit encoded SAI value."},
#else
{52, 52, 0x0000000000000000, "RO", "IMR4_READ_POL_52", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{51, 51, 0x0000000000000000, "RO", "IMR4_READ_POL_51", "Bunit IMR4 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR4 region based on the agents 6bit encoded SAI value."},
#else
{51, 51, 0x0000000000000000, "RO", "IMR4_READ_POL_51", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{50, 50, 0x0000000000000000, "RW", "IMR4_READ_POL_50", "Bunit IMR4 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR4 region based on the agents 6bit encoded SAI value."},
#else
{50, 50, 0x0000000000000000, "RW", "IMR4_READ_POL_50", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{49, 49, 0x0000000000000000, "RW", "IMR4_READ_POL_49", "Bunit IMR4 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR4 region based on the agents 6bit encoded SAI value."},
#else
{49, 49, 0x0000000000000000, "RW", "IMR4_READ_POL_49", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{48, 48, 0x0000000000000000, "RW", "IMR4_READ_POL_48", "Bunit IMR4 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR4 region based on the agents 6bit encoded SAI value."},
#else
{48, 48, 0x0000000000000000, "RW", "IMR4_READ_POL_48", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{47, 47, 0x0000000000000000, "RO", "IMR4_READ_POL_47", "Bunit IMR4 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR4 region based on the agents 6bit encoded SAI value."},
#else
{47, 47, 0x0000000000000000, "RO", "IMR4_READ_POL_47", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{46, 46, 0x0000000000000000, "RO", "IMR4_READ_POL_46", "Bunit IMR4 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR4 region based on the agents 6bit encoded SAI value."},
#else
{46, 46, 0x0000000000000000, "RO", "IMR4_READ_POL_46", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{45, 45, 0x0000000000000000, "RO", "IMR4_READ_POL_45", "Bunit IMR4 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR4 region based on the agents 6bit encoded SAI value."},
#else
{45, 45, 0x0000000000000000, "RO", "IMR4_READ_POL_45", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{44, 44, 0x0000000000000000, "RW", "IMR4_READ_POL_44", "Bunit IMR4 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR4 region based on the agents 6bit encoded SAI value."},
#else
{44, 44, 0x0000000000000000, "RW", "IMR4_READ_POL_44", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{43, 43, 0x0000000000000000, "RW", "IMR4_READ_POL_43", "Bunit IMR4 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR4 region based on the agents 6bit encoded SAI value."},
#else
{43, 43, 0x0000000000000000, "RW", "IMR4_READ_POL_43", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{42, 42, 0x0000000000000000, "RW", "IMR4_READ_POL_42", "Bunit IMR4 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR4 region based on the agents 6bit encoded SAI value."},
#else
{42, 42, 0x0000000000000000, "RW", "IMR4_READ_POL_42", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{41, 41, 0x0000000000000000, "RW", "IMR4_READ_POL_41", "Bunit IMR4 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR4 region based on the agents 6bit encoded SAI value."},
#else
{41, 41, 0x0000000000000000, "RW", "IMR4_READ_POL_41", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{40, 40, 0x0000000000000000, "RW", "IMR4_READ_POL_40", "Bunit IMR4 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR4 region based on the agents 6bit encoded SAI value."},
#else
{40, 40, 0x0000000000000000, "RW", "IMR4_READ_POL_40", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{39, 39, 0x0000000000000000, "RO", "IMR4_READ_POL_39", "Bunit IMR4 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR4 region based on the agents 6bit encoded SAI value."},
#else
{39, 39, 0x0000000000000000, "RO", "IMR4_READ_POL_39", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{38, 38, 0x0000000000000000, "RW", "IMR4_READ_POL_38", "Bunit IMR4 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR4 region based on the agents 6bit encoded SAI value."},
#else
{38, 38, 0x0000000000000000, "RW", "IMR4_READ_POL_38", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{37, 37, 0x0000000000000000, "RO", "IMR4_READ_POL_37", "Bunit IMR4 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR4 region based on the agents 6bit encoded SAI value."},
#else
{37, 37, 0x0000000000000000, "RO", "IMR4_READ_POL_37", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{36, 36, 0x0000000000000000, "RW", "IMR4_READ_POL_36", "Bunit IMR4 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR4 region based on the agents 6bit encoded SAI value."},
#else
{36, 36, 0x0000000000000000, "RW", "IMR4_READ_POL_36", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{35, 35, 0x0000000000000000, "RO", "IMR4_READ_POL_35", "Bunit IMR4 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR4 region based on the agents 6bit encoded SAI value."},
#else
{35, 35, 0x0000000000000000, "RO", "IMR4_READ_POL_35", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{34, 34, 0x0000000000000000, "RW", "IMR4_READ_POL_34", "Bunit IMR4 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR4 region based on the agents 6bit encoded SAI value."},
#else
{34, 34, 0x0000000000000000, "RW", "IMR4_READ_POL_34", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{33, 33, 0x0000000000000000, "RW", "IMR4_READ_POL_33", "Bunit IMR4 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR4 region based on the agents 6bit encoded SAI value."},
#else
{33, 33, 0x0000000000000000, "RW", "IMR4_READ_POL_33", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{32, 32, 0x0000000000000000, "RW", "IMR4_READ_POL_32", "Bunit IMR4 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR4 region based on the agents 6bit encoded SAI value."},
#else
{32, 32, 0x0000000000000000, "RW", "IMR4_READ_POL_32", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{31, 31, 0x0000000000000000, "RO", "IMR4_READ_POL_31", "Bunit IMR4 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR4 region based on the agents 6bit encoded SAI value."},
#else
{31, 31, 0x0000000000000000, "RO", "IMR4_READ_POL_31", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{30, 30, 0x0000000000000000, "RW", "IMR4_READ_POL_30", "Bunit IMR4 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR4 region based on the agents 6bit encoded SAI value."},
#else
{30, 30, 0x0000000000000000, "RW", "IMR4_READ_POL_30", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{29, 29, 0x0000000000000000, "RW", "IMR4_READ_POL_29", "Bunit IMR4 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR4 region based on the agents 6bit encoded SAI value."},
#else
{29, 29, 0x0000000000000000, "RW", "IMR4_READ_POL_29", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{28, 28, 0x0000000000000000, "RW", "IMR4_READ_POL_28", "Bunit IMR4 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR4 region based on the agents 6bit encoded SAI value."},
#else
{28, 28, 0x0000000000000000, "RW", "IMR4_READ_POL_28", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{27, 27, 0x0000000000000000, "RW", "IMR4_READ_POL_27", "Bunit IMR4 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR4 region based on the agents 6bit encoded SAI value."},
#else
{27, 27, 0x0000000000000000, "RW", "IMR4_READ_POL_27", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{26, 26, 0x0000000000000000, "RW", "IMR4_READ_POL_26", "Bunit IMR4 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR4 region based on the agents 6bit encoded SAI value."},
#else
{26, 26, 0x0000000000000000, "RW", "IMR4_READ_POL_26", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{25, 25, 0x0000000000000000, "RW", "IMR4_READ_POL_25", "Bunit IMR4 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR4 region based on the agents 6bit encoded SAI value."},
#else
{25, 25, 0x0000000000000000, "RW", "IMR4_READ_POL_25", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{24, 24, 0x0000000000000000, "RW", "IMR4_READ_POL_24", "Bunit IMR4 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR4 region based on the agents 6bit encoded SAI value."},
#else
{24, 24, 0x0000000000000000, "RW", "IMR4_READ_POL_24", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{23, 23, 0x0000000000000000, "RO", "IMR4_READ_POL_23", "Bunit IMR4 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR4 region based on the agents 6bit encoded SAI value."},
#else
{23, 23, 0x0000000000000000, "RO", "IMR4_READ_POL_23", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{22, 22, 0x0000000000000000, "RO", "IMR4_READ_POL_22", "Bunit IMR4 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR4 region based on the agents 6bit encoded SAI value."},
#else
{22, 22, 0x0000000000000000, "RO", "IMR4_READ_POL_22", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{21, 21, 0x0000000000000000, "RW", "IMR4_READ_POL_21", "Bunit IMR4 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR4 region based on the agents 6bit encoded SAI value."},
#else
{21, 21, 0x0000000000000000, "RW", "IMR4_READ_POL_21", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{20, 20, 0x0000000000000000, "RO", "IMR4_READ_POL_20", "Bunit IMR4 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR4 region based on the agents 6bit encoded SAI value."},
#else
{20, 20, 0x0000000000000000, "RO", "IMR4_READ_POL_20", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{19, 19, 0x0000000000000000, "RO", "IMR4_READ_POL_19", "Bunit IMR4 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR4 region based on the agents 6bit encoded SAI value."},
#else
{19, 19, 0x0000000000000000, "RO", "IMR4_READ_POL_19", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{18, 18, 0x0000000000000000, "RO", "IMR4_READ_POL_18", "Bunit IMR4 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR4 region based on the agents 6bit encoded SAI value."},
#else
{18, 18, 0x0000000000000000, "RO", "IMR4_READ_POL_18", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{17, 17, 0x0000000000000000, "RW", "IMR4_READ_POL_17", "Bunit IMR4 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR4 region based on the agents 6bit encoded SAI value."},
#else
{17, 17, 0x0000000000000000, "RW", "IMR4_READ_POL_17", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{16, 16, 0x0000000000000000, "RW", "IMR4_READ_POL_16", "Bunit IMR4 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR4 region based on the agents 6bit encoded SAI value."},
#else
{16, 16, 0x0000000000000000, "RW", "IMR4_READ_POL_16", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{15, 15, 0x0000000000000000, "RO", "IMR4_READ_POL_15", "Bunit IMR4 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR4 region based on the agents 6bit encoded SAI value."},
#else
{15, 15, 0x0000000000000000, "RO", "IMR4_READ_POL_15", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{14, 14, 0x0000000000000000, "RO", "IMR4_READ_POL_14", "Bunit IMR4 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR4 region based on the agents 6bit encoded SAI value."},
#else
{14, 14, 0x0000000000000000, "RO", "IMR4_READ_POL_14", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{13, 13, 0x0000000000000000, "RW", "IMR4_READ_POL_13", "Bunit IMR4 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR4 region based on the agents 6bit encoded SAI value."},
#else
{13, 13, 0x0000000000000000, "RW", "IMR4_READ_POL_13", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{12, 12, 0x0000000000000000, "RW", "IMR4_READ_POL_12", "Bunit IMR4 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR4 region based on the agents 6bit encoded SAI value."},
#else
{12, 12, 0x0000000000000000, "RW", "IMR4_READ_POL_12", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{11, 11, 0x0000000000000000, "RO", "IMR4_READ_POL_11", "Bunit IMR4 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR4 region based on the agents 6bit encoded SAI value."},
#else
{11, 11, 0x0000000000000000, "RO", "IMR4_READ_POL_11", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{10, 10, 0x0000000000000000, "RO", "IMR4_READ_POL_10", "Bunit IMR4 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR4 region based on the agents 6bit encoded SAI value."},
#else
{10, 10, 0x0000000000000000, "RO", "IMR4_READ_POL_10", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{9, 9, 0x0000000000000000, "RO", "IMR4_READ_POL_9", "Bunit IMR4 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR4 region based on the agents 6bit encoded SAI value."},
#else
{9, 9, 0x0000000000000000, "RO", "IMR4_READ_POL_9", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{8, 8, 0x0000000000000000, "RW", "IMR4_READ_POL_8", "Bunit IMR4 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR4 region based on the agents 6bit encoded SAI value."},
#else
{8, 8, 0x0000000000000000, "RW", "IMR4_READ_POL_8", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{7, 7, 0x0000000000000000, "RO", "IMR4_READ_POL_7", "Bunit IMR4 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR4 region based on the agents 6bit encoded SAI value."},
#else
{7, 7, 0x0000000000000000, "RO", "IMR4_READ_POL_7", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{6, 6, 0x0000000000000000, "RO", "IMR4_READ_POL_6", "Bunit IMR4 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR4 region based on the agents 6bit encoded SAI value."},
#else
{6, 6, 0x0000000000000000, "RO", "IMR4_READ_POL_6", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{5, 5, 0x0000000000000000, "RW", "IMR4_READ_POL_5", "Bunit IMR4 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR4 region based on the agents 6bit encoded SAI value."},
#else
{5, 5, 0x0000000000000000, "RW", "IMR4_READ_POL_5", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{4, 4, 0x0000000000000000, "RW", "IMR4_READ_POL_4", "Bunit IMR4 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR4 region based on the agents 6bit encoded SAI value."},
#else
{4, 4, 0x0000000000000000, "RW", "IMR4_READ_POL_4", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{3, 3, 0x0000000000000000, "RW", "IMR4_READ_POL_3", "Bunit IMR4 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR4 region based on the agents 6bit encoded SAI value."},
#else
{3, 3, 0x0000000000000000, "RW", "IMR4_READ_POL_3", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{2, 2, 0x0000000000000000, "RW", "IMR4_READ_POL_2", "Bunit IMR4 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR4 region based on the agents 6bit encoded SAI value."},
#else
{2, 2, 0x0000000000000000, "RW", "IMR4_READ_POL_2", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{1, 1, 0x0000000000000000, "RW", "IMR4_READ_POL_1", "Bunit IMR4 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR4 region based on the agents 6bit encoded SAI value."},
#else
{1, 1, 0x0000000000000000, "RW", "IMR4_READ_POL_1", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 0, 0x0000000000000000, "RW", "IMR4_READ_POL_0", "Bunit IMR4 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR4 region based on the agents 6bit encoded SAI value."},
#else
{0, 0, 0x0000000000000000, "RW", "IMR4_READ_POL_0", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo900[] = {{"B_CR_BIMR4RAC_0_0_0_MCHBAR", "", 0x00006900, 64, 0xFFFFFFFFFFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields901[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{63, 63, 0x0000000000000000, "RW", "IMR4_WRITE_POL_63", "Bunit IMR4 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR4 region based on the agents 6bit encoded SAI value."},
#else
{63, 63, 0x0000000000000000, "RW", "IMR4_WRITE_POL_63", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{62, 62, 0x0000000000000000, "RO", "IMR4_WRITE_POL_62", "Bunit IMR4 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR4 region based on the agents 6bit encoded SAI value."},
#else
{62, 62, 0x0000000000000000, "RO", "IMR4_WRITE_POL_62", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{61, 61, 0x0000000000000000, "RO", "IMR4_WRITE_POL_61", "Bunit IMR4 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR4 region based on the agents 6bit encoded SAI value."},
#else
{61, 61, 0x0000000000000000, "RO", "IMR4_WRITE_POL_61", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{60, 60, 0x0000000000000000, "RO", "IMR4_WRITE_POL_60", "Bunit IMR4 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR4 region based on the agents 6bit encoded SAI value."},
#else
{60, 60, 0x0000000000000000, "RO", "IMR4_WRITE_POL_60", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{59, 59, 0x0000000000000000, "RO", "IMR4_WRITE_POL_59", "Bunit IMR4 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR4 region based on the agents 6bit encoded SAI value."},
#else
{59, 59, 0x0000000000000000, "RO", "IMR4_WRITE_POL_59", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{58, 58, 0x0000000000000000, "RO", "IMR4_WRITE_POL_58", "Bunit IMR4 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR4 region based on the agents 6bit encoded SAI value."},
#else
{58, 58, 0x0000000000000000, "RO", "IMR4_WRITE_POL_58", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{57, 57, 0x0000000000000000, "RO", "IMR4_WRITE_POL_57", "Bunit IMR4 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR4 region based on the agents 6bit encoded SAI value."},
#else
{57, 57, 0x0000000000000000, "RO", "IMR4_WRITE_POL_57", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{56, 56, 0x0000000000000000, "RW", "IMR4_WRITE_POL_56", "Bunit IMR4 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR4 region based on the agents 6bit encoded SAI value."},
#else
{56, 56, 0x0000000000000000, "RW", "IMR4_WRITE_POL_56", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{55, 55, 0x0000000000000000, "RW", "IMR4_WRITE_POL_55", "Bunit IMR4 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR4 region based on the agents 6bit encoded SAI value."},
#else
{55, 55, 0x0000000000000000, "RW", "IMR4_WRITE_POL_55", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{54, 54, 0x0000000000000000, "RW", "IMR4_WRITE_POL_54", "Bunit IMR4 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR4 region based on the agents 6bit encoded SAI value."},
#else
{54, 54, 0x0000000000000000, "RW", "IMR4_WRITE_POL_54", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{53, 53, 0x0000000000000000, "RO", "IMR4_WRITE_POL_53", "Bunit IMR4 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR4 region based on the agents 6bit encoded SAI value."},
#else
{53, 53, 0x0000000000000000, "RO", "IMR4_WRITE_POL_53", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{52, 52, 0x0000000000000000, "RO", "IMR4_WRITE_POL_52", "Bunit IMR4 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR4 region based on the agents 6bit encoded SAI value."},
#else
{52, 52, 0x0000000000000000, "RO", "IMR4_WRITE_POL_52", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{51, 51, 0x0000000000000000, "RO", "IMR4_WRITE_POL_51", "Bunit IMR4 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR4 region based on the agents 6bit encoded SAI value."},
#else
{51, 51, 0x0000000000000000, "RO", "IMR4_WRITE_POL_51", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{50, 50, 0x0000000000000000, "RW", "IMR4_WRITE_POL_50", "Bunit IMR4 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR4 region based on the agents 6bit encoded SAI value."},
#else
{50, 50, 0x0000000000000000, "RW", "IMR4_WRITE_POL_50", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{49, 49, 0x0000000000000000, "RW", "IMR4_WRITE_POL_49", "Bunit IMR4 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR4 region based on the agents 6bit encoded SAI value."},
#else
{49, 49, 0x0000000000000000, "RW", "IMR4_WRITE_POL_49", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{48, 48, 0x0000000000000000, "RW", "IMR4_WRITE_POL_48", "Bunit IMR4 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR4 region based on the agents 6bit encoded SAI value."},
#else
{48, 48, 0x0000000000000000, "RW", "IMR4_WRITE_POL_48", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{47, 47, 0x0000000000000000, "RO", "IMR4_WRITE_POL_47", "Bunit IMR4 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR4 region based on the agents 6bit encoded SAI value."},
#else
{47, 47, 0x0000000000000000, "RO", "IMR4_WRITE_POL_47", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{46, 46, 0x0000000000000000, "RO", "IMR4_WRITE_POL_46", "Bunit IMR4 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR4 region based on the agents 6bit encoded SAI value."},
#else
{46, 46, 0x0000000000000000, "RO", "IMR4_WRITE_POL_46", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{45, 45, 0x0000000000000000, "RO", "IMR4_WRITE_POL_45", "Bunit IMR4 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR4 region based on the agents 6bit encoded SAI value."},
#else
{45, 45, 0x0000000000000000, "RO", "IMR4_WRITE_POL_45", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{44, 44, 0x0000000000000000, "RW", "IMR4_WRITE_POL_44", "Bunit IMR4 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR4 region based on the agents 6bit encoded SAI value."},
#else
{44, 44, 0x0000000000000000, "RW", "IMR4_WRITE_POL_44", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{43, 43, 0x0000000000000000, "RW", "IMR4_WRITE_POL_43", "Bunit IMR4 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR4 region based on the agents 6bit encoded SAI value."},
#else
{43, 43, 0x0000000000000000, "RW", "IMR4_WRITE_POL_43", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{42, 42, 0x0000000000000000, "RW", "IMR4_WRITE_POL_42", "Bunit IMR4 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR4 region based on the agents 6bit encoded SAI value."},
#else
{42, 42, 0x0000000000000000, "RW", "IMR4_WRITE_POL_42", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{41, 41, 0x0000000000000000, "RW", "IMR4_WRITE_POL_41", "Bunit IMR4 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR4 region based on the agents 6bit encoded SAI value."},
#else
{41, 41, 0x0000000000000000, "RW", "IMR4_WRITE_POL_41", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{40, 40, 0x0000000000000000, "RW", "IMR4_WRITE_POL_40", "Bunit IMR4 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR4 region based on the agents 6bit encoded SAI value."},
#else
{40, 40, 0x0000000000000000, "RW", "IMR4_WRITE_POL_40", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{39, 39, 0x0000000000000000, "RO", "IMR4_WRITE_POL_39", "Bunit IMR4 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR4 region based on the agents 6bit encoded SAI value."},
#else
{39, 39, 0x0000000000000000, "RO", "IMR4_WRITE_POL_39", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{38, 38, 0x0000000000000000, "RW", "IMR4_WRITE_POL_38", "Bunit IMR4 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR4 region based on the agents 6bit encoded SAI value."},
#else
{38, 38, 0x0000000000000000, "RW", "IMR4_WRITE_POL_38", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{37, 37, 0x0000000000000000, "RO", "IMR4_WRITE_POL_37", "Bunit IMR4 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR4 region based on the agents 6bit encoded SAI value."},
#else
{37, 37, 0x0000000000000000, "RO", "IMR4_WRITE_POL_37", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{36, 36, 0x0000000000000000, "RW", "IMR4_WRITE_POL_36", "Bunit IMR4 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR4 region based on the agents 6bit encoded SAI value."},
#else
{36, 36, 0x0000000000000000, "RW", "IMR4_WRITE_POL_36", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{35, 35, 0x0000000000000000, "RO", "IMR4_WRITE_POL_35", "Bunit IMR4 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR4 region based on the agents 6bit encoded SAI value."},
#else
{35, 35, 0x0000000000000000, "RO", "IMR4_WRITE_POL_35", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{34, 34, 0x0000000000000000, "RW", "IMR4_WRITE_POL_34", "Bunit IMR4 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR4 region based on the agents 6bit encoded SAI value."},
#else
{34, 34, 0x0000000000000000, "RW", "IMR4_WRITE_POL_34", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{33, 33, 0x0000000000000000, "RW", "IMR4_WRITE_POL_33", "Bunit IMR4 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR4 region based on the agents 6bit encoded SAI value."},
#else
{33, 33, 0x0000000000000000, "RW", "IMR4_WRITE_POL_33", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{32, 32, 0x0000000000000000, "RW", "IMR4_WRITE_POL_32", "Bunit IMR4 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR4 region based on the agents 6bit encoded SAI value."},
#else
{32, 32, 0x0000000000000000, "RW", "IMR4_WRITE_POL_32", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{31, 31, 0x0000000000000000, "RO", "IMR4_WRITE_POL_31", "Bunit IMR4 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR4 region based on the agents 6bit encoded SAI value."},
#else
{31, 31, 0x0000000000000000, "RO", "IMR4_WRITE_POL_31", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{30, 30, 0x0000000000000000, "RW", "IMR4_WRITE_POL_30", "Bunit IMR4 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR4 region based on the agents 6bit encoded SAI value."},
#else
{30, 30, 0x0000000000000000, "RW", "IMR4_WRITE_POL_30", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{29, 29, 0x0000000000000000, "RW", "IMR4_WRITE_POL_29", "Bunit IMR4 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR4 region based on the agents 6bit encoded SAI value."},
#else
{29, 29, 0x0000000000000000, "RW", "IMR4_WRITE_POL_29", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{28, 28, 0x0000000000000000, "RW", "IMR4_WRITE_POL_28", "Bunit IMR4 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR4 region based on the agents 6bit encoded SAI value."},
#else
{28, 28, 0x0000000000000000, "RW", "IMR4_WRITE_POL_28", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{27, 27, 0x0000000000000000, "RW", "IMR4_WRITE_POL_27", "Bunit IMR4 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR4 region based on the agents 6bit encoded SAI value."},
#else
{27, 27, 0x0000000000000000, "RW", "IMR4_WRITE_POL_27", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{26, 26, 0x0000000000000000, "RW", "IMR4_WRITE_POL_26", "Bunit IMR4 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR4 region based on the agents 6bit encoded SAI value."},
#else
{26, 26, 0x0000000000000000, "RW", "IMR4_WRITE_POL_26", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{25, 25, 0x0000000000000000, "RW", "IMR4_WRITE_POL_25", "Bunit IMR4 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR4 region based on the agents 6bit encoded SAI value."},
#else
{25, 25, 0x0000000000000000, "RW", "IMR4_WRITE_POL_25", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{24, 24, 0x0000000000000000, "RW", "IMR4_WRITE_POL_24", "Bunit IMR4 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR4 region based on the agents 6bit encoded SAI value."},
#else
{24, 24, 0x0000000000000000, "RW", "IMR4_WRITE_POL_24", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{23, 23, 0x0000000000000000, "RO", "IMR4_WRITE_POL_23", "Bunit IMR4 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR4 region based on the agents 6bit encoded SAI value."},
#else
{23, 23, 0x0000000000000000, "RO", "IMR4_WRITE_POL_23", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{22, 22, 0x0000000000000000, "RO", "IMR4_WRITE_POL_22", "Bunit IMR4 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR4 region based on the agents 6bit encoded SAI value."},
#else
{22, 22, 0x0000000000000000, "RO", "IMR4_WRITE_POL_22", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{21, 21, 0x0000000000000000, "RW", "IMR4_WRITE_POL_21", "Bunit IMR4 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR4 region based on the agents 6bit encoded SAI value."},
#else
{21, 21, 0x0000000000000000, "RW", "IMR4_WRITE_POL_21", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{20, 20, 0x0000000000000000, "RO", "IMR4_WRITE_POL_20", "Bunit IMR4 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR4 region based on the agents 6bit encoded SAI value."},
#else
{20, 20, 0x0000000000000000, "RO", "IMR4_WRITE_POL_20", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{19, 19, 0x0000000000000000, "RO", "IMR4_WRITE_POL_19", "Bunit IMR4 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR4 region based on the agents 6bit encoded SAI value."},
#else
{19, 19, 0x0000000000000000, "RO", "IMR4_WRITE_POL_19", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{18, 18, 0x0000000000000000, "RO", "IMR4_WRITE_POL_18", "Bunit IMR4 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR4 region based on the agents 6bit encoded SAI value."},
#else
{18, 18, 0x0000000000000000, "RO", "IMR4_WRITE_POL_18", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{17, 17, 0x0000000000000000, "RW", "IMR4_WRITE_POL_17", "Bunit IMR4 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR4 region based on the agents 6bit encoded SAI value."},
#else
{17, 17, 0x0000000000000000, "RW", "IMR4_WRITE_POL_17", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{16, 16, 0x0000000000000000, "RW", "IMR4_WRITE_POL_16", "Bunit IMR4 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR4 region based on the agents 6bit encoded SAI value."},
#else
{16, 16, 0x0000000000000000, "RW", "IMR4_WRITE_POL_16", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{15, 15, 0x0000000000000000, "RO", "IMR4_WRITE_POL_15", "Bunit IMR4 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR4 region based on the agents 6bit encoded SAI value."},
#else
{15, 15, 0x0000000000000000, "RO", "IMR4_WRITE_POL_15", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{14, 14, 0x0000000000000000, "RO", "IMR4_WRITE_POL_14", "Bunit IMR4 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR4 region based on the agents 6bit encoded SAI value."},
#else
{14, 14, 0x0000000000000000, "RO", "IMR4_WRITE_POL_14", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{13, 13, 0x0000000000000000, "RW", "IMR4_WRITE_POL_13", "Bunit IMR4 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR4 region based on the agents 6bit encoded SAI value."},
#else
{13, 13, 0x0000000000000000, "RW", "IMR4_WRITE_POL_13", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{12, 12, 0x0000000000000000, "RW", "IMR4_WRITE_POL_12", "Bunit IMR4 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR4 region based on the agents 6bit encoded SAI value."},
#else
{12, 12, 0x0000000000000000, "RW", "IMR4_WRITE_POL_12", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{11, 11, 0x0000000000000000, "RO", "IMR4_WRITE_POL_11", "Bunit IMR4 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR4 region based on the agents 6bit encoded SAI value."},
#else
{11, 11, 0x0000000000000000, "RO", "IMR4_WRITE_POL_11", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{10, 10, 0x0000000000000000, "RO", "IMR4_WRITE_POL_10", "Bunit IMR4 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR4 region based on the agents 6bit encoded SAI value."},
#else
{10, 10, 0x0000000000000000, "RO", "IMR4_WRITE_POL_10", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{9, 9, 0x0000000000000000, "RO", "IMR4_WRITE_POL_9", "Bunit IMR4 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR4 region based on the agents 6bit encoded SAI value."},
#else
{9, 9, 0x0000000000000000, "RO", "IMR4_WRITE_POL_9", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{8, 8, 0x0000000000000000, "RW", "IMR4_WRITE_POL_8", "Bunit IMR4 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR4 region based on the agents 6bit encoded SAI value."},
#else
{8, 8, 0x0000000000000000, "RW", "IMR4_WRITE_POL_8", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{7, 7, 0x0000000000000000, "RO", "IMR4_WRITE_POL_7", "Bunit IMR4 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR4 region based on the agents 6bit encoded SAI value."},
#else
{7, 7, 0x0000000000000000, "RO", "IMR4_WRITE_POL_7", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{6, 6, 0x0000000000000000, "RO", "IMR4_WRITE_POL_6", "Bunit IMR4 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR4 region based on the agents 6bit encoded SAI value."},
#else
{6, 6, 0x0000000000000000, "RO", "IMR4_WRITE_POL_6", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{5, 5, 0x0000000000000000, "RW", "IMR4_WRITE_POL_5", "Bunit IMR4 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR4 region based on the agents 6bit encoded SAI value."},
#else
{5, 5, 0x0000000000000000, "RW", "IMR4_WRITE_POL_5", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{4, 4, 0x0000000000000000, "RW", "IMR4_WRITE_POL_4", "Bunit IMR4 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR4 region based on the agents 6bit encoded SAI value."},
#else
{4, 4, 0x0000000000000000, "RW", "IMR4_WRITE_POL_4", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{3, 3, 0x0000000000000000, "RW", "IMR4_WRITE_POL_3", "Bunit IMR4 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR4 region based on the agents 6bit encoded SAI value."},
#else
{3, 3, 0x0000000000000000, "RW", "IMR4_WRITE_POL_3", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{2, 2, 0x0000000000000000, "RW", "IMR4_WRITE_POL_2", "Bunit IMR4 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR4 region based on the agents 6bit encoded SAI value."},
#else
{2, 2, 0x0000000000000000, "RW", "IMR4_WRITE_POL_2", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{1, 1, 0x0000000000000000, "RW", "IMR4_WRITE_POL_1", "Bunit IMR4 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR4 region based on the agents 6bit encoded SAI value."},
#else
{1, 1, 0x0000000000000000, "RW", "IMR4_WRITE_POL_1", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 0, 0x0000000000000000, "RW", "IMR4_WRITE_POL_0", "Bunit IMR4 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR4 region based on the agents 6bit encoded SAI value."},
#else
{0, 0, 0x0000000000000000, "RW", "IMR4_WRITE_POL_0", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo901[] = {{"B_CR_BIMR4WAC_0_0_0_MCHBAR", "", 0x00006908, 64, 0xFFFFFFFFFFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields902[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{31, 31, 0x0000000000000000, "RW", "IMR_EN", "IMR Enable: Enables access checking for the IMR region."},
#else
{31, 31, 0x0000000000000000, "RW", "IMR_EN", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{30, 30, 0x0000000000000000, "RW", "TR_EN", "Asset Classification AC[0]: Trace Enable: Enables snooping of transactions to the IMR region by tracing agents."},
#else
{30, 30, 0x0000000000000000, "RW", "TR_EN", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{29, 29, 0x0000000000000000, "RO", "RESERVED_1", "Reserved"},
#else
{29, 29, 0x0000000000000000, "RO", "RESERVED_1", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 28, 0x0000000000000000, "RW", "IMR5_BASE", "Base 0 IMR5BASE:  Specifies bits 38:10 of the start address of IMR5 region.  IMR region size must be a strict poweroftwo at least 1KB and naturally aligned to the size.  These bits are compared with the result of the IMR5MASK[28:0] applied to bits 38:10 of the incoming address to determine if an access falls within the IMR5 defined region."},
#else
{0, 28, 0x0000000000000000, "RW", "IMR5_BASE", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo902[] = {{"B_CR_BIMR5BASE_0_0_0_MCHBAR", "", 0x00006910, 4, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields903[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{31, 31, 0x0000000000000000, "RW", "GT_IWB_EN", "Asset Classification AC[2]: GT Implicit WB Enable: Enables implicit writebacks to protected region from GT caching agent. When set to 1 enables implicit writeback data HITM data from GT to be returned to the requester.  When set to 0 inhibits HITM data from GT from being returned to the requester.  HITM data from IA cores may be returned to the requester depending on the setting of the IA_IWB_EN bit."},
#else
{31, 31, 0x0000000000000000, "RW", "GT_IWB_EN", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{30, 30, 0x0000000000000000, "RW", "IA_IWB_EN", "Asset Classification AC[1]: IA Implicit WB Enable: Enables implicit writebacks to protected region from IA caching agent.  When set to 1 enables implicit writeback data HITM data from IA cores to be returned to the requester.  When set to 0 inhibits HITM data from IA cores from being returned to the requester.  HITM data from GT may be returned to the requester depending on the setting of the GT_IWB_EN bit."},
#else
{30, 30, 0x0000000000000000, "RW", "IA_IWB_EN", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{29, 29, 0x0000000000000000, "RO", "RESERVED_0", "Reserved"},
#else
{29, 29, 0x0000000000000000, "RO", "RESERVED_0", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 28, 0x0000000000000000, "RW", "IMR5_MASK", "Mask 0 IMR5MASK:  These bits are ANDed with bits 38:10 of the incoming address to determine if the combined result matches the IMR5BASE[28:0] value.  A match indicates the the incoming address falls within the IMR5 region."},
#else
{0, 28, 0x0000000000000000, "RW", "IMR5_MASK", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo903[] = {{"B_CR_BIMR5MASK_0_0_0_MCHBAR", "", 0x00006914, 4, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields904[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{0, 63, 0x00000C0061010202, "RW", "IMR5_CTRL_POL", "Bunit IMR5 Control Policy: Bit vector used to determine which agents are allowed access to the BIMR5RAC, BIMR5WAC, BIMR5CP registers based on the value from the agents 6bit SAI field."},
#else
{0, 63, 0x00000C0061010202, "RW", "IMR5_CTRL_POL", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo904[] = {{"B_CR_BIMR5CP_0_0_0_MCHBAR", "", 0x00006918, 1, 0xFFFFFFFFFFFFFFFF, 0x00000C0061010202}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields905[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{63, 63, 0x0000000000000000, "RW", "IMR5_READ_POL_63", "Bunit IMR5 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR5 region based on the agents 6bit encoded SAI value."},
#else
{63, 63, 0x0000000000000000, "RW", "IMR5_READ_POL_63", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{62, 62, 0x0000000000000000, "RO", "IMR5_READ_POL_62", "Bunit IMR5 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR5 region based on the agents 6bit encoded SAI value."},
#else
{62, 62, 0x0000000000000000, "RO", "IMR5_READ_POL_62", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{61, 61, 0x0000000000000000, "RO", "IMR5_READ_POL_61", "Bunit IMR5 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR5 region based on the agents 6bit encoded SAI value."},
#else
{61, 61, 0x0000000000000000, "RO", "IMR5_READ_POL_61", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{60, 60, 0x0000000000000000, "RO", "IMR5_READ_POL_60", "Bunit IMR5 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR5 region based on the agents 6bit encoded SAI value."},
#else
{60, 60, 0x0000000000000000, "RO", "IMR5_READ_POL_60", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{59, 59, 0x0000000000000000, "RO", "IMR5_READ_POL_59", "Bunit IMR5 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR5 region based on the agents 6bit encoded SAI value."},
#else
{59, 59, 0x0000000000000000, "RO", "IMR5_READ_POL_59", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{58, 58, 0x0000000000000000, "RO", "IMR5_READ_POL_58", "Bunit IMR5 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR5 region based on the agents 6bit encoded SAI value."},
#else
{58, 58, 0x0000000000000000, "RO", "IMR5_READ_POL_58", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{57, 57, 0x0000000000000000, "RO", "IMR5_READ_POL_57", "Bunit IMR5 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR5 region based on the agents 6bit encoded SAI value."},
#else
{57, 57, 0x0000000000000000, "RO", "IMR5_READ_POL_57", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{56, 56, 0x0000000000000000, "RW", "IMR5_READ_POL_56", "Bunit IMR5 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR5 region based on the agents 6bit encoded SAI value."},
#else
{56, 56, 0x0000000000000000, "RW", "IMR5_READ_POL_56", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{55, 55, 0x0000000000000000, "RW", "IMR5_READ_POL_55", "Bunit IMR5 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR5 region based on the agents 6bit encoded SAI value."},
#else
{55, 55, 0x0000000000000000, "RW", "IMR5_READ_POL_55", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{54, 54, 0x0000000000000000, "RW", "IMR5_READ_POL_54", "Bunit IMR5 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR5 region based on the agents 6bit encoded SAI value."},
#else
{54, 54, 0x0000000000000000, "RW", "IMR5_READ_POL_54", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{53, 53, 0x0000000000000000, "RO", "IMR5_READ_POL_53", "Bunit IMR5 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR5 region based on the agents 6bit encoded SAI value."},
#else
{53, 53, 0x0000000000000000, "RO", "IMR5_READ_POL_53", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{52, 52, 0x0000000000000000, "RO", "IMR5_READ_POL_52", "Bunit IMR5 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR5 region based on the agents 6bit encoded SAI value."},
#else
{52, 52, 0x0000000000000000, "RO", "IMR5_READ_POL_52", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{51, 51, 0x0000000000000000, "RO", "IMR5_READ_POL_51", "Bunit IMR5 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR5 region based on the agents 6bit encoded SAI value."},
#else
{51, 51, 0x0000000000000000, "RO", "IMR5_READ_POL_51", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{50, 50, 0x0000000000000000, "RW", "IMR5_READ_POL_50", "Bunit IMR5 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR5 region based on the agents 6bit encoded SAI value."},
#else
{50, 50, 0x0000000000000000, "RW", "IMR5_READ_POL_50", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{49, 49, 0x0000000000000000, "RW", "IMR5_READ_POL_49", "Bunit IMR5 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR5 region based on the agents 6bit encoded SAI value."},
#else
{49, 49, 0x0000000000000000, "RW", "IMR5_READ_POL_49", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{48, 48, 0x0000000000000000, "RW", "IMR5_READ_POL_48", "Bunit IMR5 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR5 region based on the agents 6bit encoded SAI value."},
#else
{48, 48, 0x0000000000000000, "RW", "IMR5_READ_POL_48", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{47, 47, 0x0000000000000000, "RO", "IMR5_READ_POL_47", "Bunit IMR5 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR5 region based on the agents 6bit encoded SAI value."},
#else
{47, 47, 0x0000000000000000, "RO", "IMR5_READ_POL_47", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{46, 46, 0x0000000000000000, "RO", "IMR5_READ_POL_46", "Bunit IMR5 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR5 region based on the agents 6bit encoded SAI value."},
#else
{46, 46, 0x0000000000000000, "RO", "IMR5_READ_POL_46", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{45, 45, 0x0000000000000000, "RO", "IMR5_READ_POL_45", "Bunit IMR5 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR5 region based on the agents 6bit encoded SAI value."},
#else
{45, 45, 0x0000000000000000, "RO", "IMR5_READ_POL_45", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{44, 44, 0x0000000000000000, "RW", "IMR5_READ_POL_44", "Bunit IMR5 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR5 region based on the agents 6bit encoded SAI value."},
#else
{44, 44, 0x0000000000000000, "RW", "IMR5_READ_POL_44", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{43, 43, 0x0000000000000000, "RW", "IMR5_READ_POL_43", "Bunit IMR5 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR5 region based on the agents 6bit encoded SAI value."},
#else
{43, 43, 0x0000000000000000, "RW", "IMR5_READ_POL_43", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{42, 42, 0x0000000000000000, "RW", "IMR5_READ_POL_42", "Bunit IMR5 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR5 region based on the agents 6bit encoded SAI value."},
#else
{42, 42, 0x0000000000000000, "RW", "IMR5_READ_POL_42", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{41, 41, 0x0000000000000000, "RW", "IMR5_READ_POL_41", "Bunit IMR5 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR5 region based on the agents 6bit encoded SAI value."},
#else
{41, 41, 0x0000000000000000, "RW", "IMR5_READ_POL_41", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{40, 40, 0x0000000000000000, "RW", "IMR5_READ_POL_40", "Bunit IMR5 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR5 region based on the agents 6bit encoded SAI value."},
#else
{40, 40, 0x0000000000000000, "RW", "IMR5_READ_POL_40", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{39, 39, 0x0000000000000000, "RO", "IMR5_READ_POL_39", "Bunit IMR5 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR5 region based on the agents 6bit encoded SAI value."},
#else
{39, 39, 0x0000000000000000, "RO", "IMR5_READ_POL_39", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{38, 38, 0x0000000000000000, "RW", "IMR5_READ_POL_38", "Bunit IMR5 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR5 region based on the agents 6bit encoded SAI value."},
#else
{38, 38, 0x0000000000000000, "RW", "IMR5_READ_POL_38", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{37, 37, 0x0000000000000000, "RO", "IMR5_READ_POL_37", "Bunit IMR5 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR5 region based on the agents 6bit encoded SAI value."},
#else
{37, 37, 0x0000000000000000, "RO", "IMR5_READ_POL_37", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{36, 36, 0x0000000000000000, "RW", "IMR5_READ_POL_36", "Bunit IMR5 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR5 region based on the agents 6bit encoded SAI value."},
#else
{36, 36, 0x0000000000000000, "RW", "IMR5_READ_POL_36", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{35, 35, 0x0000000000000000, "RO", "IMR5_READ_POL_35", "Bunit IMR5 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR5 region based on the agents 6bit encoded SAI value."},
#else
{35, 35, 0x0000000000000000, "RO", "IMR5_READ_POL_35", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{34, 34, 0x0000000000000000, "RW", "IMR5_READ_POL_34", "Bunit IMR5 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR5 region based on the agents 6bit encoded SAI value."},
#else
{34, 34, 0x0000000000000000, "RW", "IMR5_READ_POL_34", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{33, 33, 0x0000000000000000, "RW", "IMR5_READ_POL_33", "Bunit IMR5 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR5 region based on the agents 6bit encoded SAI value."},
#else
{33, 33, 0x0000000000000000, "RW", "IMR5_READ_POL_33", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{32, 32, 0x0000000000000000, "RW", "IMR5_READ_POL_32", "Bunit IMR5 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR5 region based on the agents 6bit encoded SAI value."},
#else
{32, 32, 0x0000000000000000, "RW", "IMR5_READ_POL_32", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{31, 31, 0x0000000000000000, "RO", "IMR5_READ_POL_31", "Bunit IMR5 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR5 region based on the agents 6bit encoded SAI value."},
#else
{31, 31, 0x0000000000000000, "RO", "IMR5_READ_POL_31", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{30, 30, 0x0000000000000000, "RW", "IMR5_READ_POL_30", "Bunit IMR5 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR5 region based on the agents 6bit encoded SAI value."},
#else
{30, 30, 0x0000000000000000, "RW", "IMR5_READ_POL_30", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{29, 29, 0x0000000000000000, "RW", "IMR5_READ_POL_29", "Bunit IMR5 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR5 region based on the agents 6bit encoded SAI value."},
#else
{29, 29, 0x0000000000000000, "RW", "IMR5_READ_POL_29", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{28, 28, 0x0000000000000000, "RW", "IMR5_READ_POL_28", "Bunit IMR5 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR5 region based on the agents 6bit encoded SAI value."},
#else
{28, 28, 0x0000000000000000, "RW", "IMR5_READ_POL_28", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{27, 27, 0x0000000000000000, "RW", "IMR5_READ_POL_27", "Bunit IMR5 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR5 region based on the agents 6bit encoded SAI value."},
#else
{27, 27, 0x0000000000000000, "RW", "IMR5_READ_POL_27", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{26, 26, 0x0000000000000000, "RW", "IMR5_READ_POL_26", "Bunit IMR5 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR5 region based on the agents 6bit encoded SAI value."},
#else
{26, 26, 0x0000000000000000, "RW", "IMR5_READ_POL_26", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{25, 25, 0x0000000000000000, "RW", "IMR5_READ_POL_25", "Bunit IMR5 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR5 region based on the agents 6bit encoded SAI value."},
#else
{25, 25, 0x0000000000000000, "RW", "IMR5_READ_POL_25", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{24, 24, 0x0000000000000000, "RW", "IMR5_READ_POL_24", "Bunit IMR5 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR5 region based on the agents 6bit encoded SAI value."},
#else
{24, 24, 0x0000000000000000, "RW", "IMR5_READ_POL_24", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{23, 23, 0x0000000000000000, "RO", "IMR5_READ_POL_23", "Bunit IMR5 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR5 region based on the agents 6bit encoded SAI value."},
#else
{23, 23, 0x0000000000000000, "RO", "IMR5_READ_POL_23", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{22, 22, 0x0000000000000000, "RO", "IMR5_READ_POL_22", "Bunit IMR5 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR5 region based on the agents 6bit encoded SAI value."},
#else
{22, 22, 0x0000000000000000, "RO", "IMR5_READ_POL_22", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{21, 21, 0x0000000000000000, "RW", "IMR5_READ_POL_21", "Bunit IMR5 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR5 region based on the agents 6bit encoded SAI value."},
#else
{21, 21, 0x0000000000000000, "RW", "IMR5_READ_POL_21", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{20, 20, 0x0000000000000000, "RO", "IMR5_READ_POL_20", "Bunit IMR5 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR5 region based on the agents 6bit encoded SAI value."},
#else
{20, 20, 0x0000000000000000, "RO", "IMR5_READ_POL_20", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{19, 19, 0x0000000000000000, "RO", "IMR5_READ_POL_19", "Bunit IMR5 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR5 region based on the agents 6bit encoded SAI value."},
#else
{19, 19, 0x0000000000000000, "RO", "IMR5_READ_POL_19", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{18, 18, 0x0000000000000000, "RO", "IMR5_READ_POL_18", "Bunit IMR5 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR5 region based on the agents 6bit encoded SAI value."},
#else
{18, 18, 0x0000000000000000, "RO", "IMR5_READ_POL_18", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{17, 17, 0x0000000000000000, "RW", "IMR5_READ_POL_17", "Bunit IMR5 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR5 region based on the agents 6bit encoded SAI value."},
#else
{17, 17, 0x0000000000000000, "RW", "IMR5_READ_POL_17", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{16, 16, 0x0000000000000000, "RW", "IMR5_READ_POL_16", "Bunit IMR5 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR5 region based on the agents 6bit encoded SAI value."},
#else
{16, 16, 0x0000000000000000, "RW", "IMR5_READ_POL_16", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{15, 15, 0x0000000000000000, "RO", "IMR5_READ_POL_15", "Bunit IMR5 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR5 region based on the agents 6bit encoded SAI value."},
#else
{15, 15, 0x0000000000000000, "RO", "IMR5_READ_POL_15", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{14, 14, 0x0000000000000000, "RO", "IMR5_READ_POL_14", "Bunit IMR5 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR5 region based on the agents 6bit encoded SAI value."},
#else
{14, 14, 0x0000000000000000, "RO", "IMR5_READ_POL_14", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{13, 13, 0x0000000000000000, "RW", "IMR5_READ_POL_13", "Bunit IMR5 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR5 region based on the agents 6bit encoded SAI value."},
#else
{13, 13, 0x0000000000000000, "RW", "IMR5_READ_POL_13", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{12, 12, 0x0000000000000000, "RW", "IMR5_READ_POL_12", "Bunit IMR5 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR5 region based on the agents 6bit encoded SAI value."},
#else
{12, 12, 0x0000000000000000, "RW", "IMR5_READ_POL_12", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{11, 11, 0x0000000000000000, "RO", "IMR5_READ_POL_11", "Bunit IMR5 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR5 region based on the agents 6bit encoded SAI value."},
#else
{11, 11, 0x0000000000000000, "RO", "IMR5_READ_POL_11", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{10, 10, 0x0000000000000000, "RO", "IMR5_READ_POL_10", "Bunit IMR5 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR5 region based on the agents 6bit encoded SAI value."},
#else
{10, 10, 0x0000000000000000, "RO", "IMR5_READ_POL_10", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{9, 9, 0x0000000000000000, "RO", "IMR5_READ_POL_9", "Bunit IMR5 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR5 region based on the agents 6bit encoded SAI value."},
#else
{9, 9, 0x0000000000000000, "RO", "IMR5_READ_POL_9", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{8, 8, 0x0000000000000000, "RW", "IMR5_READ_POL_8", "Bunit IMR5 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR5 region based on the agents 6bit encoded SAI value."},
#else
{8, 8, 0x0000000000000000, "RW", "IMR5_READ_POL_8", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{7, 7, 0x0000000000000000, "RO", "IMR5_READ_POL_7", "Bunit IMR5 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR5 region based on the agents 6bit encoded SAI value."},
#else
{7, 7, 0x0000000000000000, "RO", "IMR5_READ_POL_7", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{6, 6, 0x0000000000000000, "RO", "IMR5_READ_POL_6", "Bunit IMR5 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR5 region based on the agents 6bit encoded SAI value."},
#else
{6, 6, 0x0000000000000000, "RO", "IMR5_READ_POL_6", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{5, 5, 0x0000000000000000, "RW", "IMR5_READ_POL_5", "Bunit IMR5 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR5 region based on the agents 6bit encoded SAI value."},
#else
{5, 5, 0x0000000000000000, "RW", "IMR5_READ_POL_5", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{4, 4, 0x0000000000000000, "RW", "IMR5_READ_POL_4", "Bunit IMR5 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR5 region based on the agents 6bit encoded SAI value."},
#else
{4, 4, 0x0000000000000000, "RW", "IMR5_READ_POL_4", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{3, 3, 0x0000000000000000, "RW", "IMR5_READ_POL_3", "Bunit IMR5 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR5 region based on the agents 6bit encoded SAI value."},
#else
{3, 3, 0x0000000000000000, "RW", "IMR5_READ_POL_3", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{2, 2, 0x0000000000000000, "RW", "IMR5_READ_POL_2", "Bunit IMR5 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR5 region based on the agents 6bit encoded SAI value."},
#else
{2, 2, 0x0000000000000000, "RW", "IMR5_READ_POL_2", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{1, 1, 0x0000000000000000, "RW", "IMR5_READ_POL_1", "Bunit IMR5 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR5 region based on the agents 6bit encoded SAI value."},
#else
{1, 1, 0x0000000000000000, "RW", "IMR5_READ_POL_1", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 0, 0x0000000000000000, "RW", "IMR5_READ_POL_0", "Bunit IMR5 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR5 region based on the agents 6bit encoded SAI value."},
#else
{0, 0, 0x0000000000000000, "RW", "IMR5_READ_POL_0", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo905[] = {{"B_CR_BIMR5RAC_0_0_0_MCHBAR", "", 0x00006920, 64, 0xFFFFFFFFFFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields906[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{63, 63, 0x0000000000000000, "RW", "IMR5_WRITE_POL_63", "Bunit IMR5 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR5 region based on the agents 6bit encoded SAI value."},
#else
{63, 63, 0x0000000000000000, "RW", "IMR5_WRITE_POL_63", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{62, 62, 0x0000000000000000, "RO", "IMR5_WRITE_POL_62", "Bunit IMR5 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR5 region based on the agents 6bit encoded SAI value."},
#else
{62, 62, 0x0000000000000000, "RO", "IMR5_WRITE_POL_62", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{61, 61, 0x0000000000000000, "RO", "IMR5_WRITE_POL_61", "Bunit IMR5 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR5 region based on the agents 6bit encoded SAI value."},
#else
{61, 61, 0x0000000000000000, "RO", "IMR5_WRITE_POL_61", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{60, 60, 0x0000000000000000, "RO", "IMR5_WRITE_POL_60", "Bunit IMR5 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR5 region based on the agents 6bit encoded SAI value."},
#else
{60, 60, 0x0000000000000000, "RO", "IMR5_WRITE_POL_60", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{59, 59, 0x0000000000000000, "RO", "IMR5_WRITE_POL_59", "Bunit IMR5 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR5 region based on the agents 6bit encoded SAI value."},
#else
{59, 59, 0x0000000000000000, "RO", "IMR5_WRITE_POL_59", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{58, 58, 0x0000000000000000, "RO", "IMR5_WRITE_POL_58", "Bunit IMR5 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR5 region based on the agents 6bit encoded SAI value."},
#else
{58, 58, 0x0000000000000000, "RO", "IMR5_WRITE_POL_58", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{57, 57, 0x0000000000000000, "RO", "IMR5_WRITE_POL_57", "Bunit IMR5 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR5 region based on the agents 6bit encoded SAI value."},
#else
{57, 57, 0x0000000000000000, "RO", "IMR5_WRITE_POL_57", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{56, 56, 0x0000000000000000, "RW", "IMR5_WRITE_POL_56", "Bunit IMR5 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR5 region based on the agents 6bit encoded SAI value."},
#else
{56, 56, 0x0000000000000000, "RW", "IMR5_WRITE_POL_56", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{55, 55, 0x0000000000000000, "RW", "IMR5_WRITE_POL_55", "Bunit IMR5 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR5 region based on the agents 6bit encoded SAI value."},
#else
{55, 55, 0x0000000000000000, "RW", "IMR5_WRITE_POL_55", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{54, 54, 0x0000000000000000, "RW", "IMR5_WRITE_POL_54", "Bunit IMR5 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR5 region based on the agents 6bit encoded SAI value."},
#else
{54, 54, 0x0000000000000000, "RW", "IMR5_WRITE_POL_54", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{53, 53, 0x0000000000000000, "RO", "IMR5_WRITE_POL_53", "Bunit IMR5 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR5 region based on the agents 6bit encoded SAI value."},
#else
{53, 53, 0x0000000000000000, "RO", "IMR5_WRITE_POL_53", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{52, 52, 0x0000000000000000, "RO", "IMR5_WRITE_POL_52", "Bunit IMR5 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR5 region based on the agents 6bit encoded SAI value."},
#else
{52, 52, 0x0000000000000000, "RO", "IMR5_WRITE_POL_52", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{51, 51, 0x0000000000000000, "RO", "IMR5_WRITE_POL_51", "Bunit IMR5 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR5 region based on the agents 6bit encoded SAI value."},
#else
{51, 51, 0x0000000000000000, "RO", "IMR5_WRITE_POL_51", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{50, 50, 0x0000000000000000, "RW", "IMR5_WRITE_POL_50", "Bunit IMR5 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR5 region based on the agents 6bit encoded SAI value."},
#else
{50, 50, 0x0000000000000000, "RW", "IMR5_WRITE_POL_50", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{49, 49, 0x0000000000000000, "RW", "IMR5_WRITE_POL_49", "Bunit IMR5 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR5 region based on the agents 6bit encoded SAI value."},
#else
{49, 49, 0x0000000000000000, "RW", "IMR5_WRITE_POL_49", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{48, 48, 0x0000000000000000, "RW", "IMR5_WRITE_POL_48", "Bunit IMR5 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR5 region based on the agents 6bit encoded SAI value."},
#else
{48, 48, 0x0000000000000000, "RW", "IMR5_WRITE_POL_48", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{47, 47, 0x0000000000000000, "RO", "IMR5_WRITE_POL_47", "Bunit IMR5 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR5 region based on the agents 6bit encoded SAI value."},
#else
{47, 47, 0x0000000000000000, "RO", "IMR5_WRITE_POL_47", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{46, 46, 0x0000000000000000, "RO", "IMR5_WRITE_POL_46", "Bunit IMR5 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR5 region based on the agents 6bit encoded SAI value."},
#else
{46, 46, 0x0000000000000000, "RO", "IMR5_WRITE_POL_46", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{45, 45, 0x0000000000000000, "RO", "IMR5_WRITE_POL_45", "Bunit IMR5 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR5 region based on the agents 6bit encoded SAI value."},
#else
{45, 45, 0x0000000000000000, "RO", "IMR5_WRITE_POL_45", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{44, 44, 0x0000000000000000, "RW", "IMR5_WRITE_POL_44", "Bunit IMR5 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR5 region based on the agents 6bit encoded SAI value."},
#else
{44, 44, 0x0000000000000000, "RW", "IMR5_WRITE_POL_44", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{43, 43, 0x0000000000000000, "RW", "IMR5_WRITE_POL_43", "Bunit IMR5 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR5 region based on the agents 6bit encoded SAI value."},
#else
{43, 43, 0x0000000000000000, "RW", "IMR5_WRITE_POL_43", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{42, 42, 0x0000000000000000, "RW", "IMR5_WRITE_POL_42", "Bunit IMR5 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR5 region based on the agents 6bit encoded SAI value."},
#else
{42, 42, 0x0000000000000000, "RW", "IMR5_WRITE_POL_42", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{41, 41, 0x0000000000000000, "RW", "IMR5_WRITE_POL_41", "Bunit IMR5 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR5 region based on the agents 6bit encoded SAI value."},
#else
{41, 41, 0x0000000000000000, "RW", "IMR5_WRITE_POL_41", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{40, 40, 0x0000000000000000, "RW", "IMR5_WRITE_POL_40", "Bunit IMR5 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR5 region based on the agents 6bit encoded SAI value."},
#else
{40, 40, 0x0000000000000000, "RW", "IMR5_WRITE_POL_40", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{39, 39, 0x0000000000000000, "RO", "IMR5_WRITE_POL_39", "Bunit IMR5 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR5 region based on the agents 6bit encoded SAI value."},
#else
{39, 39, 0x0000000000000000, "RO", "IMR5_WRITE_POL_39", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{38, 38, 0x0000000000000000, "RW", "IMR5_WRITE_POL_38", "Bunit IMR5 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR5 region based on the agents 6bit encoded SAI value."},
#else
{38, 38, 0x0000000000000000, "RW", "IMR5_WRITE_POL_38", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{37, 37, 0x0000000000000000, "RO", "IMR5_WRITE_POL_37", "Bunit IMR5 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR5 region based on the agents 6bit encoded SAI value."},
#else
{37, 37, 0x0000000000000000, "RO", "IMR5_WRITE_POL_37", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{36, 36, 0x0000000000000000, "RW", "IMR5_WRITE_POL_36", "Bunit IMR5 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR5 region based on the agents 6bit encoded SAI value."},
#else
{36, 36, 0x0000000000000000, "RW", "IMR5_WRITE_POL_36", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{35, 35, 0x0000000000000000, "RO", "IMR5_WRITE_POL_35", "Bunit IMR5 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR5 region based on the agents 6bit encoded SAI value."},
#else
{35, 35, 0x0000000000000000, "RO", "IMR5_WRITE_POL_35", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{34, 34, 0x0000000000000000, "RW", "IMR5_WRITE_POL_34", "Bunit IMR5 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR5 region based on the agents 6bit encoded SAI value."},
#else
{34, 34, 0x0000000000000000, "RW", "IMR5_WRITE_POL_34", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{33, 33, 0x0000000000000000, "RW", "IMR5_WRITE_POL_33", "Bunit IMR5 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR5 region based on the agents 6bit encoded SAI value."},
#else
{33, 33, 0x0000000000000000, "RW", "IMR5_WRITE_POL_33", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{32, 32, 0x0000000000000000, "RW", "IMR5_WRITE_POL_32", "Bunit IMR5 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR5 region based on the agents 6bit encoded SAI value."},
#else
{32, 32, 0x0000000000000000, "RW", "IMR5_WRITE_POL_32", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{31, 31, 0x0000000000000000, "RO", "IMR5_WRITE_POL_31", "Bunit IMR5 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR5 region based on the agents 6bit encoded SAI value."},
#else
{31, 31, 0x0000000000000000, "RO", "IMR5_WRITE_POL_31", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{30, 30, 0x0000000000000000, "RW", "IMR5_WRITE_POL_30", "Bunit IMR5 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR5 region based on the agents 6bit encoded SAI value."},
#else
{30, 30, 0x0000000000000000, "RW", "IMR5_WRITE_POL_30", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{29, 29, 0x0000000000000000, "RW", "IMR5_WRITE_POL_29", "Bunit IMR5 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR5 region based on the agents 6bit encoded SAI value."},
#else
{29, 29, 0x0000000000000000, "RW", "IMR5_WRITE_POL_29", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{28, 28, 0x0000000000000000, "RW", "IMR5_WRITE_POL_28", "Bunit IMR5 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR5 region based on the agents 6bit encoded SAI value."},
#else
{28, 28, 0x0000000000000000, "RW", "IMR5_WRITE_POL_28", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{27, 27, 0x0000000000000000, "RW", "IMR5_WRITE_POL_27", "Bunit IMR5 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR5 region based on the agents 6bit encoded SAI value."},
#else
{27, 27, 0x0000000000000000, "RW", "IMR5_WRITE_POL_27", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{26, 26, 0x0000000000000000, "RW", "IMR5_WRITE_POL_26", "Bunit IMR5 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR5 region based on the agents 6bit encoded SAI value."},
#else
{26, 26, 0x0000000000000000, "RW", "IMR5_WRITE_POL_26", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{25, 25, 0x0000000000000000, "RW", "IMR5_WRITE_POL_25", "Bunit IMR5 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR5 region based on the agents 6bit encoded SAI value."},
#else
{25, 25, 0x0000000000000000, "RW", "IMR5_WRITE_POL_25", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{24, 24, 0x0000000000000000, "RW", "IMR5_WRITE_POL_24", "Bunit IMR5 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR5 region based on the agents 6bit encoded SAI value."},
#else
{24, 24, 0x0000000000000000, "RW", "IMR5_WRITE_POL_24", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{23, 23, 0x0000000000000000, "RO", "IMR5_WRITE_POL_23", "Bunit IMR5 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR5 region based on the agents 6bit encoded SAI value."},
#else
{23, 23, 0x0000000000000000, "RO", "IMR5_WRITE_POL_23", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{22, 22, 0x0000000000000000, "RO", "IMR5_WRITE_POL_22", "Bunit IMR5 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR5 region based on the agents 6bit encoded SAI value."},
#else
{22, 22, 0x0000000000000000, "RO", "IMR5_WRITE_POL_22", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{21, 21, 0x0000000000000000, "RW", "IMR5_WRITE_POL_21", "Bunit IMR5 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR5 region based on the agents 6bit encoded SAI value."},
#else
{21, 21, 0x0000000000000000, "RW", "IMR5_WRITE_POL_21", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{20, 20, 0x0000000000000000, "RO", "IMR5_WRITE_POL_20", "Bunit IMR5 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR5 region based on the agents 6bit encoded SAI value."},
#else
{20, 20, 0x0000000000000000, "RO", "IMR5_WRITE_POL_20", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{19, 19, 0x0000000000000000, "RO", "IMR5_WRITE_POL_19", "Bunit IMR5 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR5 region based on the agents 6bit encoded SAI value."},
#else
{19, 19, 0x0000000000000000, "RO", "IMR5_WRITE_POL_19", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{18, 18, 0x0000000000000000, "RO", "IMR5_WRITE_POL_18", "Bunit IMR5 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR5 region based on the agents 6bit encoded SAI value."},
#else
{18, 18, 0x0000000000000000, "RO", "IMR5_WRITE_POL_18", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{17, 17, 0x0000000000000000, "RW", "IMR5_WRITE_POL_17", "Bunit IMR5 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR5 region based on the agents 6bit encoded SAI value."},
#else
{17, 17, 0x0000000000000000, "RW", "IMR5_WRITE_POL_17", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{16, 16, 0x0000000000000000, "RW", "IMR5_WRITE_POL_16", "Bunit IMR5 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR5 region based on the agents 6bit encoded SAI value."},
#else
{16, 16, 0x0000000000000000, "RW", "IMR5_WRITE_POL_16", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{15, 15, 0x0000000000000000, "RO", "IMR5_WRITE_POL_15", "Bunit IMR5 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR5 region based on the agents 6bit encoded SAI value."},
#else
{15, 15, 0x0000000000000000, "RO", "IMR5_WRITE_POL_15", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{14, 14, 0x0000000000000000, "RO", "IMR5_WRITE_POL_14", "Bunit IMR5 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR5 region based on the agents 6bit encoded SAI value."},
#else
{14, 14, 0x0000000000000000, "RO", "IMR5_WRITE_POL_14", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{13, 13, 0x0000000000000000, "RW", "IMR5_WRITE_POL_13", "Bunit IMR5 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR5 region based on the agents 6bit encoded SAI value."},
#else
{13, 13, 0x0000000000000000, "RW", "IMR5_WRITE_POL_13", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{12, 12, 0x0000000000000000, "RW", "IMR5_WRITE_POL_12", "Bunit IMR5 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR5 region based on the agents 6bit encoded SAI value."},
#else
{12, 12, 0x0000000000000000, "RW", "IMR5_WRITE_POL_12", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{11, 11, 0x0000000000000000, "RO", "IMR5_WRITE_POL_11", "Bunit IMR5 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR5 region based on the agents 6bit encoded SAI value."},
#else
{11, 11, 0x0000000000000000, "RO", "IMR5_WRITE_POL_11", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{10, 10, 0x0000000000000000, "RO", "IMR5_WRITE_POL_10", "Bunit IMR5 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR5 region based on the agents 6bit encoded SAI value."},
#else
{10, 10, 0x0000000000000000, "RO", "IMR5_WRITE_POL_10", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{9, 9, 0x0000000000000000, "RO", "IMR5_WRITE_POL_9", "Bunit IMR5 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR5 region based on the agents 6bit encoded SAI value."},
#else
{9, 9, 0x0000000000000000, "RO", "IMR5_WRITE_POL_9", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{8, 8, 0x0000000000000000, "RW", "IMR5_WRITE_POL_8", "Bunit IMR5 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR5 region based on the agents 6bit encoded SAI value."},
#else
{8, 8, 0x0000000000000000, "RW", "IMR5_WRITE_POL_8", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{7, 7, 0x0000000000000000, "RO", "IMR5_WRITE_POL_7", "Bunit IMR5 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR5 region based on the agents 6bit encoded SAI value."},
#else
{7, 7, 0x0000000000000000, "RO", "IMR5_WRITE_POL_7", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{6, 6, 0x0000000000000000, "RO", "IMR5_WRITE_POL_6", "Bunit IMR5 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR5 region based on the agents 6bit encoded SAI value."},
#else
{6, 6, 0x0000000000000000, "RO", "IMR5_WRITE_POL_6", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{5, 5, 0x0000000000000000, "RW", "IMR5_WRITE_POL_5", "Bunit IMR5 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR5 region based on the agents 6bit encoded SAI value."},
#else
{5, 5, 0x0000000000000000, "RW", "IMR5_WRITE_POL_5", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{4, 4, 0x0000000000000000, "RW", "IMR5_WRITE_POL_4", "Bunit IMR5 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR5 region based on the agents 6bit encoded SAI value."},
#else
{4, 4, 0x0000000000000000, "RW", "IMR5_WRITE_POL_4", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{3, 3, 0x0000000000000000, "RW", "IMR5_WRITE_POL_3", "Bunit IMR5 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR5 region based on the agents 6bit encoded SAI value."},
#else
{3, 3, 0x0000000000000000, "RW", "IMR5_WRITE_POL_3", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{2, 2, 0x0000000000000000, "RW", "IMR5_WRITE_POL_2", "Bunit IMR5 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR5 region based on the agents 6bit encoded SAI value."},
#else
{2, 2, 0x0000000000000000, "RW", "IMR5_WRITE_POL_2", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{1, 1, 0x0000000000000000, "RW", "IMR5_WRITE_POL_1", "Bunit IMR5 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR5 region based on the agents 6bit encoded SAI value."},
#else
{1, 1, 0x0000000000000000, "RW", "IMR5_WRITE_POL_1", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 0, 0x0000000000000000, "RW", "IMR5_WRITE_POL_0", "Bunit IMR5 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR5 region based on the agents 6bit encoded SAI value."},
#else
{0, 0, 0x0000000000000000, "RW", "IMR5_WRITE_POL_0", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo906[] = {{"B_CR_BIMR5WAC_0_0_0_MCHBAR", "", 0x00006928, 64, 0xFFFFFFFFFFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields907[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{31, 31, 0x0000000000000000, "RW", "IMR_EN", "IMR Enable: Enables access checking for the IMR region."},
#else
{31, 31, 0x0000000000000000, "RW", "IMR_EN", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{30, 30, 0x0000000000000000, "RW", "TR_EN", "Asset Classification AC[0]: Trace Enable: Enables snooping of transactions to the IMR region by tracing agents."},
#else
{30, 30, 0x0000000000000000, "RW", "TR_EN", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{29, 29, 0x0000000000000000, "RO", "RESERVED_1", "Reserved"},
#else
{29, 29, 0x0000000000000000, "RO", "RESERVED_1", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 28, 0x0000000000000000, "RW", "IMR6_BASE", "Base 0 IMR6BASE:  Specifies bits 38:10 of the start address of IMR6 region.  IMR region size must be a strict poweroftwo at least 1KB and naturally aligned to the size.  These bits are compared with the result of the IMR6MASK[28:0] applied to bits 38:10 of the incoming address to determine if an access falls within the IMR6 defined region."},
#else
{0, 28, 0x0000000000000000, "RW", "IMR6_BASE", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo907[] = {{"B_CR_BIMR6BASE_0_0_0_MCHBAR", "", 0x00006930, 4, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields908[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{31, 31, 0x0000000000000000, "RW", "GT_IWB_EN", "Asset Classification AC[2]: GT Implicit WB Enable: Enables implicit writebacks to protected region from GT caching agent. When set to 1 enables implicit writeback data HITM data from GT to be returned to the requester.  When set to 0 inhibits HITM data from GT from being returned to the requester.  HITM data from IA cores may be returned to the requester depending on the setting of the IA_IWB_EN bit."},
#else
{31, 31, 0x0000000000000000, "RW", "GT_IWB_EN", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{30, 30, 0x0000000000000000, "RW", "IA_IWB_EN", "Asset Classification AC[1]: IA Implicit WB Enable: Enables implicit writebacks to protected region from IA caching agent.  When set to 1 enables implicit writeback data HITM data from IA cores to be returned to the requester.  When set to 0 inhibits HITM data from IA cores from being returned to the requester.  HITM data from GT may be returned to the requester depending on the setting of the GT_IWB_EN bit."},
#else
{30, 30, 0x0000000000000000, "RW", "IA_IWB_EN", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{29, 29, 0x0000000000000000, "RO", "RESERVED_0", "Reserved"},
#else
{29, 29, 0x0000000000000000, "RO", "RESERVED_0", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 28, 0x0000000000000000, "RW", "IMR6_MASK", "Mask 0 IMR6MASK:  These bits are ANDed with bits 38:10 of the incoming address to determine if the combined result matches the IMR6BASE[28:0] value.  A match indicates the the incoming address falls within the IMR6 region."},
#else
{0, 28, 0x0000000000000000, "RW", "IMR6_MASK", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo908[] = {{"B_CR_BIMR6MASK_0_0_0_MCHBAR", "", 0x00006934, 4, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields909[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{0, 63, 0x00000C0061010202, "RW", "IMR6_CTRL_POL", "Bunit IMR6 Control Policy: Bit vector used to determine which agents are allowed access to the BIMR6RAC, BIMR6WAC, BIMR6CP registers based on the value from the agents 6bit SAI field."},
#else
{0, 63, 0x00000C0061010202, "RW", "IMR6_CTRL_POL", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo909[] = {{"B_CR_BIMR6CP_0_0_0_MCHBAR", "", 0x00006938, 1, 0xFFFFFFFFFFFFFFFF, 0x00000C0061010202}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields910[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{63, 63, 0x0000000000000000, "RW", "IMR6_READ_POL_63", "Bunit IMR6 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR6 region based on the agents 6bit encoded SAI value."},
#else
{63, 63, 0x0000000000000000, "RW", "IMR6_READ_POL_63", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{62, 62, 0x0000000000000000, "RO", "IMR6_READ_POL_62", "Bunit IMR6 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR6 region based on the agents 6bit encoded SAI value."},
#else
{62, 62, 0x0000000000000000, "RO", "IMR6_READ_POL_62", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{61, 61, 0x0000000000000000, "RO", "IMR6_READ_POL_61", "Bunit IMR6 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR6 region based on the agents 6bit encoded SAI value."},
#else
{61, 61, 0x0000000000000000, "RO", "IMR6_READ_POL_61", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{60, 60, 0x0000000000000000, "RO", "IMR6_READ_POL_60", "Bunit IMR6 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR6 region based on the agents 6bit encoded SAI value."},
#else
{60, 60, 0x0000000000000000, "RO", "IMR6_READ_POL_60", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{59, 59, 0x0000000000000000, "RO", "IMR6_READ_POL_59", "Bunit IMR6 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR6 region based on the agents 6bit encoded SAI value."},
#else
{59, 59, 0x0000000000000000, "RO", "IMR6_READ_POL_59", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{58, 58, 0x0000000000000000, "RO", "IMR6_READ_POL_58", "Bunit IMR6 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR6 region based on the agents 6bit encoded SAI value."},
#else
{58, 58, 0x0000000000000000, "RO", "IMR6_READ_POL_58", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{57, 57, 0x0000000000000000, "RO", "IMR6_READ_POL_57", "Bunit IMR6 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR6 region based on the agents 6bit encoded SAI value."},
#else
{57, 57, 0x0000000000000000, "RO", "IMR6_READ_POL_57", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{56, 56, 0x0000000000000000, "RW", "IMR6_READ_POL_56", "Bunit IMR6 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR6 region based on the agents 6bit encoded SAI value."},
#else
{56, 56, 0x0000000000000000, "RW", "IMR6_READ_POL_56", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{55, 55, 0x0000000000000000, "RW", "IMR6_READ_POL_55", "Bunit IMR6 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR6 region based on the agents 6bit encoded SAI value."},
#else
{55, 55, 0x0000000000000000, "RW", "IMR6_READ_POL_55", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{54, 54, 0x0000000000000000, "RW", "IMR6_READ_POL_54", "Bunit IMR6 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR6 region based on the agents 6bit encoded SAI value."},
#else
{54, 54, 0x0000000000000000, "RW", "IMR6_READ_POL_54", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{53, 53, 0x0000000000000000, "RO", "IMR6_READ_POL_53", "Bunit IMR6 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR6 region based on the agents 6bit encoded SAI value."},
#else
{53, 53, 0x0000000000000000, "RO", "IMR6_READ_POL_53", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{52, 52, 0x0000000000000000, "RO", "IMR6_READ_POL_52", "Bunit IMR6 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR6 region based on the agents 6bit encoded SAI value."},
#else
{52, 52, 0x0000000000000000, "RO", "IMR6_READ_POL_52", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{51, 51, 0x0000000000000000, "RO", "IMR6_READ_POL_51", "Bunit IMR6 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR6 region based on the agents 6bit encoded SAI value."},
#else
{51, 51, 0x0000000000000000, "RO", "IMR6_READ_POL_51", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{50, 50, 0x0000000000000000, "RW", "IMR6_READ_POL_50", "Bunit IMR6 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR6 region based on the agents 6bit encoded SAI value."},
#else
{50, 50, 0x0000000000000000, "RW", "IMR6_READ_POL_50", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{49, 49, 0x0000000000000000, "RW", "IMR6_READ_POL_49", "Bunit IMR6 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR6 region based on the agents 6bit encoded SAI value."},
#else
{49, 49, 0x0000000000000000, "RW", "IMR6_READ_POL_49", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{48, 48, 0x0000000000000000, "RW", "IMR6_READ_POL_48", "Bunit IMR6 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR6 region based on the agents 6bit encoded SAI value."},
#else
{48, 48, 0x0000000000000000, "RW", "IMR6_READ_POL_48", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{47, 47, 0x0000000000000000, "RO", "IMR6_READ_POL_47", "Bunit IMR6 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR6 region based on the agents 6bit encoded SAI value."},
#else
{47, 47, 0x0000000000000000, "RO", "IMR6_READ_POL_47", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{46, 46, 0x0000000000000000, "RO", "IMR6_READ_POL_46", "Bunit IMR6 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR6 region based on the agents 6bit encoded SAI value."},
#else
{46, 46, 0x0000000000000000, "RO", "IMR6_READ_POL_46", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{45, 45, 0x0000000000000000, "RO", "IMR6_READ_POL_45", "Bunit IMR6 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR6 region based on the agents 6bit encoded SAI value."},
#else
{45, 45, 0x0000000000000000, "RO", "IMR6_READ_POL_45", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{44, 44, 0x0000000000000000, "RW", "IMR6_READ_POL_44", "Bunit IMR6 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR6 region based on the agents 6bit encoded SAI value."},
#else
{44, 44, 0x0000000000000000, "RW", "IMR6_READ_POL_44", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{43, 43, 0x0000000000000000, "RW", "IMR6_READ_POL_43", "Bunit IMR6 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR6 region based on the agents 6bit encoded SAI value."},
#else
{43, 43, 0x0000000000000000, "RW", "IMR6_READ_POL_43", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{42, 42, 0x0000000000000000, "RW", "IMR6_READ_POL_42", "Bunit IMR6 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR6 region based on the agents 6bit encoded SAI value."},
#else
{42, 42, 0x0000000000000000, "RW", "IMR6_READ_POL_42", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{41, 41, 0x0000000000000000, "RW", "IMR6_READ_POL_41", "Bunit IMR6 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR6 region based on the agents 6bit encoded SAI value."},
#else
{41, 41, 0x0000000000000000, "RW", "IMR6_READ_POL_41", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{40, 40, 0x0000000000000000, "RW", "IMR6_READ_POL_40", "Bunit IMR6 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR6 region based on the agents 6bit encoded SAI value."},
#else
{40, 40, 0x0000000000000000, "RW", "IMR6_READ_POL_40", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{39, 39, 0x0000000000000000, "RO", "IMR6_READ_POL_39", "Bunit IMR6 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR6 region based on the agents 6bit encoded SAI value."},
#else
{39, 39, 0x0000000000000000, "RO", "IMR6_READ_POL_39", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{38, 38, 0x0000000000000000, "RW", "IMR6_READ_POL_38", "Bunit IMR6 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR6 region based on the agents 6bit encoded SAI value."},
#else
{38, 38, 0x0000000000000000, "RW", "IMR6_READ_POL_38", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{37, 37, 0x0000000000000000, "RO", "IMR6_READ_POL_37", "Bunit IMR6 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR6 region based on the agents 6bit encoded SAI value."},
#else
{37, 37, 0x0000000000000000, "RO", "IMR6_READ_POL_37", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{36, 36, 0x0000000000000000, "RW", "IMR6_READ_POL_36", "Bunit IMR6 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR6 region based on the agents 6bit encoded SAI value."},
#else
{36, 36, 0x0000000000000000, "RW", "IMR6_READ_POL_36", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{35, 35, 0x0000000000000000, "RO", "IMR6_READ_POL_35", "Bunit IMR6 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR6 region based on the agents 6bit encoded SAI value."},
#else
{35, 35, 0x0000000000000000, "RO", "IMR6_READ_POL_35", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{34, 34, 0x0000000000000000, "RW", "IMR6_READ_POL_34", "Bunit IMR6 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR6 region based on the agents 6bit encoded SAI value."},
#else
{34, 34, 0x0000000000000000, "RW", "IMR6_READ_POL_34", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{33, 33, 0x0000000000000000, "RW", "IMR6_READ_POL_33", "Bunit IMR6 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR6 region based on the agents 6bit encoded SAI value."},
#else
{33, 33, 0x0000000000000000, "RW", "IMR6_READ_POL_33", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{32, 32, 0x0000000000000000, "RW", "IMR6_READ_POL_32", "Bunit IMR6 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR6 region based on the agents 6bit encoded SAI value."},
#else
{32, 32, 0x0000000000000000, "RW", "IMR6_READ_POL_32", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{31, 31, 0x0000000000000000, "RO", "IMR6_READ_POL_31", "Bunit IMR6 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR6 region based on the agents 6bit encoded SAI value."},
#else
{31, 31, 0x0000000000000000, "RO", "IMR6_READ_POL_31", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{30, 30, 0x0000000000000000, "RW", "IMR6_READ_POL_30", "Bunit IMR6 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR6 region based on the agents 6bit encoded SAI value."},
#else
{30, 30, 0x0000000000000000, "RW", "IMR6_READ_POL_30", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{29, 29, 0x0000000000000000, "RW", "IMR6_READ_POL_29", "Bunit IMR6 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR6 region based on the agents 6bit encoded SAI value."},
#else
{29, 29, 0x0000000000000000, "RW", "IMR6_READ_POL_29", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{28, 28, 0x0000000000000000, "RW", "IMR6_READ_POL_28", "Bunit IMR6 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR6 region based on the agents 6bit encoded SAI value."},
#else
{28, 28, 0x0000000000000000, "RW", "IMR6_READ_POL_28", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{27, 27, 0x0000000000000000, "RW", "IMR6_READ_POL_27", "Bunit IMR6 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR6 region based on the agents 6bit encoded SAI value."},
#else
{27, 27, 0x0000000000000000, "RW", "IMR6_READ_POL_27", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{26, 26, 0x0000000000000000, "RW", "IMR6_READ_POL_26", "Bunit IMR6 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR6 region based on the agents 6bit encoded SAI value."},
#else
{26, 26, 0x0000000000000000, "RW", "IMR6_READ_POL_26", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{25, 25, 0x0000000000000000, "RW", "IMR6_READ_POL_25", "Bunit IMR6 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR6 region based on the agents 6bit encoded SAI value."},
#else
{25, 25, 0x0000000000000000, "RW", "IMR6_READ_POL_25", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{24, 24, 0x0000000000000000, "RW", "IMR6_READ_POL_24", "Bunit IMR6 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR6 region based on the agents 6bit encoded SAI value."},
#else
{24, 24, 0x0000000000000000, "RW", "IMR6_READ_POL_24", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{23, 23, 0x0000000000000000, "RO", "IMR6_READ_POL_23", "Bunit IMR6 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR6 region based on the agents 6bit encoded SAI value."},
#else
{23, 23, 0x0000000000000000, "RO", "IMR6_READ_POL_23", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{22, 22, 0x0000000000000000, "RO", "IMR6_READ_POL_22", "Bunit IMR6 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR6 region based on the agents 6bit encoded SAI value."},
#else
{22, 22, 0x0000000000000000, "RO", "IMR6_READ_POL_22", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{21, 21, 0x0000000000000000, "RW", "IMR6_READ_POL_21", "Bunit IMR6 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR6 region based on the agents 6bit encoded SAI value."},
#else
{21, 21, 0x0000000000000000, "RW", "IMR6_READ_POL_21", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{20, 20, 0x0000000000000000, "RO", "IMR6_READ_POL_20", "Bunit IMR6 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR6 region based on the agents 6bit encoded SAI value."},
#else
{20, 20, 0x0000000000000000, "RO", "IMR6_READ_POL_20", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{19, 19, 0x0000000000000000, "RO", "IMR6_READ_POL_19", "Bunit IMR6 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR6 region based on the agents 6bit encoded SAI value."},
#else
{19, 19, 0x0000000000000000, "RO", "IMR6_READ_POL_19", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{18, 18, 0x0000000000000000, "RO", "IMR6_READ_POL_18", "Bunit IMR6 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR6 region based on the agents 6bit encoded SAI value."},
#else
{18, 18, 0x0000000000000000, "RO", "IMR6_READ_POL_18", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{17, 17, 0x0000000000000000, "RW", "IMR6_READ_POL_17", "Bunit IMR6 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR6 region based on the agents 6bit encoded SAI value."},
#else
{17, 17, 0x0000000000000000, "RW", "IMR6_READ_POL_17", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{16, 16, 0x0000000000000000, "RW", "IMR6_READ_POL_16", "Bunit IMR6 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR6 region based on the agents 6bit encoded SAI value."},
#else
{16, 16, 0x0000000000000000, "RW", "IMR6_READ_POL_16", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{15, 15, 0x0000000000000000, "RO", "IMR6_READ_POL_15", "Bunit IMR6 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR6 region based on the agents 6bit encoded SAI value."},
#else
{15, 15, 0x0000000000000000, "RO", "IMR6_READ_POL_15", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{14, 14, 0x0000000000000000, "RO", "IMR6_READ_POL_14", "Bunit IMR6 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR6 region based on the agents 6bit encoded SAI value."},
#else
{14, 14, 0x0000000000000000, "RO", "IMR6_READ_POL_14", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{13, 13, 0x0000000000000000, "RW", "IMR6_READ_POL_13", "Bunit IMR6 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR6 region based on the agents 6bit encoded SAI value."},
#else
{13, 13, 0x0000000000000000, "RW", "IMR6_READ_POL_13", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{12, 12, 0x0000000000000000, "RW", "IMR6_READ_POL_12", "Bunit IMR6 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR6 region based on the agents 6bit encoded SAI value."},
#else
{12, 12, 0x0000000000000000, "RW", "IMR6_READ_POL_12", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{11, 11, 0x0000000000000000, "RO", "IMR6_READ_POL_11", "Bunit IMR6 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR6 region based on the agents 6bit encoded SAI value."},
#else
{11, 11, 0x0000000000000000, "RO", "IMR6_READ_POL_11", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{10, 10, 0x0000000000000000, "RO", "IMR6_READ_POL_10", "Bunit IMR6 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR6 region based on the agents 6bit encoded SAI value."},
#else
{10, 10, 0x0000000000000000, "RO", "IMR6_READ_POL_10", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{9, 9, 0x0000000000000000, "RO", "IMR6_READ_POL_9", "Bunit IMR6 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR6 region based on the agents 6bit encoded SAI value."},
#else
{9, 9, 0x0000000000000000, "RO", "IMR6_READ_POL_9", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{8, 8, 0x0000000000000000, "RW", "IMR6_READ_POL_8", "Bunit IMR6 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR6 region based on the agents 6bit encoded SAI value."},
#else
{8, 8, 0x0000000000000000, "RW", "IMR6_READ_POL_8", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{7, 7, 0x0000000000000000, "RO", "IMR6_READ_POL_7", "Bunit IMR6 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR6 region based on the agents 6bit encoded SAI value."},
#else
{7, 7, 0x0000000000000000, "RO", "IMR6_READ_POL_7", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{6, 6, 0x0000000000000000, "RO", "IMR6_READ_POL_6", "Bunit IMR6 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR6 region based on the agents 6bit encoded SAI value."},
#else
{6, 6, 0x0000000000000000, "RO", "IMR6_READ_POL_6", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{5, 5, 0x0000000000000000, "RW", "IMR6_READ_POL_5", "Bunit IMR6 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR6 region based on the agents 6bit encoded SAI value."},
#else
{5, 5, 0x0000000000000000, "RW", "IMR6_READ_POL_5", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{4, 4, 0x0000000000000000, "RW", "IMR6_READ_POL_4", "Bunit IMR6 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR6 region based on the agents 6bit encoded SAI value."},
#else
{4, 4, 0x0000000000000000, "RW", "IMR6_READ_POL_4", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{3, 3, 0x0000000000000000, "RW", "IMR6_READ_POL_3", "Bunit IMR6 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR6 region based on the agents 6bit encoded SAI value."},
#else
{3, 3, 0x0000000000000000, "RW", "IMR6_READ_POL_3", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{2, 2, 0x0000000000000000, "RW", "IMR6_READ_POL_2", "Bunit IMR6 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR6 region based on the agents 6bit encoded SAI value."},
#else
{2, 2, 0x0000000000000000, "RW", "IMR6_READ_POL_2", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{1, 1, 0x0000000000000000, "RW", "IMR6_READ_POL_1", "Bunit IMR6 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR6 region based on the agents 6bit encoded SAI value."},
#else
{1, 1, 0x0000000000000000, "RW", "IMR6_READ_POL_1", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 0, 0x0000000000000000, "RW", "IMR6_READ_POL_0", "Bunit IMR6 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR6 region based on the agents 6bit encoded SAI value."},
#else
{0, 0, 0x0000000000000000, "RW", "IMR6_READ_POL_0", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo910[] = {{"B_CR_BIMR6RAC_0_0_0_MCHBAR", "", 0x00006940, 64, 0xFFFFFFFFFFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields911[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{63, 63, 0x0000000000000000, "RW", "IMR6_WRITE_POL_63", "Bunit IMR6 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR6 region based on the agents 6bit encoded SAI value."},
#else
{63, 63, 0x0000000000000000, "RW", "IMR6_WRITE_POL_63", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{62, 62, 0x0000000000000000, "RO", "IMR6_WRITE_POL_62", "Bunit IMR6 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR6 region based on the agents 6bit encoded SAI value."},
#else
{62, 62, 0x0000000000000000, "RO", "IMR6_WRITE_POL_62", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{61, 61, 0x0000000000000000, "RO", "IMR6_WRITE_POL_61", "Bunit IMR6 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR6 region based on the agents 6bit encoded SAI value."},
#else
{61, 61, 0x0000000000000000, "RO", "IMR6_WRITE_POL_61", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{60, 60, 0x0000000000000000, "RO", "IMR6_WRITE_POL_60", "Bunit IMR6 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR6 region based on the agents 6bit encoded SAI value."},
#else
{60, 60, 0x0000000000000000, "RO", "IMR6_WRITE_POL_60", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{59, 59, 0x0000000000000000, "RO", "IMR6_WRITE_POL_59", "Bunit IMR6 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR6 region based on the agents 6bit encoded SAI value."},
#else
{59, 59, 0x0000000000000000, "RO", "IMR6_WRITE_POL_59", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{58, 58, 0x0000000000000000, "RO", "IMR6_WRITE_POL_58", "Bunit IMR6 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR6 region based on the agents 6bit encoded SAI value."},
#else
{58, 58, 0x0000000000000000, "RO", "IMR6_WRITE_POL_58", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{57, 57, 0x0000000000000000, "RO", "IMR6_WRITE_POL_57", "Bunit IMR6 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR6 region based on the agents 6bit encoded SAI value."},
#else
{57, 57, 0x0000000000000000, "RO", "IMR6_WRITE_POL_57", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{56, 56, 0x0000000000000000, "RW", "IMR6_WRITE_POL_56", "Bunit IMR6 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR6 region based on the agents 6bit encoded SAI value."},
#else
{56, 56, 0x0000000000000000, "RW", "IMR6_WRITE_POL_56", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{55, 55, 0x0000000000000000, "RW", "IMR6_WRITE_POL_55", "Bunit IMR6 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR6 region based on the agents 6bit encoded SAI value."},
#else
{55, 55, 0x0000000000000000, "RW", "IMR6_WRITE_POL_55", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{54, 54, 0x0000000000000000, "RW", "IMR6_WRITE_POL_54", "Bunit IMR6 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR6 region based on the agents 6bit encoded SAI value."},
#else
{54, 54, 0x0000000000000000, "RW", "IMR6_WRITE_POL_54", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{53, 53, 0x0000000000000000, "RO", "IMR6_WRITE_POL_53", "Bunit IMR6 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR6 region based on the agents 6bit encoded SAI value."},
#else
{53, 53, 0x0000000000000000, "RO", "IMR6_WRITE_POL_53", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{52, 52, 0x0000000000000000, "RO", "IMR6_WRITE_POL_52", "Bunit IMR6 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR6 region based on the agents 6bit encoded SAI value."},
#else
{52, 52, 0x0000000000000000, "RO", "IMR6_WRITE_POL_52", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{51, 51, 0x0000000000000000, "RO", "IMR6_WRITE_POL_51", "Bunit IMR6 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR6 region based on the agents 6bit encoded SAI value."},
#else
{51, 51, 0x0000000000000000, "RO", "IMR6_WRITE_POL_51", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{50, 50, 0x0000000000000000, "RW", "IMR6_WRITE_POL_50", "Bunit IMR6 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR6 region based on the agents 6bit encoded SAI value."},
#else
{50, 50, 0x0000000000000000, "RW", "IMR6_WRITE_POL_50", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{49, 49, 0x0000000000000000, "RW", "IMR6_WRITE_POL_49", "Bunit IMR6 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR6 region based on the agents 6bit encoded SAI value."},
#else
{49, 49, 0x0000000000000000, "RW", "IMR6_WRITE_POL_49", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{48, 48, 0x0000000000000000, "RW", "IMR6_WRITE_POL_48", "Bunit IMR6 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR6 region based on the agents 6bit encoded SAI value."},
#else
{48, 48, 0x0000000000000000, "RW", "IMR6_WRITE_POL_48", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{47, 47, 0x0000000000000000, "RO", "IMR6_WRITE_POL_47", "Bunit IMR6 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR6 region based on the agents 6bit encoded SAI value."},
#else
{47, 47, 0x0000000000000000, "RO", "IMR6_WRITE_POL_47", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{46, 46, 0x0000000000000000, "RO", "IMR6_WRITE_POL_46", "Bunit IMR6 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR6 region based on the agents 6bit encoded SAI value."},
#else
{46, 46, 0x0000000000000000, "RO", "IMR6_WRITE_POL_46", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{45, 45, 0x0000000000000000, "RO", "IMR6_WRITE_POL_45", "Bunit IMR6 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR6 region based on the agents 6bit encoded SAI value."},
#else
{45, 45, 0x0000000000000000, "RO", "IMR6_WRITE_POL_45", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{44, 44, 0x0000000000000000, "RW", "IMR6_WRITE_POL_44", "Bunit IMR6 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR6 region based on the agents 6bit encoded SAI value."},
#else
{44, 44, 0x0000000000000000, "RW", "IMR6_WRITE_POL_44", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{43, 43, 0x0000000000000000, "RW", "IMR6_WRITE_POL_43", "Bunit IMR6 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR6 region based on the agents 6bit encoded SAI value."},
#else
{43, 43, 0x0000000000000000, "RW", "IMR6_WRITE_POL_43", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{42, 42, 0x0000000000000000, "RW", "IMR6_WRITE_POL_42", "Bunit IMR6 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR6 region based on the agents 6bit encoded SAI value."},
#else
{42, 42, 0x0000000000000000, "RW", "IMR6_WRITE_POL_42", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{41, 41, 0x0000000000000000, "RW", "IMR6_WRITE_POL_41", "Bunit IMR6 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR6 region based on the agents 6bit encoded SAI value."},
#else
{41, 41, 0x0000000000000000, "RW", "IMR6_WRITE_POL_41", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{40, 40, 0x0000000000000000, "RW", "IMR6_WRITE_POL_40", "Bunit IMR6 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR6 region based on the agents 6bit encoded SAI value."},
#else
{40, 40, 0x0000000000000000, "RW", "IMR6_WRITE_POL_40", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{39, 39, 0x0000000000000000, "RO", "IMR6_WRITE_POL_39", "Bunit IMR6 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR6 region based on the agents 6bit encoded SAI value."},
#else
{39, 39, 0x0000000000000000, "RO", "IMR6_WRITE_POL_39", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{38, 38, 0x0000000000000000, "RW", "IMR6_WRITE_POL_38", "Bunit IMR6 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR6 region based on the agents 6bit encoded SAI value."},
#else
{38, 38, 0x0000000000000000, "RW", "IMR6_WRITE_POL_38", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{37, 37, 0x0000000000000000, "RO", "IMR6_WRITE_POL_37", "Bunit IMR6 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR6 region based on the agents 6bit encoded SAI value."},
#else
{37, 37, 0x0000000000000000, "RO", "IMR6_WRITE_POL_37", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{36, 36, 0x0000000000000000, "RW", "IMR6_WRITE_POL_36", "Bunit IMR6 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR6 region based on the agents 6bit encoded SAI value."},
#else
{36, 36, 0x0000000000000000, "RW", "IMR6_WRITE_POL_36", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{35, 35, 0x0000000000000000, "RO", "IMR6_WRITE_POL_35", "Bunit IMR6 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR6 region based on the agents 6bit encoded SAI value."},
#else
{35, 35, 0x0000000000000000, "RO", "IMR6_WRITE_POL_35", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{34, 34, 0x0000000000000000, "RW", "IMR6_WRITE_POL_34", "Bunit IMR6 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR6 region based on the agents 6bit encoded SAI value."},
#else
{34, 34, 0x0000000000000000, "RW", "IMR6_WRITE_POL_34", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{33, 33, 0x0000000000000000, "RW", "IMR6_WRITE_POL_33", "Bunit IMR6 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR6 region based on the agents 6bit encoded SAI value."},
#else
{33, 33, 0x0000000000000000, "RW", "IMR6_WRITE_POL_33", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{32, 32, 0x0000000000000000, "RW", "IMR6_WRITE_POL_32", "Bunit IMR6 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR6 region based on the agents 6bit encoded SAI value."},
#else
{32, 32, 0x0000000000000000, "RW", "IMR6_WRITE_POL_32", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{31, 31, 0x0000000000000000, "RO", "IMR6_WRITE_POL_31", "Bunit IMR6 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR6 region based on the agents 6bit encoded SAI value."},
#else
{31, 31, 0x0000000000000000, "RO", "IMR6_WRITE_POL_31", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{30, 30, 0x0000000000000000, "RW", "IMR6_WRITE_POL_30", "Bunit IMR6 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR6 region based on the agents 6bit encoded SAI value."},
#else
{30, 30, 0x0000000000000000, "RW", "IMR6_WRITE_POL_30", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{29, 29, 0x0000000000000000, "RW", "IMR6_WRITE_POL_29", "Bunit IMR6 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR6 region based on the agents 6bit encoded SAI value."},
#else
{29, 29, 0x0000000000000000, "RW", "IMR6_WRITE_POL_29", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{28, 28, 0x0000000000000000, "RW", "IMR6_WRITE_POL_28", "Bunit IMR6 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR6 region based on the agents 6bit encoded SAI value."},
#else
{28, 28, 0x0000000000000000, "RW", "IMR6_WRITE_POL_28", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{27, 27, 0x0000000000000000, "RW", "IMR6_WRITE_POL_27", "Bunit IMR6 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR6 region based on the agents 6bit encoded SAI value."},
#else
{27, 27, 0x0000000000000000, "RW", "IMR6_WRITE_POL_27", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{26, 26, 0x0000000000000000, "RW", "IMR6_WRITE_POL_26", "Bunit IMR6 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR6 region based on the agents 6bit encoded SAI value."},
#else
{26, 26, 0x0000000000000000, "RW", "IMR6_WRITE_POL_26", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{25, 25, 0x0000000000000000, "RW", "IMR6_WRITE_POL_25", "Bunit IMR6 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR6 region based on the agents 6bit encoded SAI value."},
#else
{25, 25, 0x0000000000000000, "RW", "IMR6_WRITE_POL_25", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{24, 24, 0x0000000000000000, "RW", "IMR6_WRITE_POL_24", "Bunit IMR6 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR6 region based on the agents 6bit encoded SAI value."},
#else
{24, 24, 0x0000000000000000, "RW", "IMR6_WRITE_POL_24", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{23, 23, 0x0000000000000000, "RO", "IMR6_WRITE_POL_23", "Bunit IMR6 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR6 region based on the agents 6bit encoded SAI value."},
#else
{23, 23, 0x0000000000000000, "RO", "IMR6_WRITE_POL_23", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{22, 22, 0x0000000000000000, "RO", "IMR6_WRITE_POL_22", "Bunit IMR6 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR6 region based on the agents 6bit encoded SAI value."},
#else
{22, 22, 0x0000000000000000, "RO", "IMR6_WRITE_POL_22", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{21, 21, 0x0000000000000000, "RW", "IMR6_WRITE_POL_21", "Bunit IMR6 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR6 region based on the agents 6bit encoded SAI value."},
#else
{21, 21, 0x0000000000000000, "RW", "IMR6_WRITE_POL_21", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{20, 20, 0x0000000000000000, "RO", "IMR6_WRITE_POL_20", "Bunit IMR6 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR6 region based on the agents 6bit encoded SAI value."},
#else
{20, 20, 0x0000000000000000, "RO", "IMR6_WRITE_POL_20", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{19, 19, 0x0000000000000000, "RO", "IMR6_WRITE_POL_19", "Bunit IMR6 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR6 region based on the agents 6bit encoded SAI value."},
#else
{19, 19, 0x0000000000000000, "RO", "IMR6_WRITE_POL_19", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{18, 18, 0x0000000000000000, "RO", "IMR6_WRITE_POL_18", "Bunit IMR6 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR6 region based on the agents 6bit encoded SAI value."},
#else
{18, 18, 0x0000000000000000, "RO", "IMR6_WRITE_POL_18", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{17, 17, 0x0000000000000000, "RW", "IMR6_WRITE_POL_17", "Bunit IMR6 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR6 region based on the agents 6bit encoded SAI value."},
#else
{17, 17, 0x0000000000000000, "RW", "IMR6_WRITE_POL_17", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{16, 16, 0x0000000000000000, "RW", "IMR6_WRITE_POL_16", "Bunit IMR6 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR6 region based on the agents 6bit encoded SAI value."},
#else
{16, 16, 0x0000000000000000, "RW", "IMR6_WRITE_POL_16", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{15, 15, 0x0000000000000000, "RO", "IMR6_WRITE_POL_15", "Bunit IMR6 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR6 region based on the agents 6bit encoded SAI value."},
#else
{15, 15, 0x0000000000000000, "RO", "IMR6_WRITE_POL_15", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{14, 14, 0x0000000000000000, "RO", "IMR6_WRITE_POL_14", "Bunit IMR6 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR6 region based on the agents 6bit encoded SAI value."},
#else
{14, 14, 0x0000000000000000, "RO", "IMR6_WRITE_POL_14", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{13, 13, 0x0000000000000000, "RW", "IMR6_WRITE_POL_13", "Bunit IMR6 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR6 region based on the agents 6bit encoded SAI value."},
#else
{13, 13, 0x0000000000000000, "RW", "IMR6_WRITE_POL_13", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{12, 12, 0x0000000000000000, "RW", "IMR6_WRITE_POL_12", "Bunit IMR6 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR6 region based on the agents 6bit encoded SAI value."},
#else
{12, 12, 0x0000000000000000, "RW", "IMR6_WRITE_POL_12", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{11, 11, 0x0000000000000000, "RO", "IMR6_WRITE_POL_11", "Bunit IMR6 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR6 region based on the agents 6bit encoded SAI value."},
#else
{11, 11, 0x0000000000000000, "RO", "IMR6_WRITE_POL_11", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{10, 10, 0x0000000000000000, "RO", "IMR6_WRITE_POL_10", "Bunit IMR6 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR6 region based on the agents 6bit encoded SAI value."},
#else
{10, 10, 0x0000000000000000, "RO", "IMR6_WRITE_POL_10", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{9, 9, 0x0000000000000000, "RO", "IMR6_WRITE_POL_9", "Bunit IMR6 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR6 region based on the agents 6bit encoded SAI value."},
#else
{9, 9, 0x0000000000000000, "RO", "IMR6_WRITE_POL_9", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{8, 8, 0x0000000000000000, "RW", "IMR6_WRITE_POL_8", "Bunit IMR6 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR6 region based on the agents 6bit encoded SAI value."},
#else
{8, 8, 0x0000000000000000, "RW", "IMR6_WRITE_POL_8", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{7, 7, 0x0000000000000000, "RO", "IMR6_WRITE_POL_7", "Bunit IMR6 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR6 region based on the agents 6bit encoded SAI value."},
#else
{7, 7, 0x0000000000000000, "RO", "IMR6_WRITE_POL_7", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{6, 6, 0x0000000000000000, "RO", "IMR6_WRITE_POL_6", "Bunit IMR6 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR6 region based on the agents 6bit encoded SAI value."},
#else
{6, 6, 0x0000000000000000, "RO", "IMR6_WRITE_POL_6", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{5, 5, 0x0000000000000000, "RW", "IMR6_WRITE_POL_5", "Bunit IMR6 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR6 region based on the agents 6bit encoded SAI value."},
#else
{5, 5, 0x0000000000000000, "RW", "IMR6_WRITE_POL_5", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{4, 4, 0x0000000000000000, "RW", "IMR6_WRITE_POL_4", "Bunit IMR6 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR6 region based on the agents 6bit encoded SAI value."},
#else
{4, 4, 0x0000000000000000, "RW", "IMR6_WRITE_POL_4", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{3, 3, 0x0000000000000000, "RW", "IMR6_WRITE_POL_3", "Bunit IMR6 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR6 region based on the agents 6bit encoded SAI value."},
#else
{3, 3, 0x0000000000000000, "RW", "IMR6_WRITE_POL_3", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{2, 2, 0x0000000000000000, "RW", "IMR6_WRITE_POL_2", "Bunit IMR6 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR6 region based on the agents 6bit encoded SAI value."},
#else
{2, 2, 0x0000000000000000, "RW", "IMR6_WRITE_POL_2", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{1, 1, 0x0000000000000000, "RW", "IMR6_WRITE_POL_1", "Bunit IMR6 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR6 region based on the agents 6bit encoded SAI value."},
#else
{1, 1, 0x0000000000000000, "RW", "IMR6_WRITE_POL_1", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 0, 0x0000000000000000, "RW", "IMR6_WRITE_POL_0", "Bunit IMR6 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR6 region based on the agents 6bit encoded SAI value."},
#else
{0, 0, 0x0000000000000000, "RW", "IMR6_WRITE_POL_0", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo911[] = {{"B_CR_BIMR6WAC_0_0_0_MCHBAR", "", 0x00006948, 64, 0xFFFFFFFFFFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields912[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{31, 31, 0x0000000000000000, "RW", "IMR_EN", "IMR Enable: Enables access checking for the IMR region."},
#else
{31, 31, 0x0000000000000000, "RW", "IMR_EN", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{30, 30, 0x0000000000000000, "RW", "TR_EN", "Asset Classification AC[0]: Trace Enable: Enables snooping of transactions to the IMR region by tracing agents."},
#else
{30, 30, 0x0000000000000000, "RW", "TR_EN", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{29, 29, 0x0000000000000000, "RO", "RESERVED_1", "Reserved"},
#else
{29, 29, 0x0000000000000000, "RO", "RESERVED_1", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 28, 0x0000000000000000, "RW", "IMR7_BASE", "Base 0 IMR7BASE:  Specifies bits 38:10 of the start address of IMR7 region.  IMR region size must be a strict poweroftwo at least 1KB and naturally aligned to the size.  These bits are compared with the result of the IMR7MASK[28:0] applied to bits 38:10 of the incoming address to determine if an access falls within the IMR7 defined region."},
#else
{0, 28, 0x0000000000000000, "RW", "IMR7_BASE", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo912[] = {{"B_CR_BIMR7BASE_0_0_0_MCHBAR", "", 0x00006950, 4, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields913[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{31, 31, 0x0000000000000000, "RW", "GT_IWB_EN", "Asset Classification AC[2]: GT Implicit WB Enable: Enables implicit writebacks to protected region from GT caching agent. When set to 1 enables implicit writeback data HITM data from GT to be returned to the requester.  When set to 0 inhibits HITM data from GT from being returned to the requester.  HITM data from IA cores may be returned to the requester depending on the setting of the IA_IWB_EN bit."},
#else
{31, 31, 0x0000000000000000, "RW", "GT_IWB_EN", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{30, 30, 0x0000000000000000, "RW", "IA_IWB_EN", "Asset Classification AC[1]: IA Implicit WB Enable: Enables implicit writebacks to protected region from IA caching agent.  When set to 1 enables implicit writeback data HITM data from IA cores to be returned to the requester.  When set to 0 inhibits HITM data from IA cores from being returned to the requester.  HITM data from GT may be returned to the requester depending on the setting of the GT_IWB_EN bit."},
#else
{30, 30, 0x0000000000000000, "RW", "IA_IWB_EN", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{29, 29, 0x0000000000000000, "RO", "RESERVED_0", "Reserved"},
#else
{29, 29, 0x0000000000000000, "RO", "RESERVED_0", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 28, 0x0000000000000000, "RW", "IMR7_MASK", "Mask 0 IMR7MASK:  These bits are ANDed with bits 38:10 of the incoming address to determine if the combined result matches the IMR7BASE[28:0] value.  A match indicates the the incoming address falls within the IMR7 region."},
#else
{0, 28, 0x0000000000000000, "RW", "IMR7_MASK", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo913[] = {{"B_CR_BIMR7MASK_0_0_0_MCHBAR", "", 0x00006954, 4, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields914[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{0, 63, 0x00000C0061010202, "RW", "IMR7_CTRL_POL", "Bunit IMR7 Control Policy: Bit vector used to determine which agents are allowed access to the BIMR7RAC, BIMR7WAC, BIMR7CP registers based on the value from the agents 6bit SAI field."},
#else
{0, 63, 0x00000C0061010202, "RW", "IMR7_CTRL_POL", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo914[] = {{"B_CR_BIMR7CP_0_0_0_MCHBAR", "", 0x00006958, 1, 0xFFFFFFFFFFFFFFFF, 0x00000C0061010202}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields915[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{63, 63, 0x0000000000000000, "RW", "IMR7_READ_POL_63", "Bunit IMR7 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR7 region based on the agents 6bit encoded SAI value."},
#else
{63, 63, 0x0000000000000000, "RW", "IMR7_READ_POL_63", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{62, 62, 0x0000000000000000, "RO", "IMR7_READ_POL_62", "Bunit IMR7 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR7 region based on the agents 6bit encoded SAI value."},
#else
{62, 62, 0x0000000000000000, "RO", "IMR7_READ_POL_62", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{61, 61, 0x0000000000000000, "RO", "IMR7_READ_POL_61", "Bunit IMR7 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR7 region based on the agents 6bit encoded SAI value."},
#else
{61, 61, 0x0000000000000000, "RO", "IMR7_READ_POL_61", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{60, 60, 0x0000000000000000, "RO", "IMR7_READ_POL_60", "Bunit IMR7 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR7 region based on the agents 6bit encoded SAI value."},
#else
{60, 60, 0x0000000000000000, "RO", "IMR7_READ_POL_60", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{59, 59, 0x0000000000000000, "RO", "IMR7_READ_POL_59", "Bunit IMR7 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR7 region based on the agents 6bit encoded SAI value."},
#else
{59, 59, 0x0000000000000000, "RO", "IMR7_READ_POL_59", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{58, 58, 0x0000000000000000, "RO", "IMR7_READ_POL_58", "Bunit IMR7 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR7 region based on the agents 6bit encoded SAI value."},
#else
{58, 58, 0x0000000000000000, "RO", "IMR7_READ_POL_58", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{57, 57, 0x0000000000000000, "RO", "IMR7_READ_POL_57", "Bunit IMR7 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR7 region based on the agents 6bit encoded SAI value."},
#else
{57, 57, 0x0000000000000000, "RO", "IMR7_READ_POL_57", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{56, 56, 0x0000000000000000, "RW", "IMR7_READ_POL_56", "Bunit IMR7 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR7 region based on the agents 6bit encoded SAI value."},
#else
{56, 56, 0x0000000000000000, "RW", "IMR7_READ_POL_56", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{55, 55, 0x0000000000000000, "RW", "IMR7_READ_POL_55", "Bunit IMR7 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR7 region based on the agents 6bit encoded SAI value."},
#else
{55, 55, 0x0000000000000000, "RW", "IMR7_READ_POL_55", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{54, 54, 0x0000000000000000, "RW", "IMR7_READ_POL_54", "Bunit IMR7 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR7 region based on the agents 6bit encoded SAI value."},
#else
{54, 54, 0x0000000000000000, "RW", "IMR7_READ_POL_54", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{53, 53, 0x0000000000000000, "RO", "IMR7_READ_POL_53", "Bunit IMR7 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR7 region based on the agents 6bit encoded SAI value."},
#else
{53, 53, 0x0000000000000000, "RO", "IMR7_READ_POL_53", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{52, 52, 0x0000000000000000, "RO", "IMR7_READ_POL_52", "Bunit IMR7 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR7 region based on the agents 6bit encoded SAI value."},
#else
{52, 52, 0x0000000000000000, "RO", "IMR7_READ_POL_52", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{51, 51, 0x0000000000000000, "RO", "IMR7_READ_POL_51", "Bunit IMR7 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR7 region based on the agents 6bit encoded SAI value."},
#else
{51, 51, 0x0000000000000000, "RO", "IMR7_READ_POL_51", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{50, 50, 0x0000000000000000, "RW", "IMR7_READ_POL_50", "Bunit IMR7 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR7 region based on the agents 6bit encoded SAI value."},
#else
{50, 50, 0x0000000000000000, "RW", "IMR7_READ_POL_50", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{49, 49, 0x0000000000000000, "RW", "IMR7_READ_POL_49", "Bunit IMR7 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR7 region based on the agents 6bit encoded SAI value."},
#else
{49, 49, 0x0000000000000000, "RW", "IMR7_READ_POL_49", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{48, 48, 0x0000000000000000, "RW", "IMR7_READ_POL_48", "Bunit IMR7 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR7 region based on the agents 6bit encoded SAI value."},
#else
{48, 48, 0x0000000000000000, "RW", "IMR7_READ_POL_48", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{47, 47, 0x0000000000000000, "RO", "IMR7_READ_POL_47", "Bunit IMR7 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR7 region based on the agents 6bit encoded SAI value."},
#else
{47, 47, 0x0000000000000000, "RO", "IMR7_READ_POL_47", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{46, 46, 0x0000000000000000, "RO", "IMR7_READ_POL_46", "Bunit IMR7 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR7 region based on the agents 6bit encoded SAI value."},
#else
{46, 46, 0x0000000000000000, "RO", "IMR7_READ_POL_46", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{45, 45, 0x0000000000000000, "RO", "IMR7_READ_POL_45", "Bunit IMR7 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR7 region based on the agents 6bit encoded SAI value."},
#else
{45, 45, 0x0000000000000000, "RO", "IMR7_READ_POL_45", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{44, 44, 0x0000000000000000, "RW", "IMR7_READ_POL_44", "Bunit IMR7 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR7 region based on the agents 6bit encoded SAI value."},
#else
{44, 44, 0x0000000000000000, "RW", "IMR7_READ_POL_44", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{43, 43, 0x0000000000000000, "RW", "IMR7_READ_POL_43", "Bunit IMR7 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR7 region based on the agents 6bit encoded SAI value."},
#else
{43, 43, 0x0000000000000000, "RW", "IMR7_READ_POL_43", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{42, 42, 0x0000000000000000, "RW", "IMR7_READ_POL_42", "Bunit IMR7 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR7 region based on the agents 6bit encoded SAI value."},
#else
{42, 42, 0x0000000000000000, "RW", "IMR7_READ_POL_42", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{41, 41, 0x0000000000000000, "RW", "IMR7_READ_POL_41", "Bunit IMR7 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR7 region based on the agents 6bit encoded SAI value."},
#else
{41, 41, 0x0000000000000000, "RW", "IMR7_READ_POL_41", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{40, 40, 0x0000000000000000, "RW", "IMR7_READ_POL_40", "Bunit IMR7 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR7 region based on the agents 6bit encoded SAI value."},
#else
{40, 40, 0x0000000000000000, "RW", "IMR7_READ_POL_40", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{39, 39, 0x0000000000000000, "RO", "IMR7_READ_POL_39", "Bunit IMR7 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR7 region based on the agents 6bit encoded SAI value."},
#else
{39, 39, 0x0000000000000000, "RO", "IMR7_READ_POL_39", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{38, 38, 0x0000000000000000, "RW", "IMR7_READ_POL_38", "Bunit IMR7 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR7 region based on the agents 6bit encoded SAI value."},
#else
{38, 38, 0x0000000000000000, "RW", "IMR7_READ_POL_38", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{37, 37, 0x0000000000000000, "RO", "IMR7_READ_POL_37", "Bunit IMR7 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR7 region based on the agents 6bit encoded SAI value."},
#else
{37, 37, 0x0000000000000000, "RO", "IMR7_READ_POL_37", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{36, 36, 0x0000000000000000, "RW", "IMR7_READ_POL_36", "Bunit IMR7 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR7 region based on the agents 6bit encoded SAI value."},
#else
{36, 36, 0x0000000000000000, "RW", "IMR7_READ_POL_36", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{35, 35, 0x0000000000000000, "RO", "IMR7_READ_POL_35", "Bunit IMR7 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR7 region based on the agents 6bit encoded SAI value."},
#else
{35, 35, 0x0000000000000000, "RO", "IMR7_READ_POL_35", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{34, 34, 0x0000000000000000, "RW", "IMR7_READ_POL_34", "Bunit IMR7 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR7 region based on the agents 6bit encoded SAI value."},
#else
{34, 34, 0x0000000000000000, "RW", "IMR7_READ_POL_34", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{33, 33, 0x0000000000000000, "RW", "IMR7_READ_POL_33", "Bunit IMR7 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR7 region based on the agents 6bit encoded SAI value."},
#else
{33, 33, 0x0000000000000000, "RW", "IMR7_READ_POL_33", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{32, 32, 0x0000000000000000, "RW", "IMR7_READ_POL_32", "Bunit IMR7 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR7 region based on the agents 6bit encoded SAI value."},
#else
{32, 32, 0x0000000000000000, "RW", "IMR7_READ_POL_32", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{31, 31, 0x0000000000000000, "RO", "IMR7_READ_POL_31", "Bunit IMR7 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR7 region based on the agents 6bit encoded SAI value."},
#else
{31, 31, 0x0000000000000000, "RO", "IMR7_READ_POL_31", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{30, 30, 0x0000000000000000, "RW", "IMR7_READ_POL_30", "Bunit IMR7 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR7 region based on the agents 6bit encoded SAI value."},
#else
{30, 30, 0x0000000000000000, "RW", "IMR7_READ_POL_30", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{29, 29, 0x0000000000000000, "RW", "IMR7_READ_POL_29", "Bunit IMR7 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR7 region based on the agents 6bit encoded SAI value."},
#else
{29, 29, 0x0000000000000000, "RW", "IMR7_READ_POL_29", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{28, 28, 0x0000000000000000, "RW", "IMR7_READ_POL_28", "Bunit IMR7 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR7 region based on the agents 6bit encoded SAI value."},
#else
{28, 28, 0x0000000000000000, "RW", "IMR7_READ_POL_28", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{27, 27, 0x0000000000000000, "RW", "IMR7_READ_POL_27", "Bunit IMR7 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR7 region based on the agents 6bit encoded SAI value."},
#else
{27, 27, 0x0000000000000000, "RW", "IMR7_READ_POL_27", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{26, 26, 0x0000000000000000, "RW", "IMR7_READ_POL_26", "Bunit IMR7 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR7 region based on the agents 6bit encoded SAI value."},
#else
{26, 26, 0x0000000000000000, "RW", "IMR7_READ_POL_26", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{25, 25, 0x0000000000000000, "RW", "IMR7_READ_POL_25", "Bunit IMR7 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR7 region based on the agents 6bit encoded SAI value."},
#else
{25, 25, 0x0000000000000000, "RW", "IMR7_READ_POL_25", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{24, 24, 0x0000000000000000, "RW", "IMR7_READ_POL_24", "Bunit IMR7 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR7 region based on the agents 6bit encoded SAI value."},
#else
{24, 24, 0x0000000000000000, "RW", "IMR7_READ_POL_24", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{23, 23, 0x0000000000000000, "RO", "IMR7_READ_POL_23", "Bunit IMR7 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR7 region based on the agents 6bit encoded SAI value."},
#else
{23, 23, 0x0000000000000000, "RO", "IMR7_READ_POL_23", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{22, 22, 0x0000000000000000, "RO", "IMR7_READ_POL_22", "Bunit IMR7 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR7 region based on the agents 6bit encoded SAI value."},
#else
{22, 22, 0x0000000000000000, "RO", "IMR7_READ_POL_22", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{21, 21, 0x0000000000000000, "RW", "IMR7_READ_POL_21", "Bunit IMR7 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR7 region based on the agents 6bit encoded SAI value."},
#else
{21, 21, 0x0000000000000000, "RW", "IMR7_READ_POL_21", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{20, 20, 0x0000000000000000, "RO", "IMR7_READ_POL_20", "Bunit IMR7 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR7 region based on the agents 6bit encoded SAI value."},
#else
{20, 20, 0x0000000000000000, "RO", "IMR7_READ_POL_20", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{19, 19, 0x0000000000000000, "RO", "IMR7_READ_POL_19", "Bunit IMR7 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR7 region based on the agents 6bit encoded SAI value."},
#else
{19, 19, 0x0000000000000000, "RO", "IMR7_READ_POL_19", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{18, 18, 0x0000000000000000, "RO", "IMR7_READ_POL_18", "Bunit IMR7 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR7 region based on the agents 6bit encoded SAI value."},
#else
{18, 18, 0x0000000000000000, "RO", "IMR7_READ_POL_18", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{17, 17, 0x0000000000000000, "RW", "IMR7_READ_POL_17", "Bunit IMR7 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR7 region based on the agents 6bit encoded SAI value."},
#else
{17, 17, 0x0000000000000000, "RW", "IMR7_READ_POL_17", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{16, 16, 0x0000000000000000, "RW", "IMR7_READ_POL_16", "Bunit IMR7 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR7 region based on the agents 6bit encoded SAI value."},
#else
{16, 16, 0x0000000000000000, "RW", "IMR7_READ_POL_16", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{15, 15, 0x0000000000000000, "RO", "IMR7_READ_POL_15", "Bunit IMR7 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR7 region based on the agents 6bit encoded SAI value."},
#else
{15, 15, 0x0000000000000000, "RO", "IMR7_READ_POL_15", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{14, 14, 0x0000000000000000, "RO", "IMR7_READ_POL_14", "Bunit IMR7 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR7 region based on the agents 6bit encoded SAI value."},
#else
{14, 14, 0x0000000000000000, "RO", "IMR7_READ_POL_14", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{13, 13, 0x0000000000000000, "RW", "IMR7_READ_POL_13", "Bunit IMR7 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR7 region based on the agents 6bit encoded SAI value."},
#else
{13, 13, 0x0000000000000000, "RW", "IMR7_READ_POL_13", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{12, 12, 0x0000000000000000, "RW", "IMR7_READ_POL_12", "Bunit IMR7 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR7 region based on the agents 6bit encoded SAI value."},
#else
{12, 12, 0x0000000000000000, "RW", "IMR7_READ_POL_12", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{11, 11, 0x0000000000000000, "RO", "IMR7_READ_POL_11", "Bunit IMR7 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR7 region based on the agents 6bit encoded SAI value."},
#else
{11, 11, 0x0000000000000000, "RO", "IMR7_READ_POL_11", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{10, 10, 0x0000000000000000, "RO", "IMR7_READ_POL_10", "Bunit IMR7 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR7 region based on the agents 6bit encoded SAI value."},
#else
{10, 10, 0x0000000000000000, "RO", "IMR7_READ_POL_10", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{9, 9, 0x0000000000000000, "RO", "IMR7_READ_POL_9", "Bunit IMR7 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR7 region based on the agents 6bit encoded SAI value."},
#else
{9, 9, 0x0000000000000000, "RO", "IMR7_READ_POL_9", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{8, 8, 0x0000000000000000, "RW", "IMR7_READ_POL_8", "Bunit IMR7 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR7 region based on the agents 6bit encoded SAI value."},
#else
{8, 8, 0x0000000000000000, "RW", "IMR7_READ_POL_8", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{7, 7, 0x0000000000000000, "RO", "IMR7_READ_POL_7", "Bunit IMR7 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR7 region based on the agents 6bit encoded SAI value."},
#else
{7, 7, 0x0000000000000000, "RO", "IMR7_READ_POL_7", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{6, 6, 0x0000000000000000, "RO", "IMR7_READ_POL_6", "Bunit IMR7 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR7 region based on the agents 6bit encoded SAI value."},
#else
{6, 6, 0x0000000000000000, "RO", "IMR7_READ_POL_6", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{5, 5, 0x0000000000000000, "RW", "IMR7_READ_POL_5", "Bunit IMR7 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR7 region based on the agents 6bit encoded SAI value."},
#else
{5, 5, 0x0000000000000000, "RW", "IMR7_READ_POL_5", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{4, 4, 0x0000000000000000, "RW", "IMR7_READ_POL_4", "Bunit IMR7 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR7 region based on the agents 6bit encoded SAI value."},
#else
{4, 4, 0x0000000000000000, "RW", "IMR7_READ_POL_4", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{3, 3, 0x0000000000000000, "RW", "IMR7_READ_POL_3", "Bunit IMR7 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR7 region based on the agents 6bit encoded SAI value."},
#else
{3, 3, 0x0000000000000000, "RW", "IMR7_READ_POL_3", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{2, 2, 0x0000000000000000, "RW", "IMR7_READ_POL_2", "Bunit IMR7 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR7 region based on the agents 6bit encoded SAI value."},
#else
{2, 2, 0x0000000000000000, "RW", "IMR7_READ_POL_2", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{1, 1, 0x0000000000000000, "RW", "IMR7_READ_POL_1", "Bunit IMR7 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR7 region based on the agents 6bit encoded SAI value."},
#else
{1, 1, 0x0000000000000000, "RW", "IMR7_READ_POL_1", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 0, 0x0000000000000000, "RW", "IMR7_READ_POL_0", "Bunit IMR7 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR7 region based on the agents 6bit encoded SAI value."},
#else
{0, 0, 0x0000000000000000, "RW", "IMR7_READ_POL_0", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo915[] = {{"B_CR_BIMR7RAC_0_0_0_MCHBAR", "", 0x00006960, 64, 0xFFFFFFFFFFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields916[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{63, 63, 0x0000000000000000, "RW", "IMR7_WRITE_POL_63", "Bunit IMR7 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR7 region based on the agents 6bit encoded SAI value."},
#else
{63, 63, 0x0000000000000000, "RW", "IMR7_WRITE_POL_63", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{62, 62, 0x0000000000000000, "RO", "IMR7_WRITE_POL_62", "Bunit IMR7 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR7 region based on the agents 6bit encoded SAI value."},
#else
{62, 62, 0x0000000000000000, "RO", "IMR7_WRITE_POL_62", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{61, 61, 0x0000000000000000, "RO", "IMR7_WRITE_POL_61", "Bunit IMR7 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR7 region based on the agents 6bit encoded SAI value."},
#else
{61, 61, 0x0000000000000000, "RO", "IMR7_WRITE_POL_61", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{60, 60, 0x0000000000000000, "RO", "IMR7_WRITE_POL_60", "Bunit IMR7 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR7 region based on the agents 6bit encoded SAI value."},
#else
{60, 60, 0x0000000000000000, "RO", "IMR7_WRITE_POL_60", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{59, 59, 0x0000000000000000, "RO", "IMR7_WRITE_POL_59", "Bunit IMR7 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR7 region based on the agents 6bit encoded SAI value."},
#else
{59, 59, 0x0000000000000000, "RO", "IMR7_WRITE_POL_59", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{58, 58, 0x0000000000000000, "RO", "IMR7_WRITE_POL_58", "Bunit IMR7 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR7 region based on the agents 6bit encoded SAI value."},
#else
{58, 58, 0x0000000000000000, "RO", "IMR7_WRITE_POL_58", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{57, 57, 0x0000000000000000, "RO", "IMR7_WRITE_POL_57", "Bunit IMR7 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR7 region based on the agents 6bit encoded SAI value."},
#else
{57, 57, 0x0000000000000000, "RO", "IMR7_WRITE_POL_57", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{56, 56, 0x0000000000000000, "RW", "IMR7_WRITE_POL_56", "Bunit IMR7 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR7 region based on the agents 6bit encoded SAI value."},
#else
{56, 56, 0x0000000000000000, "RW", "IMR7_WRITE_POL_56", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{55, 55, 0x0000000000000000, "RW", "IMR7_WRITE_POL_55", "Bunit IMR7 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR7 region based on the agents 6bit encoded SAI value."},
#else
{55, 55, 0x0000000000000000, "RW", "IMR7_WRITE_POL_55", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{54, 54, 0x0000000000000000, "RW", "IMR7_WRITE_POL_54", "Bunit IMR7 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR7 region based on the agents 6bit encoded SAI value."},
#else
{54, 54, 0x0000000000000000, "RW", "IMR7_WRITE_POL_54", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{53, 53, 0x0000000000000000, "RO", "IMR7_WRITE_POL_53", "Bunit IMR7 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR7 region based on the agents 6bit encoded SAI value."},
#else
{53, 53, 0x0000000000000000, "RO", "IMR7_WRITE_POL_53", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{52, 52, 0x0000000000000000, "RO", "IMR7_WRITE_POL_52", "Bunit IMR7 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR7 region based on the agents 6bit encoded SAI value."},
#else
{52, 52, 0x0000000000000000, "RO", "IMR7_WRITE_POL_52", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{51, 51, 0x0000000000000000, "RO", "IMR7_WRITE_POL_51", "Bunit IMR7 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR7 region based on the agents 6bit encoded SAI value."},
#else
{51, 51, 0x0000000000000000, "RO", "IMR7_WRITE_POL_51", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{50, 50, 0x0000000000000000, "RW", "IMR7_WRITE_POL_50", "Bunit IMR7 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR7 region based on the agents 6bit encoded SAI value."},
#else
{50, 50, 0x0000000000000000, "RW", "IMR7_WRITE_POL_50", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{49, 49, 0x0000000000000000, "RW", "IMR7_WRITE_POL_49", "Bunit IMR7 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR7 region based on the agents 6bit encoded SAI value."},
#else
{49, 49, 0x0000000000000000, "RW", "IMR7_WRITE_POL_49", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{48, 48, 0x0000000000000000, "RW", "IMR7_WRITE_POL_48", "Bunit IMR7 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR7 region based on the agents 6bit encoded SAI value."},
#else
{48, 48, 0x0000000000000000, "RW", "IMR7_WRITE_POL_48", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{47, 47, 0x0000000000000000, "RO", "IMR7_WRITE_POL_47", "Bunit IMR7 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR7 region based on the agents 6bit encoded SAI value."},
#else
{47, 47, 0x0000000000000000, "RO", "IMR7_WRITE_POL_47", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{46, 46, 0x0000000000000000, "RO", "IMR7_WRITE_POL_46", "Bunit IMR7 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR7 region based on the agents 6bit encoded SAI value."},
#else
{46, 46, 0x0000000000000000, "RO", "IMR7_WRITE_POL_46", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{45, 45, 0x0000000000000000, "RO", "IMR7_WRITE_POL_45", "Bunit IMR7 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR7 region based on the agents 6bit encoded SAI value."},
#else
{45, 45, 0x0000000000000000, "RO", "IMR7_WRITE_POL_45", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{44, 44, 0x0000000000000000, "RW", "IMR7_WRITE_POL_44", "Bunit IMR7 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR7 region based on the agents 6bit encoded SAI value."},
#else
{44, 44, 0x0000000000000000, "RW", "IMR7_WRITE_POL_44", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{43, 43, 0x0000000000000000, "RW", "IMR7_WRITE_POL_43", "Bunit IMR7 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR7 region based on the agents 6bit encoded SAI value."},
#else
{43, 43, 0x0000000000000000, "RW", "IMR7_WRITE_POL_43", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{42, 42, 0x0000000000000000, "RW", "IMR7_WRITE_POL_42", "Bunit IMR7 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR7 region based on the agents 6bit encoded SAI value."},
#else
{42, 42, 0x0000000000000000, "RW", "IMR7_WRITE_POL_42", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{41, 41, 0x0000000000000000, "RW", "IMR7_WRITE_POL_41", "Bunit IMR7 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR7 region based on the agents 6bit encoded SAI value."},
#else
{41, 41, 0x0000000000000000, "RW", "IMR7_WRITE_POL_41", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{40, 40, 0x0000000000000000, "RW", "IMR7_WRITE_POL_40", "Bunit IMR7 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR7 region based on the agents 6bit encoded SAI value."},
#else
{40, 40, 0x0000000000000000, "RW", "IMR7_WRITE_POL_40", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{39, 39, 0x0000000000000000, "RO", "IMR7_WRITE_POL_39", "Bunit IMR7 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR7 region based on the agents 6bit encoded SAI value."},
#else
{39, 39, 0x0000000000000000, "RO", "IMR7_WRITE_POL_39", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{38, 38, 0x0000000000000000, "RW", "IMR7_WRITE_POL_38", "Bunit IMR7 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR7 region based on the agents 6bit encoded SAI value."},
#else
{38, 38, 0x0000000000000000, "RW", "IMR7_WRITE_POL_38", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{37, 37, 0x0000000000000000, "RO", "IMR7_WRITE_POL_37", "Bunit IMR7 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR7 region based on the agents 6bit encoded SAI value."},
#else
{37, 37, 0x0000000000000000, "RO", "IMR7_WRITE_POL_37", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{36, 36, 0x0000000000000000, "RW", "IMR7_WRITE_POL_36", "Bunit IMR7 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR7 region based on the agents 6bit encoded SAI value."},
#else
{36, 36, 0x0000000000000000, "RW", "IMR7_WRITE_POL_36", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{35, 35, 0x0000000000000000, "RO", "IMR7_WRITE_POL_35", "Bunit IMR7 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR7 region based on the agents 6bit encoded SAI value."},
#else
{35, 35, 0x0000000000000000, "RO", "IMR7_WRITE_POL_35", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{34, 34, 0x0000000000000000, "RW", "IMR7_WRITE_POL_34", "Bunit IMR7 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR7 region based on the agents 6bit encoded SAI value."},
#else
{34, 34, 0x0000000000000000, "RW", "IMR7_WRITE_POL_34", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{33, 33, 0x0000000000000000, "RW", "IMR7_WRITE_POL_33", "Bunit IMR7 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR7 region based on the agents 6bit encoded SAI value."},
#else
{33, 33, 0x0000000000000000, "RW", "IMR7_WRITE_POL_33", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{32, 32, 0x0000000000000000, "RW", "IMR7_WRITE_POL_32", "Bunit IMR7 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR7 region based on the agents 6bit encoded SAI value."},
#else
{32, 32, 0x0000000000000000, "RW", "IMR7_WRITE_POL_32", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{31, 31, 0x0000000000000000, "RO", "IMR7_WRITE_POL_31", "Bunit IMR7 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR7 region based on the agents 6bit encoded SAI value."},
#else
{31, 31, 0x0000000000000000, "RO", "IMR7_WRITE_POL_31", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{30, 30, 0x0000000000000000, "RW", "IMR7_WRITE_POL_30", "Bunit IMR7 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR7 region based on the agents 6bit encoded SAI value."},
#else
{30, 30, 0x0000000000000000, "RW", "IMR7_WRITE_POL_30", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{29, 29, 0x0000000000000000, "RW", "IMR7_WRITE_POL_29", "Bunit IMR7 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR7 region based on the agents 6bit encoded SAI value."},
#else
{29, 29, 0x0000000000000000, "RW", "IMR7_WRITE_POL_29", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{28, 28, 0x0000000000000000, "RW", "IMR7_WRITE_POL_28", "Bunit IMR7 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR7 region based on the agents 6bit encoded SAI value."},
#else
{28, 28, 0x0000000000000000, "RW", "IMR7_WRITE_POL_28", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{27, 27, 0x0000000000000000, "RW", "IMR7_WRITE_POL_27", "Bunit IMR7 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR7 region based on the agents 6bit encoded SAI value."},
#else
{27, 27, 0x0000000000000000, "RW", "IMR7_WRITE_POL_27", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{26, 26, 0x0000000000000000, "RW", "IMR7_WRITE_POL_26", "Bunit IMR7 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR7 region based on the agents 6bit encoded SAI value."},
#else
{26, 26, 0x0000000000000000, "RW", "IMR7_WRITE_POL_26", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{25, 25, 0x0000000000000000, "RW", "IMR7_WRITE_POL_25", "Bunit IMR7 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR7 region based on the agents 6bit encoded SAI value."},
#else
{25, 25, 0x0000000000000000, "RW", "IMR7_WRITE_POL_25", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{24, 24, 0x0000000000000000, "RW", "IMR7_WRITE_POL_24", "Bunit IMR7 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR7 region based on the agents 6bit encoded SAI value."},
#else
{24, 24, 0x0000000000000000, "RW", "IMR7_WRITE_POL_24", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{23, 23, 0x0000000000000000, "RO", "IMR7_WRITE_POL_23", "Bunit IMR7 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR7 region based on the agents 6bit encoded SAI value."},
#else
{23, 23, 0x0000000000000000, "RO", "IMR7_WRITE_POL_23", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{22, 22, 0x0000000000000000, "RO", "IMR7_WRITE_POL_22", "Bunit IMR7 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR7 region based on the agents 6bit encoded SAI value."},
#else
{22, 22, 0x0000000000000000, "RO", "IMR7_WRITE_POL_22", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{21, 21, 0x0000000000000000, "RW", "IMR7_WRITE_POL_21", "Bunit IMR7 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR7 region based on the agents 6bit encoded SAI value."},
#else
{21, 21, 0x0000000000000000, "RW", "IMR7_WRITE_POL_21", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{20, 20, 0x0000000000000000, "RO", "IMR7_WRITE_POL_20", "Bunit IMR7 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR7 region based on the agents 6bit encoded SAI value."},
#else
{20, 20, 0x0000000000000000, "RO", "IMR7_WRITE_POL_20", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{19, 19, 0x0000000000000000, "RO", "IMR7_WRITE_POL_19", "Bunit IMR7 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR7 region based on the agents 6bit encoded SAI value."},
#else
{19, 19, 0x0000000000000000, "RO", "IMR7_WRITE_POL_19", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{18, 18, 0x0000000000000000, "RO", "IMR7_WRITE_POL_18", "Bunit IMR7 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR7 region based on the agents 6bit encoded SAI value."},
#else
{18, 18, 0x0000000000000000, "RO", "IMR7_WRITE_POL_18", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{17, 17, 0x0000000000000000, "RW", "IMR7_WRITE_POL_17", "Bunit IMR7 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR7 region based on the agents 6bit encoded SAI value."},
#else
{17, 17, 0x0000000000000000, "RW", "IMR7_WRITE_POL_17", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{16, 16, 0x0000000000000000, "RW", "IMR7_WRITE_POL_16", "Bunit IMR7 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR7 region based on the agents 6bit encoded SAI value."},
#else
{16, 16, 0x0000000000000000, "RW", "IMR7_WRITE_POL_16", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{15, 15, 0x0000000000000000, "RO", "IMR7_WRITE_POL_15", "Bunit IMR7 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR7 region based on the agents 6bit encoded SAI value."},
#else
{15, 15, 0x0000000000000000, "RO", "IMR7_WRITE_POL_15", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{14, 14, 0x0000000000000000, "RO", "IMR7_WRITE_POL_14", "Bunit IMR7 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR7 region based on the agents 6bit encoded SAI value."},
#else
{14, 14, 0x0000000000000000, "RO", "IMR7_WRITE_POL_14", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{13, 13, 0x0000000000000000, "RW", "IMR7_WRITE_POL_13", "Bunit IMR7 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR7 region based on the agents 6bit encoded SAI value."},
#else
{13, 13, 0x0000000000000000, "RW", "IMR7_WRITE_POL_13", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{12, 12, 0x0000000000000000, "RW", "IMR7_WRITE_POL_12", "Bunit IMR7 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR7 region based on the agents 6bit encoded SAI value."},
#else
{12, 12, 0x0000000000000000, "RW", "IMR7_WRITE_POL_12", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{11, 11, 0x0000000000000000, "RO", "IMR7_WRITE_POL_11", "Bunit IMR7 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR7 region based on the agents 6bit encoded SAI value."},
#else
{11, 11, 0x0000000000000000, "RO", "IMR7_WRITE_POL_11", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{10, 10, 0x0000000000000000, "RO", "IMR7_WRITE_POL_10", "Bunit IMR7 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR7 region based on the agents 6bit encoded SAI value."},
#else
{10, 10, 0x0000000000000000, "RO", "IMR7_WRITE_POL_10", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{9, 9, 0x0000000000000000, "RO", "IMR7_WRITE_POL_9", "Bunit IMR7 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR7 region based on the agents 6bit encoded SAI value."},
#else
{9, 9, 0x0000000000000000, "RO", "IMR7_WRITE_POL_9", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{8, 8, 0x0000000000000000, "RW", "IMR7_WRITE_POL_8", "Bunit IMR7 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR7 region based on the agents 6bit encoded SAI value."},
#else
{8, 8, 0x0000000000000000, "RW", "IMR7_WRITE_POL_8", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{7, 7, 0x0000000000000000, "RO", "IMR7_WRITE_POL_7", "Bunit IMR7 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR7 region based on the agents 6bit encoded SAI value."},
#else
{7, 7, 0x0000000000000000, "RO", "IMR7_WRITE_POL_7", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{6, 6, 0x0000000000000000, "RO", "IMR7_WRITE_POL_6", "Bunit IMR7 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR7 region based on the agents 6bit encoded SAI value."},
#else
{6, 6, 0x0000000000000000, "RO", "IMR7_WRITE_POL_6", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{5, 5, 0x0000000000000000, "RW", "IMR7_WRITE_POL_5", "Bunit IMR7 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR7 region based on the agents 6bit encoded SAI value."},
#else
{5, 5, 0x0000000000000000, "RW", "IMR7_WRITE_POL_5", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{4, 4, 0x0000000000000000, "RW", "IMR7_WRITE_POL_4", "Bunit IMR7 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR7 region based on the agents 6bit encoded SAI value."},
#else
{4, 4, 0x0000000000000000, "RW", "IMR7_WRITE_POL_4", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{3, 3, 0x0000000000000000, "RW", "IMR7_WRITE_POL_3", "Bunit IMR7 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR7 region based on the agents 6bit encoded SAI value."},
#else
{3, 3, 0x0000000000000000, "RW", "IMR7_WRITE_POL_3", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{2, 2, 0x0000000000000000, "RW", "IMR7_WRITE_POL_2", "Bunit IMR7 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR7 region based on the agents 6bit encoded SAI value."},
#else
{2, 2, 0x0000000000000000, "RW", "IMR7_WRITE_POL_2", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{1, 1, 0x0000000000000000, "RW", "IMR7_WRITE_POL_1", "Bunit IMR7 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR7 region based on the agents 6bit encoded SAI value."},
#else
{1, 1, 0x0000000000000000, "RW", "IMR7_WRITE_POL_1", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 0, 0x0000000000000000, "RW", "IMR7_WRITE_POL_0", "Bunit IMR7 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR7 region based on the agents 6bit encoded SAI value."},
#else
{0, 0, 0x0000000000000000, "RW", "IMR7_WRITE_POL_0", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo916[] = {{"B_CR_BIMR7WAC_0_0_0_MCHBAR", "", 0x00006968, 64, 0xFFFFFFFFFFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields917[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{31, 31, 0x0000000000000000, "RW", "IMR_EN", "IMR Enable: Enables access checking for the IMR region."},
#else
{31, 31, 0x0000000000000000, "RW", "IMR_EN", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{30, 30, 0x0000000000000000, "RW", "TR_EN", "Asset Classification AC[0]: Trace Enable: Enables snooping of transactions to the IMR region by tracing agents."},
#else
{30, 30, 0x0000000000000000, "RW", "TR_EN", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{29, 29, 0x0000000000000000, "RO", "RESERVED_1", "Reserved"},
#else
{29, 29, 0x0000000000000000, "RO", "RESERVED_1", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 28, 0x0000000000000000, "RW", "IMR8_BASE", "Base 0 IMR8BASE:  Specifies bits 38:10 of the start address of IMR8 region.  IMR region size must be a strict poweroftwo at least 1KB and naturally aligned to the size.  These bits are compared with the result of the IMR8MASK[28:0] applied to bits 38:10 of the incoming address to determine if an access falls within the IMR8 defined region."},
#else
{0, 28, 0x0000000000000000, "RW", "IMR8_BASE", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo917[] = {{"B_CR_BIMR8BASE_0_0_0_MCHBAR", "", 0x00006970, 4, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields918[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{31, 31, 0x0000000000000000, "RW", "GT_IWB_EN", "Asset Classification AC[2]: GT Implicit WB Enable: Enables implicit writebacks to protected region from GT caching agent. When set to 1 enables implicit writeback data HITM data from GT to be returned to the requester.  When set to 0 inhibits HITM data from GT from being returned to the requester.  HITM data from IA cores may be returned to the requester depending on the setting of the IA_IWB_EN bit."},
#else
{31, 31, 0x0000000000000000, "RW", "GT_IWB_EN", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{30, 30, 0x0000000000000000, "RW", "IA_IWB_EN", "Asset Classification AC[1]: IA Implicit WB Enable: Enables implicit writebacks to protected region from IA caching agent.  When set to 1 enables implicit writeback data HITM data from IA cores to be returned to the requester.  When set to 0 inhibits HITM data from IA cores from being returned to the requester.  HITM data from GT may be returned to the requester depending on the setting of the GT_IWB_EN bit."},
#else
{30, 30, 0x0000000000000000, "RW", "IA_IWB_EN", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{29, 29, 0x0000000000000000, "RO", "RESERVED_0", "Reserved"},
#else
{29, 29, 0x0000000000000000, "RO", "RESERVED_0", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 28, 0x0000000000000000, "RW", "IMR8_MASK", "Mask 0 IMR8MASK:  These bits are ANDed with bits 38:10 of the incoming address to determine if the combined result matches the IMR8BASE[28:0] value.  A match indicates the the incoming address falls within the IMR8 region."},
#else
{0, 28, 0x0000000000000000, "RW", "IMR8_MASK", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo918[] = {{"B_CR_BIMR8MASK_0_0_0_MCHBAR", "", 0x00006974, 4, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields919[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{0, 63, 0x00000C0061010202, "RW", "IMR8_CTRL_POL", "Bunit IMR8 Control Policy: Bit vector used to determine which agents are allowed access to the BIMR8RAC, BIMR8WAC, BIMR8CP registers based on the value from the agents 6bit SAI field."},
#else
{0, 63, 0x00000C0061010202, "RW", "IMR8_CTRL_POL", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo919[] = {{"B_CR_BIMR8CP_0_0_0_MCHBAR", "", 0x00006978, 1, 0xFFFFFFFFFFFFFFFF, 0x00000C0061010202}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields920[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{63, 63, 0x0000000000000000, "RW", "IMR8_READ_POL_63", "Bunit IMR8 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR8 region based on the agents 6bit encoded SAI value."},
#else
{63, 63, 0x0000000000000000, "RW", "IMR8_READ_POL_63", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{62, 62, 0x0000000000000000, "RO", "IMR8_READ_POL_62", "Bunit IMR8 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR8 region based on the agents 6bit encoded SAI value."},
#else
{62, 62, 0x0000000000000000, "RO", "IMR8_READ_POL_62", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{61, 61, 0x0000000000000000, "RO", "IMR8_READ_POL_61", "Bunit IMR8 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR8 region based on the agents 6bit encoded SAI value."},
#else
{61, 61, 0x0000000000000000, "RO", "IMR8_READ_POL_61", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{60, 60, 0x0000000000000000, "RO", "IMR8_READ_POL_60", "Bunit IMR8 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR8 region based on the agents 6bit encoded SAI value."},
#else
{60, 60, 0x0000000000000000, "RO", "IMR8_READ_POL_60", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{59, 59, 0x0000000000000000, "RO", "IMR8_READ_POL_59", "Bunit IMR8 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR8 region based on the agents 6bit encoded SAI value."},
#else
{59, 59, 0x0000000000000000, "RO", "IMR8_READ_POL_59", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{58, 58, 0x0000000000000000, "RO", "IMR8_READ_POL_58", "Bunit IMR8 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR8 region based on the agents 6bit encoded SAI value."},
#else
{58, 58, 0x0000000000000000, "RO", "IMR8_READ_POL_58", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{57, 57, 0x0000000000000000, "RO", "IMR8_READ_POL_57", "Bunit IMR8 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR8 region based on the agents 6bit encoded SAI value."},
#else
{57, 57, 0x0000000000000000, "RO", "IMR8_READ_POL_57", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{56, 56, 0x0000000000000000, "RW", "IMR8_READ_POL_56", "Bunit IMR8 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR8 region based on the agents 6bit encoded SAI value."},
#else
{56, 56, 0x0000000000000000, "RW", "IMR8_READ_POL_56", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{55, 55, 0x0000000000000000, "RW", "IMR8_READ_POL_55", "Bunit IMR8 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR8 region based on the agents 6bit encoded SAI value."},
#else
{55, 55, 0x0000000000000000, "RW", "IMR8_READ_POL_55", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{54, 54, 0x0000000000000000, "RW", "IMR8_READ_POL_54", "Bunit IMR8 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR8 region based on the agents 6bit encoded SAI value."},
#else
{54, 54, 0x0000000000000000, "RW", "IMR8_READ_POL_54", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{53, 53, 0x0000000000000000, "RO", "IMR8_READ_POL_53", "Bunit IMR8 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR8 region based on the agents 6bit encoded SAI value."},
#else
{53, 53, 0x0000000000000000, "RO", "IMR8_READ_POL_53", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{52, 52, 0x0000000000000000, "RO", "IMR8_READ_POL_52", "Bunit IMR8 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR8 region based on the agents 6bit encoded SAI value."},
#else
{52, 52, 0x0000000000000000, "RO", "IMR8_READ_POL_52", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{51, 51, 0x0000000000000000, "RO", "IMR8_READ_POL_51", "Bunit IMR8 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR8 region based on the agents 6bit encoded SAI value."},
#else
{51, 51, 0x0000000000000000, "RO", "IMR8_READ_POL_51", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{50, 50, 0x0000000000000000, "RW", "IMR8_READ_POL_50", "Bunit IMR8 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR8 region based on the agents 6bit encoded SAI value."},
#else
{50, 50, 0x0000000000000000, "RW", "IMR8_READ_POL_50", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{49, 49, 0x0000000000000000, "RW", "IMR8_READ_POL_49", "Bunit IMR8 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR8 region based on the agents 6bit encoded SAI value."},
#else
{49, 49, 0x0000000000000000, "RW", "IMR8_READ_POL_49", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{48, 48, 0x0000000000000000, "RW", "IMR8_READ_POL_48", "Bunit IMR8 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR8 region based on the agents 6bit encoded SAI value."},
#else
{48, 48, 0x0000000000000000, "RW", "IMR8_READ_POL_48", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{47, 47, 0x0000000000000000, "RO", "IMR8_READ_POL_47", "Bunit IMR8 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR8 region based on the agents 6bit encoded SAI value."},
#else
{47, 47, 0x0000000000000000, "RO", "IMR8_READ_POL_47", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{46, 46, 0x0000000000000000, "RO", "IMR8_READ_POL_46", "Bunit IMR8 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR8 region based on the agents 6bit encoded SAI value."},
#else
{46, 46, 0x0000000000000000, "RO", "IMR8_READ_POL_46", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{45, 45, 0x0000000000000000, "RO", "IMR8_READ_POL_45", "Bunit IMR8 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR8 region based on the agents 6bit encoded SAI value."},
#else
{45, 45, 0x0000000000000000, "RO", "IMR8_READ_POL_45", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{44, 44, 0x0000000000000000, "RW", "IMR8_READ_POL_44", "Bunit IMR8 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR8 region based on the agents 6bit encoded SAI value."},
#else
{44, 44, 0x0000000000000000, "RW", "IMR8_READ_POL_44", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{43, 43, 0x0000000000000000, "RW", "IMR8_READ_POL_43", "Bunit IMR8 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR8 region based on the agents 6bit encoded SAI value."},
#else
{43, 43, 0x0000000000000000, "RW", "IMR8_READ_POL_43", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{42, 42, 0x0000000000000000, "RW", "IMR8_READ_POL_42", "Bunit IMR8 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR8 region based on the agents 6bit encoded SAI value."},
#else
{42, 42, 0x0000000000000000, "RW", "IMR8_READ_POL_42", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{41, 41, 0x0000000000000000, "RW", "IMR8_READ_POL_41", "Bunit IMR8 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR8 region based on the agents 6bit encoded SAI value."},
#else
{41, 41, 0x0000000000000000, "RW", "IMR8_READ_POL_41", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{40, 40, 0x0000000000000000, "RW", "IMR8_READ_POL_40", "Bunit IMR8 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR8 region based on the agents 6bit encoded SAI value."},
#else
{40, 40, 0x0000000000000000, "RW", "IMR8_READ_POL_40", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{39, 39, 0x0000000000000000, "RO", "IMR8_READ_POL_39", "Bunit IMR8 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR8 region based on the agents 6bit encoded SAI value."},
#else
{39, 39, 0x0000000000000000, "RO", "IMR8_READ_POL_39", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{38, 38, 0x0000000000000000, "RW", "IMR8_READ_POL_38", "Bunit IMR8 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR8 region based on the agents 6bit encoded SAI value."},
#else
{38, 38, 0x0000000000000000, "RW", "IMR8_READ_POL_38", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{37, 37, 0x0000000000000000, "RO", "IMR8_READ_POL_37", "Bunit IMR8 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR8 region based on the agents 6bit encoded SAI value."},
#else
{37, 37, 0x0000000000000000, "RO", "IMR8_READ_POL_37", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{36, 36, 0x0000000000000000, "RW", "IMR8_READ_POL_36", "Bunit IMR8 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR8 region based on the agents 6bit encoded SAI value."},
#else
{36, 36, 0x0000000000000000, "RW", "IMR8_READ_POL_36", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{35, 35, 0x0000000000000000, "RO", "IMR8_READ_POL_35", "Bunit IMR8 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR8 region based on the agents 6bit encoded SAI value."},
#else
{35, 35, 0x0000000000000000, "RO", "IMR8_READ_POL_35", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{34, 34, 0x0000000000000000, "RW", "IMR8_READ_POL_34", "Bunit IMR8 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR8 region based on the agents 6bit encoded SAI value."},
#else
{34, 34, 0x0000000000000000, "RW", "IMR8_READ_POL_34", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{33, 33, 0x0000000000000000, "RW", "IMR8_READ_POL_33", "Bunit IMR8 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR8 region based on the agents 6bit encoded SAI value."},
#else
{33, 33, 0x0000000000000000, "RW", "IMR8_READ_POL_33", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{32, 32, 0x0000000000000000, "RW", "IMR8_READ_POL_32", "Bunit IMR8 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR8 region based on the agents 6bit encoded SAI value."},
#else
{32, 32, 0x0000000000000000, "RW", "IMR8_READ_POL_32", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{31, 31, 0x0000000000000000, "RO", "IMR8_READ_POL_31", "Bunit IMR8 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR8 region based on the agents 6bit encoded SAI value."},
#else
{31, 31, 0x0000000000000000, "RO", "IMR8_READ_POL_31", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{30, 30, 0x0000000000000000, "RW", "IMR8_READ_POL_30", "Bunit IMR8 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR8 region based on the agents 6bit encoded SAI value."},
#else
{30, 30, 0x0000000000000000, "RW", "IMR8_READ_POL_30", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{29, 29, 0x0000000000000000, "RW", "IMR8_READ_POL_29", "Bunit IMR8 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR8 region based on the agents 6bit encoded SAI value."},
#else
{29, 29, 0x0000000000000000, "RW", "IMR8_READ_POL_29", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{28, 28, 0x0000000000000000, "RW", "IMR8_READ_POL_28", "Bunit IMR8 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR8 region based on the agents 6bit encoded SAI value."},
#else
{28, 28, 0x0000000000000000, "RW", "IMR8_READ_POL_28", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{27, 27, 0x0000000000000000, "RW", "IMR8_READ_POL_27", "Bunit IMR8 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR8 region based on the agents 6bit encoded SAI value."},
#else
{27, 27, 0x0000000000000000, "RW", "IMR8_READ_POL_27", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{26, 26, 0x0000000000000000, "RW", "IMR8_READ_POL_26", "Bunit IMR8 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR8 region based on the agents 6bit encoded SAI value."},
#else
{26, 26, 0x0000000000000000, "RW", "IMR8_READ_POL_26", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{25, 25, 0x0000000000000000, "RW", "IMR8_READ_POL_25", "Bunit IMR8 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR8 region based on the agents 6bit encoded SAI value."},
#else
{25, 25, 0x0000000000000000, "RW", "IMR8_READ_POL_25", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{24, 24, 0x0000000000000000, "RW", "IMR8_READ_POL_24", "Bunit IMR8 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR8 region based on the agents 6bit encoded SAI value."},
#else
{24, 24, 0x0000000000000000, "RW", "IMR8_READ_POL_24", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{23, 23, 0x0000000000000000, "RO", "IMR8_READ_POL_23", "Bunit IMR8 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR8 region based on the agents 6bit encoded SAI value."},
#else
{23, 23, 0x0000000000000000, "RO", "IMR8_READ_POL_23", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{22, 22, 0x0000000000000000, "RO", "IMR8_READ_POL_22", "Bunit IMR8 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR8 region based on the agents 6bit encoded SAI value."},
#else
{22, 22, 0x0000000000000000, "RO", "IMR8_READ_POL_22", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{21, 21, 0x0000000000000000, "RW", "IMR8_READ_POL_21", "Bunit IMR8 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR8 region based on the agents 6bit encoded SAI value."},
#else
{21, 21, 0x0000000000000000, "RW", "IMR8_READ_POL_21", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{20, 20, 0x0000000000000000, "RO", "IMR8_READ_POL_20", "Bunit IMR8 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR8 region based on the agents 6bit encoded SAI value."},
#else
{20, 20, 0x0000000000000000, "RO", "IMR8_READ_POL_20", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{19, 19, 0x0000000000000000, "RO", "IMR8_READ_POL_19", "Bunit IMR8 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR8 region based on the agents 6bit encoded SAI value."},
#else
{19, 19, 0x0000000000000000, "RO", "IMR8_READ_POL_19", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{18, 18, 0x0000000000000000, "RO", "IMR8_READ_POL_18", "Bunit IMR8 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR8 region based on the agents 6bit encoded SAI value."},
#else
{18, 18, 0x0000000000000000, "RO", "IMR8_READ_POL_18", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{17, 17, 0x0000000000000000, "RW", "IMR8_READ_POL_17", "Bunit IMR8 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR8 region based on the agents 6bit encoded SAI value."},
#else
{17, 17, 0x0000000000000000, "RW", "IMR8_READ_POL_17", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{16, 16, 0x0000000000000000, "RW", "IMR8_READ_POL_16", "Bunit IMR8 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR8 region based on the agents 6bit encoded SAI value."},
#else
{16, 16, 0x0000000000000000, "RW", "IMR8_READ_POL_16", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{15, 15, 0x0000000000000000, "RO", "IMR8_READ_POL_15", "Bunit IMR8 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR8 region based on the agents 6bit encoded SAI value."},
#else
{15, 15, 0x0000000000000000, "RO", "IMR8_READ_POL_15", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{14, 14, 0x0000000000000000, "RO", "IMR8_READ_POL_14", "Bunit IMR8 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR8 region based on the agents 6bit encoded SAI value."},
#else
{14, 14, 0x0000000000000000, "RO", "IMR8_READ_POL_14", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{13, 13, 0x0000000000000000, "RW", "IMR8_READ_POL_13", "Bunit IMR8 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR8 region based on the agents 6bit encoded SAI value."},
#else
{13, 13, 0x0000000000000000, "RW", "IMR8_READ_POL_13", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{12, 12, 0x0000000000000000, "RW", "IMR8_READ_POL_12", "Bunit IMR8 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR8 region based on the agents 6bit encoded SAI value."},
#else
{12, 12, 0x0000000000000000, "RW", "IMR8_READ_POL_12", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{11, 11, 0x0000000000000000, "RO", "IMR8_READ_POL_11", "Bunit IMR8 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR8 region based on the agents 6bit encoded SAI value."},
#else
{11, 11, 0x0000000000000000, "RO", "IMR8_READ_POL_11", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{10, 10, 0x0000000000000000, "RO", "IMR8_READ_POL_10", "Bunit IMR8 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR8 region based on the agents 6bit encoded SAI value."},
#else
{10, 10, 0x0000000000000000, "RO", "IMR8_READ_POL_10", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{9, 9, 0x0000000000000000, "RO", "IMR8_READ_POL_9", "Bunit IMR8 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR8 region based on the agents 6bit encoded SAI value."},
#else
{9, 9, 0x0000000000000000, "RO", "IMR8_READ_POL_9", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{8, 8, 0x0000000000000000, "RW", "IMR8_READ_POL_8", "Bunit IMR8 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR8 region based on the agents 6bit encoded SAI value."},
#else
{8, 8, 0x0000000000000000, "RW", "IMR8_READ_POL_8", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{7, 7, 0x0000000000000000, "RO", "IMR8_READ_POL_7", "Bunit IMR8 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR8 region based on the agents 6bit encoded SAI value."},
#else
{7, 7, 0x0000000000000000, "RO", "IMR8_READ_POL_7", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{6, 6, 0x0000000000000000, "RO", "IMR8_READ_POL_6", "Bunit IMR8 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR8 region based on the agents 6bit encoded SAI value."},
#else
{6, 6, 0x0000000000000000, "RO", "IMR8_READ_POL_6", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{5, 5, 0x0000000000000000, "RW", "IMR8_READ_POL_5", "Bunit IMR8 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR8 region based on the agents 6bit encoded SAI value."},
#else
{5, 5, 0x0000000000000000, "RW", "IMR8_READ_POL_5", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{4, 4, 0x0000000000000000, "RW", "IMR8_READ_POL_4", "Bunit IMR8 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR8 region based on the agents 6bit encoded SAI value."},
#else
{4, 4, 0x0000000000000000, "RW", "IMR8_READ_POL_4", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{3, 3, 0x0000000000000000, "RW", "IMR8_READ_POL_3", "Bunit IMR8 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR8 region based on the agents 6bit encoded SAI value."},
#else
{3, 3, 0x0000000000000000, "RW", "IMR8_READ_POL_3", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{2, 2, 0x0000000000000000, "RW", "IMR8_READ_POL_2", "Bunit IMR8 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR8 region based on the agents 6bit encoded SAI value."},
#else
{2, 2, 0x0000000000000000, "RW", "IMR8_READ_POL_2", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{1, 1, 0x0000000000000000, "RW", "IMR8_READ_POL_1", "Bunit IMR8 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR8 region based on the agents 6bit encoded SAI value."},
#else
{1, 1, 0x0000000000000000, "RW", "IMR8_READ_POL_1", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 0, 0x0000000000000000, "RW", "IMR8_READ_POL_0", "Bunit IMR8 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR8 region based on the agents 6bit encoded SAI value."},
#else
{0, 0, 0x0000000000000000, "RW", "IMR8_READ_POL_0", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo920[] = {{"B_CR_BIMR8RAC_0_0_0_MCHBAR", "", 0x00006980, 64, 0xFFFFFFFFFFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields921[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{63, 63, 0x0000000000000000, "RW", "IMR8_WRITE_POL_63", "Bunit IMR8 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR8 region based on the agents 6bit encoded SAI value."},
#else
{63, 63, 0x0000000000000000, "RW", "IMR8_WRITE_POL_63", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{62, 62, 0x0000000000000000, "RO", "IMR8_WRITE_POL_62", "Bunit IMR8 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR8 region based on the agents 6bit encoded SAI value."},
#else
{62, 62, 0x0000000000000000, "RO", "IMR8_WRITE_POL_62", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{61, 61, 0x0000000000000000, "RO", "IMR8_WRITE_POL_61", "Bunit IMR8 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR8 region based on the agents 6bit encoded SAI value."},
#else
{61, 61, 0x0000000000000000, "RO", "IMR8_WRITE_POL_61", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{60, 60, 0x0000000000000000, "RO", "IMR8_WRITE_POL_60", "Bunit IMR8 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR8 region based on the agents 6bit encoded SAI value."},
#else
{60, 60, 0x0000000000000000, "RO", "IMR8_WRITE_POL_60", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{59, 59, 0x0000000000000000, "RO", "IMR8_WRITE_POL_59", "Bunit IMR8 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR8 region based on the agents 6bit encoded SAI value."},
#else
{59, 59, 0x0000000000000000, "RO", "IMR8_WRITE_POL_59", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{58, 58, 0x0000000000000000, "RO", "IMR8_WRITE_POL_58", "Bunit IMR8 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR8 region based on the agents 6bit encoded SAI value."},
#else
{58, 58, 0x0000000000000000, "RO", "IMR8_WRITE_POL_58", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{57, 57, 0x0000000000000000, "RO", "IMR8_WRITE_POL_57", "Bunit IMR8 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR8 region based on the agents 6bit encoded SAI value."},
#else
{57, 57, 0x0000000000000000, "RO", "IMR8_WRITE_POL_57", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{56, 56, 0x0000000000000000, "RW", "IMR8_WRITE_POL_56", "Bunit IMR8 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR8 region based on the agents 6bit encoded SAI value."},
#else
{56, 56, 0x0000000000000000, "RW", "IMR8_WRITE_POL_56", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{55, 55, 0x0000000000000000, "RW", "IMR8_WRITE_POL_55", "Bunit IMR8 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR8 region based on the agents 6bit encoded SAI value."},
#else
{55, 55, 0x0000000000000000, "RW", "IMR8_WRITE_POL_55", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{54, 54, 0x0000000000000000, "RW", "IMR8_WRITE_POL_54", "Bunit IMR8 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR8 region based on the agents 6bit encoded SAI value."},
#else
{54, 54, 0x0000000000000000, "RW", "IMR8_WRITE_POL_54", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{53, 53, 0x0000000000000000, "RO", "IMR8_WRITE_POL_53", "Bunit IMR8 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR8 region based on the agents 6bit encoded SAI value."},
#else
{53, 53, 0x0000000000000000, "RO", "IMR8_WRITE_POL_53", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{52, 52, 0x0000000000000000, "RO", "IMR8_WRITE_POL_52", "Bunit IMR8 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR8 region based on the agents 6bit encoded SAI value."},
#else
{52, 52, 0x0000000000000000, "RO", "IMR8_WRITE_POL_52", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{51, 51, 0x0000000000000000, "RO", "IMR8_WRITE_POL_51", "Bunit IMR8 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR8 region based on the agents 6bit encoded SAI value."},
#else
{51, 51, 0x0000000000000000, "RO", "IMR8_WRITE_POL_51", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{50, 50, 0x0000000000000000, "RW", "IMR8_WRITE_POL_50", "Bunit IMR8 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR8 region based on the agents 6bit encoded SAI value."},
#else
{50, 50, 0x0000000000000000, "RW", "IMR8_WRITE_POL_50", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{49, 49, 0x0000000000000000, "RW", "IMR8_WRITE_POL_49", "Bunit IMR8 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR8 region based on the agents 6bit encoded SAI value."},
#else
{49, 49, 0x0000000000000000, "RW", "IMR8_WRITE_POL_49", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{48, 48, 0x0000000000000000, "RW", "IMR8_WRITE_POL_48", "Bunit IMR8 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR8 region based on the agents 6bit encoded SAI value."},
#else
{48, 48, 0x0000000000000000, "RW", "IMR8_WRITE_POL_48", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{47, 47, 0x0000000000000000, "RO", "IMR8_WRITE_POL_47", "Bunit IMR8 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR8 region based on the agents 6bit encoded SAI value."},
#else
{47, 47, 0x0000000000000000, "RO", "IMR8_WRITE_POL_47", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{46, 46, 0x0000000000000000, "RO", "IMR8_WRITE_POL_46", "Bunit IMR8 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR8 region based on the agents 6bit encoded SAI value."},
#else
{46, 46, 0x0000000000000000, "RO", "IMR8_WRITE_POL_46", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{45, 45, 0x0000000000000000, "RO", "IMR8_WRITE_POL_45", "Bunit IMR8 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR8 region based on the agents 6bit encoded SAI value."},
#else
{45, 45, 0x0000000000000000, "RO", "IMR8_WRITE_POL_45", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{44, 44, 0x0000000000000000, "RW", "IMR8_WRITE_POL_44", "Bunit IMR8 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR8 region based on the agents 6bit encoded SAI value."},
#else
{44, 44, 0x0000000000000000, "RW", "IMR8_WRITE_POL_44", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{43, 43, 0x0000000000000000, "RW", "IMR8_WRITE_POL_43", "Bunit IMR8 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR8 region based on the agents 6bit encoded SAI value."},
#else
{43, 43, 0x0000000000000000, "RW", "IMR8_WRITE_POL_43", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{42, 42, 0x0000000000000000, "RW", "IMR8_WRITE_POL_42", "Bunit IMR8 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR8 region based on the agents 6bit encoded SAI value."},
#else
{42, 42, 0x0000000000000000, "RW", "IMR8_WRITE_POL_42", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{41, 41, 0x0000000000000000, "RW", "IMR8_WRITE_POL_41", "Bunit IMR8 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR8 region based on the agents 6bit encoded SAI value."},
#else
{41, 41, 0x0000000000000000, "RW", "IMR8_WRITE_POL_41", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{40, 40, 0x0000000000000000, "RW", "IMR8_WRITE_POL_40", "Bunit IMR8 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR8 region based on the agents 6bit encoded SAI value."},
#else
{40, 40, 0x0000000000000000, "RW", "IMR8_WRITE_POL_40", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{39, 39, 0x0000000000000000, "RO", "IMR8_WRITE_POL_39", "Bunit IMR8 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR8 region based on the agents 6bit encoded SAI value."},
#else
{39, 39, 0x0000000000000000, "RO", "IMR8_WRITE_POL_39", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{38, 38, 0x0000000000000000, "RW", "IMR8_WRITE_POL_38", "Bunit IMR8 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR8 region based on the agents 6bit encoded SAI value."},
#else
{38, 38, 0x0000000000000000, "RW", "IMR8_WRITE_POL_38", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{37, 37, 0x0000000000000000, "RO", "IMR8_WRITE_POL_37", "Bunit IMR8 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR8 region based on the agents 6bit encoded SAI value."},
#else
{37, 37, 0x0000000000000000, "RO", "IMR8_WRITE_POL_37", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{36, 36, 0x0000000000000000, "RW", "IMR8_WRITE_POL_36", "Bunit IMR8 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR8 region based on the agents 6bit encoded SAI value."},
#else
{36, 36, 0x0000000000000000, "RW", "IMR8_WRITE_POL_36", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{35, 35, 0x0000000000000000, "RO", "IMR8_WRITE_POL_35", "Bunit IMR8 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR8 region based on the agents 6bit encoded SAI value."},
#else
{35, 35, 0x0000000000000000, "RO", "IMR8_WRITE_POL_35", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{34, 34, 0x0000000000000000, "RW", "IMR8_WRITE_POL_34", "Bunit IMR8 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR8 region based on the agents 6bit encoded SAI value."},
#else
{34, 34, 0x0000000000000000, "RW", "IMR8_WRITE_POL_34", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{33, 33, 0x0000000000000000, "RW", "IMR8_WRITE_POL_33", "Bunit IMR8 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR8 region based on the agents 6bit encoded SAI value."},
#else
{33, 33, 0x0000000000000000, "RW", "IMR8_WRITE_POL_33", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{32, 32, 0x0000000000000000, "RW", "IMR8_WRITE_POL_32", "Bunit IMR8 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR8 region based on the agents 6bit encoded SAI value."},
#else
{32, 32, 0x0000000000000000, "RW", "IMR8_WRITE_POL_32", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{31, 31, 0x0000000000000000, "RO", "IMR8_WRITE_POL_31", "Bunit IMR8 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR8 region based on the agents 6bit encoded SAI value."},
#else
{31, 31, 0x0000000000000000, "RO", "IMR8_WRITE_POL_31", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{30, 30, 0x0000000000000000, "RW", "IMR8_WRITE_POL_30", "Bunit IMR8 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR8 region based on the agents 6bit encoded SAI value."},
#else
{30, 30, 0x0000000000000000, "RW", "IMR8_WRITE_POL_30", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{29, 29, 0x0000000000000000, "RW", "IMR8_WRITE_POL_29", "Bunit IMR8 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR8 region based on the agents 6bit encoded SAI value."},
#else
{29, 29, 0x0000000000000000, "RW", "IMR8_WRITE_POL_29", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{28, 28, 0x0000000000000000, "RW", "IMR8_WRITE_POL_28", "Bunit IMR8 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR8 region based on the agents 6bit encoded SAI value."},
#else
{28, 28, 0x0000000000000000, "RW", "IMR8_WRITE_POL_28", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{27, 27, 0x0000000000000000, "RW", "IMR8_WRITE_POL_27", "Bunit IMR8 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR8 region based on the agents 6bit encoded SAI value."},
#else
{27, 27, 0x0000000000000000, "RW", "IMR8_WRITE_POL_27", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{26, 26, 0x0000000000000000, "RW", "IMR8_WRITE_POL_26", "Bunit IMR8 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR8 region based on the agents 6bit encoded SAI value."},
#else
{26, 26, 0x0000000000000000, "RW", "IMR8_WRITE_POL_26", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{25, 25, 0x0000000000000000, "RW", "IMR8_WRITE_POL_25", "Bunit IMR8 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR8 region based on the agents 6bit encoded SAI value."},
#else
{25, 25, 0x0000000000000000, "RW", "IMR8_WRITE_POL_25", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{24, 24, 0x0000000000000000, "RW", "IMR8_WRITE_POL_24", "Bunit IMR8 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR8 region based on the agents 6bit encoded SAI value."},
#else
{24, 24, 0x0000000000000000, "RW", "IMR8_WRITE_POL_24", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{23, 23, 0x0000000000000000, "RO", "IMR8_WRITE_POL_23", "Bunit IMR8 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR8 region based on the agents 6bit encoded SAI value."},
#else
{23, 23, 0x0000000000000000, "RO", "IMR8_WRITE_POL_23", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{22, 22, 0x0000000000000000, "RO", "IMR8_WRITE_POL_22", "Bunit IMR8 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR8 region based on the agents 6bit encoded SAI value."},
#else
{22, 22, 0x0000000000000000, "RO", "IMR8_WRITE_POL_22", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{21, 21, 0x0000000000000000, "RW", "IMR8_WRITE_POL_21", "Bunit IMR8 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR8 region based on the agents 6bit encoded SAI value."},
#else
{21, 21, 0x0000000000000000, "RW", "IMR8_WRITE_POL_21", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{20, 20, 0x0000000000000000, "RO", "IMR8_WRITE_POL_20", "Bunit IMR8 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR8 region based on the agents 6bit encoded SAI value."},
#else
{20, 20, 0x0000000000000000, "RO", "IMR8_WRITE_POL_20", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{19, 19, 0x0000000000000000, "RO", "IMR8_WRITE_POL_19", "Bunit IMR8 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR8 region based on the agents 6bit encoded SAI value."},
#else
{19, 19, 0x0000000000000000, "RO", "IMR8_WRITE_POL_19", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{18, 18, 0x0000000000000000, "RO", "IMR8_WRITE_POL_18", "Bunit IMR8 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR8 region based on the agents 6bit encoded SAI value."},
#else
{18, 18, 0x0000000000000000, "RO", "IMR8_WRITE_POL_18", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{17, 17, 0x0000000000000000, "RW", "IMR8_WRITE_POL_17", "Bunit IMR8 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR8 region based on the agents 6bit encoded SAI value."},
#else
{17, 17, 0x0000000000000000, "RW", "IMR8_WRITE_POL_17", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{16, 16, 0x0000000000000000, "RW", "IMR8_WRITE_POL_16", "Bunit IMR8 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR8 region based on the agents 6bit encoded SAI value."},
#else
{16, 16, 0x0000000000000000, "RW", "IMR8_WRITE_POL_16", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{15, 15, 0x0000000000000000, "RO", "IMR8_WRITE_POL_15", "Bunit IMR8 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR8 region based on the agents 6bit encoded SAI value."},
#else
{15, 15, 0x0000000000000000, "RO", "IMR8_WRITE_POL_15", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{14, 14, 0x0000000000000000, "RO", "IMR8_WRITE_POL_14", "Bunit IMR8 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR8 region based on the agents 6bit encoded SAI value."},
#else
{14, 14, 0x0000000000000000, "RO", "IMR8_WRITE_POL_14", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{13, 13, 0x0000000000000000, "RW", "IMR8_WRITE_POL_13", "Bunit IMR8 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR8 region based on the agents 6bit encoded SAI value."},
#else
{13, 13, 0x0000000000000000, "RW", "IMR8_WRITE_POL_13", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{12, 12, 0x0000000000000000, "RW", "IMR8_WRITE_POL_12", "Bunit IMR8 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR8 region based on the agents 6bit encoded SAI value."},
#else
{12, 12, 0x0000000000000000, "RW", "IMR8_WRITE_POL_12", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{11, 11, 0x0000000000000000, "RO", "IMR8_WRITE_POL_11", "Bunit IMR8 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR8 region based on the agents 6bit encoded SAI value."},
#else
{11, 11, 0x0000000000000000, "RO", "IMR8_WRITE_POL_11", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{10, 10, 0x0000000000000000, "RO", "IMR8_WRITE_POL_10", "Bunit IMR8 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR8 region based on the agents 6bit encoded SAI value."},
#else
{10, 10, 0x0000000000000000, "RO", "IMR8_WRITE_POL_10", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{9, 9, 0x0000000000000000, "RO", "IMR8_WRITE_POL_9", "Bunit IMR8 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR8 region based on the agents 6bit encoded SAI value."},
#else
{9, 9, 0x0000000000000000, "RO", "IMR8_WRITE_POL_9", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{8, 8, 0x0000000000000000, "RW", "IMR8_WRITE_POL_8", "Bunit IMR8 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR8 region based on the agents 6bit encoded SAI value."},
#else
{8, 8, 0x0000000000000000, "RW", "IMR8_WRITE_POL_8", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{7, 7, 0x0000000000000000, "RO", "IMR8_WRITE_POL_7", "Bunit IMR8 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR8 region based on the agents 6bit encoded SAI value."},
#else
{7, 7, 0x0000000000000000, "RO", "IMR8_WRITE_POL_7", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{6, 6, 0x0000000000000000, "RO", "IMR8_WRITE_POL_6", "Bunit IMR8 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR8 region based on the agents 6bit encoded SAI value."},
#else
{6, 6, 0x0000000000000000, "RO", "IMR8_WRITE_POL_6", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{5, 5, 0x0000000000000000, "RW", "IMR8_WRITE_POL_5", "Bunit IMR8 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR8 region based on the agents 6bit encoded SAI value."},
#else
{5, 5, 0x0000000000000000, "RW", "IMR8_WRITE_POL_5", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{4, 4, 0x0000000000000000, "RW", "IMR8_WRITE_POL_4", "Bunit IMR8 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR8 region based on the agents 6bit encoded SAI value."},
#else
{4, 4, 0x0000000000000000, "RW", "IMR8_WRITE_POL_4", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{3, 3, 0x0000000000000000, "RW", "IMR8_WRITE_POL_3", "Bunit IMR8 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR8 region based on the agents 6bit encoded SAI value."},
#else
{3, 3, 0x0000000000000000, "RW", "IMR8_WRITE_POL_3", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{2, 2, 0x0000000000000000, "RW", "IMR8_WRITE_POL_2", "Bunit IMR8 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR8 region based on the agents 6bit encoded SAI value."},
#else
{2, 2, 0x0000000000000000, "RW", "IMR8_WRITE_POL_2", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{1, 1, 0x0000000000000000, "RW", "IMR8_WRITE_POL_1", "Bunit IMR8 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR8 region based on the agents 6bit encoded SAI value."},
#else
{1, 1, 0x0000000000000000, "RW", "IMR8_WRITE_POL_1", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 0, 0x0000000000000000, "RW", "IMR8_WRITE_POL_0", "Bunit IMR8 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR8 region based on the agents 6bit encoded SAI value."},
#else
{0, 0, 0x0000000000000000, "RW", "IMR8_WRITE_POL_0", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo921[] = {{"B_CR_BIMR8WAC_0_0_0_MCHBAR", "", 0x00006988, 64, 0xFFFFFFFFFFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields922[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{31, 31, 0x0000000000000000, "RW", "IMR_EN", "IMR Enable: Enables access checking for the IMR region."},
#else
{31, 31, 0x0000000000000000, "RW", "IMR_EN", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{30, 30, 0x0000000000000000, "RW", "TR_EN", "Asset Classification AC[0]: Trace Enable: Enables snooping of transactions to the IMR region by tracing agents."},
#else
{30, 30, 0x0000000000000000, "RW", "TR_EN", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{29, 29, 0x0000000000000000, "RO", "RESERVED_1", "Reserved"},
#else
{29, 29, 0x0000000000000000, "RO", "RESERVED_1", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 28, 0x0000000000000000, "RW", "IMR9_BASE", "Base 1 IMR9BASE:  Specifies bits 38:10 of the start address of IMR9 region.  IMR region size must be a strict poweroftwo at least 1KB and naturally aligned to the size.  These bits are compared with the result of the IMR9MASK[28:0] applied to bits 38:10 of the incoming address to determine if an access falls within the IMR9 defined region."},
#else
{0, 28, 0x0000000000000000, "RW", "IMR9_BASE", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo922[] = {{"B_CR_BIMR9BASE_0_0_0_MCHBAR", "", 0x00006990, 4, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields923[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{31, 31, 0x0000000000000000, "RW", "GT_IWB_EN", "Asset Classification AC[2]: GT Implicit WB Enable: Enables implicit writebacks to protected region from GT caching agent. When set to 1 enables implicit writeback data HITM data from GT to be returned to the requester.  When set to 0 inhibits HITM data from GT from being returned to the requester.  HITM data from IA cores may be returned to the requester depending on the setting of the IA_IWB_EN bit."},
#else
{31, 31, 0x0000000000000000, "RW", "GT_IWB_EN", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{30, 30, 0x0000000000000000, "RW", "IA_IWB_EN", "Asset Classification AC[1]: IA Implicit WB Enable: Enables implicit writebacks to protected region from IA caching agent.  When set to 1 enables implicit writeback data HITM data from IA cores to be returned to the requester.  When set to 0 inhibits HITM data from IA cores from being returned to the requester.  HITM data from GT may be returned to the requester depending on the setting of the GT_IWB_EN bit."},
#else
{30, 30, 0x0000000000000000, "RW", "IA_IWB_EN", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{29, 29, 0x0000000000000000, "RO", "RESERVED_0", "Reserved"},
#else
{29, 29, 0x0000000000000000, "RO", "RESERVED_0", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 28, 0x0000000000000000, "RW", "IMR9_MASK", "Mask 1 IMR9MASK:  These bits are ANDed with bits 38:10 of the incoming address to determine if the combined result matches the IMR9BASE[28:0] value.  A match indicates the the incoming address falls within the IMR9 region."},
#else
{0, 28, 0x0000000000000000, "RW", "IMR9_MASK", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo923[] = {{"B_CR_BIMR9MASK_0_0_0_MCHBAR", "", 0x00006994, 4, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields924[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{0, 63, 0x00000C0061010202, "RW", "IMR9_CTRL_POL", "Bunit IMR9 Control Policy: Bit vector used to determine which agents are allowed access to the BIMR9RAC, BIMR9WAC, BIMR9CP registers based on the value from the agents 6bit SAI field."},
#else
{0, 63, 0x00000C0061010202, "RW", "IMR9_CTRL_POL", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo924[] = {{"B_CR_BIMR9CP_0_0_0_MCHBAR", "", 0x00006998, 1, 0xFFFFFFFFFFFFFFFF, 0x00000C0061010202}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields925[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{63, 63, 0x0000000000000000, "RW", "IMR9_READ_POL_63", "Bunit IMR9 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR9 region based on the agents 6bit encoded SAI value."},
#else
{63, 63, 0x0000000000000000, "RW", "IMR9_READ_POL_63", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{62, 62, 0x0000000000000000, "RO", "IMR9_READ_POL_62", "Bunit IMR9 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR9 region based on the agents 6bit encoded SAI value."},
#else
{62, 62, 0x0000000000000000, "RO", "IMR9_READ_POL_62", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{61, 61, 0x0000000000000000, "RO", "IMR9_READ_POL_61", "Bunit IMR9 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR9 region based on the agents 6bit encoded SAI value."},
#else
{61, 61, 0x0000000000000000, "RO", "IMR9_READ_POL_61", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{60, 60, 0x0000000000000000, "RO", "IMR9_READ_POL_60", "Bunit IMR9 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR9 region based on the agents 6bit encoded SAI value."},
#else
{60, 60, 0x0000000000000000, "RO", "IMR9_READ_POL_60", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{59, 59, 0x0000000000000000, "RO", "IMR9_READ_POL_59", "Bunit IMR9 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR9 region based on the agents 6bit encoded SAI value."},
#else
{59, 59, 0x0000000000000000, "RO", "IMR9_READ_POL_59", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{58, 58, 0x0000000000000000, "RO", "IMR9_READ_POL_58", "Bunit IMR9 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR9 region based on the agents 6bit encoded SAI value."},
#else
{58, 58, 0x0000000000000000, "RO", "IMR9_READ_POL_58", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{57, 57, 0x0000000000000000, "RO", "IMR9_READ_POL_57", "Bunit IMR9 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR9 region based on the agents 6bit encoded SAI value."},
#else
{57, 57, 0x0000000000000000, "RO", "IMR9_READ_POL_57", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{56, 56, 0x0000000000000000, "RW", "IMR9_READ_POL_56", "Bunit IMR9 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR9 region based on the agents 6bit encoded SAI value."},
#else
{56, 56, 0x0000000000000000, "RW", "IMR9_READ_POL_56", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{55, 55, 0x0000000000000000, "RW", "IMR9_READ_POL_55", "Bunit IMR9 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR9 region based on the agents 6bit encoded SAI value."},
#else
{55, 55, 0x0000000000000000, "RW", "IMR9_READ_POL_55", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{54, 54, 0x0000000000000000, "RW", "IMR9_READ_POL_54", "Bunit IMR9 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR9 region based on the agents 6bit encoded SAI value."},
#else
{54, 54, 0x0000000000000000, "RW", "IMR9_READ_POL_54", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{53, 53, 0x0000000000000000, "RO", "IMR9_READ_POL_53", "Bunit IMR9 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR9 region based on the agents 6bit encoded SAI value."},
#else
{53, 53, 0x0000000000000000, "RO", "IMR9_READ_POL_53", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{52, 52, 0x0000000000000000, "RO", "IMR9_READ_POL_52", "Bunit IMR9 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR9 region based on the agents 6bit encoded SAI value."},
#else
{52, 52, 0x0000000000000000, "RO", "IMR9_READ_POL_52", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{51, 51, 0x0000000000000000, "RO", "IMR9_READ_POL_51", "Bunit IMR9 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR9 region based on the agents 6bit encoded SAI value."},
#else
{51, 51, 0x0000000000000000, "RO", "IMR9_READ_POL_51", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{50, 50, 0x0000000000000000, "RW", "IMR9_READ_POL_50", "Bunit IMR9 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR9 region based on the agents 6bit encoded SAI value."},
#else
{50, 50, 0x0000000000000000, "RW", "IMR9_READ_POL_50", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{49, 49, 0x0000000000000000, "RW", "IMR9_READ_POL_49", "Bunit IMR9 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR9 region based on the agents 6bit encoded SAI value."},
#else
{49, 49, 0x0000000000000000, "RW", "IMR9_READ_POL_49", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{48, 48, 0x0000000000000000, "RW", "IMR9_READ_POL_48", "Bunit IMR9 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR9 region based on the agents 6bit encoded SAI value."},
#else
{48, 48, 0x0000000000000000, "RW", "IMR9_READ_POL_48", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{47, 47, 0x0000000000000000, "RO", "IMR9_READ_POL_47", "Bunit IMR9 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR9 region based on the agents 6bit encoded SAI value."},
#else
{47, 47, 0x0000000000000000, "RO", "IMR9_READ_POL_47", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{46, 46, 0x0000000000000000, "RO", "IMR9_READ_POL_46", "Bunit IMR9 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR9 region based on the agents 6bit encoded SAI value."},
#else
{46, 46, 0x0000000000000000, "RO", "IMR9_READ_POL_46", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{45, 45, 0x0000000000000000, "RO", "IMR9_READ_POL_45", "Bunit IMR9 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR9 region based on the agents 6bit encoded SAI value."},
#else
{45, 45, 0x0000000000000000, "RO", "IMR9_READ_POL_45", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{44, 44, 0x0000000000000000, "RW", "IMR9_READ_POL_44", "Bunit IMR9 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR9 region based on the agents 6bit encoded SAI value."},
#else
{44, 44, 0x0000000000000000, "RW", "IMR9_READ_POL_44", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{43, 43, 0x0000000000000000, "RW", "IMR9_READ_POL_43", "Bunit IMR9 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR9 region based on the agents 6bit encoded SAI value."},
#else
{43, 43, 0x0000000000000000, "RW", "IMR9_READ_POL_43", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{42, 42, 0x0000000000000000, "RW", "IMR9_READ_POL_42", "Bunit IMR9 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR9 region based on the agents 6bit encoded SAI value."},
#else
{42, 42, 0x0000000000000000, "RW", "IMR9_READ_POL_42", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{41, 41, 0x0000000000000000, "RW", "IMR9_READ_POL_41", "Bunit IMR9 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR9 region based on the agents 6bit encoded SAI value."},
#else
{41, 41, 0x0000000000000000, "RW", "IMR9_READ_POL_41", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{40, 40, 0x0000000000000000, "RW", "IMR9_READ_POL_40", "Bunit IMR9 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR9 region based on the agents 6bit encoded SAI value."},
#else
{40, 40, 0x0000000000000000, "RW", "IMR9_READ_POL_40", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{39, 39, 0x0000000000000000, "RO", "IMR9_READ_POL_39", "Bunit IMR9 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR9 region based on the agents 6bit encoded SAI value."},
#else
{39, 39, 0x0000000000000000, "RO", "IMR9_READ_POL_39", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{38, 38, 0x0000000000000000, "RW", "IMR9_READ_POL_38", "Bunit IMR9 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR9 region based on the agents 6bit encoded SAI value."},
#else
{38, 38, 0x0000000000000000, "RW", "IMR9_READ_POL_38", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{37, 37, 0x0000000000000000, "RO", "IMR9_READ_POL_37", "Bunit IMR9 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR9 region based on the agents 6bit encoded SAI value."},
#else
{37, 37, 0x0000000000000000, "RO", "IMR9_READ_POL_37", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{36, 36, 0x0000000000000000, "RW", "IMR9_READ_POL_36", "Bunit IMR9 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR9 region based on the agents 6bit encoded SAI value."},
#else
{36, 36, 0x0000000000000000, "RW", "IMR9_READ_POL_36", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{35, 35, 0x0000000000000000, "RO", "IMR9_READ_POL_35", "Bunit IMR9 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR9 region based on the agents 6bit encoded SAI value."},
#else
{35, 35, 0x0000000000000000, "RO", "IMR9_READ_POL_35", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{34, 34, 0x0000000000000000, "RW", "IMR9_READ_POL_34", "Bunit IMR9 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR9 region based on the agents 6bit encoded SAI value."},
#else
{34, 34, 0x0000000000000000, "RW", "IMR9_READ_POL_34", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{33, 33, 0x0000000000000000, "RW", "IMR9_READ_POL_33", "Bunit IMR9 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR9 region based on the agents 6bit encoded SAI value."},
#else
{33, 33, 0x0000000000000000, "RW", "IMR9_READ_POL_33", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{32, 32, 0x0000000000000000, "RW", "IMR9_READ_POL_32", "Bunit IMR9 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR9 region based on the agents 6bit encoded SAI value."},
#else
{32, 32, 0x0000000000000000, "RW", "IMR9_READ_POL_32", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{31, 31, 0x0000000000000000, "RO", "IMR9_READ_POL_31", "Bunit IMR9 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR9 region based on the agents 6bit encoded SAI value."},
#else
{31, 31, 0x0000000000000000, "RO", "IMR9_READ_POL_31", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{30, 30, 0x0000000000000000, "RW", "IMR9_READ_POL_30", "Bunit IMR9 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR9 region based on the agents 6bit encoded SAI value."},
#else
{30, 30, 0x0000000000000000, "RW", "IMR9_READ_POL_30", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{29, 29, 0x0000000000000000, "RW", "IMR9_READ_POL_29", "Bunit IMR9 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR9 region based on the agents 6bit encoded SAI value."},
#else
{29, 29, 0x0000000000000000, "RW", "IMR9_READ_POL_29", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{28, 28, 0x0000000000000000, "RW", "IMR9_READ_POL_28", "Bunit IMR9 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR9 region based on the agents 6bit encoded SAI value."},
#else
{28, 28, 0x0000000000000000, "RW", "IMR9_READ_POL_28", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{27, 27, 0x0000000000000000, "RW", "IMR9_READ_POL_27", "Bunit IMR9 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR9 region based on the agents 6bit encoded SAI value."},
#else
{27, 27, 0x0000000000000000, "RW", "IMR9_READ_POL_27", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{26, 26, 0x0000000000000000, "RW", "IMR9_READ_POL_26", "Bunit IMR9 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR9 region based on the agents 6bit encoded SAI value."},
#else
{26, 26, 0x0000000000000000, "RW", "IMR9_READ_POL_26", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{25, 25, 0x0000000000000000, "RW", "IMR9_READ_POL_25", "Bunit IMR9 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR9 region based on the agents 6bit encoded SAI value."},
#else
{25, 25, 0x0000000000000000, "RW", "IMR9_READ_POL_25", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{24, 24, 0x0000000000000000, "RW", "IMR9_READ_POL_24", "Bunit IMR9 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR9 region based on the agents 6bit encoded SAI value."},
#else
{24, 24, 0x0000000000000000, "RW", "IMR9_READ_POL_24", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{23, 23, 0x0000000000000000, "RO", "IMR9_READ_POL_23", "Bunit IMR9 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR9 region based on the agents 6bit encoded SAI value."},
#else
{23, 23, 0x0000000000000000, "RO", "IMR9_READ_POL_23", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{22, 22, 0x0000000000000000, "RO", "IMR9_READ_POL_22", "Bunit IMR9 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR9 region based on the agents 6bit encoded SAI value."},
#else
{22, 22, 0x0000000000000000, "RO", "IMR9_READ_POL_22", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{21, 21, 0x0000000000000000, "RW", "IMR9_READ_POL_21", "Bunit IMR9 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR9 region based on the agents 6bit encoded SAI value."},
#else
{21, 21, 0x0000000000000000, "RW", "IMR9_READ_POL_21", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{20, 20, 0x0000000000000000, "RO", "IMR9_READ_POL_20", "Bunit IMR9 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR9 region based on the agents 6bit encoded SAI value."},
#else
{20, 20, 0x0000000000000000, "RO", "IMR9_READ_POL_20", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{19, 19, 0x0000000000000000, "RO", "IMR9_READ_POL_19", "Bunit IMR9 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR9 region based on the agents 6bit encoded SAI value."},
#else
{19, 19, 0x0000000000000000, "RO", "IMR9_READ_POL_19", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{18, 18, 0x0000000000000000, "RO", "IMR9_READ_POL_18", "Bunit IMR9 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR9 region based on the agents 6bit encoded SAI value."},
#else
{18, 18, 0x0000000000000000, "RO", "IMR9_READ_POL_18", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{17, 17, 0x0000000000000000, "RW", "IMR9_READ_POL_17", "Bunit IMR9 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR9 region based on the agents 6bit encoded SAI value."},
#else
{17, 17, 0x0000000000000000, "RW", "IMR9_READ_POL_17", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{16, 16, 0x0000000000000000, "RW", "IMR9_READ_POL_16", "Bunit IMR9 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR9 region based on the agents 6bit encoded SAI value."},
#else
{16, 16, 0x0000000000000000, "RW", "IMR9_READ_POL_16", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{15, 15, 0x0000000000000000, "RO", "IMR9_READ_POL_15", "Bunit IMR9 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR9 region based on the agents 6bit encoded SAI value."},
#else
{15, 15, 0x0000000000000000, "RO", "IMR9_READ_POL_15", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{14, 14, 0x0000000000000000, "RO", "IMR9_READ_POL_14", "Bunit IMR9 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR9 region based on the agents 6bit encoded SAI value."},
#else
{14, 14, 0x0000000000000000, "RO", "IMR9_READ_POL_14", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{13, 13, 0x0000000000000000, "RW", "IMR9_READ_POL_13", "Bunit IMR9 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR9 region based on the agents 6bit encoded SAI value."},
#else
{13, 13, 0x0000000000000000, "RW", "IMR9_READ_POL_13", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{12, 12, 0x0000000000000000, "RW", "IMR9_READ_POL_12", "Bunit IMR9 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR9 region based on the agents 6bit encoded SAI value."},
#else
{12, 12, 0x0000000000000000, "RW", "IMR9_READ_POL_12", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{11, 11, 0x0000000000000000, "RO", "IMR9_READ_POL_11", "Bunit IMR9 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR9 region based on the agents 6bit encoded SAI value."},
#else
{11, 11, 0x0000000000000000, "RO", "IMR9_READ_POL_11", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{10, 10, 0x0000000000000000, "RO", "IMR9_READ_POL_10", "Bunit IMR9 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR9 region based on the agents 6bit encoded SAI value."},
#else
{10, 10, 0x0000000000000000, "RO", "IMR9_READ_POL_10", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{9, 9, 0x0000000000000000, "RO", "IMR9_READ_POL_9", "Bunit IMR9 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR9 region based on the agents 6bit encoded SAI value."},
#else
{9, 9, 0x0000000000000000, "RO", "IMR9_READ_POL_9", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{8, 8, 0x0000000000000000, "RW", "IMR9_READ_POL_8", "Bunit IMR9 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR9 region based on the agents 6bit encoded SAI value."},
#else
{8, 8, 0x0000000000000000, "RW", "IMR9_READ_POL_8", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{7, 7, 0x0000000000000000, "RO", "IMR9_READ_POL_7", "Bunit IMR9 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR9 region based on the agents 6bit encoded SAI value."},
#else
{7, 7, 0x0000000000000000, "RO", "IMR9_READ_POL_7", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{6, 6, 0x0000000000000000, "RO", "IMR9_READ_POL_6", "Bunit IMR9 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR9 region based on the agents 6bit encoded SAI value."},
#else
{6, 6, 0x0000000000000000, "RO", "IMR9_READ_POL_6", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{5, 5, 0x0000000000000000, "RW", "IMR9_READ_POL_5", "Bunit IMR9 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR9 region based on the agents 6bit encoded SAI value."},
#else
{5, 5, 0x0000000000000000, "RW", "IMR9_READ_POL_5", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{4, 4, 0x0000000000000000, "RW", "IMR9_READ_POL_4", "Bunit IMR9 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR9 region based on the agents 6bit encoded SAI value."},
#else
{4, 4, 0x0000000000000000, "RW", "IMR9_READ_POL_4", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{3, 3, 0x0000000000000000, "RW", "IMR9_READ_POL_3", "Bunit IMR9 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR9 region based on the agents 6bit encoded SAI value."},
#else
{3, 3, 0x0000000000000000, "RW", "IMR9_READ_POL_3", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{2, 2, 0x0000000000000000, "RW", "IMR9_READ_POL_2", "Bunit IMR9 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR9 region based on the agents 6bit encoded SAI value."},
#else
{2, 2, 0x0000000000000000, "RW", "IMR9_READ_POL_2", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{1, 1, 0x0000000000000000, "RW", "IMR9_READ_POL_1", "Bunit IMR9 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR9 region based on the agents 6bit encoded SAI value."},
#else
{1, 1, 0x0000000000000000, "RW", "IMR9_READ_POL_1", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 0, 0x0000000000000000, "RW", "IMR9_READ_POL_0", "Bunit IMR9 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR9 region based on the agents 6bit encoded SAI value."},
#else
{0, 0, 0x0000000000000000, "RW", "IMR9_READ_POL_0", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo925[] = {{"B_CR_BIMR9RAC_0_0_0_MCHBAR", "", 0x000069A0, 64, 0xFFFFFFFFFFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields926[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{63, 63, 0x0000000000000000, "RW", "IMR9_WRITE_POL_63", "Bunit IMR9 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR9 region based on the agents 6bit encoded SAI value."},
#else
{63, 63, 0x0000000000000000, "RW", "IMR9_WRITE_POL_63", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{62, 62, 0x0000000000000000, "RO", "IMR9_WRITE_POL_62", "Bunit IMR9 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR9 region based on the agents 6bit encoded SAI value."},
#else
{62, 62, 0x0000000000000000, "RO", "IMR9_WRITE_POL_62", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{61, 61, 0x0000000000000000, "RO", "IMR9_WRITE_POL_61", "Bunit IMR9 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR9 region based on the agents 6bit encoded SAI value."},
#else
{61, 61, 0x0000000000000000, "RO", "IMR9_WRITE_POL_61", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{60, 60, 0x0000000000000000, "RO", "IMR9_WRITE_POL_60", "Bunit IMR9 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR9 region based on the agents 6bit encoded SAI value."},
#else
{60, 60, 0x0000000000000000, "RO", "IMR9_WRITE_POL_60", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{59, 59, 0x0000000000000000, "RO", "IMR9_WRITE_POL_59", "Bunit IMR9 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR9 region based on the agents 6bit encoded SAI value."},
#else
{59, 59, 0x0000000000000000, "RO", "IMR9_WRITE_POL_59", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{58, 58, 0x0000000000000000, "RO", "IMR9_WRITE_POL_58", "Bunit IMR9 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR9 region based on the agents 6bit encoded SAI value."},
#else
{58, 58, 0x0000000000000000, "RO", "IMR9_WRITE_POL_58", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{57, 57, 0x0000000000000000, "RO", "IMR9_WRITE_POL_57", "Bunit IMR9 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR9 region based on the agents 6bit encoded SAI value."},
#else
{57, 57, 0x0000000000000000, "RO", "IMR9_WRITE_POL_57", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{56, 56, 0x0000000000000000, "RW", "IMR9_WRITE_POL_56", "Bunit IMR9 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR9 region based on the agents 6bit encoded SAI value."},
#else
{56, 56, 0x0000000000000000, "RW", "IMR9_WRITE_POL_56", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{55, 55, 0x0000000000000000, "RW", "IMR9_WRITE_POL_55", "Bunit IMR9 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR9 region based on the agents 6bit encoded SAI value."},
#else
{55, 55, 0x0000000000000000, "RW", "IMR9_WRITE_POL_55", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{54, 54, 0x0000000000000000, "RW", "IMR9_WRITE_POL_54", "Bunit IMR9 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR9 region based on the agents 6bit encoded SAI value."},
#else
{54, 54, 0x0000000000000000, "RW", "IMR9_WRITE_POL_54", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{53, 53, 0x0000000000000000, "RO", "IMR9_WRITE_POL_53", "Bunit IMR9 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR9 region based on the agents 6bit encoded SAI value."},
#else
{53, 53, 0x0000000000000000, "RO", "IMR9_WRITE_POL_53", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{52, 52, 0x0000000000000000, "RO", "IMR9_WRITE_POL_52", "Bunit IMR9 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR9 region based on the agents 6bit encoded SAI value."},
#else
{52, 52, 0x0000000000000000, "RO", "IMR9_WRITE_POL_52", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{51, 51, 0x0000000000000000, "RO", "IMR9_WRITE_POL_51", "Bunit IMR9 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR9 region based on the agents 6bit encoded SAI value."},
#else
{51, 51, 0x0000000000000000, "RO", "IMR9_WRITE_POL_51", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{50, 50, 0x0000000000000000, "RW", "IMR9_WRITE_POL_50", "Bunit IMR9 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR9 region based on the agents 6bit encoded SAI value."},
#else
{50, 50, 0x0000000000000000, "RW", "IMR9_WRITE_POL_50", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{49, 49, 0x0000000000000000, "RW", "IMR9_WRITE_POL_49", "Bunit IMR9 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR9 region based on the agents 6bit encoded SAI value."},
#else
{49, 49, 0x0000000000000000, "RW", "IMR9_WRITE_POL_49", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{48, 48, 0x0000000000000000, "RW", "IMR9_WRITE_POL_48", "Bunit IMR9 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR9 region based on the agents 6bit encoded SAI value."},
#else
{48, 48, 0x0000000000000000, "RW", "IMR9_WRITE_POL_48", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{47, 47, 0x0000000000000000, "RO", "IMR9_WRITE_POL_47", "Bunit IMR9 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR9 region based on the agents 6bit encoded SAI value."},
#else
{47, 47, 0x0000000000000000, "RO", "IMR9_WRITE_POL_47", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{46, 46, 0x0000000000000000, "RO", "IMR9_WRITE_POL_46", "Bunit IMR9 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR9 region based on the agents 6bit encoded SAI value."},
#else
{46, 46, 0x0000000000000000, "RO", "IMR9_WRITE_POL_46", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{45, 45, 0x0000000000000000, "RO", "IMR9_WRITE_POL_45", "Bunit IMR9 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR9 region based on the agents 6bit encoded SAI value."},
#else
{45, 45, 0x0000000000000000, "RO", "IMR9_WRITE_POL_45", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{44, 44, 0x0000000000000000, "RW", "IMR9_WRITE_POL_44", "Bunit IMR9 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR9 region based on the agents 6bit encoded SAI value."},
#else
{44, 44, 0x0000000000000000, "RW", "IMR9_WRITE_POL_44", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{43, 43, 0x0000000000000000, "RW", "IMR9_WRITE_POL_43", "Bunit IMR9 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR9 region based on the agents 6bit encoded SAI value."},
#else
{43, 43, 0x0000000000000000, "RW", "IMR9_WRITE_POL_43", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{42, 42, 0x0000000000000000, "RW", "IMR9_WRITE_POL_42", "Bunit IMR9 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR9 region based on the agents 6bit encoded SAI value."},
#else
{42, 42, 0x0000000000000000, "RW", "IMR9_WRITE_POL_42", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{41, 41, 0x0000000000000000, "RW", "IMR9_WRITE_POL_41", "Bunit IMR9 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR9 region based on the agents 6bit encoded SAI value."},
#else
{41, 41, 0x0000000000000000, "RW", "IMR9_WRITE_POL_41", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{40, 40, 0x0000000000000000, "RW", "IMR9_WRITE_POL_40", "Bunit IMR9 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR9 region based on the agents 6bit encoded SAI value."},
#else
{40, 40, 0x0000000000000000, "RW", "IMR9_WRITE_POL_40", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{39, 39, 0x0000000000000000, "RO", "IMR9_WRITE_POL_39", "Bunit IMR9 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR9 region based on the agents 6bit encoded SAI value."},
#else
{39, 39, 0x0000000000000000, "RO", "IMR9_WRITE_POL_39", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{38, 38, 0x0000000000000000, "RW", "IMR9_WRITE_POL_38", "Bunit IMR9 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR9 region based on the agents 6bit encoded SAI value."},
#else
{38, 38, 0x0000000000000000, "RW", "IMR9_WRITE_POL_38", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{37, 37, 0x0000000000000000, "RO", "IMR9_WRITE_POL_37", "Bunit IMR9 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR9 region based on the agents 6bit encoded SAI value."},
#else
{37, 37, 0x0000000000000000, "RO", "IMR9_WRITE_POL_37", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{36, 36, 0x0000000000000000, "RW", "IMR9_WRITE_POL_36", "Bunit IMR9 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR9 region based on the agents 6bit encoded SAI value."},
#else
{36, 36, 0x0000000000000000, "RW", "IMR9_WRITE_POL_36", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{35, 35, 0x0000000000000000, "RO", "IMR9_WRITE_POL_35", "Bunit IMR9 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR9 region based on the agents 6bit encoded SAI value."},
#else
{35, 35, 0x0000000000000000, "RO", "IMR9_WRITE_POL_35", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{34, 34, 0x0000000000000000, "RW", "IMR9_WRITE_POL_34", "Bunit IMR9 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR9 region based on the agents 6bit encoded SAI value."},
#else
{34, 34, 0x0000000000000000, "RW", "IMR9_WRITE_POL_34", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{33, 33, 0x0000000000000000, "RW", "IMR9_WRITE_POL_33", "Bunit IMR9 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR9 region based on the agents 6bit encoded SAI value."},
#else
{33, 33, 0x0000000000000000, "RW", "IMR9_WRITE_POL_33", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{32, 32, 0x0000000000000000, "RW", "IMR9_WRITE_POL_32", "Bunit IMR9 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR9 region based on the agents 6bit encoded SAI value."},
#else
{32, 32, 0x0000000000000000, "RW", "IMR9_WRITE_POL_32", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{31, 31, 0x0000000000000000, "RO", "IMR9_WRITE_POL_31", "Bunit IMR9 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR9 region based on the agents 6bit encoded SAI value."},
#else
{31, 31, 0x0000000000000000, "RO", "IMR9_WRITE_POL_31", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{30, 30, 0x0000000000000000, "RW", "IMR9_WRITE_POL_30", "Bunit IMR9 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR9 region based on the agents 6bit encoded SAI value."},
#else
{30, 30, 0x0000000000000000, "RW", "IMR9_WRITE_POL_30", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{29, 29, 0x0000000000000000, "RW", "IMR9_WRITE_POL_29", "Bunit IMR9 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR9 region based on the agents 6bit encoded SAI value."},
#else
{29, 29, 0x0000000000000000, "RW", "IMR9_WRITE_POL_29", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{28, 28, 0x0000000000000000, "RW", "IMR9_WRITE_POL_28", "Bunit IMR9 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR9 region based on the agents 6bit encoded SAI value."},
#else
{28, 28, 0x0000000000000000, "RW", "IMR9_WRITE_POL_28", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{27, 27, 0x0000000000000000, "RW", "IMR9_WRITE_POL_27", "Bunit IMR9 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR9 region based on the agents 6bit encoded SAI value."},
#else
{27, 27, 0x0000000000000000, "RW", "IMR9_WRITE_POL_27", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{26, 26, 0x0000000000000000, "RW", "IMR9_WRITE_POL_26", "Bunit IMR9 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR9 region based on the agents 6bit encoded SAI value."},
#else
{26, 26, 0x0000000000000000, "RW", "IMR9_WRITE_POL_26", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{25, 25, 0x0000000000000000, "RW", "IMR9_WRITE_POL_25", "Bunit IMR9 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR9 region based on the agents 6bit encoded SAI value."},
#else
{25, 25, 0x0000000000000000, "RW", "IMR9_WRITE_POL_25", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{24, 24, 0x0000000000000000, "RW", "IMR9_WRITE_POL_24", "Bunit IMR9 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR9 region based on the agents 6bit encoded SAI value."},
#else
{24, 24, 0x0000000000000000, "RW", "IMR9_WRITE_POL_24", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{23, 23, 0x0000000000000000, "RO", "IMR9_WRITE_POL_23", "Bunit IMR9 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR9 region based on the agents 6bit encoded SAI value."},
#else
{23, 23, 0x0000000000000000, "RO", "IMR9_WRITE_POL_23", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{22, 22, 0x0000000000000000, "RO", "IMR9_WRITE_POL_22", "Bunit IMR9 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR9 region based on the agents 6bit encoded SAI value."},
#else
{22, 22, 0x0000000000000000, "RO", "IMR9_WRITE_POL_22", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{21, 21, 0x0000000000000000, "RW", "IMR9_WRITE_POL_21", "Bunit IMR9 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR9 region based on the agents 6bit encoded SAI value."},
#else
{21, 21, 0x0000000000000000, "RW", "IMR9_WRITE_POL_21", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{20, 20, 0x0000000000000000, "RO", "IMR9_WRITE_POL_20", "Bunit IMR9 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR9 region based on the agents 6bit encoded SAI value."},
#else
{20, 20, 0x0000000000000000, "RO", "IMR9_WRITE_POL_20", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{19, 19, 0x0000000000000000, "RO", "IMR9_WRITE_POL_19", "Bunit IMR9 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR9 region based on the agents 6bit encoded SAI value."},
#else
{19, 19, 0x0000000000000000, "RO", "IMR9_WRITE_POL_19", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{18, 18, 0x0000000000000000, "RO", "IMR9_WRITE_POL_18", "Bunit IMR9 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR9 region based on the agents 6bit encoded SAI value."},
#else
{18, 18, 0x0000000000000000, "RO", "IMR9_WRITE_POL_18", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{17, 17, 0x0000000000000000, "RW", "IMR9_WRITE_POL_17", "Bunit IMR9 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR9 region based on the agents 6bit encoded SAI value."},
#else
{17, 17, 0x0000000000000000, "RW", "IMR9_WRITE_POL_17", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{16, 16, 0x0000000000000000, "RW", "IMR9_WRITE_POL_16", "Bunit IMR9 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR9 region based on the agents 6bit encoded SAI value."},
#else
{16, 16, 0x0000000000000000, "RW", "IMR9_WRITE_POL_16", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{15, 15, 0x0000000000000000, "RO", "IMR9_WRITE_POL_15", "Bunit IMR9 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR9 region based on the agents 6bit encoded SAI value."},
#else
{15, 15, 0x0000000000000000, "RO", "IMR9_WRITE_POL_15", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{14, 14, 0x0000000000000000, "RO", "IMR9_WRITE_POL_14", "Bunit IMR9 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR9 region based on the agents 6bit encoded SAI value."},
#else
{14, 14, 0x0000000000000000, "RO", "IMR9_WRITE_POL_14", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{13, 13, 0x0000000000000000, "RW", "IMR9_WRITE_POL_13", "Bunit IMR9 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR9 region based on the agents 6bit encoded SAI value."},
#else
{13, 13, 0x0000000000000000, "RW", "IMR9_WRITE_POL_13", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{12, 12, 0x0000000000000000, "RW", "IMR9_WRITE_POL_12", "Bunit IMR9 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR9 region based on the agents 6bit encoded SAI value."},
#else
{12, 12, 0x0000000000000000, "RW", "IMR9_WRITE_POL_12", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{11, 11, 0x0000000000000000, "RO", "IMR9_WRITE_POL_11", "Bunit IMR9 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR9 region based on the agents 6bit encoded SAI value."},
#else
{11, 11, 0x0000000000000000, "RO", "IMR9_WRITE_POL_11", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{10, 10, 0x0000000000000000, "RO", "IMR9_WRITE_POL_10", "Bunit IMR9 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR9 region based on the agents 6bit encoded SAI value."},
#else
{10, 10, 0x0000000000000000, "RO", "IMR9_WRITE_POL_10", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{9, 9, 0x0000000000000000, "RO", "IMR9_WRITE_POL_9", "Bunit IMR9 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR9 region based on the agents 6bit encoded SAI value."},
#else
{9, 9, 0x0000000000000000, "RO", "IMR9_WRITE_POL_9", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{8, 8, 0x0000000000000000, "RW", "IMR9_WRITE_POL_8", "Bunit IMR9 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR9 region based on the agents 6bit encoded SAI value."},
#else
{8, 8, 0x0000000000000000, "RW", "IMR9_WRITE_POL_8", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{7, 7, 0x0000000000000000, "RO", "IMR9_WRITE_POL_7", "Bunit IMR9 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR9 region based on the agents 6bit encoded SAI value."},
#else
{7, 7, 0x0000000000000000, "RO", "IMR9_WRITE_POL_7", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{6, 6, 0x0000000000000000, "RO", "IMR9_WRITE_POL_6", "Bunit IMR9 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR9 region based on the agents 6bit encoded SAI value."},
#else
{6, 6, 0x0000000000000000, "RO", "IMR9_WRITE_POL_6", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{5, 5, 0x0000000000000000, "RW", "IMR9_WRITE_POL_5", "Bunit IMR9 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR9 region based on the agents 6bit encoded SAI value."},
#else
{5, 5, 0x0000000000000000, "RW", "IMR9_WRITE_POL_5", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{4, 4, 0x0000000000000000, "RW", "IMR9_WRITE_POL_4", "Bunit IMR9 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR9 region based on the agents 6bit encoded SAI value."},
#else
{4, 4, 0x0000000000000000, "RW", "IMR9_WRITE_POL_4", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{3, 3, 0x0000000000000000, "RW", "IMR9_WRITE_POL_3", "Bunit IMR9 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR9 region based on the agents 6bit encoded SAI value."},
#else
{3, 3, 0x0000000000000000, "RW", "IMR9_WRITE_POL_3", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{2, 2, 0x0000000000000000, "RW", "IMR9_WRITE_POL_2", "Bunit IMR9 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR9 region based on the agents 6bit encoded SAI value."},
#else
{2, 2, 0x0000000000000000, "RW", "IMR9_WRITE_POL_2", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{1, 1, 0x0000000000000000, "RW", "IMR9_WRITE_POL_1", "Bunit IMR9 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR9 region based on the agents 6bit encoded SAI value."},
#else
{1, 1, 0x0000000000000000, "RW", "IMR9_WRITE_POL_1", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 0, 0x0000000000000000, "RW", "IMR9_WRITE_POL_0", "Bunit IMR9 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR9 region based on the agents 6bit encoded SAI value."},
#else
{0, 0, 0x0000000000000000, "RW", "IMR9_WRITE_POL_0", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo926[] = {{"B_CR_BIMR9WAC_0_0_0_MCHBAR", "", 0x000069A8, 64, 0xFFFFFFFFFFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields927[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{31, 31, 0x0000000000000000, "RW", "IMR_EN", "IMR Enable: Enables access checking for the IMR region."},
#else
{31, 31, 0x0000000000000000, "RW", "IMR_EN", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{30, 30, 0x0000000000000000, "RW", "TR_EN", "Asset Classification AC[0]: Trace Enable: Enables snooping of transactions to the IMR region by tracing agents."},
#else
{30, 30, 0x0000000000000000, "RW", "TR_EN", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{29, 29, 0x0000000000000000, "RO", "RESERVED_1", "Reserved"},
#else
{29, 29, 0x0000000000000000, "RO", "RESERVED_1", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 28, 0x0000000000000000, "RW", "IMR10_BASE", "Base 0 IMR10BASE:  Specifies bits 38:10 of the start address of IMR10 region.  IMR region size must be a strict poweroftwo at least 1KB and naturally aligned to the size.  These bits are compared with the result of the IMR10MASK[28:0] applied to bits 38:10 of the incoming address to determine if an access falls within the IMR10 defined region."},
#else
{0, 28, 0x0000000000000000, "RW", "IMR10_BASE", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo927[] = {{"B_CR_BIMR10BASE_0_0_0_MCHBAR", "", 0x000069B0, 4, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields928[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{31, 31, 0x0000000000000000, "RW", "GT_IWB_EN", "Asset Classification AC[2]: GT Implicit WB Enable: Enables implicit writebacks to protected region from GT caching agent. When set to 1 enables implicit writeback data HITM data from GT to be returned to the requester.  When set to 0 inhibits HITM data from GT from being returned to the requester.  HITM data from IA cores may be returned to the requester depending on the setting of the IA_IWB_EN bit."},
#else
{31, 31, 0x0000000000000000, "RW", "GT_IWB_EN", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{30, 30, 0x0000000000000000, "RW", "IA_IWB_EN", "Asset Classification AC[1]: IA Implicit WB Enable: Enables implicit writebacks to protected region from IA caching agent.  When set to 1 enables implicit writeback data HITM data from IA cores to be returned to the requester.  When set to 0 inhibits HITM data from IA cores from being returned to the requester.  HITM data from GT may be returned to the requester depending on the setting of the GT_IWB_EN bit."},
#else
{30, 30, 0x0000000000000000, "RW", "IA_IWB_EN", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{29, 29, 0x0000000000000000, "RO", "RESERVED_0", "Reserved"},
#else
{29, 29, 0x0000000000000000, "RO", "RESERVED_0", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 28, 0x0000000000000000, "RW", "IMR10_MASK", "Mask 0 IMR10MASK:  These bits are ANDed with bits 38:10 of the incoming address to determine if the combined result matches the IMR10BASE[28:0] value.  A match indicates the the incoming address falls within the IMR10 region."},
#else
{0, 28, 0x0000000000000000, "RW", "IMR10_MASK", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo928[] = {{"B_CR_BIMR10MASK_0_0_0_MCHBAR", "", 0x000069B4, 4, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields929[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{0, 63, 0x00000C0061010202, "RW", "IMR10_CTRL_POL", "Bunit IMR10 Control Policy: Bit vector used to determine which agents are allowed access to the BIMR10RAC, BIMR10WAC, BIMR10CP registers based on the value from the agents 6bit SAI field."},
#else
{0, 63, 0x00000C0061010202, "RW", "IMR10_CTRL_POL", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo929[] = {{"B_CR_BIMR10CP_0_0_0_MCHBAR", "", 0x000069B8, 1, 0xFFFFFFFFFFFFFFFF, 0x00000C0061010202}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields930[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{63, 63, 0x0000000000000000, "RW", "IMR10_READ_POL_63", "Bunit IMR10 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR10 region based on the agents 6bit encoded SAI value."},
#else
{63, 63, 0x0000000000000000, "RW", "IMR10_READ_POL_63", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{62, 62, 0x0000000000000000, "RO", "IMR10_READ_POL_62", "Bunit IMR10 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR10 region based on the agents 6bit encoded SAI value."},
#else
{62, 62, 0x0000000000000000, "RO", "IMR10_READ_POL_62", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{61, 61, 0x0000000000000000, "RO", "IMR10_READ_POL_61", "Bunit IMR10 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR10 region based on the agents 6bit encoded SAI value."},
#else
{61, 61, 0x0000000000000000, "RO", "IMR10_READ_POL_61", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{60, 60, 0x0000000000000000, "RO", "IMR10_READ_POL_60", "Bunit IMR10 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR10 region based on the agents 6bit encoded SAI value."},
#else
{60, 60, 0x0000000000000000, "RO", "IMR10_READ_POL_60", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{59, 59, 0x0000000000000000, "RO", "IMR10_READ_POL_59", "Bunit IMR10 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR10 region based on the agents 6bit encoded SAI value."},
#else
{59, 59, 0x0000000000000000, "RO", "IMR10_READ_POL_59", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{58, 58, 0x0000000000000000, "RO", "IMR10_READ_POL_58", "Bunit IMR10 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR10 region based on the agents 6bit encoded SAI value."},
#else
{58, 58, 0x0000000000000000, "RO", "IMR10_READ_POL_58", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{57, 57, 0x0000000000000000, "RO", "IMR10_READ_POL_57", "Bunit IMR10 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR10 region based on the agents 6bit encoded SAI value."},
#else
{57, 57, 0x0000000000000000, "RO", "IMR10_READ_POL_57", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{56, 56, 0x0000000000000000, "RW", "IMR10_READ_POL_56", "Bunit IMR10 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR10 region based on the agents 6bit encoded SAI value."},
#else
{56, 56, 0x0000000000000000, "RW", "IMR10_READ_POL_56", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{55, 55, 0x0000000000000000, "RW", "IMR10_READ_POL_55", "Bunit IMR10 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR10 region based on the agents 6bit encoded SAI value."},
#else
{55, 55, 0x0000000000000000, "RW", "IMR10_READ_POL_55", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{54, 54, 0x0000000000000000, "RW", "IMR10_READ_POL_54", "Bunit IMR10 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR10 region based on the agents 6bit encoded SAI value."},
#else
{54, 54, 0x0000000000000000, "RW", "IMR10_READ_POL_54", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{53, 53, 0x0000000000000000, "RO", "IMR10_READ_POL_53", "Bunit IMR10 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR10 region based on the agents 6bit encoded SAI value."},
#else
{53, 53, 0x0000000000000000, "RO", "IMR10_READ_POL_53", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{52, 52, 0x0000000000000000, "RO", "IMR10_READ_POL_52", "Bunit IMR10 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR10 region based on the agents 6bit encoded SAI value."},
#else
{52, 52, 0x0000000000000000, "RO", "IMR10_READ_POL_52", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{51, 51, 0x0000000000000000, "RO", "IMR10_READ_POL_51", "Bunit IMR10 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR10 region based on the agents 6bit encoded SAI value."},
#else
{51, 51, 0x0000000000000000, "RO", "IMR10_READ_POL_51", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{50, 50, 0x0000000000000000, "RW", "IMR10_READ_POL_50", "Bunit IMR10 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR10 region based on the agents 6bit encoded SAI value."},
#else
{50, 50, 0x0000000000000000, "RW", "IMR10_READ_POL_50", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{49, 49, 0x0000000000000000, "RW", "IMR10_READ_POL_49", "Bunit IMR10 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR10 region based on the agents 6bit encoded SAI value."},
#else
{49, 49, 0x0000000000000000, "RW", "IMR10_READ_POL_49", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{48, 48, 0x0000000000000000, "RW", "IMR10_READ_POL_48", "Bunit IMR10 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR10 region based on the agents 6bit encoded SAI value."},
#else
{48, 48, 0x0000000000000000, "RW", "IMR10_READ_POL_48", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{47, 47, 0x0000000000000000, "RO", "IMR10_READ_POL_47", "Bunit IMR10 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR10 region based on the agents 6bit encoded SAI value."},
#else
{47, 47, 0x0000000000000000, "RO", "IMR10_READ_POL_47", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{46, 46, 0x0000000000000000, "RO", "IMR10_READ_POL_46", "Bunit IMR10 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR10 region based on the agents 6bit encoded SAI value."},
#else
{46, 46, 0x0000000000000000, "RO", "IMR10_READ_POL_46", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{45, 45, 0x0000000000000000, "RO", "IMR10_READ_POL_45", "Bunit IMR10 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR10 region based on the agents 6bit encoded SAI value."},
#else
{45, 45, 0x0000000000000000, "RO", "IMR10_READ_POL_45", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{44, 44, 0x0000000000000000, "RW", "IMR10_READ_POL_44", "Bunit IMR10 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR10 region based on the agents 6bit encoded SAI value."},
#else
{44, 44, 0x0000000000000000, "RW", "IMR10_READ_POL_44", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{43, 43, 0x0000000000000000, "RW", "IMR10_READ_POL_43", "Bunit IMR10 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR10 region based on the agents 6bit encoded SAI value."},
#else
{43, 43, 0x0000000000000000, "RW", "IMR10_READ_POL_43", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{42, 42, 0x0000000000000000, "RW", "IMR10_READ_POL_42", "Bunit IMR10 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR10 region based on the agents 6bit encoded SAI value."},
#else
{42, 42, 0x0000000000000000, "RW", "IMR10_READ_POL_42", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{41, 41, 0x0000000000000000, "RW", "IMR10_READ_POL_41", "Bunit IMR10 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR10 region based on the agents 6bit encoded SAI value."},
#else
{41, 41, 0x0000000000000000, "RW", "IMR10_READ_POL_41", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{40, 40, 0x0000000000000000, "RW", "IMR10_READ_POL_40", "Bunit IMR10 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR10 region based on the agents 6bit encoded SAI value."},
#else
{40, 40, 0x0000000000000000, "RW", "IMR10_READ_POL_40", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{39, 39, 0x0000000000000000, "RO", "IMR10_READ_POL_39", "Bunit IMR10 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR10 region based on the agents 6bit encoded SAI value."},
#else
{39, 39, 0x0000000000000000, "RO", "IMR10_READ_POL_39", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{38, 38, 0x0000000000000000, "RW", "IMR10_READ_POL_38", "Bunit IMR10 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR10 region based on the agents 6bit encoded SAI value."},
#else
{38, 38, 0x0000000000000000, "RW", "IMR10_READ_POL_38", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{37, 37, 0x0000000000000000, "RO", "IMR10_READ_POL_37", "Bunit IMR10 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR10 region based on the agents 6bit encoded SAI value."},
#else
{37, 37, 0x0000000000000000, "RO", "IMR10_READ_POL_37", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{36, 36, 0x0000000000000000, "RW", "IMR10_READ_POL_36", "Bunit IMR10 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR10 region based on the agents 6bit encoded SAI value."},
#else
{36, 36, 0x0000000000000000, "RW", "IMR10_READ_POL_36", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{35, 35, 0x0000000000000000, "RO", "IMR10_READ_POL_35", "Bunit IMR10 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR10 region based on the agents 6bit encoded SAI value."},
#else
{35, 35, 0x0000000000000000, "RO", "IMR10_READ_POL_35", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{34, 34, 0x0000000000000000, "RW", "IMR10_READ_POL_34", "Bunit IMR10 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR10 region based on the agents 6bit encoded SAI value."},
#else
{34, 34, 0x0000000000000000, "RW", "IMR10_READ_POL_34", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{33, 33, 0x0000000000000000, "RW", "IMR10_READ_POL_33", "Bunit IMR10 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR10 region based on the agents 6bit encoded SAI value."},
#else
{33, 33, 0x0000000000000000, "RW", "IMR10_READ_POL_33", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{32, 32, 0x0000000000000000, "RW", "IMR10_READ_POL_32", "Bunit IMR10 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR10 region based on the agents 6bit encoded SAI value."},
#else
{32, 32, 0x0000000000000000, "RW", "IMR10_READ_POL_32", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{31, 31, 0x0000000000000000, "RO", "IMR10_READ_POL_31", "Bunit IMR10 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR10 region based on the agents 6bit encoded SAI value."},
#else
{31, 31, 0x0000000000000000, "RO", "IMR10_READ_POL_31", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{30, 30, 0x0000000000000000, "RW", "IMR10_READ_POL_30", "Bunit IMR10 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR10 region based on the agents 6bit encoded SAI value."},
#else
{30, 30, 0x0000000000000000, "RW", "IMR10_READ_POL_30", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{29, 29, 0x0000000000000000, "RW", "IMR10_READ_POL_29", "Bunit IMR10 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR10 region based on the agents 6bit encoded SAI value."},
#else
{29, 29, 0x0000000000000000, "RW", "IMR10_READ_POL_29", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{28, 28, 0x0000000000000000, "RW", "IMR10_READ_POL_28", "Bunit IMR10 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR10 region based on the agents 6bit encoded SAI value."},
#else
{28, 28, 0x0000000000000000, "RW", "IMR10_READ_POL_28", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{27, 27, 0x0000000000000000, "RW", "IMR10_READ_POL_27", "Bunit IMR10 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR10 region based on the agents 6bit encoded SAI value."},
#else
{27, 27, 0x0000000000000000, "RW", "IMR10_READ_POL_27", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{26, 26, 0x0000000000000000, "RW", "IMR10_READ_POL_26", "Bunit IMR10 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR10 region based on the agents 6bit encoded SAI value."},
#else
{26, 26, 0x0000000000000000, "RW", "IMR10_READ_POL_26", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{25, 25, 0x0000000000000000, "RW", "IMR10_READ_POL_25", "Bunit IMR10 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR10 region based on the agents 6bit encoded SAI value."},
#else
{25, 25, 0x0000000000000000, "RW", "IMR10_READ_POL_25", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{24, 24, 0x0000000000000000, "RW", "IMR10_READ_POL_24", "Bunit IMR10 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR10 region based on the agents 6bit encoded SAI value."},
#else
{24, 24, 0x0000000000000000, "RW", "IMR10_READ_POL_24", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{23, 23, 0x0000000000000000, "RO", "IMR10_READ_POL_23", "Bunit IMR10 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR10 region based on the agents 6bit encoded SAI value."},
#else
{23, 23, 0x0000000000000000, "RO", "IMR10_READ_POL_23", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{22, 22, 0x0000000000000000, "RO", "IMR10_READ_POL_22", "Bunit IMR10 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR10 region based on the agents 6bit encoded SAI value."},
#else
{22, 22, 0x0000000000000000, "RO", "IMR10_READ_POL_22", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{21, 21, 0x0000000000000000, "RW", "IMR10_READ_POL_21", "Bunit IMR10 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR10 region based on the agents 6bit encoded SAI value."},
#else
{21, 21, 0x0000000000000000, "RW", "IMR10_READ_POL_21", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{20, 20, 0x0000000000000000, "RO", "IMR10_READ_POL_20", "Bunit IMR10 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR10 region based on the agents 6bit encoded SAI value."},
#else
{20, 20, 0x0000000000000000, "RO", "IMR10_READ_POL_20", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{19, 19, 0x0000000000000000, "RO", "IMR10_READ_POL_19", "Bunit IMR10 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR10 region based on the agents 6bit encoded SAI value."},
#else
{19, 19, 0x0000000000000000, "RO", "IMR10_READ_POL_19", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{18, 18, 0x0000000000000000, "RO", "IMR10_READ_POL_18", "Bunit IMR10 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR10 region based on the agents 6bit encoded SAI value."},
#else
{18, 18, 0x0000000000000000, "RO", "IMR10_READ_POL_18", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{17, 17, 0x0000000000000000, "RW", "IMR10_READ_POL_17", "Bunit IMR10 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR10 region based on the agents 6bit encoded SAI value."},
#else
{17, 17, 0x0000000000000000, "RW", "IMR10_READ_POL_17", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{16, 16, 0x0000000000000000, "RW", "IMR10_READ_POL_16", "Bunit IMR10 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR10 region based on the agents 6bit encoded SAI value."},
#else
{16, 16, 0x0000000000000000, "RW", "IMR10_READ_POL_16", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{15, 15, 0x0000000000000000, "RO", "IMR10_READ_POL_15", "Bunit IMR10 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR10 region based on the agents 6bit encoded SAI value."},
#else
{15, 15, 0x0000000000000000, "RO", "IMR10_READ_POL_15", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{14, 14, 0x0000000000000000, "RO", "IMR10_READ_POL_14", "Bunit IMR10 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR10 region based on the agents 6bit encoded SAI value."},
#else
{14, 14, 0x0000000000000000, "RO", "IMR10_READ_POL_14", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{13, 13, 0x0000000000000000, "RW", "IMR10_READ_POL_13", "Bunit IMR10 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR10 region based on the agents 6bit encoded SAI value."},
#else
{13, 13, 0x0000000000000000, "RW", "IMR10_READ_POL_13", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{12, 12, 0x0000000000000000, "RW", "IMR10_READ_POL_12", "Bunit IMR10 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR10 region based on the agents 6bit encoded SAI value."},
#else
{12, 12, 0x0000000000000000, "RW", "IMR10_READ_POL_12", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{11, 11, 0x0000000000000000, "RO", "IMR10_READ_POL_11", "Bunit IMR10 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR10 region based on the agents 6bit encoded SAI value."},
#else
{11, 11, 0x0000000000000000, "RO", "IMR10_READ_POL_11", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{10, 10, 0x0000000000000000, "RO", "IMR10_READ_POL_10", "Bunit IMR10 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR10 region based on the agents 6bit encoded SAI value."},
#else
{10, 10, 0x0000000000000000, "RO", "IMR10_READ_POL_10", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{9, 9, 0x0000000000000000, "RO", "IMR10_READ_POL_9", "Bunit IMR10 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR10 region based on the agents 6bit encoded SAI value."},
#else
{9, 9, 0x0000000000000000, "RO", "IMR10_READ_POL_9", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{8, 8, 0x0000000000000000, "RW", "IMR10_READ_POL_8", "Bunit IMR10 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR10 region based on the agents 6bit encoded SAI value."},
#else
{8, 8, 0x0000000000000000, "RW", "IMR10_READ_POL_8", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{7, 7, 0x0000000000000000, "RO", "IMR10_READ_POL_7", "Bunit IMR10 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR10 region based on the agents 6bit encoded SAI value."},
#else
{7, 7, 0x0000000000000000, "RO", "IMR10_READ_POL_7", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{6, 6, 0x0000000000000000, "RO", "IMR10_READ_POL_6", "Bunit IMR10 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR10 region based on the agents 6bit encoded SAI value."},
#else
{6, 6, 0x0000000000000000, "RO", "IMR10_READ_POL_6", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{5, 5, 0x0000000000000000, "RW", "IMR10_READ_POL_5", "Bunit IMR10 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR10 region based on the agents 6bit encoded SAI value."},
#else
{5, 5, 0x0000000000000000, "RW", "IMR10_READ_POL_5", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{4, 4, 0x0000000000000000, "RW", "IMR10_READ_POL_4", "Bunit IMR10 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR10 region based on the agents 6bit encoded SAI value."},
#else
{4, 4, 0x0000000000000000, "RW", "IMR10_READ_POL_4", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{3, 3, 0x0000000000000000, "RW", "IMR10_READ_POL_3", "Bunit IMR10 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR10 region based on the agents 6bit encoded SAI value."},
#else
{3, 3, 0x0000000000000000, "RW", "IMR10_READ_POL_3", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{2, 2, 0x0000000000000000, "RW", "IMR10_READ_POL_2", "Bunit IMR10 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR10 region based on the agents 6bit encoded SAI value."},
#else
{2, 2, 0x0000000000000000, "RW", "IMR10_READ_POL_2", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{1, 1, 0x0000000000000000, "RW", "IMR10_READ_POL_1", "Bunit IMR10 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR10 region based on the agents 6bit encoded SAI value."},
#else
{1, 1, 0x0000000000000000, "RW", "IMR10_READ_POL_1", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 0, 0x0000000000000000, "RW", "IMR10_READ_POL_0", "Bunit IMR10 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR10 region based on the agents 6bit encoded SAI value."},
#else
{0, 0, 0x0000000000000000, "RW", "IMR10_READ_POL_0", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo930[] = {{"B_CR_BIMR10RAC_0_0_0_MCHBAR", "", 0x000069C0, 64, 0xFFFFFFFFFFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields931[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{63, 63, 0x0000000000000000, "RW", "IMR10_WRITE_POL_63", "Bunit IMR10 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR10 region based on the agents 6bit encoded SAI value."},
#else
{63, 63, 0x0000000000000000, "RW", "IMR10_WRITE_POL_63", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{62, 62, 0x0000000000000000, "RO", "IMR10_WRITE_POL_62", "Bunit IMR10 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR10 region based on the agents 6bit encoded SAI value."},
#else
{62, 62, 0x0000000000000000, "RO", "IMR10_WRITE_POL_62", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{61, 61, 0x0000000000000000, "RO", "IMR10_WRITE_POL_61", "Bunit IMR10 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR10 region based on the agents 6bit encoded SAI value."},
#else
{61, 61, 0x0000000000000000, "RO", "IMR10_WRITE_POL_61", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{60, 60, 0x0000000000000000, "RO", "IMR10_WRITE_POL_60", "Bunit IMR10 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR10 region based on the agents 6bit encoded SAI value."},
#else
{60, 60, 0x0000000000000000, "RO", "IMR10_WRITE_POL_60", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{59, 59, 0x0000000000000000, "RO", "IMR10_WRITE_POL_59", "Bunit IMR10 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR10 region based on the agents 6bit encoded SAI value."},
#else
{59, 59, 0x0000000000000000, "RO", "IMR10_WRITE_POL_59", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{58, 58, 0x0000000000000000, "RO", "IMR10_WRITE_POL_58", "Bunit IMR10 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR10 region based on the agents 6bit encoded SAI value."},
#else
{58, 58, 0x0000000000000000, "RO", "IMR10_WRITE_POL_58", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{57, 57, 0x0000000000000000, "RO", "IMR10_WRITE_POL_57", "Bunit IMR10 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR10 region based on the agents 6bit encoded SAI value."},
#else
{57, 57, 0x0000000000000000, "RO", "IMR10_WRITE_POL_57", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{56, 56, 0x0000000000000000, "RW", "IMR10_WRITE_POL_56", "Bunit IMR10 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR10 region based on the agents 6bit encoded SAI value."},
#else
{56, 56, 0x0000000000000000, "RW", "IMR10_WRITE_POL_56", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{55, 55, 0x0000000000000000, "RW", "IMR10_WRITE_POL_55", "Bunit IMR10 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR10 region based on the agents 6bit encoded SAI value."},
#else
{55, 55, 0x0000000000000000, "RW", "IMR10_WRITE_POL_55", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{54, 54, 0x0000000000000000, "RW", "IMR10_WRITE_POL_54", "Bunit IMR10 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR10 region based on the agents 6bit encoded SAI value."},
#else
{54, 54, 0x0000000000000000, "RW", "IMR10_WRITE_POL_54", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{53, 53, 0x0000000000000000, "RO", "IMR10_WRITE_POL_53", "Bunit IMR10 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR10 region based on the agents 6bit encoded SAI value."},
#else
{53, 53, 0x0000000000000000, "RO", "IMR10_WRITE_POL_53", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{52, 52, 0x0000000000000000, "RO", "IMR10_WRITE_POL_52", "Bunit IMR10 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR10 region based on the agents 6bit encoded SAI value."},
#else
{52, 52, 0x0000000000000000, "RO", "IMR10_WRITE_POL_52", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{51, 51, 0x0000000000000000, "RO", "IMR10_WRITE_POL_51", "Bunit IMR10 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR10 region based on the agents 6bit encoded SAI value."},
#else
{51, 51, 0x0000000000000000, "RO", "IMR10_WRITE_POL_51", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{50, 50, 0x0000000000000000, "RW", "IMR10_WRITE_POL_50", "Bunit IMR10 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR10 region based on the agents 6bit encoded SAI value."},
#else
{50, 50, 0x0000000000000000, "RW", "IMR10_WRITE_POL_50", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{49, 49, 0x0000000000000000, "RW", "IMR10_WRITE_POL_49", "Bunit IMR10 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR10 region based on the agents 6bit encoded SAI value."},
#else
{49, 49, 0x0000000000000000, "RW", "IMR10_WRITE_POL_49", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{48, 48, 0x0000000000000000, "RW", "IMR10_WRITE_POL_48", "Bunit IMR10 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR10 region based on the agents 6bit encoded SAI value."},
#else
{48, 48, 0x0000000000000000, "RW", "IMR10_WRITE_POL_48", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{47, 47, 0x0000000000000000, "RO", "IMR10_WRITE_POL_47", "Bunit IMR10 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR10 region based on the agents 6bit encoded SAI value."},
#else
{47, 47, 0x0000000000000000, "RO", "IMR10_WRITE_POL_47", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{46, 46, 0x0000000000000000, "RO", "IMR10_WRITE_POL_46", "Bunit IMR10 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR10 region based on the agents 6bit encoded SAI value."},
#else
{46, 46, 0x0000000000000000, "RO", "IMR10_WRITE_POL_46", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{45, 45, 0x0000000000000000, "RO", "IMR10_WRITE_POL_45", "Bunit IMR10 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR10 region based on the agents 6bit encoded SAI value."},
#else
{45, 45, 0x0000000000000000, "RO", "IMR10_WRITE_POL_45", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{44, 44, 0x0000000000000000, "RW", "IMR10_WRITE_POL_44", "Bunit IMR10 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR10 region based on the agents 6bit encoded SAI value."},
#else
{44, 44, 0x0000000000000000, "RW", "IMR10_WRITE_POL_44", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{43, 43, 0x0000000000000000, "RW", "IMR10_WRITE_POL_43", "Bunit IMR10 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR10 region based on the agents 6bit encoded SAI value."},
#else
{43, 43, 0x0000000000000000, "RW", "IMR10_WRITE_POL_43", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{42, 42, 0x0000000000000000, "RW", "IMR10_WRITE_POL_42", "Bunit IMR10 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR10 region based on the agents 6bit encoded SAI value."},
#else
{42, 42, 0x0000000000000000, "RW", "IMR10_WRITE_POL_42", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{41, 41, 0x0000000000000000, "RW", "IMR10_WRITE_POL_41", "Bunit IMR10 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR10 region based on the agents 6bit encoded SAI value."},
#else
{41, 41, 0x0000000000000000, "RW", "IMR10_WRITE_POL_41", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{40, 40, 0x0000000000000000, "RW", "IMR10_WRITE_POL_40", "Bunit IMR10 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR10 region based on the agents 6bit encoded SAI value."},
#else
{40, 40, 0x0000000000000000, "RW", "IMR10_WRITE_POL_40", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{39, 39, 0x0000000000000000, "RO", "IMR10_WRITE_POL_39", "Bunit IMR10 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR10 region based on the agents 6bit encoded SAI value."},
#else
{39, 39, 0x0000000000000000, "RO", "IMR10_WRITE_POL_39", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{38, 38, 0x0000000000000000, "RW", "IMR10_WRITE_POL_38", "Bunit IMR10 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR10 region based on the agents 6bit encoded SAI value."},
#else
{38, 38, 0x0000000000000000, "RW", "IMR10_WRITE_POL_38", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{37, 37, 0x0000000000000000, "RO", "IMR10_WRITE_POL_37", "Bunit IMR10 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR10 region based on the agents 6bit encoded SAI value."},
#else
{37, 37, 0x0000000000000000, "RO", "IMR10_WRITE_POL_37", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{36, 36, 0x0000000000000000, "RW", "IMR10_WRITE_POL_36", "Bunit IMR10 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR10 region based on the agents 6bit encoded SAI value."},
#else
{36, 36, 0x0000000000000000, "RW", "IMR10_WRITE_POL_36", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{35, 35, 0x0000000000000000, "RO", "IMR10_WRITE_POL_35", "Bunit IMR10 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR10 region based on the agents 6bit encoded SAI value."},
#else
{35, 35, 0x0000000000000000, "RO", "IMR10_WRITE_POL_35", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{34, 34, 0x0000000000000000, "RW", "IMR10_WRITE_POL_34", "Bunit IMR10 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR10 region based on the agents 6bit encoded SAI value."},
#else
{34, 34, 0x0000000000000000, "RW", "IMR10_WRITE_POL_34", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{33, 33, 0x0000000000000000, "RW", "IMR10_WRITE_POL_33", "Bunit IMR10 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR10 region based on the agents 6bit encoded SAI value."},
#else
{33, 33, 0x0000000000000000, "RW", "IMR10_WRITE_POL_33", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{32, 32, 0x0000000000000000, "RW", "IMR10_WRITE_POL_32", "Bunit IMR10 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR10 region based on the agents 6bit encoded SAI value."},
#else
{32, 32, 0x0000000000000000, "RW", "IMR10_WRITE_POL_32", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{31, 31, 0x0000000000000000, "RO", "IMR10_WRITE_POL_31", "Bunit IMR10 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR10 region based on the agents 6bit encoded SAI value."},
#else
{31, 31, 0x0000000000000000, "RO", "IMR10_WRITE_POL_31", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{30, 30, 0x0000000000000000, "RW", "IMR10_WRITE_POL_30", "Bunit IMR10 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR10 region based on the agents 6bit encoded SAI value."},
#else
{30, 30, 0x0000000000000000, "RW", "IMR10_WRITE_POL_30", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{29, 29, 0x0000000000000000, "RW", "IMR10_WRITE_POL_29", "Bunit IMR10 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR10 region based on the agents 6bit encoded SAI value."},
#else
{29, 29, 0x0000000000000000, "RW", "IMR10_WRITE_POL_29", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{28, 28, 0x0000000000000000, "RW", "IMR10_WRITE_POL_28", "Bunit IMR10 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR10 region based on the agents 6bit encoded SAI value."},
#else
{28, 28, 0x0000000000000000, "RW", "IMR10_WRITE_POL_28", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{27, 27, 0x0000000000000000, "RW", "IMR10_WRITE_POL_27", "Bunit IMR10 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR10 region based on the agents 6bit encoded SAI value."},
#else
{27, 27, 0x0000000000000000, "RW", "IMR10_WRITE_POL_27", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{26, 26, 0x0000000000000000, "RW", "IMR10_WRITE_POL_26", "Bunit IMR10 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR10 region based on the agents 6bit encoded SAI value."},
#else
{26, 26, 0x0000000000000000, "RW", "IMR10_WRITE_POL_26", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{25, 25, 0x0000000000000000, "RW", "IMR10_WRITE_POL_25", "Bunit IMR10 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR10 region based on the agents 6bit encoded SAI value."},
#else
{25, 25, 0x0000000000000000, "RW", "IMR10_WRITE_POL_25", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{24, 24, 0x0000000000000000, "RW", "IMR10_WRITE_POL_24", "Bunit IMR10 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR10 region based on the agents 6bit encoded SAI value."},
#else
{24, 24, 0x0000000000000000, "RW", "IMR10_WRITE_POL_24", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{23, 23, 0x0000000000000000, "RO", "IMR10_WRITE_POL_23", "Bunit IMR10 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR10 region based on the agents 6bit encoded SAI value."},
#else
{23, 23, 0x0000000000000000, "RO", "IMR10_WRITE_POL_23", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{22, 22, 0x0000000000000000, "RO", "IMR10_WRITE_POL_22", "Bunit IMR10 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR10 region based on the agents 6bit encoded SAI value."},
#else
{22, 22, 0x0000000000000000, "RO", "IMR10_WRITE_POL_22", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{21, 21, 0x0000000000000000, "RW", "IMR10_WRITE_POL_21", "Bunit IMR10 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR10 region based on the agents 6bit encoded SAI value."},
#else
{21, 21, 0x0000000000000000, "RW", "IMR10_WRITE_POL_21", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{20, 20, 0x0000000000000000, "RO", "IMR10_WRITE_POL_20", "Bunit IMR10 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR10 region based on the agents 6bit encoded SAI value."},
#else
{20, 20, 0x0000000000000000, "RO", "IMR10_WRITE_POL_20", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{19, 19, 0x0000000000000000, "RO", "IMR10_WRITE_POL_19", "Bunit IMR10 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR10 region based on the agents 6bit encoded SAI value."},
#else
{19, 19, 0x0000000000000000, "RO", "IMR10_WRITE_POL_19", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{18, 18, 0x0000000000000000, "RO", "IMR10_WRITE_POL_18", "Bunit IMR10 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR10 region based on the agents 6bit encoded SAI value."},
#else
{18, 18, 0x0000000000000000, "RO", "IMR10_WRITE_POL_18", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{17, 17, 0x0000000000000000, "RW", "IMR10_WRITE_POL_17", "Bunit IMR10 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR10 region based on the agents 6bit encoded SAI value."},
#else
{17, 17, 0x0000000000000000, "RW", "IMR10_WRITE_POL_17", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{16, 16, 0x0000000000000000, "RW", "IMR10_WRITE_POL_16", "Bunit IMR10 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR10 region based on the agents 6bit encoded SAI value."},
#else
{16, 16, 0x0000000000000000, "RW", "IMR10_WRITE_POL_16", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{15, 15, 0x0000000000000000, "RO", "IMR10_WRITE_POL_15", "Bunit IMR10 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR10 region based on the agents 6bit encoded SAI value."},
#else
{15, 15, 0x0000000000000000, "RO", "IMR10_WRITE_POL_15", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{14, 14, 0x0000000000000000, "RO", "IMR10_WRITE_POL_14", "Bunit IMR10 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR10 region based on the agents 6bit encoded SAI value."},
#else
{14, 14, 0x0000000000000000, "RO", "IMR10_WRITE_POL_14", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{13, 13, 0x0000000000000000, "RW", "IMR10_WRITE_POL_13", "Bunit IMR10 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR10 region based on the agents 6bit encoded SAI value."},
#else
{13, 13, 0x0000000000000000, "RW", "IMR10_WRITE_POL_13", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{12, 12, 0x0000000000000000, "RW", "IMR10_WRITE_POL_12", "Bunit IMR10 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR10 region based on the agents 6bit encoded SAI value."},
#else
{12, 12, 0x0000000000000000, "RW", "IMR10_WRITE_POL_12", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{11, 11, 0x0000000000000000, "RO", "IMR10_WRITE_POL_11", "Bunit IMR10 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR10 region based on the agents 6bit encoded SAI value."},
#else
{11, 11, 0x0000000000000000, "RO", "IMR10_WRITE_POL_11", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{10, 10, 0x0000000000000000, "RO", "IMR10_WRITE_POL_10", "Bunit IMR10 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR10 region based on the agents 6bit encoded SAI value."},
#else
{10, 10, 0x0000000000000000, "RO", "IMR10_WRITE_POL_10", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{9, 9, 0x0000000000000000, "RO", "IMR10_WRITE_POL_9", "Bunit IMR10 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR10 region based on the agents 6bit encoded SAI value."},
#else
{9, 9, 0x0000000000000000, "RO", "IMR10_WRITE_POL_9", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{8, 8, 0x0000000000000000, "RW", "IMR10_WRITE_POL_8", "Bunit IMR10 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR10 region based on the agents 6bit encoded SAI value."},
#else
{8, 8, 0x0000000000000000, "RW", "IMR10_WRITE_POL_8", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{7, 7, 0x0000000000000000, "RO", "IMR10_WRITE_POL_7", "Bunit IMR10 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR10 region based on the agents 6bit encoded SAI value."},
#else
{7, 7, 0x0000000000000000, "RO", "IMR10_WRITE_POL_7", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{6, 6, 0x0000000000000000, "RO", "IMR10_WRITE_POL_6", "Bunit IMR10 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR10 region based on the agents 6bit encoded SAI value."},
#else
{6, 6, 0x0000000000000000, "RO", "IMR10_WRITE_POL_6", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{5, 5, 0x0000000000000000, "RW", "IMR10_WRITE_POL_5", "Bunit IMR10 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR10 region based on the agents 6bit encoded SAI value."},
#else
{5, 5, 0x0000000000000000, "RW", "IMR10_WRITE_POL_5", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{4, 4, 0x0000000000000000, "RW", "IMR10_WRITE_POL_4", "Bunit IMR10 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR10 region based on the agents 6bit encoded SAI value."},
#else
{4, 4, 0x0000000000000000, "RW", "IMR10_WRITE_POL_4", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{3, 3, 0x0000000000000000, "RW", "IMR10_WRITE_POL_3", "Bunit IMR10 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR10 region based on the agents 6bit encoded SAI value."},
#else
{3, 3, 0x0000000000000000, "RW", "IMR10_WRITE_POL_3", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{2, 2, 0x0000000000000000, "RW", "IMR10_WRITE_POL_2", "Bunit IMR10 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR10 region based on the agents 6bit encoded SAI value."},
#else
{2, 2, 0x0000000000000000, "RW", "IMR10_WRITE_POL_2", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{1, 1, 0x0000000000000000, "RW", "IMR10_WRITE_POL_1", "Bunit IMR10 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR10 region based on the agents 6bit encoded SAI value."},
#else
{1, 1, 0x0000000000000000, "RW", "IMR10_WRITE_POL_1", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 0, 0x0000000000000000, "RW", "IMR10_WRITE_POL_0", "Bunit IMR10 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR10 region based on the agents 6bit encoded SAI value."},
#else
{0, 0, 0x0000000000000000, "RW", "IMR10_WRITE_POL_0", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo931[] = {{"B_CR_BIMR10WAC_0_0_0_MCHBAR", "", 0x000069C8, 64, 0xFFFFFFFFFFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields932[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{31, 31, 0x0000000000000000, "RW", "IMR_EN", "IMR Enable: Enables access checking for the IMR region."},
#else
{31, 31, 0x0000000000000000, "RW", "IMR_EN", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{30, 30, 0x0000000000000000, "RW", "TR_EN", "Asset Classification AC[0]: Trace Enable: Enables snooping of transactions to the IMR region by tracing agents."},
#else
{30, 30, 0x0000000000000000, "RW", "TR_EN", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{29, 29, 0x0000000000000000, "RO", "RESERVED_1", "Reserved"},
#else
{29, 29, 0x0000000000000000, "RO", "RESERVED_1", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 28, 0x0000000000000000, "RW", "IMR11_BASE", "Base 0 IMR11BASE:  Specifies bits 38:10 of the start address of IMR11 region.  IMR region size must be a strict poweroftwo at least 1KB and naturally aligned to the size.  These bits are compared with the result of the IMR11MASK[28:0] applied to bits 38:10 of the incoming address to determine if an access falls within the IMR11 defined region."},
#else
{0, 28, 0x0000000000000000, "RW", "IMR11_BASE", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo932[] = {{"B_CR_BIMR11BASE_0_0_0_MCHBAR", "", 0x000069D0, 4, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields933[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{31, 31, 0x0000000000000000, "RW", "GT_IWB_EN", "Asset Classification AC[2]: GT Implicit WB Enable: Enables implicit writebacks to protected region from GT caching agent. When set to 1 enables implicit writeback data HITM data from GT to be returned to the requester.  When set to 0 inhibits HITM data from GT from being returned to the requester.  HITM data from IA cores may be returned to the requester depending on the setting of the IA_IWB_EN bit."},
#else
{31, 31, 0x0000000000000000, "RW", "GT_IWB_EN", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{30, 30, 0x0000000000000000, "RW", "IA_IWB_EN", "Asset Classification AC[1]: IA Implicit WB Enable: Enables implicit writebacks to protected region from IA caching agent.  When set to 1 enables implicit writeback data HITM data from IA cores to be returned to the requester.  When set to 0 inhibits HITM data from IA cores from being returned to the requester.  HITM data from GT may be returned to the requester depending on the setting of the GT_IWB_EN bit."},
#else
{30, 30, 0x0000000000000000, "RW", "IA_IWB_EN", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{29, 29, 0x0000000000000000, "RO", "RESERVED_0", "Reserved"},
#else
{29, 29, 0x0000000000000000, "RO", "RESERVED_0", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 28, 0x0000000000000000, "RW", "IMR11_MASK", "Mask 0 IMR11MASK:  These bits are ANDed with bits 38:10 of the incoming address to determine if the combined result matches the IMR11BASE[28:0] value.  A match indicates the the incoming address falls within the IMR11 region."},
#else
{0, 28, 0x0000000000000000, "RW", "IMR11_MASK", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo933[] = {{"B_CR_BIMR11MASK_0_0_0_MCHBAR", "", 0x000069D4, 4, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields934[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{0, 63, 0x00000C0061010202, "RW", "IMR11_CTRL_POL", "Bunit IMR11 Control Policy: Bit vector used to determine which agents are allowed access to the BIMR11RAC, BIMR11WAC, BIMR11CP registers based on the value from the agents 6bit SAI field."},
#else
{0, 63, 0x00000C0061010202, "RW", "IMR11_CTRL_POL", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo934[] = {{"B_CR_BIMR11CP_0_0_0_MCHBAR", "", 0x000069D8, 1, 0xFFFFFFFFFFFFFFFF, 0x00000C0061010202}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields935[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{63, 63, 0x0000000000000000, "RW", "IMR11_READ_POL_63", "Bunit IMR11 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR11 region based on the agents 6bit encoded SAI value."},
#else
{63, 63, 0x0000000000000000, "RW", "IMR11_READ_POL_63", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{62, 62, 0x0000000000000000, "RO", "IMR11_READ_POL_62", "Bunit IMR11 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR11 region based on the agents 6bit encoded SAI value."},
#else
{62, 62, 0x0000000000000000, "RO", "IMR11_READ_POL_62", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{61, 61, 0x0000000000000000, "RO", "IMR11_READ_POL_61", "Bunit IMR11 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR11 region based on the agents 6bit encoded SAI value."},
#else
{61, 61, 0x0000000000000000, "RO", "IMR11_READ_POL_61", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{60, 60, 0x0000000000000000, "RO", "IMR11_READ_POL_60", "Bunit IMR11 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR11 region based on the agents 6bit encoded SAI value."},
#else
{60, 60, 0x0000000000000000, "RO", "IMR11_READ_POL_60", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{59, 59, 0x0000000000000000, "RO", "IMR11_READ_POL_59", "Bunit IMR11 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR11 region based on the agents 6bit encoded SAI value."},
#else
{59, 59, 0x0000000000000000, "RO", "IMR11_READ_POL_59", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{58, 58, 0x0000000000000000, "RO", "IMR11_READ_POL_58", "Bunit IMR11 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR11 region based on the agents 6bit encoded SAI value."},
#else
{58, 58, 0x0000000000000000, "RO", "IMR11_READ_POL_58", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{57, 57, 0x0000000000000000, "RO", "IMR11_READ_POL_57", "Bunit IMR11 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR11 region based on the agents 6bit encoded SAI value."},
#else
{57, 57, 0x0000000000000000, "RO", "IMR11_READ_POL_57", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{56, 56, 0x0000000000000000, "RW", "IMR11_READ_POL_56", "Bunit IMR11 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR11 region based on the agents 6bit encoded SAI value."},
#else
{56, 56, 0x0000000000000000, "RW", "IMR11_READ_POL_56", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{55, 55, 0x0000000000000000, "RW", "IMR11_READ_POL_55", "Bunit IMR11 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR11 region based on the agents 6bit encoded SAI value."},
#else
{55, 55, 0x0000000000000000, "RW", "IMR11_READ_POL_55", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{54, 54, 0x0000000000000000, "RW", "IMR11_READ_POL_54", "Bunit IMR11 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR11 region based on the agents 6bit encoded SAI value."},
#else
{54, 54, 0x0000000000000000, "RW", "IMR11_READ_POL_54", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{53, 53, 0x0000000000000000, "RO", "IMR11_READ_POL_53", "Bunit IMR11 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR11 region based on the agents 6bit encoded SAI value."},
#else
{53, 53, 0x0000000000000000, "RO", "IMR11_READ_POL_53", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{52, 52, 0x0000000000000000, "RO", "IMR11_READ_POL_52", "Bunit IMR11 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR11 region based on the agents 6bit encoded SAI value."},
#else
{52, 52, 0x0000000000000000, "RO", "IMR11_READ_POL_52", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{51, 51, 0x0000000000000000, "RO", "IMR11_READ_POL_51", "Bunit IMR11 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR11 region based on the agents 6bit encoded SAI value."},
#else
{51, 51, 0x0000000000000000, "RO", "IMR11_READ_POL_51", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{50, 50, 0x0000000000000000, "RW", "IMR11_READ_POL_50", "Bunit IMR11 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR11 region based on the agents 6bit encoded SAI value."},
#else
{50, 50, 0x0000000000000000, "RW", "IMR11_READ_POL_50", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{49, 49, 0x0000000000000000, "RW", "IMR11_READ_POL_49", "Bunit IMR11 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR11 region based on the agents 6bit encoded SAI value."},
#else
{49, 49, 0x0000000000000000, "RW", "IMR11_READ_POL_49", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{48, 48, 0x0000000000000000, "RW", "IMR11_READ_POL_48", "Bunit IMR11 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR11 region based on the agents 6bit encoded SAI value."},
#else
{48, 48, 0x0000000000000000, "RW", "IMR11_READ_POL_48", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{47, 47, 0x0000000000000000, "RO", "IMR11_READ_POL_47", "Bunit IMR11 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR11 region based on the agents 6bit encoded SAI value."},
#else
{47, 47, 0x0000000000000000, "RO", "IMR11_READ_POL_47", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{46, 46, 0x0000000000000000, "RO", "IMR11_READ_POL_46", "Bunit IMR11 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR11 region based on the agents 6bit encoded SAI value."},
#else
{46, 46, 0x0000000000000000, "RO", "IMR11_READ_POL_46", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{45, 45, 0x0000000000000000, "RO", "IMR11_READ_POL_45", "Bunit IMR11 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR11 region based on the agents 6bit encoded SAI value."},
#else
{45, 45, 0x0000000000000000, "RO", "IMR11_READ_POL_45", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{44, 44, 0x0000000000000000, "RW", "IMR11_READ_POL_44", "Bunit IMR11 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR11 region based on the agents 6bit encoded SAI value."},
#else
{44, 44, 0x0000000000000000, "RW", "IMR11_READ_POL_44", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{43, 43, 0x0000000000000000, "RW", "IMR11_READ_POL_43", "Bunit IMR11 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR11 region based on the agents 6bit encoded SAI value."},
#else
{43, 43, 0x0000000000000000, "RW", "IMR11_READ_POL_43", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{42, 42, 0x0000000000000000, "RW", "IMR11_READ_POL_42", "Bunit IMR11 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR11 region based on the agents 6bit encoded SAI value."},
#else
{42, 42, 0x0000000000000000, "RW", "IMR11_READ_POL_42", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{41, 41, 0x0000000000000000, "RW", "IMR11_READ_POL_41", "Bunit IMR11 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR11 region based on the agents 6bit encoded SAI value."},
#else
{41, 41, 0x0000000000000000, "RW", "IMR11_READ_POL_41", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{40, 40, 0x0000000000000000, "RW", "IMR11_READ_POL_40", "Bunit IMR11 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR11 region based on the agents 6bit encoded SAI value."},
#else
{40, 40, 0x0000000000000000, "RW", "IMR11_READ_POL_40", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{39, 39, 0x0000000000000000, "RO", "IMR11_READ_POL_39", "Bunit IMR11 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR11 region based on the agents 6bit encoded SAI value."},
#else
{39, 39, 0x0000000000000000, "RO", "IMR11_READ_POL_39", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{38, 38, 0x0000000000000000, "RW", "IMR11_READ_POL_38", "Bunit IMR11 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR11 region based on the agents 6bit encoded SAI value."},
#else
{38, 38, 0x0000000000000000, "RW", "IMR11_READ_POL_38", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{37, 37, 0x0000000000000000, "RO", "IMR11_READ_POL_37", "Bunit IMR11 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR11 region based on the agents 6bit encoded SAI value."},
#else
{37, 37, 0x0000000000000000, "RO", "IMR11_READ_POL_37", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{36, 36, 0x0000000000000000, "RW", "IMR11_READ_POL_36", "Bunit IMR11 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR11 region based on the agents 6bit encoded SAI value."},
#else
{36, 36, 0x0000000000000000, "RW", "IMR11_READ_POL_36", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{35, 35, 0x0000000000000000, "RO", "IMR11_READ_POL_35", "Bunit IMR11 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR11 region based on the agents 6bit encoded SAI value."},
#else
{35, 35, 0x0000000000000000, "RO", "IMR11_READ_POL_35", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{34, 34, 0x0000000000000000, "RW", "IMR11_READ_POL_34", "Bunit IMR11 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR11 region based on the agents 6bit encoded SAI value."},
#else
{34, 34, 0x0000000000000000, "RW", "IMR11_READ_POL_34", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{33, 33, 0x0000000000000000, "RW", "IMR11_READ_POL_33", "Bunit IMR11 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR11 region based on the agents 6bit encoded SAI value."},
#else
{33, 33, 0x0000000000000000, "RW", "IMR11_READ_POL_33", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{32, 32, 0x0000000000000000, "RW", "IMR11_READ_POL_32", "Bunit IMR11 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR11 region based on the agents 6bit encoded SAI value."},
#else
{32, 32, 0x0000000000000000, "RW", "IMR11_READ_POL_32", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{31, 31, 0x0000000000000000, "RO", "IMR11_READ_POL_31", "Bunit IMR11 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR11 region based on the agents 6bit encoded SAI value."},
#else
{31, 31, 0x0000000000000000, "RO", "IMR11_READ_POL_31", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{30, 30, 0x0000000000000000, "RW", "IMR11_READ_POL_30", "Bunit IMR11 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR11 region based on the agents 6bit encoded SAI value."},
#else
{30, 30, 0x0000000000000000, "RW", "IMR11_READ_POL_30", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{29, 29, 0x0000000000000000, "RW", "IMR11_READ_POL_29", "Bunit IMR11 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR11 region based on the agents 6bit encoded SAI value."},
#else
{29, 29, 0x0000000000000000, "RW", "IMR11_READ_POL_29", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{28, 28, 0x0000000000000000, "RW", "IMR11_READ_POL_28", "Bunit IMR11 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR11 region based on the agents 6bit encoded SAI value."},
#else
{28, 28, 0x0000000000000000, "RW", "IMR11_READ_POL_28", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{27, 27, 0x0000000000000000, "RW", "IMR11_READ_POL_27", "Bunit IMR11 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR11 region based on the agents 6bit encoded SAI value."},
#else
{27, 27, 0x0000000000000000, "RW", "IMR11_READ_POL_27", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{26, 26, 0x0000000000000000, "RW", "IMR11_READ_POL_26", "Bunit IMR11 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR11 region based on the agents 6bit encoded SAI value."},
#else
{26, 26, 0x0000000000000000, "RW", "IMR11_READ_POL_26", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{25, 25, 0x0000000000000000, "RW", "IMR11_READ_POL_25", "Bunit IMR11 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR11 region based on the agents 6bit encoded SAI value."},
#else
{25, 25, 0x0000000000000000, "RW", "IMR11_READ_POL_25", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{24, 24, 0x0000000000000000, "RW", "IMR11_READ_POL_24", "Bunit IMR11 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR11 region based on the agents 6bit encoded SAI value."},
#else
{24, 24, 0x0000000000000000, "RW", "IMR11_READ_POL_24", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{23, 23, 0x0000000000000000, "RO", "IMR11_READ_POL_23", "Bunit IMR11 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR11 region based on the agents 6bit encoded SAI value."},
#else
{23, 23, 0x0000000000000000, "RO", "IMR11_READ_POL_23", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{22, 22, 0x0000000000000000, "RO", "IMR11_READ_POL_22", "Bunit IMR11 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR11 region based on the agents 6bit encoded SAI value."},
#else
{22, 22, 0x0000000000000000, "RO", "IMR11_READ_POL_22", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{21, 21, 0x0000000000000000, "RW", "IMR11_READ_POL_21", "Bunit IMR11 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR11 region based on the agents 6bit encoded SAI value."},
#else
{21, 21, 0x0000000000000000, "RW", "IMR11_READ_POL_21", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{20, 20, 0x0000000000000000, "RO", "IMR11_READ_POL_20", "Bunit IMR11 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR11 region based on the agents 6bit encoded SAI value."},
#else
{20, 20, 0x0000000000000000, "RO", "IMR11_READ_POL_20", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{19, 19, 0x0000000000000000, "RO", "IMR11_READ_POL_19", "Bunit IMR11 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR11 region based on the agents 6bit encoded SAI value."},
#else
{19, 19, 0x0000000000000000, "RO", "IMR11_READ_POL_19", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{18, 18, 0x0000000000000000, "RO", "IMR11_READ_POL_18", "Bunit IMR11 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR11 region based on the agents 6bit encoded SAI value."},
#else
{18, 18, 0x0000000000000000, "RO", "IMR11_READ_POL_18", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{17, 17, 0x0000000000000000, "RW", "IMR11_READ_POL_17", "Bunit IMR11 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR11 region based on the agents 6bit encoded SAI value."},
#else
{17, 17, 0x0000000000000000, "RW", "IMR11_READ_POL_17", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{16, 16, 0x0000000000000000, "RW", "IMR11_READ_POL_16", "Bunit IMR11 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR11 region based on the agents 6bit encoded SAI value."},
#else
{16, 16, 0x0000000000000000, "RW", "IMR11_READ_POL_16", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{15, 15, 0x0000000000000000, "RO", "IMR11_READ_POL_15", "Bunit IMR11 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR11 region based on the agents 6bit encoded SAI value."},
#else
{15, 15, 0x0000000000000000, "RO", "IMR11_READ_POL_15", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{14, 14, 0x0000000000000000, "RO", "IMR11_READ_POL_14", "Bunit IMR11 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR11 region based on the agents 6bit encoded SAI value."},
#else
{14, 14, 0x0000000000000000, "RO", "IMR11_READ_POL_14", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{13, 13, 0x0000000000000000, "RW", "IMR11_READ_POL_13", "Bunit IMR11 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR11 region based on the agents 6bit encoded SAI value."},
#else
{13, 13, 0x0000000000000000, "RW", "IMR11_READ_POL_13", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{12, 12, 0x0000000000000000, "RW", "IMR11_READ_POL_12", "Bunit IMR11 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR11 region based on the agents 6bit encoded SAI value."},
#else
{12, 12, 0x0000000000000000, "RW", "IMR11_READ_POL_12", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{11, 11, 0x0000000000000000, "RO", "IMR11_READ_POL_11", "Bunit IMR11 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR11 region based on the agents 6bit encoded SAI value."},
#else
{11, 11, 0x0000000000000000, "RO", "IMR11_READ_POL_11", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{10, 10, 0x0000000000000000, "RO", "IMR11_READ_POL_10", "Bunit IMR11 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR11 region based on the agents 6bit encoded SAI value."},
#else
{10, 10, 0x0000000000000000, "RO", "IMR11_READ_POL_10", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{9, 9, 0x0000000000000000, "RO", "IMR11_READ_POL_9", "Bunit IMR11 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR11 region based on the agents 6bit encoded SAI value."},
#else
{9, 9, 0x0000000000000000, "RO", "IMR11_READ_POL_9", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{8, 8, 0x0000000000000000, "RW", "IMR11_READ_POL_8", "Bunit IMR11 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR11 region based on the agents 6bit encoded SAI value."},
#else
{8, 8, 0x0000000000000000, "RW", "IMR11_READ_POL_8", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{7, 7, 0x0000000000000000, "RO", "IMR11_READ_POL_7", "Bunit IMR11 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR11 region based on the agents 6bit encoded SAI value."},
#else
{7, 7, 0x0000000000000000, "RO", "IMR11_READ_POL_7", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{6, 6, 0x0000000000000000, "RO", "IMR11_READ_POL_6", "Bunit IMR11 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR11 region based on the agents 6bit encoded SAI value."},
#else
{6, 6, 0x0000000000000000, "RO", "IMR11_READ_POL_6", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{5, 5, 0x0000000000000000, "RW", "IMR11_READ_POL_5", "Bunit IMR11 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR11 region based on the agents 6bit encoded SAI value."},
#else
{5, 5, 0x0000000000000000, "RW", "IMR11_READ_POL_5", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{4, 4, 0x0000000000000000, "RW", "IMR11_READ_POL_4", "Bunit IMR11 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR11 region based on the agents 6bit encoded SAI value."},
#else
{4, 4, 0x0000000000000000, "RW", "IMR11_READ_POL_4", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{3, 3, 0x0000000000000000, "RW", "IMR11_READ_POL_3", "Bunit IMR11 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR11 region based on the agents 6bit encoded SAI value."},
#else
{3, 3, 0x0000000000000000, "RW", "IMR11_READ_POL_3", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{2, 2, 0x0000000000000000, "RW", "IMR11_READ_POL_2", "Bunit IMR11 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR11 region based on the agents 6bit encoded SAI value."},
#else
{2, 2, 0x0000000000000000, "RW", "IMR11_READ_POL_2", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{1, 1, 0x0000000000000000, "RW", "IMR11_READ_POL_1", "Bunit IMR11 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR11 region based on the agents 6bit encoded SAI value."},
#else
{1, 1, 0x0000000000000000, "RW", "IMR11_READ_POL_1", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 0, 0x0000000000000000, "RW", "IMR11_READ_POL_0", "Bunit IMR11 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR11 region based on the agents 6bit encoded SAI value."},
#else
{0, 0, 0x0000000000000000, "RW", "IMR11_READ_POL_0", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo935[] = {{"B_CR_BIMR11RAC_0_0_0_MCHBAR", "", 0x000069E0, 64, 0xFFFFFFFFFFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields936[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{63, 63, 0x0000000000000000, "RW", "IMR11_WRITE_POL_63", "Bunit IMR11 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR11 region based on the agents 6bit encoded SAI value."},
#else
{63, 63, 0x0000000000000000, "RW", "IMR11_WRITE_POL_63", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{62, 62, 0x0000000000000000, "RO", "IMR11_WRITE_POL_62", "Bunit IMR11 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR11 region based on the agents 6bit encoded SAI value."},
#else
{62, 62, 0x0000000000000000, "RO", "IMR11_WRITE_POL_62", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{61, 61, 0x0000000000000000, "RO", "IMR11_WRITE_POL_61", "Bunit IMR11 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR11 region based on the agents 6bit encoded SAI value."},
#else
{61, 61, 0x0000000000000000, "RO", "IMR11_WRITE_POL_61", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{60, 60, 0x0000000000000000, "RO", "IMR11_WRITE_POL_60", "Bunit IMR11 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR11 region based on the agents 6bit encoded SAI value."},
#else
{60, 60, 0x0000000000000000, "RO", "IMR11_WRITE_POL_60", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{59, 59, 0x0000000000000000, "RO", "IMR11_WRITE_POL_59", "Bunit IMR11 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR11 region based on the agents 6bit encoded SAI value."},
#else
{59, 59, 0x0000000000000000, "RO", "IMR11_WRITE_POL_59", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{58, 58, 0x0000000000000000, "RO", "IMR11_WRITE_POL_58", "Bunit IMR11 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR11 region based on the agents 6bit encoded SAI value."},
#else
{58, 58, 0x0000000000000000, "RO", "IMR11_WRITE_POL_58", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{57, 57, 0x0000000000000000, "RO", "IMR11_WRITE_POL_57", "Bunit IMR11 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR11 region based on the agents 6bit encoded SAI value."},
#else
{57, 57, 0x0000000000000000, "RO", "IMR11_WRITE_POL_57", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{56, 56, 0x0000000000000000, "RW", "IMR11_WRITE_POL_56", "Bunit IMR11 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR11 region based on the agents 6bit encoded SAI value."},
#else
{56, 56, 0x0000000000000000, "RW", "IMR11_WRITE_POL_56", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{55, 55, 0x0000000000000000, "RW", "IMR11_WRITE_POL_55", "Bunit IMR11 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR11 region based on the agents 6bit encoded SAI value."},
#else
{55, 55, 0x0000000000000000, "RW", "IMR11_WRITE_POL_55", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{54, 54, 0x0000000000000000, "RW", "IMR11_WRITE_POL_54", "Bunit IMR11 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR11 region based on the agents 6bit encoded SAI value."},
#else
{54, 54, 0x0000000000000000, "RW", "IMR11_WRITE_POL_54", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{53, 53, 0x0000000000000000, "RO", "IMR11_WRITE_POL_53", "Bunit IMR11 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR11 region based on the agents 6bit encoded SAI value."},
#else
{53, 53, 0x0000000000000000, "RO", "IMR11_WRITE_POL_53", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{52, 52, 0x0000000000000000, "RO", "IMR11_WRITE_POL_52", "Bunit IMR11 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR11 region based on the agents 6bit encoded SAI value."},
#else
{52, 52, 0x0000000000000000, "RO", "IMR11_WRITE_POL_52", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{51, 51, 0x0000000000000000, "RO", "IMR11_WRITE_POL_51", "Bunit IMR11 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR11 region based on the agents 6bit encoded SAI value."},
#else
{51, 51, 0x0000000000000000, "RO", "IMR11_WRITE_POL_51", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{50, 50, 0x0000000000000000, "RW", "IMR11_WRITE_POL_50", "Bunit IMR11 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR11 region based on the agents 6bit encoded SAI value."},
#else
{50, 50, 0x0000000000000000, "RW", "IMR11_WRITE_POL_50", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{49, 49, 0x0000000000000000, "RW", "IMR11_WRITE_POL_49", "Bunit IMR11 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR11 region based on the agents 6bit encoded SAI value."},
#else
{49, 49, 0x0000000000000000, "RW", "IMR11_WRITE_POL_49", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{48, 48, 0x0000000000000000, "RW", "IMR11_WRITE_POL_48", "Bunit IMR11 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR11 region based on the agents 6bit encoded SAI value."},
#else
{48, 48, 0x0000000000000000, "RW", "IMR11_WRITE_POL_48", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{47, 47, 0x0000000000000000, "RO", "IMR11_WRITE_POL_47", "Bunit IMR11 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR11 region based on the agents 6bit encoded SAI value."},
#else
{47, 47, 0x0000000000000000, "RO", "IMR11_WRITE_POL_47", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{46, 46, 0x0000000000000000, "RO", "IMR11_WRITE_POL_46", "Bunit IMR11 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR11 region based on the agents 6bit encoded SAI value."},
#else
{46, 46, 0x0000000000000000, "RO", "IMR11_WRITE_POL_46", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{45, 45, 0x0000000000000000, "RO", "IMR11_WRITE_POL_45", "Bunit IMR11 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR11 region based on the agents 6bit encoded SAI value."},
#else
{45, 45, 0x0000000000000000, "RO", "IMR11_WRITE_POL_45", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{44, 44, 0x0000000000000000, "RW", "IMR11_WRITE_POL_44", "Bunit IMR11 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR11 region based on the agents 6bit encoded SAI value."},
#else
{44, 44, 0x0000000000000000, "RW", "IMR11_WRITE_POL_44", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{43, 43, 0x0000000000000000, "RW", "IMR11_WRITE_POL_43", "Bunit IMR11 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR11 region based on the agents 6bit encoded SAI value."},
#else
{43, 43, 0x0000000000000000, "RW", "IMR11_WRITE_POL_43", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{42, 42, 0x0000000000000000, "RW", "IMR11_WRITE_POL_42", "Bunit IMR11 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR11 region based on the agents 6bit encoded SAI value."},
#else
{42, 42, 0x0000000000000000, "RW", "IMR11_WRITE_POL_42", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{41, 41, 0x0000000000000000, "RW", "IMR11_WRITE_POL_41", "Bunit IMR11 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR11 region based on the agents 6bit encoded SAI value."},
#else
{41, 41, 0x0000000000000000, "RW", "IMR11_WRITE_POL_41", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{40, 40, 0x0000000000000000, "RW", "IMR11_WRITE_POL_40", "Bunit IMR11 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR11 region based on the agents 6bit encoded SAI value."},
#else
{40, 40, 0x0000000000000000, "RW", "IMR11_WRITE_POL_40", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{39, 39, 0x0000000000000000, "RO", "IMR11_WRITE_POL_39", "Bunit IMR11 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR11 region based on the agents 6bit encoded SAI value."},
#else
{39, 39, 0x0000000000000000, "RO", "IMR11_WRITE_POL_39", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{38, 38, 0x0000000000000000, "RW", "IMR11_WRITE_POL_38", "Bunit IMR11 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR11 region based on the agents 6bit encoded SAI value."},
#else
{38, 38, 0x0000000000000000, "RW", "IMR11_WRITE_POL_38", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{37, 37, 0x0000000000000000, "RO", "IMR11_WRITE_POL_37", "Bunit IMR11 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR11 region based on the agents 6bit encoded SAI value."},
#else
{37, 37, 0x0000000000000000, "RO", "IMR11_WRITE_POL_37", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{36, 36, 0x0000000000000000, "RW", "IMR11_WRITE_POL_36", "Bunit IMR11 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR11 region based on the agents 6bit encoded SAI value."},
#else
{36, 36, 0x0000000000000000, "RW", "IMR11_WRITE_POL_36", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{35, 35, 0x0000000000000000, "RO", "IMR11_WRITE_POL_35", "Bunit IMR11 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR11 region based on the agents 6bit encoded SAI value."},
#else
{35, 35, 0x0000000000000000, "RO", "IMR11_WRITE_POL_35", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{34, 34, 0x0000000000000000, "RW", "IMR11_WRITE_POL_34", "Bunit IMR11 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR11 region based on the agents 6bit encoded SAI value."},
#else
{34, 34, 0x0000000000000000, "RW", "IMR11_WRITE_POL_34", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{33, 33, 0x0000000000000000, "RW", "IMR11_WRITE_POL_33", "Bunit IMR11 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR11 region based on the agents 6bit encoded SAI value."},
#else
{33, 33, 0x0000000000000000, "RW", "IMR11_WRITE_POL_33", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{32, 32, 0x0000000000000000, "RW", "IMR11_WRITE_POL_32", "Bunit IMR11 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR11 region based on the agents 6bit encoded SAI value."},
#else
{32, 32, 0x0000000000000000, "RW", "IMR11_WRITE_POL_32", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{31, 31, 0x0000000000000000, "RO", "IMR11_WRITE_POL_31", "Bunit IMR11 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR11 region based on the agents 6bit encoded SAI value."},
#else
{31, 31, 0x0000000000000000, "RO", "IMR11_WRITE_POL_31", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{30, 30, 0x0000000000000000, "RW", "IMR11_WRITE_POL_30", "Bunit IMR11 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR11 region based on the agents 6bit encoded SAI value."},
#else
{30, 30, 0x0000000000000000, "RW", "IMR11_WRITE_POL_30", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{29, 29, 0x0000000000000000, "RW", "IMR11_WRITE_POL_29", "Bunit IMR11 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR11 region based on the agents 6bit encoded SAI value."},
#else
{29, 29, 0x0000000000000000, "RW", "IMR11_WRITE_POL_29", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{28, 28, 0x0000000000000000, "RW", "IMR11_WRITE_POL_28", "Bunit IMR11 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR11 region based on the agents 6bit encoded SAI value."},
#else
{28, 28, 0x0000000000000000, "RW", "IMR11_WRITE_POL_28", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{27, 27, 0x0000000000000000, "RW", "IMR11_WRITE_POL_27", "Bunit IMR11 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR11 region based on the agents 6bit encoded SAI value."},
#else
{27, 27, 0x0000000000000000, "RW", "IMR11_WRITE_POL_27", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{26, 26, 0x0000000000000000, "RW", "IMR11_WRITE_POL_26", "Bunit IMR11 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR11 region based on the agents 6bit encoded SAI value."},
#else
{26, 26, 0x0000000000000000, "RW", "IMR11_WRITE_POL_26", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{25, 25, 0x0000000000000000, "RW", "IMR11_WRITE_POL_25", "Bunit IMR11 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR11 region based on the agents 6bit encoded SAI value."},
#else
{25, 25, 0x0000000000000000, "RW", "IMR11_WRITE_POL_25", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{24, 24, 0x0000000000000000, "RW", "IMR11_WRITE_POL_24", "Bunit IMR11 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR11 region based on the agents 6bit encoded SAI value."},
#else
{24, 24, 0x0000000000000000, "RW", "IMR11_WRITE_POL_24", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{23, 23, 0x0000000000000000, "RO", "IMR11_WRITE_POL_23", "Bunit IMR11 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR11 region based on the agents 6bit encoded SAI value."},
#else
{23, 23, 0x0000000000000000, "RO", "IMR11_WRITE_POL_23", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{22, 22, 0x0000000000000000, "RO", "IMR11_WRITE_POL_22", "Bunit IMR11 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR11 region based on the agents 6bit encoded SAI value."},
#else
{22, 22, 0x0000000000000000, "RO", "IMR11_WRITE_POL_22", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{21, 21, 0x0000000000000000, "RW", "IMR11_WRITE_POL_21", "Bunit IMR11 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR11 region based on the agents 6bit encoded SAI value."},
#else
{21, 21, 0x0000000000000000, "RW", "IMR11_WRITE_POL_21", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{20, 20, 0x0000000000000000, "RO", "IMR11_WRITE_POL_20", "Bunit IMR11 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR11 region based on the agents 6bit encoded SAI value."},
#else
{20, 20, 0x0000000000000000, "RO", "IMR11_WRITE_POL_20", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{19, 19, 0x0000000000000000, "RO", "IMR11_WRITE_POL_19", "Bunit IMR11 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR11 region based on the agents 6bit encoded SAI value."},
#else
{19, 19, 0x0000000000000000, "RO", "IMR11_WRITE_POL_19", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{18, 18, 0x0000000000000000, "RO", "IMR11_WRITE_POL_18", "Bunit IMR11 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR11 region based on the agents 6bit encoded SAI value."},
#else
{18, 18, 0x0000000000000000, "RO", "IMR11_WRITE_POL_18", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{17, 17, 0x0000000000000000, "RW", "IMR11_WRITE_POL_17", "Bunit IMR11 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR11 region based on the agents 6bit encoded SAI value."},
#else
{17, 17, 0x0000000000000000, "RW", "IMR11_WRITE_POL_17", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{16, 16, 0x0000000000000000, "RW", "IMR11_WRITE_POL_16", "Bunit IMR11 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR11 region based on the agents 6bit encoded SAI value."},
#else
{16, 16, 0x0000000000000000, "RW", "IMR11_WRITE_POL_16", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{15, 15, 0x0000000000000000, "RO", "IMR11_WRITE_POL_15", "Bunit IMR11 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR11 region based on the agents 6bit encoded SAI value."},
#else
{15, 15, 0x0000000000000000, "RO", "IMR11_WRITE_POL_15", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{14, 14, 0x0000000000000000, "RO", "IMR11_WRITE_POL_14", "Bunit IMR11 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR11 region based on the agents 6bit encoded SAI value."},
#else
{14, 14, 0x0000000000000000, "RO", "IMR11_WRITE_POL_14", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{13, 13, 0x0000000000000000, "RW", "IMR11_WRITE_POL_13", "Bunit IMR11 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR11 region based on the agents 6bit encoded SAI value."},
#else
{13, 13, 0x0000000000000000, "RW", "IMR11_WRITE_POL_13", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{12, 12, 0x0000000000000000, "RW", "IMR11_WRITE_POL_12", "Bunit IMR11 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR11 region based on the agents 6bit encoded SAI value."},
#else
{12, 12, 0x0000000000000000, "RW", "IMR11_WRITE_POL_12", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{11, 11, 0x0000000000000000, "RO", "IMR11_WRITE_POL_11", "Bunit IMR11 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR11 region based on the agents 6bit encoded SAI value."},
#else
{11, 11, 0x0000000000000000, "RO", "IMR11_WRITE_POL_11", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{10, 10, 0x0000000000000000, "RO", "IMR11_WRITE_POL_10", "Bunit IMR11 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR11 region based on the agents 6bit encoded SAI value."},
#else
{10, 10, 0x0000000000000000, "RO", "IMR11_WRITE_POL_10", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{9, 9, 0x0000000000000000, "RO", "IMR11_WRITE_POL_9", "Bunit IMR11 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR11 region based on the agents 6bit encoded SAI value."},
#else
{9, 9, 0x0000000000000000, "RO", "IMR11_WRITE_POL_9", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{8, 8, 0x0000000000000000, "RW", "IMR11_WRITE_POL_8", "Bunit IMR11 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR11 region based on the agents 6bit encoded SAI value."},
#else
{8, 8, 0x0000000000000000, "RW", "IMR11_WRITE_POL_8", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{7, 7, 0x0000000000000000, "RO", "IMR11_WRITE_POL_7", "Bunit IMR11 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR11 region based on the agents 6bit encoded SAI value."},
#else
{7, 7, 0x0000000000000000, "RO", "IMR11_WRITE_POL_7", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{6, 6, 0x0000000000000000, "RO", "IMR11_WRITE_POL_6", "Bunit IMR11 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR11 region based on the agents 6bit encoded SAI value."},
#else
{6, 6, 0x0000000000000000, "RO", "IMR11_WRITE_POL_6", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{5, 5, 0x0000000000000000, "RW", "IMR11_WRITE_POL_5", "Bunit IMR11 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR11 region based on the agents 6bit encoded SAI value."},
#else
{5, 5, 0x0000000000000000, "RW", "IMR11_WRITE_POL_5", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{4, 4, 0x0000000000000000, "RW", "IMR11_WRITE_POL_4", "Bunit IMR11 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR11 region based on the agents 6bit encoded SAI value."},
#else
{4, 4, 0x0000000000000000, "RW", "IMR11_WRITE_POL_4", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{3, 3, 0x0000000000000000, "RW", "IMR11_WRITE_POL_3", "Bunit IMR11 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR11 region based on the agents 6bit encoded SAI value."},
#else
{3, 3, 0x0000000000000000, "RW", "IMR11_WRITE_POL_3", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{2, 2, 0x0000000000000000, "RW", "IMR11_WRITE_POL_2", "Bunit IMR11 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR11 region based on the agents 6bit encoded SAI value."},
#else
{2, 2, 0x0000000000000000, "RW", "IMR11_WRITE_POL_2", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{1, 1, 0x0000000000000000, "RW", "IMR11_WRITE_POL_1", "Bunit IMR11 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR11 region based on the agents 6bit encoded SAI value."},
#else
{1, 1, 0x0000000000000000, "RW", "IMR11_WRITE_POL_1", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 0, 0x0000000000000000, "RW", "IMR11_WRITE_POL_0", "Bunit IMR11 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR11 region based on the agents 6bit encoded SAI value."},
#else
{0, 0, 0x0000000000000000, "RW", "IMR11_WRITE_POL_0", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo936[] = {{"B_CR_BIMR11WAC_0_0_0_MCHBAR", "", 0x000069E8, 64, 0xFFFFFFFFFFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields937[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{31, 31, 0x0000000000000000, "RW", "IMR_EN", "IMR Enable: Enables access checking for the IMR region."},
#else
{31, 31, 0x0000000000000000, "RW", "IMR_EN", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{30, 30, 0x0000000000000000, "RW", "TR_EN", "Asset Classification AC[0]: Trace Enable: Enables snooping of transactions to the IMR region by tracing agents."},
#else
{30, 30, 0x0000000000000000, "RW", "TR_EN", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{29, 29, 0x0000000000000000, "RO", "RESERVED_1", "Reserved"},
#else
{29, 29, 0x0000000000000000, "RO", "RESERVED_1", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 28, 0x0000000000000000, "RW", "IMR12_BASE", "Base 0 IMR12BASE:  Specifies bits 38:10 of the start address of IMR12 region.  IMR region size must be a strict poweroftwo at least 1KB and naturally aligned to the size.  These bits are compared with the result of the IMR12MASK[28:0] applied to bits 38:10 of the incoming address to determine if an access falls within the IMR12 defined region."},
#else
{0, 28, 0x0000000000000000, "RW", "IMR12_BASE", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo937[] = {{"B_CR_BIMR12BASE_0_0_0_MCHBAR", "", 0x000069F0, 4, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields938[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{31, 31, 0x0000000000000000, "RW", "GT_IWB_EN", "Asset Classification AC[2]: GT Implicit WB Enable: Enables implicit writebacks to protected region from GT caching agent. When set to 1 enables implicit writeback data HITM data from GT to be returned to the requester.  When set to 0 inhibits HITM data from GT from being returned to the requester.  HITM data from IA cores may be returned to the requester depending on the setting of the IA_IWB_EN bit."},
#else
{31, 31, 0x0000000000000000, "RW", "GT_IWB_EN", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{30, 30, 0x0000000000000000, "RW", "IA_IWB_EN", "Asset Classification AC[1]: IA Implicit WB Enable: Enables implicit writebacks to protected region from IA caching agent.  When set to 1 enables implicit writeback data HITM data from IA cores to be returned to the requester.  When set to 0 inhibits HITM data from IA cores from being returned to the requester.  HITM data from GT may be returned to the requester depending on the setting of the GT_IWB_EN bit."},
#else
{30, 30, 0x0000000000000000, "RW", "IA_IWB_EN", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{29, 29, 0x0000000000000000, "RO", "RESERVED_0", "Reserved"},
#else
{29, 29, 0x0000000000000000, "RO", "RESERVED_0", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 28, 0x0000000000000000, "RW", "IMR12_MASK", "Mask 0 IMR12MASK:  These bits are ANDed with bits 38:10 of the incoming address to determine if the combined result matches the IMR12BASE[28:0] value.  A match indicates the the incoming address falls within the IMR12 region."},
#else
{0, 28, 0x0000000000000000, "RW", "IMR12_MASK", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo938[] = {{"B_CR_BIMR12MASK_0_0_0_MCHBAR", "", 0x000069F4, 4, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields939[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{0, 63, 0x00000C0061010202, "RW", "IMR12_CTRL_POL", "Bunit IMR12 Control Policy: Bit vector used to determine which agents are allowed access to the BIMR12RAC, BIMR12WAC, BIMR12CP registers based on the value from the agents 6bit SAI field."},
#else
{0, 63, 0x00000C0061010202, "RW", "IMR12_CTRL_POL", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo939[] = {{"B_CR_BIMR12CP_0_0_0_MCHBAR", "", 0x000069F8, 1, 0xFFFFFFFFFFFFFFFF, 0x00000C0061010202}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields940[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{63, 63, 0x0000000000000000, "RW", "IMR12_READ_POL_63", "Bunit IMR12 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR12 region based on the agents 6bit encoded SAI value."},
#else
{63, 63, 0x0000000000000000, "RW", "IMR12_READ_POL_63", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{62, 62, 0x0000000000000000, "RO", "IMR12_READ_POL_62", "Bunit IMR12 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR12 region based on the agents 6bit encoded SAI value."},
#else
{62, 62, 0x0000000000000000, "RO", "IMR12_READ_POL_62", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{61, 61, 0x0000000000000000, "RO", "IMR12_READ_POL_61", "Bunit IMR12 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR12 region based on the agents 6bit encoded SAI value."},
#else
{61, 61, 0x0000000000000000, "RO", "IMR12_READ_POL_61", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{60, 60, 0x0000000000000000, "RO", "IMR12_READ_POL_60", "Bunit IMR12 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR12 region based on the agents 6bit encoded SAI value."},
#else
{60, 60, 0x0000000000000000, "RO", "IMR12_READ_POL_60", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{59, 59, 0x0000000000000000, "RO", "IMR12_READ_POL_59", "Bunit IMR12 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR12 region based on the agents 6bit encoded SAI value."},
#else
{59, 59, 0x0000000000000000, "RO", "IMR12_READ_POL_59", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{58, 58, 0x0000000000000000, "RO", "IMR12_READ_POL_58", "Bunit IMR12 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR12 region based on the agents 6bit encoded SAI value."},
#else
{58, 58, 0x0000000000000000, "RO", "IMR12_READ_POL_58", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{57, 57, 0x0000000000000000, "RO", "IMR12_READ_POL_57", "Bunit IMR12 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR12 region based on the agents 6bit encoded SAI value."},
#else
{57, 57, 0x0000000000000000, "RO", "IMR12_READ_POL_57", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{56, 56, 0x0000000000000000, "RW", "IMR12_READ_POL_56", "Bunit IMR12 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR12 region based on the agents 6bit encoded SAI value."},
#else
{56, 56, 0x0000000000000000, "RW", "IMR12_READ_POL_56", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{55, 55, 0x0000000000000000, "RW", "IMR12_READ_POL_55", "Bunit IMR12 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR12 region based on the agents 6bit encoded SAI value."},
#else
{55, 55, 0x0000000000000000, "RW", "IMR12_READ_POL_55", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{54, 54, 0x0000000000000000, "RW", "IMR12_READ_POL_54", "Bunit IMR12 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR12 region based on the agents 6bit encoded SAI value."},
#else
{54, 54, 0x0000000000000000, "RW", "IMR12_READ_POL_54", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{53, 53, 0x0000000000000000, "RO", "IMR12_READ_POL_53", "Bunit IMR12 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR12 region based on the agents 6bit encoded SAI value."},
#else
{53, 53, 0x0000000000000000, "RO", "IMR12_READ_POL_53", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{52, 52, 0x0000000000000000, "RO", "IMR12_READ_POL_52", "Bunit IMR12 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR12 region based on the agents 6bit encoded SAI value."},
#else
{52, 52, 0x0000000000000000, "RO", "IMR12_READ_POL_52", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{51, 51, 0x0000000000000000, "RO", "IMR12_READ_POL_51", "Bunit IMR12 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR12 region based on the agents 6bit encoded SAI value."},
#else
{51, 51, 0x0000000000000000, "RO", "IMR12_READ_POL_51", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{50, 50, 0x0000000000000000, "RW", "IMR12_READ_POL_50", "Bunit IMR12 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR12 region based on the agents 6bit encoded SAI value."},
#else
{50, 50, 0x0000000000000000, "RW", "IMR12_READ_POL_50", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{49, 49, 0x0000000000000000, "RW", "IMR12_READ_POL_49", "Bunit IMR12 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR12 region based on the agents 6bit encoded SAI value."},
#else
{49, 49, 0x0000000000000000, "RW", "IMR12_READ_POL_49", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{48, 48, 0x0000000000000000, "RW", "IMR12_READ_POL_48", "Bunit IMR12 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR12 region based on the agents 6bit encoded SAI value."},
#else
{48, 48, 0x0000000000000000, "RW", "IMR12_READ_POL_48", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{47, 47, 0x0000000000000000, "RO", "IMR12_READ_POL_47", "Bunit IMR12 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR12 region based on the agents 6bit encoded SAI value."},
#else
{47, 47, 0x0000000000000000, "RO", "IMR12_READ_POL_47", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{46, 46, 0x0000000000000000, "RO", "IMR12_READ_POL_46", "Bunit IMR12 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR12 region based on the agents 6bit encoded SAI value."},
#else
{46, 46, 0x0000000000000000, "RO", "IMR12_READ_POL_46", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{45, 45, 0x0000000000000000, "RO", "IMR12_READ_POL_45", "Bunit IMR12 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR12 region based on the agents 6bit encoded SAI value."},
#else
{45, 45, 0x0000000000000000, "RO", "IMR12_READ_POL_45", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{44, 44, 0x0000000000000000, "RW", "IMR12_READ_POL_44", "Bunit IMR12 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR12 region based on the agents 6bit encoded SAI value."},
#else
{44, 44, 0x0000000000000000, "RW", "IMR12_READ_POL_44", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{43, 43, 0x0000000000000000, "RW", "IMR12_READ_POL_43", "Bunit IMR12 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR12 region based on the agents 6bit encoded SAI value."},
#else
{43, 43, 0x0000000000000000, "RW", "IMR12_READ_POL_43", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{42, 42, 0x0000000000000000, "RW", "IMR12_READ_POL_42", "Bunit IMR12 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR12 region based on the agents 6bit encoded SAI value."},
#else
{42, 42, 0x0000000000000000, "RW", "IMR12_READ_POL_42", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{41, 41, 0x0000000000000000, "RW", "IMR12_READ_POL_41", "Bunit IMR12 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR12 region based on the agents 6bit encoded SAI value."},
#else
{41, 41, 0x0000000000000000, "RW", "IMR12_READ_POL_41", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{40, 40, 0x0000000000000000, "RW", "IMR12_READ_POL_40", "Bunit IMR12 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR12 region based on the agents 6bit encoded SAI value."},
#else
{40, 40, 0x0000000000000000, "RW", "IMR12_READ_POL_40", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{39, 39, 0x0000000000000000, "RO", "IMR12_READ_POL_39", "Bunit IMR12 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR12 region based on the agents 6bit encoded SAI value."},
#else
{39, 39, 0x0000000000000000, "RO", "IMR12_READ_POL_39", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{38, 38, 0x0000000000000000, "RW", "IMR12_READ_POL_38", "Bunit IMR12 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR12 region based on the agents 6bit encoded SAI value."},
#else
{38, 38, 0x0000000000000000, "RW", "IMR12_READ_POL_38", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{37, 37, 0x0000000000000000, "RO", "IMR12_READ_POL_37", "Bunit IMR12 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR12 region based on the agents 6bit encoded SAI value."},
#else
{37, 37, 0x0000000000000000, "RO", "IMR12_READ_POL_37", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{36, 36, 0x0000000000000000, "RW", "IMR12_READ_POL_36", "Bunit IMR12 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR12 region based on the agents 6bit encoded SAI value."},
#else
{36, 36, 0x0000000000000000, "RW", "IMR12_READ_POL_36", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{35, 35, 0x0000000000000000, "RO", "IMR12_READ_POL_35", "Bunit IMR12 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR12 region based on the agents 6bit encoded SAI value."},
#else
{35, 35, 0x0000000000000000, "RO", "IMR12_READ_POL_35", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{34, 34, 0x0000000000000000, "RW", "IMR12_READ_POL_34", "Bunit IMR12 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR12 region based on the agents 6bit encoded SAI value."},
#else
{34, 34, 0x0000000000000000, "RW", "IMR12_READ_POL_34", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{33, 33, 0x0000000000000000, "RW", "IMR12_READ_POL_33", "Bunit IMR12 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR12 region based on the agents 6bit encoded SAI value."},
#else
{33, 33, 0x0000000000000000, "RW", "IMR12_READ_POL_33", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{32, 32, 0x0000000000000000, "RW", "IMR12_READ_POL_32", "Bunit IMR12 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR12 region based on the agents 6bit encoded SAI value."},
#else
{32, 32, 0x0000000000000000, "RW", "IMR12_READ_POL_32", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{31, 31, 0x0000000000000000, "RO", "IMR12_READ_POL_31", "Bunit IMR12 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR12 region based on the agents 6bit encoded SAI value."},
#else
{31, 31, 0x0000000000000000, "RO", "IMR12_READ_POL_31", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{30, 30, 0x0000000000000000, "RW", "IMR12_READ_POL_30", "Bunit IMR12 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR12 region based on the agents 6bit encoded SAI value."},
#else
{30, 30, 0x0000000000000000, "RW", "IMR12_READ_POL_30", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{29, 29, 0x0000000000000000, "RW", "IMR12_READ_POL_29", "Bunit IMR12 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR12 region based on the agents 6bit encoded SAI value."},
#else
{29, 29, 0x0000000000000000, "RW", "IMR12_READ_POL_29", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{28, 28, 0x0000000000000000, "RW", "IMR12_READ_POL_28", "Bunit IMR12 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR12 region based on the agents 6bit encoded SAI value."},
#else
{28, 28, 0x0000000000000000, "RW", "IMR12_READ_POL_28", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{27, 27, 0x0000000000000000, "RW", "IMR12_READ_POL_27", "Bunit IMR12 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR12 region based on the agents 6bit encoded SAI value."},
#else
{27, 27, 0x0000000000000000, "RW", "IMR12_READ_POL_27", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{26, 26, 0x0000000000000000, "RW", "IMR12_READ_POL_26", "Bunit IMR12 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR12 region based on the agents 6bit encoded SAI value."},
#else
{26, 26, 0x0000000000000000, "RW", "IMR12_READ_POL_26", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{25, 25, 0x0000000000000000, "RW", "IMR12_READ_POL_25", "Bunit IMR12 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR12 region based on the agents 6bit encoded SAI value."},
#else
{25, 25, 0x0000000000000000, "RW", "IMR12_READ_POL_25", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{24, 24, 0x0000000000000000, "RW", "IMR12_READ_POL_24", "Bunit IMR12 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR12 region based on the agents 6bit encoded SAI value."},
#else
{24, 24, 0x0000000000000000, "RW", "IMR12_READ_POL_24", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{23, 23, 0x0000000000000000, "RO", "IMR12_READ_POL_23", "Bunit IMR12 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR12 region based on the agents 6bit encoded SAI value."},
#else
{23, 23, 0x0000000000000000, "RO", "IMR12_READ_POL_23", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{22, 22, 0x0000000000000000, "RO", "IMR12_READ_POL_22", "Bunit IMR12 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR12 region based on the agents 6bit encoded SAI value."},
#else
{22, 22, 0x0000000000000000, "RO", "IMR12_READ_POL_22", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{21, 21, 0x0000000000000000, "RW", "IMR12_READ_POL_21", "Bunit IMR12 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR12 region based on the agents 6bit encoded SAI value."},
#else
{21, 21, 0x0000000000000000, "RW", "IMR12_READ_POL_21", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{20, 20, 0x0000000000000000, "RO", "IMR12_READ_POL_20", "Bunit IMR12 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR12 region based on the agents 6bit encoded SAI value."},
#else
{20, 20, 0x0000000000000000, "RO", "IMR12_READ_POL_20", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{19, 19, 0x0000000000000000, "RO", "IMR12_READ_POL_19", "Bunit IMR12 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR12 region based on the agents 6bit encoded SAI value."},
#else
{19, 19, 0x0000000000000000, "RO", "IMR12_READ_POL_19", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{18, 18, 0x0000000000000000, "RO", "IMR12_READ_POL_18", "Bunit IMR12 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR12 region based on the agents 6bit encoded SAI value."},
#else
{18, 18, 0x0000000000000000, "RO", "IMR12_READ_POL_18", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{17, 17, 0x0000000000000000, "RW", "IMR12_READ_POL_17", "Bunit IMR12 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR12 region based on the agents 6bit encoded SAI value."},
#else
{17, 17, 0x0000000000000000, "RW", "IMR12_READ_POL_17", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{16, 16, 0x0000000000000000, "RW", "IMR12_READ_POL_16", "Bunit IMR12 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR12 region based on the agents 6bit encoded SAI value."},
#else
{16, 16, 0x0000000000000000, "RW", "IMR12_READ_POL_16", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{15, 15, 0x0000000000000000, "RO", "IMR12_READ_POL_15", "Bunit IMR12 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR12 region based on the agents 6bit encoded SAI value."},
#else
{15, 15, 0x0000000000000000, "RO", "IMR12_READ_POL_15", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{14, 14, 0x0000000000000000, "RO", "IMR12_READ_POL_14", "Bunit IMR12 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR12 region based on the agents 6bit encoded SAI value."},
#else
{14, 14, 0x0000000000000000, "RO", "IMR12_READ_POL_14", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{13, 13, 0x0000000000000000, "RW", "IMR12_READ_POL_13", "Bunit IMR12 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR12 region based on the agents 6bit encoded SAI value."},
#else
{13, 13, 0x0000000000000000, "RW", "IMR12_READ_POL_13", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{12, 12, 0x0000000000000000, "RW", "IMR12_READ_POL_12", "Bunit IMR12 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR12 region based on the agents 6bit encoded SAI value."},
#else
{12, 12, 0x0000000000000000, "RW", "IMR12_READ_POL_12", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{11, 11, 0x0000000000000000, "RO", "IMR12_READ_POL_11", "Bunit IMR12 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR12 region based on the agents 6bit encoded SAI value."},
#else
{11, 11, 0x0000000000000000, "RO", "IMR12_READ_POL_11", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{10, 10, 0x0000000000000000, "RO", "IMR12_READ_POL_10", "Bunit IMR12 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR12 region based on the agents 6bit encoded SAI value."},
#else
{10, 10, 0x0000000000000000, "RO", "IMR12_READ_POL_10", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{9, 9, 0x0000000000000000, "RO", "IMR12_READ_POL_9", "Bunit IMR12 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR12 region based on the agents 6bit encoded SAI value."},
#else
{9, 9, 0x0000000000000000, "RO", "IMR12_READ_POL_9", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{8, 8, 0x0000000000000000, "RW", "IMR12_READ_POL_8", "Bunit IMR12 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR12 region based on the agents 6bit encoded SAI value."},
#else
{8, 8, 0x0000000000000000, "RW", "IMR12_READ_POL_8", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{7, 7, 0x0000000000000000, "RO", "IMR12_READ_POL_7", "Bunit IMR12 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR12 region based on the agents 6bit encoded SAI value."},
#else
{7, 7, 0x0000000000000000, "RO", "IMR12_READ_POL_7", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{6, 6, 0x0000000000000000, "RO", "IMR12_READ_POL_6", "Bunit IMR12 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR12 region based on the agents 6bit encoded SAI value."},
#else
{6, 6, 0x0000000000000000, "RO", "IMR12_READ_POL_6", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{5, 5, 0x0000000000000000, "RW", "IMR12_READ_POL_5", "Bunit IMR12 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR12 region based on the agents 6bit encoded SAI value."},
#else
{5, 5, 0x0000000000000000, "RW", "IMR12_READ_POL_5", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{4, 4, 0x0000000000000000, "RW", "IMR12_READ_POL_4", "Bunit IMR12 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR12 region based on the agents 6bit encoded SAI value."},
#else
{4, 4, 0x0000000000000000, "RW", "IMR12_READ_POL_4", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{3, 3, 0x0000000000000000, "RW", "IMR12_READ_POL_3", "Bunit IMR12 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR12 region based on the agents 6bit encoded SAI value."},
#else
{3, 3, 0x0000000000000000, "RW", "IMR12_READ_POL_3", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{2, 2, 0x0000000000000000, "RW", "IMR12_READ_POL_2", "Bunit IMR12 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR12 region based on the agents 6bit encoded SAI value."},
#else
{2, 2, 0x0000000000000000, "RW", "IMR12_READ_POL_2", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{1, 1, 0x0000000000000000, "RW", "IMR12_READ_POL_1", "Bunit IMR12 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR12 region based on the agents 6bit encoded SAI value."},
#else
{1, 1, 0x0000000000000000, "RW", "IMR12_READ_POL_1", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 0, 0x0000000000000000, "RW", "IMR12_READ_POL_0", "Bunit IMR12 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR12 region based on the agents 6bit encoded SAI value."},
#else
{0, 0, 0x0000000000000000, "RW", "IMR12_READ_POL_0", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo940[] = {{"B_CR_BIMR12RAC_0_0_0_MCHBAR", "", 0x00006A00, 64, 0xFFFFFFFFFFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields941[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{63, 63, 0x0000000000000000, "RW", "IMR12_WRITE_POL_63", "Bunit IMR12 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR12 region based on the agents 6bit encoded SAI value."},
#else
{63, 63, 0x0000000000000000, "RW", "IMR12_WRITE_POL_63", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{62, 62, 0x0000000000000000, "RO", "IMR12_WRITE_POL_62", "Bunit IMR12 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR12 region based on the agents 6bit encoded SAI value."},
#else
{62, 62, 0x0000000000000000, "RO", "IMR12_WRITE_POL_62", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{61, 61, 0x0000000000000000, "RO", "IMR12_WRITE_POL_61", "Bunit IMR12 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR12 region based on the agents 6bit encoded SAI value."},
#else
{61, 61, 0x0000000000000000, "RO", "IMR12_WRITE_POL_61", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{60, 60, 0x0000000000000000, "RO", "IMR12_WRITE_POL_60", "Bunit IMR12 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR12 region based on the agents 6bit encoded SAI value."},
#else
{60, 60, 0x0000000000000000, "RO", "IMR12_WRITE_POL_60", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{59, 59, 0x0000000000000000, "RO", "IMR12_WRITE_POL_59", "Bunit IMR12 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR12 region based on the agents 6bit encoded SAI value."},
#else
{59, 59, 0x0000000000000000, "RO", "IMR12_WRITE_POL_59", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{58, 58, 0x0000000000000000, "RO", "IMR12_WRITE_POL_58", "Bunit IMR12 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR12 region based on the agents 6bit encoded SAI value."},
#else
{58, 58, 0x0000000000000000, "RO", "IMR12_WRITE_POL_58", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{57, 57, 0x0000000000000000, "RO", "IMR12_WRITE_POL_57", "Bunit IMR12 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR12 region based on the agents 6bit encoded SAI value."},
#else
{57, 57, 0x0000000000000000, "RO", "IMR12_WRITE_POL_57", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{56, 56, 0x0000000000000000, "RW", "IMR12_WRITE_POL_56", "Bunit IMR12 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR12 region based on the agents 6bit encoded SAI value."},
#else
{56, 56, 0x0000000000000000, "RW", "IMR12_WRITE_POL_56", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{55, 55, 0x0000000000000000, "RW", "IMR12_WRITE_POL_55", "Bunit IMR12 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR12 region based on the agents 6bit encoded SAI value."},
#else
{55, 55, 0x0000000000000000, "RW", "IMR12_WRITE_POL_55", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{54, 54, 0x0000000000000000, "RW", "IMR12_WRITE_POL_54", "Bunit IMR12 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR12 region based on the agents 6bit encoded SAI value."},
#else
{54, 54, 0x0000000000000000, "RW", "IMR12_WRITE_POL_54", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{53, 53, 0x0000000000000000, "RO", "IMR12_WRITE_POL_53", "Bunit IMR12 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR12 region based on the agents 6bit encoded SAI value."},
#else
{53, 53, 0x0000000000000000, "RO", "IMR12_WRITE_POL_53", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{52, 52, 0x0000000000000000, "RO", "IMR12_WRITE_POL_52", "Bunit IMR12 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR12 region based on the agents 6bit encoded SAI value."},
#else
{52, 52, 0x0000000000000000, "RO", "IMR12_WRITE_POL_52", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{51, 51, 0x0000000000000000, "RO", "IMR12_WRITE_POL_51", "Bunit IMR12 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR12 region based on the agents 6bit encoded SAI value."},
#else
{51, 51, 0x0000000000000000, "RO", "IMR12_WRITE_POL_51", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{50, 50, 0x0000000000000000, "RW", "IMR12_WRITE_POL_50", "Bunit IMR12 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR12 region based on the agents 6bit encoded SAI value."},
#else
{50, 50, 0x0000000000000000, "RW", "IMR12_WRITE_POL_50", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{49, 49, 0x0000000000000000, "RW", "IMR12_WRITE_POL_49", "Bunit IMR12 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR12 region based on the agents 6bit encoded SAI value."},
#else
{49, 49, 0x0000000000000000, "RW", "IMR12_WRITE_POL_49", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{48, 48, 0x0000000000000000, "RW", "IMR12_WRITE_POL_48", "Bunit IMR12 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR12 region based on the agents 6bit encoded SAI value."},
#else
{48, 48, 0x0000000000000000, "RW", "IMR12_WRITE_POL_48", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{47, 47, 0x0000000000000000, "RO", "IMR12_WRITE_POL_47", "Bunit IMR12 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR12 region based on the agents 6bit encoded SAI value."},
#else
{47, 47, 0x0000000000000000, "RO", "IMR12_WRITE_POL_47", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{46, 46, 0x0000000000000000, "RO", "IMR12_WRITE_POL_46", "Bunit IMR12 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR12 region based on the agents 6bit encoded SAI value."},
#else
{46, 46, 0x0000000000000000, "RO", "IMR12_WRITE_POL_46", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{45, 45, 0x0000000000000000, "RO", "IMR12_WRITE_POL_45", "Bunit IMR12 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR12 region based on the agents 6bit encoded SAI value."},
#else
{45, 45, 0x0000000000000000, "RO", "IMR12_WRITE_POL_45", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{44, 44, 0x0000000000000000, "RW", "IMR12_WRITE_POL_44", "Bunit IMR12 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR12 region based on the agents 6bit encoded SAI value."},
#else
{44, 44, 0x0000000000000000, "RW", "IMR12_WRITE_POL_44", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{43, 43, 0x0000000000000000, "RW", "IMR12_WRITE_POL_43", "Bunit IMR12 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR12 region based on the agents 6bit encoded SAI value."},
#else
{43, 43, 0x0000000000000000, "RW", "IMR12_WRITE_POL_43", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{42, 42, 0x0000000000000000, "RW", "IMR12_WRITE_POL_42", "Bunit IMR12 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR12 region based on the agents 6bit encoded SAI value."},
#else
{42, 42, 0x0000000000000000, "RW", "IMR12_WRITE_POL_42", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{41, 41, 0x0000000000000000, "RW", "IMR12_WRITE_POL_41", "Bunit IMR12 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR12 region based on the agents 6bit encoded SAI value."},
#else
{41, 41, 0x0000000000000000, "RW", "IMR12_WRITE_POL_41", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{40, 40, 0x0000000000000000, "RW", "IMR12_WRITE_POL_40", "Bunit IMR12 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR12 region based on the agents 6bit encoded SAI value."},
#else
{40, 40, 0x0000000000000000, "RW", "IMR12_WRITE_POL_40", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{39, 39, 0x0000000000000000, "RO", "IMR12_WRITE_POL_39", "Bunit IMR12 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR12 region based on the agents 6bit encoded SAI value."},
#else
{39, 39, 0x0000000000000000, "RO", "IMR12_WRITE_POL_39", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{38, 38, 0x0000000000000000, "RW", "IMR12_WRITE_POL_38", "Bunit IMR12 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR12 region based on the agents 6bit encoded SAI value."},
#else
{38, 38, 0x0000000000000000, "RW", "IMR12_WRITE_POL_38", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{37, 37, 0x0000000000000000, "RO", "IMR12_WRITE_POL_37", "Bunit IMR12 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR12 region based on the agents 6bit encoded SAI value."},
#else
{37, 37, 0x0000000000000000, "RO", "IMR12_WRITE_POL_37", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{36, 36, 0x0000000000000000, "RW", "IMR12_WRITE_POL_36", "Bunit IMR12 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR12 region based on the agents 6bit encoded SAI value."},
#else
{36, 36, 0x0000000000000000, "RW", "IMR12_WRITE_POL_36", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{35, 35, 0x0000000000000000, "RO", "IMR12_WRITE_POL_35", "Bunit IMR12 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR12 region based on the agents 6bit encoded SAI value."},
#else
{35, 35, 0x0000000000000000, "RO", "IMR12_WRITE_POL_35", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{34, 34, 0x0000000000000000, "RW", "IMR12_WRITE_POL_34", "Bunit IMR12 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR12 region based on the agents 6bit encoded SAI value."},
#else
{34, 34, 0x0000000000000000, "RW", "IMR12_WRITE_POL_34", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{33, 33, 0x0000000000000000, "RW", "IMR12_WRITE_POL_33", "Bunit IMR12 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR12 region based on the agents 6bit encoded SAI value."},
#else
{33, 33, 0x0000000000000000, "RW", "IMR12_WRITE_POL_33", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{32, 32, 0x0000000000000000, "RW", "IMR12_WRITE_POL_32", "Bunit IMR12 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR12 region based on the agents 6bit encoded SAI value."},
#else
{32, 32, 0x0000000000000000, "RW", "IMR12_WRITE_POL_32", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{31, 31, 0x0000000000000000, "RO", "IMR12_WRITE_POL_31", "Bunit IMR12 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR12 region based on the agents 6bit encoded SAI value."},
#else
{31, 31, 0x0000000000000000, "RO", "IMR12_WRITE_POL_31", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{30, 30, 0x0000000000000000, "RW", "IMR12_WRITE_POL_30", "Bunit IMR12 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR12 region based on the agents 6bit encoded SAI value."},
#else
{30, 30, 0x0000000000000000, "RW", "IMR12_WRITE_POL_30", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{29, 29, 0x0000000000000000, "RW", "IMR12_WRITE_POL_29", "Bunit IMR12 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR12 region based on the agents 6bit encoded SAI value."},
#else
{29, 29, 0x0000000000000000, "RW", "IMR12_WRITE_POL_29", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{28, 28, 0x0000000000000000, "RW", "IMR12_WRITE_POL_28", "Bunit IMR12 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR12 region based on the agents 6bit encoded SAI value."},
#else
{28, 28, 0x0000000000000000, "RW", "IMR12_WRITE_POL_28", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{27, 27, 0x0000000000000000, "RW", "IMR12_WRITE_POL_27", "Bunit IMR12 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR12 region based on the agents 6bit encoded SAI value."},
#else
{27, 27, 0x0000000000000000, "RW", "IMR12_WRITE_POL_27", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{26, 26, 0x0000000000000000, "RW", "IMR12_WRITE_POL_26", "Bunit IMR12 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR12 region based on the agents 6bit encoded SAI value."},
#else
{26, 26, 0x0000000000000000, "RW", "IMR12_WRITE_POL_26", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{25, 25, 0x0000000000000000, "RW", "IMR12_WRITE_POL_25", "Bunit IMR12 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR12 region based on the agents 6bit encoded SAI value."},
#else
{25, 25, 0x0000000000000000, "RW", "IMR12_WRITE_POL_25", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{24, 24, 0x0000000000000000, "RW", "IMR12_WRITE_POL_24", "Bunit IMR12 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR12 region based on the agents 6bit encoded SAI value."},
#else
{24, 24, 0x0000000000000000, "RW", "IMR12_WRITE_POL_24", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{23, 23, 0x0000000000000000, "RO", "IMR12_WRITE_POL_23", "Bunit IMR12 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR12 region based on the agents 6bit encoded SAI value."},
#else
{23, 23, 0x0000000000000000, "RO", "IMR12_WRITE_POL_23", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{22, 22, 0x0000000000000000, "RO", "IMR12_WRITE_POL_22", "Bunit IMR12 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR12 region based on the agents 6bit encoded SAI value."},
#else
{22, 22, 0x0000000000000000, "RO", "IMR12_WRITE_POL_22", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{21, 21, 0x0000000000000000, "RW", "IMR12_WRITE_POL_21", "Bunit IMR12 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR12 region based on the agents 6bit encoded SAI value."},
#else
{21, 21, 0x0000000000000000, "RW", "IMR12_WRITE_POL_21", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{20, 20, 0x0000000000000000, "RO", "IMR12_WRITE_POL_20", "Bunit IMR12 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR12 region based on the agents 6bit encoded SAI value."},
#else
{20, 20, 0x0000000000000000, "RO", "IMR12_WRITE_POL_20", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{19, 19, 0x0000000000000000, "RO", "IMR12_WRITE_POL_19", "Bunit IMR12 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR12 region based on the agents 6bit encoded SAI value."},
#else
{19, 19, 0x0000000000000000, "RO", "IMR12_WRITE_POL_19", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{18, 18, 0x0000000000000000, "RO", "IMR12_WRITE_POL_18", "Bunit IMR12 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR12 region based on the agents 6bit encoded SAI value."},
#else
{18, 18, 0x0000000000000000, "RO", "IMR12_WRITE_POL_18", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{17, 17, 0x0000000000000000, "RW", "IMR12_WRITE_POL_17", "Bunit IMR12 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR12 region based on the agents 6bit encoded SAI value."},
#else
{17, 17, 0x0000000000000000, "RW", "IMR12_WRITE_POL_17", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{16, 16, 0x0000000000000000, "RW", "IMR12_WRITE_POL_16", "Bunit IMR12 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR12 region based on the agents 6bit encoded SAI value."},
#else
{16, 16, 0x0000000000000000, "RW", "IMR12_WRITE_POL_16", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{15, 15, 0x0000000000000000, "RO", "IMR12_WRITE_POL_15", "Bunit IMR12 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR12 region based on the agents 6bit encoded SAI value."},
#else
{15, 15, 0x0000000000000000, "RO", "IMR12_WRITE_POL_15", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{14, 14, 0x0000000000000000, "RO", "IMR12_WRITE_POL_14", "Bunit IMR12 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR12 region based on the agents 6bit encoded SAI value."},
#else
{14, 14, 0x0000000000000000, "RO", "IMR12_WRITE_POL_14", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{13, 13, 0x0000000000000000, "RW", "IMR12_WRITE_POL_13", "Bunit IMR12 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR12 region based on the agents 6bit encoded SAI value."},
#else
{13, 13, 0x0000000000000000, "RW", "IMR12_WRITE_POL_13", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{12, 12, 0x0000000000000000, "RW", "IMR12_WRITE_POL_12", "Bunit IMR12 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR12 region based on the agents 6bit encoded SAI value."},
#else
{12, 12, 0x0000000000000000, "RW", "IMR12_WRITE_POL_12", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{11, 11, 0x0000000000000000, "RO", "IMR12_WRITE_POL_11", "Bunit IMR12 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR12 region based on the agents 6bit encoded SAI value."},
#else
{11, 11, 0x0000000000000000, "RO", "IMR12_WRITE_POL_11", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{10, 10, 0x0000000000000000, "RO", "IMR12_WRITE_POL_10", "Bunit IMR12 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR12 region based on the agents 6bit encoded SAI value."},
#else
{10, 10, 0x0000000000000000, "RO", "IMR12_WRITE_POL_10", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{9, 9, 0x0000000000000000, "RO", "IMR12_WRITE_POL_9", "Bunit IMR12 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR12 region based on the agents 6bit encoded SAI value."},
#else
{9, 9, 0x0000000000000000, "RO", "IMR12_WRITE_POL_9", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{8, 8, 0x0000000000000000, "RW", "IMR12_WRITE_POL_8", "Bunit IMR12 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR12 region based on the agents 6bit encoded SAI value."},
#else
{8, 8, 0x0000000000000000, "RW", "IMR12_WRITE_POL_8", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{7, 7, 0x0000000000000000, "RO", "IMR12_WRITE_POL_7", "Bunit IMR12 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR12 region based on the agents 6bit encoded SAI value."},
#else
{7, 7, 0x0000000000000000, "RO", "IMR12_WRITE_POL_7", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{6, 6, 0x0000000000000000, "RO", "IMR12_WRITE_POL_6", "Bunit IMR12 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR12 region based on the agents 6bit encoded SAI value."},
#else
{6, 6, 0x0000000000000000, "RO", "IMR12_WRITE_POL_6", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{5, 5, 0x0000000000000000, "RW", "IMR12_WRITE_POL_5", "Bunit IMR12 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR12 region based on the agents 6bit encoded SAI value."},
#else
{5, 5, 0x0000000000000000, "RW", "IMR12_WRITE_POL_5", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{4, 4, 0x0000000000000000, "RW", "IMR12_WRITE_POL_4", "Bunit IMR12 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR12 region based on the agents 6bit encoded SAI value."},
#else
{4, 4, 0x0000000000000000, "RW", "IMR12_WRITE_POL_4", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{3, 3, 0x0000000000000000, "RW", "IMR12_WRITE_POL_3", "Bunit IMR12 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR12 region based on the agents 6bit encoded SAI value."},
#else
{3, 3, 0x0000000000000000, "RW", "IMR12_WRITE_POL_3", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{2, 2, 0x0000000000000000, "RW", "IMR12_WRITE_POL_2", "Bunit IMR12 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR12 region based on the agents 6bit encoded SAI value."},
#else
{2, 2, 0x0000000000000000, "RW", "IMR12_WRITE_POL_2", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{1, 1, 0x0000000000000000, "RW", "IMR12_WRITE_POL_1", "Bunit IMR12 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR12 region based on the agents 6bit encoded SAI value."},
#else
{1, 1, 0x0000000000000000, "RW", "IMR12_WRITE_POL_1", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 0, 0x0000000000000000, "RW", "IMR12_WRITE_POL_0", "Bunit IMR12 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR12 region based on the agents 6bit encoded SAI value."},
#else
{0, 0, 0x0000000000000000, "RW", "IMR12_WRITE_POL_0", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo941[] = {{"B_CR_BIMR12WAC_0_0_0_MCHBAR", "", 0x00006A08, 64, 0xFFFFFFFFFFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields942[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{31, 31, 0x0000000000000000, "RW", "IMR_EN", "IMR Enable: Enables access checking for the IMR region."},
#else
{31, 31, 0x0000000000000000, "RW", "IMR_EN", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{30, 30, 0x0000000000000000, "RW", "TR_EN", "Asset Classification AC[0]: Trace Enable: Enables snooping of transactions to the IMR region by tracing agents."},
#else
{30, 30, 0x0000000000000000, "RW", "TR_EN", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{29, 29, 0x0000000000000000, "RO", "RESERVED_1", "Reserved"},
#else
{29, 29, 0x0000000000000000, "RO", "RESERVED_1", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 28, 0x0000000000000000, "RW", "IMR13_BASE", "Base 0 IMR13BASE:  Specifies bits 38:10 of the start address of IMR13 region.  IMR region size must be a strict poweroftwo at least 1KB and naturally aligned to the size.  These bits are compared with the result of the IMR13MASK[28:0] applied to bits 38:10 of the incoming address to determine if an access falls within the IMR13 defined region."},
#else
{0, 28, 0x0000000000000000, "RW", "IMR13_BASE", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo942[] = {{"B_CR_BIMR13BASE_0_0_0_MCHBAR", "", 0x00006A10, 4, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields943[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{31, 31, 0x0000000000000000, "RW", "GT_IWB_EN", "Asset Classification AC[2]: GT Implicit WB Enable: Enables implicit writebacks to protected region from GT caching agent. When set to 1 enables implicit writeback data HITM data from GT to be returned to the requester.  When set to 0 inhibits HITM data from GT from being returned to the requester.  HITM data from IA cores may be returned to the requester depending on the setting of the IA_IWB_EN bit."},
#else
{31, 31, 0x0000000000000000, "RW", "GT_IWB_EN", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{30, 30, 0x0000000000000000, "RW", "IA_IWB_EN", "Asset Classification AC[1]: IA Implicit WB Enable: Enables implicit writebacks to protected region from IA caching agent.  When set to 1 enables implicit writeback data HITM data from IA cores to be returned to the requester.  When set to 0 inhibits HITM data from IA cores from being returned to the requester.  HITM data from GT may be returned to the requester depending on the setting of the GT_IWB_EN bit."},
#else
{30, 30, 0x0000000000000000, "RW", "IA_IWB_EN", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{29, 29, 0x0000000000000000, "RO", "RESERVED_0", "Reserved"},
#else
{29, 29, 0x0000000000000000, "RO", "RESERVED_0", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 28, 0x0000000000000000, "RW", "IMR13_MASK", "Mask 0 IMR13MASK:  These bits are ANDed with bits 38:10 of the incoming address to determine if the combined result matches the IMR13BASE[28:0] value.  A match indicates the the incoming address falls within the IMR13 region."},
#else
{0, 28, 0x0000000000000000, "RW", "IMR13_MASK", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo943[] = {{"B_CR_BIMR13MASK_0_0_0_MCHBAR", "", 0x00006A14, 4, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields944[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{0, 63, 0x00000C0061010202, "RW", "IMR13_CTRL_POL", "Bunit IMR13 Control Policy: Bit vector used to determine which agents are allowed access to the BIMR13RAC, BIMR13WAC, BIMR13CP registers based on the value from the agents 6bit SAI field."},
#else
{0, 63, 0x00000C0061010202, "RW", "IMR13_CTRL_POL", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo944[] = {{"B_CR_BIMR13CP_0_0_0_MCHBAR", "", 0x00006A18, 1, 0xFFFFFFFFFFFFFFFF, 0x00000C0061010202}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields945[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{63, 63, 0x0000000000000000, "RW", "IMR13_READ_POL_63", "Bunit IMR13 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR13 region based on the agents 6bit encoded SAI value."},
#else
{63, 63, 0x0000000000000000, "RW", "IMR13_READ_POL_63", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{62, 62, 0x0000000000000000, "RO", "IMR13_READ_POL_62", "Bunit IMR13 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR13 region based on the agents 6bit encoded SAI value."},
#else
{62, 62, 0x0000000000000000, "RO", "IMR13_READ_POL_62", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{61, 61, 0x0000000000000000, "RO", "IMR13_READ_POL_61", "Bunit IMR13 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR13 region based on the agents 6bit encoded SAI value."},
#else
{61, 61, 0x0000000000000000, "RO", "IMR13_READ_POL_61", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{60, 60, 0x0000000000000000, "RO", "IMR13_READ_POL_60", "Bunit IMR13 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR13 region based on the agents 6bit encoded SAI value."},
#else
{60, 60, 0x0000000000000000, "RO", "IMR13_READ_POL_60", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{59, 59, 0x0000000000000000, "RO", "IMR13_READ_POL_59", "Bunit IMR13 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR13 region based on the agents 6bit encoded SAI value."},
#else
{59, 59, 0x0000000000000000, "RO", "IMR13_READ_POL_59", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{58, 58, 0x0000000000000000, "RO", "IMR13_READ_POL_58", "Bunit IMR13 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR13 region based on the agents 6bit encoded SAI value."},
#else
{58, 58, 0x0000000000000000, "RO", "IMR13_READ_POL_58", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{57, 57, 0x0000000000000000, "RO", "IMR13_READ_POL_57", "Bunit IMR13 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR13 region based on the agents 6bit encoded SAI value."},
#else
{57, 57, 0x0000000000000000, "RO", "IMR13_READ_POL_57", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{56, 56, 0x0000000000000000, "RW", "IMR13_READ_POL_56", "Bunit IMR13 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR13 region based on the agents 6bit encoded SAI value."},
#else
{56, 56, 0x0000000000000000, "RW", "IMR13_READ_POL_56", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{55, 55, 0x0000000000000000, "RW", "IMR13_READ_POL_55", "Bunit IMR13 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR13 region based on the agents 6bit encoded SAI value."},
#else
{55, 55, 0x0000000000000000, "RW", "IMR13_READ_POL_55", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{54, 54, 0x0000000000000000, "RW", "IMR13_READ_POL_54", "Bunit IMR13 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR13 region based on the agents 6bit encoded SAI value."},
#else
{54, 54, 0x0000000000000000, "RW", "IMR13_READ_POL_54", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{53, 53, 0x0000000000000000, "RO", "IMR13_READ_POL_53", "Bunit IMR13 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR13 region based on the agents 6bit encoded SAI value."},
#else
{53, 53, 0x0000000000000000, "RO", "IMR13_READ_POL_53", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{52, 52, 0x0000000000000000, "RO", "IMR13_READ_POL_52", "Bunit IMR13 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR13 region based on the agents 6bit encoded SAI value."},
#else
{52, 52, 0x0000000000000000, "RO", "IMR13_READ_POL_52", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{51, 51, 0x0000000000000000, "RO", "IMR13_READ_POL_51", "Bunit IMR13 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR13 region based on the agents 6bit encoded SAI value."},
#else
{51, 51, 0x0000000000000000, "RO", "IMR13_READ_POL_51", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{50, 50, 0x0000000000000000, "RW", "IMR13_READ_POL_50", "Bunit IMR13 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR13 region based on the agents 6bit encoded SAI value."},
#else
{50, 50, 0x0000000000000000, "RW", "IMR13_READ_POL_50", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{49, 49, 0x0000000000000000, "RW", "IMR13_READ_POL_49", "Bunit IMR13 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR13 region based on the agents 6bit encoded SAI value."},
#else
{49, 49, 0x0000000000000000, "RW", "IMR13_READ_POL_49", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{48, 48, 0x0000000000000000, "RW", "IMR13_READ_POL_48", "Bunit IMR13 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR13 region based on the agents 6bit encoded SAI value."},
#else
{48, 48, 0x0000000000000000, "RW", "IMR13_READ_POL_48", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{47, 47, 0x0000000000000000, "RO", "IMR13_READ_POL_47", "Bunit IMR13 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR13 region based on the agents 6bit encoded SAI value."},
#else
{47, 47, 0x0000000000000000, "RO", "IMR13_READ_POL_47", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{46, 46, 0x0000000000000000, "RO", "IMR13_READ_POL_46", "Bunit IMR13 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR13 region based on the agents 6bit encoded SAI value."},
#else
{46, 46, 0x0000000000000000, "RO", "IMR13_READ_POL_46", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{45, 45, 0x0000000000000000, "RO", "IMR13_READ_POL_45", "Bunit IMR13 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR13 region based on the agents 6bit encoded SAI value."},
#else
{45, 45, 0x0000000000000000, "RO", "IMR13_READ_POL_45", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{44, 44, 0x0000000000000000, "RW", "IMR13_READ_POL_44", "Bunit IMR13 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR13 region based on the agents 6bit encoded SAI value."},
#else
{44, 44, 0x0000000000000000, "RW", "IMR13_READ_POL_44", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{43, 43, 0x0000000000000000, "RW", "IMR13_READ_POL_43", "Bunit IMR13 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR13 region based on the agents 6bit encoded SAI value."},
#else
{43, 43, 0x0000000000000000, "RW", "IMR13_READ_POL_43", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{42, 42, 0x0000000000000000, "RW", "IMR13_READ_POL_42", "Bunit IMR13 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR13 region based on the agents 6bit encoded SAI value."},
#else
{42, 42, 0x0000000000000000, "RW", "IMR13_READ_POL_42", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{41, 41, 0x0000000000000000, "RW", "IMR13_READ_POL_41", "Bunit IMR13 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR13 region based on the agents 6bit encoded SAI value."},
#else
{41, 41, 0x0000000000000000, "RW", "IMR13_READ_POL_41", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{40, 40, 0x0000000000000000, "RW", "IMR13_READ_POL_40", "Bunit IMR13 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR13 region based on the agents 6bit encoded SAI value."},
#else
{40, 40, 0x0000000000000000, "RW", "IMR13_READ_POL_40", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{39, 39, 0x0000000000000000, "RO", "IMR13_READ_POL_39", "Bunit IMR13 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR13 region based on the agents 6bit encoded SAI value."},
#else
{39, 39, 0x0000000000000000, "RO", "IMR13_READ_POL_39", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{38, 38, 0x0000000000000000, "RW", "IMR13_READ_POL_38", "Bunit IMR13 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR13 region based on the agents 6bit encoded SAI value."},
#else
{38, 38, 0x0000000000000000, "RW", "IMR13_READ_POL_38", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{37, 37, 0x0000000000000000, "RO", "IMR13_READ_POL_37", "Bunit IMR13 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR13 region based on the agents 6bit encoded SAI value."},
#else
{37, 37, 0x0000000000000000, "RO", "IMR13_READ_POL_37", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{36, 36, 0x0000000000000000, "RW", "IMR13_READ_POL_36", "Bunit IMR13 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR13 region based on the agents 6bit encoded SAI value."},
#else
{36, 36, 0x0000000000000000, "RW", "IMR13_READ_POL_36", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{35, 35, 0x0000000000000000, "RO", "IMR13_READ_POL_35", "Bunit IMR13 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR13 region based on the agents 6bit encoded SAI value."},
#else
{35, 35, 0x0000000000000000, "RO", "IMR13_READ_POL_35", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{34, 34, 0x0000000000000000, "RW", "IMR13_READ_POL_34", "Bunit IMR13 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR13 region based on the agents 6bit encoded SAI value."},
#else
{34, 34, 0x0000000000000000, "RW", "IMR13_READ_POL_34", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{33, 33, 0x0000000000000000, "RW", "IMR13_READ_POL_33", "Bunit IMR13 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR13 region based on the agents 6bit encoded SAI value."},
#else
{33, 33, 0x0000000000000000, "RW", "IMR13_READ_POL_33", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{32, 32, 0x0000000000000000, "RW", "IMR13_READ_POL_32", "Bunit IMR13 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR13 region based on the agents 6bit encoded SAI value."},
#else
{32, 32, 0x0000000000000000, "RW", "IMR13_READ_POL_32", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{31, 31, 0x0000000000000000, "RO", "IMR13_READ_POL_31", "Bunit IMR13 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR13 region based on the agents 6bit encoded SAI value."},
#else
{31, 31, 0x0000000000000000, "RO", "IMR13_READ_POL_31", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{30, 30, 0x0000000000000000, "RW", "IMR13_READ_POL_30", "Bunit IMR13 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR13 region based on the agents 6bit encoded SAI value."},
#else
{30, 30, 0x0000000000000000, "RW", "IMR13_READ_POL_30", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{29, 29, 0x0000000000000000, "RW", "IMR13_READ_POL_29", "Bunit IMR13 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR13 region based on the agents 6bit encoded SAI value."},
#else
{29, 29, 0x0000000000000000, "RW", "IMR13_READ_POL_29", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{28, 28, 0x0000000000000000, "RW", "IMR13_READ_POL_28", "Bunit IMR13 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR13 region based on the agents 6bit encoded SAI value."},
#else
{28, 28, 0x0000000000000000, "RW", "IMR13_READ_POL_28", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{27, 27, 0x0000000000000000, "RW", "IMR13_READ_POL_27", "Bunit IMR13 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR13 region based on the agents 6bit encoded SAI value."},
#else
{27, 27, 0x0000000000000000, "RW", "IMR13_READ_POL_27", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{26, 26, 0x0000000000000000, "RW", "IMR13_READ_POL_26", "Bunit IMR13 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR13 region based on the agents 6bit encoded SAI value."},
#else
{26, 26, 0x0000000000000000, "RW", "IMR13_READ_POL_26", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{25, 25, 0x0000000000000000, "RW", "IMR13_READ_POL_25", "Bunit IMR13 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR13 region based on the agents 6bit encoded SAI value."},
#else
{25, 25, 0x0000000000000000, "RW", "IMR13_READ_POL_25", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{24, 24, 0x0000000000000000, "RW", "IMR13_READ_POL_24", "Bunit IMR13 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR13 region based on the agents 6bit encoded SAI value."},
#else
{24, 24, 0x0000000000000000, "RW", "IMR13_READ_POL_24", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{23, 23, 0x0000000000000000, "RO", "IMR13_READ_POL_23", "Bunit IMR13 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR13 region based on the agents 6bit encoded SAI value."},
#else
{23, 23, 0x0000000000000000, "RO", "IMR13_READ_POL_23", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{22, 22, 0x0000000000000000, "RO", "IMR13_READ_POL_22", "Bunit IMR13 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR13 region based on the agents 6bit encoded SAI value."},
#else
{22, 22, 0x0000000000000000, "RO", "IMR13_READ_POL_22", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{21, 21, 0x0000000000000000, "RW", "IMR13_READ_POL_21", "Bunit IMR13 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR13 region based on the agents 6bit encoded SAI value."},
#else
{21, 21, 0x0000000000000000, "RW", "IMR13_READ_POL_21", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{20, 20, 0x0000000000000000, "RO", "IMR13_READ_POL_20", "Bunit IMR13 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR13 region based on the agents 6bit encoded SAI value."},
#else
{20, 20, 0x0000000000000000, "RO", "IMR13_READ_POL_20", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{19, 19, 0x0000000000000000, "RO", "IMR13_READ_POL_19", "Bunit IMR13 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR13 region based on the agents 6bit encoded SAI value."},
#else
{19, 19, 0x0000000000000000, "RO", "IMR13_READ_POL_19", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{18, 18, 0x0000000000000000, "RO", "IMR13_READ_POL_18", "Bunit IMR13 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR13 region based on the agents 6bit encoded SAI value."},
#else
{18, 18, 0x0000000000000000, "RO", "IMR13_READ_POL_18", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{17, 17, 0x0000000000000000, "RW", "IMR13_READ_POL_17", "Bunit IMR13 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR13 region based on the agents 6bit encoded SAI value."},
#else
{17, 17, 0x0000000000000000, "RW", "IMR13_READ_POL_17", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{16, 16, 0x0000000000000000, "RW", "IMR13_READ_POL_16", "Bunit IMR13 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR13 region based on the agents 6bit encoded SAI value."},
#else
{16, 16, 0x0000000000000000, "RW", "IMR13_READ_POL_16", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{15, 15, 0x0000000000000000, "RO", "IMR13_READ_POL_15", "Bunit IMR13 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR13 region based on the agents 6bit encoded SAI value."},
#else
{15, 15, 0x0000000000000000, "RO", "IMR13_READ_POL_15", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{14, 14, 0x0000000000000000, "RO", "IMR13_READ_POL_14", "Bunit IMR13 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR13 region based on the agents 6bit encoded SAI value."},
#else
{14, 14, 0x0000000000000000, "RO", "IMR13_READ_POL_14", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{13, 13, 0x0000000000000000, "RW", "IMR13_READ_POL_13", "Bunit IMR13 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR13 region based on the agents 6bit encoded SAI value."},
#else
{13, 13, 0x0000000000000000, "RW", "IMR13_READ_POL_13", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{12, 12, 0x0000000000000000, "RW", "IMR13_READ_POL_12", "Bunit IMR13 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR13 region based on the agents 6bit encoded SAI value."},
#else
{12, 12, 0x0000000000000000, "RW", "IMR13_READ_POL_12", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{11, 11, 0x0000000000000000, "RO", "IMR13_READ_POL_11", "Bunit IMR13 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR13 region based on the agents 6bit encoded SAI value."},
#else
{11, 11, 0x0000000000000000, "RO", "IMR13_READ_POL_11", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{10, 10, 0x0000000000000000, "RO", "IMR13_READ_POL_10", "Bunit IMR13 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR13 region based on the agents 6bit encoded SAI value."},
#else
{10, 10, 0x0000000000000000, "RO", "IMR13_READ_POL_10", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{9, 9, 0x0000000000000000, "RO", "IMR13_READ_POL_9", "Bunit IMR13 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR13 region based on the agents 6bit encoded SAI value."},
#else
{9, 9, 0x0000000000000000, "RO", "IMR13_READ_POL_9", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{8, 8, 0x0000000000000000, "RW", "IMR13_READ_POL_8", "Bunit IMR13 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR13 region based on the agents 6bit encoded SAI value."},
#else
{8, 8, 0x0000000000000000, "RW", "IMR13_READ_POL_8", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{7, 7, 0x0000000000000000, "RO", "IMR13_READ_POL_7", "Bunit IMR13 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR13 region based on the agents 6bit encoded SAI value."},
#else
{7, 7, 0x0000000000000000, "RO", "IMR13_READ_POL_7", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{6, 6, 0x0000000000000000, "RO", "IMR13_READ_POL_6", "Bunit IMR13 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR13 region based on the agents 6bit encoded SAI value."},
#else
{6, 6, 0x0000000000000000, "RO", "IMR13_READ_POL_6", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{5, 5, 0x0000000000000000, "RW", "IMR13_READ_POL_5", "Bunit IMR13 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR13 region based on the agents 6bit encoded SAI value."},
#else
{5, 5, 0x0000000000000000, "RW", "IMR13_READ_POL_5", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{4, 4, 0x0000000000000000, "RW", "IMR13_READ_POL_4", "Bunit IMR13 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR13 region based on the agents 6bit encoded SAI value."},
#else
{4, 4, 0x0000000000000000, "RW", "IMR13_READ_POL_4", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{3, 3, 0x0000000000000000, "RW", "IMR13_READ_POL_3", "Bunit IMR13 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR13 region based on the agents 6bit encoded SAI value."},
#else
{3, 3, 0x0000000000000000, "RW", "IMR13_READ_POL_3", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{2, 2, 0x0000000000000000, "RW", "IMR13_READ_POL_2", "Bunit IMR13 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR13 region based on the agents 6bit encoded SAI value."},
#else
{2, 2, 0x0000000000000000, "RW", "IMR13_READ_POL_2", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{1, 1, 0x0000000000000000, "RW", "IMR13_READ_POL_1", "Bunit IMR13 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR13 region based on the agents 6bit encoded SAI value."},
#else
{1, 1, 0x0000000000000000, "RW", "IMR13_READ_POL_1", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 0, 0x0000000000000000, "RW", "IMR13_READ_POL_0", "Bunit IMR13 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR13 region based on the agents 6bit encoded SAI value."},
#else
{0, 0, 0x0000000000000000, "RW", "IMR13_READ_POL_0", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo945[] = {{"B_CR_BIMR13RAC_0_0_0_MCHBAR", "", 0x00006A20, 64, 0xFFFFFFFFFFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields946[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{63, 63, 0x0000000000000000, "RW", "IMR13_WRITE_POL_63", "Bunit IMR13 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR13 region based on the agents 6bit encoded SAI value."},
#else
{63, 63, 0x0000000000000000, "RW", "IMR13_WRITE_POL_63", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{62, 62, 0x0000000000000000, "RO", "IMR13_WRITE_POL_62", "Bunit IMR13 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR13 region based on the agents 6bit encoded SAI value."},
#else
{62, 62, 0x0000000000000000, "RO", "IMR13_WRITE_POL_62", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{61, 61, 0x0000000000000000, "RO", "IMR13_WRITE_POL_61", "Bunit IMR13 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR13 region based on the agents 6bit encoded SAI value."},
#else
{61, 61, 0x0000000000000000, "RO", "IMR13_WRITE_POL_61", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{60, 60, 0x0000000000000000, "RO", "IMR13_WRITE_POL_60", "Bunit IMR13 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR13 region based on the agents 6bit encoded SAI value."},
#else
{60, 60, 0x0000000000000000, "RO", "IMR13_WRITE_POL_60", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{59, 59, 0x0000000000000000, "RO", "IMR13_WRITE_POL_59", "Bunit IMR13 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR13 region based on the agents 6bit encoded SAI value."},
#else
{59, 59, 0x0000000000000000, "RO", "IMR13_WRITE_POL_59", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{58, 58, 0x0000000000000000, "RO", "IMR13_WRITE_POL_58", "Bunit IMR13 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR13 region based on the agents 6bit encoded SAI value."},
#else
{58, 58, 0x0000000000000000, "RO", "IMR13_WRITE_POL_58", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{57, 57, 0x0000000000000000, "RO", "IMR13_WRITE_POL_57", "Bunit IMR13 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR13 region based on the agents 6bit encoded SAI value."},
#else
{57, 57, 0x0000000000000000, "RO", "IMR13_WRITE_POL_57", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{56, 56, 0x0000000000000000, "RW", "IMR13_WRITE_POL_56", "Bunit IMR13 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR13 region based on the agents 6bit encoded SAI value."},
#else
{56, 56, 0x0000000000000000, "RW", "IMR13_WRITE_POL_56", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{55, 55, 0x0000000000000000, "RW", "IMR13_WRITE_POL_55", "Bunit IMR13 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR13 region based on the agents 6bit encoded SAI value."},
#else
{55, 55, 0x0000000000000000, "RW", "IMR13_WRITE_POL_55", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{54, 54, 0x0000000000000000, "RW", "IMR13_WRITE_POL_54", "Bunit IMR13 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR13 region based on the agents 6bit encoded SAI value."},
#else
{54, 54, 0x0000000000000000, "RW", "IMR13_WRITE_POL_54", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{53, 53, 0x0000000000000000, "RO", "IMR13_WRITE_POL_53", "Bunit IMR13 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR13 region based on the agents 6bit encoded SAI value."},
#else
{53, 53, 0x0000000000000000, "RO", "IMR13_WRITE_POL_53", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{52, 52, 0x0000000000000000, "RO", "IMR13_WRITE_POL_52", "Bunit IMR13 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR13 region based on the agents 6bit encoded SAI value."},
#else
{52, 52, 0x0000000000000000, "RO", "IMR13_WRITE_POL_52", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{51, 51, 0x0000000000000000, "RO", "IMR13_WRITE_POL_51", "Bunit IMR13 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR13 region based on the agents 6bit encoded SAI value."},
#else
{51, 51, 0x0000000000000000, "RO", "IMR13_WRITE_POL_51", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{50, 50, 0x0000000000000000, "RW", "IMR13_WRITE_POL_50", "Bunit IMR13 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR13 region based on the agents 6bit encoded SAI value."},
#else
{50, 50, 0x0000000000000000, "RW", "IMR13_WRITE_POL_50", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{49, 49, 0x0000000000000000, "RW", "IMR13_WRITE_POL_49", "Bunit IMR13 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR13 region based on the agents 6bit encoded SAI value."},
#else
{49, 49, 0x0000000000000000, "RW", "IMR13_WRITE_POL_49", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{48, 48, 0x0000000000000000, "RW", "IMR13_WRITE_POL_48", "Bunit IMR13 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR13 region based on the agents 6bit encoded SAI value."},
#else
{48, 48, 0x0000000000000000, "RW", "IMR13_WRITE_POL_48", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{47, 47, 0x0000000000000000, "RO", "IMR13_WRITE_POL_47", "Bunit IMR13 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR13 region based on the agents 6bit encoded SAI value."},
#else
{47, 47, 0x0000000000000000, "RO", "IMR13_WRITE_POL_47", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{46, 46, 0x0000000000000000, "RO", "IMR13_WRITE_POL_46", "Bunit IMR13 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR13 region based on the agents 6bit encoded SAI value."},
#else
{46, 46, 0x0000000000000000, "RO", "IMR13_WRITE_POL_46", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{45, 45, 0x0000000000000000, "RO", "IMR13_WRITE_POL_45", "Bunit IMR13 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR13 region based on the agents 6bit encoded SAI value."},
#else
{45, 45, 0x0000000000000000, "RO", "IMR13_WRITE_POL_45", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{44, 44, 0x0000000000000000, "RW", "IMR13_WRITE_POL_44", "Bunit IMR13 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR13 region based on the agents 6bit encoded SAI value."},
#else
{44, 44, 0x0000000000000000, "RW", "IMR13_WRITE_POL_44", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{43, 43, 0x0000000000000000, "RW", "IMR13_WRITE_POL_43", "Bunit IMR13 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR13 region based on the agents 6bit encoded SAI value."},
#else
{43, 43, 0x0000000000000000, "RW", "IMR13_WRITE_POL_43", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{42, 42, 0x0000000000000000, "RW", "IMR13_WRITE_POL_42", "Bunit IMR13 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR13 region based on the agents 6bit encoded SAI value."},
#else
{42, 42, 0x0000000000000000, "RW", "IMR13_WRITE_POL_42", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{41, 41, 0x0000000000000000, "RW", "IMR13_WRITE_POL_41", "Bunit IMR13 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR13 region based on the agents 6bit encoded SAI value."},
#else
{41, 41, 0x0000000000000000, "RW", "IMR13_WRITE_POL_41", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{40, 40, 0x0000000000000000, "RW", "IMR13_WRITE_POL_40", "Bunit IMR13 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR13 region based on the agents 6bit encoded SAI value."},
#else
{40, 40, 0x0000000000000000, "RW", "IMR13_WRITE_POL_40", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{39, 39, 0x0000000000000000, "RO", "IMR13_WRITE_POL_39", "Bunit IMR13 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR13 region based on the agents 6bit encoded SAI value."},
#else
{39, 39, 0x0000000000000000, "RO", "IMR13_WRITE_POL_39", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{38, 38, 0x0000000000000000, "RW", "IMR13_WRITE_POL_38", "Bunit IMR13 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR13 region based on the agents 6bit encoded SAI value."},
#else
{38, 38, 0x0000000000000000, "RW", "IMR13_WRITE_POL_38", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{37, 37, 0x0000000000000000, "RO", "IMR13_WRITE_POL_37", "Bunit IMR13 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR13 region based on the agents 6bit encoded SAI value."},
#else
{37, 37, 0x0000000000000000, "RO", "IMR13_WRITE_POL_37", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{36, 36, 0x0000000000000000, "RW", "IMR13_WRITE_POL_36", "Bunit IMR13 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR13 region based on the agents 6bit encoded SAI value."},
#else
{36, 36, 0x0000000000000000, "RW", "IMR13_WRITE_POL_36", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{35, 35, 0x0000000000000000, "RO", "IMR13_WRITE_POL_35", "Bunit IMR13 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR13 region based on the agents 6bit encoded SAI value."},
#else
{35, 35, 0x0000000000000000, "RO", "IMR13_WRITE_POL_35", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{34, 34, 0x0000000000000000, "RW", "IMR13_WRITE_POL_34", "Bunit IMR13 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR13 region based on the agents 6bit encoded SAI value."},
#else
{34, 34, 0x0000000000000000, "RW", "IMR13_WRITE_POL_34", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{33, 33, 0x0000000000000000, "RW", "IMR13_WRITE_POL_33", "Bunit IMR13 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR13 region based on the agents 6bit encoded SAI value."},
#else
{33, 33, 0x0000000000000000, "RW", "IMR13_WRITE_POL_33", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{32, 32, 0x0000000000000000, "RW", "IMR13_WRITE_POL_32", "Bunit IMR13 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR13 region based on the agents 6bit encoded SAI value."},
#else
{32, 32, 0x0000000000000000, "RW", "IMR13_WRITE_POL_32", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{31, 31, 0x0000000000000000, "RO", "IMR13_WRITE_POL_31", "Bunit IMR13 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR13 region based on the agents 6bit encoded SAI value."},
#else
{31, 31, 0x0000000000000000, "RO", "IMR13_WRITE_POL_31", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{30, 30, 0x0000000000000000, "RW", "IMR13_WRITE_POL_30", "Bunit IMR13 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR13 region based on the agents 6bit encoded SAI value."},
#else
{30, 30, 0x0000000000000000, "RW", "IMR13_WRITE_POL_30", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{29, 29, 0x0000000000000000, "RW", "IMR13_WRITE_POL_29", "Bunit IMR13 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR13 region based on the agents 6bit encoded SAI value."},
#else
{29, 29, 0x0000000000000000, "RW", "IMR13_WRITE_POL_29", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{28, 28, 0x0000000000000000, "RW", "IMR13_WRITE_POL_28", "Bunit IMR13 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR13 region based on the agents 6bit encoded SAI value."},
#else
{28, 28, 0x0000000000000000, "RW", "IMR13_WRITE_POL_28", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{27, 27, 0x0000000000000000, "RW", "IMR13_WRITE_POL_27", "Bunit IMR13 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR13 region based on the agents 6bit encoded SAI value."},
#else
{27, 27, 0x0000000000000000, "RW", "IMR13_WRITE_POL_27", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{26, 26, 0x0000000000000000, "RW", "IMR13_WRITE_POL_26", "Bunit IMR13 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR13 region based on the agents 6bit encoded SAI value."},
#else
{26, 26, 0x0000000000000000, "RW", "IMR13_WRITE_POL_26", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{25, 25, 0x0000000000000000, "RW", "IMR13_WRITE_POL_25", "Bunit IMR13 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR13 region based on the agents 6bit encoded SAI value."},
#else
{25, 25, 0x0000000000000000, "RW", "IMR13_WRITE_POL_25", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{24, 24, 0x0000000000000000, "RW", "IMR13_WRITE_POL_24", "Bunit IMR13 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR13 region based on the agents 6bit encoded SAI value."},
#else
{24, 24, 0x0000000000000000, "RW", "IMR13_WRITE_POL_24", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{23, 23, 0x0000000000000000, "RO", "IMR13_WRITE_POL_23", "Bunit IMR13 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR13 region based on the agents 6bit encoded SAI value."},
#else
{23, 23, 0x0000000000000000, "RO", "IMR13_WRITE_POL_23", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{22, 22, 0x0000000000000000, "RO", "IMR13_WRITE_POL_22", "Bunit IMR13 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR13 region based on the agents 6bit encoded SAI value."},
#else
{22, 22, 0x0000000000000000, "RO", "IMR13_WRITE_POL_22", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{21, 21, 0x0000000000000000, "RW", "IMR13_WRITE_POL_21", "Bunit IMR13 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR13 region based on the agents 6bit encoded SAI value."},
#else
{21, 21, 0x0000000000000000, "RW", "IMR13_WRITE_POL_21", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{20, 20, 0x0000000000000000, "RO", "IMR13_WRITE_POL_20", "Bunit IMR13 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR13 region based on the agents 6bit encoded SAI value."},
#else
{20, 20, 0x0000000000000000, "RO", "IMR13_WRITE_POL_20", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{19, 19, 0x0000000000000000, "RO", "IMR13_WRITE_POL_19", "Bunit IMR13 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR13 region based on the agents 6bit encoded SAI value."},
#else
{19, 19, 0x0000000000000000, "RO", "IMR13_WRITE_POL_19", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{18, 18, 0x0000000000000000, "RO", "IMR13_WRITE_POL_18", "Bunit IMR13 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR13 region based on the agents 6bit encoded SAI value."},
#else
{18, 18, 0x0000000000000000, "RO", "IMR13_WRITE_POL_18", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{17, 17, 0x0000000000000000, "RW", "IMR13_WRITE_POL_17", "Bunit IMR13 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR13 region based on the agents 6bit encoded SAI value."},
#else
{17, 17, 0x0000000000000000, "RW", "IMR13_WRITE_POL_17", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{16, 16, 0x0000000000000000, "RW", "IMR13_WRITE_POL_16", "Bunit IMR13 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR13 region based on the agents 6bit encoded SAI value."},
#else
{16, 16, 0x0000000000000000, "RW", "IMR13_WRITE_POL_16", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{15, 15, 0x0000000000000000, "RO", "IMR13_WRITE_POL_15", "Bunit IMR13 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR13 region based on the agents 6bit encoded SAI value."},
#else
{15, 15, 0x0000000000000000, "RO", "IMR13_WRITE_POL_15", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{14, 14, 0x0000000000000000, "RO", "IMR13_WRITE_POL_14", "Bunit IMR13 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR13 region based on the agents 6bit encoded SAI value."},
#else
{14, 14, 0x0000000000000000, "RO", "IMR13_WRITE_POL_14", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{13, 13, 0x0000000000000000, "RW", "IMR13_WRITE_POL_13", "Bunit IMR13 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR13 region based on the agents 6bit encoded SAI value."},
#else
{13, 13, 0x0000000000000000, "RW", "IMR13_WRITE_POL_13", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{12, 12, 0x0000000000000000, "RW", "IMR13_WRITE_POL_12", "Bunit IMR13 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR13 region based on the agents 6bit encoded SAI value."},
#else
{12, 12, 0x0000000000000000, "RW", "IMR13_WRITE_POL_12", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{11, 11, 0x0000000000000000, "RO", "IMR13_WRITE_POL_11", "Bunit IMR13 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR13 region based on the agents 6bit encoded SAI value."},
#else
{11, 11, 0x0000000000000000, "RO", "IMR13_WRITE_POL_11", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{10, 10, 0x0000000000000000, "RO", "IMR13_WRITE_POL_10", "Bunit IMR13 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR13 region based on the agents 6bit encoded SAI value."},
#else
{10, 10, 0x0000000000000000, "RO", "IMR13_WRITE_POL_10", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{9, 9, 0x0000000000000000, "RO", "IMR13_WRITE_POL_9", "Bunit IMR13 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR13 region based on the agents 6bit encoded SAI value."},
#else
{9, 9, 0x0000000000000000, "RO", "IMR13_WRITE_POL_9", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{8, 8, 0x0000000000000000, "RW", "IMR13_WRITE_POL_8", "Bunit IMR13 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR13 region based on the agents 6bit encoded SAI value."},
#else
{8, 8, 0x0000000000000000, "RW", "IMR13_WRITE_POL_8", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{7, 7, 0x0000000000000000, "RO", "IMR13_WRITE_POL_7", "Bunit IMR13 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR13 region based on the agents 6bit encoded SAI value."},
#else
{7, 7, 0x0000000000000000, "RO", "IMR13_WRITE_POL_7", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{6, 6, 0x0000000000000000, "RO", "IMR13_WRITE_POL_6", "Bunit IMR13 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR13 region based on the agents 6bit encoded SAI value."},
#else
{6, 6, 0x0000000000000000, "RO", "IMR13_WRITE_POL_6", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{5, 5, 0x0000000000000000, "RW", "IMR13_WRITE_POL_5", "Bunit IMR13 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR13 region based on the agents 6bit encoded SAI value."},
#else
{5, 5, 0x0000000000000000, "RW", "IMR13_WRITE_POL_5", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{4, 4, 0x0000000000000000, "RW", "IMR13_WRITE_POL_4", "Bunit IMR13 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR13 region based on the agents 6bit encoded SAI value."},
#else
{4, 4, 0x0000000000000000, "RW", "IMR13_WRITE_POL_4", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{3, 3, 0x0000000000000000, "RW", "IMR13_WRITE_POL_3", "Bunit IMR13 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR13 region based on the agents 6bit encoded SAI value."},
#else
{3, 3, 0x0000000000000000, "RW", "IMR13_WRITE_POL_3", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{2, 2, 0x0000000000000000, "RW", "IMR13_WRITE_POL_2", "Bunit IMR13 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR13 region based on the agents 6bit encoded SAI value."},
#else
{2, 2, 0x0000000000000000, "RW", "IMR13_WRITE_POL_2", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{1, 1, 0x0000000000000000, "RW", "IMR13_WRITE_POL_1", "Bunit IMR13 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR13 region based on the agents 6bit encoded SAI value."},
#else
{1, 1, 0x0000000000000000, "RW", "IMR13_WRITE_POL_1", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 0, 0x0000000000000000, "RW", "IMR13_WRITE_POL_0", "Bunit IMR13 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR13 region based on the agents 6bit encoded SAI value."},
#else
{0, 0, 0x0000000000000000, "RW", "IMR13_WRITE_POL_0", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo946[] = {{"B_CR_BIMR13WAC_0_0_0_MCHBAR", "", 0x00006A28, 64, 0xFFFFFFFFFFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields947[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{31, 31, 0x0000000000000000, "RW", "IMR_EN", "IMR Enable: Enables access checking for the IMR region."},
#else
{31, 31, 0x0000000000000000, "RW", "IMR_EN", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{30, 30, 0x0000000000000000, "RW", "TR_EN", "Asset Classification AC[0]: Trace Enable: Enables snooping of transactions to the IMR region by tracing agents."},
#else
{30, 30, 0x0000000000000000, "RW", "TR_EN", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{29, 29, 0x0000000000000000, "RO", "RESERVED_1", "Reserved"},
#else
{29, 29, 0x0000000000000000, "RO", "RESERVED_1", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 28, 0x0000000000000000, "RW", "IMR14_BASE", "Base 0 IMR14BASE:  Specifies bits 38:10 of the start address of IMR14 region.  IMR region size must be a strict poweroftwo at least 1KB and naturally aligned to the size.  These bits are compared with the result of the IMR14MASK[28:0] applied to bits 38:10 of the incoming address to determine if an access falls within the IMR14 defined region."},
#else
{0, 28, 0x0000000000000000, "RW", "IMR14_BASE", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo947[] = {{"B_CR_BIMR14BASE_0_0_0_MCHBAR", "", 0x00006A30, 4, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields948[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{31, 31, 0x0000000000000000, "RW", "GT_IWB_EN", "Asset Classification AC[2]: GT Implicit WB Enable: Enables implicit writebacks to protected region from GT caching agent. When set to 1 enables implicit writeback data HITM data from GT to be returned to the requester.  When set to 0 inhibits HITM data from GT from being returned to the requester.  HITM data from IA cores may be returned to the requester depending on the setting of the IA_IWB_EN bit."},
#else
{31, 31, 0x0000000000000000, "RW", "GT_IWB_EN", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{30, 30, 0x0000000000000000, "RW", "IA_IWB_EN", "Asset Classification AC[1]: IA Implicit WB Enable: Enables implicit writebacks to protected region from IA caching agent.  When set to 1 enables implicit writeback data HITM data from IA cores to be returned to the requester.  When set to 0 inhibits HITM data from IA cores from being returned to the requester.  HITM data from GT may be returned to the requester depending on the setting of the GT_IWB_EN bit."},
#else
{30, 30, 0x0000000000000000, "RW", "IA_IWB_EN", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{29, 29, 0x0000000000000000, "RO", "RESERVED_0", "Reserved"},
#else
{29, 29, 0x0000000000000000, "RO", "RESERVED_0", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 28, 0x0000000000000000, "RW", "IMR14_MASK", "Mask 0 IMR14MASK:  These bits are ANDed with bits 38:10 of the incoming address to determine if the combined result matches the IMR14BASE[28:0] value.  A match indicates the the incoming address falls within the IMR14 region."},
#else
{0, 28, 0x0000000000000000, "RW", "IMR14_MASK", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo948[] = {{"B_CR_BIMR14MASK_0_0_0_MCHBAR", "", 0x00006A34, 4, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields949[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{0, 63, 0x00000C0061010202, "RW", "IMR14_CTRL_POL", "Bunit IMR14 Control Policy: Bit vector used to determine which agents are allowed access to the BIMR14RAC, BIMR14WAC, BIMR14CP registers based on the value from the agents 6bit SAI field."},
#else
{0, 63, 0x00000C0061010202, "RW", "IMR14_CTRL_POL", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo949[] = {{"B_CR_BIMR14CP_0_0_0_MCHBAR", "", 0x00006A38, 1, 0xFFFFFFFFFFFFFFFF, 0x00000C0061010202}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields950[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{63, 63, 0x0000000000000000, "RW", "IMR14_READ_POL_63", "Bunit IMR14 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR14 region based on the agents 6bit encoded SAI value."},
#else
{63, 63, 0x0000000000000000, "RW", "IMR14_READ_POL_63", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{62, 62, 0x0000000000000000, "RO", "IMR14_READ_POL_62", "Bunit IMR14 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR14 region based on the agents 6bit encoded SAI value."},
#else
{62, 62, 0x0000000000000000, "RO", "IMR14_READ_POL_62", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{61, 61, 0x0000000000000000, "RO", "IMR14_READ_POL_61", "Bunit IMR14 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR14 region based on the agents 6bit encoded SAI value."},
#else
{61, 61, 0x0000000000000000, "RO", "IMR14_READ_POL_61", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{60, 60, 0x0000000000000000, "RO", "IMR14_READ_POL_60", "Bunit IMR14 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR14 region based on the agents 6bit encoded SAI value."},
#else
{60, 60, 0x0000000000000000, "RO", "IMR14_READ_POL_60", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{59, 59, 0x0000000000000000, "RO", "IMR14_READ_POL_59", "Bunit IMR14 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR14 region based on the agents 6bit encoded SAI value."},
#else
{59, 59, 0x0000000000000000, "RO", "IMR14_READ_POL_59", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{58, 58, 0x0000000000000000, "RO", "IMR14_READ_POL_58", "Bunit IMR14 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR14 region based on the agents 6bit encoded SAI value."},
#else
{58, 58, 0x0000000000000000, "RO", "IMR14_READ_POL_58", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{57, 57, 0x0000000000000000, "RO", "IMR14_READ_POL_57", "Bunit IMR14 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR14 region based on the agents 6bit encoded SAI value."},
#else
{57, 57, 0x0000000000000000, "RO", "IMR14_READ_POL_57", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{56, 56, 0x0000000000000000, "RW", "IMR14_READ_POL_56", "Bunit IMR14 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR14 region based on the agents 6bit encoded SAI value."},
#else
{56, 56, 0x0000000000000000, "RW", "IMR14_READ_POL_56", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{55, 55, 0x0000000000000000, "RW", "IMR14_READ_POL_55", "Bunit IMR14 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR14 region based on the agents 6bit encoded SAI value."},
#else
{55, 55, 0x0000000000000000, "RW", "IMR14_READ_POL_55", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{54, 54, 0x0000000000000000, "RW", "IMR14_READ_POL_54", "Bunit IMR14 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR14 region based on the agents 6bit encoded SAI value."},
#else
{54, 54, 0x0000000000000000, "RW", "IMR14_READ_POL_54", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{53, 53, 0x0000000000000000, "RO", "IMR14_READ_POL_53", "Bunit IMR14 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR14 region based on the agents 6bit encoded SAI value."},
#else
{53, 53, 0x0000000000000000, "RO", "IMR14_READ_POL_53", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{52, 52, 0x0000000000000000, "RO", "IMR14_READ_POL_52", "Bunit IMR14 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR14 region based on the agents 6bit encoded SAI value."},
#else
{52, 52, 0x0000000000000000, "RO", "IMR14_READ_POL_52", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{51, 51, 0x0000000000000000, "RO", "IMR14_READ_POL_51", "Bunit IMR14 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR14 region based on the agents 6bit encoded SAI value."},
#else
{51, 51, 0x0000000000000000, "RO", "IMR14_READ_POL_51", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{50, 50, 0x0000000000000000, "RW", "IMR14_READ_POL_50", "Bunit IMR14 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR14 region based on the agents 6bit encoded SAI value."},
#else
{50, 50, 0x0000000000000000, "RW", "IMR14_READ_POL_50", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{49, 49, 0x0000000000000000, "RW", "IMR14_READ_POL_49", "Bunit IMR14 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR14 region based on the agents 6bit encoded SAI value."},
#else
{49, 49, 0x0000000000000000, "RW", "IMR14_READ_POL_49", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{48, 48, 0x0000000000000000, "RW", "IMR14_READ_POL_48", "Bunit IMR14 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR14 region based on the agents 6bit encoded SAI value."},
#else
{48, 48, 0x0000000000000000, "RW", "IMR14_READ_POL_48", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{47, 47, 0x0000000000000000, "RO", "IMR14_READ_POL_47", "Bunit IMR14 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR14 region based on the agents 6bit encoded SAI value."},
#else
{47, 47, 0x0000000000000000, "RO", "IMR14_READ_POL_47", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{46, 46, 0x0000000000000000, "RO", "IMR14_READ_POL_46", "Bunit IMR14 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR14 region based on the agents 6bit encoded SAI value."},
#else
{46, 46, 0x0000000000000000, "RO", "IMR14_READ_POL_46", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{45, 45, 0x0000000000000000, "RO", "IMR14_READ_POL_45", "Bunit IMR14 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR14 region based on the agents 6bit encoded SAI value."},
#else
{45, 45, 0x0000000000000000, "RO", "IMR14_READ_POL_45", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{44, 44, 0x0000000000000000, "RW", "IMR14_READ_POL_44", "Bunit IMR14 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR14 region based on the agents 6bit encoded SAI value."},
#else
{44, 44, 0x0000000000000000, "RW", "IMR14_READ_POL_44", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{43, 43, 0x0000000000000000, "RW", "IMR14_READ_POL_43", "Bunit IMR14 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR14 region based on the agents 6bit encoded SAI value."},
#else
{43, 43, 0x0000000000000000, "RW", "IMR14_READ_POL_43", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{42, 42, 0x0000000000000000, "RW", "IMR14_READ_POL_42", "Bunit IMR14 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR14 region based on the agents 6bit encoded SAI value."},
#else
{42, 42, 0x0000000000000000, "RW", "IMR14_READ_POL_42", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{41, 41, 0x0000000000000000, "RW", "IMR14_READ_POL_41", "Bunit IMR14 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR14 region based on the agents 6bit encoded SAI value."},
#else
{41, 41, 0x0000000000000000, "RW", "IMR14_READ_POL_41", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{40, 40, 0x0000000000000000, "RW", "IMR14_READ_POL_40", "Bunit IMR14 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR14 region based on the agents 6bit encoded SAI value."},
#else
{40, 40, 0x0000000000000000, "RW", "IMR14_READ_POL_40", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{39, 39, 0x0000000000000000, "RO", "IMR14_READ_POL_39", "Bunit IMR14 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR14 region based on the agents 6bit encoded SAI value."},
#else
{39, 39, 0x0000000000000000, "RO", "IMR14_READ_POL_39", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{38, 38, 0x0000000000000000, "RW", "IMR14_READ_POL_38", "Bunit IMR14 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR14 region based on the agents 6bit encoded SAI value."},
#else
{38, 38, 0x0000000000000000, "RW", "IMR14_READ_POL_38", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{37, 37, 0x0000000000000000, "RO", "IMR14_READ_POL_37", "Bunit IMR14 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR14 region based on the agents 6bit encoded SAI value."},
#else
{37, 37, 0x0000000000000000, "RO", "IMR14_READ_POL_37", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{36, 36, 0x0000000000000000, "RW", "IMR14_READ_POL_36", "Bunit IMR14 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR14 region based on the agents 6bit encoded SAI value."},
#else
{36, 36, 0x0000000000000000, "RW", "IMR14_READ_POL_36", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{35, 35, 0x0000000000000000, "RO", "IMR14_READ_POL_35", "Bunit IMR14 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR14 region based on the agents 6bit encoded SAI value."},
#else
{35, 35, 0x0000000000000000, "RO", "IMR14_READ_POL_35", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{34, 34, 0x0000000000000000, "RW", "IMR14_READ_POL_34", "Bunit IMR14 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR14 region based on the agents 6bit encoded SAI value."},
#else
{34, 34, 0x0000000000000000, "RW", "IMR14_READ_POL_34", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{33, 33, 0x0000000000000000, "RW", "IMR14_READ_POL_33", "Bunit IMR14 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR14 region based on the agents 6bit encoded SAI value."},
#else
{33, 33, 0x0000000000000000, "RW", "IMR14_READ_POL_33", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{32, 32, 0x0000000000000000, "RW", "IMR14_READ_POL_32", "Bunit IMR14 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR14 region based on the agents 6bit encoded SAI value."},
#else
{32, 32, 0x0000000000000000, "RW", "IMR14_READ_POL_32", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{31, 31, 0x0000000000000000, "RO", "IMR14_READ_POL_31", "Bunit IMR14 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR14 region based on the agents 6bit encoded SAI value."},
#else
{31, 31, 0x0000000000000000, "RO", "IMR14_READ_POL_31", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{30, 30, 0x0000000000000000, "RW", "IMR14_READ_POL_30", "Bunit IMR14 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR14 region based on the agents 6bit encoded SAI value."},
#else
{30, 30, 0x0000000000000000, "RW", "IMR14_READ_POL_30", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{29, 29, 0x0000000000000000, "RW", "IMR14_READ_POL_29", "Bunit IMR14 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR14 region based on the agents 6bit encoded SAI value."},
#else
{29, 29, 0x0000000000000000, "RW", "IMR14_READ_POL_29", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{28, 28, 0x0000000000000000, "RW", "IMR14_READ_POL_28", "Bunit IMR14 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR14 region based on the agents 6bit encoded SAI value."},
#else
{28, 28, 0x0000000000000000, "RW", "IMR14_READ_POL_28", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{27, 27, 0x0000000000000000, "RW", "IMR14_READ_POL_27", "Bunit IMR14 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR14 region based on the agents 6bit encoded SAI value."},
#else
{27, 27, 0x0000000000000000, "RW", "IMR14_READ_POL_27", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{26, 26, 0x0000000000000000, "RW", "IMR14_READ_POL_26", "Bunit IMR14 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR14 region based on the agents 6bit encoded SAI value."},
#else
{26, 26, 0x0000000000000000, "RW", "IMR14_READ_POL_26", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{25, 25, 0x0000000000000000, "RW", "IMR14_READ_POL_25", "Bunit IMR14 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR14 region based on the agents 6bit encoded SAI value."},
#else
{25, 25, 0x0000000000000000, "RW", "IMR14_READ_POL_25", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{24, 24, 0x0000000000000000, "RW", "IMR14_READ_POL_24", "Bunit IMR14 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR14 region based on the agents 6bit encoded SAI value."},
#else
{24, 24, 0x0000000000000000, "RW", "IMR14_READ_POL_24", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{23, 23, 0x0000000000000000, "RO", "IMR14_READ_POL_23", "Bunit IMR14 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR14 region based on the agents 6bit encoded SAI value."},
#else
{23, 23, 0x0000000000000000, "RO", "IMR14_READ_POL_23", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{22, 22, 0x0000000000000000, "RO", "IMR14_READ_POL_22", "Bunit IMR14 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR14 region based on the agents 6bit encoded SAI value."},
#else
{22, 22, 0x0000000000000000, "RO", "IMR14_READ_POL_22", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{21, 21, 0x0000000000000000, "RW", "IMR14_READ_POL_21", "Bunit IMR14 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR14 region based on the agents 6bit encoded SAI value."},
#else
{21, 21, 0x0000000000000000, "RW", "IMR14_READ_POL_21", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{20, 20, 0x0000000000000000, "RO", "IMR14_READ_POL_20", "Bunit IMR14 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR14 region based on the agents 6bit encoded SAI value."},
#else
{20, 20, 0x0000000000000000, "RO", "IMR14_READ_POL_20", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{19, 19, 0x0000000000000000, "RO", "IMR14_READ_POL_19", "Bunit IMR14 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR14 region based on the agents 6bit encoded SAI value."},
#else
{19, 19, 0x0000000000000000, "RO", "IMR14_READ_POL_19", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{18, 18, 0x0000000000000000, "RO", "IMR14_READ_POL_18", "Bunit IMR14 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR14 region based on the agents 6bit encoded SAI value."},
#else
{18, 18, 0x0000000000000000, "RO", "IMR14_READ_POL_18", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{17, 17, 0x0000000000000000, "RW", "IMR14_READ_POL_17", "Bunit IMR14 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR14 region based on the agents 6bit encoded SAI value."},
#else
{17, 17, 0x0000000000000000, "RW", "IMR14_READ_POL_17", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{16, 16, 0x0000000000000000, "RW", "IMR14_READ_POL_16", "Bunit IMR14 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR14 region based on the agents 6bit encoded SAI value."},
#else
{16, 16, 0x0000000000000000, "RW", "IMR14_READ_POL_16", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{15, 15, 0x0000000000000000, "RO", "IMR14_READ_POL_15", "Bunit IMR14 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR14 region based on the agents 6bit encoded SAI value."},
#else
{15, 15, 0x0000000000000000, "RO", "IMR14_READ_POL_15", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{14, 14, 0x0000000000000000, "RO", "IMR14_READ_POL_14", "Bunit IMR14 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR14 region based on the agents 6bit encoded SAI value."},
#else
{14, 14, 0x0000000000000000, "RO", "IMR14_READ_POL_14", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{13, 13, 0x0000000000000000, "RW", "IMR14_READ_POL_13", "Bunit IMR14 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR14 region based on the agents 6bit encoded SAI value."},
#else
{13, 13, 0x0000000000000000, "RW", "IMR14_READ_POL_13", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{12, 12, 0x0000000000000000, "RW", "IMR14_READ_POL_12", "Bunit IMR14 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR14 region based on the agents 6bit encoded SAI value."},
#else
{12, 12, 0x0000000000000000, "RW", "IMR14_READ_POL_12", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{11, 11, 0x0000000000000000, "RO", "IMR14_READ_POL_11", "Bunit IMR14 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR14 region based on the agents 6bit encoded SAI value."},
#else
{11, 11, 0x0000000000000000, "RO", "IMR14_READ_POL_11", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{10, 10, 0x0000000000000000, "RO", "IMR14_READ_POL_10", "Bunit IMR14 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR14 region based on the agents 6bit encoded SAI value."},
#else
{10, 10, 0x0000000000000000, "RO", "IMR14_READ_POL_10", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{9, 9, 0x0000000000000000, "RO", "IMR14_READ_POL_9", "Bunit IMR14 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR14 region based on the agents 6bit encoded SAI value."},
#else
{9, 9, 0x0000000000000000, "RO", "IMR14_READ_POL_9", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{8, 8, 0x0000000000000000, "RW", "IMR14_READ_POL_8", "Bunit IMR14 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR14 region based on the agents 6bit encoded SAI value."},
#else
{8, 8, 0x0000000000000000, "RW", "IMR14_READ_POL_8", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{7, 7, 0x0000000000000000, "RO", "IMR14_READ_POL_7", "Bunit IMR14 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR14 region based on the agents 6bit encoded SAI value."},
#else
{7, 7, 0x0000000000000000, "RO", "IMR14_READ_POL_7", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{6, 6, 0x0000000000000000, "RO", "IMR14_READ_POL_6", "Bunit IMR14 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR14 region based on the agents 6bit encoded SAI value."},
#else
{6, 6, 0x0000000000000000, "RO", "IMR14_READ_POL_6", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{5, 5, 0x0000000000000000, "RW", "IMR14_READ_POL_5", "Bunit IMR14 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR14 region based on the agents 6bit encoded SAI value."},
#else
{5, 5, 0x0000000000000000, "RW", "IMR14_READ_POL_5", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{4, 4, 0x0000000000000000, "RW", "IMR14_READ_POL_4", "Bunit IMR14 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR14 region based on the agents 6bit encoded SAI value."},
#else
{4, 4, 0x0000000000000000, "RW", "IMR14_READ_POL_4", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{3, 3, 0x0000000000000000, "RW", "IMR14_READ_POL_3", "Bunit IMR14 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR14 region based on the agents 6bit encoded SAI value."},
#else
{3, 3, 0x0000000000000000, "RW", "IMR14_READ_POL_3", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{2, 2, 0x0000000000000000, "RW", "IMR14_READ_POL_2", "Bunit IMR14 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR14 region based on the agents 6bit encoded SAI value."},
#else
{2, 2, 0x0000000000000000, "RW", "IMR14_READ_POL_2", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{1, 1, 0x0000000000000000, "RW", "IMR14_READ_POL_1", "Bunit IMR14 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR14 region based on the agents 6bit encoded SAI value."},
#else
{1, 1, 0x0000000000000000, "RW", "IMR14_READ_POL_1", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 0, 0x0000000000000000, "RW", "IMR14_READ_POL_0", "Bunit IMR14 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR14 region based on the agents 6bit encoded SAI value."},
#else
{0, 0, 0x0000000000000000, "RW", "IMR14_READ_POL_0", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo950[] = {{"B_CR_BIMR14RAC_0_0_0_MCHBAR", "", 0x00006A40, 64, 0xFFFFFFFFFFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields951[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{63, 63, 0x0000000000000000, "RW", "IMR14_WRITE_POL_63", "Bunit IMR14 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR14 region based on the agents 6bit encoded SAI value."},
#else
{63, 63, 0x0000000000000000, "RW", "IMR14_WRITE_POL_63", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{62, 62, 0x0000000000000000, "RO", "IMR14_WRITE_POL_62", "Bunit IMR14 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR14 region based on the agents 6bit encoded SAI value."},
#else
{62, 62, 0x0000000000000000, "RO", "IMR14_WRITE_POL_62", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{61, 61, 0x0000000000000000, "RO", "IMR14_WRITE_POL_61", "Bunit IMR14 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR14 region based on the agents 6bit encoded SAI value."},
#else
{61, 61, 0x0000000000000000, "RO", "IMR14_WRITE_POL_61", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{60, 60, 0x0000000000000000, "RO", "IMR14_WRITE_POL_60", "Bunit IMR14 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR14 region based on the agents 6bit encoded SAI value."},
#else
{60, 60, 0x0000000000000000, "RO", "IMR14_WRITE_POL_60", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{59, 59, 0x0000000000000000, "RO", "IMR14_WRITE_POL_59", "Bunit IMR14 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR14 region based on the agents 6bit encoded SAI value."},
#else
{59, 59, 0x0000000000000000, "RO", "IMR14_WRITE_POL_59", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{58, 58, 0x0000000000000000, "RO", "IMR14_WRITE_POL_58", "Bunit IMR14 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR14 region based on the agents 6bit encoded SAI value."},
#else
{58, 58, 0x0000000000000000, "RO", "IMR14_WRITE_POL_58", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{57, 57, 0x0000000000000000, "RO", "IMR14_WRITE_POL_57", "Bunit IMR14 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR14 region based on the agents 6bit encoded SAI value."},
#else
{57, 57, 0x0000000000000000, "RO", "IMR14_WRITE_POL_57", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{56, 56, 0x0000000000000000, "RW", "IMR14_WRITE_POL_56", "Bunit IMR14 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR14 region based on the agents 6bit encoded SAI value."},
#else
{56, 56, 0x0000000000000000, "RW", "IMR14_WRITE_POL_56", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{55, 55, 0x0000000000000000, "RW", "IMR14_WRITE_POL_55", "Bunit IMR14 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR14 region based on the agents 6bit encoded SAI value."},
#else
{55, 55, 0x0000000000000000, "RW", "IMR14_WRITE_POL_55", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{54, 54, 0x0000000000000000, "RW", "IMR14_WRITE_POL_54", "Bunit IMR14 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR14 region based on the agents 6bit encoded SAI value."},
#else
{54, 54, 0x0000000000000000, "RW", "IMR14_WRITE_POL_54", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{53, 53, 0x0000000000000000, "RO", "IMR14_WRITE_POL_53", "Bunit IMR14 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR14 region based on the agents 6bit encoded SAI value."},
#else
{53, 53, 0x0000000000000000, "RO", "IMR14_WRITE_POL_53", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{52, 52, 0x0000000000000000, "RO", "IMR14_WRITE_POL_52", "Bunit IMR14 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR14 region based on the agents 6bit encoded SAI value."},
#else
{52, 52, 0x0000000000000000, "RO", "IMR14_WRITE_POL_52", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{51, 51, 0x0000000000000000, "RO", "IMR14_WRITE_POL_51", "Bunit IMR14 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR14 region based on the agents 6bit encoded SAI value."},
#else
{51, 51, 0x0000000000000000, "RO", "IMR14_WRITE_POL_51", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{50, 50, 0x0000000000000000, "RW", "IMR14_WRITE_POL_50", "Bunit IMR14 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR14 region based on the agents 6bit encoded SAI value."},
#else
{50, 50, 0x0000000000000000, "RW", "IMR14_WRITE_POL_50", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{49, 49, 0x0000000000000000, "RW", "IMR14_WRITE_POL_49", "Bunit IMR14 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR14 region based on the agents 6bit encoded SAI value."},
#else
{49, 49, 0x0000000000000000, "RW", "IMR14_WRITE_POL_49", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{48, 48, 0x0000000000000000, "RW", "IMR14_WRITE_POL_48", "Bunit IMR14 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR14 region based on the agents 6bit encoded SAI value."},
#else
{48, 48, 0x0000000000000000, "RW", "IMR14_WRITE_POL_48", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{47, 47, 0x0000000000000000, "RO", "IMR14_WRITE_POL_47", "Bunit IMR14 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR14 region based on the agents 6bit encoded SAI value."},
#else
{47, 47, 0x0000000000000000, "RO", "IMR14_WRITE_POL_47", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{46, 46, 0x0000000000000000, "RO", "IMR14_WRITE_POL_46", "Bunit IMR14 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR14 region based on the agents 6bit encoded SAI value."},
#else
{46, 46, 0x0000000000000000, "RO", "IMR14_WRITE_POL_46", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{45, 45, 0x0000000000000000, "RO", "IMR14_WRITE_POL_45", "Bunit IMR14 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR14 region based on the agents 6bit encoded SAI value."},
#else
{45, 45, 0x0000000000000000, "RO", "IMR14_WRITE_POL_45", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{44, 44, 0x0000000000000000, "RW", "IMR14_WRITE_POL_44", "Bunit IMR14 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR14 region based on the agents 6bit encoded SAI value."},
#else
{44, 44, 0x0000000000000000, "RW", "IMR14_WRITE_POL_44", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{43, 43, 0x0000000000000000, "RW", "IMR14_WRITE_POL_43", "Bunit IMR14 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR14 region based on the agents 6bit encoded SAI value."},
#else
{43, 43, 0x0000000000000000, "RW", "IMR14_WRITE_POL_43", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{42, 42, 0x0000000000000000, "RW", "IMR14_WRITE_POL_42", "Bunit IMR14 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR14 region based on the agents 6bit encoded SAI value."},
#else
{42, 42, 0x0000000000000000, "RW", "IMR14_WRITE_POL_42", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{41, 41, 0x0000000000000000, "RW", "IMR14_WRITE_POL_41", "Bunit IMR14 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR14 region based on the agents 6bit encoded SAI value."},
#else
{41, 41, 0x0000000000000000, "RW", "IMR14_WRITE_POL_41", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{40, 40, 0x0000000000000000, "RW", "IMR14_WRITE_POL_40", "Bunit IMR14 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR14 region based on the agents 6bit encoded SAI value."},
#else
{40, 40, 0x0000000000000000, "RW", "IMR14_WRITE_POL_40", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{39, 39, 0x0000000000000000, "RO", "IMR14_WRITE_POL_39", "Bunit IMR14 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR14 region based on the agents 6bit encoded SAI value."},
#else
{39, 39, 0x0000000000000000, "RO", "IMR14_WRITE_POL_39", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{38, 38, 0x0000000000000000, "RW", "IMR14_WRITE_POL_38", "Bunit IMR14 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR14 region based on the agents 6bit encoded SAI value."},
#else
{38, 38, 0x0000000000000000, "RW", "IMR14_WRITE_POL_38", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{37, 37, 0x0000000000000000, "RO", "IMR14_WRITE_POL_37", "Bunit IMR14 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR14 region based on the agents 6bit encoded SAI value."},
#else
{37, 37, 0x0000000000000000, "RO", "IMR14_WRITE_POL_37", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{36, 36, 0x0000000000000000, "RW", "IMR14_WRITE_POL_36", "Bunit IMR14 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR14 region based on the agents 6bit encoded SAI value."},
#else
{36, 36, 0x0000000000000000, "RW", "IMR14_WRITE_POL_36", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{35, 35, 0x0000000000000000, "RO", "IMR14_WRITE_POL_35", "Bunit IMR14 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR14 region based on the agents 6bit encoded SAI value."},
#else
{35, 35, 0x0000000000000000, "RO", "IMR14_WRITE_POL_35", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{34, 34, 0x0000000000000000, "RW", "IMR14_WRITE_POL_34", "Bunit IMR14 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR14 region based on the agents 6bit encoded SAI value."},
#else
{34, 34, 0x0000000000000000, "RW", "IMR14_WRITE_POL_34", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{33, 33, 0x0000000000000000, "RW", "IMR14_WRITE_POL_33", "Bunit IMR14 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR14 region based on the agents 6bit encoded SAI value."},
#else
{33, 33, 0x0000000000000000, "RW", "IMR14_WRITE_POL_33", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{32, 32, 0x0000000000000000, "RW", "IMR14_WRITE_POL_32", "Bunit IMR14 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR14 region based on the agents 6bit encoded SAI value."},
#else
{32, 32, 0x0000000000000000, "RW", "IMR14_WRITE_POL_32", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{31, 31, 0x0000000000000000, "RO", "IMR14_WRITE_POL_31", "Bunit IMR14 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR14 region based on the agents 6bit encoded SAI value."},
#else
{31, 31, 0x0000000000000000, "RO", "IMR14_WRITE_POL_31", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{30, 30, 0x0000000000000000, "RW", "IMR14_WRITE_POL_30", "Bunit IMR14 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR14 region based on the agents 6bit encoded SAI value."},
#else
{30, 30, 0x0000000000000000, "RW", "IMR14_WRITE_POL_30", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{29, 29, 0x0000000000000000, "RW", "IMR14_WRITE_POL_29", "Bunit IMR14 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR14 region based on the agents 6bit encoded SAI value."},
#else
{29, 29, 0x0000000000000000, "RW", "IMR14_WRITE_POL_29", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{28, 28, 0x0000000000000000, "RW", "IMR14_WRITE_POL_28", "Bunit IMR14 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR14 region based on the agents 6bit encoded SAI value."},
#else
{28, 28, 0x0000000000000000, "RW", "IMR14_WRITE_POL_28", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{27, 27, 0x0000000000000000, "RW", "IMR14_WRITE_POL_27", "Bunit IMR14 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR14 region based on the agents 6bit encoded SAI value."},
#else
{27, 27, 0x0000000000000000, "RW", "IMR14_WRITE_POL_27", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{26, 26, 0x0000000000000000, "RW", "IMR14_WRITE_POL_26", "Bunit IMR14 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR14 region based on the agents 6bit encoded SAI value."},
#else
{26, 26, 0x0000000000000000, "RW", "IMR14_WRITE_POL_26", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{25, 25, 0x0000000000000000, "RW", "IMR14_WRITE_POL_25", "Bunit IMR14 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR14 region based on the agents 6bit encoded SAI value."},
#else
{25, 25, 0x0000000000000000, "RW", "IMR14_WRITE_POL_25", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{24, 24, 0x0000000000000000, "RW", "IMR14_WRITE_POL_24", "Bunit IMR14 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR14 region based on the agents 6bit encoded SAI value."},
#else
{24, 24, 0x0000000000000000, "RW", "IMR14_WRITE_POL_24", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{23, 23, 0x0000000000000000, "RO", "IMR14_WRITE_POL_23", "Bunit IMR14 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR14 region based on the agents 6bit encoded SAI value."},
#else
{23, 23, 0x0000000000000000, "RO", "IMR14_WRITE_POL_23", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{22, 22, 0x0000000000000000, "RO", "IMR14_WRITE_POL_22", "Bunit IMR14 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR14 region based on the agents 6bit encoded SAI value."},
#else
{22, 22, 0x0000000000000000, "RO", "IMR14_WRITE_POL_22", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{21, 21, 0x0000000000000000, "RW", "IMR14_WRITE_POL_21", "Bunit IMR14 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR14 region based on the agents 6bit encoded SAI value."},
#else
{21, 21, 0x0000000000000000, "RW", "IMR14_WRITE_POL_21", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{20, 20, 0x0000000000000000, "RO", "IMR14_WRITE_POL_20", "Bunit IMR14 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR14 region based on the agents 6bit encoded SAI value."},
#else
{20, 20, 0x0000000000000000, "RO", "IMR14_WRITE_POL_20", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{19, 19, 0x0000000000000000, "RO", "IMR14_WRITE_POL_19", "Bunit IMR14 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR14 region based on the agents 6bit encoded SAI value."},
#else
{19, 19, 0x0000000000000000, "RO", "IMR14_WRITE_POL_19", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{18, 18, 0x0000000000000000, "RO", "IMR14_WRITE_POL_18", "Bunit IMR14 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR14 region based on the agents 6bit encoded SAI value."},
#else
{18, 18, 0x0000000000000000, "RO", "IMR14_WRITE_POL_18", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{17, 17, 0x0000000000000000, "RW", "IMR14_WRITE_POL_17", "Bunit IMR14 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR14 region based on the agents 6bit encoded SAI value."},
#else
{17, 17, 0x0000000000000000, "RW", "IMR14_WRITE_POL_17", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{16, 16, 0x0000000000000000, "RW", "IMR14_WRITE_POL_16", "Bunit IMR14 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR14 region based on the agents 6bit encoded SAI value."},
#else
{16, 16, 0x0000000000000000, "RW", "IMR14_WRITE_POL_16", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{15, 15, 0x0000000000000000, "RO", "IMR14_WRITE_POL_15", "Bunit IMR14 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR14 region based on the agents 6bit encoded SAI value."},
#else
{15, 15, 0x0000000000000000, "RO", "IMR14_WRITE_POL_15", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{14, 14, 0x0000000000000000, "RO", "IMR14_WRITE_POL_14", "Bunit IMR14 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR14 region based on the agents 6bit encoded SAI value."},
#else
{14, 14, 0x0000000000000000, "RO", "IMR14_WRITE_POL_14", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{13, 13, 0x0000000000000000, "RW", "IMR14_WRITE_POL_13", "Bunit IMR14 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR14 region based on the agents 6bit encoded SAI value."},
#else
{13, 13, 0x0000000000000000, "RW", "IMR14_WRITE_POL_13", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{12, 12, 0x0000000000000000, "RW", "IMR14_WRITE_POL_12", "Bunit IMR14 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR14 region based on the agents 6bit encoded SAI value."},
#else
{12, 12, 0x0000000000000000, "RW", "IMR14_WRITE_POL_12", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{11, 11, 0x0000000000000000, "RO", "IMR14_WRITE_POL_11", "Bunit IMR14 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR14 region based on the agents 6bit encoded SAI value."},
#else
{11, 11, 0x0000000000000000, "RO", "IMR14_WRITE_POL_11", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{10, 10, 0x0000000000000000, "RO", "IMR14_WRITE_POL_10", "Bunit IMR14 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR14 region based on the agents 6bit encoded SAI value."},
#else
{10, 10, 0x0000000000000000, "RO", "IMR14_WRITE_POL_10", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{9, 9, 0x0000000000000000, "RO", "IMR14_WRITE_POL_9", "Bunit IMR14 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR14 region based on the agents 6bit encoded SAI value."},
#else
{9, 9, 0x0000000000000000, "RO", "IMR14_WRITE_POL_9", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{8, 8, 0x0000000000000000, "RW", "IMR14_WRITE_POL_8", "Bunit IMR14 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR14 region based on the agents 6bit encoded SAI value."},
#else
{8, 8, 0x0000000000000000, "RW", "IMR14_WRITE_POL_8", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{7, 7, 0x0000000000000000, "RO", "IMR14_WRITE_POL_7", "Bunit IMR14 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR14 region based on the agents 6bit encoded SAI value."},
#else
{7, 7, 0x0000000000000000, "RO", "IMR14_WRITE_POL_7", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{6, 6, 0x0000000000000000, "RO", "IMR14_WRITE_POL_6", "Bunit IMR14 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR14 region based on the agents 6bit encoded SAI value."},
#else
{6, 6, 0x0000000000000000, "RO", "IMR14_WRITE_POL_6", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{5, 5, 0x0000000000000000, "RW", "IMR14_WRITE_POL_5", "Bunit IMR14 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR14 region based on the agents 6bit encoded SAI value."},
#else
{5, 5, 0x0000000000000000, "RW", "IMR14_WRITE_POL_5", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{4, 4, 0x0000000000000000, "RW", "IMR14_WRITE_POL_4", "Bunit IMR14 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR14 region based on the agents 6bit encoded SAI value."},
#else
{4, 4, 0x0000000000000000, "RW", "IMR14_WRITE_POL_4", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{3, 3, 0x0000000000000000, "RW", "IMR14_WRITE_POL_3", "Bunit IMR14 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR14 region based on the agents 6bit encoded SAI value."},
#else
{3, 3, 0x0000000000000000, "RW", "IMR14_WRITE_POL_3", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{2, 2, 0x0000000000000000, "RW", "IMR14_WRITE_POL_2", "Bunit IMR14 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR14 region based on the agents 6bit encoded SAI value."},
#else
{2, 2, 0x0000000000000000, "RW", "IMR14_WRITE_POL_2", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{1, 1, 0x0000000000000000, "RW", "IMR14_WRITE_POL_1", "Bunit IMR14 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR14 region based on the agents 6bit encoded SAI value."},
#else
{1, 1, 0x0000000000000000, "RW", "IMR14_WRITE_POL_1", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 0, 0x0000000000000000, "RW", "IMR14_WRITE_POL_0", "Bunit IMR14 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR14 region based on the agents 6bit encoded SAI value."},
#else
{0, 0, 0x0000000000000000, "RW", "IMR14_WRITE_POL_0", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo951[] = {{"B_CR_BIMR14WAC_0_0_0_MCHBAR", "", 0x00006A48, 64, 0xFFFFFFFFFFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields952[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{31, 31, 0x0000000000000000, "RW", "IMR_EN", "IMR Enable: Enables access checking for the IMR region."},
#else
{31, 31, 0x0000000000000000, "RW", "IMR_EN", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{30, 30, 0x0000000000000000, "RW", "TR_EN", "Asset Classification AC[0]: Trace Enable: Enables snooping of transactions to the IMR region by tracing agents."},
#else
{30, 30, 0x0000000000000000, "RW", "TR_EN", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{29, 29, 0x0000000000000000, "RO", "RESERVED_1", "Reserved"},
#else
{29, 29, 0x0000000000000000, "RO", "RESERVED_1", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 28, 0x0000000000000000, "RW", "IMR15_BASE", "Base 0 IMR15BASE:  Specifies bits 38:10 of the start address of IMR15 region.  IMR region size must be a strict poweroftwo at least 1KB and naturally aligned to the size.  These bits are compared with the result of the IMR15MASK[28:0] applied to bits 38:10 of the incoming address to determine if an access falls within the IMR15 defined region."},
#else
{0, 28, 0x0000000000000000, "RW", "IMR15_BASE", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo952[] = {{"B_CR_BIMR15BASE_0_0_0_MCHBAR", "", 0x00006A50, 4, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields953[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{31, 31, 0x0000000000000000, "RW", "GT_IWB_EN", "Asset Classification AC[2]: GT Implicit WB Enable: Enables implicit writebacks to protected region from GT caching agent. When set to 1 enables implicit writeback data HITM data from GT to be returned to the requester.  When set to 0 inhibits HITM data from GT from being returned to the requester.  HITM data from IA cores may be returned to the requester depending on the setting of the IA_IWB_EN bit."},
#else
{31, 31, 0x0000000000000000, "RW", "GT_IWB_EN", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{30, 30, 0x0000000000000000, "RW", "IA_IWB_EN", "Asset Classification AC[1]: IA Implicit WB Enable: Enables implicit writebacks to protected region from IA caching agent.  When set to 1 enables implicit writeback data HITM data from IA cores to be returned to the requester.  When set to 0 inhibits HITM data from IA cores from being returned to the requester.  HITM data from GT may be returned to the requester depending on the setting of the GT_IWB_EN bit."},
#else
{30, 30, 0x0000000000000000, "RW", "IA_IWB_EN", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{29, 29, 0x0000000000000000, "RO", "RESERVED_0", "Reserved"},
#else
{29, 29, 0x0000000000000000, "RO", "RESERVED_0", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 28, 0x0000000000000000, "RW", "IMR15_MASK", "Mask 0 IMR15MASK:  These bits are ANDed with bits 38:10 of the incoming address to determine if the combined result matches the IMR15BASE[28:0] value.  A match indicates the the incoming address falls within the IMR15 region."},
#else
{0, 28, 0x0000000000000000, "RW", "IMR15_MASK", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo953[] = {{"B_CR_BIMR15MASK_0_0_0_MCHBAR", "", 0x00006A54, 4, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields954[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{0, 63, 0x00000C0061010202, "RW", "IMR15_CTRL_POL", "Bunit IMR15 Control Policy: Bit vector used to determine which agents are allowed access to the BIMR15RAC, BIMR15WAC, BIMR15CP registers based on the value from the agents 6bit SAI field."},
#else
{0, 63, 0x00000C0061010202, "RW", "IMR15_CTRL_POL", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo954[] = {{"B_CR_BIMR15CP_0_0_0_MCHBAR", "", 0x00006A58, 1, 0xFFFFFFFFFFFFFFFF, 0x00000C0061010202}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields955[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{63, 63, 0x0000000000000000, "RW", "IMR15_READ_POL_63", "Bunit IMR15 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR15 region based on the agents 6bit encoded SAI value."},
#else
{63, 63, 0x0000000000000000, "RW", "IMR15_READ_POL_63", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{62, 62, 0x0000000000000000, "RO", "IMR15_READ_POL_62", "Bunit IMR15 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR15 region based on the agents 6bit encoded SAI value."},
#else
{62, 62, 0x0000000000000000, "RO", "IMR15_READ_POL_62", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{61, 61, 0x0000000000000000, "RO", "IMR15_READ_POL_61", "Bunit IMR15 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR15 region based on the agents 6bit encoded SAI value."},
#else
{61, 61, 0x0000000000000000, "RO", "IMR15_READ_POL_61", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{60, 60, 0x0000000000000000, "RO", "IMR15_READ_POL_60", "Bunit IMR15 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR15 region based on the agents 6bit encoded SAI value."},
#else
{60, 60, 0x0000000000000000, "RO", "IMR15_READ_POL_60", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{59, 59, 0x0000000000000000, "RO", "IMR15_READ_POL_59", "Bunit IMR15 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR15 region based on the agents 6bit encoded SAI value."},
#else
{59, 59, 0x0000000000000000, "RO", "IMR15_READ_POL_59", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{58, 58, 0x0000000000000000, "RO", "IMR15_READ_POL_58", "Bunit IMR15 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR15 region based on the agents 6bit encoded SAI value."},
#else
{58, 58, 0x0000000000000000, "RO", "IMR15_READ_POL_58", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{57, 57, 0x0000000000000000, "RO", "IMR15_READ_POL_57", "Bunit IMR15 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR15 region based on the agents 6bit encoded SAI value."},
#else
{57, 57, 0x0000000000000000, "RO", "IMR15_READ_POL_57", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{56, 56, 0x0000000000000000, "RW", "IMR15_READ_POL_56", "Bunit IMR15 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR15 region based on the agents 6bit encoded SAI value."},
#else
{56, 56, 0x0000000000000000, "RW", "IMR15_READ_POL_56", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{55, 55, 0x0000000000000000, "RW", "IMR15_READ_POL_55", "Bunit IMR15 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR15 region based on the agents 6bit encoded SAI value."},
#else
{55, 55, 0x0000000000000000, "RW", "IMR15_READ_POL_55", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{54, 54, 0x0000000000000000, "RW", "IMR15_READ_POL_54", "Bunit IMR15 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR15 region based on the agents 6bit encoded SAI value."},
#else
{54, 54, 0x0000000000000000, "RW", "IMR15_READ_POL_54", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{53, 53, 0x0000000000000000, "RO", "IMR15_READ_POL_53", "Bunit IMR15 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR15 region based on the agents 6bit encoded SAI value."},
#else
{53, 53, 0x0000000000000000, "RO", "IMR15_READ_POL_53", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{52, 52, 0x0000000000000000, "RO", "IMR15_READ_POL_52", "Bunit IMR15 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR15 region based on the agents 6bit encoded SAI value."},
#else
{52, 52, 0x0000000000000000, "RO", "IMR15_READ_POL_52", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{51, 51, 0x0000000000000000, "RO", "IMR15_READ_POL_51", "Bunit IMR15 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR15 region based on the agents 6bit encoded SAI value."},
#else
{51, 51, 0x0000000000000000, "RO", "IMR15_READ_POL_51", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{50, 50, 0x0000000000000000, "RW", "IMR15_READ_POL_50", "Bunit IMR15 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR15 region based on the agents 6bit encoded SAI value."},
#else
{50, 50, 0x0000000000000000, "RW", "IMR15_READ_POL_50", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{49, 49, 0x0000000000000000, "RW", "IMR15_READ_POL_49", "Bunit IMR15 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR15 region based on the agents 6bit encoded SAI value."},
#else
{49, 49, 0x0000000000000000, "RW", "IMR15_READ_POL_49", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{48, 48, 0x0000000000000000, "RW", "IMR15_READ_POL_48", "Bunit IMR15 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR15 region based on the agents 6bit encoded SAI value."},
#else
{48, 48, 0x0000000000000000, "RW", "IMR15_READ_POL_48", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{47, 47, 0x0000000000000000, "RO", "IMR15_READ_POL_47", "Bunit IMR15 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR15 region based on the agents 6bit encoded SAI value."},
#else
{47, 47, 0x0000000000000000, "RO", "IMR15_READ_POL_47", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{46, 46, 0x0000000000000000, "RO", "IMR15_READ_POL_46", "Bunit IMR15 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR15 region based on the agents 6bit encoded SAI value."},
#else
{46, 46, 0x0000000000000000, "RO", "IMR15_READ_POL_46", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{45, 45, 0x0000000000000000, "RO", "IMR15_READ_POL_45", "Bunit IMR15 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR15 region based on the agents 6bit encoded SAI value."},
#else
{45, 45, 0x0000000000000000, "RO", "IMR15_READ_POL_45", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{44, 44, 0x0000000000000000, "RW", "IMR15_READ_POL_44", "Bunit IMR15 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR15 region based on the agents 6bit encoded SAI value."},
#else
{44, 44, 0x0000000000000000, "RW", "IMR15_READ_POL_44", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{43, 43, 0x0000000000000000, "RW", "IMR15_READ_POL_43", "Bunit IMR15 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR15 region based on the agents 6bit encoded SAI value."},
#else
{43, 43, 0x0000000000000000, "RW", "IMR15_READ_POL_43", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{42, 42, 0x0000000000000000, "RW", "IMR15_READ_POL_42", "Bunit IMR15 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR15 region based on the agents 6bit encoded SAI value."},
#else
{42, 42, 0x0000000000000000, "RW", "IMR15_READ_POL_42", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{41, 41, 0x0000000000000000, "RW", "IMR15_READ_POL_41", "Bunit IMR15 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR15 region based on the agents 6bit encoded SAI value."},
#else
{41, 41, 0x0000000000000000, "RW", "IMR15_READ_POL_41", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{40, 40, 0x0000000000000000, "RW", "IMR15_READ_POL_40", "Bunit IMR15 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR15 region based on the agents 6bit encoded SAI value."},
#else
{40, 40, 0x0000000000000000, "RW", "IMR15_READ_POL_40", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{39, 39, 0x0000000000000000, "RO", "IMR15_READ_POL_39", "Bunit IMR15 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR15 region based on the agents 6bit encoded SAI value."},
#else
{39, 39, 0x0000000000000000, "RO", "IMR15_READ_POL_39", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{38, 38, 0x0000000000000000, "RW", "IMR15_READ_POL_38", "Bunit IMR15 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR15 region based on the agents 6bit encoded SAI value."},
#else
{38, 38, 0x0000000000000000, "RW", "IMR15_READ_POL_38", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{37, 37, 0x0000000000000000, "RO", "IMR15_READ_POL_37", "Bunit IMR15 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR15 region based on the agents 6bit encoded SAI value."},
#else
{37, 37, 0x0000000000000000, "RO", "IMR15_READ_POL_37", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{36, 36, 0x0000000000000000, "RW", "IMR15_READ_POL_36", "Bunit IMR15 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR15 region based on the agents 6bit encoded SAI value."},
#else
{36, 36, 0x0000000000000000, "RW", "IMR15_READ_POL_36", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{35, 35, 0x0000000000000000, "RO", "IMR15_READ_POL_35", "Bunit IMR15 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR15 region based on the agents 6bit encoded SAI value."},
#else
{35, 35, 0x0000000000000000, "RO", "IMR15_READ_POL_35", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{34, 34, 0x0000000000000000, "RW", "IMR15_READ_POL_34", "Bunit IMR15 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR15 region based on the agents 6bit encoded SAI value."},
#else
{34, 34, 0x0000000000000000, "RW", "IMR15_READ_POL_34", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{33, 33, 0x0000000000000000, "RW", "IMR15_READ_POL_33", "Bunit IMR15 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR15 region based on the agents 6bit encoded SAI value."},
#else
{33, 33, 0x0000000000000000, "RW", "IMR15_READ_POL_33", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{32, 32, 0x0000000000000000, "RW", "IMR15_READ_POL_32", "Bunit IMR15 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR15 region based on the agents 6bit encoded SAI value."},
#else
{32, 32, 0x0000000000000000, "RW", "IMR15_READ_POL_32", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{31, 31, 0x0000000000000000, "RO", "IMR15_READ_POL_31", "Bunit IMR15 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR15 region based on the agents 6bit encoded SAI value."},
#else
{31, 31, 0x0000000000000000, "RO", "IMR15_READ_POL_31", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{30, 30, 0x0000000000000000, "RW", "IMR15_READ_POL_30", "Bunit IMR15 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR15 region based on the agents 6bit encoded SAI value."},
#else
{30, 30, 0x0000000000000000, "RW", "IMR15_READ_POL_30", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{29, 29, 0x0000000000000000, "RW", "IMR15_READ_POL_29", "Bunit IMR15 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR15 region based on the agents 6bit encoded SAI value."},
#else
{29, 29, 0x0000000000000000, "RW", "IMR15_READ_POL_29", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{28, 28, 0x0000000000000000, "RW", "IMR15_READ_POL_28", "Bunit IMR15 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR15 region based on the agents 6bit encoded SAI value."},
#else
{28, 28, 0x0000000000000000, "RW", "IMR15_READ_POL_28", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{27, 27, 0x0000000000000000, "RW", "IMR15_READ_POL_27", "Bunit IMR15 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR15 region based on the agents 6bit encoded SAI value."},
#else
{27, 27, 0x0000000000000000, "RW", "IMR15_READ_POL_27", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{26, 26, 0x0000000000000000, "RW", "IMR15_READ_POL_26", "Bunit IMR15 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR15 region based on the agents 6bit encoded SAI value."},
#else
{26, 26, 0x0000000000000000, "RW", "IMR15_READ_POL_26", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{25, 25, 0x0000000000000000, "RW", "IMR15_READ_POL_25", "Bunit IMR15 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR15 region based on the agents 6bit encoded SAI value."},
#else
{25, 25, 0x0000000000000000, "RW", "IMR15_READ_POL_25", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{24, 24, 0x0000000000000000, "RW", "IMR15_READ_POL_24", "Bunit IMR15 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR15 region based on the agents 6bit encoded SAI value."},
#else
{24, 24, 0x0000000000000000, "RW", "IMR15_READ_POL_24", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{23, 23, 0x0000000000000000, "RO", "IMR15_READ_POL_23", "Bunit IMR15 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR15 region based on the agents 6bit encoded SAI value."},
#else
{23, 23, 0x0000000000000000, "RO", "IMR15_READ_POL_23", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{22, 22, 0x0000000000000000, "RO", "IMR15_READ_POL_22", "Bunit IMR15 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR15 region based on the agents 6bit encoded SAI value."},
#else
{22, 22, 0x0000000000000000, "RO", "IMR15_READ_POL_22", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{21, 21, 0x0000000000000000, "RW", "IMR15_READ_POL_21", "Bunit IMR15 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR15 region based on the agents 6bit encoded SAI value."},
#else
{21, 21, 0x0000000000000000, "RW", "IMR15_READ_POL_21", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{20, 20, 0x0000000000000000, "RO", "IMR15_READ_POL_20", "Bunit IMR15 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR15 region based on the agents 6bit encoded SAI value."},
#else
{20, 20, 0x0000000000000000, "RO", "IMR15_READ_POL_20", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{19, 19, 0x0000000000000000, "RO", "IMR15_READ_POL_19", "Bunit IMR15 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR15 region based on the agents 6bit encoded SAI value."},
#else
{19, 19, 0x0000000000000000, "RO", "IMR15_READ_POL_19", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{18, 18, 0x0000000000000000, "RO", "IMR15_READ_POL_18", "Bunit IMR15 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR15 region based on the agents 6bit encoded SAI value."},
#else
{18, 18, 0x0000000000000000, "RO", "IMR15_READ_POL_18", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{17, 17, 0x0000000000000000, "RW", "IMR15_READ_POL_17", "Bunit IMR15 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR15 region based on the agents 6bit encoded SAI value."},
#else
{17, 17, 0x0000000000000000, "RW", "IMR15_READ_POL_17", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{16, 16, 0x0000000000000000, "RW", "IMR15_READ_POL_16", "Bunit IMR15 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR15 region based on the agents 6bit encoded SAI value."},
#else
{16, 16, 0x0000000000000000, "RW", "IMR15_READ_POL_16", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{15, 15, 0x0000000000000000, "RO", "IMR15_READ_POL_15", "Bunit IMR15 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR15 region based on the agents 6bit encoded SAI value."},
#else
{15, 15, 0x0000000000000000, "RO", "IMR15_READ_POL_15", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{14, 14, 0x0000000000000000, "RO", "IMR15_READ_POL_14", "Bunit IMR15 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR15 region based on the agents 6bit encoded SAI value."},
#else
{14, 14, 0x0000000000000000, "RO", "IMR15_READ_POL_14", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{13, 13, 0x0000000000000000, "RW", "IMR15_READ_POL_13", "Bunit IMR15 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR15 region based on the agents 6bit encoded SAI value."},
#else
{13, 13, 0x0000000000000000, "RW", "IMR15_READ_POL_13", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{12, 12, 0x0000000000000000, "RW", "IMR15_READ_POL_12", "Bunit IMR15 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR15 region based on the agents 6bit encoded SAI value."},
#else
{12, 12, 0x0000000000000000, "RW", "IMR15_READ_POL_12", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{11, 11, 0x0000000000000000, "RO", "IMR15_READ_POL_11", "Bunit IMR15 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR15 region based on the agents 6bit encoded SAI value."},
#else
{11, 11, 0x0000000000000000, "RO", "IMR15_READ_POL_11", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{10, 10, 0x0000000000000000, "RO", "IMR15_READ_POL_10", "Bunit IMR15 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR15 region based on the agents 6bit encoded SAI value."},
#else
{10, 10, 0x0000000000000000, "RO", "IMR15_READ_POL_10", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{9, 9, 0x0000000000000000, "RO", "IMR15_READ_POL_9", "Bunit IMR15 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR15 region based on the agents 6bit encoded SAI value."},
#else
{9, 9, 0x0000000000000000, "RO", "IMR15_READ_POL_9", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{8, 8, 0x0000000000000000, "RW", "IMR15_READ_POL_8", "Bunit IMR15 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR15 region based on the agents 6bit encoded SAI value."},
#else
{8, 8, 0x0000000000000000, "RW", "IMR15_READ_POL_8", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{7, 7, 0x0000000000000000, "RO", "IMR15_READ_POL_7", "Bunit IMR15 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR15 region based on the agents 6bit encoded SAI value."},
#else
{7, 7, 0x0000000000000000, "RO", "IMR15_READ_POL_7", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{6, 6, 0x0000000000000000, "RO", "IMR15_READ_POL_6", "Bunit IMR15 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR15 region based on the agents 6bit encoded SAI value."},
#else
{6, 6, 0x0000000000000000, "RO", "IMR15_READ_POL_6", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{5, 5, 0x0000000000000000, "RW", "IMR15_READ_POL_5", "Bunit IMR15 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR15 region based on the agents 6bit encoded SAI value."},
#else
{5, 5, 0x0000000000000000, "RW", "IMR15_READ_POL_5", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{4, 4, 0x0000000000000000, "RW", "IMR15_READ_POL_4", "Bunit IMR15 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR15 region based on the agents 6bit encoded SAI value."},
#else
{4, 4, 0x0000000000000000, "RW", "IMR15_READ_POL_4", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{3, 3, 0x0000000000000000, "RW", "IMR15_READ_POL_3", "Bunit IMR15 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR15 region based on the agents 6bit encoded SAI value."},
#else
{3, 3, 0x0000000000000000, "RW", "IMR15_READ_POL_3", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{2, 2, 0x0000000000000000, "RW", "IMR15_READ_POL_2", "Bunit IMR15 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR15 region based on the agents 6bit encoded SAI value."},
#else
{2, 2, 0x0000000000000000, "RW", "IMR15_READ_POL_2", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{1, 1, 0x0000000000000000, "RW", "IMR15_READ_POL_1", "Bunit IMR15 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR15 region based on the agents 6bit encoded SAI value."},
#else
{1, 1, 0x0000000000000000, "RW", "IMR15_READ_POL_1", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 0, 0x0000000000000000, "RW", "IMR15_READ_POL_0", "Bunit IMR15 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR15 region based on the agents 6bit encoded SAI value."},
#else
{0, 0, 0x0000000000000000, "RW", "IMR15_READ_POL_0", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo955[] = {{"B_CR_BIMR15RAC_0_0_0_MCHBAR", "", 0x00006A60, 64, 0xFFFFFFFFFFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields956[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{63, 63, 0x0000000000000000, "RW", "IMR15_WRITE_POL_63", "Bunit IMR15 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR15 region based on the agents 6bit encoded SAI value."},
#else
{63, 63, 0x0000000000000000, "RW", "IMR15_WRITE_POL_63", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{62, 62, 0x0000000000000000, "RO", "IMR15_WRITE_POL_62", "Bunit IMR15 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR15 region based on the agents 6bit encoded SAI value."},
#else
{62, 62, 0x0000000000000000, "RO", "IMR15_WRITE_POL_62", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{61, 61, 0x0000000000000000, "RO", "IMR15_WRITE_POL_61", "Bunit IMR15 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR15 region based on the agents 6bit encoded SAI value."},
#else
{61, 61, 0x0000000000000000, "RO", "IMR15_WRITE_POL_61", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{60, 60, 0x0000000000000000, "RO", "IMR15_WRITE_POL_60", "Bunit IMR15 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR15 region based on the agents 6bit encoded SAI value."},
#else
{60, 60, 0x0000000000000000, "RO", "IMR15_WRITE_POL_60", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{59, 59, 0x0000000000000000, "RO", "IMR15_WRITE_POL_59", "Bunit IMR15 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR15 region based on the agents 6bit encoded SAI value."},
#else
{59, 59, 0x0000000000000000, "RO", "IMR15_WRITE_POL_59", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{58, 58, 0x0000000000000000, "RO", "IMR15_WRITE_POL_58", "Bunit IMR15 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR15 region based on the agents 6bit encoded SAI value."},
#else
{58, 58, 0x0000000000000000, "RO", "IMR15_WRITE_POL_58", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{57, 57, 0x0000000000000000, "RO", "IMR15_WRITE_POL_57", "Bunit IMR15 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR15 region based on the agents 6bit encoded SAI value."},
#else
{57, 57, 0x0000000000000000, "RO", "IMR15_WRITE_POL_57", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{56, 56, 0x0000000000000000, "RW", "IMR15_WRITE_POL_56", "Bunit IMR15 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR15 region based on the agents 6bit encoded SAI value."},
#else
{56, 56, 0x0000000000000000, "RW", "IMR15_WRITE_POL_56", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{55, 55, 0x0000000000000000, "RW", "IMR15_WRITE_POL_55", "Bunit IMR15 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR15 region based on the agents 6bit encoded SAI value."},
#else
{55, 55, 0x0000000000000000, "RW", "IMR15_WRITE_POL_55", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{54, 54, 0x0000000000000000, "RW", "IMR15_WRITE_POL_54", "Bunit IMR15 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR15 region based on the agents 6bit encoded SAI value."},
#else
{54, 54, 0x0000000000000000, "RW", "IMR15_WRITE_POL_54", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{53, 53, 0x0000000000000000, "RO", "IMR15_WRITE_POL_53", "Bunit IMR15 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR15 region based on the agents 6bit encoded SAI value."},
#else
{53, 53, 0x0000000000000000, "RO", "IMR15_WRITE_POL_53", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{52, 52, 0x0000000000000000, "RO", "IMR15_WRITE_POL_52", "Bunit IMR15 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR15 region based on the agents 6bit encoded SAI value."},
#else
{52, 52, 0x0000000000000000, "RO", "IMR15_WRITE_POL_52", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{51, 51, 0x0000000000000000, "RO", "IMR15_WRITE_POL_51", "Bunit IMR15 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR15 region based on the agents 6bit encoded SAI value."},
#else
{51, 51, 0x0000000000000000, "RO", "IMR15_WRITE_POL_51", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{50, 50, 0x0000000000000000, "RW", "IMR15_WRITE_POL_50", "Bunit IMR15 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR15 region based on the agents 6bit encoded SAI value."},
#else
{50, 50, 0x0000000000000000, "RW", "IMR15_WRITE_POL_50", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{49, 49, 0x0000000000000000, "RW", "IMR15_WRITE_POL_49", "Bunit IMR15 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR15 region based on the agents 6bit encoded SAI value."},
#else
{49, 49, 0x0000000000000000, "RW", "IMR15_WRITE_POL_49", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{48, 48, 0x0000000000000000, "RW", "IMR15_WRITE_POL_48", "Bunit IMR15 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR15 region based on the agents 6bit encoded SAI value."},
#else
{48, 48, 0x0000000000000000, "RW", "IMR15_WRITE_POL_48", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{47, 47, 0x0000000000000000, "RO", "IMR15_WRITE_POL_47", "Bunit IMR15 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR15 region based on the agents 6bit encoded SAI value."},
#else
{47, 47, 0x0000000000000000, "RO", "IMR15_WRITE_POL_47", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{46, 46, 0x0000000000000000, "RO", "IMR15_WRITE_POL_46", "Bunit IMR15 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR15 region based on the agents 6bit encoded SAI value."},
#else
{46, 46, 0x0000000000000000, "RO", "IMR15_WRITE_POL_46", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{45, 45, 0x0000000000000000, "RO", "IMR15_WRITE_POL_45", "Bunit IMR15 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR15 region based on the agents 6bit encoded SAI value."},
#else
{45, 45, 0x0000000000000000, "RO", "IMR15_WRITE_POL_45", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{44, 44, 0x0000000000000000, "RW", "IMR15_WRITE_POL_44", "Bunit IMR15 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR15 region based on the agents 6bit encoded SAI value."},
#else
{44, 44, 0x0000000000000000, "RW", "IMR15_WRITE_POL_44", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{43, 43, 0x0000000000000000, "RW", "IMR15_WRITE_POL_43", "Bunit IMR15 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR15 region based on the agents 6bit encoded SAI value."},
#else
{43, 43, 0x0000000000000000, "RW", "IMR15_WRITE_POL_43", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{42, 42, 0x0000000000000000, "RW", "IMR15_WRITE_POL_42", "Bunit IMR15 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR15 region based on the agents 6bit encoded SAI value."},
#else
{42, 42, 0x0000000000000000, "RW", "IMR15_WRITE_POL_42", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{41, 41, 0x0000000000000000, "RW", "IMR15_WRITE_POL_41", "Bunit IMR15 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR15 region based on the agents 6bit encoded SAI value."},
#else
{41, 41, 0x0000000000000000, "RW", "IMR15_WRITE_POL_41", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{40, 40, 0x0000000000000000, "RW", "IMR15_WRITE_POL_40", "Bunit IMR15 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR15 region based on the agents 6bit encoded SAI value."},
#else
{40, 40, 0x0000000000000000, "RW", "IMR15_WRITE_POL_40", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{39, 39, 0x0000000000000000, "RO", "IMR15_WRITE_POL_39", "Bunit IMR15 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR15 region based on the agents 6bit encoded SAI value."},
#else
{39, 39, 0x0000000000000000, "RO", "IMR15_WRITE_POL_39", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{38, 38, 0x0000000000000000, "RW", "IMR15_WRITE_POL_38", "Bunit IMR15 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR15 region based on the agents 6bit encoded SAI value."},
#else
{38, 38, 0x0000000000000000, "RW", "IMR15_WRITE_POL_38", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{37, 37, 0x0000000000000000, "RO", "IMR15_WRITE_POL_37", "Bunit IMR15 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR15 region based on the agents 6bit encoded SAI value."},
#else
{37, 37, 0x0000000000000000, "RO", "IMR15_WRITE_POL_37", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{36, 36, 0x0000000000000000, "RW", "IMR15_WRITE_POL_36", "Bunit IMR15 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR15 region based on the agents 6bit encoded SAI value."},
#else
{36, 36, 0x0000000000000000, "RW", "IMR15_WRITE_POL_36", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{35, 35, 0x0000000000000000, "RO", "IMR15_WRITE_POL_35", "Bunit IMR15 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR15 region based on the agents 6bit encoded SAI value."},
#else
{35, 35, 0x0000000000000000, "RO", "IMR15_WRITE_POL_35", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{34, 34, 0x0000000000000000, "RW", "IMR15_WRITE_POL_34", "Bunit IMR15 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR15 region based on the agents 6bit encoded SAI value."},
#else
{34, 34, 0x0000000000000000, "RW", "IMR15_WRITE_POL_34", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{33, 33, 0x0000000000000000, "RW", "IMR15_WRITE_POL_33", "Bunit IMR15 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR15 region based on the agents 6bit encoded SAI value."},
#else
{33, 33, 0x0000000000000000, "RW", "IMR15_WRITE_POL_33", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{32, 32, 0x0000000000000000, "RW", "IMR15_WRITE_POL_32", "Bunit IMR15 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR15 region based on the agents 6bit encoded SAI value."},
#else
{32, 32, 0x0000000000000000, "RW", "IMR15_WRITE_POL_32", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{31, 31, 0x0000000000000000, "RO", "IMR15_WRITE_POL_31", "Bunit IMR15 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR15 region based on the agents 6bit encoded SAI value."},
#else
{31, 31, 0x0000000000000000, "RO", "IMR15_WRITE_POL_31", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{30, 30, 0x0000000000000000, "RW", "IMR15_WRITE_POL_30", "Bunit IMR15 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR15 region based on the agents 6bit encoded SAI value."},
#else
{30, 30, 0x0000000000000000, "RW", "IMR15_WRITE_POL_30", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{29, 29, 0x0000000000000000, "RW", "IMR15_WRITE_POL_29", "Bunit IMR15 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR15 region based on the agents 6bit encoded SAI value."},
#else
{29, 29, 0x0000000000000000, "RW", "IMR15_WRITE_POL_29", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{28, 28, 0x0000000000000000, "RW", "IMR15_WRITE_POL_28", "Bunit IMR15 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR15 region based on the agents 6bit encoded SAI value."},
#else
{28, 28, 0x0000000000000000, "RW", "IMR15_WRITE_POL_28", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{27, 27, 0x0000000000000000, "RW", "IMR15_WRITE_POL_27", "Bunit IMR15 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR15 region based on the agents 6bit encoded SAI value."},
#else
{27, 27, 0x0000000000000000, "RW", "IMR15_WRITE_POL_27", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{26, 26, 0x0000000000000000, "RW", "IMR15_WRITE_POL_26", "Bunit IMR15 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR15 region based on the agents 6bit encoded SAI value."},
#else
{26, 26, 0x0000000000000000, "RW", "IMR15_WRITE_POL_26", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{25, 25, 0x0000000000000000, "RW", "IMR15_WRITE_POL_25", "Bunit IMR15 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR15 region based on the agents 6bit encoded SAI value."},
#else
{25, 25, 0x0000000000000000, "RW", "IMR15_WRITE_POL_25", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{24, 24, 0x0000000000000000, "RW", "IMR15_WRITE_POL_24", "Bunit IMR15 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR15 region based on the agents 6bit encoded SAI value."},
#else
{24, 24, 0x0000000000000000, "RW", "IMR15_WRITE_POL_24", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{23, 23, 0x0000000000000000, "RO", "IMR15_WRITE_POL_23", "Bunit IMR15 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR15 region based on the agents 6bit encoded SAI value."},
#else
{23, 23, 0x0000000000000000, "RO", "IMR15_WRITE_POL_23", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{22, 22, 0x0000000000000000, "RO", "IMR15_WRITE_POL_22", "Bunit IMR15 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR15 region based on the agents 6bit encoded SAI value."},
#else
{22, 22, 0x0000000000000000, "RO", "IMR15_WRITE_POL_22", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{21, 21, 0x0000000000000000, "RW", "IMR15_WRITE_POL_21", "Bunit IMR15 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR15 region based on the agents 6bit encoded SAI value."},
#else
{21, 21, 0x0000000000000000, "RW", "IMR15_WRITE_POL_21", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{20, 20, 0x0000000000000000, "RO", "IMR15_WRITE_POL_20", "Bunit IMR15 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR15 region based on the agents 6bit encoded SAI value."},
#else
{20, 20, 0x0000000000000000, "RO", "IMR15_WRITE_POL_20", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{19, 19, 0x0000000000000000, "RO", "IMR15_WRITE_POL_19", "Bunit IMR15 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR15 region based on the agents 6bit encoded SAI value."},
#else
{19, 19, 0x0000000000000000, "RO", "IMR15_WRITE_POL_19", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{18, 18, 0x0000000000000000, "RO", "IMR15_WRITE_POL_18", "Bunit IMR15 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR15 region based on the agents 6bit encoded SAI value."},
#else
{18, 18, 0x0000000000000000, "RO", "IMR15_WRITE_POL_18", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{17, 17, 0x0000000000000000, "RW", "IMR15_WRITE_POL_17", "Bunit IMR15 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR15 region based on the agents 6bit encoded SAI value."},
#else
{17, 17, 0x0000000000000000, "RW", "IMR15_WRITE_POL_17", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{16, 16, 0x0000000000000000, "RW", "IMR15_WRITE_POL_16", "Bunit IMR15 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR15 region based on the agents 6bit encoded SAI value."},
#else
{16, 16, 0x0000000000000000, "RW", "IMR15_WRITE_POL_16", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{15, 15, 0x0000000000000000, "RO", "IMR15_WRITE_POL_15", "Bunit IMR15 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR15 region based on the agents 6bit encoded SAI value."},
#else
{15, 15, 0x0000000000000000, "RO", "IMR15_WRITE_POL_15", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{14, 14, 0x0000000000000000, "RO", "IMR15_WRITE_POL_14", "Bunit IMR15 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR15 region based on the agents 6bit encoded SAI value."},
#else
{14, 14, 0x0000000000000000, "RO", "IMR15_WRITE_POL_14", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{13, 13, 0x0000000000000000, "RW", "IMR15_WRITE_POL_13", "Bunit IMR15 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR15 region based on the agents 6bit encoded SAI value."},
#else
{13, 13, 0x0000000000000000, "RW", "IMR15_WRITE_POL_13", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{12, 12, 0x0000000000000000, "RW", "IMR15_WRITE_POL_12", "Bunit IMR15 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR15 region based on the agents 6bit encoded SAI value."},
#else
{12, 12, 0x0000000000000000, "RW", "IMR15_WRITE_POL_12", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{11, 11, 0x0000000000000000, "RO", "IMR15_WRITE_POL_11", "Bunit IMR15 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR15 region based on the agents 6bit encoded SAI value."},
#else
{11, 11, 0x0000000000000000, "RO", "IMR15_WRITE_POL_11", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{10, 10, 0x0000000000000000, "RO", "IMR15_WRITE_POL_10", "Bunit IMR15 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR15 region based on the agents 6bit encoded SAI value."},
#else
{10, 10, 0x0000000000000000, "RO", "IMR15_WRITE_POL_10", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{9, 9, 0x0000000000000000, "RO", "IMR15_WRITE_POL_9", "Bunit IMR15 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR15 region based on the agents 6bit encoded SAI value."},
#else
{9, 9, 0x0000000000000000, "RO", "IMR15_WRITE_POL_9", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{8, 8, 0x0000000000000000, "RW", "IMR15_WRITE_POL_8", "Bunit IMR15 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR15 region based on the agents 6bit encoded SAI value."},
#else
{8, 8, 0x0000000000000000, "RW", "IMR15_WRITE_POL_8", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{7, 7, 0x0000000000000000, "RO", "IMR15_WRITE_POL_7", "Bunit IMR15 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR15 region based on the agents 6bit encoded SAI value."},
#else
{7, 7, 0x0000000000000000, "RO", "IMR15_WRITE_POL_7", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{6, 6, 0x0000000000000000, "RO", "IMR15_WRITE_POL_6", "Bunit IMR15 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR15 region based on the agents 6bit encoded SAI value."},
#else
{6, 6, 0x0000000000000000, "RO", "IMR15_WRITE_POL_6", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{5, 5, 0x0000000000000000, "RW", "IMR15_WRITE_POL_5", "Bunit IMR15 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR15 region based on the agents 6bit encoded SAI value."},
#else
{5, 5, 0x0000000000000000, "RW", "IMR15_WRITE_POL_5", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{4, 4, 0x0000000000000000, "RW", "IMR15_WRITE_POL_4", "Bunit IMR15 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR15 region based on the agents 6bit encoded SAI value."},
#else
{4, 4, 0x0000000000000000, "RW", "IMR15_WRITE_POL_4", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{3, 3, 0x0000000000000000, "RW", "IMR15_WRITE_POL_3", "Bunit IMR15 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR15 region based on the agents 6bit encoded SAI value."},
#else
{3, 3, 0x0000000000000000, "RW", "IMR15_WRITE_POL_3", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{2, 2, 0x0000000000000000, "RW", "IMR15_WRITE_POL_2", "Bunit IMR15 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR15 region based on the agents 6bit encoded SAI value."},
#else
{2, 2, 0x0000000000000000, "RW", "IMR15_WRITE_POL_2", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{1, 1, 0x0000000000000000, "RW", "IMR15_WRITE_POL_1", "Bunit IMR15 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR15 region based on the agents 6bit encoded SAI value."},
#else
{1, 1, 0x0000000000000000, "RW", "IMR15_WRITE_POL_1", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 0, 0x0000000000000000, "RW", "IMR15_WRITE_POL_0", "Bunit IMR15 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR15 region based on the agents 6bit encoded SAI value."},
#else
{0, 0, 0x0000000000000000, "RW", "IMR15_WRITE_POL_0", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo956[] = {{"B_CR_BIMR15WAC_0_0_0_MCHBAR", "", 0x00006A68, 64, 0xFFFFFFFFFFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields957[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{31, 31, 0x0000000000000000, "RW", "IMR_EN", "IMR Enable: Enables access checking for the IMR region."},
#else
{31, 31, 0x0000000000000000, "RW", "IMR_EN", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{30, 30, 0x0000000000000000, "RW", "TR_EN", "Asset Classification AC[0]: Trace Enable: Enables snooping of transactions to the IMR region by tracing agents."},
#else
{30, 30, 0x0000000000000000, "RW", "TR_EN", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{29, 29, 0x0000000000000000, "RO", "RESERVED_1", "Reserved"},
#else
{29, 29, 0x0000000000000000, "RO", "RESERVED_1", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 28, 0x0000000000000000, "RW", "IMR16_BASE", "Base 0 IMR16BASE:  Specifies bits 38:10 of the start address of IMR16 region.  IMR region size must be a strict poweroftwo at least 1KB and naturally aligned to the size.  These bits are compared with the result of the IMR16MASK[28:0] applied to bits 38:10 of the incoming address to determine if an access falls within the IMR16 defined region."},
#else
{0, 28, 0x0000000000000000, "RW", "IMR16_BASE", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo957[] = {{"B_CR_BIMR16BASE_0_0_0_MCHBAR", "", 0x00006A70, 4, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields958[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{31, 31, 0x0000000000000000, "RW", "GT_IWB_EN", "Asset Classification AC[2]: GT Implicit WB Enable: Enables implicit writebacks to protected region from GT caching agent. When set to 1 enables implicit writeback data HITM data from GT to be returned to the requester.  When set to 0 inhibits HITM data from GT from being returned to the requester.  HITM data from IA cores may be returned to the requester depending on the setting of the IA_IWB_EN bit."},
#else
{31, 31, 0x0000000000000000, "RW", "GT_IWB_EN", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{30, 30, 0x0000000000000000, "RW", "IA_IWB_EN", "Asset Classification AC[1]: IA Implicit WB Enable: Enables implicit writebacks to protected region from IA caching agent.  When set to 1 enables implicit writeback data HITM data from IA cores to be returned to the requester.  When set to 0 inhibits HITM data from IA cores from being returned to the requester.  HITM data from GT may be returned to the requester depending on the setting of the GT_IWB_EN bit."},
#else
{30, 30, 0x0000000000000000, "RW", "IA_IWB_EN", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{29, 29, 0x0000000000000000, "RO", "RESERVED_0", "Reserved"},
#else
{29, 29, 0x0000000000000000, "RO", "RESERVED_0", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 28, 0x0000000000000000, "RW", "IMR16_MASK", "Mask 0 IMR16MASK:  These bits are ANDed with bits 38:10 of the incoming address to determine if the combined result matches the IMR16BASE[28:0] value.  A match indicates the the incoming address falls within the IMR16 region."},
#else
{0, 28, 0x0000000000000000, "RW", "IMR16_MASK", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo958[] = {{"B_CR_BIMR16MASK_0_0_0_MCHBAR", "", 0x00006A74, 4, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields959[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{0, 63, 0x00000C0061010202, "RW", "IMR16_CTRL_POL", "Bunit IMR16 Control Policy: Bit vector used to determine which agents are allowed access to the BIMR16RAC, BIMR16WAC, BIMR16CP registers based on the value from the agents 6bit SAI field."},
#else
{0, 63, 0x00000C0061010202, "RW", "IMR16_CTRL_POL", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo959[] = {{"B_CR_BIMR16CP_0_0_0_MCHBAR", "", 0x00006A78, 1, 0xFFFFFFFFFFFFFFFF, 0x00000C0061010202}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields960[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{63, 63, 0x0000000000000000, "RW", "IMR16_READ_POL_63", "Bunit IMR16 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR16 region based on the agents 6bit encoded SAI value."},
#else
{63, 63, 0x0000000000000000, "RW", "IMR16_READ_POL_63", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{62, 62, 0x0000000000000000, "RO", "IMR16_READ_POL_62", "Bunit IMR16 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR16 region based on the agents 6bit encoded SAI value."},
#else
{62, 62, 0x0000000000000000, "RO", "IMR16_READ_POL_62", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{61, 61, 0x0000000000000000, "RO", "IMR16_READ_POL_61", "Bunit IMR16 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR16 region based on the agents 6bit encoded SAI value."},
#else
{61, 61, 0x0000000000000000, "RO", "IMR16_READ_POL_61", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{60, 60, 0x0000000000000000, "RO", "IMR16_READ_POL_60", "Bunit IMR16 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR16 region based on the agents 6bit encoded SAI value."},
#else
{60, 60, 0x0000000000000000, "RO", "IMR16_READ_POL_60", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{59, 59, 0x0000000000000000, "RO", "IMR16_READ_POL_59", "Bunit IMR16 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR16 region based on the agents 6bit encoded SAI value."},
#else
{59, 59, 0x0000000000000000, "RO", "IMR16_READ_POL_59", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{58, 58, 0x0000000000000000, "RO", "IMR16_READ_POL_58", "Bunit IMR16 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR16 region based on the agents 6bit encoded SAI value."},
#else
{58, 58, 0x0000000000000000, "RO", "IMR16_READ_POL_58", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{57, 57, 0x0000000000000000, "RO", "IMR16_READ_POL_57", "Bunit IMR16 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR16 region based on the agents 6bit encoded SAI value."},
#else
{57, 57, 0x0000000000000000, "RO", "IMR16_READ_POL_57", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{56, 56, 0x0000000000000000, "RW", "IMR16_READ_POL_56", "Bunit IMR16 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR16 region based on the agents 6bit encoded SAI value."},
#else
{56, 56, 0x0000000000000000, "RW", "IMR16_READ_POL_56", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{55, 55, 0x0000000000000000, "RW", "IMR16_READ_POL_55", "Bunit IMR16 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR16 region based on the agents 6bit encoded SAI value."},
#else
{55, 55, 0x0000000000000000, "RW", "IMR16_READ_POL_55", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{54, 54, 0x0000000000000000, "RW", "IMR16_READ_POL_54", "Bunit IMR16 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR16 region based on the agents 6bit encoded SAI value."},
#else
{54, 54, 0x0000000000000000, "RW", "IMR16_READ_POL_54", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{53, 53, 0x0000000000000000, "RO", "IMR16_READ_POL_53", "Bunit IMR16 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR16 region based on the agents 6bit encoded SAI value."},
#else
{53, 53, 0x0000000000000000, "RO", "IMR16_READ_POL_53", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{52, 52, 0x0000000000000000, "RO", "IMR16_READ_POL_52", "Bunit IMR16 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR16 region based on the agents 6bit encoded SAI value."},
#else
{52, 52, 0x0000000000000000, "RO", "IMR16_READ_POL_52", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{51, 51, 0x0000000000000000, "RO", "IMR16_READ_POL_51", "Bunit IMR16 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR16 region based on the agents 6bit encoded SAI value."},
#else
{51, 51, 0x0000000000000000, "RO", "IMR16_READ_POL_51", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{50, 50, 0x0000000000000000, "RW", "IMR16_READ_POL_50", "Bunit IMR16 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR16 region based on the agents 6bit encoded SAI value."},
#else
{50, 50, 0x0000000000000000, "RW", "IMR16_READ_POL_50", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{49, 49, 0x0000000000000000, "RW", "IMR16_READ_POL_49", "Bunit IMR16 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR16 region based on the agents 6bit encoded SAI value."},
#else
{49, 49, 0x0000000000000000, "RW", "IMR16_READ_POL_49", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{48, 48, 0x0000000000000000, "RW", "IMR16_READ_POL_48", "Bunit IMR16 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR16 region based on the agents 6bit encoded SAI value."},
#else
{48, 48, 0x0000000000000000, "RW", "IMR16_READ_POL_48", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{47, 47, 0x0000000000000000, "RO", "IMR16_READ_POL_47", "Bunit IMR16 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR16 region based on the agents 6bit encoded SAI value."},
#else
{47, 47, 0x0000000000000000, "RO", "IMR16_READ_POL_47", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{46, 46, 0x0000000000000000, "RO", "IMR16_READ_POL_46", "Bunit IMR16 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR16 region based on the agents 6bit encoded SAI value."},
#else
{46, 46, 0x0000000000000000, "RO", "IMR16_READ_POL_46", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{45, 45, 0x0000000000000000, "RO", "IMR16_READ_POL_45", "Bunit IMR16 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR16 region based on the agents 6bit encoded SAI value."},
#else
{45, 45, 0x0000000000000000, "RO", "IMR16_READ_POL_45", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{44, 44, 0x0000000000000000, "RW", "IMR16_READ_POL_44", "Bunit IMR16 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR16 region based on the agents 6bit encoded SAI value."},
#else
{44, 44, 0x0000000000000000, "RW", "IMR16_READ_POL_44", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{43, 43, 0x0000000000000000, "RW", "IMR16_READ_POL_43", "Bunit IMR16 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR16 region based on the agents 6bit encoded SAI value."},
#else
{43, 43, 0x0000000000000000, "RW", "IMR16_READ_POL_43", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{42, 42, 0x0000000000000000, "RW", "IMR16_READ_POL_42", "Bunit IMR16 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR16 region based on the agents 6bit encoded SAI value."},
#else
{42, 42, 0x0000000000000000, "RW", "IMR16_READ_POL_42", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{41, 41, 0x0000000000000000, "RW", "IMR16_READ_POL_41", "Bunit IMR16 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR16 region based on the agents 6bit encoded SAI value."},
#else
{41, 41, 0x0000000000000000, "RW", "IMR16_READ_POL_41", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{40, 40, 0x0000000000000000, "RW", "IMR16_READ_POL_40", "Bunit IMR16 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR16 region based on the agents 6bit encoded SAI value."},
#else
{40, 40, 0x0000000000000000, "RW", "IMR16_READ_POL_40", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{39, 39, 0x0000000000000000, "RO", "IMR16_READ_POL_39", "Bunit IMR16 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR16 region based on the agents 6bit encoded SAI value."},
#else
{39, 39, 0x0000000000000000, "RO", "IMR16_READ_POL_39", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{38, 38, 0x0000000000000000, "RW", "IMR16_READ_POL_38", "Bunit IMR16 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR16 region based on the agents 6bit encoded SAI value."},
#else
{38, 38, 0x0000000000000000, "RW", "IMR16_READ_POL_38", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{37, 37, 0x0000000000000000, "RO", "IMR16_READ_POL_37", "Bunit IMR16 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR16 region based on the agents 6bit encoded SAI value."},
#else
{37, 37, 0x0000000000000000, "RO", "IMR16_READ_POL_37", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{36, 36, 0x0000000000000000, "RW", "IMR16_READ_POL_36", "Bunit IMR16 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR16 region based on the agents 6bit encoded SAI value."},
#else
{36, 36, 0x0000000000000000, "RW", "IMR16_READ_POL_36", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{35, 35, 0x0000000000000000, "RO", "IMR16_READ_POL_35", "Bunit IMR16 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR16 region based on the agents 6bit encoded SAI value."},
#else
{35, 35, 0x0000000000000000, "RO", "IMR16_READ_POL_35", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{34, 34, 0x0000000000000000, "RW", "IMR16_READ_POL_34", "Bunit IMR16 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR16 region based on the agents 6bit encoded SAI value."},
#else
{34, 34, 0x0000000000000000, "RW", "IMR16_READ_POL_34", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{33, 33, 0x0000000000000000, "RW", "IMR16_READ_POL_33", "Bunit IMR16 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR16 region based on the agents 6bit encoded SAI value."},
#else
{33, 33, 0x0000000000000000, "RW", "IMR16_READ_POL_33", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{32, 32, 0x0000000000000000, "RW", "IMR16_READ_POL_32", "Bunit IMR16 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR16 region based on the agents 6bit encoded SAI value."},
#else
{32, 32, 0x0000000000000000, "RW", "IMR16_READ_POL_32", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{31, 31, 0x0000000000000000, "RO", "IMR16_READ_POL_31", "Bunit IMR16 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR16 region based on the agents 6bit encoded SAI value."},
#else
{31, 31, 0x0000000000000000, "RO", "IMR16_READ_POL_31", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{30, 30, 0x0000000000000000, "RW", "IMR16_READ_POL_30", "Bunit IMR16 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR16 region based on the agents 6bit encoded SAI value."},
#else
{30, 30, 0x0000000000000000, "RW", "IMR16_READ_POL_30", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{29, 29, 0x0000000000000000, "RW", "IMR16_READ_POL_29", "Bunit IMR16 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR16 region based on the agents 6bit encoded SAI value."},
#else
{29, 29, 0x0000000000000000, "RW", "IMR16_READ_POL_29", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{28, 28, 0x0000000000000000, "RW", "IMR16_READ_POL_28", "Bunit IMR16 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR16 region based on the agents 6bit encoded SAI value."},
#else
{28, 28, 0x0000000000000000, "RW", "IMR16_READ_POL_28", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{27, 27, 0x0000000000000000, "RW", "IMR16_READ_POL_27", "Bunit IMR16 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR16 region based on the agents 6bit encoded SAI value."},
#else
{27, 27, 0x0000000000000000, "RW", "IMR16_READ_POL_27", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{26, 26, 0x0000000000000000, "RW", "IMR16_READ_POL_26", "Bunit IMR16 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR16 region based on the agents 6bit encoded SAI value."},
#else
{26, 26, 0x0000000000000000, "RW", "IMR16_READ_POL_26", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{25, 25, 0x0000000000000000, "RW", "IMR16_READ_POL_25", "Bunit IMR16 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR16 region based on the agents 6bit encoded SAI value."},
#else
{25, 25, 0x0000000000000000, "RW", "IMR16_READ_POL_25", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{24, 24, 0x0000000000000000, "RW", "IMR16_READ_POL_24", "Bunit IMR16 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR16 region based on the agents 6bit encoded SAI value."},
#else
{24, 24, 0x0000000000000000, "RW", "IMR16_READ_POL_24", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{23, 23, 0x0000000000000000, "RO", "IMR16_READ_POL_23", "Bunit IMR16 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR16 region based on the agents 6bit encoded SAI value."},
#else
{23, 23, 0x0000000000000000, "RO", "IMR16_READ_POL_23", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{22, 22, 0x0000000000000000, "RO", "IMR16_READ_POL_22", "Bunit IMR16 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR16 region based on the agents 6bit encoded SAI value."},
#else
{22, 22, 0x0000000000000000, "RO", "IMR16_READ_POL_22", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{21, 21, 0x0000000000000000, "RW", "IMR16_READ_POL_21", "Bunit IMR16 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR16 region based on the agents 6bit encoded SAI value."},
#else
{21, 21, 0x0000000000000000, "RW", "IMR16_READ_POL_21", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{20, 20, 0x0000000000000000, "RO", "IMR16_READ_POL_20", "Bunit IMR16 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR16 region based on the agents 6bit encoded SAI value."},
#else
{20, 20, 0x0000000000000000, "RO", "IMR16_READ_POL_20", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{19, 19, 0x0000000000000000, "RO", "IMR16_READ_POL_19", "Bunit IMR16 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR16 region based on the agents 6bit encoded SAI value."},
#else
{19, 19, 0x0000000000000000, "RO", "IMR16_READ_POL_19", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{18, 18, 0x0000000000000000, "RO", "IMR16_READ_POL_18", "Bunit IMR16 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR16 region based on the agents 6bit encoded SAI value."},
#else
{18, 18, 0x0000000000000000, "RO", "IMR16_READ_POL_18", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{17, 17, 0x0000000000000000, "RW", "IMR16_READ_POL_17", "Bunit IMR16 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR16 region based on the agents 6bit encoded SAI value."},
#else
{17, 17, 0x0000000000000000, "RW", "IMR16_READ_POL_17", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{16, 16, 0x0000000000000000, "RW", "IMR16_READ_POL_16", "Bunit IMR16 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR16 region based on the agents 6bit encoded SAI value."},
#else
{16, 16, 0x0000000000000000, "RW", "IMR16_READ_POL_16", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{15, 15, 0x0000000000000000, "RO", "IMR16_READ_POL_15", "Bunit IMR16 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR16 region based on the agents 6bit encoded SAI value."},
#else
{15, 15, 0x0000000000000000, "RO", "IMR16_READ_POL_15", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{14, 14, 0x0000000000000000, "RO", "IMR16_READ_POL_14", "Bunit IMR16 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR16 region based on the agents 6bit encoded SAI value."},
#else
{14, 14, 0x0000000000000000, "RO", "IMR16_READ_POL_14", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{13, 13, 0x0000000000000000, "RW", "IMR16_READ_POL_13", "Bunit IMR16 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR16 region based on the agents 6bit encoded SAI value."},
#else
{13, 13, 0x0000000000000000, "RW", "IMR16_READ_POL_13", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{12, 12, 0x0000000000000000, "RW", "IMR16_READ_POL_12", "Bunit IMR16 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR16 region based on the agents 6bit encoded SAI value."},
#else
{12, 12, 0x0000000000000000, "RW", "IMR16_READ_POL_12", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{11, 11, 0x0000000000000000, "RO", "IMR16_READ_POL_11", "Bunit IMR16 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR16 region based on the agents 6bit encoded SAI value."},
#else
{11, 11, 0x0000000000000000, "RO", "IMR16_READ_POL_11", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{10, 10, 0x0000000000000000, "RO", "IMR16_READ_POL_10", "Bunit IMR16 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR16 region based on the agents 6bit encoded SAI value."},
#else
{10, 10, 0x0000000000000000, "RO", "IMR16_READ_POL_10", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{9, 9, 0x0000000000000000, "RO", "IMR16_READ_POL_9", "Bunit IMR16 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR16 region based on the agents 6bit encoded SAI value."},
#else
{9, 9, 0x0000000000000000, "RO", "IMR16_READ_POL_9", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{8, 8, 0x0000000000000000, "RW", "IMR16_READ_POL_8", "Bunit IMR16 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR16 region based on the agents 6bit encoded SAI value."},
#else
{8, 8, 0x0000000000000000, "RW", "IMR16_READ_POL_8", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{7, 7, 0x0000000000000000, "RO", "IMR16_READ_POL_7", "Bunit IMR16 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR16 region based on the agents 6bit encoded SAI value."},
#else
{7, 7, 0x0000000000000000, "RO", "IMR16_READ_POL_7", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{6, 6, 0x0000000000000000, "RO", "IMR16_READ_POL_6", "Bunit IMR16 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR16 region based on the agents 6bit encoded SAI value."},
#else
{6, 6, 0x0000000000000000, "RO", "IMR16_READ_POL_6", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{5, 5, 0x0000000000000000, "RW", "IMR16_READ_POL_5", "Bunit IMR16 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR16 region based on the agents 6bit encoded SAI value."},
#else
{5, 5, 0x0000000000000000, "RW", "IMR16_READ_POL_5", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{4, 4, 0x0000000000000000, "RW", "IMR16_READ_POL_4", "Bunit IMR16 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR16 region based on the agents 6bit encoded SAI value."},
#else
{4, 4, 0x0000000000000000, "RW", "IMR16_READ_POL_4", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{3, 3, 0x0000000000000000, "RW", "IMR16_READ_POL_3", "Bunit IMR16 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR16 region based on the agents 6bit encoded SAI value."},
#else
{3, 3, 0x0000000000000000, "RW", "IMR16_READ_POL_3", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{2, 2, 0x0000000000000000, "RW", "IMR16_READ_POL_2", "Bunit IMR16 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR16 region based on the agents 6bit encoded SAI value."},
#else
{2, 2, 0x0000000000000000, "RW", "IMR16_READ_POL_2", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{1, 1, 0x0000000000000000, "RW", "IMR16_READ_POL_1", "Bunit IMR16 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR16 region based on the agents 6bit encoded SAI value."},
#else
{1, 1, 0x0000000000000000, "RW", "IMR16_READ_POL_1", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 0, 0x0000000000000000, "RW", "IMR16_READ_POL_0", "Bunit IMR16 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR16 region based on the agents 6bit encoded SAI value."},
#else
{0, 0, 0x0000000000000000, "RW", "IMR16_READ_POL_0", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo960[] = {{"B_CR_BIMR16RAC_0_0_0_MCHBAR", "", 0x00006A80, 64, 0xFFFFFFFFFFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields961[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{63, 63, 0x0000000000000000, "RW", "IMR16_WRITE_POL_63", "Bunit IMR16 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR16 region based on the agents 6bit encoded SAI value."},
#else
{63, 63, 0x0000000000000000, "RW", "IMR16_WRITE_POL_63", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{62, 62, 0x0000000000000000, "RO", "IMR16_WRITE_POL_62", "Bunit IMR16 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR16 region based on the agents 6bit encoded SAI value."},
#else
{62, 62, 0x0000000000000000, "RO", "IMR16_WRITE_POL_62", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{61, 61, 0x0000000000000000, "RO", "IMR16_WRITE_POL_61", "Bunit IMR16 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR16 region based on the agents 6bit encoded SAI value."},
#else
{61, 61, 0x0000000000000000, "RO", "IMR16_WRITE_POL_61", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{60, 60, 0x0000000000000000, "RO", "IMR16_WRITE_POL_60", "Bunit IMR16 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR16 region based on the agents 6bit encoded SAI value."},
#else
{60, 60, 0x0000000000000000, "RO", "IMR16_WRITE_POL_60", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{59, 59, 0x0000000000000000, "RO", "IMR16_WRITE_POL_59", "Bunit IMR16 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR16 region based on the agents 6bit encoded SAI value."},
#else
{59, 59, 0x0000000000000000, "RO", "IMR16_WRITE_POL_59", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{58, 58, 0x0000000000000000, "RO", "IMR16_WRITE_POL_58", "Bunit IMR16 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR16 region based on the agents 6bit encoded SAI value."},
#else
{58, 58, 0x0000000000000000, "RO", "IMR16_WRITE_POL_58", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{57, 57, 0x0000000000000000, "RO", "IMR16_WRITE_POL_57", "Bunit IMR16 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR16 region based on the agents 6bit encoded SAI value."},
#else
{57, 57, 0x0000000000000000, "RO", "IMR16_WRITE_POL_57", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{56, 56, 0x0000000000000000, "RW", "IMR16_WRITE_POL_56", "Bunit IMR16 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR16 region based on the agents 6bit encoded SAI value."},
#else
{56, 56, 0x0000000000000000, "RW", "IMR16_WRITE_POL_56", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{55, 55, 0x0000000000000000, "RW", "IMR16_WRITE_POL_55", "Bunit IMR16 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR16 region based on the agents 6bit encoded SAI value."},
#else
{55, 55, 0x0000000000000000, "RW", "IMR16_WRITE_POL_55", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{54, 54, 0x0000000000000000, "RW", "IMR16_WRITE_POL_54", "Bunit IMR16 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR16 region based on the agents 6bit encoded SAI value."},
#else
{54, 54, 0x0000000000000000, "RW", "IMR16_WRITE_POL_54", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{53, 53, 0x0000000000000000, "RO", "IMR16_WRITE_POL_53", "Bunit IMR16 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR16 region based on the agents 6bit encoded SAI value."},
#else
{53, 53, 0x0000000000000000, "RO", "IMR16_WRITE_POL_53", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{52, 52, 0x0000000000000000, "RO", "IMR16_WRITE_POL_52", "Bunit IMR16 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR16 region based on the agents 6bit encoded SAI value."},
#else
{52, 52, 0x0000000000000000, "RO", "IMR16_WRITE_POL_52", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{51, 51, 0x0000000000000000, "RO", "IMR16_WRITE_POL_51", "Bunit IMR16 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR16 region based on the agents 6bit encoded SAI value."},
#else
{51, 51, 0x0000000000000000, "RO", "IMR16_WRITE_POL_51", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{50, 50, 0x0000000000000000, "RW", "IMR16_WRITE_POL_50", "Bunit IMR16 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR16 region based on the agents 6bit encoded SAI value."},
#else
{50, 50, 0x0000000000000000, "RW", "IMR16_WRITE_POL_50", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{49, 49, 0x0000000000000000, "RW", "IMR16_WRITE_POL_49", "Bunit IMR16 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR16 region based on the agents 6bit encoded SAI value."},
#else
{49, 49, 0x0000000000000000, "RW", "IMR16_WRITE_POL_49", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{48, 48, 0x0000000000000000, "RW", "IMR16_WRITE_POL_48", "Bunit IMR16 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR16 region based on the agents 6bit encoded SAI value."},
#else
{48, 48, 0x0000000000000000, "RW", "IMR16_WRITE_POL_48", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{47, 47, 0x0000000000000000, "RO", "IMR16_WRITE_POL_47", "Bunit IMR16 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR16 region based on the agents 6bit encoded SAI value."},
#else
{47, 47, 0x0000000000000000, "RO", "IMR16_WRITE_POL_47", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{46, 46, 0x0000000000000000, "RO", "IMR16_WRITE_POL_46", "Bunit IMR16 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR16 region based on the agents 6bit encoded SAI value."},
#else
{46, 46, 0x0000000000000000, "RO", "IMR16_WRITE_POL_46", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{45, 45, 0x0000000000000000, "RO", "IMR16_WRITE_POL_45", "Bunit IMR16 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR16 region based on the agents 6bit encoded SAI value."},
#else
{45, 45, 0x0000000000000000, "RO", "IMR16_WRITE_POL_45", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{44, 44, 0x0000000000000000, "RW", "IMR16_WRITE_POL_44", "Bunit IMR16 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR16 region based on the agents 6bit encoded SAI value."},
#else
{44, 44, 0x0000000000000000, "RW", "IMR16_WRITE_POL_44", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{43, 43, 0x0000000000000000, "RW", "IMR16_WRITE_POL_43", "Bunit IMR16 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR16 region based on the agents 6bit encoded SAI value."},
#else
{43, 43, 0x0000000000000000, "RW", "IMR16_WRITE_POL_43", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{42, 42, 0x0000000000000000, "RW", "IMR16_WRITE_POL_42", "Bunit IMR16 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR16 region based on the agents 6bit encoded SAI value."},
#else
{42, 42, 0x0000000000000000, "RW", "IMR16_WRITE_POL_42", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{41, 41, 0x0000000000000000, "RW", "IMR16_WRITE_POL_41", "Bunit IMR16 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR16 region based on the agents 6bit encoded SAI value."},
#else
{41, 41, 0x0000000000000000, "RW", "IMR16_WRITE_POL_41", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{40, 40, 0x0000000000000000, "RW", "IMR16_WRITE_POL_40", "Bunit IMR16 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR16 region based on the agents 6bit encoded SAI value."},
#else
{40, 40, 0x0000000000000000, "RW", "IMR16_WRITE_POL_40", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{39, 39, 0x0000000000000000, "RO", "IMR16_WRITE_POL_39", "Bunit IMR16 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR16 region based on the agents 6bit encoded SAI value."},
#else
{39, 39, 0x0000000000000000, "RO", "IMR16_WRITE_POL_39", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{38, 38, 0x0000000000000000, "RW", "IMR16_WRITE_POL_38", "Bunit IMR16 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR16 region based on the agents 6bit encoded SAI value."},
#else
{38, 38, 0x0000000000000000, "RW", "IMR16_WRITE_POL_38", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{37, 37, 0x0000000000000000, "RO", "IMR16_WRITE_POL_37", "Bunit IMR16 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR16 region based on the agents 6bit encoded SAI value."},
#else
{37, 37, 0x0000000000000000, "RO", "IMR16_WRITE_POL_37", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{36, 36, 0x0000000000000000, "RW", "IMR16_WRITE_POL_36", "Bunit IMR16 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR16 region based on the agents 6bit encoded SAI value."},
#else
{36, 36, 0x0000000000000000, "RW", "IMR16_WRITE_POL_36", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{35, 35, 0x0000000000000000, "RO", "IMR16_WRITE_POL_35", "Bunit IMR16 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR16 region based on the agents 6bit encoded SAI value."},
#else
{35, 35, 0x0000000000000000, "RO", "IMR16_WRITE_POL_35", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{34, 34, 0x0000000000000000, "RW", "IMR16_WRITE_POL_34", "Bunit IMR16 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR16 region based on the agents 6bit encoded SAI value."},
#else
{34, 34, 0x0000000000000000, "RW", "IMR16_WRITE_POL_34", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{33, 33, 0x0000000000000000, "RW", "IMR16_WRITE_POL_33", "Bunit IMR16 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR16 region based on the agents 6bit encoded SAI value."},
#else
{33, 33, 0x0000000000000000, "RW", "IMR16_WRITE_POL_33", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{32, 32, 0x0000000000000000, "RW", "IMR16_WRITE_POL_32", "Bunit IMR16 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR16 region based on the agents 6bit encoded SAI value."},
#else
{32, 32, 0x0000000000000000, "RW", "IMR16_WRITE_POL_32", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{31, 31, 0x0000000000000000, "RO", "IMR16_WRITE_POL_31", "Bunit IMR16 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR16 region based on the agents 6bit encoded SAI value."},
#else
{31, 31, 0x0000000000000000, "RO", "IMR16_WRITE_POL_31", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{30, 30, 0x0000000000000000, "RW", "IMR16_WRITE_POL_30", "Bunit IMR16 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR16 region based on the agents 6bit encoded SAI value."},
#else
{30, 30, 0x0000000000000000, "RW", "IMR16_WRITE_POL_30", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{29, 29, 0x0000000000000000, "RW", "IMR16_WRITE_POL_29", "Bunit IMR16 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR16 region based on the agents 6bit encoded SAI value."},
#else
{29, 29, 0x0000000000000000, "RW", "IMR16_WRITE_POL_29", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{28, 28, 0x0000000000000000, "RW", "IMR16_WRITE_POL_28", "Bunit IMR16 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR16 region based on the agents 6bit encoded SAI value."},
#else
{28, 28, 0x0000000000000000, "RW", "IMR16_WRITE_POL_28", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{27, 27, 0x0000000000000000, "RW", "IMR16_WRITE_POL_27", "Bunit IMR16 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR16 region based on the agents 6bit encoded SAI value."},
#else
{27, 27, 0x0000000000000000, "RW", "IMR16_WRITE_POL_27", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{26, 26, 0x0000000000000000, "RW", "IMR16_WRITE_POL_26", "Bunit IMR16 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR16 region based on the agents 6bit encoded SAI value."},
#else
{26, 26, 0x0000000000000000, "RW", "IMR16_WRITE_POL_26", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{25, 25, 0x0000000000000000, "RW", "IMR16_WRITE_POL_25", "Bunit IMR16 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR16 region based on the agents 6bit encoded SAI value."},
#else
{25, 25, 0x0000000000000000, "RW", "IMR16_WRITE_POL_25", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{24, 24, 0x0000000000000000, "RW", "IMR16_WRITE_POL_24", "Bunit IMR16 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR16 region based on the agents 6bit encoded SAI value."},
#else
{24, 24, 0x0000000000000000, "RW", "IMR16_WRITE_POL_24", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{23, 23, 0x0000000000000000, "RO", "IMR16_WRITE_POL_23", "Bunit IMR16 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR16 region based on the agents 6bit encoded SAI value."},
#else
{23, 23, 0x0000000000000000, "RO", "IMR16_WRITE_POL_23", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{22, 22, 0x0000000000000000, "RO", "IMR16_WRITE_POL_22", "Bunit IMR16 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR16 region based on the agents 6bit encoded SAI value."},
#else
{22, 22, 0x0000000000000000, "RO", "IMR16_WRITE_POL_22", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{21, 21, 0x0000000000000000, "RW", "IMR16_WRITE_POL_21", "Bunit IMR16 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR16 region based on the agents 6bit encoded SAI value."},
#else
{21, 21, 0x0000000000000000, "RW", "IMR16_WRITE_POL_21", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{20, 20, 0x0000000000000000, "RO", "IMR16_WRITE_POL_20", "Bunit IMR16 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR16 region based on the agents 6bit encoded SAI value."},
#else
{20, 20, 0x0000000000000000, "RO", "IMR16_WRITE_POL_20", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{19, 19, 0x0000000000000000, "RO", "IMR16_WRITE_POL_19", "Bunit IMR16 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR16 region based on the agents 6bit encoded SAI value."},
#else
{19, 19, 0x0000000000000000, "RO", "IMR16_WRITE_POL_19", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{18, 18, 0x0000000000000000, "RO", "IMR16_WRITE_POL_18", "Bunit IMR16 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR16 region based on the agents 6bit encoded SAI value."},
#else
{18, 18, 0x0000000000000000, "RO", "IMR16_WRITE_POL_18", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{17, 17, 0x0000000000000000, "RW", "IMR16_WRITE_POL_17", "Bunit IMR16 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR16 region based on the agents 6bit encoded SAI value."},
#else
{17, 17, 0x0000000000000000, "RW", "IMR16_WRITE_POL_17", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{16, 16, 0x0000000000000000, "RW", "IMR16_WRITE_POL_16", "Bunit IMR16 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR16 region based on the agents 6bit encoded SAI value."},
#else
{16, 16, 0x0000000000000000, "RW", "IMR16_WRITE_POL_16", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{15, 15, 0x0000000000000000, "RO", "IMR16_WRITE_POL_15", "Bunit IMR16 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR16 region based on the agents 6bit encoded SAI value."},
#else
{15, 15, 0x0000000000000000, "RO", "IMR16_WRITE_POL_15", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{14, 14, 0x0000000000000000, "RO", "IMR16_WRITE_POL_14", "Bunit IMR16 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR16 region based on the agents 6bit encoded SAI value."},
#else
{14, 14, 0x0000000000000000, "RO", "IMR16_WRITE_POL_14", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{13, 13, 0x0000000000000000, "RW", "IMR16_WRITE_POL_13", "Bunit IMR16 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR16 region based on the agents 6bit encoded SAI value."},
#else
{13, 13, 0x0000000000000000, "RW", "IMR16_WRITE_POL_13", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{12, 12, 0x0000000000000000, "RW", "IMR16_WRITE_POL_12", "Bunit IMR16 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR16 region based on the agents 6bit encoded SAI value."},
#else
{12, 12, 0x0000000000000000, "RW", "IMR16_WRITE_POL_12", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{11, 11, 0x0000000000000000, "RO", "IMR16_WRITE_POL_11", "Bunit IMR16 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR16 region based on the agents 6bit encoded SAI value."},
#else
{11, 11, 0x0000000000000000, "RO", "IMR16_WRITE_POL_11", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{10, 10, 0x0000000000000000, "RO", "IMR16_WRITE_POL_10", "Bunit IMR16 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR16 region based on the agents 6bit encoded SAI value."},
#else
{10, 10, 0x0000000000000000, "RO", "IMR16_WRITE_POL_10", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{9, 9, 0x0000000000000000, "RO", "IMR16_WRITE_POL_9", "Bunit IMR16 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR16 region based on the agents 6bit encoded SAI value."},
#else
{9, 9, 0x0000000000000000, "RO", "IMR16_WRITE_POL_9", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{8, 8, 0x0000000000000000, "RW", "IMR16_WRITE_POL_8", "Bunit IMR16 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR16 region based on the agents 6bit encoded SAI value."},
#else
{8, 8, 0x0000000000000000, "RW", "IMR16_WRITE_POL_8", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{7, 7, 0x0000000000000000, "RO", "IMR16_WRITE_POL_7", "Bunit IMR16 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR16 region based on the agents 6bit encoded SAI value."},
#else
{7, 7, 0x0000000000000000, "RO", "IMR16_WRITE_POL_7", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{6, 6, 0x0000000000000000, "RO", "IMR16_WRITE_POL_6", "Bunit IMR16 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR16 region based on the agents 6bit encoded SAI value."},
#else
{6, 6, 0x0000000000000000, "RO", "IMR16_WRITE_POL_6", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{5, 5, 0x0000000000000000, "RW", "IMR16_WRITE_POL_5", "Bunit IMR16 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR16 region based on the agents 6bit encoded SAI value."},
#else
{5, 5, 0x0000000000000000, "RW", "IMR16_WRITE_POL_5", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{4, 4, 0x0000000000000000, "RW", "IMR16_WRITE_POL_4", "Bunit IMR16 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR16 region based on the agents 6bit encoded SAI value."},
#else
{4, 4, 0x0000000000000000, "RW", "IMR16_WRITE_POL_4", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{3, 3, 0x0000000000000000, "RW", "IMR16_WRITE_POL_3", "Bunit IMR16 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR16 region based on the agents 6bit encoded SAI value."},
#else
{3, 3, 0x0000000000000000, "RW", "IMR16_WRITE_POL_3", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{2, 2, 0x0000000000000000, "RW", "IMR16_WRITE_POL_2", "Bunit IMR16 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR16 region based on the agents 6bit encoded SAI value."},
#else
{2, 2, 0x0000000000000000, "RW", "IMR16_WRITE_POL_2", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{1, 1, 0x0000000000000000, "RW", "IMR16_WRITE_POL_1", "Bunit IMR16 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR16 region based on the agents 6bit encoded SAI value."},
#else
{1, 1, 0x0000000000000000, "RW", "IMR16_WRITE_POL_1", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 0, 0x0000000000000000, "RW", "IMR16_WRITE_POL_0", "Bunit IMR16 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR16 region based on the agents 6bit encoded SAI value."},
#else
{0, 0, 0x0000000000000000, "RW", "IMR16_WRITE_POL_0", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo961[] = {{"B_CR_BIMR16WAC_0_0_0_MCHBAR", "", 0x00006A88, 64, 0xFFFFFFFFFFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields962[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{31, 31, 0x0000000000000000, "RW", "IMR_EN", "IMR Enable: Enables access checking for the IMR region."},
#else
{31, 31, 0x0000000000000000, "RW", "IMR_EN", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{30, 30, 0x0000000000000000, "RW", "TR_EN", "Asset Classification AC[0]: Trace Enable: Enables snooping of transactions to the IMR region by tracing agents."},
#else
{30, 30, 0x0000000000000000, "RW", "TR_EN", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{29, 29, 0x0000000000000000, "RO", "RESERVED_1", "Reserved"},
#else
{29, 29, 0x0000000000000000, "RO", "RESERVED_1", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 28, 0x0000000000000000, "RW", "IMR17_BASE", "Base 0 IMR17BASE:  Specifies bits 38:10 of the start address of IMR17 region.  IMR region size must be a strict poweroftwo at least 1KB and naturally aligned to the size.  These bits are compared with the result of the IMR17MASK[28:0] applied to bits 38:10 of the incoming address to determine if an access falls within the IMR17 defined region."},
#else
{0, 28, 0x0000000000000000, "RW", "IMR17_BASE", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo962[] = {{"B_CR_BIMR17BASE_0_0_0_MCHBAR", "", 0x00006A90, 4, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields963[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{31, 31, 0x0000000000000000, "RW", "GT_IWB_EN", "Asset Classification AC[2]: GT Implicit WB Enable: Enables implicit writebacks to protected region from GT caching agent. When set to 1 enables implicit writeback data HITM data from GT to be returned to the requester.  When set to 0 inhibits HITM data from GT from being returned to the requester.  HITM data from IA cores may be returned to the requester depending on the setting of the IA_IWB_EN bit."},
#else
{31, 31, 0x0000000000000000, "RW", "GT_IWB_EN", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{30, 30, 0x0000000000000000, "RW", "IA_IWB_EN", "Asset Classification AC[1]: IA Implicit WB Enable: Enables implicit writebacks to protected region from IA caching agent.  When set to 1 enables implicit writeback data HITM data from IA cores to be returned to the requester.  When set to 0 inhibits HITM data from IA cores from being returned to the requester.  HITM data from GT may be returned to the requester depending on the setting of the GT_IWB_EN bit."},
#else
{30, 30, 0x0000000000000000, "RW", "IA_IWB_EN", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{29, 29, 0x0000000000000000, "RO", "RESERVED_0", "Reserved"},
#else
{29, 29, 0x0000000000000000, "RO", "RESERVED_0", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 28, 0x0000000000000000, "RW", "IMR17_MASK", "Mask 0 IMR17MASK:  These bits are ANDed with bits 38:10 of the incoming address to determine if the combined result matches the IMR17BASE[28:0] value.  A match indicates the the incoming address falls within the IMR17 region."},
#else
{0, 28, 0x0000000000000000, "RW", "IMR17_MASK", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo963[] = {{"B_CR_BIMR17MASK_0_0_0_MCHBAR", "", 0x00006A94, 4, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields964[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{0, 63, 0x00000C0061010202, "RW", "IMR17_CTRL_POL", "Bunit IMR17 Control Policy: Bit vector used to determine which agents are allowed access to the BIMR17RAC, BIMR17WAC, BIMR17CP registers based on the value from the agents 6bit SAI field."},
#else
{0, 63, 0x00000C0061010202, "RW", "IMR17_CTRL_POL", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo964[] = {{"B_CR_BIMR17CP_0_0_0_MCHBAR", "", 0x00006A98, 1, 0xFFFFFFFFFFFFFFFF, 0x00000C0061010202}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields965[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{63, 63, 0x0000000000000000, "RW", "IMR17_READ_POL_63", "Bunit IMR17 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR17 region based on the agents 6bit encoded SAI value."},
#else
{63, 63, 0x0000000000000000, "RW", "IMR17_READ_POL_63", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{62, 62, 0x0000000000000000, "RO", "IMR17_READ_POL_62", "Bunit IMR17 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR17 region based on the agents 6bit encoded SAI value."},
#else
{62, 62, 0x0000000000000000, "RO", "IMR17_READ_POL_62", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{61, 61, 0x0000000000000000, "RO", "IMR17_READ_POL_61", "Bunit IMR17 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR17 region based on the agents 6bit encoded SAI value."},
#else
{61, 61, 0x0000000000000000, "RO", "IMR17_READ_POL_61", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{60, 60, 0x0000000000000000, "RO", "IMR17_READ_POL_60", "Bunit IMR17 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR17 region based on the agents 6bit encoded SAI value."},
#else
{60, 60, 0x0000000000000000, "RO", "IMR17_READ_POL_60", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{59, 59, 0x0000000000000000, "RO", "IMR17_READ_POL_59", "Bunit IMR17 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR17 region based on the agents 6bit encoded SAI value."},
#else
{59, 59, 0x0000000000000000, "RO", "IMR17_READ_POL_59", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{58, 58, 0x0000000000000000, "RO", "IMR17_READ_POL_58", "Bunit IMR17 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR17 region based on the agents 6bit encoded SAI value."},
#else
{58, 58, 0x0000000000000000, "RO", "IMR17_READ_POL_58", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{57, 57, 0x0000000000000000, "RO", "IMR17_READ_POL_57", "Bunit IMR17 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR17 region based on the agents 6bit encoded SAI value."},
#else
{57, 57, 0x0000000000000000, "RO", "IMR17_READ_POL_57", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{56, 56, 0x0000000000000000, "RW", "IMR17_READ_POL_56", "Bunit IMR17 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR17 region based on the agents 6bit encoded SAI value."},
#else
{56, 56, 0x0000000000000000, "RW", "IMR17_READ_POL_56", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{55, 55, 0x0000000000000000, "RW", "IMR17_READ_POL_55", "Bunit IMR17 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR17 region based on the agents 6bit encoded SAI value."},
#else
{55, 55, 0x0000000000000000, "RW", "IMR17_READ_POL_55", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{54, 54, 0x0000000000000000, "RW", "IMR17_READ_POL_54", "Bunit IMR17 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR17 region based on the agents 6bit encoded SAI value."},
#else
{54, 54, 0x0000000000000000, "RW", "IMR17_READ_POL_54", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{53, 53, 0x0000000000000000, "RO", "IMR17_READ_POL_53", "Bunit IMR17 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR17 region based on the agents 6bit encoded SAI value."},
#else
{53, 53, 0x0000000000000000, "RO", "IMR17_READ_POL_53", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{52, 52, 0x0000000000000000, "RO", "IMR17_READ_POL_52", "Bunit IMR17 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR17 region based on the agents 6bit encoded SAI value."},
#else
{52, 52, 0x0000000000000000, "RO", "IMR17_READ_POL_52", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{51, 51, 0x0000000000000000, "RO", "IMR17_READ_POL_51", "Bunit IMR17 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR17 region based on the agents 6bit encoded SAI value."},
#else
{51, 51, 0x0000000000000000, "RO", "IMR17_READ_POL_51", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{50, 50, 0x0000000000000000, "RW", "IMR17_READ_POL_50", "Bunit IMR17 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR17 region based on the agents 6bit encoded SAI value."},
#else
{50, 50, 0x0000000000000000, "RW", "IMR17_READ_POL_50", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{49, 49, 0x0000000000000000, "RW", "IMR17_READ_POL_49", "Bunit IMR17 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR17 region based on the agents 6bit encoded SAI value."},
#else
{49, 49, 0x0000000000000000, "RW", "IMR17_READ_POL_49", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{48, 48, 0x0000000000000000, "RW", "IMR17_READ_POL_48", "Bunit IMR17 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR17 region based on the agents 6bit encoded SAI value."},
#else
{48, 48, 0x0000000000000000, "RW", "IMR17_READ_POL_48", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{47, 47, 0x0000000000000000, "RO", "IMR17_READ_POL_47", "Bunit IMR17 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR17 region based on the agents 6bit encoded SAI value."},
#else
{47, 47, 0x0000000000000000, "RO", "IMR17_READ_POL_47", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{46, 46, 0x0000000000000000, "RO", "IMR17_READ_POL_46", "Bunit IMR17 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR17 region based on the agents 6bit encoded SAI value."},
#else
{46, 46, 0x0000000000000000, "RO", "IMR17_READ_POL_46", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{45, 45, 0x0000000000000000, "RO", "IMR17_READ_POL_45", "Bunit IMR17 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR17 region based on the agents 6bit encoded SAI value."},
#else
{45, 45, 0x0000000000000000, "RO", "IMR17_READ_POL_45", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{44, 44, 0x0000000000000000, "RW", "IMR17_READ_POL_44", "Bunit IMR17 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR17 region based on the agents 6bit encoded SAI value."},
#else
{44, 44, 0x0000000000000000, "RW", "IMR17_READ_POL_44", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{43, 43, 0x0000000000000000, "RW", "IMR17_READ_POL_43", "Bunit IMR17 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR17 region based on the agents 6bit encoded SAI value."},
#else
{43, 43, 0x0000000000000000, "RW", "IMR17_READ_POL_43", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{42, 42, 0x0000000000000000, "RW", "IMR17_READ_POL_42", "Bunit IMR17 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR17 region based on the agents 6bit encoded SAI value."},
#else
{42, 42, 0x0000000000000000, "RW", "IMR17_READ_POL_42", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{41, 41, 0x0000000000000000, "RW", "IMR17_READ_POL_41", "Bunit IMR17 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR17 region based on the agents 6bit encoded SAI value."},
#else
{41, 41, 0x0000000000000000, "RW", "IMR17_READ_POL_41", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{40, 40, 0x0000000000000000, "RW", "IMR17_READ_POL_40", "Bunit IMR17 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR17 region based on the agents 6bit encoded SAI value."},
#else
{40, 40, 0x0000000000000000, "RW", "IMR17_READ_POL_40", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{39, 39, 0x0000000000000000, "RO", "IMR17_READ_POL_39", "Bunit IMR17 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR17 region based on the agents 6bit encoded SAI value."},
#else
{39, 39, 0x0000000000000000, "RO", "IMR17_READ_POL_39", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{38, 38, 0x0000000000000000, "RW", "IMR17_READ_POL_38", "Bunit IMR17 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR17 region based on the agents 6bit encoded SAI value."},
#else
{38, 38, 0x0000000000000000, "RW", "IMR17_READ_POL_38", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{37, 37, 0x0000000000000000, "RO", "IMR17_READ_POL_37", "Bunit IMR17 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR17 region based on the agents 6bit encoded SAI value."},
#else
{37, 37, 0x0000000000000000, "RO", "IMR17_READ_POL_37", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{36, 36, 0x0000000000000000, "RW", "IMR17_READ_POL_36", "Bunit IMR17 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR17 region based on the agents 6bit encoded SAI value."},
#else
{36, 36, 0x0000000000000000, "RW", "IMR17_READ_POL_36", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{35, 35, 0x0000000000000000, "RO", "IMR17_READ_POL_35", "Bunit IMR17 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR17 region based on the agents 6bit encoded SAI value."},
#else
{35, 35, 0x0000000000000000, "RO", "IMR17_READ_POL_35", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{34, 34, 0x0000000000000000, "RW", "IMR17_READ_POL_34", "Bunit IMR17 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR17 region based on the agents 6bit encoded SAI value."},
#else
{34, 34, 0x0000000000000000, "RW", "IMR17_READ_POL_34", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{33, 33, 0x0000000000000000, "RW", "IMR17_READ_POL_33", "Bunit IMR17 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR17 region based on the agents 6bit encoded SAI value."},
#else
{33, 33, 0x0000000000000000, "RW", "IMR17_READ_POL_33", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{32, 32, 0x0000000000000000, "RW", "IMR17_READ_POL_32", "Bunit IMR17 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR17 region based on the agents 6bit encoded SAI value."},
#else
{32, 32, 0x0000000000000000, "RW", "IMR17_READ_POL_32", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{31, 31, 0x0000000000000000, "RO", "IMR17_READ_POL_31", "Bunit IMR17 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR17 region based on the agents 6bit encoded SAI value."},
#else
{31, 31, 0x0000000000000000, "RO", "IMR17_READ_POL_31", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{30, 30, 0x0000000000000000, "RW", "IMR17_READ_POL_30", "Bunit IMR17 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR17 region based on the agents 6bit encoded SAI value."},
#else
{30, 30, 0x0000000000000000, "RW", "IMR17_READ_POL_30", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{29, 29, 0x0000000000000000, "RW", "IMR17_READ_POL_29", "Bunit IMR17 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR17 region based on the agents 6bit encoded SAI value."},
#else
{29, 29, 0x0000000000000000, "RW", "IMR17_READ_POL_29", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{28, 28, 0x0000000000000000, "RW", "IMR17_READ_POL_28", "Bunit IMR17 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR17 region based on the agents 6bit encoded SAI value."},
#else
{28, 28, 0x0000000000000000, "RW", "IMR17_READ_POL_28", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{27, 27, 0x0000000000000000, "RW", "IMR17_READ_POL_27", "Bunit IMR17 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR17 region based on the agents 6bit encoded SAI value."},
#else
{27, 27, 0x0000000000000000, "RW", "IMR17_READ_POL_27", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{26, 26, 0x0000000000000000, "RW", "IMR17_READ_POL_26", "Bunit IMR17 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR17 region based on the agents 6bit encoded SAI value."},
#else
{26, 26, 0x0000000000000000, "RW", "IMR17_READ_POL_26", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{25, 25, 0x0000000000000000, "RW", "IMR17_READ_POL_25", "Bunit IMR17 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR17 region based on the agents 6bit encoded SAI value."},
#else
{25, 25, 0x0000000000000000, "RW", "IMR17_READ_POL_25", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{24, 24, 0x0000000000000000, "RW", "IMR17_READ_POL_24", "Bunit IMR17 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR17 region based on the agents 6bit encoded SAI value."},
#else
{24, 24, 0x0000000000000000, "RW", "IMR17_READ_POL_24", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{23, 23, 0x0000000000000000, "RO", "IMR17_READ_POL_23", "Bunit IMR17 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR17 region based on the agents 6bit encoded SAI value."},
#else
{23, 23, 0x0000000000000000, "RO", "IMR17_READ_POL_23", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{22, 22, 0x0000000000000000, "RO", "IMR17_READ_POL_22", "Bunit IMR17 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR17 region based on the agents 6bit encoded SAI value."},
#else
{22, 22, 0x0000000000000000, "RO", "IMR17_READ_POL_22", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{21, 21, 0x0000000000000000, "RW", "IMR17_READ_POL_21", "Bunit IMR17 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR17 region based on the agents 6bit encoded SAI value."},
#else
{21, 21, 0x0000000000000000, "RW", "IMR17_READ_POL_21", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{20, 20, 0x0000000000000000, "RO", "IMR17_READ_POL_20", "Bunit IMR17 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR17 region based on the agents 6bit encoded SAI value."},
#else
{20, 20, 0x0000000000000000, "RO", "IMR17_READ_POL_20", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{19, 19, 0x0000000000000000, "RO", "IMR17_READ_POL_19", "Bunit IMR17 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR17 region based on the agents 6bit encoded SAI value."},
#else
{19, 19, 0x0000000000000000, "RO", "IMR17_READ_POL_19", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{18, 18, 0x0000000000000000, "RO", "IMR17_READ_POL_18", "Bunit IMR17 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR17 region based on the agents 6bit encoded SAI value."},
#else
{18, 18, 0x0000000000000000, "RO", "IMR17_READ_POL_18", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{17, 17, 0x0000000000000000, "RW", "IMR17_READ_POL_17", "Bunit IMR17 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR17 region based on the agents 6bit encoded SAI value."},
#else
{17, 17, 0x0000000000000000, "RW", "IMR17_READ_POL_17", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{16, 16, 0x0000000000000000, "RW", "IMR17_READ_POL_16", "Bunit IMR17 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR17 region based on the agents 6bit encoded SAI value."},
#else
{16, 16, 0x0000000000000000, "RW", "IMR17_READ_POL_16", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{15, 15, 0x0000000000000000, "RO", "IMR17_READ_POL_15", "Bunit IMR17 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR17 region based on the agents 6bit encoded SAI value."},
#else
{15, 15, 0x0000000000000000, "RO", "IMR17_READ_POL_15", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{14, 14, 0x0000000000000000, "RO", "IMR17_READ_POL_14", "Bunit IMR17 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR17 region based on the agents 6bit encoded SAI value."},
#else
{14, 14, 0x0000000000000000, "RO", "IMR17_READ_POL_14", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{13, 13, 0x0000000000000000, "RW", "IMR17_READ_POL_13", "Bunit IMR17 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR17 region based on the agents 6bit encoded SAI value."},
#else
{13, 13, 0x0000000000000000, "RW", "IMR17_READ_POL_13", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{12, 12, 0x0000000000000000, "RW", "IMR17_READ_POL_12", "Bunit IMR17 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR17 region based on the agents 6bit encoded SAI value."},
#else
{12, 12, 0x0000000000000000, "RW", "IMR17_READ_POL_12", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{11, 11, 0x0000000000000000, "RO", "IMR17_READ_POL_11", "Bunit IMR17 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR17 region based on the agents 6bit encoded SAI value."},
#else
{11, 11, 0x0000000000000000, "RO", "IMR17_READ_POL_11", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{10, 10, 0x0000000000000000, "RO", "IMR17_READ_POL_10", "Bunit IMR17 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR17 region based on the agents 6bit encoded SAI value."},
#else
{10, 10, 0x0000000000000000, "RO", "IMR17_READ_POL_10", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{9, 9, 0x0000000000000000, "RO", "IMR17_READ_POL_9", "Bunit IMR17 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR17 region based on the agents 6bit encoded SAI value."},
#else
{9, 9, 0x0000000000000000, "RO", "IMR17_READ_POL_9", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{8, 8, 0x0000000000000000, "RW", "IMR17_READ_POL_8", "Bunit IMR17 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR17 region based on the agents 6bit encoded SAI value."},
#else
{8, 8, 0x0000000000000000, "RW", "IMR17_READ_POL_8", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{7, 7, 0x0000000000000000, "RO", "IMR17_READ_POL_7", "Bunit IMR17 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR17 region based on the agents 6bit encoded SAI value."},
#else
{7, 7, 0x0000000000000000, "RO", "IMR17_READ_POL_7", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{6, 6, 0x0000000000000000, "RO", "IMR17_READ_POL_6", "Bunit IMR17 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR17 region based on the agents 6bit encoded SAI value."},
#else
{6, 6, 0x0000000000000000, "RO", "IMR17_READ_POL_6", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{5, 5, 0x0000000000000000, "RW", "IMR17_READ_POL_5", "Bunit IMR17 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR17 region based on the agents 6bit encoded SAI value."},
#else
{5, 5, 0x0000000000000000, "RW", "IMR17_READ_POL_5", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{4, 4, 0x0000000000000000, "RW", "IMR17_READ_POL_4", "Bunit IMR17 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR17 region based on the agents 6bit encoded SAI value."},
#else
{4, 4, 0x0000000000000000, "RW", "IMR17_READ_POL_4", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{3, 3, 0x0000000000000000, "RW", "IMR17_READ_POL_3", "Bunit IMR17 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR17 region based on the agents 6bit encoded SAI value."},
#else
{3, 3, 0x0000000000000000, "RW", "IMR17_READ_POL_3", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{2, 2, 0x0000000000000000, "RW", "IMR17_READ_POL_2", "Bunit IMR17 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR17 region based on the agents 6bit encoded SAI value."},
#else
{2, 2, 0x0000000000000000, "RW", "IMR17_READ_POL_2", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{1, 1, 0x0000000000000000, "RW", "IMR17_READ_POL_1", "Bunit IMR17 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR17 region based on the agents 6bit encoded SAI value."},
#else
{1, 1, 0x0000000000000000, "RW", "IMR17_READ_POL_1", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 0, 0x0000000000000000, "RW", "IMR17_READ_POL_0", "Bunit IMR17 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR17 region based on the agents 6bit encoded SAI value."},
#else
{0, 0, 0x0000000000000000, "RW", "IMR17_READ_POL_0", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo965[] = {{"B_CR_BIMR17RAC_0_0_0_MCHBAR", "", 0x00006AA0, 64, 0xFFFFFFFFFFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields966[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{63, 63, 0x0000000000000000, "RW", "IMR17_WRITE_POL_63", "Bunit IMR17 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR17 region based on the agents 6bit encoded SAI value."},
#else
{63, 63, 0x0000000000000000, "RW", "IMR17_WRITE_POL_63", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{62, 62, 0x0000000000000000, "RO", "IMR17_WRITE_POL_62", "Bunit IMR17 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR17 region based on the agents 6bit encoded SAI value."},
#else
{62, 62, 0x0000000000000000, "RO", "IMR17_WRITE_POL_62", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{61, 61, 0x0000000000000000, "RO", "IMR17_WRITE_POL_61", "Bunit IMR17 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR17 region based on the agents 6bit encoded SAI value."},
#else
{61, 61, 0x0000000000000000, "RO", "IMR17_WRITE_POL_61", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{60, 60, 0x0000000000000000, "RO", "IMR17_WRITE_POL_60", "Bunit IMR17 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR17 region based on the agents 6bit encoded SAI value."},
#else
{60, 60, 0x0000000000000000, "RO", "IMR17_WRITE_POL_60", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{59, 59, 0x0000000000000000, "RO", "IMR17_WRITE_POL_59", "Bunit IMR17 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR17 region based on the agents 6bit encoded SAI value."},
#else
{59, 59, 0x0000000000000000, "RO", "IMR17_WRITE_POL_59", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{58, 58, 0x0000000000000000, "RO", "IMR17_WRITE_POL_58", "Bunit IMR17 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR17 region based on the agents 6bit encoded SAI value."},
#else
{58, 58, 0x0000000000000000, "RO", "IMR17_WRITE_POL_58", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{57, 57, 0x0000000000000000, "RO", "IMR17_WRITE_POL_57", "Bunit IMR17 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR17 region based on the agents 6bit encoded SAI value."},
#else
{57, 57, 0x0000000000000000, "RO", "IMR17_WRITE_POL_57", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{56, 56, 0x0000000000000000, "RW", "IMR17_WRITE_POL_56", "Bunit IMR17 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR17 region based on the agents 6bit encoded SAI value."},
#else
{56, 56, 0x0000000000000000, "RW", "IMR17_WRITE_POL_56", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{55, 55, 0x0000000000000000, "RW", "IMR17_WRITE_POL_55", "Bunit IMR17 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR17 region based on the agents 6bit encoded SAI value."},
#else
{55, 55, 0x0000000000000000, "RW", "IMR17_WRITE_POL_55", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{54, 54, 0x0000000000000000, "RW", "IMR17_WRITE_POL_54", "Bunit IMR17 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR17 region based on the agents 6bit encoded SAI value."},
#else
{54, 54, 0x0000000000000000, "RW", "IMR17_WRITE_POL_54", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{53, 53, 0x0000000000000000, "RO", "IMR17_WRITE_POL_53", "Bunit IMR17 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR17 region based on the agents 6bit encoded SAI value."},
#else
{53, 53, 0x0000000000000000, "RO", "IMR17_WRITE_POL_53", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{52, 52, 0x0000000000000000, "RO", "IMR17_WRITE_POL_52", "Bunit IMR17 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR17 region based on the agents 6bit encoded SAI value."},
#else
{52, 52, 0x0000000000000000, "RO", "IMR17_WRITE_POL_52", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{51, 51, 0x0000000000000000, "RO", "IMR17_WRITE_POL_51", "Bunit IMR17 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR17 region based on the agents 6bit encoded SAI value."},
#else
{51, 51, 0x0000000000000000, "RO", "IMR17_WRITE_POL_51", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{50, 50, 0x0000000000000000, "RW", "IMR17_WRITE_POL_50", "Bunit IMR17 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR17 region based on the agents 6bit encoded SAI value."},
#else
{50, 50, 0x0000000000000000, "RW", "IMR17_WRITE_POL_50", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{49, 49, 0x0000000000000000, "RW", "IMR17_WRITE_POL_49", "Bunit IMR17 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR17 region based on the agents 6bit encoded SAI value."},
#else
{49, 49, 0x0000000000000000, "RW", "IMR17_WRITE_POL_49", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{48, 48, 0x0000000000000000, "RW", "IMR17_WRITE_POL_48", "Bunit IMR17 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR17 region based on the agents 6bit encoded SAI value."},
#else
{48, 48, 0x0000000000000000, "RW", "IMR17_WRITE_POL_48", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{47, 47, 0x0000000000000000, "RO", "IMR17_WRITE_POL_47", "Bunit IMR17 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR17 region based on the agents 6bit encoded SAI value."},
#else
{47, 47, 0x0000000000000000, "RO", "IMR17_WRITE_POL_47", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{46, 46, 0x0000000000000000, "RO", "IMR17_WRITE_POL_46", "Bunit IMR17 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR17 region based on the agents 6bit encoded SAI value."},
#else
{46, 46, 0x0000000000000000, "RO", "IMR17_WRITE_POL_46", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{45, 45, 0x0000000000000000, "RO", "IMR17_WRITE_POL_45", "Bunit IMR17 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR17 region based on the agents 6bit encoded SAI value."},
#else
{45, 45, 0x0000000000000000, "RO", "IMR17_WRITE_POL_45", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{44, 44, 0x0000000000000000, "RW", "IMR17_WRITE_POL_44", "Bunit IMR17 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR17 region based on the agents 6bit encoded SAI value."},
#else
{44, 44, 0x0000000000000000, "RW", "IMR17_WRITE_POL_44", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{43, 43, 0x0000000000000000, "RW", "IMR17_WRITE_POL_43", "Bunit IMR17 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR17 region based on the agents 6bit encoded SAI value."},
#else
{43, 43, 0x0000000000000000, "RW", "IMR17_WRITE_POL_43", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{42, 42, 0x0000000000000000, "RW", "IMR17_WRITE_POL_42", "Bunit IMR17 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR17 region based on the agents 6bit encoded SAI value."},
#else
{42, 42, 0x0000000000000000, "RW", "IMR17_WRITE_POL_42", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{41, 41, 0x0000000000000000, "RW", "IMR17_WRITE_POL_41", "Bunit IMR17 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR17 region based on the agents 6bit encoded SAI value."},
#else
{41, 41, 0x0000000000000000, "RW", "IMR17_WRITE_POL_41", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{40, 40, 0x0000000000000000, "RW", "IMR17_WRITE_POL_40", "Bunit IMR17 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR17 region based on the agents 6bit encoded SAI value."},
#else
{40, 40, 0x0000000000000000, "RW", "IMR17_WRITE_POL_40", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{39, 39, 0x0000000000000000, "RO", "IMR17_WRITE_POL_39", "Bunit IMR17 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR17 region based on the agents 6bit encoded SAI value."},
#else
{39, 39, 0x0000000000000000, "RO", "IMR17_WRITE_POL_39", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{38, 38, 0x0000000000000000, "RW", "IMR17_WRITE_POL_38", "Bunit IMR17 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR17 region based on the agents 6bit encoded SAI value."},
#else
{38, 38, 0x0000000000000000, "RW", "IMR17_WRITE_POL_38", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{37, 37, 0x0000000000000000, "RO", "IMR17_WRITE_POL_37", "Bunit IMR17 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR17 region based on the agents 6bit encoded SAI value."},
#else
{37, 37, 0x0000000000000000, "RO", "IMR17_WRITE_POL_37", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{36, 36, 0x0000000000000000, "RW", "IMR17_WRITE_POL_36", "Bunit IMR17 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR17 region based on the agents 6bit encoded SAI value."},
#else
{36, 36, 0x0000000000000000, "RW", "IMR17_WRITE_POL_36", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{35, 35, 0x0000000000000000, "RO", "IMR17_WRITE_POL_35", "Bunit IMR17 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR17 region based on the agents 6bit encoded SAI value."},
#else
{35, 35, 0x0000000000000000, "RO", "IMR17_WRITE_POL_35", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{34, 34, 0x0000000000000000, "RW", "IMR17_WRITE_POL_34", "Bunit IMR17 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR17 region based on the agents 6bit encoded SAI value."},
#else
{34, 34, 0x0000000000000000, "RW", "IMR17_WRITE_POL_34", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{33, 33, 0x0000000000000000, "RW", "IMR17_WRITE_POL_33", "Bunit IMR17 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR17 region based on the agents 6bit encoded SAI value."},
#else
{33, 33, 0x0000000000000000, "RW", "IMR17_WRITE_POL_33", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{32, 32, 0x0000000000000000, "RW", "IMR17_WRITE_POL_32", "Bunit IMR17 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR17 region based on the agents 6bit encoded SAI value."},
#else
{32, 32, 0x0000000000000000, "RW", "IMR17_WRITE_POL_32", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{31, 31, 0x0000000000000000, "RO", "IMR17_WRITE_POL_31", "Bunit IMR17 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR17 region based on the agents 6bit encoded SAI value."},
#else
{31, 31, 0x0000000000000000, "RO", "IMR17_WRITE_POL_31", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{30, 30, 0x0000000000000000, "RW", "IMR17_WRITE_POL_30", "Bunit IMR17 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR17 region based on the agents 6bit encoded SAI value."},
#else
{30, 30, 0x0000000000000000, "RW", "IMR17_WRITE_POL_30", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{29, 29, 0x0000000000000000, "RW", "IMR17_WRITE_POL_29", "Bunit IMR17 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR17 region based on the agents 6bit encoded SAI value."},
#else
{29, 29, 0x0000000000000000, "RW", "IMR17_WRITE_POL_29", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{28, 28, 0x0000000000000000, "RW", "IMR17_WRITE_POL_28", "Bunit IMR17 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR17 region based on the agents 6bit encoded SAI value."},
#else
{28, 28, 0x0000000000000000, "RW", "IMR17_WRITE_POL_28", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{27, 27, 0x0000000000000000, "RW", "IMR17_WRITE_POL_27", "Bunit IMR17 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR17 region based on the agents 6bit encoded SAI value."},
#else
{27, 27, 0x0000000000000000, "RW", "IMR17_WRITE_POL_27", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{26, 26, 0x0000000000000000, "RW", "IMR17_WRITE_POL_26", "Bunit IMR17 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR17 region based on the agents 6bit encoded SAI value."},
#else
{26, 26, 0x0000000000000000, "RW", "IMR17_WRITE_POL_26", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{25, 25, 0x0000000000000000, "RW", "IMR17_WRITE_POL_25", "Bunit IMR17 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR17 region based on the agents 6bit encoded SAI value."},
#else
{25, 25, 0x0000000000000000, "RW", "IMR17_WRITE_POL_25", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{24, 24, 0x0000000000000000, "RW", "IMR17_WRITE_POL_24", "Bunit IMR17 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR17 region based on the agents 6bit encoded SAI value."},
#else
{24, 24, 0x0000000000000000, "RW", "IMR17_WRITE_POL_24", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{23, 23, 0x0000000000000000, "RO", "IMR17_WRITE_POL_23", "Bunit IMR17 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR17 region based on the agents 6bit encoded SAI value."},
#else
{23, 23, 0x0000000000000000, "RO", "IMR17_WRITE_POL_23", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{22, 22, 0x0000000000000000, "RO", "IMR17_WRITE_POL_22", "Bunit IMR17 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR17 region based on the agents 6bit encoded SAI value."},
#else
{22, 22, 0x0000000000000000, "RO", "IMR17_WRITE_POL_22", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{21, 21, 0x0000000000000000, "RW", "IMR17_WRITE_POL_21", "Bunit IMR17 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR17 region based on the agents 6bit encoded SAI value."},
#else
{21, 21, 0x0000000000000000, "RW", "IMR17_WRITE_POL_21", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{20, 20, 0x0000000000000000, "RO", "IMR17_WRITE_POL_20", "Bunit IMR17 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR17 region based on the agents 6bit encoded SAI value."},
#else
{20, 20, 0x0000000000000000, "RO", "IMR17_WRITE_POL_20", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{19, 19, 0x0000000000000000, "RO", "IMR17_WRITE_POL_19", "Bunit IMR17 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR17 region based on the agents 6bit encoded SAI value."},
#else
{19, 19, 0x0000000000000000, "RO", "IMR17_WRITE_POL_19", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{18, 18, 0x0000000000000000, "RO", "IMR17_WRITE_POL_18", "Bunit IMR17 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR17 region based on the agents 6bit encoded SAI value."},
#else
{18, 18, 0x0000000000000000, "RO", "IMR17_WRITE_POL_18", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{17, 17, 0x0000000000000000, "RW", "IMR17_WRITE_POL_17", "Bunit IMR17 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR17 region based on the agents 6bit encoded SAI value."},
#else
{17, 17, 0x0000000000000000, "RW", "IMR17_WRITE_POL_17", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{16, 16, 0x0000000000000000, "RW", "IMR17_WRITE_POL_16", "Bunit IMR17 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR17 region based on the agents 6bit encoded SAI value."},
#else
{16, 16, 0x0000000000000000, "RW", "IMR17_WRITE_POL_16", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{15, 15, 0x0000000000000000, "RO", "IMR17_WRITE_POL_15", "Bunit IMR17 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR17 region based on the agents 6bit encoded SAI value."},
#else
{15, 15, 0x0000000000000000, "RO", "IMR17_WRITE_POL_15", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{14, 14, 0x0000000000000000, "RO", "IMR17_WRITE_POL_14", "Bunit IMR17 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR17 region based on the agents 6bit encoded SAI value."},
#else
{14, 14, 0x0000000000000000, "RO", "IMR17_WRITE_POL_14", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{13, 13, 0x0000000000000000, "RW", "IMR17_WRITE_POL_13", "Bunit IMR17 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR17 region based on the agents 6bit encoded SAI value."},
#else
{13, 13, 0x0000000000000000, "RW", "IMR17_WRITE_POL_13", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{12, 12, 0x0000000000000000, "RW", "IMR17_WRITE_POL_12", "Bunit IMR17 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR17 region based on the agents 6bit encoded SAI value."},
#else
{12, 12, 0x0000000000000000, "RW", "IMR17_WRITE_POL_12", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{11, 11, 0x0000000000000000, "RO", "IMR17_WRITE_POL_11", "Bunit IMR17 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR17 region based on the agents 6bit encoded SAI value."},
#else
{11, 11, 0x0000000000000000, "RO", "IMR17_WRITE_POL_11", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{10, 10, 0x0000000000000000, "RO", "IMR17_WRITE_POL_10", "Bunit IMR17 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR17 region based on the agents 6bit encoded SAI value."},
#else
{10, 10, 0x0000000000000000, "RO", "IMR17_WRITE_POL_10", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{9, 9, 0x0000000000000000, "RO", "IMR17_WRITE_POL_9", "Bunit IMR17 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR17 region based on the agents 6bit encoded SAI value."},
#else
{9, 9, 0x0000000000000000, "RO", "IMR17_WRITE_POL_9", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{8, 8, 0x0000000000000000, "RW", "IMR17_WRITE_POL_8", "Bunit IMR17 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR17 region based on the agents 6bit encoded SAI value."},
#else
{8, 8, 0x0000000000000000, "RW", "IMR17_WRITE_POL_8", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{7, 7, 0x0000000000000000, "RO", "IMR17_WRITE_POL_7", "Bunit IMR17 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR17 region based on the agents 6bit encoded SAI value."},
#else
{7, 7, 0x0000000000000000, "RO", "IMR17_WRITE_POL_7", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{6, 6, 0x0000000000000000, "RO", "IMR17_WRITE_POL_6", "Bunit IMR17 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR17 region based on the agents 6bit encoded SAI value."},
#else
{6, 6, 0x0000000000000000, "RO", "IMR17_WRITE_POL_6", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{5, 5, 0x0000000000000000, "RW", "IMR17_WRITE_POL_5", "Bunit IMR17 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR17 region based on the agents 6bit encoded SAI value."},
#else
{5, 5, 0x0000000000000000, "RW", "IMR17_WRITE_POL_5", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{4, 4, 0x0000000000000000, "RW", "IMR17_WRITE_POL_4", "Bunit IMR17 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR17 region based on the agents 6bit encoded SAI value."},
#else
{4, 4, 0x0000000000000000, "RW", "IMR17_WRITE_POL_4", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{3, 3, 0x0000000000000000, "RW", "IMR17_WRITE_POL_3", "Bunit IMR17 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR17 region based on the agents 6bit encoded SAI value."},
#else
{3, 3, 0x0000000000000000, "RW", "IMR17_WRITE_POL_3", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{2, 2, 0x0000000000000000, "RW", "IMR17_WRITE_POL_2", "Bunit IMR17 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR17 region based on the agents 6bit encoded SAI value."},
#else
{2, 2, 0x0000000000000000, "RW", "IMR17_WRITE_POL_2", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{1, 1, 0x0000000000000000, "RW", "IMR17_WRITE_POL_1", "Bunit IMR17 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR17 region based on the agents 6bit encoded SAI value."},
#else
{1, 1, 0x0000000000000000, "RW", "IMR17_WRITE_POL_1", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 0, 0x0000000000000000, "RW", "IMR17_WRITE_POL_0", "Bunit IMR17 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR17 region based on the agents 6bit encoded SAI value."},
#else
{0, 0, 0x0000000000000000, "RW", "IMR17_WRITE_POL_0", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo966[] = {{"B_CR_BIMR17WAC_0_0_0_MCHBAR", "", 0x00006AA8, 64, 0xFFFFFFFFFFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields967[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{31, 31, 0x0000000000000000, "RW", "IMR_EN", "IMR Enable: Enables access checking for the IMR region."},
#else
{31, 31, 0x0000000000000000, "RW", "IMR_EN", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{30, 30, 0x0000000000000000, "RW", "TR_EN", "Asset Classification AC[0]: Trace Enable: Enables snooping of transactions to the IMR region by tracing agents."},
#else
{30, 30, 0x0000000000000000, "RW", "TR_EN", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{29, 29, 0x0000000000000000, "RO", "RESERVED_1", "Reserved"},
#else
{29, 29, 0x0000000000000000, "RO", "RESERVED_1", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 28, 0x0000000000000000, "RW", "IMR18_BASE", "Base 0 IMR18BASE:  Specifies bits 38:10 of the start address of IMR18 region.  IMR region size must be a strict poweroftwo at least 1KB and naturally aligned to the size.  These bits are compared with the result of the IMR18MASK[28:0] applied to bits 38:10 of the incoming address to determine if an access falls within the IMR18 defined region."},
#else
{0, 28, 0x0000000000000000, "RW", "IMR18_BASE", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo967[] = {{"B_CR_BIMR18BASE_0_0_0_MCHBAR", "", 0x00006AB0, 4, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields968[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{31, 31, 0x0000000000000000, "RW", "GT_IWB_EN", "Asset Classification AC[2]: GT Implicit WB Enable: Enables implicit writebacks to protected region from GT caching agent. When set to 1 enables implicit writeback data HITM data from GT to be returned to the requester.  When set to 0 inhibits HITM data from GT from being returned to the requester.  HITM data from IA cores may be returned to the requester depending on the setting of the IA_IWB_EN bit."},
#else
{31, 31, 0x0000000000000000, "RW", "GT_IWB_EN", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{30, 30, 0x0000000000000000, "RW", "IA_IWB_EN", "Asset Classification AC[1]: IA Implicit WB Enable: Enables implicit writebacks to protected region from IA caching agent.  When set to 1 enables implicit writeback data HITM data from IA cores to be returned to the requester.  When set to 0 inhibits HITM data from IA cores from being returned to the requester.  HITM data from GT may be returned to the requester depending on the setting of the GT_IWB_EN bit."},
#else
{30, 30, 0x0000000000000000, "RW", "IA_IWB_EN", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{29, 29, 0x0000000000000000, "RO", "RESERVED_0", "Reserved"},
#else
{29, 29, 0x0000000000000000, "RO", "RESERVED_0", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 28, 0x0000000000000000, "RW", "IMR18_MASK", "Mask 0 IMR18MASK:  These bits are ANDed with bits 38:10 of the incoming address to determine if the combined result matches the IMR18BASE[28:0] value.  A match indicates the the incoming address falls within the IMR18 region."},
#else
{0, 28, 0x0000000000000000, "RW", "IMR18_MASK", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo968[] = {{"B_CR_BIMR18MASK_0_0_0_MCHBAR", "", 0x00006AB4, 4, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields969[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{0, 63, 0x00000C0061010202, "RW", "IMR18_CTRL_POL", "Bunit IMR18 Control Policy: Bit vector used to determine which agents are allowed access to the BIMR18RAC, BIMR18WAC, BIMR18CP registers based on the value from the agents 6bit SAI field."},
#else
{0, 63, 0x00000C0061010202, "RW", "IMR18_CTRL_POL", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo969[] = {{"B_CR_BIMR18CP_0_0_0_MCHBAR", "", 0x00006AB8, 1, 0xFFFFFFFFFFFFFFFF, 0x00000C0061010202}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields970[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{63, 63, 0x0000000000000000, "RW", "IMR18_READ_POL_63", "Bunit IMR18 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR18 region based on the agents 6bit encoded SAI value."},
#else
{63, 63, 0x0000000000000000, "RW", "IMR18_READ_POL_63", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{62, 62, 0x0000000000000000, "RO", "IMR18_READ_POL_62", "Bunit IMR18 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR18 region based on the agents 6bit encoded SAI value."},
#else
{62, 62, 0x0000000000000000, "RO", "IMR18_READ_POL_62", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{61, 61, 0x0000000000000000, "RO", "IMR18_READ_POL_61", "Bunit IMR18 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR18 region based on the agents 6bit encoded SAI value."},
#else
{61, 61, 0x0000000000000000, "RO", "IMR18_READ_POL_61", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{60, 60, 0x0000000000000000, "RO", "IMR18_READ_POL_60", "Bunit IMR18 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR18 region based on the agents 6bit encoded SAI value."},
#else
{60, 60, 0x0000000000000000, "RO", "IMR18_READ_POL_60", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{59, 59, 0x0000000000000000, "RO", "IMR18_READ_POL_59", "Bunit IMR18 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR18 region based on the agents 6bit encoded SAI value."},
#else
{59, 59, 0x0000000000000000, "RO", "IMR18_READ_POL_59", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{58, 58, 0x0000000000000000, "RO", "IMR18_READ_POL_58", "Bunit IMR18 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR18 region based on the agents 6bit encoded SAI value."},
#else
{58, 58, 0x0000000000000000, "RO", "IMR18_READ_POL_58", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{57, 57, 0x0000000000000000, "RO", "IMR18_READ_POL_57", "Bunit IMR18 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR18 region based on the agents 6bit encoded SAI value."},
#else
{57, 57, 0x0000000000000000, "RO", "IMR18_READ_POL_57", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{56, 56, 0x0000000000000000, "RW", "IMR18_READ_POL_56", "Bunit IMR18 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR18 region based on the agents 6bit encoded SAI value."},
#else
{56, 56, 0x0000000000000000, "RW", "IMR18_READ_POL_56", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{55, 55, 0x0000000000000000, "RW", "IMR18_READ_POL_55", "Bunit IMR18 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR18 region based on the agents 6bit encoded SAI value."},
#else
{55, 55, 0x0000000000000000, "RW", "IMR18_READ_POL_55", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{54, 54, 0x0000000000000000, "RW", "IMR18_READ_POL_54", "Bunit IMR18 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR18 region based on the agents 6bit encoded SAI value."},
#else
{54, 54, 0x0000000000000000, "RW", "IMR18_READ_POL_54", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{53, 53, 0x0000000000000000, "RO", "IMR18_READ_POL_53", "Bunit IMR18 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR18 region based on the agents 6bit encoded SAI value."},
#else
{53, 53, 0x0000000000000000, "RO", "IMR18_READ_POL_53", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{52, 52, 0x0000000000000000, "RO", "IMR18_READ_POL_52", "Bunit IMR18 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR18 region based on the agents 6bit encoded SAI value."},
#else
{52, 52, 0x0000000000000000, "RO", "IMR18_READ_POL_52", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{51, 51, 0x0000000000000000, "RO", "IMR18_READ_POL_51", "Bunit IMR18 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR18 region based on the agents 6bit encoded SAI value."},
#else
{51, 51, 0x0000000000000000, "RO", "IMR18_READ_POL_51", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{50, 50, 0x0000000000000000, "RW", "IMR18_READ_POL_50", "Bunit IMR18 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR18 region based on the agents 6bit encoded SAI value."},
#else
{50, 50, 0x0000000000000000, "RW", "IMR18_READ_POL_50", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{49, 49, 0x0000000000000000, "RW", "IMR18_READ_POL_49", "Bunit IMR18 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR18 region based on the agents 6bit encoded SAI value."},
#else
{49, 49, 0x0000000000000000, "RW", "IMR18_READ_POL_49", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{48, 48, 0x0000000000000000, "RW", "IMR18_READ_POL_48", "Bunit IMR18 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR18 region based on the agents 6bit encoded SAI value."},
#else
{48, 48, 0x0000000000000000, "RW", "IMR18_READ_POL_48", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{47, 47, 0x0000000000000000, "RO", "IMR18_READ_POL_47", "Bunit IMR18 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR18 region based on the agents 6bit encoded SAI value."},
#else
{47, 47, 0x0000000000000000, "RO", "IMR18_READ_POL_47", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{46, 46, 0x0000000000000000, "RO", "IMR18_READ_POL_46", "Bunit IMR18 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR18 region based on the agents 6bit encoded SAI value."},
#else
{46, 46, 0x0000000000000000, "RO", "IMR18_READ_POL_46", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{45, 45, 0x0000000000000000, "RO", "IMR18_READ_POL_45", "Bunit IMR18 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR18 region based on the agents 6bit encoded SAI value."},
#else
{45, 45, 0x0000000000000000, "RO", "IMR18_READ_POL_45", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{44, 44, 0x0000000000000000, "RW", "IMR18_READ_POL_44", "Bunit IMR18 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR18 region based on the agents 6bit encoded SAI value."},
#else
{44, 44, 0x0000000000000000, "RW", "IMR18_READ_POL_44", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{43, 43, 0x0000000000000000, "RW", "IMR18_READ_POL_43", "Bunit IMR18 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR18 region based on the agents 6bit encoded SAI value."},
#else
{43, 43, 0x0000000000000000, "RW", "IMR18_READ_POL_43", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{42, 42, 0x0000000000000000, "RW", "IMR18_READ_POL_42", "Bunit IMR18 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR18 region based on the agents 6bit encoded SAI value."},
#else
{42, 42, 0x0000000000000000, "RW", "IMR18_READ_POL_42", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{41, 41, 0x0000000000000000, "RW", "IMR18_READ_POL_41", "Bunit IMR18 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR18 region based on the agents 6bit encoded SAI value."},
#else
{41, 41, 0x0000000000000000, "RW", "IMR18_READ_POL_41", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{40, 40, 0x0000000000000000, "RW", "IMR18_READ_POL_40", "Bunit IMR18 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR18 region based on the agents 6bit encoded SAI value."},
#else
{40, 40, 0x0000000000000000, "RW", "IMR18_READ_POL_40", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{39, 39, 0x0000000000000000, "RO", "IMR18_READ_POL_39", "Bunit IMR18 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR18 region based on the agents 6bit encoded SAI value."},
#else
{39, 39, 0x0000000000000000, "RO", "IMR18_READ_POL_39", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{38, 38, 0x0000000000000000, "RW", "IMR18_READ_POL_38", "Bunit IMR18 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR18 region based on the agents 6bit encoded SAI value."},
#else
{38, 38, 0x0000000000000000, "RW", "IMR18_READ_POL_38", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{37, 37, 0x0000000000000000, "RO", "IMR18_READ_POL_37", "Bunit IMR18 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR18 region based on the agents 6bit encoded SAI value."},
#else
{37, 37, 0x0000000000000000, "RO", "IMR18_READ_POL_37", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{36, 36, 0x0000000000000000, "RW", "IMR18_READ_POL_36", "Bunit IMR18 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR18 region based on the agents 6bit encoded SAI value."},
#else
{36, 36, 0x0000000000000000, "RW", "IMR18_READ_POL_36", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{35, 35, 0x0000000000000000, "RO", "IMR18_READ_POL_35", "Bunit IMR18 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR18 region based on the agents 6bit encoded SAI value."},
#else
{35, 35, 0x0000000000000000, "RO", "IMR18_READ_POL_35", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{34, 34, 0x0000000000000000, "RW", "IMR18_READ_POL_34", "Bunit IMR18 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR18 region based on the agents 6bit encoded SAI value."},
#else
{34, 34, 0x0000000000000000, "RW", "IMR18_READ_POL_34", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{33, 33, 0x0000000000000000, "RW", "IMR18_READ_POL_33", "Bunit IMR18 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR18 region based on the agents 6bit encoded SAI value."},
#else
{33, 33, 0x0000000000000000, "RW", "IMR18_READ_POL_33", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{32, 32, 0x0000000000000000, "RW", "IMR18_READ_POL_32", "Bunit IMR18 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR18 region based on the agents 6bit encoded SAI value."},
#else
{32, 32, 0x0000000000000000, "RW", "IMR18_READ_POL_32", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{31, 31, 0x0000000000000000, "RO", "IMR18_READ_POL_31", "Bunit IMR18 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR18 region based on the agents 6bit encoded SAI value."},
#else
{31, 31, 0x0000000000000000, "RO", "IMR18_READ_POL_31", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{30, 30, 0x0000000000000000, "RW", "IMR18_READ_POL_30", "Bunit IMR18 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR18 region based on the agents 6bit encoded SAI value."},
#else
{30, 30, 0x0000000000000000, "RW", "IMR18_READ_POL_30", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{29, 29, 0x0000000000000000, "RW", "IMR18_READ_POL_29", "Bunit IMR18 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR18 region based on the agents 6bit encoded SAI value."},
#else
{29, 29, 0x0000000000000000, "RW", "IMR18_READ_POL_29", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{28, 28, 0x0000000000000000, "RW", "IMR18_READ_POL_28", "Bunit IMR18 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR18 region based on the agents 6bit encoded SAI value."},
#else
{28, 28, 0x0000000000000000, "RW", "IMR18_READ_POL_28", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{27, 27, 0x0000000000000000, "RW", "IMR18_READ_POL_27", "Bunit IMR18 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR18 region based on the agents 6bit encoded SAI value."},
#else
{27, 27, 0x0000000000000000, "RW", "IMR18_READ_POL_27", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{26, 26, 0x0000000000000000, "RW", "IMR18_READ_POL_26", "Bunit IMR18 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR18 region based on the agents 6bit encoded SAI value."},
#else
{26, 26, 0x0000000000000000, "RW", "IMR18_READ_POL_26", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{25, 25, 0x0000000000000000, "RW", "IMR18_READ_POL_25", "Bunit IMR18 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR18 region based on the agents 6bit encoded SAI value."},
#else
{25, 25, 0x0000000000000000, "RW", "IMR18_READ_POL_25", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{24, 24, 0x0000000000000000, "RW", "IMR18_READ_POL_24", "Bunit IMR18 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR18 region based on the agents 6bit encoded SAI value."},
#else
{24, 24, 0x0000000000000000, "RW", "IMR18_READ_POL_24", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{23, 23, 0x0000000000000000, "RO", "IMR18_READ_POL_23", "Bunit IMR18 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR18 region based on the agents 6bit encoded SAI value."},
#else
{23, 23, 0x0000000000000000, "RO", "IMR18_READ_POL_23", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{22, 22, 0x0000000000000000, "RO", "IMR18_READ_POL_22", "Bunit IMR18 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR18 region based on the agents 6bit encoded SAI value."},
#else
{22, 22, 0x0000000000000000, "RO", "IMR18_READ_POL_22", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{21, 21, 0x0000000000000000, "RW", "IMR18_READ_POL_21", "Bunit IMR18 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR18 region based on the agents 6bit encoded SAI value."},
#else
{21, 21, 0x0000000000000000, "RW", "IMR18_READ_POL_21", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{20, 20, 0x0000000000000000, "RO", "IMR18_READ_POL_20", "Bunit IMR18 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR18 region based on the agents 6bit encoded SAI value."},
#else
{20, 20, 0x0000000000000000, "RO", "IMR18_READ_POL_20", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{19, 19, 0x0000000000000000, "RO", "IMR18_READ_POL_19", "Bunit IMR18 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR18 region based on the agents 6bit encoded SAI value."},
#else
{19, 19, 0x0000000000000000, "RO", "IMR18_READ_POL_19", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{18, 18, 0x0000000000000000, "RO", "IMR18_READ_POL_18", "Bunit IMR18 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR18 region based on the agents 6bit encoded SAI value."},
#else
{18, 18, 0x0000000000000000, "RO", "IMR18_READ_POL_18", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{17, 17, 0x0000000000000000, "RW", "IMR18_READ_POL_17", "Bunit IMR18 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR18 region based on the agents 6bit encoded SAI value."},
#else
{17, 17, 0x0000000000000000, "RW", "IMR18_READ_POL_17", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{16, 16, 0x0000000000000000, "RW", "IMR18_READ_POL_16", "Bunit IMR18 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR18 region based on the agents 6bit encoded SAI value."},
#else
{16, 16, 0x0000000000000000, "RW", "IMR18_READ_POL_16", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{15, 15, 0x0000000000000000, "RO", "IMR18_READ_POL_15", "Bunit IMR18 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR18 region based on the agents 6bit encoded SAI value."},
#else
{15, 15, 0x0000000000000000, "RO", "IMR18_READ_POL_15", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{14, 14, 0x0000000000000000, "RO", "IMR18_READ_POL_14", "Bunit IMR18 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR18 region based on the agents 6bit encoded SAI value."},
#else
{14, 14, 0x0000000000000000, "RO", "IMR18_READ_POL_14", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{13, 13, 0x0000000000000000, "RW", "IMR18_READ_POL_13", "Bunit IMR18 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR18 region based on the agents 6bit encoded SAI value."},
#else
{13, 13, 0x0000000000000000, "RW", "IMR18_READ_POL_13", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{12, 12, 0x0000000000000000, "RW", "IMR18_READ_POL_12", "Bunit IMR18 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR18 region based on the agents 6bit encoded SAI value."},
#else
{12, 12, 0x0000000000000000, "RW", "IMR18_READ_POL_12", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{11, 11, 0x0000000000000000, "RO", "IMR18_READ_POL_11", "Bunit IMR18 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR18 region based on the agents 6bit encoded SAI value."},
#else
{11, 11, 0x0000000000000000, "RO", "IMR18_READ_POL_11", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{10, 10, 0x0000000000000000, "RO", "IMR18_READ_POL_10", "Bunit IMR18 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR18 region based on the agents 6bit encoded SAI value."},
#else
{10, 10, 0x0000000000000000, "RO", "IMR18_READ_POL_10", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{9, 9, 0x0000000000000000, "RO", "IMR18_READ_POL_9", "Bunit IMR18 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR18 region based on the agents 6bit encoded SAI value."},
#else
{9, 9, 0x0000000000000000, "RO", "IMR18_READ_POL_9", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{8, 8, 0x0000000000000000, "RW", "IMR18_READ_POL_8", "Bunit IMR18 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR18 region based on the agents 6bit encoded SAI value."},
#else
{8, 8, 0x0000000000000000, "RW", "IMR18_READ_POL_8", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{7, 7, 0x0000000000000000, "RO", "IMR18_READ_POL_7", "Bunit IMR18 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR18 region based on the agents 6bit encoded SAI value."},
#else
{7, 7, 0x0000000000000000, "RO", "IMR18_READ_POL_7", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{6, 6, 0x0000000000000000, "RO", "IMR18_READ_POL_6", "Bunit IMR18 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR18 region based on the agents 6bit encoded SAI value."},
#else
{6, 6, 0x0000000000000000, "RO", "IMR18_READ_POL_6", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{5, 5, 0x0000000000000000, "RW", "IMR18_READ_POL_5", "Bunit IMR18 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR18 region based on the agents 6bit encoded SAI value."},
#else
{5, 5, 0x0000000000000000, "RW", "IMR18_READ_POL_5", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{4, 4, 0x0000000000000000, "RW", "IMR18_READ_POL_4", "Bunit IMR18 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR18 region based on the agents 6bit encoded SAI value."},
#else
{4, 4, 0x0000000000000000, "RW", "IMR18_READ_POL_4", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{3, 3, 0x0000000000000000, "RW", "IMR18_READ_POL_3", "Bunit IMR18 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR18 region based on the agents 6bit encoded SAI value."},
#else
{3, 3, 0x0000000000000000, "RW", "IMR18_READ_POL_3", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{2, 2, 0x0000000000000000, "RW", "IMR18_READ_POL_2", "Bunit IMR18 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR18 region based on the agents 6bit encoded SAI value."},
#else
{2, 2, 0x0000000000000000, "RW", "IMR18_READ_POL_2", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{1, 1, 0x0000000000000000, "RW", "IMR18_READ_POL_1", "Bunit IMR18 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR18 region based on the agents 6bit encoded SAI value."},
#else
{1, 1, 0x0000000000000000, "RW", "IMR18_READ_POL_1", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 0, 0x0000000000000000, "RW", "IMR18_READ_POL_0", "Bunit IMR18 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR18 region based on the agents 6bit encoded SAI value."},
#else
{0, 0, 0x0000000000000000, "RW", "IMR18_READ_POL_0", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo970[] = {{"B_CR_BIMR18RAC_0_0_0_MCHBAR", "", 0x00006AC0, 64, 0xFFFFFFFFFFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields971[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{63, 63, 0x0000000000000000, "RW", "IMR18_WRITE_POL_63", "Bunit IMR18 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR18 region based on the agents 6bit encoded SAI value."},
#else
{63, 63, 0x0000000000000000, "RW", "IMR18_WRITE_POL_63", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{62, 62, 0x0000000000000000, "RO", "IMR18_WRITE_POL_62", "Bunit IMR18 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR18 region based on the agents 6bit encoded SAI value."},
#else
{62, 62, 0x0000000000000000, "RO", "IMR18_WRITE_POL_62", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{61, 61, 0x0000000000000000, "RO", "IMR18_WRITE_POL_61", "Bunit IMR18 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR18 region based on the agents 6bit encoded SAI value."},
#else
{61, 61, 0x0000000000000000, "RO", "IMR18_WRITE_POL_61", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{60, 60, 0x0000000000000000, "RO", "IMR18_WRITE_POL_60", "Bunit IMR18 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR18 region based on the agents 6bit encoded SAI value."},
#else
{60, 60, 0x0000000000000000, "RO", "IMR18_WRITE_POL_60", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{59, 59, 0x0000000000000000, "RO", "IMR18_WRITE_POL_59", "Bunit IMR18 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR18 region based on the agents 6bit encoded SAI value."},
#else
{59, 59, 0x0000000000000000, "RO", "IMR18_WRITE_POL_59", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{58, 58, 0x0000000000000000, "RO", "IMR18_WRITE_POL_58", "Bunit IMR18 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR18 region based on the agents 6bit encoded SAI value."},
#else
{58, 58, 0x0000000000000000, "RO", "IMR18_WRITE_POL_58", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{57, 57, 0x0000000000000000, "RO", "IMR18_WRITE_POL_57", "Bunit IMR18 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR18 region based on the agents 6bit encoded SAI value."},
#else
{57, 57, 0x0000000000000000, "RO", "IMR18_WRITE_POL_57", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{56, 56, 0x0000000000000000, "RW", "IMR18_WRITE_POL_56", "Bunit IMR18 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR18 region based on the agents 6bit encoded SAI value."},
#else
{56, 56, 0x0000000000000000, "RW", "IMR18_WRITE_POL_56", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{55, 55, 0x0000000000000000, "RW", "IMR18_WRITE_POL_55", "Bunit IMR18 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR18 region based on the agents 6bit encoded SAI value."},
#else
{55, 55, 0x0000000000000000, "RW", "IMR18_WRITE_POL_55", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{54, 54, 0x0000000000000000, "RW", "IMR18_WRITE_POL_54", "Bunit IMR18 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR18 region based on the agents 6bit encoded SAI value."},
#else
{54, 54, 0x0000000000000000, "RW", "IMR18_WRITE_POL_54", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{53, 53, 0x0000000000000000, "RO", "IMR18_WRITE_POL_53", "Bunit IMR18 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR18 region based on the agents 6bit encoded SAI value."},
#else
{53, 53, 0x0000000000000000, "RO", "IMR18_WRITE_POL_53", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{52, 52, 0x0000000000000000, "RO", "IMR18_WRITE_POL_52", "Bunit IMR18 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR18 region based on the agents 6bit encoded SAI value."},
#else
{52, 52, 0x0000000000000000, "RO", "IMR18_WRITE_POL_52", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{51, 51, 0x0000000000000000, "RO", "IMR18_WRITE_POL_51", "Bunit IMR18 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR18 region based on the agents 6bit encoded SAI value."},
#else
{51, 51, 0x0000000000000000, "RO", "IMR18_WRITE_POL_51", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{50, 50, 0x0000000000000000, "RW", "IMR18_WRITE_POL_50", "Bunit IMR18 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR18 region based on the agents 6bit encoded SAI value."},
#else
{50, 50, 0x0000000000000000, "RW", "IMR18_WRITE_POL_50", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{49, 49, 0x0000000000000000, "RW", "IMR18_WRITE_POL_49", "Bunit IMR18 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR18 region based on the agents 6bit encoded SAI value."},
#else
{49, 49, 0x0000000000000000, "RW", "IMR18_WRITE_POL_49", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{48, 48, 0x0000000000000000, "RW", "IMR18_WRITE_POL_48", "Bunit IMR18 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR18 region based on the agents 6bit encoded SAI value."},
#else
{48, 48, 0x0000000000000000, "RW", "IMR18_WRITE_POL_48", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{47, 47, 0x0000000000000000, "RO", "IMR18_WRITE_POL_47", "Bunit IMR18 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR18 region based on the agents 6bit encoded SAI value."},
#else
{47, 47, 0x0000000000000000, "RO", "IMR18_WRITE_POL_47", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{46, 46, 0x0000000000000000, "RO", "IMR18_WRITE_POL_46", "Bunit IMR18 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR18 region based on the agents 6bit encoded SAI value."},
#else
{46, 46, 0x0000000000000000, "RO", "IMR18_WRITE_POL_46", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{45, 45, 0x0000000000000000, "RO", "IMR18_WRITE_POL_45", "Bunit IMR18 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR18 region based on the agents 6bit encoded SAI value."},
#else
{45, 45, 0x0000000000000000, "RO", "IMR18_WRITE_POL_45", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{44, 44, 0x0000000000000000, "RW", "IMR18_WRITE_POL_44", "Bunit IMR18 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR18 region based on the agents 6bit encoded SAI value."},
#else
{44, 44, 0x0000000000000000, "RW", "IMR18_WRITE_POL_44", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{43, 43, 0x0000000000000000, "RW", "IMR18_WRITE_POL_43", "Bunit IMR18 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR18 region based on the agents 6bit encoded SAI value."},
#else
{43, 43, 0x0000000000000000, "RW", "IMR18_WRITE_POL_43", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{42, 42, 0x0000000000000000, "RW", "IMR18_WRITE_POL_42", "Bunit IMR18 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR18 region based on the agents 6bit encoded SAI value."},
#else
{42, 42, 0x0000000000000000, "RW", "IMR18_WRITE_POL_42", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{41, 41, 0x0000000000000000, "RW", "IMR18_WRITE_POL_41", "Bunit IMR18 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR18 region based on the agents 6bit encoded SAI value."},
#else
{41, 41, 0x0000000000000000, "RW", "IMR18_WRITE_POL_41", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{40, 40, 0x0000000000000000, "RW", "IMR18_WRITE_POL_40", "Bunit IMR18 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR18 region based on the agents 6bit encoded SAI value."},
#else
{40, 40, 0x0000000000000000, "RW", "IMR18_WRITE_POL_40", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{39, 39, 0x0000000000000000, "RO", "IMR18_WRITE_POL_39", "Bunit IMR18 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR18 region based on the agents 6bit encoded SAI value."},
#else
{39, 39, 0x0000000000000000, "RO", "IMR18_WRITE_POL_39", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{38, 38, 0x0000000000000000, "RW", "IMR18_WRITE_POL_38", "Bunit IMR18 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR18 region based on the agents 6bit encoded SAI value."},
#else
{38, 38, 0x0000000000000000, "RW", "IMR18_WRITE_POL_38", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{37, 37, 0x0000000000000000, "RO", "IMR18_WRITE_POL_37", "Bunit IMR18 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR18 region based on the agents 6bit encoded SAI value."},
#else
{37, 37, 0x0000000000000000, "RO", "IMR18_WRITE_POL_37", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{36, 36, 0x0000000000000000, "RW", "IMR18_WRITE_POL_36", "Bunit IMR18 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR18 region based on the agents 6bit encoded SAI value."},
#else
{36, 36, 0x0000000000000000, "RW", "IMR18_WRITE_POL_36", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{35, 35, 0x0000000000000000, "RO", "IMR18_WRITE_POL_35", "Bunit IMR18 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR18 region based on the agents 6bit encoded SAI value."},
#else
{35, 35, 0x0000000000000000, "RO", "IMR18_WRITE_POL_35", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{34, 34, 0x0000000000000000, "RW", "IMR18_WRITE_POL_34", "Bunit IMR18 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR18 region based on the agents 6bit encoded SAI value."},
#else
{34, 34, 0x0000000000000000, "RW", "IMR18_WRITE_POL_34", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{33, 33, 0x0000000000000000, "RW", "IMR18_WRITE_POL_33", "Bunit IMR18 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR18 region based on the agents 6bit encoded SAI value."},
#else
{33, 33, 0x0000000000000000, "RW", "IMR18_WRITE_POL_33", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{32, 32, 0x0000000000000000, "RW", "IMR18_WRITE_POL_32", "Bunit IMR18 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR18 region based on the agents 6bit encoded SAI value."},
#else
{32, 32, 0x0000000000000000, "RW", "IMR18_WRITE_POL_32", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{31, 31, 0x0000000000000000, "RO", "IMR18_WRITE_POL_31", "Bunit IMR18 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR18 region based on the agents 6bit encoded SAI value."},
#else
{31, 31, 0x0000000000000000, "RO", "IMR18_WRITE_POL_31", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{30, 30, 0x0000000000000000, "RW", "IMR18_WRITE_POL_30", "Bunit IMR18 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR18 region based on the agents 6bit encoded SAI value."},
#else
{30, 30, 0x0000000000000000, "RW", "IMR18_WRITE_POL_30", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{29, 29, 0x0000000000000000, "RW", "IMR18_WRITE_POL_29", "Bunit IMR18 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR18 region based on the agents 6bit encoded SAI value."},
#else
{29, 29, 0x0000000000000000, "RW", "IMR18_WRITE_POL_29", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{28, 28, 0x0000000000000000, "RW", "IMR18_WRITE_POL_28", "Bunit IMR18 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR18 region based on the agents 6bit encoded SAI value."},
#else
{28, 28, 0x0000000000000000, "RW", "IMR18_WRITE_POL_28", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{27, 27, 0x0000000000000000, "RW", "IMR18_WRITE_POL_27", "Bunit IMR18 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR18 region based on the agents 6bit encoded SAI value."},
#else
{27, 27, 0x0000000000000000, "RW", "IMR18_WRITE_POL_27", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{26, 26, 0x0000000000000000, "RW", "IMR18_WRITE_POL_26", "Bunit IMR18 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR18 region based on the agents 6bit encoded SAI value."},
#else
{26, 26, 0x0000000000000000, "RW", "IMR18_WRITE_POL_26", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{25, 25, 0x0000000000000000, "RW", "IMR18_WRITE_POL_25", "Bunit IMR18 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR18 region based on the agents 6bit encoded SAI value."},
#else
{25, 25, 0x0000000000000000, "RW", "IMR18_WRITE_POL_25", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{24, 24, 0x0000000000000000, "RW", "IMR18_WRITE_POL_24", "Bunit IMR18 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR18 region based on the agents 6bit encoded SAI value."},
#else
{24, 24, 0x0000000000000000, "RW", "IMR18_WRITE_POL_24", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{23, 23, 0x0000000000000000, "RO", "IMR18_WRITE_POL_23", "Bunit IMR18 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR18 region based on the agents 6bit encoded SAI value."},
#else
{23, 23, 0x0000000000000000, "RO", "IMR18_WRITE_POL_23", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{22, 22, 0x0000000000000000, "RO", "IMR18_WRITE_POL_22", "Bunit IMR18 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR18 region based on the agents 6bit encoded SAI value."},
#else
{22, 22, 0x0000000000000000, "RO", "IMR18_WRITE_POL_22", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{21, 21, 0x0000000000000000, "RW", "IMR18_WRITE_POL_21", "Bunit IMR18 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR18 region based on the agents 6bit encoded SAI value."},
#else
{21, 21, 0x0000000000000000, "RW", "IMR18_WRITE_POL_21", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{20, 20, 0x0000000000000000, "RO", "IMR18_WRITE_POL_20", "Bunit IMR18 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR18 region based on the agents 6bit encoded SAI value."},
#else
{20, 20, 0x0000000000000000, "RO", "IMR18_WRITE_POL_20", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{19, 19, 0x0000000000000000, "RO", "IMR18_WRITE_POL_19", "Bunit IMR18 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR18 region based on the agents 6bit encoded SAI value."},
#else
{19, 19, 0x0000000000000000, "RO", "IMR18_WRITE_POL_19", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{18, 18, 0x0000000000000000, "RO", "IMR18_WRITE_POL_18", "Bunit IMR18 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR18 region based on the agents 6bit encoded SAI value."},
#else
{18, 18, 0x0000000000000000, "RO", "IMR18_WRITE_POL_18", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{17, 17, 0x0000000000000000, "RW", "IMR18_WRITE_POL_17", "Bunit IMR18 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR18 region based on the agents 6bit encoded SAI value."},
#else
{17, 17, 0x0000000000000000, "RW", "IMR18_WRITE_POL_17", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{16, 16, 0x0000000000000000, "RW", "IMR18_WRITE_POL_16", "Bunit IMR18 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR18 region based on the agents 6bit encoded SAI value."},
#else
{16, 16, 0x0000000000000000, "RW", "IMR18_WRITE_POL_16", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{15, 15, 0x0000000000000000, "RO", "IMR18_WRITE_POL_15", "Bunit IMR18 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR18 region based on the agents 6bit encoded SAI value."},
#else
{15, 15, 0x0000000000000000, "RO", "IMR18_WRITE_POL_15", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{14, 14, 0x0000000000000000, "RO", "IMR18_WRITE_POL_14", "Bunit IMR18 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR18 region based on the agents 6bit encoded SAI value."},
#else
{14, 14, 0x0000000000000000, "RO", "IMR18_WRITE_POL_14", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{13, 13, 0x0000000000000000, "RW", "IMR18_WRITE_POL_13", "Bunit IMR18 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR18 region based on the agents 6bit encoded SAI value."},
#else
{13, 13, 0x0000000000000000, "RW", "IMR18_WRITE_POL_13", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{12, 12, 0x0000000000000000, "RW", "IMR18_WRITE_POL_12", "Bunit IMR18 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR18 region based on the agents 6bit encoded SAI value."},
#else
{12, 12, 0x0000000000000000, "RW", "IMR18_WRITE_POL_12", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{11, 11, 0x0000000000000000, "RO", "IMR18_WRITE_POL_11", "Bunit IMR18 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR18 region based on the agents 6bit encoded SAI value."},
#else
{11, 11, 0x0000000000000000, "RO", "IMR18_WRITE_POL_11", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{10, 10, 0x0000000000000000, "RO", "IMR18_WRITE_POL_10", "Bunit IMR18 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR18 region based on the agents 6bit encoded SAI value."},
#else
{10, 10, 0x0000000000000000, "RO", "IMR18_WRITE_POL_10", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{9, 9, 0x0000000000000000, "RO", "IMR18_WRITE_POL_9", "Bunit IMR18 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR18 region based on the agents 6bit encoded SAI value."},
#else
{9, 9, 0x0000000000000000, "RO", "IMR18_WRITE_POL_9", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{8, 8, 0x0000000000000000, "RW", "IMR18_WRITE_POL_8", "Bunit IMR18 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR18 region based on the agents 6bit encoded SAI value."},
#else
{8, 8, 0x0000000000000000, "RW", "IMR18_WRITE_POL_8", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{7, 7, 0x0000000000000000, "RO", "IMR18_WRITE_POL_7", "Bunit IMR18 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR18 region based on the agents 6bit encoded SAI value."},
#else
{7, 7, 0x0000000000000000, "RO", "IMR18_WRITE_POL_7", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{6, 6, 0x0000000000000000, "RO", "IMR18_WRITE_POL_6", "Bunit IMR18 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR18 region based on the agents 6bit encoded SAI value."},
#else
{6, 6, 0x0000000000000000, "RO", "IMR18_WRITE_POL_6", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{5, 5, 0x0000000000000000, "RW", "IMR18_WRITE_POL_5", "Bunit IMR18 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR18 region based on the agents 6bit encoded SAI value."},
#else
{5, 5, 0x0000000000000000, "RW", "IMR18_WRITE_POL_5", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{4, 4, 0x0000000000000000, "RW", "IMR18_WRITE_POL_4", "Bunit IMR18 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR18 region based on the agents 6bit encoded SAI value."},
#else
{4, 4, 0x0000000000000000, "RW", "IMR18_WRITE_POL_4", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{3, 3, 0x0000000000000000, "RW", "IMR18_WRITE_POL_3", "Bunit IMR18 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR18 region based on the agents 6bit encoded SAI value."},
#else
{3, 3, 0x0000000000000000, "RW", "IMR18_WRITE_POL_3", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{2, 2, 0x0000000000000000, "RW", "IMR18_WRITE_POL_2", "Bunit IMR18 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR18 region based on the agents 6bit encoded SAI value."},
#else
{2, 2, 0x0000000000000000, "RW", "IMR18_WRITE_POL_2", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{1, 1, 0x0000000000000000, "RW", "IMR18_WRITE_POL_1", "Bunit IMR18 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR18 region based on the agents 6bit encoded SAI value."},
#else
{1, 1, 0x0000000000000000, "RW", "IMR18_WRITE_POL_1", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 0, 0x0000000000000000, "RW", "IMR18_WRITE_POL_0", "Bunit IMR18 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR18 region based on the agents 6bit encoded SAI value."},
#else
{0, 0, 0x0000000000000000, "RW", "IMR18_WRITE_POL_0", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo971[] = {{"B_CR_BIMR18WAC_0_0_0_MCHBAR", "", 0x00006AC8, 64, 0xFFFFFFFFFFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields972[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{31, 31, 0x0000000000000000, "RW", "IMR_EN", "IMR Enable: Enables access checking for the IMR region."},
#else
{31, 31, 0x0000000000000000, "RW", "IMR_EN", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{30, 30, 0x0000000000000000, "RW", "TR_EN", "Asset Classification AC[0]: Trace Enable: Enables snooping of transactions to the IMR region by tracing agents."},
#else
{30, 30, 0x0000000000000000, "RW", "TR_EN", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{29, 29, 0x0000000000000000, "RO", "RESERVED_1", "Reserved"},
#else
{29, 29, 0x0000000000000000, "RO", "RESERVED_1", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 28, 0x0000000000000000, "RW", "IMR19_BASE", "Base 0 IMR19BASE:  Specifies bits 38:10 of the start address of IMR19 region.  IMR region size must be a strict poweroftwo at least 1KB and naturally aligned to the size.  These bits are compared with the result of the IMR19MASK[28:0] applied to bits 38:10 of the incoming address to determine if an access falls within the IMR19 defined region."},
#else
{0, 28, 0x0000000000000000, "RW", "IMR19_BASE", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo972[] = {{"B_CR_BIMR19BASE_0_0_0_MCHBAR", "", 0x00006AD0, 4, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields973[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{31, 31, 0x0000000000000000, "RW", "GT_IWB_EN", "Asset Classification AC[2]: GT Implicit WB Enable: Enables implicit writebacks to protected region from GT caching agent. When set to 1 enables implicit writeback data HITM data from GT to be returned to the requester.  When set to 0 inhibits HITM data from GT from being returned to the requester.  HITM data from IA cores may be returned to the requester depending on the setting of the IA_IWB_EN bit."},
#else
{31, 31, 0x0000000000000000, "RW", "GT_IWB_EN", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{30, 30, 0x0000000000000000, "RW", "IA_IWB_EN", "Asset Classification AC[1]: IA Implicit WB Enable: Enables implicit writebacks to protected region from IA caching agent.  When set to 1 enables implicit writeback data HITM data from IA cores to be returned to the requester.  When set to 0 inhibits HITM data from IA cores from being returned to the requester.  HITM data from GT may be returned to the requester depending on the setting of the GT_IWB_EN bit."},
#else
{30, 30, 0x0000000000000000, "RW", "IA_IWB_EN", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{29, 29, 0x0000000000000000, "RO", "RESERVED_0", "Reserved"},
#else
{29, 29, 0x0000000000000000, "RO", "RESERVED_0", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 28, 0x0000000000000000, "RW", "IMR19_MASK", "Mask 0 IMR19MASK:  These bits are ANDed with bits 38:10 of the incoming address to determine if the combined result matches the IMR19BASE[28:0] value.  A match indicates the the incoming address falls within the IMR19 region."},
#else
{0, 28, 0x0000000000000000, "RW", "IMR19_MASK", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo973[] = {{"B_CR_BIMR19MASK_0_0_0_MCHBAR", "", 0x00006AD4, 4, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields974[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{0, 63, 0x00000C0061010202, "RW", "IMR19_CTRL_POL", "Bunit IMR19 Control Policy: Bit vector used to determine which agents are allowed access to the BIMR19RAC, BIMR19WAC, BIMR19CP registers based on the value from the agents 6bit SAI field."},
#else
{0, 63, 0x00000C0061010202, "RW", "IMR19_CTRL_POL", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo974[] = {{"B_CR_BIMR19CP_0_0_0_MCHBAR", "", 0x00006AD8, 1, 0xFFFFFFFFFFFFFFFF, 0x00000C0061010202}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields975[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{63, 63, 0x0000000000000000, "RW", "IMR19_READ_POL_63", "Bunit IMR19 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR19 region based on the agents 6bit encoded SAI value."},
#else
{63, 63, 0x0000000000000000, "RW", "IMR19_READ_POL_63", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{62, 62, 0x0000000000000000, "RO", "IMR19_READ_POL_62", "Bunit IMR19 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR19 region based on the agents 6bit encoded SAI value."},
#else
{62, 62, 0x0000000000000000, "RO", "IMR19_READ_POL_62", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{61, 61, 0x0000000000000000, "RO", "IMR19_READ_POL_61", "Bunit IMR19 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR19 region based on the agents 6bit encoded SAI value."},
#else
{61, 61, 0x0000000000000000, "RO", "IMR19_READ_POL_61", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{60, 60, 0x0000000000000000, "RO", "IMR19_READ_POL_60", "Bunit IMR19 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR19 region based on the agents 6bit encoded SAI value."},
#else
{60, 60, 0x0000000000000000, "RO", "IMR19_READ_POL_60", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{59, 59, 0x0000000000000000, "RO", "IMR19_READ_POL_59", "Bunit IMR19 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR19 region based on the agents 6bit encoded SAI value."},
#else
{59, 59, 0x0000000000000000, "RO", "IMR19_READ_POL_59", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{58, 58, 0x0000000000000000, "RO", "IMR19_READ_POL_58", "Bunit IMR19 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR19 region based on the agents 6bit encoded SAI value."},
#else
{58, 58, 0x0000000000000000, "RO", "IMR19_READ_POL_58", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{57, 57, 0x0000000000000000, "RO", "IMR19_READ_POL_57", "Bunit IMR19 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR19 region based on the agents 6bit encoded SAI value."},
#else
{57, 57, 0x0000000000000000, "RO", "IMR19_READ_POL_57", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{56, 56, 0x0000000000000000, "RW", "IMR19_READ_POL_56", "Bunit IMR19 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR19 region based on the agents 6bit encoded SAI value."},
#else
{56, 56, 0x0000000000000000, "RW", "IMR19_READ_POL_56", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{55, 55, 0x0000000000000000, "RW", "IMR19_READ_POL_55", "Bunit IMR19 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR19 region based on the agents 6bit encoded SAI value."},
#else
{55, 55, 0x0000000000000000, "RW", "IMR19_READ_POL_55", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{54, 54, 0x0000000000000000, "RW", "IMR19_READ_POL_54", "Bunit IMR19 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR19 region based on the agents 6bit encoded SAI value."},
#else
{54, 54, 0x0000000000000000, "RW", "IMR19_READ_POL_54", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{53, 53, 0x0000000000000000, "RO", "IMR19_READ_POL_53", "Bunit IMR19 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR19 region based on the agents 6bit encoded SAI value."},
#else
{53, 53, 0x0000000000000000, "RO", "IMR19_READ_POL_53", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{52, 52, 0x0000000000000000, "RO", "IMR19_READ_POL_52", "Bunit IMR19 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR19 region based on the agents 6bit encoded SAI value."},
#else
{52, 52, 0x0000000000000000, "RO", "IMR19_READ_POL_52", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{51, 51, 0x0000000000000000, "RO", "IMR19_READ_POL_51", "Bunit IMR19 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR19 region based on the agents 6bit encoded SAI value."},
#else
{51, 51, 0x0000000000000000, "RO", "IMR19_READ_POL_51", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{50, 50, 0x0000000000000000, "RW", "IMR19_READ_POL_50", "Bunit IMR19 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR19 region based on the agents 6bit encoded SAI value."},
#else
{50, 50, 0x0000000000000000, "RW", "IMR19_READ_POL_50", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{49, 49, 0x0000000000000000, "RW", "IMR19_READ_POL_49", "Bunit IMR19 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR19 region based on the agents 6bit encoded SAI value."},
#else
{49, 49, 0x0000000000000000, "RW", "IMR19_READ_POL_49", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{48, 48, 0x0000000000000000, "RW", "IMR19_READ_POL_48", "Bunit IMR19 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR19 region based on the agents 6bit encoded SAI value."},
#else
{48, 48, 0x0000000000000000, "RW", "IMR19_READ_POL_48", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{47, 47, 0x0000000000000000, "RO", "IMR19_READ_POL_47", "Bunit IMR19 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR19 region based on the agents 6bit encoded SAI value."},
#else
{47, 47, 0x0000000000000000, "RO", "IMR19_READ_POL_47", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{46, 46, 0x0000000000000000, "RO", "IMR19_READ_POL_46", "Bunit IMR19 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR19 region based on the agents 6bit encoded SAI value."},
#else
{46, 46, 0x0000000000000000, "RO", "IMR19_READ_POL_46", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{45, 45, 0x0000000000000000, "RO", "IMR19_READ_POL_45", "Bunit IMR19 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR19 region based on the agents 6bit encoded SAI value."},
#else
{45, 45, 0x0000000000000000, "RO", "IMR19_READ_POL_45", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{44, 44, 0x0000000000000000, "RW", "IMR19_READ_POL_44", "Bunit IMR19 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR19 region based on the agents 6bit encoded SAI value."},
#else
{44, 44, 0x0000000000000000, "RW", "IMR19_READ_POL_44", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{43, 43, 0x0000000000000000, "RW", "IMR19_READ_POL_43", "Bunit IMR19 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR19 region based on the agents 6bit encoded SAI value."},
#else
{43, 43, 0x0000000000000000, "RW", "IMR19_READ_POL_43", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{42, 42, 0x0000000000000000, "RW", "IMR19_READ_POL_42", "Bunit IMR19 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR19 region based on the agents 6bit encoded SAI value."},
#else
{42, 42, 0x0000000000000000, "RW", "IMR19_READ_POL_42", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{41, 41, 0x0000000000000000, "RW", "IMR19_READ_POL_41", "Bunit IMR19 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR19 region based on the agents 6bit encoded SAI value."},
#else
{41, 41, 0x0000000000000000, "RW", "IMR19_READ_POL_41", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{40, 40, 0x0000000000000000, "RW", "IMR19_READ_POL_40", "Bunit IMR19 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR19 region based on the agents 6bit encoded SAI value."},
#else
{40, 40, 0x0000000000000000, "RW", "IMR19_READ_POL_40", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{39, 39, 0x0000000000000000, "RO", "IMR19_READ_POL_39", "Bunit IMR19 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR19 region based on the agents 6bit encoded SAI value."},
#else
{39, 39, 0x0000000000000000, "RO", "IMR19_READ_POL_39", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{38, 38, 0x0000000000000000, "RW", "IMR19_READ_POL_38", "Bunit IMR19 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR19 region based on the agents 6bit encoded SAI value."},
#else
{38, 38, 0x0000000000000000, "RW", "IMR19_READ_POL_38", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{37, 37, 0x0000000000000000, "RO", "IMR19_READ_POL_37", "Bunit IMR19 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR19 region based on the agents 6bit encoded SAI value."},
#else
{37, 37, 0x0000000000000000, "RO", "IMR19_READ_POL_37", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{36, 36, 0x0000000000000000, "RW", "IMR19_READ_POL_36", "Bunit IMR19 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR19 region based on the agents 6bit encoded SAI value."},
#else
{36, 36, 0x0000000000000000, "RW", "IMR19_READ_POL_36", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{35, 35, 0x0000000000000000, "RO", "IMR19_READ_POL_35", "Bunit IMR19 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR19 region based on the agents 6bit encoded SAI value."},
#else
{35, 35, 0x0000000000000000, "RO", "IMR19_READ_POL_35", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{34, 34, 0x0000000000000000, "RW", "IMR19_READ_POL_34", "Bunit IMR19 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR19 region based on the agents 6bit encoded SAI value."},
#else
{34, 34, 0x0000000000000000, "RW", "IMR19_READ_POL_34", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{33, 33, 0x0000000000000000, "RW", "IMR19_READ_POL_33", "Bunit IMR19 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR19 region based on the agents 6bit encoded SAI value."},
#else
{33, 33, 0x0000000000000000, "RW", "IMR19_READ_POL_33", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{32, 32, 0x0000000000000000, "RW", "IMR19_READ_POL_32", "Bunit IMR19 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR19 region based on the agents 6bit encoded SAI value."},
#else
{32, 32, 0x0000000000000000, "RW", "IMR19_READ_POL_32", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{31, 31, 0x0000000000000000, "RO", "IMR19_READ_POL_31", "Bunit IMR19 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR19 region based on the agents 6bit encoded SAI value."},
#else
{31, 31, 0x0000000000000000, "RO", "IMR19_READ_POL_31", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{30, 30, 0x0000000000000000, "RW", "IMR19_READ_POL_30", "Bunit IMR19 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR19 region based on the agents 6bit encoded SAI value."},
#else
{30, 30, 0x0000000000000000, "RW", "IMR19_READ_POL_30", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{29, 29, 0x0000000000000000, "RW", "IMR19_READ_POL_29", "Bunit IMR19 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR19 region based on the agents 6bit encoded SAI value."},
#else
{29, 29, 0x0000000000000000, "RW", "IMR19_READ_POL_29", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{28, 28, 0x0000000000000000, "RW", "IMR19_READ_POL_28", "Bunit IMR19 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR19 region based on the agents 6bit encoded SAI value."},
#else
{28, 28, 0x0000000000000000, "RW", "IMR19_READ_POL_28", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{27, 27, 0x0000000000000000, "RW", "IMR19_READ_POL_27", "Bunit IMR19 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR19 region based on the agents 6bit encoded SAI value."},
#else
{27, 27, 0x0000000000000000, "RW", "IMR19_READ_POL_27", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{26, 26, 0x0000000000000000, "RW", "IMR19_READ_POL_26", "Bunit IMR19 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR19 region based on the agents 6bit encoded SAI value."},
#else
{26, 26, 0x0000000000000000, "RW", "IMR19_READ_POL_26", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{25, 25, 0x0000000000000000, "RW", "IMR19_READ_POL_25", "Bunit IMR19 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR19 region based on the agents 6bit encoded SAI value."},
#else
{25, 25, 0x0000000000000000, "RW", "IMR19_READ_POL_25", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{24, 24, 0x0000000000000000, "RW", "IMR19_READ_POL_24", "Bunit IMR19 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR19 region based on the agents 6bit encoded SAI value."},
#else
{24, 24, 0x0000000000000000, "RW", "IMR19_READ_POL_24", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{23, 23, 0x0000000000000000, "RO", "IMR19_READ_POL_23", "Bunit IMR19 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR19 region based on the agents 6bit encoded SAI value."},
#else
{23, 23, 0x0000000000000000, "RO", "IMR19_READ_POL_23", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{22, 22, 0x0000000000000000, "RO", "IMR19_READ_POL_22", "Bunit IMR19 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR19 region based on the agents 6bit encoded SAI value."},
#else
{22, 22, 0x0000000000000000, "RO", "IMR19_READ_POL_22", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{21, 21, 0x0000000000000000, "RW", "IMR19_READ_POL_21", "Bunit IMR19 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR19 region based on the agents 6bit encoded SAI value."},
#else
{21, 21, 0x0000000000000000, "RW", "IMR19_READ_POL_21", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{20, 20, 0x0000000000000000, "RO", "IMR19_READ_POL_20", "Bunit IMR19 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR19 region based on the agents 6bit encoded SAI value."},
#else
{20, 20, 0x0000000000000000, "RO", "IMR19_READ_POL_20", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{19, 19, 0x0000000000000000, "RO", "IMR19_READ_POL_19", "Bunit IMR19 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR19 region based on the agents 6bit encoded SAI value."},
#else
{19, 19, 0x0000000000000000, "RO", "IMR19_READ_POL_19", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{18, 18, 0x0000000000000000, "RO", "IMR19_READ_POL_18", "Bunit IMR19 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR19 region based on the agents 6bit encoded SAI value."},
#else
{18, 18, 0x0000000000000000, "RO", "IMR19_READ_POL_18", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{17, 17, 0x0000000000000000, "RW", "IMR19_READ_POL_17", "Bunit IMR19 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR19 region based on the agents 6bit encoded SAI value."},
#else
{17, 17, 0x0000000000000000, "RW", "IMR19_READ_POL_17", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{16, 16, 0x0000000000000000, "RW", "IMR19_READ_POL_16", "Bunit IMR19 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR19 region based on the agents 6bit encoded SAI value."},
#else
{16, 16, 0x0000000000000000, "RW", "IMR19_READ_POL_16", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{15, 15, 0x0000000000000000, "RO", "IMR19_READ_POL_15", "Bunit IMR19 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR19 region based on the agents 6bit encoded SAI value."},
#else
{15, 15, 0x0000000000000000, "RO", "IMR19_READ_POL_15", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{14, 14, 0x0000000000000000, "RO", "IMR19_READ_POL_14", "Bunit IMR19 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR19 region based on the agents 6bit encoded SAI value."},
#else
{14, 14, 0x0000000000000000, "RO", "IMR19_READ_POL_14", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{13, 13, 0x0000000000000000, "RW", "IMR19_READ_POL_13", "Bunit IMR19 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR19 region based on the agents 6bit encoded SAI value."},
#else
{13, 13, 0x0000000000000000, "RW", "IMR19_READ_POL_13", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{12, 12, 0x0000000000000000, "RW", "IMR19_READ_POL_12", "Bunit IMR19 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR19 region based on the agents 6bit encoded SAI value."},
#else
{12, 12, 0x0000000000000000, "RW", "IMR19_READ_POL_12", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{11, 11, 0x0000000000000000, "RO", "IMR19_READ_POL_11", "Bunit IMR19 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR19 region based on the agents 6bit encoded SAI value."},
#else
{11, 11, 0x0000000000000000, "RO", "IMR19_READ_POL_11", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{10, 10, 0x0000000000000000, "RO", "IMR19_READ_POL_10", "Bunit IMR19 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR19 region based on the agents 6bit encoded SAI value."},
#else
{10, 10, 0x0000000000000000, "RO", "IMR19_READ_POL_10", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{9, 9, 0x0000000000000000, "RO", "IMR19_READ_POL_9", "Bunit IMR19 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR19 region based on the agents 6bit encoded SAI value."},
#else
{9, 9, 0x0000000000000000, "RO", "IMR19_READ_POL_9", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{8, 8, 0x0000000000000000, "RW", "IMR19_READ_POL_8", "Bunit IMR19 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR19 region based on the agents 6bit encoded SAI value."},
#else
{8, 8, 0x0000000000000000, "RW", "IMR19_READ_POL_8", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{7, 7, 0x0000000000000000, "RO", "IMR19_READ_POL_7", "Bunit IMR19 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR19 region based on the agents 6bit encoded SAI value."},
#else
{7, 7, 0x0000000000000000, "RO", "IMR19_READ_POL_7", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{6, 6, 0x0000000000000000, "RO", "IMR19_READ_POL_6", "Bunit IMR19 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR19 region based on the agents 6bit encoded SAI value."},
#else
{6, 6, 0x0000000000000000, "RO", "IMR19_READ_POL_6", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{5, 5, 0x0000000000000000, "RW", "IMR19_READ_POL_5", "Bunit IMR19 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR19 region based on the agents 6bit encoded SAI value."},
#else
{5, 5, 0x0000000000000000, "RW", "IMR19_READ_POL_5", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{4, 4, 0x0000000000000000, "RW", "IMR19_READ_POL_4", "Bunit IMR19 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR19 region based on the agents 6bit encoded SAI value."},
#else
{4, 4, 0x0000000000000000, "RW", "IMR19_READ_POL_4", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{3, 3, 0x0000000000000000, "RW", "IMR19_READ_POL_3", "Bunit IMR19 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR19 region based on the agents 6bit encoded SAI value."},
#else
{3, 3, 0x0000000000000000, "RW", "IMR19_READ_POL_3", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{2, 2, 0x0000000000000000, "RW", "IMR19_READ_POL_2", "Bunit IMR19 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR19 region based on the agents 6bit encoded SAI value."},
#else
{2, 2, 0x0000000000000000, "RW", "IMR19_READ_POL_2", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{1, 1, 0x0000000000000000, "RW", "IMR19_READ_POL_1", "Bunit IMR19 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR19 region based on the agents 6bit encoded SAI value."},
#else
{1, 1, 0x0000000000000000, "RW", "IMR19_READ_POL_1", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 0, 0x0000000000000000, "RW", "IMR19_READ_POL_0", "Bunit IMR19 Read Access Policy: Bit vector used to determine which agents are allowed read access to the IMR19 region based on the agents 6bit encoded SAI value."},
#else
{0, 0, 0x0000000000000000, "RW", "IMR19_READ_POL_0", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo975[] = {{"B_CR_BIMR19RAC_0_0_0_MCHBAR", "", 0x00006AE0, 64, 0xFFFFFFFFFFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields976[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{63, 63, 0x0000000000000000, "RW", "IMR19_WRITE_POL_63", "Bunit IMR19 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR19 region based on the agents 6bit encoded SAI value."},
#else
{63, 63, 0x0000000000000000, "RW", "IMR19_WRITE_POL_63", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{62, 62, 0x0000000000000000, "RO", "IMR19_WRITE_POL_62", "Bunit IMR19 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR19 region based on the agents 6bit encoded SAI value."},
#else
{62, 62, 0x0000000000000000, "RO", "IMR19_WRITE_POL_62", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{61, 61, 0x0000000000000000, "RO", "IMR19_WRITE_POL_61", "Bunit IMR19 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR19 region based on the agents 6bit encoded SAI value."},
#else
{61, 61, 0x0000000000000000, "RO", "IMR19_WRITE_POL_61", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{60, 60, 0x0000000000000000, "RO", "IMR19_WRITE_POL_60", "Bunit IMR19 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR19 region based on the agents 6bit encoded SAI value."},
#else
{60, 60, 0x0000000000000000, "RO", "IMR19_WRITE_POL_60", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{59, 59, 0x0000000000000000, "RO", "IMR19_WRITE_POL_59", "Bunit IMR19 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR19 region based on the agents 6bit encoded SAI value."},
#else
{59, 59, 0x0000000000000000, "RO", "IMR19_WRITE_POL_59", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{58, 58, 0x0000000000000000, "RO", "IMR19_WRITE_POL_58", "Bunit IMR19 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR19 region based on the agents 6bit encoded SAI value."},
#else
{58, 58, 0x0000000000000000, "RO", "IMR19_WRITE_POL_58", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{57, 57, 0x0000000000000000, "RO", "IMR19_WRITE_POL_57", "Bunit IMR19 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR19 region based on the agents 6bit encoded SAI value."},
#else
{57, 57, 0x0000000000000000, "RO", "IMR19_WRITE_POL_57", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{56, 56, 0x0000000000000000, "RW", "IMR19_WRITE_POL_56", "Bunit IMR19 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR19 region based on the agents 6bit encoded SAI value."},
#else
{56, 56, 0x0000000000000000, "RW", "IMR19_WRITE_POL_56", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{55, 55, 0x0000000000000000, "RW", "IMR19_WRITE_POL_55", "Bunit IMR19 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR19 region based on the agents 6bit encoded SAI value."},
#else
{55, 55, 0x0000000000000000, "RW", "IMR19_WRITE_POL_55", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{54, 54, 0x0000000000000000, "RW", "IMR19_WRITE_POL_54", "Bunit IMR19 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR19 region based on the agents 6bit encoded SAI value."},
#else
{54, 54, 0x0000000000000000, "RW", "IMR19_WRITE_POL_54", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{53, 53, 0x0000000000000000, "RO", "IMR19_WRITE_POL_53", "Bunit IMR19 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR19 region based on the agents 6bit encoded SAI value."},
#else
{53, 53, 0x0000000000000000, "RO", "IMR19_WRITE_POL_53", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{52, 52, 0x0000000000000000, "RO", "IMR19_WRITE_POL_52", "Bunit IMR19 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR19 region based on the agents 6bit encoded SAI value."},
#else
{52, 52, 0x0000000000000000, "RO", "IMR19_WRITE_POL_52", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{51, 51, 0x0000000000000000, "RO", "IMR19_WRITE_POL_51", "Bunit IMR19 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR19 region based on the agents 6bit encoded SAI value."},
#else
{51, 51, 0x0000000000000000, "RO", "IMR19_WRITE_POL_51", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{50, 50, 0x0000000000000000, "RW", "IMR19_WRITE_POL_50", "Bunit IMR19 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR19 region based on the agents 6bit encoded SAI value."},
#else
{50, 50, 0x0000000000000000, "RW", "IMR19_WRITE_POL_50", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{49, 49, 0x0000000000000000, "RW", "IMR19_WRITE_POL_49", "Bunit IMR19 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR19 region based on the agents 6bit encoded SAI value."},
#else
{49, 49, 0x0000000000000000, "RW", "IMR19_WRITE_POL_49", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{48, 48, 0x0000000000000000, "RW", "IMR19_WRITE_POL_48", "Bunit IMR19 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR19 region based on the agents 6bit encoded SAI value."},
#else
{48, 48, 0x0000000000000000, "RW", "IMR19_WRITE_POL_48", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{47, 47, 0x0000000000000000, "RO", "IMR19_WRITE_POL_47", "Bunit IMR19 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR19 region based on the agents 6bit encoded SAI value."},
#else
{47, 47, 0x0000000000000000, "RO", "IMR19_WRITE_POL_47", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{46, 46, 0x0000000000000000, "RO", "IMR19_WRITE_POL_46", "Bunit IMR19 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR19 region based on the agents 6bit encoded SAI value."},
#else
{46, 46, 0x0000000000000000, "RO", "IMR19_WRITE_POL_46", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{45, 45, 0x0000000000000000, "RO", "IMR19_WRITE_POL_45", "Bunit IMR19 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR19 region based on the agents 6bit encoded SAI value."},
#else
{45, 45, 0x0000000000000000, "RO", "IMR19_WRITE_POL_45", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{44, 44, 0x0000000000000000, "RW", "IMR19_WRITE_POL_44", "Bunit IMR19 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR19 region based on the agents 6bit encoded SAI value."},
#else
{44, 44, 0x0000000000000000, "RW", "IMR19_WRITE_POL_44", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{43, 43, 0x0000000000000000, "RW", "IMR19_WRITE_POL_43", "Bunit IMR19 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR19 region based on the agents 6bit encoded SAI value."},
#else
{43, 43, 0x0000000000000000, "RW", "IMR19_WRITE_POL_43", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{42, 42, 0x0000000000000000, "RW", "IMR19_WRITE_POL_42", "Bunit IMR19 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR19 region based on the agents 6bit encoded SAI value."},
#else
{42, 42, 0x0000000000000000, "RW", "IMR19_WRITE_POL_42", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{41, 41, 0x0000000000000000, "RW", "IMR19_WRITE_POL_41", "Bunit IMR19 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR19 region based on the agents 6bit encoded SAI value."},
#else
{41, 41, 0x0000000000000000, "RW", "IMR19_WRITE_POL_41", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{40, 40, 0x0000000000000000, "RW", "IMR19_WRITE_POL_40", "Bunit IMR19 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR19 region based on the agents 6bit encoded SAI value."},
#else
{40, 40, 0x0000000000000000, "RW", "IMR19_WRITE_POL_40", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{39, 39, 0x0000000000000000, "RO", "IMR19_WRITE_POL_39", "Bunit IMR19 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR19 region based on the agents 6bit encoded SAI value."},
#else
{39, 39, 0x0000000000000000, "RO", "IMR19_WRITE_POL_39", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{38, 38, 0x0000000000000000, "RW", "IMR19_WRITE_POL_38", "Bunit IMR19 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR19 region based on the agents 6bit encoded SAI value."},
#else
{38, 38, 0x0000000000000000, "RW", "IMR19_WRITE_POL_38", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{37, 37, 0x0000000000000000, "RO", "IMR19_WRITE_POL_37", "Bunit IMR19 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR19 region based on the agents 6bit encoded SAI value."},
#else
{37, 37, 0x0000000000000000, "RO", "IMR19_WRITE_POL_37", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{36, 36, 0x0000000000000000, "RW", "IMR19_WRITE_POL_36", "Bunit IMR19 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR19 region based on the agents 6bit encoded SAI value."},
#else
{36, 36, 0x0000000000000000, "RW", "IMR19_WRITE_POL_36", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{35, 35, 0x0000000000000000, "RO", "IMR19_WRITE_POL_35", "Bunit IMR19 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR19 region based on the agents 6bit encoded SAI value."},
#else
{35, 35, 0x0000000000000000, "RO", "IMR19_WRITE_POL_35", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{34, 34, 0x0000000000000000, "RW", "IMR19_WRITE_POL_34", "Bunit IMR19 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR19 region based on the agents 6bit encoded SAI value."},
#else
{34, 34, 0x0000000000000000, "RW", "IMR19_WRITE_POL_34", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{33, 33, 0x0000000000000000, "RW", "IMR19_WRITE_POL_33", "Bunit IMR19 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR19 region based on the agents 6bit encoded SAI value."},
#else
{33, 33, 0x0000000000000000, "RW", "IMR19_WRITE_POL_33", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{32, 32, 0x0000000000000000, "RW", "IMR19_WRITE_POL_32", "Bunit IMR19 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR19 region based on the agents 6bit encoded SAI value."},
#else
{32, 32, 0x0000000000000000, "RW", "IMR19_WRITE_POL_32", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{31, 31, 0x0000000000000000, "RO", "IMR19_WRITE_POL_31", "Bunit IMR19 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR19 region based on the agents 6bit encoded SAI value."},
#else
{31, 31, 0x0000000000000000, "RO", "IMR19_WRITE_POL_31", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{30, 30, 0x0000000000000000, "RW", "IMR19_WRITE_POL_30", "Bunit IMR19 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR19 region based on the agents 6bit encoded SAI value."},
#else
{30, 30, 0x0000000000000000, "RW", "IMR19_WRITE_POL_30", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{29, 29, 0x0000000000000000, "RW", "IMR19_WRITE_POL_29", "Bunit IMR19 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR19 region based on the agents 6bit encoded SAI value."},
#else
{29, 29, 0x0000000000000000, "RW", "IMR19_WRITE_POL_29", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{28, 28, 0x0000000000000000, "RW", "IMR19_WRITE_POL_28", "Bunit IMR19 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR19 region based on the agents 6bit encoded SAI value."},
#else
{28, 28, 0x0000000000000000, "RW", "IMR19_WRITE_POL_28", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{27, 27, 0x0000000000000000, "RW", "IMR19_WRITE_POL_27", "Bunit IMR19 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR19 region based on the agents 6bit encoded SAI value."},
#else
{27, 27, 0x0000000000000000, "RW", "IMR19_WRITE_POL_27", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{26, 26, 0x0000000000000000, "RW", "IMR19_WRITE_POL_26", "Bunit IMR19 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR19 region based on the agents 6bit encoded SAI value."},
#else
{26, 26, 0x0000000000000000, "RW", "IMR19_WRITE_POL_26", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{25, 25, 0x0000000000000000, "RW", "IMR19_WRITE_POL_25", "Bunit IMR19 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR19 region based on the agents 6bit encoded SAI value."},
#else
{25, 25, 0x0000000000000000, "RW", "IMR19_WRITE_POL_25", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{24, 24, 0x0000000000000000, "RW", "IMR19_WRITE_POL_24", "Bunit IMR19 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR19 region based on the agents 6bit encoded SAI value."},
#else
{24, 24, 0x0000000000000000, "RW", "IMR19_WRITE_POL_24", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{23, 23, 0x0000000000000000, "RO", "IMR19_WRITE_POL_23", "Bunit IMR19 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR19 region based on the agents 6bit encoded SAI value."},
#else
{23, 23, 0x0000000000000000, "RO", "IMR19_WRITE_POL_23", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{22, 22, 0x0000000000000000, "RO", "IMR19_WRITE_POL_22", "Bunit IMR19 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR19 region based on the agents 6bit encoded SAI value."},
#else
{22, 22, 0x0000000000000000, "RO", "IMR19_WRITE_POL_22", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{21, 21, 0x0000000000000000, "RW", "IMR19_WRITE_POL_21", "Bunit IMR19 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR19 region based on the agents 6bit encoded SAI value."},
#else
{21, 21, 0x0000000000000000, "RW", "IMR19_WRITE_POL_21", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{20, 20, 0x0000000000000000, "RO", "IMR19_WRITE_POL_20", "Bunit IMR19 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR19 region based on the agents 6bit encoded SAI value."},
#else
{20, 20, 0x0000000000000000, "RO", "IMR19_WRITE_POL_20", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{19, 19, 0x0000000000000000, "RO", "IMR19_WRITE_POL_19", "Bunit IMR19 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR19 region based on the agents 6bit encoded SAI value."},
#else
{19, 19, 0x0000000000000000, "RO", "IMR19_WRITE_POL_19", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{18, 18, 0x0000000000000000, "RO", "IMR19_WRITE_POL_18", "Bunit IMR19 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR19 region based on the agents 6bit encoded SAI value."},
#else
{18, 18, 0x0000000000000000, "RO", "IMR19_WRITE_POL_18", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{17, 17, 0x0000000000000000, "RW", "IMR19_WRITE_POL_17", "Bunit IMR19 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR19 region based on the agents 6bit encoded SAI value."},
#else
{17, 17, 0x0000000000000000, "RW", "IMR19_WRITE_POL_17", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{16, 16, 0x0000000000000000, "RW", "IMR19_WRITE_POL_16", "Bunit IMR19 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR19 region based on the agents 6bit encoded SAI value."},
#else
{16, 16, 0x0000000000000000, "RW", "IMR19_WRITE_POL_16", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{15, 15, 0x0000000000000000, "RO", "IMR19_WRITE_POL_15", "Bunit IMR19 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR19 region based on the agents 6bit encoded SAI value."},
#else
{15, 15, 0x0000000000000000, "RO", "IMR19_WRITE_POL_15", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{14, 14, 0x0000000000000000, "RO", "IMR19_WRITE_POL_14", "Bunit IMR19 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR19 region based on the agents 6bit encoded SAI value."},
#else
{14, 14, 0x0000000000000000, "RO", "IMR19_WRITE_POL_14", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{13, 13, 0x0000000000000000, "RW", "IMR19_WRITE_POL_13", "Bunit IMR19 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR19 region based on the agents 6bit encoded SAI value."},
#else
{13, 13, 0x0000000000000000, "RW", "IMR19_WRITE_POL_13", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{12, 12, 0x0000000000000000, "RW", "IMR19_WRITE_POL_12", "Bunit IMR19 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR19 region based on the agents 6bit encoded SAI value."},
#else
{12, 12, 0x0000000000000000, "RW", "IMR19_WRITE_POL_12", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{11, 11, 0x0000000000000000, "RO", "IMR19_WRITE_POL_11", "Bunit IMR19 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR19 region based on the agents 6bit encoded SAI value."},
#else
{11, 11, 0x0000000000000000, "RO", "IMR19_WRITE_POL_11", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{10, 10, 0x0000000000000000, "RO", "IMR19_WRITE_POL_10", "Bunit IMR19 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR19 region based on the agents 6bit encoded SAI value."},
#else
{10, 10, 0x0000000000000000, "RO", "IMR19_WRITE_POL_10", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{9, 9, 0x0000000000000000, "RO", "IMR19_WRITE_POL_9", "Bunit IMR19 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR19 region based on the agents 6bit encoded SAI value."},
#else
{9, 9, 0x0000000000000000, "RO", "IMR19_WRITE_POL_9", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{8, 8, 0x0000000000000000, "RW", "IMR19_WRITE_POL_8", "Bunit IMR19 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR19 region based on the agents 6bit encoded SAI value."},
#else
{8, 8, 0x0000000000000000, "RW", "IMR19_WRITE_POL_8", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{7, 7, 0x0000000000000000, "RO", "IMR19_WRITE_POL_7", "Bunit IMR19 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR19 region based on the agents 6bit encoded SAI value."},
#else
{7, 7, 0x0000000000000000, "RO", "IMR19_WRITE_POL_7", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{6, 6, 0x0000000000000000, "RO", "IMR19_WRITE_POL_6", "Bunit IMR19 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR19 region based on the agents 6bit encoded SAI value."},
#else
{6, 6, 0x0000000000000000, "RO", "IMR19_WRITE_POL_6", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{5, 5, 0x0000000000000000, "RW", "IMR19_WRITE_POL_5", "Bunit IMR19 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR19 region based on the agents 6bit encoded SAI value."},
#else
{5, 5, 0x0000000000000000, "RW", "IMR19_WRITE_POL_5", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{4, 4, 0x0000000000000000, "RW", "IMR19_WRITE_POL_4", "Bunit IMR19 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR19 region based on the agents 6bit encoded SAI value."},
#else
{4, 4, 0x0000000000000000, "RW", "IMR19_WRITE_POL_4", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{3, 3, 0x0000000000000000, "RW", "IMR19_WRITE_POL_3", "Bunit IMR19 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR19 region based on the agents 6bit encoded SAI value."},
#else
{3, 3, 0x0000000000000000, "RW", "IMR19_WRITE_POL_3", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{2, 2, 0x0000000000000000, "RW", "IMR19_WRITE_POL_2", "Bunit IMR19 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR19 region based on the agents 6bit encoded SAI value."},
#else
{2, 2, 0x0000000000000000, "RW", "IMR19_WRITE_POL_2", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{1, 1, 0x0000000000000000, "RW", "IMR19_WRITE_POL_1", "Bunit IMR19 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR19 region based on the agents 6bit encoded SAI value."},
#else
{1, 1, 0x0000000000000000, "RW", "IMR19_WRITE_POL_1", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 0, 0x0000000000000000, "RW", "IMR19_WRITE_POL_0", "Bunit IMR19 Write Access Policy: Bit vector used to determine which agents are allowed write access to the IMR19 region based on the agents 6bit encoded SAI value."},
#else
{0, 0, 0x0000000000000000, "RW", "IMR19_WRITE_POL_0", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo976[] = {{"B_CR_BIMR19WAC_0_0_0_MCHBAR", "", 0x00006AE8, 64, 0xFFFFFFFFFFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields977[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{31, 31, 0x0000000000000000, "RW", "IMR_EN", "IMR Enable: Enables access checking for the MOT region.  Note: this does not enable MOT itself merely enables access control checks for transactions that attempt to access the MOT buffer."},
#else
{31, 31, 0x0000000000000000, "RW", "IMR_EN", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{30, 30, 0x0000000000000000, "RO", "TR_EN", "Asset Classification AC[0]: Trace Enable: Enables snooping of transactions to the IMR region by tracing agents such as MOT.  Reserved and set to 0 for the MOT region since otherwise this would enable recursive tracing and corrupt MOT buffer."},
#else
{30, 30, 0x0000000000000000, "RO", "TR_EN", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{29, 29, 0x0000000000000000, "RO", "RESERVED_1", "Reserved"},
#else
{29, 29, 0x0000000000000000, "RO", "RESERVED_1", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{14, 28, 0x0000000000000000, "RW", "MOT_OUT_BASE", "Specifies bits 38:24 of the start address of the MOT memory region.  Region size must be a strict poweroftwo at least 16MB and naturally aligned to the size.  These bits are compared with the result of the MOT_OUT_MASK[28:14] applied to bits 38:24 of the incoming address to determine if an access falls within the MOT region."},
#else
{14, 28, 0x0000000000000000, "RW", "MOT_OUT_BASE", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 13, 0x0000000000000000, "RO", "RESERVED_0", "Reserved"},
#else
{0, 13, 0x0000000000000000, "RO", "RESERVED_0", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo977[] = {{"B_CR_MOT_OUT_BASE_0_0_0_MCHBAR", "", 0x00006AF0, 5, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields978[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{31, 31, 0x0000000000000000, "RW", "GT_IWB_EN", "Asset Classification AC[2]: GT Implicit WB Enable: Enables implicit writebacks to protected region from GT caching agent. When set to 1 enables implicit writeback data HITM data from GT to be returned to the requester.  When set to 0 inhibits HITM data from GT from being returned to the requester.  HITM data from IA cores may be returned to the requester depending on the setting of the IA_IWB_EN bit."},
#else
{31, 31, 0x0000000000000000, "RW", "GT_IWB_EN", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{30, 30, 0x0000000000000000, "RW", "IA_IWB_EN", "Asset Classification AC[1]: IA Implicit WB Enable: Enables implicit writebacks to protected region from IA caching agent.  When set to 1 enables implicit writeback data HITM data from IA cores to be returned to the requester.  When set to 0 inhibits HITM data from IA cores from being returned to the requester.  HITM data from GT may be returned to the requester depending on the setting of the GT_IWB_EN bit."},
#else
{30, 30, 0x0000000000000000, "RW", "IA_IWB_EN", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{29, 29, 0x0000000000000000, "RO", "RESERVED_1", "Reserved"},
#else
{29, 29, 0x0000000000000000, "RO", "RESERVED_1", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{14, 28, 0x0000000000000000, "RW", "MOT_OUT_MASK", "Specifies the size of the MOT region.  If Request Address [38:24] ANDed with MOT_OUT_MASK[28:14] matches the MOT_OUT_BASE[28:14] then the request falls within the MOT_OUT region"},
#else
{14, 28, 0x0000000000000000, "RW", "MOT_OUT_MASK", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 13, 0x0000000000000000, "RO", "RESERVED_0", "Reserved"},
#else
{0, 13, 0x0000000000000000, "RO", "RESERVED_0", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo978[] = {{"B_CR_MOT_OUT_MASK_0_0_0_MCHBAR", "", 0x00006AF4, 5, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields979[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{0, 63, 0x00000C0061010202, "RW", "MOT_BUF_CTRL_POL", "Bunit MOT Buffer Control Policy: Bit vector used to determine which agents are allowed access to the BMOT_BUF_RAC BMOT_BUF_WAC BMOT_BUF_CP registers based on the value from the agents 6bit SAI field."},
#else
{0, 63, 0x00000C0061010202, "RW", "MOT_BUF_CTRL_POL", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo979[] = {{"B_CR_BMOT_BUF_CP_0_0_0_MCHBAR", "", 0x00006AF8, 1, 0xFFFFFFFFFFFFFFFF, 0x00000C0061010202}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields980[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{63, 63, 0x0000000000000000, "RW", "MOT_BUF_READ_POL_63", "Bunit MOT Read Access Policy: Bit vector used to determine which agents are allowed read access to the MOT region based on the agents 6bit encoded SAI value."},
#else
{63, 63, 0x0000000000000000, "RW", "MOT_BUF_READ_POL_63", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{62, 62, 0x0000000000000000, "RO", "MOT_BUF_READ_POL_62", "Bunit MOT Read Access Policy: Bit vector used to determine which agents are allowed read access to the MOT region based on the agents 6bit encoded SAI value."},
#else
{62, 62, 0x0000000000000000, "RO", "MOT_BUF_READ_POL_62", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{61, 61, 0x0000000000000000, "RO", "MOT_BUF_READ_POL_61", "Bunit MOT Read Access Policy: Bit vector used to determine which agents are allowed read access to the MOT region based on the agents 6bit encoded SAI value."},
#else
{61, 61, 0x0000000000000000, "RO", "MOT_BUF_READ_POL_61", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{60, 60, 0x0000000000000000, "RO", "MOT_BUF_READ_POL_60", "Bunit MOT Read Access Policy: Bit vector used to determine which agents are allowed read access to the MOT region based on the agents 6bit encoded SAI value."},
#else
{60, 60, 0x0000000000000000, "RO", "MOT_BUF_READ_POL_60", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{59, 59, 0x0000000000000000, "RO", "MOT_BUF_READ_POL_59", "Bunit MOT Read Access Policy: Bit vector used to determine which agents are allowed read access to the MOT region based on the agents 6bit encoded SAI value."},
#else
{59, 59, 0x0000000000000000, "RO", "MOT_BUF_READ_POL_59", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{58, 58, 0x0000000000000000, "RO", "MOT_BUF_READ_POL_58", "Bunit MOT Read Access Policy: Bit vector used to determine which agents are allowed read access to the MOT region based on the agents 6bit encoded SAI value."},
#else
{58, 58, 0x0000000000000000, "RO", "MOT_BUF_READ_POL_58", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{57, 57, 0x0000000000000000, "RO", "MOT_BUF_READ_POL_57", "Bunit MOT Read Access Policy: Bit vector used to determine which agents are allowed read access to the MOT region based on the agents 6bit encoded SAI value."},
#else
{57, 57, 0x0000000000000000, "RO", "MOT_BUF_READ_POL_57", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{56, 56, 0x0000000000000000, "RW", "MOT_BUF_READ_POL_56", "Bunit MOT Read Access Policy: Bit vector used to determine which agents are allowed read access to the MOT region based on the agents 6bit encoded SAI value."},
#else
{56, 56, 0x0000000000000000, "RW", "MOT_BUF_READ_POL_56", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{55, 55, 0x0000000000000000, "RW", "MOT_BUF_READ_POL_55", "Bunit MOT Read Access Policy: Bit vector used to determine which agents are allowed read access to the MOT region based on the agents 6bit encoded SAI value."},
#else
{55, 55, 0x0000000000000000, "RW", "MOT_BUF_READ_POL_55", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{54, 54, 0x0000000000000000, "RW", "MOT_BUF_READ_POL_54", "Bunit MOT Read Access Policy: Bit vector used to determine which agents are allowed read access to the MOT region based on the agents 6bit encoded SAI value."},
#else
{54, 54, 0x0000000000000000, "RW", "MOT_BUF_READ_POL_54", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{53, 53, 0x0000000000000000, "RO", "MOT_BUF_READ_POL_53", "Bunit MOT Read Access Policy: Bit vector used to determine which agents are allowed read access to the MOT region based on the agents 6bit encoded SAI value."},
#else
{53, 53, 0x0000000000000000, "RO", "MOT_BUF_READ_POL_53", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{52, 52, 0x0000000000000000, "RO", "MOT_BUF_READ_POL_52", "Bunit MOT Read Access Policy: Bit vector used to determine which agents are allowed read access to the MOT region based on the agents 6bit encoded SAI value."},
#else
{52, 52, 0x0000000000000000, "RO", "MOT_BUF_READ_POL_52", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{51, 51, 0x0000000000000000, "RO", "MOT_BUF_READ_POL_51", "Bunit MOT Read Access Policy: Bit vector used to determine which agents are allowed read access to the MOT region based on the agents 6bit encoded SAI value."},
#else
{51, 51, 0x0000000000000000, "RO", "MOT_BUF_READ_POL_51", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{50, 50, 0x0000000000000000, "RW", "MOT_BUF_READ_POL_50", "Bunit MOT Read Access Policy: Bit vector used to determine which agents are allowed read access to the MOT region based on the agents 6bit encoded SAI value."},
#else
{50, 50, 0x0000000000000000, "RW", "MOT_BUF_READ_POL_50", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{49, 49, 0x0000000000000000, "RW", "MOT_BUF_READ_POL_49", "Bunit MOT Read Access Policy: Bit vector used to determine which agents are allowed read access to the MOT region based on the agents 6bit encoded SAI value."},
#else
{49, 49, 0x0000000000000000, "RW", "MOT_BUF_READ_POL_49", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{48, 48, 0x0000000000000000, "RW", "MOT_BUF_READ_POL_48", "Bunit MOT Read Access Policy: Bit vector used to determine which agents are allowed read access to the MOT region based on the agents 6bit encoded SAI value."},
#else
{48, 48, 0x0000000000000000, "RW", "MOT_BUF_READ_POL_48", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{47, 47, 0x0000000000000000, "RO", "MOT_BUF_READ_POL_47", "Bunit MOT Read Access Policy: Bit vector used to determine which agents are allowed read access to the MOT region based on the agents 6bit encoded SAI value."},
#else
{47, 47, 0x0000000000000000, "RO", "MOT_BUF_READ_POL_47", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{46, 46, 0x0000000000000000, "RO", "MOT_BUF_READ_POL_46", "Bunit MOT Read Access Policy: Bit vector used to determine which agents are allowed read access to the MOT region based on the agents 6bit encoded SAI value."},
#else
{46, 46, 0x0000000000000000, "RO", "MOT_BUF_READ_POL_46", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{45, 45, 0x0000000000000000, "RO", "MOT_BUF_READ_POL_45", "Bunit MOT Read Access Policy: Bit vector used to determine which agents are allowed read access to the MOT region based on the agents 6bit encoded SAI value."},
#else
{45, 45, 0x0000000000000000, "RO", "MOT_BUF_READ_POL_45", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{44, 44, 0x0000000000000000, "RW", "MOT_BUF_READ_POL_44", "Bunit MOT Read Access Policy: Bit vector used to determine which agents are allowed read access to the MOT region based on the agents 6bit encoded SAI value."},
#else
{44, 44, 0x0000000000000000, "RW", "MOT_BUF_READ_POL_44", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{43, 43, 0x0000000000000000, "RW", "MOT_BUF_READ_POL_43", "Bunit MOT Read Access Policy: Bit vector used to determine which agents are allowed read access to the MOT region based on the agents 6bit encoded SAI value."},
#else
{43, 43, 0x0000000000000000, "RW", "MOT_BUF_READ_POL_43", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{42, 42, 0x0000000000000000, "RW", "MOT_BUF_READ_POL_42", "Bunit MOT Read Access Policy: Bit vector used to determine which agents are allowed read access to the MOT region based on the agents 6bit encoded SAI value."},
#else
{42, 42, 0x0000000000000000, "RW", "MOT_BUF_READ_POL_42", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{41, 41, 0x0000000000000000, "RW", "MOT_BUF_READ_POL_41", "Bunit MOT Read Access Policy: Bit vector used to determine which agents are allowed read access to the MOT region based on the agents 6bit encoded SAI value."},
#else
{41, 41, 0x0000000000000000, "RW", "MOT_BUF_READ_POL_41", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{40, 40, 0x0000000000000000, "RW", "MOT_BUF_READ_POL_40", "Bunit MOT Read Access Policy: Bit vector used to determine which agents are allowed read access to the MOT region based on the agents 6bit encoded SAI value."},
#else
{40, 40, 0x0000000000000000, "RW", "MOT_BUF_READ_POL_40", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{39, 39, 0x0000000000000000, "RO", "MOT_BUF_READ_POL_39", "Bunit MOT Read Access Policy: Bit vector used to determine which agents are allowed read access to the MOT region based on the agents 6bit encoded SAI value."},
#else
{39, 39, 0x0000000000000000, "RO", "MOT_BUF_READ_POL_39", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{38, 38, 0x0000000000000000, "RW", "MOT_BUF_READ_POL_38", "Bunit MOT Read Access Policy: Bit vector used to determine which agents are allowed read access to the MOT region based on the agents 6bit encoded SAI value."},
#else
{38, 38, 0x0000000000000000, "RW", "MOT_BUF_READ_POL_38", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{37, 37, 0x0000000000000000, "RO", "MOT_BUF_READ_POL_37", "Bunit MOT Read Access Policy: Bit vector used to determine which agents are allowed read access to the MOT region based on the agents 6bit encoded SAI value."},
#else
{37, 37, 0x0000000000000000, "RO", "MOT_BUF_READ_POL_37", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{36, 36, 0x0000000000000000, "RW", "MOT_BUF_READ_POL_36", "Bunit MOT Read Access Policy: Bit vector used to determine which agents are allowed read access to the MOT region based on the agents 6bit encoded SAI value."},
#else
{36, 36, 0x0000000000000000, "RW", "MOT_BUF_READ_POL_36", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{35, 35, 0x0000000000000000, "RO", "MOT_BUF_READ_POL_35", "Bunit MOT Read Access Policy: Bit vector used to determine which agents are allowed read access to the MOT region based on the agents 6bit encoded SAI value."},
#else
{35, 35, 0x0000000000000000, "RO", "MOT_BUF_READ_POL_35", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{34, 34, 0x0000000000000000, "RW", "MOT_BUF_READ_POL_34", "Bunit MOT Read Access Policy: Bit vector used to determine which agents are allowed read access to the MOT region based on the agents 6bit encoded SAI value."},
#else
{34, 34, 0x0000000000000000, "RW", "MOT_BUF_READ_POL_34", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{33, 33, 0x0000000000000000, "RW", "MOT_BUF_READ_POL_33", "Bunit MOT Read Access Policy: Bit vector used to determine which agents are allowed read access to the MOT region based on the agents 6bit encoded SAI value."},
#else
{33, 33, 0x0000000000000000, "RW", "MOT_BUF_READ_POL_33", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{32, 32, 0x0000000000000000, "RW", "MOT_BUF_READ_POL_32", "Bunit MOT Read Access Policy: Bit vector used to determine which agents are allowed read access to the MOT region based on the agents 6bit encoded SAI value."},
#else
{32, 32, 0x0000000000000000, "RW", "MOT_BUF_READ_POL_32", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{31, 31, 0x0000000000000000, "RO", "MOT_BUF_READ_POL_31", "Bunit MOT Read Access Policy: Bit vector used to determine which agents are allowed read access to the MOT region based on the agents 6bit encoded SAI value."},
#else
{31, 31, 0x0000000000000000, "RO", "MOT_BUF_READ_POL_31", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{30, 30, 0x0000000000000000, "RW", "MOT_BUF_READ_POL_30", "Bunit MOT Read Access Policy: Bit vector used to determine which agents are allowed read access to the MOT region based on the agents 6bit encoded SAI value."},
#else
{30, 30, 0x0000000000000000, "RW", "MOT_BUF_READ_POL_30", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{29, 29, 0x0000000000000000, "RW", "MOT_BUF_READ_POL_29", "Bunit MOT Read Access Policy: Bit vector used to determine which agents are allowed read access to the MOT region based on the agents 6bit encoded SAI value."},
#else
{29, 29, 0x0000000000000000, "RW", "MOT_BUF_READ_POL_29", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{28, 28, 0x0000000000000000, "RW", "MOT_BUF_READ_POL_28", "Bunit MOT Read Access Policy: Bit vector used to determine which agents are allowed read access to the MOT region based on the agents 6bit encoded SAI value."},
#else
{28, 28, 0x0000000000000000, "RW", "MOT_BUF_READ_POL_28", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{27, 27, 0x0000000000000000, "RW", "MOT_BUF_READ_POL_27", "Bunit MOT Read Access Policy: Bit vector used to determine which agents are allowed read access to the MOT region based on the agents 6bit encoded SAI value."},
#else
{27, 27, 0x0000000000000000, "RW", "MOT_BUF_READ_POL_27", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{26, 26, 0x0000000000000000, "RW", "MOT_BUF_READ_POL_26", "Bunit MOT Read Access Policy: Bit vector used to determine which agents are allowed read access to the MOT region based on the agents 6bit encoded SAI value."},
#else
{26, 26, 0x0000000000000000, "RW", "MOT_BUF_READ_POL_26", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{25, 25, 0x0000000000000000, "RW", "MOT_BUF_READ_POL_25", "Bunit MOT Read Access Policy: Bit vector used to determine which agents are allowed read access to the MOT region based on the agents 6bit encoded SAI value."},
#else
{25, 25, 0x0000000000000000, "RW", "MOT_BUF_READ_POL_25", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{24, 24, 0x0000000000000000, "RW", "MOT_BUF_READ_POL_24", "Bunit MOT Read Access Policy: Bit vector used to determine which agents are allowed read access to the MOT region based on the agents 6bit encoded SAI value."},
#else
{24, 24, 0x0000000000000000, "RW", "MOT_BUF_READ_POL_24", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{23, 23, 0x0000000000000000, "RO", "MOT_BUF_READ_POL_23", "Bunit MOT Read Access Policy: Bit vector used to determine which agents are allowed read access to the MOT region based on the agents 6bit encoded SAI value."},
#else
{23, 23, 0x0000000000000000, "RO", "MOT_BUF_READ_POL_23", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{22, 22, 0x0000000000000000, "RO", "MOT_BUF_READ_POL_22", "Bunit MOT Read Access Policy: Bit vector used to determine which agents are allowed read access to the MOT region based on the agents 6bit encoded SAI value."},
#else
{22, 22, 0x0000000000000000, "RO", "MOT_BUF_READ_POL_22", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{21, 21, 0x0000000000000000, "RW", "MOT_BUF_READ_POL_21", "Bunit MOT Read Access Policy: Bit vector used to determine which agents are allowed read access to the MOT region based on the agents 6bit encoded SAI value."},
#else
{21, 21, 0x0000000000000000, "RW", "MOT_BUF_READ_POL_21", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{20, 20, 0x0000000000000000, "RO", "MOT_BUF_READ_POL_20", "Bunit MOT Read Access Policy: Bit vector used to determine which agents are allowed read access to the MOT region based on the agents 6bit encoded SAI value."},
#else
{20, 20, 0x0000000000000000, "RO", "MOT_BUF_READ_POL_20", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{19, 19, 0x0000000000000000, "RO", "MOT_BUF_READ_POL_19", "Bunit MOT Read Access Policy: Bit vector used to determine which agents are allowed read access to the MOT region based on the agents 6bit encoded SAI value."},
#else
{19, 19, 0x0000000000000000, "RO", "MOT_BUF_READ_POL_19", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{18, 18, 0x0000000000000000, "RO", "MOT_BUF_READ_POL_18", "Bunit MOT Read Access Policy: Bit vector used to determine which agents are allowed read access to the MOT region based on the agents 6bit encoded SAI value."},
#else
{18, 18, 0x0000000000000000, "RO", "MOT_BUF_READ_POL_18", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{17, 17, 0x0000000000000000, "RW", "MOT_BUF_READ_POL_17", "Bunit MOT Read Access Policy: Bit vector used to determine which agents are allowed read access to the MOT region based on the agents 6bit encoded SAI value."},
#else
{17, 17, 0x0000000000000000, "RW", "MOT_BUF_READ_POL_17", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{16, 16, 0x0000000000000001, "RW", "MOT_BUF_READ_POL_16", "Bunit MOT Read Access Policy: Bit vector used to determine which agents are allowed read access to the MOT region based on the agents 6bit encoded SAI value."},
#else
{16, 16, 0x0000000000000001, "RW", "MOT_BUF_READ_POL_16", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{15, 15, 0x0000000000000000, "RO", "MOT_BUF_READ_POL_15", "Bunit MOT Read Access Policy: Bit vector used to determine which agents are allowed read access to the MOT region based on the agents 6bit encoded SAI value."},
#else
{15, 15, 0x0000000000000000, "RO", "MOT_BUF_READ_POL_15", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{14, 14, 0x0000000000000000, "RO", "MOT_BUF_READ_POL_14", "Bunit MOT Read Access Policy: Bit vector used to determine which agents are allowed read access to the MOT region based on the agents 6bit encoded SAI value."},
#else
{14, 14, 0x0000000000000000, "RO", "MOT_BUF_READ_POL_14", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{13, 13, 0x0000000000000000, "RW", "MOT_BUF_READ_POL_13", "Bunit MOT Read Access Policy: Bit vector used to determine which agents are allowed read access to the MOT region based on the agents 6bit encoded SAI value."},
#else
{13, 13, 0x0000000000000000, "RW", "MOT_BUF_READ_POL_13", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{12, 12, 0x0000000000000000, "RW", "MOT_BUF_READ_POL_12", "Bunit MOT Read Access Policy: Bit vector used to determine which agents are allowed read access to the MOT region based on the agents 6bit encoded SAI value."},
#else
{12, 12, 0x0000000000000000, "RW", "MOT_BUF_READ_POL_12", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{11, 11, 0x0000000000000000, "RO", "MOT_BUF_READ_POL_11", "Bunit MOT Read Access Policy: Bit vector used to determine which agents are allowed read access to the MOT region based on the agents 6bit encoded SAI value."},
#else
{11, 11, 0x0000000000000000, "RO", "MOT_BUF_READ_POL_11", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{10, 10, 0x0000000000000000, "RO", "MOT_BUF_READ_POL_10", "Bunit MOT Read Access Policy: Bit vector used to determine which agents are allowed read access to the MOT region based on the agents 6bit encoded SAI value."},
#else
{10, 10, 0x0000000000000000, "RO", "MOT_BUF_READ_POL_10", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{9, 9, 0x0000000000000000, "RO", "MOT_BUF_READ_POL_9", "Bunit MOT Read Access Policy: Bit vector used to determine which agents are allowed read access to the MOT region based on the agents 6bit encoded SAI value."},
#else
{9, 9, 0x0000000000000000, "RO", "MOT_BUF_READ_POL_9", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{8, 8, 0x0000000000000000, "RW", "MOT_BUF_READ_POL_8", "Bunit MOT Read Access Policy: Bit vector used to determine which agents are allowed read access to the MOT region based on the agents 6bit encoded SAI value."},
#else
{8, 8, 0x0000000000000000, "RW", "MOT_BUF_READ_POL_8", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{7, 7, 0x0000000000000000, "RO", "MOT_BUF_READ_POL_7", "Bunit MOT Read Access Policy: Bit vector used to determine which agents are allowed read access to the MOT region based on the agents 6bit encoded SAI value."},
#else
{7, 7, 0x0000000000000000, "RO", "MOT_BUF_READ_POL_7", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{6, 6, 0x0000000000000000, "RO", "MOT_BUF_READ_POL_6", "Bunit MOT Read Access Policy: Bit vector used to determine which agents are allowed read access to the MOT region based on the agents 6bit encoded SAI value."},
#else
{6, 6, 0x0000000000000000, "RO", "MOT_BUF_READ_POL_6", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{5, 5, 0x0000000000000000, "RW", "MOT_BUF_READ_POL_5", "Bunit MOT Read Access Policy: Bit vector used to determine which agents are allowed read access to the MOT region based on the agents 6bit encoded SAI value."},
#else
{5, 5, 0x0000000000000000, "RW", "MOT_BUF_READ_POL_5", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{4, 4, 0x0000000000000001, "RW", "MOT_BUF_READ_POL_4", "Bunit MOT Read Access Policy: Bit vector used to determine which agents are allowed read access to the MOT region based on the agents 6bit encoded SAI value."},
#else
{4, 4, 0x0000000000000001, "RW", "MOT_BUF_READ_POL_4", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{3, 3, 0x0000000000000000, "RW", "MOT_BUF_READ_POL_3", "Bunit MOT Read Access Policy: Bit vector used to determine which agents are allowed read access to the MOT region based on the agents 6bit encoded SAI value."},
#else
{3, 3, 0x0000000000000000, "RW", "MOT_BUF_READ_POL_3", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{2, 2, 0x0000000000000001, "RW", "MOT_BUF_READ_POL_2", "Bunit MOT Read Access Policy: Bit vector used to determine which agents are allowed read access to the MOT region based on the agents 6bit encoded SAI value."},
#else
{2, 2, 0x0000000000000001, "RW", "MOT_BUF_READ_POL_2", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{1, 1, 0x0000000000000001, "RW", "MOT_BUF_READ_POL_1", "Bunit MOT Read Access Policy: Bit vector used to determine which agents are allowed read access to the MOT region based on the agents 6bit encoded SAI value."},
#else
{1, 1, 0x0000000000000001, "RW", "MOT_BUF_READ_POL_1", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 0, 0x0000000000000001, "RW", "MOT_BUF_READ_POL_0", "Bunit MOT Read Access Policy: Bit vector used to determine which agents are allowed read access to the MOT region based on the agents 6bit encoded SAI value."},
#else
{0, 0, 0x0000000000000001, "RW", "MOT_BUF_READ_POL_0", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo980[] = {{"B_CR_BMOT_BUF_RAC_0_0_0_MCHBAR", "", 0x00006B00, 64, 0xFFFFFFFFFFFFFFFF, 0x0000000000010017}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields981[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{63, 63, 0x0000000000000000, "RW", "MOT_BUF_WRITE_POL_63", "Bunit MOT Write Access Policy: Bit vector used to determine which agents are allowed write access to the MOT region based on the agents 6bit encoded SAI value."},
#else
{63, 63, 0x0000000000000000, "RW", "MOT_BUF_WRITE_POL_63", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{62, 62, 0x0000000000000000, "RO", "MOT_BUF_WRITE_POL_62", "Bunit MOT Write Access Policy: Bit vector used to determine which agents are allowed write access to the MOT region based on the agents 6bit encoded SAI value."},
#else
{62, 62, 0x0000000000000000, "RO", "MOT_BUF_WRITE_POL_62", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{61, 61, 0x0000000000000000, "RO", "MOT_BUF_WRITE_POL_61", "Bunit MOT Write Access Policy: Bit vector used to determine which agents are allowed write access to the MOT region based on the agents 6bit encoded SAI value."},
#else
{61, 61, 0x0000000000000000, "RO", "MOT_BUF_WRITE_POL_61", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{60, 60, 0x0000000000000000, "RO", "MOT_BUF_WRITE_POL_60", "Bunit MOT Write Access Policy: Bit vector used to determine which agents are allowed write access to the MOT region based on the agents 6bit encoded SAI value."},
#else
{60, 60, 0x0000000000000000, "RO", "MOT_BUF_WRITE_POL_60", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{59, 59, 0x0000000000000000, "RO", "MOT_BUF_WRITE_POL_59", "Bunit MOT Write Access Policy: Bit vector used to determine which agents are allowed write access to the MOT region based on the agents 6bit encoded SAI value."},
#else
{59, 59, 0x0000000000000000, "RO", "MOT_BUF_WRITE_POL_59", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{58, 58, 0x0000000000000000, "RO", "MOT_BUF_WRITE_POL_58", "Bunit MOT Write Access Policy: Bit vector used to determine which agents are allowed write access to the MOT region based on the agents 6bit encoded SAI value."},
#else
{58, 58, 0x0000000000000000, "RO", "MOT_BUF_WRITE_POL_58", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{57, 57, 0x0000000000000000, "RO", "MOT_BUF_WRITE_POL_57", "Bunit MOT Write Access Policy: Bit vector used to determine which agents are allowed write access to the MOT region based on the agents 6bit encoded SAI value."},
#else
{57, 57, 0x0000000000000000, "RO", "MOT_BUF_WRITE_POL_57", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{56, 56, 0x0000000000000000, "RW", "MOT_BUF_WRITE_POL_56", "Bunit MOT Write Access Policy: Bit vector used to determine which agents are allowed write access to the MOT region based on the agents 6bit encoded SAI value."},
#else
{56, 56, 0x0000000000000000, "RW", "MOT_BUF_WRITE_POL_56", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{55, 55, 0x0000000000000000, "RW", "MOT_BUF_WRITE_POL_55", "Bunit MOT Write Access Policy: Bit vector used to determine which agents are allowed write access to the MOT region based on the agents 6bit encoded SAI value."},
#else
{55, 55, 0x0000000000000000, "RW", "MOT_BUF_WRITE_POL_55", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{54, 54, 0x0000000000000000, "RW", "MOT_BUF_WRITE_POL_54", "Bunit MOT Write Access Policy: Bit vector used to determine which agents are allowed write access to the MOT region based on the agents 6bit encoded SAI value."},
#else
{54, 54, 0x0000000000000000, "RW", "MOT_BUF_WRITE_POL_54", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{53, 53, 0x0000000000000000, "RO", "MOT_BUF_WRITE_POL_53", "Bunit MOT Write Access Policy: Bit vector used to determine which agents are allowed write access to the MOT region based on the agents 6bit encoded SAI value."},
#else
{53, 53, 0x0000000000000000, "RO", "MOT_BUF_WRITE_POL_53", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{52, 52, 0x0000000000000000, "RO", "MOT_BUF_WRITE_POL_52", "Bunit MOT Write Access Policy: Bit vector used to determine which agents are allowed write access to the MOT region based on the agents 6bit encoded SAI value."},
#else
{52, 52, 0x0000000000000000, "RO", "MOT_BUF_WRITE_POL_52", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{51, 51, 0x0000000000000000, "RO", "MOT_BUF_WRITE_POL_51", "Bunit MOT Write Access Policy: Bit vector used to determine which agents are allowed write access to the MOT region based on the agents 6bit encoded SAI value."},
#else
{51, 51, 0x0000000000000000, "RO", "MOT_BUF_WRITE_POL_51", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{50, 50, 0x0000000000000000, "RW", "MOT_BUF_WRITE_POL_50", "Bunit MOT Write Access Policy: Bit vector used to determine which agents are allowed write access to the MOT region based on the agents 6bit encoded SAI value."},
#else
{50, 50, 0x0000000000000000, "RW", "MOT_BUF_WRITE_POL_50", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{49, 49, 0x0000000000000000, "RW", "MOT_BUF_WRITE_POL_49", "Bunit MOT Write Access Policy: Bit vector used to determine which agents are allowed write access to the MOT region based on the agents 6bit encoded SAI value."},
#else
{49, 49, 0x0000000000000000, "RW", "MOT_BUF_WRITE_POL_49", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{48, 48, 0x0000000000000000, "RW", "MOT_BUF_WRITE_POL_48", "Bunit MOT Write Access Policy: Bit vector used to determine which agents are allowed write access to the MOT region based on the agents 6bit encoded SAI value."},
#else
{48, 48, 0x0000000000000000, "RW", "MOT_BUF_WRITE_POL_48", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{47, 47, 0x0000000000000000, "RO", "MOT_BUF_WRITE_POL_47", "Bunit MOT Write Access Policy: Bit vector used to determine which agents are allowed write access to the MOT region based on the agents 6bit encoded SAI value."},
#else
{47, 47, 0x0000000000000000, "RO", "MOT_BUF_WRITE_POL_47", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{46, 46, 0x0000000000000000, "RO", "MOT_BUF_WRITE_POL_46", "Bunit MOT Write Access Policy: Bit vector used to determine which agents are allowed write access to the MOT region based on the agents 6bit encoded SAI value."},
#else
{46, 46, 0x0000000000000000, "RO", "MOT_BUF_WRITE_POL_46", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{45, 45, 0x0000000000000000, "RO", "MOT_BUF_WRITE_POL_45", "Bunit MOT Write Access Policy: Bit vector used to determine which agents are allowed write access to the MOT region based on the agents 6bit encoded SAI value."},
#else
{45, 45, 0x0000000000000000, "RO", "MOT_BUF_WRITE_POL_45", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{44, 44, 0x0000000000000000, "RW", "MOT_BUF_WRITE_POL_44", "Bunit MOT Write Access Policy: Bit vector used to determine which agents are allowed write access to the MOT region based on the agents 6bit encoded SAI value."},
#else
{44, 44, 0x0000000000000000, "RW", "MOT_BUF_WRITE_POL_44", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{43, 43, 0x0000000000000000, "RW", "MOT_BUF_WRITE_POL_43", "Bunit MOT Write Access Policy: Bit vector used to determine which agents are allowed write access to the MOT region based on the agents 6bit encoded SAI value."},
#else
{43, 43, 0x0000000000000000, "RW", "MOT_BUF_WRITE_POL_43", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{42, 42, 0x0000000000000000, "RW", "MOT_BUF_WRITE_POL_42", "Bunit MOT Write Access Policy: Bit vector used to determine which agents are allowed write access to the MOT region based on the agents 6bit encoded SAI value."},
#else
{42, 42, 0x0000000000000000, "RW", "MOT_BUF_WRITE_POL_42", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{41, 41, 0x0000000000000000, "RW", "MOT_BUF_WRITE_POL_41", "Bunit MOT Write Access Policy: Bit vector used to determine which agents are allowed write access to the MOT region based on the agents 6bit encoded SAI value."},
#else
{41, 41, 0x0000000000000000, "RW", "MOT_BUF_WRITE_POL_41", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{40, 40, 0x0000000000000000, "RW", "MOT_BUF_WRITE_POL_40", "Bunit MOT Write Access Policy: Bit vector used to determine which agents are allowed write access to the MOT region based on the agents 6bit encoded SAI value."},
#else
{40, 40, 0x0000000000000000, "RW", "MOT_BUF_WRITE_POL_40", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{39, 39, 0x0000000000000000, "RO", "MOT_BUF_WRITE_POL_39", "Bunit MOT Write Access Policy: Bit vector used to determine which agents are allowed write access to the MOT region based on the agents 6bit encoded SAI value."},
#else
{39, 39, 0x0000000000000000, "RO", "MOT_BUF_WRITE_POL_39", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{38, 38, 0x0000000000000000, "RW", "MOT_BUF_WRITE_POL_38", "Bunit MOT Write Access Policy: Bit vector used to determine which agents are allowed write access to the MOT region based on the agents 6bit encoded SAI value."},
#else
{38, 38, 0x0000000000000000, "RW", "MOT_BUF_WRITE_POL_38", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{37, 37, 0x0000000000000000, "RO", "MOT_BUF_WRITE_POL_37", "Bunit MOT Write Access Policy: Bit vector used to determine which agents are allowed write access to the MOT region based on the agents 6bit encoded SAI value."},
#else
{37, 37, 0x0000000000000000, "RO", "MOT_BUF_WRITE_POL_37", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{36, 36, 0x0000000000000000, "RW", "MOT_BUF_WRITE_POL_36", "Bunit MOT Write Access Policy: Bit vector used to determine which agents are allowed write access to the MOT region based on the agents 6bit encoded SAI value."},
#else
{36, 36, 0x0000000000000000, "RW", "MOT_BUF_WRITE_POL_36", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{35, 35, 0x0000000000000000, "RO", "MOT_BUF_WRITE_POL_35", "Bunit MOT Write Access Policy: Bit vector used to determine which agents are allowed write access to the MOT region based on the agents 6bit encoded SAI value."},
#else
{35, 35, 0x0000000000000000, "RO", "MOT_BUF_WRITE_POL_35", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{34, 34, 0x0000000000000000, "RW", "MOT_BUF_WRITE_POL_34", "Bunit MOT Write Access Policy: Bit vector used to determine which agents are allowed write access to the MOT region based on the agents 6bit encoded SAI value."},
#else
{34, 34, 0x0000000000000000, "RW", "MOT_BUF_WRITE_POL_34", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{33, 33, 0x0000000000000000, "RW", "MOT_BUF_WRITE_POL_33", "Bunit MOT Write Access Policy: Bit vector used to determine which agents are allowed write access to the MOT region based on the agents 6bit encoded SAI value."},
#else
{33, 33, 0x0000000000000000, "RW", "MOT_BUF_WRITE_POL_33", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{32, 32, 0x0000000000000000, "RW", "MOT_BUF_WRITE_POL_32", "Bunit MOT Write Access Policy: Bit vector used to determine which agents are allowed write access to the MOT region based on the agents 6bit encoded SAI value."},
#else
{32, 32, 0x0000000000000000, "RW", "MOT_BUF_WRITE_POL_32", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{31, 31, 0x0000000000000000, "RO", "MOT_BUF_WRITE_POL_31", "Bunit MOT Write Access Policy: Bit vector used to determine which agents are allowed write access to the MOT region based on the agents 6bit encoded SAI value."},
#else
{31, 31, 0x0000000000000000, "RO", "MOT_BUF_WRITE_POL_31", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{30, 30, 0x0000000000000000, "RW", "MOT_BUF_WRITE_POL_30", "Bunit MOT Write Access Policy: Bit vector used to determine which agents are allowed write access to the MOT region based on the agents 6bit encoded SAI value."},
#else
{30, 30, 0x0000000000000000, "RW", "MOT_BUF_WRITE_POL_30", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{29, 29, 0x0000000000000000, "RW", "MOT_BUF_WRITE_POL_29", "Bunit MOT Write Access Policy: Bit vector used to determine which agents are allowed write access to the MOT region based on the agents 6bit encoded SAI value."},
#else
{29, 29, 0x0000000000000000, "RW", "MOT_BUF_WRITE_POL_29", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{28, 28, 0x0000000000000000, "RW", "MOT_BUF_WRITE_POL_28", "Bunit MOT Write Access Policy: Bit vector used to determine which agents are allowed write access to the MOT region based on the agents 6bit encoded SAI value."},
#else
{28, 28, 0x0000000000000000, "RW", "MOT_BUF_WRITE_POL_28", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{27, 27, 0x0000000000000000, "RW", "MOT_BUF_WRITE_POL_27", "Bunit MOT Write Access Policy: Bit vector used to determine which agents are allowed write access to the MOT region based on the agents 6bit encoded SAI value."},
#else
{27, 27, 0x0000000000000000, "RW", "MOT_BUF_WRITE_POL_27", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{26, 26, 0x0000000000000000, "RW", "MOT_BUF_WRITE_POL_26", "Bunit MOT Write Access Policy: Bit vector used to determine which agents are allowed write access to the MOT region based on the agents 6bit encoded SAI value."},
#else
{26, 26, 0x0000000000000000, "RW", "MOT_BUF_WRITE_POL_26", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{25, 25, 0x0000000000000000, "RW", "MOT_BUF_WRITE_POL_25", "Bunit MOT Write Access Policy: Bit vector used to determine which agents are allowed write access to the MOT region based on the agents 6bit encoded SAI value."},
#else
{25, 25, 0x0000000000000000, "RW", "MOT_BUF_WRITE_POL_25", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{24, 24, 0x0000000000000000, "RW", "MOT_BUF_WRITE_POL_24", "Bunit MOT Write Access Policy: Bit vector used to determine which agents are allowed write access to the MOT region based on the agents 6bit encoded SAI value."},
#else
{24, 24, 0x0000000000000000, "RW", "MOT_BUF_WRITE_POL_24", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{23, 23, 0x0000000000000000, "RO", "MOT_BUF_WRITE_POL_23", "Bunit MOT Write Access Policy: Bit vector used to determine which agents are allowed write access to the MOT region based on the agents 6bit encoded SAI value."},
#else
{23, 23, 0x0000000000000000, "RO", "MOT_BUF_WRITE_POL_23", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{22, 22, 0x0000000000000000, "RO", "MOT_BUF_WRITE_POL_22", "Bunit MOT Write Access Policy: Bit vector used to determine which agents are allowed write access to the MOT region based on the agents 6bit encoded SAI value."},
#else
{22, 22, 0x0000000000000000, "RO", "MOT_BUF_WRITE_POL_22", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{21, 21, 0x0000000000000000, "RW", "MOT_BUF_WRITE_POL_21", "Bunit MOT Write Access Policy: Bit vector used to determine which agents are allowed write access to the MOT region based on the agents 6bit encoded SAI value."},
#else
{21, 21, 0x0000000000000000, "RW", "MOT_BUF_WRITE_POL_21", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{20, 20, 0x0000000000000000, "RO", "MOT_BUF_WRITE_POL_20", "Bunit MOT Write Access Policy: Bit vector used to determine which agents are allowed write access to the MOT region based on the agents 6bit encoded SAI value."},
#else
{20, 20, 0x0000000000000000, "RO", "MOT_BUF_WRITE_POL_20", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{19, 19, 0x0000000000000000, "RO", "MOT_BUF_WRITE_POL_19", "Bunit MOT Write Access Policy: Bit vector used to determine which agents are allowed write access to the MOT region based on the agents 6bit encoded SAI value."},
#else
{19, 19, 0x0000000000000000, "RO", "MOT_BUF_WRITE_POL_19", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{18, 18, 0x0000000000000000, "RO", "MOT_BUF_WRITE_POL_18", "Bunit MOT Write Access Policy: Bit vector used to determine which agents are allowed write access to the MOT region based on the agents 6bit encoded SAI value."},
#else
{18, 18, 0x0000000000000000, "RO", "MOT_BUF_WRITE_POL_18", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{17, 17, 0x0000000000000000, "RW", "MOT_BUF_WRITE_POL_17", "Bunit MOT Write Access Policy: Bit vector used to determine which agents are allowed write access to the MOT region based on the agents 6bit encoded SAI value."},
#else
{17, 17, 0x0000000000000000, "RW", "MOT_BUF_WRITE_POL_17", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{16, 16, 0x0000000000000001, "RW", "MOT_BUF_WRITE_POL_16", "Bunit MOT Write Access Policy: Bit vector used to determine which agents are allowed write access to the MOT region based on the agents 6bit encoded SAI value."},
#else
{16, 16, 0x0000000000000001, "RW", "MOT_BUF_WRITE_POL_16", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{15, 15, 0x0000000000000000, "RO", "MOT_BUF_WRITE_POL_15", "Bunit MOT Write Access Policy: Bit vector used to determine which agents are allowed write access to the MOT region based on the agents 6bit encoded SAI value."},
#else
{15, 15, 0x0000000000000000, "RO", "MOT_BUF_WRITE_POL_15", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{14, 14, 0x0000000000000000, "RO", "MOT_BUF_WRITE_POL_14", "Bunit MOT Write Access Policy: Bit vector used to determine which agents are allowed write access to the MOT region based on the agents 6bit encoded SAI value."},
#else
{14, 14, 0x0000000000000000, "RO", "MOT_BUF_WRITE_POL_14", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{13, 13, 0x0000000000000000, "RW", "MOT_BUF_WRITE_POL_13", "Bunit MOT Write Access Policy: Bit vector used to determine which agents are allowed write access to the MOT region based on the agents 6bit encoded SAI value."},
#else
{13, 13, 0x0000000000000000, "RW", "MOT_BUF_WRITE_POL_13", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{12, 12, 0x0000000000000000, "RW", "MOT_BUF_WRITE_POL_12", "Bunit MOT Write Access Policy: Bit vector used to determine which agents are allowed write access to the MOT region based on the agents 6bit encoded SAI value."},
#else
{12, 12, 0x0000000000000000, "RW", "MOT_BUF_WRITE_POL_12", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{11, 11, 0x0000000000000000, "RO", "MOT_BUF_WRITE_POL_11", "Bunit MOT Write Access Policy: Bit vector used to determine which agents are allowed write access to the MOT region based on the agents 6bit encoded SAI value."},
#else
{11, 11, 0x0000000000000000, "RO", "MOT_BUF_WRITE_POL_11", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{10, 10, 0x0000000000000000, "RO", "MOT_BUF_WRITE_POL_10", "Bunit MOT Write Access Policy: Bit vector used to determine which agents are allowed write access to the MOT region based on the agents 6bit encoded SAI value."},
#else
{10, 10, 0x0000000000000000, "RO", "MOT_BUF_WRITE_POL_10", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{9, 9, 0x0000000000000000, "RO", "MOT_BUF_WRITE_POL_9", "Bunit MOT Write Access Policy: Bit vector used to determine which agents are allowed write access to the MOT region based on the agents 6bit encoded SAI value."},
#else
{9, 9, 0x0000000000000000, "RO", "MOT_BUF_WRITE_POL_9", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{8, 8, 0x0000000000000000, "RW", "MOT_BUF_WRITE_POL_8", "Bunit MOT Write Access Policy: Bit vector used to determine which agents are allowed write access to the MOT region based on the agents 6bit encoded SAI value."},
#else
{8, 8, 0x0000000000000000, "RW", "MOT_BUF_WRITE_POL_8", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{7, 7, 0x0000000000000000, "RO", "MOT_BUF_WRITE_POL_7", "Bunit MOT Write Access Policy: Bit vector used to determine which agents are allowed write access to the MOT region based on the agents 6bit encoded SAI value."},
#else
{7, 7, 0x0000000000000000, "RO", "MOT_BUF_WRITE_POL_7", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{6, 6, 0x0000000000000000, "RO", "MOT_BUF_WRITE_POL_6", "Bunit MOT Write Access Policy: Bit vector used to determine which agents are allowed write access to the MOT region based on the agents 6bit encoded SAI value."},
#else
{6, 6, 0x0000000000000000, "RO", "MOT_BUF_WRITE_POL_6", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{5, 5, 0x0000000000000000, "RW", "MOT_BUF_WRITE_POL_5", "Bunit MOT Write Access Policy: Bit vector used to determine which agents are allowed write access to the MOT region based on the agents 6bit encoded SAI value."},
#else
{5, 5, 0x0000000000000000, "RW", "MOT_BUF_WRITE_POL_5", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{4, 4, 0x0000000000000000, "RW", "MOT_BUF_WRITE_POL_4", "Bunit MOT Write Access Policy: Bit vector used to determine which agents are allowed write access to the MOT region based on the agents 6bit encoded SAI value."},
#else
{4, 4, 0x0000000000000000, "RW", "MOT_BUF_WRITE_POL_4", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{3, 3, 0x0000000000000000, "RW", "MOT_BUF_WRITE_POL_3", "Bunit MOT Write Access Policy: Bit vector used to determine which agents are allowed write access to the MOT region based on the agents 6bit encoded SAI value."},
#else
{3, 3, 0x0000000000000000, "RW", "MOT_BUF_WRITE_POL_3", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{2, 2, 0x0000000000000000, "RW", "MOT_BUF_WRITE_POL_2", "Bunit MOT Write Access Policy: Bit vector used to determine which agents are allowed write access to the MOT region based on the agents 6bit encoded SAI value."},
#else
{2, 2, 0x0000000000000000, "RW", "MOT_BUF_WRITE_POL_2", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{1, 1, 0x0000000000000000, "RW", "MOT_BUF_WRITE_POL_1", "Bunit MOT Write Access Policy: Bit vector used to determine which agents are allowed write access to the MOT region based on the agents 6bit encoded SAI value."},
#else
{1, 1, 0x0000000000000000, "RW", "MOT_BUF_WRITE_POL_1", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 0, 0x0000000000000000, "RW", "MOT_BUF_WRITE_POL_0", "Bunit MOT Write Access Policy: Bit vector used to determine which agents are allowed write access to the MOT region based on the agents 6bit encoded SAI value."},
#else
{0, 0, 0x0000000000000000, "RW", "MOT_BUF_WRITE_POL_0", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo981[] = {{"B_CR_BMOT_BUF_WAC_0_0_0_MCHBAR", "", 0x00006B08, 64, 0xFFFFFFFFFFFFFFFF, 0x0000000000010000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields982[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{0, 63, 0x00000C0061010202, "RW", "BM_CTRL_POL", "BM Control Policy: Bit vector used to determine which agents are allowed write access to BIMRGLOBAL_BM_WAC based on the agents 6bit encoded SAI value."},
#else
{0, 63, 0x00000C0061010202, "RW", "BM_CTRL_POL", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo982[] = {{"B_CR_BIMRGLOBAL_BM_CP_0_0_0_MCHBAR", "", 0x00006B10, 1, 0xFFFFFFFFFFFFFFFF, 0x00000C0061010202}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields983[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{0, 63, 0xFFFFFFFFFFFFFFFF, "RO", "BM_READ_POL", "BM Read Access Policy: Bit vector used to determine which agents are allowed read access to all IMRxBASE and IMRxMASK registers based on the agents 6bit encoded SAI value."},
#else
{0, 63, 0xFFFFFFFFFFFFFFFF, "RO", "BM_READ_POL", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo983[] = {{"B_CR_BIMRGLOBAL_BM_RAC_0_0_0_MCHBAR", "", 0x00006B18, 1, 0xFFFFFFFFFFFFFFFF, 0xFFFFFFFFFFFFFFFF}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields984[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{0, 63, 0x00000C0061010202, "RW", "BM_WRITE_POL", "BM Write Access Policy: Bit vector used to determine which agents are allowed write access to all IMRxBASE and IMRxMASK registers based on the agents 6bit encoded SAI value."},
#else
{0, 63, 0x00000C0061010202, "RW", "BM_WRITE_POL", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo984[] = {{"B_CR_BIMRGLOBAL_BM_WAC_0_0_0_MCHBAR", "", 0x00006B20, 1, 0xFFFFFFFFFFFFFFFF, 0x00000C0061010202}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields985[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{0, 63, 0x00000C0061010202, "RW", "GSM_CTRL_POL", "Bunit GSM Control Policy: Bit vector used to determine which agents are allowed access to the BGSMRAC BGSMWAC and BGSMCP registers based on the value from the agents 6bit SAI field."},
#else
{0, 63, 0x00000C0061010202, "RW", "GSM_CTRL_POL", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo985[] = {{"B_CR_BGSMCP_0_0_0_MCHBAR", "", 0x00006B28, 1, 0xFFFFFFFFFFFFFFFF, 0x00000C0061010202}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields986[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{63, 63, 0x0000000000000000, "RW", "GSM_SAI_POL_63", "Bunit SMM Read Access Policy: Bit vector used to determine which agents are allowed read access to the memory range from BGSM to TOLUD1 based on the agents 6bit encoded SAI value."},
#else
{63, 63, 0x0000000000000000, "RW", "GSM_SAI_POL_63", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{62, 62, 0x0000000000000000, "RO", "GSM_SAI_POL_62", "Bunit SMM Read Access Policy: Bit vector used to determine which agents are allowed read access to the memory range from BGSM to TOLUD1 based on the agents 6bit encoded SAI value."},
#else
{62, 62, 0x0000000000000000, "RO", "GSM_SAI_POL_62", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{61, 61, 0x0000000000000000, "RO", "GSM_SAI_POL_61", "Bunit SMM Read Access Policy: Bit vector used to determine which agents are allowed read access to the memory range from BGSM to TOLUD1 based on the agents 6bit encoded SAI value."},
#else
{61, 61, 0x0000000000000000, "RO", "GSM_SAI_POL_61", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{60, 60, 0x0000000000000000, "RO", "GSM_SAI_POL_60", "Bunit SMM Read Access Policy: Bit vector used to determine which agents are allowed read access to the memory range from BGSM to TOLUD1 based on the agents 6bit encoded SAI value."},
#else
{60, 60, 0x0000000000000000, "RO", "GSM_SAI_POL_60", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{59, 59, 0x0000000000000000, "RO", "GSM_SAI_POL_59", "Bunit SMM Read Access Policy: Bit vector used to determine which agents are allowed read access to the memory range from BGSM to TOLUD1 based on the agents 6bit encoded SAI value."},
#else
{59, 59, 0x0000000000000000, "RO", "GSM_SAI_POL_59", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{58, 58, 0x0000000000000000, "RO", "GSM_SAI_POL_58", "Bunit SMM Read Access Policy: Bit vector used to determine which agents are allowed read access to the memory range from BGSM to TOLUD1 based on the agents 6bit encoded SAI value."},
#else
{58, 58, 0x0000000000000000, "RO", "GSM_SAI_POL_58", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{57, 57, 0x0000000000000000, "RO", "GSM_SAI_POL_57", "Bunit SMM Read Access Policy: Bit vector used to determine which agents are allowed read access to the memory range from BGSM to TOLUD1 based on the agents 6bit encoded SAI value."},
#else
{57, 57, 0x0000000000000000, "RO", "GSM_SAI_POL_57", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{56, 56, 0x0000000000000000, "RW", "GSM_SAI_POL_56", "Bunit SMM Read Access Policy: Bit vector used to determine which agents are allowed read access to the memory range from BGSM to TOLUD1 based on the agents 6bit encoded SAI value."},
#else
{56, 56, 0x0000000000000000, "RW", "GSM_SAI_POL_56", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{55, 55, 0x0000000000000000, "RW", "GSM_SAI_POL_55", "Bunit SMM Read Access Policy: Bit vector used to determine which agents are allowed read access to the memory range from BGSM to TOLUD1 based on the agents 6bit encoded SAI value."},
#else
{55, 55, 0x0000000000000000, "RW", "GSM_SAI_POL_55", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{54, 54, 0x0000000000000000, "RW", "GSM_SAI_POL_54", "Bunit SMM Read Access Policy: Bit vector used to determine which agents are allowed read access to the memory range from BGSM to TOLUD1 based on the agents 6bit encoded SAI value."},
#else
{54, 54, 0x0000000000000000, "RW", "GSM_SAI_POL_54", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{53, 53, 0x0000000000000000, "RO", "GSM_SAI_POL_53", "Bunit SMM Read Access Policy: Bit vector used to determine which agents are allowed read access to the memory range from BGSM to TOLUD1 based on the agents 6bit encoded SAI value."},
#else
{53, 53, 0x0000000000000000, "RO", "GSM_SAI_POL_53", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{52, 52, 0x0000000000000000, "RO", "GSM_SAI_POL_52", "Bunit SMM Read Access Policy: Bit vector used to determine which agents are allowed read access to the memory range from BGSM to TOLUD1 based on the agents 6bit encoded SAI value."},
#else
{52, 52, 0x0000000000000000, "RO", "GSM_SAI_POL_52", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{51, 51, 0x0000000000000000, "RO", "GSM_SAI_POL_51", "Bunit SMM Read Access Policy: Bit vector used to determine which agents are allowed read access to the memory range from BGSM to TOLUD1 based on the agents 6bit encoded SAI value."},
#else
{51, 51, 0x0000000000000000, "RO", "GSM_SAI_POL_51", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{50, 50, 0x0000000000000000, "RW", "GSM_SAI_POL_50", "Bunit SMM Read Access Policy: Bit vector used to determine which agents are allowed read access to the memory range from BGSM to TOLUD1 based on the agents 6bit encoded SAI value."},
#else
{50, 50, 0x0000000000000000, "RW", "GSM_SAI_POL_50", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{49, 49, 0x0000000000000000, "RW", "GSM_SAI_POL_49", "Bunit SMM Read Access Policy: Bit vector used to determine which agents are allowed read access to the memory range from BGSM to TOLUD1 based on the agents 6bit encoded SAI value."},
#else
{49, 49, 0x0000000000000000, "RW", "GSM_SAI_POL_49", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{48, 48, 0x0000000000000000, "RW", "GSM_SAI_POL_48", "Bunit SMM Read Access Policy: Bit vector used to determine which agents are allowed read access to the memory range from BGSM to TOLUD1 based on the agents 6bit encoded SAI value."},
#else
{48, 48, 0x0000000000000000, "RW", "GSM_SAI_POL_48", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{47, 47, 0x0000000000000000, "RO", "GSM_SAI_POL_47", "Bunit SMM Read Access Policy: Bit vector used to determine which agents are allowed read access to the memory range from BGSM to TOLUD1 based on the agents 6bit encoded SAI value."},
#else
{47, 47, 0x0000000000000000, "RO", "GSM_SAI_POL_47", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{46, 46, 0x0000000000000000, "RO", "GSM_SAI_POL_46", "Bunit SMM Read Access Policy: Bit vector used to determine which agents are allowed read access to the memory range from BGSM to TOLUD1 based on the agents 6bit encoded SAI value."},
#else
{46, 46, 0x0000000000000000, "RO", "GSM_SAI_POL_46", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{45, 45, 0x0000000000000000, "RO", "GSM_SAI_POL_45", "Bunit SMM Read Access Policy: Bit vector used to determine which agents are allowed read access to the memory range from BGSM to TOLUD1 based on the agents 6bit encoded SAI value."},
#else
{45, 45, 0x0000000000000000, "RO", "GSM_SAI_POL_45", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{44, 44, 0x0000000000000001, "RW", "GSM_SAI_POL_44", "Bunit SMM Read Access Policy: Bit vector used to determine which agents are allowed read access to the memory range from BGSM to TOLUD1 based on the agents 6bit encoded SAI value."},
#else
{44, 44, 0x0000000000000001, "RW", "GSM_SAI_POL_44", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{43, 43, 0x0000000000000000, "RW", "GSM_SAI_POL_43", "Bunit SMM Read Access Policy: Bit vector used to determine which agents are allowed read access to the memory range from BGSM to TOLUD1 based on the agents 6bit encoded SAI value."},
#else
{43, 43, 0x0000000000000000, "RW", "GSM_SAI_POL_43", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{42, 42, 0x0000000000000000, "RW", "GSM_SAI_POL_42", "Bunit SMM Read Access Policy: Bit vector used to determine which agents are allowed read access to the memory range from BGSM to TOLUD1 based on the agents 6bit encoded SAI value."},
#else
{42, 42, 0x0000000000000000, "RW", "GSM_SAI_POL_42", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{41, 41, 0x0000000000000000, "RW", "GSM_SAI_POL_41", "Bunit SMM Read Access Policy: Bit vector used to determine which agents are allowed read access to the memory range from BGSM to TOLUD1 based on the agents 6bit encoded SAI value."},
#else
{41, 41, 0x0000000000000000, "RW", "GSM_SAI_POL_41", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{40, 40, 0x0000000000000000, "RW", "GSM_SAI_POL_40", "Bunit SMM Read Access Policy: Bit vector used to determine which agents are allowed read access to the memory range from BGSM to TOLUD1 based on the agents 6bit encoded SAI value."},
#else
{40, 40, 0x0000000000000000, "RW", "GSM_SAI_POL_40", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{39, 39, 0x0000000000000000, "RO", "GSM_SAI_POL_39", "Bunit SMM Read Access Policy: Bit vector used to determine which agents are allowed read access to the memory range from BGSM to TOLUD1 based on the agents 6bit encoded SAI value."},
#else
{39, 39, 0x0000000000000000, "RO", "GSM_SAI_POL_39", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{38, 38, 0x0000000000000000, "RW", "GSM_SAI_POL_38", "Bunit SMM Read Access Policy: Bit vector used to determine which agents are allowed read access to the memory range from BGSM to TOLUD1 based on the agents 6bit encoded SAI value."},
#else
{38, 38, 0x0000000000000000, "RW", "GSM_SAI_POL_38", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{37, 37, 0x0000000000000000, "RO", "GSM_SAI_POL_37", "Bunit SMM Read Access Policy: Bit vector used to determine which agents are allowed read access to the memory range from BGSM to TOLUD1 based on the agents 6bit encoded SAI value."},
#else
{37, 37, 0x0000000000000000, "RO", "GSM_SAI_POL_37", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{36, 36, 0x0000000000000000, "RW", "GSM_SAI_POL_36", "Bunit SMM Read Access Policy: Bit vector used to determine which agents are allowed read access to the memory range from BGSM to TOLUD1 based on the agents 6bit encoded SAI value."},
#else
{36, 36, 0x0000000000000000, "RW", "GSM_SAI_POL_36", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{35, 35, 0x0000000000000000, "RO", "GSM_SAI_POL_35", "Bunit SMM Read Access Policy: Bit vector used to determine which agents are allowed read access to the memory range from BGSM to TOLUD1 based on the agents 6bit encoded SAI value."},
#else
{35, 35, 0x0000000000000000, "RO", "GSM_SAI_POL_35", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{34, 34, 0x0000000000000000, "RW", "GSM_SAI_POL_34", "Bunit SMM Read Access Policy: Bit vector used to determine which agents are allowed read access to the memory range from BGSM to TOLUD1 based on the agents 6bit encoded SAI value."},
#else
{34, 34, 0x0000000000000000, "RW", "GSM_SAI_POL_34", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{33, 33, 0x0000000000000000, "RW", "GSM_SAI_POL_33", "Bunit SMM Read Access Policy: Bit vector used to determine which agents are allowed read access to the memory range from BGSM to TOLUD1 based on the agents 6bit encoded SAI value."},
#else
{33, 33, 0x0000000000000000, "RW", "GSM_SAI_POL_33", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{32, 32, 0x0000000000000000, "RW", "GSM_SAI_POL_32", "Bunit SMM Read Access Policy: Bit vector used to determine which agents are allowed read access to the memory range from BGSM to TOLUD1 based on the agents 6bit encoded SAI value."},
#else
{32, 32, 0x0000000000000000, "RW", "GSM_SAI_POL_32", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{31, 31, 0x0000000000000000, "RO", "GSM_SAI_POL_31", "Bunit SMM Read Access Policy: Bit vector used to determine which agents are allowed read access to the memory range from BGSM to TOLUD1 based on the agents 6bit encoded SAI value."},
#else
{31, 31, 0x0000000000000000, "RO", "GSM_SAI_POL_31", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{30, 30, 0x0000000000000000, "RW", "GSM_SAI_POL_30", "Bunit SMM Read Access Policy: Bit vector used to determine which agents are allowed read access to the memory range from BGSM to TOLUD1 based on the agents 6bit encoded SAI value."},
#else
{30, 30, 0x0000000000000000, "RW", "GSM_SAI_POL_30", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{29, 29, 0x0000000000000000, "RW", "GSM_SAI_POL_29", "Bunit SMM Read Access Policy: Bit vector used to determine which agents are allowed read access to the memory range from BGSM to TOLUD1 based on the agents 6bit encoded SAI value."},
#else
{29, 29, 0x0000000000000000, "RW", "GSM_SAI_POL_29", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{28, 28, 0x0000000000000000, "RW", "GSM_SAI_POL_28", "Bunit SMM Read Access Policy: Bit vector used to determine which agents are allowed read access to the memory range from BGSM to TOLUD1 based on the agents 6bit encoded SAI value."},
#else
{28, 28, 0x0000000000000000, "RW", "GSM_SAI_POL_28", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{27, 27, 0x0000000000000000, "RW", "GSM_SAI_POL_27", "Bunit SMM Read Access Policy: Bit vector used to determine which agents are allowed read access to the memory range from BGSM to TOLUD1 based on the agents 6bit encoded SAI value."},
#else
{27, 27, 0x0000000000000000, "RW", "GSM_SAI_POL_27", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{26, 26, 0x0000000000000000, "RW", "GSM_SAI_POL_26", "Bunit SMM Read Access Policy: Bit vector used to determine which agents are allowed read access to the memory range from BGSM to TOLUD1 based on the agents 6bit encoded SAI value."},
#else
{26, 26, 0x0000000000000000, "RW", "GSM_SAI_POL_26", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{25, 25, 0x0000000000000000, "RW", "GSM_SAI_POL_25", "Bunit SMM Read Access Policy: Bit vector used to determine which agents are allowed read access to the memory range from BGSM to TOLUD1 based on the agents 6bit encoded SAI value."},
#else
{25, 25, 0x0000000000000000, "RW", "GSM_SAI_POL_25", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{24, 24, 0x0000000000000000, "RW", "GSM_SAI_POL_24", "Bunit SMM Read Access Policy: Bit vector used to determine which agents are allowed read access to the memory range from BGSM to TOLUD1 based on the agents 6bit encoded SAI value."},
#else
{24, 24, 0x0000000000000000, "RW", "GSM_SAI_POL_24", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{23, 23, 0x0000000000000000, "RO", "GSM_SAI_POL_23", "Bunit SMM Read Access Policy: Bit vector used to determine which agents are allowed read access to the memory range from BGSM to TOLUD1 based on the agents 6bit encoded SAI value."},
#else
{23, 23, 0x0000000000000000, "RO", "GSM_SAI_POL_23", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{22, 22, 0x0000000000000000, "RO", "GSM_SAI_POL_22", "Bunit SMM Read Access Policy: Bit vector used to determine which agents are allowed read access to the memory range from BGSM to TOLUD1 based on the agents 6bit encoded SAI value."},
#else
{22, 22, 0x0000000000000000, "RO", "GSM_SAI_POL_22", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{21, 21, 0x0000000000000000, "RW", "GSM_SAI_POL_21", "Bunit SMM Read Access Policy: Bit vector used to determine which agents are allowed read access to the memory range from BGSM to TOLUD1 based on the agents 6bit encoded SAI value."},
#else
{21, 21, 0x0000000000000000, "RW", "GSM_SAI_POL_21", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{20, 20, 0x0000000000000000, "RO", "GSM_SAI_POL_20", "Bunit SMM Read Access Policy: Bit vector used to determine which agents are allowed read access to the memory range from BGSM to TOLUD1 based on the agents 6bit encoded SAI value."},
#else
{20, 20, 0x0000000000000000, "RO", "GSM_SAI_POL_20", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{19, 19, 0x0000000000000000, "RO", "GSM_SAI_POL_19", "Bunit SMM Read Access Policy: Bit vector used to determine which agents are allowed read access to the memory range from BGSM to TOLUD1 based on the agents 6bit encoded SAI value."},
#else
{19, 19, 0x0000000000000000, "RO", "GSM_SAI_POL_19", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{18, 18, 0x0000000000000000, "RO", "GSM_SAI_POL_18", "Bunit SMM Read Access Policy: Bit vector used to determine which agents are allowed read access to the memory range from BGSM to TOLUD1 based on the agents 6bit encoded SAI value."},
#else
{18, 18, 0x0000000000000000, "RO", "GSM_SAI_POL_18", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{17, 17, 0x0000000000000000, "RW", "GSM_SAI_POL_17", "Bunit SMM Read Access Policy: Bit vector used to determine which agents are allowed read access to the memory range from BGSM to TOLUD1 based on the agents 6bit encoded SAI value."},
#else
{17, 17, 0x0000000000000000, "RW", "GSM_SAI_POL_17", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{16, 16, 0x0000000000000001, "RW", "GSM_SAI_POL_16", "Bunit SMM Read Access Policy: Bit vector used to determine which agents are allowed read access to the memory range from BGSM to TOLUD1 based on the agents 6bit encoded SAI value."},
#else
{16, 16, 0x0000000000000001, "RW", "GSM_SAI_POL_16", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{15, 15, 0x0000000000000000, "RO", "GSM_SAI_POL_15", "Bunit SMM Read Access Policy: Bit vector used to determine which agents are allowed read access to the memory range from BGSM to TOLUD1 based on the agents 6bit encoded SAI value."},
#else
{15, 15, 0x0000000000000000, "RO", "GSM_SAI_POL_15", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{14, 14, 0x0000000000000000, "RO", "GSM_SAI_POL_14", "Bunit SMM Read Access Policy: Bit vector used to determine which agents are allowed read access to the memory range from BGSM to TOLUD1 based on the agents 6bit encoded SAI value."},
#else
{14, 14, 0x0000000000000000, "RO", "GSM_SAI_POL_14", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{13, 13, 0x0000000000000000, "RW", "GSM_SAI_POL_13", "Bunit SMM Read Access Policy: Bit vector used to determine which agents are allowed read access to the memory range from BGSM to TOLUD1 based on the agents 6bit encoded SAI value."},
#else
{13, 13, 0x0000000000000000, "RW", "GSM_SAI_POL_13", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{12, 12, 0x0000000000000000, "RW", "GSM_SAI_POL_12", "Bunit SMM Read Access Policy: Bit vector used to determine which agents are allowed read access to the memory range from BGSM to TOLUD1 based on the agents 6bit encoded SAI value."},
#else
{12, 12, 0x0000000000000000, "RW", "GSM_SAI_POL_12", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{11, 11, 0x0000000000000000, "RO", "GSM_SAI_POL_11", "Bunit SMM Read Access Policy: Bit vector used to determine which agents are allowed read access to the memory range from BGSM to TOLUD1 based on the agents 6bit encoded SAI value."},
#else
{11, 11, 0x0000000000000000, "RO", "GSM_SAI_POL_11", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{10, 10, 0x0000000000000000, "RO", "GSM_SAI_POL_10", "Bunit SMM Read Access Policy: Bit vector used to determine which agents are allowed read access to the memory range from BGSM to TOLUD1 based on the agents 6bit encoded SAI value."},
#else
{10, 10, 0x0000000000000000, "RO", "GSM_SAI_POL_10", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{9, 9, 0x0000000000000000, "RO", "GSM_SAI_POL_9", "Bunit SMM Read Access Policy: Bit vector used to determine which agents are allowed read access to the memory range from BGSM to TOLUD1 based on the agents 6bit encoded SAI value."},
#else
{9, 9, 0x0000000000000000, "RO", "GSM_SAI_POL_9", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{8, 8, 0x0000000000000001, "RW", "GSM_SAI_POL_8", "Bunit SMM Read Access Policy: Bit vector used to determine which agents are allowed read access to the memory range from BGSM to TOLUD1 based on the agents 6bit encoded SAI value."},
#else
{8, 8, 0x0000000000000001, "RW", "GSM_SAI_POL_8", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{7, 7, 0x0000000000000000, "RO", "GSM_SAI_POL_7", "Bunit SMM Read Access Policy: Bit vector used to determine which agents are allowed read access to the memory range from BGSM to TOLUD1 based on the agents 6bit encoded SAI value."},
#else
{7, 7, 0x0000000000000000, "RO", "GSM_SAI_POL_7", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{6, 6, 0x0000000000000000, "RO", "GSM_SAI_POL_6", "Bunit SMM Read Access Policy: Bit vector used to determine which agents are allowed read access to the memory range from BGSM to TOLUD1 based on the agents 6bit encoded SAI value."},
#else
{6, 6, 0x0000000000000000, "RO", "GSM_SAI_POL_6", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{5, 5, 0x0000000000000000, "RW", "GSM_SAI_POL_5", "Bunit SMM Read Access Policy: Bit vector used to determine which agents are allowed read access to the memory range from BGSM to TOLUD1 based on the agents 6bit encoded SAI value."},
#else
{5, 5, 0x0000000000000000, "RW", "GSM_SAI_POL_5", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{4, 4, 0x0000000000000000, "RW", "GSM_SAI_POL_4", "Bunit SMM Read Access Policy: Bit vector used to determine which agents are allowed read access to the memory range from BGSM to TOLUD1 based on the agents 6bit encoded SAI value."},
#else
{4, 4, 0x0000000000000000, "RW", "GSM_SAI_POL_4", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{3, 3, 0x0000000000000000, "RW", "GSM_SAI_POL_3", "Bunit SMM Read Access Policy: Bit vector used to determine which agents are allowed read access to the memory range from BGSM to TOLUD1 based on the agents 6bit encoded SAI value."},
#else
{3, 3, 0x0000000000000000, "RW", "GSM_SAI_POL_3", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{2, 2, 0x0000000000000000, "RW", "GSM_SAI_POL_2", "Bunit SMM Read Access Policy: Bit vector used to determine which agents are allowed read access to the memory range from BGSM to TOLUD1 based on the agents 6bit encoded SAI value."},
#else
{2, 2, 0x0000000000000000, "RW", "GSM_SAI_POL_2", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{1, 1, 0x0000000000000000, "RW", "GSM_SAI_POL_1", "Bunit SMM Read Access Policy: Bit vector used to determine which agents are allowed read access to the memory range from BGSM to TOLUD1 based on the agents 6bit encoded SAI value."},
#else
{1, 1, 0x0000000000000000, "RW", "GSM_SAI_POL_1", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 0, 0x0000000000000000, "RW", "GSM_SAI_POL_0", "Bunit SMM Read Access Policy: Bit vector used to determine which agents are allowed read access to the memory range from BGSM to TOLUD1 based on the agents 6bit encoded SAI value."},
#else
{0, 0, 0x0000000000000000, "RW", "GSM_SAI_POL_0", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo986[] = {{"B_CR_BGSMRAC_0_0_0_MCHBAR", "", 0x00006B30, 64, 0xFFFFFFFFFFFFFFFF, 0x0000100000010100}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields987[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{63, 63, 0x0000000000000000, "RW", "GSM_SAI_POL_63", "Bunit GSM Write Access Policy: Bit vector used to determine which agents are allowed write access to the memory range from BGSM to TOLUD1 based on the agents 6bit encoded SAI value."},
#else
{63, 63, 0x0000000000000000, "RW", "GSM_SAI_POL_63", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{62, 62, 0x0000000000000000, "RO", "GSM_SAI_POL_62", "Bunit GSM Write Access Policy: Bit vector used to determine which agents are allowed write access to the memory range from BGSM to TOLUD1 based on the agents 6bit encoded SAI value."},
#else
{62, 62, 0x0000000000000000, "RO", "GSM_SAI_POL_62", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{61, 61, 0x0000000000000000, "RO", "GSM_SAI_POL_61", "Bunit GSM Write Access Policy: Bit vector used to determine which agents are allowed write access to the memory range from BGSM to TOLUD1 based on the agents 6bit encoded SAI value."},
#else
{61, 61, 0x0000000000000000, "RO", "GSM_SAI_POL_61", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{60, 60, 0x0000000000000000, "RO", "GSM_SAI_POL_60", "Bunit GSM Write Access Policy: Bit vector used to determine which agents are allowed write access to the memory range from BGSM to TOLUD1 based on the agents 6bit encoded SAI value."},
#else
{60, 60, 0x0000000000000000, "RO", "GSM_SAI_POL_60", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{59, 59, 0x0000000000000000, "RO", "GSM_SAI_POL_59", "Bunit GSM Write Access Policy: Bit vector used to determine which agents are allowed write access to the memory range from BGSM to TOLUD1 based on the agents 6bit encoded SAI value."},
#else
{59, 59, 0x0000000000000000, "RO", "GSM_SAI_POL_59", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{58, 58, 0x0000000000000000, "RO", "GSM_SAI_POL_58", "Bunit GSM Write Access Policy: Bit vector used to determine which agents are allowed write access to the memory range from BGSM to TOLUD1 based on the agents 6bit encoded SAI value."},
#else
{58, 58, 0x0000000000000000, "RO", "GSM_SAI_POL_58", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{57, 57, 0x0000000000000000, "RO", "GSM_SAI_POL_57", "Bunit GSM Write Access Policy: Bit vector used to determine which agents are allowed write access to the memory range from BGSM to TOLUD1 based on the agents 6bit encoded SAI value."},
#else
{57, 57, 0x0000000000000000, "RO", "GSM_SAI_POL_57", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{56, 56, 0x0000000000000000, "RW", "GSM_SAI_POL_56", "Bunit GSM Write Access Policy: Bit vector used to determine which agents are allowed write access to the memory range from BGSM to TOLUD1 based on the agents 6bit encoded SAI value."},
#else
{56, 56, 0x0000000000000000, "RW", "GSM_SAI_POL_56", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{55, 55, 0x0000000000000000, "RW", "GSM_SAI_POL_55", "Bunit GSM Write Access Policy: Bit vector used to determine which agents are allowed write access to the memory range from BGSM to TOLUD1 based on the agents 6bit encoded SAI value."},
#else
{55, 55, 0x0000000000000000, "RW", "GSM_SAI_POL_55", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{54, 54, 0x0000000000000000, "RW", "GSM_SAI_POL_54", "Bunit GSM Write Access Policy: Bit vector used to determine which agents are allowed write access to the memory range from BGSM to TOLUD1 based on the agents 6bit encoded SAI value."},
#else
{54, 54, 0x0000000000000000, "RW", "GSM_SAI_POL_54", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{53, 53, 0x0000000000000000, "RO", "GSM_SAI_POL_53", "Bunit GSM Write Access Policy: Bit vector used to determine which agents are allowed write access to the memory range from BGSM to TOLUD1 based on the agents 6bit encoded SAI value."},
#else
{53, 53, 0x0000000000000000, "RO", "GSM_SAI_POL_53", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{52, 52, 0x0000000000000000, "RO", "GSM_SAI_POL_52", "Bunit GSM Write Access Policy: Bit vector used to determine which agents are allowed write access to the memory range from BGSM to TOLUD1 based on the agents 6bit encoded SAI value."},
#else
{52, 52, 0x0000000000000000, "RO", "GSM_SAI_POL_52", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{51, 51, 0x0000000000000000, "RO", "GSM_SAI_POL_51", "Bunit GSM Write Access Policy: Bit vector used to determine which agents are allowed write access to the memory range from BGSM to TOLUD1 based on the agents 6bit encoded SAI value."},
#else
{51, 51, 0x0000000000000000, "RO", "GSM_SAI_POL_51", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{50, 50, 0x0000000000000000, "RW", "GSM_SAI_POL_50", "Bunit GSM Write Access Policy: Bit vector used to determine which agents are allowed write access to the memory range from BGSM to TOLUD1 based on the agents 6bit encoded SAI value."},
#else
{50, 50, 0x0000000000000000, "RW", "GSM_SAI_POL_50", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{49, 49, 0x0000000000000000, "RW", "GSM_SAI_POL_49", "Bunit GSM Write Access Policy: Bit vector used to determine which agents are allowed write access to the memory range from BGSM to TOLUD1 based on the agents 6bit encoded SAI value."},
#else
{49, 49, 0x0000000000000000, "RW", "GSM_SAI_POL_49", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{48, 48, 0x0000000000000000, "RW", "GSM_SAI_POL_48", "Bunit GSM Write Access Policy: Bit vector used to determine which agents are allowed write access to the memory range from BGSM to TOLUD1 based on the agents 6bit encoded SAI value."},
#else
{48, 48, 0x0000000000000000, "RW", "GSM_SAI_POL_48", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{47, 47, 0x0000000000000000, "RO", "GSM_SAI_POL_47", "Bunit GSM Write Access Policy: Bit vector used to determine which agents are allowed write access to the memory range from BGSM to TOLUD1 based on the agents 6bit encoded SAI value."},
#else
{47, 47, 0x0000000000000000, "RO", "GSM_SAI_POL_47", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{46, 46, 0x0000000000000000, "RO", "GSM_SAI_POL_46", "Bunit GSM Write Access Policy: Bit vector used to determine which agents are allowed write access to the memory range from BGSM to TOLUD1 based on the agents 6bit encoded SAI value."},
#else
{46, 46, 0x0000000000000000, "RO", "GSM_SAI_POL_46", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{45, 45, 0x0000000000000000, "RO", "GSM_SAI_POL_45", "Bunit GSM Write Access Policy: Bit vector used to determine which agents are allowed write access to the memory range from BGSM to TOLUD1 based on the agents 6bit encoded SAI value."},
#else
{45, 45, 0x0000000000000000, "RO", "GSM_SAI_POL_45", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{44, 44, 0x0000000000000001, "RW", "GSM_SAI_POL_44", "Bunit GSM Write Access Policy: Bit vector used to determine which agents are allowed write access to the memory range from BGSM to TOLUD1 based on the agents 6bit encoded SAI value."},
#else
{44, 44, 0x0000000000000001, "RW", "GSM_SAI_POL_44", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{43, 43, 0x0000000000000000, "RW", "GSM_SAI_POL_43", "Bunit GSM Write Access Policy: Bit vector used to determine which agents are allowed write access to the memory range from BGSM to TOLUD1 based on the agents 6bit encoded SAI value."},
#else
{43, 43, 0x0000000000000000, "RW", "GSM_SAI_POL_43", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{42, 42, 0x0000000000000000, "RW", "GSM_SAI_POL_42", "Bunit GSM Write Access Policy: Bit vector used to determine which agents are allowed write access to the memory range from BGSM to TOLUD1 based on the agents 6bit encoded SAI value."},
#else
{42, 42, 0x0000000000000000, "RW", "GSM_SAI_POL_42", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{41, 41, 0x0000000000000000, "RW", "GSM_SAI_POL_41", "Bunit GSM Write Access Policy: Bit vector used to determine which agents are allowed write access to the memory range from BGSM to TOLUD1 based on the agents 6bit encoded SAI value."},
#else
{41, 41, 0x0000000000000000, "RW", "GSM_SAI_POL_41", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{40, 40, 0x0000000000000000, "RW", "GSM_SAI_POL_40", "Bunit GSM Write Access Policy: Bit vector used to determine which agents are allowed write access to the memory range from BGSM to TOLUD1 based on the agents 6bit encoded SAI value."},
#else
{40, 40, 0x0000000000000000, "RW", "GSM_SAI_POL_40", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{39, 39, 0x0000000000000000, "RO", "GSM_SAI_POL_39", "Bunit GSM Write Access Policy: Bit vector used to determine which agents are allowed write access to the memory range from BGSM to TOLUD1 based on the agents 6bit encoded SAI value."},
#else
{39, 39, 0x0000000000000000, "RO", "GSM_SAI_POL_39", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{38, 38, 0x0000000000000000, "RW", "GSM_SAI_POL_38", "Bunit GSM Write Access Policy: Bit vector used to determine which agents are allowed write access to the memory range from BGSM to TOLUD1 based on the agents 6bit encoded SAI value."},
#else
{38, 38, 0x0000000000000000, "RW", "GSM_SAI_POL_38", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{37, 37, 0x0000000000000000, "RO", "GSM_SAI_POL_37", "Bunit GSM Write Access Policy: Bit vector used to determine which agents are allowed write access to the memory range from BGSM to TOLUD1 based on the agents 6bit encoded SAI value."},
#else
{37, 37, 0x0000000000000000, "RO", "GSM_SAI_POL_37", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{36, 36, 0x0000000000000000, "RW", "GSM_SAI_POL_36", "Bunit GSM Write Access Policy: Bit vector used to determine which agents are allowed write access to the memory range from BGSM to TOLUD1 based on the agents 6bit encoded SAI value."},
#else
{36, 36, 0x0000000000000000, "RW", "GSM_SAI_POL_36", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{35, 35, 0x0000000000000000, "RO", "GSM_SAI_POL_35", "Bunit GSM Write Access Policy: Bit vector used to determine which agents are allowed write access to the memory range from BGSM to TOLUD1 based on the agents 6bit encoded SAI value."},
#else
{35, 35, 0x0000000000000000, "RO", "GSM_SAI_POL_35", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{34, 34, 0x0000000000000000, "RW", "GSM_SAI_POL_34", "Bunit GSM Write Access Policy: Bit vector used to determine which agents are allowed write access to the memory range from BGSM to TOLUD1 based on the agents 6bit encoded SAI value."},
#else
{34, 34, 0x0000000000000000, "RW", "GSM_SAI_POL_34", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{33, 33, 0x0000000000000000, "RW", "GSM_SAI_POL_33", "Bunit GSM Write Access Policy: Bit vector used to determine which agents are allowed write access to the memory range from BGSM to TOLUD1 based on the agents 6bit encoded SAI value."},
#else
{33, 33, 0x0000000000000000, "RW", "GSM_SAI_POL_33", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{32, 32, 0x0000000000000000, "RW", "GSM_SAI_POL_32", "Bunit GSM Write Access Policy: Bit vector used to determine which agents are allowed write access to the memory range from BGSM to TOLUD1 based on the agents 6bit encoded SAI value."},
#else
{32, 32, 0x0000000000000000, "RW", "GSM_SAI_POL_32", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{31, 31, 0x0000000000000000, "RO", "GSM_SAI_POL_31", "Bunit GSM Write Access Policy: Bit vector used to determine which agents are allowed write access to the memory range from BGSM to TOLUD1 based on the agents 6bit encoded SAI value."},
#else
{31, 31, 0x0000000000000000, "RO", "GSM_SAI_POL_31", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{30, 30, 0x0000000000000000, "RW", "GSM_SAI_POL_30", "Bunit GSM Write Access Policy: Bit vector used to determine which agents are allowed write access to the memory range from BGSM to TOLUD1 based on the agents 6bit encoded SAI value."},
#else
{30, 30, 0x0000000000000000, "RW", "GSM_SAI_POL_30", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{29, 29, 0x0000000000000000, "RW", "GSM_SAI_POL_29", "Bunit GSM Write Access Policy: Bit vector used to determine which agents are allowed write access to the memory range from BGSM to TOLUD1 based on the agents 6bit encoded SAI value."},
#else
{29, 29, 0x0000000000000000, "RW", "GSM_SAI_POL_29", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{28, 28, 0x0000000000000000, "RW", "GSM_SAI_POL_28", "Bunit GSM Write Access Policy: Bit vector used to determine which agents are allowed write access to the memory range from BGSM to TOLUD1 based on the agents 6bit encoded SAI value."},
#else
{28, 28, 0x0000000000000000, "RW", "GSM_SAI_POL_28", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{27, 27, 0x0000000000000000, "RW", "GSM_SAI_POL_27", "Bunit GSM Write Access Policy: Bit vector used to determine which agents are allowed write access to the memory range from BGSM to TOLUD1 based on the agents 6bit encoded SAI value."},
#else
{27, 27, 0x0000000000000000, "RW", "GSM_SAI_POL_27", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{26, 26, 0x0000000000000000, "RW", "GSM_SAI_POL_26", "Bunit GSM Write Access Policy: Bit vector used to determine which agents are allowed write access to the memory range from BGSM to TOLUD1 based on the agents 6bit encoded SAI value."},
#else
{26, 26, 0x0000000000000000, "RW", "GSM_SAI_POL_26", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{25, 25, 0x0000000000000000, "RW", "GSM_SAI_POL_25", "Bunit GSM Write Access Policy: Bit vector used to determine which agents are allowed write access to the memory range from BGSM to TOLUD1 based on the agents 6bit encoded SAI value."},
#else
{25, 25, 0x0000000000000000, "RW", "GSM_SAI_POL_25", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{24, 24, 0x0000000000000000, "RW", "GSM_SAI_POL_24", "Bunit GSM Write Access Policy: Bit vector used to determine which agents are allowed write access to the memory range from BGSM to TOLUD1 based on the agents 6bit encoded SAI value."},
#else
{24, 24, 0x0000000000000000, "RW", "GSM_SAI_POL_24", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{23, 23, 0x0000000000000000, "RO", "GSM_SAI_POL_23", "Bunit GSM Write Access Policy: Bit vector used to determine which agents are allowed write access to the memory range from BGSM to TOLUD1 based on the agents 6bit encoded SAI value."},
#else
{23, 23, 0x0000000000000000, "RO", "GSM_SAI_POL_23", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{22, 22, 0x0000000000000000, "RO", "GSM_SAI_POL_22", "Bunit GSM Write Access Policy: Bit vector used to determine which agents are allowed write access to the memory range from BGSM to TOLUD1 based on the agents 6bit encoded SAI value."},
#else
{22, 22, 0x0000000000000000, "RO", "GSM_SAI_POL_22", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{21, 21, 0x0000000000000000, "RW", "GSM_SAI_POL_21", "Bunit GSM Write Access Policy: Bit vector used to determine which agents are allowed write access to the memory range from BGSM to TOLUD1 based on the agents 6bit encoded SAI value."},
#else
{21, 21, 0x0000000000000000, "RW", "GSM_SAI_POL_21", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{20, 20, 0x0000000000000000, "RO", "GSM_SAI_POL_20", "Bunit GSM Write Access Policy: Bit vector used to determine which agents are allowed write access to the memory range from BGSM to TOLUD1 based on the agents 6bit encoded SAI value."},
#else
{20, 20, 0x0000000000000000, "RO", "GSM_SAI_POL_20", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{19, 19, 0x0000000000000000, "RO", "GSM_SAI_POL_19", "Bunit GSM Write Access Policy: Bit vector used to determine which agents are allowed write access to the memory range from BGSM to TOLUD1 based on the agents 6bit encoded SAI value."},
#else
{19, 19, 0x0000000000000000, "RO", "GSM_SAI_POL_19", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{18, 18, 0x0000000000000000, "RO", "GSM_SAI_POL_18", "Bunit GSM Write Access Policy: Bit vector used to determine which agents are allowed write access to the memory range from BGSM to TOLUD1 based on the agents 6bit encoded SAI value."},
#else
{18, 18, 0x0000000000000000, "RO", "GSM_SAI_POL_18", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{17, 17, 0x0000000000000000, "RW", "GSM_SAI_POL_17", "Bunit GSM Write Access Policy: Bit vector used to determine which agents are allowed write access to the memory range from BGSM to TOLUD1 based on the agents 6bit encoded SAI value."},
#else
{17, 17, 0x0000000000000000, "RW", "GSM_SAI_POL_17", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{16, 16, 0x0000000000000001, "RW", "GSM_SAI_POL_16", "Bunit GSM Write Access Policy: Bit vector used to determine which agents are allowed write access to the memory range from BGSM to TOLUD1 based on the agents 6bit encoded SAI value."},
#else
{16, 16, 0x0000000000000001, "RW", "GSM_SAI_POL_16", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{15, 15, 0x0000000000000000, "RO", "GSM_SAI_POL_15", "Bunit GSM Write Access Policy: Bit vector used to determine which agents are allowed write access to the memory range from BGSM to TOLUD1 based on the agents 6bit encoded SAI value."},
#else
{15, 15, 0x0000000000000000, "RO", "GSM_SAI_POL_15", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{14, 14, 0x0000000000000000, "RO", "GSM_SAI_POL_14", "Bunit GSM Write Access Policy: Bit vector used to determine which agents are allowed write access to the memory range from BGSM to TOLUD1 based on the agents 6bit encoded SAI value."},
#else
{14, 14, 0x0000000000000000, "RO", "GSM_SAI_POL_14", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{13, 13, 0x0000000000000000, "RW", "GSM_SAI_POL_13", "Bunit GSM Write Access Policy: Bit vector used to determine which agents are allowed write access to the memory range from BGSM to TOLUD1 based on the agents 6bit encoded SAI value."},
#else
{13, 13, 0x0000000000000000, "RW", "GSM_SAI_POL_13", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{12, 12, 0x0000000000000000, "RW", "GSM_SAI_POL_12", "Bunit GSM Write Access Policy: Bit vector used to determine which agents are allowed write access to the memory range from BGSM to TOLUD1 based on the agents 6bit encoded SAI value."},
#else
{12, 12, 0x0000000000000000, "RW", "GSM_SAI_POL_12", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{11, 11, 0x0000000000000000, "RO", "GSM_SAI_POL_11", "Bunit GSM Write Access Policy: Bit vector used to determine which agents are allowed write access to the memory range from BGSM to TOLUD1 based on the agents 6bit encoded SAI value."},
#else
{11, 11, 0x0000000000000000, "RO", "GSM_SAI_POL_11", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{10, 10, 0x0000000000000000, "RO", "GSM_SAI_POL_10", "Bunit GSM Write Access Policy: Bit vector used to determine which agents are allowed write access to the memory range from BGSM to TOLUD1 based on the agents 6bit encoded SAI value."},
#else
{10, 10, 0x0000000000000000, "RO", "GSM_SAI_POL_10", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{9, 9, 0x0000000000000000, "RO", "GSM_SAI_POL_9", "Bunit GSM Write Access Policy: Bit vector used to determine which agents are allowed write access to the memory range from BGSM to TOLUD1 based on the agents 6bit encoded SAI value."},
#else
{9, 9, 0x0000000000000000, "RO", "GSM_SAI_POL_9", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{8, 8, 0x0000000000000001, "RW", "GSM_SAI_POL_8", "Bunit GSM Write Access Policy: Bit vector used to determine which agents are allowed write access to the memory range from BGSM to TOLUD1 based on the agents 6bit encoded SAI value."},
#else
{8, 8, 0x0000000000000001, "RW", "GSM_SAI_POL_8", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{7, 7, 0x0000000000000000, "RO", "GSM_SAI_POL_7", "Bunit GSM Write Access Policy: Bit vector used to determine which agents are allowed write access to the memory range from BGSM to TOLUD1 based on the agents 6bit encoded SAI value."},
#else
{7, 7, 0x0000000000000000, "RO", "GSM_SAI_POL_7", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{6, 6, 0x0000000000000000, "RO", "GSM_SAI_POL_6", "Bunit GSM Write Access Policy: Bit vector used to determine which agents are allowed write access to the memory range from BGSM to TOLUD1 based on the agents 6bit encoded SAI value."},
#else
{6, 6, 0x0000000000000000, "RO", "GSM_SAI_POL_6", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{5, 5, 0x0000000000000000, "RW", "GSM_SAI_POL_5", "Bunit GSM Write Access Policy: Bit vector used to determine which agents are allowed write access to the memory range from BGSM to TOLUD1 based on the agents 6bit encoded SAI value."},
#else
{5, 5, 0x0000000000000000, "RW", "GSM_SAI_POL_5", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{4, 4, 0x0000000000000000, "RW", "GSM_SAI_POL_4", "Bunit GSM Write Access Policy: Bit vector used to determine which agents are allowed write access to the memory range from BGSM to TOLUD1 based on the agents 6bit encoded SAI value."},
#else
{4, 4, 0x0000000000000000, "RW", "GSM_SAI_POL_4", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{3, 3, 0x0000000000000000, "RW", "GSM_SAI_POL_3", "Bunit GSM Write Access Policy: Bit vector used to determine which agents are allowed write access to the memory range from BGSM to TOLUD1 based on the agents 6bit encoded SAI value."},
#else
{3, 3, 0x0000000000000000, "RW", "GSM_SAI_POL_3", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{2, 2, 0x0000000000000000, "RW", "GSM_SAI_POL_2", "Bunit GSM Write Access Policy: Bit vector used to determine which agents are allowed write access to the memory range from BGSM to TOLUD1 based on the agents 6bit encoded SAI value."},
#else
{2, 2, 0x0000000000000000, "RW", "GSM_SAI_POL_2", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{1, 1, 0x0000000000000000, "RW", "GSM_SAI_POL_1", "Bunit GSM Write Access Policy: Bit vector used to determine which agents are allowed write access to the memory range from BGSM to TOLUD1 based on the agents 6bit encoded SAI value."},
#else
{1, 1, 0x0000000000000000, "RW", "GSM_SAI_POL_1", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 0, 0x0000000000000000, "RW", "GSM_SAI_POL_0", "Bunit GSM Write Access Policy: Bit vector used to determine which agents are allowed write access to the memory range from BGSM to TOLUD1 based on the agents 6bit encoded SAI value."},
#else
{0, 0, 0x0000000000000000, "RW", "GSM_SAI_POL_0", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo987[] = {{"B_CR_BGSMWAC_0_0_0_MCHBAR", "", 0x00006B38, 64, 0xFFFFFFFFFFFFFFFF, 0x0000100000010100}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields988[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{0, 63, 0x00000C0061010202, "RW", "CTRL_POL", "TPM Control Policy: Bit vector used to determine which agents are allowed write access to TPM_AC register based on the agents 6-bit encoded SAI value."},
#else
{0, 63, 0x00000C0061010202, "RW", "CTRL_POL", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo988[] = {{"B_CR_TPM_CP_0_0_0_MCHBAR", "", 0x00006B40, 1, 0xFFFFFFFFFFFFFFFF, 0x00000C0061010202}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields989[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{0, 63, 0x00000C0061010222, "RW", "AC_POL", "TPM Access Policy: Bit vector used to determine which agents are allowed read/write access to TPM_SELECTOR based on the agents 6-bit encoded SAI value."},
#else
{0, 63, 0x00000C0061010222, "RW", "AC_POL", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo989[] = {{"B_CR_TPM_AC_0_0_0_MCHBAR", "", 0x00006B48, 1, 0xFFFFFFFFFFFFFFFF, 0x00000C0061010222}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields990[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{5, 31, 0x0000000000000000, "RO", "RESERVED_0", "Reserved"},
#else
{5, 31, 0x0000000000000000, "RO", "RESERVED_0", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{4, 4, 0x0000000000000001, "RW", "RS0_EN", "RS0 Asset Classification bit for Graphics and Data Stolen Memory.  PII transactions from RS0 that hit the Graphics and Data Stolen Memory range will be allowed access only when both of the following conditions are met: a Request SAI is in the legal permitted list as specified in the RAC/WAC policy registers and b GSM_RS0_EN bit is set to 1.  PII RS0 transactions targeting DRAM that do not hit any enabled IMR or special protected regions will always be allowed access."},
#else
{4, 4, 0x0000000000000001, "RW", "RS0_EN", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{3, 3, 0x0000000000000001, "RW", "GT_IWB_EN", "GT Implicit WB Enable: Enables implicit writebacks to protected region from GT caching agent. When set to 1 enables implicit writeback data HITM data from GT to be returned to the requester.  When set to 0 inhibits HITM data from GT from being returned to the requester.  HITM data from IA cores may be returned to the requester depending on the setting of the IA_IWB_EN bit."},
#else
{3, 3, 0x0000000000000001, "RW", "GT_IWB_EN", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{2, 2, 0x0000000000000000, "RW", "IA_IWB_EN", "IA Implicit WB Enable: Enables implicit writebacks to protected region from IA caching agent.  When set to 1 enables implicit writeback data HITM data from IA cores to be returned to the requester.  When set to 0 inhibits HITM data from IA cores from being returned to the requester.  HITM data from GT may be returned to the requester depending on the setting of the GT_IWB_EN bit."},
#else
{2, 2, 0x0000000000000000, "RW", "IA_IWB_EN", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{1, 1, 0x0000000000000000, "RW", "TRACE_EN", "Trace Enable: Enables snooping of transactions to the Graphics Stolen Memory region by tracing agents."},
#else
{1, 1, 0x0000000000000000, "RW", "TRACE_EN", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 0, 0x0000000000000001, "RW", "RANGE_CHECK_EN", "Enables SAI checking for the memory range from BGSM to TOLUD-1"},
#else
{0, 0, 0x0000000000000001, "RW", "RANGE_CHECK_EN", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo990[] = {{"B_CR_BGSM_CTRL_0_0_0_MCHBAR", "", 0x00006B50, 6, 0x00000000FFFFFFFF, 0x0000000000000019}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields991[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{5, 31, 0x0000000000000000, "RO", "RESERVED_0", "Reserved"},
#else
{5, 31, 0x0000000000000000, "RO", "RESERVED_0", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{4, 4, 0x0000000000000000, "RO", "RS0_EN", "RS0 Asset Classification bit for SMM region.  No PII transaction is allowed access to SMM region.  As such RS0 asset classification bit does not apply and hence provisioned as a readonly bit and set to 0."},
#else
{4, 4, 0x0000000000000000, "RO", "RS0_EN", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{3, 3, 0x0000000000000000, "RW", "GT_IWB_EN", "GT Implicit WB Enable: Enables implicit writebacks to protected region from GT caching agent. When set to 1 enables implicit writeback data HITM data from GT to be returned to the requester.  When set to 0 inhibits HITM data from GT from being returned to the requester.  HITM data from IA cores may be returned to the requester depending on the setting of the IA_IWB_EN bit."},
#else
{3, 3, 0x0000000000000000, "RW", "GT_IWB_EN", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{2, 2, 0x0000000000000001, "RW", "IA_IWB_EN", "IA Implicit WB Enable: Enables implicit writebacks to protected region from IA caching agent.  When set to 1 enables implicit writeback data HITM data from IA cores to be returned to the requester.  When set to 0 inhibits HITM data from IA cores from being returned to the requester.  HITM data from GT may be returned to the requester depending on the setting of the GT_IWB_EN bit."},
#else
{2, 2, 0x0000000000000001, "RW", "IA_IWB_EN", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{1, 1, 0x0000000000000001, "RW", "TRACE_EN", "Trace Enable: Enables snooping of transactions to the SMM region by tracing agents."},
#else
{1, 1, 0x0000000000000001, "RW", "TRACE_EN", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 0, 0x0000000000000001, "RW", "RANGE_CHECK_EN", "Enables SAI checking for the SMM memory range: TSEGMB to BGSM"},
#else
{0, 0, 0x0000000000000001, "RW", "RANGE_CHECK_EN", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo991[] = {{"B_CR_BSMR_CTRL_0_0_0_MCHBAR", "", 0x00006B54, 6, 0x00000000FFFFFFFF, 0x0000000000000007}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields992[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{5, 31, 0x0000000000000000, "RO", "RESERVED_1", "Reserved"},
#else
{5, 31, 0x0000000000000000, "RO", "RESERVED_1", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{4, 4, 0x0000000000000001, "RW", "RS0_EN", "RS0 Asset Classification bit for the high and low VTd PMRs.  PII transactions from RS0 that hit VTd PMR high and low memory ranges will be allowed access only when both of the following conditions are met: a Request SAI is in the legal permitted list as specified in the RAC/WAC policy registers and b VTDPMR_RS0_EN bit is set to 1.  PII RS0 transactions targeting DRAM that do not hit any enabled IMR or special protected regions will always be allowed access."},
#else
{4, 4, 0x0000000000000001, "RW", "RS0_EN", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{3, 3, 0x0000000000000001, "RW", "GT_IWB_EN", "GT Implicit WB Enable: Enables implicit writebacks to protected region from GT caching agent. When set to 1 enables implicit writeback data HITM data from GT to be returned to the requester.  When set to 0 inhibits HITM data from GT from being returned to the requester.  HITM data from IA cores may be returned to the requester depending on the setting of the IA_IWB_EN bit."},
#else
{3, 3, 0x0000000000000001, "RW", "GT_IWB_EN", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{2, 2, 0x0000000000000001, "RW", "IA_IWB_EN", "IA Implicit WB Enable: Enables implicit writebacks to protected region from IA caching agent.  When set to 1 enables implicit writeback data HITM data from IA cores to be returned to the requester.  When set to 0 inhibits HITM data from IA cores from being returned to the requester.  HITM data from GT may be returned to the requester depending on the setting of the GT_IWB_EN bit."},
#else
{2, 2, 0x0000000000000001, "RW", "IA_IWB_EN", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{1, 1, 0x0000000000000000, "RW", "TRACE_EN", "Trace Enable: Enables snooping of transactions to the Default VTd PHM and PLM regions by tracing agents."},
#else
{1, 1, 0x0000000000000000, "RW", "TRACE_EN", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 0, 0x0000000000000000, "RO", "RESERVED_0", "Reserved"},
#else
{0, 0, 0x0000000000000000, "RO", "RESERVED_0", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo992[] = {{"B_CR_BDEFVTDPMR_CTRL_0_0_0_MCHBAR", "", 0x00006B58, 6, 0x00000000FFFFFFFF, 0x000000000000001C}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields993[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{16, 31, 0x0000000000000000, "RW", "UPPER_NO_SNOOP_BOUND", "Upper Bound UpperNoSnoopBound:  These bits are compared with bits 35:20 of the incoming address to determine the upper 1MB aligned value of the nonsnoop range when EnableNoSnoop is set."},
#else
{16, 31, 0x0000000000000000, "RW", "UPPER_NO_SNOOP_BOUND", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 15, 0x0000000000000000, "RW", "LOWER_NO_SNOOP_BOUND", "Lower Bound LowerNoSnoopBound:  These bits are compared with bits 35:20 of the incoming address to determine the lower 1MB aligned value of the protected range when EnableNoSnoop is set."},
#else
{0, 15, 0x0000000000000000, "RW", "LOWER_NO_SNOOP_BOUND", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo993[] = {{"B_CR_BNOCACHE_0_0_0_MCHBAR", "", 0x00006B5C, 2, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields994[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{1, 31, 0x0000000000000000, "RO", "RESERVED_0", "Reserved"},
#else
{1, 31, 0x0000000000000000, "RO", "RESERVED_0", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 0, 0x0000000000000000, "RW", "ENABLE_NO_SNOOP", "Enable No Snoop:  When set Bunit compares bits 35:20 incoming addresses to Upper and Lower NoSnoop Bounds to see if the transaction should be prevented from issuing a processor snoop operation."},
#else
{0, 0, 0x0000000000000000, "RW", "ENABLE_NO_SNOOP", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo994[] = {{"B_CR_BNOCACHECTL_0_0_0_MCHBAR", "", 0x00006B60, 2, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields995[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{28, 31, 0x000000000000000E, "RW", "FLUSH_TIMER_PERIOD", "Specifies the duration of the periodic MOT flush timer.  Duration is 2^N cycles of a 19.2 MHz clock, where N is the value specified in the field."},
#else
{28, 31, 0x000000000000000E, "RW", "FLUSH_TIMER_PERIOD", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{27, 27, 0x0000000000000000, "RO", "RESERVED_0", "Reserved"},
#else
{27, 27, 0x0000000000000000, "RO", "RESERVED_0", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{26, 26, 0x0000000000000000, "RW/V", "STICKY_TRIGGER_1_MATCH", "1 indicates Trigger 1 match. Cleared by powergood or explicit SW write"},
#else
{26, 26, 0x0000000000000000, "RW/V", "STICKY_TRIGGER_1_MATCH", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{25, 25, 0x0000000000000000, "RW/V", "STICKY_TRIGGER_0_MATCH", "1 indicates Trigger 0 match. Cleared by powergood or explicit SW write"},
#else
{25, 25, 0x0000000000000000, "RW/V", "STICKY_TRIGGER_0_MATCH", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{24, 24, 0x0000000000000000, "RW/V", "STICKY_FILTER_1_MATCH", "1 indicates Filter 1 match. Cleared by powergood or explicit SW write"},
#else
{24, 24, 0x0000000000000000, "RW/V", "STICKY_FILTER_1_MATCH", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{23, 23, 0x0000000000000000, "RW/V", "STICKY_FILTER_0_MATCH", "1 indicates Filter 0 match. Cleared by powergood or explicit SW write"},
#else
{23, 23, 0x0000000000000000, "RW/V", "STICKY_FILTER_0_MATCH", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{22, 22, 0x0000000000000000, "RW/V", "MOT_STORAGE_ACTIVE", "Current status of MOT storage to memory. Used to save/restore trigger state across power states"},
#else
{22, 22, 0x0000000000000000, "RW/V", "MOT_STORAGE_ACTIVE", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{16, 21, 0x0000000000000000, "RW", "MOT_TRACE_STORAGE_STOP_SOURCE", "A bit field allowing multiple triggers to result in a trace storage stop. Storage stop is the logical OR of trigger sources selected. Note that selecting the same trigger to start and stop trace storage results in start trace storage only.  Bit position 5: External Trigger in 1 Bit position 4: External Trigger in 0 Bit position 3: MOT Trigger  1 Bit position 2: MOT Trigger 0 Bit position 1: MOT Filter 1 match Bit position 0: MOT Filter 0 match"},
#else
{16, 21, 0x0000000000000000, "RW", "MOT_TRACE_STORAGE_STOP_SOURCE", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{10, 15, 0x0000000000000000, "RW", "MOT_TRACE_STORAGE_START_SOURCE", "A bit field allowing multiple triggers to result in a trace storage start. Storage stop is the logical OR of trigger sources selected. Note that selecting the same trigger to start and stop trace storage results in start trace storage only.  Bit position 5: External Trigger in 1 Bit position 4: External Trigger in 0 Bit position 3: MOT Trigger  1 Bit position 2: MOT Trigger 0 Bit position 1: MOT Filter 1 match Bit position 0: MOT Filter 0 match"},
#else
{10, 15, 0x0000000000000000, "RW", "MOT_TRACE_STORAGE_START_SOURCE", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{9, 9, 0x0000000000000000, "RW", "ENABLE_EXTERNAL_TRIGGER_IN_1", "1 to enable  0 to disable External trigger 1 to MOT from rdu_mid"},
#else
{9, 9, 0x0000000000000000, "RW", "ENABLE_EXTERNAL_TRIGGER_IN_1", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{8, 8, 0x0000000000000000, "RW", "ENABLE_EXTERNAL_TRIGGER_IN_0", "1 to enable  0 to disable External trigger 0 to MOT from rdu_mid"},
#else
{8, 8, 0x0000000000000000, "RW", "ENABLE_EXTERNAL_TRIGGER_IN_0", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{6, 7, 0x0000000000000000, "RW", "TRIGGER_OUT_SOURCE", "Select source of trigger sent to rdu_mid. 2 b00: Filter 0 2 b01: Filter 1 2 b10: Trigger 0 2 b11: Trigger 1"},
#else
{6, 7, 0x0000000000000000, "RW", "TRIGGER_OUT_SOURCE", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{5, 5, 0x0000000000000000, "RW", "ENABLE_EXTERNAL_TRIGGER_OUT_0", "1 to enable  0 to disable External trigger out to from MOT to rdu_mid"},
#else
{5, 5, 0x0000000000000000, "RW", "ENABLE_EXTERNAL_TRIGGER_OUT_0", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{4, 4, 0x0000000000000000, "RW", "ENABLE_MOT_TRIGGER_1", "1 to enable  0 to disable MOT trigger 1"},
#else
{4, 4, 0x0000000000000000, "RW", "ENABLE_MOT_TRIGGER_1", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{3, 3, 0x0000000000000000, "RW", "ENABLE_MOT_TRIGGER_0", "1 to enable  0 to disable MOT trigger 0"},
#else
{3, 3, 0x0000000000000000, "RW", "ENABLE_MOT_TRIGGER_0", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{2, 2, 0x0000000000000000, "RW", "ENABLE_MOT_FILTER_1", "1 to enable  0 to disable MOT filter 1"},
#else
{2, 2, 0x0000000000000000, "RW", "ENABLE_MOT_FILTER_1", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{1, 1, 0x0000000000000000, "RW", "ENABLE_MOT_FILTER_0", "1 to enable  0 to disable MOT filter 0"},
#else
{1, 1, 0x0000000000000000, "RW", "ENABLE_MOT_FILTER_0", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 0, 0x0000000000000000, "RW", "ENABLE_MOT", "Global MOT enable 1 to enable  0 to disable MOT"},
#else
{0, 0, 0x0000000000000000, "RW", "ENABLE_MOT", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo995[] = {{"B_CR_MOT_TRIG_TRACE_CTRL_0_0_0_MCHBAR", "", 0x00006B7C, 18, 0x00000000FFFFFFFF, 0x00000000E0000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields996[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{39, 63, 0x0000000000000000, "RO", "RESERVED_0", "Reserved"},
#else
{39, 63, 0x0000000000000000, "RO", "RESERVED_0", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{6, 38, 0x0000000000000000, "RW/V", "MOT_MEMORY_POINTER", "The current pointer into MOT slice 0 region. Cache line granularity bits [38:6]"},
#else
{6, 38, 0x0000000000000000, "RW/V", "MOT_MEMORY_POINTER", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{2, 5, 0x0000000000000000, "RO", "RESERVED_1", "Reserved"},
#else
{2, 5, 0x0000000000000000, "RO", "RESERVED_1", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{1, 1, 0x0000000000000001, "RW", "NEAR_OR_FAR_MEMORY", "Pin MOT slice 0 to near1 or far0 memory. This logic is implemented in the 2LM. Thus this register bit is shadowed in its entirety in the 2LM.  Unused by MOT"},
#else
{1, 1, 0x0000000000000001, "RW", "NEAR_OR_FAR_MEMORY", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 0, 0x0000000000000000, "RW/V", "MOT_BUFFER_WRAP", "Indication that the MOT slice 0 buffer has wrapped since the last clear of this write cleared by power good or explicit SW write"},
#else
{0, 0, 0x0000000000000000, "RW/V", "MOT_BUFFER_WRAP", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo996[] = {{"B_CR_MOT_SLICE_0_MEM_PTR_0_0_0_MCHBAR", "", 0x00006B88, 5, 0xFFFFFFFFFFFFFFFF, 0x0000000000000002}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields997[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{39, 63, 0x0000000000000000, "RO", "RESERVED_0", "Reserved"},
#else
{39, 63, 0x0000000000000000, "RO", "RESERVED_0", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{6, 38, 0x0000000000000000, "RW/V", "MOT_MEMORY_POINTER", "The current pointer into MOT slice 1 region. Cache line granularity bits [38:6]"},
#else
{6, 38, 0x0000000000000000, "RW/V", "MOT_MEMORY_POINTER", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{2, 5, 0x0000000000000000, "RO", "RESERVED_1", "Reserved"},
#else
{2, 5, 0x0000000000000000, "RO", "RESERVED_1", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{1, 1, 0x0000000000000001, "RW", "NEAR_OR_FAR_MEMORY", "Pin MOT slice 1 to near1 or far0 memory. This logic is implemented in the 2LM. Thus this register is shadowed in its entirety in the 2LM."},
#else
{1, 1, 0x0000000000000001, "RW", "NEAR_OR_FAR_MEMORY", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 0, 0x0000000000000000, "RW/V", "MOT_BUFFER_WRAP", "Indication that the MOT slice 1 buffer has wrapped since the last clear of this write cleared by power good or explicit SW write"},
#else
{0, 0, 0x0000000000000000, "RW/V", "MOT_BUFFER_WRAP", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo997[] = {{"B_CR_MOT_SLICE_1_MEM_PTR_0_0_0_MCHBAR", "", 0x00006B98, 5, 0xFFFFFFFFFFFFFFFF, 0x0000000000000002}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields998[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{39, 63, 0x0000000000000000, "RO", "RESERVED_0", "Reserved"},
#else
{39, 63, 0x0000000000000000, "RO", "RESERVED_0", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{5, 38, 0x0000000000000000, "RW", "MOT_0_FILTER_MATCH_ADDRESS", "Access address to match. Match results in trace of access. Half cache line granularity bits 38:5 to support legacy devices."},
#else
{5, 38, 0x0000000000000000, "RW", "MOT_0_FILTER_MATCH_ADDRESS", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 4, 0x0000000000000000, "RO", "RESERVED_1", "Reserved"},
#else
{0, 4, 0x0000000000000000, "RO", "RESERVED_1", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo998[] = {{"B_CR_MOT_FILTER_MATCH0_0_0_0_MCHBAR", "", 0x00006BA0, 3, 0xFFFFFFFFFFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields999[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{39, 63, 0x0000000000000000, "RO", "RESERVED_0", "Reserved"},
#else
{39, 63, 0x0000000000000000, "RO", "RESERVED_0", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{5, 38, 0x00000003FFFFFFFF, "RW", "MOT_0_FILTER_MASK_ADDRESS", "Access address bits to mask. A value of 1 ignores the corresponding address bit. Half cache line granularity bits 38:5 to support legacy devices."},
#else
{5, 38, 0x00000003FFFFFFFF, "RW", "MOT_0_FILTER_MASK_ADDRESS", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 4, 0x0000000000000000, "RO", "RESERVED_1", "Reserved"},
#else
{0, 4, 0x0000000000000000, "RO", "RESERVED_1", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo999[] = {{"B_CR_MOT_FILTER_MASK0_0_0_0_MCHBAR", "", 0x00006BA8, 3, 0xFFFFFFFFFFFFFFFF, 0x0000007FFFFFFFE0}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields1000[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{39, 63, 0x0000000000000000, "RO", "RESERVED_0", "Reserved"},
#else
{39, 63, 0x0000000000000000, "RO", "RESERVED_0", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{5, 38, 0x0000000000000000, "RW", "MOT_1_FILTER_MATCH_ADDRESS", "Access address to match. Match results in trace of access. Half cache line granularity bits 38:5 to support legacy devices."},
#else
{5, 38, 0x0000000000000000, "RW", "MOT_1_FILTER_MATCH_ADDRESS", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 4, 0x0000000000000000, "RO", "RESERVED_1", "Reserved"},
#else
{0, 4, 0x0000000000000000, "RO", "RESERVED_1", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo1000[] = {{"B_CR_MOT_FILTER_MATCH1_0_0_0_MCHBAR", "", 0x00006BB0, 3, 0xFFFFFFFFFFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields1001[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{39, 63, 0x0000000000000000, "RO", "RESERVED_0", "Reserved"},
#else
{39, 63, 0x0000000000000000, "RO", "RESERVED_0", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{5, 38, 0x00000003FFFFFFFF, "RW", "MOT_1_FILTER_MASK_ADDRESS", "Access address bits to mask. A value of 1 ignores the corresponding address bit. Half cache line granularity bits 38:5 to support legacy devices."},
#else
{5, 38, 0x00000003FFFFFFFF, "RW", "MOT_1_FILTER_MASK_ADDRESS", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 4, 0x0000000000000000, "RO", "RESERVED_1", "Reserved"},
#else
{0, 4, 0x0000000000000000, "RO", "RESERVED_1", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo1001[] = {{"B_CR_MOT_FILTER_MASK1_0_0_0_MCHBAR", "", 0x00006BB8, 3, 0xFFFFFFFFFFFFFFFF, 0x0000007FFFFFFFE0}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields1002[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{35, 63, 0x0000000000000000, "RO", "RESERVED_0", "N/A"},
#else
{35, 63, 0x0000000000000000, "RO", "RESERVED_0", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{34, 34, 0x0000000000000000, "RO", "CPU_7_CORE_1_MATCH", "CPU IDI Agent  LPID Match"},
#else
{34, 34, 0x0000000000000000, "RO", "CPU_7_CORE_1_MATCH", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{33, 33, 0x0000000000000000, "RO", "CPU_7_CORE_0_MATCH", "CPU IDI Agent  LPID Match"},
#else
{33, 33, 0x0000000000000000, "RO", "CPU_7_CORE_0_MATCH", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{32, 32, 0x0000000000000000, "RO", "CPU_6_CORE_1_MATCH", "CPU IDI Agent  LPID Match"},
#else
{32, 32, 0x0000000000000000, "RO", "CPU_6_CORE_1_MATCH", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{31, 31, 0x0000000000000000, "RO", "CPU_6_CORE_0_MATCH", "CPU IDI Agent  LPID Match"},
#else
{31, 31, 0x0000000000000000, "RO", "CPU_6_CORE_0_MATCH", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{30, 30, 0x0000000000000000, "RO", "CPU_5_CORE_1_MATCH", "CPU IDI Agent  LPID Match"},
#else
{30, 30, 0x0000000000000000, "RO", "CPU_5_CORE_1_MATCH", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{29, 29, 0x0000000000000000, "RO", "CPU_5_CORE_0_MATCH", "CPU IDI Agent  LPID Match"},
#else
{29, 29, 0x0000000000000000, "RO", "CPU_5_CORE_0_MATCH", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{28, 28, 0x0000000000000000, "RO", "CPU_4_CORE_1_MATCH", "CPU IDI Agent  LPID Match"},
#else
{28, 28, 0x0000000000000000, "RO", "CPU_4_CORE_1_MATCH", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{27, 27, 0x0000000000000000, "RO", "CPU_4_CORE_0_MATCH", "CPU IDI Agent  LPID Match"},
#else
{27, 27, 0x0000000000000000, "RO", "CPU_4_CORE_0_MATCH", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{26, 26, 0x0000000000000000, "RO", "CPU_3_CORE_1_MATCH", "CPU IDI Agent  LPID Match"},
#else
{26, 26, 0x0000000000000000, "RO", "CPU_3_CORE_1_MATCH", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{25, 25, 0x0000000000000000, "RO", "CPU_3_CORE_0_MATCH", "CPU IDI Agent  LPID Match"},
#else
{25, 25, 0x0000000000000000, "RO", "CPU_3_CORE_0_MATCH", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{24, 24, 0x0000000000000000, "RO", "CPU_2_CORE_1_MATCH", "CPU IDI Agent  LPID Match"},
#else
{24, 24, 0x0000000000000000, "RO", "CPU_2_CORE_1_MATCH", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{23, 23, 0x0000000000000000, "RO", "CPU_2_CORE_0_MATCH", "CPU IDI Agent  LPID Match"},
#else
{23, 23, 0x0000000000000000, "RO", "CPU_2_CORE_0_MATCH", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{22, 22, 0x0000000000000000, "RW", "CPU_1_CORE_1_MATCH", "CPU IDI Agent  LPID Match"},
#else
{22, 22, 0x0000000000000000, "RW", "CPU_1_CORE_1_MATCH", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{21, 21, 0x0000000000000000, "RW", "CPU_1_CORE_0_MATCH", "CPU IDI Agent  LPID Match"},
#else
{21, 21, 0x0000000000000000, "RW", "CPU_1_CORE_0_MATCH", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{20, 20, 0x0000000000000000, "RW", "CPU_0_CORE_1_MATCH", "CPU IDI Agent  LPID Match"},
#else
{20, 20, 0x0000000000000000, "RW", "CPU_0_CORE_1_MATCH", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{19, 19, 0x0000000000000000, "RW", "CPU_0_CORE_0_MATCH", "CPU IDI Agent  LPID Match"},
#else
{19, 19, 0x0000000000000000, "RW", "CPU_0_CORE_0_MATCH", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{18, 18, 0x0000000000000000, "RW", "GT_MATCH", "GT match. 1 to match 0 to ignore."},
#else
{18, 18, 0x0000000000000000, "RW", "GT_MATCH", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{17, 17, 0x0000000000000000, "RO", "VC15_MATCH", "VC15 match. 1 to match 0 to ignore."},
#else
{17, 17, 0x0000000000000000, "RO", "VC15_MATCH", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{16, 16, 0x0000000000000000, "RO", "VC14_MATCH", "VC14 match. 1 to match 0 to ignore."},
#else
{16, 16, 0x0000000000000000, "RO", "VC14_MATCH", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{15, 15, 0x0000000000000000, "RO", "VC13_MATCH", "VC13 match. 1 to match 0 to ignore."},
#else
{15, 15, 0x0000000000000000, "RO", "VC13_MATCH", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{14, 14, 0x0000000000000000, "RO", "VC12_MATCH", "VC12 match. 1 to match 0 to ignore."},
#else
{14, 14, 0x0000000000000000, "RO", "VC12_MATCH", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{13, 13, 0x0000000000000000, "RO", "VC11_MATCH", "VC11 match. 1 to match 0 to ignore."},
#else
{13, 13, 0x0000000000000000, "RO", "VC11_MATCH", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{12, 12, 0x0000000000000000, "RW", "VC10_MATCH", "VC10 match. 1 to match 0 to ignore."},
#else
{12, 12, 0x0000000000000000, "RW", "VC10_MATCH", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{11, 11, 0x0000000000000000, "RW", "VC9_MATCH", "VC9 match. 1 to match 0 to ignore."},
#else
{11, 11, 0x0000000000000000, "RW", "VC9_MATCH", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{10, 10, 0x0000000000000000, "RW", "VC8_MATCH", "VC8 match. 1 to match 0 to ignore."},
#else
{10, 10, 0x0000000000000000, "RW", "VC8_MATCH", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{9, 9, 0x0000000000000000, "RW", "VC7_MATCH", "VC7 match. 1 to match 0 to ignore."},
#else
{9, 9, 0x0000000000000000, "RW", "VC7_MATCH", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{8, 8, 0x0000000000000000, "RW", "VC6_MATCH", "VC6 match. 1 to match 0 to ignore."},
#else
{8, 8, 0x0000000000000000, "RW", "VC6_MATCH", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{7, 7, 0x0000000000000000, "RW", "VC5_MATCH", "VC5 match. 1 to match 0 to ignore."},
#else
{7, 7, 0x0000000000000000, "RW", "VC5_MATCH", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{6, 6, 0x0000000000000000, "RW", "VC4_MATCH", "VC4 match. 1 to match 0 to ignore."},
#else
{6, 6, 0x0000000000000000, "RW", "VC4_MATCH", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{5, 5, 0x0000000000000000, "RW", "VC3_MATCH", "VC3 match. 1 to match 0 to ignore."},
#else
{5, 5, 0x0000000000000000, "RW", "VC3_MATCH", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{4, 4, 0x0000000000000000, "RW", "VC2_MATCH", "VC2 match. 1 to match 0 to ignore."},
#else
{4, 4, 0x0000000000000000, "RW", "VC2_MATCH", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{3, 3, 0x0000000000000000, "RW", "VC1_MATCH", "VC1 match. 1 to match 0 to ignore."},
#else
{3, 3, 0x0000000000000000, "RW", "VC1_MATCH", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{2, 2, 0x0000000000000000, "RW", "VC0_MATCH", "VC0 match. 1 to match 0 to ignore."},
#else
{2, 2, 0x0000000000000000, "RW", "VC0_MATCH", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{1, 1, 0x0000000000000000, "RW", "ADDR_MATCH_POLARITY", "0 to match criteria 1 for filter inversion"},
#else
{1, 1, 0x0000000000000000, "RW", "ADDR_MATCH_POLARITY", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 0, 0x0000000000000000, "RW", "ACCESS_TYPE_MATCH_READ_OR_WRITE", "1 to match Writes 0 for Reads"},
#else
{0, 0, 0x0000000000000000, "RW", "ACCESS_TYPE_MATCH_READ_OR_WRITE", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo1002[] = {{"B_CR_MOT_FILTER_MISC0_0_0_0_MCHBAR", "", 0x00006BC0, 36, 0xFFFFFFFFFFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields1003[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{35, 63, 0x0000000000000000, "RO", "RESERVED_0", "N/A"},
#else
{35, 63, 0x0000000000000000, "RO", "RESERVED_0", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{34, 34, 0x0000000000000000, "RO", "CPU_7_CORE_1_MATCH", "CPU IDI Agent  LPID Match"},
#else
{34, 34, 0x0000000000000000, "RO", "CPU_7_CORE_1_MATCH", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{33, 33, 0x0000000000000000, "RO", "CPU_7_CORE_0_MATCH", "CPU IDI Agent  LPID Match"},
#else
{33, 33, 0x0000000000000000, "RO", "CPU_7_CORE_0_MATCH", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{32, 32, 0x0000000000000000, "RO", "CPU_6_CORE_1_MATCH", "CPU IDI Agent  LPID Match"},
#else
{32, 32, 0x0000000000000000, "RO", "CPU_6_CORE_1_MATCH", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{31, 31, 0x0000000000000000, "RO", "CPU_6_CORE_0_MATCH", "CPU IDI Agent  LPID Match"},
#else
{31, 31, 0x0000000000000000, "RO", "CPU_6_CORE_0_MATCH", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{30, 30, 0x0000000000000000, "RO", "CPU_5_CORE_1_MATCH", "CPU IDI Agent  LPID Match"},
#else
{30, 30, 0x0000000000000000, "RO", "CPU_5_CORE_1_MATCH", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{29, 29, 0x0000000000000000, "RO", "CPU_5_CORE_0_MATCH", "CPU IDI Agent  LPID Match"},
#else
{29, 29, 0x0000000000000000, "RO", "CPU_5_CORE_0_MATCH", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{28, 28, 0x0000000000000000, "RO", "CPU_4_CORE_1_MATCH", "CPU IDI Agent  LPID Match"},
#else
{28, 28, 0x0000000000000000, "RO", "CPU_4_CORE_1_MATCH", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{27, 27, 0x0000000000000000, "RO", "CPU_4_CORE_0_MATCH", "CPU IDI Agent  LPID Match"},
#else
{27, 27, 0x0000000000000000, "RO", "CPU_4_CORE_0_MATCH", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{26, 26, 0x0000000000000000, "RO", "CPU_3_CORE_1_MATCH", "CPU IDI Agent  LPID Match"},
#else
{26, 26, 0x0000000000000000, "RO", "CPU_3_CORE_1_MATCH", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{25, 25, 0x0000000000000000, "RO", "CPU_3_CORE_0_MATCH", "CPU IDI Agent  LPID Match"},
#else
{25, 25, 0x0000000000000000, "RO", "CPU_3_CORE_0_MATCH", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{24, 24, 0x0000000000000000, "RO", "CPU_2_CORE_1_MATCH", "CPU IDI Agent  LPID Match"},
#else
{24, 24, 0x0000000000000000, "RO", "CPU_2_CORE_1_MATCH", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{23, 23, 0x0000000000000000, "RO", "CPU_2_CORE_0_MATCH", "CPU IDI Agent  LPID Match"},
#else
{23, 23, 0x0000000000000000, "RO", "CPU_2_CORE_0_MATCH", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{22, 22, 0x0000000000000000, "RW", "CPU_1_CORE_1_MATCH", "CPU IDI Agent  LPID Match"},
#else
{22, 22, 0x0000000000000000, "RW", "CPU_1_CORE_1_MATCH", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{21, 21, 0x0000000000000000, "RW", "CPU_1_CORE_0_MATCH", "CPU IDI Agent  LPID Match"},
#else
{21, 21, 0x0000000000000000, "RW", "CPU_1_CORE_0_MATCH", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{20, 20, 0x0000000000000000, "RW", "CPU_0_CORE_1_MATCH", "CPU IDI Agent  LPID Match"},
#else
{20, 20, 0x0000000000000000, "RW", "CPU_0_CORE_1_MATCH", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{19, 19, 0x0000000000000000, "RW", "CPU_0_CORE_0_MATCH", "CPU IDI Agent  LPID Match"},
#else
{19, 19, 0x0000000000000000, "RW", "CPU_0_CORE_0_MATCH", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{18, 18, 0x0000000000000000, "RW", "GT_MATCH", "GT match. 1 to match 0 to ignore."},
#else
{18, 18, 0x0000000000000000, "RW", "GT_MATCH", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{17, 17, 0x0000000000000000, "RO", "VC15_MATCH", "VC15 match. 1 to match 0 to ignore."},
#else
{17, 17, 0x0000000000000000, "RO", "VC15_MATCH", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{16, 16, 0x0000000000000000, "RO", "VC14_MATCH", "VC14 match. 1 to match 0 to ignore."},
#else
{16, 16, 0x0000000000000000, "RO", "VC14_MATCH", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{15, 15, 0x0000000000000000, "RO", "VC13_MATCH", "VC13 match. 1 to match 0 to ignore."},
#else
{15, 15, 0x0000000000000000, "RO", "VC13_MATCH", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{14, 14, 0x0000000000000000, "RO", "VC12_MATCH", "VC12 match. 1 to match 0 to ignore."},
#else
{14, 14, 0x0000000000000000, "RO", "VC12_MATCH", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{13, 13, 0x0000000000000000, "RO", "VC11_MATCH", "VC11 match. 1 to match 0 to ignore."},
#else
{13, 13, 0x0000000000000000, "RO", "VC11_MATCH", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{12, 12, 0x0000000000000000, "RW", "VC10_MATCH", "VC10 match. 1 to match 0 to ignore."},
#else
{12, 12, 0x0000000000000000, "RW", "VC10_MATCH", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{11, 11, 0x0000000000000000, "RW", "VC9_MATCH", "VC9 match. 1 to match 0 to ignore."},
#else
{11, 11, 0x0000000000000000, "RW", "VC9_MATCH", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{10, 10, 0x0000000000000000, "RW", "VC8_MATCH", "VC8 match. 1 to match 0 to ignore."},
#else
{10, 10, 0x0000000000000000, "RW", "VC8_MATCH", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{9, 9, 0x0000000000000000, "RW", "VC7_MATCH", "VC7 match. 1 to match 0 to ignore."},
#else
{9, 9, 0x0000000000000000, "RW", "VC7_MATCH", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{8, 8, 0x0000000000000000, "RW", "VC6_MATCH", "VC6 match. 1 to match 0 to ignore."},
#else
{8, 8, 0x0000000000000000, "RW", "VC6_MATCH", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{7, 7, 0x0000000000000000, "RW", "VC5_MATCH", "VC5 match. 1 to match 0 to ignore."},
#else
{7, 7, 0x0000000000000000, "RW", "VC5_MATCH", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{6, 6, 0x0000000000000000, "RW", "VC4_MATCH", "VC4 match. 1 to match 0 to ignore."},
#else
{6, 6, 0x0000000000000000, "RW", "VC4_MATCH", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{5, 5, 0x0000000000000000, "RW", "VC3_MATCH", "VC3 match. 1 to match 0 to ignore."},
#else
{5, 5, 0x0000000000000000, "RW", "VC3_MATCH", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{4, 4, 0x0000000000000000, "RW", "VC2_MATCH", "VC2 match. 1 to match 0 to ignore."},
#else
{4, 4, 0x0000000000000000, "RW", "VC2_MATCH", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{3, 3, 0x0000000000000000, "RW", "VC1_MATCH", "VC1 match. 1 to match 0 to ignore."},
#else
{3, 3, 0x0000000000000000, "RW", "VC1_MATCH", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{2, 2, 0x0000000000000000, "RW", "VC0_MATCH", "VC0 match. 1 to match 0 to ignore."},
#else
{2, 2, 0x0000000000000000, "RW", "VC0_MATCH", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{1, 1, 0x0000000000000000, "RW", "ADDR_MATCH_POLARITY", "0 to match criteria 1 for filter inversion"},
#else
{1, 1, 0x0000000000000000, "RW", "ADDR_MATCH_POLARITY", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 0, 0x0000000000000000, "RW", "ACCESS_TYPE_MATCH_READ_OR_WRITE", "1 to match Writes 0 for Reads"},
#else
{0, 0, 0x0000000000000000, "RW", "ACCESS_TYPE_MATCH_READ_OR_WRITE", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo1003[] = {{"B_CR_MOT_FILTER_MISC1_0_0_0_MCHBAR", "", 0x00006BC8, 36, 0xFFFFFFFFFFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields1004[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{39, 63, 0x0000000000000000, "RO", "RESERVED_0", "Reserved"},
#else
{39, 63, 0x0000000000000000, "RO", "RESERVED_0", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{5, 38, 0x0000000000000000, "RW", "MOT_0_TRIGGER_MATCH_ADDRESS", "Access address to match. Match results in trace of access. Half cache line granularity bits 38:5 to support legacy devices."},
#else
{5, 38, 0x0000000000000000, "RW", "MOT_0_TRIGGER_MATCH_ADDRESS", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 4, 0x0000000000000000, "RO", "RESERVED_1", "Reserved"},
#else
{0, 4, 0x0000000000000000, "RO", "RESERVED_1", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo1004[] = {{"B_CR_MOT_TRIGGER_MATCH0_0_0_0_MCHBAR", "", 0x00006BD0, 3, 0xFFFFFFFFFFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields1005[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{39, 63, 0x0000000000000000, "RO", "RESERVED_0", "Reserved"},
#else
{39, 63, 0x0000000000000000, "RO", "RESERVED_0", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{5, 38, 0x00000003FFFFFFFF, "RW", "MOT_0_TRIGGER_MASK_ADDRESS", "Access address bits to mask. A value of 1 ignores the corresponding address bit. Half cache line granularity bits 38:5 to support legacy devices."},
#else
{5, 38, 0x00000003FFFFFFFF, "RW", "MOT_0_TRIGGER_MASK_ADDRESS", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 4, 0x0000000000000000, "RO", "RESERVED_1", "Reserved"},
#else
{0, 4, 0x0000000000000000, "RO", "RESERVED_1", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo1005[] = {{"B_CR_MOT_TRIGGER_MASK0_0_0_0_MCHBAR", "", 0x00006BD8, 3, 0xFFFFFFFFFFFFFFFF, 0x0000007FFFFFFFE0}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields1006[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{39, 63, 0x0000000000000000, "RO", "RESERVED_0", "Reserved"},
#else
{39, 63, 0x0000000000000000, "RO", "RESERVED_0", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{5, 38, 0x0000000000000000, "RW", "MOT_1_TRIGGER_MATCH_ADDRESS", "Access address to match. Match results in trace of access. Half cache line granularity bits 38:5 to support legacy devices."},
#else
{5, 38, 0x0000000000000000, "RW", "MOT_1_TRIGGER_MATCH_ADDRESS", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 4, 0x0000000000000000, "RO", "RESERVED_1", "Reserved"},
#else
{0, 4, 0x0000000000000000, "RO", "RESERVED_1", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo1006[] = {{"B_CR_MOT_TRIGGER_MATCH1_0_0_0_MCHBAR", "", 0x00006BE0, 3, 0xFFFFFFFFFFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields1007[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{39, 63, 0x0000000000000000, "RO", "RESERVED_0", "Reserved"},
#else
{39, 63, 0x0000000000000000, "RO", "RESERVED_0", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{5, 38, 0x00000003FFFFFFFF, "RW", "MOT_1_TRIGGER_MASK_ADDRESS", "Access address bits to mask. A value of 1 ignores the corresponding address bit. Half cache line granularity bits 38:5 to support legacy devices."},
#else
{5, 38, 0x00000003FFFFFFFF, "RW", "MOT_1_TRIGGER_MASK_ADDRESS", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 4, 0x0000000000000000, "RO", "RESERVED_1", "Reserved"},
#else
{0, 4, 0x0000000000000000, "RO", "RESERVED_1", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo1007[] = {{"B_CR_MOT_TRIGGER_MASK1_0_0_0_MCHBAR", "", 0x00006BE8, 3, 0xFFFFFFFFFFFFFFFF, 0x0000007FFFFFFFE0}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields1008[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{35, 63, 0x0000000000000000, "RO", "RESERVED_0", "N/A"},
#else
{35, 63, 0x0000000000000000, "RO", "RESERVED_0", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{34, 34, 0x0000000000000000, "RO", "CPU_7_CORE_1_MATCH", "CPU IDI Agent  LPID Match"},
#else
{34, 34, 0x0000000000000000, "RO", "CPU_7_CORE_1_MATCH", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{33, 33, 0x0000000000000000, "RO", "CPU_7_CORE_0_MATCH", "CPU IDI Agent  LPID Match"},
#else
{33, 33, 0x0000000000000000, "RO", "CPU_7_CORE_0_MATCH", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{32, 32, 0x0000000000000000, "RO", "CPU_6_CORE_1_MATCH", "CPU IDI Agent  LPID Match"},
#else
{32, 32, 0x0000000000000000, "RO", "CPU_6_CORE_1_MATCH", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{31, 31, 0x0000000000000000, "RO", "CPU_6_CORE_0_MATCH", "CPU IDI Agent  LPID Match"},
#else
{31, 31, 0x0000000000000000, "RO", "CPU_6_CORE_0_MATCH", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{30, 30, 0x0000000000000000, "RO", "CPU_5_CORE_1_MATCH", "CPU IDI Agent  LPID Match"},
#else
{30, 30, 0x0000000000000000, "RO", "CPU_5_CORE_1_MATCH", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{29, 29, 0x0000000000000000, "RO", "CPU_5_CORE_0_MATCH", "CPU IDI Agent  LPID Match"},
#else
{29, 29, 0x0000000000000000, "RO", "CPU_5_CORE_0_MATCH", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{28, 28, 0x0000000000000000, "RO", "CPU_4_CORE_1_MATCH", "CPU IDI Agent  LPID Match"},
#else
{28, 28, 0x0000000000000000, "RO", "CPU_4_CORE_1_MATCH", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{27, 27, 0x0000000000000000, "RO", "CPU_4_CORE_0_MATCH", "CPU IDI Agent  LPID Match"},
#else
{27, 27, 0x0000000000000000, "RO", "CPU_4_CORE_0_MATCH", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{26, 26, 0x0000000000000000, "RO", "CPU_3_CORE_1_MATCH", "CPU IDI Agent  LPID Match"},
#else
{26, 26, 0x0000000000000000, "RO", "CPU_3_CORE_1_MATCH", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{25, 25, 0x0000000000000000, "RO", "CPU_3_CORE_0_MATCH", "CPU IDI Agent  LPID Match"},
#else
{25, 25, 0x0000000000000000, "RO", "CPU_3_CORE_0_MATCH", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{24, 24, 0x0000000000000000, "RO", "CPU_2_CORE_1_MATCH", "CPU IDI Agent  LPID Match"},
#else
{24, 24, 0x0000000000000000, "RO", "CPU_2_CORE_1_MATCH", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{23, 23, 0x0000000000000000, "RO", "CPU_2_CORE_0_MATCH", "CPU IDI Agent  LPID Match"},
#else
{23, 23, 0x0000000000000000, "RO", "CPU_2_CORE_0_MATCH", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{22, 22, 0x0000000000000000, "RW", "CPU_1_CORE_1_MATCH", "CPU IDI Agent  LPID Match"},
#else
{22, 22, 0x0000000000000000, "RW", "CPU_1_CORE_1_MATCH", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{21, 21, 0x0000000000000000, "RW", "CPU_1_CORE_0_MATCH", "CPU IDI Agent  LPID Match"},
#else
{21, 21, 0x0000000000000000, "RW", "CPU_1_CORE_0_MATCH", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{20, 20, 0x0000000000000000, "RW", "CPU_0_CORE_1_MATCH", "CPU IDI Agent  LPID Match"},
#else
{20, 20, 0x0000000000000000, "RW", "CPU_0_CORE_1_MATCH", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{19, 19, 0x0000000000000000, "RW", "CPU_0_CORE_0_MATCH", "CPU IDI Agent  LPID Match"},
#else
{19, 19, 0x0000000000000000, "RW", "CPU_0_CORE_0_MATCH", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{18, 18, 0x0000000000000000, "RW", "GT_MATCH", "GT match. 1 to match 0 to ignore."},
#else
{18, 18, 0x0000000000000000, "RW", "GT_MATCH", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{17, 17, 0x0000000000000000, "RO", "VC15_MATCH", "VC15 match. 1 to match 0 to ignore."},
#else
{17, 17, 0x0000000000000000, "RO", "VC15_MATCH", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{16, 16, 0x0000000000000000, "RO", "VC14_MATCH", "VC14 match. 1 to match 0 to ignore."},
#else
{16, 16, 0x0000000000000000, "RO", "VC14_MATCH", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{15, 15, 0x0000000000000000, "RO", "VC13_MATCH", "VC13 match. 1 to match 0 to ignore."},
#else
{15, 15, 0x0000000000000000, "RO", "VC13_MATCH", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{14, 14, 0x0000000000000000, "RO", "VC12_MATCH", "VC12 match. 1 to match 0 to ignore."},
#else
{14, 14, 0x0000000000000000, "RO", "VC12_MATCH", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{13, 13, 0x0000000000000000, "RO", "VC11_MATCH", "VC11 match. 1 to match 0 to ignore."},
#else
{13, 13, 0x0000000000000000, "RO", "VC11_MATCH", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{12, 12, 0x0000000000000000, "RW", "VC10_MATCH", "VC10 match. 1 to match 0 to ignore."},
#else
{12, 12, 0x0000000000000000, "RW", "VC10_MATCH", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{11, 11, 0x0000000000000000, "RW", "VC9_MATCH", "VC9 match. 1 to match 0 to ignore."},
#else
{11, 11, 0x0000000000000000, "RW", "VC9_MATCH", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{10, 10, 0x0000000000000000, "RW", "VC8_MATCH", "VC8 match. 1 to match 0 to ignore."},
#else
{10, 10, 0x0000000000000000, "RW", "VC8_MATCH", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{9, 9, 0x0000000000000000, "RW", "VC7_MATCH", "VC7 match. 1 to match 0 to ignore."},
#else
{9, 9, 0x0000000000000000, "RW", "VC7_MATCH", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{8, 8, 0x0000000000000000, "RW", "VC6_MATCH", "VC6 match. 1 to match 0 to ignore."},
#else
{8, 8, 0x0000000000000000, "RW", "VC6_MATCH", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{7, 7, 0x0000000000000000, "RW", "VC5_MATCH", "VC5 match. 1 to match 0 to ignore."},
#else
{7, 7, 0x0000000000000000, "RW", "VC5_MATCH", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{6, 6, 0x0000000000000000, "RW", "VC4_MATCH", "VC4 match. 1 to match 0 to ignore."},
#else
{6, 6, 0x0000000000000000, "RW", "VC4_MATCH", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{5, 5, 0x0000000000000000, "RW", "VC3_MATCH", "VC3 match. 1 to match 0 to ignore."},
#else
{5, 5, 0x0000000000000000, "RW", "VC3_MATCH", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{4, 4, 0x0000000000000000, "RW", "VC2_MATCH", "VC2 match. 1 to match 0 to ignore."},
#else
{4, 4, 0x0000000000000000, "RW", "VC2_MATCH", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{3, 3, 0x0000000000000000, "RW", "VC1_MATCH", "VC1 match. 1 to match 0 to ignore."},
#else
{3, 3, 0x0000000000000000, "RW", "VC1_MATCH", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{2, 2, 0x0000000000000000, "RW", "VC0_MATCH", "VC0 match. 1 to match 0 to ignore."},
#else
{2, 2, 0x0000000000000000, "RW", "VC0_MATCH", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{1, 1, 0x0000000000000000, "RW", "ADDR_MATCH_POLARITY", "0 to match criteria 1 for filter inversion"},
#else
{1, 1, 0x0000000000000000, "RW", "ADDR_MATCH_POLARITY", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 0, 0x0000000000000000, "RW", "ACCESS_TYPE_MATCH_READ_OR_WRITE", "1 to match Writes 0 for Reads"},
#else
{0, 0, 0x0000000000000000, "RW", "ACCESS_TYPE_MATCH_READ_OR_WRITE", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo1008[] = {{"B_CR_MOT_TRIGGER_MISC0_0_0_0_MCHBAR", "", 0x00006BF0, 36, 0xFFFFFFFFFFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields1009[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{35, 63, 0x0000000000000000, "RO", "RESERVED_0", "N/A"},
#else
{35, 63, 0x0000000000000000, "RO", "RESERVED_0", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{34, 34, 0x0000000000000000, "RO", "CPU_7_CORE_1_MATCH", "CPU IDI Agent  LPID Match"},
#else
{34, 34, 0x0000000000000000, "RO", "CPU_7_CORE_1_MATCH", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{33, 33, 0x0000000000000000, "RO", "CPU_7_CORE_0_MATCH", "CPU IDI Agent  LPID Match"},
#else
{33, 33, 0x0000000000000000, "RO", "CPU_7_CORE_0_MATCH", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{32, 32, 0x0000000000000000, "RO", "CPU_6_CORE_1_MATCH", "CPU IDI Agent  LPID Match"},
#else
{32, 32, 0x0000000000000000, "RO", "CPU_6_CORE_1_MATCH", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{31, 31, 0x0000000000000000, "RO", "CPU_6_CORE_0_MATCH", "CPU IDI Agent  LPID Match"},
#else
{31, 31, 0x0000000000000000, "RO", "CPU_6_CORE_0_MATCH", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{30, 30, 0x0000000000000000, "RO", "CPU_5_CORE_1_MATCH", "CPU IDI Agent  LPID Match"},
#else
{30, 30, 0x0000000000000000, "RO", "CPU_5_CORE_1_MATCH", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{29, 29, 0x0000000000000000, "RO", "CPU_5_CORE_0_MATCH", "CPU IDI Agent  LPID Match"},
#else
{29, 29, 0x0000000000000000, "RO", "CPU_5_CORE_0_MATCH", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{28, 28, 0x0000000000000000, "RO", "CPU_4_CORE_1_MATCH", "CPU IDI Agent  LPID Match"},
#else
{28, 28, 0x0000000000000000, "RO", "CPU_4_CORE_1_MATCH", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{27, 27, 0x0000000000000000, "RO", "CPU_4_CORE_0_MATCH", "CPU IDI Agent  LPID Match"},
#else
{27, 27, 0x0000000000000000, "RO", "CPU_4_CORE_0_MATCH", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{26, 26, 0x0000000000000000, "RO", "CPU_3_CORE_1_MATCH", "CPU IDI Agent  LPID Match"},
#else
{26, 26, 0x0000000000000000, "RO", "CPU_3_CORE_1_MATCH", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{25, 25, 0x0000000000000000, "RO", "CPU_3_CORE_0_MATCH", "CPU IDI Agent  LPID Match"},
#else
{25, 25, 0x0000000000000000, "RO", "CPU_3_CORE_0_MATCH", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{24, 24, 0x0000000000000000, "RO", "CPU_2_CORE_1_MATCH", "CPU IDI Agent  LPID Match"},
#else
{24, 24, 0x0000000000000000, "RO", "CPU_2_CORE_1_MATCH", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{23, 23, 0x0000000000000000, "RO", "CPU_2_CORE_0_MATCH", "CPU IDI Agent  LPID Match"},
#else
{23, 23, 0x0000000000000000, "RO", "CPU_2_CORE_0_MATCH", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{22, 22, 0x0000000000000000, "RW", "CPU_1_CORE_1_MATCH", "CPU IDI Agent  LPID Match"},
#else
{22, 22, 0x0000000000000000, "RW", "CPU_1_CORE_1_MATCH", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{21, 21, 0x0000000000000000, "RW", "CPU_1_CORE_0_MATCH", "CPU IDI Agent  LPID Match"},
#else
{21, 21, 0x0000000000000000, "RW", "CPU_1_CORE_0_MATCH", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{20, 20, 0x0000000000000000, "RW", "CPU_0_CORE_1_MATCH", "CPU IDI Agent  LPID Match"},
#else
{20, 20, 0x0000000000000000, "RW", "CPU_0_CORE_1_MATCH", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{19, 19, 0x0000000000000000, "RW", "CPU_0_CORE_0_MATCH", "CPU IDI Agent  LPID Match"},
#else
{19, 19, 0x0000000000000000, "RW", "CPU_0_CORE_0_MATCH", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{18, 18, 0x0000000000000000, "RW", "GT_MATCH", "GT match. 1 to match 0 to ignore."},
#else
{18, 18, 0x0000000000000000, "RW", "GT_MATCH", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{17, 17, 0x0000000000000000, "RO", "VC15_MATCH", "VC15 match. 1 to match 0 to ignore."},
#else
{17, 17, 0x0000000000000000, "RO", "VC15_MATCH", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{16, 16, 0x0000000000000000, "RO", "VC14_MATCH", "VC14 match. 1 to match 0 to ignore."},
#else
{16, 16, 0x0000000000000000, "RO", "VC14_MATCH", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{15, 15, 0x0000000000000000, "RO", "VC13_MATCH", "VC13 match. 1 to match 0 to ignore."},
#else
{15, 15, 0x0000000000000000, "RO", "VC13_MATCH", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{14, 14, 0x0000000000000000, "RO", "VC12_MATCH", "VC12 match. 1 to match 0 to ignore."},
#else
{14, 14, 0x0000000000000000, "RO", "VC12_MATCH", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{13, 13, 0x0000000000000000, "RO", "VC11_MATCH", "VC11 match. 1 to match 0 to ignore."},
#else
{13, 13, 0x0000000000000000, "RO", "VC11_MATCH", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{12, 12, 0x0000000000000000, "RW", "VC10_MATCH", "VC10 match. 1 to match 0 to ignore."},
#else
{12, 12, 0x0000000000000000, "RW", "VC10_MATCH", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{11, 11, 0x0000000000000000, "RW", "VC9_MATCH", "VC9 match. 1 to match 0 to ignore."},
#else
{11, 11, 0x0000000000000000, "RW", "VC9_MATCH", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{10, 10, 0x0000000000000000, "RW", "VC8_MATCH", "VC8 match. 1 to match 0 to ignore."},
#else
{10, 10, 0x0000000000000000, "RW", "VC8_MATCH", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{9, 9, 0x0000000000000000, "RW", "VC7_MATCH", "VC7 match. 1 to match 0 to ignore."},
#else
{9, 9, 0x0000000000000000, "RW", "VC7_MATCH", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{8, 8, 0x0000000000000000, "RW", "VC6_MATCH", "VC6 match. 1 to match 0 to ignore."},
#else
{8, 8, 0x0000000000000000, "RW", "VC6_MATCH", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{7, 7, 0x0000000000000000, "RW", "VC5_MATCH", "VC5 match. 1 to match 0 to ignore."},
#else
{7, 7, 0x0000000000000000, "RW", "VC5_MATCH", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{6, 6, 0x0000000000000000, "RW", "VC4_MATCH", "VC4 match. 1 to match 0 to ignore."},
#else
{6, 6, 0x0000000000000000, "RW", "VC4_MATCH", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{5, 5, 0x0000000000000000, "RW", "VC3_MATCH", "VC3 match. 1 to match 0 to ignore."},
#else
{5, 5, 0x0000000000000000, "RW", "VC3_MATCH", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{4, 4, 0x0000000000000000, "RW", "VC2_MATCH", "VC2 match. 1 to match 0 to ignore."},
#else
{4, 4, 0x0000000000000000, "RW", "VC2_MATCH", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{3, 3, 0x0000000000000000, "RW", "VC1_MATCH", "VC1 match. 1 to match 0 to ignore."},
#else
{3, 3, 0x0000000000000000, "RW", "VC1_MATCH", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{2, 2, 0x0000000000000000, "RW", "VC0_MATCH", "VC0 match. 1 to match 0 to ignore."},
#else
{2, 2, 0x0000000000000000, "RW", "VC0_MATCH", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{1, 1, 0x0000000000000000, "RW", "ADDR_MATCH_POLARITY", "0 to match criteria 1 for filter inversion"},
#else
{1, 1, 0x0000000000000000, "RW", "ADDR_MATCH_POLARITY", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 0, 0x0000000000000000, "RW", "ACCESS_TYPE_MATCH_READ_OR_WRITE", "1 to match Writes 0 for Reads"},
#else
{0, 0, 0x0000000000000000, "RW", "ACCESS_TYPE_MATCH_READ_OR_WRITE", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo1009[] = {{"B_CR_MOT_TRIGGER_MISC1_0_0_0_MCHBAR", "", 0x00006BF8, 36, 0xFFFFFFFFFFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields1010[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{2, 31, 0x0000000000000000, "RO", "RESERVED_0", "Reserved"},
#else
{2, 31, 0x0000000000000000, "RO", "RESERVED_0", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{1, 1, 0x0000000000000000, "RW/V", "PSMI_SYNC1", "Set by PSMI microcode Once set cleared by HW after creating of first MOT record in Slice1"},
#else
{1, 1, 0x0000000000000000, "RW/V", "PSMI_SYNC1", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 0, 0x0000000000000000, "RW/V", "PSMI_SYNC0", "Set by PSMI microcode Once set cleared by HW after creating of first MOT record in Slice0"},
#else
{0, 0, 0x0000000000000000, "RW/V", "PSMI_SYNC0", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo1010[] = {{"B_CR_MOT_PSMI_SYNC_0_0_0_MCHBAR", "", 0x00006C00, 3, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields1011[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{16, 31, 0x0000000000000000, "RO", "RESERVED_0", "Reserved"},
#else
{16, 31, 0x0000000000000000, "RO", "RESERVED_0", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 15, 0x0000000000000000, "RW", "ASYM_MEM_RANGE_BASE", "Specifies bits 39:24 of the start address of Asymmetric memory region.  Region size must be a strict poweroftwo at least 16MB and naturally aligned to the size.  These bits are compared with the result of the ASYM_MEM_RANGE_MASK[15:0] applied to bits 39:24 of the incoming address to determine if an access falls within the region"},
#else
{0, 15, 0x0000000000000000, "RW", "ASYM_MEM_RANGE_BASE", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo1011[] = {{"B_CR_ASYM_MEM_RANGE_BASE_0_0_0_MCHBAR", "", 0x00006C1C, 2, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields1012[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{31, 31, 0x0000000000000000, "RW", "RANGE_EN", "0: Asymmetric memory region is disabled 1: Asymmetric memory region is enabled."},
#else
{31, 31, 0x0000000000000000, "RW", "RANGE_EN", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{16, 30, 0x0000000000000000, "RO", "RESERVED_0", "Reserved"},
#else
{16, 30, 0x0000000000000000, "RO", "RESERVED_0", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 15, 0x0000000000000000, "RW", "ASYM_MEM_RANGE_MASK", "These bits are ANDed with bits 39:24 of the incoming address to determine if the combined result matches the ASYM_MEM_RANGE_BASE[15:0] value.  A match indicates the the incoming address falls within the Asymmetric memory range region."},
#else
{0, 15, 0x0000000000000000, "RW", "ASYM_MEM_RANGE_MASK", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo1012[] = {{"B_CR_ASYM_MEM_RANGE_MASK_0_0_0_MCHBAR", "", 0x00006C20, 3, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields1013[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{2, 31, 0x0000000000000000, "RO", "RESERVED_0", "Reserved"},
#else
{2, 31, 0x0000000000000000, "RO", "RESERVED_0", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 1, 0x0000000000000000, "RW", "TPM_SELECTOR", "0x0:   fTPM enabled.  Target of TPM accesses is the CSE  0x1:   SPI TPM enabled.  Target of TPM accesses is SPI  0x2:   LPC TPM enabled.  Target of TPM accesses is LPC  0x3:   All TPMs disabled.  Target of TPM accesses is the PSF Error Handler"},
#else
{0, 1, 0x0000000000000000, "RW", "TPM_SELECTOR", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo1013[] = {{"B_CR_TPM_SELECTOR_0_0_0_MCHBAR", "", 0x00006C24, 2, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields1014[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{40, 63, 0x0000000000000000, "RO", "RESERVED_0", "Reserved"},
#else
{40, 63, 0x0000000000000000, "RO", "RESERVED_0", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{39, 39, 0x0000000000000000, "RO", "DEFVTDBAR_40_BIT", "Reserved for future growth to 40bit addressing in uServer.  Will always be 0 in WLV/BXT"},
#else
{39, 39, 0x0000000000000000, "RO", "DEFVTDBAR_40_BIT", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{12, 38, 0x0000000000000000, "RW", "DEFVTDBAR", "If DEFVTDBAR is enabled this field corresponds to bits 38:12 of the base address default IOMMU VTd configuration space.  BIOS will program this register resulting in a base address for a 4KB block of contiguous memory address space.  This register ensures that a naturally aligned 4KB space is allocated within the first 512GB of addressable memory space.  System Software uses this base address to program the default VTd IOMMU register set.  If DEFVTDBAR is enabled and incoming Request Address[38:12] matches DEFVTDBAR[38:12] the request targets the Default VTd BAR."},
#else
{12, 38, 0x0000000000000000, "RW", "DEFVTDBAR", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{2, 11, 0x0000000000000000, "RO", "RESERVED_1", "Reserved"},
#else
{2, 11, 0x0000000000000000, "RO", "RESERVED_1", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{1, 1, 0x0000000000000000, "RW", "LOCK", "Locks the contents of the register including itself.  Unused by the Bunit and does not implement the intended lock functionality.  Bunit includes this bit to support shadow copies of the register that rely on this lock bit."},
#else
{1, 1, 0x0000000000000000, "RW", "LOCK", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 0, 0x0000000000000000, "RW/L", "DEFVTDBAREN", "0: DEFVTDBAR is disabled and does not claim any memory  1: DEFVTDBAR memory mapped accesses are claimed and decoded appropriately  This bit will remain 0 if VTd capability is disabled."},
#else
{0, 0, 0x0000000000000000, "RW/L", "DEFVTDBAREN", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo1014[] = {{"B_CR_DEFVTDBAR_0_0_0_MCHBAR", "", 0x00006C80, 6, 0xFFFFFFFFFFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields1015[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{39, 63, 0x0000000000000000, "RO", "RESERVED_0", "Reserved"},
#else
{39, 63, 0x0000000000000000, "RO", "RESERVED_0", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{12, 38, 0x0000000000000000, "RW", "GFXVTBAR", "This field corresponds to bits 38 to 12 of the base address GFXVT configuration space. BIOS will program this register resulting in a base address for a 4KB block of contiguous memory address space. This register ensures that a naturally aligned 4KB space is allocated within the first 512GB of addressable memory space. System Software uses this base address to program the GFXVT register set.  If GFXVTBAR is enabled and incoming Request Address[38:12] matches GFXVTBAR[38:12] the request targets the Gfx VTd BAR."},
#else
{12, 38, 0x0000000000000000, "RW", "GFXVTBAR", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{2, 11, 0x0000000000000000, "RO", "RESERVED_1", "Reserved"},
#else
{2, 11, 0x0000000000000000, "RO", "RESERVED_1", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{1, 1, 0x0000000000000000, "RW", "LOCK", "Locks the contents of the register including itself.  Unused by the Bunit and does not implement the intended lock functionality.  Bunit includes this bit to support shadow copies of the register that rely on this lock bit."},
#else
{1, 1, 0x0000000000000000, "RW", "LOCK", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 0, 0x0000000000000000, "RW/L", "GFXVTBAREN", "0: GFXVTBAR is disabled and does not claim any memory  1: GFXVTBAR memory mapped accesses are claimed and decoded appropriately  This bit will remain 0 if VTd capability is disabled."},
#else
{0, 0, 0x0000000000000000, "RW/L", "GFXVTBAREN", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo1015[] = {{"B_CR_GFXVTDBAR_0_0_0_MCHBAR", "", 0x00006C88, 5, 0xFFFFFFFFFFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields1016[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{14, 31, 0x0000000000000000, "RW", "IDI_LENGTH_MATCH", "Enables length matching for IDI requests for Lites Group 0.  Each bit when set to 1 enables match for that length for an IDI request.  Note: In certain cases the Bunit ignores the length field in the original IDI request. In order to produce a hit in these cases this field must be set accordingly FIXME:  which opcodes are these.                  Bit 31:64B                  Bit 30:16B                  Bit 29:15B                  Bit 28:14B                  Bit 27:13B                  Bit 26:12B                  Bit 25:11B                  Bit 24:10B                  Bit 23:9B                  Bit 22:8B                  Bit 21:7B                  Bit 20:6B                  Bit 19:5B                  Bit 18:4B                  Bit 17:3B                  Bit 16:2B                  Bit 15:1B                  Bit 14:0B"},
#else
{14, 31, 0x0000000000000000, "RW", "IDI_LENGTH_MATCH", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{12, 13, 0x0000000000000000, "RW", "PII_LENGTH_MATCH", "Enables length matching for PII requests for Lites Group 0.  Each bit when set to 1 enables  length match  for the PII request                  Bit 13:64B                   Bit 12:32B"},
#else
{12, 13, 0x0000000000000000, "RW", "PII_LENGTH_MATCH", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{10, 11, 0x0000000000000000, "RO", "RESERVED_0", "Reserved"},
#else
{10, 11, 0x0000000000000000, "RO", "RESERVED_0", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{8, 9, 0x0000000000000000, "RW", "SLICE_MATCH", "00:  All mask/match hits are suppressed 01:  Mask/Match hits enabled only for Slice0 10:  Mask/match hits enabled only for Slice1 11: Mask/Match hits enabled for both Slices"},
#else
{8, 9, 0x0000000000000000, "RW", "SLICE_MATCH", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{4, 7, 0x0000000000000000, "RW", "DWORD_SELECT", "DWord Select: Selects the dword within the 512bit data field that is compared for data mask/matches for Lites Group 0"},
#else
{4, 7, 0x0000000000000000, "RW", "DWORD_SELECT", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{3, 3, 0x0000000000000000, "RW", "ENABLE_DATA_MATCH", "When set  this field enables data matching on Lites Group 0"},
#else
{3, 3, 0x0000000000000000, "RW", "ENABLE_DATA_MATCH", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{2, 2, 0x0000000000000000, "RW", "ALTU2CREQVIEW", "When set address match/mask opcode match and agent match registers are used to generate matches for the U2C request observation point.  When clear Badmit observation point matches are reported on the U2C request observation point."},
#else
{2, 2, 0x0000000000000000, "RW", "ALTU2CREQVIEW", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{1, 1, 0x0000000000000000, "RW", "INVERT_ADDR_MATCH", "When set inverts the polarity of the address match/mask logic i.e. reports a match for addresses that are not in the specified range."},
#else
{1, 1, 0x0000000000000000, "RW", "INVERT_ADDR_MATCH", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 0, 0x0000000000000000, "RW", "ENABLE_GROUP", "Enables all match filters for Lites Group 0.  The following are the observation points that contain match filters  Badmit logic within each slice after a transaction is successfully admitted into the Bunit U2C request launch PMI datain for each PMI channel read data PMI dataout for each PMI channel write data agent data write to BRAM in each slice read data return on the live bypass and nonlive bypass paths in each slice.  To report a match at an observation point all match criteria for that point must be satisfied."},
#else
{0, 0, 0x0000000000000000, "RW", "ENABLE_GROUP", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo1016[] = {{"B_CR_LITES0_CTL_0_0_0_MCHBAR", "", 0x00006C90, 9, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields1017[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{0, 31, 0x0000000000000000, "RW", "OPCODE_MATCH", "Bit vector that enables a match on the opcode for C2U IDI requests PII A2B requests and U2C IDI requests.  All three observation points  Badmit in both slices  and the U2C request interface  use this same opcode match register.  Each bit when set enables a match on the corresponding opcode and when clear will suppress a match on the corresponding opcode.  To match on any opcode set all bits to 1.  Bit 31: C2U_Req_CRd  Bit 30:C2U_Req_DRd  Bit 29: C2U_Req_DRdPTE  Bit 28: C2U_Req_SetMonitor  Bit 27: C2U_Req_RFO  Bit 26: C2U_Req_PRd  Bit 25: C2U_Req_UcRdF  Bit 24: C2U_Req_PortIn,U2C_Req_SnpCode  Bit 23: C2U_Req_IntA,U2C_Req_SnpData  Bit 22: C2U_Req_Lock  Bit 21: C2U_Req_SplitLock  Bit 20: C2U_Req_Unlock  Bit 19: C2U_Req_ItoM  Bit 18: C2U_Req_SpCyc,U2C_Req_SnpInv  Bit 17: C2U_Req_RdMonitor,U2C_Req_StopReq  Bit 16:C2U_Req_ClrMonitor,U2C_Req_StartReq  Bit 15: C2U_Req_CLFlush  Bit 14: C2U_Req_WbMtoI,U2C_Req_IntLog_MSI  Bit 13: C2U_Req_WbMtoE,U2C_Req_IntPhy_MSI  Bit 12: C2U_Req_WiL  Bit 11: C2U_Req_WCiL  Bit 10: C2U_Req_WCilF  Bit 9: C2U_Req_PortOut  Bit 8: C2U_Req_IntPriUp,U2C_Req_LTWrite  Bit 7: C2U_Req_IntLog  Bit 6: C2U_Req_IntPhy  Bit 5: C2U_Req_EOI,U2C_Req_VLW  Bit 4: C2U_Req_ItoMWr  Bit 3: A2B_Req_SnoopedRead  Bit 2: A2B_Req_UnSnoopedRead,U2C_Req_IntPhy_IPI  Bit 1: A2B_Req_SnoopedWrite  Bit 0: A2B_Req_UnSnoopedWrite,U2C_Req_IntLog_IPI"},
#else
{0, 31, 0x0000000000000000, "RW", "OPCODE_MATCH", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo1017[] = {{"B_CR_LITES0_OPCODE_MATCH_0_0_0_MCHBAR", "", 0x00006C94, 1, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields1018[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{31, 31, 0x0000000000000000, "RW", "GT_MATCH", "This field is used to match IDI ransactions from GT for Lites Group0.  When set enables a match for a transaction origination from GT.  When clear suppresses a match for a transaction from GT."},
#else
{31, 31, 0x0000000000000000, "RW", "GT_MATCH", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{16, 30, 0x0000000000000000, "RW", "VC_MATCH", "This field is used to match VC Channel ID for PII transactions for Lites Group0.  Each bit when set enables a match for a transaction origination from that VC.  When clear suppresses a match for a transaction from that VC.      Bit 30: VC14   Bit 29: VC13   Bit 28: VC12   Bit 27: VC11   Bit 26: VC10   Bit 25: VC9   Bit 24: VC8   Bit 23: VC7   Bit 22: VC6   Bit 21: VC5   Bit 20: VC4   Bit 19: VC3   Bit 18: VC2   Bit 17: VC1   Bit 16: VC0"},
#else
{16, 30, 0x0000000000000000, "RW", "VC_MATCH", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 15, 0x0000000000000000, "RW", "CPU_CORE_MATCH", "This field is used to match Logical Processor Core ID for CPU IDI transactions for Lites Group 0.  Each bit when set enables a match for a transaction origination from that core.  When clear suppresses a match for a transaction from that core.   Bit 15: CPU7 Core1   Bit 14: CPU7 Core0   Bit 13: CPU6 Core1   Bit 12:  CPU6 Core0   Bit 11:  CPU5 Core1   Bit 10:  CPU5 Core0   Bit 9:  CPU4 Core1   Bit 8:  CPU4 Core0   Bit 7:  CPU3 Core1   Bit 6:  CPU3 Core0   Bit 5:  CPU2 Core1   Bit 4:  CPU2 Core0   Bit 3:  CPU1 Core1   Bit 2:  CPU1 Core0   Bit 1:  CPU0 Core1   Bit 0:  CPU0 Core0"},
#else
{0, 15, 0x0000000000000000, "RW", "CPU_CORE_MATCH", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo1018[] = {{"B_CR_LITES0_AGENT_MATCH_0_0_0_MCHBAR", "", 0x00006C98, 3, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields1019[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{16, 31, 0x0000000000000000, "RW", "INTDATA_MASK", "Mask for U2C Request IntData[15:0] for generating Lites Group 0 U2C request alternative view match.   If the mask bit in this register is 0 then the corresponding bit in the INTDATA_MATCH register is ignored.  If the mask bit is 1  then the corresponding bit in the INTDATA_MATCH register must match the corresponding u2c request IntData bit for a match."},
#else
{16, 31, 0x0000000000000000, "RW", "INTDATA_MASK", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 15, 0x0000000000000000, "RW", "INTDATA_MATCH", "U2C Request IntData[15:0] value is compared with this field to generate a match for the U2C request address match."},
#else
{0, 15, 0x0000000000000000, "RW", "INTDATA_MATCH", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo1019[] = {{"B_CR_LITES0_U2CINTDATA_MATCH_0_0_0_MCHBAR", "", 0x00006C9C, 2, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields1020[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{39, 63, 0x0000000000000000, "RO", "RESERVED_1", "Reserved"},
#else
{39, 63, 0x0000000000000000, "RO", "RESERVED_1", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{3, 38, 0x0000000000000000, "RW", "ADDRESS_MATCH", "Address value to match for Lites"},
#else
{3, 38, 0x0000000000000000, "RW", "ADDRESS_MATCH", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 2, 0x0000000000000000, "RO", "RESERVED_0", "Reserved"},
#else
{0, 2, 0x0000000000000000, "RO", "RESERVED_0", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo1020[] = {{"B_CR_LITES0_ADDR_MATCH_0_0_0_MCHBAR", "", 0x00006CA0, 3, 0xFFFFFFFFFFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields1021[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{39, 63, 0x0000000000000000, "RO", "RESERVED_1", "Reserved"},
#else
{39, 63, 0x0000000000000000, "RO", "RESERVED_1", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{3, 38, 0x0000000000000000, "RW", "ADDRESS_MASK", "Address mask value used for comparing request address during filter operation for Lites.  If the mask bit in this register is 0 then the corresponding bit in the ADDR_MATCH register is ignored.  If the mask bit is 1  then the corresponding bit in the ADDR_MATCH register must match the corresponding request address bit for a match."},
#else
{3, 38, 0x0000000000000000, "RW", "ADDRESS_MASK", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 2, 0x0000000000000000, "RO", "RESERVED_0", "Reserved"},
#else
{0, 2, 0x0000000000000000, "RO", "RESERVED_0", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo1021[] = {{"B_CR_LITES0_ADDR_MASK_0_0_0_MCHBAR", "", 0x00006CA8, 3, 0xFFFFFFFFFFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields1022[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{0, 31, 0x0000000000000000, "RW", "DATA_MATCH", "Data value to match for Lites"},
#else
{0, 31, 0x0000000000000000, "RW", "DATA_MATCH", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo1022[] = {{"B_CR_LITES0_DATA_MATCH_0_0_0_MCHBAR", "", 0x00006CB0, 1, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields1023[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{0, 31, 0x0000000000000000, "RW", "DATA_MASK", "Data mask value used for comparing data during filter operations for Lites.  If the mask bit in this register is 0 then the corresponding bit in the DATA_MATCH register is ignored.  If the mask bit is 1 then the corresponding bit in the DATA_MATCH register must match the corresponding bit of the reques data for a match."},
#else
{0, 31, 0x0000000000000000, "RW", "DATA_MASK", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo1023[] = {{"B_CR_LITES0_DATA_MASK_0_0_0_MCHBAR", "", 0x00006CB4, 1, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields1024[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{14, 31, 0x0000000000000000, "RW", "IDI_LENGTH_MATCH", "Enables length matching for IDI requests for Lites Group 1.  Each bit when set to 1 enables match for that length for an IDI request.  Note: In certain cases the Bunit ignores the length field in the original IDI request. In order to produce a hit in these cases this field must be set accordingly FIXME:  which opcodes are these.                  Bit 31:64B                  Bit 30:16B                  Bit 29:15B                  Bit 28:14B                  Bit 27:13B                  Bit 26:12B                  Bit 25:11B                  Bit 24:10B                  Bit 23:9B                  Bit 22:8B                  Bit 21:7B                  Bit 20:6B                  Bit 19:5B                  Bit 18:4B                  Bit 17:3B                  Bit 16:2B                  Bit 15:1B                  Bit 14:0B"},
#else
{14, 31, 0x0000000000000000, "RW", "IDI_LENGTH_MATCH", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{12, 13, 0x0000000000000000, "RW", "PII_LENGTH_MATCH", "Enables length matching for PII requests for Lites Group 1.  Each bit when set to 1 enables  length match  for the PII request                  Bit 13:64B                   Bit 12:32B"},
#else
{12, 13, 0x0000000000000000, "RW", "PII_LENGTH_MATCH", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{10, 11, 0x0000000000000000, "RO", "RESERVED_0", "Reserved"},
#else
{10, 11, 0x0000000000000000, "RO", "RESERVED_0", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{8, 9, 0x0000000000000000, "RW", "SLICE_MATCH", "00:  All mask/match hits are suppressed 01:  Mask/Match hits enabled only for Slice0 10:  Mask/match hits enabled only for Slice1 11: Mask/Match hits enabled for both Slices"},
#else
{8, 9, 0x0000000000000000, "RW", "SLICE_MATCH", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{4, 7, 0x0000000000000000, "RW", "DWORD_SELECT", "DWord Select: Selects the dword within the 512bit data field that is compared for data mask/matches for Lites Group 1"},
#else
{4, 7, 0x0000000000000000, "RW", "DWORD_SELECT", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{3, 3, 0x0000000000000000, "RW", "ENABLE_DATA_MATCH", "When set  this field enables data matching on Lites Group 1"},
#else
{3, 3, 0x0000000000000000, "RW", "ENABLE_DATA_MATCH", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{2, 2, 0x0000000000000000, "RW", "ALTU2CREQVIEW", "When set address match/mask opcode match and agent match registers are used to generate matches for the U2C request observation point.  When clear Badmit observation point matches are reported on the U2C request observation point."},
#else
{2, 2, 0x0000000000000000, "RW", "ALTU2CREQVIEW", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{1, 1, 0x0000000000000000, "RW", "INVERT_ADDR_MATCH", "When set inverts the polarity of the address match/mask logic i.e. reports a match for addresses that are not in the specified range."},
#else
{1, 1, 0x0000000000000000, "RW", "INVERT_ADDR_MATCH", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 0, 0x0000000000000000, "RW", "ENABLE_GROUP", "Enables all match filters for Lites Group 1.  The following are the observation points that contain match filters  Badmit logic within each slice after a transaction is successfully admitted into the Bunit U2C request launch PMI datain for each PMI channel read data PMI dataout for each PMI channel write data agent data write to BRAM in each slice read data return on the live bypass and nonlive bypass paths in each slice.  To report a match at an observation point all match criteria for that point must be satisfied."},
#else
{0, 0, 0x0000000000000000, "RW", "ENABLE_GROUP", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo1024[] = {{"B_CR_LITES1_CTL_0_0_0_MCHBAR", "", 0x00006CC0, 9, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields1025[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{0, 31, 0x0000000000000000, "RW", "OPCODE_MATCH", "Bit vector that enables a match on the opcode for C2U IDI requests PII A2B requests and U2C IDI requests.  All three observation points  Badmit in both slices  and the U2C request interface  use this same opcode match register.  Each bit when set enables a match on the corresponding opcode and when clear will suppress a match on the corresponding opcode.  To match on any opcode set all bits to 1.  Bit 31: C2U_Req_CRd  Bit 30:C2U_Req_DRd  Bit 29: C2U_Req_DRdPTE  Bit 28: C2U_Req_SetMonitor  Bit 27: C2U_Req_RFO  Bit 26: C2U_Req_PRd  Bit 25: C2U_Req_UcRdF  Bit 24: C2U_Req_PortIn,U2C_Req_SnpCode  Bit 23: C2U_Req_IntA,U2C_Req_SnpData  Bit 22: C2U_Req_Lock  Bit 21: C2U_Req_SplitLock  Bit 20: C2U_Req_Unlock  Bit 19: C2U_Req_ItoM  Bit 18: C2U_Req_SpCyc,U2C_Req_SnpInv  Bit 17: C2U_Req_RdMonitor,U2C_Req_StopReq  Bit 16:C2U_Req_ClrMonitor,U2C_Req_StartReq  Bit 15: C2U_Req_CLFlush  Bit 14: C2U_Req_WbMtoI,U2C_Req_IntLog_MSI  Bit 13: C2U_Req_WbMtoE,U2C_Req_IntPhy_MSI  Bit 12: C2U_Req_WiL  Bit 11: C2U_Req_WCiL  Bit 10: C2U_Req_WCilF  Bit 9: C2U_Req_PortOut  Bit 8: C2U_Req_IntPriUp,U2C_Req_LTWrite  Bit 7: C2U_Req_IntLog  Bit 6: C2U_Req_IntPhy  Bit 5: C2U_Req_EOI,U2C_Req_VLW  Bit 4: C2U_Req_ItoMWr  Bit 3: A2B_Req_SnoopedRead  Bit 2: A2B_Req_UnSnoopedRead,U2C_Req_IntPhy_IPI  Bit 1: A2B_Req_SnoopedWrite  Bit 0: A2B_Req_UnSnoopedWrite,U2C_Req_IntLog_IPI"},
#else
{0, 31, 0x0000000000000000, "RW", "OPCODE_MATCH", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo1025[] = {{"B_CR_LITES1_OPCODE_MATCH_0_0_0_MCHBAR", "", 0x00006CC4, 1, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields1026[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{31, 31, 0x0000000000000000, "RW", "GT_MATCH", "This field is used to match IDI ransactions from GT for Lites Group0.  When set enables a match for a transaction origination from GT.  When clear suppresses a match for a transaction from GT."},
#else
{31, 31, 0x0000000000000000, "RW", "GT_MATCH", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{16, 30, 0x0000000000000000, "RW", "VC_MATCH", "This field is used to match VC Channel ID for PII transactions for Lites Group1.  Each bit when set enables a match for a transaction origination from that VC.  When clear suppresses a match for a transaction from that VC.      Bit 30: VC14   Bit 29: VC13   Bit 28: VC12   Bit 27: VC11   Bit 26: VC10   Bit 25: VC9   Bit 24: VC8   Bit 23: VC7   Bit 22: VC6   Bit 21: VC5   Bit 20: VC4   Bit 19: VC3   Bit 18: VC2   Bit 17: VC1   Bit 16: VC0"},
#else
{16, 30, 0x0000000000000000, "RW", "VC_MATCH", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 15, 0x0000000000000000, "RW", "CPU_CORE_MATCH", "This field is used to match Logical Processor Core ID for CPU IDI transactions for Lites Group 1.  Each bit when set enables a match for a transaction origination from that core.  When clear suppresses a match for a transaction from that core.   Bit 15: CPU7 Core1   Bit 14: CPU7 Core0   Bit 13: CPU6 Core1   Bit 12:  CPU6 Core0   Bit 11:  CPU5 Core1   Bit 10:  CPU5 Core0   Bit 9:  CPU4 Core1   Bit 8:  CPU4 Core0   Bit 7:  CPU3 Core1   Bit 6:  CPU3 Core0   Bit 5:  CPU2 Core1   Bit 4:  CPU2 Core0   Bit 3:  CPU1 Core1   Bit 2:  CPU1 Core0   Bit 1:  CPU0 Core1   Bit 0:  CPU0 Core0"},
#else
{0, 15, 0x0000000000000000, "RW", "CPU_CORE_MATCH", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo1026[] = {{"B_CR_LITES1_AGENT_MATCH_0_0_0_MCHBAR", "", 0x00006CC8, 3, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields1027[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{16, 31, 0x0000000000000000, "RW", "INTDATA_MASK", "Mask for U2C Request IntData[15:0] for generating Lites Group 1 U2C request alternative view match.   If the mask bit in this register is 0 then the corresponding bit in the INTDATA_MATCH register is ignored.  If the mask bit is 1  then the corresponding bit in the INTDATA_MATCH register must match the corresponding u2c request IntData bit for a match."},
#else
{16, 31, 0x0000000000000000, "RW", "INTDATA_MASK", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 15, 0x0000000000000000, "RW", "INTDATA_MATCH", "U2C Request IntData[15:0] value is compared with this field to generate a match for the U2C request address match."},
#else
{0, 15, 0x0000000000000000, "RW", "INTDATA_MATCH", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo1027[] = {{"B_CR_LITES1_U2CINTDATA_MATCH_0_0_0_MCHBAR", "", 0x00006CCC, 2, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields1028[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{39, 63, 0x0000000000000000, "RO", "RESERVED_1", "Reserved"},
#else
{39, 63, 0x0000000000000000, "RO", "RESERVED_1", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{3, 38, 0x0000000000000000, "RW", "ADDRESS_MATCH", "Address value to match for Lites"},
#else
{3, 38, 0x0000000000000000, "RW", "ADDRESS_MATCH", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 2, 0x0000000000000000, "RO", "RESERVED_0", "Reserved"},
#else
{0, 2, 0x0000000000000000, "RO", "RESERVED_0", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo1028[] = {{"B_CR_LITES1_ADDR_MATCH_0_0_0_MCHBAR", "", 0x00006CD0, 3, 0xFFFFFFFFFFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields1029[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{39, 63, 0x0000000000000000, "RO", "RESERVED_1", "Reserved"},
#else
{39, 63, 0x0000000000000000, "RO", "RESERVED_1", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{3, 38, 0x0000000000000000, "RW", "ADDRESS_MASK", "Address mask value used for comparing request address during filter operation for Lites.  If the mask bit in this register is 0 then the corresponding bit in the ADDR_MATCH register is ignored.  If the mask bit is 1  then the corresponding bit in the ADDR_MATCH register must match the corresponding request address bit for a match."},
#else
{3, 38, 0x0000000000000000, "RW", "ADDRESS_MASK", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 2, 0x0000000000000000, "RO", "RESERVED_0", "Reserved"},
#else
{0, 2, 0x0000000000000000, "RO", "RESERVED_0", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo1029[] = {{"B_CR_LITES1_ADDR_MASK_0_0_0_MCHBAR", "", 0x00006CD8, 3, 0xFFFFFFFFFFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields1030[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{0, 31, 0x0000000000000000, "RW", "DATA_MATCH", "Data value to match for Lites"},
#else
{0, 31, 0x0000000000000000, "RW", "DATA_MATCH", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo1030[] = {{"B_CR_LITES1_DATA_MATCH_0_0_0_MCHBAR", "", 0x00006CE0, 1, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields1031[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{0, 31, 0x0000000000000000, "RW", "DATA_MASK", "Data mask value used for comparing data during filter operations for Lites.  If the mask bit in this register is 0 then the corresponding bit in the DATA_MATCH register is ignored.  If the mask bit is 1 then the corresponding bit in the DATA_MATCH register must match the corresponding bit of the reques data for a match."},
#else
{0, 31, 0x0000000000000000, "RW", "DATA_MASK", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo1031[] = {{"B_CR_LITES1_DATA_MASK_0_0_0_MCHBAR", "", 0x00006CE4, 1, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields1032[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{14, 31, 0x0000000000000000, "RW", "IDI_LENGTH_MATCH", "Enables length matching for IDI requests for Lites Group 0.  Each bit when set to 1 enables match for that length for an IDI request.  Note: In certain cases the Bunit ignores the length field in the original IDI request. In order to produce a hit in these cases this field must be set accordingly FIXME:  which opcodes are these.                  Bit 31:64B                  Bit 30:16B                  Bit 29:15B                  Bit 28:14B                  Bit 27:13B                  Bit 26:12B                  Bit 25:11B                  Bit 24:10B                  Bit 23:9B                  Bit 22:8B                  Bit 21:7B                  Bit 20:6B                  Bit 19:5B                  Bit 18:4B                  Bit 17:3B                  Bit 16:2B                  Bit 15:1B                  Bit 14:0B"},
#else
{14, 31, 0x0000000000000000, "RW", "IDI_LENGTH_MATCH", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{12, 13, 0x0000000000000000, "RW", "PII_LENGTH_MATCH", "Enables length matching for PII requests for Lites Group 0.  Each bit when set to 1 enables  length match  for the PII request                  Bit 13:64B                   Bit 12:32B"},
#else
{12, 13, 0x0000000000000000, "RW", "PII_LENGTH_MATCH", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{10, 11, 0x0000000000000000, "RO", "RESERVED_0", "Reserved"},
#else
{10, 11, 0x0000000000000000, "RO", "RESERVED_0", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{8, 9, 0x0000000000000000, "RW", "SLICE_MATCH", "00:  All mask/match hits are suppressed 01:  Mask/Match hits enabled only for Slice0 10:  Mask/match hits enabled only for Slice1 11: Mask/Match hits enabled for both Slices"},
#else
{8, 9, 0x0000000000000000, "RW", "SLICE_MATCH", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{4, 7, 0x0000000000000000, "RW", "DWORD_SELECT", "DWord Select: Selects the dword within the 512bit data field that is compared for data mask/matches for Lites Group 2"},
#else
{4, 7, 0x0000000000000000, "RW", "DWORD_SELECT", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{3, 3, 0x0000000000000000, "RW", "ENABLE_DATA_MATCH", "When set  this field enables data matching on Lites Group 2"},
#else
{3, 3, 0x0000000000000000, "RW", "ENABLE_DATA_MATCH", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{2, 2, 0x0000000000000000, "RW", "ALTU2CREQVIEW", "When set address match/mask opcode match and agent match registers are used to generate matches for the U2C request observation point.  When clear Badmit observation point matches are reported on the U2C request observation point."},
#else
{2, 2, 0x0000000000000000, "RW", "ALTU2CREQVIEW", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{1, 1, 0x0000000000000000, "RW", "INVERT_ADDR_MATCH", "When set inverts the polarity of the address match/mask logic i.e. reports a match for addresses that are not in the specified range."},
#else
{1, 1, 0x0000000000000000, "RW", "INVERT_ADDR_MATCH", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 0, 0x0000000000000000, "RW", "ENABLE_GROUP", "Enables all match filters for Lites Group 2.  The following are the observation points that contain match filters  Badmit logic within each slice after a transaction is successfully admitted into the Bunit U2C request launch PMI datain for each PMI channel read data PMI dataout for each PMI channel write data agent data write to BRAM in each slice read data return on the live bypass and nonlive bypass paths in each slice.  To report a match at an observation point all match criteria for that point must be satisfied."},
#else
{0, 0, 0x0000000000000000, "RW", "ENABLE_GROUP", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo1032[] = {{"B_CR_LITES2_CTL_0_0_0_MCHBAR", "", 0x00006CF0, 9, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields1033[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{0, 31, 0x0000000000000000, "RW", "OPCODE_MATCH", "Bit vector that enables a match on the opcode for C2U IDI requests PII A2B requests and U2C IDI requests.  All three observation points  Badmit in both slices  and the U2C request interface  use this same opcode match register.  Each bit when set enables a match on the corresponding opcode and when clear will suppress a match on the corresponding opcode.  To match on any opcode set all bits to 1.  Bit 31: C2U_Req_CRd  Bit 30:C2U_Req_DRd  Bit 29: C2U_Req_DRdPTE  Bit 28: C2U_Req_SetMonitor  Bit 27: C2U_Req_RFO  Bit 26: C2U_Req_PRd  Bit 25: C2U_Req_UcRdF  Bit 24: C2U_Req_PortIn,U2C_Req_SnpCode  Bit 23: C2U_Req_IntA,U2C_Req_SnpData  Bit 22: C2U_Req_Lock  Bit 21: C2U_Req_SplitLock  Bit 20: C2U_Req_Unlock  Bit 19: C2U_Req_ItoM  Bit 18: C2U_Req_SpCyc,U2C_Req_SnpInv  Bit 17: C2U_Req_RdMonitor,U2C_Req_StopReq  Bit 16:C2U_Req_ClrMonitor,U2C_Req_StartReq  Bit 15: C2U_Req_CLFlush  Bit 14: C2U_Req_WbMtoI,U2C_Req_IntLog_MSI  Bit 13: C2U_Req_WbMtoE,U2C_Req_IntPhy_MSI  Bit 12: C2U_Req_WiL  Bit 11: C2U_Req_WCiL  Bit 10: C2U_Req_WCilF  Bit 9: C2U_Req_PortOut  Bit 8: C2U_Req_IntPriUp,U2C_Req_LTWrite  Bit 7: C2U_Req_IntLog  Bit 6: C2U_Req_IntPhy  Bit 5: C2U_Req_EOI,U2C_Req_VLW  Bit 4: C2U_Req_ItoMWr  Bit 3: A2B_Req_SnoopedRead  Bit 2: A2B_Req_UnSnoopedRead,U2C_Req_IntPhy_IPI  Bit 1: A2B_Req_SnoopedWrite  Bit 0: A2B_Req_UnSnoopedWrite,U2C_Req_IntLog_IPI"},
#else
{0, 31, 0x0000000000000000, "RW", "OPCODE_MATCH", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo1033[] = {{"B_CR_LITES2_OPCODE_MATCH_0_0_0_MCHBAR", "", 0x00006CF4, 1, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields1034[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{31, 31, 0x0000000000000000, "RW", "GT_MATCH", "This field is used to match IDI ransactions from GT for Lites Group0.  When set enables a match for a transaction origination from GT.  When clear suppresses a match for a transaction from GT."},
#else
{31, 31, 0x0000000000000000, "RW", "GT_MATCH", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{16, 30, 0x0000000000000000, "RW", "VC_MATCH", "This field is used to match VC Channel ID for PII transactions for Lites Group2.  Each bit when set enables a match for a transaction origination from that VC.  When clear suppresses a match for a transaction from that VC.      Bit 30: VC14   Bit 29: VC13   Bit 28: VC12   Bit 27: VC11   Bit 26: VC10   Bit 25: VC9   Bit 24: VC8   Bit 23: VC7   Bit 22: VC6   Bit 21: VC5   Bit 20: VC4   Bit 19: VC3   Bit 18: VC2   Bit 17: VC1   Bit 16: VC0"},
#else
{16, 30, 0x0000000000000000, "RW", "VC_MATCH", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 15, 0x0000000000000000, "RW", "CPU_CORE_MATCH", "This field is used to match Logical Processor Core ID for CPU IDI transactions for Lites Group 2.  Each bit when set enables a match for a transaction origination from that core.  When clear suppresses a match for a transaction from that core.   Bit 15: CPU7 Core1   Bit 14: CPU7 Core0   Bit 13: CPU6 Core1   Bit 12:  CPU6 Core0   Bit 11:  CPU5 Core1   Bit 10:  CPU5 Core0   Bit 9:  CPU4 Core1   Bit 8:  CPU4 Core0   Bit 7:  CPU3 Core1   Bit 6:  CPU3 Core0   Bit 5:  CPU2 Core1   Bit 4:  CPU2 Core0   Bit 3:  CPU1 Core1   Bit 2:  CPU1 Core0   Bit 1:  CPU0 Core1   Bit 0:  CPU0 Core0"},
#else
{0, 15, 0x0000000000000000, "RW", "CPU_CORE_MATCH", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo1034[] = {{"B_CR_LITES2_AGENT_MATCH_0_0_0_MCHBAR", "", 0x00006CF8, 3, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields1035[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{16, 31, 0x0000000000000000, "RW", "INTDATA_MASK", "Mask for U2C Request IntData[15:0] for generating Lites Group 2 U2C request alternative view match.   If the mask bit in this register is 0 then the corresponding bit in the INTDATA_MATCH register is ignored.  If the mask bit is 1  then the corresponding bit in the INTDATA_MATCH register must match the corresponding u2c request IntData bit for a match."},
#else
{16, 31, 0x0000000000000000, "RW", "INTDATA_MASK", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 15, 0x0000000000000000, "RW", "INTDATA_MATCH", "U2C Request IntData[15:0] value is compared with this field to generate a match for the U2C request address match."},
#else
{0, 15, 0x0000000000000000, "RW", "INTDATA_MATCH", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo1035[] = {{"B_CR_LITES2_U2CINTDATA_MATCH_0_0_0_MCHBAR", "", 0x00006CFC, 2, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields1036[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{39, 63, 0x0000000000000000, "RO", "RESERVED_1", "Reserved"},
#else
{39, 63, 0x0000000000000000, "RO", "RESERVED_1", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{3, 38, 0x0000000000000000, "RW", "ADDRESS_MATCH", "Address value to match for Lites"},
#else
{3, 38, 0x0000000000000000, "RW", "ADDRESS_MATCH", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 2, 0x0000000000000000, "RO", "RESERVED_0", "Reserved"},
#else
{0, 2, 0x0000000000000000, "RO", "RESERVED_0", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo1036[] = {{"B_CR_LITES2_ADDR_MATCH_0_0_0_MCHBAR", "", 0x00006D00, 3, 0xFFFFFFFFFFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields1037[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{39, 63, 0x0000000000000000, "RO", "RESERVED_1", "Reserved"},
#else
{39, 63, 0x0000000000000000, "RO", "RESERVED_1", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{3, 38, 0x0000000000000000, "RW", "ADDRESS_MASK", "Address mask value used for comparing request address during filter operation for Lites.  If the mask bit in this register is 0 then the corresponding bit in the ADDR_MATCH register is ignored.  If the mask bit is 1  then the corresponding bit in the ADDR_MATCH register must match the corresponding request address bit for a match."},
#else
{3, 38, 0x0000000000000000, "RW", "ADDRESS_MASK", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 2, 0x0000000000000000, "RO", "RESERVED_0", "Reserved"},
#else
{0, 2, 0x0000000000000000, "RO", "RESERVED_0", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo1037[] = {{"B_CR_LITES2_ADDR_MASK_0_0_0_MCHBAR", "", 0x00006D08, 3, 0xFFFFFFFFFFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields1038[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{0, 31, 0x0000000000000000, "RW", "DATA_MATCH", "Data value to match for Lites"},
#else
{0, 31, 0x0000000000000000, "RW", "DATA_MATCH", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo1038[] = {{"B_CR_LITES2_DATA_MATCH_0_0_0_MCHBAR", "", 0x00006D10, 1, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields1039[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{0, 31, 0x0000000000000000, "RW", "DATA_MASK", "Data mask value used for comparing data during filter operations for Lites.  If the mask bit in this register is 0 then the corresponding bit in the DATA_MATCH register is ignored.  If the mask bit is 1 then the corresponding bit in the DATA_MATCH register must match the corresponding bit of the reques data for a match."},
#else
{0, 31, 0x0000000000000000, "RW", "DATA_MASK", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo1039[] = {{"B_CR_LITES2_DATA_MASK_0_0_0_MCHBAR", "", 0x00006D14, 1, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields1040[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{14, 31, 0x0000000000000000, "RW", "IDI_LENGTH_MATCH", "Enables length matching for IDI requests for Lites Group 0.  Each bit when set to 1 enables match for that length for an IDI request.  Note: In certain cases the Bunit ignores the length field in the original IDI request. In order to produce a hit in these cases this field must be set accordingly FIXME:  which opcodes are these.                  Bit 31:64B                  Bit 30:16B                  Bit 29:15B                  Bit 28:14B                  Bit 27:13B                  Bit 26:12B                  Bit 25:11B                  Bit 24:10B                  Bit 23:9B                  Bit 22:8B                  Bit 21:7B                  Bit 20:6B                  Bit 19:5B                  Bit 18:4B                  Bit 17:3B                  Bit 16:2B                  Bit 15:1B                  Bit 14:0B"},
#else
{14, 31, 0x0000000000000000, "RW", "IDI_LENGTH_MATCH", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{12, 13, 0x0000000000000000, "RW", "PII_LENGTH_MATCH", "Enables length matching for PII requests for Lites Group 0.  Each bit when set to 1 enables  length match  for the PII request                  Bit 13:64B                   Bit 12:32B"},
#else
{12, 13, 0x0000000000000000, "RW", "PII_LENGTH_MATCH", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{10, 11, 0x0000000000000000, "RO", "RESERVED_0", "Reserved"},
#else
{10, 11, 0x0000000000000000, "RO", "RESERVED_0", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{8, 9, 0x0000000000000000, "RW", "SLICE_MATCH", "00:  All mask/match hits are suppressed 01:  Mask/Match hits enabled only for Slice0 10:  Mask/match hits enabled only for Slice1 11: Mask/Match hits enabled for both Slices"},
#else
{8, 9, 0x0000000000000000, "RW", "SLICE_MATCH", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{4, 7, 0x0000000000000000, "RW", "DWORD_SELECT", "DWord Select: Selects the dword within the 512bit data field that is compared for data mask/matches for Lites Group 3"},
#else
{4, 7, 0x0000000000000000, "RW", "DWORD_SELECT", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{3, 3, 0x0000000000000000, "RW", "ENABLE_DATA_MATCH", "When set  this field enables data matching on Lites Group 3"},
#else
{3, 3, 0x0000000000000000, "RW", "ENABLE_DATA_MATCH", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{2, 2, 0x0000000000000000, "RW", "ALTU2CREQVIEW", "When set address match/mask opcode match and agent match registers are used to generate matches for the U2C request observation point.  When clear Badmit observation point matches are reported on the U2C request observation point."},
#else
{2, 2, 0x0000000000000000, "RW", "ALTU2CREQVIEW", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{1, 1, 0x0000000000000000, "RW", "INVERT_ADDR_MATCH", "When set inverts the polarity of the address match/mask logic i.e. reports a match for addresses that are not in the specified range."},
#else
{1, 1, 0x0000000000000000, "RW", "INVERT_ADDR_MATCH", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 0, 0x0000000000000000, "RW", "ENABLE_GROUP", "Enables all match filters for Lites Group 3.  The following are the observation points that contain match filters  Badmit logic within each slice after a transaction is successfully admitted into the Bunit U2C request launch PMI datain for each PMI channel read data PMI dataout for each PMI channel write data agent data write to BRAM in each slice read data return on the live bypass and nonlive bypass paths in each slice.  To report a match at an observation point all match criteria for that point must be satisfied."},
#else
{0, 0, 0x0000000000000000, "RW", "ENABLE_GROUP", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo1040[] = {{"B_CR_LITES3_CTL_0_0_0_MCHBAR", "", 0x00006D20, 9, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields1041[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{0, 31, 0x0000000000000000, "RW", "OPCODE_MATCH", "Bit vector that enables a match on the opcode for C2U IDI requests PII A2B requests and U2C IDI requests.  All three observation points  Badmit in both slices  and the U2C request interface  use this same opcode match register.  Each bit when set enables a match on the corresponding opcode and when clear will suppress a match on the corresponding opcode.  To match on any opcode set all bits to 1.  Bit 31: C2U_Req_CRd  Bit 30:C2U_Req_DRd  Bit 29: C2U_Req_DRdPTE  Bit 28: C2U_Req_SetMonitor  Bit 27: C2U_Req_RFO  Bit 26: C2U_Req_PRd  Bit 25: C2U_Req_UcRdF  Bit 24: C2U_Req_PortIn,U2C_Req_SnpCode  Bit 23: C2U_Req_IntA,U2C_Req_SnpData  Bit 22: C2U_Req_Lock  Bit 21: C2U_Req_SplitLock  Bit 20: C2U_Req_Unlock  Bit 19: C2U_Req_ItoM  Bit 18: C2U_Req_SpCyc,U2C_Req_SnpInv  Bit 17: C2U_Req_RdMonitor,U2C_Req_StopReq  Bit 16:C2U_Req_ClrMonitor,U2C_Req_StartReq  Bit 15: C2U_Req_CLFlush  Bit 14: C2U_Req_WbMtoI,U2C_Req_IntLog_MSI  Bit 13: C2U_Req_WbMtoE,U2C_Req_IntPhy_MSI  Bit 12: C2U_Req_WiL  Bit 11: C2U_Req_WCiL  Bit 10: C2U_Req_WCilF  Bit 9: C2U_Req_PortOut  Bit 8: C2U_Req_IntPriUp,U2C_Req_LTWrite  Bit 7: C2U_Req_IntLog  Bit 6: C2U_Req_IntPhy  Bit 5: C2U_Req_EOI,U2C_Req_VLW  Bit 4: C2U_Req_ItoMWr  Bit 3: A2B_Req_SnoopedRead  Bit 2: A2B_Req_UnSnoopedRead,U2C_Req_IntPhy_IPI  Bit 1: A2B_Req_SnoopedWrite  Bit 0: A2B_Req_UnSnoopedWrite,U2C_Req_IntLog_IPI"},
#else
{0, 31, 0x0000000000000000, "RW", "OPCODE_MATCH", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo1041[] = {{"B_CR_LITES3_OPCODE_MATCH_0_0_0_MCHBAR", "", 0x00006D24, 1, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields1042[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{31, 31, 0x0000000000000000, "RW", "GT_MATCH", "This field is used to match IDI ransactions from GT for Lites Group0.  When set enables a match for a transaction origination from GT.  When clear suppresses a match for a transaction from GT."},
#else
{31, 31, 0x0000000000000000, "RW", "GT_MATCH", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{16, 30, 0x0000000000000000, "RW", "VC_MATCH", "This field is used to match VC Channel ID for PII transactions for Lites Group3.  Each bit when set enables a match for a transaction origination from that VC.  When clear suppresses a match for a transaction from that VC.      Bit 30: VC14   Bit 29: VC13   Bit 28: VC12   Bit 27: VC11   Bit 26: VC10   Bit 25: VC9   Bit 24: VC8   Bit 23: VC7   Bit 22: VC6   Bit 21: VC5   Bit 20: VC4   Bit 19: VC3   Bit 18: VC2   Bit 17: VC1   Bit 16: VC0"},
#else
{16, 30, 0x0000000000000000, "RW", "VC_MATCH", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 15, 0x0000000000000000, "RW", "CPU_CORE_MATCH", "This field is used to match Logical Processor Core ID for CPU IDI transactions for Lites Group 3.  Each bit when set enables a match for a transaction origination from that core.  When clear suppresses a match for a transaction from that core.   Bit 15: CPU7 Core1   Bit 14: CPU7 Core0   Bit 13: CPU6 Core1   Bit 12:  CPU6 Core0   Bit 11:  CPU5 Core1   Bit 10:  CPU5 Core0   Bit 9:  CPU4 Core1   Bit 8:  CPU4 Core0   Bit 7:  CPU3 Core1   Bit 6:  CPU3 Core0   Bit 5:  CPU2 Core1   Bit 4:  CPU2 Core0   Bit 3:  CPU1 Core1   Bit 2:  CPU1 Core0   Bit 1:  CPU0 Core1   Bit 0:  CPU0 Core0"},
#else
{0, 15, 0x0000000000000000, "RW", "CPU_CORE_MATCH", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo1042[] = {{"B_CR_LITES3_AGENT_MATCH_0_0_0_MCHBAR", "", 0x00006D28, 3, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields1043[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{16, 31, 0x0000000000000000, "RW", "INTDATA_MASK", "Mask for U2C Request IntData[15:0] for generating Lites Group 3 U2C request alternative view match.   If the mask bit in this register is 0 then the corresponding bit in the INTDATA_MATCH register is ignored.  If the mask bit is 1  then the corresponding bit in the INTDATA_MATCH register must match the corresponding u2c request IntData bit for a match."},
#else
{16, 31, 0x0000000000000000, "RW", "INTDATA_MASK", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 15, 0x0000000000000000, "RW", "INTDATA_MATCH", "U2C Request IntData[15:0] value is compared with this field to generate a match for the U2C request address match."},
#else
{0, 15, 0x0000000000000000, "RW", "INTDATA_MATCH", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo1043[] = {{"B_CR_LITES3_U2CINTDATA_MATCH_0_0_0_MCHBAR", "", 0x00006D2C, 2, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields1044[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{39, 63, 0x0000000000000000, "RO", "RESERVED_1", "Reserved"},
#else
{39, 63, 0x0000000000000000, "RO", "RESERVED_1", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{3, 38, 0x0000000000000000, "RW", "ADDRESS_MATCH", "Address value to match for Lites"},
#else
{3, 38, 0x0000000000000000, "RW", "ADDRESS_MATCH", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 2, 0x0000000000000000, "RO", "RESERVED_0", "Reserved"},
#else
{0, 2, 0x0000000000000000, "RO", "RESERVED_0", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo1044[] = {{"B_CR_LITES3_ADDR_MATCH_0_0_0_MCHBAR", "", 0x00006D30, 3, 0xFFFFFFFFFFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields1045[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{39, 63, 0x0000000000000000, "RO", "RESERVED_1", "Reserved"},
#else
{39, 63, 0x0000000000000000, "RO", "RESERVED_1", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{3, 38, 0x0000000000000000, "RW", "ADDRESS_MASK", "Address mask value used for comparing request address during filter operation for Lites.  If the mask bit in this register is 0 then the corresponding bit in the ADDR_MATCH register is ignored.  If the mask bit is 1  then the corresponding bit in the ADDR_MATCH register must match the corresponding request address bit for a match."},
#else
{3, 38, 0x0000000000000000, "RW", "ADDRESS_MASK", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 2, 0x0000000000000000, "RO", "RESERVED_0", "Reserved"},
#else
{0, 2, 0x0000000000000000, "RO", "RESERVED_0", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo1045[] = {{"B_CR_LITES3_ADDR_MASK_0_0_0_MCHBAR", "", 0x00006D38, 3, 0xFFFFFFFFFFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields1046[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{0, 31, 0x0000000000000000, "RW", "DATA_MATCH", "Data value to match for Lites"},
#else
{0, 31, 0x0000000000000000, "RW", "DATA_MATCH", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo1046[] = {{"B_CR_LITES3_DATA_MATCH_0_0_0_MCHBAR", "", 0x00006D40, 1, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields1047[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{0, 31, 0x0000000000000000, "RW", "DATA_MASK", "Data mask value used for comparing data during filter operations for Lites.  If the mask bit in this register is 0 then the corresponding bit in the DATA_MATCH register is ignored.  If the mask bit is 1 then the corresponding bit in the DATA_MATCH register must match the corresponding bit of the reques data for a match."},
#else
{0, 31, 0x0000000000000000, "RW", "DATA_MASK", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo1047[] = {{"B_CR_LITES3_DATA_MASK_0_0_0_MCHBAR", "", 0x00006D44, 1, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields1048[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{31, 31, 0x0000000000000000, "RW", "ENABLE_LITES", "0: Lites logic is disabled.  All Lites Views will be driven to 0s.  1: Lites logic is enabled."},
#else
{31, 31, 0x0000000000000000, "RW", "ENABLE_LITES", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{30, 30, 0x0000000000000000, "RO", "RESERVED_0", "Reserved"},
#else
{30, 30, 0x0000000000000000, "RO", "RESERVED_0", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{26, 29, 0x0000000000000000, "RW", "EMON_BARB_CQ_SELECT", "Select barb conflictQ FIFO; 0000 to 0111: pii0 to pii7, 1xx0: idi slice0, 1xx1: idi slice1"},
#else
{26, 29, 0x0000000000000000, "RW", "EMON_BARB_CQ_SELECT", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{24, 25, 0x0000000000000000, "RW", "EMON_BARB_INGRESS_SELECT", "Select barb ingress FIFO; 00: GLM0, 01: GLM1, 10: GT slice0, 11: GT slice1"},
#else
{24, 25, 0x0000000000000000, "RW", "EMON_BARB_INGRESS_SELECT", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{13, 23, 0x0000000000000000, "RW", "EMON_VC_MASK", "Bunit and Tunit expose only the Emons corresponding to the VC(s) specified in this field (it is a mask)."},
#else
{13, 23, 0x0000000000000000, "RW", "EMON_VC_MASK", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{5, 12, 0x0000000000000000, "RW", "EMON_IDI_MASK", "Bunit and Tunit expose only the Emons corresponding to the IDI agent(s) specified in this field (it is a mask).  IDI agent refers to GLM modules and GT not Sunits"},
#else
{5, 12, 0x0000000000000000, "RW", "EMON_IDI_MASK", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{2, 4, 0x0000000000000000, "RW", "LITES_IDI_SELECT", "Bunit and Tunit expose only the views corresponding to the IDI agent specified in this field.  IDI agents only refer to GT and GLM modules not Sunits.  Used only on the C2U response views."},
#else
{2, 4, 0x0000000000000000, "RW", "LITES_IDI_SELECT", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{1, 1, 0x0000000000000000, "RW", "LITES_SLICE_SELECT", "When set to 0 Bunit and Tunit expose only Slice0 views.  No Lites observability of any transaction routed to Slice 1.   When set to 1 Bunit and Tunit expose only Slice1 views.  No Lites observability of any transaction routed to Slice0."},
#else
{1, 1, 0x0000000000000000, "RW", "LITES_SLICE_SELECT", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 0, 0x0000000000000000, "RW", "LITES_PMI_SELECT", "When set to 0 Bunit exposes only PMI channel 0 views in either slice.  No Lites observability of any transaction routed to PMI channel 1 in either slice.   When set to 1 Bunit exposes only PMI Channel 1 views  in either slice.  No Lites observability of any transaction routed to PMI channel 1 in either slice."},
#else
{0, 0, 0x0000000000000000, "RW", "LITES_PMI_SELECT", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo1048[] = {{"B_CR_LITESEMON_CTL_0_0_0_MCHBAR", "", 0x00006D48, 9, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields1049[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{30, 31, 0x0000000000000000, "RO", "RESERVED_0", "Reserved"},
#else
{30, 31, 0x0000000000000000, "RO", "RESERVED_0", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{24, 29, 0x0000000000000004, "RW", "AGENT3_WEIGHT", "Agent 3 Weight : Arbiter weight for Agent 3"},
#else
{24, 29, 0x0000000000000004, "RW", "AGENT3_WEIGHT", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{22, 23, 0x0000000000000000, "RO", "RESERVED_1", "Reserved"},
#else
{22, 23, 0x0000000000000000, "RO", "RESERVED_1", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{16, 21, 0x0000000000000004, "RW", "AGENT2_WEIGHT", "Agent 2 Weight : Arbiter weight for Agent 2"},
#else
{16, 21, 0x0000000000000004, "RW", "AGENT2_WEIGHT", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{14, 15, 0x0000000000000000, "RO", "RESERVED_2", "Reserved"},
#else
{14, 15, 0x0000000000000000, "RO", "RESERVED_2", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{8, 13, 0x0000000000000004, "RW", "AGENT1_WEIGHT", "Agent 1 Weight : Arbiter weight for Agent 1"},
#else
{8, 13, 0x0000000000000004, "RW", "AGENT1_WEIGHT", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{6, 7, 0x0000000000000000, "RO", "RESERVED_3", "Reserved"},
#else
{6, 7, 0x0000000000000000, "RO", "RESERVED_3", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 5, 0x0000000000000004, "RW", "AGENT0_WEIGHT", "Agent 0 Weight : Arbiter weight for Agent 0"},
#else
{0, 5, 0x0000000000000004, "RW", "AGENT0_WEIGHT", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo1049[] = {{"B_CR_BARBCTRL0", "", 0x00006D4C, 8, 0x00000000FFFFFFFF, 0x0000000004040404}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields1050[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{30, 31, 0x0000000000000000, "RO", "RESERVED_0", "Reserved"},
#else
{30, 31, 0x0000000000000000, "RO", "RESERVED_0", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{24, 29, 0x0000000000000004, "RW", "AGENT7_WEIGHT", "Agent 7 Weight : Arbiter weight for Agent 7"},
#else
{24, 29, 0x0000000000000004, "RW", "AGENT7_WEIGHT", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{22, 23, 0x0000000000000000, "RO", "RESERVED_1", "Reserved"},
#else
{22, 23, 0x0000000000000000, "RO", "RESERVED_1", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{16, 21, 0x0000000000000004, "RW", "AGENT6_WEIGHT", "Agent 6 Weight : Arbiter weight for Agent 6"},
#else
{16, 21, 0x0000000000000004, "RW", "AGENT6_WEIGHT", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{14, 15, 0x0000000000000000, "RO", "RESERVED_2", "Reserved"},
#else
{14, 15, 0x0000000000000000, "RO", "RESERVED_2", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{8, 13, 0x0000000000000004, "RW", "AGENT5_WEIGHT", "Agent 5 Weight : Arbiter weight for Agent 5"},
#else
{8, 13, 0x0000000000000004, "RW", "AGENT5_WEIGHT", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{6, 7, 0x0000000000000000, "RO", "RESERVED_3", "Reserved"},
#else
{6, 7, 0x0000000000000000, "RO", "RESERVED_3", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 5, 0x0000000000000004, "RW", "AGENT4_WEIGHT", "Agent 4 Weight : Arbiter weight for Agent 4"},
#else
{0, 5, 0x0000000000000004, "RW", "AGENT4_WEIGHT", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo1050[] = {{"B_CR_BARBCTRL1", "", 0x00006D50, 8, 0x00000000FFFFFFFF, 0x0000000004040404}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields1051[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{30, 31, 0x0000000000000000, "RO", "RESERVED_0", "Reserved"},
#else
{30, 31, 0x0000000000000000, "RO", "RESERVED_0", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{24, 29, 0x0000000000000004, "RW", "AGENT3_WEIGHT", "Agent 3 Weight : Arbiter weight for Agent 3"},
#else
{24, 29, 0x0000000000000004, "RW", "AGENT3_WEIGHT", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{22, 23, 0x0000000000000000, "RO", "RESERVED_1", "Reserved"},
#else
{22, 23, 0x0000000000000000, "RO", "RESERVED_1", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{16, 21, 0x0000000000000004, "RW", "AGENT2_WEIGHT", "Agent 2 Weight : Arbiter weight for Agent 2"},
#else
{16, 21, 0x0000000000000004, "RW", "AGENT2_WEIGHT", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{14, 15, 0x0000000000000000, "RO", "RESERVED_2", "Reserved"},
#else
{14, 15, 0x0000000000000000, "RO", "RESERVED_2", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{8, 13, 0x0000000000000004, "RW", "AGENT1_WEIGHT", "Agent 1 Weight : Arbiter weight for Agent 1"},
#else
{8, 13, 0x0000000000000004, "RW", "AGENT1_WEIGHT", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{6, 7, 0x0000000000000000, "RO", "RESERVED_3", "Reserved"},
#else
{6, 7, 0x0000000000000000, "RO", "RESERVED_3", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 5, 0x0000000000000004, "RW", "AGENT0_WEIGHT", "Agent 0 Weight : Arbiter weight for Agent 0"},
#else
{0, 5, 0x0000000000000004, "RW", "AGENT0_WEIGHT", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo1051[] = {{"B_CR_BSCHWT0", "", 0x00006D54, 8, 0x00000000FFFFFFFF, 0x0000000004040404}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields1052[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{30, 31, 0x0000000000000000, "RO", "RESERVED_0", "Reserved"},
#else
{30, 31, 0x0000000000000000, "RO", "RESERVED_0", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{24, 29, 0x0000000000000004, "RW", "AGENT7_WEIGHT", "Agent 7 Weight : Arbiter weight for Agent 7"},
#else
{24, 29, 0x0000000000000004, "RW", "AGENT7_WEIGHT", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{22, 23, 0x0000000000000000, "RO", "RESERVED_1", "Reserved"},
#else
{22, 23, 0x0000000000000000, "RO", "RESERVED_1", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{16, 21, 0x0000000000000004, "RW", "AGENT6_WEIGHT", "Agent 6 Weight : Arbiter weight for Agent 6"},
#else
{16, 21, 0x0000000000000004, "RW", "AGENT6_WEIGHT", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{14, 15, 0x0000000000000000, "RO", "RESERVED_2", "Reserved"},
#else
{14, 15, 0x0000000000000000, "RO", "RESERVED_2", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{8, 13, 0x0000000000000004, "RW", "AGENT5_WEIGHT", "Agent 5 Weight : Arbiter weight for Agent 5"},
#else
{8, 13, 0x0000000000000004, "RW", "AGENT5_WEIGHT", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{6, 7, 0x0000000000000000, "RO", "RESERVED_3", "Reserved"},
#else
{6, 7, 0x0000000000000000, "RO", "RESERVED_3", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 5, 0x0000000000000004, "RW", "AGENT4_WEIGHT", "Agent 4 Weight : Arbiter weight for Agent 4"},
#else
{0, 5, 0x0000000000000004, "RW", "AGENT4_WEIGHT", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo1052[] = {{"B_CR_BSCHWT1", "", 0x00006D58, 8, 0x00000000FFFFFFFF, 0x0000000004040404}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields1053[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{30, 31, 0x0000000000000000, "RO", "RESERVED_0", "Reserved"},
#else
{30, 31, 0x0000000000000000, "RO", "RESERVED_0", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{24, 29, 0x0000000000000004, "RW", "AGENT11_WEIGHT", "Agent 11 Weight : Arbiter weight for Agent 11"},
#else
{24, 29, 0x0000000000000004, "RW", "AGENT11_WEIGHT", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{22, 23, 0x0000000000000000, "RO", "RESERVED_1", "Reserved"},
#else
{22, 23, 0x0000000000000000, "RO", "RESERVED_1", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{16, 21, 0x0000000000000004, "RW", "AGENT10_WEIGHT", "Agent 10 Weight : Arbiter weight for Agent 10"},
#else
{16, 21, 0x0000000000000004, "RW", "AGENT10_WEIGHT", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{14, 15, 0x0000000000000000, "RO", "RESERVED_2", "Reserved"},
#else
{14, 15, 0x0000000000000000, "RO", "RESERVED_2", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{8, 13, 0x0000000000000004, "RW", "AGENT9_WEIGHT", "Agent 9 Weight : Arbiter weight for Agent 9"},
#else
{8, 13, 0x0000000000000004, "RW", "AGENT9_WEIGHT", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{6, 7, 0x0000000000000000, "RO", "RESERVED_3", "Reserved"},
#else
{6, 7, 0x0000000000000000, "RO", "RESERVED_3", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 5, 0x0000000000000004, "RW", "AGENT8_WEIGHT", "Agent 8 Weight   : Arbiter weight for Agent 8"},
#else
{0, 5, 0x0000000000000004, "RW", "AGENT8_WEIGHT", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo1053[] = {{"B_CR_BSCHWT2", "", 0x00006D5C, 8, 0x00000000FFFFFFFF, 0x0000000004040404}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields1054[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{30, 31, 0x0000000000000000, "RO", "RESERVED_0", "Reserved"},
#else
{30, 31, 0x0000000000000000, "RO", "RESERVED_0", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{24, 29, 0x0000000000000004, "RW", "AGENT15_WEIGHT", "Agent 15 Weight : Arbiter weight for Agent 15"},
#else
{24, 29, 0x0000000000000004, "RW", "AGENT15_WEIGHT", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{22, 23, 0x0000000000000000, "RO", "RESERVED_1", "Reserved"},
#else
{22, 23, 0x0000000000000000, "RO", "RESERVED_1", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{16, 21, 0x0000000000000004, "RW", "AGENT14_WEIGHT", "Agent 14 Weight : Arbiter weight for Agent 14"},
#else
{16, 21, 0x0000000000000004, "RW", "AGENT14_WEIGHT", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{14, 15, 0x0000000000000000, "RO", "RESERVED_2", "Reserved"},
#else
{14, 15, 0x0000000000000000, "RO", "RESERVED_2", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{8, 13, 0x0000000000000004, "RW", "AGENT13_WEIGHT", "Agent 13 Weight : Arbiter weight for Agent 13"},
#else
{8, 13, 0x0000000000000004, "RW", "AGENT13_WEIGHT", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{6, 7, 0x0000000000000000, "RO", "RESERVED_3", "Reserved"},
#else
{6, 7, 0x0000000000000000, "RO", "RESERVED_3", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 5, 0x0000000000000004, "RW", "AGENT12_WEIGHT", "Agent 12 Weight   : Arbiter weight for Agent 12"},
#else
{0, 5, 0x0000000000000004, "RW", "AGENT12_WEIGHT", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo1054[] = {{"B_CR_BSCHWT3", "", 0x00006D60, 8, 0x00000000FFFFFFFF, 0x0000000004040404}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields1055[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{24, 31, 0x00000000000000FF, "RW", "FLUSH_THRESHOLD", "Flush Threshold: All writes command are blocked at Badmit if the number of write commands in the Flush Pool exceeeds this value."},
#else
{24, 31, 0x00000000000000FF, "RW", "FLUSH_THRESHOLD", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{17, 23, 0x0000000000000000, "RO", "RESERVED_0", "Reserved"},
#else
{17, 23, 0x0000000000000000, "RO", "RESERVED_0", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{16, 16, 0x0000000000000001, "RO/V", "ALL_ENTRIES_FLUSHED", "All Entries Flushed: All dirty entries in the Bunit in both slices have been flushed."},
#else
{16, 16, 0x0000000000000001, "RO/V", "ALL_ENTRIES_FLUSHED", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{8, 15, 0x0000000000000000, "RW", "DIRTY_LWM", "Low water mark for dirty entries retained by the Bunit.  Bunit will immediately attempt to flush any dirty entry hence setting the low watermark to 0."},
#else
{8, 15, 0x0000000000000000, "RW", "DIRTY_LWM", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 7, 0x0000000000000000, "RW", "DIRTY_HWM", "High water mark for dirty entries retained by the Bunit.  Bunit will immediately attempt to flush any dirty entry hence setting the low watermark to 0."},
#else
{0, 7, 0x0000000000000000, "RW", "DIRTY_HWM", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo1055[] = {{"B_CR_BWFLUSH", "", 0x00006D64, 5, 0x00000000FFFFFFFF, 0x00000000FF010000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields1056[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{31, 31, 0x0000000000000000, "RW", "DISABLE_FLUSH_WEIGHTS", "When set to 1 disables flush weights.  Flushing of dirty entries will start when Dirty Limits is  HWM and continue until Dirty Limit is  LWM and no reads will be scheduled in between."},
#else
{31, 31, 0x0000000000000000, "RW", "DISABLE_FLUSH_WEIGHTS", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{14, 30, 0x0000000000000000, "RO", "RESERVED_1", "Reserved"},
#else
{14, 30, 0x0000000000000000, "RO", "RESERVED_1", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{8, 13, 0x0000000000000004, "RW", "WRITE_WEIGHTS", "Number of write requests sent to a PMI channel before switching to scheduling read requests when use of flush weights is not disabled."},
#else
{8, 13, 0x0000000000000004, "RW", "WRITE_WEIGHTS", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{6, 7, 0x0000000000000000, "RO", "RESERVED_0", "Reserved"},
#else
{6, 7, 0x0000000000000000, "RO", "RESERVED_0", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 5, 0x0000000000000004, "RW", "READ_WEIGHTS", "Number of read requests sent to a PMI channel before switching to scheduling write requests when use of flush weights is not disabled."},
#else
{0, 5, 0x0000000000000004, "RW", "READ_WEIGHTS", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo1056[] = {{"B_CR_BFLWT", "", 0x00006D68, 5, 0x00000000FFFFFFFF, 0x0000000000000404}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields1057[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{31, 31, 0x0000000000000001, "RW", "ENABLE_ISOC_WEIGHTS", "When set to 1 enables switching from scheduling High Priority ISOC requests to scheduling Best Effort and Low Priority ISOC requests based on ISOC weights and NONISOC weights."},
#else
{31, 31, 0x0000000000000001, "RW", "ENABLE_ISOC_WEIGHTS", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{14, 30, 0x0000000000000000, "RO", "RESERVED_1", "Reserved"},
#else
{14, 30, 0x0000000000000000, "RO", "RESERVED_1", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{8, 13, 0x000000000000003F, "RW", "ISOC_REQUEST_WEIGHTS", "Weight for High Priority Isoc Requests"},
#else
{8, 13, 0x000000000000003F, "RW", "ISOC_REQUEST_WEIGHTS", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{6, 7, 0x0000000000000000, "RO", "RESERVED_0", "Reserved"},
#else
{6, 7, 0x0000000000000000, "RO", "RESERVED_0", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 5, 0x000000000000000F, "RW", "NON_ISOC_REQUEST_WEIGHTS", "Weight for NonHigh Priority Isoc and Best Effort Requests"},
#else
{0, 5, 0x000000000000000F, "RW", "NON_ISOC_REQUEST_WEIGHTS", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo1057[] = {{"B_CR_BISOCWT", "", 0x00006D6C, 5, 0x00000000FFFFFFFF, 0x0000000080003F0F}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields1058[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{31, 31, 0x0000000000000000, "RW", "ENABLE_READ_INVALIDATE_TIMER", "When set to 1 enables the BRAM to clear the RD_DONE bit and flush dirty data when a timer expires.  Used when parity is not enabled to force the Bunit to not indefinitely cache previously read lines and also cause a flush of dirty data that has been written to the BRAM entry."},
#else
{31, 31, 0x0000000000000000, "RW", "ENABLE_READ_INVALIDATE_TIMER", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{25, 30, 0x0000000000000000, "RO", "RESERVED_2", "Reserved"},
#else
{25, 30, 0x0000000000000000, "RO", "RESERVED_2", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{24, 24, 0x0000000000000000, "RW", "MOT_DISABLE_STALL_ARB_ON_ERR", "If the HH widget gets an error, allow transactions to get arbitrated"},
#else
{24, 24, 0x0000000000000000, "RW", "MOT_DISABLE_STALL_ARB_ON_ERR", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{16, 23, 0x000000000000000F, "RW", "BRAM_READ_INVALIDATE_TIME", "Timer threshold to clear rd_done bits or flush a BRAM entry if dirty.  The value specified is in multiples of 250ns. For each time interval specified the read done status of one BRAM entry will be cleared based on a BTAG index which is then incremented to point to the next BRAM entry."},
#else
{16, 23, 0x000000000000000F, "RW", "BRAM_READ_INVALIDATE_TIME", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{8, 15, 0x0000000000000000, "RW", "CASUAL_TIMER", "Casual Timer:  The number of clock cycles that the BUnit waits before starting a casual dirty flush.  Casual Flush feature will not be enabled by PND2 architecture.  Instead a dirty write will be made eligible for scheduling immediately."},
#else
{8, 15, 0x0000000000000000, "RW", "CASUAL_TIMER", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{5, 7, 0x0000000000000000, "RO", "RESERVED_1", "Reserved"},
#else
{5, 7, 0x0000000000000000, "RO", "RESERVED_1", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{4, 4, 0x0000000000000001, "RW", "ENABLE_64B_READ", "When set, B-unit will send 64B PMI read requests for transactions requiring read access to DRAM. Must always be set to one, otherwise functional errors may occur. "},
#else
{4, 4, 0x0000000000000001, "RW", "ENABLE_64B_READ", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{3, 3, 0x0000000000000000, "RO", "RESERVED_0", "Reserved"},
#else
{3, 3, 0x0000000000000000, "RO", "RESERVED_0", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{2, 2, 0x0000000000000001, "RW", "ENABLE_READ_DONE_FOR_WRITE", "Enable Any writes (IWB or normal writes) to set the read_done bit in bstat which enables return of data from the BRAM cache instead of Memory"},
#else
{2, 2, 0x0000000000000001, "RW", "ENABLE_READ_DONE_FOR_WRITE", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{1, 1, 0x0000000000000000, "RW", "MISS_VALID_ENTRIES", "Miss Valid Entries: This mode causes reads to clean valid Bunit buffer entries to look like misses instead of hits.  When this bit is set, even when all requested bytes are valid and present in the BRAM data buffer, Bunit will send read requests over the PMI interface to re-fetch the data from DRAM, instead of returning it from the BRAM"},
#else
{1, 1, 0x0000000000000000, "RW", "MISS_VALID_ENTRIES", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 0, 0x0000000000000000, "RW", "DIRTY_STALL", "Dirty Stall: This mode causes reads or writes from any requestor interface to dirty valid Bunit buffer entries to stall on the approproate requestor interface until the entry has been flushed from the BUnit."},
#else
{0, 0, 0x0000000000000000, "RW", "DIRTY_STALL", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo1058[] = {{"B_CR_BCTRL2", "", 0x00006D70, 11, 0x00000000FFFFFFFF, 0x00000000000F0014}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields1059[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{21, 31, 0x0000000000000000, "RO", "RESERVED_0", "Reserved"},
#else
{21, 31, 0x0000000000000000, "RO", "RESERVED_0", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{20, 20, 0x0000000000000001, "RW", "MOT_RS0_EN", "RS Asset Classification bit for the MOT buffer.  PII transactions from RS0 that hit the MOT buffer will be allowed access only when both of the following conditions are met: a Request SAI is in the legal permitted list as specified in the RAC/WAC policy registers and b MOT_RS0_EN bit is set to 1.  PII RS0 transactions targeting DRAM that do not hit any enabled IMR or special protected regions will always be allowed access."},
#else
{20, 20, 0x0000000000000001, "RW", "MOT_RS0_EN", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 19, 0x0000000000000000, "RW", "IMR_RS0_EN", "RS Asset Classification bit for IMRs 0 19.  PII transactions from RS0 that hit an enabled IMR address range will be allowed access only when both of the following conditions are met: a Request SAI is in the legal permitted list as specified in the IMRs RAC/WAC policy registers and b IMR_AC_RS bit corresponding to the IMR is set to 1.  PII RS0 transactions targeting DRAM that do not hit any enabled IMR or special protected regions will always be allowed access."},
#else
{0, 19, 0x0000000000000000, "RW", "IMR_RS0_EN", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo1059[] = {{"B_CR_AC_RS0_0_0_0_MCHBAR", "", 0x00006D74, 3, 0x00000000FFFFFFFF, 0x0000000000100000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields1060[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{0, 31, 0x0000000000000000, "RW/V", "DATA", "This field contains the data associated with specific commands.  This register represents the lower 32b of the interface."},
#else
{0, 31, 0x0000000000000000, "RW/V", "DATA", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo1060[] = {{"P_CR_THERMAL_MAILBOX_DATA0_0_0_0_MCHBAR", "", 0x00007000, 1, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields1061[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{0, 31, 0x0000000000000000, "RW/V", "DATA", "This field contains the data associated with specific commands.  This register represents the upper 32b of the interface."},
#else
{0, 31, 0x0000000000000000, "RW/V", "DATA", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo1061[] = {{"P_CR_THERMAL_MAILBOX_DATA1_0_0_0_MCHBAR", "", 0x00007004, 1, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields1062[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{31, 31, 0x0000000000000000, "RW/1S/V", "RUN_BUSY", "Software may write to the mailbox registers only when RUN_BUSY is cleared (0b).  Setting RUN_BUSY to 1b will create a Fast Path event to Pcode.  After setting this bit, SW will poll this bit until it is cleared.  Pcode will clear the RUN_BUSY after updating the mailbox registers with the result and completion code."},
#else
{31, 31, 0x0000000000000000, "RW/1S/V", "RUN_BUSY", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{8, 28, 0x0000000000000000, "RW/V", "ADDR_CNTL", "Software may write to the mailbox registers only when RUN_BUSY is cleared (0b).  Setting RUN_BUSY to 1b will create a Fast Path event to Pcode.  After setting this bit, SW will poll this bit until it is cleared.  Pcode will clear the RUN_BUSY after updating the mailbox registers with the result and completion code."},
#else
{8, 28, 0x0000000000000000, "RW/V", "ADDR_CNTL", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 7, 0x0000000000000000, "RW/V", "COMMAND", "This field contains the SW request command or the PCODE response code, depending on the setting of RUN_BUSY.  It is the command when RUN_BUSY=1 and response code when RUN_BUSY=0"},
#else
{0, 7, 0x0000000000000000, "RW/V", "COMMAND", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo1062[] = {{"P_CR_THERMAL_MAILBOX_INTERFACE_0_0_0_MCHBAR", "", 0x00007008, 3, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields1063[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{31, 31, 0x0000000000000000, "RW/L", "LOCK", "Bit used to lock P_CR_INTR_LAT_0_0_1_PCI.INTPIN"},
#else
{31, 31, 0x0000000000000000, "RW/L", "LOCK", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{8, 30, 0x0000000000000000, "RO", "RESERVED", "Reserved"},
#else
{8, 30, 0x0000000000000000, "RO", "RESERVED", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 7, 0x0000000000000000, "RW", "IRQ", "IRQ vector number for the thermal / power device.  This field controls the event vector issues to the IOAPIC.   It must be configured by BIOS for INTA support."},
#else
{0, 7, 0x0000000000000000, "RW", "IRQ", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo1063[] = {{"P_CR_THERMAL_DEVICE_IRQ_0_0_0_MCHBAR", "", 0x0000700C, 3, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields1064[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{24, 30, 0x0000000000000000, "RW/V", "TIME_WINDOW", "The value in this field defines the RC time constant for thermal filtering.   Bit format is 'xx.yyyyy'.  Time window in seconds is described as: \r\n"
"Time Window = 0.976ms * (float)((1+xx/4) * (2^yyyyy))\r\n"
"E.g., for an RC time constant of 109ms, program 0b1100110\r\n"
"A value of zero indicates no filtering."},
#else
{24, 30, 0x0000000000000000, "RW/V", "TIME_WINDOW", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{16, 23, 0x0000000000000000, "RW/V", "THRESHOLD2_TEMP", "Threshold temperature in degrees Celsius.  Reported in a signed, 2's complement format with the LSB representing 1'C resolution (S8.7.0).  E.g., a reading of 0x28 == 40'C.  This threshold is managed relative to the filtered temperature."},
#else
{16, 23, 0x0000000000000000, "RW/V", "THRESHOLD2_TEMP", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{8, 15, 0x0000000000000000, "RW/V", "THRESHOLD1_TEMP", "Threshold temperature in degrees Celsius.  Reported in a signed, 2's complement format with the LSB representing 1'C resolution (S8.7.0).  E.g., a reading of 0x28 == 40'C.  This threshold is managed relative to the filtered temperature."},
#else
{8, 15, 0x0000000000000000, "RW/V", "THRESHOLD1_TEMP", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{2, 2, 0x0000000000000000, "RW/V", "CRITICAL_THERMAL_INT_ENABLE", "Enable thermal interrupt generation when the processor has detected a critical thermal event that requires immediate servicing.  This event is intended to be an alert indicating thermal control failure and is an early warning of thermal runaway."},
#else
{2, 2, 0x0000000000000000, "RW/V", "CRITICAL_THERMAL_INT_ENABLE", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{1, 1, 0x0000000000000000, "RW/V", "THRESHOLD2_INT_ENABLE", "Controls the generation of a thermal interrupt whenever the Thermal Threshold 2 Temperature is crossed.  Interrupts are generated when the threshold is crossed in either direction."},
#else
{1, 1, 0x0000000000000000, "RW/V", "THRESHOLD2_INT_ENABLE", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 0, 0x0000000000000000, "RW/V", "THRESHOLD1_INT_ENABLE", "Controls the generation of a thermal interrupt whenever the Thermal Threshold 1 Temperature is crossed.  Interrupts are generated when the threshold is crossed in either direction."},
#else
{0, 0, 0x0000000000000000, "RW/V", "THRESHOLD1_INT_ENABLE", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo1064[] = {{"P_CR_PKG_THERM_INTERRUPT_0_0_0_MCHBAR", "", 0x00007010, 6, 0x000000007FFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields1065[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{24, 31, 0x0000000000000000, "RO/V", "LAST_RESOLVED_RATIO", "Reserved1"},
#else
{24, 31, 0x0000000000000000, "RO/V", "LAST_RESOLVED_RATIO", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{16, 23, 0x0000000000000000, "RO/V", "MAX_RATIO", "max ratio"},
#else
{16, 23, 0x0000000000000000, "RO/V", "MAX_RATIO", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{8, 15, 0x0000000000000000, "RO/V", "EFFICIENT_RATIO", "min ratio"},
#else
{8, 15, 0x0000000000000000, "RO/V", "EFFICIENT_RATIO", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 7, 0x0000000000000000, "RO/V", "MIN_RATIO", "Efficient ratio"},
#else
{0, 7, 0x0000000000000000, "RO/V", "MIN_RATIO", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo1065[] = {{"P_CR_PROCESSING_SYSTEM_FREQ_CAPABILITIES_0_0_0_MCHBAR", "", 0x00007014, 4, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields1066[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{16, 23, 0x0000000000000000, "RO/V", "TEMPERATURE", "Virtual maximum SOC temperature in degrees Celsius. Caculated as a maximum of all on-die thermal sensor readings and filtered accoring to the time constant described in pkg_therm_interrupt.  Data format is signed, 2's complement with the LSB representing 1'C resolution (S8.7.0)."},
#else
{16, 23, 0x0000000000000000, "RO/V", "TEMPERATURE", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{5, 5, 0x0000000000000000, "RW/0C/V", "CRITICAL_THERMAL_EVENT_LOG", "Sticky log bit indicating that the processor has operated out of its thermal specification since the last time SW cleared this bit. Set by HW on a 0 to 1 transition of critical_thermal_event_status."},
#else
{5, 5, 0x0000000000000000, "RW/0C/V", "CRITICAL_THERMAL_EVENT_LOG", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{4, 4, 0x0000000000000000, "RO/V", "CRITICAL_THERMAL_EVENT_STATUS", "Status bit indicating that the processor is operating outside of its thermal specification."},
#else
{4, 4, 0x0000000000000000, "RO/V", "CRITICAL_THERMAL_EVENT_STATUS", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{3, 3, 0x0000000000000000, "RW/0C/V", "THRESHOLD2_LOG", "Sticky log bit that indicates temperature has crossed the software programmable thermal threshold2 in either falling or rising directions."},
#else
{3, 3, 0x0000000000000000, "RW/0C/V", "THRESHOLD2_LOG", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{2, 2, 0x0000000000000000, "RO/V", "THRESHOLD2_STATUS", "Indicates that the current filtered temperature (bits 23:16 of this register) is greater than or equal to the Threshold2 defined in the pkg_therm_interrupt configuration register."},
#else
{2, 2, 0x0000000000000000, "RO/V", "THRESHOLD2_STATUS", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{1, 1, 0x0000000000000000, "RW/0C/V", "THRESHOLD1_LOG", "Sticky log bit that indicates temperature has crossed the software programmable thermal threshold1 in either falling or rising directions."},
#else
{1, 1, 0x0000000000000000, "RW/0C/V", "THRESHOLD1_LOG", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 0, 0x0000000000000000, "RO/V", "THRESHOLD1_STATUS", "Indicates that the current filtered temperature (bits 23:16 of this register) is greater than or equal to the Threshold1 defined in the pkg_therm_interrupt configuration register."},
#else
{0, 0, 0x0000000000000000, "RO/V", "THRESHOLD1_STATUS", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo1066[] = {{"P_CR_PKG_THERM_STATUS_0_0_0_MCHBAR", "", 0x0000701C, 7, 0x0000000000FFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields1067[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{6, 31, 0x0000000000000000, "RO", "RESERVED_0", "Reserved"},
#else
{6, 31, 0x0000000000000000, "RO", "RESERVED_0", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{3, 5, 0x0000000000000000, "RW", "MR4_RANK_1", "MR4 Device temperature of Rank_1  only LPDDR3 and LPDDR4 not WIO2 .  This field is updated LPDDR Dunit after each read of MR4 if a 2nd rank is populated."},
#else
{3, 5, 0x0000000000000000, "RW", "MR4_RANK_1", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 2, 0x0000000000000000, "RW", "MR4_RANK_0", "MR4 Device temperature of Rank_0  for WIO2 LPDDR3 and LPDDR4 .  This field is updated b either LPDDR Dunit or WIO2 Dunit after each read of MR4. For LPDDRx this is temperature status of the 1st rank in a channel"},
#else
{0, 2, 0x0000000000000000, "RW", "MR4_RANK_0", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo1067[] = {{"P_CR_MEM_MR4_TEMPERATURE_DEV0_0_0_0_MCHBAR", "", 0x00007020, 3, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields1068[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{6, 31, 0x0000000000000000, "RO", "RESERVED_0", "Reserved"},
#else
{6, 31, 0x0000000000000000, "RO", "RESERVED_0", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{3, 5, 0x0000000000000000, "RW", "MR4_RANK_1", "MR4 Device temperature of Rank_1  only LPDDR3 and LPDDR4 not WIO2 .  This field is updated LPDDR Dunit after each read of MR4 if a 2nd rank is populated."},
#else
{3, 5, 0x0000000000000000, "RW", "MR4_RANK_1", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 2, 0x0000000000000000, "RW", "MR4_RANK_0", "MR4 Device temperature of Rank_0  for WIO2 LPDDR3 and LPDDR4 .  This field is updated b either LPDDR Dunit or WIO2 Dunit after each read of MR4. For LPDDRx this is temperature status of the 1st rank in a channel"},
#else
{0, 2, 0x0000000000000000, "RW", "MR4_RANK_0", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo1068[] = {{"P_CR_MEM_MR4_TEMPERATURE_DEV1_0_0_0_MCHBAR", "", 0x00007024, 3, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields1069[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{6, 31, 0x0000000000000000, "RO", "RESERVED_0", "Reserved"},
#else
{6, 31, 0x0000000000000000, "RO", "RESERVED_0", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{3, 5, 0x0000000000000000, "RW", "MR4_RANK_1", "MR4 Device temperature of Rank_1  only LPDDR3 and LPDDR4 not WIO2 .  This field is updated LPDDR Dunit after each read of MR4 if a 2nd rank is populated."},
#else
{3, 5, 0x0000000000000000, "RW", "MR4_RANK_1", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 2, 0x0000000000000000, "RW", "MR4_RANK_0", "MR4 Device temperature of Rank_0  for WIO2 LPDDR3 and LPDDR4 .  This field is updated b either LPDDR Dunit or WIO2 Dunit after each read of MR4. For LPDDRx this is temperature status of the 1st rank in a channel"},
#else
{0, 2, 0x0000000000000000, "RW", "MR4_RANK_0", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo1069[] = {{"P_CR_MEM_MR4_TEMPERATURE_DEV2_0_0_0_MCHBAR", "", 0x00007028, 3, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields1070[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{17, 31, 0x0000000000000000, "RO", "RESERVED_1", "RESERVED"},
#else
{17, 31, 0x0000000000000000, "RO", "RESERVED_1", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{16, 16, 0x0000000000000000, "RW/V", "XLTT_MEM_THRT_ENABLE", "Must be 0x1 for DNV - \r\n"
"        1: memory is throttled if required based on OLTT/CLTT thermal status\r\n"
"        0: OLTT/CLTT memory throttle will not be used"},
#else
{16, 16, 0x0000000000000000, "RW/V", "XLTT_MEM_THRT_ENABLE", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{10, 15, 0x0000000000000000, "RO", "RESERVED_0", "RESERVED"},
#else
{10, 15, 0x0000000000000000, "RO", "RESERVED_0", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{9, 9, 0x0000000000000000, "RW/V", "MEM_THRT_ENABLE", "When enabled, memory traffic is throttled if near or far memory MR4 value >= NM/FM_THERM_THRT_THRESHOLD"},
#else
{9, 9, 0x0000000000000000, "RW/V", "MEM_THRT_ENABLE", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{8, 8, 0x0000000000000000, "RW/V", "MEM_THRT_CFG", "Configure memory throttling behavior -\r\n"
"         0: use instanous MR4 status for FM/NM_THERM_THRT_THRESHOLD\r\n"
"         1: use time-filtered MR4 status for FM/NM_THERM_THRT_THRESHOLD"},
#else
{8, 8, 0x0000000000000000, "RW/V", "MEM_THRT_CFG", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{7, 7, 0x0000000000000000, "RW/V", "NM_THERM_THRT_ENABLE", "When enabled throttling is activated if near memory MR4 value is at and above NM_THERM_THRT_THRESHOLD"},
#else
{7, 7, 0x0000000000000000, "RW/V", "NM_THERM_THRT_ENABLE", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{4, 6, 0x0000000000000000, "RW/V", "NM_THERM_THRT_THRESHOLD", "Configurable threshold of near memory MR4 value at and above which thermal throttling is activated."},
#else
{4, 6, 0x0000000000000000, "RW/V", "NM_THERM_THRT_THRESHOLD", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{3, 3, 0x0000000000000000, "RW/V", "FM_THERM_THRT_ENABLE", "When enabled thorttling is activated if far memory MR4 value is at and above FM_THERM_THRT_THRESHOLD.  Fort standard LPDDR DRAM that is only capable to Tcasemax of 85C this enable bit should be set."},
#else
{3, 3, 0x0000000000000000, "RW/V", "FM_THERM_THRT_ENABLE", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 2, 0x0000000000000000, "RW/V", "FM_THERM_THRT_THRESHOLD", "Configurable threshold of far memory MR4 value at and above which thermal throttling is activated.  Fort standard LPDDR DRAM that is only capable to Tcasemax of 85C this field should be configured to 3b011"},
#else
{0, 2, 0x0000000000000000, "RW/V", "FM_THERM_THRT_THRESHOLD", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo1070[] = {{"P_CR_DDR_THERM_THRT_CTRL_0_0_0_MCHBAR", "", 0x00007030, 9, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields1071[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{24, 30, 0x0000000000000000, "RW", "TIME_WINDOW", "The value in this field defines the RC time constant for thermal filtering.   Bit format is 'xx.yyyyy'.  Time window in seconds is described as: \r\n"
"Time Window = 0.976ms * (float)((1+xx/4) * (2^yyyyy))\r\n"
"E.g., for an RC time constant of 109ms, program 0b1100110\r\n"
"A value of zero indicates no filtering."},
#else
{24, 30, 0x0000000000000000, "RW", "TIME_WINDOW", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{15, 15, 0x0000000000000000, "RW", "NEAR_MEM_MR4_THRESHOLD2_INT_ENABLE", "Enable thermal interrupt generation whenever the virtual maximum near memory MR4 has crossed THRESHOLD2.  Interrupts are triggered when the filtered MR4 temperature crosses in both rising and falling directions."},
#else
{15, 15, 0x0000000000000000, "RW", "NEAR_MEM_MR4_THRESHOLD2_INT_ENABLE", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{12, 14, 0x0000000000000000, "RW", "NEAR_MEM_MR4_THRESHOLD2", "Configurable near memory threshold2 value for near memory thermal interrupt generation"},
#else
{12, 14, 0x0000000000000000, "RW", "NEAR_MEM_MR4_THRESHOLD2", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{11, 11, 0x0000000000000000, "RW", "NEAR_MEM_MR4_THRESHOLD1_INT_ENABLE", "Enable thermal interrupt generation whenever the virtual maximum near memory MR4 has crossed THRESHOLD1.  Interrupts are triggered when the filtered MR4 temperature crosses in both rising and falling directions."},
#else
{11, 11, 0x0000000000000000, "RW", "NEAR_MEM_MR4_THRESHOLD1_INT_ENABLE", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{8, 10, 0x0000000000000000, "RW", "NEAR_MEM_MR4_THRESHOLD1", "Configurable near memory threshold1 value for near memory thermal interrupt generation"},
#else
{8, 10, 0x0000000000000000, "RW", "NEAR_MEM_MR4_THRESHOLD1", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{7, 7, 0x0000000000000000, "RW", "FAR_MEM_MR4_THRESHOLD2_INT_ENABLE", "Enable thermal interrupt generation whenever the virtual maximum far memory MR4 has crossed THRESHOLD2.  Interrupts are triggered when the filtered MR4 temperature crosses in both rising and falling directions."},
#else
{7, 7, 0x0000000000000000, "RW", "FAR_MEM_MR4_THRESHOLD2_INT_ENABLE", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{4, 6, 0x0000000000000000, "RW", "FAR_MEM_MR4_THRESHOLD2", "Configurable far memory threshold2 value for far memory thermal interrupt generation"},
#else
{4, 6, 0x0000000000000000, "RW", "FAR_MEM_MR4_THRESHOLD2", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{3, 3, 0x0000000000000000, "RW", "FAR_MEM_MR4_THRESHOLD1_INT_ENABLE", "Enable thermal interrupt generation whenever the virtual maximum far memory MR4 has crossed THRESHOLD1.  Interrupts are triggered when the filtered MR4 temperature crosses in both rising and falling directions."},
#else
{3, 3, 0x0000000000000000, "RW", "FAR_MEM_MR4_THRESHOLD1_INT_ENABLE", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 2, 0x0000000000000000, "RW", "FAR_MEM_MR4_THRESHOLD1", "Configurable far memory threshold1 value for far memory thermal interrupt generation"},
#else
{0, 2, 0x0000000000000000, "RW", "FAR_MEM_MR4_THRESHOLD1", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo1071[] = {{"P_CR_DDR_THERM_INTERRUPT_0_0_0_MCHBAR", "", 0x00007034, 9, 0x000000007FFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields1072[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{19, 21, 0x0000000000000000, "RO/V", "NEAR_MEM_MR4", "Virtual maximum near memory MR4 reading.  Caculated as a maximum of all near memory MR4 readingsand filtered accoring to the time constant described in ddr_therm_interrupt."},
#else
{19, 21, 0x0000000000000000, "RO/V", "NEAR_MEM_MR4", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{16, 18, 0x0000000000000000, "RO/V", "FAR_MEM_MR4", "Virtual maximum far memory MR4 reading.  Caculated as a maximum of all far memory MR4 readingsand filtered accoring to the time constant described in ddr_therm_interrupt."},
#else
{16, 18, 0x0000000000000000, "RO/V", "FAR_MEM_MR4", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{7, 7, 0x0000000000000000, "RW/0C/V", "NEAR_MEM_MR4_THRESHOLD2_LOG", "Indicates that the virtual maximum near memory MR4 has crossed THRESHOLD2 since the last time this register was cleared.  The bit is set when the threshold is crossed in either direction.  Software may clear this bit."},
#else
{7, 7, 0x0000000000000000, "RW/0C/V", "NEAR_MEM_MR4_THRESHOLD2_LOG", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{6, 6, 0x0000000000000000, "RO/V", "NEAR_MEM_MR4_THRESHOLD2_STATUS", "Status bit is set when the virtual maximum near memory MR4 reading is greater than or equal to THRESHOLD2.  It is cleared when temperature is less than THRESHOLD2"},
#else
{6, 6, 0x0000000000000000, "RO/V", "NEAR_MEM_MR4_THRESHOLD2_STATUS", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{5, 5, 0x0000000000000000, "RW/0C/V", "NEAR_MEM_MR4_THRESHOLD1_LOG", "Indicates that the virtual maximum near memory MR4 has crossed THRESHOLD1 since the last time this register was cleared.  The bit is set when the threshold is crossed in either direction.  Software may clear this bit."},
#else
{5, 5, 0x0000000000000000, "RW/0C/V", "NEAR_MEM_MR4_THRESHOLD1_LOG", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{4, 4, 0x0000000000000000, "RO/V", "NEAR_MEM_MR4_THRESHOLD1_STATUS", "Status bit is set when the virtual maximum near memory MR4 reading is greater than or equal to THRESHOLD1.  It is cleared when temperature is less than THRESHOLD1"},
#else
{4, 4, 0x0000000000000000, "RO/V", "NEAR_MEM_MR4_THRESHOLD1_STATUS", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{3, 3, 0x0000000000000000, "RW/0C/V", "FAR_MEM_MR4_THRESHOLD2_LOG", "Indicates that the virtual maximum far memory MR4 has crossed THRESHOLD2 since the last time this register was cleared.  The bit is set when the threshold is crossed in either direction.  Software may clear this bit."},
#else
{3, 3, 0x0000000000000000, "RW/0C/V", "FAR_MEM_MR4_THRESHOLD2_LOG", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{2, 2, 0x0000000000000000, "RO/V", "FAR_MEM_MR4_THRESHOLD2_STATUS", "Status bit is set when the virtual maximum far memory MR4 reading is greater than or equal to THRESHOLD2.  It is cleared when temperature is less than THRESHOLD2"},
#else
{2, 2, 0x0000000000000000, "RO/V", "FAR_MEM_MR4_THRESHOLD2_STATUS", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{1, 1, 0x0000000000000000, "RW/0C/V", "FAR_MEM_MR4_THRESHOLD1_LOG", "Indicates that the virtual maximum far memory MR4 has crossed THRESHOLD1 since the last time this register was cleared.  The bit is set when the threshold is crossed in either direction.  Software may clear this bit."},
#else
{1, 1, 0x0000000000000000, "RW/0C/V", "FAR_MEM_MR4_THRESHOLD1_LOG", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 0, 0x0000000000000000, "RO/V", "FAR_MEM_MR4_THRESHOLD1_STATUS", "Status bit is set when the virtual maximum far memory MR4 reading is greater than or equal to THRESHOLD1.  It is cleared when temperature is less than THRESHOLD1"},
#else
{0, 0, 0x0000000000000000, "RO/V", "FAR_MEM_MR4_THRESHOLD1_STATUS", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo1072[] = {{"P_CR_DDR_THERM_STATUS_0_0_0_MCHBAR", "", 0x00007038, 10, 0x00000000003FFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields1073[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{63, 63, 0x0000000000000000, "RW/KL", "LOCKED", "When set this entire register becomes readonly. This bit will typically be set by BIOS during boot."},
#else
{63, 63, 0x0000000000000000, "RW/KL", "LOCKED", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{56, 62, 0x0000000000000000, "RO", "RESERVED_3", "Reserved"},
#else
{56, 62, 0x0000000000000000, "RO", "RESERVED_3", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{54, 55, 0x0000000000000000, "RW/L", "LIMIT2_TIME_WINDOW_X", "Power Limit[1] time window X value for DDR domain. Actual time_window for RAPL is: 1/1024 seconds  1x/4  2y"},
#else
{54, 55, 0x0000000000000000, "RW/L", "LIMIT2_TIME_WINDOW_X", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{49, 53, 0x0000000000000000, "RW/L", "LIMIT2_TIME_WINDOW_Y", "Power Limit[1] time window Y value for DDR domain. Actual time_window for RAPL is: 1/1024 seconds  1x/4  2y"},
#else
{49, 53, 0x0000000000000000, "RW/L", "LIMIT2_TIME_WINDOW_Y", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{48, 48, 0x0000000000000000, "RO", "RESERVED_2", "Reserved"},
#else
{48, 48, 0x0000000000000000, "RO", "RESERVED_2", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{47, 47, 0x0000000000000000, "RW/L", "LIMIT2_ENABLE", "Power Limit[1] enable bit for DDR domain."},
#else
{47, 47, 0x0000000000000000, "RW/L", "LIMIT2_ENABLE", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{32, 46, 0x0000000000000000, "RW/L", "LIMIT2_POWER", "Power Limit[1] for DDR domain. UnitsWatts Format11.3 Resolution0.125W Range02047.875W."},
#else
{32, 46, 0x0000000000000000, "RW/L", "LIMIT2_POWER", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{24, 31, 0x0000000000000000, "RO", "RESERVED_1", "Reserved"},
#else
{24, 31, 0x0000000000000000, "RO", "RESERVED_1", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{22, 23, 0x0000000000000000, "RW/L", "LIMIT1_TIME_WINDOW_X", "Power Limit[0] time window X value for DDR domain. Actual time_window for RAPL is: 1/1024 seconds  1x/4  2y"},
#else
{22, 23, 0x0000000000000000, "RW/L", "LIMIT1_TIME_WINDOW_X", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{17, 21, 0x0000000000000000, "RW/L", "LIMIT1_TIME_WINDOW_Y", "Power Limit[0] time window Y value for DDR domain. Actual time_window for RAPL is: 1/1024 seconds  1x/4  2y"},
#else
{17, 21, 0x0000000000000000, "RW/L", "LIMIT1_TIME_WINDOW_Y", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{16, 16, 0x0000000000000000, "RO", "RESERVED_0", "Reserved"},
#else
{16, 16, 0x0000000000000000, "RO", "RESERVED_0", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{15, 15, 0x0000000000000000, "RW/L", "LIMIT1_ENABLE", "Power Limit[0] enable bit for DDR domain."},
#else
{15, 15, 0x0000000000000000, "RW/L", "LIMIT1_ENABLE", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 14, 0x0000000000000000, "RW/L", "LIMIT1_POWER", "Power Limit[0] for DDR domain. UnitsWatts Format11.3 Resolution0.125W Range02047.875W."},
#else
{0, 14, 0x0000000000000000, "RW/L", "LIMIT1_POWER", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo1073[] = {{"P_CR_DDR_RAPL_LIMIT_0_0_0_MCHBAR", "", 0x00007040, 13, 0xFFFFFFFFFFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields1074[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{0, 31, 0x0000000000000000, "RO/V", "JOULES", "Total Joules of energy consumed by all DIMMs: Format  18.14 Resolution  61uJ Range  0 to 2.62e5 J."},
#else
{0, 31, 0x0000000000000000, "RO/V", "JOULES", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo1074[] = {{"P_CR_DDR_ENERGY_STATUS_0_0_0_MCHBAR", "", 0x00007048, 1, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields1075[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{0, 31, 0x00000000000058F0, "RW", "DURATION", "Throttle duration due to RAPL sum across all channels in units of 1/1024 seconds. This data can serve as a proxy for the potential performance impacts of RAPL on memory accesses. This is a real time accumulator that is based on iMC counters at QCLK granularity thus this register is more accurate than PACKAGE_RAPL_PERF_STATUS."},
#else
{0, 31, 0x00000000000058F0, "RW", "DURATION", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo1075[] = {{"P_CR_DDR_RAPL_PERF_STATUS_0_0_0_MCHBAR", "", 0x0000704C, 1, 0x00000000FFFFFFFF, 0x00000000000058F0}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields1076[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{0, 31, 0x0000000000000000, "RW", "COUNTS", "Counter of the time units within which RAPL was limiting Pstates. If limitation occurred anywhere within the time window of 1/1024 seconds the count will be incremented limitation on accuracy. This data can serve as a proxy for the potential performance impacts of RAPL on cores performance."},
#else
{0, 31, 0x0000000000000000, "RW", "COUNTS", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo1076[] = {{"P_CR_PACKAGE_RAPL_PERF_STATUS_0_0_0_MCHBAR", "", 0x00007050, 1, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields1077[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{5, 31, 0x0000000000000000, "RO", "RESERVED_0", "Reserved"},
#else
{5, 31, 0x0000000000000000, "RO", "RESERVED_0", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 4, 0x0000000000000000, "RW", "PRIPTP", "Priority Level. A higher number implies a higher priority."},
#else
{0, 4, 0x0000000000000000, "RW", "PRIPTP", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo1077[] = {{"P_CR_PRIMARY_PLANE_TURBO_PLCY_0_0_0_MCHBAR", "", 0x00007054, 2, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields1078[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{5, 31, 0x0000000000000000, "RO", "RESERVED_0", "Reserved"},
#else
{5, 31, 0x0000000000000000, "RO", "RESERVED_0", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 4, 0x0000000000000010, "RW", "SECPTP", "Priority Level. A higher number implies a higher priority."},
#else
{0, 4, 0x0000000000000010, "RW", "SECPTP", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo1078[] = {{"P_CR_SECONDARY_PLANE_TURBO_PLCY_0_0_0_MCHBAR", "", 0x00007058, 2, 0x00000000FFFFFFFF, 0x0000000000000010}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields1079[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{0, 31, 0x0000000000000000, "RO/V", "DATA", "Energy Value"},
#else
{0, 31, 0x0000000000000000, "RO/V", "DATA", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo1079[] = {{"P_CR_PRIMARY_PLANE_ENERGY_STATUS_0_0_0_MCHBAR", "", 0x0000705C, 1, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields1080[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{0, 31, 0x0000000000000000, "RO/V", "DATA", "Energy Value"},
#else
{0, 31, 0x0000000000000000, "RO/V", "DATA", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo1080[] = {{"P_CR_SECONDARY_PLANE_ENERGY_STATUS_0_0_0_MCHBAR", "", 0x00007060, 1, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields1081[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{28, 31, 0x0000000000000003, "RW", "RESISTANCE_UNIT", "\r\n"
"      Specifies the number of decimal bits in which current units in this register are specified. \r\n"
"      0: steps of 1Ohm\r\n"
"      1: steps of 0.5 Ohms\r\n"
"      2: steps of 0.25 Ohms etc..."},
#else
{28, 31, 0x0000000000000003, "RW", "RESISTANCE_UNIT", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{24, 27, 0x0000000000000003, "RW", "CURRENT_UNIT", "\r\n"
"      Specifies the number of decimal bits in which current units in this register are specified. \r\n"
"      0: steps of 1A\r\n"
"      1: steps of 0.5 Amps\r\n"
"      2: steps of 0.25 A etc..."},
#else
{24, 27, 0x0000000000000003, "RW", "CURRENT_UNIT", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{20, 23, 0x0000000000000000, "RO", "RESERVED_2", "Reserved"},
#else
{20, 23, 0x0000000000000000, "RO", "RESERVED_2", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{16, 19, 0x000000000000000A, "RW", "TIME_UNIT", "Time Units used for power control registers.   The actual unit value is calculated by 1 s / Power2TIME_UNIT.  The default value of Ah corresponds to 976 usec."},
#else
{16, 19, 0x000000000000000A, "RW", "TIME_UNIT", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{13, 15, 0x0000000000000000, "RO", "RESERVED_1", "Reserved"},
#else
{13, 15, 0x0000000000000000, "RO", "RESERVED_1", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{8, 12, 0x000000000000000E, "RW", "ENERGY_UNIT", "Energy Units used for power control registers.  The actual unit value is calculated by 1 J / Power2ENERGY_UNIT.  The default value of 14 corresponds to Ux.14 number."},
#else
{8, 12, 0x000000000000000E, "RW", "ENERGY_UNIT", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{4, 7, 0x0000000000000000, "RO", "RESERVED_0", "Reserved"},
#else
{4, 7, 0x0000000000000000, "RO", "RESERVED_0", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 3, 0x0000000000000008, "RW", "PWR_UNIT", "Power Units used for power control registers.   The actual unit value is calculated by 1 W / Power2PWR_UNIT.  The default value of 0110b corresponds to 1/256 W."},
#else
{0, 3, 0x0000000000000008, "RW", "PWR_UNIT", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo1081[] = {{"P_CR_PACKAGE_POWER_SKU_UNIT_0_0_0_MCHBAR", "", 0x00007068, 8, 0x00000000FFFFFFFF, 0x00000000330A0E08}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields1082[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{0, 31, 0x0000000000000000, "RO/V", "DATA", "Energy Value"},
#else
{0, 31, 0x0000000000000000, "RO/V", "DATA", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo1082[] = {{"P_CR_PACKAGE_ENERGY_STATUS_0_0_0_MCHBAR", "", 0x0000706C, 1, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields1083[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{17, 25, 0x0000000000000000, "RO/V", "RP_STATE_RATIO_SLICE", "Ratio of the current RP-state. When the graphics engine is in RC6, this field reflects the last ratio in use"},
#else
{17, 25, 0x0000000000000000, "RO/V", "RP_STATE_RATIO_SLICE", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{8, 16, 0x0000000000000000, "RO/V", "RP_STATE_RATIO_UNSLICE", "Ratio of the current RP-state. When the graphics engine is in RC6, this field reflects the last ratio in use"},
#else
{8, 16, 0x0000000000000000, "RO/V", "RP_STATE_RATIO_UNSLICE", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 7, 0x0000000000000000, "RO/V", "RP_STATE_VOLTAGE", "RP-State Voltage GT Target Voltage in U1.7 Volts"},
#else
{0, 7, 0x0000000000000000, "RO/V", "RP_STATE_VOLTAGE", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo1083[] = {{"P_CR_GT_PERF_STATUS_0_0_0_MCHBAR", "", 0x00007070, 3, 0x0000000003FFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields1084[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{31, 31, 0x0000000000000000, "RO", "RESERVED_1", "Reserved"},
#else
{31, 31, 0x0000000000000000, "RO", "RESERVED_1", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{24, 30, 0x0000000000000000, "RW", "TJ_MAX_TCC_OFFSET", "This field allows platform SW to configure a Tjmax_offset such that thermal throttling is activated at fused_Tjmax  Tjmax_TCC_offset.Punit FW reads this field to control thermal throttling activation at temperature lower than fused Tjmax"},
#else
{24, 30, 0x0000000000000000, "RW", "TJ_MAX_TCC_OFFSET", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{16, 23, 0x000000000000005A, "RO/V", "REF_TEMP", "Tjmax a.k.a. Throttle Temperature TCC activation temperature or Prochot Temperature or REF_TEMP  This is the maximum junction temperature at which thermal throttling aka thermal monitor is activated. Punit FW updates this register based on FUSE_TJMAX.This field is read only by all other SW"},
#else
{16, 23, 0x000000000000005A, "RO/V", "REF_TEMP", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 7, 0x0000000000000000, "RO", "RESERVED_0", "Reserved"},
#else
{0, 7, 0x0000000000000000, "RO", "RESERVED_0", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo1084[] = {{"P_CR_TEMPERATURE_TARGET_0_0_0_MCHBAR", "", 0x00007074, 4, 0x00000000FFFFFFFF, 0x00000000005A0000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields1085[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{16, 31, 0x0000000000000000, "RW", "RESERVED0", "reserved"},
#else
{16, 31, 0x0000000000000000, "RW", "RESERVED0", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{15, 15, 0x0000000000000000, "RW", "PCODE_INIT_DONE7", "pcode complete"},
#else
{15, 15, 0x0000000000000000, "RW", "PCODE_INIT_DONE7", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{14, 14, 0x0000000000000000, "RW", "PCODE_INIT_DONE6", "pcode complete"},
#else
{14, 14, 0x0000000000000000, "RW", "PCODE_INIT_DONE6", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{13, 13, 0x0000000000000000, "RW", "PCODE_INIT_DONE5", "pcode complete"},
#else
{13, 13, 0x0000000000000000, "RW", "PCODE_INIT_DONE5", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{12, 12, 0x0000000000000000, "RW", "PCODE_INIT_DONE4", "pcode complete"},
#else
{12, 12, 0x0000000000000000, "RW", "PCODE_INIT_DONE4", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{11, 11, 0x0000000000000000, "RW", "PCODE_INIT_DONE3", "pcode complete"},
#else
{11, 11, 0x0000000000000000, "RW", "PCODE_INIT_DONE3", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{10, 10, 0x0000000000000000, "RW", "PCODE_INIT_DONE2", "pcode complete"},
#else
{10, 10, 0x0000000000000000, "RW", "PCODE_INIT_DONE2", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{9, 9, 0x0000000000000000, "RW", "PCODE_INIT_DONE1", "pcode complete"},
#else
{9, 9, 0x0000000000000000, "RW", "PCODE_INIT_DONE1", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{8, 8, 0x0000000000000000, "RW", "PCODE_INIT_DONE", "pcode complete"},
#else
{8, 8, 0x0000000000000000, "RW", "PCODE_INIT_DONE", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{7, 7, 0x0000000000000000, "RW", "RST_CPL7", "reset complete"},
#else
{7, 7, 0x0000000000000000, "RW", "RST_CPL7", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{6, 6, 0x0000000000000000, "RW", "RST_CPL6", "reset complete"},
#else
{6, 6, 0x0000000000000000, "RW", "RST_CPL6", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{5, 5, 0x0000000000000000, "RW", "RST_CPL5", "reset complete"},
#else
{5, 5, 0x0000000000000000, "RW", "RST_CPL5", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{4, 4, 0x0000000000000000, "RW", "RST_CPL4", "reset complete"},
#else
{4, 4, 0x0000000000000000, "RW", "RST_CPL4", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{3, 3, 0x0000000000000000, "RW", "RST_CPL3", "reset complete"},
#else
{3, 3, 0x0000000000000000, "RW", "RST_CPL3", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{2, 2, 0x0000000000000000, "RW", "RST_CPL2", "reset complete"},
#else
{2, 2, 0x0000000000000000, "RW", "RST_CPL2", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{1, 1, 0x0000000000000000, "RW", "RST_CPL1", "reset complete"},
#else
{1, 1, 0x0000000000000000, "RW", "RST_CPL1", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 0, 0x0000000000000000, "RW", "RST_CPL", "reset complete"},
#else
{0, 0, 0x0000000000000000, "RW", "RST_CPL", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo1085[] = {{"P_CR_BIOS_RESET_CPL_0_0_0_MCHBAR", "", 0x00007078, 17, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields1086[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{0, 31, 0x0000000000000000, "RW/V", "DATA", "This field contains the data associated with specific commands."},
#else
{0, 31, 0x0000000000000000, "RW/V", "DATA", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo1086[] = {{"P_CR_BIOS_MAILBOX_DATA_0_0_0_MCHBAR", "", 0x00007080, 1, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields1087[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{31, 31, 0x0000000000000000, "RW/1S/V", "RUN_BUSY", "SW may write to the two mailbox registers only when RUN_BUSY is cleared 0b. Setting RUN_BUSY to 1b will create a Fast Path event. After setting this bit SW will poll this bit until it is cleared.  PCODE will clear RUN_BUSY after updating the mailbox registers with the result and error code."},
#else
{31, 31, 0x0000000000000000, "RW/1S/V", "RUN_BUSY", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{8, 28, 0x0000000000000000, "RW/V", "ADDRESS", "This field contains the address associated with specific commands."},
#else
{8, 28, 0x0000000000000000, "RW/V", "ADDRESS", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 7, 0x0000000000000000, "RW/V", "COMMAND", "This field contains the SW request command or the PCODE response code depending on the setting of RUN_BUSY.  Command Encodings  01h MAILBOX_BIOS_CMD_READ_PCS  02h MAILBOX_BIOS_CMD_WRITE_PCS  Error Code Encodings  00h MAILBOX_BIOS_ERROR_NONE  01h MAILBOX_BIOS_ERROR_INVALID_COMMAND"},
#else
{0, 7, 0x0000000000000000, "RW/V", "COMMAND", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo1087[] = {{"P_CR_BIOS_MAILBOX_INTERFACE_0_0_0_MCHBAR", "", 0x00007084, 3, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields1088[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{24, 31, 0x0000000000000000, "RO/V", "LAST_RESOLVED_FREQ", "Last resolved core frequency"},
#else
{24, 31, 0x0000000000000000, "RO/V", "LAST_RESOLVED_FREQ", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{16, 23, 0x0000000000000000, "RO/V", "MAX_SUPPORTED_FREQ", "Max Supported core frequency"},
#else
{16, 23, 0x0000000000000000, "RO/V", "MAX_SUPPORTED_FREQ", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{8, 15, 0x0000000000000000, "RO/V", "EFFICIENT_FREQ", "Efficient core frequency"},
#else
{8, 15, 0x0000000000000000, "RO/V", "EFFICIENT_FREQ", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 7, 0x0000000000000000, "RO/V", "MIN_SUPPORTED_FREQ", "Minimum supported core frequency"},
#else
{0, 7, 0x0000000000000000, "RO/V", "MIN_SUPPORTED_FREQ", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo1088[] = {{"P_CR_CORE_FREQUENCY_CAPABILITIES_0_0_0_MCHBAR", "", 0x00007088, 4, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields1089[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{24, 31, 0x0000000000000000, "RO/V", "LAST_RESOLVED_FREQ", "Last resolved gfx frequency"},
#else
{24, 31, 0x0000000000000000, "RO/V", "LAST_RESOLVED_FREQ", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{16, 23, 0x0000000000000000, "RO/V", "MAX_SUPPORTED_FREQ", "Max Supported gfx frequency"},
#else
{16, 23, 0x0000000000000000, "RO/V", "MAX_SUPPORTED_FREQ", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{8, 15, 0x0000000000000000, "RO/V", "EFFICIENT_FREQ", "Efficient gfx frequency"},
#else
{8, 15, 0x0000000000000000, "RO/V", "EFFICIENT_FREQ", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 7, 0x0000000000000000, "RO/V", "MIN_SUPPORTED_FREQ", "Minimum supported gfx frequency"},
#else
{0, 7, 0x0000000000000000, "RO/V", "MIN_SUPPORTED_FREQ", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo1089[] = {{"P_CR_GRAPHICS_FREQUENCY_CAPABILITIES_0_0_0_MCHBAR", "", 0x0000708C, 4, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields1090[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{24, 31, 0x0000000000000000, "RO/V", "LAST_RESOLVED_RATIO", "Last resolved system agent ratio"},
#else
{24, 31, 0x0000000000000000, "RO/V", "LAST_RESOLVED_RATIO", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{16, 23, 0x0000000000000000, "RO/V", "RESERVED_2", "Reserved"},
#else
{16, 23, 0x0000000000000000, "RO/V", "RESERVED_2", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{8, 15, 0x0000000000000000, "RO/V", "RESERVED_1", "Reserved"},
#else
{8, 15, 0x0000000000000000, "RO/V", "RESERVED_1", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 7, 0x0000000000000000, "RO/V", "RESERVED_0", "Reserved"},
#else
{0, 7, 0x0000000000000000, "RO/V", "RESERVED_0", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo1090[] = {{"P_CR_SYSTEM_AGENT_FREQUENCY_CAPABILITIES_0_0_0_MCHBAR", "", 0x00007090, 4, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields1091[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{24, 31, 0x0000000000000000, "RO/V", "LAST_RESOLVED_RATIO", "Last resolved far memory LPDDR ratio"},
#else
{24, 31, 0x0000000000000000, "RO/V", "LAST_RESOLVED_RATIO", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{16, 23, 0x0000000000000000, "RO/V", "RESERVED_2", "Reserved"},
#else
{16, 23, 0x0000000000000000, "RO/V", "RESERVED_2", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{8, 15, 0x0000000000000000, "RO/V", "RESERVED_1", "Reserved"},
#else
{8, 15, 0x0000000000000000, "RO/V", "RESERVED_1", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 7, 0x0000000000000000, "RO/V", "RESERVED_0", "Reserved"},
#else
{0, 7, 0x0000000000000000, "RO/V", "RESERVED_0", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo1091[] = {{"P_CR_FAR_MEMORY_FREQUENCY_CAPABILITIES_0_0_0_MCHBAR", "", 0x00007094, 4, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields1092[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{24, 31, 0x0000000000000000, "RO/V", "LAST_RESOLVED_RATIO", "Last resolved near memory WIO ratio"},
#else
{24, 31, 0x0000000000000000, "RO/V", "LAST_RESOLVED_RATIO", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{16, 23, 0x0000000000000000, "RO/V", "RESERVED_2", "Reserved"},
#else
{16, 23, 0x0000000000000000, "RO/V", "RESERVED_2", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{8, 15, 0x0000000000000000, "RO/V", "RESERVED_1", "Reserved"},
#else
{8, 15, 0x0000000000000000, "RO/V", "RESERVED_1", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 7, 0x0000000000000000, "RO/V", "RESERVED_0", "Reserved"},
#else
{0, 7, 0x0000000000000000, "RO/V", "RESERVED_0", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo1092[] = {{"P_CR_NEAR_MEMORY_FREQUENCY_CAPABILITIES_0_0_0_MCHBAR", "", 0x00007098, 4, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields1093[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{55, 63, 0x0000000000000000, "RO", "RESERVED_3", "Reserved"},
#else
{55, 63, 0x0000000000000000, "RO", "RESERVED_3", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{48, 54, 0x0000000000000012, "RW", "PKG_MAX_WIN", "The maximal time window allowed for the SKU. Higher values will be clamped to this value.  x  PKG_MAX_WIN[54:53]  y  PKG_MAX_WIN[52:48]  The timing interval window is Floating Point number given by 1.x  power2y.  The unit of measurement is defined in PACKAGE_POWER_SKU_UNIT_MSR[TIME_UNIT]."},
#else
{48, 54, 0x0000000000000012, "RW", "PKG_MAX_WIN", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{47, 47, 0x0000000000000000, "RO", "RESERVED_2", "Reserved"},
#else
{47, 47, 0x0000000000000000, "RO", "RESERVED_2", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{32, 46, 0x0000000000000240, "RW", "PKG_MAX_PWR", "The maximal package power setting allowed for the SKU. Higher values will be clamped to this value. The maximum setting is typical not guaranteed.  The default value for this field is determined by fuses.  The units for this value are defined in PACKAGE_POWER_SKU_MSR[PWR_UNIT]."},
#else
{32, 46, 0x0000000000000240, "RW", "PKG_MAX_PWR", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{31, 31, 0x0000000000000000, "RO", "RESERVED_1", "Reserved"},
#else
{31, 31, 0x0000000000000000, "RO", "RESERVED_1", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{16, 30, 0x0000000000000060, "RW", "PKG_MIN_PWR", "The minimal package power setting allowed for the SKU. Lower values will be clamped to this value. The minimum setting is typical not guaranteed.  The default value for this field is determined by fuses.  The units for this value are defined in PACKAGE_POWER_SKU_MSR[PWR_UNIT]."},
#else
{16, 30, 0x0000000000000060, "RW", "PKG_MIN_PWR", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{15, 15, 0x0000000000000000, "RO", "RESERVED_0", "Reserved"},
#else
{15, 15, 0x0000000000000000, "RO", "RESERVED_0", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 14, 0x0000000000000118, "RW", "PKG_TDP", "The TDP package power setting allowed for the SKU. The TDP setting is typical not guaranteed.  The default value for this field is determined by fuses.  The units for this value are defined in PACKAGE_POWER_SKU_MSR[PWR_UNIT]."},
#else
{0, 14, 0x0000000000000118, "RW", "PKG_TDP", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo1093[] = {{"P_CR_PACKAGE_POWER_SKU_0_0_0_MCHBAR", "", 0x000070A0, 8, 0xFFFFFFFFFFFFFFFF, 0x0012024000600118}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields1094[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{63, 63, 0x0000000000000000, "RW/KL", "PKG_PWR_LIM_LOCK", "When set all settings in this register are locked and are treated as Read Only.  This bit will typically set by BIOS during boot time or resume from Sx."},
#else
{63, 63, 0x0000000000000000, "RW/KL", "PKG_PWR_LIM_LOCK", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{56, 62, 0x0000000000000000, "RO", "RESERVED_1", "Reserved"},
#else
{56, 62, 0x0000000000000000, "RO", "RESERVED_1", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{49, 55, 0x0000000000000000, "RW/L", "PKG_PWR_LIM_2_TIME", "x  PKG_PWR_LIM_2_TIME[55:54]  y  PKG_PWR_LIM_2_TIME[53:49]  The timing interval window is Floating Point number given by 1.x  power2y.  The unit of measurement is defined in PACKAGE_POWER_SKU_UNIT_MSR[TIME_UNIT].  The maximal time window is bounded by PACKAGE_POWER_SKU_MSR[PKG_MAX_WIN].  The minimum time window is 1 unit of measurement as defined above."},
#else
{49, 55, 0x0000000000000000, "RW/L", "PKG_PWR_LIM_2_TIME", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{48, 48, 0x0000000000000000, "RW/L", "PKG_CLMP_LIM_2", "Package Clamping limitation 2  Allow going below P1.  0b PBM is limited between P1 and P0.  1b PBM can go below P1."},
#else
{48, 48, 0x0000000000000000, "RW/L", "PKG_CLMP_LIM_2", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{47, 47, 0x0000000000000000, "RW/L", "PKG_PWR_LIM_2_EN", "This bit enables/disables PKG_PWR_LIM_2.  0b Package Power Limit 2 is Disabled  1b Package Power Limit 2 is Enabled"},
#else
{47, 47, 0x0000000000000000, "RW/L", "PKG_PWR_LIM_2_EN", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{32, 46, 0x0000000000000000, "RW/L", "PKG_PWR_LIM_2", "This field indicates the power limitation 2.   The unit of measurement is defined in PACKAGE_POWER_SKU_UNIT_MSR[PWR_UNIT]."},
#else
{32, 46, 0x0000000000000000, "RW/L", "PKG_PWR_LIM_2", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{24, 31, 0x0000000000000000, "RO", "RESERVED_0", "Reserved"},
#else
{24, 31, 0x0000000000000000, "RO", "RESERVED_0", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{17, 23, 0x0000000000000000, "RW/L", "PKG_PWR_LIM_1_TIME", "x  PKG_PWR_LIM_1_TIME[23:22]  y  PKG_PWR_LIM_1_TIME[21:17]  The timing interval window is Floating Point number given by 1.x  power2y.  The unit of measurement is defined in PACKAGE_POWER_SKU_UNIT_MSR[TIME_UNIT].  The maximal time window is bounded by PACKAGE_POWER_SKU_MSR[PKG_MAX_WIN]. The minimum time window is 1 unit of measurement as defined above."},
#else
{17, 23, 0x0000000000000000, "RW/L", "PKG_PWR_LIM_1_TIME", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{16, 16, 0x0000000000000000, "RW/L", "PKG_CLMP_LIM_1", "Package Clamping limitation 1  Allow going below P1.  0b PBM is limited between P1 and P0.  1b PBM can go below P1."},
#else
{16, 16, 0x0000000000000000, "RW/L", "PKG_CLMP_LIM_1", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{15, 15, 0x0000000000000000, "RW/L", "PKG_PWR_LIM_1_EN", "This bit enables/disables PKG_PWR_LIM_1.  0b Package Power Limit 1 is Disabled  1b Package Power Limit 1 is Enabled"},
#else
{15, 15, 0x0000000000000000, "RW/L", "PKG_PWR_LIM_1_EN", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 14, 0x0000000000000000, "RW/L", "PKG_PWR_LIM_1", "This field indicates the power limitation 1. The default value is loaded from fuses.  The unit of measurement is defined in PACKAGE_POWER_SKU_UNIT_MSR[PWR_UNIT]."},
#else
{0, 14, 0x0000000000000000, "RW/L", "PKG_PWR_LIM_1", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo1094[] = {{"P_CR_PACKAGE_RAPL_LIMIT_0_0_0_MCHBAR", "", 0x000070A8, 11, 0xFFFFFFFFFFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields1095[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{31, 31, 0x0000000000000000, "RW/0C/V", "QOS_LOG", "set by pcode, cleared by SW"},
#else
{31, 31, 0x0000000000000000, "RW/0C/V", "QOS_LOG", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{30, 30, 0x0000000000000000, "RW/0C/V", "MAX_EFFICIENCY_FREQ_LOG", "set by pcode, cleared by SW"},
#else
{30, 30, 0x0000000000000000, "RW/0C/V", "MAX_EFFICIENCY_FREQ_LOG", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{29, 29, 0x0000000000000000, "RW/0C/V", "MCT_LOG", "set by pcode, cleared by SW"},
#else
{29, 29, 0x0000000000000000, "RW/0C/V", "MCT_LOG", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{28, 28, 0x0000000000000000, "RW/0C/V", "EDP_LOG", "set by pcode, cleared by SW"},
#else
{28, 28, 0x0000000000000000, "RW/0C/V", "EDP_LOG", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{27, 27, 0x0000000000000000, "RW/0C/V", "MULTI_CORE_TURBO_LOG", "set by pcode, cleared by SW"},
#else
{27, 27, 0x0000000000000000, "RW/0C/V", "MULTI_CORE_TURBO_LOG", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{26, 26, 0x0000000000000000, "RW/0C/V", "VR_THERMALERT_LOG", "set by pcode, cleared by SW"},
#else
{26, 26, 0x0000000000000000, "RW/0C/V", "VR_THERMALERT_LOG", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{25, 25, 0x0000000000000000, "RW/0C/V", "IA_UTILIZATION_LOG", "set by pcode, cleared by SW"},
#else
{25, 25, 0x0000000000000000, "RW/0C/V", "IA_UTILIZATION_LOG", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{24, 24, 0x0000000000000000, "RW/0C/V", "DEV3_LOG", "set by pcode, cleared by SW"},
#else
{24, 24, 0x0000000000000000, "RW/0C/V", "DEV3_LOG", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{23, 23, 0x0000000000000000, "RW/0C/V", "DEV2_LOG", "set by pcode, cleared by SW"},
#else
{23, 23, 0x0000000000000000, "RW/0C/V", "DEV2_LOG", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{22, 22, 0x0000000000000000, "RW/0C/V", "SPARE6_LOG", "set by pcode, cleared by SW"},
#else
{22, 22, 0x0000000000000000, "RW/0C/V", "SPARE6_LOG", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{21, 21, 0x0000000000000000, "RW/0C/V", "SPARE5_LOG", "set by pcode, cleared by SW"},
#else
{21, 21, 0x0000000000000000, "RW/0C/V", "SPARE5_LOG", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{20, 20, 0x0000000000000000, "RW/0C/V", "SPARE4_LOG", "set by pcode, cleared by SW"},
#else
{20, 20, 0x0000000000000000, "RW/0C/V", "SPARE4_LOG", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{19, 19, 0x0000000000000000, "RW/0C/V", "PL2_LOG", "set by pcode, cleared by SW"},
#else
{19, 19, 0x0000000000000000, "RW/0C/V", "PL2_LOG", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{18, 18, 0x0000000000000000, "RW/0C/V", "PL1_LOG", "set by pcode, cleared by SW"},
#else
{18, 18, 0x0000000000000000, "RW/0C/V", "PL1_LOG", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{17, 17, 0x0000000000000000, "RW/0C/V", "THERMAL_LOG", "set by pcode, cleared by SW"},
#else
{17, 17, 0x0000000000000000, "RW/0C/V", "THERMAL_LOG", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{16, 16, 0x0000000000000000, "RW/0C/V", "PROCHOT_LOG", "set by pcode, cleared by SW"},
#else
{16, 16, 0x0000000000000000, "RW/0C/V", "PROCHOT_LOG", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{15, 15, 0x0000000000000000, "RO/V", "QOS_STATUS", "Frequency is limited below the operating system or driver Quality-of-Service floor."},
#else
{15, 15, 0x0000000000000000, "RO/V", "QOS_STATUS", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{14, 14, 0x0000000000000000, "RO/V", "MAX_EFFICIENCY_FREQ_STATUS", "Frequency is limited below the maximum efficiency frequency."},
#else
{14, 14, 0x0000000000000000, "RO/V", "MAX_EFFICIENCY_FREQ_STATUS", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{13, 13, 0x0000000000000000, "RO/V", "MCT_STATUS", "Frequency is limited due to ratio change transition attenuation (MCT, prevents frequent ratio changes due to core C-state entry/exit)."},
#else
{13, 13, 0x0000000000000000, "RO/V", "MCT_STATUS", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{12, 12, 0x0000000000000000, "RO/V", "EDP_STATUS", "Frequency is limited due to a package-level EDP constraint."},
#else
{12, 12, 0x0000000000000000, "RO/V", "EDP_STATUS", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{11, 11, 0x0000000000000000, "RO/V", "MULTI_CORE_TURBO_STATUS", "Frequency is limited due to effective multi-core turbo constraints, if applicable on Broxton."},
#else
{11, 11, 0x0000000000000000, "RO/V", "MULTI_CORE_TURBO_STATUS", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{10, 10, 0x0000000000000000, "RO/V", "VR_THERMALERT_STATUS", "requency is limited due to a VR thermal excursion."},
#else
{10, 10, 0x0000000000000000, "RO/V", "VR_THERMALERT_STATUS", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{9, 9, 0x0000000000000000, "RO/V", "IA_UTILIZATION_STATUS", "requency is limited due to autonomous utilization-based P-state control, if supported on Broxton"},
#else
{9, 9, 0x0000000000000000, "RO/V", "IA_UTILIZATION_STATUS", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{8, 8, 0x0000000000000000, "RO/V", "DEV3_STATUS", "Frequency is limited due to Dev3 driver override."},
#else
{8, 8, 0x0000000000000000, "RO/V", "DEV3_STATUS", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{7, 7, 0x0000000000000000, "RO/V", "DEV2_STATUS", "Frequency is limited due to Dev2 driver override."},
#else
{7, 7, 0x0000000000000000, "RO/V", "DEV2_STATUS", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{6, 6, 0x0000000000000000, "RO/V", "SPARE6_STATUS", "Spare6"},
#else
{6, 6, 0x0000000000000000, "RO/V", "SPARE6_STATUS", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{5, 5, 0x0000000000000000, "RO/V", "SPARE5_STATUS", "Spare5"},
#else
{5, 5, 0x0000000000000000, "RO/V", "SPARE5_STATUS", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{4, 4, 0x0000000000000000, "RO/V", "SPARE4_STATUS", "Spare4"},
#else
{4, 4, 0x0000000000000000, "RO/V", "SPARE4_STATUS", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{3, 3, 0x0000000000000000, "RO/V", "PL2_STATUS", "requency is limited due to a package-level PL2 excursion."},
#else
{3, 3, 0x0000000000000000, "RO/V", "PL2_STATUS", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{2, 2, 0x0000000000000000, "RO/V", "PL1_STATUS", "requency is limited due to a package-level PL1 excursion."},
#else
{2, 2, 0x0000000000000000, "RO/V", "PL1_STATUS", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{1, 1, 0x0000000000000000, "RO/V", "THERMAL_STATUS", "Frequency is limited due to thermal excursion."},
#else
{1, 1, 0x0000000000000000, "RO/V", "THERMAL_STATUS", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 0, 0x0000000000000000, "RO/V", "PROCHOT_STATUS", "requency is limited due to external PROCHOT assertion, if supported on Broxton."},
#else
{0, 0, 0x0000000000000000, "RO/V", "PROCHOT_STATUS", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo1095[] = {{"P_CR_IA_PERF_LIMIT_REASONS_0_0_0_MCHBAR", "", 0x000070B0, 32, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields1096[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{0, 31, 0x0000000000000000, "RO/V", "DATA", "Residency data"},
#else
{0, 31, 0x0000000000000000, "RO/V", "DATA", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo1096[] = {{"P_CR_TELEM_IA_C0_RESIDENCY_0_0_0_MCHBAR", "", 0x000070C0, 1, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields1097[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{0, 31, 0x0000000000000000, "RO/V", "DATA", "Residency data"},
#else
{0, 31, 0x0000000000000000, "RO/V", "DATA", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo1097[] = {{"P_CR_TELEM_GT_C0_RESIDENCY_0_0_0_MCHBAR", "", 0x000070C4, 1, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields1098[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{0, 31, 0x0000000000000000, "RO/V", "DATA", "Residency data"},
#else
{0, 31, 0x0000000000000000, "RO/V", "DATA", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo1098[] = {{"P_CR_TELEM_IUNIT_C0_RESIDENCY_0_0_0_MCHBAR", "", 0x000070C8, 1, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields1099[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{0, 31, 0x0000000000000000, "RO/V", "DATA", "Residency data"},
#else
{0, 31, 0x0000000000000000, "RO/V", "DATA", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo1099[] = {{"P_CR_TELEM_IA_FREQ_ACCUMULATOR_0_0_0_MCHBAR", "", 0x000070CC, 1, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields1100[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{0, 31, 0x0000000000000000, "RO/V", "DATA", "Residency data"},
#else
{0, 31, 0x0000000000000000, "RO/V", "DATA", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo1100[] = {{"P_CR_TELEM_GT_FREQ_ACCUMULATOR_0_0_0_MCHBAR", "", 0x000070D0, 1, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields1101[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{0, 31, 0x0000000000000000, "RO/V", "DATA", "Residency data"},
#else
{0, 31, 0x0000000000000000, "RO/V", "DATA", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo1101[] = {{"P_CR_TELEM_IUNIT_FREQ_ACCUMULATOR_0_0_0_MCHBAR", "", 0x000070D4, 1, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields1102[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{0, 63, 0x0000000000000000, "RO/V", "DATA", "Residency data"},
#else
{0, 63, 0x0000000000000000, "RO/V", "DATA", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo1102[] = {{"P_CR_TELEM_NEAR_MEMORY_ACTIVE_0_0_0_MCHBAR", "", 0x000070E0, 1, 0xFFFFFFFFFFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields1103[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{0, 63, 0x0000000000000000, "RO/V", "DATA", "Residency data"},
#else
{0, 63, 0x0000000000000000, "RO/V", "DATA", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo1103[] = {{"P_CR_TELEM_FAR_MEMORY_ACTIVE_0_0_0_MCHBAR", "", 0x000070E8, 1, 0xFFFFFFFFFFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields1104[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{24, 31, 0x0000000000000000, "RO/V", "SA_Temperature", "System agent domain max temperature in degrees C.  Reported in a signed, 2's complement format with the LSB representing 1'C resolution (S8.7.0).  Raw, unfiltered"},
#else
{24, 31, 0x0000000000000000, "RO/V", "SA_Temperature", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{16, 23, 0x0000000000000000, "RO/V", "ISP_Temperature", "Camera domain max temperature in degrees C.  Reported in a signed, 2's complement format with the LSB representing 1'C resolution (S8.7.0).  Raw, unfiltered"},
#else
{16, 23, 0x0000000000000000, "RO/V", "ISP_Temperature", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{8, 15, 0x0000000000000000, "RO/V", "GT_Temperature", "Graphics domain max temperature in degrees C.  Reported in a signed, 2's complement format with the LSB representing 1'C resolution (S8.7.0).  Raw, unfiltered"},
#else
{8, 15, 0x0000000000000000, "RO/V", "GT_Temperature", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 7, 0x0000000000000000, "RO/V", "IA_Temperature", "Virtual max temperature of all IA cores in degrees C.  Reported in a signed, 2's complement format with the LSB representing 1'C resolution (S8.7.0).  Raw, unfiltered"},
#else
{0, 7, 0x0000000000000000, "RO/V", "IA_Temperature", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo1104[] = {{"P_CR_PACKAGE_TEMPERATURES_0_0_0_MCHBAR", "", 0x000070F4, 4, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields1105[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{8, 8, 0x0000000000000000, "RW", "ENABLE", "When set, it enables run-time thermal limit control to the THERMAL_LIMIT_TEMP described in this register."},
#else
{8, 8, 0x0000000000000000, "RW", "ENABLE", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 7, 0x0000000000000000, "RW", "THERMAL_LIMIT_TEMP", "Maximum SOC temperature allowed.  Described in a signed, 2's complement format with the LSB representing 1'C resolution (S8.7.0).  If the setting is higher than the processor's factory configured maximum temperature as described in the TEMPERATURE_TARGET MSR, this field is ignored.  This field may be updated at any time."},
#else
{0, 7, 0x0000000000000000, "RW", "THERMAL_LIMIT_TEMP", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo1105[] = {{"P_CR_THERMAL_LIMIT_CONTROL_0_0_0_MCHBAR", "", 0x00007104, 2, 0x00000000000001FF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields1106[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{30, 31, 0x0000000000000000, "RW", "NUM_NM_CH", "N/A"},
#else
{30, 31, 0x0000000000000000, "RW", "NUM_NM_CH", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{24, 29, 0x0000000000000000, "RW", "WIO_FREQ", "N/A"},
#else
{24, 29, 0x0000000000000000, "RW", "WIO_FREQ", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{18, 23, 0x0000000000000000, "RW", "LP4_FREQ_HIGH", "N/A"},
#else
{18, 23, 0x0000000000000000, "RW", "LP4_FREQ_HIGH", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{12, 17, 0x0000000000000000, "RW", "LP4_FREQ_LOW", "N/A"},
#else
{12, 17, 0x0000000000000000, "RW", "LP4_FREQ_LOW", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{6, 11, 0x0000000000000000, "RW", "LP3_FREQ_HIGH", "N/A"},
#else
{6, 11, 0x0000000000000000, "RW", "LP3_FREQ_HIGH", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 5, 0x0000000000000000, "RW", "LP3_FREQ_LOW", "N/A"},
#else
{0, 5, 0x0000000000000000, "RW", "LP3_FREQ_LOW", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo1106[] = {{"P_CR_MEMSS_FREQUENCY_CAPABILITIES_0_0_0_MCHBAR", "", 0x00007108, 6, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields1107[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{31, 31, 0x0000000000000000, "RW", "RUN_BUSY", "N/A"},
#else
{31, 31, 0x0000000000000000, "RW", "RUN_BUSY", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{20, 30, 0x0000000000000000, "RW", "RESERVED_1", "N/A"},
#else
{20, 30, 0x0000000000000000, "RW", "RESERVED_1", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{19, 19, 0x0000000000000000, "RW", "MEM_INIT_DONE", "N/A"},
#else
{19, 19, 0x0000000000000000, "RW", "MEM_INIT_DONE", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{18, 18, 0x0000000000000000, "RW", "CPGC_MODE_COMPLETE", "N/A"},
#else
{18, 18, 0x0000000000000000, "RW", "CPGC_MODE_COMPLETE", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{17, 17, 0x0000000000000000, "RW", "DUNIT_RESET_COMPLETE", "N/A"},
#else
{17, 17, 0x0000000000000000, "RW", "DUNIT_RESET_COMPLETE", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{16, 16, 0x0000000000000000, "RW", "PHY_CONFIG_COMPLETE", "N/A"},
#else
{16, 16, 0x0000000000000000, "RW", "PHY_CONFIG_COMPLETE", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{15, 15, 0x0000000000000000, "RW", "FM_CH3_ACTIVE", "N/A"},
#else
{15, 15, 0x0000000000000000, "RW", "FM_CH3_ACTIVE", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{14, 14, 0x0000000000000000, "RW", "FM_CH2_ACTIVE", "N/A"},
#else
{14, 14, 0x0000000000000000, "RW", "FM_CH2_ACTIVE", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{13, 13, 0x0000000000000000, "RW", "FM_CH1_ACTIVE", "N/A"},
#else
{13, 13, 0x0000000000000000, "RW", "FM_CH1_ACTIVE", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{12, 12, 0x0000000000000000, "RW", "FM_CH0_ACTIVE", "N/A"},
#else
{12, 12, 0x0000000000000000, "RW", "FM_CH0_ACTIVE", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{11, 11, 0x0000000000000000, "RW", "WIO_ONLY", "N/A"},
#else
{11, 11, 0x0000000000000000, "RW", "WIO_ONLY", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{10, 10, 0x0000000000000000, "RW", "RESERVED_0", "N/A"},
#else
{10, 10, 0x0000000000000000, "RW", "RESERVED_0", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{9, 9, 0x0000000000000000, "RW", "REQ_TYPE_SPECIAL", "N/A"},
#else
{9, 9, 0x0000000000000000, "RW", "REQ_TYPE_SPECIAL", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{6, 8, 0x0000000000000000, "RW", "REQ_TYPE", "N/A"},
#else
{6, 8, 0x0000000000000000, "RW", "REQ_TYPE", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 5, 0x0000000000000000, "RW", "REQ_DATA", "N/A"},
#else
{0, 5, 0x0000000000000000, "RW", "REQ_DATA", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo1107[] = {{"P_CR_MC_BIOS_REQ_0_0_0_MCHBAR", "", 0x00007114, 15, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields1108[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{0, 31, 0x0000000000000000, "RO/V", "DATA", "data"},
#else
{0, 31, 0x0000000000000000, "RO/V", "DATA", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo1108[] = {{"P_CR_PP1_C0_CORE_CLOCK_0_0_0_MCHBAR", "", 0x00007160, 1, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields1109[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{3, 3, 0x0000000000000000, "RW", "CORE3_EXISTS", "core3 exists"},
#else
{3, 3, 0x0000000000000000, "RW", "CORE3_EXISTS", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{2, 2, 0x0000000000000000, "RW", "CORE2_EXISTS", "core2 exists"},
#else
{2, 2, 0x0000000000000000, "RW", "CORE2_EXISTS", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{1, 1, 0x0000000000000000, "RW", "CORE1_EXISTS", "core1 exists"},
#else
{1, 1, 0x0000000000000000, "RW", "CORE1_EXISTS", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 0, 0x0000000000000000, "RW", "CORE0_EXISTS", "core0 exists"},
#else
{0, 0, 0x0000000000000000, "RW", "CORE0_EXISTS", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo1109[] = {{"P_CR_CORE_EXISTS_VECTOR_0_0_0_MCHBAR", "", 0x00007164, 4, 0x000000000000000F, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields1110[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{3, 3, 0x0000000000000000, "RW", "CORE3_DISABLE_MASK", "core3 disable mask"},
#else
{3, 3, 0x0000000000000000, "RW", "CORE3_DISABLE_MASK", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{2, 2, 0x0000000000000000, "RW", "CORE2_DISABLE_MASK", "core2 disable mask"},
#else
{2, 2, 0x0000000000000000, "RW", "CORE2_DISABLE_MASK", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{1, 1, 0x0000000000000000, "RW", "CORE1_DISABLE_MASK", "core1 disable mask"},
#else
{1, 1, 0x0000000000000000, "RW", "CORE1_DISABLE_MASK", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 0, 0x0000000000000000, "RW", "CORE0_DISABLE_MASK", "core0 disable mask"},
#else
{0, 0, 0x0000000000000000, "RW", "CORE0_DISABLE_MASK", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo1110[] = {{"P_CR_CORE_DISABLE_MASK_0_0_0_MCHBAR", "", 0x00007168, 4, 0x000000000000000F, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields1111[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{63, 63, 0x0000000000000000, "RW/KL", "LOCK", "Lock this MMIO  until next reset: 0 - unlocked, 1 - locked"},
#else
{63, 63, 0x0000000000000000, "RW/KL", "LOCK", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{47, 47, 0x0000000000000000, "RW/L", "PL4_ENABLE", "0 => Algorithm disabled, 1 => Algorithm enabled"},
#else
{47, 47, 0x0000000000000000, "RW/L", "PL4_ENABLE", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{32, 46, 0x0000000000000000, "RW/L", "PMAX", "Power Limit 'PL4' or Pmax power limit in the units as described PACAKGE_POWER_SKU_UNIT MSR"},
#else
{32, 46, 0x0000000000000000, "RW/L", "PMAX", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{24, 30, 0x0000000000000000, "RW/L", "DUTY_CYCLE", "Expressed in percentage(%).  Clipped to a max value of 100%."},
#else
{24, 30, 0x0000000000000000, "RW/L", "DUTY_CYCLE", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{17, 23, 0x0000000000000000, "RW/L", "TIME_WINDOW", "Duration over which duty cycle control will be maintained.  (xxYYYY format)"},
#else
{17, 23, 0x0000000000000000, "RW/L", "TIME_WINDOW", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{15, 15, 0x0000000000000000, "RW/L", "PL3_ENABLE", "0 => Algorithm disabled, 1 => Algorithm enabled"},
#else
{15, 15, 0x0000000000000000, "RW/L", "PL3_ENABLE", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 14, 0x0000000000000000, "RW/L", "POWER_LIMIT", "PL3 or PAppMax power level.  A power reading above this will be interpreted as a violation (in increments of 1/8th Watt)"},
#else
{0, 14, 0x0000000000000000, "RW/L", "POWER_LIMIT", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo1111[] = {{"P_CR_PL3_CONTROL_0_0_0_MCHBAR", "", 0x000071F0, 7, 0xFFFFFFFFFFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields1112[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{45, 63, 0x0000000000000000, "RW", "RESERVED_0", "Reserved bits"},
#else
{45, 63, 0x0000000000000000, "RW", "RESERVED_0", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{44, 44, 0x0000000000000000, "RW", "PSMI_Mode_Enabled", "Set/cleared by PSMI handler. When set, causes MLMC to stop swapping. Overrides Disable_Swaps."},
#else
{44, 44, 0x0000000000000000, "RW", "PSMI_Mode_Enabled", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{43, 43, 0x0000000000000000, "RW", "Thermal_Throttling_Enabled", "Set/cleared by Pcode. When set, causes MLMC to stop swapping. Dynamic."},
#else
{43, 43, 0x0000000000000000, "RW", "Thermal_Throttling_Enabled", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{40, 42, 0x0000000000000004, "RW", "PMI_Max_FM_Rd_Ret_Credits", "Specifies how many read return credits to give to each far memory D-Unit."},
#else
{40, 42, 0x0000000000000004, "RW", "PMI_Max_FM_Rd_Ret_Credits", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{37, 39, 0x0000000000000004, "RW", "PMI_Max_NM_Rd_Ret_Credits", "Specifies how many read return credits to give to each near memory D-Unit."},
#else
{37, 39, 0x0000000000000004, "RW", "PMI_Max_NM_Rd_Ret_Credits", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{34, 36, 0x0000000000000002, "RW", "PMI_Max_Bunit_Wr_Credits", "Specifies how many write request credits to give to B-Unit."},
#else
{34, 36, 0x0000000000000002, "RW", "PMI_Max_Bunit_Wr_Credits", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{31, 33, 0x0000000000000002, "RW", "PMI_Max_Bunit_Rd_Credits", "Specifies how many read request credits to give to B-Unit."},
#else
{31, 33, 0x0000000000000002, "RW", "PMI_Max_Bunit_Rd_Credits", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{27, 30, 0x000000000000000F, "RW", "MLM_Controller_Enable", "4bit vector to identify active MLMCs: \r\n"
"             [list]\r\n"
"             [*]0: inactive \r\n"
"             [*]1: active\r\n"
"             [/list]"},
#else
{27, 30, 0x000000000000000F, "RW", "MLM_Controller_Enable", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{25, 26, 0x0000000000000000, "RW", "CR_2LM_Mode", " [list]\r\n"
"               [*]0: exclusive 2LMDDR \r\n"
"               [*]1: inclusive 2LMDDR \r\n"
"               [*]2: inclusive 2LMSXP \r\n"
"               [*]3: Reserved\r\n"
"               [/list]"},
#else
{25, 26, 0x0000000000000000, "RW", "CR_2LM_Mode", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{24, 24, 0x0000000000000001, "RW", "CR_1LM_Mode", "[list]\r\n"
"              [*]0: 2LM \r\n"
"              [*]1: 1LM mode bypass MLM core logic\r\n"
"              [/list]"},
#else
{24, 24, 0x0000000000000001, "RW", "CR_1LM_Mode", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{17, 23, 0x0000000000000000, "RW", "TQ_rsvd_non_VC0", "TBD"},
#else
{17, 23, 0x0000000000000000, "RW", "TQ_rsvd_non_VC0", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{10, 16, 0x0000000000000000, "RW", "Astore_rsvd_non_VC0", "TBD"},
#else
{10, 16, 0x0000000000000000, "RW", "Astore_rsvd_non_VC0", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{3, 9, 0x0000000000000004, "RW", "Astore_Low_WM", "Watermark for when Astore starts to evict old translations."},
#else
{3, 9, 0x0000000000000004, "RW", "Astore_Low_WM", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{1, 2, 0x0000000000000001, "RW", "NM_Size_MB", "Near memory size in GB: \r\n"
"              [list]\r\n"
"              [*]1: 1GB \r\n"
"              [*]2: 2GB\r\n"
"              [/list]"},
#else
{1, 2, 0x0000000000000001, "RW", "NM_Size_MB", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 0, 0x0000000000000001, "RW", "Num_NM_Channels", "\r\n"
"              [list]\r\n"
"              [*]0: 4Ch \r\n"
"              [*]1: 8Ch\r\n"
"              [/list]"},
#else
{0, 0, 0x0000000000000001, "RW", "Num_NM_Channels", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo1112[] = {{"MLM_CR_CONFIG", "", 0x00004F00, 15, 0xFFFFFFFFFFFFFFFF, 0x0000048979000023}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields1113[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{26, 31, 0x0000000000000000, "RW", "RESERVED_0", "Reserved bits"},
#else
{26, 31, 0x0000000000000000, "RW", "RESERVED_0", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{16, 25, 0x0000000000000010, "RW", "Swap_Inter_Swap_Delay", "Interswap delay in MLM clocks."},
#else
{16, 25, 0x0000000000000010, "RW", "Swap_Inter_Swap_Delay", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{8, 15, 0x0000000000000011, "RW", "Swap_Inter_Sector_Delay", "Intersector delay in MLM clocks."},
#else
{8, 15, 0x0000000000000011, "RW", "Swap_Inter_Sector_Delay", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{4, 7, 0x0000000000000004, "RW", "Swap_Num_Outstanding_CL_requests", "Max outstanding FM swap CL requests."},
#else
{4, 7, 0x0000000000000004, "RW", "Swap_Num_Outstanding_CL_requests", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 3, 0x0000000000000002, "RW", "Policy", "First Miss2 currently our only supported policy."},
#else
{0, 3, 0x0000000000000002, "RW", "Policy", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo1113[] = {{"MLM_CR_SWAP_PARAMS", "", 0x00004F08, 5, 0x00000000FFFFFFFF, 0x0000000000101142}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields1114[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{11, 31, 0x0000000000000000, "RW", "RESERVED_0", "Reserved bits - FIXME  - jlunderd - the lower 3 bits of this field have been used in the RTL and must be renamed. reserved_0[2] --> forcepgpok_sai_check_def, reserved_0[1] --> sbep_cgctrl_clkgaten_b, reserved_0[0] --> sbep_cgctrl_clkgate_def"},
#else
{11, 31, 0x0000000000000000, "RW", "RESERVED_0", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{10, 10, 0x0000000000000000, "RW", "Adjust_Sleep_idle_count", "Change idle count for entering SRAM sleep from 1 us to"},
#else
{10, 10, 0x0000000000000000, "RW", "Adjust_Sleep_idle_count", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{9, 9, 0x0000000000000000, "RW", "Disable_WL_Sleep", "Disable large SRAM WL sleep mode."},
#else
{9, 9, 0x0000000000000000, "RW", "Disable_WL_Sleep", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{8, 8, 0x0000000000000000, "RW", "Disable_BL_Float", "Disable large SRAM BL floating."},
#else
{8, 8, 0x0000000000000000, "RW", "Disable_BL_Float", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{7, 7, 0x0000000000000000, "RWV", "MLM_SDT_EXPOSE_RUNBUSY", "Polled by SDT Expose clients to determine expose completion."},
#else
{7, 7, 0x0000000000000000, "RWV", "MLM_SDT_EXPOSE_RUNBUSY", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{5, 6, 0x0000000000000000, "RW", "MLM_SDT_EXPOSE_TARGET", "[list]\r\n"
"              [*]00: Expose SDT in MLMC 0 \r\n"
"              [*]01: Expose SDT in MLMC 1 \r\n"
"              [*]10: Expose SDT in MLMC 2 \r\n"
"              [*]11: Expose SDT in MLMC 3\r\n"
"              [/list]"},
#else
{5, 6, 0x0000000000000000, "RW", "MLM_SDT_EXPOSE_TARGET", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{4, 4, 0x0000000000000000, "RW", "Disable_Porous_Swap", "Disable porous swapping."},
#else
{4, 4, 0x0000000000000000, "RW", "Disable_Porous_Swap", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{3, 3, 0x0000000000000000, "RW", "Disable_Pinning", "Disable pinning."},
#else
{3, 3, 0x0000000000000000, "RW", "Disable_Pinning", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{2, 2, 0x0000000000000000, "RW", "Disable_TC", "Disable ondie tag cache."},
#else
{2, 2, 0x0000000000000000, "RW", "Disable_TC", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{1, 1, 0x0000000000000000, "RW", "Disable_ODTS", "Disable ondie tag store."},
#else
{1, 1, 0x0000000000000000, "RW", "Disable_ODTS", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 0, 0x0000000000000000, "RW", "Disable_Swaps", "Disable swapping. Static overrides all other swapping enables."},
#else
{0, 0, 0x0000000000000000, "RW", "Disable_Swaps", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo1114[] = {{"MLM_CR_DEFEATURES", "", 0x00004F0C, 11, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields1115[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{31, 31, 0x0000000000000000, "RW", "enabled", "Enable pinning region 0."},
#else
{31, 31, 0x0000000000000000, "RW", "enabled", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{28, 30, 0x0000000000000000, "RW", "RESERVED_1", "Read only 0"},
#else
{28, 30, 0x0000000000000000, "RW", "RESERVED_1", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{24, 27, 0x0000000000000000, "RW", "Pinned_way", "Pinned region 0 pinned way."},
#else
{24, 27, 0x0000000000000000, "RW", "Pinned_way", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{22, 23, 0x0000000000000000, "RW", "RESERVED_0", "Read only 0"},
#else
{22, 23, 0x0000000000000000, "RW", "RESERVED_0", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{16, 21, 0x0000000000000000, "RW", "Size", "Pinned region 0 -- size of pinned region, 1MB granularity."},
#else
{16, 21, 0x0000000000000000, "RW", "Size", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 15, 0x0000000000000000, "RW", "Base", "Pinning region 0 -- base address of pinned PPA, 1MB granularity."},
#else
{0, 15, 0x0000000000000000, "RW", "Base", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo1115[] = {{"MLM_CR_PINNING_REGION0", "", 0x00004F10, 6, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields1116[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{31, 31, 0x0000000000000000, "RW", "enabled", "Enable pinning region 1."},
#else
{31, 31, 0x0000000000000000, "RW", "enabled", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{28, 30, 0x0000000000000000, "RW", "RESERVED_1", "Read only 0"},
#else
{28, 30, 0x0000000000000000, "RW", "RESERVED_1", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{24, 27, 0x0000000000000000, "RW", "Pinned_way", "Pinned region 1 pinned way."},
#else
{24, 27, 0x0000000000000000, "RW", "Pinned_way", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{22, 23, 0x0000000000000000, "RW", "RESERVED_0", "Read only 0"},
#else
{22, 23, 0x0000000000000000, "RW", "RESERVED_0", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{16, 21, 0x0000000000000000, "RW", "Size", "Pinned region 1 -- size of pinned region, 1MB granularity."},
#else
{16, 21, 0x0000000000000000, "RW", "Size", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 15, 0x0000000000000000, "RW", "Base", "Pinning region 1: Base address of pinned PPA, 1MB granularity."},
#else
{0, 15, 0x0000000000000000, "RW", "Base", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo1116[] = {{"MLM_CR_PINNING_REGION1", "", 0x00004F14, 6, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields1117[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{31, 31, 0x0000000000000000, "RW", "enabled", "Enable pinning region 2."},
#else
{31, 31, 0x0000000000000000, "RW", "enabled", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{28, 30, 0x0000000000000000, "RW", "RESERVED_1", "Read only 0"},
#else
{28, 30, 0x0000000000000000, "RW", "RESERVED_1", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{24, 27, 0x0000000000000000, "RW", "Pinned_way", "Pinned region 2 pinned way."},
#else
{24, 27, 0x0000000000000000, "RW", "Pinned_way", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{22, 23, 0x0000000000000000, "RW", "RESERVED_0", "Read only 0"},
#else
{22, 23, 0x0000000000000000, "RW", "RESERVED_0", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{16, 21, 0x0000000000000000, "RW", "Size", "Pinned region 2: Size of pinned region, 1MB granularity."},
#else
{16, 21, 0x0000000000000000, "RW", "Size", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 15, 0x0000000000000000, "RW", "Base", "Pinning region 2: Base address of pinned PPA, 1MB granularity."},
#else
{0, 15, 0x0000000000000000, "RW", "Base", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo1117[] = {{"MLM_CR_PINNING_REGION2", "", 0x00004F18, 6, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields1118[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{31, 31, 0x0000000000000000, "RW", "enabled", "Enable pinning region 2"},
#else
{31, 31, 0x0000000000000000, "RW", "enabled", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{28, 30, 0x0000000000000000, "RW", "RESERVED_1", "Read only 0"},
#else
{28, 30, 0x0000000000000000, "RW", "RESERVED_1", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{24, 27, 0x0000000000000000, "RW", "Pinned_way", "Pinned region 2 pinned way."},
#else
{24, 27, 0x0000000000000000, "RW", "Pinned_way", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{22, 23, 0x0000000000000000, "RW", "RESERVED_0", "Read only 0"},
#else
{22, 23, 0x0000000000000000, "RW", "RESERVED_0", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{16, 21, 0x0000000000000000, "RW", "Size", "Pinned region 2: Size of pinned region, 1MB granularity."},
#else
{16, 21, 0x0000000000000000, "RW", "Size", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 15, 0x0000000000000000, "RW", "Base", "Pinning region 2: Base address of pinned PPA, 1MB granularity."},
#else
{0, 15, 0x0000000000000000, "RW", "Base", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo1118[] = {{"MLM_CR_PINNING_REGION3", "", 0x00004F1C, 6, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields1119[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{10, 31, 0x0000000000000000, "RW", "RESERVED_0", "Reserved bits"},
#else
{10, 31, 0x0000000000000000, "RW", "RESERVED_0", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{5, 9, 0x0000000000000004, "RW", "Max_Pinned_Ways", "Maximum number of pinned ways per set."},
#else
{5, 9, 0x0000000000000004, "RW", "Max_Pinned_Ways", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 4, 0x0000000000000004, "RW", "Min_Unpinned_Ways", "Minimum number of unpinned ways per set"},
#else
{0, 4, 0x0000000000000004, "RW", "Min_Unpinned_Ways", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo1119[] = {{"MLM_CR_PINNING", "", 0x00004F20, 3, 0x00000000FFFFFFFF, 0x0000000000000084}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields1120[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{2, 31, 0x0000000000000000, "RW", "RESERVED_0", "Reserved bits"},
#else
{2, 31, 0x0000000000000000, "RW", "RESERVED_0", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{1, 1, 0x0000000000000000, "RWV", "SDT_Init_Done", "Flag set by MLMC when SDT initialization is complete."},
#else
{1, 1, 0x0000000000000000, "RWV", "SDT_Init_Done", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 0, 0x0000000000000000, "RW", "Execute_SDT_Init", "Flag for Pcode/BIOS to set when MLMC should perform SDT initialization."},
#else
{0, 0, 0x0000000000000000, "RW", "Execute_SDT_Init", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo1120[] = {{"MLM_CR_MISC", "", 0x00004F24, 3, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields1121[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{52, 63, 0x0000000000000000, "RWV", "MLM3_DED_SET_ADDRESS", "SET address in DED : For the case of both SRAM have DED the set of small SRAM will be reported."},
#else
{52, 63, 0x0000000000000000, "RWV", "MLM3_DED_SET_ADDRESS", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{51, 51, 0x0000000000000000, "RWV", "MLM3_DED_SET_VALID", "[list]\r\n"
"              [*]0: set address is not valid  \r\n"
"              [*]1: SET address in DED is valid\r\n"
"              [/list]"},
#else
{51, 51, 0x0000000000000000, "RWV", "MLM3_DED_SET_VALID", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{50, 50, 0x0000000000000000, "RWV", "MLM3_DED_overflow", "There are DEDs more than 1."},
#else
{50, 50, 0x0000000000000000, "RWV", "MLM3_DED_overflow", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{49, 49, 0x0000000000000000, "RWV", "MLM3_LARGE_SRAM_DED", "[list]\r\n"
"              [*]0: no double bit errors in the large SRAM  \r\n"
"              [*]1: DED happens in the large SRAM\r\n"
"              [/list]"},
#else
{49, 49, 0x0000000000000000, "RWV", "MLM3_LARGE_SRAM_DED", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{48, 48, 0x0000000000000000, "RWV", "MLM3_SMALL_SRAM_DED", "[list]\r\n"
"              [*]0: no double bit errors in the large SRAM  \r\n"
"              [*]1: DED happens in the small SRAM\r\n"
"              [/list]"},
#else
{48, 48, 0x0000000000000000, "RWV", "MLM3_SMALL_SRAM_DED", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{36, 47, 0x0000000000000000, "RWV", "MLM2_DED_SET_ADDRESS", "SET address in DED: For the case in which both SRAMs have DED, the set of small SRAM will be reported."},
#else
{36, 47, 0x0000000000000000, "RWV", "MLM2_DED_SET_ADDRESS", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{35, 35, 0x0000000000000000, "RWV", "MLM2_DED_SET_VALID", "[list]\r\n"
"              [*]0: set address is not valid  \r\n"
"              [*]1: SET address in DED is valid\r\n"
"              [/list]"},
#else
{35, 35, 0x0000000000000000, "RWV", "MLM2_DED_SET_VALID", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{34, 34, 0x0000000000000000, "RWV", "MLM2_DED_overflow", "There are DEDs more than 1."},
#else
{34, 34, 0x0000000000000000, "RWV", "MLM2_DED_overflow", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{33, 33, 0x0000000000000000, "RWV", "MLM2_LARGE_SRAM_DED", "[list]\r\n"
"              [*]0: no double bit errors in the large SRAM  \r\n"
"              [*]1: DED happens in the large SRAM\r\n"
"              [/list]"},
#else
{33, 33, 0x0000000000000000, "RWV", "MLM2_LARGE_SRAM_DED", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{32, 32, 0x0000000000000000, "RWV", "MLM2_SMALL_SRAM_DED", "[list]\r\n"
"              [*]0: no double bit errors in the large SRAM  \r\n"
"              [*]1: DED happens in the small SRAM\r\n"
"              [/list]"},
#else
{32, 32, 0x0000000000000000, "RWV", "MLM2_SMALL_SRAM_DED", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{20, 31, 0x0000000000000000, "RWV", "MLM1_DED_SET_ADDRESS", "SET address in DED: For the case in which both SRAMs have DED, the set of small SRAM will be reported."},
#else
{20, 31, 0x0000000000000000, "RWV", "MLM1_DED_SET_ADDRESS", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{19, 19, 0x0000000000000000, "RWV", "MLM1_DED_SET_VALID", "[list]\r\n"
"              [*]0: set address is not valid\r\n"
"              [*]1: SET address in DED is valid\r\n"
"              [/list]"},
#else
{19, 19, 0x0000000000000000, "RWV", "MLM1_DED_SET_VALID", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{18, 18, 0x0000000000000000, "RWV", "MLM1_DED_overflow", "There are DEDs more than 1."},
#else
{18, 18, 0x0000000000000000, "RWV", "MLM1_DED_overflow", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{17, 17, 0x0000000000000000, "RWV", "MLM1_LARGE_SRAM_DED", "[list]\r\n"
"              [*]0: no double bit errors in the large SRAM  \r\n"
"              [*]1: DED happens in the large SRAM\r\n"
"              [/list]"},
#else
{17, 17, 0x0000000000000000, "RWV", "MLM1_LARGE_SRAM_DED", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{16, 16, 0x0000000000000000, "RWV", "MLM1_SMALL_SRAM_DED", "[list]\r\n"
"              [*]0: no double bit errors in the large SRAM  \r\n"
"              [*]1: DED happens in the small SRAM\r\n"
"              [/list]"},
#else
{16, 16, 0x0000000000000000, "RWV", "MLM1_SMALL_SRAM_DED", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{4, 15, 0x0000000000000000, "RWV", "MLM0_DED_SET_ADDRESS", "SET address in DED: For the case in which both SRAMs have DED, the set of small SRAM will be reported."},
#else
{4, 15, 0x0000000000000000, "RWV", "MLM0_DED_SET_ADDRESS", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{3, 3, 0x0000000000000000, "RWV", "MLM0_DED_SET_VALID", "[list]\r\n"
"              [*]0: set address is not valid\r\n"
"              [*]1: SET address in DED is valid\r\n"
"              [/list]"},
#else
{3, 3, 0x0000000000000000, "RWV", "MLM0_DED_SET_VALID", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{2, 2, 0x0000000000000000, "RWV", "MLM0_DED_overflow", "There are DEDs more than 1."},
#else
{2, 2, 0x0000000000000000, "RWV", "MLM0_DED_overflow", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{1, 1, 0x0000000000000000, "RWV", "MLM0_LARGE_SRAM_DED", "[list]\r\n"
"              [*]0: no double bit errors in the large SRAM  \r\n"
"              [*]1: DED happens in the large SRAM\r\n"
"              [/list]"},
#else
{1, 1, 0x0000000000000000, "RWV", "MLM0_LARGE_SRAM_DED", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 0, 0x0000000000000000, "RWV", "MLM0_SMALL_SRAM_DED", "[list]\r\n"
"              [*]0: no double bit errors in the large SRAM  \r\n"
"              [*]1: DED happens in the small SRAM\r\n"
"              [/list]"},
#else
{0, 0, 0x0000000000000000, "RWV", "MLM0_SMALL_SRAM_DED", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo1121[] = {{"MLM_CR_ARRAY_ECC_STATUS", "", 0x00004F28, 20, 0xFFFFFFFFFFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields1122[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{46, 63, 0x0000000000000000, "RWV", "RESERVED_0", "Reserved bits"},
#else
{46, 63, 0x0000000000000000, "RWV", "RESERVED_0", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{45, 45, 0x0000000000000000, "ROV", "MLMC_core_empty", "1 if la astore is empty -- all rd/wt were done."},
#else
{45, 45, 0x0000000000000000, "ROV", "MLMC_core_empty", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{44, 44, 0x0000000000000000, "ROV", "MLMC_core_quiet", "1 if all TC/TM/LA/DA are quiet --  all functional units in mlmc are quiet."},
#else
{44, 44, 0x0000000000000000, "ROV", "MLMC_core_quiet", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{43, 43, 0x0000000000000000, "ROV", "MLMC_adapters_quiet", "1 if all responders are ready for entering clock_gating."},
#else
{43, 43, 0x0000000000000000, "ROV", "MLMC_adapters_quiet", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{42, 42, 0x0000000000000000, "RWV", "FM_PMI_Idle_Status", "1 if all far memory PMIs are in idle state."},
#else
{42, 42, 0x0000000000000000, "RWV", "FM_PMI_Idle_Status", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{41, 41, 0x0000000000000000, "RWV", "NM_PMI_Idle_Status", "1 if all near memory PMIs are in idle state."},
#else
{41, 41, 0x0000000000000000, "RWV", "NM_PMI_Idle_Status", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{40, 40, 0x0000000000000000, "RWV", "Bunit_PMI_Idle_Status", "1 if all B-Unit PMIs are in idle state."},
#else
{40, 40, 0x0000000000000000, "RWV", "Bunit_PMI_Idle_Status", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{16, 39, 0x0000000000000000, "RWV", "FM_Access_Count", "Total number of FM accesses readswrites across all MLMCs."},
#else
{16, 39, 0x0000000000000000, "RWV", "FM_Access_Count", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 15, 0x0000000000000000, "RWV", "Swap_Count", "Total swap count across all 4 MLMCs."},
#else
{0, 15, 0x0000000000000000, "RWV", "Swap_Count", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo1122[] = {{"MLM_CR_STATUS", "", 0x00004F30, 9, 0xFFFFFFFFFFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields1123[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{0, 63, 0x00000C0061010212, "RW", "RESERVED_0", "Reserved bits"},
#else
{0, 63, 0x00000C0061010212, "RW", "RESERVED_0", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo1123[] = {{"MLM_CR_SAI_RAC", "", 0x00004F38, 1, 0xFFFFFFFFFFFFFFFF, 0x00000C0061010212}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields1124[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{0, 63, 0x00000C0061010212, "RW", "RESERVED_0", "Reserved bits"},
#else
{0, 63, 0x00000C0061010212, "RW", "RESERVED_0", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo1124[] = {{"MLM_CR_SAI_WAC", "", 0x00004F40, 1, 0xFFFFFFFFFFFFFFFF, 0x00000C0061010212}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields1125[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{0, 63, 0x00000C0061010202, "RW", "RESERVED_0", "Reserved bits"},
#else
{0, 63, 0x00000C0061010202, "RW", "RESERVED_0", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo1125[] = {{"MLM_CR_SAI_CP", "", 0x00004F48, 1, 0xFFFFFFFFFFFFFFFF, 0x00000C0061010202}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields1126[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{29, 31, 0x0000000000000000, "RW", "RESERVED_0", "Reserved bits"},
#else
{29, 31, 0x0000000000000000, "RW", "RESERVED_0", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{28, 28, 0x0000000000000000, "RW", "Disable_pgcbclk_trunk_gating", "This will prevent PGCB clockreq from going down. pgcb clock stays alive but ipclk clkreq can turn off."},
#else
{28, 28, 0x0000000000000000, "RW", "Disable_pgcbclk_trunk_gating", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{27, 27, 0x0000000000000000, "RW", "Enable_clkreq2ccp", "This is for disabling the clock req from CDC to the CCP.ie trunk clock. This will not affect local clock gating."},
#else
{27, 27, 0x0000000000000000, "RW", "Enable_clkreq2ccp", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{26, 26, 0x0000000000000000, "RW", "Sleep_Enable", "If set, then IP may assert Sleep during PG ing."},
#else
{26, 26, 0x0000000000000000, "RW", "Sleep_Enable", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{25, 25, 0x0000000000000000, "RW", "Astore_Always_Flush", "Enables immediate flushing of Astore entries."},
#else
{25, 25, 0x0000000000000000, "RW", "Astore_Always_Flush", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{24, 24, 0x0000000000000001, "RW", "Powergate_Leave_TC_ON", "If set, causes TC to remain turned on during AutoPG."},
#else
{24, 24, 0x0000000000000001, "RW", "Powergate_Leave_TC_ON", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{13, 23, 0x0000000000000002, "RW", "PGCB_Powergate_Timer", "Number of SB clocks 100MHz till PGCB powergates MLMC."},
#else
{13, 23, 0x0000000000000002, "RW", "PGCB_Powergate_Timer", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{9, 12, 0x0000000000000002, "RW", "PGCB_Clockgate_hyst_timer", "Number of SB clocks 100MHz till PGCB clockgates MLMC."},
#else
{9, 12, 0x0000000000000002, "RW", "PGCB_Clockgate_hyst_timer", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{8, 8, 0x0000000000000000, "RW", "PGCB_HW_Autonomous_Enable", "Enable of PGCB HW_AutoPG -- always 0 since POR is P-Unit control."},
#else
{8, 8, 0x0000000000000000, "RW", "PGCB_HW_Autonomous_Enable", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{7, 7, 0x0000000000000001, "RW", "PMC_Request_Enable", "If set, then IP will PG when idle and the PMC requests power gating."},
#else
{7, 7, 0x0000000000000001, "RW", "PMC_Request_Enable", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{6, 6, 0x0000000000000000, "RW", "PGCB_CGREQ_DISABLE", "This will disable internal clock gating in cdc. This in turn will also disable IP to CCP clock req."},
#else
{6, 6, 0x0000000000000000, "RW", "PGCB_CGREQ_DISABLE", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{2, 5, 0x0000000000000004, "RW", "PMI_ISM_Idle_Timer", "Number of MLMC clocks of idleness before requesting PMI to go idle."},
#else
{2, 5, 0x0000000000000004, "RW", "PMI_ISM_Idle_Timer", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{1, 1, 0x0000000000000000, "RW", "PMI_ISM_Force_Wakeup", "If set, forces all requestor ISMs to wake up and stop requesting clock/power gating."},
#else
{1, 1, 0x0000000000000000, "RW", "PMI_ISM_Force_Wakeup", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 0, 0x0000000000000000, "RW", "PMI_ISM_Idle_Disable", "If set, prevents all PMI ISMs from entering idle state."},
#else
{0, 0, 0x0000000000000000, "RW", "PMI_ISM_Idle_Disable", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo1126[] = {{"MLM_CR_POWER_MGMT", "", 0x00004F50, 14, 0x00000000FFFFFFFF, 0x0000000001004490}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields1127[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{30, 31, 0x0000000000000000, "RW", "RESERVED_0", "Reserved bits"},
#else
{30, 31, 0x0000000000000000, "RW", "RESERVED_0", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{29, 29, 0x0000000000000000, "RW", "Mem_Init_Done", "Flag for BIOS to set when FM configuration fields are set."},
#else
{29, 29, 0x0000000000000000, "RW", "Mem_Init_Done", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{23, 28, 0x0000000000000004, "RW", "FM_Chan_E_Size", "Far memory channel East size in 256MB multiples."},
#else
{23, 28, 0x0000000000000004, "RW", "FM_Chan_E_Size", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{17, 22, 0x0000000000000004, "RW", "FM_Chan_W_Size", "Far memory channel West size in 256MB multiples"},
#else
{17, 22, 0x0000000000000004, "RW", "FM_Chan_W_Size", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{11, 16, 0x0000000000000004, "RW", "FM_Chan_N_Size", "Far memory channel North size in 256MB multiples"},
#else
{11, 16, 0x0000000000000004, "RW", "FM_Chan_N_Size", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{5, 10, 0x0000000000000004, "RW", "FM_Chan_S_Size", "Far memory channel South size in 256MB multiples"},
#else
{5, 10, 0x0000000000000004, "RW", "FM_Chan_S_Size", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{1, 4, 0x0000000000000009, "RW", "FM_Active_Dunits", "Active far memory Dunits. One bit for S N W E Dunits."},
#else
{1, 4, 0x0000000000000009, "RW", "FM_Active_Dunits", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 0, 0x0000000000000000, "RW", "FM_No_LPDDR_Present", "Near memory only configuration, i.e. only WIO2 populated -- debugonly only."},
#else
{0, 0, 0x0000000000000000, "RW", "FM_No_LPDDR_Present", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo1127[] = {{"MLM_CR_FM_CONFIG", "", 0x00004F54, 8, 0x00000000FFFFFFFF, 0x0000000002082092}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields1128[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{13, 31, 0x0000000000000000, "RW", "RESERVED_0", "Reserved bits"},
#else
{13, 31, 0x0000000000000000, "RW", "RESERVED_0", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{12, 12, 0x0000000000000000, "RW", "FMArb_Staggered_Intlv", "[list]\r\n"
"              [*]1: FMArb performs staggered interleave \r\n"
"              [*]0: FMArb does flat interleave\r\n"
"              [/list]"},
#else
{12, 12, 0x0000000000000000, "RW", "FMArb_Staggered_Intlv", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{8, 11, 0x000000000000000D, "RW", "NM_Intlv_Xor_Bit2", "NM interleave XOR bit 2 should be higher than XOR bit 1 if enabled"},
#else
{8, 11, 0x000000000000000D, "RW", "NM_Intlv_Xor_Bit2", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{7, 7, 0x0000000000000000, "RW", "NM_Intlv_Xor_Bit2_Enable", "Optional. Do not use with 1K and 2K interleave."},
#else
{7, 7, 0x0000000000000000, "RW", "NM_Intlv_Xor_Bit2_Enable", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{3, 6, 0x000000000000000A, "RW", "NM_Intlv_Xor_Bit1", "This should be higher than bit 6, if enabled."},
#else
{3, 6, 0x000000000000000A, "RW", "NM_Intlv_Xor_Bit1", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{2, 2, 0x0000000000000000, "RW", "NM_Intlv_Xor_Bit1_Enable", "Optional. Do not use with 1K and 2K interleave."},
#else
{2, 2, 0x0000000000000000, "RW", "NM_Intlv_Xor_Bit1_Enable", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 1, 0x0000000000000000, "RW", "NM_Intlv_Bit", "[list]\r\n"
"              [*]0: bit 10 interleave \r\n"
"              [*]1: bit 11 interleave \r\n"
"              [*]2: bit 6 interleave\r\n"
"              [/list]"},
#else
{0, 1, 0x0000000000000000, "RW", "NM_Intlv_Bit", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo1128[] = {{"MLM_CR_NM_INTERLEAVE", "", 0x00004F58, 7, 0x00000000FFFFFFFF, 0x0000000000000D50}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields1129[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{23, 31, 0x0000000000000015, "RW/V", "DEVICE_ID_STRAP2", "The reset default value of this register is tied to the parameter DEVICE_ID_STRAP2. These  bits  can  be  rewritten  from SETIDVALUE message 1st DW data byte 2  byte3"},
#else
{23, 31, 0x0000000000000015, "RW/V", "DEVICE_ID_STRAP2", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{21, 22, 0x0000000000000003, "RO", "DEVICE_ID_STRAP1", "These bits are tied to a Cunit parameter DEVICE_ID_STRAP1."},
#else
{21, 22, 0x0000000000000003, "RO", "DEVICE_ID_STRAP1", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{16, 20, 0x0000000000000010, "RO/V", "DEVICE_ID_FUSE", "These  bits  are fuse backed."},
#else
{16, 20, 0x0000000000000010, "RO/V", "DEVICE_ID_FUSE", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 15, 0x0000000000008086, "RO", "VENDOR_ID", "Hardwired to Intels VENDOR ID value"},
#else
{0, 15, 0x0000000000008086, "RO", "VENDOR_ID", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo1129[] = {{"DEVICE_ID_VENDOR_ID_0_0_0_PCI", "", 0x00000000, 4, 0x00000000FFFFFFFF, 0x000000000AF08086}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields1130[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{0, 31, 0x0000000000000007, "RO", "PCI_STATUS_AND_COMMAND", "PCI Status and PCI Command. Hardwired to 32 h00000007"},
#else
{0, 31, 0x0000000000000007, "RO", "PCI_STATUS_AND_COMMAND", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo1130[] = {{"PCI_STATUS_COMMAND_0_0_0_PCI", "", 0x00000004, 1, 0x00000000FFFFFFFF, 0x0000000000000007}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields1131[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{16, 31, 0x0000000000000600, "RO", "CLASS_CODE1", "Hardwired 16 h0600"},
#else
{16, 31, 0x0000000000000600, "RO", "CLASS_CODE1", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{8, 15, 0x0000000000000000, "RO", "CLASS_CODE0", "Hardwired to 8 h00"},
#else
{8, 15, 0x0000000000000000, "RO", "CLASS_CODE0", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 7, 0x0000000000000000, "RW/V", "REVISION_ID_STRAP", "These  bits  can  be  rewritten  from SETIDVALUE message 1st DW data byte 0"},
#else
{0, 7, 0x0000000000000000, "RW/V", "REVISION_ID_STRAP", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo1131[] = {{"REVISION_ID_CLASS_CODE_0_0_0_PCI", "", 0x00000008, 3, 0x00000000FFFFFFFF, 0x0000000006000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields1132[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{24, 31, 0x0000000000000000, "RO", "RESERVED_1", "Reserved"},
#else
{24, 31, 0x0000000000000000, "RO", "RESERVED_1", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{16, 23, 0x0000000000000080, "RO", "HEADER_TYPE", "Header Type"},
#else
{16, 23, 0x0000000000000080, "RO", "HEADER_TYPE", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{8, 15, 0x0000000000000000, "RO", "MASTER_LATENCY_TIMER", "Header Type   hardwired to 0"},
#else
{8, 15, 0x0000000000000000, "RO", "MASTER_LATENCY_TIMER", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 7, 0x0000000000000000, "RO", "RESERVED_0", "Reserved"},
#else
{0, 7, 0x0000000000000000, "RO", "RESERVED_0", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo1132[] = {{"MASTER_LATENCY_TIME_0_0_0_PCI", "", 0x0000000C, 4, 0x00000000FFFFFFFF, 0x0000000000800000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields1133[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{15, 31, 0x0000000000000000, "RW", "TMMBA", "This field corresponds to bits 31 to 15 of the base address TMBAR address space. BIOS will program this register resulting in a base address for a 32KB block of contiguous memory address space. This register ensures that a naturally aligned 32KB space is allocated within total addressable memory space. The DPTF driver uses this base address to program all Thermal and Throttling control register set."},
#else
{15, 31, 0x0000000000000000, "RW", "TMMBA", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{4, 14, 0x0000000000000000, "RO", "ADM", "Hardwired to 0s to indicate at least 32KB address range."},
#else
{4, 14, 0x0000000000000000, "RO", "ADM", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{3, 3, 0x0000000000000000, "RO", "PM", "Hardwired to 0 to prevent prefetching."},
#else
{3, 3, 0x0000000000000000, "RO", "PM", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{1, 2, 0x0000000000000002, "RO", "MT", "Hardwired to 10 to indicate 64bit address."},
#else
{1, 2, 0x0000000000000002, "RO", "MT", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 0, 0x0000000000000000, "RO", "MIOS", "This register represents the lower 32bits of PCI CFG register for that defines the DPTF MMIO address space."},
#else
{0, 0, 0x0000000000000000, "RO", "MIOS", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo1133[] = {{"TMBAR_LO_0_0_1_PCI", "", 0x00000010, 5, 0x00000000FFFFFFFF, 0x0000000000000004}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields1134[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{7, 31, 0x0000000000000000, "RW", "RSVDRW", "Must be set to 0 since addressing above 512GB is not supported."},
#else
{7, 31, 0x0000000000000000, "RW", "RSVDRW", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 6, 0x0000000000000000, "RW", "TMMBA", "This register represents the lower 32bits of PCI CFG register for that defines the DPTF MMIO address space."},
#else
{0, 6, 0x0000000000000000, "RW", "TMMBA", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo1134[] = {{"TMBAR_HI_0_0_1_PCI", "", 0x00000014, 2, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields1135[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{16, 31, 0x0000000000000000, "RW", "SUBSYSTEM_ID", "PCI Subsystem ID: This field should be programmed during BIOS initialization."},
#else
{16, 31, 0x0000000000000000, "RW", "SUBSYSTEM_ID", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 15, 0x0000000000000000, "RW", "SUBSYSTEM_VENDOR_ID", "PCI Subsystem Vendor ID: This field shouldbe programmed by BIOS during bootup to indicate the vendor of the system board."},
#else
{0, 15, 0x0000000000000000, "RW", "SUBSYSTEM_VENDOR_ID", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo1135[] = {{"SVID_SID_0_0_0_PCI", "", 0x0000002C, 2, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields1136[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{8, 31, 0x0000000000000000, "RO", "RESERVED_0", "Reserved"},
#else
{8, 31, 0x0000000000000000, "RO", "RESERVED_0", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 7, 0x00000000000000E0, "RO", "BASE_ADDR", "Pointer to first capabilities register"},
#else
{0, 7, 0x00000000000000E0, "RO", "BASE_ADDR", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo1136[] = {{"CAPPTR_0_0_0_PCI", "", 0x00000034, 2, 0x00000000FFFFFFFF, 0x00000000000000E0}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields1137[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{15, 31, 0x0000000000000000, "RW", "BASE_ADDR", "Number of implemented bits used to indicated size of BAR 32kB"},
#else
{15, 31, 0x0000000000000000, "RW", "BASE_ADDR", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{4, 14, 0x0000000000000000, "RO", "BASE_ADDR_NOT_IMPLEMENTED", "Hardwired to 0 to indicate size of BAR 32kB"},
#else
{4, 14, 0x0000000000000000, "RO", "BASE_ADDR_NOT_IMPLEMENTED", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{1, 3, 0x0000000000000000, "RO", "RESERVED_0", "Reserved"},
#else
{1, 3, 0x0000000000000000, "RO", "RESERVED_0", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 0, 0x0000000000000000, "RW", "MCHBAREN", "0: MCHBAR is disabled and does not claim any memory  1: MCHBAR memory mapped accesses are claimed and decoded appropriately  Encoding Description  0b MCHBAR is disabled  1b MCHBAR is enabled"},
#else
{0, 0, 0x0000000000000000, "RW", "MCHBAREN", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo1137[] = {{"MCHBAR_LO_0_0_0_PCI", "", 0x00000048, 4, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields1138[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{7, 31, 0x0000000000000000, "RO", "RESERVED_0", "Reserved"},
#else
{7, 31, 0x0000000000000000, "RO", "RESERVED_0", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 6, 0x0000000000000000, "RW", "BASE_ADDR", "Number of implemented bits used to indicated size of BAR 32kB"},
#else
{0, 6, 0x0000000000000000, "RW", "BASE_ADDR", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo1138[] = {{"MCHBAR_HI_0_0_0_PCI", "", 0x0000004C, 2, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields1139[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{16, 31, 0x0000000000000000, "RO", "RESERVED_1", "Reserved"},
#else
{16, 31, 0x0000000000000000, "RO", "RESERVED_1", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{8, 15, 0x0000000000000000, "RW", "GMS", "This field is used to select the amount of Main Memory that is preallocated to support the Internal Graphics device in VGA nonlinear and Native linear modes. The BIOS ensures that memory is preallocated only when Internal graphics is enabled.  This register is also Intel TXT lockable.  Hardware does not clear or set any of these bits automatically based on IGD being disabled/enabled.  BIOS Requirement: BIOS must not set this field to 0h if IVD bit 1 of this register is 0.  0x00:0MB  0x01:32MB  0x02:64MB  0x03:96MB  0x04:128MB  0x05:160MB  0x06:192MB  0x07:224MB  0x08:256MB  0x09:288MB  0x0A:320MB  0x0B:352MB  0x0C:384MB  0x0D:416MB  0x0E:448MB  0x0F:480MB  0x10:512MB  0x20:...1024MB...  0x30:...1536MB...  0x3F:...2016MB  0x400xFF:Illegal value"},
#else
{8, 15, 0x0000000000000000, "RW", "GMS", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{6, 7, 0x0000000000000000, "RW", "GGMS", "This field is used to select the amount of Main Memory that is preallocated to support the Internal Graphics Translation Table. The BIOS ensures that memory is preallocated only when Internal graphics is enabled.  GSM is assumed to be a contiguous physical DRAM space with DSM and BIOS needs to allocate a contiguous memory chunk. Hardware will derive the base of GSM from DSM only using the GSM size programmed in the register.  Hardware functionality in case of programming this value to Reserved is not guaranteed.  0x0:No Preallocated Memory  0x1:2MB of Preallocated Memory  0x2:4MB of Preallocated Memory  0x3:8MB of Preallocated Memory"},
#else
{6, 7, 0x0000000000000000, "RW", "GGMS", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{3, 5, 0x0000000000000000, "RO", "RESERVED_0", "Reserved"},
#else
{3, 5, 0x0000000000000000, "RO", "RESERVED_0", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{2, 2, 0x0000000000000000, "RO", "VAMEN", "Enables the use of the iGFX enbines for Versatile Acceleration.  1  iGFX engines are in Versatile Acceleration Mode. Device 2 Class Code is 048000h.  0  iGFX engines are in iGFX Mode. Device 2 Class Code is 030000h."},
#else
{2, 2, 0x0000000000000000, "RO", "VAMEN", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{1, 1, 0x0000000000000000, "RW/V", "IVD", "IGD VGA Disable  0: Enable. Device 2 IGD claims VGA memory and IO cycles the SubClass Code within Device 2 Class Code register is 00.  1: Disable. Device 2 IGD does not claim VGA cycles Mem and IO and the Sub Class Code field within Device 2 function 0 Class Code register is 80.  BIOS Requirement: BIOS must not set this bit to 0 if the GMS field bits 7:3 of this register preallocates no memory.  This bit MUST be set to 1 if Device 2 is disabled DEVEN_0_0_0_PCI.D2F0EN  0."},
#else
{1, 1, 0x0000000000000000, "RW/V", "IVD", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 0, 0x0000000000000000, "RW", "GGCLCK", "This lock bit only impacts the Display copy of this register. In the Cunit all register protection is implemented with SAI policy groups. This bit is maintained in the Cunit for software observability. Diplay description: This bit locks all other writeable bits in this register."},
#else
{0, 0, 0x0000000000000000, "RW", "GGCLCK", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo1139[] = {{"GGC_0_0_0_PCI", "", 0x00000050, 7, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields1140[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{6, 31, 0x0000000000000000, "RO", "RESERVED_1", "Reserved"},
#else
{6, 31, 0x0000000000000000, "RO", "RESERVED_1", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{5, 5, 0x0000000000000001, "RW/V", "D3F0EN", "0:      Bus 0 Device 3 Function 0 is disabled and hidden  1:      Bus 0 Device 3 Function 0 is enabled and visible  This bit will be set to 0b and remain 0b if BDF0.3.0 capability is disabled."},
#else
{5, 5, 0x0000000000000001, "RW/V", "D3F0EN", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{4, 4, 0x0000000000000001, "RW/V", "D2F0EN", "0:      Bus 0 Device 2 Function 0 is disabled and hidden  1:      Bus 0 Device 2 Function 0 is enabled and visible  This bit will be set to 0b and remain 0b if BDF0.2.0 capability is disabled."},
#else
{4, 4, 0x0000000000000001, "RW/V", "D2F0EN", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{2, 2, 0x0000000000000000, "RO", "RESERVED_0", "Reserved"},
#else
{2, 2, 0x0000000000000000, "RO", "RESERVED_0", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{1, 1, 0x0000000000000001, "RW/V", "D0F1EN", "0:      Bus 0 Device 0 Function 1 is disabled and hidden  1:      Bus 0 Device 0 Function 1 is enabled and visible  This bit will be set to 0b and remain 0b if BDF0.0.1 capability is disabled."},
#else
{1, 1, 0x0000000000000001, "RW/V", "D0F1EN", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 0, 0x0000000000000001, "RO", "D0F0EN", "Bus 0 Device 0 Function 0 may not be disabled and is therefore hardwired to 1."},
#else
{0, 0, 0x0000000000000001, "RO", "D0F0EN", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo1140[] = {{"DEVEN_0_0_0_PCI", "", 0x00000054, 6, 0x00000000FFFFFFFF, 0x0000000000000033}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields1141[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{20, 31, 0x0000000000000000, "RW", "PCMBASE", "Sizes supported in BDW: 1M 2M 4M and 8M. Base value programmed from Top of Stolen Memory itself defines the size of the WOPCM. Separate WOPCM size programming is redundant information and not required. Default 1M size programming. 4M recommended for BDW."},
#else
{20, 31, 0x0000000000000000, "RW", "PCMBASE", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{7, 19, 0x0000000000000000, "RO", "RSVD2", "These bits are reserved for future use."},
#else
{7, 19, 0x0000000000000000, "RO", "RSVD2", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{6, 6, 0x0000000000000000, "RW", "ASMFEN", "ASMF method enabled  0b Disabled default.   1b Enabled."},
#else
{6, 6, 0x0000000000000000, "RW", "ASMFEN", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{5, 5, 0x0000000000000000, "RO", "RSVD1", "These bits are reserved for future use."},
#else
{5, 5, 0x0000000000000000, "RO", "RSVD1", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{4, 4, 0x0000000000000000, "RW", "OVTATTACK", "Override of Unsolicited Connection State Attack and Terminate.  0: Disable Override. Attack Terminate allowed.  1: Enable Override. Attack Terminate disallowed."},
#else
{4, 4, 0x0000000000000000, "RW", "OVTATTACK", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{3, 3, 0x0000000000000000, "RW", "HVYMODSEL", "This bit is applicable only for PAVP2 operation mode with a chicken bit also set or for PAVP3 mode only if the perApp memory config is disabled due to the clearing of an additional chicken bit 9 in the Crypto Function Control_1 register address 0x320F0.  0: Lite Mode NonSerpent mode  1: Serpent Mode  For chickenbit enabled PAVP3 mode this one type boot time programming has been replaced by perApp programming through the Media Crypto Copy command. Note that PAVP2 or PAVP3 mode selection is done by programming bit 8 of the MFX_MODE  Video Mode register."},
#else
{3, 3, 0x0000000000000000, "RW", "HVYMODSEL", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{2, 2, 0x0000000000000000, "RW", "PAVPLCK", "This lock bit only impacts the Display copy of this register. In the Cunit all register protection is implemented with SAI policy groups. This bit is maintained in the Cunit for software observability. Diplay description: This bit locks all writeable contents in this register when set including itself. Only a hardware reset can unlock the register again. This lock bit needs to be set only if PAVP is enabled bit 1 of this register is asserted."},
#else
{2, 2, 0x0000000000000000, "RW", "PAVPLCK", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{1, 1, 0x0000000000000000, "RW", "PAVPE", "0: PAVP functionality is disabled.  1: PAVP functionality is enabled."},
#else
{1, 1, 0x0000000000000000, "RW", "PAVPE", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 0, 0x0000000000000000, "RW", "PCME", "This field enables Protected Content Memory within Graphics Stolen Memory. This memory is the same as the WOPCM area whose size is defined by bit 5 of this register. This register is locked when PAVPLCK is set. A value of 0 in this field indicates that Protected Content Memory is disabled and cannot be programmed in this manner  when PAVP is enabled. A value of 1 in this field indicates that Protected Content Memory is enabled and is the only programming option available when PAVP is enabled. Note that the SNB legacy Lite mode programming of PCME bit  0 is not supported. For nonPAVP3 Mode even for Lite mode configuration this bit should be programmed to 1 and HVYMODESEL  0. This bit should always be programmed to 1 if bits 1 and 2 PAVPE and PAVP lock bits are both set. With perApp Memory configuration support the range check for the WOPCM memory area should always happen when this bit is set regardless of Lite or Serpent mode or PAVP2 or PAVP3 mode programming."},
#else
{0, 0, 0x0000000000000000, "RW", "PCME", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo1141[] = {{"PAVPC_0_0_0_PCI", "", 0x00000058, 9, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields1142[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{28, 31, 0x0000000000000000, "RW", "PCIEXBAR", "PCIEXBAR: PCIEXBAR[38:28] is PCIEXBAR_HI[6:0]PCIEXBAR_LO[31:28]. Describes bits [38:28] of the base address of the contiguous 256MB region for PCI Express Enhanced Configuration region.   If bits [38:28] of the request address matches the PCIEXBAR[38:28] then the request targets the PCI Express Enhanced Configuration Space region.  A posted memory operation from an IDI agent will be treated as a nonposted operation by the Tunit and Aunit."},
#else
{28, 31, 0x0000000000000000, "RW", "PCIEXBAR", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{27, 27, 0x0000000000000000, "RO", "ADMSK128", "Reserved.  Unused by SoC since PCIEXBAR is a fixed 256MB region in SoCs."},
#else
{27, 27, 0x0000000000000000, "RO", "ADMSK128", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{26, 26, 0x0000000000000000, "RO", "ADMSK64", "Reserved.  Unused by SoC since PCIEXBAR is a fixed 256MB region in SoCs."},
#else
{26, 26, 0x0000000000000000, "RO", "ADMSK64", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{3, 25, 0x0000000000000000, "RO", "RESERVED_0", "Reserved"},
#else
{3, 25, 0x0000000000000000, "RO", "RESERVED_0", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{1, 2, 0x0000000000000000, "RO", "LENGTH", "Length of the region.  Reserved and set to 0 indicating a fixed 256 MB region."},
#else
{1, 2, 0x0000000000000000, "RO", "LENGTH", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 0, 0x0000000000000000, "RW", "PCIEXBAREN", "0: The PCIEXBAR register is disabled. Memory read and write transactions proceed s if there were no PCIEXBAR register. PCIEXBAR bits 38:26 are R/W with no functionality behind them.  1: The PCIEXBAR register is enabled. Memory read and write transactions whose address bits 38:26 match PCIEXBAR will be translated to configuration reads and writes within the Uncore. These Translated cycles are routed as shown in the above table."},
#else
{0, 0, 0x0000000000000000, "RW", "PCIEXBAREN", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo1142[] = {{"PCIEXBAR_LO_0_0_0_PCI", "", 0x00000060, 6, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields1143[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{7, 31, 0x0000000000000000, "RO", "RESERVED_0", "Reserved"},
#else
{7, 31, 0x0000000000000000, "RO", "RESERVED_0", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 6, 0x0000000000000000, "RW", "PCIEXBAR_HI", "PCIEXBAR: PCIEXBAR[38:28] is PCIEXBAR_HI[6:0]PCIEXBAR_LO[31:28]. Describes bits [38:28] of the base address of the contiguous 256MB region for PCI Express Enhanced Configuration region.   If bits [38:28] of the request address matches the PCIEXBAR[38:28] then the request targets the PCI Express Enhanced Configuration Space region.  A posted memory operation from an IDI agent will be treated as a nonposted operation by the Tunit and Aunit."},
#else
{0, 6, 0x0000000000000000, "RW", "PCIEXBAR_HI", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo1143[] = {{"PCIEXBAR_HI_0_0_0_PCI", "", 0x00000064, 2, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields1144[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{20, 31, 0x0000000000000000, "RW", "TOUUD", "This register contains bits 38  to 20 of an address one byte above the maximum DRAM memory above 4G that is usable by the operating system. Configuration software must set this value to TOM minus all ME stolen memory if reclaim is disabled. If reclaim is enabled this value must be set to reclaim limit 1MB aligned since reclaim limit  1byte is 1MB aligned. Address bits 19:0 are assumed to be 000_0000h for the purposes of address comparison. The Host interface positively decodes an address towards DRAM if the incoming address is less than the value programmed in this register and greater than 4GB.  Note: for 40bit addressing have to add a bit to this field"},
#else
{20, 31, 0x0000000000000000, "RW", "TOUUD", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{1, 19, 0x0000000000000000, "RO", "RESERVED_0", "Reserved should return 0s on read"},
#else
{1, 19, 0x0000000000000000, "RO", "RESERVED_0", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 0, 0x0000000000000000, "RW", "LOCK_RESERVED", "This lock bit only impacts the Display copy of this register. In the Cunit all register protection is implemented with SAI policy groups. This bit is maintained in the Cunit for software observability. Diplay description: This bit will lock all writeable settings in this register including itself client definition."},
#else
{0, 0, 0x0000000000000000, "RW", "LOCK_RESERVED", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo1144[] = {{"TOUUD_LO_0_0_0_PCI", "", 0x000000A8, 3, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields1145[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{7, 31, 0x0000000000000000, "RO", "RESERVED_0", "Reserved"},
#else
{7, 31, 0x0000000000000000, "RO", "RESERVED_0", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 6, 0x0000000000000000, "RW", "TOUUD_HI", "This register contains bits 38  to 20 of an address one byte above the maximum DRAM memory above 4G that is usable by the operating system. Configuration software must set this value to TOM minus all ME stolen memory if reclaim is disabled. If reclaim is enabled this value must be set to reclaim limit 1MB aligned since reclaim limit  1byte is 1MB aligned. Address bits 19:0 are assumed to be 000_0000h for the purposes of address comparison. The Host interface positively decodes an address towards DRAM if the incoming address is less than the value programmed in this register and greater than 4GB.  Note: for 40bit addressing have to add a bit to this field"},
#else
{0, 6, 0x0000000000000000, "RW", "TOUUD_HI", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo1145[] = {{"TOUUD_HI_0_0_0_PCI", "", 0x000000AC, 2, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields1146[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{20, 31, 0x0000000000000000, "RW", "BDSM", "This register contains the base address of graphics data stolen DRAM memory. BIOS determines the base of graphics data stolen memory by subtracting the graphics data stolen memory size PCI Device 0 offset 52 bits 7:4 from TOLUD PCI Device 0 offset BC bits 31:20."},
#else
{20, 31, 0x0000000000000000, "RW", "BDSM", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{1, 19, 0x0000000000000000, "RO", "RESERVED_0", "Reserved"},
#else
{1, 19, 0x0000000000000000, "RO", "RESERVED_0", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 0, 0x0000000000000000, "RW", "LOCK", "This lock bit only impacts the Display copy of this register. In the Cunit all register protection is implemented with SAI policy groups. This bit is maintained in the Cunit for software observability. Diplay description: This bit will lock all writeable settings in this register including itself."},
#else
{0, 0, 0x0000000000000000, "RW", "LOCK", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo1146[] = {{"BDSM_0_0_0_PCI", "", 0x000000B0, 3, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields1147[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{20, 31, 0x0000000000000000, "RW", "BGSM", "This register contains the base address of stolen DRAM memory for the GTT. BIOS determines the base of GTT stolen memory by subtracting the GTT graphics stolen memory size PCI Device 0 offset 52 bits 11:8 from the Graphics Base of  Data Stolen Memory PCI Device 0 offset B0 bits 31:20."},
#else
{20, 31, 0x0000000000000000, "RW", "BGSM", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{1, 19, 0x0000000000000000, "RO", "RESERVED_0", "Reserved"},
#else
{1, 19, 0x0000000000000000, "RO", "RESERVED_0", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 0, 0x0000000000000000, "RW", "LOCK", "This lock bit only impacts the Display copy of this register. In the Cunit all register protection is implemented with SAI policy groups. This bit is maintained in the Cunit for software observability. Diplay description: This bit will lock all writeable settings in this register including itself."},
#else
{0, 0, 0x0000000000000000, "RW", "LOCK", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo1147[] = {{"BGSM_0_0_0_PCI", "", 0x000000B4, 3, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields1148[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{20, 31, 0x0000000000000001, "RW", "TSEGMB", "Base address of TSEG DRAM memory.  BIOS determines the base of TSEG memory which must be at or below Graphics Base of GTT Stolen Memory BGSM.  SMM range starts at this base and ends at BGSM1.  Incoming Request Address [31:20] will be compared with TSEGMB[31:20] and BGSM[31:20] to determine if the request targets the SMM range.  The comparison check is as follows: Address[31:20]  TSEGMB[31:20]  Address[31:20]  BGSM[31:20]  Address[38:32]  0.  If the check passes the request targets the SMM range.  If the protection for the range is enabled then the request SAI is compared against allowed SAIs specified by BSMRRAC and BSMRWAC registers to determine if access is allowed."},
#else
{20, 31, 0x0000000000000001, "RW", "TSEGMB", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{1, 19, 0x0000000000000000, "RO", "RESERVED_0", "Reserved"},
#else
{1, 19, 0x0000000000000000, "RO", "RESERVED_0", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 0, 0x0000000000000000, "RW", "LOCK", "This lock bit only impacts the Display copy of this register. In the Cunit all register protection is implemented with SAI policy groups. This bit is maintained in the Cunit for software observability. Diplay description: This bit will lock all writeable settings in this register including itself."},
#else
{0, 0, 0x0000000000000000, "RW", "LOCK", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo1148[] = {{"TSEGMB_0_0_0_PCI", "", 0x000000B8, 3, 0x00000000FFFFFFFF, 0x0000000000100000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields1149[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{20, 31, 0x0000000000000001, "RW", "TOLUD", "Defines the top of lower usable DRAM which ends at the preceding byte.  Lower MMIO Address range starts at this address and continues up to the 4GB Address 0xFFFF_FFFF.  Bits 31:20 are compared with incoming request Address[31:20] to determine whether the request targets lower usable DRAM range or the lower MMIO range.  If Request Address[31:20]  TOLUD[31:20] and Request Address[38:32]  0 then the Request Address falls in the Lower MMIO Address range."},
#else
{20, 31, 0x0000000000000001, "RW", "TOLUD", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{1, 19, 0x0000000000000000, "RO", "RESERVED_0", "Reserved"},
#else
{1, 19, 0x0000000000000000, "RO", "RESERVED_0", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 0, 0x0000000000000000, "RW", "LOCK", "N/A"},
#else
{0, 0, 0x0000000000000000, "RW", "LOCK", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo1149[] = {{"TOLUD_0_0_0_PCI", "", 0x000000BC, 3, 0x00000000FFFFFFFF, 0x0000000000100000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields1150[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{0, 31, 0x0000000000000000, "RW", "SKPD", "1 DWORD of data storage."},
#else
{0, 31, 0x0000000000000000, "RW", "SKPD", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo1150[] = {{"SKPD_0_0_0_PCI", "", 0x000000DC, 1, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields1151[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{28, 31, 0x0000000000000000, "RO", "RESERVED_0", "Reserved"},
#else
{28, 31, 0x0000000000000000, "RO", "RESERVED_0", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{24, 27, 0x0000000000000001, "RO", "CAPID_VER", "This field has the value 0001b to identify the first revision of the CAPID register definition."},
#else
{24, 27, 0x0000000000000001, "RO", "CAPID_VER", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{16, 23, 0x000000000000000C, "RO", "CAPIDLEN", "This field has the value 0Ch to indicate the structure length 12 bytes.  Are these the right values for us  Check with SCA  NOTE: merged these two registrers 0xE0 and 0xE2/CAPCTRL0"},
#else
{16, 23, 0x000000000000000C, "RO", "CAPIDLEN", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{8, 15, 0x0000000000000000, "RO", "NEXT_CAP", "This field is hardwired to 00h indicating the end of the capabilities linked list."},
#else
{8, 15, 0x0000000000000000, "RO", "NEXT_CAP", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 7, 0x0000000000000009, "RO", "CAP_ID", "This field has the value 1001b to identify the CAP_ID assigned by the PCI SIG for vendor dependent capability pointers."},
#else
{0, 7, 0x0000000000000009, "RO", "CAP_ID", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo1151[] = {{"CAPID0_CAPCTRL0_0_0_0_PCI", "", 0x000000E0, 5, 0x00000000FFFFFFFF, 0x00000000010C0009}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields1152[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{24, 31, 0x0000000000000000, "RW", "SPARE31_24", "Reserved for future capabilities."},
#else
{24, 31, 0x0000000000000000, "RW", "SPARE31_24", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{23, 23, 0x0000000000000000, "RW/Fuse", "VTDD", "0: Enable VTd  1: Disable VTd"},
#else
{23, 23, 0x0000000000000000, "RW/Fuse", "VTDD", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{22, 22, 0x0000000000000000, "RW/Fuse", "FUSE_SPARE22", "Fuse backed spare."},
#else
{22, 22, 0x0000000000000000, "RW/Fuse", "FUSE_SPARE22", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{21, 21, 0x0000000000000000, "RW/Fuse", "FUSE_SPARE21", "Fuse backed spare."},
#else
{21, 21, 0x0000000000000000, "RW/Fuse", "FUSE_SPARE21", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{20, 20, 0x0000000000000000, "RW/Fuse", "FUSE_SPARE20", "Fuse backed spare."},
#else
{20, 20, 0x0000000000000000, "RW/Fuse", "FUSE_SPARE20", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{19, 19, 0x0000000000000000, "RW/Fuse", "FUSE_SPARE19", "Fuse backed spare."},
#else
{19, 19, 0x0000000000000000, "RW/Fuse", "FUSE_SPARE19", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{18, 18, 0x0000000000000000, "RW/Fuse", "FUSE_SPARE18", "Fuse backed spare."},
#else
{18, 18, 0x0000000000000000, "RW/Fuse", "FUSE_SPARE18", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{17, 17, 0x0000000000000000, "RW/Fuse", "FUSE_SPARE17", "Fuse backed spare."},
#else
{17, 17, 0x0000000000000000, "RW/Fuse", "FUSE_SPARE17", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{16, 16, 0x0000000000000000, "RW/Fuse", "FUSE_SPARE16", "Fuse backed spare."},
#else
{16, 16, 0x0000000000000000, "RW/Fuse", "FUSE_SPARE16", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{15, 15, 0x0000000000000000, "RW/Fuse", "CDD", "0: DPTF Camarillo associated memory spaces are accessible.  1: DPTF Camarillo associated memory and IO spaces are disabled.  DEVEN_0_0_0_PCI field for DPTF can not be set."},
#else
{15, 15, 0x0000000000000000, "RW/Fuse", "CDD", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{14, 14, 0x0000000000000000, "RW/Fuse", "FUSE_SPARE14", "Fuse backed spare."},
#else
{14, 14, 0x0000000000000000, "RW/Fuse", "FUSE_SPARE14", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{13, 13, 0x0000000000000000, "RW/Fuse", "FUSE_SPARE13", "Fuse backed spare."},
#else
{13, 13, 0x0000000000000000, "RW/Fuse", "FUSE_SPARE13", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{12, 12, 0x0000000000000000, "RW/Fuse", "FUSE_SPARE12", "Fuse backed spare."},
#else
{12, 12, 0x0000000000000000, "RW/Fuse", "FUSE_SPARE12", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{11, 11, 0x0000000000000000, "RW/Fuse", "IGD", "0: There is a graphics engine within this CPU. Internal Graphics Device Device 2 is enabled and all of its memory and I/O spaces are accessable. Configuration cycles to Device 2 will be completed within the CPU. All nonSMM memory and IO accesses to VGA will be handled based on Memory and IO enables of Device 2 and IO registers within Device 2 and VGA Enable of the PCI to PCI bridge control register in Devices 1 and 6 If PCI Express GFX attach is supported. A selected amount of Graphics Memory space is preallocated from the main memory based on Graphics Mode Select GMS in the GGC Register. Graphics Memory is preallocated above TSEG Memory.  1: There is no graphics engine within this CPU. Internal Graphics Device Device 2 and all of its memory and I/O functions are disabled. Configuration cycle targeted to Device 2 will be passed on to DMI. In addition all clocks to internal graphics logic are turned off. All nonSMM memory and IO accesses to VGA will be handled based on VGA Enable of the PCI to PCI bridge control register in Devices 1 and 6. DEVEN [4:3] Device 0 offset 54h have no meaning. Device 2 Functions 0 and 1 are disabled and hidden."},
#else
{11, 11, 0x0000000000000000, "RW/Fuse", "IGD", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{10, 10, 0x0000000000000000, "RO", "DIDOE", "Controls if there is an override of Dev2 GFX device ID. This functionality is not needed on BXT because Dev2 supports receiving the SetIDValue message for changing device ID. Hardwired to 1b0.   0b Disable ability to override DID  For production  1b Enable ability to override DID  For debug and samples only"},
#else
{10, 10, 0x0000000000000000, "RO", "DIDOE", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{8, 9, 0x0000000000000000, "RO", "CDID", "Controls the value of Dev2 GFX device ID. This functionality is not needed on BXT because Dev2 supports receiving the SetIDValue message for changing device ID. Hardwared to 2b00.  Identifier assigned to the core/primary PCI device.The corresponding two bit capability ID  programming is:  00: Desktop  01: Mobile  10: Server  11: Marketing Spare"},
#else
{8, 9, 0x0000000000000000, "RO", "CDID", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 7, 0x0000000000000000, "RW", "SPARE7_0", "Reserved for future capabilities"},
#else
{0, 7, 0x0000000000000000, "RW", "SPARE7_0", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo1152[] = {{"CAPID0_A_0_0_0_PCI", "", 0x000000E4, 17, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields1153[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{31, 31, 0x0000000000000000, "RW/Fuse", "IMGU_DIS", "0: Imaging Unit associated memory spaces are accessible.  1: Imaging Unit associated memory and IO spaces are disabled.  DEVEN_0_0_0_PCI field for Iunit can not be set."},
#else
{31, 31, 0x0000000000000000, "RW/Fuse", "IMGU_DIS", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{30, 30, 0x0000000000000000, "RW/Fuse", "FUSE_SPARE_30", "Fuse backed spare."},
#else
{30, 30, 0x0000000000000000, "RW/Fuse", "FUSE_SPARE_30", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{29, 29, 0x0000000000000000, "RW/Fuse", "FUSE_SPARE_29", "Fuse backed spares potentially to be used for PKGTYP encoding."},
#else
{29, 29, 0x0000000000000000, "RW/Fuse", "FUSE_SPARE_29", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{28, 28, 0x0000000000000000, "RW/Fuse", "FUSE_SPARE_28", "Fuse backed spares potentially to be used for PKGTYP encoding."},
#else
{28, 28, 0x0000000000000000, "RW/Fuse", "FUSE_SPARE_28", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{27, 27, 0x0000000000000000, "RW/Fuse", "FUSE_SPARE_27", "Fuse backed spares potentially to be used for PKGTYP encoding."},
#else
{27, 27, 0x0000000000000000, "RW/Fuse", "FUSE_SPARE_27", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{26, 26, 0x0000000000000000, "RW/Fuse", "FUSE_SPARE_26", "Fuse backed spares potentially to be used for PKGTYP encoding."},
#else
{26, 26, 0x0000000000000000, "RW/Fuse", "FUSE_SPARE_26", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{25, 25, 0x0000000000000000, "RW/Fuse", "FUSE_SPARE_25", "Fuse backed spares potentially to be used for PKGTYP encoding."},
#else
{25, 25, 0x0000000000000000, "RW/Fuse", "FUSE_SPARE_25", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{24, 24, 0x0000000000000000, "RW/Fuse", "SVMDIS", "0: Enable SVM mode  1: Disable SVM mode"},
#else
{24, 24, 0x0000000000000000, "RW/Fuse", "SVMDIS", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 23, 0x0000000000000000, "RW", "SPARE23_0", "Reserved for future capabilities."},
#else
{0, 23, 0x0000000000000000, "RW", "SPARE23_0", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo1153[] = {{"CAPID0_B_0_0_0_PCI", "", 0x000000E8, 9, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields1154[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{28, 31, 0x0000000000000000, "RW/V", "RESERVED_0", "Reserved  These  bits  can  be  rewritten  from SETIDVALUE message 2nd DW data  byte 3  upper  nibble"},
#else
{28, 31, 0x0000000000000000, "RW/V", "RESERVED_0", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{24, 27, 0x0000000000000000, "RW/V", "DOT_PORTION_OF_PROCESS_ID", "DOT Portion of Process ID  These  bits  can  be  rewritten  from SETIDVALUE message 2nd DW data byte 3 lower  nibble"},
#else
{24, 27, 0x0000000000000000, "RW/V", "DOT_PORTION_OF_PROCESS_ID", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{16, 23, 0x0000000000000000, "RW/V", "PROCESS_PORTION_OF_PROCESS_ID", "Process Portion of Process ID  These  bits  can  be  rewritten  from SETIDVALUE message 2nd DW data byte 0"},
#else
{16, 23, 0x0000000000000000, "RW/V", "PROCESS_PORTION_OF_PROCESS_ID", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{8, 15, 0x0000000000000000, "RW/V", "MID", "Manufacturing ID MID  These  bits  can  be  rewritten  from SETIDVALUE message 2nd DW data byte 1"},
#else
{8, 15, 0x0000000000000000, "RW/V", "MID", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 7, 0x0000000000000000, "RW/V", "MSID", "Manufacturing Stepping ID MSID  These  bits  can  be  rewritten  from SETIDVALUE message 2nd DW data byte 2"},
#else
{0, 7, 0x0000000000000000, "RW/V", "MSID", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo1154[] = {{"MANUFACTURER_ID_0_0_0_PCI", "", 0x000000F4, 5, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields1155[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{0, 31, 0x0000000000000000, "RW", "SPARE_RW", "Spare RW bits for future"},
#else
{0, 31, 0x0000000000000000, "RW", "SPARE_RW", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo1155[] = {{"DEBUP0_0_0_0_PCI", "", 0x000000F8, 1, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields1156[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{0, 31, 0x0000000000000000, "RW", "SPARE_RW", "Spare RW bits for future"},
#else
{0, 31, 0x0000000000000000, "RW", "SPARE_RW", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo1156[] = {{"DEBUP1_0_0_0_PCI", "", 0x000000FC, 1, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields1157[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{1, 31, 0x0000000000000000, "RO", "RESERVED_0", "Reserved"},
#else
{1, 31, 0x0000000000000000, "RO", "RESERVED_0", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 0, 0x0000000000000000, "RW", "C_CLKGATE_DISABLE", "When set disables local clock gating in the Cunit"},
#else
{0, 0, 0x0000000000000000, "RW", "C_CLKGATE_DISABLE", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo1157[] = {{"C_CR_LOCAL_CONTROL_MODE", "", 0x00004104, 2, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields1158[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{6, 31, 0x0000000000000000, "RO", "RESERVED_1", "Reserved"},
#else
{6, 31, 0x0000000000000000, "RO", "RESERVED_1", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{5, 5, 0x0000000000000001, "RW", "HAE", "Hardware Autonomous Enable: If set then the IP may request a PG whenever it is idle.   Note: If this bit is set then bits[2:0] must be 000."},
#else
{5, 5, 0x0000000000000001, "RW", "HAE", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{4, 4, 0x0000000000000000, "RO", "RESERVED_0", "Reserved"},
#else
{4, 4, 0x0000000000000000, "RO", "RESERVED_0", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{3, 3, 0x0000000000000001, "RW", "SE", "Sleep Enable: If clear then IP will never assert Sleep to the retention flops. If set then IP may assert Sleep during PGing. Note that some platforms may default this bit to 0 others to 1."},
#else
{3, 3, 0x0000000000000001, "RW", "SE", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{2, 2, 0x0000000000000000, "RO", "D3HE", "D3Hot Enable: If set then IP will PG when idle and the PMCSR[1:0] register is the IP11.  Hardwired to 1b0 since the Cunit does not support D0i3."},
#else
{2, 2, 0x0000000000000000, "RO", "D3HE", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{1, 1, 0x0000000000000000, "RO", "I3E", "I3 Enable: if set then IP will PG when idle and the D0i3 register D0i3C[2]  1 is set.   Note: If bits[2:1] 11 then the IP would PG whenever either PMCSR  11 or the D0i3C.i3 bit is set.  Hardwired to 1b0 since the Cunit does not support D0i3."},
#else
{1, 1, 0x0000000000000000, "RO", "I3E", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 0, 0x0000000000000000, "RO", "PMCRE", "PMC Request Enable: If set then IP will PG when idle and the PMC requests power gating by asserting pmc_ip_sw_pg_req_b signal.  Hardwired to 1b0 since the Cunit does not support  SW controlled PGing."},
#else
{0, 0, 0x0000000000000000, "RO", "PMCRE", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo1158[] = {{"C_CR_PGCB_PWRGATE_PCE", "", 0x00004108, 7, 0x00000000FFFFFFFF, 0x0000000000000028}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields1159[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{5, 31, 0x0000000000000000, "RO", "RESERVED_0", "Reserved"},
#else
{5, 31, 0x0000000000000000, "RO", "RESERVED_0", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{4, 4, 0x0000000000000000, "RW", "pgcb_clkgating_disable", "This will feed into the cfg_pgcb_clkgate_disabled input of PGCB clock gate component and when asserted, prevents the PGCB clock trunk from ever gating."},
#else
{4, 4, 0x0000000000000000, "RW", "pgcb_clkgating_disable", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 3, 0x0000000000000002, "RW", "pg_timer", "Power Gate Hysterisis Timer This is the min time from which all internal Idle conditions have been observed to when PGCB actually starts the power gating sequence."},
#else
{0, 3, 0x0000000000000002, "RW", "pg_timer", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo1159[] = {{"C_CR_PGCB_PG_IDLE_TIMER", "", 0x0000410C, 3, 0x00000000FFFFFFFF, 0x0000000000000002}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields1160[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{18, 31, 0x0000000000000000, "RO", "RESERVED_1", "Reserved"},
#else
{18, 31, 0x0000000000000000, "RO", "RESERVED_1", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{17, 17, 0x0000000000000000, "RW", "priclk_force_trunk", "Disable IOSFPri trunk gating"},
#else
{17, 17, 0x0000000000000000, "RW", "priclk_force_trunk", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{16, 16, 0x0000000000000000, "RW", "sbclk_force_trunk", "Disable IOSFSB trunk gating"},
#else
{16, 16, 0x0000000000000000, "RW", "sbclk_force_trunk", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{2, 15, 0x0000000000000000, "RO", "RESERVED_0", "Reserved"},
#else
{2, 15, 0x0000000000000000, "RO", "RESERVED_0", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{1, 1, 0x0000000000000000, "RW", "priclkgating_disable", "Disable IOSFPri clk gating"},
#else
{1, 1, 0x0000000000000000, "RW", "priclkgating_disable", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 0, 0x0000000000000000, "RW", "sbclkgating_disable", "Disable IOSFSB clk gating"},
#else
{0, 0, 0x0000000000000000, "RW", "sbclkgating_disable", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo1160[] = {{"C_CR_PGCB_CLKGATE_DIS", "", 0x00004110, 6, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields1161[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{8, 31, 0x0000000000000000, "RO", "RESERVED_0", "Reserved"},
#else
{8, 31, 0x0000000000000000, "RO", "RESERVED_0", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{4, 7, 0x0000000000000004, "RW", "priclk_idle_timer", "IOSFPri idle timer"},
#else
{4, 7, 0x0000000000000004, "RW", "priclk_idle_timer", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 3, 0x0000000000000004, "RW", "sbclk_idle_timer", "IOSFSB idle timer"},
#else
{0, 3, 0x0000000000000004, "RW", "sbclk_idle_timer", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo1161[] = {{"C_CR_PGCB_CG_IDLE_TIMER", "", 0x00004114, 3, 0x00000000FFFFFFFF, 0x0000000000000044}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields1162[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{17, 31, 0x0000000000000000, "RO", "RESERVED_1", "Reserved"},
#else
{17, 31, 0x0000000000000000, "RO", "RESERVED_1", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{16, 16, 0x0000000000000000, "RW", "SAI_VIO_MSG_ENABLE", "Toggles sending of SAI violation messages on sideband"},
#else
{16, 16, 0x0000000000000000, "RW", "SAI_VIO_MSG_ENABLE", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{8, 15, 0x0000000000000000, "RW/V", "VIO_SAI", "SAI bits that triggered the violation"},
#else
{8, 15, 0x0000000000000000, "RW/V", "VIO_SAI", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{2, 7, 0x0000000000000000, "RO", "RESERVED_0", "Reserved"},
#else
{2, 7, 0x0000000000000000, "RO", "RESERVED_0", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{1, 1, 0x0000000000000000, "RW/V", "VIO_MORE_THAN_1", "More than one SAI violation detected"},
#else
{1, 1, 0x0000000000000000, "RW/V", "VIO_MORE_THAN_1", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 0, 0x0000000000000000, "RW/V", "VIO_MORE_THAN_0", "First SAI violation detected"},
#else
{0, 0, 0x0000000000000000, "RW/V", "VIO_MORE_THAN_0", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo1162[] = {{"C_CR_SECURITY_STAT0", "", 0x00004118, 6, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields1163[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{16, 31, 0x0000000000000000, "RW/V", "VIO_ADDR", "Address that triggered the violation"},
#else
{16, 31, 0x0000000000000000, "RW/V", "VIO_ADDR", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{8, 15, 0x0000000000000000, "RW/V", "VIO_SRC_PORT", "Port that sent the violation"},
#else
{8, 15, 0x0000000000000000, "RW/V", "VIO_SRC_PORT", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 7, 0x0000000000000000, "RW/V", "VIO_OPC", "Opcode that triggered the violation"},
#else
{0, 7, 0x0000000000000000, "RW/V", "VIO_OPC", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo1163[] = {{"C_CR_SECURITY_STAT1", "", 0x0000411C, 3, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields1164[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{0, 63, 0x0000040061210202, "RW", "sai", "N/A"},
#else
{0, 63, 0x0000040061210202, "RW", "sai", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo1164[] = {{"C_CR_BIOSWR_CP", "", 0x00004120, 1, 0xFFFFFFFFFFFFFFFF, 0x0000040061210202}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields1165[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{0, 63, 0x00000C00632D0217, "RW", "sai", "N/A"},
#else
{0, 63, 0x00000C00632D0217, "RW", "sai", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo1165[] = {{"C_CR_BIOSWR_RAC", "", 0x00004128, 1, 0xFFFFFFFFFFFFFFFF, 0x00000C00632D0217}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields1166[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{0, 63, 0x00000C00212C0212, "RW", "sai", "N/A"},
#else
{0, 63, 0x00000C00212C0212, "RW", "sai", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo1166[] = {{"C_CR_BIOSWR_WAC", "", 0x00004130, 1, 0xFFFFFFFFFFFFFFFF, 0x00000C00212C0212}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields1167[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{0, 63, 0x0000040021200202, "RW", "sai", "N/A"},
#else
{0, 63, 0x0000040021200202, "RW", "sai", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo1167[] = {{"C_CR_P_U_CODERDWR_CP", "", 0x00004138, 1, 0xFFFFFFFFFFFFFFFF, 0x0000040021200202}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields1168[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{0, 63, 0x00000400212C0202, "RW", "sai", "N/A"},
#else
{0, 63, 0x00000400212C0202, "RW", "sai", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo1168[] = {{"C_CR_P_U_CODERDWR_RAC", "", 0x00004140, 1, 0xFFFFFFFFFFFFFFFF, 0x00000400212C0202}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields1169[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{0, 63, 0x00000400212C0202, "RW", "sai", "N/A"},
#else
{0, 63, 0x00000400212C0202, "RW", "sai", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo1169[] = {{"C_CR_P_U_CODERDWR_WAC", "", 0x00004148, 1, 0xFFFFFFFFFFFFFFFF, 0x00000400212C0202}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields1170[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{0, 63, 0x0000040021200202, "RW", "sai", "N/A"},
#else
{0, 63, 0x0000040021200202, "RW", "sai", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo1170[] = {{"C_CR_P_U_CODEWR_ALLRD_CP", "", 0x00004150, 1, 0xFFFFFFFFFFFFFFFF, 0x0000040021200202}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields1171[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{0, 63, 0x00000C00632D0217, "RW", "sai", "N/A"},
#else
{0, 63, 0x00000C00632D0217, "RW", "sai", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo1171[] = {{"C_CR_P_U_CODEWR_ALLRD_RAC", "", 0x00004158, 1, 0xFFFFFFFFFFFFFFFF, 0x00000C00632D0217}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields1172[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{0, 63, 0x00000400212C0202, "RW", "sai", "N/A"},
#else
{0, 63, 0x00000400212C0202, "RW", "sai", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo1172[] = {{"C_CR_P_U_CODEWR_ALLRD_WAC", "", 0x00004160, 1, 0xFFFFFFFFFFFFFFFF, 0x00000400212C0202}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields1173[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{0, 63, 0x0000040021200202, "RW", "sai", "N/A"},
#else
{0, 63, 0x0000040021200202, "RW", "sai", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo1173[] = {{"C_CR_IA_UNTRUSTED_CP", "", 0x00004168, 1, 0xFFFFFFFFFFFFFFFF, 0x0000040021200202}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields1174[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{0, 63, 0x00000C00632D0217, "RW", "sai", "N/A"},
#else
{0, 63, 0x00000C00632D0217, "RW", "sai", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo1174[] = {{"C_CR_IA_UNTRUSTED_RAC", "", 0x00004170, 1, 0xFFFFFFFFFFFFFFFF, 0x00000C00632D0217}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields1175[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{0, 63, 0x00000C00632D0217, "RW", "sai", "N/A"},
#else
{0, 63, 0x00000C00632D0217, "RW", "sai", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo1175[] = {{"C_CR_IA_UNTRUSTED_WAC", "", 0x00004178, 1, 0xFFFFFFFFFFFFFFFF, 0x00000C00632D0217}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields1176[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{0, 63, 0x0000000000000000, "RO", "sai", "N/A"},
#else
{0, 63, 0x0000000000000000, "RO", "sai", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo1176[] = {{"C_CR_SECURITY_CP_0_0_0_MCHBAR", "", 0x00006000, 1, 0xFFFFFFFFFFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields1177[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{0, 63, 0x00000C00612D0202, "RO", "sai", "N/A"},
#else
{0, 63, 0x00000C00612D0202, "RO", "sai", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo1177[] = {{"C_CR_SECURITY_RAC_0_0_0_MCHBAR", "", 0x00006008, 1, 0xFFFFFFFFFFFFFFFF, 0x00000C00612D0202}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields1178[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{0, 63, 0x00000C00612D0202, "RO", "sai", "N/A"},
#else
{0, 63, 0x00000C00612D0202, "RO", "sai", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo1178[] = {{"C_CR_SECURITY_WAC_0_0_0_MCHBAR", "", 0x00006010, 1, 0xFFFFFFFFFFFFFFFF, 0x00000C00612D0202}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields1179[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{40, 63, 0x0000000000000000, "RO", "RESERVED_1", "Reserved"},
#else
{40, 63, 0x0000000000000000, "RO", "RESERVED_1", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{39, 39, 0x0000000000000000, "RO", "DEFVTDBAR_40_BIT", "Reserved for future growth to 40bit addressing in uServer.  Will always be 0 in WLV/BXT"},
#else
{39, 39, 0x0000000000000000, "RO", "DEFVTDBAR_40_BIT", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{12, 38, 0x0000000000000000, "RW", "DEFVTDBAR", "If DEFVTDBAR is enabled this field corresponds to bits 38:12 of the base address default IOMMU VTd configuration space.  BIOS will program this register resulting in a base address for a 4KB block of contiguous memory address space.  This register ensures that a naturally aligned 4KB space is allocated within the first 512GB of addressable memory space.  System Software uses this base address to program the default VTd IOMMU register set.  If DEFVTDBAR is enabled and incoming Request Address[38:12] matches DEFVTDBAR[38:12] the request targets the Default VTd BAR."},
#else
{12, 38, 0x0000000000000000, "RW", "DEFVTDBAR", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{2, 11, 0x0000000000000000, "RO", "RESERVED_0", "Reserved"},
#else
{2, 11, 0x0000000000000000, "RO", "RESERVED_0", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{1, 1, 0x0000000000000000, "RW", "LOCK", "This lock bit only impacts the Display copy of this register. In the Cunit all register protection is implemented with SAI policy groups. This bit is maintained in the Cunit for software observability. Diplay description: Locks the contents of the register including itself."},
#else
{1, 1, 0x0000000000000000, "RW", "LOCK", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 0, 0x0000000000000000, "RW/L", "DEFVTDBAREN", "0: DEFVTDBAR is disabled and does not claim any memory  1: DEFVTDBAR memory mapped accesses are claimed and decoded appropriately  This bit will remain 0 if VTd capability is disabled."},
#else
{0, 0, 0x0000000000000000, "RW/L", "DEFVTDBAREN", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo1179[] = {{"DEFVTDBAR_0_0_0_MCHBAR_C", "", 0x00006C80, 6, 0xFFFFFFFFFFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields1180[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{39, 63, 0x0000000000000000, "RO", "RESERVED_1", "Reserved"},
#else
{39, 63, 0x0000000000000000, "RO", "RESERVED_1", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{12, 38, 0x0000000000000000, "RW", "GFXVTBAR", "This field corresponds to bits 39 to 12 of the base address GFXVT configuration space. BIOS will program this register resulting in a base address for a 4KB block of contiguous memory address space. This register ensures that a naturally aligned 4KB space is allocated within the first 512GB of addressable memory space. System Software uses this base address to program the GFXVT register set. All the Bits in this register are locked in LT mode."},
#else
{12, 38, 0x0000000000000000, "RW", "GFXVTBAR", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{2, 11, 0x0000000000000000, "RO", "RESERVED_0", "Reserved"},
#else
{2, 11, 0x0000000000000000, "RO", "RESERVED_0", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{1, 1, 0x0000000000000000, "RW", "LOCK", "This lock bit only impacts the Display copy of this register. In the Cunit all register protection is implemented with SAI policy groups. This bit is maintained in the Cunit for software observability. Diplay description: Locks the contents of the register including itself."},
#else
{1, 1, 0x0000000000000000, "RW", "LOCK", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 0, 0x0000000000000000, "RW/L", "GFXVTBAREN", "0: GFXVTBAR is disabled and does not claim any memory  1: GFXVTBAR memory mapped accesses are claimed and decoded appropriately  This bit will remain 0 if VTd capability is disabled."},
#else
{0, 0, 0x0000000000000000, "RW/L", "GFXVTBAREN", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo1180[] = {{"GFXVTDBAR_0_0_0_MCHBAR_C", "", 0x00006C88, 5, 0xFFFFFFFFFFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields1181[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{24, 31, 0x0000000000000000, "RW", "BaseAddress", "Base address for P2SB"},
#else
{24, 31, 0x0000000000000000, "RW", "BaseAddress", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo1181[] = {{"BASE_ADDRESS_LO", "", 0x00000010, 1, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields1182[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{0, 31, 0x0000000000000000, "RW", "BaseAddress", "Base address for P2SB"},
#else
{0, 31, 0x0000000000000000, "RW", "BaseAddress", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo1182[] = {{"BASE_ADDRESS_HI", "", 0x00000014, 1, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields1183[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{16, 31, 0x000000000000C5C5, "RO", "DID", "The upper 8-bits of this field can be overridden by the SetID IOSF-SB Message."},
#else
{16, 31, 0x000000000000C5C5, "RO", "DID", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 15, 0x0000000000008086, "RO", "VID", "Indicates Intel"},
#else
{0, 15, 0x0000000000008086, "RO", "VID", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo1183[] = {{"PCIID", "", 0x00000000, 2, 0x00000000FFFFFFFF, 0x00000000C5C58086}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields1184[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{11, 15, 0x0000000000000000, "RO", "RSVD", "Reserved"},
#else
{11, 15, 0x0000000000000000, "RO", "RSVD", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{10, 10, 0x0000000000000000, "RO", "INTD", "P2SB does not issue any interrupts on its own behalf"},
#else
{10, 10, 0x0000000000000000, "RO", "INTD", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{9, 9, 0x0000000000000000, "RO", "FB2BE", "Not applicable"},
#else
{9, 9, 0x0000000000000000, "RO", "FB2BE", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{8, 8, 0x0000000000000000, "RO", "SE", "P2SB does not issue SERR# on its own behalf."},
#else
{8, 8, 0x0000000000000000, "RO", "SE", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{7, 7, 0x0000000000000000, "RO", "RSVD_1", "Reserved"},
#else
{7, 7, 0x0000000000000000, "RO", "RSVD_1", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{6, 6, 0x0000000000000000, "RO", "PER", "No support for parity error detection."},
#else
{6, 6, 0x0000000000000000, "RO", "PER", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{5, 5, 0x0000000000000000, "RO", "VGA", "Not applicable."},
#else
{5, 5, 0x0000000000000000, "RO", "VGA", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{4, 4, 0x0000000000000000, "RO", "MWIE", "Not applicable."},
#else
{4, 4, 0x0000000000000000, "RO", "MWIE", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{3, 3, 0x0000000000000000, "RO", "SCE", "Not applicable."},
#else
{3, 3, 0x0000000000000000, "RO", "SCE", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{2, 2, 0x0000000000000001, "RO", "BME", "Bus mastering cannot be disabled as this device acts as a proxy for non-PCI devices."},
#else
{2, 2, 0x0000000000000001, "RO", "BME", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{1, 1, 0x0000000000000000, "RW", "MSE", "Will control the P2SB acceptance of PCI MMIO BARs only. Other legacy regions are unaffected by this bit."},
#else
{1, 1, 0x0000000000000000, "RW", "MSE", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 0, 0x0000000000000000, "RW", "IOSE", "Legacy regions are unaffected by this bit."},
#else
{0, 0, 0x0000000000000000, "RW", "IOSE", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo1184[] = {{"PCICMD", "", 0x00000004, 12, 0x000000000000FFFF, 0x0000000000000004}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields1185[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{0, 15, 0x0000000000000000, "RO", "RSVD", "Reserved"},
#else
{0, 15, 0x0000000000000000, "RO", "RSVD", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo1185[] = {{"PCISTS", "", 0x00000006, 1, 0x000000000000FFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields1186[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{0, 7, 0x0000000000000000, "RO", "RID", "Indicates the part revision. This will reset to 0 but will overridden by the SetID IOSFSB message during the power-up sequence"},
#else
{0, 7, 0x0000000000000000, "RO", "RID", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo1186[] = {{"PCIRID", "", 0x00000008, 1, 0x00000000000000FF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields1187[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{16, 23, 0x0000000000000005, "RO", "BCC", "Indicates a memory controller device class."},
#else
{16, 23, 0x0000000000000005, "RO", "BCC", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{8, 15, 0x0000000000000080, "RO", "SCC", "Indicates an unspecified other memory controller."},
#else
{8, 15, 0x0000000000000080, "RO", "SCC", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 7, 0x0000000000000000, "RO", "PI", "No programming interface."},
#else
{0, 7, 0x0000000000000000, "RO", "PI", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo1187[] = {{"PCICC", "", 0x00000009, 3, 0x0000000000FFFFFF, 0x0000000000058000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields1188[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{0, 7, 0x0000000000000000, "RO", "RSVD", "Reserved"},
#else
{0, 7, 0x0000000000000000, "RO", "RSVD", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo1188[] = {{"PCIMLT", "", 0x0000000D, 1, 0x00000000000000FF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields1189[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{7, 7, 0x0000000000000000, "RO", "MFD", "Indicates that this is part of a multi-function device."},
#else
{7, 7, 0x0000000000000000, "RO", "MFD", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 6, 0x0000000000000000, "RO", "HTYPE", "Indicates a generic device header."},
#else
{0, 6, 0x0000000000000000, "RO", "HTYPE", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo1189[] = {{"PCIHTYPE", "", 0x0000000E, 2, 0x00000000000000FF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields1190[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{24, 31, 0x0000000000000000, "RW", "RBA", "Lower DWORD of the base address for the sideband register access BAR."},
#else
{24, 31, 0x0000000000000000, "RW", "RBA", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{4, 23, 0x0000000000000000, "RO", "HW202RB16MB", "Hardwired to 0 to request a BAR of 16MB"},
#else
{4, 23, 0x0000000000000000, "RO", "HW202RB16MB", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{3, 3, 0x0000000000000000, "RO", "PREF", "Indicates this is not prefetchable."},
#else
{3, 3, 0x0000000000000000, "RO", "PREF", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{1, 2, 0x0000000000000002, "RO", "ATYPE", "Indicates that this can be placed anywhere in 64b space."},
#else
{1, 2, 0x0000000000000002, "RO", "ATYPE", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 0, 0x0000000000000000, "RO", "STYPE", "Indicates memory space"},
#else
{0, 0, 0x0000000000000000, "RO", "STYPE", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo1190[] = {{"SBREG_BAR", "", 0x00000010, 5, 0x00000000FFFFFFFF, 0x0000000000000004}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields1191[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{0, 31, 0x0000000000000000, "RW", "RBAH", "Upper DWORD of the base address for the sideband register access BAR."},
#else
{0, 31, 0x0000000000000000, "RW", "RBAH", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo1191[] = {{"SBREG_BARH", "", 0x00000014, 1, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields1192[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{16, 31, 0x0000000000000000, "RW/O", "SSID", "Written by BIOS. Not used by hardware."},
#else
{16, 31, 0x0000000000000000, "RW/O", "SSID", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 15, 0x0000000000000000, "RW/O", "SSVID", "Written by BIOS. Not used by hardware."},
#else
{0, 15, 0x0000000000000000, "RW/O", "SSVID", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo1192[] = {{"PCIHSS", "", 0x0000002C, 2, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields1193[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{8, 15, 0x0000000000000000, "RW", "BUS", "N/A"},
#else
{8, 15, 0x0000000000000000, "RW", "BUS", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{3, 7, 0x000000000000001F, "RW", "DEV", "N/A"},
#else
{3, 7, 0x000000000000001F, "RW", "DEV", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 2, 0x0000000000000000, "RW", "FUNC", "N/A"},
#else
{0, 2, 0x0000000000000000, "RW", "FUNC", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo1193[] = {{"VBDF", "", 0x00000050, 3, 0x000000000000FFFF, 0x00000000000000F8}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields1194[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{8, 15, 0x0000000000000000, "RW", "BUS", "N/A"},
#else
{8, 15, 0x0000000000000000, "RW", "BUS", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{3, 7, 0x000000000000001F, "RW", "DEV", "N/A"},
#else
{3, 7, 0x000000000000001F, "RW", "DEV", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 2, 0x0000000000000000, "RW", "FUNC", "N/A"},
#else
{0, 2, 0x0000000000000000, "RW", "FUNC", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo1194[] = {{"EBDF", "", 0x00000052, 3, 0x000000000000FFFF, 0x00000000000000F8}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields1195[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{16, 31, 0x0000000000000000, "RW", "RSVD", "N/A"},
#else
{16, 31, 0x0000000000000000, "RW", "RSVD", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{8, 15, 0x00000000000000D2, "RW", "RPRID", "Specifies the  IOSF-SB destination ID for sending Reserved Page Register cycles (e.g. Port 80h).  By default this will load to the ID of the LPC or eSPI device depending on which has been strapped active in the system."},
#else
{8, 15, 0x00000000000000D2, "RW", "RPRID", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{1, 7, 0x0000000000000000, "RW", "RSVD_1", "N/A"},
#else
{1, 7, 0x0000000000000000, "RW", "RSVD_1", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 0, 0x0000000000000000, "RW", "RSE", "When set, all IO writes to the RTC will be also sent to the PMC.  This allows cases where the battery backed storage is in an external PMIC."},
#else
{0, 0, 0x0000000000000000, "RW", "RSE", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo1195[] = {{"RCFG", "", 0x00000054, 4, 0x00000000FFFFFFFF, 0x000000000000D200}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields1196[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{7, 7, 0x0000000000000000, "RW", "AE", "When set, the P2SB will decode the High Performance Timer memory address range selected by bits 1:0 below."},
#else
{7, 7, 0x0000000000000000, "RW", "AE", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{2, 6, 0x0000000000000000, "RO", "RSVD", "N/A"},
#else
{2, 6, 0x0000000000000000, "RO", "RSVD", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 1, 0x0000000000000000, "RW", "AS", "This 2-bit field selects 1 of 4 possible memory address ranges for the High Performance Timer functionality. The encodings are:\r\n"
"00 : FED0_0000h - FED0_03FFFh\r\n"
"01 : FED0_1000h - FED0_13FFFh\r\n"
"10 : FED0_2000h - FED0_23FFFh\r\n"
"11 : FED0_3000h - FED0_33FFFh"},
#else
{0, 1, 0x0000000000000000, "RW", "AS", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo1196[] = {{"HPTC", "", 0x00000060, 3, 0x00000000000000FF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields1197[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{9, 15, 0x0000000000000000, "RO", "RSVD", "N/A"},
#else
{9, 15, 0x0000000000000000, "RO", "RSVD", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{8, 8, 0x0000000000000000, "RW", "AE", "When set, the P2SB will decode the IOxAPIC memory address range selected by bits 7:0 below."},
#else
{8, 8, 0x0000000000000000, "RW", "AE", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 7, 0x0000000000000000, "RW", "ASEL", "These bits define address bits 19:12 for the IOxAPIC range. The default value of 00h enables compatibility with prior products as an initial value. This value must not be changed unless the IOxAPIC Enable bit is cleared."},
#else
{0, 7, 0x0000000000000000, "RW", "ASEL", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo1197[] = {{"IOAC", "", 0x00000064, 3, 0x000000000000FFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields1198[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{8, 15, 0x0000000000000000, "RW", "BUS", "N/A"},
#else
{8, 15, 0x0000000000000000, "RW", "BUS", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{3, 7, 0x000000000000001F, "RW", "DEV", "N/A"},
#else
{3, 7, 0x000000000000001F, "RW", "DEV", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 2, 0x0000000000000000, "RW", "FUNC", "N/A"},
#else
{0, 2, 0x0000000000000000, "RW", "FUNC", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo1198[] = {{"IBDF", "", 0x0000006C, 3, 0x000000000000FFFF, 0x00000000000000F8}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields1199[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{8, 15, 0x0000000000000000, "RW", "BUS", "N/A"},
#else
{8, 15, 0x0000000000000000, "RW", "BUS", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{3, 7, 0x000000000000001F, "RW", "DEV", "N/A"},
#else
{3, 7, 0x000000000000001F, "RW", "DEV", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 2, 0x0000000000000000, "RW", "FUNC", "N/A"},
#else
{0, 2, 0x0000000000000000, "RW", "FUNC", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo1199[] = {{"HBDF", "", 0x00000070, 3, 0x000000000000FFFF, 0x00000000000000F8}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields1200[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{0, 31, 0x0000000000000000, "RW", "SBREGPOSTED0", "One hot masks for setting SBREG to posted posted for IOSF-SB endpoint IDs 31-0."},
#else
{0, 31, 0x0000000000000000, "RW", "SBREGPOSTED0", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo1200[] = {{"SBREGPOSTED0", "", 0x00000080, 1, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields1201[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{0, 31, 0x0000000000000000, "RW", "SBREGPOSTED1", "One hot masks for setting SBREG to posted posted for IOSF-SB endpoint IDs 63-32."},
#else
{0, 31, 0x0000000000000000, "RW", "SBREGPOSTED1", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo1201[] = {{"SBREGPOSTED1", "", 0x00000084, 1, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields1202[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{0, 31, 0x0000000000000000, "RW", "SBREGPOSTED2", "One hot masks for setting SBREG to posted posted for IOSF-SB endpoint IDs 95-64."},
#else
{0, 31, 0x0000000000000000, "RW", "SBREGPOSTED2", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo1202[] = {{"SBREGPOSTED2", "", 0x00000088, 1, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields1203[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{0, 31, 0x0000000000000000, "RW", "SBREGPOSTED3", "One hot masks for setting SBREG to posted posted for IOSF-SB endpoint IDs 127-96."},
#else
{0, 31, 0x0000000000000000, "RW", "SBREGPOSTED3", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo1203[] = {{"SBREGPOSTED3", "", 0x0000008C, 1, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields1204[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{0, 31, 0x0000000000000000, "RW", "SBREGPOSTED4", "One hot masks for setting SBREG to posted posted for IOSF-SB endpoint IDs 159-128."},
#else
{0, 31, 0x0000000000000000, "RW", "SBREGPOSTED4", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo1204[] = {{"SBREGPOSTED4", "", 0x00000090, 1, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields1205[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{0, 31, 0x0000000000000000, "RW", "SBREGPOSTED5", "One hot masks for setting SBREG to posted posted for IOSF-SB endpoint IDs 191-160."},
#else
{0, 31, 0x0000000000000000, "RW", "SBREGPOSTED5", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo1205[] = {{"SBREGPOSTED5", "", 0x00000094, 1, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields1206[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{0, 31, 0x0000000000000000, "RW", "SBREGPOSTED6", "One hot masks for setting SBREG to posted posted for IOSF-SB endpoint IDs 223-192."},
#else
{0, 31, 0x0000000000000000, "RW", "SBREGPOSTED6", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo1206[] = {{"SBREGPOSTED6", "", 0x00000098, 1, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields1207[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{0, 31, 0x0000000000000000, "RW", "SBREGPOSTED7", "One hot masks for setting SBREG to posted posted for IOSF-SB endpoint IDs 255-224."},
#else
{0, 31, 0x0000000000000000, "RW", "SBREGPOSTED7", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo1207[] = {{"SBREGPOSTED7", "", 0x0000009C, 1, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields1208[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{19, 31, 0x0000000000000000, "RO", "RSVD", "N/A"},
#else
{19, 31, 0x0000000000000000, "RO", "RSVD", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{16, 18, 0x0000000000000006, "RW", "DTBLK", "This register contains the Target BLK field that will be used when sending RAVDM messages to the CPU Complex North Display."},
#else
{16, 18, 0x0000000000000006, "RW", "DTBLK", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{8, 15, 0x0000000000000000, "RW", "BUS", "The bus number of the Display in the CPU Complex."},
#else
{8, 15, 0x0000000000000000, "RW", "BUS", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{3, 7, 0x0000000000000002, "RW", "DEV", "The bus number of the Display in the CPU Complex."},
#else
{3, 7, 0x0000000000000002, "RW", "DEV", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 2, 0x0000000000000000, "RW", "FUNC", "The function number of the Display in the CPU Complex"},
#else
{0, 2, 0x0000000000000000, "RW", "FUNC", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo1208[] = {{"DISPBDF", "", 0x000000A0, 5, 0x00000000FFFFFFFF, 0x0000000000060010}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields1209[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{8, 15, 0x0000000000000000, "RW", "MODBASE", "This specifies the upper 8b for the 16b address that will be used for sending RAVDM access that target the Modulator Control range of the ICC (FFF00h - FFFFFh)."},
#else
{8, 15, 0x0000000000000000, "RW", "MODBASE", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 7, 0x0000000000000000, "RW", "BUFBASE", "This specifies the upper 8b for the 16b address that will be used for sending RAVDM access that target the Buffer range of the ICC (FFE00h - FFEFFh)."},
#else
{0, 7, 0x0000000000000000, "RW", "BUFBASE", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo1209[] = {{"ICCOS", "", 0x000000A4, 2, 0x000000000000FFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields1210[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{0, 31, 0x0000000000000000, "RW/L", "EPMASK0", "One hot masks for disabling IOSF-SB endpoint IDs 31-0."},
#else
{0, 31, 0x0000000000000000, "RW/L", "EPMASK0", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo1210[] = {{"EPMASK0", "", 0x000000B0, 1, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields1211[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{0, 31, 0x0000000000000000, "RW/L", "EPMASK1", "One hot masks for disabling IOSF-SB endpoint IDs 63-32."},
#else
{0, 31, 0x0000000000000000, "RW/L", "EPMASK1", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo1211[] = {{"EPMASK1", "", 0x000000B4, 1, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields1212[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{0, 31, 0x0000000000000000, "RW/L", "EPMASK2", "One hot masks for disabling IOSF-SB endpoint IDs 95-64"},
#else
{0, 31, 0x0000000000000000, "RW/L", "EPMASK2", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo1212[] = {{"EPMASK2", "", 0x000000B8, 1, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields1213[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{0, 31, 0x0000000000000000, "RW/L", "EPMASK3", "One hot masks for disabling IOSF-SB endpoint IDs 127-96"},
#else
{0, 31, 0x0000000000000000, "RW/L", "EPMASK3", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo1213[] = {{"EPMASK3", "", 0x000000BC, 1, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields1214[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{0, 31, 0x0000000000000000, "RW/L", "EPMASK4", "One hot masks for disabling IOSF-SB endpoint IDs 128-159"},
#else
{0, 31, 0x0000000000000000, "RW/L", "EPMASK4", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo1214[] = {{"EPMASK4", "", 0x000000C0, 1, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields1215[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{0, 31, 0x0000000000000000, "RW/L", "EPMASK5", "One hot masks for disabling IOSF-SB endpoint IDs 191-160"},
#else
{0, 31, 0x0000000000000000, "RW/L", "EPMASK5", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo1215[] = {{"EPMASK5", "", 0x000000C4, 1, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields1216[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{0, 31, 0x0000000000000000, "RW/L", "EPMASK6", "One hot masks for disabling IOSF-SB endpoint IDs 223-192"},
#else
{0, 31, 0x0000000000000000, "RW/L", "EPMASK6", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo1216[] = {{"EPMASK6", "", 0x000000C8, 1, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields1217[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{0, 31, 0x0000000000000000, "RW/L", "EPMASK7", "One hot masks for disabling IOSF-SB endpoint IDs 255-224"},
#else
{0, 31, 0x0000000000000000, "RW/L", "EPMASK7", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo1217[] = {{"EPMASK7", "", 0x000000CC, 1, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields1218[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{24, 31, 0x0000000000000000, "RW", "DESTID", "The content of this register field is sent in the IOSF Sideband Message Register Access dest field.\r\n"
"See the IOSF Sideband C-spec chapter for Destination ID assignments."},
#else
{24, 31, 0x0000000000000000, "RW", "DESTID", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{20, 23, 0x0000000000000000, "RO", "RSVD", "N/A"},
#else
{20, 23, 0x0000000000000000, "RO", "RSVD", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{16, 19, 0x0000000000000000, "RW", "RS", "Destination IOSF-SB Root Space.\r\n"
"*Note: This register may only be written during manufacturing test.  P2SB will only accept writes to this register from transactions with a SAI equal to the SBI_RS_ACCESS_SAI parameter.  This should be assigned to the SAI used by the functional test module (typically TAM) that will perform this register write on IOSF-P."},
#else
{16, 19, 0x0000000000000000, "RW", "RS", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 15, 0x0000000000000000, "RW", "OFFSET", "Register address offset.  The content of this register field is sent in the IOSF Sideband Message Register Access address(15:0) field."},
#else
{0, 15, 0x0000000000000000, "RW", "OFFSET", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo1218[] = {{"SBIADDR", "", 0x000000D0, 4, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields1219[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{0, 31, 0x0000000000000000, "RW/V", "DATA", "The content of this register field is sent on the IOSF sideband Message Register Access data(31:0) field."},
#else
{0, 31, 0x0000000000000000, "RW/V", "DATA", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo1219[] = {{"SBIDATA", "", 0x000000D4, 1, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields1220[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{8, 15, 0x0000000000000000, "RW", "OPCODE", "This is the Opcode sent in the IOSF sideband message."},
#else
{8, 15, 0x0000000000000000, "RW", "OPCODE", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{7, 7, 0x0000000000000000, "RW", "POSTED", "When set to 1, the message will be send as a posted message instead of non-posted.  This should only be used if the receiver is known to support posted operations for the specified operation."},
#else
{7, 7, 0x0000000000000000, "RW", "POSTED", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{3, 6, 0x0000000000000000, "RO", "RSVD", "N/A"},
#else
{3, 6, 0x0000000000000000, "RO", "RSVD", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{1, 2, 0x0000000000000000, "RO/V", "RESPONSE", "00 - Successful\r\n"
"01 - Unsuccessful / Not Supported \r\n"
"10 - Powered Down\r\n"
"11 - Multi-cast Mixed\r\n"
"\r\n"
"This register reflects the response status for the previously completed transaction.  The value of this register is only meaningful if SBISTAT.INITRDY is zero."},
#else
{1, 2, 0x0000000000000000, "RO/V", "RESPONSE", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 0, 0x0000000000000000, "RW/1S", "INITRDY", "0:  The IOSF sideband interface is ready for a new transaction\r\n"
"1:  The IOSF sideband interface is busy with the previous transaction. \r\n"
"A write to set this register bit to 1 will trigger an IOSF sideband message on the private IOSF sideband interface. The message will be formed based on the values programmed in the Sideband Message Interface Register Access registers. \r\n"
"Software needs to ensure that the interface is not busy (SBISTAT.INITRDY is clear) before writing to this register."},
#else
{0, 0, 0x0000000000000000, "RW/1S", "INITRDY", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo1220[] = {{"SBISTAT", "", 0x000000D8, 5, 0x000000000000FFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields1221[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{12, 15, 0x0000000000000000, "RW", "FBE", "The content of this field is sent in the IOSF Sideband Register Access FBE field."},
#else
{12, 15, 0x0000000000000000, "RW", "FBE", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{11, 11, 0x0000000000000000, "RO", "RSVD", "N/A"},
#else
{11, 11, 0x0000000000000000, "RO", "RSVD", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{8, 10, 0x0000000000000000, "RW", "BAR", "The contents of this field are sent in the IOSF Sideband Register Access BAR field.  This should be zero performing a Memory Mapped operation to a PCI compliant device."},
#else
{8, 10, 0x0000000000000000, "RW", "BAR", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 7, 0x0000000000000000, "RW", "FID", "The contents of this field are sent in the IOSF Sideband Register access FID field.\r\n"
"This field should generally remain at zero unless specifically required by a particular application."},
#else
{0, 7, 0x0000000000000000, "RW", "FID", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo1221[] = {{"SBIRID", "", 0x000000DA, 4, 0x000000000000FFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields1222[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{0, 31, 0x0000000000000000, "RW/V", "ADDR", "The content of this register field is sent on the IOSF sideband Message Register Access address(48:32) field.\r\n"
"This must be set to all 0 if 16b addressing is desired."},
#else
{0, 31, 0x0000000000000000, "RW/V", "ADDR", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo1222[] = {{"SBIEXTADDR", "", 0x000000DC, 1, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields1223[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{18, 31, 0x0000000000000000, "RW", "RSVD", "N/A"},
#else
{18, 31, 0x0000000000000000, "RW", "RSVD", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{17, 17, 0x0000000000000000, "RW/O", "MASKLOCK", "Locks the value of the EPMASK[0-7] registers.  Once this value is written to a one it may only be cleared by a reset."},
#else
{17, 17, 0x0000000000000000, "RW/O", "MASKLOCK", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{16, 16, 0x0000000000000000, "RW", "PGCBCGE", "When asserted the P2SB can de-assert the clock request to disable the PGCB clock dynamically when it reaches the power down idle state."},
#else
{16, 16, 0x0000000000000000, "RW", "PGCBCGE", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{9, 15, 0x0000000000000000, "RW", "RSVD_1", "Hardware will not allocate these bits for any purpose in the future so that BIOS can always write to the HIDE field with this byte enabled without having to remember any other field values since it will not be possible to do a read-modify-write when the device is hidden."},
#else
{9, 15, 0x0000000000000000, "RW", "RSVD_1", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{8, 8, 0x0000000000000000, "RW", "HIDE", "When this bit is set, the P2SB will return 1s on any PCI Configuration Read on IOSF-P.  All other transactions including PCI Configuration Writes are unaffected by this.  This does not affect reads performed on the IOSF-SB interface."},
#else
{8, 8, 0x0000000000000000, "RW", "HIDE", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{3, 7, 0x0000000000000000, "RW", "RSVD_2", "N/A"},
#else
{3, 7, 0x0000000000000000, "RW", "RSVD_2", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 2, 0x0000000000000007, "RW", "MAXW", "This controls the max number of outstanding writes on IOSF-SB initiated by MMIO writes to the SBREG_BAR.\r\n"
"Once the number of SBREG_BAR writes issued but not completed on IOSF-SB is equal to this value no new requests will be forwarded until completions are received.  \r\n"
"A value of zero will have the same behavior as the value of one (single write outstanding)."},
#else
{0, 2, 0x0000000000000007, "RW", "MAXW", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo1223[] = {{"P2SBC", "", 0x000000E0, 7, 0x00000000FFFFFFFF, 0x0000000000000007}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields1224[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{6, 7, 0x0000000000000000, "RO", "RSVD", "N/A"},
#else
{6, 7, 0x0000000000000000, "RO", "RSVD", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{5, 5, 0x0000000000000000, "RW", "HAE", "When set, the P2SB will automatically engage power gating when it has reached its idle condition."},
#else
{5, 5, 0x0000000000000000, "RW", "HAE", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{3, 4, 0x0000000000000000, "RO", "RSVD_1", "N/A"},
#else
{3, 4, 0x0000000000000000, "RO", "RSVD_1", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{2, 2, 0x0000000000000000, "RO", "D3HE", "No support for D3 Hot power gating."},
#else
{2, 2, 0x0000000000000000, "RO", "D3HE", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{1, 1, 0x0000000000000000, "RO", "I3E", "No support for S0i3 power gating."},
#else
{1, 1, 0x0000000000000000, "RO", "I3E", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 0, 0x0000000000000001, "RW", "PMCPG_EN", "When set to 1, the P2SB will engage power gating if it is idle and the pmc_p2sb_sw_pg_req_b signal is asserted."},
#else
{0, 0, 0x0000000000000001, "RW", "PMCPG_EN", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo1224[] = {{"PCE", "", 0x000000E4, 6, 0x00000000000000FF, 0x0000000000000001}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields1225[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{12, 15, 0x0000000000000000, "RW", "RSVD", "N/A"},
#else
{12, 15, 0x0000000000000000, "RW", "RSVD", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{10, 11, 0x0000000000000001, "RW", "TIRSTUP", "Value representing the number of delay clocks required between the deassertion of pgcb_force_prim_rst_b and the next state in the FSM (varies).\r\n"
"               00:  1 clock \r\n"
"               01:  2 clocks (default)\r\n"
"               10:  8 clocks \r\n"
"               11:  256 clocks\r\n"
"              "},
#else
{10, 11, 0x0000000000000001, "RW", "TIRSTUP", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{8, 9, 0x0000000000000001, "RW", "TDEISOLATE", "Value representing the minimum number of delay clocks required between the deassertion of pgcb_isol_en_b until the restore flow begins.\r\n"
"               00:  1 clock \r\n"
"               01:  2 clocks (default)\r\n"
"               10:  8 clocks \r\n"
"               11:  256 clocks\r\n"
"              "},
#else
{8, 9, 0x0000000000000001, "RW", "TDEISOLATE", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{6, 7, 0x0000000000000001, "RW", "TSLPINACTV", "Value representing the minimum number of delay clocks required between the deassertion of pgcb_sleep to the deassertion of either pgcb_ip_*_lock_req_b from state retention or pgcb_isol_en_b from a non-retention state.\r\n"
"00:  1 clock \r\n"
"01:  2 clocks (default)\r\n"
"10:  8 clocks \r\n"
"11:  256 clocks\r\n"
""},
#else
{6, 7, 0x0000000000000001, "RW", "TSLPINACTV", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{4, 5, 0x0000000000000001, "RW", "TRESETACT", "Value representing the minimum number of delay clocks required between the assertion of pgcb_force_prim_rst_b (and pgcb_force_rst_b) to either the assertion of pgcb_pmc_pg_req_b for state retention or pgcb_sleep for non-retention.\r\n"
"00:  1 clock \r\n"
"01:  2 clocks (default)\r\n"
"10:  8 clocks \r\n"
"11:  256 clocks\r\n"
""},
#else
{4, 5, 0x0000000000000001, "RW", "TRESETACT", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{2, 3, 0x0000000000000001, "RW", "TISOLATE", "alue representing the minimum number of pgcb_clk cyles required between the assertion of pgcb_isol_en_b to the assertion of pgcb_force_prim_rst_b and pgcb_force_rst_b.\r\n"
"00:  1 clock \r\n"
"01:  2 clocks (default)\r\n"
"10:  8 clocks \r\n"
"11:  256 clocks\r\n"
""},
#else
{2, 3, 0x0000000000000001, "RW", "TISOLATE", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 1, 0x0000000000000001, "RW", "TSLEEPACT", "Value representing the minimum number of pgcb_clk cyles required between the assertion of pgcb_sleep (and the deassertion of pgcb_isol_latchen) to the assertion of pgcb_isol_en_b.\r\n"
"00:  1 clock \r\n"
"01:  2 clocks (default)\r\n"
"10:  8 clocks \r\n"
"11:  256 clocks\r\n"
""},
#else
{0, 1, 0x0000000000000001, "RW", "TSLEEPACT", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo1225[] = {{"PGCBT", "", 0x000000E6, 7, 0x000000000000FFFF, 0x0000000000000555}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields1226[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{12, 15, 0x0000000000000003, "RW", "CKREQHO", "Defines the amount of idle time required between locking for power gate preparation and deassertion of the prim_clkreq signal.  This field defines the exponent such that the actual delay = 2^ CKREQHO."},
#else
{12, 15, 0x0000000000000003, "RW", "CKREQHO", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{8, 11, 0x0000000000000003, "RW", "LOCKHO", "Defines the amount of idle time required between local clock gating and locking for power gate preparation (if power gating is enabled).  This field defines the exponent such that the actual delay = 2^ LOCKHO."},
#else
{8, 11, 0x0000000000000003, "RW", "LOCKHO", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{4, 7, 0x0000000000000003, "RW", "CGATEHO", "Defines the amount of idle time required before local clock gating will be engaged (if enabled).  This field defines the exponent such that the actual delay = 2^ CGATEHO."},
#else
{4, 7, 0x0000000000000003, "RW", "CGATEHO", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{2, 3, 0x0000000000000000, "RW", "RSVD", "N/A"},
#else
{2, 3, 0x0000000000000000, "RW", "RSVD", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{1, 1, 0x0000000000000000, "RW", "CKREQD", "N/A"},
#else
{1, 1, 0x0000000000000000, "RW", "CKREQD", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 0, 0x0000000000000000, "RW", "CGD", "When set to 1, the local clock gating for the IOSF-P clock domain within the P2SB will be disabled."},
#else
{0, 0, 0x0000000000000000, "RW", "CGD", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo1226[] = {{"PDOMAIN", "", 0x000000E8, 6, 0x000000000000FFFF, 0x0000000000003330}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields1227[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{12, 15, 0x0000000000000003, "RW", "CKREQHO", "Defines the amount of idle time required between locking for power gate preparation and deassertion of the prim_clkreq signal.  This field defines the exponent such that the actual delay = 2^ SCKREQHO."},
#else
{12, 15, 0x0000000000000003, "RW", "CKREQHO", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{8, 11, 0x0000000000000003, "RW", "LOCKHO", "Defines the amount of idle time required between local clock gating and locking for power gate preparation (if power gating is enabled).  This field defines the exponent such that the actual delay = 2^ PLOCKHO."},
#else
{8, 11, 0x0000000000000003, "RW", "LOCKHO", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{4, 7, 0x0000000000000003, "RW", "CGATEHO", "Defines the amount of idle time required before local clock gating will be engaged (if enabled).  This field defines the exponent such that the actual delay = 2^ CGATEHO."},
#else
{4, 7, 0x0000000000000003, "RW", "CGATEHO", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{2, 3, 0x0000000000000000, "RW", "RSVD", "N/A"},
#else
{2, 3, 0x0000000000000000, "RW", "RSVD", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{1, 1, 0x0000000000000000, "RW", "CKREQD", "N/A"},
#else
{1, 1, 0x0000000000000000, "RW", "CKREQD", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 0, 0x0000000000000000, "RW", "CGD", "When set to 1, the local clock gating for the IOSF-P clock domain within the P2SB will be disabled."},
#else
{0, 0, 0x0000000000000000, "RW", "CGD", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo1227[] = {{"SDOMAIN", "", 0x000000EA, 6, 0x000000000000FFFF, 0x0000000000003330}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields1228[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{28, 31, 0x0000000000000000, "RO", "RSVD", "N/A"},
#else
{28, 31, 0x0000000000000000, "RO", "RSVD", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{24, 27, 0x0000000000000000, "RO", "DOT", "Indicates the dot process"},
#else
{24, 27, 0x0000000000000000, "RO", "DOT", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{16, 23, 0x0000000000000000, "RO", "MSID", "This field is incremented for each stepping of the part.\r\n"
"\r\n"
"Note that this field can be used by software to differentiate steppings when the Stepping Revision ID may not change."},
#else
{16, 23, 0x0000000000000000, "RO", "MSID", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{8, 15, 0x000000000000000F, "RO", "MID", "0Fh = Intel"},
#else
{8, 15, 0x000000000000000F, "RO", "MID", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 7, 0x0000000000000000, "RO", "PROC", "Indicates the process.  The dot portion of the process is reflected in bits (27:24)"},
#else
{0, 7, 0x0000000000000000, "RO", "PROC", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo1228[] = {{"MANID", "", 0x000000F8, 5, 0x00000000FFFFFFFF, 0x0000000000000F00}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields1229[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{0, 31, 0x0000000061010202, "RW", "sai_ctrl_policy", "SAI Control Policy for Group 1 (LSB)"},
#else
{0, 31, 0x0000000061010202, "RW", "sai_ctrl_policy", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo1229[] = {{"sai_ctrl_reg0", "", 0x00000040, 1, 0x00000000FFFFFFFF, 0x0000000061010202}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields1230[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{0, 31, 0x0000000000000C00, "RW", "sai_ctrl_policy_1", "SAI Control Policy for Group 1 (MSB)"},
#else
{0, 31, 0x0000000000000C00, "RW", "sai_ctrl_policy_1", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo1230[] = {{"sai_ctrl_reg0_1", "", 0x00000044, 1, 0x00000000FFFFFFFF, 0x0000000000000C00}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields1231[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{0, 31, 0x0000000001000212, "RW", "sai_rw_policy0", "SAI Read/Write Policy for Group 1: policy0"},
#else
{0, 31, 0x0000000001000212, "RW", "sai_rw_policy0", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo1231[] = {{"sai_rw_reg0", "", 0x00000048, 1, 0x00000000FFFFFFFF, 0x0000000001000212}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields1232[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{0, 31, 0x0000000000000C00, "RW", "sai_rw_policy0_1", "SAI Read/Write Policy for Group 2: policy0"},
#else
{0, 31, 0x0000000000000C00, "RW", "sai_rw_policy0_1", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo1232[] = {{"sai_rw_reg0_1", "", 0x0000004C, 1, 0x00000000FFFFFFFF, 0x0000000000000C00}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields1233[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{0, 31, 0x0000000000000000, "RO", "sai_rw_policy1", "Reserved"},
#else
{0, 31, 0x0000000000000000, "RO", "sai_rw_policy1", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo1233[] = {{"sai_rw_reg1", "", 0x00000050, 1, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields1234[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{0, 31, 0x0000000000000000, "RO", "sai_rw_policy1_1", "Reserved"},
#else
{0, 31, 0x0000000000000000, "RO", "sai_rw_policy1_1", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo1234[] = {{"sai_rw_reg1_1", "", 0x00000054, 1, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields1235[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{0, 31, 0x0000000000000000, "RO", "sai_rw_policy2", "Reserved"},
#else
{0, 31, 0x0000000000000000, "RO", "sai_rw_policy2", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo1235[] = {{"sai_rw_reg2", "", 0x00000058, 1, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields1236[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{0, 31, 0x0000000000000000, "RO", "sai_rw_policy2_1", "Reserved"},
#else
{0, 31, 0x0000000000000000, "RO", "sai_rw_policy2_1", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo1236[] = {{"sai_rw_reg2_1", "", 0x0000005C, 1, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields1237[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{0, 31, 0x0000000000000003, "RW", "region_policy0", "CR Region Policy0: [br] 1'b1 (applicable for all indexes): The corresponding configuration register region is locked and only accessible by trusted agents associated with policy0 [br]1'b0 (applicable for all indexes): The corresponding configuration register region is unlocked - all agents (trusted or untrusted) are allowed to access this region."},
#else
{0, 31, 0x0000000000000003, "RW", "region_policy0", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo1237[] = {{"reg_policy0", "", 0x00000060, 1, 0x00000000FFFFFFFF, 0x0000000000000003}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields1238[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{0, 31, 0x0000000000000000, "RO", "region_policy1", "Reserved"},
#else
{0, 31, 0x0000000000000000, "RO", "region_policy1", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo1238[] = {{"reg_policy1", "", 0x00000064, 1, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields1239[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{0, 31, 0x0000000000000000, "RO", "region_policy2", "Reserved"},
#else
{0, 31, 0x0000000000000000, "RO", "region_policy2", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo1239[] = {{"reg_policy2", "", 0x00000068, 1, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields1240[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{0, 31, 0x0000000000000000, "RO", "reg_RSVD", "Reserved"},
#else
{0, 31, 0x0000000000000000, "RO", "reg_RSVD", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo1240[] = {{"reg_RSVD", "", 0x0000006C, 1, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields1241[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{0, 31, 0x0000000061010202, "RW", "sai_ctrl_policy", "SAI Control Policy for Group 1 (LSB)"},
#else
{0, 31, 0x0000000061010202, "RW", "sai_ctrl_policy", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo1241[] = {{"sai_ctrl_reg0", "", 0x00000040, 1, 0x00000000FFFFFFFF, 0x0000000061010202}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields1242[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{0, 31, 0x0000000000000C00, "RW", "sai_ctrl_policy_1", "SAI Control Policy for Group 1 (MSB)"},
#else
{0, 31, 0x0000000000000C00, "RW", "sai_ctrl_policy_1", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo1242[] = {{"sai_ctrl_reg0_1", "", 0x00000044, 1, 0x00000000FFFFFFFF, 0x0000000000000C00}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields1243[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{0, 31, 0x0000000001000212, "RW", "sai_rw_policy0", "SAI Read/Write Policy for Group 1: policy0"},
#else
{0, 31, 0x0000000001000212, "RW", "sai_rw_policy0", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo1243[] = {{"sai_rw_reg0", "", 0x00000048, 1, 0x00000000FFFFFFFF, 0x0000000001000212}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields1244[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{0, 31, 0x0000000000000C00, "RW", "sai_rw_policy0_1", "SAI Read/Write Policy for Group 2: policy0"},
#else
{0, 31, 0x0000000000000C00, "RW", "sai_rw_policy0_1", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo1244[] = {{"sai_rw_reg0_1", "", 0x0000004C, 1, 0x00000000FFFFFFFF, 0x0000000000000C00}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields1245[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{0, 31, 0x0000000000000000, "RO", "sai_rw_policy1", "Reserved"},
#else
{0, 31, 0x0000000000000000, "RO", "sai_rw_policy1", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo1245[] = {{"sai_rw_reg1", "", 0x00000050, 1, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields1246[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{0, 31, 0x0000000000000000, "RO", "sai_rw_policy1_1", "Reserved"},
#else
{0, 31, 0x0000000000000000, "RO", "sai_rw_policy1_1", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo1246[] = {{"sai_rw_reg1_1", "", 0x00000054, 1, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields1247[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{0, 31, 0x0000000000000000, "RO", "sai_rw_policy2", "Reserved"},
#else
{0, 31, 0x0000000000000000, "RO", "sai_rw_policy2", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo1247[] = {{"sai_rw_reg2", "", 0x00000058, 1, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields1248[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{0, 31, 0x0000000000000000, "RO", "sai_rw_policy2_1", "Reserved"},
#else
{0, 31, 0x0000000000000000, "RO", "sai_rw_policy2_1", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo1248[] = {{"sai_rw_reg2_1", "", 0x0000005C, 1, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields1249[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{0, 31, 0x0000000000000003, "RW", "region_policy0", "CR Region Policy0: [br] 1'b1 (applicable for all indexes): The corresponding configuration register region is locked and only accessible by trusted agents associated with policy0 [br]1'b0 (applicable for all indexes): The corresponding configuration register region is unlocked - all agents (trusted or untrusted) are allowed to access this region."},
#else
{0, 31, 0x0000000000000003, "RW", "region_policy0", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo1249[] = {{"reg_policy0", "", 0x00000060, 1, 0x00000000FFFFFFFF, 0x0000000000000003}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields1250[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{0, 31, 0x0000000000000000, "RO", "region_policy1", "Reserved"},
#else
{0, 31, 0x0000000000000000, "RO", "region_policy1", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo1250[] = {{"reg_policy1", "", 0x00000064, 1, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields1251[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{0, 31, 0x0000000000000000, "RO", "region_policy2", "Reserved"},
#else
{0, 31, 0x0000000000000000, "RO", "region_policy2", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo1251[] = {{"reg_policy2", "", 0x00000068, 1, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields1252[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{0, 31, 0x0000000000000000, "RO", "reg_RSVD", "Reserved"},
#else
{0, 31, 0x0000000000000000, "RO", "reg_RSVD", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo1252[] = {{"reg_RSVD", "", 0x0000006C, 1, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields1253[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{24, 31, 0x0000000000000001, "RW", "VC0B_C", "VC0BCmp to Tunit"},
#else
{24, 31, 0x0000000000000001, "RW", "VC0B_C", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{16, 23, 0x0000000000000001, "RW", "VC0B_P", "VC0BPosted to Tunit MSIs"},
#else
{16, 23, 0x0000000000000001, "RW", "VC0B_P", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{8, 15, 0x0000000000000001, "RW", "VC0A_C", "VC0ACmp to Tunit"},
#else
{8, 15, 0x0000000000000001, "RW", "VC0A_C", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 7, 0x0000000000000001, "RW", "VC0A_P", "VC0APosted to Tunit MSIs"},
#else
{0, 7, 0x0000000000000001, "RW", "VC0A_P", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo1253[] = {{"A_CR_UPARB_GCNT_DEV_A2T_MCHBAR", "", 0x00006400, 4, 0x00000000FFFFFFFF, 0x0000000001010101}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields1254[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{24, 31, 0x0000000000000001, "RW", "CHID0_TGT", "Tgt arb input for this Class arb"},
#else
{24, 31, 0x0000000000000001, "RW", "CHID0_TGT", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{16, 23, 0x0000000000000001, "RW", "CHID0_MMU_NP", "VC0A IOMMU PTE fetch grant count"},
#else
{16, 23, 0x0000000000000001, "RW", "CHID0_MMU_NP", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{8, 15, 0x0000000000000001, "RW", "CHID0_NP", "VC0A NonPosted grant "},
#else
{8, 15, 0x0000000000000001, "RW", "CHID0_NP", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 7, 0x0000000000000001, "RW", "CHID0_P", "VC0A posted grant count"},
#else
{0, 7, 0x0000000000000001, "RW", "CHID0_P", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo1254[] = {{"A_CR_UPARB_GCNT_A2B_0_MCHBAR", "", 0x00006404, 4, 0x00000000FFFFFFFF, 0x0000000001010101}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields1255[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{24, 31, 0x0000000000000001, "RW", "CHID1_TGT", "Tgt arb input for this Class arb"},
#else
{24, 31, 0x0000000000000001, "RW", "CHID1_TGT", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{16, 23, 0x0000000000000001, "RW", "CHID1_MMU_NP", "VC0B IOMMU PTE fetch"},
#else
{16, 23, 0x0000000000000001, "RW", "CHID1_MMU_NP", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{8, 15, 0x0000000000000001, "RW", "CHID1_NP", "VC0B NonPosted"},
#else
{8, 15, 0x0000000000000001, "RW", "CHID1_NP", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 7, 0x0000000000000001, "RW", "CHID1_P", "VC0B Posted"},
#else
{0, 7, 0x0000000000000001, "RW", "CHID1_P", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo1255[] = {{"A_CR_UPARB_GCNT_A2B_1_MCHBAR", "", 0x00006408, 4, 0x00000000FFFFFFFF, 0x0000000001010101}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields1256[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{24, 31, 0x0000000000000001, "RW", "CHID2_TGT", "Tgt arb input for this Class arb"},
#else
{24, 31, 0x0000000000000001, "RW", "CHID2_TGT", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{16, 23, 0x0000000000000000, "RO", "CHID2_MMU_NP", "ReservedZ"},
#else
{16, 23, 0x0000000000000000, "RO", "CHID2_MMU_NP", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{8, 15, 0x0000000000000001, "RW", "CHID2_NP", "VC1A Non Posted"},
#else
{8, 15, 0x0000000000000001, "RW", "CHID2_NP", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 7, 0x0000000000000000, "RO", "CHID2_P", "ReservedZ.  Not currently used."},
#else
{0, 7, 0x0000000000000000, "RO", "CHID2_P", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo1256[] = {{"A_CR_UPARB_GCNT_A2B_2_MCHBAR", "", 0x0000640C, 4, 0x00000000FFFFFFFF, 0x0000000001000100}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields1257[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{24, 31, 0x0000000000000001, "RW", "CHID3_TGT", "Tgt arb input for this Class arb"},
#else
{24, 31, 0x0000000000000001, "RW", "CHID3_TGT", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{16, 23, 0x0000000000000001, "RW", "CHID3_MMU_NP", "VC1 IOMMU PTE fetch"},
#else
{16, 23, 0x0000000000000001, "RW", "CHID3_MMU_NP", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{8, 15, 0x0000000000000001, "RW", "CHID3_NP", "VC1B NonPosted"},
#else
{8, 15, 0x0000000000000001, "RW", "CHID3_NP", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 7, 0x0000000000000001, "RW", "CHID3_P", "VC1B Posted"},
#else
{0, 7, 0x0000000000000001, "RW", "CHID3_P", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo1257[] = {{"A_CR_UPARB_GCNT_A2B_3_MCHBAR", "", 0x00006410, 4, 0x00000000FFFFFFFF, 0x0000000001010101}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields1258[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{24, 31, 0x0000000000000001, "RW", "CHID4_TGT", "Tgt arb input for this Class arb"},
#else
{24, 31, 0x0000000000000001, "RW", "CHID4_TGT", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{16, 23, 0x0000000000000000, "RO", "CHID4_MMU_NP", "ReservedZ"},
#else
{16, 23, 0x0000000000000000, "RO", "CHID4_MMU_NP", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{8, 15, 0x0000000000000001, "RW", "CHID4_NP", "VC2A Non Posted"},
#else
{8, 15, 0x0000000000000001, "RW", "CHID4_NP", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 7, 0x0000000000000000, "RO", "CHID4_P", "ReservedZ. Not currently used."},
#else
{0, 7, 0x0000000000000000, "RO", "CHID4_P", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo1258[] = {{"A_CR_UPARB_GCNT_A2B_4_MCHBAR", "", 0x00006414, 4, 0x00000000FFFFFFFF, 0x0000000001000100}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields1259[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{24, 31, 0x0000000000000001, "RW", "CHID5_TGT", "Tgt arb input for this Class arb"},
#else
{24, 31, 0x0000000000000001, "RW", "CHID5_TGT", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{16, 23, 0x0000000000000000, "RO", "CHID5_MMU_NP", "ReservedZ"},
#else
{16, 23, 0x0000000000000000, "RO", "CHID5_MMU_NP", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{8, 15, 0x0000000000000001, "RW", "CHID5_NP", "VC2B Non Posted"},
#else
{8, 15, 0x0000000000000001, "RW", "CHID5_NP", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 7, 0x0000000000000001, "RW", "CHID5_P", "VC2B Posted"},
#else
{0, 7, 0x0000000000000001, "RW", "CHID5_P", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo1259[] = {{"A_CR_UPARB_GCNT_A2B_5_MCHBAR", "", 0x00006418, 4, 0x00000000FFFFFFFF, 0x0000000001000101}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields1260[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{24, 31, 0x0000000000000001, "RW", "CHID6_TGT", "Tgt arb input for this Class arb"},
#else
{24, 31, 0x0000000000000001, "RW", "CHID6_TGT", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{16, 23, 0x0000000000000000, "RO", "CHID6_MMU_NP", "ReservedZ. Not currently used."},
#else
{16, 23, 0x0000000000000000, "RO", "CHID6_MMU_NP", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{8, 15, 0x0000000000000001, "RW", "CHID6_NP", "VC2C Non Posted"},
#else
{8, 15, 0x0000000000000001, "RW", "CHID6_NP", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 7, 0x0000000000000001, "RW", "CHID6_P", "VC2C Posted"},
#else
{0, 7, 0x0000000000000001, "RW", "CHID6_P", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo1260[] = {{"A_CR_UPARB_GCNT_A2B_6_MCHBAR", "", 0x0000641C, 4, 0x00000000FFFFFFFF, 0x0000000001000101}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields1261[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{24, 31, 0x0000000000000001, "RW", "CHID7_TGT", "Tgt arb input for this Class arb"},
#else
{24, 31, 0x0000000000000001, "RW", "CHID7_TGT", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{16, 23, 0x0000000000000000, "RO", "CHID7_MMU_NP", "ReservedZ"},
#else
{16, 23, 0x0000000000000000, "RO", "CHID7_MMU_NP", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{8, 15, 0x0000000000000001, "RW", "CHID7_NP", "VCBR Non Posted"},
#else
{8, 15, 0x0000000000000001, "RW", "CHID7_NP", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 7, 0x0000000000000001, "RW", "CHID7_P", "VCBR Posted"},
#else
{0, 7, 0x0000000000000001, "RW", "CHID7_P", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo1261[] = {{"A_CR_UPARB_GCNT_A2B_7_MCHBAR", "", 0x00006420, 4, 0x00000000FFFFFFFF, 0x0000000001000101}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields1262[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{24, 31, 0x0000000000000001, "RW", "CHID0_TGT", "Tgt arb input for this Class arb"},
#else
{24, 31, 0x0000000000000001, "RW", "CHID0_TGT", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{16, 23, 0x0000000000000000, "RO", "CHID0_MMU_NP", "Reserved"},
#else
{16, 23, 0x0000000000000000, "RO", "CHID0_MMU_NP", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{8, 15, 0x0000000000000001, "RW", "CHID0_NP", "VC0B Non Posted"},
#else
{8, 15, 0x0000000000000001, "RW", "CHID0_NP", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 7, 0x0000000000000001, "RW", "CHID0_P", "VC0A Posted"},
#else
{0, 7, 0x0000000000000001, "RW", "CHID0_P", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo1262[] = {{"A_CR_UPARB_GCNT_A2T_0_MCHBAR", "", 0x00006424, 4, 0x00000000FFFFFFFF, 0x0000000001000101}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields1263[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{24, 31, 0x0000000000000001, "RO", "CHID0_TGT", "Tgt arb input for this Class arb"},
#else
{24, 31, 0x0000000000000001, "RO", "CHID0_TGT", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{16, 23, 0x0000000000000001, "RO", "CHID0_C", "VC0A Completion"},
#else
{16, 23, 0x0000000000000001, "RO", "CHID0_C", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{8, 15, 0x0000000000000001, "RO", "CHID0_N", "VC0A NonPosted"},
#else
{8, 15, 0x0000000000000001, "RO", "CHID0_N", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 7, 0x0000000000000001, "RO", "CHID0_P", "VC0A Posted"},
#else
{0, 7, 0x0000000000000001, "RO", "CHID0_P", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo1263[] = {{"A_CR_UPARB_GCNT_P2P_0_MCHBAR", "", 0x00006428, 4, 0x00000000FFFFFFFF, 0x0000000001010101}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields1264[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{24, 31, 0x0000000000000001, "RO", "CHID1_TGT", "Tgt arb input for this Class arb"},
#else
{24, 31, 0x0000000000000001, "RO", "CHID1_TGT", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{16, 23, 0x0000000000000001, "RO", "CHID1_C", "VC0B Completion"},
#else
{16, 23, 0x0000000000000001, "RO", "CHID1_C", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{8, 15, 0x0000000000000001, "RO", "CHID1_N", "VC0B NonPosted"},
#else
{8, 15, 0x0000000000000001, "RO", "CHID1_N", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 7, 0x0000000000000001, "RO", "CHID1_P", "VC0B Posted"},
#else
{0, 7, 0x0000000000000001, "RO", "CHID1_P", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo1264[] = {{"A_CR_UPARB_GCNT_P2P_1_MCHBAR", "", 0x0000642C, 4, 0x00000000FFFFFFFF, 0x0000000001010101}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields1265[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{24, 31, 0x0000000000000001, "RW", "CHID3", "VC1B Posted"},
#else
{24, 31, 0x0000000000000001, "RW", "CHID3", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{16, 23, 0x0000000000000000, "RO", "CHID2", "ReservedZ"},
#else
{16, 23, 0x0000000000000000, "RO", "CHID2", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{8, 15, 0x0000000000000001, "RW", "CHID1", "VC0B Posted"},
#else
{8, 15, 0x0000000000000001, "RW", "CHID1", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 7, 0x0000000000000001, "RW", "CHID0", "VC0A Posted"},
#else
{0, 7, 0x0000000000000001, "RW", "CHID0", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo1265[] = {{"A_CR_CRDARB_PRIV_GCNT_DEV_P_0_MCHBAR", "", 0x00006430, 4, 0x00000000FFFFFFFF, 0x0000000001000101}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields1266[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{24, 31, 0x0000000000000001, "RW", "CHID7", "VCBR Posted"},
#else
{24, 31, 0x0000000000000001, "RW", "CHID7", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{16, 23, 0x0000000000000001, "RW", "CHID6", "VC2C Posted"},
#else
{16, 23, 0x0000000000000001, "RW", "CHID6", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{8, 15, 0x0000000000000001, "RW", "CHID5", "VC2B Posted"},
#else
{8, 15, 0x0000000000000001, "RW", "CHID5", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 7, 0x0000000000000000, "RO", "CHID4", "ReservedZ"},
#else
{0, 7, 0x0000000000000000, "RO", "CHID4", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo1266[] = {{"A_CR_CRDARB_PRIV_GCNT_DEV_P_1_MCHBAR", "", 0x00006434, 4, 0x00000000FFFFFFFF, 0x0000000001010100}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields1267[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{24, 31, 0x0000000000000001, "RW", "CHID3", "VC1B Non Posted"},
#else
{24, 31, 0x0000000000000001, "RW", "CHID3", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{16, 23, 0x0000000000000001, "RW", "CHID2", "VC1A Non Posted"},
#else
{16, 23, 0x0000000000000001, "RW", "CHID2", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{8, 15, 0x0000000000000001, "RW", "CHID1", "VC0B Non Posted"},
#else
{8, 15, 0x0000000000000001, "RW", "CHID1", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 7, 0x0000000000000001, "RW", "CHID0", "VC0A Non Posted"},
#else
{0, 7, 0x0000000000000001, "RW", "CHID0", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo1267[] = {{"A_CR_CRDARB_PRIV_GCNT_DEV_N_0_MCHBAR", "", 0x00006438, 4, 0x00000000FFFFFFFF, 0x0000000001010101}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields1268[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{24, 31, 0x0000000000000001, "RW", "CHID7", "VCBR Non Posted"},
#else
{24, 31, 0x0000000000000001, "RW", "CHID7", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{16, 23, 0x0000000000000001, "RW", "CHID6", "VC2C Non Posted"},
#else
{16, 23, 0x0000000000000001, "RW", "CHID6", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{8, 15, 0x0000000000000001, "RW", "CHID5", "VC2B Non Posted"},
#else
{8, 15, 0x0000000000000001, "RW", "CHID5", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 7, 0x0000000000000001, "RW", "CHID4", "VC2A Non Posted"},
#else
{0, 7, 0x0000000000000001, "RW", "CHID4", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo1268[] = {{"A_CR_CRDARB_PRIV_GCNT_DEV_N_1_MCHBAR", "", 0x0000643C, 4, 0x00000000FFFFFFFF, 0x0000000001010101}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields1269[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{24, 31, 0x0000000000000000, "RO", "CHID3", "ReservedZ"},
#else
{24, 31, 0x0000000000000000, "RO", "CHID3", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{16, 23, 0x0000000000000000, "RO", "CHID2", "ReservedZ"},
#else
{16, 23, 0x0000000000000000, "RO", "CHID2", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{8, 15, 0x0000000000000001, "RW", "CHID1", "VC0B Completion"},
#else
{8, 15, 0x0000000000000001, "RW", "CHID1", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 7, 0x0000000000000001, "RW", "CHID0", "VC0A Completion"},
#else
{0, 7, 0x0000000000000001, "RW", "CHID0", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo1269[] = {{"A_CR_CRDARB_PRIV_GCNT_DEV_C_0_MCHBAR", "", 0x00006440, 4, 0x00000000FFFFFFFF, 0x0000000000000101}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields1270[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{24, 31, 0x0000000000000001, "RW", "CHID3", "VC1B Posted"},
#else
{24, 31, 0x0000000000000001, "RW", "CHID3", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{16, 23, 0x0000000000000000, "RO", "CHID2", "ReservedZ"},
#else
{16, 23, 0x0000000000000000, "RO", "CHID2", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{8, 15, 0x0000000000000001, "RW", "CHID1", "VC0B Posted"},
#else
{8, 15, 0x0000000000000001, "RW", "CHID1", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 7, 0x0000000000000001, "RW", "CHID0", "VC0A Posted"},
#else
{0, 7, 0x0000000000000001, "RW", "CHID0", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo1270[] = {{"A_CR_CRDARB_SHRD_GCNT_DEV_P_0_MCHBAR", "", 0x00006444, 4, 0x00000000FFFFFFFF, 0x0000000001000101}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields1271[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{24, 31, 0x0000000000000001, "RW", "CHID7", "VCBR Posted"},
#else
{24, 31, 0x0000000000000001, "RW", "CHID7", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{16, 23, 0x0000000000000001, "RW", "CHID6", "VC2C Posted"},
#else
{16, 23, 0x0000000000000001, "RW", "CHID6", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{8, 15, 0x0000000000000001, "RW", "CHID5", "VC2B Posted"},
#else
{8, 15, 0x0000000000000001, "RW", "CHID5", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 7, 0x0000000000000000, "RO", "CHID4", "ReservedZ"},
#else
{0, 7, 0x0000000000000000, "RO", "CHID4", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo1271[] = {{"A_CR_CRDARB_SHRD_GCNT_DEV_P_1_MCHBAR", "", 0x00006448, 4, 0x00000000FFFFFFFF, 0x0000000001010100}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields1272[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{24, 31, 0x0000000000000001, "RW", "CHID3", "VC1B Non Posted"},
#else
{24, 31, 0x0000000000000001, "RW", "CHID3", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{16, 23, 0x0000000000000001, "RW", "CHID2", "VC1A Non Posted"},
#else
{16, 23, 0x0000000000000001, "RW", "CHID2", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{8, 15, 0x0000000000000001, "RW", "CHID1", "VC0B Non Posted"},
#else
{8, 15, 0x0000000000000001, "RW", "CHID1", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 7, 0x0000000000000001, "RW", "CHID0", "VC0A Non Posted"},
#else
{0, 7, 0x0000000000000001, "RW", "CHID0", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo1272[] = {{"A_CR_CRDARB_SHRD_GCNT_DEV_N_0_MCHBAR", "", 0x0000644C, 4, 0x00000000FFFFFFFF, 0x0000000001010101}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields1273[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{24, 31, 0x0000000000000001, "RW", "CHID7", "VCBR Non Posted"},
#else
{24, 31, 0x0000000000000001, "RW", "CHID7", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{16, 23, 0x0000000000000001, "RW", "CHID6", "VC2C Non Posted"},
#else
{16, 23, 0x0000000000000001, "RW", "CHID6", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{8, 15, 0x0000000000000001, "RW", "CHID5", "VC2B Non Posted"},
#else
{8, 15, 0x0000000000000001, "RW", "CHID5", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 7, 0x0000000000000001, "RW", "CHID4", "VC2A Non Posted"},
#else
{0, 7, 0x0000000000000001, "RW", "CHID4", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo1273[] = {{"A_CR_CRDARB_SHRD_GCNT_DEV_N_1_MCHBAR", "", 0x00006450, 4, 0x00000000FFFFFFFF, 0x0000000001010101}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields1274[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{24, 31, 0x0000000000000000, "RO", "CHID3", "ReservedZ"},
#else
{24, 31, 0x0000000000000000, "RO", "CHID3", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{16, 23, 0x0000000000000000, "RO", "CHID2", "ReservedZ"},
#else
{16, 23, 0x0000000000000000, "RO", "CHID2", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{8, 15, 0x0000000000000001, "RW", "CHID1", "VC0B Completion"},
#else
{8, 15, 0x0000000000000001, "RW", "CHID1", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 7, 0x0000000000000001, "RW", "CHID0", "VC0A Completion"},
#else
{0, 7, 0x0000000000000001, "RW", "CHID0", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo1274[] = {{"A_CR_CRDARB_SHRD_GCNT_DEV_C_0_MCHBAR", "", 0x00006454, 4, 0x00000000FFFFFFFF, 0x0000000000000101}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields1275[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{16, 23, 0x0000000000000001, "RW", "C", "All Completions"},
#else
{16, 23, 0x0000000000000001, "RW", "C", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{8, 15, 0x0000000000000001, "RW", "NP", "All Non Posteds"},
#else
{8, 15, 0x0000000000000001, "RW", "NP", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 7, 0x0000000000000001, "RW", "P", "All Posteds"},
#else
{0, 7, 0x0000000000000001, "RW", "P", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo1275[] = {{"A_CR_CRDARB_PRIV_GCNT_CLS_MCHBAR", "", 0x00006458, 3, 0x0000000000FFFFFF, 0x0000000000010101}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields1276[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{16, 23, 0x0000000000000001, "RW", "C", "All Completions"},
#else
{16, 23, 0x0000000000000001, "RW", "C", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{8, 15, 0x0000000000000001, "RW", "NP", "All Non Posteds"},
#else
{8, 15, 0x0000000000000001, "RW", "NP", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 7, 0x0000000000000001, "RW", "P", "All Posteds"},
#else
{0, 7, 0x0000000000000001, "RW", "P", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo1276[] = {{"A_CR_CRDARB_SHRD_GCNT_CLS_MCHBAR", "", 0x0000645C, 3, 0x0000000000FFFFFF, 0x0000000000010101}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields1277[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{24, 31, 0x00000000000000FF, "RW", "CHID3", "GazelleQ limit for Upstream NP on CHID3"},
#else
{24, 31, 0x00000000000000FF, "RW", "CHID3", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{16, 23, 0x00000000000000FF, "RW", "CHID2", "GazelleQ limit for Upstream NP on CHID2"},
#else
{16, 23, 0x00000000000000FF, "RW", "CHID2", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{8, 15, 0x00000000000000FF, "RW", "CHID1", "GazelleQ limit for Upstream NP on CHID1"},
#else
{8, 15, 0x00000000000000FF, "RW", "CHID1", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 7, 0x0000000000000008, "RW", "CHID0", "GazelleQ limit for Upstream NP on CHID0"},
#else
{0, 7, 0x0000000000000008, "RW", "CHID0", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo1277[] = {{"A_CR_GZLQ_LIMIT_CH0_3_MCHBAR", "", 0x00006460, 4, 0x00000000FFFFFFFF, 0x00000000FFFFFF08}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields1278[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{24, 31, 0x00000000000000FF, "RW", "CHID7", "GazelleQ limit for Upstream NP on CHID7"},
#else
{24, 31, 0x00000000000000FF, "RW", "CHID7", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{16, 23, 0x00000000000000FF, "RW", "CHID6", "GazelleQ limit for Upstream NP on CHID6"},
#else
{16, 23, 0x00000000000000FF, "RW", "CHID6", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{8, 15, 0x00000000000000FF, "RW", "CHID5", "GazelleQ limit for Upstream NP on CHID5"},
#else
{8, 15, 0x00000000000000FF, "RW", "CHID5", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 7, 0x00000000000000FF, "RW", "CHID4", "GazelleQ limit for Upstream NP on CHID4"},
#else
{0, 7, 0x00000000000000FF, "RW", "CHID4", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo1278[] = {{"A_CR_GZLQ_LIMIT_CH4_7_MCHBAR", "", 0x00006464, 4, 0x00000000FFFFFFFF, 0x00000000FFFFFFFF}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields1279[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{16, 23, 0x0000000000000001, "RW", "CLASS_CNT", "iommu arbiter class grant count"},
#else
{16, 23, 0x0000000000000001, "RW", "CLASS_CNT", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{8, 15, 0x0000000000000001, "RW", "DEV_NP", "iommu arbiter device grant count for np"},
#else
{8, 15, 0x0000000000000001, "RW", "DEV_NP", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 7, 0x0000000000000001, "RW", "DEV_P", "iommu arbiter device grant count for p"},
#else
{0, 7, 0x0000000000000001, "RW", "DEV_P", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo1279[] = {{"A_CR_IOMMUARB_GCNT_VC0a_0_0_0_MCHBAR", "", 0x00006468, 3, 0x0000000000FFFFFF, 0x0000000000010101}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields1280[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{16, 23, 0x0000000000000001, "RW", "CLASS_CNT", "iommu arbiter class grant count"},
#else
{16, 23, 0x0000000000000001, "RW", "CLASS_CNT", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{8, 15, 0x0000000000000001, "RW", "DEV_NP", "iommu arbiter device grant count for np"},
#else
{8, 15, 0x0000000000000001, "RW", "DEV_NP", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 7, 0x0000000000000001, "RW", "DEV_P", "iommu arbiter device grant count for p"},
#else
{0, 7, 0x0000000000000001, "RW", "DEV_P", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo1280[] = {{"A_CR_IOMMUARB_GCNT_VC0b_0_0_0_MCHBAR", "", 0x0000646C, 3, 0x0000000000FFFFFF, 0x0000000000010101}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields1281[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{16, 23, 0x0000000000000001, "RW", "CLASS_CNT", "iommu arbiter class grant count"},
#else
{16, 23, 0x0000000000000001, "RW", "CLASS_CNT", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{8, 15, 0x0000000000000001, "RW", "DEV_NP", "iommu arbiter device grant count for np"},
#else
{8, 15, 0x0000000000000001, "RW", "DEV_NP", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 7, 0x0000000000000001, "RW", "DEV_P", "iommu arbiter device grant count for p"},
#else
{0, 7, 0x0000000000000001, "RW", "DEV_P", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo1281[] = {{"A_CR_IOMMUARB_GCNT_VC1b_0_0_0_MCHBAR", "", 0x00006470, 3, 0x0000000000FFFFFF, 0x0000000000010101}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields1282[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{24, 31, 0x0000000000000004, "RW", "CHID3", "GazelleQ reservation for Upstream NP on CHID3"},
#else
{24, 31, 0x0000000000000004, "RW", "CHID3", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{16, 23, 0x0000000000000004, "RW", "CHID2", "GazelleQ reservation for Upstream NP on CHID2"},
#else
{16, 23, 0x0000000000000004, "RW", "CHID2", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{8, 15, 0x0000000000000001, "RW", "CHID1", "GazelleQ reservation for Upstream NP on CHID1"},
#else
{8, 15, 0x0000000000000001, "RW", "CHID1", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 7, 0x0000000000000001, "RW", "CHID0", "GazelleQ reservation for Upstream NP on CHID0"},
#else
{0, 7, 0x0000000000000001, "RW", "CHID0", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo1282[] = {{"A_CR_GZLQ_RSVD_CH0_3_MCHBAR", "", 0x00006474, 4, 0x00000000FFFFFFFF, 0x0000000004040101}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields1283[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{24, 31, 0x0000000000000001, "RW", "CHID7", "GazelleQ reservation for Upstream NP on CHID7"},
#else
{24, 31, 0x0000000000000001, "RW", "CHID7", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{16, 23, 0x0000000000000001, "RW", "CHID6", "GazelleQ reservation for Upstream NP on CHID6"},
#else
{16, 23, 0x0000000000000001, "RW", "CHID6", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{8, 15, 0x0000000000000001, "RW", "CHID5", "GazelleQ reservation for Upstream NP on CHID5"},
#else
{8, 15, 0x0000000000000001, "RW", "CHID5", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 7, 0x0000000000000001, "RW", "CHID4", "GazelleQ reservation for Upstream NP on CHID4"},
#else
{0, 7, 0x0000000000000001, "RW", "CHID4", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo1283[] = {{"A_CR_GZLQ_RSVD_CH4_7_MCHBAR", "", 0x00006478, 4, 0x00000000FFFFFFFF, 0x0000000001010101}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields1284[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{0, 31, 0x0000000000000000, "RW", "SPARE_RW", "Spare RW 32 bits in BIOS policy group"},
#else
{0, 31, 0x0000000000000000, "RW", "SPARE_RW", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo1284[] = {{"A_CR_SPARE_BIOS_MCHBAR", "", 0x0000647C, 1, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields1285[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{16, 23, 0x0000000000000000, "RW", "CHID_Y_CNT_UPTXN", "Count upstream Txn on all VCs where CHID_Y[i]=1"},
#else
{16, 23, 0x0000000000000000, "RW", "CHID_Y_CNT_UPTXN", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 7, 0x0000000000000000, "RW", "CHID_X_CNT_UPTXN", "Count upstream Txn on all VCs where CHID_X[i]=1"},
#else
{0, 7, 0x0000000000000000, "RW", "CHID_X_CNT_UPTXN", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo1285[] = {{"A_CR_CHAP_SLCT1_MCHBAR", "", 0x00006484, 2, 0x0000000000FFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields1286[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{16, 23, 0x0000000000000000, "RW", "CHID_Y_CNT_DNTXN", "Count downstream Txn on all VCs where CHID_Y[i]=1"},
#else
{16, 23, 0x0000000000000000, "RW", "CHID_Y_CNT_DNTXN", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 7, 0x0000000000000000, "RW", "CHID_X_CNT_DNTXN", "Count downstream Txn on all VCs where CHID_X[i]=1"},
#else
{0, 7, 0x0000000000000000, "RW", "CHID_X_CNT_DNTXN", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo1286[] = {{"A_CR_CHAP_SLCT2_MCHBAR", "", 0x00006488, 2, 0x0000000000FFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields1287[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{2, 3, 0x0000000000000001, "RW", "Q_OCCUPANCY_Y", "Count occupancy/residency of certain Q in Aunit 00 : UpCmd;  01 : UpData;  10 : GzlQ;  11 : DnCmd/Data"},
#else
{2, 3, 0x0000000000000001, "RW", "Q_OCCUPANCY_Y", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 1, 0x0000000000000000, "RW", "Q_OCCUPANCY_X", "Count occupancy/residency of certain Q in Aunit00 : UpCmd;  01 : UpData;  10 : GzlQ;  11 : DnCmd/Data"},
#else
{0, 1, 0x0000000000000000, "RW", "Q_OCCUPANCY_X", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo1287[] = {{"A_CR_CHAP_SLCT3_MCHBAR", "", 0x0000648C, 2, 0x000000000000000F, 0x0000000000000004}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields1288[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{16, 22, 0x0000000000000004, "RW", "CMP_MAX", "Max Cmp credits sent to PSF0 for Chid."},
#else
{16, 22, 0x0000000000000004, "RW", "CMP_MAX", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{8, 14, 0x0000000000000004, "RW", "NP_MAX", "Max non-posted credits sent to PSF0 for Chid."},
#else
{8, 14, 0x0000000000000004, "RW", "NP_MAX", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 6, 0x000000000000000C, "RW", "P_MAX", "Max posted credits sent to PSF0 for Chid."},
#else
{0, 6, 0x000000000000000C, "RW", "P_MAX", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo1288[] = {{"A_CR_UPCMD_CRDTMAX_CH0_0_0_0_MCHBAR", "", 0x00006490, 3, 0x00000000007FFFFF, 0x000000000004040C}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields1289[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{16, 22, 0x0000000000000004, "RW", "CMP_MAX", "Max Cmp credits sent to PSF0 for Chid."},
#else
{16, 22, 0x0000000000000004, "RW", "CMP_MAX", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{8, 14, 0x0000000000000004, "RW", "NP_MAX", "Max non-posted credits sent to PSF0 for Chid."},
#else
{8, 14, 0x0000000000000004, "RW", "NP_MAX", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 6, 0x0000000000000004, "RW", "P_MAX", "Max posted credits sent to PSF0 for Chid."},
#else
{0, 6, 0x0000000000000004, "RW", "P_MAX", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo1289[] = {{"A_CR_UPCMD_CRDTMAX_CH1_0_0_0_MCHBAR", "", 0x00006494, 3, 0x00000000007FFFFF, 0x0000000000040404}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields1290[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{16, 22, 0x0000000000000000, "RW", "CMP_MAX", "Max Cmp credits sent to PSF0 for Chid."},
#else
{16, 22, 0x0000000000000000, "RW", "CMP_MAX", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{8, 14, 0x000000000000007F, "RW", "NP_MAX", "Max non-posted credits sent to PSF0 for Chid."},
#else
{8, 14, 0x000000000000007F, "RW", "NP_MAX", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 6, 0x0000000000000000, "RW", "P_MAX", "Max posted credits sent to PSF0 for Chid."},
#else
{0, 6, 0x0000000000000000, "RW", "P_MAX", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo1290[] = {{"A_CR_UPCMD_CRDTMAX_CH2_0_0_0_MCHBAR", "", 0x00006498, 3, 0x00000000007FFFFF, 0x0000000000007F00}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields1291[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{16, 22, 0x0000000000000000, "RW", "CMP_MAX", "Max Cmp credits sent to PSF0 for Chid."},
#else
{16, 22, 0x0000000000000000, "RW", "CMP_MAX", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{8, 14, 0x000000000000007F, "RW", "NP_MAX", "Max non-posted credits sent to PSF0 for Chid."},
#else
{8, 14, 0x000000000000007F, "RW", "NP_MAX", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 6, 0x000000000000007F, "RW", "P_MAX", "Max posted credits sent to PSF0 for Chid."},
#else
{0, 6, 0x000000000000007F, "RW", "P_MAX", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo1291[] = {{"A_CR_UPCMD_CRDTMAX_CH3_0_0_0_MCHBAR", "", 0x0000649C, 3, 0x00000000007FFFFF, 0x0000000000007F7F}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields1292[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{16, 22, 0x0000000000000000, "RW", "CMP_MAX", "Max Cmp credits sent to PSF0 for Chid."},
#else
{16, 22, 0x0000000000000000, "RW", "CMP_MAX", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{8, 14, 0x0000000000000004, "RW", "NP_MAX", "Max non-posted credits sent to PSF0 for Chid."},
#else
{8, 14, 0x0000000000000004, "RW", "NP_MAX", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 6, 0x0000000000000000, "RW", "P_MAX", "Max posted credits sent to PSF0 for Chid."},
#else
{0, 6, 0x0000000000000000, "RW", "P_MAX", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo1292[] = {{"A_CR_UPCMD_CRDTMAX_CH4_0_0_0_MCHBAR", "", 0x000064A0, 3, 0x00000000007FFFFF, 0x0000000000000400}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields1293[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{16, 22, 0x0000000000000000, "RW", "CMP_MAX", "Max Cmp credits sent to PSF0 for Chid."},
#else
{16, 22, 0x0000000000000000, "RW", "CMP_MAX", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{8, 14, 0x0000000000000004, "RW", "NP_MAX", "Max non-posted credits sent to PSF0 for Chid."},
#else
{8, 14, 0x0000000000000004, "RW", "NP_MAX", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 6, 0x0000000000000004, "RW", "P_MAX", "Max posted credits sent to PSF0 for Chid."},
#else
{0, 6, 0x0000000000000004, "RW", "P_MAX", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo1293[] = {{"A_CR_UPCMD_CRDTMAX_CH5_0_0_0_MCHBAR", "", 0x000064A4, 3, 0x00000000007FFFFF, 0x0000000000000404}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields1294[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{16, 22, 0x0000000000000000, "RW", "CMP_MAX", "Max Cmp credits sent to PSF0 for Chid."},
#else
{16, 22, 0x0000000000000000, "RW", "CMP_MAX", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{8, 14, 0x0000000000000004, "RW", "NP_MAX", "Max non-posted credits sent to PSF0 for Chid."},
#else
{8, 14, 0x0000000000000004, "RW", "NP_MAX", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 6, 0x0000000000000004, "RW", "P_MAX", "Max posted credits sent to PSF0 for Chid."},
#else
{0, 6, 0x0000000000000004, "RW", "P_MAX", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo1294[] = {{"A_CR_UPCMD_CRDTMAX_CH6_0_0_0_MCHBAR", "", 0x000064A8, 3, 0x00000000007FFFFF, 0x0000000000000404}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields1295[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{16, 22, 0x0000000000000000, "RW", "CMP_MAX", "Max Cmp credits sent to PSF0 for Chid."},
#else
{16, 22, 0x0000000000000000, "RW", "CMP_MAX", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{8, 14, 0x0000000000000004, "RW", "NP_MAX", "Max non-posted credits sent to PSF0 for Chid."},
#else
{8, 14, 0x0000000000000004, "RW", "NP_MAX", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 6, 0x000000000000000C, "RW", "P_MAX", "Max posted credits sent to PSF0 for Chid."},
#else
{0, 6, 0x000000000000000C, "RW", "P_MAX", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo1295[] = {{"A_CR_UPCMD_CRDTMAX_CH7_0_0_0_MCHBAR", "", 0x000064AC, 3, 0x00000000007FFFFF, 0x000000000000040C}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields1296[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{31, 31, 0x0000000000000000, "RW", "IMR_EN", "IMR Enable: Enables access checking for the MOT region.  Note: this does not enable MOT itself merely enables access control checks for transactions that attempt to access the MOT buffer."},
#else
{31, 31, 0x0000000000000000, "RW", "IMR_EN", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{30, 30, 0x0000000000000000, "RO", "TR_EN", "Asset Classification (AC)[0]: Trace Enable: Enables snooping of transactions to the IMR region by tracing agents such as MOT.  Reserved and set to 0 for the MOT region, since otherwise this would enable recursive"},
#else
{30, 30, 0x0000000000000000, "RO", "TR_EN", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{14, 28, 0x0000000000000000, "RW", "MOT_OUT_BASE", "Specifies bits 38:24 of the start address of the MOT memory region.  Region size must be a strict poweroftwo at least 16MB and naturally aligned to the size.  These bits are compared with the result of the MOT_OUT_MASK[28:14] applied to bits 38:24 of the incoming address to determine if an access falls within the MOT region."},
#else
{14, 28, 0x0000000000000000, "RW", "MOT_OUT_BASE", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo1296[] = {{"A_CR_MOT_OUT_BASE_0_0_0_MCHBAR", "", 0x000064C0, 3, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields1297[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{31, 31, 0x0000000000000000, "RW", "GT_IWB_EN", "Asset Classification AC[2]: GT Implicit WB Enable: Enables implicit writebacks to protected region from GT caching agent. When set to 1 enables implicit writeback data HITM data from GT to be returned to the requester.  When set to 0 inhibits HITM data from GT from being returned to the requester.  HITM data from IA cores may be returned to the requester depending on the setting of the IA_IWB_EN bit."},
#else
{31, 31, 0x0000000000000000, "RW", "GT_IWB_EN", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{30, 30, 0x0000000000000000, "RW", "IA_IWB_EN", "Asset Classification AC[1]: IA Implicit WB Enable: Enables implicit writebacks to protected region from IA caching agent.  When set to 1 enables implicit writeback data HITM data from IA cores to be returned to the requester.  When set to 0 inhibits HITM data from IA cores from being returned to the requester.  HITM data from GT may be returned to the requester depending on the setting of the GT_IWB_EN bit."},
#else
{30, 30, 0x0000000000000000, "RW", "IA_IWB_EN", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{14, 28, 0x0000000000000000, "RW", "MOT_OUT_MASK", "Specifies the size of the MOT region.  If Request Address [38:24] ANDed with MOT_OUT_MASK[28:14] matches the MOT_OUT_BASE[28:14] then the request falls within the MOT_OUT region"},
#else
{14, 28, 0x0000000000000000, "RW", "MOT_OUT_MASK", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo1297[] = {{"A_CR_MOT_OUT_MASK_0_0_0_MCHBAR", "", 0x000064C4, 3, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields1298[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{31, 31, 0x0000000000000000, "RO", "undefined31", "reserved for future use"},
#else
{31, 31, 0x0000000000000000, "RO", "undefined31", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{30, 30, 0x0000000000000000, "RO", "undefined30", "reserved for future use"},
#else
{30, 30, 0x0000000000000000, "RO", "undefined30", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{29, 29, 0x0000000000000000, "RO", "undefined29", "reserved for future use"},
#else
{29, 29, 0x0000000000000000, "RO", "undefined29", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{28, 28, 0x0000000000000000, "RO", "undefined28", "reserved for future use"},
#else
{28, 28, 0x0000000000000000, "RO", "undefined28", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{27, 27, 0x0000000000000000, "RO", "undefined27", "reserved for future use"},
#else
{27, 27, 0x0000000000000000, "RO", "undefined27", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{26, 26, 0x0000000000000000, "RO", "undefined26", "reserved for future use"},
#else
{26, 26, 0x0000000000000000, "RO", "undefined26", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{25, 25, 0x0000000000000000, "RO", "undefined25", "reserved for future use"},
#else
{25, 25, 0x0000000000000000, "RO", "undefined25", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{24, 24, 0x0000000000000000, "RO", "undefined24", "reserved for future use"},
#else
{24, 24, 0x0000000000000000, "RO", "undefined24", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{23, 23, 0x0000000000000000, "RO", "undefined23", "reserved for future use"},
#else
{23, 23, 0x0000000000000000, "RO", "undefined23", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{22, 22, 0x0000000000000000, "RO", "undefined22", "reserved for future use"},
#else
{22, 22, 0x0000000000000000, "RO", "undefined22", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{21, 21, 0x0000000000000000, "RO", "undefined21", "reserved for future use"},
#else
{21, 21, 0x0000000000000000, "RO", "undefined21", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{20, 20, 0x0000000000000000, "RO", "undefined20", "reserved for future use"},
#else
{20, 20, 0x0000000000000000, "RO", "undefined20", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{19, 19, 0x0000000000000000, "RO", "undefined19", "reserved for future use"},
#else
{19, 19, 0x0000000000000000, "RO", "undefined19", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{18, 18, 0x0000000000000000, "RO", "undefined18", "reserved for future use"},
#else
{18, 18, 0x0000000000000000, "RO", "undefined18", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{17, 17, 0x0000000000000000, "RO", "undefined17", "reserved for future use"},
#else
{17, 17, 0x0000000000000000, "RO", "undefined17", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{16, 16, 0x0000000000000000, "RO", "undefined16", "reserved for future use"},
#else
{16, 16, 0x0000000000000000, "RO", "undefined16", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{15, 15, 0x0000000000000000, "RO", "undefined15", "reserved for future use"},
#else
{15, 15, 0x0000000000000000, "RO", "undefined15", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{14, 14, 0x0000000000000000, "RO", "undefined14", "reserved for future use"},
#else
{14, 14, 0x0000000000000000, "RO", "undefined14", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{13, 13, 0x0000000000000000, "RO", "undefined13", "reserved for future use"},
#else
{13, 13, 0x0000000000000000, "RO", "undefined13", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{12, 12, 0x0000000000000000, "RO", "undefined12", "reserved for future use"},
#else
{12, 12, 0x0000000000000000, "RO", "undefined12", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{11, 11, 0x0000000000000000, "RO", "undefined11", "reserved for future use"},
#else
{11, 11, 0x0000000000000000, "RO", "undefined11", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{10, 10, 0x0000000000000000, "RW1C", "msi_rsvd_set", "An MSI was received with reserved bits set"},
#else
{10, 10, 0x0000000000000000, "RW1C", "msi_rsvd_set", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{9, 9, 0x0000000000000000, "RW1C", "gpa_overflow", "A transaction was received with a guest physical address that was too large"},
#else
{9, 9, 0x0000000000000000, "RW1C", "gpa_overflow", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{8, 8, 0x0000000000000000, "RW1C", "illegal_msi", "A malformed/illegal MSI was received in the upstream direction"},
#else
{8, 8, 0x0000000000000000, "RW1C", "illegal_msi", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{7, 7, 0x0000000000000000, "RW1C", "at_translated_illegal_device", "A device that is not support to set the AT bit set it to an illegal value"},
#else
{7, 7, 0x0000000000000000, "RW1C", "at_translated_illegal_device", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{6, 6, 0x0000000000000000, "RW1C", "unsupported_at", "The address translation (AT) bit was set to an illegal value."},
#else
{6, 6, 0x0000000000000000, "RW1C", "unsupported_at", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{5, 5, 0x0000000000000000, "RW1C", "bad_sai_cmpl", "An incorrect/illegal sai was received with an upstream completion transaction."},
#else
{5, 5, 0x0000000000000000, "RW1C", "bad_sai_cmpl", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{4, 4, 0x0000000000000000, "RW1C", "received_lk_cmpl", "Received a CmplLck completion from iosf."},
#else
{4, 4, 0x0000000000000000, "RW1C", "received_lk_cmpl", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{3, 3, 0x0000000000000000, "RW1C", "bad_sai_nonposted", "An incorrect/illegal sai was received with an upstream non-posted transaction."},
#else
{3, 3, 0x0000000000000000, "RW1C", "bad_sai_nonposted", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{2, 2, 0x0000000000000000, "RW1C", "illegal_nonposted_opcode", "Illegal/Unsupported non-posted opcode received from iosf."},
#else
{2, 2, 0x0000000000000000, "RW1C", "illegal_nonposted_opcode", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{1, 1, 0x0000000000000000, "RW1C", "bad_sai_posted", "An incorrect/illegal sai was received with an upstream posted transaction."},
#else
{1, 1, 0x0000000000000000, "RW1C", "bad_sai_posted", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 0, 0x0000000000000000, "RW1C", "illegal_posted_opcode", "Illegal/Unsupported posted opcode received from iosf."},
#else
{0, 0, 0x0000000000000000, "RW1C", "illegal_posted_opcode", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo1298[] = {{"A_CR_UNCERRSTS_0_0_0_MCHBAR", "", 0x00006588, 32, 0x00000000FFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields1299[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{31, 31, 0x0000000000000001, "RO", "undefined31", "reserved for future use"},
#else
{31, 31, 0x0000000000000001, "RO", "undefined31", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{30, 30, 0x0000000000000001, "RO", "undefined30", "reserved for future use"},
#else
{30, 30, 0x0000000000000001, "RO", "undefined30", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{29, 29, 0x0000000000000001, "RO", "undefined29", "reserved for future use"},
#else
{29, 29, 0x0000000000000001, "RO", "undefined29", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{28, 28, 0x0000000000000001, "RO", "undefined28", "reserved for future use"},
#else
{28, 28, 0x0000000000000001, "RO", "undefined28", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{27, 27, 0x0000000000000001, "RO", "undefined27", "reserved for future use"},
#else
{27, 27, 0x0000000000000001, "RO", "undefined27", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{26, 26, 0x0000000000000001, "RO", "undefined26", "reserved for future use"},
#else
{26, 26, 0x0000000000000001, "RO", "undefined26", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{25, 25, 0x0000000000000001, "RO", "undefined25", "reserved for future use"},
#else
{25, 25, 0x0000000000000001, "RO", "undefined25", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{24, 24, 0x0000000000000001, "RO", "undefined24", "reserved for future use"},
#else
{24, 24, 0x0000000000000001, "RO", "undefined24", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{23, 23, 0x0000000000000001, "RO", "undefined23", "reserved for future use"},
#else
{23, 23, 0x0000000000000001, "RO", "undefined23", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{22, 22, 0x0000000000000001, "RO", "undefined22", "reserved for future use"},
#else
{22, 22, 0x0000000000000001, "RO", "undefined22", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{21, 21, 0x0000000000000001, "RO", "undefined21", "reserved for future use"},
#else
{21, 21, 0x0000000000000001, "RO", "undefined21", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{20, 20, 0x0000000000000001, "RO", "undefined20", "reserved for future use"},
#else
{20, 20, 0x0000000000000001, "RO", "undefined20", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{19, 19, 0x0000000000000001, "RO", "undefined19", "reserved for future use"},
#else
{19, 19, 0x0000000000000001, "RO", "undefined19", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{18, 18, 0x0000000000000001, "RO", "undefined18", "reserved for future use"},
#else
{18, 18, 0x0000000000000001, "RO", "undefined18", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{17, 17, 0x0000000000000001, "RO", "undefined17", "reserved for future use"},
#else
{17, 17, 0x0000000000000001, "RO", "undefined17", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{16, 16, 0x0000000000000001, "RO", "undefined16", "reserved for future use"},
#else
{16, 16, 0x0000000000000001, "RO", "undefined16", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{15, 15, 0x0000000000000001, "RO", "undefined15", "reserved for future use"},
#else
{15, 15, 0x0000000000000001, "RO", "undefined15", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{14, 14, 0x0000000000000001, "RO", "undefined14", "reserved for future use"},
#else
{14, 14, 0x0000000000000001, "RO", "undefined14", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{13, 13, 0x0000000000000001, "RO", "undefined13", "reserved for future use"},
#else
{13, 13, 0x0000000000000001, "RO", "undefined13", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{12, 12, 0x0000000000000001, "RO", "undefined12", "reserved for future use"},
#else
{12, 12, 0x0000000000000001, "RO", "undefined12", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{11, 11, 0x0000000000000001, "RO", "undefined11", "reserved for future use"},
#else
{11, 11, 0x0000000000000001, "RO", "undefined11", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{10, 10, 0x0000000000000001, "RW", "msi_rsvd_set", "An MSI was received with reserved bits set"},
#else
{10, 10, 0x0000000000000001, "RW", "msi_rsvd_set", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{9, 9, 0x0000000000000001, "RW", "gpa_overflow", "A transaction was received with a guest physical address that was too large"},
#else
{9, 9, 0x0000000000000001, "RW", "gpa_overflow", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{8, 8, 0x0000000000000001, "RW", "illegal_msi", "A malformed/illegal MSI was received in the upstream direction"},
#else
{8, 8, 0x0000000000000001, "RW", "illegal_msi", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{7, 7, 0x0000000000000001, "RW", "at_translated_illegal_device", "A device that is not support to set the AT bit set it to an illegal value"},
#else
{7, 7, 0x0000000000000001, "RW", "at_translated_illegal_device", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{6, 6, 0x0000000000000001, "RW", "unsupported_at", "The address translation (AT) bit was set to an illegal value."},
#else
{6, 6, 0x0000000000000001, "RW", "unsupported_at", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{5, 5, 0x0000000000000001, "RW", "bad_sai_cmpl", "An incorrect/illegal sai was received with an upstream completion transaction."},
#else
{5, 5, 0x0000000000000001, "RW", "bad_sai_cmpl", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{4, 4, 0x0000000000000001, "RW", "received_lk_cmpl", "Received a CmplLck completion from iosf."},
#else
{4, 4, 0x0000000000000001, "RW", "received_lk_cmpl", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{3, 3, 0x0000000000000001, "RW", "bad_sai_nonposted", "An incorrect/illegal sai was received with an upstream non-posted transaction."},
#else
{3, 3, 0x0000000000000001, "RW", "bad_sai_nonposted", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{2, 2, 0x0000000000000001, "RW", "illegal_nonposted_opcode", "Illegal/Unsupported non-posted opcode received from iosf."},
#else
{2, 2, 0x0000000000000001, "RW", "illegal_nonposted_opcode", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{1, 1, 0x0000000000000001, "RW", "bad_sai_posted", "An incorrect/illegal sai was received with an upstream posted transaction."},
#else
{1, 1, 0x0000000000000001, "RW", "bad_sai_posted", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 0, 0x0000000000000001, "RW", "illegal_posted_opcode", "Illegal/Unsupported posted opcode received from iosf."},
#else
{0, 0, 0x0000000000000001, "RW", "illegal_posted_opcode", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo1299[] = {{"A_CR_UNCERRMSK_0_0_0_MCHBAR", "", 0x0000658C, 32, 0x00000000FFFFFFFF, 0x00000000FFFFFFFF}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields1300[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{63, 63, 0x0000000000000000, "RW", "LOCK", "Intended usage is for BIOS to set the LOCK when it updates the CR.  Aunit implements only storage for this bit.  No hardware exists to implement hardware locking.  NOTE:  Bunit copy of this bit is used by ucode to protect WRMSR to the Bunit's CR.  Ucode has no access to the Aunit's copy of the CR"},
#else
{63, 63, 0x0000000000000000, "RW", "LOCK", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{38, 51, 0x0000000000000000, "RW", "CH_HASH_MASK", "When both PMI channels in a slice are enabled this field specifies the Channel Hash Mask to be applied on Addr[19:6] postremap DRAM address of the request to compute which PMI channel a request must be routed to.  Relevant only when HVM mode is disabled and only for requests that do not fall under the MOT region.  Bunit will override the programmed value to include the Channel Selector bit See SLICEHASH.INTERLEAVE_MODE field.  Note that HVM mode and MOT regions have special hash requirements and hence they do not use the CH_HASH_MASK."},
#else
{38, 51, 0x0000000000000000, "RW", "CH_HASH_MASK", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{32, 32, 0x0000000000000000, "RW", "CH_1_DISABLED", "Channel 1 in both slices are disabled no memory address mapped to ch 1. All requests sent to channel 0."},
#else
{32, 32, 0x0000000000000000, "RW", "CH_1_DISABLED", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{31, 31, 0x0000000000000000, "RW", "SPARE", "Spare.  No identified usage yet"},
#else
{31, 31, 0x0000000000000000, "RW", "SPARE", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{6, 19, 0x0000000000000000, "RW", "SLICE_HASH_MASK", "When both slices are enabled this field specifies the Slice Hash Mask to be applied on Addr[19:6] physical address of the request to compute which slice a request must be routed to.  Relevant only when HVM mode is disabled and only for physical addresses that do not fall under the Asymmetric Memory Region and the MOT region.  Bunit will override the programmed value to include the Slice Selector bit See INTERLEAVE_MODE field.  Note that HVM mode nonaddress IDI requests asymmetric memory region and MOT regions have special hash requirements and hence they do not use the SLICE_HASH_MASK."},
#else
{6, 19, 0x0000000000000000, "RW", "SLICE_HASH_MASK", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{4, 4, 0x0000000000000000, "RO", "SLICE_0_MEM_DISABLED", "Slice 0 is disabled for memory accesses; no memory address mapped to Slice 0 and all memory requests sent to Slice 1.  In BXT, this bit is RO with the value of 0."},
#else
{4, 4, 0x0000000000000000, "RO", "SLICE_0_MEM_DISABLED", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{2, 3, 0x0000000000000000, "RW", "INTERLEAVE_MODE", "Default interleave mode that specifies how the Slice Selector and Channel Selector bits are to be determined.  Relevant only when HVM mode is disabled and only for system memory addresses that do not fall under the MOT region or the Asymmetric memory region in the System Address Map.  Legal encodings are 0x0 0x1 and 0x2.  An encoding of 0x3 is treated as if it was 0x2.   When both slices and all four PMI channels are enabled   0x0: Default Slice Selector is Addr[10] and Default Channel Selector is Addr[11]  0x1: Default Slice Selector is Addr[11] and Default Channel Selector is Addr[12]  0x2: Default Slice Selector is Addr[12] and Default Channel Selector is Addr[13]  When both slices are enabled but only one channel in each slice enabled:   0x0: Default Slice Selector is Addr[10]  0x1: Default Slice Selector is Addr[11]  0x2: Default Slice Selector is Addr[12]  When only SLICE0 is enabled and both channels on that slice are enabled:   0x0: Default Channel Selector is Addr[10]  0x1: Default Channel Selector is Addr[11]  0x2: Default Channel Selector is Addr[12]  When SLICE0 and only one channel in that slice is enabled this field is not relevant.  Bunit overrides the setting of the SLICE_HASH_MASK to always include the Slice Selector bit.  Similarly Bunit overrides the setting of the CH_HASH_MASK to always include the Channel Selector bit."},
#else
{2, 3, 0x0000000000000000, "RW", "INTERLEAVE_MODE", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{1, 1, 0x0000000000000000, "RW", "HVM_MODE", "0: HVM mode is disabled.  1: HVM mode is enabled.   When HVM mode is enabled Slice Hash and Channel Hash is done as follows:  Both slices and all four PMI channels enabled:  Slice Hash is Request Physical Addr[29] Channel Hash is PostRemap Addr[30]  Both slices enabled but only one PMI channel in each slice enabled:  Slice Hash is Request Physical Addr[29]  Only one SLICE0 enabled but both PMI channels in SLICE0 enabled:  Channel Hash is PostRemap Addr[29]  When HVM_MODE is enabled TOLUD must be set at 2GB."},
#else
{1, 1, 0x0000000000000000, "RW", "HVM_MODE", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 0, 0x0000000000000000, "RW", "SLICE_1_DISABLED", "Slice 1 is disabled no memory address mapped to Slice 1.  All request sent to Slice 0"},
#else
{0, 0, 0x0000000000000000, "RW", "SLICE_1_DISABLED", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo1300[] = {{"A_CR_SLICE_CHANNEL_HASH_0_0_0_MCHBAR", "", 0x00006450, 9, 0xFFFFFFFFFFFFFFFF, 0x0000000000000000}};
#if DUMP_REGISTER_FIELDS
RegisterField RegisterFields1301[] = {
#if DUMP_REGISTER_DESCRIPTIONS
{32, 47, 0x0000000000000000, "RW", "MIRROR_LIMIT", "Mirror Limit: specifies b38:b23 of HPA indicating the end of mirror packet buffer region"},
#else
{32, 47, 0x0000000000000000, "RW", "MIRROR_LIMIT", NULL},
#endif
#if DUMP_REGISTER_DESCRIPTIONS
{0, 15, 0x0000000000000000, "RW", "MIRROR_BASE", "Mirror Base: specifies b38:b23 of HPA indicating the start of mirror packet buffer region"},
#else
{0, 15, 0x0000000000000000, "RW", "MIRROR_BASE", NULL},
#endif
};
#endif // DUMP_REGISTER_FIELDS
RegisterInformation RegisterInfo1301[] = {{"A_CR_MIRROR_RANGE_0_0_0_MCHBAR", "", 0x000065C8, 2, 0x0000FFFFFFFFFFFF, 0x0000000000000000}};
Register Registers[] = {
#if DUMP_REGISTER_FIELDS
  {(RegisterInformation *)&RegisterInfo0, RegisterFields0}, // DUNIT
  {(RegisterInformation *)&RegisterInfo1, RegisterFields1}, // DUNIT
  {(RegisterInformation *)&RegisterInfo2, RegisterFields2}, // DUNIT
  {(RegisterInformation *)&RegisterInfo3, RegisterFields3}, // DUNIT
  {(RegisterInformation *)&RegisterInfo4, RegisterFields4}, // DUNIT
  {(RegisterInformation *)&RegisterInfo5, RegisterFields5}, // DUNIT
  {(RegisterInformation *)&RegisterInfo6, RegisterFields6}, // DUNIT
  {(RegisterInformation *)&RegisterInfo7, RegisterFields7}, // DUNIT
  {(RegisterInformation *)&RegisterInfo8, RegisterFields8}, // DUNIT
  {(RegisterInformation *)&RegisterInfo9, RegisterFields9}, // DUNIT
  {(RegisterInformation *)&RegisterInfo10, RegisterFields10}, // DUNIT
  {(RegisterInformation *)&RegisterInfo11, RegisterFields11}, // DUNIT
  {(RegisterInformation *)&RegisterInfo12, RegisterFields12}, // DUNIT
  {(RegisterInformation *)&RegisterInfo13, RegisterFields13}, // DUNIT
  {(RegisterInformation *)&RegisterInfo14, RegisterFields14}, // DUNIT
  {(RegisterInformation *)&RegisterInfo15, RegisterFields15}, // DUNIT
  {(RegisterInformation *)&RegisterInfo16, RegisterFields16}, // DUNIT
  {(RegisterInformation *)&RegisterInfo17, RegisterFields17}, // DUNIT
  {(RegisterInformation *)&RegisterInfo18, RegisterFields18}, // DUNIT
  {(RegisterInformation *)&RegisterInfo19, RegisterFields19}, // DUNIT
  {(RegisterInformation *)&RegisterInfo20, RegisterFields20}, // DUNIT
  {(RegisterInformation *)&RegisterInfo21, RegisterFields21}, // DUNIT
  {(RegisterInformation *)&RegisterInfo22, RegisterFields22}, // DUNIT
  {(RegisterInformation *)&RegisterInfo23, RegisterFields23}, // DUNIT
  {(RegisterInformation *)&RegisterInfo24, RegisterFields24}, // DUNIT
  {(RegisterInformation *)&RegisterInfo25, RegisterFields25}, // DUNIT
  {(RegisterInformation *)&RegisterInfo26, RegisterFields26}, // DUNIT
  {(RegisterInformation *)&RegisterInfo27, RegisterFields27}, // DUNIT
  {(RegisterInformation *)&RegisterInfo28, RegisterFields28}, // DUNIT
  {(RegisterInformation *)&RegisterInfo29, RegisterFields29}, // DUNIT
  {(RegisterInformation *)&RegisterInfo30, RegisterFields30}, // DUNIT
  {(RegisterInformation *)&RegisterInfo31, RegisterFields31}, // DUNIT
  {(RegisterInformation *)&RegisterInfo32, RegisterFields32}, // DUNIT
  {(RegisterInformation *)&RegisterInfo33, RegisterFields33}, // DUNIT
  {(RegisterInformation *)&RegisterInfo34, RegisterFields34}, // DUNIT
  {(RegisterInformation *)&RegisterInfo35, RegisterFields35}, // DUNIT
  {(RegisterInformation *)&RegisterInfo36, RegisterFields36}, // DUNIT
  {(RegisterInformation *)&RegisterInfo37, RegisterFields37}, // DUNIT
  {(RegisterInformation *)&RegisterInfo38, RegisterFields38}, // DUNIT
  {(RegisterInformation *)&RegisterInfo39, RegisterFields39}, // DUNIT
  {(RegisterInformation *)&RegisterInfo40, RegisterFields40}, // DUNIT
  {(RegisterInformation *)&RegisterInfo41, RegisterFields41}, // DUNIT
  {(RegisterInformation *)&RegisterInfo42, RegisterFields42}, // DUNIT
  {(RegisterInformation *)&RegisterInfo43, RegisterFields43}, // DUNIT
  {(RegisterInformation *)&RegisterInfo44, RegisterFields44}, // DUNIT
  {(RegisterInformation *)&RegisterInfo45, RegisterFields45}, // DUNIT
  {(RegisterInformation *)&RegisterInfo46, RegisterFields46}, // DUNIT
  {(RegisterInformation *)&RegisterInfo47, RegisterFields47}, // DUNIT
  {(RegisterInformation *)&RegisterInfo48, RegisterFields48}, // DUNIT
  {(RegisterInformation *)&RegisterInfo49, RegisterFields49}, // DUNIT
  {(RegisterInformation *)&RegisterInfo50, RegisterFields50}, // DUNIT
  {(RegisterInformation *)&RegisterInfo51, RegisterFields51}, // DUNIT
  {(RegisterInformation *)&RegisterInfo52, RegisterFields52}, // DUNIT
  {(RegisterInformation *)&RegisterInfo53, RegisterFields53}, // DUNIT
  {(RegisterInformation *)&RegisterInfo54, RegisterFields54}, // DUNIT
  {(RegisterInformation *)&RegisterInfo55, RegisterFields55}, // DUNIT
  {(RegisterInformation *)&RegisterInfo56, RegisterFields56}, // DUNIT
  {(RegisterInformation *)&RegisterInfo57, RegisterFields57}, // DUNIT
  {(RegisterInformation *)&RegisterInfo58, RegisterFields58}, // DUNIT
  {(RegisterInformation *)&RegisterInfo59, RegisterFields59}, // DUNIT
  {(RegisterInformation *)&RegisterInfo60, RegisterFields60}, // DUNIT
  {(RegisterInformation *)&RegisterInfo61, RegisterFields61}, // DUNIT
  {(RegisterInformation *)&RegisterInfo62, RegisterFields62}, // DUNIT
{NULL, NULL},
  {(RegisterInformation *)&RegisterInfo63, RegisterFields63}, // CPGC
  {(RegisterInformation *)&RegisterInfo64, RegisterFields64}, // CPGC
  {(RegisterInformation *)&RegisterInfo65, RegisterFields65}, // CPGC
  {(RegisterInformation *)&RegisterInfo66, RegisterFields66}, // CPGC
  {(RegisterInformation *)&RegisterInfo67, RegisterFields67}, // CPGC
  {(RegisterInformation *)&RegisterInfo68, RegisterFields68}, // CPGC
  {(RegisterInformation *)&RegisterInfo69, RegisterFields69}, // CPGC
  {(RegisterInformation *)&RegisterInfo70, RegisterFields70}, // CPGC
  {(RegisterInformation *)&RegisterInfo71, RegisterFields71}, // CPGC
  {(RegisterInformation *)&RegisterInfo72, RegisterFields72}, // CPGC
  {(RegisterInformation *)&RegisterInfo73, RegisterFields73}, // CPGC
  {(RegisterInformation *)&RegisterInfo74, RegisterFields74}, // CPGC
  {(RegisterInformation *)&RegisterInfo75, RegisterFields75}, // CPGC
  {(RegisterInformation *)&RegisterInfo76, RegisterFields76}, // CPGC
  {(RegisterInformation *)&RegisterInfo77, RegisterFields77}, // CPGC
  {(RegisterInformation *)&RegisterInfo78, RegisterFields78}, // CPGC
  {(RegisterInformation *)&RegisterInfo79, RegisterFields79}, // CPGC
  {(RegisterInformation *)&RegisterInfo80, RegisterFields80}, // CPGC
  {(RegisterInformation *)&RegisterInfo81, RegisterFields81}, // CPGC
  {(RegisterInformation *)&RegisterInfo82, RegisterFields82}, // CPGC
  {(RegisterInformation *)&RegisterInfo83, RegisterFields83}, // CPGC
  {(RegisterInformation *)&RegisterInfo84, RegisterFields84}, // CPGC
  {(RegisterInformation *)&RegisterInfo85, RegisterFields85}, // CPGC
  {(RegisterInformation *)&RegisterInfo86, RegisterFields86}, // CPGC
  {(RegisterInformation *)&RegisterInfo87, RegisterFields87}, // CPGC
  {(RegisterInformation *)&RegisterInfo88, RegisterFields88}, // CPGC
  {(RegisterInformation *)&RegisterInfo89, RegisterFields89}, // CPGC
  {(RegisterInformation *)&RegisterInfo90, RegisterFields90}, // CPGC
  {(RegisterInformation *)&RegisterInfo91, RegisterFields91}, // CPGC
  {(RegisterInformation *)&RegisterInfo92, RegisterFields92}, // CPGC
  {(RegisterInformation *)&RegisterInfo93, RegisterFields93}, // CPGC
  {(RegisterInformation *)&RegisterInfo94, RegisterFields94}, // CPGC
  {(RegisterInformation *)&RegisterInfo95, RegisterFields95}, // CPGC
  {(RegisterInformation *)&RegisterInfo96, RegisterFields96}, // CPGC
  {(RegisterInformation *)&RegisterInfo97, RegisterFields97}, // CPGC
  {(RegisterInformation *)&RegisterInfo98, RegisterFields98}, // CPGC
  {(RegisterInformation *)&RegisterInfo99, RegisterFields99}, // CPGC
  {(RegisterInformation *)&RegisterInfo100, RegisterFields100}, // CPGC
  {(RegisterInformation *)&RegisterInfo101, RegisterFields101}, // CPGC
  {(RegisterInformation *)&RegisterInfo102, RegisterFields102}, // CPGC
  {(RegisterInformation *)&RegisterInfo103, RegisterFields103}, // CPGC
  {(RegisterInformation *)&RegisterInfo104, RegisterFields104}, // CPGC
  {(RegisterInformation *)&RegisterInfo105, RegisterFields105}, // CPGC
  {(RegisterInformation *)&RegisterInfo106, RegisterFields106}, // CPGC
  {(RegisterInformation *)&RegisterInfo107, RegisterFields107}, // CPGC
  {(RegisterInformation *)&RegisterInfo108, RegisterFields108}, // CPGC
  {(RegisterInformation *)&RegisterInfo109, RegisterFields109}, // CPGC
  {(RegisterInformation *)&RegisterInfo110, RegisterFields110}, // CPGC
  {(RegisterInformation *)&RegisterInfo111, RegisterFields111}, // CPGC
  {(RegisterInformation *)&RegisterInfo112, RegisterFields112}, // CPGC
  {(RegisterInformation *)&RegisterInfo113, RegisterFields113}, // CPGC
  {(RegisterInformation *)&RegisterInfo114, RegisterFields114}, // CPGC
  {(RegisterInformation *)&RegisterInfo115, RegisterFields115}, // CPGC
  {(RegisterInformation *)&RegisterInfo116, RegisterFields116}, // CPGC
  {(RegisterInformation *)&RegisterInfo117, RegisterFields117}, // CPGC
  {(RegisterInformation *)&RegisterInfo118, RegisterFields118}, // CPGC
  {(RegisterInformation *)&RegisterInfo119, RegisterFields119}, // CPGC
  {(RegisterInformation *)&RegisterInfo120, RegisterFields120}, // CPGC
  {(RegisterInformation *)&RegisterInfo121, RegisterFields121}, // CPGC
  {(RegisterInformation *)&RegisterInfo122, RegisterFields122}, // CPGC
  {(RegisterInformation *)&RegisterInfo123, RegisterFields123}, // CPGC
  {(RegisterInformation *)&RegisterInfo124, RegisterFields124}, // CPGC
  {(RegisterInformation *)&RegisterInfo125, RegisterFields125}, // CPGC
  {(RegisterInformation *)&RegisterInfo126, RegisterFields126}, // CPGC
  {(RegisterInformation *)&RegisterInfo127, RegisterFields127}, // CPGC
  {(RegisterInformation *)&RegisterInfo128, RegisterFields128}, // CPGC
  {(RegisterInformation *)&RegisterInfo129, RegisterFields129}, // CPGC
  {(RegisterInformation *)&RegisterInfo130, RegisterFields130}, // CPGC
  {(RegisterInformation *)&RegisterInfo131, RegisterFields131}, // CPGC
  {(RegisterInformation *)&RegisterInfo132, RegisterFields132}, // CPGC
  {(RegisterInformation *)&RegisterInfo133, RegisterFields133}, // CPGC
  {(RegisterInformation *)&RegisterInfo134, RegisterFields134}, // CPGC
  {(RegisterInformation *)&RegisterInfo135, RegisterFields135}, // CPGC
  {(RegisterInformation *)&RegisterInfo136, RegisterFields136}, // CPGC
  {(RegisterInformation *)&RegisterInfo137, RegisterFields137}, // CPGC
  {(RegisterInformation *)&RegisterInfo138, RegisterFields138}, // CPGC
  {(RegisterInformation *)&RegisterInfo139, RegisterFields139}, // CPGC
  {(RegisterInformation *)&RegisterInfo140, RegisterFields140}, // CPGC
  {(RegisterInformation *)&RegisterInfo141, RegisterFields141}, // CPGC
  {(RegisterInformation *)&RegisterInfo142, RegisterFields142}, // CPGC
  {(RegisterInformation *)&RegisterInfo143, RegisterFields143}, // CPGC
  {(RegisterInformation *)&RegisterInfo144, RegisterFields144}, // CPGC
  {(RegisterInformation *)&RegisterInfo145, RegisterFields145}, // CPGC
  {(RegisterInformation *)&RegisterInfo146, RegisterFields146}, // CPGC
  {(RegisterInformation *)&RegisterInfo147, RegisterFields147}, // CPGC
  {(RegisterInformation *)&RegisterInfo148, RegisterFields148}, // CPGC
  {(RegisterInformation *)&RegisterInfo149, RegisterFields149}, // CPGC
  {(RegisterInformation *)&RegisterInfo150, RegisterFields150}, // CPGC
  {(RegisterInformation *)&RegisterInfo151, RegisterFields151}, // CPGC
  {(RegisterInformation *)&RegisterInfo152, RegisterFields152}, // CPGC
  {(RegisterInformation *)&RegisterInfo153, RegisterFields153}, // CPGC
  {(RegisterInformation *)&RegisterInfo154, RegisterFields154}, // CPGC
  {(RegisterInformation *)&RegisterInfo155, RegisterFields155}, // CPGC
  {(RegisterInformation *)&RegisterInfo156, RegisterFields156}, // CPGC
  {(RegisterInformation *)&RegisterInfo157, RegisterFields157}, // CPGC
  {(RegisterInformation *)&RegisterInfo158, RegisterFields158}, // CPGC
  {(RegisterInformation *)&RegisterInfo159, RegisterFields159}, // CPGC
  {(RegisterInformation *)&RegisterInfo160, RegisterFields160}, // CPGC
  {(RegisterInformation *)&RegisterInfo161, RegisterFields161}, // CPGC
  {(RegisterInformation *)&RegisterInfo162, RegisterFields162}, // CPGC
  {(RegisterInformation *)&RegisterInfo163, RegisterFields163}, // CPGC
  {(RegisterInformation *)&RegisterInfo164, RegisterFields164}, // CPGC
  {(RegisterInformation *)&RegisterInfo165, RegisterFields165}, // CPGC
  {(RegisterInformation *)&RegisterInfo166, RegisterFields166}, // CPGC
  {(RegisterInformation *)&RegisterInfo167, RegisterFields167}, // CPGC
  {(RegisterInformation *)&RegisterInfo168, RegisterFields168}, // CPGC
  {(RegisterInformation *)&RegisterInfo169, RegisterFields169}, // CPGC
  {(RegisterInformation *)&RegisterInfo170, RegisterFields170}, // CPGC
  {(RegisterInformation *)&RegisterInfo171, RegisterFields171}, // CPGC
  {(RegisterInformation *)&RegisterInfo172, RegisterFields172}, // CPGC
  {(RegisterInformation *)&RegisterInfo173, RegisterFields173}, // CPGC
  {(RegisterInformation *)&RegisterInfo174, RegisterFields174}, // CPGC
  {(RegisterInformation *)&RegisterInfo175, RegisterFields175}, // CPGC
  {(RegisterInformation *)&RegisterInfo176, RegisterFields176}, // CPGC
  {(RegisterInformation *)&RegisterInfo177, RegisterFields177}, // CPGC
  {(RegisterInformation *)&RegisterInfo178, RegisterFields178}, // CPGC
  {(RegisterInformation *)&RegisterInfo179, RegisterFields179}, // CPGC
  {(RegisterInformation *)&RegisterInfo180, RegisterFields180}, // CPGC
  {(RegisterInformation *)&RegisterInfo181, RegisterFields181}, // CPGC
  {(RegisterInformation *)&RegisterInfo182, RegisterFields182}, // CPGC
  {(RegisterInformation *)&RegisterInfo183, RegisterFields183}, // CPGC
  {(RegisterInformation *)&RegisterInfo184, RegisterFields184}, // CPGC
  {(RegisterInformation *)&RegisterInfo185, RegisterFields185}, // CPGC
  {(RegisterInformation *)&RegisterInfo186, RegisterFields186}, // CPGC
  {(RegisterInformation *)&RegisterInfo187, RegisterFields187}, // CPGC
  {(RegisterInformation *)&RegisterInfo188, RegisterFields188}, // CPGC
  {(RegisterInformation *)&RegisterInfo189, RegisterFields189}, // CPGC
  {(RegisterInformation *)&RegisterInfo190, RegisterFields190}, // CPGC
  {(RegisterInformation *)&RegisterInfo191, RegisterFields191}, // CPGC
  {(RegisterInformation *)&RegisterInfo192, RegisterFields192}, // CPGC
  {(RegisterInformation *)&RegisterInfo193, RegisterFields193}, // CPGC
  {(RegisterInformation *)&RegisterInfo194, RegisterFields194}, // CPGC
  {(RegisterInformation *)&RegisterInfo195, RegisterFields195}, // CPGC
  {(RegisterInformation *)&RegisterInfo196, RegisterFields196}, // CPGC
  {(RegisterInformation *)&RegisterInfo197, RegisterFields197}, // CPGC
  {(RegisterInformation *)&RegisterInfo198, RegisterFields198}, // CPGC
  {(RegisterInformation *)&RegisterInfo199, RegisterFields199}, // CPGC
  {(RegisterInformation *)&RegisterInfo200, RegisterFields200}, // CPGC
  {(RegisterInformation *)&RegisterInfo201, RegisterFields201}, // CPGC
  {(RegisterInformation *)&RegisterInfo202, RegisterFields202}, // CPGC
  {(RegisterInformation *)&RegisterInfo203, RegisterFields203}, // CPGC
  {(RegisterInformation *)&RegisterInfo204, RegisterFields204}, // CPGC
  {(RegisterInformation *)&RegisterInfo205, RegisterFields205}, // CPGC
  {(RegisterInformation *)&RegisterInfo206, RegisterFields206}, // CPGC
  {(RegisterInformation *)&RegisterInfo207, RegisterFields207}, // CPGC
  {(RegisterInformation *)&RegisterInfo208, RegisterFields208}, // CPGC
  {(RegisterInformation *)&RegisterInfo209, RegisterFields209}, // CPGC
  {(RegisterInformation *)&RegisterInfo210, RegisterFields210}, // CPGC
  {(RegisterInformation *)&RegisterInfo211, RegisterFields211}, // CPGC
  {(RegisterInformation *)&RegisterInfo212, RegisterFields212}, // CPGC
  {(RegisterInformation *)&RegisterInfo213, RegisterFields213}, // CPGC
  {(RegisterInformation *)&RegisterInfo214, RegisterFields214}, // CPGC
  {(RegisterInformation *)&RegisterInfo215, RegisterFields215}, // CPGC
  {(RegisterInformation *)&RegisterInfo216, RegisterFields216}, // CPGC
  {(RegisterInformation *)&RegisterInfo217, RegisterFields217}, // CPGC
  {(RegisterInformation *)&RegisterInfo218, RegisterFields218}, // CPGC
  {(RegisterInformation *)&RegisterInfo219, RegisterFields219}, // CPGC
  {(RegisterInformation *)&RegisterInfo220, RegisterFields220}, // CPGC
  {(RegisterInformation *)&RegisterInfo221, RegisterFields221}, // CPGC
  {(RegisterInformation *)&RegisterInfo222, RegisterFields222}, // CPGC
  {(RegisterInformation *)&RegisterInfo223, RegisterFields223}, // CPGC
  {(RegisterInformation *)&RegisterInfo224, RegisterFields224}, // CPGC
  {(RegisterInformation *)&RegisterInfo225, RegisterFields225}, // CPGC
  {(RegisterInformation *)&RegisterInfo226, RegisterFields226}, // CPGC
  {(RegisterInformation *)&RegisterInfo227, RegisterFields227}, // CPGC
  {(RegisterInformation *)&RegisterInfo228, RegisterFields228}, // CPGC
  {(RegisterInformation *)&RegisterInfo229, RegisterFields229}, // CPGC
  {(RegisterInformation *)&RegisterInfo230, RegisterFields230}, // CPGC
  {(RegisterInformation *)&RegisterInfo231, RegisterFields231}, // CPGC
  {(RegisterInformation *)&RegisterInfo232, RegisterFields232}, // CPGC
  {(RegisterInformation *)&RegisterInfo233, RegisterFields233}, // CPGC
  {(RegisterInformation *)&RegisterInfo234, RegisterFields234}, // CPGC
  {(RegisterInformation *)&RegisterInfo235, RegisterFields235}, // CPGC
  {(RegisterInformation *)&RegisterInfo236, RegisterFields236}, // CPGC
  {(RegisterInformation *)&RegisterInfo237, RegisterFields237}, // CPGC
  {(RegisterInformation *)&RegisterInfo238, RegisterFields238}, // CPGC
  {(RegisterInformation *)&RegisterInfo239, RegisterFields239}, // CPGC
  {(RegisterInformation *)&RegisterInfo240, RegisterFields240}, // CPGC
  {(RegisterInformation *)&RegisterInfo241, RegisterFields241}, // CPGC
  {(RegisterInformation *)&RegisterInfo242, RegisterFields242}, // CPGC
  {(RegisterInformation *)&RegisterInfo243, RegisterFields243}, // CPGC
  {(RegisterInformation *)&RegisterInfo244, RegisterFields244}, // CPGC
  {(RegisterInformation *)&RegisterInfo245, RegisterFields245}, // CPGC
  {(RegisterInformation *)&RegisterInfo246, RegisterFields246}, // CPGC
  {(RegisterInformation *)&RegisterInfo247, RegisterFields247}, // CPGC
  {(RegisterInformation *)&RegisterInfo248, RegisterFields248}, // CPGC
  {(RegisterInformation *)&RegisterInfo249, RegisterFields249}, // CPGC
  {(RegisterInformation *)&RegisterInfo250, RegisterFields250}, // CPGC
  {(RegisterInformation *)&RegisterInfo251, RegisterFields251}, // CPGC
  {(RegisterInformation *)&RegisterInfo252, RegisterFields252}, // CPGC
  {(RegisterInformation *)&RegisterInfo253, RegisterFields253}, // CPGC
  {(RegisterInformation *)&RegisterInfo254, RegisterFields254}, // CPGC
  {(RegisterInformation *)&RegisterInfo255, RegisterFields255}, // CPGC
  {(RegisterInformation *)&RegisterInfo256, RegisterFields256}, // CPGC
  {(RegisterInformation *)&RegisterInfo257, RegisterFields257}, // CPGC
  {(RegisterInformation *)&RegisterInfo258, RegisterFields258}, // CPGC
  {(RegisterInformation *)&RegisterInfo259, RegisterFields259}, // CPGC
  {(RegisterInformation *)&RegisterInfo260, RegisterFields260}, // CPGC
  {(RegisterInformation *)&RegisterInfo261, RegisterFields261}, // CPGC
  {(RegisterInformation *)&RegisterInfo262, RegisterFields262}, // CPGC
  {(RegisterInformation *)&RegisterInfo263, RegisterFields263}, // CPGC
  {(RegisterInformation *)&RegisterInfo264, RegisterFields264}, // CPGC
  {(RegisterInformation *)&RegisterInfo265, RegisterFields265}, // CPGC
  {(RegisterInformation *)&RegisterInfo266, RegisterFields266}, // CPGC
  {(RegisterInformation *)&RegisterInfo267, RegisterFields267}, // CPGC
  {(RegisterInformation *)&RegisterInfo268, RegisterFields268}, // CPGC
  {(RegisterInformation *)&RegisterInfo269, RegisterFields269}, // CPGC
  {(RegisterInformation *)&RegisterInfo270, RegisterFields270}, // CPGC
  {(RegisterInformation *)&RegisterInfo271, RegisterFields271}, // CPGC
  {(RegisterInformation *)&RegisterInfo272, RegisterFields272}, // CPGC
  {(RegisterInformation *)&RegisterInfo273, RegisterFields273}, // CPGC
  {(RegisterInformation *)&RegisterInfo274, RegisterFields274}, // CPGC
  {(RegisterInformation *)&RegisterInfo275, RegisterFields275}, // CPGC
  {(RegisterInformation *)&RegisterInfo276, RegisterFields276}, // CPGC
  {(RegisterInformation *)&RegisterInfo277, RegisterFields277}, // CPGC
  {(RegisterInformation *)&RegisterInfo278, RegisterFields278}, // CPGC
  {(RegisterInformation *)&RegisterInfo279, RegisterFields279}, // CPGC
  {(RegisterInformation *)&RegisterInfo280, RegisterFields280}, // CPGC
  {(RegisterInformation *)&RegisterInfo281, RegisterFields281}, // CPGC
  {(RegisterInformation *)&RegisterInfo282, RegisterFields282}, // CPGC
  {(RegisterInformation *)&RegisterInfo283, RegisterFields283}, // CPGC
  {(RegisterInformation *)&RegisterInfo284, RegisterFields284}, // CPGC
  {(RegisterInformation *)&RegisterInfo285, RegisterFields285}, // CPGC
  {(RegisterInformation *)&RegisterInfo286, RegisterFields286}, // CPGC
  {(RegisterInformation *)&RegisterInfo287, RegisterFields287}, // CPGC
  {(RegisterInformation *)&RegisterInfo288, RegisterFields288}, // CPGC
  {(RegisterInformation *)&RegisterInfo289, RegisterFields289}, // CPGC
  {(RegisterInformation *)&RegisterInfo290, RegisterFields290}, // CPGC
  {(RegisterInformation *)&RegisterInfo291, RegisterFields291}, // CPGC
  {(RegisterInformation *)&RegisterInfo292, RegisterFields292}, // CPGC
  {(RegisterInformation *)&RegisterInfo293, RegisterFields293}, // CPGC
  {(RegisterInformation *)&RegisterInfo294, RegisterFields294}, // CPGC
  {(RegisterInformation *)&RegisterInfo295, RegisterFields295}, // CPGC
  {(RegisterInformation *)&RegisterInfo296, RegisterFields296}, // CPGC
  {(RegisterInformation *)&RegisterInfo297, RegisterFields297}, // CPGC
  {(RegisterInformation *)&RegisterInfo298, RegisterFields298}, // CPGC
  {(RegisterInformation *)&RegisterInfo299, RegisterFields299}, // CPGC
  {(RegisterInformation *)&RegisterInfo300, RegisterFields300}, // CPGC
  {(RegisterInformation *)&RegisterInfo301, RegisterFields301}, // CPGC
  {(RegisterInformation *)&RegisterInfo302, RegisterFields302}, // CPGC
  {(RegisterInformation *)&RegisterInfo303, RegisterFields303}, // CPGC
  {(RegisterInformation *)&RegisterInfo304, RegisterFields304}, // CPGC
  {(RegisterInformation *)&RegisterInfo305, RegisterFields305}, // CPGC
  {(RegisterInformation *)&RegisterInfo306, RegisterFields306}, // CPGC
  {(RegisterInformation *)&RegisterInfo307, RegisterFields307}, // CPGC
  {(RegisterInformation *)&RegisterInfo308, RegisterFields308}, // CPGC
  {(RegisterInformation *)&RegisterInfo309, RegisterFields309}, // CPGC
  {(RegisterInformation *)&RegisterInfo310, RegisterFields310}, // CPGC
  {(RegisterInformation *)&RegisterInfo311, RegisterFields311}, // CPGC
  {(RegisterInformation *)&RegisterInfo312, RegisterFields312}, // CPGC
  {(RegisterInformation *)&RegisterInfo313, RegisterFields313}, // CPGC
  {(RegisterInformation *)&RegisterInfo314, RegisterFields314}, // CPGC
  {(RegisterInformation *)&RegisterInfo315, RegisterFields315}, // CPGC
  {(RegisterInformation *)&RegisterInfo316, RegisterFields316}, // CPGC
  {(RegisterInformation *)&RegisterInfo317, RegisterFields317}, // CPGC
  {(RegisterInformation *)&RegisterInfo318, RegisterFields318}, // CPGC
  {(RegisterInformation *)&RegisterInfo319, RegisterFields319}, // CPGC
  {(RegisterInformation *)&RegisterInfo320, RegisterFields320}, // CPGC
  {(RegisterInformation *)&RegisterInfo321, RegisterFields321}, // CPGC
  {(RegisterInformation *)&RegisterInfo322, RegisterFields322}, // CPGC
  {(RegisterInformation *)&RegisterInfo323, RegisterFields323}, // CPGC
  {(RegisterInformation *)&RegisterInfo324, RegisterFields324}, // CPGC
  {(RegisterInformation *)&RegisterInfo325, RegisterFields325}, // CPGC
  {(RegisterInformation *)&RegisterInfo326, RegisterFields326}, // CPGC
  {(RegisterInformation *)&RegisterInfo327, RegisterFields327}, // CPGC
  {(RegisterInformation *)&RegisterInfo328, RegisterFields328}, // CPGC
  {(RegisterInformation *)&RegisterInfo329, RegisterFields329}, // CPGC
  {(RegisterInformation *)&RegisterInfo330, RegisterFields330}, // CPGC
  {(RegisterInformation *)&RegisterInfo331, RegisterFields331}, // CPGC
  {(RegisterInformation *)&RegisterInfo332, RegisterFields332}, // CPGC
  {(RegisterInformation *)&RegisterInfo333, RegisterFields333}, // CPGC
  {(RegisterInformation *)&RegisterInfo334, RegisterFields334}, // CPGC
  {(RegisterInformation *)&RegisterInfo335, RegisterFields335}, // CPGC
  {(RegisterInformation *)&RegisterInfo336, RegisterFields336}, // CPGC
  {(RegisterInformation *)&RegisterInfo337, RegisterFields337}, // CPGC
  {(RegisterInformation *)&RegisterInfo338, RegisterFields338}, // CPGC
  {(RegisterInformation *)&RegisterInfo339, RegisterFields339}, // CPGC
{NULL, NULL},
  {(RegisterInformation *)&RegisterInfo340, RegisterFields340}, // DQCCC
  {(RegisterInformation *)&RegisterInfo341, RegisterFields341}, // DQCCC
  {(RegisterInformation *)&RegisterInfo342, RegisterFields342}, // DQCCC
  {(RegisterInformation *)&RegisterInfo343, RegisterFields343}, // DQCCC
  {(RegisterInformation *)&RegisterInfo344, RegisterFields344}, // DQCCC
  {(RegisterInformation *)&RegisterInfo345, RegisterFields345}, // DQCCC
  {(RegisterInformation *)&RegisterInfo346, RegisterFields346}, // DQCCC
  {(RegisterInformation *)&RegisterInfo347, RegisterFields347}, // DQCCC
  {(RegisterInformation *)&RegisterInfo348, RegisterFields348}, // DQCCC
  {(RegisterInformation *)&RegisterInfo349, RegisterFields349}, // DQCCC
  {(RegisterInformation *)&RegisterInfo350, RegisterFields350}, // DQCCC
  {(RegisterInformation *)&RegisterInfo351, RegisterFields351}, // DQCCC
  {(RegisterInformation *)&RegisterInfo352, RegisterFields352}, // DQCCC
  {(RegisterInformation *)&RegisterInfo353, RegisterFields353}, // DQCCC
  {(RegisterInformation *)&RegisterInfo354, RegisterFields354}, // DQCCC
  {(RegisterInformation *)&RegisterInfo355, RegisterFields355}, // DQCCC
  {(RegisterInformation *)&RegisterInfo356, RegisterFields356}, // DQCCC
  {(RegisterInformation *)&RegisterInfo357, RegisterFields357}, // DQCCC
  {(RegisterInformation *)&RegisterInfo358, RegisterFields358}, // DQCCC
  {(RegisterInformation *)&RegisterInfo359, RegisterFields359}, // DQCCC
  {(RegisterInformation *)&RegisterInfo360, RegisterFields360}, // DQCCC
  {(RegisterInformation *)&RegisterInfo361, RegisterFields361}, // DQCCC
  {(RegisterInformation *)&RegisterInfo362, RegisterFields362}, // DQCCC
  {(RegisterInformation *)&RegisterInfo363, RegisterFields363}, // DQCCC
  {(RegisterInformation *)&RegisterInfo364, RegisterFields364}, // DQCCC
  {(RegisterInformation *)&RegisterInfo365, RegisterFields365}, // DQCCC
  {(RegisterInformation *)&RegisterInfo366, RegisterFields366}, // DQCCC
  {(RegisterInformation *)&RegisterInfo367, RegisterFields367}, // DQCCC
  {(RegisterInformation *)&RegisterInfo368, RegisterFields368}, // DQCCC
  {(RegisterInformation *)&RegisterInfo369, RegisterFields369}, // DQCCC
  {(RegisterInformation *)&RegisterInfo370, RegisterFields370}, // DQCCC
  {(RegisterInformation *)&RegisterInfo371, RegisterFields371}, // DQCCC
  {(RegisterInformation *)&RegisterInfo372, RegisterFields372}, // DQCCC
  {(RegisterInformation *)&RegisterInfo373, RegisterFields373}, // DQCCC
  {(RegisterInformation *)&RegisterInfo374, RegisterFields374}, // DQCCC
  {(RegisterInformation *)&RegisterInfo375, RegisterFields375}, // DQCCC
  {(RegisterInformation *)&RegisterInfo376, RegisterFields376}, // DQCCC
  {(RegisterInformation *)&RegisterInfo377, RegisterFields377}, // DQCCC
  {(RegisterInformation *)&RegisterInfo378, RegisterFields378}, // DQCCC
  {(RegisterInformation *)&RegisterInfo379, RegisterFields379}, // DQCCC
  {(RegisterInformation *)&RegisterInfo380, RegisterFields380}, // DQCCC
  {(RegisterInformation *)&RegisterInfo381, RegisterFields381}, // DQCCC
  {(RegisterInformation *)&RegisterInfo382, RegisterFields382}, // DQCCC
  {(RegisterInformation *)&RegisterInfo383, RegisterFields383}, // DQCCC
  {(RegisterInformation *)&RegisterInfo384, RegisterFields384}, // DQCCC
  {(RegisterInformation *)&RegisterInfo385, RegisterFields385}, // DQCCC
  {(RegisterInformation *)&RegisterInfo386, RegisterFields386}, // DQCCC
  {(RegisterInformation *)&RegisterInfo387, RegisterFields387}, // DQCCC
  {(RegisterInformation *)&RegisterInfo388, RegisterFields388}, // DQCCC
  {(RegisterInformation *)&RegisterInfo389, RegisterFields389}, // DQCCC
  {(RegisterInformation *)&RegisterInfo390, RegisterFields390}, // DQCCC
  {(RegisterInformation *)&RegisterInfo391, RegisterFields391}, // DQCCC
  {(RegisterInformation *)&RegisterInfo392, RegisterFields392}, // DQCCC
  {(RegisterInformation *)&RegisterInfo393, RegisterFields393}, // DQCCC
  {(RegisterInformation *)&RegisterInfo394, RegisterFields394}, // DQCCC
  {(RegisterInformation *)&RegisterInfo395, RegisterFields395}, // DQCCC
  {(RegisterInformation *)&RegisterInfo396, RegisterFields396}, // DQCCC
  {(RegisterInformation *)&RegisterInfo397, RegisterFields397}, // DQCCC
  {(RegisterInformation *)&RegisterInfo398, RegisterFields398}, // DQCCC
  {(RegisterInformation *)&RegisterInfo399, RegisterFields399}, // DQCCC
  {(RegisterInformation *)&RegisterInfo400, RegisterFields400}, // DQCCC
  {(RegisterInformation *)&RegisterInfo401, RegisterFields401}, // DQCCC
  {(RegisterInformation *)&RegisterInfo402, RegisterFields402}, // DQCCC
  {(RegisterInformation *)&RegisterInfo403, RegisterFields403}, // DQCCC
  {(RegisterInformation *)&RegisterInfo404, RegisterFields404}, // DQCCC
  {(RegisterInformation *)&RegisterInfo405, RegisterFields405}, // DQCCC
  {(RegisterInformation *)&RegisterInfo406, RegisterFields406}, // DQCCC
  {(RegisterInformation *)&RegisterInfo407, RegisterFields407}, // DQCCC
  {(RegisterInformation *)&RegisterInfo408, RegisterFields408}, // DQCCC
  {(RegisterInformation *)&RegisterInfo409, RegisterFields409}, // DQCCC
  {(RegisterInformation *)&RegisterInfo410, RegisterFields410}, // DQCCC
  {(RegisterInformation *)&RegisterInfo411, RegisterFields411}, // DQCCC
  {(RegisterInformation *)&RegisterInfo412, RegisterFields412}, // DQCCC
  {(RegisterInformation *)&RegisterInfo413, RegisterFields413}, // DQCCC
  {(RegisterInformation *)&RegisterInfo414, RegisterFields414}, // DQCCC
  {(RegisterInformation *)&RegisterInfo415, RegisterFields415}, // DQCCC
  {(RegisterInformation *)&RegisterInfo416, RegisterFields416}, // DQCCC
  {(RegisterInformation *)&RegisterInfo417, RegisterFields417}, // DQCCC
  {(RegisterInformation *)&RegisterInfo418, RegisterFields418}, // DQCCC
  {(RegisterInformation *)&RegisterInfo419, RegisterFields419}, // DQCCC
  {(RegisterInformation *)&RegisterInfo420, RegisterFields420}, // DQCCC
  {(RegisterInformation *)&RegisterInfo421, RegisterFields421}, // DQCCC
  {(RegisterInformation *)&RegisterInfo422, RegisterFields422}, // DQCCC
  {(RegisterInformation *)&RegisterInfo423, RegisterFields423}, // DQCCC
  {(RegisterInformation *)&RegisterInfo424, RegisterFields424}, // DQCCC
  {(RegisterInformation *)&RegisterInfo425, RegisterFields425}, // DQCCC
  {(RegisterInformation *)&RegisterInfo426, RegisterFields426}, // DQCCC
  {(RegisterInformation *)&RegisterInfo427, RegisterFields427}, // DQCCC
  {(RegisterInformation *)&RegisterInfo428, RegisterFields428}, // DQCCC
  {(RegisterInformation *)&RegisterInfo429, RegisterFields429}, // DQCCC
  {(RegisterInformation *)&RegisterInfo430, RegisterFields430}, // DQCCC
  {(RegisterInformation *)&RegisterInfo431, RegisterFields431}, // DQCCC
  {(RegisterInformation *)&RegisterInfo432, RegisterFields432}, // DQCCC
  {(RegisterInformation *)&RegisterInfo433, RegisterFields433}, // DQCCC
  {(RegisterInformation *)&RegisterInfo434, RegisterFields434}, // DQCCC
  {(RegisterInformation *)&RegisterInfo435, RegisterFields435}, // DQCCC
  {(RegisterInformation *)&RegisterInfo436, RegisterFields436}, // DQCCC
  {(RegisterInformation *)&RegisterInfo437, RegisterFields437}, // DQCCC
  {(RegisterInformation *)&RegisterInfo438, RegisterFields438}, // DQCCC
  {(RegisterInformation *)&RegisterInfo439, RegisterFields439}, // DQCCC
{NULL, NULL},
  {(RegisterInformation *)&RegisterInfo440, RegisterFields440}, // DQ
  {(RegisterInformation *)&RegisterInfo441, RegisterFields441}, // DQ
  {(RegisterInformation *)&RegisterInfo442, RegisterFields442}, // DQ
  {(RegisterInformation *)&RegisterInfo443, RegisterFields443}, // DQ
  {(RegisterInformation *)&RegisterInfo444, RegisterFields444}, // DQ
  {(RegisterInformation *)&RegisterInfo445, RegisterFields445}, // DQ
  {(RegisterInformation *)&RegisterInfo446, RegisterFields446}, // DQ
  {(RegisterInformation *)&RegisterInfo447, RegisterFields447}, // DQ
  {(RegisterInformation *)&RegisterInfo448, RegisterFields448}, // DQ
  {(RegisterInformation *)&RegisterInfo449, RegisterFields449}, // DQ
  {(RegisterInformation *)&RegisterInfo450, RegisterFields450}, // DQ
  {(RegisterInformation *)&RegisterInfo451, RegisterFields451}, // DQ
  {(RegisterInformation *)&RegisterInfo452, RegisterFields452}, // DQ
  {(RegisterInformation *)&RegisterInfo453, RegisterFields453}, // DQ
  {(RegisterInformation *)&RegisterInfo454, RegisterFields454}, // DQ
  {(RegisterInformation *)&RegisterInfo455, RegisterFields455}, // DQ
  {(RegisterInformation *)&RegisterInfo456, RegisterFields456}, // DQ
  {(RegisterInformation *)&RegisterInfo457, RegisterFields457}, // DQ
  {(RegisterInformation *)&RegisterInfo458, RegisterFields458}, // DQ
  {(RegisterInformation *)&RegisterInfo459, RegisterFields459}, // DQ
  {(RegisterInformation *)&RegisterInfo460, RegisterFields460}, // DQ
  {(RegisterInformation *)&RegisterInfo461, RegisterFields461}, // DQ
  {(RegisterInformation *)&RegisterInfo462, RegisterFields462}, // DQ
  {(RegisterInformation *)&RegisterInfo463, RegisterFields463}, // DQ
  {(RegisterInformation *)&RegisterInfo464, RegisterFields464}, // DQ
  {(RegisterInformation *)&RegisterInfo465, RegisterFields465}, // DQ
  {(RegisterInformation *)&RegisterInfo466, RegisterFields466}, // DQ
  {(RegisterInformation *)&RegisterInfo467, RegisterFields467}, // DQ
  {(RegisterInformation *)&RegisterInfo468, RegisterFields468}, // DQ
  {(RegisterInformation *)&RegisterInfo469, RegisterFields469}, // DQ
  {(RegisterInformation *)&RegisterInfo470, RegisterFields470}, // DQ
  {(RegisterInformation *)&RegisterInfo471, RegisterFields471}, // DQ
  {(RegisterInformation *)&RegisterInfo472, RegisterFields472}, // DQ
  {(RegisterInformation *)&RegisterInfo473, RegisterFields473}, // DQ
  {(RegisterInformation *)&RegisterInfo474, RegisterFields474}, // DQ
  {(RegisterInformation *)&RegisterInfo475, RegisterFields475}, // DQ
  {(RegisterInformation *)&RegisterInfo476, RegisterFields476}, // DQ
  {(RegisterInformation *)&RegisterInfo477, RegisterFields477}, // DQ
  {(RegisterInformation *)&RegisterInfo478, RegisterFields478}, // DQ
  {(RegisterInformation *)&RegisterInfo479, RegisterFields479}, // DQ
  {(RegisterInformation *)&RegisterInfo480, RegisterFields480}, // DQ
  {(RegisterInformation *)&RegisterInfo481, RegisterFields481}, // DQ
  {(RegisterInformation *)&RegisterInfo482, RegisterFields482}, // DQ
  {(RegisterInformation *)&RegisterInfo483, RegisterFields483}, // DQ
  {(RegisterInformation *)&RegisterInfo484, RegisterFields484}, // DQ
  {(RegisterInformation *)&RegisterInfo485, RegisterFields485}, // DQ
  {(RegisterInformation *)&RegisterInfo486, RegisterFields486}, // DQ
  {(RegisterInformation *)&RegisterInfo487, RegisterFields487}, // DQ
  {(RegisterInformation *)&RegisterInfo488, RegisterFields488}, // DQ
  {(RegisterInformation *)&RegisterInfo489, RegisterFields489}, // DQ
  {(RegisterInformation *)&RegisterInfo490, RegisterFields490}, // DQ
  {(RegisterInformation *)&RegisterInfo491, RegisterFields491}, // DQ
  {(RegisterInformation *)&RegisterInfo492, RegisterFields492}, // DQ
  {(RegisterInformation *)&RegisterInfo493, RegisterFields493}, // DQ
  {(RegisterInformation *)&RegisterInfo494, RegisterFields494}, // DQ
  {(RegisterInformation *)&RegisterInfo495, RegisterFields495}, // DQ
  {(RegisterInformation *)&RegisterInfo496, RegisterFields496}, // DQ
  {(RegisterInformation *)&RegisterInfo497, RegisterFields497}, // DQ
  {(RegisterInformation *)&RegisterInfo498, RegisterFields498}, // DQ
  {(RegisterInformation *)&RegisterInfo499, RegisterFields499}, // DQ
  {(RegisterInformation *)&RegisterInfo500, RegisterFields500}, // DQ
  {(RegisterInformation *)&RegisterInfo501, RegisterFields501}, // DQ
  {(RegisterInformation *)&RegisterInfo502, RegisterFields502}, // DQ
  {(RegisterInformation *)&RegisterInfo503, RegisterFields503}, // DQ
  {(RegisterInformation *)&RegisterInfo504, RegisterFields504}, // DQ
  {(RegisterInformation *)&RegisterInfo505, RegisterFields505}, // DQ
  {(RegisterInformation *)&RegisterInfo506, RegisterFields506}, // DQ
  {(RegisterInformation *)&RegisterInfo507, RegisterFields507}, // DQ
  {(RegisterInformation *)&RegisterInfo508, RegisterFields508}, // DQ
  {(RegisterInformation *)&RegisterInfo509, RegisterFields509}, // DQ
  {(RegisterInformation *)&RegisterInfo510, RegisterFields510}, // DQ
  {(RegisterInformation *)&RegisterInfo511, RegisterFields511}, // DQ
  {(RegisterInformation *)&RegisterInfo512, RegisterFields512}, // DQ
  {(RegisterInformation *)&RegisterInfo513, RegisterFields513}, // DQ
  {(RegisterInformation *)&RegisterInfo514, RegisterFields514}, // DQ
  {(RegisterInformation *)&RegisterInfo515, RegisterFields515}, // DQ
  {(RegisterInformation *)&RegisterInfo516, RegisterFields516}, // DQ
  {(RegisterInformation *)&RegisterInfo517, RegisterFields517}, // DQ
  {(RegisterInformation *)&RegisterInfo518, RegisterFields518}, // DQ
  {(RegisterInformation *)&RegisterInfo519, RegisterFields519}, // DQ
  {(RegisterInformation *)&RegisterInfo520, RegisterFields520}, // DQ
  {(RegisterInformation *)&RegisterInfo521, RegisterFields521}, // DQ
  {(RegisterInformation *)&RegisterInfo522, RegisterFields522}, // DQ
  {(RegisterInformation *)&RegisterInfo523, RegisterFields523}, // DQ
  {(RegisterInformation *)&RegisterInfo524, RegisterFields524}, // DQ
  {(RegisterInformation *)&RegisterInfo525, RegisterFields525}, // DQ
  {(RegisterInformation *)&RegisterInfo526, RegisterFields526}, // DQ
  {(RegisterInformation *)&RegisterInfo527, RegisterFields527}, // DQ
  {(RegisterInformation *)&RegisterInfo528, RegisterFields528}, // DQ
  {(RegisterInformation *)&RegisterInfo529, RegisterFields529}, // DQ
  {(RegisterInformation *)&RegisterInfo530, RegisterFields530}, // DQ
  {(RegisterInformation *)&RegisterInfo531, RegisterFields531}, // DQ
  {(RegisterInformation *)&RegisterInfo532, RegisterFields532}, // DQ
  {(RegisterInformation *)&RegisterInfo533, RegisterFields533}, // DQ
  {(RegisterInformation *)&RegisterInfo534, RegisterFields534}, // DQ
{NULL, NULL},
  {(RegisterInformation *)&RegisterInfo535, RegisterFields535}, // CCC
  {(RegisterInformation *)&RegisterInfo536, RegisterFields536}, // CCC
  {(RegisterInformation *)&RegisterInfo537, RegisterFields537}, // CCC
  {(RegisterInformation *)&RegisterInfo538, RegisterFields538}, // CCC
  {(RegisterInformation *)&RegisterInfo539, RegisterFields539}, // CCC
  {(RegisterInformation *)&RegisterInfo540, RegisterFields540}, // CCC
  {(RegisterInformation *)&RegisterInfo541, RegisterFields541}, // CCC
  {(RegisterInformation *)&RegisterInfo542, RegisterFields542}, // CCC
  {(RegisterInformation *)&RegisterInfo543, RegisterFields543}, // CCC
  {(RegisterInformation *)&RegisterInfo544, RegisterFields544}, // CCC
  {(RegisterInformation *)&RegisterInfo545, RegisterFields545}, // CCC
  {(RegisterInformation *)&RegisterInfo546, RegisterFields546}, // CCC
  {(RegisterInformation *)&RegisterInfo547, RegisterFields547}, // CCC
  {(RegisterInformation *)&RegisterInfo548, RegisterFields548}, // CCC
  {(RegisterInformation *)&RegisterInfo549, RegisterFields549}, // CCC
  {(RegisterInformation *)&RegisterInfo550, RegisterFields550}, // CCC
  {(RegisterInformation *)&RegisterInfo551, RegisterFields551}, // CCC
  {(RegisterInformation *)&RegisterInfo552, RegisterFields552}, // CCC
  {(RegisterInformation *)&RegisterInfo553, RegisterFields553}, // CCC
  {(RegisterInformation *)&RegisterInfo554, RegisterFields554}, // CCC
  {(RegisterInformation *)&RegisterInfo555, RegisterFields555}, // CCC
  {(RegisterInformation *)&RegisterInfo556, RegisterFields556}, // CCC
  {(RegisterInformation *)&RegisterInfo557, RegisterFields557}, // CCC
  {(RegisterInformation *)&RegisterInfo558, RegisterFields558}, // CCC
  {(RegisterInformation *)&RegisterInfo559, RegisterFields559}, // CCC
  {(RegisterInformation *)&RegisterInfo560, RegisterFields560}, // CCC
  {(RegisterInformation *)&RegisterInfo561, RegisterFields561}, // CCC
  {(RegisterInformation *)&RegisterInfo562, RegisterFields562}, // CCC
  {(RegisterInformation *)&RegisterInfo563, RegisterFields563}, // CCC
  {(RegisterInformation *)&RegisterInfo564, RegisterFields564}, // CCC
  {(RegisterInformation *)&RegisterInfo565, RegisterFields565}, // CCC
  {(RegisterInformation *)&RegisterInfo566, RegisterFields566}, // CCC
  {(RegisterInformation *)&RegisterInfo567, RegisterFields567}, // CCC
  {(RegisterInformation *)&RegisterInfo568, RegisterFields568}, // CCC
  {(RegisterInformation *)&RegisterInfo569, RegisterFields569}, // CCC
  {(RegisterInformation *)&RegisterInfo570, RegisterFields570}, // CCC
  {(RegisterInformation *)&RegisterInfo571, RegisterFields571}, // CCC
  {(RegisterInformation *)&RegisterInfo572, RegisterFields572}, // CCC
  {(RegisterInformation *)&RegisterInfo573, RegisterFields573}, // CCC
  {(RegisterInformation *)&RegisterInfo574, RegisterFields574}, // CCC
  {(RegisterInformation *)&RegisterInfo575, RegisterFields575}, // CCC
  {(RegisterInformation *)&RegisterInfo576, RegisterFields576}, // CCC
  {(RegisterInformation *)&RegisterInfo577, RegisterFields577}, // CCC
  {(RegisterInformation *)&RegisterInfo578, RegisterFields578}, // CCC
  {(RegisterInformation *)&RegisterInfo579, RegisterFields579}, // CCC
  {(RegisterInformation *)&RegisterInfo580, RegisterFields580}, // CCC
  {(RegisterInformation *)&RegisterInfo581, RegisterFields581}, // CCC
  {(RegisterInformation *)&RegisterInfo582, RegisterFields582}, // CCC
  {(RegisterInformation *)&RegisterInfo583, RegisterFields583}, // CCC
  {(RegisterInformation *)&RegisterInfo584, RegisterFields584}, // CCC
  {(RegisterInformation *)&RegisterInfo585, RegisterFields585}, // CCC
  {(RegisterInformation *)&RegisterInfo586, RegisterFields586}, // CCC
  {(RegisterInformation *)&RegisterInfo587, RegisterFields587}, // CCC
  {(RegisterInformation *)&RegisterInfo588, RegisterFields588}, // CCC
  {(RegisterInformation *)&RegisterInfo589, RegisterFields589}, // CCC
  {(RegisterInformation *)&RegisterInfo590, RegisterFields590}, // CCC
  {(RegisterInformation *)&RegisterInfo591, RegisterFields591}, // CCC
  {(RegisterInformation *)&RegisterInfo592, RegisterFields592}, // CCC
  {(RegisterInformation *)&RegisterInfo593, RegisterFields593}, // CCC
  {(RegisterInformation *)&RegisterInfo594, RegisterFields594}, // CCC
  {(RegisterInformation *)&RegisterInfo595, RegisterFields595}, // CCC
  {(RegisterInformation *)&RegisterInfo596, RegisterFields596}, // CCC
  {(RegisterInformation *)&RegisterInfo597, RegisterFields597}, // CCC
  {(RegisterInformation *)&RegisterInfo598, RegisterFields598}, // CCC
  {(RegisterInformation *)&RegisterInfo599, RegisterFields599}, // CCC
  {(RegisterInformation *)&RegisterInfo600, RegisterFields600}, // CCC
  {(RegisterInformation *)&RegisterInfo601, RegisterFields601}, // CCC
  {(RegisterInformation *)&RegisterInfo602, RegisterFields602}, // CCC
  {(RegisterInformation *)&RegisterInfo603, RegisterFields603}, // CCC
  {(RegisterInformation *)&RegisterInfo604, RegisterFields604}, // CCC
  {(RegisterInformation *)&RegisterInfo605, RegisterFields605}, // CCC
  {(RegisterInformation *)&RegisterInfo606, RegisterFields606}, // CCC
  {(RegisterInformation *)&RegisterInfo607, RegisterFields607}, // CCC
  {(RegisterInformation *)&RegisterInfo608, RegisterFields608}, // CCC
  {(RegisterInformation *)&RegisterInfo609, RegisterFields609}, // CCC
  {(RegisterInformation *)&RegisterInfo610, RegisterFields610}, // CCC
  {(RegisterInformation *)&RegisterInfo611, RegisterFields611}, // CCC
  {(RegisterInformation *)&RegisterInfo612, RegisterFields612}, // CCC
  {(RegisterInformation *)&RegisterInfo613, RegisterFields613}, // CCC
  {(RegisterInformation *)&RegisterInfo614, RegisterFields614}, // CCC
  {(RegisterInformation *)&RegisterInfo615, RegisterFields615}, // CCC
  {(RegisterInformation *)&RegisterInfo616, RegisterFields616}, // CCC
  {(RegisterInformation *)&RegisterInfo617, RegisterFields617}, // CCC
  {(RegisterInformation *)&RegisterInfo618, RegisterFields618}, // CCC
  {(RegisterInformation *)&RegisterInfo619, RegisterFields619}, // CCC
  {(RegisterInformation *)&RegisterInfo620, RegisterFields620}, // CCC
  {(RegisterInformation *)&RegisterInfo621, RegisterFields621}, // CCC
  {(RegisterInformation *)&RegisterInfo622, RegisterFields622}, // CCC
  {(RegisterInformation *)&RegisterInfo623, RegisterFields623}, // CCC
  {(RegisterInformation *)&RegisterInfo624, RegisterFields624}, // CCC
  {(RegisterInformation *)&RegisterInfo625, RegisterFields625}, // CCC
  {(RegisterInformation *)&RegisterInfo626, RegisterFields626}, // CCC
  {(RegisterInformation *)&RegisterInfo627, RegisterFields627}, // CCC
  {(RegisterInformation *)&RegisterInfo628, RegisterFields628}, // CCC
  {(RegisterInformation *)&RegisterInfo629, RegisterFields629}, // CCC
  {(RegisterInformation *)&RegisterInfo630, RegisterFields630}, // CCC
  {(RegisterInformation *)&RegisterInfo631, RegisterFields631}, // CCC
  {(RegisterInformation *)&RegisterInfo632, RegisterFields632}, // CCC
{NULL, NULL},
  {(RegisterInformation *)&RegisterInfo633, RegisterFields633}, // DPLVUG
  {(RegisterInformation *)&RegisterInfo634, RegisterFields634}, // DPLVUG
  {(RegisterInformation *)&RegisterInfo635, RegisterFields635}, // DPLVUG
  {(RegisterInformation *)&RegisterInfo636, RegisterFields636}, // DPLVUG
  {(RegisterInformation *)&RegisterInfo637, RegisterFields637}, // DPLVUG
  {(RegisterInformation *)&RegisterInfo638, RegisterFields638}, // DPLVUG
  {(RegisterInformation *)&RegisterInfo639, RegisterFields639}, // DPLVUG
  {(RegisterInformation *)&RegisterInfo640, RegisterFields640}, // DPLVUG
  {(RegisterInformation *)&RegisterInfo641, RegisterFields641}, // DPLVUG
  {(RegisterInformation *)&RegisterInfo642, RegisterFields642}, // DPLVUG
  {(RegisterInformation *)&RegisterInfo643, RegisterFields643}, // DPLVUG
  {(RegisterInformation *)&RegisterInfo644, RegisterFields644}, // DPLVUG
  {(RegisterInformation *)&RegisterInfo645, RegisterFields645}, // DPLVUG
  {(RegisterInformation *)&RegisterInfo646, RegisterFields646}, // DPLVUG
  {(RegisterInformation *)&RegisterInfo647, RegisterFields647}, // DPLVUG
  {(RegisterInformation *)&RegisterInfo648, RegisterFields648}, // DPLVUG
  {(RegisterInformation *)&RegisterInfo649, RegisterFields649}, // DPLVUG
  {(RegisterInformation *)&RegisterInfo650, RegisterFields650}, // DPLVUG
  {(RegisterInformation *)&RegisterInfo651, RegisterFields651}, // DPLVUG
  {(RegisterInformation *)&RegisterInfo652, RegisterFields652}, // DPLVUG
  {(RegisterInformation *)&RegisterInfo653, RegisterFields653}, // DPLVUG
  {(RegisterInformation *)&RegisterInfo654, RegisterFields654}, // DPLVUG
  {(RegisterInformation *)&RegisterInfo655, RegisterFields655}, // DPLVUG
  {(RegisterInformation *)&RegisterInfo656, RegisterFields656}, // DPLVUG
  {(RegisterInformation *)&RegisterInfo657, RegisterFields657}, // DPLVUG
  {(RegisterInformation *)&RegisterInfo658, RegisterFields658}, // DPLVUG
  {(RegisterInformation *)&RegisterInfo659, RegisterFields659}, // DPLVUG
  {(RegisterInformation *)&RegisterInfo660, RegisterFields660}, // DPLVUG
  {(RegisterInformation *)&RegisterInfo661, RegisterFields661}, // DPLVUG
  {(RegisterInformation *)&RegisterInfo662, RegisterFields662}, // DPLVUG
  {(RegisterInformation *)&RegisterInfo663, RegisterFields663}, // DPLVUG
  {(RegisterInformation *)&RegisterInfo664, RegisterFields664}, // DPLVUG
  {(RegisterInformation *)&RegisterInfo665, RegisterFields665}, // DPLVUG
  {(RegisterInformation *)&RegisterInfo666, RegisterFields666}, // DPLVUG
  {(RegisterInformation *)&RegisterInfo667, RegisterFields667}, // DPLVUG
  {(RegisterInformation *)&RegisterInfo668, RegisterFields668}, // DPLVUG
  {(RegisterInformation *)&RegisterInfo669, RegisterFields669}, // DPLVUG
  {(RegisterInformation *)&RegisterInfo670, RegisterFields670}, // DPLVUG
  {(RegisterInformation *)&RegisterInfo671, RegisterFields671}, // DPLVUG
  {(RegisterInformation *)&RegisterInfo672, RegisterFields672}, // DPLVUG
  {(RegisterInformation *)&RegisterInfo673, RegisterFields673}, // DPLVUG
  {(RegisterInformation *)&RegisterInfo674, RegisterFields674}, // DPLVUG
  {(RegisterInformation *)&RegisterInfo675, RegisterFields675}, // DPLVUG
  {(RegisterInformation *)&RegisterInfo676, RegisterFields676}, // DPLVUG
  {(RegisterInformation *)&RegisterInfo677, RegisterFields677}, // DPLVUG
  {(RegisterInformation *)&RegisterInfo678, RegisterFields678}, // DPLVUG
  {(RegisterInformation *)&RegisterInfo679, RegisterFields679}, // DPLVUG
  {(RegisterInformation *)&RegisterInfo680, RegisterFields680}, // DPLVUG
  {(RegisterInformation *)&RegisterInfo681, RegisterFields681}, // DPLVUG
  {(RegisterInformation *)&RegisterInfo682, RegisterFields682}, // DPLVUG
  {(RegisterInformation *)&RegisterInfo683, RegisterFields683}, // DPLVUG
  {(RegisterInformation *)&RegisterInfo684, RegisterFields684}, // DPLVUG
  {(RegisterInformation *)&RegisterInfo685, RegisterFields685}, // DPLVUG
  {(RegisterInformation *)&RegisterInfo686, RegisterFields686}, // DPLVUG
  {(RegisterInformation *)&RegisterInfo687, RegisterFields687}, // DPLVUG
  {(RegisterInformation *)&RegisterInfo688, RegisterFields688}, // DPLVUG
  {(RegisterInformation *)&RegisterInfo689, RegisterFields689}, // DPLVUG
  {(RegisterInformation *)&RegisterInfo690, RegisterFields690}, // DPLVUG
  {(RegisterInformation *)&RegisterInfo691, RegisterFields691}, // DPLVUG
  {(RegisterInformation *)&RegisterInfo692, RegisterFields692}, // DPLVUG
  {(RegisterInformation *)&RegisterInfo693, RegisterFields693}, // DPLVUG
  {(RegisterInformation *)&RegisterInfo694, RegisterFields694}, // DPLVUG
  {(RegisterInformation *)&RegisterInfo695, RegisterFields695}, // DPLVUG
  {(RegisterInformation *)&RegisterInfo696, RegisterFields696}, // DPLVUG
  {(RegisterInformation *)&RegisterInfo697, RegisterFields697}, // DPLVUG
  {(RegisterInformation *)&RegisterInfo698, RegisterFields698}, // DPLVUG
  {(RegisterInformation *)&RegisterInfo699, RegisterFields699}, // DPLVUG
  {(RegisterInformation *)&RegisterInfo700, RegisterFields700}, // DPLVUG
  {(RegisterInformation *)&RegisterInfo701, RegisterFields701}, // DPLVUG
  {(RegisterInformation *)&RegisterInfo702, RegisterFields702}, // DPLVUG
  {(RegisterInformation *)&RegisterInfo703, RegisterFields703}, // DPLVUG
  {(RegisterInformation *)&RegisterInfo704, RegisterFields704}, // DPLVUG
  {(RegisterInformation *)&RegisterInfo705, RegisterFields705}, // DPLVUG
  {(RegisterInformation *)&RegisterInfo706, RegisterFields706}, // DPLVUG
{NULL, NULL},
  {(RegisterInformation *)&RegisterInfo707, RegisterFields707}, // ADPLL
  {(RegisterInformation *)&RegisterInfo708, RegisterFields708}, // ADPLL
  {(RegisterInformation *)&RegisterInfo709, RegisterFields709}, // ADPLL
  {(RegisterInformation *)&RegisterInfo710, RegisterFields710}, // ADPLL
  {(RegisterInformation *)&RegisterInfo711, RegisterFields711}, // ADPLL
  {(RegisterInformation *)&RegisterInfo712, RegisterFields712}, // ADPLL
  {(RegisterInformation *)&RegisterInfo713, RegisterFields713}, // ADPLL
  {(RegisterInformation *)&RegisterInfo714, RegisterFields714}, // ADPLL
  {(RegisterInformation *)&RegisterInfo715, RegisterFields715}, // ADPLL
  {(RegisterInformation *)&RegisterInfo716, RegisterFields716}, // ADPLL
  {(RegisterInformation *)&RegisterInfo717, RegisterFields717}, // ADPLL
  {(RegisterInformation *)&RegisterInfo718, RegisterFields718}, // ADPLL
  {(RegisterInformation *)&RegisterInfo719, RegisterFields719}, // ADPLL
  {(RegisterInformation *)&RegisterInfo720, RegisterFields720}, // ADPLL
{NULL, NULL},
  {(RegisterInformation *)&RegisterInfo721, RegisterFields721}, // LDO
  {(RegisterInformation *)&RegisterInfo722, RegisterFields722}, // LDO
  {(RegisterInformation *)&RegisterInfo723, RegisterFields723}, // LDO
  {(RegisterInformation *)&RegisterInfo724, RegisterFields724}, // LDO
  {(RegisterInformation *)&RegisterInfo725, RegisterFields725}, // LDO
  {(RegisterInformation *)&RegisterInfo726, RegisterFields726}, // LDO
  {(RegisterInformation *)&RegisterInfo727, RegisterFields727}, // LDO
  {(RegisterInformation *)&RegisterInfo728, RegisterFields728}, // LDO
  {(RegisterInformation *)&RegisterInfo729, RegisterFields729}, // LDO
  {(RegisterInformation *)&RegisterInfo730, RegisterFields730}, // LDO
{NULL, NULL},
  {(RegisterInformation *)&RegisterInfo731, RegisterFields731}, // DPIC
  {(RegisterInformation *)&RegisterInfo732, RegisterFields732}, // DPIC
  {(RegisterInformation *)&RegisterInfo733, RegisterFields733}, // DPIC
  {(RegisterInformation *)&RegisterInfo734, RegisterFields734}, // DPIC
  {(RegisterInformation *)&RegisterInfo735, RegisterFields735}, // DPIC
  {(RegisterInformation *)&RegisterInfo736, RegisterFields736}, // DPIC
  {(RegisterInformation *)&RegisterInfo737, RegisterFields737}, // DPIC
  {(RegisterInformation *)&RegisterInfo738, RegisterFields738}, // DPIC
  {(RegisterInformation *)&RegisterInfo739, RegisterFields739}, // DPIC
  {(RegisterInformation *)&RegisterInfo740, RegisterFields740}, // DPIC
  {(RegisterInformation *)&RegisterInfo741, RegisterFields741}, // DPIC
  {(RegisterInformation *)&RegisterInfo742, RegisterFields742}, // DPIC
  {(RegisterInformation *)&RegisterInfo743, RegisterFields743}, // DPIC
  {(RegisterInformation *)&RegisterInfo744, RegisterFields744}, // DPIC
  {(RegisterInformation *)&RegisterInfo745, RegisterFields745}, // DPIC
  {(RegisterInformation *)&RegisterInfo746, RegisterFields746}, // DPIC
  {(RegisterInformation *)&RegisterInfo747, RegisterFields747}, // DPIC
  {(RegisterInformation *)&RegisterInfo748, RegisterFields748}, // DPIC
  {(RegisterInformation *)&RegisterInfo749, RegisterFields749}, // DPIC
  {(RegisterInformation *)&RegisterInfo750, RegisterFields750}, // DPIC
  {(RegisterInformation *)&RegisterInfo751, RegisterFields751}, // DPIC
  {(RegisterInformation *)&RegisterInfo752, RegisterFields752}, // DPIC
  {(RegisterInformation *)&RegisterInfo753, RegisterFields753}, // DPIC
  {(RegisterInformation *)&RegisterInfo754, RegisterFields754}, // DPIC
  {(RegisterInformation *)&RegisterInfo755, RegisterFields755}, // DPIC
  {(RegisterInformation *)&RegisterInfo756, RegisterFields756}, // DPIC
  {(RegisterInformation *)&RegisterInfo757, RegisterFields757}, // DPIC
  {(RegisterInformation *)&RegisterInfo758, RegisterFields758}, // DPIC
  {(RegisterInformation *)&RegisterInfo759, RegisterFields759}, // DPIC
  {(RegisterInformation *)&RegisterInfo760, RegisterFields760}, // DPIC
  {(RegisterInformation *)&RegisterInfo761, RegisterFields761}, // DPIC
  {(RegisterInformation *)&RegisterInfo762, RegisterFields762}, // DPIC
  {(RegisterInformation *)&RegisterInfo763, RegisterFields763}, // DPIC
  {(RegisterInformation *)&RegisterInfo764, RegisterFields764}, // DPIC
  {(RegisterInformation *)&RegisterInfo765, RegisterFields765}, // DPIC
  {(RegisterInformation *)&RegisterInfo766, RegisterFields766}, // DPIC
  {(RegisterInformation *)&RegisterInfo767, RegisterFields767}, // DPIC
  {(RegisterInformation *)&RegisterInfo768, RegisterFields768}, // DPIC
  {(RegisterInformation *)&RegisterInfo769, RegisterFields769}, // DPIC
  {(RegisterInformation *)&RegisterInfo770, RegisterFields770}, // DPIC
{NULL, NULL},
  {(RegisterInformation *)&RegisterInfo771, RegisterFields771}, // WIO2PHY
{NULL, NULL},
  {(RegisterInformation *)&RegisterInfo772, RegisterFields772}, // BUNIT
  {(RegisterInformation *)&RegisterInfo773, RegisterFields773}, // BUNIT
  {(RegisterInformation *)&RegisterInfo774, RegisterFields774}, // BUNIT
  {(RegisterInformation *)&RegisterInfo775, RegisterFields775}, // BUNIT
  {(RegisterInformation *)&RegisterInfo776, RegisterFields776}, // BUNIT
  {(RegisterInformation *)&RegisterInfo777, RegisterFields777}, // BUNIT
  {(RegisterInformation *)&RegisterInfo778, RegisterFields778}, // BUNIT
  {(RegisterInformation *)&RegisterInfo779, RegisterFields779}, // BUNIT
  {(RegisterInformation *)&RegisterInfo780, RegisterFields780}, // BUNIT
  {(RegisterInformation *)&RegisterInfo781, RegisterFields781}, // BUNIT
  {(RegisterInformation *)&RegisterInfo782, RegisterFields782}, // BUNIT
  {(RegisterInformation *)&RegisterInfo783, RegisterFields783}, // BUNIT
  {(RegisterInformation *)&RegisterInfo784, RegisterFields784}, // BUNIT
  {(RegisterInformation *)&RegisterInfo785, RegisterFields785}, // BUNIT
  {(RegisterInformation *)&RegisterInfo786, RegisterFields786}, // BUNIT
  {(RegisterInformation *)&RegisterInfo787, RegisterFields787}, // BUNIT
  {(RegisterInformation *)&RegisterInfo788, RegisterFields788}, // BUNIT
  {(RegisterInformation *)&RegisterInfo789, RegisterFields789}, // BUNIT
  {(RegisterInformation *)&RegisterInfo790, RegisterFields790}, // BUNIT
  {(RegisterInformation *)&RegisterInfo791, RegisterFields791}, // BUNIT
  {(RegisterInformation *)&RegisterInfo792, RegisterFields792}, // BUNIT
  {(RegisterInformation *)&RegisterInfo793, RegisterFields793}, // BUNIT
  {(RegisterInformation *)&RegisterInfo794, RegisterFields794}, // BUNIT
  {(RegisterInformation *)&RegisterInfo795, RegisterFields795}, // BUNIT
  {(RegisterInformation *)&RegisterInfo796, RegisterFields796}, // BUNIT
  {(RegisterInformation *)&RegisterInfo797, RegisterFields797}, // BUNIT
  {(RegisterInformation *)&RegisterInfo798, RegisterFields798}, // BUNIT
  {(RegisterInformation *)&RegisterInfo799, RegisterFields799}, // BUNIT
  {(RegisterInformation *)&RegisterInfo800, RegisterFields800}, // BUNIT
  {(RegisterInformation *)&RegisterInfo801, RegisterFields801}, // BUNIT
  {(RegisterInformation *)&RegisterInfo802, RegisterFields802}, // BUNIT
  {(RegisterInformation *)&RegisterInfo803, RegisterFields803}, // BUNIT
  {(RegisterInformation *)&RegisterInfo804, RegisterFields804}, // BUNIT
  {(RegisterInformation *)&RegisterInfo805, RegisterFields805}, // BUNIT
  {(RegisterInformation *)&RegisterInfo806, RegisterFields806}, // BUNIT
  {(RegisterInformation *)&RegisterInfo807, RegisterFields807}, // BUNIT
  {(RegisterInformation *)&RegisterInfo808, RegisterFields808}, // BUNIT
  {(RegisterInformation *)&RegisterInfo809, RegisterFields809}, // BUNIT
  {(RegisterInformation *)&RegisterInfo810, RegisterFields810}, // BUNIT
  {(RegisterInformation *)&RegisterInfo811, RegisterFields811}, // BUNIT
  {(RegisterInformation *)&RegisterInfo812, RegisterFields812}, // BUNIT
  {(RegisterInformation *)&RegisterInfo813, RegisterFields813}, // BUNIT
  {(RegisterInformation *)&RegisterInfo814, RegisterFields814}, // BUNIT
  {(RegisterInformation *)&RegisterInfo815, RegisterFields815}, // BUNIT
  {(RegisterInformation *)&RegisterInfo816, RegisterFields816}, // BUNIT
  {(RegisterInformation *)&RegisterInfo817, RegisterFields817}, // BUNIT
  {(RegisterInformation *)&RegisterInfo818, RegisterFields818}, // BUNIT
  {(RegisterInformation *)&RegisterInfo819, RegisterFields819}, // BUNIT
  {(RegisterInformation *)&RegisterInfo820, RegisterFields820}, // BUNIT
  {(RegisterInformation *)&RegisterInfo821, RegisterFields821}, // BUNIT
  {(RegisterInformation *)&RegisterInfo822, RegisterFields822}, // BUNIT
  {(RegisterInformation *)&RegisterInfo823, RegisterFields823}, // BUNIT
  {(RegisterInformation *)&RegisterInfo824, RegisterFields824}, // BUNIT
  {(RegisterInformation *)&RegisterInfo825, RegisterFields825}, // BUNIT
  {(RegisterInformation *)&RegisterInfo826, RegisterFields826}, // BUNIT
  {(RegisterInformation *)&RegisterInfo827, RegisterFields827}, // BUNIT
  {(RegisterInformation *)&RegisterInfo828, RegisterFields828}, // BUNIT
  {(RegisterInformation *)&RegisterInfo829, RegisterFields829}, // BUNIT
  {(RegisterInformation *)&RegisterInfo830, RegisterFields830}, // BUNIT
  {(RegisterInformation *)&RegisterInfo831, RegisterFields831}, // BUNIT
  {(RegisterInformation *)&RegisterInfo832, RegisterFields832}, // BUNIT
  {(RegisterInformation *)&RegisterInfo833, RegisterFields833}, // BUNIT
  {(RegisterInformation *)&RegisterInfo834, RegisterFields834}, // BUNIT
  {(RegisterInformation *)&RegisterInfo835, RegisterFields835}, // BUNIT
  {(RegisterInformation *)&RegisterInfo836, RegisterFields836}, // BUNIT
  {(RegisterInformation *)&RegisterInfo837, RegisterFields837}, // BUNIT
  {(RegisterInformation *)&RegisterInfo838, RegisterFields838}, // BUNIT
  {(RegisterInformation *)&RegisterInfo839, RegisterFields839}, // BUNIT
  {(RegisterInformation *)&RegisterInfo840, RegisterFields840}, // BUNIT
  {(RegisterInformation *)&RegisterInfo841, RegisterFields841}, // BUNIT
  {(RegisterInformation *)&RegisterInfo842, RegisterFields842}, // BUNIT
  {(RegisterInformation *)&RegisterInfo843, RegisterFields843}, // BUNIT
  {(RegisterInformation *)&RegisterInfo844, RegisterFields844}, // BUNIT
  {(RegisterInformation *)&RegisterInfo845, RegisterFields845}, // BUNIT
  {(RegisterInformation *)&RegisterInfo846, RegisterFields846}, // BUNIT
  {(RegisterInformation *)&RegisterInfo847, RegisterFields847}, // BUNIT
  {(RegisterInformation *)&RegisterInfo848, RegisterFields848}, // BUNIT
  {(RegisterInformation *)&RegisterInfo849, RegisterFields849}, // BUNIT
  {(RegisterInformation *)&RegisterInfo850, RegisterFields850}, // BUNIT
  {(RegisterInformation *)&RegisterInfo851, RegisterFields851}, // BUNIT
  {(RegisterInformation *)&RegisterInfo852, RegisterFields852}, // BUNIT
  {(RegisterInformation *)&RegisterInfo853, RegisterFields853}, // BUNIT
  {(RegisterInformation *)&RegisterInfo854, RegisterFields854}, // BUNIT
  {(RegisterInformation *)&RegisterInfo855, RegisterFields855}, // BUNIT
  {(RegisterInformation *)&RegisterInfo856, RegisterFields856}, // BUNIT
  {(RegisterInformation *)&RegisterInfo857, RegisterFields857}, // BUNIT
  {(RegisterInformation *)&RegisterInfo858, RegisterFields858}, // BUNIT
  {(RegisterInformation *)&RegisterInfo859, RegisterFields859}, // BUNIT
  {(RegisterInformation *)&RegisterInfo860, RegisterFields860}, // BUNIT
  {(RegisterInformation *)&RegisterInfo861, RegisterFields861}, // BUNIT
  {(RegisterInformation *)&RegisterInfo862, RegisterFields862}, // BUNIT
  {(RegisterInformation *)&RegisterInfo863, RegisterFields863}, // BUNIT
  {(RegisterInformation *)&RegisterInfo864, RegisterFields864}, // BUNIT
  {(RegisterInformation *)&RegisterInfo865, RegisterFields865}, // BUNIT
  {(RegisterInformation *)&RegisterInfo866, RegisterFields866}, // BUNIT
  {(RegisterInformation *)&RegisterInfo867, RegisterFields867}, // BUNIT
  {(RegisterInformation *)&RegisterInfo868, RegisterFields868}, // BUNIT
  {(RegisterInformation *)&RegisterInfo869, RegisterFields869}, // BUNIT
  {(RegisterInformation *)&RegisterInfo870, RegisterFields870}, // BUNIT
  {(RegisterInformation *)&RegisterInfo871, RegisterFields871}, // BUNIT
  {(RegisterInformation *)&RegisterInfo872, RegisterFields872}, // BUNIT
  {(RegisterInformation *)&RegisterInfo873, RegisterFields873}, // BUNIT
  {(RegisterInformation *)&RegisterInfo874, RegisterFields874}, // BUNIT
  {(RegisterInformation *)&RegisterInfo875, RegisterFields875}, // BUNIT
  {(RegisterInformation *)&RegisterInfo876, RegisterFields876}, // BUNIT
  {(RegisterInformation *)&RegisterInfo877, RegisterFields877}, // BUNIT
  {(RegisterInformation *)&RegisterInfo878, RegisterFields878}, // BUNIT
  {(RegisterInformation *)&RegisterInfo879, RegisterFields879}, // BUNIT
  {(RegisterInformation *)&RegisterInfo880, RegisterFields880}, // BUNIT
  {(RegisterInformation *)&RegisterInfo881, RegisterFields881}, // BUNIT
  {(RegisterInformation *)&RegisterInfo882, RegisterFields882}, // BUNIT
  {(RegisterInformation *)&RegisterInfo883, RegisterFields883}, // BUNIT
  {(RegisterInformation *)&RegisterInfo884, RegisterFields884}, // BUNIT
  {(RegisterInformation *)&RegisterInfo885, RegisterFields885}, // BUNIT
  {(RegisterInformation *)&RegisterInfo886, RegisterFields886}, // BUNIT
  {(RegisterInformation *)&RegisterInfo887, RegisterFields887}, // BUNIT
  {(RegisterInformation *)&RegisterInfo888, RegisterFields888}, // BUNIT
  {(RegisterInformation *)&RegisterInfo889, RegisterFields889}, // BUNIT
  {(RegisterInformation *)&RegisterInfo890, RegisterFields890}, // BUNIT
  {(RegisterInformation *)&RegisterInfo891, RegisterFields891}, // BUNIT
  {(RegisterInformation *)&RegisterInfo892, RegisterFields892}, // BUNIT
  {(RegisterInformation *)&RegisterInfo893, RegisterFields893}, // BUNIT
  {(RegisterInformation *)&RegisterInfo894, RegisterFields894}, // BUNIT
  {(RegisterInformation *)&RegisterInfo895, RegisterFields895}, // BUNIT
  {(RegisterInformation *)&RegisterInfo896, RegisterFields896}, // BUNIT
  {(RegisterInformation *)&RegisterInfo897, RegisterFields897}, // BUNIT
  {(RegisterInformation *)&RegisterInfo898, RegisterFields898}, // BUNIT
  {(RegisterInformation *)&RegisterInfo899, RegisterFields899}, // BUNIT
  {(RegisterInformation *)&RegisterInfo900, RegisterFields900}, // BUNIT
  {(RegisterInformation *)&RegisterInfo901, RegisterFields901}, // BUNIT
  {(RegisterInformation *)&RegisterInfo902, RegisterFields902}, // BUNIT
  {(RegisterInformation *)&RegisterInfo903, RegisterFields903}, // BUNIT
  {(RegisterInformation *)&RegisterInfo904, RegisterFields904}, // BUNIT
  {(RegisterInformation *)&RegisterInfo905, RegisterFields905}, // BUNIT
  {(RegisterInformation *)&RegisterInfo906, RegisterFields906}, // BUNIT
  {(RegisterInformation *)&RegisterInfo907, RegisterFields907}, // BUNIT
  {(RegisterInformation *)&RegisterInfo908, RegisterFields908}, // BUNIT
  {(RegisterInformation *)&RegisterInfo909, RegisterFields909}, // BUNIT
  {(RegisterInformation *)&RegisterInfo910, RegisterFields910}, // BUNIT
  {(RegisterInformation *)&RegisterInfo911, RegisterFields911}, // BUNIT
  {(RegisterInformation *)&RegisterInfo912, RegisterFields912}, // BUNIT
  {(RegisterInformation *)&RegisterInfo913, RegisterFields913}, // BUNIT
  {(RegisterInformation *)&RegisterInfo914, RegisterFields914}, // BUNIT
  {(RegisterInformation *)&RegisterInfo915, RegisterFields915}, // BUNIT
  {(RegisterInformation *)&RegisterInfo916, RegisterFields916}, // BUNIT
  {(RegisterInformation *)&RegisterInfo917, RegisterFields917}, // BUNIT
  {(RegisterInformation *)&RegisterInfo918, RegisterFields918}, // BUNIT
  {(RegisterInformation *)&RegisterInfo919, RegisterFields919}, // BUNIT
  {(RegisterInformation *)&RegisterInfo920, RegisterFields920}, // BUNIT
  {(RegisterInformation *)&RegisterInfo921, RegisterFields921}, // BUNIT
  {(RegisterInformation *)&RegisterInfo922, RegisterFields922}, // BUNIT
  {(RegisterInformation *)&RegisterInfo923, RegisterFields923}, // BUNIT
  {(RegisterInformation *)&RegisterInfo924, RegisterFields924}, // BUNIT
  {(RegisterInformation *)&RegisterInfo925, RegisterFields925}, // BUNIT
  {(RegisterInformation *)&RegisterInfo926, RegisterFields926}, // BUNIT
  {(RegisterInformation *)&RegisterInfo927, RegisterFields927}, // BUNIT
  {(RegisterInformation *)&RegisterInfo928, RegisterFields928}, // BUNIT
  {(RegisterInformation *)&RegisterInfo929, RegisterFields929}, // BUNIT
  {(RegisterInformation *)&RegisterInfo930, RegisterFields930}, // BUNIT
  {(RegisterInformation *)&RegisterInfo931, RegisterFields931}, // BUNIT
  {(RegisterInformation *)&RegisterInfo932, RegisterFields932}, // BUNIT
  {(RegisterInformation *)&RegisterInfo933, RegisterFields933}, // BUNIT
  {(RegisterInformation *)&RegisterInfo934, RegisterFields934}, // BUNIT
  {(RegisterInformation *)&RegisterInfo935, RegisterFields935}, // BUNIT
  {(RegisterInformation *)&RegisterInfo936, RegisterFields936}, // BUNIT
  {(RegisterInformation *)&RegisterInfo937, RegisterFields937}, // BUNIT
  {(RegisterInformation *)&RegisterInfo938, RegisterFields938}, // BUNIT
  {(RegisterInformation *)&RegisterInfo939, RegisterFields939}, // BUNIT
  {(RegisterInformation *)&RegisterInfo940, RegisterFields940}, // BUNIT
  {(RegisterInformation *)&RegisterInfo941, RegisterFields941}, // BUNIT
  {(RegisterInformation *)&RegisterInfo942, RegisterFields942}, // BUNIT
  {(RegisterInformation *)&RegisterInfo943, RegisterFields943}, // BUNIT
  {(RegisterInformation *)&RegisterInfo944, RegisterFields944}, // BUNIT
  {(RegisterInformation *)&RegisterInfo945, RegisterFields945}, // BUNIT
  {(RegisterInformation *)&RegisterInfo946, RegisterFields946}, // BUNIT
  {(RegisterInformation *)&RegisterInfo947, RegisterFields947}, // BUNIT
  {(RegisterInformation *)&RegisterInfo948, RegisterFields948}, // BUNIT
  {(RegisterInformation *)&RegisterInfo949, RegisterFields949}, // BUNIT
  {(RegisterInformation *)&RegisterInfo950, RegisterFields950}, // BUNIT
  {(RegisterInformation *)&RegisterInfo951, RegisterFields951}, // BUNIT
  {(RegisterInformation *)&RegisterInfo952, RegisterFields952}, // BUNIT
  {(RegisterInformation *)&RegisterInfo953, RegisterFields953}, // BUNIT
  {(RegisterInformation *)&RegisterInfo954, RegisterFields954}, // BUNIT
  {(RegisterInformation *)&RegisterInfo955, RegisterFields955}, // BUNIT
  {(RegisterInformation *)&RegisterInfo956, RegisterFields956}, // BUNIT
  {(RegisterInformation *)&RegisterInfo957, RegisterFields957}, // BUNIT
  {(RegisterInformation *)&RegisterInfo958, RegisterFields958}, // BUNIT
  {(RegisterInformation *)&RegisterInfo959, RegisterFields959}, // BUNIT
  {(RegisterInformation *)&RegisterInfo960, RegisterFields960}, // BUNIT
  {(RegisterInformation *)&RegisterInfo961, RegisterFields961}, // BUNIT
  {(RegisterInformation *)&RegisterInfo962, RegisterFields962}, // BUNIT
  {(RegisterInformation *)&RegisterInfo963, RegisterFields963}, // BUNIT
  {(RegisterInformation *)&RegisterInfo964, RegisterFields964}, // BUNIT
  {(RegisterInformation *)&RegisterInfo965, RegisterFields965}, // BUNIT
  {(RegisterInformation *)&RegisterInfo966, RegisterFields966}, // BUNIT
  {(RegisterInformation *)&RegisterInfo967, RegisterFields967}, // BUNIT
  {(RegisterInformation *)&RegisterInfo968, RegisterFields968}, // BUNIT
  {(RegisterInformation *)&RegisterInfo969, RegisterFields969}, // BUNIT
  {(RegisterInformation *)&RegisterInfo970, RegisterFields970}, // BUNIT
  {(RegisterInformation *)&RegisterInfo971, RegisterFields971}, // BUNIT
  {(RegisterInformation *)&RegisterInfo972, RegisterFields972}, // BUNIT
  {(RegisterInformation *)&RegisterInfo973, RegisterFields973}, // BUNIT
  {(RegisterInformation *)&RegisterInfo974, RegisterFields974}, // BUNIT
  {(RegisterInformation *)&RegisterInfo975, RegisterFields975}, // BUNIT
  {(RegisterInformation *)&RegisterInfo976, RegisterFields976}, // BUNIT
  {(RegisterInformation *)&RegisterInfo977, RegisterFields977}, // BUNIT
  {(RegisterInformation *)&RegisterInfo978, RegisterFields978}, // BUNIT
  {(RegisterInformation *)&RegisterInfo979, RegisterFields979}, // BUNIT
  {(RegisterInformation *)&RegisterInfo980, RegisterFields980}, // BUNIT
  {(RegisterInformation *)&RegisterInfo981, RegisterFields981}, // BUNIT
  {(RegisterInformation *)&RegisterInfo982, RegisterFields982}, // BUNIT
  {(RegisterInformation *)&RegisterInfo983, RegisterFields983}, // BUNIT
  {(RegisterInformation *)&RegisterInfo984, RegisterFields984}, // BUNIT
  {(RegisterInformation *)&RegisterInfo985, RegisterFields985}, // BUNIT
  {(RegisterInformation *)&RegisterInfo986, RegisterFields986}, // BUNIT
  {(RegisterInformation *)&RegisterInfo987, RegisterFields987}, // BUNIT
  {(RegisterInformation *)&RegisterInfo988, RegisterFields988}, // BUNIT
  {(RegisterInformation *)&RegisterInfo989, RegisterFields989}, // BUNIT
  {(RegisterInformation *)&RegisterInfo990, RegisterFields990}, // BUNIT
  {(RegisterInformation *)&RegisterInfo991, RegisterFields991}, // BUNIT
  {(RegisterInformation *)&RegisterInfo992, RegisterFields992}, // BUNIT
  {(RegisterInformation *)&RegisterInfo993, RegisterFields993}, // BUNIT
  {(RegisterInformation *)&RegisterInfo994, RegisterFields994}, // BUNIT
  {(RegisterInformation *)&RegisterInfo995, RegisterFields995}, // BUNIT
  {(RegisterInformation *)&RegisterInfo996, RegisterFields996}, // BUNIT
  {(RegisterInformation *)&RegisterInfo997, RegisterFields997}, // BUNIT
  {(RegisterInformation *)&RegisterInfo998, RegisterFields998}, // BUNIT
  {(RegisterInformation *)&RegisterInfo999, RegisterFields999}, // BUNIT
  {(RegisterInformation *)&RegisterInfo1000, RegisterFields1000}, // BUNIT
  {(RegisterInformation *)&RegisterInfo1001, RegisterFields1001}, // BUNIT
  {(RegisterInformation *)&RegisterInfo1002, RegisterFields1002}, // BUNIT
  {(RegisterInformation *)&RegisterInfo1003, RegisterFields1003}, // BUNIT
  {(RegisterInformation *)&RegisterInfo1004, RegisterFields1004}, // BUNIT
  {(RegisterInformation *)&RegisterInfo1005, RegisterFields1005}, // BUNIT
  {(RegisterInformation *)&RegisterInfo1006, RegisterFields1006}, // BUNIT
  {(RegisterInformation *)&RegisterInfo1007, RegisterFields1007}, // BUNIT
  {(RegisterInformation *)&RegisterInfo1008, RegisterFields1008}, // BUNIT
  {(RegisterInformation *)&RegisterInfo1009, RegisterFields1009}, // BUNIT
  {(RegisterInformation *)&RegisterInfo1010, RegisterFields1010}, // BUNIT
  {(RegisterInformation *)&RegisterInfo1011, RegisterFields1011}, // BUNIT
  {(RegisterInformation *)&RegisterInfo1012, RegisterFields1012}, // BUNIT
  {(RegisterInformation *)&RegisterInfo1013, RegisterFields1013}, // BUNIT
  {(RegisterInformation *)&RegisterInfo1014, RegisterFields1014}, // BUNIT
  {(RegisterInformation *)&RegisterInfo1015, RegisterFields1015}, // BUNIT
  {(RegisterInformation *)&RegisterInfo1016, RegisterFields1016}, // BUNIT
  {(RegisterInformation *)&RegisterInfo1017, RegisterFields1017}, // BUNIT
  {(RegisterInformation *)&RegisterInfo1018, RegisterFields1018}, // BUNIT
  {(RegisterInformation *)&RegisterInfo1019, RegisterFields1019}, // BUNIT
  {(RegisterInformation *)&RegisterInfo1020, RegisterFields1020}, // BUNIT
  {(RegisterInformation *)&RegisterInfo1021, RegisterFields1021}, // BUNIT
  {(RegisterInformation *)&RegisterInfo1022, RegisterFields1022}, // BUNIT
  {(RegisterInformation *)&RegisterInfo1023, RegisterFields1023}, // BUNIT
  {(RegisterInformation *)&RegisterInfo1024, RegisterFields1024}, // BUNIT
  {(RegisterInformation *)&RegisterInfo1025, RegisterFields1025}, // BUNIT
  {(RegisterInformation *)&RegisterInfo1026, RegisterFields1026}, // BUNIT
  {(RegisterInformation *)&RegisterInfo1027, RegisterFields1027}, // BUNIT
  {(RegisterInformation *)&RegisterInfo1028, RegisterFields1028}, // BUNIT
  {(RegisterInformation *)&RegisterInfo1029, RegisterFields1029}, // BUNIT
  {(RegisterInformation *)&RegisterInfo1030, RegisterFields1030}, // BUNIT
  {(RegisterInformation *)&RegisterInfo1031, RegisterFields1031}, // BUNIT
  {(RegisterInformation *)&RegisterInfo1032, RegisterFields1032}, // BUNIT
  {(RegisterInformation *)&RegisterInfo1033, RegisterFields1033}, // BUNIT
  {(RegisterInformation *)&RegisterInfo1034, RegisterFields1034}, // BUNIT
  {(RegisterInformation *)&RegisterInfo1035, RegisterFields1035}, // BUNIT
  {(RegisterInformation *)&RegisterInfo1036, RegisterFields1036}, // BUNIT
  {(RegisterInformation *)&RegisterInfo1037, RegisterFields1037}, // BUNIT
  {(RegisterInformation *)&RegisterInfo1038, RegisterFields1038}, // BUNIT
  {(RegisterInformation *)&RegisterInfo1039, RegisterFields1039}, // BUNIT
  {(RegisterInformation *)&RegisterInfo1040, RegisterFields1040}, // BUNIT
  {(RegisterInformation *)&RegisterInfo1041, RegisterFields1041}, // BUNIT
  {(RegisterInformation *)&RegisterInfo1042, RegisterFields1042}, // BUNIT
  {(RegisterInformation *)&RegisterInfo1043, RegisterFields1043}, // BUNIT
  {(RegisterInformation *)&RegisterInfo1044, RegisterFields1044}, // BUNIT
  {(RegisterInformation *)&RegisterInfo1045, RegisterFields1045}, // BUNIT
  {(RegisterInformation *)&RegisterInfo1046, RegisterFields1046}, // BUNIT
  {(RegisterInformation *)&RegisterInfo1047, RegisterFields1047}, // BUNIT
  {(RegisterInformation *)&RegisterInfo1048, RegisterFields1048}, // BUNIT
  {(RegisterInformation *)&RegisterInfo1049, RegisterFields1049}, // BUNIT
  {(RegisterInformation *)&RegisterInfo1050, RegisterFields1050}, // BUNIT
  {(RegisterInformation *)&RegisterInfo1051, RegisterFields1051}, // BUNIT
  {(RegisterInformation *)&RegisterInfo1052, RegisterFields1052}, // BUNIT
  {(RegisterInformation *)&RegisterInfo1053, RegisterFields1053}, // BUNIT
  {(RegisterInformation *)&RegisterInfo1054, RegisterFields1054}, // BUNIT
  {(RegisterInformation *)&RegisterInfo1055, RegisterFields1055}, // BUNIT
  {(RegisterInformation *)&RegisterInfo1056, RegisterFields1056}, // BUNIT
  {(RegisterInformation *)&RegisterInfo1057, RegisterFields1057}, // BUNIT
  {(RegisterInformation *)&RegisterInfo1058, RegisterFields1058}, // BUNIT
  {(RegisterInformation *)&RegisterInfo1059, RegisterFields1059}, // BUNIT
{NULL, NULL},
  {(RegisterInformation *)&RegisterInfo1060, RegisterFields1060}, // PUNIT
  {(RegisterInformation *)&RegisterInfo1061, RegisterFields1061}, // PUNIT
  {(RegisterInformation *)&RegisterInfo1062, RegisterFields1062}, // PUNIT
  {(RegisterInformation *)&RegisterInfo1063, RegisterFields1063}, // PUNIT
  {(RegisterInformation *)&RegisterInfo1064, RegisterFields1064}, // PUNIT
  {(RegisterInformation *)&RegisterInfo1065, RegisterFields1065}, // PUNIT
  {(RegisterInformation *)&RegisterInfo1066, RegisterFields1066}, // PUNIT
  {(RegisterInformation *)&RegisterInfo1067, RegisterFields1067}, // PUNIT
  {(RegisterInformation *)&RegisterInfo1068, RegisterFields1068}, // PUNIT
  {(RegisterInformation *)&RegisterInfo1069, RegisterFields1069}, // PUNIT
  {(RegisterInformation *)&RegisterInfo1070, RegisterFields1070}, // PUNIT
  {(RegisterInformation *)&RegisterInfo1071, RegisterFields1071}, // PUNIT
  {(RegisterInformation *)&RegisterInfo1072, RegisterFields1072}, // PUNIT
  {(RegisterInformation *)&RegisterInfo1073, RegisterFields1073}, // PUNIT
  {(RegisterInformation *)&RegisterInfo1074, RegisterFields1074}, // PUNIT
  {(RegisterInformation *)&RegisterInfo1075, RegisterFields1075}, // PUNIT
  {(RegisterInformation *)&RegisterInfo1076, RegisterFields1076}, // PUNIT
  {(RegisterInformation *)&RegisterInfo1077, RegisterFields1077}, // PUNIT
  {(RegisterInformation *)&RegisterInfo1078, RegisterFields1078}, // PUNIT
  {(RegisterInformation *)&RegisterInfo1079, RegisterFields1079}, // PUNIT
  {(RegisterInformation *)&RegisterInfo1080, RegisterFields1080}, // PUNIT
  {(RegisterInformation *)&RegisterInfo1081, RegisterFields1081}, // PUNIT
  {(RegisterInformation *)&RegisterInfo1082, RegisterFields1082}, // PUNIT
  {(RegisterInformation *)&RegisterInfo1083, RegisterFields1083}, // PUNIT
  {(RegisterInformation *)&RegisterInfo1084, RegisterFields1084}, // PUNIT
  {(RegisterInformation *)&RegisterInfo1085, RegisterFields1085}, // PUNIT
  {(RegisterInformation *)&RegisterInfo1086, RegisterFields1086}, // PUNIT
  {(RegisterInformation *)&RegisterInfo1087, RegisterFields1087}, // PUNIT
  {(RegisterInformation *)&RegisterInfo1088, RegisterFields1088}, // PUNIT
  {(RegisterInformation *)&RegisterInfo1089, RegisterFields1089}, // PUNIT
  {(RegisterInformation *)&RegisterInfo1090, RegisterFields1090}, // PUNIT
  {(RegisterInformation *)&RegisterInfo1091, RegisterFields1091}, // PUNIT
  {(RegisterInformation *)&RegisterInfo1092, RegisterFields1092}, // PUNIT
  {(RegisterInformation *)&RegisterInfo1093, RegisterFields1093}, // PUNIT
  {(RegisterInformation *)&RegisterInfo1094, RegisterFields1094}, // PUNIT
  {(RegisterInformation *)&RegisterInfo1095, RegisterFields1095}, // PUNIT
  {(RegisterInformation *)&RegisterInfo1096, RegisterFields1096}, // PUNIT
  {(RegisterInformation *)&RegisterInfo1097, RegisterFields1097}, // PUNIT
  {(RegisterInformation *)&RegisterInfo1098, RegisterFields1098}, // PUNIT
  {(RegisterInformation *)&RegisterInfo1099, RegisterFields1099}, // PUNIT
  {(RegisterInformation *)&RegisterInfo1100, RegisterFields1100}, // PUNIT
  {(RegisterInformation *)&RegisterInfo1101, RegisterFields1101}, // PUNIT
  {(RegisterInformation *)&RegisterInfo1102, RegisterFields1102}, // PUNIT
  {(RegisterInformation *)&RegisterInfo1103, RegisterFields1103}, // PUNIT
  {(RegisterInformation *)&RegisterInfo1104, RegisterFields1104}, // PUNIT
  {(RegisterInformation *)&RegisterInfo1105, RegisterFields1105}, // PUNIT
  {(RegisterInformation *)&RegisterInfo1106, RegisterFields1106}, // PUNIT
  {(RegisterInformation *)&RegisterInfo1107, RegisterFields1107}, // PUNIT
  {(RegisterInformation *)&RegisterInfo1108, RegisterFields1108}, // PUNIT
  {(RegisterInformation *)&RegisterInfo1109, RegisterFields1109}, // PUNIT
  {(RegisterInformation *)&RegisterInfo1110, RegisterFields1110}, // PUNIT
  {(RegisterInformation *)&RegisterInfo1111, RegisterFields1111}, // PUNIT
{NULL, NULL},
  {(RegisterInformation *)&RegisterInfo1112, RegisterFields1112}, // MLMC
  {(RegisterInformation *)&RegisterInfo1113, RegisterFields1113}, // MLMC
  {(RegisterInformation *)&RegisterInfo1114, RegisterFields1114}, // MLMC
  {(RegisterInformation *)&RegisterInfo1115, RegisterFields1115}, // MLMC
  {(RegisterInformation *)&RegisterInfo1116, RegisterFields1116}, // MLMC
  {(RegisterInformation *)&RegisterInfo1117, RegisterFields1117}, // MLMC
  {(RegisterInformation *)&RegisterInfo1118, RegisterFields1118}, // MLMC
  {(RegisterInformation *)&RegisterInfo1119, RegisterFields1119}, // MLMC
  {(RegisterInformation *)&RegisterInfo1120, RegisterFields1120}, // MLMC
  {(RegisterInformation *)&RegisterInfo1121, RegisterFields1121}, // MLMC
  {(RegisterInformation *)&RegisterInfo1122, RegisterFields1122}, // MLMC
  {(RegisterInformation *)&RegisterInfo1123, RegisterFields1123}, // MLMC
  {(RegisterInformation *)&RegisterInfo1124, RegisterFields1124}, // MLMC
  {(RegisterInformation *)&RegisterInfo1125, RegisterFields1125}, // MLMC
  {(RegisterInformation *)&RegisterInfo1126, RegisterFields1126}, // MLMC
  {(RegisterInformation *)&RegisterInfo1127, RegisterFields1127}, // MLMC
  {(RegisterInformation *)&RegisterInfo1128, RegisterFields1128}, // MLMC
{NULL, NULL},
  {(RegisterInformation *)&RegisterInfo1129, RegisterFields1129}, // CUNIT
  {(RegisterInformation *)&RegisterInfo1130, RegisterFields1130}, // CUNIT
  {(RegisterInformation *)&RegisterInfo1131, RegisterFields1131}, // CUNIT
  {(RegisterInformation *)&RegisterInfo1132, RegisterFields1132}, // CUNIT
  {(RegisterInformation *)&RegisterInfo1133, RegisterFields1133}, // CUNIT
  {(RegisterInformation *)&RegisterInfo1134, RegisterFields1134}, // CUNIT
  {(RegisterInformation *)&RegisterInfo1135, RegisterFields1135}, // CUNIT
  {(RegisterInformation *)&RegisterInfo1136, RegisterFields1136}, // CUNIT
  {(RegisterInformation *)&RegisterInfo1137, RegisterFields1137}, // CUNIT
  {(RegisterInformation *)&RegisterInfo1138, RegisterFields1138}, // CUNIT
  {(RegisterInformation *)&RegisterInfo1139, RegisterFields1139}, // CUNIT
  {(RegisterInformation *)&RegisterInfo1140, RegisterFields1140}, // CUNIT
  {(RegisterInformation *)&RegisterInfo1141, RegisterFields1141}, // CUNIT
  {(RegisterInformation *)&RegisterInfo1142, RegisterFields1142}, // CUNIT
  {(RegisterInformation *)&RegisterInfo1143, RegisterFields1143}, // CUNIT
  {(RegisterInformation *)&RegisterInfo1144, RegisterFields1144}, // CUNIT
  {(RegisterInformation *)&RegisterInfo1145, RegisterFields1145}, // CUNIT
  {(RegisterInformation *)&RegisterInfo1146, RegisterFields1146}, // CUNIT
  {(RegisterInformation *)&RegisterInfo1147, RegisterFields1147}, // CUNIT
  {(RegisterInformation *)&RegisterInfo1148, RegisterFields1148}, // CUNIT
  {(RegisterInformation *)&RegisterInfo1149, RegisterFields1149}, // CUNIT
  {(RegisterInformation *)&RegisterInfo1150, RegisterFields1150}, // CUNIT
  {(RegisterInformation *)&RegisterInfo1151, RegisterFields1151}, // CUNIT
  {(RegisterInformation *)&RegisterInfo1152, RegisterFields1152}, // CUNIT
  {(RegisterInformation *)&RegisterInfo1153, RegisterFields1153}, // CUNIT
  {(RegisterInformation *)&RegisterInfo1154, RegisterFields1154}, // CUNIT
  {(RegisterInformation *)&RegisterInfo1155, RegisterFields1155}, // CUNIT
  {(RegisterInformation *)&RegisterInfo1156, RegisterFields1156}, // CUNIT
  {(RegisterInformation *)&RegisterInfo1157, RegisterFields1157}, // CUNIT
  {(RegisterInformation *)&RegisterInfo1158, RegisterFields1158}, // CUNIT
  {(RegisterInformation *)&RegisterInfo1159, RegisterFields1159}, // CUNIT
  {(RegisterInformation *)&RegisterInfo1160, RegisterFields1160}, // CUNIT
  {(RegisterInformation *)&RegisterInfo1161, RegisterFields1161}, // CUNIT
  {(RegisterInformation *)&RegisterInfo1162, RegisterFields1162}, // CUNIT
  {(RegisterInformation *)&RegisterInfo1163, RegisterFields1163}, // CUNIT
  {(RegisterInformation *)&RegisterInfo1164, RegisterFields1164}, // CUNIT
  {(RegisterInformation *)&RegisterInfo1165, RegisterFields1165}, // CUNIT
  {(RegisterInformation *)&RegisterInfo1166, RegisterFields1166}, // CUNIT
  {(RegisterInformation *)&RegisterInfo1167, RegisterFields1167}, // CUNIT
  {(RegisterInformation *)&RegisterInfo1168, RegisterFields1168}, // CUNIT
  {(RegisterInformation *)&RegisterInfo1169, RegisterFields1169}, // CUNIT
  {(RegisterInformation *)&RegisterInfo1170, RegisterFields1170}, // CUNIT
  {(RegisterInformation *)&RegisterInfo1171, RegisterFields1171}, // CUNIT
  {(RegisterInformation *)&RegisterInfo1172, RegisterFields1172}, // CUNIT
  {(RegisterInformation *)&RegisterInfo1173, RegisterFields1173}, // CUNIT
  {(RegisterInformation *)&RegisterInfo1174, RegisterFields1174}, // CUNIT
  {(RegisterInformation *)&RegisterInfo1175, RegisterFields1175}, // CUNIT
  {(RegisterInformation *)&RegisterInfo1176, RegisterFields1176}, // CUNIT
  {(RegisterInformation *)&RegisterInfo1177, RegisterFields1177}, // CUNIT
  {(RegisterInformation *)&RegisterInfo1178, RegisterFields1178}, // CUNIT
  {(RegisterInformation *)&RegisterInfo1179, RegisterFields1179}, // CUNIT
  {(RegisterInformation *)&RegisterInfo1180, RegisterFields1180}, // CUNIT
{NULL, NULL},
  {(RegisterInformation *)&RegisterInfo1181, RegisterFields1181}, // P2SB
  {(RegisterInformation *)&RegisterInfo1182, RegisterFields1182}, // P2SB
  {(RegisterInformation *)&RegisterInfo1183, RegisterFields1183}, // P2SB
  {(RegisterInformation *)&RegisterInfo1184, RegisterFields1184}, // P2SB
  {(RegisterInformation *)&RegisterInfo1185, RegisterFields1185}, // P2SB
  {(RegisterInformation *)&RegisterInfo1186, RegisterFields1186}, // P2SB
  {(RegisterInformation *)&RegisterInfo1187, RegisterFields1187}, // P2SB
  {(RegisterInformation *)&RegisterInfo1188, RegisterFields1188}, // P2SB
  {(RegisterInformation *)&RegisterInfo1189, RegisterFields1189}, // P2SB
  {(RegisterInformation *)&RegisterInfo1190, RegisterFields1190}, // P2SB
  {(RegisterInformation *)&RegisterInfo1191, RegisterFields1191}, // P2SB
  {(RegisterInformation *)&RegisterInfo1192, RegisterFields1192}, // P2SB
  {(RegisterInformation *)&RegisterInfo1193, RegisterFields1193}, // P2SB
  {(RegisterInformation *)&RegisterInfo1194, RegisterFields1194}, // P2SB
  {(RegisterInformation *)&RegisterInfo1195, RegisterFields1195}, // P2SB
  {(RegisterInformation *)&RegisterInfo1196, RegisterFields1196}, // P2SB
  {(RegisterInformation *)&RegisterInfo1197, RegisterFields1197}, // P2SB
  {(RegisterInformation *)&RegisterInfo1198, RegisterFields1198}, // P2SB
  {(RegisterInformation *)&RegisterInfo1199, RegisterFields1199}, // P2SB
  {(RegisterInformation *)&RegisterInfo1200, RegisterFields1200}, // P2SB
  {(RegisterInformation *)&RegisterInfo1201, RegisterFields1201}, // P2SB
  {(RegisterInformation *)&RegisterInfo1202, RegisterFields1202}, // P2SB
  {(RegisterInformation *)&RegisterInfo1203, RegisterFields1203}, // P2SB
  {(RegisterInformation *)&RegisterInfo1204, RegisterFields1204}, // P2SB
  {(RegisterInformation *)&RegisterInfo1205, RegisterFields1205}, // P2SB
  {(RegisterInformation *)&RegisterInfo1206, RegisterFields1206}, // P2SB
  {(RegisterInformation *)&RegisterInfo1207, RegisterFields1207}, // P2SB
  {(RegisterInformation *)&RegisterInfo1208, RegisterFields1208}, // P2SB
  {(RegisterInformation *)&RegisterInfo1209, RegisterFields1209}, // P2SB
  {(RegisterInformation *)&RegisterInfo1210, RegisterFields1210}, // P2SB
  {(RegisterInformation *)&RegisterInfo1211, RegisterFields1211}, // P2SB
  {(RegisterInformation *)&RegisterInfo1212, RegisterFields1212}, // P2SB
  {(RegisterInformation *)&RegisterInfo1213, RegisterFields1213}, // P2SB
  {(RegisterInformation *)&RegisterInfo1214, RegisterFields1214}, // P2SB
  {(RegisterInformation *)&RegisterInfo1215, RegisterFields1215}, // P2SB
  {(RegisterInformation *)&RegisterInfo1216, RegisterFields1216}, // P2SB
  {(RegisterInformation *)&RegisterInfo1217, RegisterFields1217}, // P2SB
  {(RegisterInformation *)&RegisterInfo1218, RegisterFields1218}, // P2SB
  {(RegisterInformation *)&RegisterInfo1219, RegisterFields1219}, // P2SB
  {(RegisterInformation *)&RegisterInfo1220, RegisterFields1220}, // P2SB
  {(RegisterInformation *)&RegisterInfo1221, RegisterFields1221}, // P2SB
  {(RegisterInformation *)&RegisterInfo1222, RegisterFields1222}, // P2SB
  {(RegisterInformation *)&RegisterInfo1223, RegisterFields1223}, // P2SB
  {(RegisterInformation *)&RegisterInfo1224, RegisterFields1224}, // P2SB
  {(RegisterInformation *)&RegisterInfo1225, RegisterFields1225}, // P2SB
  {(RegisterInformation *)&RegisterInfo1226, RegisterFields1226}, // P2SB
  {(RegisterInformation *)&RegisterInfo1227, RegisterFields1227}, // P2SB
  {(RegisterInformation *)&RegisterInfo1228, RegisterFields1228}, // P2SB
{NULL, NULL},
  {(RegisterInformation *)&RegisterInfo1229, RegisterFields1229}, // DDRSAI
  {(RegisterInformation *)&RegisterInfo1230, RegisterFields1230}, // DDRSAI
  {(RegisterInformation *)&RegisterInfo1231, RegisterFields1231}, // DDRSAI
  {(RegisterInformation *)&RegisterInfo1232, RegisterFields1232}, // DDRSAI
  {(RegisterInformation *)&RegisterInfo1233, RegisterFields1233}, // DDRSAI
  {(RegisterInformation *)&RegisterInfo1234, RegisterFields1234}, // DDRSAI
  {(RegisterInformation *)&RegisterInfo1235, RegisterFields1235}, // DDRSAI
  {(RegisterInformation *)&RegisterInfo1236, RegisterFields1236}, // DDRSAI
  {(RegisterInformation *)&RegisterInfo1237, RegisterFields1237}, // DDRSAI
  {(RegisterInformation *)&RegisterInfo1238, RegisterFields1238}, // DDRSAI
  {(RegisterInformation *)&RegisterInfo1239, RegisterFields1239}, // DDRSAI
  {(RegisterInformation *)&RegisterInfo1240, RegisterFields1240}, // DDRSAI
{NULL, NULL},
  {(RegisterInformation *)&RegisterInfo1241, RegisterFields1241}, // SAI
  {(RegisterInformation *)&RegisterInfo1242, RegisterFields1242}, // SAI
  {(RegisterInformation *)&RegisterInfo1243, RegisterFields1243}, // SAI
  {(RegisterInformation *)&RegisterInfo1244, RegisterFields1244}, // SAI
  {(RegisterInformation *)&RegisterInfo1245, RegisterFields1245}, // SAI
  {(RegisterInformation *)&RegisterInfo1246, RegisterFields1246}, // SAI
  {(RegisterInformation *)&RegisterInfo1247, RegisterFields1247}, // SAI
  {(RegisterInformation *)&RegisterInfo1248, RegisterFields1248}, // SAI
  {(RegisterInformation *)&RegisterInfo1249, RegisterFields1249}, // SAI
  {(RegisterInformation *)&RegisterInfo1250, RegisterFields1250}, // SAI
  {(RegisterInformation *)&RegisterInfo1251, RegisterFields1251}, // SAI
  {(RegisterInformation *)&RegisterInfo1252, RegisterFields1252}, // SAI
{NULL, NULL},
  {(RegisterInformation *)&RegisterInfo1253, RegisterFields1253}, // AUNIT
  {(RegisterInformation *)&RegisterInfo1254, RegisterFields1254}, // AUNIT
  {(RegisterInformation *)&RegisterInfo1255, RegisterFields1255}, // AUNIT
  {(RegisterInformation *)&RegisterInfo1256, RegisterFields1256}, // AUNIT
  {(RegisterInformation *)&RegisterInfo1257, RegisterFields1257}, // AUNIT
  {(RegisterInformation *)&RegisterInfo1258, RegisterFields1258}, // AUNIT
  {(RegisterInformation *)&RegisterInfo1259, RegisterFields1259}, // AUNIT
  {(RegisterInformation *)&RegisterInfo1260, RegisterFields1260}, // AUNIT
  {(RegisterInformation *)&RegisterInfo1261, RegisterFields1261}, // AUNIT
  {(RegisterInformation *)&RegisterInfo1262, RegisterFields1262}, // AUNIT
  {(RegisterInformation *)&RegisterInfo1263, RegisterFields1263}, // AUNIT
  {(RegisterInformation *)&RegisterInfo1264, RegisterFields1264}, // AUNIT
  {(RegisterInformation *)&RegisterInfo1265, RegisterFields1265}, // AUNIT
  {(RegisterInformation *)&RegisterInfo1266, RegisterFields1266}, // AUNIT
  {(RegisterInformation *)&RegisterInfo1267, RegisterFields1267}, // AUNIT
  {(RegisterInformation *)&RegisterInfo1268, RegisterFields1268}, // AUNIT
  {(RegisterInformation *)&RegisterInfo1269, RegisterFields1269}, // AUNIT
  {(RegisterInformation *)&RegisterInfo1270, RegisterFields1270}, // AUNIT
  {(RegisterInformation *)&RegisterInfo1271, RegisterFields1271}, // AUNIT
  {(RegisterInformation *)&RegisterInfo1272, RegisterFields1272}, // AUNIT
  {(RegisterInformation *)&RegisterInfo1273, RegisterFields1273}, // AUNIT
  {(RegisterInformation *)&RegisterInfo1274, RegisterFields1274}, // AUNIT
  {(RegisterInformation *)&RegisterInfo1275, RegisterFields1275}, // AUNIT
  {(RegisterInformation *)&RegisterInfo1276, RegisterFields1276}, // AUNIT
  {(RegisterInformation *)&RegisterInfo1277, RegisterFields1277}, // AUNIT
  {(RegisterInformation *)&RegisterInfo1278, RegisterFields1278}, // AUNIT
  {(RegisterInformation *)&RegisterInfo1279, RegisterFields1279}, // AUNIT
  {(RegisterInformation *)&RegisterInfo1280, RegisterFields1280}, // AUNIT
  {(RegisterInformation *)&RegisterInfo1281, RegisterFields1281}, // AUNIT
  {(RegisterInformation *)&RegisterInfo1282, RegisterFields1282}, // AUNIT
  {(RegisterInformation *)&RegisterInfo1283, RegisterFields1283}, // AUNIT
  {(RegisterInformation *)&RegisterInfo1284, RegisterFields1284}, // AUNIT
  {(RegisterInformation *)&RegisterInfo1285, RegisterFields1285}, // AUNIT
  {(RegisterInformation *)&RegisterInfo1286, RegisterFields1286}, // AUNIT
  {(RegisterInformation *)&RegisterInfo1287, RegisterFields1287}, // AUNIT
  {(RegisterInformation *)&RegisterInfo1288, RegisterFields1288}, // AUNIT
  {(RegisterInformation *)&RegisterInfo1289, RegisterFields1289}, // AUNIT
  {(RegisterInformation *)&RegisterInfo1290, RegisterFields1290}, // AUNIT
  {(RegisterInformation *)&RegisterInfo1291, RegisterFields1291}, // AUNIT
  {(RegisterInformation *)&RegisterInfo1292, RegisterFields1292}, // AUNIT
  {(RegisterInformation *)&RegisterInfo1293, RegisterFields1293}, // AUNIT
  {(RegisterInformation *)&RegisterInfo1294, RegisterFields1294}, // AUNIT
  {(RegisterInformation *)&RegisterInfo1295, RegisterFields1295}, // AUNIT
  {(RegisterInformation *)&RegisterInfo1296, RegisterFields1296}, // AUNIT
  {(RegisterInformation *)&RegisterInfo1297, RegisterFields1297}, // AUNIT
  {(RegisterInformation *)&RegisterInfo1298, RegisterFields1298}, // AUNIT
  {(RegisterInformation *)&RegisterInfo1299, RegisterFields1299}, // AUNIT
  {(RegisterInformation *)&RegisterInfo1300, RegisterFields1300}, // AUNIT
  {(RegisterInformation *)&RegisterInfo1301, RegisterFields1301}, // AUNIT
{NULL, NULL},
#else
  {(RegisterInformation *)&RegisterInfo0, NULL}, // DUNIT
  {(RegisterInformation *)&RegisterInfo1, NULL}, // DUNIT
  {(RegisterInformation *)&RegisterInfo2, NULL}, // DUNIT
  {(RegisterInformation *)&RegisterInfo3, NULL}, // DUNIT
  {(RegisterInformation *)&RegisterInfo4, NULL}, // DUNIT
  {(RegisterInformation *)&RegisterInfo5, NULL}, // DUNIT
  {(RegisterInformation *)&RegisterInfo6, NULL}, // DUNIT
  {(RegisterInformation *)&RegisterInfo7, NULL}, // DUNIT
  {(RegisterInformation *)&RegisterInfo8, NULL}, // DUNIT
  {(RegisterInformation *)&RegisterInfo9, NULL}, // DUNIT
  {(RegisterInformation *)&RegisterInfo10, NULL}, // DUNIT
  {(RegisterInformation *)&RegisterInfo11, NULL}, // DUNIT
  {(RegisterInformation *)&RegisterInfo12, NULL}, // DUNIT
  {(RegisterInformation *)&RegisterInfo13, NULL}, // DUNIT
  {(RegisterInformation *)&RegisterInfo14, NULL}, // DUNIT
  {(RegisterInformation *)&RegisterInfo15, NULL}, // DUNIT
  {(RegisterInformation *)&RegisterInfo16, NULL}, // DUNIT
  {(RegisterInformation *)&RegisterInfo17, NULL}, // DUNIT
  {(RegisterInformation *)&RegisterInfo18, NULL}, // DUNIT
  {(RegisterInformation *)&RegisterInfo19, NULL}, // DUNIT
  {(RegisterInformation *)&RegisterInfo20, NULL}, // DUNIT
  {(RegisterInformation *)&RegisterInfo21, NULL}, // DUNIT
  {(RegisterInformation *)&RegisterInfo22, NULL}, // DUNIT
  {(RegisterInformation *)&RegisterInfo23, NULL}, // DUNIT
  {(RegisterInformation *)&RegisterInfo24, NULL}, // DUNIT
  {(RegisterInformation *)&RegisterInfo25, NULL}, // DUNIT
  {(RegisterInformation *)&RegisterInfo26, NULL}, // DUNIT
  {(RegisterInformation *)&RegisterInfo27, NULL}, // DUNIT
  {(RegisterInformation *)&RegisterInfo28, NULL}, // DUNIT
  {(RegisterInformation *)&RegisterInfo29, NULL}, // DUNIT
  {(RegisterInformation *)&RegisterInfo30, NULL}, // DUNIT
  {(RegisterInformation *)&RegisterInfo31, NULL}, // DUNIT
  {(RegisterInformation *)&RegisterInfo32, NULL}, // DUNIT
  {(RegisterInformation *)&RegisterInfo33, NULL}, // DUNIT
  {(RegisterInformation *)&RegisterInfo34, NULL}, // DUNIT
  {(RegisterInformation *)&RegisterInfo35, NULL}, // DUNIT
  {(RegisterInformation *)&RegisterInfo36, NULL}, // DUNIT
  {(RegisterInformation *)&RegisterInfo37, NULL}, // DUNIT
  {(RegisterInformation *)&RegisterInfo38, NULL}, // DUNIT
  {(RegisterInformation *)&RegisterInfo39, NULL}, // DUNIT
  {(RegisterInformation *)&RegisterInfo40, NULL}, // DUNIT
  {(RegisterInformation *)&RegisterInfo41, NULL}, // DUNIT
  {(RegisterInformation *)&RegisterInfo42, NULL}, // DUNIT
  {(RegisterInformation *)&RegisterInfo43, NULL}, // DUNIT
  {(RegisterInformation *)&RegisterInfo44, NULL}, // DUNIT
  {(RegisterInformation *)&RegisterInfo45, NULL}, // DUNIT
  {(RegisterInformation *)&RegisterInfo46, NULL}, // DUNIT
  {(RegisterInformation *)&RegisterInfo47, NULL}, // DUNIT
  {(RegisterInformation *)&RegisterInfo48, NULL}, // DUNIT
  {(RegisterInformation *)&RegisterInfo49, NULL}, // DUNIT
  {(RegisterInformation *)&RegisterInfo50, NULL}, // DUNIT
  {(RegisterInformation *)&RegisterInfo51, NULL}, // DUNIT
  {(RegisterInformation *)&RegisterInfo52, NULL}, // DUNIT
  {(RegisterInformation *)&RegisterInfo53, NULL}, // DUNIT
  {(RegisterInformation *)&RegisterInfo54, NULL}, // DUNIT
  {(RegisterInformation *)&RegisterInfo55, NULL}, // DUNIT
  {(RegisterInformation *)&RegisterInfo56, NULL}, // DUNIT
  {(RegisterInformation *)&RegisterInfo57, NULL}, // DUNIT
  {(RegisterInformation *)&RegisterInfo58, NULL}, // DUNIT
  {(RegisterInformation *)&RegisterInfo59, NULL}, // DUNIT
  {(RegisterInformation *)&RegisterInfo60, NULL}, // DUNIT
  {(RegisterInformation *)&RegisterInfo61, NULL}, // DUNIT
  {(RegisterInformation *)&RegisterInfo62, NULL}, // DUNIT
{NULL, NULL},
  {(RegisterInformation *)&RegisterInfo63, NULL}, // CPGC
  {(RegisterInformation *)&RegisterInfo64, NULL}, // CPGC
  {(RegisterInformation *)&RegisterInfo65, NULL}, // CPGC
  {(RegisterInformation *)&RegisterInfo66, NULL}, // CPGC
  {(RegisterInformation *)&RegisterInfo67, NULL}, // CPGC
  {(RegisterInformation *)&RegisterInfo68, NULL}, // CPGC
  {(RegisterInformation *)&RegisterInfo69, NULL}, // CPGC
  {(RegisterInformation *)&RegisterInfo70, NULL}, // CPGC
  {(RegisterInformation *)&RegisterInfo71, NULL}, // CPGC
  {(RegisterInformation *)&RegisterInfo72, NULL}, // CPGC
  {(RegisterInformation *)&RegisterInfo73, NULL}, // CPGC
  {(RegisterInformation *)&RegisterInfo74, NULL}, // CPGC
  {(RegisterInformation *)&RegisterInfo75, NULL}, // CPGC
  {(RegisterInformation *)&RegisterInfo76, NULL}, // CPGC
  {(RegisterInformation *)&RegisterInfo77, NULL}, // CPGC
  {(RegisterInformation *)&RegisterInfo78, NULL}, // CPGC
  {(RegisterInformation *)&RegisterInfo79, NULL}, // CPGC
  {(RegisterInformation *)&RegisterInfo80, NULL}, // CPGC
  {(RegisterInformation *)&RegisterInfo81, NULL}, // CPGC
  {(RegisterInformation *)&RegisterInfo82, NULL}, // CPGC
  {(RegisterInformation *)&RegisterInfo83, NULL}, // CPGC
  {(RegisterInformation *)&RegisterInfo84, NULL}, // CPGC
  {(RegisterInformation *)&RegisterInfo85, NULL}, // CPGC
  {(RegisterInformation *)&RegisterInfo86, NULL}, // CPGC
  {(RegisterInformation *)&RegisterInfo87, NULL}, // CPGC
  {(RegisterInformation *)&RegisterInfo88, NULL}, // CPGC
  {(RegisterInformation *)&RegisterInfo89, NULL}, // CPGC
  {(RegisterInformation *)&RegisterInfo90, NULL}, // CPGC
  {(RegisterInformation *)&RegisterInfo91, NULL}, // CPGC
  {(RegisterInformation *)&RegisterInfo92, NULL}, // CPGC
  {(RegisterInformation *)&RegisterInfo93, NULL}, // CPGC
  {(RegisterInformation *)&RegisterInfo94, NULL}, // CPGC
  {(RegisterInformation *)&RegisterInfo95, NULL}, // CPGC
  {(RegisterInformation *)&RegisterInfo96, NULL}, // CPGC
  {(RegisterInformation *)&RegisterInfo97, NULL}, // CPGC
  {(RegisterInformation *)&RegisterInfo98, NULL}, // CPGC
  {(RegisterInformation *)&RegisterInfo99, NULL}, // CPGC
  {(RegisterInformation *)&RegisterInfo100, NULL}, // CPGC
  {(RegisterInformation *)&RegisterInfo101, NULL}, // CPGC
  {(RegisterInformation *)&RegisterInfo102, NULL}, // CPGC
  {(RegisterInformation *)&RegisterInfo103, NULL}, // CPGC
  {(RegisterInformation *)&RegisterInfo104, NULL}, // CPGC
  {(RegisterInformation *)&RegisterInfo105, NULL}, // CPGC
  {(RegisterInformation *)&RegisterInfo106, NULL}, // CPGC
  {(RegisterInformation *)&RegisterInfo107, NULL}, // CPGC
  {(RegisterInformation *)&RegisterInfo108, NULL}, // CPGC
  {(RegisterInformation *)&RegisterInfo109, NULL}, // CPGC
  {(RegisterInformation *)&RegisterInfo110, NULL}, // CPGC
  {(RegisterInformation *)&RegisterInfo111, NULL}, // CPGC
  {(RegisterInformation *)&RegisterInfo112, NULL}, // CPGC
  {(RegisterInformation *)&RegisterInfo113, NULL}, // CPGC
  {(RegisterInformation *)&RegisterInfo114, NULL}, // CPGC
  {(RegisterInformation *)&RegisterInfo115, NULL}, // CPGC
  {(RegisterInformation *)&RegisterInfo116, NULL}, // CPGC
  {(RegisterInformation *)&RegisterInfo117, NULL}, // CPGC
  {(RegisterInformation *)&RegisterInfo118, NULL}, // CPGC
  {(RegisterInformation *)&RegisterInfo119, NULL}, // CPGC
  {(RegisterInformation *)&RegisterInfo120, NULL}, // CPGC
  {(RegisterInformation *)&RegisterInfo121, NULL}, // CPGC
  {(RegisterInformation *)&RegisterInfo122, NULL}, // CPGC
  {(RegisterInformation *)&RegisterInfo123, NULL}, // CPGC
  {(RegisterInformation *)&RegisterInfo124, NULL}, // CPGC
  {(RegisterInformation *)&RegisterInfo125, NULL}, // CPGC
  {(RegisterInformation *)&RegisterInfo126, NULL}, // CPGC
  {(RegisterInformation *)&RegisterInfo127, NULL}, // CPGC
  {(RegisterInformation *)&RegisterInfo128, NULL}, // CPGC
  {(RegisterInformation *)&RegisterInfo129, NULL}, // CPGC
  {(RegisterInformation *)&RegisterInfo130, NULL}, // CPGC
  {(RegisterInformation *)&RegisterInfo131, NULL}, // CPGC
  {(RegisterInformation *)&RegisterInfo132, NULL}, // CPGC
  {(RegisterInformation *)&RegisterInfo133, NULL}, // CPGC
  {(RegisterInformation *)&RegisterInfo134, NULL}, // CPGC
  {(RegisterInformation *)&RegisterInfo135, NULL}, // CPGC
  {(RegisterInformation *)&RegisterInfo136, NULL}, // CPGC
  {(RegisterInformation *)&RegisterInfo137, NULL}, // CPGC
  {(RegisterInformation *)&RegisterInfo138, NULL}, // CPGC
  {(RegisterInformation *)&RegisterInfo139, NULL}, // CPGC
  {(RegisterInformation *)&RegisterInfo140, NULL}, // CPGC
  {(RegisterInformation *)&RegisterInfo141, NULL}, // CPGC
  {(RegisterInformation *)&RegisterInfo142, NULL}, // CPGC
  {(RegisterInformation *)&RegisterInfo143, NULL}, // CPGC
  {(RegisterInformation *)&RegisterInfo144, NULL}, // CPGC
  {(RegisterInformation *)&RegisterInfo145, NULL}, // CPGC
  {(RegisterInformation *)&RegisterInfo146, NULL}, // CPGC
  {(RegisterInformation *)&RegisterInfo147, NULL}, // CPGC
  {(RegisterInformation *)&RegisterInfo148, NULL}, // CPGC
  {(RegisterInformation *)&RegisterInfo149, NULL}, // CPGC
  {(RegisterInformation *)&RegisterInfo150, NULL}, // CPGC
  {(RegisterInformation *)&RegisterInfo151, NULL}, // CPGC
  {(RegisterInformation *)&RegisterInfo152, NULL}, // CPGC
  {(RegisterInformation *)&RegisterInfo153, NULL}, // CPGC
  {(RegisterInformation *)&RegisterInfo154, NULL}, // CPGC
  {(RegisterInformation *)&RegisterInfo155, NULL}, // CPGC
  {(RegisterInformation *)&RegisterInfo156, NULL}, // CPGC
  {(RegisterInformation *)&RegisterInfo157, NULL}, // CPGC
  {(RegisterInformation *)&RegisterInfo158, NULL}, // CPGC
  {(RegisterInformation *)&RegisterInfo159, NULL}, // CPGC
  {(RegisterInformation *)&RegisterInfo160, NULL}, // CPGC
  {(RegisterInformation *)&RegisterInfo161, NULL}, // CPGC
  {(RegisterInformation *)&RegisterInfo162, NULL}, // CPGC
  {(RegisterInformation *)&RegisterInfo163, NULL}, // CPGC
  {(RegisterInformation *)&RegisterInfo164, NULL}, // CPGC
  {(RegisterInformation *)&RegisterInfo165, NULL}, // CPGC
  {(RegisterInformation *)&RegisterInfo166, NULL}, // CPGC
  {(RegisterInformation *)&RegisterInfo167, NULL}, // CPGC
  {(RegisterInformation *)&RegisterInfo168, NULL}, // CPGC
  {(RegisterInformation *)&RegisterInfo169, NULL}, // CPGC
  {(RegisterInformation *)&RegisterInfo170, NULL}, // CPGC
  {(RegisterInformation *)&RegisterInfo171, NULL}, // CPGC
  {(RegisterInformation *)&RegisterInfo172, NULL}, // CPGC
  {(RegisterInformation *)&RegisterInfo173, NULL}, // CPGC
  {(RegisterInformation *)&RegisterInfo174, NULL}, // CPGC
  {(RegisterInformation *)&RegisterInfo175, NULL}, // CPGC
  {(RegisterInformation *)&RegisterInfo176, NULL}, // CPGC
  {(RegisterInformation *)&RegisterInfo177, NULL}, // CPGC
  {(RegisterInformation *)&RegisterInfo178, NULL}, // CPGC
  {(RegisterInformation *)&RegisterInfo179, NULL}, // CPGC
  {(RegisterInformation *)&RegisterInfo180, NULL}, // CPGC
  {(RegisterInformation *)&RegisterInfo181, NULL}, // CPGC
  {(RegisterInformation *)&RegisterInfo182, NULL}, // CPGC
  {(RegisterInformation *)&RegisterInfo183, NULL}, // CPGC
  {(RegisterInformation *)&RegisterInfo184, NULL}, // CPGC
  {(RegisterInformation *)&RegisterInfo185, NULL}, // CPGC
  {(RegisterInformation *)&RegisterInfo186, NULL}, // CPGC
  {(RegisterInformation *)&RegisterInfo187, NULL}, // CPGC
  {(RegisterInformation *)&RegisterInfo188, NULL}, // CPGC
  {(RegisterInformation *)&RegisterInfo189, NULL}, // CPGC
  {(RegisterInformation *)&RegisterInfo190, NULL}, // CPGC
  {(RegisterInformation *)&RegisterInfo191, NULL}, // CPGC
  {(RegisterInformation *)&RegisterInfo192, NULL}, // CPGC
  {(RegisterInformation *)&RegisterInfo193, NULL}, // CPGC
  {(RegisterInformation *)&RegisterInfo194, NULL}, // CPGC
  {(RegisterInformation *)&RegisterInfo195, NULL}, // CPGC
  {(RegisterInformation *)&RegisterInfo196, NULL}, // CPGC
  {(RegisterInformation *)&RegisterInfo197, NULL}, // CPGC
  {(RegisterInformation *)&RegisterInfo198, NULL}, // CPGC
  {(RegisterInformation *)&RegisterInfo199, NULL}, // CPGC
  {(RegisterInformation *)&RegisterInfo200, NULL}, // CPGC
  {(RegisterInformation *)&RegisterInfo201, NULL}, // CPGC
  {(RegisterInformation *)&RegisterInfo202, NULL}, // CPGC
  {(RegisterInformation *)&RegisterInfo203, NULL}, // CPGC
  {(RegisterInformation *)&RegisterInfo204, NULL}, // CPGC
  {(RegisterInformation *)&RegisterInfo205, NULL}, // CPGC
  {(RegisterInformation *)&RegisterInfo206, NULL}, // CPGC
  {(RegisterInformation *)&RegisterInfo207, NULL}, // CPGC
  {(RegisterInformation *)&RegisterInfo208, NULL}, // CPGC
  {(RegisterInformation *)&RegisterInfo209, NULL}, // CPGC
  {(RegisterInformation *)&RegisterInfo210, NULL}, // CPGC
  {(RegisterInformation *)&RegisterInfo211, NULL}, // CPGC
  {(RegisterInformation *)&RegisterInfo212, NULL}, // CPGC
  {(RegisterInformation *)&RegisterInfo213, NULL}, // CPGC
  {(RegisterInformation *)&RegisterInfo214, NULL}, // CPGC
  {(RegisterInformation *)&RegisterInfo215, NULL}, // CPGC
  {(RegisterInformation *)&RegisterInfo216, NULL}, // CPGC
  {(RegisterInformation *)&RegisterInfo217, NULL}, // CPGC
  {(RegisterInformation *)&RegisterInfo218, NULL}, // CPGC
  {(RegisterInformation *)&RegisterInfo219, NULL}, // CPGC
  {(RegisterInformation *)&RegisterInfo220, NULL}, // CPGC
  {(RegisterInformation *)&RegisterInfo221, NULL}, // CPGC
  {(RegisterInformation *)&RegisterInfo222, NULL}, // CPGC
  {(RegisterInformation *)&RegisterInfo223, NULL}, // CPGC
  {(RegisterInformation *)&RegisterInfo224, NULL}, // CPGC
  {(RegisterInformation *)&RegisterInfo225, NULL}, // CPGC
  {(RegisterInformation *)&RegisterInfo226, NULL}, // CPGC
  {(RegisterInformation *)&RegisterInfo227, NULL}, // CPGC
  {(RegisterInformation *)&RegisterInfo228, NULL}, // CPGC
  {(RegisterInformation *)&RegisterInfo229, NULL}, // CPGC
  {(RegisterInformation *)&RegisterInfo230, NULL}, // CPGC
  {(RegisterInformation *)&RegisterInfo231, NULL}, // CPGC
  {(RegisterInformation *)&RegisterInfo232, NULL}, // CPGC
  {(RegisterInformation *)&RegisterInfo233, NULL}, // CPGC
  {(RegisterInformation *)&RegisterInfo234, NULL}, // CPGC
  {(RegisterInformation *)&RegisterInfo235, NULL}, // CPGC
  {(RegisterInformation *)&RegisterInfo236, NULL}, // CPGC
  {(RegisterInformation *)&RegisterInfo237, NULL}, // CPGC
  {(RegisterInformation *)&RegisterInfo238, NULL}, // CPGC
  {(RegisterInformation *)&RegisterInfo239, NULL}, // CPGC
  {(RegisterInformation *)&RegisterInfo240, NULL}, // CPGC
  {(RegisterInformation *)&RegisterInfo241, NULL}, // CPGC
  {(RegisterInformation *)&RegisterInfo242, NULL}, // CPGC
  {(RegisterInformation *)&RegisterInfo243, NULL}, // CPGC
  {(RegisterInformation *)&RegisterInfo244, NULL}, // CPGC
  {(RegisterInformation *)&RegisterInfo245, NULL}, // CPGC
  {(RegisterInformation *)&RegisterInfo246, NULL}, // CPGC
  {(RegisterInformation *)&RegisterInfo247, NULL}, // CPGC
  {(RegisterInformation *)&RegisterInfo248, NULL}, // CPGC
  {(RegisterInformation *)&RegisterInfo249, NULL}, // CPGC
  {(RegisterInformation *)&RegisterInfo250, NULL}, // CPGC
  {(RegisterInformation *)&RegisterInfo251, NULL}, // CPGC
  {(RegisterInformation *)&RegisterInfo252, NULL}, // CPGC
  {(RegisterInformation *)&RegisterInfo253, NULL}, // CPGC
  {(RegisterInformation *)&RegisterInfo254, NULL}, // CPGC
  {(RegisterInformation *)&RegisterInfo255, NULL}, // CPGC
  {(RegisterInformation *)&RegisterInfo256, NULL}, // CPGC
  {(RegisterInformation *)&RegisterInfo257, NULL}, // CPGC
  {(RegisterInformation *)&RegisterInfo258, NULL}, // CPGC
  {(RegisterInformation *)&RegisterInfo259, NULL}, // CPGC
  {(RegisterInformation *)&RegisterInfo260, NULL}, // CPGC
  {(RegisterInformation *)&RegisterInfo261, NULL}, // CPGC
  {(RegisterInformation *)&RegisterInfo262, NULL}, // CPGC
  {(RegisterInformation *)&RegisterInfo263, NULL}, // CPGC
  {(RegisterInformation *)&RegisterInfo264, NULL}, // CPGC
  {(RegisterInformation *)&RegisterInfo265, NULL}, // CPGC
  {(RegisterInformation *)&RegisterInfo266, NULL}, // CPGC
  {(RegisterInformation *)&RegisterInfo267, NULL}, // CPGC
  {(RegisterInformation *)&RegisterInfo268, NULL}, // CPGC
  {(RegisterInformation *)&RegisterInfo269, NULL}, // CPGC
  {(RegisterInformation *)&RegisterInfo270, NULL}, // CPGC
  {(RegisterInformation *)&RegisterInfo271, NULL}, // CPGC
  {(RegisterInformation *)&RegisterInfo272, NULL}, // CPGC
  {(RegisterInformation *)&RegisterInfo273, NULL}, // CPGC
  {(RegisterInformation *)&RegisterInfo274, NULL}, // CPGC
  {(RegisterInformation *)&RegisterInfo275, NULL}, // CPGC
  {(RegisterInformation *)&RegisterInfo276, NULL}, // CPGC
  {(RegisterInformation *)&RegisterInfo277, NULL}, // CPGC
  {(RegisterInformation *)&RegisterInfo278, NULL}, // CPGC
  {(RegisterInformation *)&RegisterInfo279, NULL}, // CPGC
  {(RegisterInformation *)&RegisterInfo280, NULL}, // CPGC
  {(RegisterInformation *)&RegisterInfo281, NULL}, // CPGC
  {(RegisterInformation *)&RegisterInfo282, NULL}, // CPGC
  {(RegisterInformation *)&RegisterInfo283, NULL}, // CPGC
  {(RegisterInformation *)&RegisterInfo284, NULL}, // CPGC
  {(RegisterInformation *)&RegisterInfo285, NULL}, // CPGC
  {(RegisterInformation *)&RegisterInfo286, NULL}, // CPGC
  {(RegisterInformation *)&RegisterInfo287, NULL}, // CPGC
  {(RegisterInformation *)&RegisterInfo288, NULL}, // CPGC
  {(RegisterInformation *)&RegisterInfo289, NULL}, // CPGC
  {(RegisterInformation *)&RegisterInfo290, NULL}, // CPGC
  {(RegisterInformation *)&RegisterInfo291, NULL}, // CPGC
  {(RegisterInformation *)&RegisterInfo292, NULL}, // CPGC
  {(RegisterInformation *)&RegisterInfo293, NULL}, // CPGC
  {(RegisterInformation *)&RegisterInfo294, NULL}, // CPGC
  {(RegisterInformation *)&RegisterInfo295, NULL}, // CPGC
  {(RegisterInformation *)&RegisterInfo296, NULL}, // CPGC
  {(RegisterInformation *)&RegisterInfo297, NULL}, // CPGC
  {(RegisterInformation *)&RegisterInfo298, NULL}, // CPGC
  {(RegisterInformation *)&RegisterInfo299, NULL}, // CPGC
  {(RegisterInformation *)&RegisterInfo300, NULL}, // CPGC
  {(RegisterInformation *)&RegisterInfo301, NULL}, // CPGC
  {(RegisterInformation *)&RegisterInfo302, NULL}, // CPGC
  {(RegisterInformation *)&RegisterInfo303, NULL}, // CPGC
  {(RegisterInformation *)&RegisterInfo304, NULL}, // CPGC
  {(RegisterInformation *)&RegisterInfo305, NULL}, // CPGC
  {(RegisterInformation *)&RegisterInfo306, NULL}, // CPGC
  {(RegisterInformation *)&RegisterInfo307, NULL}, // CPGC
  {(RegisterInformation *)&RegisterInfo308, NULL}, // CPGC
  {(RegisterInformation *)&RegisterInfo309, NULL}, // CPGC
  {(RegisterInformation *)&RegisterInfo310, NULL}, // CPGC
  {(RegisterInformation *)&RegisterInfo311, NULL}, // CPGC
  {(RegisterInformation *)&RegisterInfo312, NULL}, // CPGC
  {(RegisterInformation *)&RegisterInfo313, NULL}, // CPGC
  {(RegisterInformation *)&RegisterInfo314, NULL}, // CPGC
  {(RegisterInformation *)&RegisterInfo315, NULL}, // CPGC
  {(RegisterInformation *)&RegisterInfo316, NULL}, // CPGC
  {(RegisterInformation *)&RegisterInfo317, NULL}, // CPGC
  {(RegisterInformation *)&RegisterInfo318, NULL}, // CPGC
  {(RegisterInformation *)&RegisterInfo319, NULL}, // CPGC
  {(RegisterInformation *)&RegisterInfo320, NULL}, // CPGC
  {(RegisterInformation *)&RegisterInfo321, NULL}, // CPGC
  {(RegisterInformation *)&RegisterInfo322, NULL}, // CPGC
  {(RegisterInformation *)&RegisterInfo323, NULL}, // CPGC
  {(RegisterInformation *)&RegisterInfo324, NULL}, // CPGC
  {(RegisterInformation *)&RegisterInfo325, NULL}, // CPGC
  {(RegisterInformation *)&RegisterInfo326, NULL}, // CPGC
  {(RegisterInformation *)&RegisterInfo327, NULL}, // CPGC
  {(RegisterInformation *)&RegisterInfo328, NULL}, // CPGC
  {(RegisterInformation *)&RegisterInfo329, NULL}, // CPGC
  {(RegisterInformation *)&RegisterInfo330, NULL}, // CPGC
  {(RegisterInformation *)&RegisterInfo331, NULL}, // CPGC
  {(RegisterInformation *)&RegisterInfo332, NULL}, // CPGC
  {(RegisterInformation *)&RegisterInfo333, NULL}, // CPGC
  {(RegisterInformation *)&RegisterInfo334, NULL}, // CPGC
  {(RegisterInformation *)&RegisterInfo335, NULL}, // CPGC
  {(RegisterInformation *)&RegisterInfo336, NULL}, // CPGC
  {(RegisterInformation *)&RegisterInfo337, NULL}, // CPGC
  {(RegisterInformation *)&RegisterInfo338, NULL}, // CPGC
  {(RegisterInformation *)&RegisterInfo339, NULL}, // CPGC
{NULL, NULL},
  {(RegisterInformation *)&RegisterInfo340, NULL}, // DQCCC
  {(RegisterInformation *)&RegisterInfo341, NULL}, // DQCCC
  {(RegisterInformation *)&RegisterInfo342, NULL}, // DQCCC
  {(RegisterInformation *)&RegisterInfo343, NULL}, // DQCCC
  {(RegisterInformation *)&RegisterInfo344, NULL}, // DQCCC
  {(RegisterInformation *)&RegisterInfo345, NULL}, // DQCCC
  {(RegisterInformation *)&RegisterInfo346, NULL}, // DQCCC
  {(RegisterInformation *)&RegisterInfo347, NULL}, // DQCCC
  {(RegisterInformation *)&RegisterInfo348, NULL}, // DQCCC
  {(RegisterInformation *)&RegisterInfo349, NULL}, // DQCCC
  {(RegisterInformation *)&RegisterInfo350, NULL}, // DQCCC
  {(RegisterInformation *)&RegisterInfo351, NULL}, // DQCCC
  {(RegisterInformation *)&RegisterInfo352, NULL}, // DQCCC
  {(RegisterInformation *)&RegisterInfo353, NULL}, // DQCCC
  {(RegisterInformation *)&RegisterInfo354, NULL}, // DQCCC
  {(RegisterInformation *)&RegisterInfo355, NULL}, // DQCCC
  {(RegisterInformation *)&RegisterInfo356, NULL}, // DQCCC
  {(RegisterInformation *)&RegisterInfo357, NULL}, // DQCCC
  {(RegisterInformation *)&RegisterInfo358, NULL}, // DQCCC
  {(RegisterInformation *)&RegisterInfo359, NULL}, // DQCCC
  {(RegisterInformation *)&RegisterInfo360, NULL}, // DQCCC
  {(RegisterInformation *)&RegisterInfo361, NULL}, // DQCCC
  {(RegisterInformation *)&RegisterInfo362, NULL}, // DQCCC
  {(RegisterInformation *)&RegisterInfo363, NULL}, // DQCCC
  {(RegisterInformation *)&RegisterInfo364, NULL}, // DQCCC
  {(RegisterInformation *)&RegisterInfo365, NULL}, // DQCCC
  {(RegisterInformation *)&RegisterInfo366, NULL}, // DQCCC
  {(RegisterInformation *)&RegisterInfo367, NULL}, // DQCCC
  {(RegisterInformation *)&RegisterInfo368, NULL}, // DQCCC
  {(RegisterInformation *)&RegisterInfo369, NULL}, // DQCCC
  {(RegisterInformation *)&RegisterInfo370, NULL}, // DQCCC
  {(RegisterInformation *)&RegisterInfo371, NULL}, // DQCCC
  {(RegisterInformation *)&RegisterInfo372, NULL}, // DQCCC
  {(RegisterInformation *)&RegisterInfo373, NULL}, // DQCCC
  {(RegisterInformation *)&RegisterInfo374, NULL}, // DQCCC
  {(RegisterInformation *)&RegisterInfo375, NULL}, // DQCCC
  {(RegisterInformation *)&RegisterInfo376, NULL}, // DQCCC
  {(RegisterInformation *)&RegisterInfo377, NULL}, // DQCCC
  {(RegisterInformation *)&RegisterInfo378, NULL}, // DQCCC
  {(RegisterInformation *)&RegisterInfo379, NULL}, // DQCCC
  {(RegisterInformation *)&RegisterInfo380, NULL}, // DQCCC
  {(RegisterInformation *)&RegisterInfo381, NULL}, // DQCCC
  {(RegisterInformation *)&RegisterInfo382, NULL}, // DQCCC
  {(RegisterInformation *)&RegisterInfo383, NULL}, // DQCCC
  {(RegisterInformation *)&RegisterInfo384, NULL}, // DQCCC
  {(RegisterInformation *)&RegisterInfo385, NULL}, // DQCCC
  {(RegisterInformation *)&RegisterInfo386, NULL}, // DQCCC
  {(RegisterInformation *)&RegisterInfo387, NULL}, // DQCCC
  {(RegisterInformation *)&RegisterInfo388, NULL}, // DQCCC
  {(RegisterInformation *)&RegisterInfo389, NULL}, // DQCCC
  {(RegisterInformation *)&RegisterInfo390, NULL}, // DQCCC
  {(RegisterInformation *)&RegisterInfo391, NULL}, // DQCCC
  {(RegisterInformation *)&RegisterInfo392, NULL}, // DQCCC
  {(RegisterInformation *)&RegisterInfo393, NULL}, // DQCCC
  {(RegisterInformation *)&RegisterInfo394, NULL}, // DQCCC
  {(RegisterInformation *)&RegisterInfo395, NULL}, // DQCCC
  {(RegisterInformation *)&RegisterInfo396, NULL}, // DQCCC
  {(RegisterInformation *)&RegisterInfo397, NULL}, // DQCCC
  {(RegisterInformation *)&RegisterInfo398, NULL}, // DQCCC
  {(RegisterInformation *)&RegisterInfo399, NULL}, // DQCCC
  {(RegisterInformation *)&RegisterInfo400, NULL}, // DQCCC
  {(RegisterInformation *)&RegisterInfo401, NULL}, // DQCCC
  {(RegisterInformation *)&RegisterInfo402, NULL}, // DQCCC
  {(RegisterInformation *)&RegisterInfo403, NULL}, // DQCCC
  {(RegisterInformation *)&RegisterInfo404, NULL}, // DQCCC
  {(RegisterInformation *)&RegisterInfo405, NULL}, // DQCCC
  {(RegisterInformation *)&RegisterInfo406, NULL}, // DQCCC
  {(RegisterInformation *)&RegisterInfo407, NULL}, // DQCCC
  {(RegisterInformation *)&RegisterInfo408, NULL}, // DQCCC
  {(RegisterInformation *)&RegisterInfo409, NULL}, // DQCCC
  {(RegisterInformation *)&RegisterInfo410, NULL}, // DQCCC
  {(RegisterInformation *)&RegisterInfo411, NULL}, // DQCCC
  {(RegisterInformation *)&RegisterInfo412, NULL}, // DQCCC
  {(RegisterInformation *)&RegisterInfo413, NULL}, // DQCCC
  {(RegisterInformation *)&RegisterInfo414, NULL}, // DQCCC
  {(RegisterInformation *)&RegisterInfo415, NULL}, // DQCCC
  {(RegisterInformation *)&RegisterInfo416, NULL}, // DQCCC
  {(RegisterInformation *)&RegisterInfo417, NULL}, // DQCCC
  {(RegisterInformation *)&RegisterInfo418, NULL}, // DQCCC
  {(RegisterInformation *)&RegisterInfo419, NULL}, // DQCCC
  {(RegisterInformation *)&RegisterInfo420, NULL}, // DQCCC
  {(RegisterInformation *)&RegisterInfo421, NULL}, // DQCCC
  {(RegisterInformation *)&RegisterInfo422, NULL}, // DQCCC
  {(RegisterInformation *)&RegisterInfo423, NULL}, // DQCCC
  {(RegisterInformation *)&RegisterInfo424, NULL}, // DQCCC
  {(RegisterInformation *)&RegisterInfo425, NULL}, // DQCCC
  {(RegisterInformation *)&RegisterInfo426, NULL}, // DQCCC
  {(RegisterInformation *)&RegisterInfo427, NULL}, // DQCCC
  {(RegisterInformation *)&RegisterInfo428, NULL}, // DQCCC
  {(RegisterInformation *)&RegisterInfo429, NULL}, // DQCCC
  {(RegisterInformation *)&RegisterInfo430, NULL}, // DQCCC
  {(RegisterInformation *)&RegisterInfo431, NULL}, // DQCCC
  {(RegisterInformation *)&RegisterInfo432, NULL}, // DQCCC
  {(RegisterInformation *)&RegisterInfo433, NULL}, // DQCCC
  {(RegisterInformation *)&RegisterInfo434, NULL}, // DQCCC
  {(RegisterInformation *)&RegisterInfo435, NULL}, // DQCCC
  {(RegisterInformation *)&RegisterInfo436, NULL}, // DQCCC
  {(RegisterInformation *)&RegisterInfo437, NULL}, // DQCCC
  {(RegisterInformation *)&RegisterInfo438, NULL}, // DQCCC
  {(RegisterInformation *)&RegisterInfo439, NULL}, // DQCCC
{NULL, NULL},
  {(RegisterInformation *)&RegisterInfo440, NULL}, // DQ
  {(RegisterInformation *)&RegisterInfo441, NULL}, // DQ
  {(RegisterInformation *)&RegisterInfo442, NULL}, // DQ
  {(RegisterInformation *)&RegisterInfo443, NULL}, // DQ
  {(RegisterInformation *)&RegisterInfo444, NULL}, // DQ
  {(RegisterInformation *)&RegisterInfo445, NULL}, // DQ
  {(RegisterInformation *)&RegisterInfo446, NULL}, // DQ
  {(RegisterInformation *)&RegisterInfo447, NULL}, // DQ
  {(RegisterInformation *)&RegisterInfo448, NULL}, // DQ
  {(RegisterInformation *)&RegisterInfo449, NULL}, // DQ
  {(RegisterInformation *)&RegisterInfo450, NULL}, // DQ
  {(RegisterInformation *)&RegisterInfo451, NULL}, // DQ
  {(RegisterInformation *)&RegisterInfo452, NULL}, // DQ
  {(RegisterInformation *)&RegisterInfo453, NULL}, // DQ
  {(RegisterInformation *)&RegisterInfo454, NULL}, // DQ
  {(RegisterInformation *)&RegisterInfo455, NULL}, // DQ
  {(RegisterInformation *)&RegisterInfo456, NULL}, // DQ
  {(RegisterInformation *)&RegisterInfo457, NULL}, // DQ
  {(RegisterInformation *)&RegisterInfo458, NULL}, // DQ
  {(RegisterInformation *)&RegisterInfo459, NULL}, // DQ
  {(RegisterInformation *)&RegisterInfo460, NULL}, // DQ
  {(RegisterInformation *)&RegisterInfo461, NULL}, // DQ
  {(RegisterInformation *)&RegisterInfo462, NULL}, // DQ
  {(RegisterInformation *)&RegisterInfo463, NULL}, // DQ
  {(RegisterInformation *)&RegisterInfo464, NULL}, // DQ
  {(RegisterInformation *)&RegisterInfo465, NULL}, // DQ
  {(RegisterInformation *)&RegisterInfo466, NULL}, // DQ
  {(RegisterInformation *)&RegisterInfo467, NULL}, // DQ
  {(RegisterInformation *)&RegisterInfo468, NULL}, // DQ
  {(RegisterInformation *)&RegisterInfo469, NULL}, // DQ
  {(RegisterInformation *)&RegisterInfo470, NULL}, // DQ
  {(RegisterInformation *)&RegisterInfo471, NULL}, // DQ
  {(RegisterInformation *)&RegisterInfo472, NULL}, // DQ
  {(RegisterInformation *)&RegisterInfo473, NULL}, // DQ
  {(RegisterInformation *)&RegisterInfo474, NULL}, // DQ
  {(RegisterInformation *)&RegisterInfo475, NULL}, // DQ
  {(RegisterInformation *)&RegisterInfo476, NULL}, // DQ
  {(RegisterInformation *)&RegisterInfo477, NULL}, // DQ
  {(RegisterInformation *)&RegisterInfo478, NULL}, // DQ
  {(RegisterInformation *)&RegisterInfo479, NULL}, // DQ
  {(RegisterInformation *)&RegisterInfo480, NULL}, // DQ
  {(RegisterInformation *)&RegisterInfo481, NULL}, // DQ
  {(RegisterInformation *)&RegisterInfo482, NULL}, // DQ
  {(RegisterInformation *)&RegisterInfo483, NULL}, // DQ
  {(RegisterInformation *)&RegisterInfo484, NULL}, // DQ
  {(RegisterInformation *)&RegisterInfo485, NULL}, // DQ
  {(RegisterInformation *)&RegisterInfo486, NULL}, // DQ
  {(RegisterInformation *)&RegisterInfo487, NULL}, // DQ
  {(RegisterInformation *)&RegisterInfo488, NULL}, // DQ
  {(RegisterInformation *)&RegisterInfo489, NULL}, // DQ
  {(RegisterInformation *)&RegisterInfo490, NULL}, // DQ
  {(RegisterInformation *)&RegisterInfo491, NULL}, // DQ
  {(RegisterInformation *)&RegisterInfo492, NULL}, // DQ
  {(RegisterInformation *)&RegisterInfo493, NULL}, // DQ
  {(RegisterInformation *)&RegisterInfo494, NULL}, // DQ
  {(RegisterInformation *)&RegisterInfo495, NULL}, // DQ
  {(RegisterInformation *)&RegisterInfo496, NULL}, // DQ
  {(RegisterInformation *)&RegisterInfo497, NULL}, // DQ
  {(RegisterInformation *)&RegisterInfo498, NULL}, // DQ
  {(RegisterInformation *)&RegisterInfo499, NULL}, // DQ
  {(RegisterInformation *)&RegisterInfo500, NULL}, // DQ
  {(RegisterInformation *)&RegisterInfo501, NULL}, // DQ
  {(RegisterInformation *)&RegisterInfo502, NULL}, // DQ
  {(RegisterInformation *)&RegisterInfo503, NULL}, // DQ
  {(RegisterInformation *)&RegisterInfo504, NULL}, // DQ
  {(RegisterInformation *)&RegisterInfo505, NULL}, // DQ
  {(RegisterInformation *)&RegisterInfo506, NULL}, // DQ
  {(RegisterInformation *)&RegisterInfo507, NULL}, // DQ
  {(RegisterInformation *)&RegisterInfo508, NULL}, // DQ
  {(RegisterInformation *)&RegisterInfo509, NULL}, // DQ
  {(RegisterInformation *)&RegisterInfo510, NULL}, // DQ
  {(RegisterInformation *)&RegisterInfo511, NULL}, // DQ
  {(RegisterInformation *)&RegisterInfo512, NULL}, // DQ
  {(RegisterInformation *)&RegisterInfo513, NULL}, // DQ
  {(RegisterInformation *)&RegisterInfo514, NULL}, // DQ
  {(RegisterInformation *)&RegisterInfo515, NULL}, // DQ
  {(RegisterInformation *)&RegisterInfo516, NULL}, // DQ
  {(RegisterInformation *)&RegisterInfo517, NULL}, // DQ
  {(RegisterInformation *)&RegisterInfo518, NULL}, // DQ
  {(RegisterInformation *)&RegisterInfo519, NULL}, // DQ
  {(RegisterInformation *)&RegisterInfo520, NULL}, // DQ
  {(RegisterInformation *)&RegisterInfo521, NULL}, // DQ
  {(RegisterInformation *)&RegisterInfo522, NULL}, // DQ
  {(RegisterInformation *)&RegisterInfo523, NULL}, // DQ
  {(RegisterInformation *)&RegisterInfo524, NULL}, // DQ
  {(RegisterInformation *)&RegisterInfo525, NULL}, // DQ
  {(RegisterInformation *)&RegisterInfo526, NULL}, // DQ
  {(RegisterInformation *)&RegisterInfo527, NULL}, // DQ
  {(RegisterInformation *)&RegisterInfo528, NULL}, // DQ
  {(RegisterInformation *)&RegisterInfo529, NULL}, // DQ
  {(RegisterInformation *)&RegisterInfo530, NULL}, // DQ
  {(RegisterInformation *)&RegisterInfo531, NULL}, // DQ
  {(RegisterInformation *)&RegisterInfo532, NULL}, // DQ
  {(RegisterInformation *)&RegisterInfo533, NULL}, // DQ
  {(RegisterInformation *)&RegisterInfo534, NULL}, // DQ
{NULL, NULL},
  {(RegisterInformation *)&RegisterInfo535, NULL}, // CCC
  {(RegisterInformation *)&RegisterInfo536, NULL}, // CCC
  {(RegisterInformation *)&RegisterInfo537, NULL}, // CCC
  {(RegisterInformation *)&RegisterInfo538, NULL}, // CCC
  {(RegisterInformation *)&RegisterInfo539, NULL}, // CCC
  {(RegisterInformation *)&RegisterInfo540, NULL}, // CCC
  {(RegisterInformation *)&RegisterInfo541, NULL}, // CCC
  {(RegisterInformation *)&RegisterInfo542, NULL}, // CCC
  {(RegisterInformation *)&RegisterInfo543, NULL}, // CCC
  {(RegisterInformation *)&RegisterInfo544, NULL}, // CCC
  {(RegisterInformation *)&RegisterInfo545, NULL}, // CCC
  {(RegisterInformation *)&RegisterInfo546, NULL}, // CCC
  {(RegisterInformation *)&RegisterInfo547, NULL}, // CCC
  {(RegisterInformation *)&RegisterInfo548, NULL}, // CCC
  {(RegisterInformation *)&RegisterInfo549, NULL}, // CCC
  {(RegisterInformation *)&RegisterInfo550, NULL}, // CCC
  {(RegisterInformation *)&RegisterInfo551, NULL}, // CCC
  {(RegisterInformation *)&RegisterInfo552, NULL}, // CCC
  {(RegisterInformation *)&RegisterInfo553, NULL}, // CCC
  {(RegisterInformation *)&RegisterInfo554, NULL}, // CCC
  {(RegisterInformation *)&RegisterInfo555, NULL}, // CCC
  {(RegisterInformation *)&RegisterInfo556, NULL}, // CCC
  {(RegisterInformation *)&RegisterInfo557, NULL}, // CCC
  {(RegisterInformation *)&RegisterInfo558, NULL}, // CCC
  {(RegisterInformation *)&RegisterInfo559, NULL}, // CCC
  {(RegisterInformation *)&RegisterInfo560, NULL}, // CCC
  {(RegisterInformation *)&RegisterInfo561, NULL}, // CCC
  {(RegisterInformation *)&RegisterInfo562, NULL}, // CCC
  {(RegisterInformation *)&RegisterInfo563, NULL}, // CCC
  {(RegisterInformation *)&RegisterInfo564, NULL}, // CCC
  {(RegisterInformation *)&RegisterInfo565, NULL}, // CCC
  {(RegisterInformation *)&RegisterInfo566, NULL}, // CCC
  {(RegisterInformation *)&RegisterInfo567, NULL}, // CCC
  {(RegisterInformation *)&RegisterInfo568, NULL}, // CCC
  {(RegisterInformation *)&RegisterInfo569, NULL}, // CCC
  {(RegisterInformation *)&RegisterInfo570, NULL}, // CCC
  {(RegisterInformation *)&RegisterInfo571, NULL}, // CCC
  {(RegisterInformation *)&RegisterInfo572, NULL}, // CCC
  {(RegisterInformation *)&RegisterInfo573, NULL}, // CCC
  {(RegisterInformation *)&RegisterInfo574, NULL}, // CCC
  {(RegisterInformation *)&RegisterInfo575, NULL}, // CCC
  {(RegisterInformation *)&RegisterInfo576, NULL}, // CCC
  {(RegisterInformation *)&RegisterInfo577, NULL}, // CCC
  {(RegisterInformation *)&RegisterInfo578, NULL}, // CCC
  {(RegisterInformation *)&RegisterInfo579, NULL}, // CCC
  {(RegisterInformation *)&RegisterInfo580, NULL}, // CCC
  {(RegisterInformation *)&RegisterInfo581, NULL}, // CCC
  {(RegisterInformation *)&RegisterInfo582, NULL}, // CCC
  {(RegisterInformation *)&RegisterInfo583, NULL}, // CCC
  {(RegisterInformation *)&RegisterInfo584, NULL}, // CCC
  {(RegisterInformation *)&RegisterInfo585, NULL}, // CCC
  {(RegisterInformation *)&RegisterInfo586, NULL}, // CCC
  {(RegisterInformation *)&RegisterInfo587, NULL}, // CCC
  {(RegisterInformation *)&RegisterInfo588, NULL}, // CCC
  {(RegisterInformation *)&RegisterInfo589, NULL}, // CCC
  {(RegisterInformation *)&RegisterInfo590, NULL}, // CCC
  {(RegisterInformation *)&RegisterInfo591, NULL}, // CCC
  {(RegisterInformation *)&RegisterInfo592, NULL}, // CCC
  {(RegisterInformation *)&RegisterInfo593, NULL}, // CCC
  {(RegisterInformation *)&RegisterInfo594, NULL}, // CCC
  {(RegisterInformation *)&RegisterInfo595, NULL}, // CCC
  {(RegisterInformation *)&RegisterInfo596, NULL}, // CCC
  {(RegisterInformation *)&RegisterInfo597, NULL}, // CCC
  {(RegisterInformation *)&RegisterInfo598, NULL}, // CCC
  {(RegisterInformation *)&RegisterInfo599, NULL}, // CCC
  {(RegisterInformation *)&RegisterInfo600, NULL}, // CCC
  {(RegisterInformation *)&RegisterInfo601, NULL}, // CCC
  {(RegisterInformation *)&RegisterInfo602, NULL}, // CCC
  {(RegisterInformation *)&RegisterInfo603, NULL}, // CCC
  {(RegisterInformation *)&RegisterInfo604, NULL}, // CCC
  {(RegisterInformation *)&RegisterInfo605, NULL}, // CCC
  {(RegisterInformation *)&RegisterInfo606, NULL}, // CCC
  {(RegisterInformation *)&RegisterInfo607, NULL}, // CCC
  {(RegisterInformation *)&RegisterInfo608, NULL}, // CCC
  {(RegisterInformation *)&RegisterInfo609, NULL}, // CCC
  {(RegisterInformation *)&RegisterInfo610, NULL}, // CCC
  {(RegisterInformation *)&RegisterInfo611, NULL}, // CCC
  {(RegisterInformation *)&RegisterInfo612, NULL}, // CCC
  {(RegisterInformation *)&RegisterInfo613, NULL}, // CCC
  {(RegisterInformation *)&RegisterInfo614, NULL}, // CCC
  {(RegisterInformation *)&RegisterInfo615, NULL}, // CCC
  {(RegisterInformation *)&RegisterInfo616, NULL}, // CCC
  {(RegisterInformation *)&RegisterInfo617, NULL}, // CCC
  {(RegisterInformation *)&RegisterInfo618, NULL}, // CCC
  {(RegisterInformation *)&RegisterInfo619, NULL}, // CCC
  {(RegisterInformation *)&RegisterInfo620, NULL}, // CCC
  {(RegisterInformation *)&RegisterInfo621, NULL}, // CCC
  {(RegisterInformation *)&RegisterInfo622, NULL}, // CCC
  {(RegisterInformation *)&RegisterInfo623, NULL}, // CCC
  {(RegisterInformation *)&RegisterInfo624, NULL}, // CCC
  {(RegisterInformation *)&RegisterInfo625, NULL}, // CCC
  {(RegisterInformation *)&RegisterInfo626, NULL}, // CCC
  {(RegisterInformation *)&RegisterInfo627, NULL}, // CCC
  {(RegisterInformation *)&RegisterInfo628, NULL}, // CCC
  {(RegisterInformation *)&RegisterInfo629, NULL}, // CCC
  {(RegisterInformation *)&RegisterInfo630, NULL}, // CCC
  {(RegisterInformation *)&RegisterInfo631, NULL}, // CCC
  {(RegisterInformation *)&RegisterInfo632, NULL}, // CCC
{NULL, NULL},
  {(RegisterInformation *)&RegisterInfo633, NULL}, // DPLVUG
  {(RegisterInformation *)&RegisterInfo634, NULL}, // DPLVUG
  {(RegisterInformation *)&RegisterInfo635, NULL}, // DPLVUG
  {(RegisterInformation *)&RegisterInfo636, NULL}, // DPLVUG
  {(RegisterInformation *)&RegisterInfo637, NULL}, // DPLVUG
  {(RegisterInformation *)&RegisterInfo638, NULL}, // DPLVUG
  {(RegisterInformation *)&RegisterInfo639, NULL}, // DPLVUG
  {(RegisterInformation *)&RegisterInfo640, NULL}, // DPLVUG
  {(RegisterInformation *)&RegisterInfo641, NULL}, // DPLVUG
  {(RegisterInformation *)&RegisterInfo642, NULL}, // DPLVUG
  {(RegisterInformation *)&RegisterInfo643, NULL}, // DPLVUG
  {(RegisterInformation *)&RegisterInfo644, NULL}, // DPLVUG
  {(RegisterInformation *)&RegisterInfo645, NULL}, // DPLVUG
  {(RegisterInformation *)&RegisterInfo646, NULL}, // DPLVUG
  {(RegisterInformation *)&RegisterInfo647, NULL}, // DPLVUG
  {(RegisterInformation *)&RegisterInfo648, NULL}, // DPLVUG
  {(RegisterInformation *)&RegisterInfo649, NULL}, // DPLVUG
  {(RegisterInformation *)&RegisterInfo650, NULL}, // DPLVUG
  {(RegisterInformation *)&RegisterInfo651, NULL}, // DPLVUG
  {(RegisterInformation *)&RegisterInfo652, NULL}, // DPLVUG
  {(RegisterInformation *)&RegisterInfo653, NULL}, // DPLVUG
  {(RegisterInformation *)&RegisterInfo654, NULL}, // DPLVUG
  {(RegisterInformation *)&RegisterInfo655, NULL}, // DPLVUG
  {(RegisterInformation *)&RegisterInfo656, NULL}, // DPLVUG
  {(RegisterInformation *)&RegisterInfo657, NULL}, // DPLVUG
  {(RegisterInformation *)&RegisterInfo658, NULL}, // DPLVUG
  {(RegisterInformation *)&RegisterInfo659, NULL}, // DPLVUG
  {(RegisterInformation *)&RegisterInfo660, NULL}, // DPLVUG
  {(RegisterInformation *)&RegisterInfo661, NULL}, // DPLVUG
  {(RegisterInformation *)&RegisterInfo662, NULL}, // DPLVUG
  {(RegisterInformation *)&RegisterInfo663, NULL}, // DPLVUG
  {(RegisterInformation *)&RegisterInfo664, NULL}, // DPLVUG
  {(RegisterInformation *)&RegisterInfo665, NULL}, // DPLVUG
  {(RegisterInformation *)&RegisterInfo666, NULL}, // DPLVUG
  {(RegisterInformation *)&RegisterInfo667, NULL}, // DPLVUG
  {(RegisterInformation *)&RegisterInfo668, NULL}, // DPLVUG
  {(RegisterInformation *)&RegisterInfo669, NULL}, // DPLVUG
  {(RegisterInformation *)&RegisterInfo670, NULL}, // DPLVUG
  {(RegisterInformation *)&RegisterInfo671, NULL}, // DPLVUG
  {(RegisterInformation *)&RegisterInfo672, NULL}, // DPLVUG
  {(RegisterInformation *)&RegisterInfo673, NULL}, // DPLVUG
  {(RegisterInformation *)&RegisterInfo674, NULL}, // DPLVUG
  {(RegisterInformation *)&RegisterInfo675, NULL}, // DPLVUG
  {(RegisterInformation *)&RegisterInfo676, NULL}, // DPLVUG
  {(RegisterInformation *)&RegisterInfo677, NULL}, // DPLVUG
  {(RegisterInformation *)&RegisterInfo678, NULL}, // DPLVUG
  {(RegisterInformation *)&RegisterInfo679, NULL}, // DPLVUG
  {(RegisterInformation *)&RegisterInfo680, NULL}, // DPLVUG
  {(RegisterInformation *)&RegisterInfo681, NULL}, // DPLVUG
  {(RegisterInformation *)&RegisterInfo682, NULL}, // DPLVUG
  {(RegisterInformation *)&RegisterInfo683, NULL}, // DPLVUG
  {(RegisterInformation *)&RegisterInfo684, NULL}, // DPLVUG
  {(RegisterInformation *)&RegisterInfo685, NULL}, // DPLVUG
  {(RegisterInformation *)&RegisterInfo686, NULL}, // DPLVUG
  {(RegisterInformation *)&RegisterInfo687, NULL}, // DPLVUG
  {(RegisterInformation *)&RegisterInfo688, NULL}, // DPLVUG
  {(RegisterInformation *)&RegisterInfo689, NULL}, // DPLVUG
  {(RegisterInformation *)&RegisterInfo690, NULL}, // DPLVUG
  {(RegisterInformation *)&RegisterInfo691, NULL}, // DPLVUG
  {(RegisterInformation *)&RegisterInfo692, NULL}, // DPLVUG
  {(RegisterInformation *)&RegisterInfo693, NULL}, // DPLVUG
  {(RegisterInformation *)&RegisterInfo694, NULL}, // DPLVUG
  {(RegisterInformation *)&RegisterInfo695, NULL}, // DPLVUG
  {(RegisterInformation *)&RegisterInfo696, NULL}, // DPLVUG
  {(RegisterInformation *)&RegisterInfo697, NULL}, // DPLVUG
  {(RegisterInformation *)&RegisterInfo698, NULL}, // DPLVUG
  {(RegisterInformation *)&RegisterInfo699, NULL}, // DPLVUG
  {(RegisterInformation *)&RegisterInfo700, NULL}, // DPLVUG
  {(RegisterInformation *)&RegisterInfo701, NULL}, // DPLVUG
  {(RegisterInformation *)&RegisterInfo702, NULL}, // DPLVUG
  {(RegisterInformation *)&RegisterInfo703, NULL}, // DPLVUG
  {(RegisterInformation *)&RegisterInfo704, NULL}, // DPLVUG
  {(RegisterInformation *)&RegisterInfo705, NULL}, // DPLVUG
  {(RegisterInformation *)&RegisterInfo706, NULL}, // DPLVUG
{NULL, NULL},
  {(RegisterInformation *)&RegisterInfo707, NULL}, // ADPLL
  {(RegisterInformation *)&RegisterInfo708, NULL}, // ADPLL
  {(RegisterInformation *)&RegisterInfo709, NULL}, // ADPLL
  {(RegisterInformation *)&RegisterInfo710, NULL}, // ADPLL
  {(RegisterInformation *)&RegisterInfo711, NULL}, // ADPLL
  {(RegisterInformation *)&RegisterInfo712, NULL}, // ADPLL
  {(RegisterInformation *)&RegisterInfo713, NULL}, // ADPLL
  {(RegisterInformation *)&RegisterInfo714, NULL}, // ADPLL
  {(RegisterInformation *)&RegisterInfo715, NULL}, // ADPLL
  {(RegisterInformation *)&RegisterInfo716, NULL}, // ADPLL
  {(RegisterInformation *)&RegisterInfo717, NULL}, // ADPLL
  {(RegisterInformation *)&RegisterInfo718, NULL}, // ADPLL
  {(RegisterInformation *)&RegisterInfo719, NULL}, // ADPLL
  {(RegisterInformation *)&RegisterInfo720, NULL}, // ADPLL
{NULL, NULL},
  {(RegisterInformation *)&RegisterInfo721, NULL}, // LDO
  {(RegisterInformation *)&RegisterInfo722, NULL}, // LDO
  {(RegisterInformation *)&RegisterInfo723, NULL}, // LDO
  {(RegisterInformation *)&RegisterInfo724, NULL}, // LDO
  {(RegisterInformation *)&RegisterInfo725, NULL}, // LDO
  {(RegisterInformation *)&RegisterInfo726, NULL}, // LDO
  {(RegisterInformation *)&RegisterInfo727, NULL}, // LDO
  {(RegisterInformation *)&RegisterInfo728, NULL}, // LDO
  {(RegisterInformation *)&RegisterInfo729, NULL}, // LDO
  {(RegisterInformation *)&RegisterInfo730, NULL}, // LDO
{NULL, NULL},
  {(RegisterInformation *)&RegisterInfo731, NULL}, // DPIC
  {(RegisterInformation *)&RegisterInfo732, NULL}, // DPIC
  {(RegisterInformation *)&RegisterInfo733, NULL}, // DPIC
  {(RegisterInformation *)&RegisterInfo734, NULL}, // DPIC
  {(RegisterInformation *)&RegisterInfo735, NULL}, // DPIC
  {(RegisterInformation *)&RegisterInfo736, NULL}, // DPIC
  {(RegisterInformation *)&RegisterInfo737, NULL}, // DPIC
  {(RegisterInformation *)&RegisterInfo738, NULL}, // DPIC
  {(RegisterInformation *)&RegisterInfo739, NULL}, // DPIC
  {(RegisterInformation *)&RegisterInfo740, NULL}, // DPIC
  {(RegisterInformation *)&RegisterInfo741, NULL}, // DPIC
  {(RegisterInformation *)&RegisterInfo742, NULL}, // DPIC
  {(RegisterInformation *)&RegisterInfo743, NULL}, // DPIC
  {(RegisterInformation *)&RegisterInfo744, NULL}, // DPIC
  {(RegisterInformation *)&RegisterInfo745, NULL}, // DPIC
  {(RegisterInformation *)&RegisterInfo746, NULL}, // DPIC
  {(RegisterInformation *)&RegisterInfo747, NULL}, // DPIC
  {(RegisterInformation *)&RegisterInfo748, NULL}, // DPIC
  {(RegisterInformation *)&RegisterInfo749, NULL}, // DPIC
  {(RegisterInformation *)&RegisterInfo750, NULL}, // DPIC
  {(RegisterInformation *)&RegisterInfo751, NULL}, // DPIC
  {(RegisterInformation *)&RegisterInfo752, NULL}, // DPIC
  {(RegisterInformation *)&RegisterInfo753, NULL}, // DPIC
  {(RegisterInformation *)&RegisterInfo754, NULL}, // DPIC
  {(RegisterInformation *)&RegisterInfo755, NULL}, // DPIC
  {(RegisterInformation *)&RegisterInfo756, NULL}, // DPIC
  {(RegisterInformation *)&RegisterInfo757, NULL}, // DPIC
  {(RegisterInformation *)&RegisterInfo758, NULL}, // DPIC
  {(RegisterInformation *)&RegisterInfo759, NULL}, // DPIC
  {(RegisterInformation *)&RegisterInfo760, NULL}, // DPIC
  {(RegisterInformation *)&RegisterInfo761, NULL}, // DPIC
  {(RegisterInformation *)&RegisterInfo762, NULL}, // DPIC
  {(RegisterInformation *)&RegisterInfo763, NULL}, // DPIC
  {(RegisterInformation *)&RegisterInfo764, NULL}, // DPIC
  {(RegisterInformation *)&RegisterInfo765, NULL}, // DPIC
  {(RegisterInformation *)&RegisterInfo766, NULL}, // DPIC
  {(RegisterInformation *)&RegisterInfo767, NULL}, // DPIC
  {(RegisterInformation *)&RegisterInfo768, NULL}, // DPIC
  {(RegisterInformation *)&RegisterInfo769, NULL}, // DPIC
  {(RegisterInformation *)&RegisterInfo770, NULL}, // DPIC
{NULL, NULL},
  {(RegisterInformation *)&RegisterInfo771, NULL}, // WIO2PHY
{NULL, NULL},
  {(RegisterInformation *)&RegisterInfo772, NULL}, // BUNIT
  {(RegisterInformation *)&RegisterInfo773, NULL}, // BUNIT
  {(RegisterInformation *)&RegisterInfo774, NULL}, // BUNIT
  {(RegisterInformation *)&RegisterInfo775, NULL}, // BUNIT
  {(RegisterInformation *)&RegisterInfo776, NULL}, // BUNIT
  {(RegisterInformation *)&RegisterInfo777, NULL}, // BUNIT
  {(RegisterInformation *)&RegisterInfo778, NULL}, // BUNIT
  {(RegisterInformation *)&RegisterInfo779, NULL}, // BUNIT
  {(RegisterInformation *)&RegisterInfo780, NULL}, // BUNIT
  {(RegisterInformation *)&RegisterInfo781, NULL}, // BUNIT
  {(RegisterInformation *)&RegisterInfo782, NULL}, // BUNIT
  {(RegisterInformation *)&RegisterInfo783, NULL}, // BUNIT
  {(RegisterInformation *)&RegisterInfo784, NULL}, // BUNIT
  {(RegisterInformation *)&RegisterInfo785, NULL}, // BUNIT
  {(RegisterInformation *)&RegisterInfo786, NULL}, // BUNIT
  {(RegisterInformation *)&RegisterInfo787, NULL}, // BUNIT
  {(RegisterInformation *)&RegisterInfo788, NULL}, // BUNIT
  {(RegisterInformation *)&RegisterInfo789, NULL}, // BUNIT
  {(RegisterInformation *)&RegisterInfo790, NULL}, // BUNIT
  {(RegisterInformation *)&RegisterInfo791, NULL}, // BUNIT
  {(RegisterInformation *)&RegisterInfo792, NULL}, // BUNIT
  {(RegisterInformation *)&RegisterInfo793, NULL}, // BUNIT
  {(RegisterInformation *)&RegisterInfo794, NULL}, // BUNIT
  {(RegisterInformation *)&RegisterInfo795, NULL}, // BUNIT
  {(RegisterInformation *)&RegisterInfo796, NULL}, // BUNIT
  {(RegisterInformation *)&RegisterInfo797, NULL}, // BUNIT
  {(RegisterInformation *)&RegisterInfo798, NULL}, // BUNIT
  {(RegisterInformation *)&RegisterInfo799, NULL}, // BUNIT
  {(RegisterInformation *)&RegisterInfo800, NULL}, // BUNIT
  {(RegisterInformation *)&RegisterInfo801, NULL}, // BUNIT
  {(RegisterInformation *)&RegisterInfo802, NULL}, // BUNIT
  {(RegisterInformation *)&RegisterInfo803, NULL}, // BUNIT
  {(RegisterInformation *)&RegisterInfo804, NULL}, // BUNIT
  {(RegisterInformation *)&RegisterInfo805, NULL}, // BUNIT
  {(RegisterInformation *)&RegisterInfo806, NULL}, // BUNIT
  {(RegisterInformation *)&RegisterInfo807, NULL}, // BUNIT
  {(RegisterInformation *)&RegisterInfo808, NULL}, // BUNIT
  {(RegisterInformation *)&RegisterInfo809, NULL}, // BUNIT
  {(RegisterInformation *)&RegisterInfo810, NULL}, // BUNIT
  {(RegisterInformation *)&RegisterInfo811, NULL}, // BUNIT
  {(RegisterInformation *)&RegisterInfo812, NULL}, // BUNIT
  {(RegisterInformation *)&RegisterInfo813, NULL}, // BUNIT
  {(RegisterInformation *)&RegisterInfo814, NULL}, // BUNIT
  {(RegisterInformation *)&RegisterInfo815, NULL}, // BUNIT
  {(RegisterInformation *)&RegisterInfo816, NULL}, // BUNIT
  {(RegisterInformation *)&RegisterInfo817, NULL}, // BUNIT
  {(RegisterInformation *)&RegisterInfo818, NULL}, // BUNIT
  {(RegisterInformation *)&RegisterInfo819, NULL}, // BUNIT
  {(RegisterInformation *)&RegisterInfo820, NULL}, // BUNIT
  {(RegisterInformation *)&RegisterInfo821, NULL}, // BUNIT
  {(RegisterInformation *)&RegisterInfo822, NULL}, // BUNIT
  {(RegisterInformation *)&RegisterInfo823, NULL}, // BUNIT
  {(RegisterInformation *)&RegisterInfo824, NULL}, // BUNIT
  {(RegisterInformation *)&RegisterInfo825, NULL}, // BUNIT
  {(RegisterInformation *)&RegisterInfo826, NULL}, // BUNIT
  {(RegisterInformation *)&RegisterInfo827, NULL}, // BUNIT
  {(RegisterInformation *)&RegisterInfo828, NULL}, // BUNIT
  {(RegisterInformation *)&RegisterInfo829, NULL}, // BUNIT
  {(RegisterInformation *)&RegisterInfo830, NULL}, // BUNIT
  {(RegisterInformation *)&RegisterInfo831, NULL}, // BUNIT
  {(RegisterInformation *)&RegisterInfo832, NULL}, // BUNIT
  {(RegisterInformation *)&RegisterInfo833, NULL}, // BUNIT
  {(RegisterInformation *)&RegisterInfo834, NULL}, // BUNIT
  {(RegisterInformation *)&RegisterInfo835, NULL}, // BUNIT
  {(RegisterInformation *)&RegisterInfo836, NULL}, // BUNIT
  {(RegisterInformation *)&RegisterInfo837, NULL}, // BUNIT
  {(RegisterInformation *)&RegisterInfo838, NULL}, // BUNIT
  {(RegisterInformation *)&RegisterInfo839, NULL}, // BUNIT
  {(RegisterInformation *)&RegisterInfo840, NULL}, // BUNIT
  {(RegisterInformation *)&RegisterInfo841, NULL}, // BUNIT
  {(RegisterInformation *)&RegisterInfo842, NULL}, // BUNIT
  {(RegisterInformation *)&RegisterInfo843, NULL}, // BUNIT
  {(RegisterInformation *)&RegisterInfo844, NULL}, // BUNIT
  {(RegisterInformation *)&RegisterInfo845, NULL}, // BUNIT
  {(RegisterInformation *)&RegisterInfo846, NULL}, // BUNIT
  {(RegisterInformation *)&RegisterInfo847, NULL}, // BUNIT
  {(RegisterInformation *)&RegisterInfo848, NULL}, // BUNIT
  {(RegisterInformation *)&RegisterInfo849, NULL}, // BUNIT
  {(RegisterInformation *)&RegisterInfo850, NULL}, // BUNIT
  {(RegisterInformation *)&RegisterInfo851, NULL}, // BUNIT
  {(RegisterInformation *)&RegisterInfo852, NULL}, // BUNIT
  {(RegisterInformation *)&RegisterInfo853, NULL}, // BUNIT
  {(RegisterInformation *)&RegisterInfo854, NULL}, // BUNIT
  {(RegisterInformation *)&RegisterInfo855, NULL}, // BUNIT
  {(RegisterInformation *)&RegisterInfo856, NULL}, // BUNIT
  {(RegisterInformation *)&RegisterInfo857, NULL}, // BUNIT
  {(RegisterInformation *)&RegisterInfo858, NULL}, // BUNIT
  {(RegisterInformation *)&RegisterInfo859, NULL}, // BUNIT
  {(RegisterInformation *)&RegisterInfo860, NULL}, // BUNIT
  {(RegisterInformation *)&RegisterInfo861, NULL}, // BUNIT
  {(RegisterInformation *)&RegisterInfo862, NULL}, // BUNIT
  {(RegisterInformation *)&RegisterInfo863, NULL}, // BUNIT
  {(RegisterInformation *)&RegisterInfo864, NULL}, // BUNIT
  {(RegisterInformation *)&RegisterInfo865, NULL}, // BUNIT
  {(RegisterInformation *)&RegisterInfo866, NULL}, // BUNIT
  {(RegisterInformation *)&RegisterInfo867, NULL}, // BUNIT
  {(RegisterInformation *)&RegisterInfo868, NULL}, // BUNIT
  {(RegisterInformation *)&RegisterInfo869, NULL}, // BUNIT
  {(RegisterInformation *)&RegisterInfo870, NULL}, // BUNIT
  {(RegisterInformation *)&RegisterInfo871, NULL}, // BUNIT
  {(RegisterInformation *)&RegisterInfo872, NULL}, // BUNIT
  {(RegisterInformation *)&RegisterInfo873, NULL}, // BUNIT
  {(RegisterInformation *)&RegisterInfo874, NULL}, // BUNIT
  {(RegisterInformation *)&RegisterInfo875, NULL}, // BUNIT
  {(RegisterInformation *)&RegisterInfo876, NULL}, // BUNIT
  {(RegisterInformation *)&RegisterInfo877, NULL}, // BUNIT
  {(RegisterInformation *)&RegisterInfo878, NULL}, // BUNIT
  {(RegisterInformation *)&RegisterInfo879, NULL}, // BUNIT
  {(RegisterInformation *)&RegisterInfo880, NULL}, // BUNIT
  {(RegisterInformation *)&RegisterInfo881, NULL}, // BUNIT
  {(RegisterInformation *)&RegisterInfo882, NULL}, // BUNIT
  {(RegisterInformation *)&RegisterInfo883, NULL}, // BUNIT
  {(RegisterInformation *)&RegisterInfo884, NULL}, // BUNIT
  {(RegisterInformation *)&RegisterInfo885, NULL}, // BUNIT
  {(RegisterInformation *)&RegisterInfo886, NULL}, // BUNIT
  {(RegisterInformation *)&RegisterInfo887, NULL}, // BUNIT
  {(RegisterInformation *)&RegisterInfo888, NULL}, // BUNIT
  {(RegisterInformation *)&RegisterInfo889, NULL}, // BUNIT
  {(RegisterInformation *)&RegisterInfo890, NULL}, // BUNIT
  {(RegisterInformation *)&RegisterInfo891, NULL}, // BUNIT
  {(RegisterInformation *)&RegisterInfo892, NULL}, // BUNIT
  {(RegisterInformation *)&RegisterInfo893, NULL}, // BUNIT
  {(RegisterInformation *)&RegisterInfo894, NULL}, // BUNIT
  {(RegisterInformation *)&RegisterInfo895, NULL}, // BUNIT
  {(RegisterInformation *)&RegisterInfo896, NULL}, // BUNIT
  {(RegisterInformation *)&RegisterInfo897, NULL}, // BUNIT
  {(RegisterInformation *)&RegisterInfo898, NULL}, // BUNIT
  {(RegisterInformation *)&RegisterInfo899, NULL}, // BUNIT
  {(RegisterInformation *)&RegisterInfo900, NULL}, // BUNIT
  {(RegisterInformation *)&RegisterInfo901, NULL}, // BUNIT
  {(RegisterInformation *)&RegisterInfo902, NULL}, // BUNIT
  {(RegisterInformation *)&RegisterInfo903, NULL}, // BUNIT
  {(RegisterInformation *)&RegisterInfo904, NULL}, // BUNIT
  {(RegisterInformation *)&RegisterInfo905, NULL}, // BUNIT
  {(RegisterInformation *)&RegisterInfo906, NULL}, // BUNIT
  {(RegisterInformation *)&RegisterInfo907, NULL}, // BUNIT
  {(RegisterInformation *)&RegisterInfo908, NULL}, // BUNIT
  {(RegisterInformation *)&RegisterInfo909, NULL}, // BUNIT
  {(RegisterInformation *)&RegisterInfo910, NULL}, // BUNIT
  {(RegisterInformation *)&RegisterInfo911, NULL}, // BUNIT
  {(RegisterInformation *)&RegisterInfo912, NULL}, // BUNIT
  {(RegisterInformation *)&RegisterInfo913, NULL}, // BUNIT
  {(RegisterInformation *)&RegisterInfo914, NULL}, // BUNIT
  {(RegisterInformation *)&RegisterInfo915, NULL}, // BUNIT
  {(RegisterInformation *)&RegisterInfo916, NULL}, // BUNIT
  {(RegisterInformation *)&RegisterInfo917, NULL}, // BUNIT
  {(RegisterInformation *)&RegisterInfo918, NULL}, // BUNIT
  {(RegisterInformation *)&RegisterInfo919, NULL}, // BUNIT
  {(RegisterInformation *)&RegisterInfo920, NULL}, // BUNIT
  {(RegisterInformation *)&RegisterInfo921, NULL}, // BUNIT
  {(RegisterInformation *)&RegisterInfo922, NULL}, // BUNIT
  {(RegisterInformation *)&RegisterInfo923, NULL}, // BUNIT
  {(RegisterInformation *)&RegisterInfo924, NULL}, // BUNIT
  {(RegisterInformation *)&RegisterInfo925, NULL}, // BUNIT
  {(RegisterInformation *)&RegisterInfo926, NULL}, // BUNIT
  {(RegisterInformation *)&RegisterInfo927, NULL}, // BUNIT
  {(RegisterInformation *)&RegisterInfo928, NULL}, // BUNIT
  {(RegisterInformation *)&RegisterInfo929, NULL}, // BUNIT
  {(RegisterInformation *)&RegisterInfo930, NULL}, // BUNIT
  {(RegisterInformation *)&RegisterInfo931, NULL}, // BUNIT
  {(RegisterInformation *)&RegisterInfo932, NULL}, // BUNIT
  {(RegisterInformation *)&RegisterInfo933, NULL}, // BUNIT
  {(RegisterInformation *)&RegisterInfo934, NULL}, // BUNIT
  {(RegisterInformation *)&RegisterInfo935, NULL}, // BUNIT
  {(RegisterInformation *)&RegisterInfo936, NULL}, // BUNIT
  {(RegisterInformation *)&RegisterInfo937, NULL}, // BUNIT
  {(RegisterInformation *)&RegisterInfo938, NULL}, // BUNIT
  {(RegisterInformation *)&RegisterInfo939, NULL}, // BUNIT
  {(RegisterInformation *)&RegisterInfo940, NULL}, // BUNIT
  {(RegisterInformation *)&RegisterInfo941, NULL}, // BUNIT
  {(RegisterInformation *)&RegisterInfo942, NULL}, // BUNIT
  {(RegisterInformation *)&RegisterInfo943, NULL}, // BUNIT
  {(RegisterInformation *)&RegisterInfo944, NULL}, // BUNIT
  {(RegisterInformation *)&RegisterInfo945, NULL}, // BUNIT
  {(RegisterInformation *)&RegisterInfo946, NULL}, // BUNIT
  {(RegisterInformation *)&RegisterInfo947, NULL}, // BUNIT
  {(RegisterInformation *)&RegisterInfo948, NULL}, // BUNIT
  {(RegisterInformation *)&RegisterInfo949, NULL}, // BUNIT
  {(RegisterInformation *)&RegisterInfo950, NULL}, // BUNIT
  {(RegisterInformation *)&RegisterInfo951, NULL}, // BUNIT
  {(RegisterInformation *)&RegisterInfo952, NULL}, // BUNIT
  {(RegisterInformation *)&RegisterInfo953, NULL}, // BUNIT
  {(RegisterInformation *)&RegisterInfo954, NULL}, // BUNIT
  {(RegisterInformation *)&RegisterInfo955, NULL}, // BUNIT
  {(RegisterInformation *)&RegisterInfo956, NULL}, // BUNIT
  {(RegisterInformation *)&RegisterInfo957, NULL}, // BUNIT
  {(RegisterInformation *)&RegisterInfo958, NULL}, // BUNIT
  {(RegisterInformation *)&RegisterInfo959, NULL}, // BUNIT
  {(RegisterInformation *)&RegisterInfo960, NULL}, // BUNIT
  {(RegisterInformation *)&RegisterInfo961, NULL}, // BUNIT
  {(RegisterInformation *)&RegisterInfo962, NULL}, // BUNIT
  {(RegisterInformation *)&RegisterInfo963, NULL}, // BUNIT
  {(RegisterInformation *)&RegisterInfo964, NULL}, // BUNIT
  {(RegisterInformation *)&RegisterInfo965, NULL}, // BUNIT
  {(RegisterInformation *)&RegisterInfo966, NULL}, // BUNIT
  {(RegisterInformation *)&RegisterInfo967, NULL}, // BUNIT
  {(RegisterInformation *)&RegisterInfo968, NULL}, // BUNIT
  {(RegisterInformation *)&RegisterInfo969, NULL}, // BUNIT
  {(RegisterInformation *)&RegisterInfo970, NULL}, // BUNIT
  {(RegisterInformation *)&RegisterInfo971, NULL}, // BUNIT
  {(RegisterInformation *)&RegisterInfo972, NULL}, // BUNIT
  {(RegisterInformation *)&RegisterInfo973, NULL}, // BUNIT
  {(RegisterInformation *)&RegisterInfo974, NULL}, // BUNIT
  {(RegisterInformation *)&RegisterInfo975, NULL}, // BUNIT
  {(RegisterInformation *)&RegisterInfo976, NULL}, // BUNIT
  {(RegisterInformation *)&RegisterInfo977, NULL}, // BUNIT
  {(RegisterInformation *)&RegisterInfo978, NULL}, // BUNIT
  {(RegisterInformation *)&RegisterInfo979, NULL}, // BUNIT
  {(RegisterInformation *)&RegisterInfo980, NULL}, // BUNIT
  {(RegisterInformation *)&RegisterInfo981, NULL}, // BUNIT
  {(RegisterInformation *)&RegisterInfo982, NULL}, // BUNIT
  {(RegisterInformation *)&RegisterInfo983, NULL}, // BUNIT
  {(RegisterInformation *)&RegisterInfo984, NULL}, // BUNIT
  {(RegisterInformation *)&RegisterInfo985, NULL}, // BUNIT
  {(RegisterInformation *)&RegisterInfo986, NULL}, // BUNIT
  {(RegisterInformation *)&RegisterInfo987, NULL}, // BUNIT
  {(RegisterInformation *)&RegisterInfo988, NULL}, // BUNIT
  {(RegisterInformation *)&RegisterInfo989, NULL}, // BUNIT
  {(RegisterInformation *)&RegisterInfo990, NULL}, // BUNIT
  {(RegisterInformation *)&RegisterInfo991, NULL}, // BUNIT
  {(RegisterInformation *)&RegisterInfo992, NULL}, // BUNIT
  {(RegisterInformation *)&RegisterInfo993, NULL}, // BUNIT
  {(RegisterInformation *)&RegisterInfo994, NULL}, // BUNIT
  {(RegisterInformation *)&RegisterInfo995, NULL}, // BUNIT
  {(RegisterInformation *)&RegisterInfo996, NULL}, // BUNIT
  {(RegisterInformation *)&RegisterInfo997, NULL}, // BUNIT
  {(RegisterInformation *)&RegisterInfo998, NULL}, // BUNIT
  {(RegisterInformation *)&RegisterInfo999, NULL}, // BUNIT
  {(RegisterInformation *)&RegisterInfo1000, NULL}, // BUNIT
  {(RegisterInformation *)&RegisterInfo1001, NULL}, // BUNIT
  {(RegisterInformation *)&RegisterInfo1002, NULL}, // BUNIT
  {(RegisterInformation *)&RegisterInfo1003, NULL}, // BUNIT
  {(RegisterInformation *)&RegisterInfo1004, NULL}, // BUNIT
  {(RegisterInformation *)&RegisterInfo1005, NULL}, // BUNIT
  {(RegisterInformation *)&RegisterInfo1006, NULL}, // BUNIT
  {(RegisterInformation *)&RegisterInfo1007, NULL}, // BUNIT
  {(RegisterInformation *)&RegisterInfo1008, NULL}, // BUNIT
  {(RegisterInformation *)&RegisterInfo1009, NULL}, // BUNIT
  {(RegisterInformation *)&RegisterInfo1010, NULL}, // BUNIT
  {(RegisterInformation *)&RegisterInfo1011, NULL}, // BUNIT
  {(RegisterInformation *)&RegisterInfo1012, NULL}, // BUNIT
  {(RegisterInformation *)&RegisterInfo1013, NULL}, // BUNIT
  {(RegisterInformation *)&RegisterInfo1014, NULL}, // BUNIT
  {(RegisterInformation *)&RegisterInfo1015, NULL}, // BUNIT
  {(RegisterInformation *)&RegisterInfo1016, NULL}, // BUNIT
  {(RegisterInformation *)&RegisterInfo1017, NULL}, // BUNIT
  {(RegisterInformation *)&RegisterInfo1018, NULL}, // BUNIT
  {(RegisterInformation *)&RegisterInfo1019, NULL}, // BUNIT
  {(RegisterInformation *)&RegisterInfo1020, NULL}, // BUNIT
  {(RegisterInformation *)&RegisterInfo1021, NULL}, // BUNIT
  {(RegisterInformation *)&RegisterInfo1022, NULL}, // BUNIT
  {(RegisterInformation *)&RegisterInfo1023, NULL}, // BUNIT
  {(RegisterInformation *)&RegisterInfo1024, NULL}, // BUNIT
  {(RegisterInformation *)&RegisterInfo1025, NULL}, // BUNIT
  {(RegisterInformation *)&RegisterInfo1026, NULL}, // BUNIT
  {(RegisterInformation *)&RegisterInfo1027, NULL}, // BUNIT
  {(RegisterInformation *)&RegisterInfo1028, NULL}, // BUNIT
  {(RegisterInformation *)&RegisterInfo1029, NULL}, // BUNIT
  {(RegisterInformation *)&RegisterInfo1030, NULL}, // BUNIT
  {(RegisterInformation *)&RegisterInfo1031, NULL}, // BUNIT
  {(RegisterInformation *)&RegisterInfo1032, NULL}, // BUNIT
  {(RegisterInformation *)&RegisterInfo1033, NULL}, // BUNIT
  {(RegisterInformation *)&RegisterInfo1034, NULL}, // BUNIT
  {(RegisterInformation *)&RegisterInfo1035, NULL}, // BUNIT
  {(RegisterInformation *)&RegisterInfo1036, NULL}, // BUNIT
  {(RegisterInformation *)&RegisterInfo1037, NULL}, // BUNIT
  {(RegisterInformation *)&RegisterInfo1038, NULL}, // BUNIT
  {(RegisterInformation *)&RegisterInfo1039, NULL}, // BUNIT
  {(RegisterInformation *)&RegisterInfo1040, NULL}, // BUNIT
  {(RegisterInformation *)&RegisterInfo1041, NULL}, // BUNIT
  {(RegisterInformation *)&RegisterInfo1042, NULL}, // BUNIT
  {(RegisterInformation *)&RegisterInfo1043, NULL}, // BUNIT
  {(RegisterInformation *)&RegisterInfo1044, NULL}, // BUNIT
  {(RegisterInformation *)&RegisterInfo1045, NULL}, // BUNIT
  {(RegisterInformation *)&RegisterInfo1046, NULL}, // BUNIT
  {(RegisterInformation *)&RegisterInfo1047, NULL}, // BUNIT
  {(RegisterInformation *)&RegisterInfo1048, NULL}, // BUNIT
  {(RegisterInformation *)&RegisterInfo1049, NULL}, // BUNIT
  {(RegisterInformation *)&RegisterInfo1050, NULL}, // BUNIT
  {(RegisterInformation *)&RegisterInfo1051, NULL}, // BUNIT
  {(RegisterInformation *)&RegisterInfo1052, NULL}, // BUNIT
  {(RegisterInformation *)&RegisterInfo1053, NULL}, // BUNIT
  {(RegisterInformation *)&RegisterInfo1054, NULL}, // BUNIT
  {(RegisterInformation *)&RegisterInfo1055, NULL}, // BUNIT
  {(RegisterInformation *)&RegisterInfo1056, NULL}, // BUNIT
  {(RegisterInformation *)&RegisterInfo1057, NULL}, // BUNIT
  {(RegisterInformation *)&RegisterInfo1058, NULL}, // BUNIT
  {(RegisterInformation *)&RegisterInfo1059, NULL}, // BUNIT
{NULL, NULL},
  {(RegisterInformation *)&RegisterInfo1060, NULL}, // PUNIT
  {(RegisterInformation *)&RegisterInfo1061, NULL}, // PUNIT
  {(RegisterInformation *)&RegisterInfo1062, NULL}, // PUNIT
  {(RegisterInformation *)&RegisterInfo1063, NULL}, // PUNIT
  {(RegisterInformation *)&RegisterInfo1064, NULL}, // PUNIT
  {(RegisterInformation *)&RegisterInfo1065, NULL}, // PUNIT
  {(RegisterInformation *)&RegisterInfo1066, NULL}, // PUNIT
  {(RegisterInformation *)&RegisterInfo1067, NULL}, // PUNIT
  {(RegisterInformation *)&RegisterInfo1068, NULL}, // PUNIT
  {(RegisterInformation *)&RegisterInfo1069, NULL}, // PUNIT
  {(RegisterInformation *)&RegisterInfo1070, NULL}, // PUNIT
  {(RegisterInformation *)&RegisterInfo1071, NULL}, // PUNIT
  {(RegisterInformation *)&RegisterInfo1072, NULL}, // PUNIT
  {(RegisterInformation *)&RegisterInfo1073, NULL}, // PUNIT
  {(RegisterInformation *)&RegisterInfo1074, NULL}, // PUNIT
  {(RegisterInformation *)&RegisterInfo1075, NULL}, // PUNIT
  {(RegisterInformation *)&RegisterInfo1076, NULL}, // PUNIT
  {(RegisterInformation *)&RegisterInfo1077, NULL}, // PUNIT
  {(RegisterInformation *)&RegisterInfo1078, NULL}, // PUNIT
  {(RegisterInformation *)&RegisterInfo1079, NULL}, // PUNIT
  {(RegisterInformation *)&RegisterInfo1080, NULL}, // PUNIT
  {(RegisterInformation *)&RegisterInfo1081, NULL}, // PUNIT
  {(RegisterInformation *)&RegisterInfo1082, NULL}, // PUNIT
  {(RegisterInformation *)&RegisterInfo1083, NULL}, // PUNIT
  {(RegisterInformation *)&RegisterInfo1084, NULL}, // PUNIT
  {(RegisterInformation *)&RegisterInfo1085, NULL}, // PUNIT
  {(RegisterInformation *)&RegisterInfo1086, NULL}, // PUNIT
  {(RegisterInformation *)&RegisterInfo1087, NULL}, // PUNIT
  {(RegisterInformation *)&RegisterInfo1088, NULL}, // PUNIT
  {(RegisterInformation *)&RegisterInfo1089, NULL}, // PUNIT
  {(RegisterInformation *)&RegisterInfo1090, NULL}, // PUNIT
  {(RegisterInformation *)&RegisterInfo1091, NULL}, // PUNIT
  {(RegisterInformation *)&RegisterInfo1092, NULL}, // PUNIT
  {(RegisterInformation *)&RegisterInfo1093, NULL}, // PUNIT
  {(RegisterInformation *)&RegisterInfo1094, NULL}, // PUNIT
  {(RegisterInformation *)&RegisterInfo1095, NULL}, // PUNIT
  {(RegisterInformation *)&RegisterInfo1096, NULL}, // PUNIT
  {(RegisterInformation *)&RegisterInfo1097, NULL}, // PUNIT
  {(RegisterInformation *)&RegisterInfo1098, NULL}, // PUNIT
  {(RegisterInformation *)&RegisterInfo1099, NULL}, // PUNIT
  {(RegisterInformation *)&RegisterInfo1100, NULL}, // PUNIT
  {(RegisterInformation *)&RegisterInfo1101, NULL}, // PUNIT
  {(RegisterInformation *)&RegisterInfo1102, NULL}, // PUNIT
  {(RegisterInformation *)&RegisterInfo1103, NULL}, // PUNIT
  {(RegisterInformation *)&RegisterInfo1104, NULL}, // PUNIT
  {(RegisterInformation *)&RegisterInfo1105, NULL}, // PUNIT
  {(RegisterInformation *)&RegisterInfo1106, NULL}, // PUNIT
  {(RegisterInformation *)&RegisterInfo1107, NULL}, // PUNIT
  {(RegisterInformation *)&RegisterInfo1108, NULL}, // PUNIT
  {(RegisterInformation *)&RegisterInfo1109, NULL}, // PUNIT
  {(RegisterInformation *)&RegisterInfo1110, NULL}, // PUNIT
  {(RegisterInformation *)&RegisterInfo1111, NULL}, // PUNIT
{NULL, NULL},
  {(RegisterInformation *)&RegisterInfo1112, NULL}, // MLMC
  {(RegisterInformation *)&RegisterInfo1113, NULL}, // MLMC
  {(RegisterInformation *)&RegisterInfo1114, NULL}, // MLMC
  {(RegisterInformation *)&RegisterInfo1115, NULL}, // MLMC
  {(RegisterInformation *)&RegisterInfo1116, NULL}, // MLMC
  {(RegisterInformation *)&RegisterInfo1117, NULL}, // MLMC
  {(RegisterInformation *)&RegisterInfo1118, NULL}, // MLMC
  {(RegisterInformation *)&RegisterInfo1119, NULL}, // MLMC
  {(RegisterInformation *)&RegisterInfo1120, NULL}, // MLMC
  {(RegisterInformation *)&RegisterInfo1121, NULL}, // MLMC
  {(RegisterInformation *)&RegisterInfo1122, NULL}, // MLMC
  {(RegisterInformation *)&RegisterInfo1123, NULL}, // MLMC
  {(RegisterInformation *)&RegisterInfo1124, NULL}, // MLMC
  {(RegisterInformation *)&RegisterInfo1125, NULL}, // MLMC
  {(RegisterInformation *)&RegisterInfo1126, NULL}, // MLMC
  {(RegisterInformation *)&RegisterInfo1127, NULL}, // MLMC
  {(RegisterInformation *)&RegisterInfo1128, NULL}, // MLMC
{NULL, NULL},
  {(RegisterInformation *)&RegisterInfo1129, NULL}, // CUNIT
  {(RegisterInformation *)&RegisterInfo1130, NULL}, // CUNIT
  {(RegisterInformation *)&RegisterInfo1131, NULL}, // CUNIT
  {(RegisterInformation *)&RegisterInfo1132, NULL}, // CUNIT
  {(RegisterInformation *)&RegisterInfo1133, NULL}, // CUNIT
  {(RegisterInformation *)&RegisterInfo1134, NULL}, // CUNIT
  {(RegisterInformation *)&RegisterInfo1135, NULL}, // CUNIT
  {(RegisterInformation *)&RegisterInfo1136, NULL}, // CUNIT
  {(RegisterInformation *)&RegisterInfo1137, NULL}, // CUNIT
  {(RegisterInformation *)&RegisterInfo1138, NULL}, // CUNIT
  {(RegisterInformation *)&RegisterInfo1139, NULL}, // CUNIT
  {(RegisterInformation *)&RegisterInfo1140, NULL}, // CUNIT
  {(RegisterInformation *)&RegisterInfo1141, NULL}, // CUNIT
  {(RegisterInformation *)&RegisterInfo1142, NULL}, // CUNIT
  {(RegisterInformation *)&RegisterInfo1143, NULL}, // CUNIT
  {(RegisterInformation *)&RegisterInfo1144, NULL}, // CUNIT
  {(RegisterInformation *)&RegisterInfo1145, NULL}, // CUNIT
  {(RegisterInformation *)&RegisterInfo1146, NULL}, // CUNIT
  {(RegisterInformation *)&RegisterInfo1147, NULL}, // CUNIT
  {(RegisterInformation *)&RegisterInfo1148, NULL}, // CUNIT
  {(RegisterInformation *)&RegisterInfo1149, NULL}, // CUNIT
  {(RegisterInformation *)&RegisterInfo1150, NULL}, // CUNIT
  {(RegisterInformation *)&RegisterInfo1151, NULL}, // CUNIT
  {(RegisterInformation *)&RegisterInfo1152, NULL}, // CUNIT
  {(RegisterInformation *)&RegisterInfo1153, NULL}, // CUNIT
  {(RegisterInformation *)&RegisterInfo1154, NULL}, // CUNIT
  {(RegisterInformation *)&RegisterInfo1155, NULL}, // CUNIT
  {(RegisterInformation *)&RegisterInfo1156, NULL}, // CUNIT
  {(RegisterInformation *)&RegisterInfo1157, NULL}, // CUNIT
  {(RegisterInformation *)&RegisterInfo1158, NULL}, // CUNIT
  {(RegisterInformation *)&RegisterInfo1159, NULL}, // CUNIT
  {(RegisterInformation *)&RegisterInfo1160, NULL}, // CUNIT
  {(RegisterInformation *)&RegisterInfo1161, NULL}, // CUNIT
  {(RegisterInformation *)&RegisterInfo1162, NULL}, // CUNIT
  {(RegisterInformation *)&RegisterInfo1163, NULL}, // CUNIT
  {(RegisterInformation *)&RegisterInfo1164, NULL}, // CUNIT
  {(RegisterInformation *)&RegisterInfo1165, NULL}, // CUNIT
  {(RegisterInformation *)&RegisterInfo1166, NULL}, // CUNIT
  {(RegisterInformation *)&RegisterInfo1167, NULL}, // CUNIT
  {(RegisterInformation *)&RegisterInfo1168, NULL}, // CUNIT
  {(RegisterInformation *)&RegisterInfo1169, NULL}, // CUNIT
  {(RegisterInformation *)&RegisterInfo1170, NULL}, // CUNIT
  {(RegisterInformation *)&RegisterInfo1171, NULL}, // CUNIT
  {(RegisterInformation *)&RegisterInfo1172, NULL}, // CUNIT
  {(RegisterInformation *)&RegisterInfo1173, NULL}, // CUNIT
  {(RegisterInformation *)&RegisterInfo1174, NULL}, // CUNIT
  {(RegisterInformation *)&RegisterInfo1175, NULL}, // CUNIT
  {(RegisterInformation *)&RegisterInfo1176, NULL}, // CUNIT
  {(RegisterInformation *)&RegisterInfo1177, NULL}, // CUNIT
  {(RegisterInformation *)&RegisterInfo1178, NULL}, // CUNIT
  {(RegisterInformation *)&RegisterInfo1179, NULL}, // CUNIT
  {(RegisterInformation *)&RegisterInfo1180, NULL}, // CUNIT
{NULL, NULL},
  {(RegisterInformation *)&RegisterInfo1181, NULL}, // P2SB
  {(RegisterInformation *)&RegisterInfo1182, NULL}, // P2SB
  {(RegisterInformation *)&RegisterInfo1183, NULL}, // P2SB
  {(RegisterInformation *)&RegisterInfo1184, NULL}, // P2SB
  {(RegisterInformation *)&RegisterInfo1185, NULL}, // P2SB
  {(RegisterInformation *)&RegisterInfo1186, NULL}, // P2SB
  {(RegisterInformation *)&RegisterInfo1187, NULL}, // P2SB
  {(RegisterInformation *)&RegisterInfo1188, NULL}, // P2SB
  {(RegisterInformation *)&RegisterInfo1189, NULL}, // P2SB
  {(RegisterInformation *)&RegisterInfo1190, NULL}, // P2SB
  {(RegisterInformation *)&RegisterInfo1191, NULL}, // P2SB
  {(RegisterInformation *)&RegisterInfo1192, NULL}, // P2SB
  {(RegisterInformation *)&RegisterInfo1193, NULL}, // P2SB
  {(RegisterInformation *)&RegisterInfo1194, NULL}, // P2SB
  {(RegisterInformation *)&RegisterInfo1195, NULL}, // P2SB
  {(RegisterInformation *)&RegisterInfo1196, NULL}, // P2SB
  {(RegisterInformation *)&RegisterInfo1197, NULL}, // P2SB
  {(RegisterInformation *)&RegisterInfo1198, NULL}, // P2SB
  {(RegisterInformation *)&RegisterInfo1199, NULL}, // P2SB
  {(RegisterInformation *)&RegisterInfo1200, NULL}, // P2SB
  {(RegisterInformation *)&RegisterInfo1201, NULL}, // P2SB
  {(RegisterInformation *)&RegisterInfo1202, NULL}, // P2SB
  {(RegisterInformation *)&RegisterInfo1203, NULL}, // P2SB
  {(RegisterInformation *)&RegisterInfo1204, NULL}, // P2SB
  {(RegisterInformation *)&RegisterInfo1205, NULL}, // P2SB
  {(RegisterInformation *)&RegisterInfo1206, NULL}, // P2SB
  {(RegisterInformation *)&RegisterInfo1207, NULL}, // P2SB
  {(RegisterInformation *)&RegisterInfo1208, NULL}, // P2SB
  {(RegisterInformation *)&RegisterInfo1209, NULL}, // P2SB
  {(RegisterInformation *)&RegisterInfo1210, NULL}, // P2SB
  {(RegisterInformation *)&RegisterInfo1211, NULL}, // P2SB
  {(RegisterInformation *)&RegisterInfo1212, NULL}, // P2SB
  {(RegisterInformation *)&RegisterInfo1213, NULL}, // P2SB
  {(RegisterInformation *)&RegisterInfo1214, NULL}, // P2SB
  {(RegisterInformation *)&RegisterInfo1215, NULL}, // P2SB
  {(RegisterInformation *)&RegisterInfo1216, NULL}, // P2SB
  {(RegisterInformation *)&RegisterInfo1217, NULL}, // P2SB
  {(RegisterInformation *)&RegisterInfo1218, NULL}, // P2SB
  {(RegisterInformation *)&RegisterInfo1219, NULL}, // P2SB
  {(RegisterInformation *)&RegisterInfo1220, NULL}, // P2SB
  {(RegisterInformation *)&RegisterInfo1221, NULL}, // P2SB
  {(RegisterInformation *)&RegisterInfo1222, NULL}, // P2SB
  {(RegisterInformation *)&RegisterInfo1223, NULL}, // P2SB
  {(RegisterInformation *)&RegisterInfo1224, NULL}, // P2SB
  {(RegisterInformation *)&RegisterInfo1225, NULL}, // P2SB
  {(RegisterInformation *)&RegisterInfo1226, NULL}, // P2SB
  {(RegisterInformation *)&RegisterInfo1227, NULL}, // P2SB
  {(RegisterInformation *)&RegisterInfo1228, NULL}, // P2SB
{NULL, NULL},
  {(RegisterInformation *)&RegisterInfo1229, NULL}, // DDRSAI
  {(RegisterInformation *)&RegisterInfo1230, NULL}, // DDRSAI
  {(RegisterInformation *)&RegisterInfo1231, NULL}, // DDRSAI
  {(RegisterInformation *)&RegisterInfo1232, NULL}, // DDRSAI
  {(RegisterInformation *)&RegisterInfo1233, NULL}, // DDRSAI
  {(RegisterInformation *)&RegisterInfo1234, NULL}, // DDRSAI
  {(RegisterInformation *)&RegisterInfo1235, NULL}, // DDRSAI
  {(RegisterInformation *)&RegisterInfo1236, NULL}, // DDRSAI
  {(RegisterInformation *)&RegisterInfo1237, NULL}, // DDRSAI
  {(RegisterInformation *)&RegisterInfo1238, NULL}, // DDRSAI
  {(RegisterInformation *)&RegisterInfo1239, NULL}, // DDRSAI
  {(RegisterInformation *)&RegisterInfo1240, NULL}, // DDRSAI
{NULL, NULL},
  {(RegisterInformation *)&RegisterInfo1241, NULL}, // SAI
  {(RegisterInformation *)&RegisterInfo1242, NULL}, // SAI
  {(RegisterInformation *)&RegisterInfo1243, NULL}, // SAI
  {(RegisterInformation *)&RegisterInfo1244, NULL}, // SAI
  {(RegisterInformation *)&RegisterInfo1245, NULL}, // SAI
  {(RegisterInformation *)&RegisterInfo1246, NULL}, // SAI
  {(RegisterInformation *)&RegisterInfo1247, NULL}, // SAI
  {(RegisterInformation *)&RegisterInfo1248, NULL}, // SAI
  {(RegisterInformation *)&RegisterInfo1249, NULL}, // SAI
  {(RegisterInformation *)&RegisterInfo1250, NULL}, // SAI
  {(RegisterInformation *)&RegisterInfo1251, NULL}, // SAI
  {(RegisterInformation *)&RegisterInfo1252, NULL}, // SAI
{NULL, NULL},
  {(RegisterInformation *)&RegisterInfo1253, NULL}, // AUNIT
  {(RegisterInformation *)&RegisterInfo1254, NULL}, // AUNIT
  {(RegisterInformation *)&RegisterInfo1255, NULL}, // AUNIT
  {(RegisterInformation *)&RegisterInfo1256, NULL}, // AUNIT
  {(RegisterInformation *)&RegisterInfo1257, NULL}, // AUNIT
  {(RegisterInformation *)&RegisterInfo1258, NULL}, // AUNIT
  {(RegisterInformation *)&RegisterInfo1259, NULL}, // AUNIT
  {(RegisterInformation *)&RegisterInfo1260, NULL}, // AUNIT
  {(RegisterInformation *)&RegisterInfo1261, NULL}, // AUNIT
  {(RegisterInformation *)&RegisterInfo1262, NULL}, // AUNIT
  {(RegisterInformation *)&RegisterInfo1263, NULL}, // AUNIT
  {(RegisterInformation *)&RegisterInfo1264, NULL}, // AUNIT
  {(RegisterInformation *)&RegisterInfo1265, NULL}, // AUNIT
  {(RegisterInformation *)&RegisterInfo1266, NULL}, // AUNIT
  {(RegisterInformation *)&RegisterInfo1267, NULL}, // AUNIT
  {(RegisterInformation *)&RegisterInfo1268, NULL}, // AUNIT
  {(RegisterInformation *)&RegisterInfo1269, NULL}, // AUNIT
  {(RegisterInformation *)&RegisterInfo1270, NULL}, // AUNIT
  {(RegisterInformation *)&RegisterInfo1271, NULL}, // AUNIT
  {(RegisterInformation *)&RegisterInfo1272, NULL}, // AUNIT
  {(RegisterInformation *)&RegisterInfo1273, NULL}, // AUNIT
  {(RegisterInformation *)&RegisterInfo1274, NULL}, // AUNIT
  {(RegisterInformation *)&RegisterInfo1275, NULL}, // AUNIT
  {(RegisterInformation *)&RegisterInfo1276, NULL}, // AUNIT
  {(RegisterInformation *)&RegisterInfo1277, NULL}, // AUNIT
  {(RegisterInformation *)&RegisterInfo1278, NULL}, // AUNIT
  {(RegisterInformation *)&RegisterInfo1279, NULL}, // AUNIT
  {(RegisterInformation *)&RegisterInfo1280, NULL}, // AUNIT
  {(RegisterInformation *)&RegisterInfo1281, NULL}, // AUNIT
  {(RegisterInformation *)&RegisterInfo1282, NULL}, // AUNIT
  {(RegisterInformation *)&RegisterInfo1283, NULL}, // AUNIT
  {(RegisterInformation *)&RegisterInfo1284, NULL}, // AUNIT
  {(RegisterInformation *)&RegisterInfo1285, NULL}, // AUNIT
  {(RegisterInformation *)&RegisterInfo1286, NULL}, // AUNIT
  {(RegisterInformation *)&RegisterInfo1287, NULL}, // AUNIT
  {(RegisterInformation *)&RegisterInfo1288, NULL}, // AUNIT
  {(RegisterInformation *)&RegisterInfo1289, NULL}, // AUNIT
  {(RegisterInformation *)&RegisterInfo1290, NULL}, // AUNIT
  {(RegisterInformation *)&RegisterInfo1291, NULL}, // AUNIT
  {(RegisterInformation *)&RegisterInfo1292, NULL}, // AUNIT
  {(RegisterInformation *)&RegisterInfo1293, NULL}, // AUNIT
  {(RegisterInformation *)&RegisterInfo1294, NULL}, // AUNIT
  {(RegisterInformation *)&RegisterInfo1295, NULL}, // AUNIT
  {(RegisterInformation *)&RegisterInfo1296, NULL}, // AUNIT
  {(RegisterInformation *)&RegisterInfo1297, NULL}, // AUNIT
  {(RegisterInformation *)&RegisterInfo1298, NULL}, // AUNIT
  {(RegisterInformation *)&RegisterInfo1299, NULL}, // AUNIT
  {(RegisterInformation *)&RegisterInfo1300, NULL}, // AUNIT
  {(RegisterInformation *)&RegisterInfo1301, NULL}, // AUNIT
{NULL, NULL},
#endif // DUMP_REGISTER_FIELDS
};

#else
Register Registers[] = {{NULL, NULL}};
#endif // DUMP_REGISTER_NAMES

